package netscape.security;

public class Target {
   private String name = null;
   private Principal prin = null;
   private String risk = null;
   private String riskColor = null;
   private String description = null;
   private String url = null;
   private Target[] targetAry = null;

   protected Target() {
      this(null, null, null, null, null, null, null);
   }

   public Target(String var1, Principal var2) {
      this(var1, var2, null, null, null, null, null);
   }

   public Target(String var1) {
      this(var1, null, null, null, null, null, null);
   }

   public Target(String var1, Principal var2, Target[] var3) {
      this(var1, var2, null, null, null, null, var3);
   }

   public Target(String var1, Principal var2, String var3, String var4, String var5, String var6) {
      this(var1, var2, var3, var4, var5, var6, null);
   }

   public Target(String var1, Principal var2, String var3, String var4, String var5, String var6, Target[] var7) {
      this.name = var1;
      this.prin = var2;
      this.risk = var3;
      this.riskColor = var4;
      this.description = var5;
      this.url = var6;
      this.targetAry = var7;
   }

   public static Target findTarget(String var0) {
      return new Target(var0);
   }

   public static Target findTarget(String var0, Principal var1) {
      return new Target(var0, var1);
   }

   public static Target findTarget(Target var0) {
      return var0;
   }

   public Privilege checkPrivilegeEnabled(Principal[] var1, Object var2) {
      PrivilegeManager var3 = PrivilegeManager.getPrivilegeManager();
      var3.checkPrivilegeEnabled(this, var2);
      return null;
   }

   public Privilege checkPrivilegeEnabled(Principal[] var1) {
      return this.checkPrivilegeEnabled(var1, null);
   }

   public Privilege checkPrivilegeEnabled(Principal var1, Object var2) {
      PrivilegeManager var3 = PrivilegeManager.getPrivilegeManager();
      var3.checkPrivilegeEnabled(this, var2);
      return null;
   }

   public Privilege enablePrivilege(Principal var1, Object var2) {
      PrivilegeManager var3 = PrivilegeManager.getPrivilegeManager();
      var3.enablePrivilege(this, var1, var2);
      return null;
   }

   public String getRisk() {
      return this.risk;
   }

   public String getRiskColor() {
      return this.riskColor;
   }

   public String getDescription() {
      return this.description;
   }

   public static Target getTargetFromDescription(String var0) {
      return null;
   }

   public String getHelpUrl() {
      return this.url;
   }

   public String getDetailedInfo(Object var1) {
      return null;
   }
}
