package sun.beans.ole;

import java.lang.reflect.Constructor;
import java.lang.reflect.Field;
import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import java.lang.reflect.Modifier;
import java.util.Hashtable;
import sun.beanbox.SimpleClassLoader;

class JavaObjectInterface extends OleDispatchInterface implements Dispatch, ObjectProxy {
   private Object interfacedObject;
   private Method[] methods;
   private Field[] fields;
   private static Hashtable dispids;

   public static void clearAllCaches() {
      Class var0 = class$sun$beans$ole$JavaObjectInterface == null
         ? (class$sun$beans$ole$JavaObjectInterface = class$("sun.beans.ole.JavaObjectInterface"))
         : class$sun$beans$ole$JavaObjectInterface;
      synchronized (var0) {
         dispids = null;
      }
   }

   public JavaObjectInterface(Object var1) {
      this.interfacedObject = var1;
   }

   public int getIDsOfNames(String var1) {
      Class var3 = class$sun$beans$ole$JavaObjectInterface == null
         ? (class$sun$beans$ole$JavaObjectInterface = class$("sun.beans.ole.JavaObjectInterface"))
         : class$sun$beans$ole$JavaObjectInterface;
      Hashtable var2;
      synchronized (var3) {
         if (dispids == null) {
            dispids = new Hashtable();
         }

         Object var4 = dispids.get(this.interfacedObject.getClass());
         if (var4 == null) {
            var2 = new Hashtable();
            dispids.put(this.interfacedObject.getClass(), var2);
            var2.put("methods_automation", this.interfacedObject.getClass().getMethods());
            var2.put("fields_automation", this.interfacedObject.getClass().getFields());
         } else {
            var2 = (Hashtable)var4;
         }
      }

      this.methods = (Method[])var2.get("methods_automation");
      this.fields = (Field[])var2.get("fields_automation");
      Object var7 = var2.get(var1);
      if (var7 != null && var7 instanceof Integer) {
         return (Integer)var7;
      } else {
         int var5 = this.getDispidOfName(var1);
         var2.put(var1, new Integer(var5));
         return var5;
      }
   }

   private int getDispidOfName(String var1) {
      if (this.methods == null) {
         Class var2 = this.interfacedObject.getClass();
         this.methods = var2.getMethods();
         this.fields = var2.getFields();
      }

      if (this.fields != null) {
         for (int var4 = 0; var4 < this.fields.length; var4++) {
            Field var3 = this.fields[var4];
            if (var1.equalsIgnoreCase(var3.getName())) {
               return var4 + 134217728;
            }
         }
      }

      if (this.methods != null) {
         for (int var5 = 0; var5 < this.methods.length; var5++) {
            Method var6 = this.methods[var5];
            if (var1.equalsIgnoreCase(var6.getName())) {
               return var5 + 1;
            }
         }
      }

      if (var1.equalsIgnoreCase("getNew")) {
         return 134217726;
      } else {
         return var1.equalsIgnoreCase("getConstructor") ? 134217725 : -1;
      }
   }

   public int getProperty(int var1, int var2) throws Throwable {
      Field var3;
      try {
         var3 = this.fields[var1];
      } catch (IndexOutOfBoundsException var10) {
         return -2147352573;
      }

      try {
         this.storeParm(var2, var3.get(this.interfacedObject), true);
         return 0;
      } catch (NullPointerException var7) {
         return -2147467259;
      } catch (IllegalArgumentException var8) {
         return -2147352571;
      } catch (IllegalAccessException var9) {
         return -2147352573;
      }
   }

   public int setProperty(int var1, int var2) throws Throwable {
      Field var3;
      try {
         var3 = this.fields[var1];
      } catch (IndexOutOfBoundsException var11) {
         return -2147352573;
      }

      if (this.parmsNumber(var2) != 1) {
         return -2147352562;
      } else {
         Object var4 = this.extractParameter(var3.getType(), var2, 0);
         if (var4 == null) {
            return -2147352571;
         } else {
            try {
               var3.set(this.interfacedObject, var4);
               return 0;
            } catch (NullPointerException var8) {
               return -2147467259;
            } catch (IllegalArgumentException var9) {
               return -2147352571;
            } catch (IllegalAccessException var10) {
               return -2147352573;
            }
         }
      }
   }

   public int invoke(int var1, int var2, int var3) throws Throwable {
      Object var5 = null;
      boolean var6 = true;
      if (this.methods == null) {
         this.methods = this.interfacedObject.getClass().getMethods();
         this.fields = this.interfacedObject.getClass().getFields();
      }

      if (var1 == 134217726) {
         if (this.parmsNumber(var2) != 1) {
            return -2147352562;
         }

         String var7 = this.getStringObjectParm(var2, 0);
         Class var8 = null;

         try {
            var8 = Class.forName(var7);
         } catch (ClassNotFoundException var21) {
            var8 = SimpleClassLoader.ourLoader.loadClass(var7);
         }

         if (var8 == null) {
            throw new NoClassDefFoundError("Class " + var7 + " Not found");
         }

         var5 = var8.newInstance();
      } else if (var1 == 134217725) {
         int var23 = this.parmsNumber(var2);
         String var26 = this.getStringObjectParm(var2, var23 - 1);
         Class var9 = null;

         try {
            var9 = Class.forName(var26);
         } catch (ClassNotFoundException var20) {
            var9 = SimpleClassLoader.ourLoader.loadClass(var26);
         }

         String var10 = "public " + var26 + "(" + this.getStringObjectParm(var2, 0) + ")";
         Constructor[] var11 = var9.getConstructors();

         for (int var12 = 0; var12 < var11.length; var12++) {
            if (Modifier.isPublic(var11[var12].getModifiers()) && var11[var12].getParameterTypes().length == var23 - 1) {
               Class[] var13 = var11[var12].getParameterTypes();
               int var14 = 0;

               while (var14 < var13.length && var13[var14].getName().equalsIgnoreCase(this.getStringObjectParm(var2, var23 - 2 - var14))) {
                  var14++;
               }

               if (var14 == var13.length) {
                  var5 = var11[var12];
                  break;
               }
            }
         }

         if (var5 == null) {
            return -2147352573;
         }
      } else {
         Method var4;
         try {
            var4 = this.methods[var1 - 1];
         } catch (IndexOutOfBoundsException var19) {
            return -2147352573;
         }

         String var24 = var4.getName();
         Method var27 = null;

         for (int var29 = 0; var29 < this.methods.length; var29++) {
            if (this.methods[var29].getName().equals(var24) && this.methods[var29].getParameterTypes().length == this.parmsNumber(var2)) {
               var27 = this.methods[var29];
               break;
            }
         }

         if (var27 == null) {
            return -2147352562;
         }

         var4 = var27;
         Object[] var30 = null;
         Class[] var31 = var27.getParameterTypes();
         if (var31 != null) {
            if (this.parmsNumber(var2) != var31.length) {
               return -2147352562;
            }

            var30 = new Object[var31.length];

            for (int var32 = 0; var32 < var31.length; var32++) {
               var30[var32] = this.extractParameter(var31[var32], var2, var31.length - var32 - 1);
            }
         }

         Class var33 = var27.getReturnType();
         if (var33.isPrimitive()) {
            var6 = true;
         } else {
            var6 = false;
         }

         try {
            var5 = var4.invoke(this.interfacedObject, var30);
         } catch (NullPointerException var16) {
            return -2147467259;
         } catch (IllegalArgumentException var17) {
            return -2147352571;
         } catch (InvocationTargetException var18) {
            throw var18.getTargetException();
         }
      }

      if (var3 != 0 && var5 != null) {
         this.storeParm(var3, var5, var6);
      }

      return 0;
   }

   public Object getInterfacedObject() {
      return this.interfacedObject;
   }

   private void storeParm(int var1, Object var2, boolean var3) {
      this.nativeStoreParm(var1, var2, var2.getClass().toString().replace('.', '/'), var2.getClass().isArray(), var3);
   }

   private Object extractParameter(Class var1, int var2, int var3) {
      String var4 = var1.getName();
      if (var4.compareTo("java.lang.Integer") == 0 || var4.compareTo("int") == 0) {
         return this.getIntegerObjectParm(var2, var3);
      } else if (var4.compareTo("java.lang.Short") == 0 || var4.compareTo("short") == 0) {
         return this.getIntegerObjectParm(var2, var3);
      } else if (var4.compareTo("java.lang.Double") == 0 || var4.compareTo("double") == 0) {
         return this.getDoubleObjectParm(var2, var3);
      } else if (var4.compareTo("java.lang.Float") == 0 || var4.compareTo("float") == 0) {
         return this.getFloatObjectParm(var2, var3);
      } else if (var4.compareTo("java.lang.Boolean") == 0 || var4.compareTo("boolean") == 0) {
         return this.getIntegerObjectParm(var2, var3);
      } else if (var4.compareTo("java.lang.Character") == 0 || var4.compareTo("char") == 0) {
         return this.getCharacterObjectParm(var2, var3);
      } else if (var4.compareTo("java.lang.Long") == 0 || var4.compareTo("long") == 0) {
         return this.getLongObjectParm(var2, var3);
      } else if (var4.compareTo("java.lang.Byte") == 0 || var4.compareTo("byte") == 0) {
         return this.getByteObjectParm(var2, var3);
      } else if (var4.compareTo("java.lang.String") == 0) {
         return this.getStringObjectParm(var2, var3);
      } else if (var4.compareTo("java.awt.Font") == 0) {
         return this.getFontObjectParm(var2, var3);
      } else if (var4.compareTo("java.awt.Color") == 0) {
         return this.getColorObjectParm(var2, var3);
      } else if (var4.compareTo("[I") == 0) {
         return this.intArrayParm(var2, var3);
      } else if (var4.compareTo("[S") == 0) {
         return this.shortArrayParm(var2, var3);
      } else if (var4.compareTo("[F") == 0) {
         return this.floatArrayParm(var2, var3);
      } else if (var4.compareTo("[D") == 0) {
         return this.doubleArrayParm(var2, var3);
      } else if (var4.compareTo("[B") == 0) {
         return this.byteArrayParm(var2, var3);
      } else if (var4.compareTo("[Z") == 0) {
         return this.booleanArrayParm(var2, var3);
      } else if (var4.compareTo("[J") == 0) {
         return this.longArrayParm(var2, var3);
      } else if (var4.compareTo("[C") == 0) {
         return this.charArrayParm(var2, var3);
      } else if (var4.compareTo("[Ljava.lang.String;") == 0) {
         return this.getStringObjectArrayParm(var2, var3);
      } else if (var4.compareTo("[Ljava.awt.Color;") == 0) {
         return this.getColorObjectArrayParm(var2, var3);
      } else if (var4.compareTo("[Ljava.awt.Font;") == 0) {
         return this.getFontObjectArrayParm(var2, var3);
      } else {
         return var1.isArray() ? this.getObjectArrayParm(var2, var3) : this.getObjectParm(var2, var3);
      }
   }
}
