package sun.beans.ole;

import java.awt.Image;
import java.beans.BeanDescriptor;
import java.beans.BeanInfo;
import java.beans.EventSetDescriptor;
import java.beans.IndexedPropertyDescriptor;
import java.beans.IntrospectionException;
import java.beans.Introspector;
import java.beans.MethodDescriptor;
import java.beans.PropertyDescriptor;
import java.util.Vector;

public class OleBeanInfo implements BeanInfo {
   public boolean uncrackEvent;
   private BeanInfo beanInfo;
   private EventSetDescriptor[] defaultEvents;
   private EventSetDescriptor[] extendedEvents;
   private EventSetDescriptor propChange;
   private EventSetDescriptor vetoChange;
   private Class beanClass;

   public OleBeanInfo(Class var1) throws IntrospectionException {
      this.beanInfo = Introspector.getBeanInfo(var1, 3);
      this.beanClass = var1;
      Vector var2 = new Vector();
      Vector var3 = new Vector();
      new Vector();
      EventSetDescriptor[] var5 = this.getEventSetDescriptors();

      for (int var6 = 0; var6 < var5.length; var6++) {
         if (this.isImplementorOf(
            var5[var6].getListenerType(),
            class$java$beans$PropertyChangeListener == null
               ? (class$java$beans$PropertyChangeListener = class$("java.beans.PropertyChangeListener"))
               : class$java$beans$PropertyChangeListener
         )) {
            this.propChange = var5[var6];
         } else if (this.isImplementorOf(
            var5[var6].getListenerType(),
            class$java$beans$VetoableChangeListener == null
               ? (class$java$beans$VetoableChangeListener = class$("java.beans.VetoableChangeListener"))
               : class$java$beans$VetoableChangeListener
         )) {
            this.vetoChange = var5[var6];
         } else if (var5[var6].isInDefaultEventSet()) {
            var2.addElement(var5[var6]);
         } else {
            var3.addElement(var5[var6]);
         }
      }

      if (var2.size() > 0) {
         this.defaultEvents = new EventSetDescriptor[var2.size()];
         var2.copyInto(this.defaultEvents);
      }

      if (var3.size() > 0) {
         this.extendedEvents = new EventSetDescriptor[var3.size()];
         var3.copyInto(this.extendedEvents);
      }

      this.noBoundFix();
   }

   public BeanInfo[] getAdditionalBeanInfo() {
      return null;
   }

   public BeanDescriptor getBeanDescriptor() {
      return this.beanInfo.getBeanDescriptor();
   }

   public int getDefaultEventIndex() {
      return this.beanInfo.getDefaultEventIndex();
   }

   public int getDefaultPropertyIndex() {
      return this.beanInfo.getDefaultPropertyIndex();
   }

   public EventSetDescriptor[] getEventSetDescriptors() {
      return this.beanInfo.getEventSetDescriptors();
   }

   public Image getIcon(int var1) {
      return this.beanInfo.getIcon(var1);
   }

   public MethodDescriptor[] getMethodDescriptors() {
      return this.beanInfo.getMethodDescriptors();
   }

   public PropertyDescriptor[] getPropertyDescriptors() {
      return this.beanInfo.getPropertyDescriptors();
   }

   public EventSetDescriptor[] getDefaultEventSetDescriptors() {
      return this.defaultEvents;
   }

   public EventSetDescriptor[] getExtendedEventSetDescriptors() {
      return this.extendedEvents;
   }

   public boolean supportBoundProperties() {
      return this.propChange != null;
   }

   public boolean supportConstrainedProperties() {
      return this.vetoChange != null;
   }

   public Class getBeanClass() {
      return this.beanClass;
   }

   public Class getCustomizerClass() {
      BeanDescriptor var1 = this.getBeanDescriptor();
      return var1.getCustomizerClass();
   }

   public boolean isPropertyIndexed(PropertyDescriptor var1) {
      return var1 instanceof IndexedPropertyDescriptor;
   }

   public boolean isVisible() {
      Class var1 = this.beanClass;

      while (var1 != (class$java$awt$Component == null ? (class$java$awt$Component = class$("java.awt.Component")) : class$java$awt$Component)) {
         var1 = var1.getSuperclass();
         if (var1 == null) {
            return false;
         }
      }

      return true;
   }

   private void noBoundFix() {
      if (this.propChange != null) {
         PropertyDescriptor[] var1 = this.getPropertyDescriptors();
         boolean var2 = false;

         for (int var3 = 0; var3 < var1.length; var3++) {
            var2 = var1[var3].isBound();
         }

         if (!var2) {
            for (int var4 = 0; var4 < var1.length; var4++) {
               var1[var4].setBound(true);
            }
         }
      }
   }

   private boolean isPropertyNotification(EventSetDescriptor var1) {
      Class var2;
      Class var3;
      try {
         var2 = Class.forName("java.beans.PropertyChangeListener");
         var3 = Class.forName("java.beans.VetoableChangeListener");
      } catch (Exception var5) {
         return false;
      }

      return this.isImplementorOf(var1.getListenerType(), var2) || this.isImplementorOf(var1.getListenerType(), var3);
   }

   private boolean isImplementorOf(Class var1, Class var2) {
      for (Class var3 = var1; var3 != null; var3 = var3.getSuperclass()) {
         if (var3 == var2) {
            return true;
         }

         Class[] var4 = var3.getInterfaces();

         for (int var5 = 0; var5 < var4.length; var5++) {
            if (var4[var5] == var2) {
               return true;
            }
         }
      }

      return false;
   }

   public boolean isSuitableForUncracking(Class var1) {
      try {
         return this.isImplementorOf(var1, Class.forName("java.util.EventObject"));
      } catch (ClassNotFoundException var3) {
         return false;
      }
   }

   public String getInformationString() {
      Object var1 = this.beanInfo.getBeanDescriptor().getValue("hidden-state");
      return var1 == Boolean.TRUE ? "{{CDG}} P" : "{{CDG}} C";
   }
}
