package sun.beans.ole;

import java.awt.Color;
import java.awt.Component;
import java.awt.event.WindowListener;
import java.beans.PropertyEditor;
import java.beans.PropertyEditorManager;
import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.lang.reflect.Method;
import java.util.MissingResourceException;
import java.util.ResourceBundle;
import java.util.Vector;
import sun.beans.ole.event.EncapsulatedEventInformation;
import sun.beans.ole.event.EventManager;
import sun.plugin.usability.Trace;

public class OleBeanInterface implements ObjectProxy {
   private Object bean;
   protected int handle = 0;
   public String beanName;
   private boolean eventListeners = false;
   private OleEncapsulatedEventListener customListener;
   private EventManager myEventManager;
   private OlePropertyChangeListener changeListener;
   private OleVetoableChangeListener vetoableListener;
   private static ResourceBundle rb = ResourceBundle.getBundle("sun.beans.ole.resources.ActiveX");

   private void setBackground(Color var1) {
      Object var2 = this.getInterfacedObject();
      if (var2 instanceof Component) {
         ((Component)var2).setBackground(var1);
      }
   }

   protected OleBeanInterface(Object var1, int var2) {
      this.bean = var1;
      this.handle = var2;
   }

   public boolean isValid() {
      return this.bean != null;
   }

   public void release() {
      JavaObjectInterface.clearAllCaches();
      this.bean = null;
      this.handle = 0;
   }

   public void finalize() throws Throwable {
      if (this.handle != 0) {
         this.nativeRelease();
      }
   }

   public boolean addCustomEventListeners(String var1, int var2, int var3) {
      Object var4 = this.getInterfacedObject();
      if (var4 == null) {
         return true;
      } else {
         Vector var5 = new Vector();
         new Vector();
         new Vector();
         new Vector();

         try {
            String var9 = var1;

            int var21;
            do {
               var21 = var9.indexOf(32);
               String var11 = var9.substring(0, var21);
               String var19 = var9.substring(var21 + 1);
               var21 = var19.indexOf(32);
               String var12 = var19.substring(0, var21);
               var9 = var19.substring(var21 + 1);
               var21 = var9.indexOf(32);
               String var13;
               if (var21 != -1) {
                  var13 = var9.substring(0, var21);
                  var9 = var9.substring(var21 + 1);
               } else {
                  var13 = var9;
               }

               Class var14;
               try {
                  if (var4.getClass().getClassLoader() == null) {
                     var14 = Class.forName(var11);
                  } else {
                     var14 = var4.getClass().getClassLoader().loadClass(var11);
                  }
               } catch (ClassNotFoundException var17) {
                  System.err.println(getMessage("error.beanclass") + var11);
                  return false;
               }

               Class[] var15 = new Class[]{var14};
               EncapsulatedEventInformation var16 = new EncapsulatedEventInformation(
                  var14, var4.getClass().getMethod(var12, var15), var4.getClass().getMethod(var13, var15)
               );
               var5.addElement(var16);
            } while (var21 != -1);

            EncapsulatedEventInformation[] var22 = new EncapsulatedEventInformation[var5.size()];
            var5.copyInto(var22);
            this.myEventManager = new EventManager(var22, this.getInterfacedObject());
            this.customListener = new OleEncapsulatedEventListener(var2);
            this.setEventListenersActive(true);
            return true;
         } catch (Exception var18) {
            var18.printStackTrace();
            return false;
         }
      }
   }

   public boolean addPropertyEventListener(String var1, int var2, int var3) {
      Object var4 = this.getInterfacedObject();
      int var6 = var1.indexOf(32);
      String var7 = var1.substring(0, var6);
      String var5 = var1.substring(var6 + 1);
      var6 = var5.indexOf(32);
      String var8 = var5.substring(0, var6);
      var5 = var5.substring(var6 + 1);
      var6 = var5.indexOf(32);
      String var9 = var5;

      Class var10;
      try {
         var10 = Class.forName(var7);
      } catch (ClassNotFoundException var17) {
         System.err.println(getMessage("error.loadclass") + var7);
         return false;
      }

      Class[] var11 = new Class[]{var10};
      Object var12;
      if (var10
         == (
            class$java$beans$PropertyChangeListener == null
               ? (class$java$beans$PropertyChangeListener = class$("java.beans.PropertyChangeListener"))
               : class$java$beans$PropertyChangeListener
         )) {
         this.changeListener = new OlePropertyChangeListener(var3, var2);
         var12 = this.changeListener;
      } else {
         this.vetoableListener = new OleVetoableChangeListener(var3, var2);
         var12 = this.vetoableListener;
      }

      Method var13;
      Method var14;
      try {
         var13 = var4.getClass().getMethod(var8, var11);
         var14 = var4.getClass().getMethod(var9, var11);
      } catch (Exception var16) {
         var16.printStackTrace();
         return false;
      }

      ((OlePropertyEventsListener)var12).setRegistrationMethodsPair(var13, var14);
      ((OlePropertyEventsListener)var12).setListenerActive(var4, true);
      return true;
   }

   private WindowListener getWindowListener() {
      return new OleBeanInterface$1(this);
   }

   public synchronized boolean setEventListenersActive(boolean var1) {
      Object var2 = this.getInterfacedObject();
      this.eventListeners = var1;
      if (this.myEventManager != null) {
         if (var1) {
            this.myEventManager.addEncapsulatedEventListener(var2, this.customListener);
         } else {
            this.myEventManager.removeEncapsulatedEventListener(var2, this.customListener);
         }
      }

      if (this.changeListener != null) {
         this.changeListener.setListenerActive(var2, var1);
      }

      if (this.vetoableListener != null) {
         this.vetoableListener.setListenerActive(var2, var1);
      }

      return true;
   }

   public Object getInterfacedObject() {
      return this.bean;
   }

   public Object getDispatchImpl() {
      return new DispatchImpl(this.getInterfacedObject());
   }

   public static String getPropertyAsText(Object var0) {
      if (var0 == null) {
         return null;
      } else {
         PropertyEditor var1 = PropertyEditorManager.findEditor(var0.getClass());
         if (var1 != null) {
            var1.setValue(var0);
            String var2 = var1.getAsText();
            if (var2 != null) {
               return var2;
            }
         }

         return null;
      }
   }

   public static byte[] getPersistedProperty(Object var0) {
      ByteArrayOutputStream var1 = new ByteArrayOutputStream();
      if (var0 instanceof ObjectProxy) {
         ObjectProxy var2 = (ObjectProxy)var0;

         try {
            ObjectOutputStream var3 = new ObjectOutputStream(var1);
            var3.writeObject(var2.getInterfacedObject());
            var3.flush();
         } catch (IOException var4) {
            System.err.println(getMessage("error.propertypersistence") + var2.getInterfacedObject());
            return null;
         }

         return var1.toByteArray();
      } else {
         return null;
      }
   }

   public static Object setPropertyAsText(Object var0, String var1) {
      if (var0 == null) {
         return null;
      } else {
         PropertyEditor var2 = PropertyEditorManager.findEditor(var0.getClass());
         if (var2 != null) {
            try {
               var2.setAsText(var1);
            } catch (IllegalArgumentException var4) {
               System.err.println(getMessage("error.textproperty") + var1);
               return null;
            }

            return var2.getValue();
         } else {
            return null;
         }
      }
   }

   public static Object getPersistedValue(byte[] var0) {
      if (var0 == null) {
         return null;
      } else {
         ByteArrayInputStream var1 = new ByteArrayInputStream(var0);

         try {
            ObjectInputStream var2 = new ObjectInputStream(var1);
            Object var3 = var2.readObject();
            return new JavaObjectInterface(var3);
         } catch (Throwable var5) {
            System.err.println(var5);
            return null;
         }
      }
   }

   public static void notifyException(String var0) {
      String[] var1 = new String[]{var0};
      Trace.printException(new Exception(var0));
   }

   public void notifyException(Throwable var1, String var2) {
      Trace.printException(var1, var2, null);
   }

   public static String getMessage(String var0) {
      try {
         return rb.getString(var0);
      } catch (MissingResourceException var2) {
         return var0;
      }
   }

   protected native void nativeRelease();

   public native void viewChanged();
}
