package sun.beans.ole;

import java.awt.Color;
import java.awt.Font;
import sun.plugin.javascript.ocx.JSObject;

public class OleDispatchInterface {
   public static final int READ_ONLY = 1;
   public static final int READ_WRITE = 2;
   public static final int UNWRAP_RETURN_VALUE = 4;

   public native int parmsNumber(int var1);

   public void storeParm(int var1, int var2, Float var3, int var4) {
      if ((var4 & 4) == 4) {
         this.storeParm(var1, var2, var3.floatValue(), var4);
      } else {
         this.storeParm(var1, var2, (Object)var3, var4);
      }
   }

   public void storeParm(int var1, int var2, Integer var3, int var4) {
      if ((var4 & 4) == 4) {
         this.storeParm(var1, var2, var3.intValue(), var4);
      } else {
         this.storeParm(var1, var2, (Object)var3, var4);
      }
   }

   public void storeParm(int var1, int var2, Double var3, int var4) {
      if ((var4 & 4) == 4) {
         this.storeParm(var1, var2, var3.doubleValue(), var4);
      } else {
         this.storeParm(var1, var2, (Object)var3, var4);
      }
   }

   public void storeParm(int var1, int var2, Character var3, int var4) {
      if ((var4 & 4) == 4) {
         this.storeParm(var1, var2, var3.charValue(), var4);
      } else {
         this.storeParm(var1, var2, (Object)var3, var4);
      }
   }

   public void storeParm(int var1, int var2, Boolean var3, int var4) {
      if ((var4 & 4) == 4) {
         this.storeParm(var1, var2, var3.booleanValue(), var4);
      } else {
         this.storeParm(var1, var2, (Object)var3, var4);
      }
   }

   public void storeParm(int var1, int var2, Long var3, int var4) {
      if ((var4 & 4) == 4) {
         this.storeParm(var1, var2, var3.intValue(), var4);
      } else {
         this.storeParm(var1, var2, (Object)var3, var4);
      }
   }

   public void storeParm(int var1, int var2, long var3, int var5) {
      this.storeParm(var1, var2, (int)var3, var5);
   }

   public void storeParm(int var1, int var2, Byte var3, int var4) {
      if ((var4 & 4) == 4) {
         this.storeParm(var1, var2, var3.floatValue(), var4);
      } else {
         this.storeParm(var1, var2, (Object)var3, var4);
      }
   }

   public void storeParm(int var1, int var2, Short var3, int var4) {
      if ((var4 & 4) == 4) {
         this.storeParm(var1, var2, var3.shortValue(), var4);
      } else {
         this.storeParm(var1, var2, (Object)var3, var4);
      }
   }

   public void storeParm(int var1, int var2, Dispatch var3, int var4) {
      this.nativeStoreParm(var1, var2, var3, var4);
   }

   public void storeParm(int var1, int var2, Object var3, int var4) {
      if (var3 == null) {
         this.nativeStoreParm(var1, var2, null, var4);
      } else if (var3.getClass().isArray()) {
         Object[] var6 = (Object[])var3;
         this.storeParm(var1, var2, var6, var4);
      } else if (var3 instanceof String) {
         this.storeParm(var1, var2, (String)var3, var4);
      } else if (var3 instanceof Font) {
         this.storeParm(var1, var2, (Font)var3, var4);
      } else if (var3 instanceof Integer && (var4 & 4) == 4) {
         this.storeParm(var1, var2, ((Integer)var3).intValue(), var4);
      } else {
         JavaObjectInterface var5 = new JavaObjectInterface(var3);
         this.nativeStoreParm(var1, var2, var5, var4);
      }
   }

   public void storeParm(int var1, int var2, Float[] var3, int var4) {
      float[] var5 = new float[var3.length];

      for (int var6 = 0; var6 < var3.length; var6++) {
         var5[var6] = var3[var6];
      }

      this.storeParm(var1, var2, var3, var4);
   }

   public void storeParm(int var1, int var2, Double[] var3, int var4) {
      double[] var5 = new double[var3.length];

      for (int var6 = 0; var6 < var3.length; var6++) {
         var5[var6] = var3[var6];
      }

      this.storeParm(var1, var2, var3, var4);
   }

   public void storeParm(int var1, int var2, Character[] var3, int var4) {
      char[] var5 = new char[var3.length];

      for (int var6 = 0; var6 < var3.length; var6++) {
         var5[var6] = var3[var6];
      }

      this.storeParm(var1, var2, var3, var4);
   }

   public void storeParm(int var1, int var2, Boolean[] var3, int var4) {
      boolean[] var5 = new boolean[var3.length];

      for (int var6 = 0; var6 < var3.length; var6++) {
         var5[var6] = var3[var6];
      }

      this.storeParm(var1, var2, var3, var4);
   }

   public void storeParm(int var1, int var2, Byte[] var3, int var4) {
      byte[] var5 = new byte[var3.length];

      for (int var6 = 0; var6 < var3.length; var6++) {
         var5[var6] = var3[var6];
      }

      this.storeParm(var1, var2, var3, var4);
   }

   public void storeParm(int var1, int var2, Long[] var3, int var4) {
      int[] var5 = new int[var3.length];

      for (int var6 = 0; var6 < var3.length; var6++) {
         var5[var6] = var3[var6].intValue();
      }

      this.storeParm(var1, var2, var3, var4);
   }

   public void storeParm(int var1, int var2, Integer[] var3, int var4) {
      int[] var5 = new int[var3.length];

      for (int var6 = 0; var6 < var3.length; var6++) {
         var5[var6] = var3[var6];
      }

      this.storeParm(var1, var2, var3, var4);
   }

   public void storeParm(int var1, int var2, Short[] var3, int var4) {
      short[] var5 = new short[var3.length];

      for (int var6 = 0; var6 < var3.length; var6++) {
         var5[var6] = var3[var6];
      }

      this.storeParm(var1, var2, var3, var4);
   }

   public void storeParm(int var1, int var2, Dispatch[] var3, int var4) {
      this.nativeStoreArrayParm(var1, var2, var3, var4);
   }

   public void storeParm(int var1, int var2, Object[] var3, int var4) {
      JavaObjectInterface[] var5 = new JavaObjectInterface[var3.length];

      for (int var6 = 0; var6 < var3.length; var6++) {
         Object var7 = var3[var6];
         if (var7 == null) {
            var5[var6] = null;
         } else {
            JavaObjectInterface var8 = new JavaObjectInterface(var7);
            var5[var6] = var8;
         }
      }

      this.nativeStoreArrayParm(var1, var2, var5, var4);
   }

   public Object getObjectParm(int var1, int var2) {
      Object var3 = this.nativeGetObjectParm(var1, var2);
      return var3 instanceof ObjectProxy ? ((ObjectProxy)var3).getInterfacedObject() : var3;
   }

   public Double getDoubleObjectParm(int var1, int var2) {
      return new Double(this.doubleParm(var1, var2));
   }

   public Float getFloatObjectParm(int var1, int var2) {
      return new Float(this.floatParm(var1, var2));
   }

   public Character getCharacterObjectParm(int var1, int var2) {
      return new Character(this.charParm(var1, var2));
   }

   public Integer getIntegerObjectParm(int var1, int var2) {
      return new Integer(this.intParm(var1, var2));
   }

   public Long getLongObjectParm(int var1, int var2) {
      return new Long(this.longParm(var1, var2));
   }

   public Boolean getBooleanObjectParm(int var1, int var2) {
      return new Boolean(this.booleanParm(var1, var2));
   }

   public Short getShortObjectParm(int var1, int var2) {
      return new Short(this.shortParm(var1, var2));
   }

   public Byte getByteObjectParm(int var1, int var2) {
      return new Byte(this.byteParm(var1, var2));
   }

   public native void storeParm(int var1, int var2, float var3, int var4);

   public native void storeParm(int var1, int var2, double var3, int var5);

   public native void storeParm(int var1, int var2, char var3, int var4);

   public native void storeParm(int var1, int var2, byte var3, int var4);

   public native void storeParm(int var1, int var2, boolean var3, int var4);

   public native void storeParm(int var1, int var2, short var3, int var4);

   public native void storeParm(int var1, int var2, int var3, int var4);

   public native void storeParm(int var1, int var2, String var3, int var4);

   public native void storeParm(int var1, int var2, Font var3, int var4);

   public native void storeParm(int var1, int var2, Color var3, int var4);

   public native void storeParm(int var1, int var2, JSObject var3, int var4);

   public native void storeParm(int var1, int var2, float[] var3, int var4);

   public native void storeParm(int var1, int var2, double[] var3, int var4);

   public native void storeParm(int var1, int var2, char[] var3, int var4);

   public native void storeParm(int var1, int var2, byte[] var3, int var4);

   public native void storeParm(int var1, int var2, boolean[] var3, int var4);

   public native void storeParm(int var1, int var2, short[] var3, int var4);

   public native void storeParm(int var1, int var2, int[] var3, int var4);

   public native void storeParm(int var1, int var2, String[] var3, int var4);

   public native void storeParm(int var1, int var2, Font[] var3, int var4);

   public native void storeParm(int var1, int var2, Color[] var3, int var4);

   protected native void nativeStoreArrayParm(int var1, int var2, Object[] var3, int var4);

   protected native void nativeStoreParm(int var1, int var2, Object var3, int var4);

   public native void nativeStoreParm(int var1, Object var2, String var3, boolean var4, boolean var5);

   public native double doubleParm(int var1, int var2);

   public native float floatParm(int var1, int var2);

   public native char charParm(int var1, int var2);

   public native byte byteParm(int var1, int var2);

   public native boolean booleanParm(int var1, int var2);

   public native short shortParm(int var1, int var2);

   public native int intParm(int var1, int var2);

   public long longParm(int var1, int var2) {
      return this.intParm(var1, var2);
   }

   public native String getStringObjectParm(int var1, int var2);

   protected native Object nativeGetObjectParm(int var1, int var2);

   public native Font getFontObjectParm(int var1, int var2);

   public native Color getColorObjectParm(int var1, int var2);

   public native double[] doubleArrayParm(int var1, int var2);

   public native float[] floatArrayParm(int var1, int var2);

   public native char[] charArrayParm(int var1, int var2);

   public native byte[] byteArrayParm(int var1, int var2);

   public native boolean[] booleanArrayParm(int var1, int var2);

   public native short[] shortArrayParm(int var1, int var2);

   public native int[] intArrayParm(int var1, int var2);

   public native long[] longArrayParm(int var1, int var2);

   public Object[] getObjectArrayParm(int var1, int var2) {
      Object[] var3 = this.nativeGetObjectArrayParm(var1, var2);
      Object[] var4 = new Object[var3.length];

      for (int var5 = 0; var5 < var3.length; var5++) {
         if (var3[var5] instanceof ObjectProxy) {
            var4[var5] = ((ObjectProxy)var3[var5]).getInterfacedObject();
         } else if (!(var3[var5] instanceof String) && !(var3[var5] instanceof Integer)) {
            var4[var5] = null;
         } else {
            var4[var5] = var3[var5];
         }
      }

      return var4;
   }

   public native Object[] nativeGetObjectArrayParm(int var1, int var2);

   public String[] getStringObjectArrayParm(int var1, int var2) {
      Object[] var3 = this.nativeGetObjectArrayParm(var1, var2);
      if (var3 == null) {
         return null;
      } else {
         return var3 instanceof String[] ? (String[])var3 : null;
      }
   }

   public Font[] getFontObjectArrayParm(int var1, int var2) {
      Object[] var3 = this.nativeGetObjectArrayParm(var1, var2);
      if (var3 == null) {
         return null;
      } else {
         return var3 instanceof Font[] ? (Font[])var3 : null;
      }
   }

   public Color[] getColorObjectArrayParm(int var1, int var2) {
      Object[] var3 = this.nativeGetObjectArrayParm(var1, var2);
      if (var3 == null) {
         return null;
      } else {
         return var3 instanceof Color[] ? (Color[])var3 : null;
      }
   }

   public Double[] getDoubleObjectArrayParm(int var1, int var2) {
      double[] var3 = this.doubleArrayParm(var1, var2);
      if (var3 == null) {
         return null;
      } else {
         Double[] var4 = new Double[var3.length];

         for (int var5 = 0; var5 < var3.length; var5++) {
            var4[var5] = new Double(var3[var5]);
         }

         return var4;
      }
   }

   public Float[] getFloatObjectArrayParm(int var1, int var2) {
      float[] var3 = this.floatArrayParm(var1, var2);
      if (var3 == null) {
         return null;
      } else {
         Float[] var4 = new Float[var3.length];

         for (int var5 = 0; var5 < var3.length; var5++) {
            var4[var5] = new Float(var3[var5]);
         }

         return var4;
      }
   }

   public Character[] getCharacterObjectArrayParm(int var1, int var2) {
      char[] var3 = this.charArrayParm(var1, var2);
      if (var3 == null) {
         return null;
      } else {
         Character[] var4 = new Character[var3.length];

         for (int var5 = 0; var5 < var3.length; var5++) {
            var4[var5] = new Character(var3[var5]);
         }

         return var4;
      }
   }

   public Integer[] getIntegerObjectArrayParm(int var1, int var2) {
      int[] var3 = this.intArrayParm(var1, var2);
      if (var3 == null) {
         return null;
      } else {
         Integer[] var4 = new Integer[var3.length];

         for (int var5 = 0; var5 < var3.length; var5++) {
            var4[var5] = new Integer(var3[var5]);
         }

         return var4;
      }
   }

   public Byte[] getByteObjectArrayParm(int var1, int var2) {
      byte[] var3 = this.byteArrayParm(var1, var2);
      if (var3 == null) {
         return null;
      } else {
         Byte[] var4 = new Byte[var3.length];

         for (int var5 = 0; var5 < var3.length; var5++) {
            var4[var5] = new Byte(var3[var5]);
         }

         return var4;
      }
   }

   public Boolean[] getBooleanObjectArrayParm(int var1, int var2) {
      boolean[] var3 = this.booleanArrayParm(var1, var2);
      if (var3 == null) {
         return null;
      } else {
         Boolean[] var4 = new Boolean[var3.length];

         for (int var5 = 0; var5 < var3.length; var5++) {
            var4[var5] = new Boolean(var3[var5]);
         }

         return var4;
      }
   }

   public Short[] getShortObjectArrayParm(int var1, int var2) {
      short[] var3 = this.shortArrayParm(var1, var2);
      if (var3 == null) {
         return null;
      } else {
         Short[] var4 = new Short[var3.length];

         for (int var5 = 0; var5 < var3.length; var5++) {
            var4[var5] = new Short(var3[var5]);
         }

         return var4;
      }
   }

   public Long[] getLongObjectArrayParm(int var1, int var2) {
      long[] var3 = this.longArrayParm(var1, var2);
      if (var3 == null) {
         return null;
      } else {
         Long[] var4 = new Long[var3.length];

         for (int var5 = 0; var5 < var3.length; var5++) {
            var4[var5] = new Long(var3[var5]);
         }

         return var4;
      }
   }

   public native int allocateParmsFor(int var1);

   public native void freeParms(int var1);
}
