package sun.beans.ole;

import java.lang.reflect.Method;

public abstract class OlePropertyEventsListener {
   protected int m_propertyNotifySink;
   protected int m_connectionPoint;
   private Method registrationMethod;
   private Method unregistrationMethod;
   private boolean active;

   public OlePropertyEventsListener(int var1, int var2) {
      this.m_propertyNotifySink = var1;
      this.m_connectionPoint = var2;
   }

   protected native boolean nativePropertyEvent(boolean var1, int var2, int var3, String var4, Dispatch var5);

   public void setRegistrationMethodsPair(Method var1, Method var2) {
      this.registrationMethod = var1;
      this.unregistrationMethod = var2;
   }

   public void setListenerActive(Object var1, boolean var2) {
      if (var1 == null) {
         throw new IllegalArgumentException("Target");
      } else if (this.active != var2) {
         this.active = var2;

         try {
            Object[] var3 = new Object[]{this};
            if (var2) {
               this.registrationMethod.invoke(var1, var3);
            } else {
               this.unregistrationMethod.invoke(var1, var3);
            }
         } catch (Exception var4) {
            System.err.println("Cannot " + (var2 ? "enable" : "disable") + "property listener");
         }
      }
   }
}
