package sun.beans.ole;

import java.util.Properties;

public class StubInformation {
   private String sourceBeanName;
   private String targetDir;
   private String jarName;
   private OleBeanInfo beanInfo;
   private boolean uncrackEvent;
   private String activeXName;
   private String libName;
   private boolean register;
   private boolean dynamic = false;
   private static boolean bInitialize = false;

   public static StubInformation getStub(Class var0, String var1) {
      try {
         StubInformation var2 = new StubInformation();
         var2.setOleBeanInfo(new OleBeanInfo(var0));
         var2.setTargetDir(var1);
         var2.setEventGeneration(false);
         var2.setGenerationType(true);
         var2.setActiveXName(var0.getName());
         return var2;
      } catch (Exception var3) {
         var3.printStackTrace();
         return null;
      }
   }

   public void setSourceBeanName(String var1) {
      this.sourceBeanName = var1;
   }

   public String getSourceBeanName() {
      return this.sourceBeanName;
   }

   public void setTargetDir(String var1) {
      this.targetDir = var1;
   }

   public String getTargetDir() {
      return this.targetDir;
   }

   public void setJarFileName(String var1) {
      if (var1.length() > 2) {
         if (var1.charAt(1) == ':') {
            this.jarName = var1;
         } else {
            Properties var2 = System.getProperties();
            String var3 = var2.getProperty("user.dir", null);
            this.jarName = var3 + "\\" + var1;
         }
      } else {
         this.jarName = var1;
      }
   }

   public String getJarFileName() {
      return this.jarName;
   }

   public void setOleBeanInfo(OleBeanInfo var1) {
      this.beanInfo = var1;
   }

   public OleBeanInfo getOleBeanInfo() {
      return this.beanInfo;
   }

   public void setEventGeneration(boolean var1) {
      this.uncrackEvent = var1;
   }

   public boolean getEventGeneration() {
      return this.uncrackEvent;
   }

   public void setActiveXName(String var1) {
      StringBuffer var2 = new StringBuffer(var1);

      for (int var3 = 0; var3 < var2.length(); var3++) {
         if (var2.charAt(var3) == ' ') {
            var2.setCharAt(var3, '_');
         }
      }

      this.activeXName = var2.toString();
   }

   public String getActiveXName() {
      return this.activeXName;
   }

   public String getPackageName() {
      if (this.beanInfo != null) {
         String var1 = this.beanInfo.getBeanClass().getName();
         int var2 = var1.lastIndexOf(46);
         String var3 = var1.substring(0, var2);
         return var3.replace('.', '\\');
      } else {
         return null;
      }
   }

   public void setRegister(boolean var1) {
      this.register = var1;
   }

   public boolean doRegister() {
      return this.register;
   }

   public boolean isDynamic() {
      return this.dynamic;
   }

   public void setGenerationType(boolean var1) {
      this.dynamic = var1;
   }

   public void setTypeLibName(String var1) {
      this.libName = var1;
   }

   public String getTypeLibName() {
      return this.libName;
   }

   public String toString() {
      return "Stub information for " + this.sourceBeanName + " generation in " + this.targetDir;
   }

   public native boolean generateTypeLib(boolean var1);
}
