package sun.beans.ole.event;

import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import java.util.EventListener;
import java.util.EventObject;

public class EncapsulatedEvent extends EventObject {
   protected EventObject event;
   protected Method listenerMethod;
   protected Class listenerInterface;
   protected Object[] eventArgs;

   protected EncapsulatedEvent(Object var1, EventObject var2, Method var3, Object[] var4) {
      super(var1);
      if (var3 != null && (var2 != null || var4 != null)) {
         if (var2 == null && var4 != null) {
            for (int var5 = 0; var5 < var4.length; var5++) {
               if (var4[var5] instanceof EventObject) {
                  var2 = (EventObject)var4[var5];
                  break;
               }
            }
         }

         if (var2 != null && var2 instanceof EncapsulatedEvent) {
            EncapsulatedEvent var7 = (EncapsulatedEvent)var2;
            this.event = var7.getEvent();
            var3 = var7.getListenerMethod();
         } else {
            this.event = var2;
         }

         this.listenerMethod = var3;
         this.listenerInterface = var3.getDeclaringClass();
         if (var2 != null) {
            if (var4 == null) {
               var4 = new Object[]{this.event};
            } else {
               int var8 = 0;

               while (var8 < var4.length && !var2.equals(var4[var8])) {
                  var8++;
               }

               if (var8 == var4.length) {
                  Object[] var6 = new Object[var4.length + 1];
                  var6[0] = this.event;

                  for (int var9 = 0; var9 < var4.length; var9++) {
                     var6[var9 + 1] = var4[var9];
                  }
               }
            }
         }

         this.eventArgs = var4;
      } else {
         throw new NullPointerException("Encapsulated Event constructor args");
      }
   }

   public EncapsulatedEvent(Object var1, EventObject var2, Method var3) {
      this(var1, var2, var3, null);
   }

   public EncapsulatedEvent(EventObject var1, Method var2) {
      this(var1.getSource(), var1, var2);
   }

   public EncapsulatedEvent(Object var1, Method var2, Object[] var3) {
      this(var1, null, var2, var3);
   }

   public EventObject getEvent() {
      return this.event;
   }

   public Class getEventClass() {
      return this.event != null ? this.event.getClass() : null;
   }

   public String getEventClassName() {
      return this.event != null ? this.event.getClass().getName() : null;
   }

   public Object getEventSource() {
      return this.event != null ? this.event.getSource() : this.getSource();
   }

   public Method getListenerMethod() {
      return this.listenerMethod;
   }

   public String getListenerMethodName() {
      return this.listenerMethod.getName();
   }

   public Class getListenerInterface() {
      return this.listenerInterface;
   }

   public String getListenerInterfaceName() {
      return this.listenerInterface.getName();
   }

   public Object[] getEventArguments() {
      return this.eventArgs;
   }

   public void deliverEvent(EventListener var1) throws InvocationTargetException, IllegalAccessException {
      this.listenerMethod.invoke(var1, this.eventArgs);
   }
}
