package sun.plugin;

import com.sun.java.browser.net.ProxyService;
import java.applet.Applet;
import java.applet.AppletContext;
import java.awt.Color;
import java.awt.Component;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.FontMetrics;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Image;
import java.awt.RenderingHints;
import java.awt.event.WindowEvent;
import java.awt.event.WindowListener;
import java.io.BufferedInputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.lang.reflect.Method;
import java.net.Authenticator;
import java.net.MalformedURLException;
import java.net.URL;
import java.net.URLConnection;
import java.security.AccessController;
import java.util.Enumeration;
import java.util.HashMap;
import java.util.Locale;
import java.util.Properties;
import java.util.StringTokenizer;
import java.util.Vector;
import netscape.javascript.JSException;
import netscape.javascript.JSObject;
import sun.applet.AppletClassLoader;
import sun.applet.AppletEvent;
import sun.applet.AppletListener;
import sun.applet.AppletPanel;
import sun.net.www.MimeTable;
import sun.net.www.protocol.jar.URLJarFile;
import sun.plugin.cache.JarCache;
import sun.plugin.cache.JarCacheUtil;
import sun.plugin.extension.ExtensionInstallationImpl;
import sun.plugin.javascript.JSContext;
import sun.plugin.net.proxy.PluginProxyManager;
import sun.plugin.net.proxy.PluginProxyServiceProvider;
import sun.plugin.resources.ResourceHandler;
import sun.plugin.security.ActivatorSecurityManager;
import sun.plugin.security.JDK11ClassFileTransformer;
import sun.plugin.security.PluginAuthenticator;
import sun.plugin.security.PluginClassLoader;
import sun.plugin.services.BrowserService;
import sun.plugin.services.ServiceProvider;
import sun.plugin.usability.ProgressListener;
import sun.plugin.usability.ProgressTracker;
import sun.plugin.usability.Trace;
import sun.plugin.usability.TraceListener;
import sun.plugin.usability.UserProfile;
import sun.plugin.viewer.context.PluginAppletContext;
import sun.security.action.GetPropertyAction;

public class AppletViewer extends AppletPanel implements TraceListener, ProgressListener, WindowListener {
   private final ProgressInfo appletProgress = new ProgressInfo();
   private boolean loading_first_time = true;
   private boolean preloading = false;
   private Color boxBGColor = Color.lightGray;
   private Color boxFGColor = Color.black;
   private Color progressColor = new Color(153, 153, 204);
   private String userMsg = null;
   private boolean colorSet = false;
   public static final int NETWORK_ACCESS_NONE = 0;
   public static final int NETWORK_ACCESS_HOST = 1;
   public static final int NETWORK_ACCESS_UNRESTRICTED = 2;
   private static boolean initialized = false;
   public static boolean javaEnabled = true;
   public static String theVersion = "1.1";
   private static String defaultSaveFile = "Applet.ser";
   public static File theUserPropertiesFile;
   public static File theAppletViewerPropsFile;
   private URL documentURL = null;
   private URL baseURL = null;
   private static AppletMessageHandler amh = new AppletMessageHandler("appletpanel");
   protected HashMap atts = new HashMap();
   private ClassLoaderInfo cli = null;
   private static boolean fShowException = false;
   private AppletViewer.AppletEventListener appletEventListener = new AppletViewer.AppletEventListener(null);
   private Object syncInit = new Object();
   private boolean bInit = false;
   private boolean docbaseInit = false;
   private Object docBaseSyncObj = new Object();
   private boolean codeBaseInit = false;
   private String classLoaderCacheKey = null;
   private AppletStatusListener statusListener = null;
   private PluginAppletContext appletContext;
   private InputStream is;
   private GrayBoxProcesser grayBoxProcesser = null;
   private String tracingBuffer = "";

   public static void loadPropertiesFiles() {
      theUserPropertiesFile = new File(UserProfile.getPropertyFile());
      new File(theUserPropertiesFile.getParent()).mkdirs();
      theAppletViewerPropsFile = new File(UserProfile.getAppletViewerPropertyFile());
   }

   public static void initEnvironment(int var0) {
      if (!initialized) {
         initialized = true;

         try {
            ProxyService.setProvider(new PluginProxyServiceProvider());
         } catch (Exception var12) {
         }

         ServiceProvider.setService(var0);

         try {
            if (class$javax$swing$ImageIcon == null) {
               class$javax$swing$ImageIcon = class$("javax.swing.ImageIcon");
            }

            if (class$javax$swing$plaf$basic$BasicComboBoxUI == null) {
               class$javax$swing$plaf$basic$BasicComboBoxUI = class$("javax.swing.plaf.basic.BasicComboBoxUI");
            }
         } catch (Throwable var11) {
         }

         try {
            JDK11ClassFileTransformer.init();
         } catch (Throwable var10) {
            var10.printStackTrace();
         }

         Properties var1 = new Properties(System.getProperties());
         var1.put("acl.read", "+");
         var1.put("acl.read.default", "");
         var1.put("acl.write", "+");
         var1.put("acl.write.default", "");
         var1.put("browser", "sun.plugin");
         var1.put("browser.version", theVersion);
         var1.put("browser.vendor", "Sun Microsystems, Inc.");
         var1.put("http.agent", "Mozilla/4.0 (" + System.getProperty("os.name") + " " + System.getProperty("os.version") + ")");
         var1.put("package.restrict.access.sun", "true");
         var1.put("package.restrict.access.netscape", "false");
         var1.put("package.restrict.definition.java", "true");
         var1.put("package.restrict.definition.sun", "true");
         var1.put("package.restrict.definition.netscape", "true");
         var1.put("java.version.applet", "true");
         var1.put("java.vendor.applet", "true");
         var1.put("java.vendor.url.applet", "true");
         var1.put("java.class.version.applet", "true");
         var1.put("os.name.applet", "true");
         var1.put("os.version.applet", "true");
         var1.put("os.arch.applet", "true");
         var1.put("file.separator.applet", "true");
         var1.put("path.separator.applet", "true");
         var1.put("line.separator.applet", "true");
         String var2 = (String)var1.get("java.protocol.handler.pkgs");
         if (var2 != null) {
            var1.put("java.protocol.handler.pkgs", var2 + "|sun.plugin.net.protocol");
         } else {
            var1.put("java.protocol.handler.pkgs", "sun.plugin.net.protocol");
         }

         URLConnection.setDefaultAllowUserInteraction(true);

         try {
            FileInputStream var3 = new FileInputStream(theUserPropertiesFile);
            var1.load(new BufferedInputStream(var3));
            var3.close();
         } catch (Exception var9) {
         }

         if ("false".equalsIgnoreCase(var1.getProperty("javaplugin.enabled", "true"))) {
            javaEnabled = false;
            System.err.println(getMessage("java_not_enabled"));
            System.setProperties(var1);
            JavaRunTime.setNoConsole(true);
         } else {
            if ("show".equalsIgnoreCase(var1.getProperty("javaplugin.console", "hide"))) {
               JavaRunTime.showJavaConsole(true);
            } else if ("nothing".equalsIgnoreCase(var1.getProperty("javaplugin.console", "hide"))) {
               JavaRunTime.setNoConsole(true);
               JavaRunTime.showJavaConsole(false);
            } else {
               String var13 = AccessController.doPrivileged(new GetPropertyAction("os.name"));
               String var4 = AccessController.doPrivileged(new GetPropertyAction("mozilla.workaround", "false"));
               if (var13.indexOf("Windows") != -1 || var4.equalsIgnoreCase("false")) {
                  JavaRunTime.showJavaConsole(false);
               }
            }

            if ("true".equalsIgnoreCase(var1.getProperty("javaplugin.exception", "false"))) {
               fShowException = true;
            }

            try {
               Class var14 = Class.forName("sun.misc.ExtensionDependency");
               if (var14 != null) {
                  Class[] var17 = new Class[]{Class.forName("sun.misc.ExtensionInstallationProvider")};
                  Method var5 = var14.getMethod("addExtensionInstallationProvider", var17);
                  if (var5 != null) {
                     Object[] var6 = new Object[]{new ExtensionInstallationImpl()};
                     var5.invoke(null, var6);
                  } else {
                     Trace.println(ResourceHandler.getMessage("optpkg.install.error.nomethod"), 2);
                  }
               } else {
                  Trace.println(ResourceHandler.getMessage("optpkg.install.error.noclass"), 2);
               }
            } catch (Throwable var8) {
               Trace.printException(var8);
            }

            var1.remove("proxyHost");
            var1.remove("proxyPort");
            var1.remove("http.proxyHost");
            var1.remove("http.proxyPort");
            var1.remove("https.proxyHost");
            var1.remove("https.proxyPort");
            var1.remove("ftpProxyHost");
            var1.remove("ftpProxyPort");
            var1.remove("ftpProxySet");
            var1.remove("gopherProxyHost");
            var1.remove("gopherProxyPort");
            var1.remove("gopherProxySet");
            var1.remove("socksProxyHost");
            var1.remove("socksProxyPort");
            if ("true".equalsIgnoreCase(var1.getProperty("javaplugin.proxy.authentication", "true"))) {
               Authenticator.setDefault(new PluginAuthenticator());
            }

            System.setProperties(var1);
            System.out.println("");
            PluginProxyManager.reset();
            System.out.println("");
            JarCache.init();
            if (Trace.isEnabled()) {
               JavaRunTime.showSystemProperties();
            }

            System.out.println("");

            try {
               MimeTable var15 = MimeTable.getDefaultTable();
            } catch (Throwable var7) {
               Trace.printException(var7);
            }

            ActivatorSecurityManager var16 = new ActivatorSecurityManager();
            System.setSecurityManager(var16);
            JavaRunTime.showJavaConsoleHelp();
            URLJarFile.setCallBack(new PluginURLJarFileCallBack());
         }
      }
   }

   public void appletInit() {
      this.addAppletListener(this.appletEventListener);
      String var1 = this.getParameter("cache_archive");
      String var2 = this.getParameter("cache_version");
      String var3 = this.getParameter("cache_archive_ex");

      try {
         HashMap var4 = JarCacheUtil.getJarsWithVersion(var1, var2, var3);
         if (!var4.isEmpty()) {
            JarCacheUtil.verifyJarVersions(this.getCodeBase(), this.getClassLoaderCacheKey(), var4);
         }
      } catch (Exception var10) {
         Trace.printException(var10, ResourceHandler.getMessage("cache.error"), ResourceHandler.getMessage("cache.caption"));
      }

      this.cli = ClassLoaderInfo.find(this.getCodeBase(), this.getClassLoaderCacheKey());
      this.cli.addReference();
      this.appletContext.addAppletPanelInContext(this);
      Class var11 = class$sun$plugin$AppletViewer == null ? (class$sun$plugin$AppletViewer = class$("sun.plugin.AppletViewer")) : class$sun$plugin$AppletViewer;
      synchronized (var11) {
         super.init();
      }

      Thread var5 = this.getAppletHandlerThread();
      Trace.addTraceListener(var5.getThreadGroup(), this);
      ProgressTracker.addProgressListener(var5.getThreadGroup(), this);
      this.grayBoxProcesser = new GrayBoxProcesser(var5.getThreadGroup(), this);
      this.grayBoxProcesser.start();
      this.appletProgress.init(this);
      Trace.println(ResourceHandler.getMessage("applet.progress.load"), this);
      this.sendEvent(1);
      Trace.println(ResourceHandler.getMessage("applet.progress.init"), this);
      this.sendEvent(2);
      Object var6 = this.syncInit;
      synchronized (var6) {
         this.bInit = true;
      }
   }

   public void appletStart() {
      Object var1 = this.syncInit;
      synchronized (var1) {
         if (!this.bInit) {
            return;
         }
      }

      Trace.println(ResourceHandler.getMessage("applet.progress.start"), this);
      this.sendEvent(3);
   }

   public void appletStop() {
      Object var1 = this.syncInit;
      synchronized (var1) {
         if (!this.bInit) {
            return;
         }
      }

      if (this.status == 1) {
         Trace.println(ResourceHandler.getMessage("applet.progress.stoploading"), this, 2);
         this.stopLoading();
      }

      Trace.println(ResourceHandler.getMessage("applet.progress.stop"), this);
      this.sendEvent(4);
   }

   public void appletDestroy() {
      Object var1 = this.syncInit;
      synchronized (var1) {
         if (!this.bInit) {
            return;
         }
      }

      if (this.grayBoxProcesser != null) {
         this.grayBoxProcesser.stop();
         this.grayBoxProcesser = null;
      }

      this.removeAppletListener(this.appletEventListener);
      this.appletEventListener = null;
      this.appletContext.removeAppletPanelFromContext(this);
      Thread var2 = this.getAppletHandlerThread();
      if (var2 != null) {
         ProgressTracker.removeProgressListener(var2.getThreadGroup(), this);
         Trace.removeTraceListener(var2.getThreadGroup(), this);
      }

      AppletViewer$1 var3 = new AppletViewer$1(this);
      Thread var4 = new Thread(var3);
      var4.start();

      try {
         Trace.println(ResourceHandler.getMessage("applet.progress.joining"), this);
         if (var2 != null) {
            var2.join(1000L);
         }

         Trace.println(ResourceHandler.getMessage("applet.progress.joined"), this);
      } catch (InterruptedException var6) {
      }
   }

   protected void onPrivateClose(int var1) {
      Trace.println(ResourceHandler.getMessage("applet.progress.destroy"), this);
      this.sendEvent(5);
      Trace.println(ResourceHandler.getMessage("applet.progress.dispose"), this);
      this.sendEvent(0);
      Trace.println(ResourceHandler.getMessage("applet.progress.quit"), this);
      this.sendEvent(6);
      Trace.println(ResourceHandler.getMessage("applet.progress.findinfo.0"), this, 2);
      this.cli.removeReference();
      this.cli = null;
      Trace.println(ResourceHandler.getMessage("applet.progress.findinfo.1"), this, 2);
      this.appletContext = null;
   }

   public String getParameter(String var1) {
      var1 = var1.toLowerCase(Locale.ENGLISH);
      HashMap var2 = this.atts;
      synchronized (var2) {
         String var3 = (String)this.atts.get(var1);
         if (var3 != null) {
            var3 = this.trimWhiteSpaces(var3);
         }

         return var3;
      }
   }

   public void setParameter(String var1, Object var2) {
      var1 = var1.toLowerCase(Locale.ENGLISH);
      HashMap var3 = this.atts;
      synchronized (var3) {
         this.atts.put(var1, this.trimWhiteSpaces(var2.toString()));
      }
   }

   private String trimWhiteSpaces(String var1) {
      if (var1 == null) {
         return var1;
      } else {
         StringBuffer var2 = new StringBuffer();

         for (int var3 = 0; var3 < var1.length(); var3++) {
            char var4 = var1.charAt(var3);
            if (var4 != '\n' && var4 != '\f' && var4 != '\r' && var4 != '\t') {
               var2.append(var4);
            }
         }

         return var2.toString().trim();
      }
   }

   public void setDocumentBase(String var1) {
      if (!this.docbaseInit) {
         StringBuffer var3 = new StringBuffer(var1);
         int var4 = var3.toString().indexOf("|");
         if (var4 >= 0) {
            var3.setCharAt(var4, ':');
         }

         try {
            this.documentURL = new URL(this.canonicalizeDocumentURL(var3.toString()));
         } catch (Throwable var8) {
            var8.printStackTrace();
         }

         this.docbaseInit = true;
         Object var5 = this.docBaseSyncObj;
         synchronized (var5) {
            this.docBaseSyncObj.notifyAll();
         }
      }
   }

   public String canonicalizeDocumentURL(String var1) {
      int var2 = -1;
      int var4 = var1.indexOf(35);
      int var5 = var1.indexOf(63);
      if (var5 != -1 && var4 != -1) {
         var2 = Math.min(var4, var5);
      } else if (var4 != -1) {
         var2 = var4;
      } else if (var5 != -1) {
         var2 = var5;
      }

      String var6;
      if (var2 == -1) {
         var6 = var1;
      } else {
         var6 = var1.substring(0, var2);
      }

      StringBuffer var7 = new StringBuffer(var6);
      int var8 = var7.toString().indexOf("|");
      if (var8 >= 0) {
         var7.setCharAt(var8, ':');
      }

      return var7.toString();
   }

   public URL getDocumentBase() {
      Object var1 = new Object();
      synchronized (var1) {
         if (!this.docbaseInit) {
            BrowserService var3 = ServiceProvider.getService();
            if (var3.isNetscape() && var3.getBrowserVersion() >= 5.0F) {
               try {
                  Object var16 = this.docBaseSyncObj;
                  synchronized (var16) {
                     while (!this.docbaseInit) {
                        this.docBaseSyncObj.wait(0L);
                     }
                  }
               } catch (InterruptedException var13) {
                  var13.printStackTrace();
               }
            } else {
               JSContext var4 = (JSContext)this.getAppletContext();

               try {
                  JSObject var5 = var4.getJSObject();
                  if (var5 == null) {
                     throw new JSException("Unable to obtain Window object");
                  }

                  JSObject var6 = (JSObject)var5.getMember("document");
                  if (var6 == null) {
                     throw new JSException("Unable to obtain Document object");
                  }

                  String var7 = (String)var6.getMember("URL");
                  StringBuffer var8 = new StringBuffer(var7);
                  int var9 = var8.toString().indexOf("|");
                  if (var9 >= 0) {
                     var8.setCharAt(var9, ':');
                  }

                  for (int var10 = 0; var10 < var7.length(); var10++) {
                     if (var7.charAt(var10) == '\\') {
                        var8.setCharAt(var10, '/');
                     }
                  }

                  var9 = var8.toString().indexOf("file://");
                  if (var9 == 0 && var8.toString().charAt(var9 + 7) != '/') {
                     var8.insert(var9 + 7, '/');
                  }

                  this.documentURL = new URL(this.canonicalizeDocumentURL(var8.toString()));
               } catch (Throwable var14) {
                  var14.printStackTrace();
               }

               this.docbaseInit = true;
            }
         }
      }

      return this.documentURL;
   }

   public URL getCodeBase() {
      Object var1 = new Object();
      synchronized (var1) {
         if (!this.codeBaseInit) {
            String var3 = this.getParameter("java_codebase");
            if (var3 == null) {
               var3 = this.getParameter("codebase");
            }

            if (var3 != null) {
               if (!var3.equals(".") && !var3.endsWith("/")) {
                  var3 = var3 + "/";
               }

               try {
                  this.baseURL = new URL(this.getDocumentBase(), var3);
               } catch (MalformedURLException var9) {
               }
            }

            if (this.baseURL == null) {
               String var4 = this.getDocumentBase().getFile();
               int var5 = var4.lastIndexOf(47);
               if (var5 > -1 && var5 < var4.length() - 1) {
                  try {
                     this.baseURL = new URL(this.getDocumentBase(), var4.substring(0, var5 + 1));
                  } catch (MalformedURLException var8) {
                  }
               }
            }

            if (this.baseURL == null) {
               this.baseURL = this.getDocumentBase();
            }

            this.codeBaseInit = true;
         }
      }

      return this.baseURL;
   }

   public int getWidth() {
      String var1 = this.getParameter("width");
      return var1 != null ? Integer.valueOf(var1) : 0;
   }

   public int getHeight() {
      String var1 = this.getParameter("height");
      return var1 != null ? Integer.valueOf(var1) : 0;
   }

   public String getCode() {
      String var1 = this.getParameter("classid");
      String var2 = null;
      if (var1 != null) {
         int var3 = var1.indexOf("java:");
         if (var3 > -1) {
            var2 = var1.substring(5 + var3);
            if (var2 != null || !var2.equals("")) {
               return var2;
            }
         }
      }

      var2 = this.getParameter("java_code");
      if (var2 == null) {
         var2 = this.getParameter("code");
      }

      return var2;
   }

   public boolean isLegacyLifeCycle() {
      String var1 = this.getParameter("legacy_lifecycle");
      return var1 != null && var1.equalsIgnoreCase("true");
   }

   public String getClassLoaderCacheKey() {
      String var1 = this.getParameter("classloader-policy");
      if (var1 != null && var1.equals("classic")) {
         return super.getClassLoaderCacheKey();
      } else {
         if (this.classLoaderCacheKey == null) {
            StringBuffer var2 = new StringBuffer();
            var2.append(this.getCodeBase());
            String var3 = this.getParameter("cache_archive");
            if (var3 != null) {
               var2.append(",");
               var2.append(var3);
            }

            var3 = this.getParameter("java_archive");
            if (var3 != null) {
               var2.append(",");
               var2.append(var3);
            }

            var3 = this.getParameter("archive");
            if (var3 != null) {
               var2.append(",");
               var2.append(var3);
            }

            this.classLoaderCacheKey = var2.toString();
         }

         return this.classLoaderCacheKey;
      }
   }

   public String getJarFiles() {
      String var1 = this.getParameter("archive");
      String var2 = this.getParameter("java_archive");
      String var3 = this.getParameter("cache_archive");
      String var4 = this.getParameter("cache_archive_ex");
      String var5 = null;
      if (var4 != null) {
         int var6 = var4.indexOf(";");
         if (var6 != -1) {
            var5 = JarCacheUtil.getJarsInCacheArchiveEx(var4);
         } else {
            var5 = var4;
         }
      }

      return this.addJarFileToPath(var5, this.addJarFileToPath(var3, this.addJarFileToPath(var2, var1)));
   }

   private String addJarFileToPath(String var1, String var2) {
      if (var1 == null && var2 == null) {
         return null;
      } else if (var1 == null && var2 != null) {
         return var2;
      } else {
         return var1 != null && var2 == null ? var1 : var1 + "," + var2;
      }
   }

   protected Vector getLocalJarFiles() {
      String var1 = File.separator;
      String var2 = System.getProperty("java.home") + var1 + "lib";
      String var3 = var2 + var1 + "applet";
      return this.getJarFilesFromPath(var3);
   }

   private Vector getJarFilesFromPath(String var1) {
      Vector var2 = new Vector();
      File var3 = new File(var1);
      if (var3.exists()) {
         String[] var4 = var3.list(new AppletViewer$2(this));
         String var5 = File.separator;

         for (int var6 = 0; var6 < var4.length; var6++) {
            String var7 = var1 + var5 + var4[var6];
            var2.add(new File(var7));
         }
      }

      return var2;
   }

   protected void loadJarFiles(AppletClassLoader var1) throws IOException, InterruptedException {
      if (this.loading_first_time) {
         this.loading_first_time = false;
         String var2 = this.getParameter("cache_archive_ex");

         try {
            if (var2 != null) {
               this.preloading = true;
               JarCacheUtil.preload(this.getCodeBase(), var2);
               this.preloading = false;
            }
         } catch (Exception var10) {
            Trace.printException(var10, ResourceHandler.getMessage("cache.error"), ResourceHandler.getMessage("cache.caption"));
         }
      }

      String var12 = this.getJarFiles();

      try {
         this.cli.lock();
         if (!this.cli.getLocalJarsLoaded() && var1 instanceof PluginClassLoader) {
            Vector var3 = this.getLocalJarFiles();
            Enumeration var4 = var3.elements();

            while (var4.hasMoreElements()) {
               URL var5 = ((File)var4.nextElement()).toURL();
               ((PluginClassLoader)var1).addMyJar(var5);
            }

            this.cli.setLocalJarsLoaded(true);
         }

         if (var12 != null) {
            StringTokenizer var13 = new StringTokenizer(var12, ",", false);

            while (var13.hasMoreTokens()) {
               String var14 = var13.nextToken().trim();
               if (!this.cli.hasJar(var14)) {
                  this.cli.addJar(var14);
               }
            }

            super.loadJarFiles(var1);
            return;
         }
      } finally {
         this.cli.unlock();
      }
   }

   public String getSerializedObject() {
      String var1 = this.getParameter("java_object");
      if (var1 == null) {
         var1 = this.getParameter("object");
      }

      return var1;
   }

   public Applet getApplet() {
      Applet var1 = super.getApplet();
      if (var1 != null) {
         return var1 instanceof BeansApplet ? null : var1;
      } else {
         return null;
      }
   }

   public Object getViewedObject() {
      Applet var1 = super.getApplet();
      return var1 instanceof BeansApplet ? ((BeansApplet)var1).bean : var1;
   }

   public void setAppletContext(AppletContext var1) {
      if (var1 == null) {
         throw new IllegalArgumentException("AppletContext");
      } else {
         if (this.appletContext != null) {
            this.appletContext.removeAppletPanelFromContext(this);
         }

         this.appletContext = (PluginAppletContext)var1;
      }
   }

   public AppletContext getAppletContext() {
      return this.appletContext;
   }

   public void setColorAndText() {
      String var1 = this.getParameter("boxbgcolor");
      if (var1 != null) {
         this.boxBGColor = this.createColor("boxbgcolor", var1);
      }

      this.setBackground(Color.lightGray);
      String var2 = this.getParameter("boxfgcolor");
      if (var2 != null) {
         this.boxFGColor = this.createColor("boxfgcolor", var2);
      }

      String var3 = this.getParameter("progresscolor");
      if (var3 != null) {
         this.progressColor = this.createColor("progresscolor", var3);
      }

      this.userMsg = this.getParameter("boxmessage");
      this.colorSet = true;
   }

   private Color createColor(String var1, String var2) {
      if (var2 != null && var2.indexOf(",") != -1) {
         StringTokenizer var3 = new StringTokenizer(var2, ",");
         if (var3.countTokens() == 3) {
            int var4 = 0;
            int var5 = 0;
            int var6 = 0;

            int var7;
            for (var7 = 0; var3.hasMoreTokens(); var4++) {
               String var8 = (String)var3.nextElement();
               switch (var4) {
                  case 0:
                     if (!var8.trim().equals("")) {
                        var5 = new Integer(var8.trim());
                     }
                     break;
                  case 1:
                     if (!var8.trim().equals("")) {
                        var6 = new Integer(var8.trim());
                     }
                     break;
                  case 2:
                     if (!var8.trim().equals("")) {
                        var7 = new Integer(var8.trim());
                     }
               }
            }

            return new Color(var5, var6, var7);
         } else {
            Trace.println(ResourceHandler.getMessage("applet_viewer.color_tag") + var1, 2);
            return null;
         }
      } else {
         if (var2 != null) {
            if (var2.equalsIgnoreCase("red")) {
               return Color.red;
            }

            if (var2.equalsIgnoreCase("yellow")) {
               return Color.yellow;
            }

            if (var2.equalsIgnoreCase("black")) {
               return Color.black;
            }

            if (var2.equalsIgnoreCase("blue")) {
               return Color.blue;
            }

            if (var2.equalsIgnoreCase("cyan")) {
               return Color.cyan;
            }

            if (var2.equalsIgnoreCase("darkGray")) {
               return Color.darkGray;
            }

            if (var2.equalsIgnoreCase("gray")) {
               return Color.gray;
            }

            if (var2.equalsIgnoreCase("lightGray")) {
               return Color.lightGray;
            }

            if (var2.equalsIgnoreCase("green")) {
               return Color.green;
            }

            if (var2.equalsIgnoreCase("magenta")) {
               return Color.magenta;
            }

            if (var2.equalsIgnoreCase("orange")) {
               return Color.orange;
            }

            if (var2.equalsIgnoreCase("pink")) {
               return Color.pink;
            }

            if (var2.equalsIgnoreCase("white")) {
               return Color.white;
            }
         }

         return null;
      }
   }

   public void paintForegrnd(Graphics var1) {
      Dimension var2 = this.getSize();
      if (var2.width > 0 && var2.height > 0) {
         Image var3 = this.createImage(var2.width, var2.height);
         Graphics2D var4 = (Graphics2D)var3.getGraphics();
         var4.setRenderingHint(RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_ON);
         var4.setBackground(this.boxBGColor);
         var4.setColor(this.boxBGColor);
         var4.fillRect(0, 0, var2.width, var2.height);
         Font var5 = var4.getFont();
         var5 = var5.deriveFont(0, 10.0F);
         var4.setFont(var5);
         FontMetrics var6 = var4.getFontMetrics(var5);
         Object var7 = null;
         if (this.tracingBuffer == null) {
            var7 = this.getWaitingMessage();
         } else {
            var7 = this.tracingBuffer;
         }

         if (var2 != null && var6 != null) {
            var4.setColor(this.boxFGColor);
            if (this.userMsg != null) {
               var7 = this.userMsg;
            }

            var4.drawString((String)var7, (var2.width - var6.stringWidth((String)var7)) / 2, (var2.height + var6.getAscent()) / 2);
            var4.drawRect((int)(var2.width * 0.2), (var2.height + var6.getAscent()) / 2 + var6.getHeight() - 1, (int)(var2.width * 0.6), var6.getHeight() + 1);
            var4.setColor(this.progressColor);
            int var8 = 0;
            ProgressInfo var9 = this.appletProgress;
            synchronized (var9) {
               var8 = (int)((var2.width * 0.6 - 1.0) * this.appletProgress.getProgress() / this.appletProgress.getProgressMax());
            }

            var4.fillRect((int)(var2.width * 0.2 + 1.0), (var2.height + var6.getAscent()) / 2 + var6.getHeight(), var8, var6.getHeight());
         }

         var1.drawImage(var3, 0, 0, null);
         var3.flush();
      }
   }

   public String getWaitingMessage() {
      return getMessage("loading") + this.getHandledType() + " ...";
   }

   protected void load(InputStream var1) {
      this.is = var1;
   }

   protected Applet createApplet(AppletClassLoader var1) throws ClassNotFoundException, IllegalAccessException, IOException, InstantiationException, InterruptedException {
      if (this.is == null) {
         return super.createApplet(var1);
      } else {
         AppletObjectInputStream var2 = new AppletObjectInputStream(this.is, var1);
         Object var3 = var2.readObject();
         Applet var4 = (Applet)var3;
         this.doInit = false;
         if (Thread.interrupted()) {
            label28:
            try {
               this.status = 0;
               Object var9 = null;
               this.showAppletStatus("death");
            } finally {
               break label28;
            }

            Thread.currentThread().interrupt();
            return null;
         } else {
            this.is = null;
            return var4;
         }
      }
   }

   public String getName() {
      String var1 = this.getParameter("name");
      if (var1 != null) {
         return var1;
      } else {
         var1 = this.getCode();
         if (var1 != null) {
            int var2 = var1.lastIndexOf(".class");
            if (var2 != -1) {
               var1 = var1.substring(0, var2);
            }
         } else {
            var1 = this.getSerializedObject();
            if (var1 != null) {
               int var4 = var1.lastIndexOf(".ser");
               if (var4 != -1) {
                  var1 = var1.substring(0, var4);
               }
            }
         }

         return var1;
      }
   }

   protected String getHandledType() {
      return getMessage("java_applet");
   }

   public void addAppletStatusListener(AppletStatusListener var1) {
      this.statusListener = var1;
   }

   public void removeAppletStatusListener(AppletStatusListener var1) {
      this.statusListener = null;
   }

   public void setStatus(int var1) {
      this.status = var1;
   }

   public void showAppletLog(String var1) {
      super.showAppletLog(var1);
   }

   public void showAppletStatus(String var1) {
      if (var1 != null && !var1.equals("") && !var1.equals("\n")) {
         try {
            String var2 = this.getName();
            if (var2 != null && !var1.equals("")) {
               this.getAppletContext().showStatus(getMessage("status_applet") + var2 + " " + var1);
            } else {
               this.getAppletContext().showStatus(getMessage("status_applet") + var1);
            }

            if ((this.status == 3 || this.status == 7) && this.grayBoxProcesser != null) {
               this.grayBoxProcesser.stop();
               this.grayBoxProcesser = null;
            }

            if (this.statusListener != null) {
               this.statusListener.statusChanged(this.status);
            }
         } catch (Throwable var3) {
            var3.printStackTrace();
         }
      }
   }

   public void setDoInit(boolean var1) {
      this.doInit = var1;
   }

   public static String getMessage(String var0) {
      return ResourceHandler.getMessage(var0);
   }

   public static String[] getMessageArray(String var0) {
      return ResourceHandler.getMessageArray(var0);
   }

   protected AppletClassLoader createClassLoader(URL var1) {
      return ClassLoaderInfo.find(var1, this.getClassLoaderCacheKey()).getLoader();
   }

   protected void showAppletException(Throwable var1) {
      super.showAppletException(var1);
      Trace.println("Exception: " + var1.toString(), this, 4);
      if (fShowException) {
         Trace.printException(var1);
      }
   }

   public void println(String var1, int var2) {
      if ((var2 & 4) == 4) {
         if (this.status == 1 || this.status == 2 || this.status == 7) {
            this.tracingBuffer = var1;
            if (this.grayBoxProcesser != null && this.status == 7) {
               this.grayBoxProcesser.addRequest(new AppletViewer$3(this, this));
            }
         }
      } else if ((var2 & 1) == 1) {
         this.getAppletContext().showStatus(var1);
      }
   }

   public boolean isSupported(int var1) {
      return (var1 & 4) == 4 || (var1 & 1) == 1;
   }

   public void onStartBinding(Object var1) {
      if (this.grayBoxProcesser != null) {
         this.grayBoxProcesser.addRequest(new AppletViewer$4(this, var1));
      }

      if (this.preloading) {
         Trace.println(ResourceHandler.getMessage("progress_bar.preload") + var1.toString().substring(var1.toString().lastIndexOf(47) + 1), this, 4);
      }
   }

   public void onProgressAvailable(Object var1, int var2, int var3) {
      if (this.grayBoxProcesser != null) {
         this.grayBoxProcesser.addRequest(new AppletViewer$5(this, var1, var2, var3));
      }
   }

   public void update(Graphics var1) {
      Dimension var2 = this.getSize();
      if (var2.width <= 0 || var2.height <= 0 || this.status != 1 && this.status != 2 && this.status != 7) {
         super.update(var1);
      } else {
         this.paintForegrnd(var1);
      }
   }

   public void onStopBinding(Object var1) {
      this.onProgressComplete(var1);
   }

   public void onProgressComplete(Object var1) {
      if (this.grayBoxProcesser != null) {
         this.grayBoxProcesser.addRequest(new AppletViewer$6(this, var1));
      }
   }

   public int getLoadingStatus() {
      return this.status;
   }

   public void windowActivated(WindowEvent var1) {
   }

   public void windowClosed(WindowEvent var1) {
   }

   public void windowClosing(WindowEvent var1) {
   }

   public void windowDeactivated(WindowEvent var1) {
   }

   public void windowDeiconified(WindowEvent var1) {
   }

   public void windowIconified(WindowEvent var1) {
   }

   public void windowOpened(WindowEvent var1) {
   }

   private static class AppletEventListener implements AppletListener {
      private AppletEventListener() {
      }

      public void appletStateChanged(AppletEvent var1) {
         switch (var1.getID()) {
            case 51234:
               AppletViewer var2 = (AppletViewer)var1.getSource();
               if (var2 != null) {
                  Object var3 = var2.getViewedObject();
                  if (var3 instanceof Component) {
                     var2.setSize(var2.getSize());
                     ((Component)var3).setSize(var2.getSize());
                     var2.validate();
                  }
               }
         }
      }
   }
}
