package sun.plugin;

import java.awt.BorderLayout;
import java.awt.EventQueue;
import java.awt.FlowLayout;
import java.awt.Insets;
import java.awt.Toolkit;
import java.awt.event.InvocationEvent;
import java.security.AccessController;
import java.util.Enumeration;
import java.util.TreeSet;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollBar;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.JViewport;
import javax.swing.KeyStroke;
import sun.awt.AppContext;
import sun.plugin.resources.ResourceHandler;
import sun.security.action.GetPropertyAction;

class ConsoleWindow extends JFrame {
   private static EventQueue consoleEventQueue;
   private JTextArea textArea;
   private JScrollPane scroller;
   private JScrollBar sbHor;
   private JScrollBar sbVer;
   private boolean onWindows = false;
   private boolean isMozilla = false;
   private Toolkit toolkit = null;
   private static final int TEXT_LIMIT = 1048575;

   ConsoleWindow() {
      super(ResourceHandler.getMessage("console.caption"));

      try {
         String var1 = AccessController.doPrivileged(new GetPropertyAction("os.name"));
         if (var1.indexOf("Windows") != -1) {
            this.onWindows = true;
         }

         String var2 = AccessController.doPrivileged(new GetPropertyAction("mozilla.workaround", "false"));
         if (var2 != null && var2.equalsIgnoreCase("true")) {
            this.isMozilla = true;
         }
      } catch (Exception var26) {
         var26.printStackTrace();
      }

      this.setSize(450, 400);
      this.setResizable(true);
      this.setDefaultCloseOperation(0);
      if (!this.onWindows && this.isMozilla) {
         this.getRootPane().setDoubleBuffered(false);
         ((JPanel)this.getContentPane()).setDoubleBuffered(false);
      }

      this.getContentPane().setLayout(new BorderLayout());
      this.textArea = new JTextArea();
      this.textArea.setEditable(false);
      this.textArea.setMargin(new Insets(0, 5, 0, 0));
      this.scroller = new JScrollPane(this.textArea);
      JViewport var27 = this.scroller.getViewport();
      var27.setScrollMode(1);
      this.sbVer = this.scroller.getVerticalScrollBar();
      this.sbHor = this.scroller.getHorizontalScrollBar();
      this.getContentPane().add(this.scroller, "Center");
      ConsoleWindow$1 var28 = new ConsoleWindow$1(this);
      ConsoleWindow$2 var3 = new ConsoleWindow$2(this);
      ConsoleWindow$3 var4 = new ConsoleWindow$3(this);
      ConsoleWindow$4 var5 = new ConsoleWindow$4(this);
      ConsoleWindow$5 var6 = new ConsoleWindow$5(this);
      ConsoleWindow$6 var7 = new ConsoleWindow$6(this);
      ConsoleWindow$7 var8 = new ConsoleWindow$7(this);
      ConsoleWindow$8 var9 = new ConsoleWindow$8(this);
      ConsoleWindow$9 var10 = new ConsoleWindow$9(this);
      ConsoleWindow$10 var11 = new ConsoleWindow$10(this);
      ConsoleWindow$11 var12 = new ConsoleWindow$11(this);
      ConsoleWindow$12 var13 = new ConsoleWindow$12(this, var12);
      ConsoleWindow$13 var14 = new ConsoleWindow$13(this, var12);
      ConsoleWindow$14 var15 = new ConsoleWindow$14(this);
      ConsoleWindow$15 var16 = new ConsoleWindow$15(this);
      ConsoleWindow$16 var17 = new ConsoleWindow$16(this);
      ConsoleWindow$17 var18 = new ConsoleWindow$17(this);
      ConsoleWindow$18 var19 = new ConsoleWindow$18(this);
      ConsoleWindow$19 var20 = new ConsoleWindow$19(this);
      ConsoleWindow$20 var21 = new ConsoleWindow$20(this);
      this.textArea.registerKeyboardAction(var28, KeyStroke.getKeyStroke(84, 0), 2);
      this.textArea.registerKeyboardAction(var4, KeyStroke.getKeyStroke(80, 0), 2);
      this.textArea.registerKeyboardAction(var3, KeyStroke.getKeyStroke(82, 0), 2);
      this.textArea.registerKeyboardAction(var5, KeyStroke.getKeyStroke(83, 0), 2);
      this.textArea.registerKeyboardAction(var6, KeyStroke.getKeyStroke(72, 0), 2);
      this.textArea.registerKeyboardAction(var12, KeyStroke.getKeyStroke(77, 0), 2);
      this.textArea.registerKeyboardAction(var9, KeyStroke.getKeyStroke(67, 0), 2);
      this.textArea.registerKeyboardAction(var14, KeyStroke.getKeyStroke(71, 0), 2);
      this.textArea.registerKeyboardAction(var13, KeyStroke.getKeyStroke(70, 0), 2);
      this.textArea.registerKeyboardAction(var11, KeyStroke.getKeyStroke(81, 0), 2);
      this.textArea.registerKeyboardAction(var15, KeyStroke.getKeyStroke(48, 0), 2);
      this.textArea.registerKeyboardAction(var16, KeyStroke.getKeyStroke(49, 0), 2);
      this.textArea.registerKeyboardAction(var17, KeyStroke.getKeyStroke(50, 0), 2);
      this.textArea.registerKeyboardAction(var18, KeyStroke.getKeyStroke(51, 0), 2);
      this.textArea.registerKeyboardAction(var19, KeyStroke.getKeyStroke(52, 0), 2);
      this.textArea.registerKeyboardAction(var20, KeyStroke.getKeyStroke(53, 0), 2);
      this.textArea.registerKeyboardAction(var8, KeyStroke.getKeyStroke(88, 0), 2);
      this.textArea.registerKeyboardAction(var7, KeyStroke.getKeyStroke(76, 0), 2);
      this.textArea.registerKeyboardAction(var21, KeyStroke.getKeyStroke(79, 0), 2);
      JButton var22 = new JButton(ResourceHandler.getMessage("console.clear"));
      var22.setMnemonic(67);
      JButton var23 = new JButton(ResourceHandler.getMessage("console.copy"));
      var23.setMnemonic(88);
      JButton var24 = new JButton(ResourceHandler.getMessage("console.close"));
      var24.setMnemonic(81);
      JPanel var25 = new JPanel();
      var25.setLayout(new FlowLayout(1));
      var25.add(var22);
      var25.add(new JLabel("    "));
      var25.add(var23);
      var25.add(new JLabel("    "));
      var25.add(var24);
      this.getContentPane().add(var25, "South");
      this.addWindowListener(new ConsoleWindow$21(this));
      var22.addActionListener(var9);
      var23.addActionListener(var10);
      var24.addActionListener(var11);
      consoleEventQueue = (EventQueue)AppContext.getAppContext().get(AppContext.EVENT_QUEUE_KEY);
      this.toolkit = Toolkit.getDefaultToolkit();
   }

   public void append(String var1) {
      Toolkit var2 = this.toolkit;
      consoleEventQueue.postEvent(new InvocationEvent(var2, new ConsoleWindow$22(this, var1)));
   }

   private void dumpThreadGroup(ThreadGroup var1, StringBuffer var2) {
      if (var1 != null) {
         try {
            if (var1.activeCount() == 0 && var1.activeGroupCount() == 0 && !var1.isDestroyed()) {
               var1.destroy();
            }
         } catch (Throwable var7) {
         }

         var2.append("Group " + var1.getName());
         var2.append(",ac=" + var1.activeCount());
         var2.append(",agc=" + var1.activeGroupCount());
         var2.append(",pri=" + var1.getMaxPriority());
         if (var1.isDestroyed()) {
            var2.append(",destoyed");
         }

         if (var1.isDaemon()) {
            var2.append(",daemon");
         }

         var2.append("\n");
         Thread[] var3 = new Thread[1000];
         var1.enumerate(var3, false);

         for (int var4 = 0; var4 < var3.length; var4++) {
            if (var3[var4] != null) {
               var2.append("    ");
               var2.append(var3[var4].getName());
               var2.append(",");
               var2.append(var3[var4].getPriority());
               if (var3[var4].isAlive()) {
                  var2.append(",alive");
               } else {
                  var2.append(",not alive");
               }

               if (var3[var4].isDaemon()) {
                  var2.append(",dameon");
               }

               if (var3[var4].isInterrupted()) {
                  var2.append(",interrupted");
               }

               var2.append("\n");
            }
         }

         ThreadGroup[] var5 = new ThreadGroup[1000];
         var1.enumerate(var5, false);

         for (int var6 = 0; var6 < var5.length; var6++) {
            if (var5[var6] != null) {
               this.dumpThreadGroup(var5[var6], var2);
            }
         }
      }
   }

   public String displayHelp() {
      StringBuffer var1 = new StringBuffer();
      var1.append(ResourceHandler.getMessage("console.menu.text.top"));
      var1.append(ResourceHandler.getMessage("console.menu.text.c"));
      var1.append(ResourceHandler.getMessage("console.menu.text.f"));
      var1.append(ResourceHandler.getMessage("console.menu.text.g"));
      var1.append(ResourceHandler.getMessage("console.menu.text.h"));
      var1.append(ResourceHandler.getMessage("console.menu.text.l"));
      var1.append(ResourceHandler.getMessage("console.menu.text.m"));
      var1.append(ResourceHandler.getMessage("console.menu.text.o"));
      var1.append(ResourceHandler.getMessage("console.menu.text.p"));
      var1.append(ResourceHandler.getMessage("console.menu.text.q"));
      var1.append(ResourceHandler.getMessage("console.menu.text.r"));
      var1.append(ResourceHandler.getMessage("console.menu.text.s"));
      var1.append(ResourceHandler.getMessage("console.menu.text.t"));
      var1.append(ResourceHandler.getMessage("console.menu.text.x"));
      var1.append(ResourceHandler.getMessage("console.menu.text.0"));
      var1.append(ResourceHandler.getMessage("console.menu.text.tail"));
      return var1.toString();
   }

   public String displayVersion() {
      StringBuffer var1 = new StringBuffer();
      var1.append(ResourceHandler.getMessage("product_name"));
      String var2 = System.getProperty("javaplugin.version");
      if (var2 != null) {
         var1.append(": " + ResourceHandler.getMessage("version") + " " + System.getProperty("javaplugin.version"));
      }

      var1.append("\n");
      var1.append(ResourceHandler.getMessage("using_jre_version"));
      var1.append(" ");
      var1.append(System.getProperty("java.version"));
      var1.append(" ");
      var1.append(System.getProperty("java.vm.name"));
      var1.append("\n");
      var1.append(ResourceHandler.getMessage("user_home_dir"));
      var1.append(" = ");
      var1.append(System.getProperty("user.home"));
      return var1.toString();
   }

   public void displaySystemProperties() {
      TreeSet var1 = new TreeSet();
      Enumeration var2 = System.getProperties().propertyNames();

      while (var2.hasMoreElements()) {
         var1.add(var2.nextElement());
      }

      StringBuffer var3 = new StringBuffer();
      var3.append(ResourceHandler.getMessage("console.dump.properties"));
      var3.append(ResourceHandler.getMessage("console.menu.text.top"));

      for (String var5 : var1) {
         String var6 = System.getProperty(var5);
         if (var6 != null) {
            if (var6.equals("\n")) {
               var6 = "\\n";
            } else if (var6.equals("\r")) {
               var6 = "\\r";
            } else if (var6.equals("\r\n")) {
               var6 = "\\r\\n";
            } else if (var6.equals("\n\r")) {
               var6 = "\\n\\r";
            } else if (var6.equals("\n\n")) {
               var6 = "\\n\\n";
            } else if (var6.equals("\r\r")) {
               var6 = "\\r\\r";
            }
         }

         var3.append(var5 + " = " + var6 + "\n");
      }

      var3.append(ResourceHandler.getMessage("console.menu.text.tail"));
      var3.append(ResourceHandler.getMessage("console.done"));
      System.out.println(var3.toString());
   }

   public void setScrollPosition() {
      this.scroller.validate();
      this.sbVer.setValue(this.sbVer.getMaximum());
      this.sbHor.setValue(this.sbHor.getMinimum());
   }
}
