package sun.plugin;

import java.awt.Component;
import java.util.ArrayList;
import javax.swing.Timer;

class GrayBoxProcesser implements Runnable {
   private ArrayList requests = new ArrayList();
   private ThreadGroup tg = null;
   private Thread processerThread = null;
   private Timer timer = null;

   GrayBoxProcesser(ThreadGroup var1, Component var2) {
      this.tg = var1;
      this.timer = new Timer(1000, new GrayBoxProcesser$1(this, var2));
   }

   void addRequest(Runnable var1) {
      Thread var2 = this.processerThread;
      if (var2 != null && !var2.isInterrupted()) {
         ArrayList var3 = this.requests;
         synchronized (var3) {
            this.requests.add(var1);
            this.requests.notifyAll();
         }
      }
   }

   public void start() {
      this.processerThread = new Thread(this.tg, this, "GrayBoxThread");
      this.processerThread.start();
      if (this.timer != null) {
         this.timer.start();
      }
   }

   public void stop() {
      if (this.timer != null) {
         this.timer.stop();
         this.timer = null;
      }

      if (this.processerThread != null) {
         this.processerThread.interrupt();
         this.processerThread = null;
      }

      ArrayList var1 = this.requests;
      synchronized (var1) {
         this.requests.clear();
      }
   }

   public void run() {
      Thread var1 = Thread.currentThread();

      try {
         while (!var1.isInterrupted()) {
            Object var2 = null;
            ArrayList var3 = this.requests;
            synchronized (var3) {
               this.requests.wait();
               var2 = this.requests.toArray();
               this.requests.clear();
            }

            for (int var4 = 0; var4 < ((Object[])var2).length; var4++) {
               Runnable var5 = (Runnable)((Object[])var2)[var4];

               try {
                  var5.run();
               } catch (ThreadDeath var8) {
                  throw var8;
               } catch (Throwable var9) {
               }
            }
         }
      } catch (InterruptedException var11) {
      }
   }
}
