package sun.plugin;

import java.io.OutputStream;
import java.util.LinkedList;

public class MainConsoleWriter implements Runnable {
   private LinkedList queue = new LinkedList();
   private OutputStream traceOutputStream;
   private ConsoleWindow console = null;

   MainConsoleWriter(ConsoleWindow var1, OutputStream var2) {
      this.console = var1;
      this.traceOutputStream = var2;
      Thread var3 = new Thread(this, "Main Console Writer");
      var3.setDaemon(false);
      var3.setPriority(6);
      var3.start();
   }

   public void run() {
      while (true) {
         byte[] var1 = null;

         try {
            LinkedList var2 = this.queue;
            synchronized (var2) {
               if (this.queue.size() > 0) {
                  var1 = (byte[])this.queue.remove(0);
               } else {
                  this.queue.wait();
               }
            }

            if (var1 != null) {
               this.trace(new String(var1));
            }
         } catch (InterruptedException var5) {
         }
      }
   }

   public void enQueue(byte[] var1) {
      try {
         LinkedList var2 = this.queue;
         synchronized (var2) {
            this.queue.addLast(var1);
            this.queue.notifyAll();
         }
      } catch (Exception var5) {
         this.console.append(var5.toString());
      }
   }

   private void trace(String var1) {
      try {
         if (this.console != null) {
            this.console.append(var1);
         }

         this.traceOutputStream.write(var1.getBytes());
         this.traceOutputStream.flush();
      } catch (Exception var3) {
         this.console.append(var3.toString());
      }
   }
}
