package sun.plugin;

import java.awt.AWTEvent;
import java.awt.Component;
import java.awt.EventQueue;
import java.awt.Toolkit;
import java.lang.reflect.InvocationTargetException;

public class SystemEventQueueUtilities {
   public static void invokeLater(Runnable var0) {
      postRunnable(var0, null);
   }

   public static void invokeAndWait(Runnable var0) throws InterruptedException, InvocationTargetException {
      if (EventQueue.isDispatchThread()) {
         throw new Error("Cannot call invokeAndWait from the event dispatcher thread");
      } else {
         SystemEventQueueUtilities$1 var1 = new SystemEventQueueUtilities$1(var0);
         Object var2 = null;
         synchronized (var1) {
            var2 = postRunnable(var0, var1);
            var1.wait();
         }

         if (var2 != null) {
            throw new InvocationTargetException((Throwable)var2);
         }
      }
   }

   private static Exception postRunnable(Runnable var0, Object var1) {
      EventQueue var2 = Toolkit.getDefaultToolkit().getSystemEventQueue();
      SystemEventQueueUtilities.RunnableEvent var3 = new SystemEventQueueUtilities.RunnableEvent(var0, var1);
      var2.postEvent(var3);
      return var3.exception;
   }

   private static void processRunnableEvent(SystemEventQueueUtilities.RunnableEvent var0) {
      Object var1 = var0.lock;
      if (var1 == null) {
         var0.doRun.run();
      } else {
         synchronized (var1) {
            try {
               var0.doRun.run();
            } catch (Exception var10) {
               var0.exception = var10;
            } finally {
               if (var0.lock != null) {
                  var0.lock.notify();
               }
            }
         }
      }
   }

   private static class RunnableEvent extends AWTEvent {
      static final int EVENT_ID = 2999;
      static final Component target = new SystemEventQueueUtilities.RunnableTarget();
      final Runnable doRun;
      final Object lock;
      Exception exception;

      RunnableEvent(Runnable var1, Object var2) {
         super(target, 2999);
         this.doRun = var1;
         this.lock = var2;
      }
   }

   private static class RunnableTarget extends Component {
      RunnableTarget() {
         this.enableEvents(2999L);
      }

      protected void processEvent(AWTEvent var1) {
         if (var1 instanceof SystemEventQueueUtilities.RunnableEvent) {
            SystemEventQueueUtilities.processRunnableEvent((SystemEventQueueUtilities.RunnableEvent)var1);
         }
      }
   }
}
