package sun.plugin.cache;

import java.security.PrivilegedAction;
import java.text.MessageFormat;
import sun.plugin.resources.ResourceHandler;
import sun.plugin.usability.UserProfile;

class Cache$1 implements PrivilegedAction {
   public Object run() {
      String var1 = System.getProperty("javaplugin.cache.disabled", "false");
      Cache.cachingDisabled = var1.equalsIgnoreCase("true");
      if (Cache.cachingDisabled) {
         Cache.message(ResourceHandler.getMessage("cache.disabled"), null);
         return null;
      } else {
         var1 = System.getProperty("javaplugin.cache.size", "50m");
         var1.trim();
         long var2;
         MessageFormat var4;
         if (var1.endsWith("M") || var1.endsWith("m")) {
            var2 = 1048576L;
            var1 = var1.substring(0, var1.length() - 1);
            var4 = new MessageFormat(Cache.MB);
         } else if (!var1.endsWith("K") && !var1.endsWith("k")) {
            var2 = 1L;
            var4 = new MessageFormat(Cache.BYTES);
         } else {
            var2 = 1024L;
            var1 = var1.substring(0, var1.length() - 1);
            var4 = new MessageFormat(Cache.KB);
         }

         long var5;
         try {
            var5 = Long.valueOf(var1);
            Cache.maxSize = var2 * var5;
         } catch (NumberFormatException var9) {
            var5 = 50L;
            Cache.maxSize = 52428800L;
            var4 = new MessageFormat(Cache.MB);
         }

         String var7;
         if (var5 > 0L) {
            var7 = var4.format(new Object[]{new Long(var5)});
            ThreadGroup var8 = Thread.currentThread().getThreadGroup();

            while (var8.getParent() != null) {
               var8 = var8.getParent();
            }

            if (Cache.maxSize >= 5242880L) {
               Cache.threadThresholdSize = Cache.maxSize - 1048576L;
               Cache.deleteThresholdSize = Cache.maxSize - 2097152L;
               Cache.cleanupThread = new CleanupThread(var8, 60000L);
               Cache.cleanupThread.start();
            } else {
               Cache.cachingDisabled = true;
               Cache.message(ResourceHandler.getMessage("cache.minSize"), new Object[]{var7});
               var7 = null;
            }
         } else {
            var7 = Cache.UNLIMITED;
         }

         if (var7 != null) {
            Cache.message(ResourceHandler.getMessage("cache.enabled"), null);
            Cache.message(ResourceHandler.getMessage("cache.location"), new Object[]{UserProfile.getCommonCacheDir()});
            Cache.message(ResourceHandler.getMessage("cache.maxSize"), new Object[]{var7});
         }

         return null;
      }
   }
}
