package sun.plugin.cache;

import java.io.File;
import java.security.PrivilegedAction;
import sun.plugin.resources.ResourceHandler;
import sun.plugin.usability.UserProfile;

class FileCache$1 implements PrivilegedAction {
   public Object run() {
      Cache.init();
      if (!Cache.cachingDisabled) {
         FileCache.directory = null;
         String var1 = UserProfile.getNewFileCacheDir();
         if (var1 != null) {
            FileCache.directory = new File(var1.trim());
         }

         boolean var2 = false;
         if (FileCache.directory != null) {
            var2 = FileCache.directory.exists();
            if (!var2) {
               var2 = FileCache.directory.mkdirs();
               if (!var2) {
                  Cache.message(ResourceHandler.getMessage("cache.create_warning"), new Object[]{FileCache.directory.toString()});
               }
            } else if (!FileCache.directory.canRead()) {
               var2 = false;
               Cache.message(ResourceHandler.getMessage("cache.read_warning"), new Object[]{FileCache.directory.toString()});
            } else if (!FileCache.directory.canWrite()) {
               var2 = false;
               Cache.message(ResourceHandler.getMessage("cache.write_warning"), new Object[]{FileCache.directory.toString()});
            } else if (!FileCache.directory.isDirectory()) {
               var2 = false;
               Cache.message(ResourceHandler.getMessage("cache.directory_warning"), new Object[]{FileCache.directory.toString()});
            }
         }

         if (var2) {
            Cache.createTable(FileCache.directory, FileCache.filesInCache);
         }
      }

      return null;
   }
}
