package sun.plugin.cache;

import java.awt.Color;
import java.awt.Component;
import javax.swing.JTable;
import javax.swing.JToolTip;
import javax.swing.UIManager;
import javax.swing.table.DefaultTableCellRenderer;
import javax.swing.table.JTableHeader;

class JarCacheTableHeaderRenderer extends DefaultTableCellRenderer {
   JToolTip toolTip = new JToolTip();

   public JarCacheTableHeaderRenderer() {
      this.toolTip.setBackground(Color.blue);
      this.toolTip.setComponent(this);
   }

   public Component getTableCellRendererComponent(JTable var1, Object var2, boolean var3, boolean var4, int var5, int var6) {
      JTableHeader var7 = var1.getTableHeader();
      if (var7 != null) {
         this.setForeground(var7.getForeground());
         this.setBackground(var7.getBackground());
         this.setFont(var7.getFont());
         this.setHorizontalAlignment(2);
      }

      this.setText(var2 == null ? "" : " " + var2.toString());
      this.setBorder(UIManager.getBorder("TableHeader.cellBorder"));
      this.setToolTipText(((JarCacheTable)var1).getJarCacheTableColumns()[var6].getToolTipText());
      return this;
   }

   public JToolTip createToolTip() {
      return this.toolTip;
   }
}
