package sun.plugin.cache;

import java.util.Arrays;
import java.util.Date;
import javax.swing.JTable;
import javax.swing.table.JTableHeader;

public class JarCacheTableSorter extends JarCacheTableModel {
   int selectedColumn = -1;
   boolean ascending = true;

   public JarCacheTableSorter(String[] var1) {
      super(var1);
   }

   public int compareRowsByColumn(JarCacheEntry var1, JarCacheEntry var2) {
      Object var3 = var1.getValue(super.getColumnName(this.selectedColumn));
      Object var4 = var2.getValue(super.getColumnName(this.selectedColumn));
      if (var3 instanceof Number) {
         Number var14 = (Number)var3;
         double var18 = var14.doubleValue();
         Number var22 = (Number)var4;
         double var23 = var22.doubleValue();
         if (var18 < var23) {
            return -1;
         } else {
            return var18 > var23 ? 1 : 0;
         }
      } else if (var3 instanceof Date) {
         Date var13 = (Date)var3;
         long var17 = var13.getTime();
         Date var21 = (Date)var4;
         long var9 = var21.getTime();
         if (var17 < var9) {
            return -1;
         } else {
            return var17 > var9 ? 1 : 0;
         }
      } else if (var3 instanceof String) {
         String var12 = (String)var3;
         String var16 = (String)var4;
         int var20 = var12.compareToIgnoreCase(var16);
         if (var20 < 0) {
            return -1;
         } else {
            return var20 > 0 ? 1 : 0;
         }
      } else if (var3 instanceof Boolean) {
         Boolean var11 = (Boolean)var3;
         boolean var15 = var11;
         Boolean var19 = (Boolean)var4;
         boolean var8 = var19;
         if (var15 == var8) {
            return 0;
         } else {
            return var15 ? 1 : -1;
         }
      } else {
         String var5 = var3.toString();
         String var6 = var4.toString();
         int var7 = var5.compareToIgnoreCase(var6);
         if (var7 < 0) {
            return -1;
         } else {
            return var7 > 0 ? 1 : 0;
         }
      }
   }

   public void sort() {
      if (this.selectedColumn != -1) {
         Arrays.sort(super.tableRows, new JarCacheTableSorter$1(this));
      }

      super.fireTableDataChanged();
   }

   public void sortByColumn(int var1) {
      if (var1 != this.selectedColumn) {
         this.ascending = true;
      } else {
         this.ascending = !this.ascending;
      }

      this.selectedColumn = var1;
      this.sort();
   }

   public void refresh() {
      super.refresh();
      this.sort();
   }

   public void removeRows(int[] var1) {
      super.removeRows(var1);
      this.sort();
   }

   public void addMouseListenerToHeaderInTable(JTable var1) {
      var1.setColumnSelectionAllowed(false);
      JarCacheTableSorter$2 var4 = new JarCacheTableSorter$2(this, var1, this);
      JTableHeader var5 = var1.getTableHeader();
      var5.addMouseListener(var4);
   }
}
