package sun.plugin.cache;

import java.io.IOException;
import java.net.URL;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.StringTokenizer;
import java.util.regex.Pattern;
import sun.plugin.ClassLoaderInfo;
import sun.plugin.resources.ResourceHandler;
import sun.plugin.usability.Trace;

public class JarCacheUtil {
   private static String PRELOAD = "preload";

   public static synchronized void verifyJarVersions(URL var0, String var1, HashMap var2) throws IOException, JarCacheVersionException {
      boolean var3 = true;

      for (String var5 : var2.keySet()) {
         String var6 = (String)var2.get(var5);
         URL var7 = new URL(var0, var5);
         Trace.messageNetPrintln("cache.version_checking", new Object[]{var5, var6});
         boolean var8 = JarCache.checkJarVersion(var7, new FileVersion(var6));
         if (var3) {
            var3 = var8;
         }
      }

      if (!var3) {
         ClassLoaderInfo.markNotCachable(var0, var1);
      }
   }

   public static HashMap getJarsWithVersion(String var0, String var1, String var2) throws JarCacheVersionException {
      HashMap var5 = new HashMap();
      if (var0 != null && var1 != null) {
         StringTokenizer var6 = new StringTokenizer(var0, ",", false);
         int var7 = var6.countTokens();
         StringTokenizer var8 = new StringTokenizer(var1, ",", false);
         int var9 = var8.countTokens();
         if (var9 != var9) {
            throw new JarCacheVersionException(ResourceHandler.getMessage("cache.version_attrib_error"));
         }

         while (var6.hasMoreTokens()) {
            String var3 = var6.nextToken().trim();
            String var4 = var8.nextToken().trim();
            var5.put(var3, var4);
         }
      }

      if (var2 != null) {
         StringTokenizer var12 = new StringTokenizer(var2, ",", false);

         while (var12.hasMoreTokens()) {
            String var13 = var12.nextToken().trim();
            StringTokenizer var14 = new StringTokenizer(var13, ";", false);
            String var10 = var14.nextToken().trim();

            while (var14.hasMoreTokens()) {
               String var11 = var14.nextToken().trim();
               if (Pattern.matches("\\p{XDigit}{1,4}\\.\\p{XDigit}{1,4}\\.\\p{XDigit}{1,4}\\.\\p{XDigit}{1,4}", var11)) {
                  var5.put(var10, var11);
                  break;
               }
            }
         }
      }

      return var5;
   }

   public static synchronized String getJarsInCacheArchiveEx(String var0) {
      if (var0 != null) {
         String var1 = "";
         StringTokenizer var2 = new StringTokenizer(var0, ",", false);
         int var3 = var2.countTokens();

         for (int var4 = 0; var4 < var3; var4++) {
            String var5 = var2.nextToken().trim();
            int var6 = var5.indexOf(";");
            if (var6 != -1) {
               String var7 = var5.substring(0, var6);
               var1 = var1 + var7;
               var1 = var1 + (var4 != var3 - 1 ? "," : "");
            }
         }

         return var1;
      } else {
         return null;
      }
   }

   public static synchronized void preload(URL var0, String var1) throws IOException {
      ArrayList var2 = new ArrayList();
      StringTokenizer var3 = new StringTokenizer(var1, ",", false);

      while (var3.hasMoreTokens()) {
         String var4 = var3.nextToken().trim();
         int var5 = var4.indexOf(59);
         if (var5 != -1) {
            String var6 = var4.substring(var5);
            if (var6.toLowerCase().indexOf(PRELOAD) != -1) {
               String var7 = var4.substring(0, var5);
               var2.add(var7);
            }
         }
      }

      for (int var8 = 0; var8 < var2.size(); var8++) {
         URL var9 = new URL(var0, (String)var2.get(var8));
         Trace.messageNetPrintln("cache.preloading", new Object[]{(String)var2.get(var8)});
         JarCache.get(var9);
      }
   }
}
