package sun.plugin.cachescheme;

import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.Properties;
import java.util.StringTokenizer;
import sun.plugin.usability.UserProfile;

public class HTMLVersionTable {
   private static char separator = '|';
   private static String _filename = UserProfile.getHTMLCacheTableFile();
   private static String _cachedir = UserProfile.getHTMLCacheDir();
   Properties _versionTable = new Properties();

   public void load() throws IOException {
      File var1 = new File(_filename);
      if (var1.exists()) {
         FileInputStream var2 = new FileInputStream(_filename);
         BufferedInputStream var3 = new BufferedInputStream(var2);
         this._versionTable.load(var3);
         var3.close();
         var2.close();
      }
   }

   public void save() throws IOException {
      File var1 = new File(_cachedir);
      if (!var1.exists()) {
         var1.mkdirs();
      }

      FileOutputStream var2 = new FileOutputStream(_filename);
      BufferedOutputStream var3 = new BufferedOutputStream(var2);
      this._versionTable
         .store(
            var3,
            "This File is Machine Generated.  DO NOT EDIT IT.  Changing it will BREAK the Applet Installation Cache, which will in turn cause the Java Plug-in to break."
         );
      var3.close();
      var2.close();
   }

   public void add(String var1, String var2, String var3, String var4) {
      this._versionTable.put(var1, var2 + separator + var3 + separator + var4);
   }

   public void remove(String var1) {
      this._versionTable.remove(var1);
   }

   public String getVersion(String var1) throws EntryNotFoundException {
      String var2 = this.getVersionEntry(var1);
      StringTokenizer var3 = new StringTokenizer(var2, "|", false);
      if (var3.countTokens() < 3) {
         throw new EntryNotFoundException("Version information is not found in the version table for " + var1);
      } else {
         return var3.nextToken().trim();
      }
   }

   public String getPath(String var1) throws EntryNotFoundException {
      String var2 = this.getVersionEntry(var1);
      StringTokenizer var3 = new StringTokenizer(var2, "|", false);
      if (var3.countTokens() < 3) {
         throw new EntryNotFoundException("Path information is not found in the version table for " + var1);
      } else {
         var3.nextToken();
         return var3.nextToken().trim();
      }
   }

   public String getFilename(String var1) throws EntryNotFoundException {
      String var2 = this.getVersionEntry(var1);
      StringTokenizer var3 = new StringTokenizer(var2, "|", false);
      if (var3.countTokens() < 3) {
         throw new EntryNotFoundException("Filename information is not found in the version table for " + var1);
      } else {
         var3.nextToken();
         var3.nextToken();
         return var3.nextToken().trim();
      }
   }

   private String getVersionEntry(String var1) throws EntryNotFoundException {
      String var2 = (String)this._versionTable.get(var1);
      if (var2 == null) {
         throw new EntryNotFoundException(var1 + " is not found in version table");
      } else {
         return var2;
      }
   }
}
