package sun.plugin.dom;

import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.html.HTMLDocument;
import org.w3c.dom.html.HTMLElement;
import org.w3c.dom.html.HTMLFormElement;
import org.w3c.dom.stylesheets.StyleSheet;
import sun.plugin.dom.css.CSSStyleSheet;
import sun.plugin.dom.exception.NotSupportedException;
import sun.plugin.dom.html.HTMLAnchorElement;
import sun.plugin.dom.html.HTMLImageElement;
import sun.plugin.dom.html.HTMLInputElement;
import sun.plugin.dom.html.HTMLLinkStyleElement;
import sun.plugin.dom.html.HTMLObjectElement;
import sun.plugin.dom.html.HTMLSelectElement;
import sun.plugin.dom.html.HTMLTextAreaElement;

public class DOMObjectFactory {
   public static HTMLElement createHTMLElement(int var0, Object var1, HTMLDocument var2, Element var3) {
      if (var1 == null) {
         return null;
      } else {
         if (var1 instanceof DOMObject) {
            switch (var0) {
               case 19:
                  return new HTMLAnchorElement((DOMObject)var1, var2);
               case 33:
                  try {
                     DOMObject var4 = (DOMObject)var1;
                     Object var5 = var4.getMember("tagName");
                     if (var5 != null) {
                        if ("INPUT".equalsIgnoreCase(var5.toString())) {
                           return new HTMLInputElement((DOMObject)var1, var2, (HTMLFormElement)var3);
                        }

                        if ("SELECT".equalsIgnoreCase(var5.toString())) {
                           return new HTMLSelectElement((DOMObject)var1, var2, (HTMLFormElement)var3);
                        }

                        if ("TEXTAREA".equalsIgnoreCase(var5.toString())) {
                           return new HTMLTextAreaElement((DOMObject)var1, var2, (HTMLFormElement)var3);
                        }
                     }
                  } catch (Throwable var6) {
                  }

                  return new sun.plugin.dom.html.HTMLElement((DOMObject)var1, var2);
               case 36:
                  return new sun.plugin.dom.html.HTMLFormElement((DOMObject)var1, var2);
               case 44:
                  return new HTMLImageElement((DOMObject)var1, var2);
               case 50:
                  return new HTMLLinkStyleElement((DOMObject)var1, var2);
               case 55:
                  return new HTMLObjectElement((DOMObject)var1, var2);
            }
         }

         throw new NotSupportedException("DOMObjectFactory::createHTMLElement() cannot wrap " + var1);
      }
   }

   public static StyleSheet createStyleSheet(int var0, Object var1, Node var2) {
      if (var1 == null) {
         return null;
      } else {
         if (var1 instanceof DOMObject) {
            switch (var0) {
               case 80:
                  return new sun.plugin.dom.stylesheets.StyleSheet((DOMObject)var1, var2);
               case 113:
                  return new CSSStyleSheet((DOMObject)var1, var2);
            }
         }

         throw new NotSupportedException("DOMObjectFactory::createStyleSheet() cannot wrap " + var1);
      }
   }
}
