package sun.plugin.dom.core;

import org.w3c.dom.CDATASection;
import org.w3c.dom.DOMException;
import org.w3c.dom.DOMImplementation;
import org.w3c.dom.DocumentType;
import org.w3c.dom.EntityReference;
import org.w3c.dom.NodeList;
import org.w3c.dom.ProcessingInstruction;
import sun.plugin.dom.DOMObject;
import sun.plugin.dom.exception.NotSupportedException;

public abstract class Document extends Node implements org.w3c.dom.Document {
   protected Document(int var1, DOMObject var2) {
      super(var1, var2);
   }

   public DocumentType getDoctype() {
      return null;
   }

   public DOMImplementation getImplementation() {
      return new sun.plugin.dom.DOMImplementation();
   }

   public abstract org.w3c.dom.Element getDocumentElement();

   public org.w3c.dom.Document getOwnerDocument() {
      return null;
   }

   public abstract org.w3c.dom.Element createElement(String var1) throws DOMException;

   public org.w3c.dom.DocumentFragment createDocumentFragment() {
      Object var1 = this.obj.call("createDocumentFragment", new Object[0]);
      return var1 != null && var1 instanceof DOMObject ? new DocumentFragment(this.obj) : null;
   }

   public org.w3c.dom.Text createTextNode(String var1) {
      Object[] var2 = new Object[]{var1};
      Object var3 = this.obj.call("createTextNode", var2);
      return var3 != null && var3 instanceof DOMObject ? new Text(this.obj) : null;
   }

   public org.w3c.dom.Comment createComment(String var1) {
      Object[] var2 = new Object[]{var1};
      Object var3 = this.obj.call("createComment", var2);
      return var3 != null && var3 instanceof DOMObject ? new Comment(this.obj) : null;
   }

   public CDATASection createCDATASection(String var1) throws DOMException {
      throw new NotSupportedException("Document.createCDATASection() is not supported");
   }

   public ProcessingInstruction createProcessingInstruction(String var1, String var2) throws DOMException {
      throw new NotSupportedException("Document.createProcessingInstruction() is not supported");
   }

   public org.w3c.dom.Attr createAttribute(String var1) throws DOMException {
      throw new NotSupportedException("Document.createAttribute() is not supported");
   }

   public EntityReference createEntityReference(String var1) throws DOMException {
      throw new NotSupportedException("Document.createEntityReference() is not supported");
   }

   public abstract NodeList getElementsByTagName(String var1);

   public org.w3c.dom.Node importNode(org.w3c.dom.Node var1, boolean var2) throws DOMException {
      throw new NotSupportedException("Document.importNode() is not supported");
   }

   public org.w3c.dom.Element createElementNS(String var1, String var2) throws DOMException {
      throw new NotSupportedException("Document.createElementNS() is not supported");
   }

   public org.w3c.dom.Attr createAttributeNS(String var1, String var2) throws DOMException {
      throw new NotSupportedException("Document.createAttributeNS() is not supported");
   }

   public NodeList getElementsByTagNameNS(String var1, String var2) {
      throw new NotSupportedException("Document.getElementsByTagNameNS() is not supported");
   }

   public abstract org.w3c.dom.Element getElementById(String var1);

   public String getNodeName() {
      return "#document";
   }

   public String getNodeValue() throws DOMException {
      return null;
   }

   public void setNodeValue(String var1) throws DOMException {
   }

   public short getNodeType() {
      return 9;
   }
}
