package sun.plugin.dom.core;

import org.w3c.dom.DOMException;
import org.w3c.dom.NodeList;
import sun.plugin.dom.DOMObject;
import sun.plugin.dom.DOMObjectHelper;
import sun.plugin.dom.exception.NotSupportedException;

public abstract class Element extends Node implements org.w3c.dom.Element {
   private org.w3c.dom.Document doc;
   protected org.w3c.dom.Element owner;

   protected Element(int var1, DOMObject var2, org.w3c.dom.Document var3, org.w3c.dom.Element var4) {
      super(var1, var2);
      this.doc = var3;
      this.owner = var4;
   }

   public String getTagName() {
      return this.getAttribute("tagName");
   }

   public String getAttribute(String var1) {
      return DOMObjectHelper.getStringMemberNoEx(this.obj, var1);
   }

   public void setAttribute(String var1, String var2) throws DOMException {
      DOMObjectHelper.setStringMember(this.obj, var1, var2);
   }

   public void removeAttribute(String var1) throws DOMException {
      throw new NotSupportedException("Element.getAttributeNode() is not supported");
   }

   public org.w3c.dom.Attr getAttributeNode(String var1) {
      throw new NotSupportedException("Element.getAttributeNode() is not supported");
   }

   public org.w3c.dom.Attr setAttributeNode(org.w3c.dom.Attr var1) throws DOMException {
      throw new NotSupportedException("Element.setAttributeNode() is not supported");
   }

   public org.w3c.dom.Attr removeAttributeNode(org.w3c.dom.Attr var1) throws DOMException {
      throw new NotSupportedException("Element.removeAttributeNode() is not supported");
   }

   public NodeList getElementsByTagName(String var1) {
      throw new NotSupportedException("Element.getElementsByTagName() is not supported");
   }

   public String getAttributeNS(String var1, String var2) {
      throw new NotSupportedException("Element.getAttributeNS() is not supported");
   }

   public void setAttributeNS(String var1, String var2, String var3) throws DOMException {
      throw new NotSupportedException("Element.setAttributeNS() is not supported");
   }

   public void removeAttributeNS(String var1, String var2) throws DOMException {
      throw new NotSupportedException("Element.removeAttributeNS() is not supported");
   }

   public org.w3c.dom.Attr getAttributeNodeNS(String var1, String var2) {
      throw new NotSupportedException("Element.getAttributeNodeNS() is not supported");
   }

   public org.w3c.dom.Attr setAttributeNodeNS(org.w3c.dom.Attr var1) throws DOMException {
      throw new NotSupportedException("Element.setAttributeNodeNS() is not supported");
   }

   public NodeList getElementsByTagNameNS(String var1, String var2) {
      return null;
   }

   public boolean hasAttribute(String var1) {
      String var2 = this.getAttribute(var1);
      return var2 != null;
   }

   public boolean hasAttributeNS(String var1, String var2) {
      return false;
   }

   public String getNodeName() {
      return this.getTagName();
   }

   public String getNodeValue() throws DOMException {
      return null;
   }

   public void setNodeValue(String var1) throws DOMException {
   }

   public short getNodeType() {
      return 1;
   }

   public org.w3c.dom.Document getOwnerDocument() {
      return this.doc;
   }
}
