package sun.plugin.dom.css;

import org.w3c.dom.DOMException;
import org.w3c.dom.css.CSS2Properties;
import org.w3c.dom.css.CSSValue;
import sun.plugin.dom.DOMObject;
import sun.plugin.dom.DOMObjectHelper;

public class CSSStyleDeclaration implements org.w3c.dom.css.CSSStyleDeclaration, CSS2Properties {
   protected DOMObject obj;
   private org.w3c.dom.css.CSSStyleSheet parentStyleSheet;
   private org.w3c.dom.css.CSSRule parentRule;

   public CSSStyleDeclaration(DOMObject var1, org.w3c.dom.css.CSSStyleSheet var2, org.w3c.dom.css.CSSRule var3) {
      this.obj = var1;
      this.parentStyleSheet = var2;
      this.parentRule = var3;
   }

   public String getCssText() {
      return this.getPropertyValue("cssText");
   }

   public void setCssText(String var1) throws DOMException {
      this.setProperty("cssText", var1, null);
   }

   public String getPropertyValue(String var1) {
      return DOMObjectHelper.getStringMemberNoEx(this.obj, var1);
   }

   public CSSValue getPropertyCSSValue(String var1) {
      return null;
   }

   public String removeProperty(String var1) throws DOMException {
      return null;
   }

   public String getPropertyPriority(String var1) {
      return "";
   }

   public void setProperty(String var1, String var2, String var3) throws DOMException {
      DOMObjectHelper.setStringMember(this.obj, var1, var2);
   }

   public int getLength() {
      return 0;
   }

   public String item(int var1) {
      return "";
   }

   public org.w3c.dom.css.CSSRule getParentRule() {
      return this.parentRule;
   }

   public String getAzimuth() {
      return this.getPropertyValue("azimuth");
   }

   public void setAzimuth(String var1) throws DOMException {
      this.setProperty("azimuth", var1, null);
   }

   public String getBackground() {
      return this.getPropertyValue("background");
   }

   public void setBackground(String var1) throws DOMException {
      this.setProperty("background", var1, null);
   }

   public String getBackgroundAttachment() {
      return this.getPropertyValue("backgroundAttachment");
   }

   public void setBackgroundAttachment(String var1) throws DOMException {
      this.setProperty("backgroundAttachment", var1, null);
   }

   public String getBackgroundColor() {
      return this.getPropertyValue("backgroundColor");
   }

   public void setBackgroundColor(String var1) throws DOMException {
      this.setProperty("backgroundColor", var1, null);
   }

   public String getBackgroundImage() {
      return this.getPropertyValue("backgroundImage");
   }

   public void setBackgroundImage(String var1) throws DOMException {
      this.setProperty("backgroundImage", var1, null);
   }

   public String getBackgroundPosition() {
      return this.getPropertyValue("backgroundPosition");
   }

   public void setBackgroundPosition(String var1) throws DOMException {
      this.setProperty("backgroundPosition", var1, null);
   }

   public String getBackgroundRepeat() {
      return this.getPropertyValue("backgroundRepeat");
   }

   public void setBackgroundRepeat(String var1) throws DOMException {
      this.setProperty("backgroundRepeat", var1, null);
   }

   public String getBorder() {
      return this.getPropertyValue("border");
   }

   public void setBorder(String var1) throws DOMException {
      this.setProperty("border", var1, null);
   }

   public String getBorderCollapse() {
      return this.getPropertyValue("borderCollapse");
   }

   public void setBorderCollapse(String var1) throws DOMException {
      this.setProperty("borderCollapse", var1, null);
   }

   public String getBorderColor() {
      return this.getPropertyValue("borderColor");
   }

   public void setBorderColor(String var1) throws DOMException {
      this.setProperty("borderColor", var1, null);
   }

   public String getBorderSpacing() {
      return this.getPropertyValue("borderSpacing");
   }

   public void setBorderSpacing(String var1) throws DOMException {
      this.setProperty("borderSpacing", var1, null);
   }

   public String getBorderStyle() {
      return this.getPropertyValue("borderStyle");
   }

   public void setBorderStyle(String var1) throws DOMException {
      this.setProperty("borderStyle", var1, null);
   }

   public String getBorderTop() {
      return this.getPropertyValue("borderTop");
   }

   public void setBorderTop(String var1) throws DOMException {
      this.setProperty("borderTop", var1, null);
   }

   public String getBorderRight() {
      return this.getPropertyValue("borderRight");
   }

   public void setBorderRight(String var1) throws DOMException {
      this.setProperty("borderRight", var1, null);
   }

   public String getBorderBottom() {
      return this.getPropertyValue("borderBottom");
   }

   public void setBorderBottom(String var1) throws DOMException {
      this.setProperty("borderBottom", var1, null);
   }

   public String getBorderLeft() {
      return this.getPropertyValue("borderLeft");
   }

   public void setBorderLeft(String var1) throws DOMException {
      this.setProperty("borderLeft", var1, null);
   }

   public String getBorderTopColor() {
      return this.getPropertyValue("borderTopColor");
   }

   public void setBorderTopColor(String var1) throws DOMException {
      this.setProperty("borderTopColor", var1, null);
   }

   public String getBorderRightColor() {
      return this.getPropertyValue("borderRightColor");
   }

   public void setBorderRightColor(String var1) throws DOMException {
      this.setProperty("borderRightColor", var1, null);
   }

   public String getBorderBottomColor() {
      return this.getPropertyValue("borderBottomColor");
   }

   public void setBorderBottomColor(String var1) throws DOMException {
      this.setProperty("borderBottomColor", var1, null);
   }

   public String getBorderLeftColor() {
      return this.getPropertyValue("borderLeftColor");
   }

   public void setBorderLeftColor(String var1) throws DOMException {
      this.setProperty("borderLeftColor", var1, null);
   }

   public String getBorderTopStyle() {
      return this.getPropertyValue("borderTopStyle");
   }

   public void setBorderTopStyle(String var1) throws DOMException {
      this.setProperty("borderTopStyle", var1, null);
   }

   public String getBorderRightStyle() {
      return this.getPropertyValue("borderRightStyle");
   }

   public void setBorderRightStyle(String var1) throws DOMException {
      this.setProperty("borderRightStyle", var1, null);
   }

   public String getBorderBottomStyle() {
      return this.getPropertyValue("borderBottomStyle");
   }

   public void setBorderBottomStyle(String var1) throws DOMException {
      this.setProperty("borderBottomStyle", var1, null);
   }

   public String getBorderLeftStyle() {
      return this.getPropertyValue("borderLeftStyle");
   }

   public void setBorderLeftStyle(String var1) throws DOMException {
      this.setProperty("borderLeftStyle", var1, null);
   }

   public String getBorderTopWidth() {
      return this.getPropertyValue("borderTopWidth");
   }

   public void setBorderTopWidth(String var1) throws DOMException {
      this.setProperty("borderTopWidth", var1, null);
   }

   public String getBorderRightWidth() {
      return this.getPropertyValue("borderRightWidth");
   }

   public void setBorderRightWidth(String var1) throws DOMException {
      this.setProperty("borderRightWidth", var1, null);
   }

   public String getBorderBottomWidth() {
      return this.getPropertyValue("borderBottomWidth");
   }

   public void setBorderBottomWidth(String var1) throws DOMException {
      this.setProperty("borderBottomWidth", var1, null);
   }

   public String getBorderLeftWidth() {
      return this.getPropertyValue("borderLeftWidth");
   }

   public void setBorderLeftWidth(String var1) throws DOMException {
      this.setProperty("borderLeftWidth", var1, null);
   }

   public String getBorderWidth() {
      return this.getPropertyValue("borderWidth");
   }

   public void setBorderWidth(String var1) throws DOMException {
      this.setProperty("borderWidth", var1, null);
   }

   public String getBottom() {
      return this.getPropertyValue("bottom");
   }

   public void setBottom(String var1) throws DOMException {
      this.setProperty("bottom", var1, null);
   }

   public String getCaptionSide() {
      return this.getPropertyValue("captionSide");
   }

   public void setCaptionSide(String var1) throws DOMException {
      this.setProperty("captionSide", var1, null);
   }

   public String getClear() {
      return this.getPropertyValue("clear");
   }

   public void setClear(String var1) throws DOMException {
      this.setProperty("clear", var1, null);
   }

   public String getClip() {
      return this.getPropertyValue("clip");
   }

   public void setClip(String var1) throws DOMException {
      this.setProperty("clip", var1, null);
   }

   public String getColor() {
      return this.getPropertyValue("color");
   }

   public void setColor(String var1) throws DOMException {
      this.setProperty("color", var1, null);
   }

   public String getContent() {
      return this.getPropertyValue("content");
   }

   public void setContent(String var1) throws DOMException {
      this.setProperty("content", var1, null);
   }

   public String getCounterIncrement() {
      return this.getPropertyValue("counterIncrement");
   }

   public void setCounterIncrement(String var1) throws DOMException {
      this.setProperty("counterIncrement", var1, null);
   }

   public String getCounterReset() {
      return this.getPropertyValue("counterReset");
   }

   public void setCounterReset(String var1) throws DOMException {
      this.setProperty("counterReset", var1, null);
   }

   public String getCue() {
      return this.getPropertyValue("cue");
   }

   public void setCue(String var1) throws DOMException {
      this.setProperty("cue", var1, null);
   }

   public String getCueAfter() {
      return this.getPropertyValue("cueAfter");
   }

   public void setCueAfter(String var1) throws DOMException {
      this.setProperty("cueAfter", var1, null);
   }

   public String getCueBefore() {
      return this.getPropertyValue("cueBefore");
   }

   public void setCueBefore(String var1) throws DOMException {
      this.setProperty("cueBefore", var1, null);
   }

   public String getCursor() {
      return this.getPropertyValue("cursor");
   }

   public void setCursor(String var1) throws DOMException {
      this.setProperty("cursor", var1, null);
   }

   public String getDirection() {
      return this.getPropertyValue("direction");
   }

   public void setDirection(String var1) throws DOMException {
      this.setProperty("direction", var1, null);
   }

   public String getDisplay() {
      return this.getPropertyValue("display");
   }

   public void setDisplay(String var1) throws DOMException {
      this.setProperty("display", var1, null);
   }

   public String getElevation() {
      return this.getPropertyValue("elevation");
   }

   public void setElevation(String var1) throws DOMException {
      this.setProperty("elevation", var1, null);
   }

   public String getEmptyCells() {
      return this.getPropertyValue("emptyCells");
   }

   public void setEmptyCells(String var1) throws DOMException {
      this.setProperty("emptyCells", var1, null);
   }

   public String getCssFloat() {
      return this.getPropertyValue("cssFloat");
   }

   public void setCssFloat(String var1) throws DOMException {
      this.setProperty("cssFloat", var1, null);
   }

   public String getFont() {
      return this.getPropertyValue("font");
   }

   public void setFont(String var1) throws DOMException {
      this.setProperty("font", var1, null);
   }

   public String getFontFamily() {
      return this.getPropertyValue("fontFamily");
   }

   public void setFontFamily(String var1) throws DOMException {
      this.setProperty("fontFamily", var1, null);
   }

   public String getFontSize() {
      return this.getPropertyValue("fontSize");
   }

   public void setFontSize(String var1) throws DOMException {
      this.setProperty("fontSize", var1, null);
   }

   public String getFontSizeAdjust() {
      return this.getPropertyValue("fontSizeAdjust");
   }

   public void setFontSizeAdjust(String var1) throws DOMException {
      this.setProperty("fontSizeAdjust", var1, null);
   }

   public String getFontStretch() {
      return this.getPropertyValue("fontStretch");
   }

   public void setFontStretch(String var1) throws DOMException {
      this.setProperty("fontStretch", var1, null);
   }

   public String getFontStyle() {
      return this.getPropertyValue("fontStyle");
   }

   public void setFontStyle(String var1) throws DOMException {
      this.setProperty("fontStyle", var1, null);
   }

   public String getFontVariant() {
      return this.getPropertyValue("fontVariant");
   }

   public void setFontVariant(String var1) throws DOMException {
      this.setProperty("fontVariant", var1, null);
   }

   public String getFontWeight() {
      return this.getPropertyValue("fontWeight");
   }

   public void setFontWeight(String var1) throws DOMException {
      this.setProperty("fontWeight", var1, null);
   }

   public String getHeight() {
      return this.getPropertyValue("height");
   }

   public void setHeight(String var1) throws DOMException {
      this.setProperty("height", var1, null);
   }

   public String getLeft() {
      return this.getPropertyValue("left");
   }

   public void setLeft(String var1) throws DOMException {
      this.setProperty("left", var1, null);
   }

   public String getLetterSpacing() {
      return this.getPropertyValue("letterSpacing");
   }

   public void setLetterSpacing(String var1) throws DOMException {
      this.setProperty("letterSpacing", var1, null);
   }

   public String getLineHeight() {
      return this.getPropertyValue("lineHeight");
   }

   public void setLineHeight(String var1) throws DOMException {
      this.setProperty("lineHeight", var1, null);
   }

   public String getListStyle() {
      return this.getPropertyValue("listStyle");
   }

   public void setListStyle(String var1) throws DOMException {
      this.setProperty("listStyle", var1, null);
   }

   public String getListStyleImage() {
      return this.getPropertyValue("listStyleImage");
   }

   public void setListStyleImage(String var1) throws DOMException {
      this.setProperty("listStyleImage", var1, null);
   }

   public String getListStylePosition() {
      return this.getPropertyValue("listStylePosition");
   }

   public void setListStylePosition(String var1) throws DOMException {
      this.setProperty("listStylePosition", var1, null);
   }

   public String getListStyleType() {
      return this.getPropertyValue("listStyleType");
   }

   public void setListStyleType(String var1) throws DOMException {
      this.setProperty("listStyleType", var1, null);
   }

   public String getMargin() {
      return this.getPropertyValue("margin");
   }

   public void setMargin(String var1) throws DOMException {
      this.setProperty("margin", var1, null);
   }

   public String getMarginTop() {
      return this.getPropertyValue("marginTop");
   }

   public void setMarginTop(String var1) throws DOMException {
      this.setProperty("marginTop", var1, null);
   }

   public String getMarginRight() {
      return this.getPropertyValue("marginRight");
   }

   public void setMarginRight(String var1) throws DOMException {
      this.setProperty("marginRight", var1, null);
   }

   public String getMarginBottom() {
      return this.getPropertyValue("marginBottom");
   }

   public void setMarginBottom(String var1) throws DOMException {
      this.setProperty("marginBottom", var1, null);
   }

   public String getMarginLeft() {
      return this.getPropertyValue("marginLeft");
   }

   public void setMarginLeft(String var1) throws DOMException {
      this.setProperty("marginLeft", var1, null);
   }

   public String getMarkerOffset() {
      return this.getPropertyValue("markerOffset");
   }

   public void setMarkerOffset(String var1) throws DOMException {
      this.setProperty("markerOffset", var1, null);
   }

   public String getMarks() {
      return this.getPropertyValue("marks");
   }

   public void setMarks(String var1) throws DOMException {
      this.setProperty("marks", var1, null);
   }

   public String getMaxHeight() {
      return this.getPropertyValue("maxHeight");
   }

   public void setMaxHeight(String var1) throws DOMException {
      this.setProperty("maxHeight", var1, null);
   }

   public String getMaxWidth() {
      return this.getPropertyValue("maxWidth");
   }

   public void setMaxWidth(String var1) throws DOMException {
      this.setProperty("maxWidth", var1, null);
   }

   public String getMinHeight() {
      return this.getPropertyValue("minHeight");
   }

   public void setMinHeight(String var1) throws DOMException {
      this.setProperty("minHeight", var1, null);
   }

   public String getMinWidth() {
      return this.getPropertyValue("minWidth");
   }

   public void setMinWidth(String var1) throws DOMException {
      this.setProperty("minWidth", var1, null);
   }

   public String getOrphans() {
      return this.getPropertyValue("orphans");
   }

   public void setOrphans(String var1) throws DOMException {
      this.setProperty("orphans", var1, null);
   }

   public String getOutline() {
      return this.getPropertyValue("outline");
   }

   public void setOutline(String var1) throws DOMException {
      this.setProperty("outline", var1, null);
   }

   public String getOutlineColor() {
      return this.getPropertyValue("outlineColor");
   }

   public void setOutlineColor(String var1) throws DOMException {
      this.setProperty("outlineColor", var1, null);
   }

   public String getOutlineStyle() {
      return this.getPropertyValue("outlineStyle");
   }

   public void setOutlineStyle(String var1) throws DOMException {
      this.setProperty("outlineStyle", var1, null);
   }

   public String getOutlineWidth() {
      return this.getPropertyValue("outlineWidth");
   }

   public void setOutlineWidth(String var1) throws DOMException {
      this.setProperty("outlineWidth", var1, null);
   }

   public String getOverflow() {
      return this.getPropertyValue("overflow");
   }

   public void setOverflow(String var1) throws DOMException {
      this.setProperty("overflow", var1, null);
   }

   public String getPadding() {
      return this.getPropertyValue("padding");
   }

   public void setPadding(String var1) throws DOMException {
      this.setProperty("padding", var1, null);
   }

   public String getPaddingTop() {
      return this.getPropertyValue("paddingTop");
   }

   public void setPaddingTop(String var1) throws DOMException {
      this.setProperty("paddingTop", var1, null);
   }

   public String getPaddingRight() {
      return this.getPropertyValue("paddingRight");
   }

   public void setPaddingRight(String var1) throws DOMException {
      this.setProperty("paddingRight", var1, null);
   }

   public String getPaddingBottom() {
      return this.getPropertyValue("paddingBottom");
   }

   public void setPaddingBottom(String var1) throws DOMException {
      this.setProperty("paddingBottom", var1, null);
   }

   public String getPaddingLeft() {
      return this.getPropertyValue("paddingLeft");
   }

   public void setPaddingLeft(String var1) throws DOMException {
      this.setProperty("paddingLeft", var1, null);
   }

   public String getPage() {
      return this.getPropertyValue("page");
   }

   public void setPage(String var1) throws DOMException {
      this.setProperty("page", var1, null);
   }

   public String getPageBreakAfter() {
      return this.getPropertyValue("pageBreakAfter");
   }

   public void setPageBreakAfter(String var1) throws DOMException {
      this.setProperty("pageBreakAfter", var1, null);
   }

   public String getPageBreakBefore() {
      return this.getPropertyValue("pageBreakBefore");
   }

   public void setPageBreakBefore(String var1) throws DOMException {
      this.setProperty("pageBreakBefore", var1, null);
   }

   public String getPageBreakInside() {
      return this.getPropertyValue("pageBreakInside");
   }

   public void setPageBreakInside(String var1) throws DOMException {
      this.setProperty("pageBreakInside", var1, null);
   }

   public String getPause() {
      return this.getPropertyValue("pause");
   }

   public void setPause(String var1) throws DOMException {
      this.setProperty("pause", var1, null);
   }

   public String getPauseAfter() {
      return this.getPropertyValue("pauseAfter");
   }

   public void setPauseAfter(String var1) throws DOMException {
      this.setProperty("pauseAfter", var1, null);
   }

   public String getPauseBefore() {
      return this.getPropertyValue("pauseBefore");
   }

   public void setPauseBefore(String var1) throws DOMException {
      this.setProperty("pauseBefore", var1, null);
   }

   public String getPitch() {
      return this.getPropertyValue("pitch");
   }

   public void setPitch(String var1) throws DOMException {
      this.setProperty("pitch", var1, null);
   }

   public String getPitchRange() {
      return this.getPropertyValue("pitchRange");
   }

   public void setPitchRange(String var1) throws DOMException {
      this.setProperty("pitchRange", var1, null);
   }

   public String getPlayDuring() {
      return this.getPropertyValue("playDuring");
   }

   public void setPlayDuring(String var1) throws DOMException {
      this.setProperty("playDuring", var1, null);
   }

   public String getPosition() {
      return this.getPropertyValue("position");
   }

   public void setPosition(String var1) throws DOMException {
      this.setProperty("position", var1, null);
   }

   public String getQuotes() {
      return this.getPropertyValue("quotes");
   }

   public void setQuotes(String var1) throws DOMException {
      this.setProperty("quotes", var1, null);
   }

   public String getRichness() {
      return this.getPropertyValue("richness");
   }

   public void setRichness(String var1) throws DOMException {
      this.setProperty("richness", var1, null);
   }

   public String getRight() {
      return this.getPropertyValue("right");
   }

   public void setRight(String var1) throws DOMException {
      this.setProperty("right", var1, null);
   }

   public String getSize() {
      return this.getPropertyValue("size");
   }

   public void setSize(String var1) throws DOMException {
      this.setProperty("size", var1, null);
   }

   public String getSpeak() {
      return this.getPropertyValue("speak");
   }

   public void setSpeak(String var1) throws DOMException {
      this.setProperty("speak", var1, null);
   }

   public String getSpeakHeader() {
      return this.getPropertyValue("speakHeader");
   }

   public void setSpeakHeader(String var1) throws DOMException {
      this.setProperty("speakHeader", var1, null);
   }

   public String getSpeakNumeral() {
      return this.getPropertyValue("speakNumeral");
   }

   public void setSpeakNumeral(String var1) throws DOMException {
      this.setProperty("speakNumeral", var1, null);
   }

   public String getSpeakPunctuation() {
      return this.getPropertyValue("speakPunctuation");
   }

   public void setSpeakPunctuation(String var1) throws DOMException {
      this.setProperty("speakPunctuation", var1, null);
   }

   public String getSpeechRate() {
      return this.getPropertyValue("speechRate");
   }

   public void setSpeechRate(String var1) throws DOMException {
      this.setProperty("speechRate", var1, null);
   }

   public String getStress() {
      return this.getPropertyValue("stress");
   }

   public void setStress(String var1) throws DOMException {
      this.setProperty("stress", var1, null);
   }

   public String getTableLayout() {
      return this.getPropertyValue("tableLayout");
   }

   public void setTableLayout(String var1) throws DOMException {
      this.setProperty("tableLayout", var1, null);
   }

   public String getTextAlign() {
      return this.getPropertyValue("textAlign");
   }

   public void setTextAlign(String var1) throws DOMException {
      this.setProperty("textAlign", var1, null);
   }

   public String getTextDecoration() {
      return this.getPropertyValue("textDecoration");
   }

   public void setTextDecoration(String var1) throws DOMException {
      this.setProperty("textDecoration", var1, null);
   }

   public String getTextIndent() {
      return this.getPropertyValue("textIndent");
   }

   public void setTextIndent(String var1) throws DOMException {
      this.setProperty("textIndent", var1, null);
   }

   public String getTextShadow() {
      return this.getPropertyValue("textShadow");
   }

   public void setTextShadow(String var1) throws DOMException {
      this.setProperty("textShadow", var1, null);
   }

   public String getTextTransform() {
      return this.getPropertyValue("textTransform");
   }

   public void setTextTransform(String var1) throws DOMException {
      this.setProperty("textTransform", var1, null);
   }

   public String getTop() {
      return this.getPropertyValue("top");
   }

   public void setTop(String var1) throws DOMException {
      this.setProperty("top", var1, null);
   }

   public String getUnicodeBidi() {
      return this.getPropertyValue("unicodeBidi");
   }

   public void setUnicodeBidi(String var1) throws DOMException {
      this.setProperty("unicodeBidi", var1, null);
   }

   public String getVerticalAlign() {
      return this.getPropertyValue("verticalAlign");
   }

   public void setVerticalAlign(String var1) throws DOMException {
      this.setProperty("verticalAlign", var1, null);
   }

   public String getVisibility() {
      return this.getPropertyValue("visibility");
   }

   public void setVisibility(String var1) throws DOMException {
      this.setProperty("visibility", var1, null);
   }

   public String getVoiceFamily() {
      return this.getPropertyValue("voiceFamily");
   }

   public void setVoiceFamily(String var1) throws DOMException {
      this.setProperty("voiceFamily", var1, null);
   }

   public String getVolume() {
      return this.getPropertyValue("volumn");
   }

   public void setVolume(String var1) throws DOMException {
      this.setProperty("volume", var1, null);
   }

   public String getWhiteSpace() {
      return this.getPropertyValue("whiteSpace");
   }

   public void setWhiteSpace(String var1) throws DOMException {
      this.setProperty("whiteSpace", var1, null);
   }

   public String getWidows() {
      return this.getPropertyValue("widows");
   }

   public void setWidows(String var1) throws DOMException {
      this.setProperty("widows", var1, null);
   }

   public String getWidth() {
      return this.getPropertyValue("width");
   }

   public void setWidth(String var1) throws DOMException {
      this.setProperty("width", var1, null);
   }

   public String getWordSpacing() {
      return this.getPropertyValue("wordSpacing");
   }

   public void setWordSpacing(String var1) throws DOMException {
      this.setProperty("wordSpacing", var1, null);
   }

   public String getZIndex() {
      return this.getPropertyValue("zIndex");
   }

   public void setZIndex(String var1) throws DOMException {
      this.setProperty("zIndex", var1, null);
   }
}
