package sun.plugin.dom.html;

import org.w3c.dom.DOMException;
import org.w3c.dom.html.HTMLLinkElement;
import org.w3c.dom.html.HTMLStyleElement;
import org.w3c.dom.stylesheets.LinkStyle;
import org.w3c.dom.stylesheets.StyleSheet;
import sun.plugin.dom.DOMObject;
import sun.plugin.dom.DOMObjectHelper;

public class HTMLLinkStyleElement extends HTMLElement implements HTMLLinkElement, HTMLStyleElement, LinkStyle {
   public HTMLLinkStyleElement(DOMObject var1, org.w3c.dom.html.HTMLDocument var2) {
      super(50, var1, var2);
   }

   public boolean getDisabled() {
      return DOMObjectHelper.getBooleanMemberNoEx(this.obj, "disabled");
   }

   public void setDisabled(boolean var1) {
      DOMObjectHelper.setBooleanMemberNoEx(this.obj, "disabled", var1);
   }

   public String getCharset() {
      return this.getAttribute("charset");
   }

   public void setCharset(String var1) {
      this.setAttribute("charset", var1);
   }

   public String getHref() {
      return this.getAttribute("href");
   }

   public void setHref(String var1) {
      this.setAttribute("href", var1);
   }

   public String getHreflang() {
      return this.getAttribute("hreflang");
   }

   public void setHreflang(String var1) {
      this.setAttribute("hreflang", var1);
   }

   public String getMedia() {
      return this.getAttribute("media");
   }

   public void setMedia(String var1) {
      this.setAttribute("media", var1);
   }

   public String getRel() {
      return this.getAttribute("rel");
   }

   public void setRel(String var1) {
      this.setAttribute("rel", var1);
   }

   public String getRev() {
      return this.getAttribute("rev");
   }

   public void setRev(String var1) {
      this.setAttribute("rev", var1);
   }

   public String getTarget() {
      return this.getAttribute("target");
   }

   public void setTarget(String var1) {
      this.setAttribute("target", var1);
   }

   public String getType() {
      return this.getAttribute("type");
   }

   public void setType(String var1) {
      this.setAttribute("type", var1);
   }

   public StyleSheet getSheet() {
      try {
         Object var1 = null;

         try {
            var1 = this.obj.getMember("stylesheet");
         } catch (Throwable var4) {
         }

         if (var1 == null) {
            try {
               var1 = this.obj.getMember("sheet");
            } catch (Throwable var3) {
            }
         }

         if (var1 != null && var1 instanceof DOMObject) {
            return new sun.plugin.dom.stylesheets.StyleSheet((DOMObject)var1, this.getOwnerDocument());
         }
      } catch (DOMException var5) {
      }

      return null;
   }
}
