package sun.plugin.javascript.navig;

import java.util.HashMap;
import netscape.javascript.JSException;

public class Document extends JSObject {
   private static HashMap methodTable = new HashMap();
   private static HashMap fieldTable = new HashMap();

   protected Document(int var1, String var2) {
      super(var1, var2);
      this.addObjectTable(fieldTable, methodTable);
   }

   public Object getMember(String var1) throws JSException {
      if (var1.equals("links")) {
         return this.resolveObject("[object LinkArray]", this.context + ".links");
      } else if (var1.equals("anchors")) {
         return this.resolveObject("[object AnchorArray]", this.context + ".anchors");
      } else if (var1.equals("forms")) {
         return this.resolveObject("[object FormArray]", this.context + ".forms");
      } else if (var1.equals("images")) {
         return this.resolveObject("[object ImageArray]", this.context + ".images");
      } else if (var1.equals("applets")) {
         return this.resolveObject("[object AppletArray]", this.context + ".applets");
      } else if (var1.equals("embeds")) {
         return this.resolveObject("[object EmbedArray]", this.context + ".embeds");
      } else if (var1.equals("location")) {
         return this.resolveObject("[object Location]", this.context + ".location");
      } else {
         try {
            return super.getMember(var1);
         } catch (JSException var5) {
            String var3 = this.evalScript(this.instance, "javascript: typeof(" + this.context + "." + var1 + ")");
            if (var3 != null && var3.equalsIgnoreCase("object")) {
               String var4 = this.evalScript(this.instance, "javascript:" + this.context + "." + var1 + ".constructor.name");
               if (!var4.equalsIgnoreCase("Form") && !var4.equalsIgnoreCase("HTMLFormElement")) {
                  throw var5;
               } else {
                  return this.resolveObject("[object Form]", this.context + "." + var1);
               }
            } else {
               throw var5;
            }
         }
      }
   }

   static {
      methodTable.put("clear", Boolean.FALSE);
      methodTable.put("close", Boolean.FALSE);
      methodTable.put("open", Boolean.FALSE);
      methodTable.put("write", Boolean.FALSE);
      methodTable.put("writeln", Boolean.FALSE);
      fieldTable.put("alinkColor", Boolean.TRUE);
      fieldTable.put("anchors", Boolean.FALSE);
      fieldTable.put("applets", Boolean.FALSE);
      fieldTable.put("bgColor", Boolean.TRUE);
      fieldTable.put("cookie", Boolean.TRUE);
      fieldTable.put("domain", Boolean.TRUE);
      fieldTable.put("embeds", Boolean.FALSE);
      fieldTable.put("fgColor", Boolean.TRUE);
      fieldTable.put("forms", Boolean.FALSE);
      fieldTable.put("images", Boolean.FALSE);
      fieldTable.put("lastModified", Boolean.FALSE);
      fieldTable.put("linkColor", Boolean.TRUE);
      fieldTable.put("links", Boolean.FALSE);
      fieldTable.put("location", Boolean.TRUE);
      fieldTable.put("plugins", Boolean.FALSE);
      fieldTable.put("referrer", Boolean.FALSE);
      fieldTable.put("title", Boolean.FALSE);
      fieldTable.put("URL", Boolean.FALSE);
      fieldTable.put("vlinkColor", Boolean.TRUE);
   }
}
