package sun.plugin.javascript.navig;

import java.util.HashMap;
import java.util.LinkedList;
import netscape.javascript.JSException;
import sun.plugin.usability.Trace;

public class JSObject extends sun.plugin.javascript.JSObject {
   protected String context;
   protected int instance;
   private LinkedList methodVector = new LinkedList();
   private LinkedList fieldVector = new LinkedList();
   private static JSObjectResolver resolver = null;

   protected JSObject(int var1, String var2) {
      this.instance = var1;
      this.context = var2;
   }

   public Object getMember(String var1) throws JSException {
      try {
         boolean var2 = false;
         LinkedList var3 = this.fieldVector;
         synchronized (var3) {
            for (HashMap var5 : this.fieldVector) {
               Boolean var6 = (Boolean)var5.get(var1);
               if (var6 != null) {
                  var2 = true;
                  break;
               }
            }
         }

         if (var2) {
            return this.evaluate(this.context + "." + var1);
         }
      } catch (Throwable var9) {
      }

      return super.getMember(var1);
   }

   public void setMember(String var1, Object var2) throws JSException {
      try {
         if (var2 == null) {
            var2 = "";
         }

         boolean var3 = false;
         LinkedList var4 = this.fieldVector;
         synchronized (var4) {
            for (HashMap var6 : this.fieldVector) {
               Boolean var7 = (Boolean)var6.get(var1);
               if (var7 != null && var7) {
                  var3 = true;
                  break;
               }
            }
         }

         if (var3) {
            if (var2 instanceof String) {
               this.evaluate(this.context + "." + var1 + "='" + var2.toString() + "'");
            } else {
               this.evaluate(this.context + "." + var1 + "=" + var2.toString());
            }

            return;
         }
      } catch (Throwable var10) {
      }

      super.setMember(var1, var2);
   }

   public Object call(String var1, Object[] var2) throws JSException {
      try {
         boolean var3 = false;
         LinkedList var4 = this.methodVector;
         synchronized (var4) {
            for (HashMap var6 : this.methodVector) {
               Boolean var7 = (Boolean)var6.get(var1);
               if (var7 != null) {
                  var3 = true;
                  break;
               }
            }
         }

         if (var3) {
            String var11 = this.context + "." + var1 + "(";
            if (var2 != null) {
               for (int var13 = 0; var13 < var2.length; var13++) {
                  if (var2[var13] instanceof String) {
                     var11 = var11 + "'" + var2[var13].toString() + "'";
                  } else {
                     var11 = var11 + var2[var13].toString();
                  }

                  if (var13 != var2.length - 1) {
                     var11 = var11 + ", ";
                  }
               }
            }

            var11 = var11 + ")";
            return this.evaluate(var11);
         }
      } catch (Throwable var10) {
      }

      return super.call(var1, var2);
   }

   public Object eval(String var1) throws JSException {
      return this.evaluate(var1);
   }

   public String toString() {
      return this.context;
   }

   protected synchronized Object evaluate(String var1) throws JSException {
      String var2 = this.evalScript(this.instance, "javascript: " + var1);
      Trace.messageLiveConnectPrintln("jsobject.eval", new Object[]{var1, var2}, 2);
      return var2;
   }

   public native String evalScript(int var1, String var2);

   protected static JSObjectResolver getResolver() {
      if (resolver == null) {
         resolver = new JSObjectFactory();
      }

      return resolver;
   }

   protected static void setResolver(JSObjectResolver var0) throws JSException {
      if (resolver == null) {
         resolver = var0;
      } else {
         throw new JSException("JSObject resolver already exists.");
      }
   }

   protected Object resolveObject(String var1, String var2, Object var3) throws JSException {
      JSObjectResolver var4 = getResolver();
      return var4.resolveObject(this, var1, this.instance, var2, var3);
   }

   protected Object resolveObject(String var1, String var2) throws JSException {
      return this.resolveObject(var1, var2, null);
   }

   protected final void addObjectTable(HashMap var1, HashMap var2) {
      if (var1 != null) {
         LinkedList var3 = this.fieldVector;
         synchronized (var3) {
            this.fieldVector.add(0, var1);
         }
      }

      if (var2 != null) {
         LinkedList var8 = this.methodVector;
         synchronized (var8) {
            this.methodVector.add(0, var2);
         }
      }
   }
}
