package sun.plugin.javascript.navig;

import netscape.javascript.JSException;

public class JSObjectFactory implements JSObjectResolver {
   public Object resolveObject(JSObject var1, String var2, int var3, String var4, Object var5) throws JSException {
      if (var2 == null || var2.indexOf("[") == -1) {
         return var2;
      } else if (var2.indexOf("Array]") != -1) {
         int var7 = 0;

         try {
            Object var8 = var1.eval(var4 + ".length");
            var7 = Integer.parseInt(var8.toString().trim());
         } catch (Throwable var9) {
            throw new JSException("resolveObject does not support " + this.toString() + ".length");
         }

         if (var2.indexOf("[object AnchorArray]") != -1) {
            return new AnchorArray(var3, var4, var7);
         } else if (var2.indexOf("[object ElementArray]") != -1) {
            return new ElementArray(var3, var4, var7, (Form)var5);
         } else if (var2.indexOf("[object FormArray]") != -1) {
            return new FormArray(var3, var4, var7);
         } else if (var2.indexOf("[object FrameArray]") != -1) {
            return new FrameArray(var3, var4, var7);
         } else if (var2.indexOf("[object ImageArray]") != -1) {
            return new ImageArray(var3, var4, var7);
         } else if (var2.indexOf("[object LinkArray]") != -1) {
            return new LinkArray(var3, var4, var7);
         } else if (var2.indexOf("[object OptionArray]") != -1) {
            return new OptionArray(var3, var4, var7);
         } else if (var2.indexOf("[object AppletArray]") != -1) {
            return new AnchorArray(var3, var4, var7);
         } else if (var2.indexOf("[object EmbedArray]") != -1) {
            return new AnchorArray(var3, var4, var7);
         } else {
            throw new JSException(var2 + " cannot be resolved as JSObject.");
         }
      } else if (var2.indexOf("[object Window]") != -1) {
         return new Window(var3, var4);
      } else if (var2.indexOf("[object Anchor]") != -1) {
         return new Anchor(var3, var4);
      } else if (var2.indexOf("[object Document]") != -1) {
         return new Document(var3, var4);
      } else if (var2.indexOf("[object Element]") != -1) {
         return new Element(var3, var4, (Form)var5);
      } else if (var2.indexOf("[object Form]") != -1) {
         return new Form(var3, var4);
      } else if (var2.indexOf("[object History]") != -1) {
         return new History(var3, var4);
      } else if (var2.indexOf("[object Image]") != -1) {
         return new Image(var3, var4);
      } else if (var2.indexOf("[object Link]") != -1) {
         return new Link(var3, var4);
      } else if (var2.indexOf("[object Location]") != -1) {
         return new Location(var3, var4);
      } else if (var2.indexOf("[object Navigator]") != -1) {
         return new Navigator(var3);
      } else if (var2.indexOf("[object Option]") != -1) {
         return new Option(var3, var4);
      } else if (var2.indexOf("[object URL]") != -1) {
         return new URL(var3, var4);
      } else {
         throw new JSException(var2 + " cannot be resolved as JSObject.");
      }
   }
}
