package sun.plugin.javascript.navig5;

import java.security.AccessControlContext;
import java.security.AccessControlException;
import java.security.AllPermission;
import netscape.javascript.JSException;
import sun.plugin.usability.Trace;

public class JSObject extends netscape.javascript.JSObject {
   private int nativeJSObject = 0;
   private int jsThreadID = 0;

   public JSObject(int var1) {
      this(JSGetThreadID(var1), JSGetNativeJSObject(var1));
   }

   public JSObject(int var1, int var2) {
      this.jsThreadID = var1;
      this.nativeJSObject = var2;
   }

   public Object call(String var1, Object[] var2) throws JSException {
      SecurityContext var3 = SecurityContext.getCurrentSecurityContext();
      boolean var4 = false;

      try {
         AccessControlContext var5 = var3.getAccessControlContext();
         var5.checkPermission(new AllPermission());
         var4 = true;
      } catch (AccessControlException var6) {
      }

      Trace.messageLiveConnectPrintln("jsobject.call", new Object[]{var1, var3.getURL(), String.valueOf(var4)}, 2);
      return JSObjectCall(this.jsThreadID, this.nativeJSObject, var3.getURL(), var1, var2, var4);
   }

   public Object eval(String var1) throws JSException {
      SecurityContext var2 = SecurityContext.getCurrentSecurityContext();
      boolean var3 = false;

      try {
         AccessControlContext var4 = var2.getAccessControlContext();
         var4.checkPermission(new AllPermission());
         var3 = true;
      } catch (AccessControlException var5) {
      }

      Trace.messageLiveConnectPrintln("jsobject.eval.url.permission", new Object[]{var1, var2.getURL(), String.valueOf(var3)}, 2);
      return JSObjectEval(this.jsThreadID, this.nativeJSObject, var2.getURL(), var1, var3);
   }

   public Object getMember(String var1) throws JSException {
      SecurityContext var2 = SecurityContext.getCurrentSecurityContext();
      boolean var3 = false;

      try {
         AccessControlContext var4 = var2.getAccessControlContext();
         var4.checkPermission(new AllPermission());
         var3 = true;
      } catch (AccessControlException var5) {
      }

      Trace.messageLiveConnectPrintln("jsobject.getMember", new Object[]{var1, var2.getURL(), String.valueOf(var3)}, 2);
      return JSObjectGetMember(this.jsThreadID, this.nativeJSObject, var2.getURL(), var1, var3);
   }

   public void setMember(String var1, Object var2) throws JSException {
      SecurityContext var3 = SecurityContext.getCurrentSecurityContext();
      boolean var4 = false;

      try {
         AccessControlContext var5 = var3.getAccessControlContext();
         var5.checkPermission(new AllPermission());
         var4 = true;
      } catch (AccessControlException var6) {
      }

      Trace.messageLiveConnectPrintln("jsobject.setMember", new Object[]{var1, var3.getURL(), String.valueOf(var4)}, 2);
      JSObjectSetMember(this.jsThreadID, this.nativeJSObject, var3.getURL(), var1, var2, var4);
   }

   public void removeMember(String var1) throws JSException {
      SecurityContext var2 = SecurityContext.getCurrentSecurityContext();
      boolean var3 = false;

      try {
         AccessControlContext var4 = var2.getAccessControlContext();
         var4.checkPermission(new AllPermission());
         var3 = true;
      } catch (AccessControlException var5) {
      }

      Trace.messageLiveConnectPrintln("jsobject.removeMember", new Object[]{var1, var2.getURL(), String.valueOf(var3)}, 2);
      JSObjectRemoveMember(this.jsThreadID, this.nativeJSObject, var2.getURL(), var1, var3);
   }

   public Object getSlot(int var1) throws JSException {
      SecurityContext var2 = SecurityContext.getCurrentSecurityContext();
      boolean var3 = false;

      try {
         AccessControlContext var4 = var2.getAccessControlContext();
         var4.checkPermission(new AllPermission());
         var3 = true;
      } catch (AccessControlException var5) {
      }

      Trace.messageLiveConnectPrintln("jsobject.getSlot", new Object[]{String.valueOf(var1), var2.getURL(), String.valueOf(var3)}, 2);
      return JSObjectGetSlot(this.jsThreadID, this.nativeJSObject, var2.getURL(), var1, var3);
   }

   public void setSlot(int var1, Object var2) throws JSException {
      SecurityContext var3 = SecurityContext.getCurrentSecurityContext();
      boolean var4 = false;

      try {
         AccessControlContext var5 = var3.getAccessControlContext();
         var5.checkPermission(new AllPermission());
         var4 = true;
      } catch (AccessControlException var6) {
      }

      Trace.messageLiveConnectPrintln("jsobject.setSlot", new Object[]{String.valueOf(var1), var3.getURL(), String.valueOf(var4)}, 2);
      JSObjectSetSlot(this.jsThreadID, this.nativeJSObject, var3.getURL(), var1, var2, var4);
   }

   public String toString() {
      return JSObjectToString(this.jsThreadID, this.nativeJSObject);
   }

   public void finalize() throws Throwable {
      JSFinalize(this.jsThreadID, this.nativeJSObject);
      super.finalize();
   }

   private static int JSGetNativeJSObject(int var0) {
      SecurityContext var1 = SecurityContext.getCurrentSecurityContext();
      boolean var2 = false;

      try {
         AccessControlContext var3 = var1.getAccessControlContext();
         var3.checkPermission(new AllPermission());
         var2 = true;
      } catch (AccessControlException var4) {
      }

      return JSGetNativeJSObject(var0, var1.getURL(), var2);
   }

   private static native int JSGetNativeJSObject(int var0, String var1, boolean var2);

   private static native int JSGetThreadID(int var0);

   private static native void JSFinalize(int var0, int var1);

   private static native Object JSObjectCall(int var0, int var1, String var2, String var3, Object[] var4, boolean var5) throws JSException;

   private static native Object JSObjectEval(int var0, int var1, String var2, String var3, boolean var4) throws JSException;

   private static native Object JSObjectGetMember(int var0, int var1, String var2, String var3, boolean var4) throws JSException;

   private static native void JSObjectSetMember(int var0, int var1, String var2, String var3, Object var4, boolean var5) throws JSException;

   private static native void JSObjectRemoveMember(int var0, int var1, String var2, String var3, boolean var4) throws JSException;

   private static native Object JSObjectGetSlot(int var0, int var1, String var2, int var3, boolean var4) throws JSException;

   private static native void JSObjectSetSlot(int var0, int var1, String var2, int var3, Object var4, boolean var5) throws JSException;

   private static native String JSObjectToString(int var0, int var1);
}
