package sun.plugin.javascript.ocx;

import netscape.javascript.JSException;
import sun.beans.ole.OleDispatchInterface;
import sun.plugin.viewer.context.IExplorerAppletContext;

public class JSObject extends sun.plugin.javascript.JSObject {
   static final int DISPATCH_METHOD = 1;
   static final int DISPATCH_PROPERTYGET = 2;
   static final int DISPATCH_PROPERTYPUT = 4;
   private int pointer;
   private OleDispatchInterface service = new OleDispatchInterface();
   private IExplorerAppletContext aac;
   private static Thread jsThread;
   private boolean released = false;
   private int handle = 0;

   public JSObject(int var1) {
      this.pointer = var1;
   }

   private void setIExplorerAppletContext(IExplorerAppletContext var1, int var2) {
      this.aac = var1;
      this.handle = var2;
      var1.addJSObjectToExportedList(this);
   }

   public void finalize() {
      this.cleanup();
   }

   public void cleanup() {
      if (!this.released) {
         this.nativeRelease(this.pointer);
         this.released = true;
      }
   }

   public synchronized Object invoke(String var1, Object[] var2, int var3) throws JSException {
      this.checkValidity();
      Object var4 = this.nativeInvoke(var1, var3, var2, this.handle, this.pointer);
      if (var4 != null && var4 instanceof JSObject) {
         ((JSObject)var4).setIExplorerAppletContext(this.aac, this.handle);
      }

      return var4;
   }

   public Object call(String var1, Object[] var2) throws JSException {
      return this.invoke(var1, var2, 1);
   }

   private int packageParms(Object[] var1) {
      int var2 = 0;
      if (var1 != null) {
         var2 = var1.length;
      }

      int var3 = this.service.allocateParmsFor(var2);

      for (int var4 = 0; var4 < var2; var4++) {
         if (var1[var4] instanceof Integer) {
            Integer var5 = (Integer)var1[var4];
            this.service.storeParm(var3, var2 - var4 - 1, var5.intValue(), 1);
         } else {
            this.service.storeParm(var3, var2 - var4 - 1, var1[var4], 1);
         }
      }

      return var3;
   }

   private void freeParms(int var1) {
      this.service.freeParms(var1);
   }

   public Object eval(String var1) throws JSException {
      Object[] var2 = new Object[1];
      StringBuffer var3 = new StringBuffer();

      for (int var4 = 0; var4 < var1.length(); var4++) {
         char var5 = var1.charAt(var4);
         if (var5 == '\'' || var5 == '"' || var5 == '\\') {
            var3.append('\\');
         }

         var3.append(var5);
      }

      var2[0] = "evalIntermediateValueToReturn=0;evalIntermediateValueToReturn=eval('" + var3.toString() + "');";
      netscape.javascript.JSObject var9 = this.aac.getJSObject();

      try {
         var9.call("execScript", var2);
      } catch (JSException var8) {
         throw new JSException("Failure to evaluate " + var1);
      }

      try {
         return var9.getMember("evalIntermediateValueToReturn");
      } catch (JSException var7) {
         return null;
      }
   }

   public Object getMember(String var1) throws JSException {
      return this.invoke(var1, null, 2);
   }

   public void setMember(String var1, Object var2) throws JSException {
      Object[] var3 = new Object[]{var2};
      this.invoke(var1, var3, 4);
   }

   public void removeMember(String var1) throws JSException {
      throw new JSException("removeMember does not support " + this.toString() + "." + var1);
   }

   public Object getSlot(int var1) throws JSException {
      Object[] var2 = new Object[]{new Integer(var1), new Integer(var1)};
      return this.invoke("item", var2, 1);
   }

   public void setSlot(int var1, Object var2) throws JSException {
      Object[] var3 = new Object[]{new Integer(var1), var2};
      this.invoke("add", var3, 1);
   }

   public String toString() {
      Object var1 = null;

      try {
         var1 = this.invoke("toString", null, 1);
      } catch (JSException var3) {
         var1 = "[object JSObject]";
      }

      return var1.toString();
   }

   private void checkValidity() throws JSException {
      if (this.released) {
         throw new JSException("Native DOM object has been released");
      }
   }

   private native void nativeRelease(int var1);

   private native Object nativeInvoke(String var1, int var2, Object[] var3, int var4, int var5);
}
