package sun.plugin.liveconnect;

import java.io.FilePermission;
import java.lang.reflect.Constructor;
import java.lang.reflect.Field;
import java.lang.reflect.Method;
import java.net.MalformedURLException;
import java.net.SocketPermission;
import java.net.URL;
import java.security.AccessController;
import java.security.AllPermission;
import java.security.CodeSource;
import java.security.PermissionCollection;
import java.security.Permissions;
import java.security.Policy;
import java.security.PrivilegedActionException;
import java.security.ProtectionDomain;
import sun.plugin.resources.ResourceHandler;
import sun.plugin.usability.Trace;

public class SecureInvocation {
   public static Object ConstructObject(Class var0, Constructor var1, Object[] var2, String var3, boolean var4, boolean var5) throws Exception {
      try {
         return AccessController.doPrivileged(new SecureInvocation$1(var0, var3, var4, var5, var1, var2));
      } catch (PrivilegedActionException var7) {
         throw var7;
      }
   }

   public static Object CallMethod(Class var0, Object var1, Method var2, Object[] var3, String var4, boolean var5, boolean var6) throws Exception {
      try {
         return AccessController.doPrivileged(new SecureInvocation$2(var0, var4, var5, var6, var2, var1, var3));
      } catch (PrivilegedActionException var8) {
         throw var8;
      }
   }

   public static Object GetField(Class var0, Object var1, Field var2, String var3, boolean var4, boolean var5) throws Exception {
      try {
         return AccessController.doPrivileged(new SecureInvocation$3(var0, var3, var4, var5, var2, var1));
      } catch (PrivilegedActionException var7) {
         throw var7;
      }
   }

   public static void SetField(Class var0, Object var1, Field var2, Object var3, String var4, boolean var5, boolean var6) throws Exception {
      try {
         AccessController.doPrivileged(new SecureInvocation$4(var0, var4, var5, var6, var2, var1, var3));
      } catch (PrivilegedActionException var8) {
         throw var8;
      }
   }

   private static ProtectionDomain getProtectionDomain(Class var0, String var1, boolean var2, boolean var3) throws OriginNotAllowedException, MalformedURLException {
      boolean var4 = false;
      checkLiveConnectCaller(var0, var1, var2);
      return var3 ? getTrustedProtectionDomain() : getDefaultProtectionDomain(var1);
   }

   private static void checkLiveConnectCaller(Class var0, String var1, boolean var2) throws OriginNotAllowedException, MalformedURLException {
      if (var2) {
         Trace.liveConnectPrintln(ResourceHandler.getMessage("liveconnect.UniversalBrowserRead.enabled"), 2);
      } else {
         ProtectionDomain var3 = var0.getProtectionDomain();
         CodeSource var4 = var3.getCodeSource();
         if (var4 == null) {
            Trace.liveConnectPrintln(ResourceHandler.getMessage("liveconnect.java.system"), 2);
         } else {
            URL var5 = var4.getLocation();
            URL var6 = null;
            if (var1 != null) {
               try {
                  var6 = new URL(var1);
               } catch (MalformedURLException var8) {
                  var8.printStackTrace();
                  return;
               }
            }

            if (var5 != null
               && var6 != null
               && var5.getProtocol().equalsIgnoreCase(var6.getProtocol())
               && var5.getHost().equalsIgnoreCase(var6.getHost())
               && var5.getPort() == var6.getPort()) {
               Trace.liveConnectPrintln(ResourceHandler.getMessage("liveconnect.same.origin"), 2);
            } else {
               throw new OriginNotAllowedException("JavaScript is not from the same origin as the Java code, caller=" + var6 + ", callee=" + var5);
            }
         }
      }
   }

   private static ProtectionDomain getDefaultProtectionDomain(String var0) throws MalformedURLException {
      Trace.liveConnectPrintln(ResourceHandler.getMessage("liveconnect.default.policy") + var0, 2);
      URL var1 = null;
      if (var0 != null) {
         try {
            var1 = new URL(var0);
         } catch (MalformedURLException var6) {
         }
      }

      Policy var2 = Policy.getPolicy();
      CodeSource var3 = new CodeSource(var1, null);
      PermissionCollection var4 = var2.getPermissions(var3);
      if (var1 != null && !var1.getProtocol().equals("file")) {
         String var5 = var1.getHost();
         AccessController.doPrivileged(new SecureInvocation$6(var4, var5));
      } else {
         var4.add(new FilePermission("<<ALL FILES>>", "read"));
         var4.add(new SocketPermission("localhost", "connect,accept"));
         AccessController.doPrivileged(new SecureInvocation$5(var4));
      }

      return new JavaScriptProtectionDomain(var4);
   }

   private static ProtectionDomain getTrustedProtectionDomain() {
      Trace.liveConnectPrintln(ResourceHandler.getMessage("liveconnect.UniversalJavaPermission.enabled"), 2);
      Permissions var0 = new Permissions();
      var0.add(new AllPermission());
      return new JavaScriptProtectionDomain(var0);
   }
}
