package sun.plugin.net.cookie;

import java.net.URL;
import netscape.javascript.JSException;
import netscape.javascript.JSObject;
import sun.applet.AppletPanel;
import sun.plugin.services.ServiceUnavailableException;
import sun.plugin.viewer.AppletPanelCache;
import sun.plugin.viewer.context.PluginAppletContext;

public class Netscape4CookieHandler implements CookieHandler {
   public synchronized void setCookieInfo(String var1, String var2) throws ServiceUnavailableException {
      if (!AppletPanelCache.hasValidInstance()) {
         throw new ServiceUnavailableException("Cookie service is not available for " + var1);
      } else {
         PluginAppletContext var3 = this.getMatchedApplet(var1);
         if (null != var3) {
            try {
               JSObject var4 = var3.getJSObject();
               if (var4 == null) {
                  throw new JSException("Unable to obtain Window object");
               }

               JSObject var5 = (JSObject)var4.getMember("document");
               if (var5 == null) {
                  throw new JSException("Unable to obtain Document object");
               }

               var5.setMember("cookie", var2);
            } catch (JSException var6) {
               var6.printStackTrace();
            }
         }
      }
   }

   public synchronized String getCookieInfo(String var1) throws ServiceUnavailableException {
      if (!AppletPanelCache.hasValidInstance()) {
         throw new ServiceUnavailableException("Cookie service is not available for " + var1);
      } else {
         PluginAppletContext var2 = this.getMatchedApplet(var1);
         if (null == var2) {
            return null;
         } else {
            try {
               JSObject var3 = var2.getJSObject();
               if (var3 == null) {
                  throw new JSException("Unable to obtain Window object");
               } else {
                  JSObject var4 = (JSObject)var3.getMember("document");
                  if (var4 == null) {
                     throw new JSException("Unable to obtain Document object");
                  } else {
                     return (String)var4.getMember("cookie");
                  }
               }
            } catch (JSException var5) {
               var5.printStackTrace();
               return null;
            }
         }
      }
   }

   protected PluginAppletContext getMatchedApplet(String var1) {
      String var2 = this.truncateURL(var1);
      Object[] var3 = AppletPanelCache.getAppletPanels();

      for (int var4 = 0; var4 < var3.length; var4++) {
         AppletPanel var5 = (AppletPanel)var3[var4];
         if (var5 != null) {
            URL var6 = var5.getDocumentBase();
            String var7 = this.truncateURL(var6.toString());
            if (var2.indexOf(var7) != -1) {
               return (PluginAppletContext)var5.getAppletContext();
            }
         }
      }

      return null;
   }

   private String truncateURL(String var1) {
      int var2 = var1.lastIndexOf(47);
      return var2 != -1 ? var1.substring(0, var2) : var1;
   }
}
