package sun.plugin.net.cookie;

import java.net.URL;
import java.text.MessageFormat;
import java.util.HashMap;
import sun.plugin.resources.ResourceHandler;
import sun.plugin.services.BrowserService;
import sun.plugin.services.ServiceProvider;
import sun.plugin.services.ServiceUnavailableException;
import sun.plugin.usability.Trace;

public class PluginCookieManager {
   private static HashMap cookieTable = new HashMap();
   private static CookieHandler cookieHandler = null;

   public static synchronized void setCookieInfo(URL var0, String var1) {
      initialize();
      MessageFormat var2 = new MessageFormat(ResourceHandler.getMessage("cookiehandler.server"));
      Object[] var3 = new Object[]{var0, var1};
      Trace.netPrintln(var2.format(var3), 2);

      try {
         cookieHandler.setCookieInfo(var0.toString(), var1);
      } catch (ServiceUnavailableException var5) {
         System.out.println(ResourceHandler.getMessage("cookiehandler.ignore.setcookie"));
      }
   }

   public static synchronized String getCookieInfo(URL var0) {
      initialize();
      String var1 = null;

      try {
         String var2 = var0.getProtocol() + var0.getHost() + var0.getFile();
         int var3 = var2.lastIndexOf(47);
         if (var3 < 0) {
            return null;
         }

         var2 = var2.substring(0, var3);

         try {
            var1 = cookieHandler.getCookieInfo(var0.toString());
            if (var1 != null && !var1.equals("") && !var1.equals("\n") && !var1.equals("\r\n")) {
               cookieTable.put(var2, var1);
            } else {
               cookieTable.put(var2, "");
               var1 = null;
            }
         } catch (ServiceUnavailableException var6) {
            System.out.println(ResourceHandler.getMessage("cookiehandler.noservice"));
            var1 = (String)cookieTable.get(var2);
         }

         if (var1 != null) {
            MessageFormat var4 = new MessageFormat(ResourceHandler.getMessage("cookiehandler.connect"));
            Object[] var5 = new Object[]{var0, var1};
            Trace.netPrintln(var4.format(var5), 2);
         }
      } catch (Throwable var7) {
         var7.printStackTrace();
      }

      return var1;
   }

   private static void initialize() {
      if (cookieHandler == null) {
         BrowserService var0 = ServiceProvider.getService();
         cookieHandler = var0.getCookieHandler();
      }
   }
}
