package sun.plugin.net.proxy;

import java.net.URL;
import java.util.StringTokenizer;
import sun.plugin.resources.ResourceHandler;
import sun.plugin.usability.Trace;

public class BrowserProxyHandler implements ProxyHandler {
   public boolean isSupported(int var1) {
      return var1 == 3;
   }

   public boolean isProxyCacheSupported() {
      return false;
   }

   public void init(BrowserProxyInfo var1) throws ProxyConfigException {
      Trace.netPrintln(ResourceHandler.getMessage("net.proxy.loading.browser"));
      if (!this.isSupported(var1.getType())) {
         throw new ProxyConfigException("Unable to support proxy type: " + var1.getType());
      } else {
         Trace.netPrintln(ResourceHandler.getMessage("net.proxy.loading.done"));
      }
   }

   public ProxyInfo getProxyInfo(URL var1) {
      String var2 = this.findProxyForURL(var1.toString());
      return this.extractAutoProxySetting(var2);
   }

   private native String findProxyForURL(String var1);

   private ProxyInfo extractAutoProxySetting(String var1) {
      if (var1 != null) {
         StringTokenizer var2 = new StringTokenizer(var1, ";", false);
         if (var2.hasMoreTokens()) {
            String var3 = var2.nextToken();
            int var4 = var3.indexOf("PROXY");
            if (var4 != -1) {
               return new ProxyInfo(var3.substring(var4 + 6));
            }

            var4 = var3.indexOf("SOCKS");
            if (var4 != -1) {
               return new ProxyInfo(null, var3.substring(var4 + 6));
            }
         }
      }

      return new ProxyInfo(null, -1);
   }
}
