package sun.plugin.net.proxy;

import java.io.FileInputStream;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Locale;
import java.util.Properties;
import java.util.StringTokenizer;
import sun.plugin.resources.ResourceHandler;
import sun.plugin.usability.Trace;
import sun.plugin.usability.UserProfile;

public class UserDefinedProxyConfig implements BrowserProxyConfig {
   public BrowserProxyInfo getBrowserProxyInfo() {
      Trace.netPrintln(ResourceHandler.getMessage("net.proxy.loading.userdef"));
      BrowserProxyInfo var1 = new BrowserProxyInfo();
      var1.setType(3);
      String var2 = UserProfile.getPropertyFile();

      try {
         FileInputStream var3 = new FileInputStream(var2);
         Properties var4 = new Properties();
         var4.load(var3);
         if ("false".equals(var4.getProperty("javaplugin.proxy.usebrowsersettings", "true"))) {
            var1.setType(1);
            String var5 = var4.getProperty("javaplugin.proxy.auto.url", "");
            Trace.netPrintln(ResourceHandler.getMessage("net.proxy.browser.autoConfigURL") + var5);
            if (var5 != null && !"".equals(var5.trim())) {
               var1.setType(2);
               var1.setAutoConfigURL(var5);
            }

            String var6 = var4.getProperty("javaplugin.proxy.settings", "");
            Trace.netPrintln(ResourceHandler.getMessage("net.proxy.browser.proxyList") + var6);
            if (var6 != null && !"".equals(var6.trim())) {
               ProxyUtils.parseProxyServer(var6, var1);
            }

            String var7 = var4.getProperty("javaplugin.proxy.bypass", "");
            Trace.netPrintln(ResourceHandler.getMessage("net.proxy.browser.proxyOverride") + var7);
            if (var7 != null && !"".equals(var7.trim())) {
               StringTokenizer var8 = new StringTokenizer(var7, ";");
               ArrayList var9 = new ArrayList();

               while (var8.hasMoreTokens()) {
                  String var10 = var8.nextToken().toLowerCase(Locale.ENGLISH).trim();
                  if (var10 != null) {
                     var9.add(var10);
                  }
               }

               var1.setOverrides(var9);
            }
         }
      } catch (IOException var11) {
      }

      Trace.netPrintln(ResourceHandler.getMessage("net.proxy.loading.done"));
      return var1;
   }
}
