package sun.plugin.net.proxy;

import java.util.ArrayList;
import java.util.Locale;
import java.util.StringTokenizer;
import sun.plugin.resources.ResourceHandler;
import sun.plugin.services.WinRegistry;
import sun.plugin.usability.Trace;

public class WIExplorerProxyConfig implements BrowserProxyConfig {
   private static final String REGSTR_PATH_INTERNET_SETTINGS = "Software\\Microsoft\\Windows\\CurrentVersion\\Internet Settings";
   private static final String REGSTR_VAL_PROXYENABLE = "ProxyEnable";
   private static final String REGSTR_VAL_PROXYSERVER = "ProxyServer";
   private static final String REGSTR_VAL_PROXYOVERRIDE = "ProxyOverride";
   private static final String REGSTR_VAL_AUTOCONFIGURL = "AutoConfigURL";

   public BrowserProxyInfo getBrowserProxyInfo() {
      Trace.netPrintln(ResourceHandler.getMessage("net.proxy.loading.ie"));
      BrowserProxyInfo var1 = new BrowserProxyInfo();
      WinRegistry.init();
      int var2 = -2147483647;
      Integer var3 = WinRegistry.getInteger(var2, "Software\\Microsoft\\Windows\\CurrentVersion\\Internet Settings", "ProxyEnable");
      Trace.netPrintln(ResourceHandler.getMessage("net.proxy.browser.proxyEnable") + var3);
      if (var3 != null) {
         var1.setType(var3);
      }

      if (var1.getType() == 1) {
         String var4 = WinRegistry.getString(var2, "Software\\Microsoft\\Windows\\CurrentVersion\\Internet Settings", "ProxyServer");
         Trace.netPrintln(ResourceHandler.getMessage("net.proxy.browser.proxyList") + var4);
         if (var4 != null) {
            ProxyUtils.parseProxyServer(var4, var1);
         }

         String var5 = WinRegistry.getString(var2, "Software\\Microsoft\\Windows\\CurrentVersion\\Internet Settings", "ProxyOverride");
         Trace.netPrintln(ResourceHandler.getMessage("net.proxy.browser.proxyOverride") + var5);
         if (var5 != null) {
            StringTokenizer var6 = new StringTokenizer(var5, ";");
            ArrayList var7 = new ArrayList();

            while (var6.hasMoreTokens()) {
               String var8 = var6.nextToken().toLowerCase(Locale.ENGLISH).trim();
               if (var8 != null) {
                  var7.add(var8);
               }
            }

            var1.setOverrides(var7);
         }
      }

      String var9 = WinRegistry.getString(var2, "Software\\Microsoft\\Windows\\CurrentVersion\\Internet Settings", "AutoConfigURL");
      if (var9 != null) {
         Trace.netPrintln(ResourceHandler.getMessage("net.proxy.browser.autoConfigURL") + var9);
         var1.setType(2);
         var1.setAutoConfigURL(var9);
      }

      Trace.netPrintln(ResourceHandler.getMessage("net.proxy.loading.done"));
      return var1;
   }
}
