package sun.plugin.net.proxy;

import java.io.File;
import sun.plugin.resources.ResourceHandler;
import sun.plugin.services.WinRegistry;
import sun.plugin.usability.Trace;

public class WNetscape4ProxyConfig implements BrowserProxyConfig {
   public BrowserProxyInfo getBrowserProxyInfo() {
      Trace.netPrintln(ResourceHandler.getMessage("net.proxy.loading.ns"));
      WinRegistry.init();
      BrowserProxyInfo var1 = new BrowserProxyInfo();
      float var2 = getNSVersion();
      File var3 = null;
      if (var2 >= 4.5) {
         String var4 = WinRegistry.getWindowsDirectory();
         if (var4 != null) {
            var3 = getNSPrefsFile(new File(var4, "nsreg.dat"));
         }
      } else {
         var3 = getNS40PrefsFile();
      }

      if (var3 != null) {
         Trace.netPrintln(ResourceHandler.getMessage("net.proxy.browser.pref.read") + var3.getPath());
         NSPreferences.parseFile(var3, var1);
      }

      Trace.netPrintln(ResourceHandler.getMessage("net.proxy.loading.done"));
      return var1;
   }

   private static float getNSVersion() {
      String var0 = "Software\\Netscape\\Netscape Navigator";
      String var1 = WinRegistry.getString(-2147483646, var0, "CurrentVersion");
      int var2 = -1;
      int var3 = -1;

      for (int var4 = 0; var4 < var1.length() && var3 == -1; var4++) {
         char var5 = var1.charAt(var4);
         boolean var6 = Character.isDigit(var5) || var5 == '.';
         if (var2 == -1) {
            if (var6) {
               var2 = var4;
            }
         } else if (!var6) {
            var3 = var4;
         }
      }

      if (var2 != -1 && var3 > var2) {
         try {
            return Float.parseFloat(var1.substring(var2, var3));
         } catch (NumberFormatException var7) {
            return -1.0F;
         }
      } else {
         return -1.0F;
      }
   }

   static File getNSPrefsFile(File var0) {
      NSRegistry var1 = new NSRegistry().open(var0);
      String var2 = null;
      if (var1 != null) {
         String var3 = var1.get("Common/Netscape/ProfileManager/LastNetscapeUser");
         if (var3 != null) {
            var2 = var1.get("Users/" + var3 + "/ProfileLocation");
         }

         var1.close();
      }

      return var2 != null ? new File(var2, "prefs.js") : null;
   }

   private static File getNS40PrefsFile() {
      String var0 = null;
      int var1 = -2147483646;
      String var2 = "Software\\Netscape\\Netscape Navigator\\Users";
      String var3 = WinRegistry.getString(var1, var2, "CurrentUser");
      if (var3 != null) {
         String var4 = "Software\\Netscape\\Netscape Navigator\\Users\\" + var3;
         var0 = WinRegistry.getString(var1, var4, "DirRoot");
      }

      return var0 != null ? new File(var0, "prefs.js") : null;
   }
}
