package sun.plugin.panel;

import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.BorderFactory;
import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.ButtonGroup;
import javax.swing.JCheckBox;
import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JRadioButton;

public class BasicPanel extends ActivatorSubPanel implements ActionListener {
   private JCheckBox enableJava;
   private JCheckBox showException;
   private MessageHandler mh = new MessageHandler("basic");
   private JRadioButton show;
   private JRadioButton hide;
   private JRadioButton nothing;
   private ButtonGroup one;

   BasicPanel(ConfigurationInfo var1) {
      super(var1);
      this.setBorder(BorderFactory.createEmptyBorder(4, 30, 4, 30));
      this.setLayout(new BoxLayout(this, 1));
      this.add(Box.createGlue());
      Dimension var2 = new Dimension(1, 5);
      this.add(Box.createRigidArea(var2));
      JPanel var3 = new JPanel();
      var3.setLayout(new BoxLayout(var3, 0));
      this.enableJava = new JCheckBox(this.mh.getMessage("enable_java"), true);
      this.enableJava.addActionListener(this);
      var3.add(this.enableJava);
      var3.add(Box.createGlue());
      this.add(var3);
      this.add(Box.createRigidArea(var2));
      JPanel var4 = new JPanel();
      var4.setLayout(new BoxLayout(var4, 1));
      JPanel var5 = new JPanel();
      var5.setLayout(new BoxLayout(var5, 0));
      JPanel var6 = new JPanel();
      var6.setLayout(new BoxLayout(var6, 0));
      JLabel var7 = new JLabel(this.mh.getMessage("java_console"));
      var6.add(var7);
      var6.add(Box.createGlue());
      var4.add(var6);
      var4.add(Box.createGlue());
      this.show = new JRadioButton(this.mh.getMessage("show_console"));
      this.hide = new JRadioButton(this.mh.getMessage("hide_console"));
      this.hide.setSelected(true);
      this.nothing = new JRadioButton(this.mh.getMessage("no_console"));
      this.one = new ButtonGroup();
      this.one.add(this.show);
      this.one.add(this.hide);
      this.one.add(this.nothing);
      this.show.addActionListener(this);
      this.hide.addActionListener(this);
      this.nothing.addActionListener(this);
      JPanel var8 = new JPanel();
      var8.setLayout(new BoxLayout(var8, 1));
      var8.add(this.show);
      var8.add(this.hide);
      var8.add(this.nothing);
      var5.add(Box.createRigidArea(new Dimension(15, 1)));
      var5.add(var8);
      var5.add(Box.createGlue());
      var4.add(var5);
      this.add(var4);
      this.add(Box.createRigidArea(var2));
      JPanel var9 = new JPanel();
      var9.setLayout(new BoxLayout(var9, 1));
      JPanel var10 = new JPanel();
      var10.setLayout(new BoxLayout(var10, 0));
      this.showException = new JCheckBox(this.mh.getMessage("show_exception"));
      this.showException.addActionListener(this);
      var10.add(this.showException);
      var10.add(Box.createGlue());
      var9.add(var10);
      this.add(var9);
      this.add(Box.createRigidArea(new Dimension(1, 10)));
      this.add(Box.createGlue());
      this.add(Box.createRigidArea(new Dimension(1, 10)));
      this.add(Box.createGlue());
      this.add(Box.createGlue());
      this.reset();
   }

   private JComboBox addComboBoxFor(JPanel var1, JLabel var2, String[] var3, int var4) {
      var1.add(var2);
      JComboBox var5 = new JComboBox();

      for (int var6 = 0; var6 < var3.length; var6++) {
         var5.addItem(var3[var6]);
      }

      var5.setSelectedIndex(var4);
      var5.addActionListener(this);
      var1.add(var5);
      return var5;
   }

   public void actionPerformed(ActionEvent var1) {
      if (var1.getSource() == this.enableJava) {
         this.model.setJavaEnabled(this.enableJava.isSelected());
         if (this.enableJava.isSelected()) {
            this.showException.setEnabled(true);
            this.show.setEnabled(true);
            this.hide.setEnabled(true);
            this.nothing.setEnabled(true);
         } else {
            this.showException.setEnabled(false);
            this.show.setEnabled(false);
            this.hide.setEnabled(false);
            this.nothing.setEnabled(false);
         }
      }

      if (var1.getSource() == this.show) {
         this.model.setConsoleEnabled("show");
      }

      if (var1.getSource() == this.hide) {
         this.model.setConsoleEnabled("hide");
      }

      if (var1.getSource() == this.nothing) {
         this.model.setConsoleEnabled("nothing");
      }

      if (var1.getSource() == this.showException) {
         this.model.setShowException(this.showException.isSelected());
      }
   }

   public void reset() {
      String var1 = this.model.isConsoleEnabled();
      if (var1.equalsIgnoreCase("show")) {
         this.show.setSelected(true);
      }

      if (var1.equalsIgnoreCase("hide")) {
         this.hide.setSelected(true);
      }

      if (var1.equalsIgnoreCase("nothing")) {
         this.nothing.setSelected(true);
      }

      this.enableJava.setSelected(this.model.isJavaEnabled());
      this.showException.setSelected(this.model.isShowExceptionEnabled());
      if (this.enableJava.isSelected()) {
         this.showException.setEnabled(true);
         this.show.setEnabled(true);
         this.hide.setEnabled(true);
         this.nothing.setEnabled(true);
      } else {
         this.showException.setEnabled(false);
         this.show.setEnabled(false);
         this.hide.setEnabled(false);
         this.nothing.setEnabled(false);
      }
   }
}
