package sun.plugin.panel;

import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.BorderFactory;
import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.JCheckBox;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.border.Border;
import sun.plugin.usability.DialogFactory;

public class BrowserPanel extends ActivatorSubPanel implements ActionListener {
   private static MessageHandler mh = new MessageHandler("browser");
   JCheckBox iexplorerCheckBox = new JCheckBox(mh.getMessage("ie.text"));
   JCheckBox netscape6CheckBox = new JCheckBox(mh.getMessage("ns6.text"));

   public BrowserPanel(ConfigurationInfo var1) {
      super(var1);
      this.setLayout(new BoxLayout(this, 1));
      Border var2 = BorderFactory.createEtchedBorder();
      JPanel var3 = new JPanel();
      var3.setLayout(new BoxLayout(var3, 1));
      var3.setBorder(
         BorderFactory.createCompoundBorder(BorderFactory.createEmptyBorder(4, 4, 4, 4), BorderFactory.createTitledBorder(var2, mh.getMessage("settings")))
      );
      JPanel var4 = new JPanel();
      var4.setLayout(new BoxLayout(var4, 1));
      var4.setBorder(BorderFactory.createEmptyBorder(4, 30, 4, 30));
      var4.add(Box.createRigidArea(new Dimension(1, 5)));
      var4.add(new JLabel(mh.getMessage("desc.text")));
      var4.add(Box.createRigidArea(new Dimension(1, 15)));
      var4.add(this.iexplorerCheckBox);
      var4.add(Box.createRigidArea(new Dimension(1, 5)));
      var4.add(this.netscape6CheckBox);
      var4.add(Box.createRigidArea(new Dimension(1, 5)));
      this.iexplorerCheckBox.addActionListener(this);
      this.netscape6CheckBox.addActionListener(this);
      var4.add(Box.createRigidArea(new Dimension(1, 40)));
      var4.add(Box.createGlue());
      var3.add(var4);
      this.add(var3);
      this.reset();
   }

   public void reset() {
      this.iexplorerCheckBox.setSelected(this.model.isIExplorerDefault());
      this.netscape6CheckBox.setSelected(this.model.isNetscape6Default());
   }

   public void actionPerformed(ActionEvent var1) {
      if (var1.getSource() == this.iexplorerCheckBox) {
         this.model.setIExplorerDefault(this.iexplorerCheckBox.isSelected());
      }

      if (var1.getSource() == this.netscape6CheckBox) {
         this.model.setNetscape6Default(this.netscape6CheckBox.isSelected());
      }
   }

   private static void showIExplorerErrorDialog() {
      DialogFactory.showMessageDialog(mh.getMessage("settings.fail.ie.text"), mh.getMessage("settings.fail.caption"));
   }

   private static void showNetscape6ErrorDialog() {
      DialogFactory.showMessageDialog(mh.getMessage("settings.fail.ns6.text"), mh.getMessage("settings.fail.caption"));
   }

   private static void showSuccessDialog() {
      DialogFactory.showMessageDialog(mh.getMessage("settings.success.text"), mh.getMessage("settings.success.caption"));
   }

   private static boolean showAlertDialog() {
      int var0 = DialogFactory.showConfirmDialog(mh.getMessage("settings.alert.text"));
      return var0 == 0;
   }
}
