package sun.plugin.panel;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.BufferedOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.InputStream;
import java.io.PrintStream;
import java.security.KeyStore;
import java.security.cert.CertificateException;
import java.security.cert.CertificateFactory;
import java.security.cert.CertificateParsingException;
import java.security.cert.X509Certificate;
import java.util.Collection;
import java.util.Enumeration;
import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JComponent;
import javax.swing.JFileChooser;
import javax.swing.JList;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.border.EmptyBorder;
import sun.misc.BASE64Encoder;
import sun.plugin.resources.ResourceHandler;
import sun.plugin.security.CertificateDialog;
import sun.plugin.usability.DialogFactory;
import sun.plugin.usability.Trace;

public class CertAllPanel extends ActivatorSubPanel implements ActionListener {
   private JList certList;
   private JButton removeButton;
   private JButton viewCertButton;
   private JButton exportButton;
   private JButton importButton;
   private String radioPos;
   private MessageHandler mh = new MessageHandler("cert");

   public CertAllPanel(ConfigurationInfo var1) {
      super(var1);
      this.setLayout(new BoxLayout(this, 1));
      this.add(Box.createRigidArea(new Dimension(1, 5)));
      JPanel var2 = new JPanel();
      var2.setLayout(new BorderLayout());
      var2.setBorder(new EmptyBorder(0, 5, 0, 5));
      this.certList = new JList();
      this.certList.setSelectionMode(0);
      var2.add(new JScrollPane(this.certList), "Center");
      this.removeButton = new JButton(this.mh.getMessage("remove_button"));
      this.removeButton.setMnemonic(82);
      this.removeButton.addActionListener(this);
      this.exportButton = new JButton(this.mh.getMessage("export_button"));
      this.exportButton.setMnemonic(69);
      this.exportButton.addActionListener(this);
      this.importButton = new JButton(this.mh.getMessage("import_button"));
      this.importButton.setMnemonic(73);
      this.importButton.addActionListener(this);
      this.viewCertButton = new JButton(this.mh.getMessage("details_button"));
      this.viewCertButton.setMnemonic(68);
      this.viewCertButton.addActionListener(this);
      JPanel var3 = new JPanel();
      var3.setLayout(new FlowLayout(1));
      var3.add(this.importButton);
      var3.add(this.exportButton);
      var3.add(this.removeButton);
      var3.add(this.viewCertButton);
      var2.add(var3, "South");
      this.add(var2);
   }

   public void actionPerformed(ActionEvent var1) {
      int var2 = this.certList.getSelectedIndex();
      String var3 = (String)this.certList.getSelectedValue();
      if (var1.getSource() == this.removeButton) {
         if (this.getRadioPos() == this.mh.getMessage("SignedApplet_value")) {
            this.model.deactivateCertificate(var3);
         } else {
            this.model.deactivateHttpsCertificate(var3);
         }

         this.reset();
      } else if (var1.getSource() == this.viewCertButton) {
         X509Certificate var4 = null;
         if (this.getRadioPos() == this.mh.getMessage("SignedApplet_value")) {
            var4 = (X509Certificate)this.model.getCertificate(var3);
         } else if (this.getRadioPos() == this.mh.getMessage("SecureSite_value")) {
            var4 = (X509Certificate)this.model.getHttpsCertificate(var3);
         } else if (this.getRadioPos() == this.mh.getMessage("SignerCA_value")) {
            var4 = (X509Certificate)this.model.getRootCACertificate(var3);
         } else if (this.getRadioPos() == this.mh.getMessage("SecureSiteCA_value")) {
            var4 = (X509Certificate)this.model.getHttpsRootCACertificate(var3);
         }

         X509Certificate[] var5 = new X509Certificate[]{var4};
         if (var5.length > 0 && var5[0] instanceof X509Certificate) {
            CertificateDialog var25 = new CertificateDialog(var5, 0);
            var25.DoModal();
         } else {
            Object var6 = null;
            if (this.getRadioPos() == this.mh.getMessage("SignedApplet_value")) {
               var6 = this.model.getImpCertificate(var3);
            } else {
               var6 = this.model.getImpHttpsCertificate(var3);
            }

            X509Certificate[] var7 = new X509Certificate[]{(X509Certificate)var6};
            CertificateDialog var8 = new CertificateDialog(var7, 0);
            var8.DoModal();
         }
      } else if (var1.getSource() == this.importButton) {
         JFileChooser var19 = new JFileChooser();
         CertFileFilter var21 = new CertFileFilter();
         var21.addExtension("csr");
         var21.addExtension("p12");
         var21.setDescription("Certificate Files");
         var19.setFileFilter(var21);
         var19.setFileSelectionMode(0);
         var19.setDialogType(0);
         var19.setMultiSelectionEnabled(false);
         int var26 = var19.showOpenDialog(this);
         if (var26 == 0) {
            File var28 = var19.getSelectedFile();
            if (var28 == null) {
               return;
            }

            try {
               InputStream var30 = System.in;
               FileInputStream var31 = new FileInputStream(var28);
               boolean var9 = false;
               var9 = this.importCertificate(var31);
               if (!var9) {
                  InputStream var10 = System.in;
                  FileInputStream var34 = new FileInputStream(var28);
                  this.importPKCS12Certificate(var34);
               }
            } catch (Throwable var17) {
               Trace.printException(var17);
            }
         }

         this.reset();
      } else if (var1.getSource() == this.exportButton) {
         X509Certificate var20 = null;
         if (this.getRadioPos() == this.mh.getMessage("SignedApplet_value")) {
            var20 = (X509Certificate)this.model.getCertificate(var3);
         } else if (this.getRadioPos() == this.mh.getMessage("SecureSite_value")) {
            var20 = (X509Certificate)this.model.getHttpsCertificate(var3);
         } else if (this.getRadioPos() == this.mh.getMessage("SignerCA_value")) {
            var20 = (X509Certificate)this.model.getRootCACertificate(var3);
         } else if (this.getRadioPos() == this.mh.getMessage("SecureSiteCA_value")) {
            var20 = (X509Certificate)this.model.getHttpsRootCACertificate(var3);
         }

         if (!(var20 instanceof X509Certificate)) {
            if (this.getRadioPos() == this.mh.getMessage("SignedApplet_value")) {
               var20 = this.model.getImpCertificate(var3);
            } else {
               var20 = this.model.getImpHttpsCertificate(var3);
            }
         }

         if (var20 != null) {
            JFileChooser var22 = new JFileChooser();
            var22.setFileSelectionMode(0);
            var22.setDialogType(1);
            var22.setMultiSelectionEnabled(false);
            int var27 = var22.showSaveDialog(this);
            if (var27 == 0) {
               File var29 = var22.getSelectedFile();
               if (var29 == null) {
                  return;
               }

               PrintStream var32 = null;

               try {
                  var32 = new PrintStream(new BufferedOutputStream(new FileOutputStream(var29)));
                  this.exportCertificate(var20, var32);
               } catch (Throwable var16) {
                  Trace.printException(var16);
               } finally {
                  if (var32 != null) {
                     var32.close();
                  }
               }
            }
         } else {
            Object[] var23 = new Object[]{getMessage("cert_export_dialog.caption")};
            DialogFactory.showMessageDialog(var23, getMessage("cert_export_dialog.title"));
         }
      }
   }

   public void exportCertificate(X509Certificate var1, PrintStream var2) {
      BASE64Encoder var3 = new BASE64Encoder();
      var2.println("-----BEGIN CERTIFICATE-----");

      try {
         var3.encodeBuffer(var1.getEncoded(), var2);
      } catch (Throwable var5) {
         Trace.printException(var5);
      }

      var2.println("-----END CERTIFICATE-----");
   }

   public void importPKCS12Certificate(InputStream var1) {
      KeyStore var2 = null;
      String var3 = null;

      try {
         var2 = KeyStore.getInstance("PKCS12");
         Object[] var4 = new Object[]{getMessage("cert_password_dialog.caption")};
         var3 = DialogFactory.showInputDialog(var4, getMessage("cert_password_dialog.title"));
         char[] var11 = var3.toCharArray();
         var2.load(var1, var11);
         Enumeration var6 = var2.aliases();

         while (var6.hasMoreElements()) {
            Object var7 = null;
            String var8 = (String)var6.nextElement();
            var7 = (X509Certificate)var2.getCertificate(var8);
            if (this.getRadioPos() == this.mh.getMessage("SignedApplet_value")) {
               this.model.deactivateImpCertificate((X509Certificate)var7);
            } else if (this.getRadioPos() == this.mh.getMessage("SecureSite_value")) {
               this.model.deactivateImpHttpsCertificate((X509Certificate)var7);
            }
         }
      } catch (Throwable var9) {
         if (var3 != "uninitializedValue") {
            Object[] var5 = new Object[]{getMessage("import_password_dialog.caption")};
            DialogFactory.showMessageDialog(var5, getMessage("import_password_dialog.title"));
         }
      }
   }

   public boolean importCertificate(InputStream var1) {
      CertificateFactory var2 = null;
      Object var3 = null;

      try {
         var2 = CertificateFactory.getInstance("X.509");
         var3 = (X509Certificate)var2.generateCertificate(var1);
         if (this.getRadioPos() == this.mh.getMessage("SignedApplet_value")) {
            this.model.deactivateImpCertificate((X509Certificate)var3);
         } else if (this.getRadioPos() == this.mh.getMessage("SecureSite_value")) {
            this.model.deactivateImpHttpsCertificate((X509Certificate)var3);
         }
      } catch (CertificateParsingException var7) {
         return false;
      } catch (CertificateException var8) {
         Object[] var6 = new Object[]{getMessage("import_format_dialog.caption")};
         DialogFactory.showMessageDialog(var6, getMessage("import_format_dialog.title"));
      }

      return true;
   }

   public void reset() {
      Collection var1 = null;
      if (this.getRadioPos() == this.mh.getMessage("SignedApplet_value")) {
         var1 = this.model.getCertificateAliases();
      } else if (this.getRadioPos() == this.mh.getMessage("SecureSite_value")) {
         var1 = this.model.getHttpsCertificateAliases();
      } else if (this.getRadioPos() == this.mh.getMessage("SignerCA_value")) {
         var1 = this.model.getRootCACertificateAliases();
      } else if (this.getRadioPos() == this.mh.getMessage("SecureSiteCA_value")) {
         var1 = this.model.getHttpsRootCACertAliases();
      }

      if (var1 != null && var1.size() != 0) {
         this.certList.setListData(var1.toArray());
      } else {
         this.certList.setListData(new String[0]);
      }

      boolean var2 = var1 != null && var1.size() > 0;
      if (this.getRadioPos() != this.mh.getMessage("SignerCA_value") && this.getRadioPos() != this.mh.getMessage("SecureSiteCA_value")) {
         this.setEnabled(this.removeButton, var2);
         this.setEnabled(this.exportButton, var2);
         this.setEnabled(this.importButton, true);
         this.setEnabled(this.viewCertButton, var2);
      } else {
         this.setEnabled(this.removeButton, false);
         this.setEnabled(this.exportButton, false);
         this.setEnabled(this.importButton, false);
         this.setEnabled(this.viewCertButton, var2);
      }

      if (var2) {
         this.certList.setSelectedIndex(0);
      }
   }

   private void setEnabled(JComponent var1, boolean var2) {
      var1.setEnabled(var2);
      var1.repaint();
   }

   public void setRadioPos(String var1) {
      this.radioPos = var1;
   }

   private String getRadioPos() {
      return this.radioPos == null ? this.mh.getMessage("SignedApplet_value") : this.radioPos;
   }

   private static String getMessage(String var0) {
      return ResourceHandler.getMessage(var0);
   }
}
