package sun.plugin.panel;

import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import javax.swing.BorderFactory;
import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.JCheckBox;
import javax.swing.JComponent;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.JTextField;
import javax.swing.border.EmptyBorder;
import javax.swing.event.TableModelEvent;
import javax.swing.event.TableModelListener;
import javax.swing.table.TableModel;
import sun.plugin.net.proxy.BrowserProxyInfo;
import sun.plugin.net.proxy.ProxyUtils;
import sun.plugin.usability.Trace;

public class ProxyPanel extends ActivatorSubPanel implements ActionListener, KeyListener, TableModelListener {
   private JTable table;
   private JTextField proxyByPass = new JTextField();
   private JTextField autoProxyURL = new JTextField();
   private JCheckBox useDefault;
   private MessageHandler mh = new MessageHandler("proxy");

   public ProxyPanel(ConfigurationInfo var1) {
      super(var1);
      this.setLayout(new BoxLayout(this, 1));
      JPanel var2 = new JPanel();
      var2.setLayout(new FlowLayout(0));
      this.useDefault = new JCheckBox(this.mh.getMessage("use_browser"));
      this.useDefault.addActionListener(this);
      var2.add(this.useDefault);
      var2.setBorder(BorderFactory.createEmptyBorder(4, 4, 4, 4));
      this.add(var2);
      JPanel var3 = new JPanel();
      var3.setLayout(new BoxLayout(var3, 1));
      var3.setBorder(new EmptyBorder(4, 4, 4, 4));
      Object[] var4 = new Object[]{this.mh.getMessage("proxy_protocol"), this.mh.getMessage("proxy_address"), this.mh.getMessage("proxy_port")};
      Object[][] var5 = new Object[][]{
         {this.mh.getMessage("http"), null, null},
         {this.mh.getMessage("https"), null, null},
         {this.mh.getMessage("ftp"), null, null},
         {this.mh.getMessage("gopher"), null, null},
         {this.mh.getMessage("socks"), null, null}
      };
      ProxyPanel$1 var6 = new ProxyPanel$1(this, var5, var4);
      this.table = new JTable(var6);
      this.table.getModel().addTableModelListener(this);
      JScrollPane var7 = new JScrollPane(this.table);
      var7.setPreferredSize(new Dimension(100, 100));
      var3.add(var7);
      this.add(var3);
      this.add(Box.createRigidArea(new Dimension(1, 5)));
      JPanel var8 = new JPanel();
      var8.setLayout(new BoxLayout(var8, 1));
      var8.add(new JLabel(this.mh.getMessage("bypass")));
      var8.add(this.proxyByPass);
      var8.setBorder(new EmptyBorder(0, 5, 0, 5));
      this.proxyByPass.addKeyListener(this);
      this.add(var8);
      this.add(Box.createRigidArea(new Dimension(1, 5)));
      JPanel var9 = new JPanel();
      var9.setLayout(new BoxLayout(var9, 1));
      var9.add(new JLabel(this.mh.getMessage("autourl")));
      var9.add(this.autoProxyURL);
      var9.setBorder(new EmptyBorder(0, 5, 0, 5));
      this.autoProxyURL.addKeyListener(this);
      this.add(var9);
      this.add(Box.createRigidArea(new Dimension(1, 5)));
      this.reset();
   }

   public void actionPerformed(ActionEvent var1) {
      if (var1.getSource() == this.useDefault) {
         boolean var2 = this.useDefault.isSelected();
         this.model.setDefaultProxySettings(var2);
         this.reset();
      }
   }

   public void keyTyped(KeyEvent var1) {
      this.setProxySettings();
   }

   public void keyReleased(KeyEvent var1) {
      this.setProxySettings();
   }

   public void keyPressed(KeyEvent var1) {
   }

   public void reset() {
      boolean var1 = this.model.useDefaultProxy();
      this.useDefault.setSelected(var1);
      boolean var2 = !var1;
      this.setEnabled(this.table, var2);
      this.setEnabled(this.proxyByPass, var2);
      this.setEnabled(this.autoProxyURL, var2);
      this.initProxySettings();
   }

   private void setProxySettings() {
      this.model.setProxyByPass(this.proxyByPass.getText());
      this.model.setAutoProxyURL(this.autoProxyURL.getText());
      StringBuffer var1 = new StringBuffer();
      TableModel var2 = this.table.getModel();
      String var3 = (String)var2.getValueAt(0, 1);
      if (var3 != null && !var3.equals("")) {
         var1.append("http=");
         var1.append(var3);
         Object var4 = var2.getValueAt(0, 2);

         try {
            if (var4 != null) {
               int var5 = Integer.parseInt(var4.toString());
               if (var5 != -1) {
                  var1.append(":");
                  var1.append(var4);
               }
            }
         } catch (Throwable var10) {
         }
      }

      var3 = (String)var2.getValueAt(1, 1);
      if (var3 != null && !var3.equals("")) {
         var1.append(";");
         var1.append("https=");
         var1.append(var3);
         Object var15 = var2.getValueAt(1, 2);

         try {
            if (var15 != null) {
               int var20 = Integer.parseInt(var15.toString());
               if (var20 != -1) {
                  var1.append(":");
                  var1.append(var15);
               }
            }
         } catch (Throwable var9) {
         }
      }

      var3 = (String)var2.getValueAt(2, 1);
      if (var3 != null && !var3.equals("")) {
         var1.append(";");
         var1.append("ftp=");
         var1.append(var3);
         Object var16 = var2.getValueAt(2, 2);

         try {
            if (var16 != null) {
               int var21 = Integer.parseInt(var16.toString());
               if (var21 != -1) {
                  var1.append(":");
                  var1.append(var16);
               }
            }
         } catch (Throwable var8) {
         }
      }

      var3 = (String)var2.getValueAt(3, 1);
      if (var3 != null && !var3.equals("")) {
         var1.append(";");
         var1.append("gopher=");
         var1.append(var3);
         Object var17 = var2.getValueAt(3, 2);

         try {
            if (var17 != null) {
               int var22 = Integer.parseInt(var17.toString());
               if (var22 != -1) {
                  var1.append(":");
                  var1.append(var17);
               }
            }
         } catch (Throwable var7) {
         }
      }

      var3 = (String)var2.getValueAt(4, 1);
      if (var3 != null && !var3.equals("")) {
         var1.append(";");
         var1.append("socks=");
         var1.append(var3);
         Object var18 = var2.getValueAt(4, 2);

         try {
            if (var18 != null) {
               int var23 = Integer.parseInt(var18.toString());
               if (var23 != -1) {
                  var1.append(":");
                  var1.append(var18);
               }
            }
         } catch (Throwable var6) {
         }
      }

      String var19 = var1.toString();
      if (var19.length() != 0) {
         this.model.setProxySettingsString(var19);
      } else {
         this.model.setProxySettingsString(null);
      }
   }

   private void initProxySettings() {
      this.proxyByPass.setText(this.model.getProxyByPass());
      this.autoProxyURL.setText(this.model.getAutoProxyURL());
      String var1 = this.model.getProxySettingsString();
      if (var1 != null && var1.length() != 0) {
         try {
            BrowserProxyInfo var2 = new BrowserProxyInfo();
            ProxyUtils.parseProxyServer(var1, var2);
            TableModel var3 = this.table.getModel();
            var3.setValueAt(var2.getHttpHost(), 0, 1);
            if (var2.getHttpPort() != -1) {
               var3.setValueAt(new Integer(var2.getHttpPort()), 0, 2);
            }

            var3.setValueAt(var2.getHttpsHost(), 1, 1);
            if (var2.getHttpsPort() != -1) {
               var3.setValueAt(new Integer(var2.getHttpsPort()), 1, 2);
            }

            var3.setValueAt(var2.getFtpHost(), 2, 1);
            if (var2.getFtpPort() != -1) {
               var3.setValueAt(new Integer(var2.getFtpPort()), 2, 2);
            }

            var3.setValueAt(var2.getGopherHost(), 3, 1);
            if (var2.getGopherPort() != -1) {
               var3.setValueAt(new Integer(var2.getGopherPort()), 3, 2);
            }

            var3.setValueAt(var2.getSocksHost(), 4, 1);
            if (var2.getSocksPort() != -1) {
               var3.setValueAt(new Integer(var2.getSocksPort()), 4, 2);
            }
         } catch (Exception var4) {
            Trace.printException(var4);
         }
      }
   }

   private void setEnabled(JComponent var1, boolean var2) {
      var1.setEnabled(var2);
      var1.repaint();
   }

   public void tableChanged(TableModelEvent var1) {
      this.setProxySettings();
   }
}
