package sun.plugin.security;

import java.security.AccessController;
import java.security.PrivilegedAction;
import sun.applet.AppletSecurity;
import sun.plugin.resources.ResourceHandler;
import sun.plugin.usability.DialogFactory;
import sun.plugin.usability.Trace;

public class ActivatorSecurityManager extends AppletSecurity {
   public void checkDelete(String var1) {
      this.checkWrite(var1);
   }

   public void checkAwtEventQueueAccess() {
      try {
         super.checkAwtEventQueueAccess();
      } catch (SecurityException var2) {
         this.checkSecurityAccess("accessEventQueue");
      }
   }

   public void checkSecurityAccess(String var1) {
      if (var1 == null || !var1.equals("java")) {
         super.checkSecurityAccess(var1);
      }
   }

   public void checkPrintJobAccess() {
      try {
         super.checkPrintJobAccess();
      } catch (SecurityException var2) {
         new ActivatorSecurityManager.CheckPrint_1_2();
      }
   }

   void showPrintDialog() {
      String var1 = ResourceHandler.getMessage("print.title");
      String[] var2 = ResourceHandler.getMessageArray("print.message");
      int var3 = 0;
      if (!Trace.isAutomationEnabled()) {
         var3 = DialogFactory.showConfirmDialog(var2, var1);
      } else {
         Trace.securityPrintln(ResourceHandler.getMessage("securitymgr.automation.printing"), 2);
         var3 = 0;
      }

      if (var3 != 0) {
         throw new SecurityException("checkPrintJobAccess");
      }
   }

   public Class[] getExecutionStackContext() {
      return super.getClassContext();
   }

   private class CheckPrint_1_2 implements PrivilegedAction {
      CheckPrint_1_2() {
         AccessController.doPrivileged(this);
      }

      public Object run() {
         ActivatorSecurityManager.this.showPrintDialog();
         return null;
      }
   }
}
