package sun.plugin.security;

import java.awt.BorderLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.security.cert.Certificate;
import java.security.cert.X509Certificate;
import javax.swing.BorderFactory;
import javax.swing.JButton;
import javax.swing.JList;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.UIManager;
import javax.swing.border.Border;
import javax.swing.border.TitledBorder;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;
import sun.misc.HexDumpEncoder;
import sun.plugin.resources.ResourceHandler;
import sun.plugin.usability.DialogFactory;
import sun.plugin.usability.Trace;
import sun.security.x509.SerialNumber;

public class CertificateDialog implements ListSelectionListener, ActionListener {
   private Certificate[] certs = null;
   private int index = 0;
   JTextArea textArea = new JTextArea();
   Object[] msg;
   Object[] options;

   public CertificateDialog(Certificate[] var1, int var2) {
      if ($assertionsDisabled || var1 != null && var2 >= 0) {
         this.certs = var1;
         this.index = var2;
         UIManager.getBorder("List.focusCellHighlightBorder");
         if (var1.length > var2 && var1[var2] instanceof X509Certificate) {
            Border var3 = BorderFactory.createEtchedBorder();
            TitledBorder var4 = BorderFactory.createTitledBorder(var3, getMessage("cert_dialog.field"));
            TitledBorder var5 = BorderFactory.createTitledBorder(var3, getMessage("cert_dialog.value"));
            Object[] var6 = new Object[]{
               getMessage("cert_dialog.field.Version"),
               getMessage("cert_dialog.field.SerialNumber"),
               getMessage("cert_dialog.field.SignatureAlg"),
               getMessage("cert_dialog.field.Issuer"),
               getMessage("cert_dialog.field.Validity"),
               getMessage("cert_dialog.field.Subject"),
               getMessage("cert_dialog.field.Signature")
            };
            JList var7 = new JList<>(var6);
            var7.setSelectionMode(0);
            var7.addListSelectionListener(this);
            var7.setSelectedIndex(6);
            JPanel var8 = new JPanel();
            var8.setLayout(new BorderLayout());
            var8.setBorder(var4);
            var8.add(new JScrollPane(var7), "Center");
            this.textArea.setLineWrap(false);
            this.textArea.setEditable(false);
            this.textArea.setColumns(40);
            JPanel var9 = new JPanel();
            var9.setLayout(new BorderLayout());
            var9.setBorder(var5);
            var9.add(new JScrollPane(this.textArea), "Center");
            JButton var10 = new JButton(getMessage("cert_dialog.viewIssuerButton"));
            var10.setMnemonic(86);
            if (var1.length == var2 + 1) {
               var10.setEnabled(false);
            } else {
               var10.addActionListener(this);
            }

            this.msg = new Object[]{var8, var9};
            Object[] var11 = new Object[]{getMessage("cert_dialog.okButton"), var10};
            this.options = var11;
         }
      } else {
         throw new AssertionError();
      }
   }

   public void DoModal() {
      if (!Trace.isAutomationEnabled()) {
         DialogFactory.showOptionDialog(this.msg, getMessage("cert_dialog.title"), this.options, this.options[0]);
      }
   }

   public void actionPerformed(ActionEvent var1) {
      CertificateDialog var2 = new CertificateDialog(this.certs, this.index + 1);
      var2.DoModal();
   }

   public void valueChanged(ListSelectionEvent var1) {
      JList var2 = (JList)var1.getSource();
      int var3 = var2.getSelectedIndex();
      X509Certificate var4 = (X509Certificate)this.certs[this.index];
      StringBuffer var5 = new StringBuffer();
      switch (var3) {
         case 0:
            var5.append("V");
            var5.append(var4.getVersion());
            break;
         case 1:
            SerialNumber var7 = new SerialNumber(var4.getSerialNumber());
            var5.append("[");
            var5.append(var7.getNumber().toString());
            var5.append("]");
            break;
         case 2:
            var5.append("[");
            var5.append(var4.getSigAlgName());
            var5.append("]");
            break;
         case 3:
            var5.append(this.formatDNString(var4.getIssuerDN().toString()));
            break;
         case 4:
            var5.append("[From: ");
            var5.append(var4.getNotBefore());
            var5.append(",\n To: ");
            var5.append(var4.getNotAfter());
            var5.append("]");
            break;
         case 5:
            var5.append(this.formatDNString(var4.getSubjectDN().toString()));
            break;
         case 6:
            HexDumpEncoder var6 = new HexDumpEncoder();
            var5.append(var6.encodeBuffer(var4.getSignature()));
            break;
         default:
            if (!$assertionsDisabled) {
               throw new AssertionError();
            }
      }

      this.textArea.setText(var5.toString());
      this.textArea.repaint();
   }

   private String formatDNString(String var1) {
      int var2 = var1.length();
      boolean var3 = false;
      boolean var4 = false;
      StringBuffer var5 = new StringBuffer();

      for (int var6 = 0; var6 < var2; var6++) {
         char var7 = var1.charAt(var6);
         if (var7 == '"' || var7 == '\'') {
            var4 = !var4;
         }

         if (var7 == ',' && !var4) {
            var5.append(",\n");
         } else {
            var5.append(var7);
         }
      }

      return var5.toString();
   }

   private static String getMessage(String var0) {
      return ResourceHandler.getMessage(var0);
   }
}
