package sun.plugin.security;

import java.security.cert.Certificate;
import java.security.cert.X509Certificate;
import java.text.MessageFormat;
import java.util.HashSet;
import javax.net.ssl.SSLPeerUnverifiedException;
import javax.net.ssl.SSLSession;
import sun.plugin.resources.ResourceHandler;
import sun.plugin.usability.DialogFactory;
import sun.plugin.usability.Trace;

public class HostnameVerifier implements javax.net.ssl.HostnameVerifier {
   private static HashSet hashSet = new HashSet();

   public boolean verify(String var1, SSLSession var2) {
      String var3 = null;

      label98: {
         boolean var5;
         try {
            Certificate[] var4 = var2.getPeerCertificates();
            if (!(var4[0] instanceof X509Certificate)) {
               throw new SSLPeerUnverifiedException("");
            }

            X509Certificate var19 = (X509Certificate)var4[0];
            String var6 = var19.getSubjectDN().getName();
            int var7 = var6.toUpperCase().indexOf("CN=");
            int var8 = var6.indexOf(",", var7);
            var3 = var6.substring(var7 + 3, var8);
            break label98;
         } catch (SSLPeerUnverifiedException var14) {
            var5 = false;
         } catch (Throwable var15) {
            var15.printStackTrace();
            break label98;
         } finally {
            if (var3 == null) {
               var3 = ResourceHandler.getMessage("https_dialog.unknown.host");
            }
         }

         return var5;
      }

      if (var1.equalsIgnoreCase(var3)) {
         return true;
      } else {
         for (Object[] var20 : hashSet) {
            if (var20[0].toString().equalsIgnoreCase(var1) && var20[1].toString().equalsIgnoreCase(var3)) {
               return true;
            }
         }

         return this.showHostnameMismatchDialog(var1, var3);
      }
   }

   boolean showHostnameMismatchDialog(String var1, String var2) {
      String var3 = ResourceHandler.getMessage("https_dialog.caption");
      MessageFormat var4 = new MessageFormat(ResourceHandler.getMessage("https_dialog.text"));
      Object[] var5 = new Object[]{var1, var2};
      String var6 = var4.format(var5);
      int var7 = 1;
      if (!Trace.isAutomationEnabled()) {
         var7 = DialogFactory.showConfirmDialog(var6, var3);
      } else {
         Trace.securityPrintln(ResourceHandler.getMessage("hostnameverifier.automation.ignoremismatch"), 2);
         var7 = 0;
      }

      if (var7 == 0) {
         Object[] var8 = new Object[]{var1, var2};
         hashSet.add(var8);
      }

      return var7 == 0;
   }
}
