package sun.plugin.security;

import sun.misc.ClassFileTransformer;

public class JDK11ClassFileTransformer {
   public static synchronized void init() {
      ClassFileTransformer.add(new JDK11ClassFileTransformer.Broken11Transformer_0());
      ClassFileTransformer.add(new JDK11ClassFileTransformer.Broken11Transformer_1());
   }

   private static void ensureClassFileVersion(byte[] var0, int var1, int var2) throws ClassFormatError {
      if (var2 < 8) {
         throw new ClassFormatError();
      } else {
         int var3 = readShort(var0, var1 + 6);
         if (var3 >= 46) {
            throw new ClassFormatError();
         }
      }
   }

   private static int readByte(byte var0) {
      return var0 & 0xFF;
   }

   private static int readShort(byte[] var0, int var1) {
      int var2 = readByte(var0[var1]);
      int var3 = readByte(var0[var1 + 1]);
      return var2 << 8 | var3;
   }

   private static class Broken11Transformer_0 extends ClassFileTransformer {
      private Broken11Transformer_0() {
      }

      public byte[] transform(byte[] var1, int var2, int var3) throws ClassFormatError {
         JDK11ClassFileTransformer.ensureClassFileVersion(var1, var2, var3);

         try {
            Broken11ClassFixer var4 = new Broken11ClassFixer();
            var4.process(var1, var2, var3);
            byte[] var5 = var4.getProcessedData();
            int var6 = var4.getProcessedDataOffset();
            int var7 = var4.getProcessedDataLength();
            if (var6 == 0 && var7 == var5.length) {
               return var5;
            } else {
               byte[] var8 = new byte[var7];
               System.arraycopy(var5, var6, var8, 0, var7);
               return var8;
            }
         } catch (ThreadDeath var9) {
            throw var9;
         } catch (Throwable var10) {
            throw new ClassFormatError();
         }
      }
   }

   private static class Broken11Transformer_1 extends ClassFileTransformer {
      private Broken11Transformer_1() {
      }

      public byte[] transform(byte[] var1, int var2, int var3) throws ClassFormatError {
         JDK11ClassFileTransformer.ensureClassFileVersion(var1, var2, var3);

         try {
            StripClassFile var4 = new StripClassFile();
            return var4.strip(var1);
         } catch (ThreadDeath var6) {
            throw var6;
         } catch (Throwable var7) {
            throw new ClassFormatError();
         }
      }
   }
}
