package sun.plugin.security;

import java.net.Authenticator;
import java.net.InetAddress;
import java.net.PasswordAuthentication;
import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JPasswordField;
import javax.swing.JTextField;
import sun.plugin.resources.ResourceHandler;
import sun.plugin.usability.DialogFactory;
import sun.plugin.usability.Trace;

public class PluginAuthenticator extends Authenticator {
   protected synchronized PasswordAuthentication getPasswordAuthentication() {
      PasswordAuthentication var1 = null;

      try {
         StringBuffer var2 = new StringBuffer();
         var2.append("Firewall authentication: site=");
         var2.append(this.getRequestingSite());
         var2.append(":" + this.getRequestingPort());
         var2.append(", protocol=");
         var2.append(this.getRequestingProtocol());
         var2.append(", prompt=");
         var2.append(this.getRequestingPrompt());
         var2.append(", scheme=");
         var2.append(this.getRequestingScheme());
         Trace.netPrintln(var2.toString(), 2);
         InetAddress var3 = this.getRequestingSite();
         String var4 = "Unknown Site";
         if (var3 != null) {
            var4 = var3.toString();
         }

         var1 = this.openDialog(var4, this.getRequestingPrompt(), this.getRequestingScheme());
      } catch (Exception var5) {
         Trace.netPrintException(var5);
      }

      return var1;
   }

   private PasswordAuthentication openDialog(String var1, String var2, String var3) {
      if (var1 == null) {
         var1 = "";
      }

      if (var2 == null) {
         var2 = "";
      }

      if (var3 == null) {
         var3 = "";
      }

      JTextField var4 = new JTextField();
      var4.setColumns(15);
      JPasswordField var5 = new JPasswordField();
      var5.setColumns(15);
      JPanel var6 = new JPanel();
      var6.setLayout(new BoxLayout(var6, 1));
      var6.add(new JLabel(this.getMessage("net.authenticate.firewall")));
      var6.add(Box.createVerticalStrut(15));
      var6.add(new JLabel(this.getMessage("net.authenticate.realm")));
      var6.add(Box.createVerticalStrut(15));
      var6.add(new JLabel(this.getMessage("net.authenticate.scheme")));
      var6.add(Box.createVerticalStrut(15));
      var6.add(new JLabel(this.getMessage("net.authenticate.username")));
      var6.add(Box.createVerticalStrut(20));
      var6.add(new JLabel(this.getMessage("net.authenticate.password")));
      var6.add(Box.createVerticalStrut(5));
      JPanel var7 = new JPanel();
      var7.setLayout(new BoxLayout(var7, 1));
      var7.add(new JLabel(var1));
      var7.add(Box.createVerticalStrut(15));
      var7.add(new JLabel(var2));
      var7.add(Box.createVerticalStrut(15));
      var7.add(new JLabel(var3));
      var7.add(Box.createVerticalStrut(15));
      var7.add(var4);
      var7.add(Box.createVerticalStrut(15));
      var7.add(var5);
      JPanel var8 = new JPanel();
      var8.setLayout(new BoxLayout(var8, 0));
      var8.add(var6);
      var8.add(Box.createHorizontalStrut(15));
      var8.add(var7);
      Object[] var9 = new Object[]{var8};
      int var10 = DialogFactory.showConfirmDialog(var9, this.getMessage("net.authenticate.title"));
      return var10 == 0 ? new PasswordAuthentication(var4.getText(), var5.getPassword()) : null;
   }

   private String getMessage(String var1) {
      return ResourceHandler.getMessage(var1);
   }
}
