package sun.plugin.security;

import java.io.Serializable;
import java.security.MessageDigest;
import java.security.NoSuchAlgorithmException;
import java.security.SecureRandomSpi;
import sun.security.provider.SecureRandom;

public final class WSecureRandom extends SecureRandomSpi implements Serializable {
   private SecureRandom spi = null;

   public WSecureRandom() {
      byte[] var1 = WSeedGenerator.generateSeed(128);

      try {
         MessageDigest var2 = MessageDigest.getInstance("SHA");
         var2.update(var1);
         var1 = var2.digest();
      } catch (NoSuchAlgorithmException var3) {
         var3.printStackTrace();
      }

      this.spi = new SecureRandom();
      this.spi.engineSetSeed(var1);
   }

   public byte[] engineGenerateSeed(int var1) {
      return this.spi.engineGenerateSeed(var1);
   }

   public synchronized void engineSetSeed(byte[] var1) {
      this.spi.engineSetSeed(var1);
   }

   public synchronized void engineNextBytes(byte[] var1) {
      this.spi.engineNextBytes(var1);
   }
}
