package sun.plugin.services;

import java.security.Provider;
import java.security.SecureRandom;
import java.security.Security;
import sun.plugin.net.cookie.CookieHandler;
import sun.plugin.net.cookie.IExplorerCookieHandler;
import sun.plugin.net.proxy.BrowserProxyConfig;
import sun.plugin.net.proxy.WIExplorerProxyConfig;
import sun.plugin.viewer.context.IExplorerAppletContext;
import sun.plugin.viewer.context.PluginAppletContext;
import sun.plugin.viewer.context.PluginBeansContext;

public class WIExplorerBrowserService implements BrowserService {
   public CookieHandler getCookieHandler() {
      return new IExplorerCookieHandler();
   }

   public BrowserProxyConfig getProxyConfig() {
      return new WIExplorerProxyConfig();
   }

   public PluginAppletContext getAppletContext() {
      return new IExplorerAppletContext();
   }

   public PluginBeansContext getBeansContext() {
      PluginBeansContext var1 = new PluginBeansContext();
      var1.setPluginAppletContext(new IExplorerAppletContext());
      return var1;
   }

   public boolean isIExplorer() {
      return true;
   }

   public boolean isNetscape() {
      return false;
   }

   public float getBrowserVersion() {
      return 5.0F;
   }

   public SecureRandom getSecureRandom() {
      Provider var1 = Security.getProvider("SUN");
      var1.put("SecureRandom.SHA1PRNG", "sun.plugin.security.WSecureRandom");
      return new SecureRandom();
   }
}
