package sun.plugin.services;

import java.security.Provider;
import java.security.SecureRandom;
import java.security.Security;
import sun.plugin.net.cookie.CookieHandler;
import sun.plugin.net.cookie.Netscape4CookieHandler;
import sun.plugin.net.proxy.BrowserProxyConfig;
import sun.plugin.net.proxy.WNetscape4ProxyConfig;
import sun.plugin.viewer.context.NetscapeAppletContext;
import sun.plugin.viewer.context.PluginAppletContext;
import sun.plugin.viewer.context.PluginBeansContext;

public class WNetscape4BrowserService implements BrowserService {
   public CookieHandler getCookieHandler() {
      return new Netscape4CookieHandler();
   }

   public BrowserProxyConfig getProxyConfig() {
      return new WNetscape4ProxyConfig();
   }

   public PluginAppletContext getAppletContext() {
      return new NetscapeAppletContext();
   }

   public PluginBeansContext getBeansContext() {
      PluginBeansContext var1 = new PluginBeansContext();
      var1.setPluginAppletContext(new NetscapeAppletContext());
      return var1;
   }

   public boolean isIExplorer() {
      return false;
   }

   public boolean isNetscape() {
      return true;
   }

   public float getBrowserVersion() {
      return 4.0F;
   }

   public SecureRandom getSecureRandom() {
      Provider var1 = Security.getProvider("SUN");
      var1.put("SecureRandom.SHA1PRNG", "sun.plugin.security.WSecureRandom");
      return new SecureRandom();
   }
}
