package sun.plugin.services;

import java.security.Provider;
import java.security.SecureRandom;
import java.security.Security;
import sun.plugin.net.cookie.CookieHandler;
import sun.plugin.net.cookie.WNetscape6CookieHandler;
import sun.plugin.net.proxy.BrowserProxyConfig;
import sun.plugin.net.proxy.Netscape6ProxyConfig;
import sun.plugin.viewer.context.PluginAppletContext;
import sun.plugin.viewer.context.PluginBeansContext;
import sun.plugin.viewer.context.WNetscape6AppletContext;

public class WNetscape6BrowserService implements BrowserService {
   public CookieHandler getCookieHandler() {
      return new WNetscape6CookieHandler();
   }

   public BrowserProxyConfig getProxyConfig() {
      return new Netscape6ProxyConfig();
   }

   public PluginAppletContext getAppletContext() {
      return new WNetscape6AppletContext();
   }

   public PluginBeansContext getBeansContext() {
      PluginBeansContext var1 = new PluginBeansContext();
      var1.setPluginAppletContext(new WNetscape6AppletContext());
      return var1;
   }

   public boolean isIExplorer() {
      return false;
   }

   public boolean isNetscape() {
      return true;
   }

   public float getBrowserVersion() {
      return 6.0F;
   }

   public SecureRandom getSecureRandom() {
      Provider var1 = Security.getProvider("SUN");
      var1.put("SecureRandom.SHA1PRNG", "sun.plugin.security.WSecureRandom");
      return new SecureRandom();
   }
}
