package sun.plugin.services;

public class WinRegistry {
   public static final int HKEY_CLASSES_ROOT = Integer.MIN_VALUE;
   public static final int HKEY_CURRENT_USER = -2147483647;
   public static final int HKEY_LOCAL_MACHINE = -2147483646;
   public static final int HKEY_USERS = -2147483645;
   public static final int HKEY_PERFORMANCE_DATA = -2147483644;
   public static final int HKEY_CURRENT_CONFIG = -2147483643;
   public static final int HKEY_DYN_DATA = -2147483642;
   static final int KEY_QUERY_VALUE = 1;
   static final int KEY_SET_VALUE = 2;
   static final int KEY_CREATE_SUB_KEY = 4;
   static final int KEY_ENUMERATE_SUB_KEYS = 8;
   static final int KEY_NOTIFY = 16;
   static final int KEY_CREATE_LINK = 32;
   static final int KEY_READ = 131097;
   static final int KEY_WRITE = 131078;
   static final int KEY_EXECUTE = 131097;
   static final int KEY_ALL_ACCESS = 983103;
   static final int REG_OPTION_RESERVED = 0;
   static final int REG_OPTION_NON_VOLATILE = 0;
   static final int REG_OPTION_VOLATILE = 1;
   static final int REG_OPTION_CREATE_LINK = 2;
   static final int REG_OPTION_BACKUP_RESTORE = 4;
   static final int REG_OPTION_OPEN_LINK = 8;
   static final int REG_LEGAL_OPTION = 15;
   static final int REG_CREATED_NEW_KEY = 1;
   static final int REG_OPENED_EXISTING_KEY = 2;
   static final int REG_WHOLE_HIVE_VOLATILE = 1;
   static final int REG_REFRESH_HIVE = 2;
   static final int REG_NO_LAZY_FLUSH = 4;
   static final int REG_NOTIFY_CHANGE_NAME = 1;
   static final int REG_NOTIFY_CHANGE_ATTRIBUTES = 2;
   static final int REG_NOTIFY_CHANGE_LAST_SET = 4;
   static final int REG_NOTIFY_CHANGE_SECURITY = 8;
   static final int REG_LEGAL_CHANGE_FILTER = 15;
   static final int REG_NONE = 0;
   static final int REG_SZ = 1;
   static final int REG_EXPAND_SZ = 2;
   static final int REG_BINARY = 3;
   static final int REG_DWORD = 4;
   static final int REG_DWORD_LITTLE_ENDIAN = 4;
   static final int REG_DWORD_BIG_ENDIAN = 5;
   static final int REG_LINK = 6;
   static final int REG_MULTI_SZ = 7;
   static final int REG_RESOURCE_LIST = 8;
   static final int REG_FULL_RESOURCE_DESCRIPTOR = 9;
   static final int REG_RESOURCE_REQUIREMENTS_LIST = 10;

   public static void init() {
      initIDs();
   }

   static native void initIDs();

   static native int sysOpenKey(int var0, String var1, int var2);

   static native int sysCloseKey(int var0);

   static native WinRegistry.KeyValue sysQueryKey(int var0, String var1);

   static native int sysCreateKey(int var0, String var1, int var2);

   static native boolean sysSetStringValue(int var0, String var1, String var2);

   static native boolean sysDeleteKey(int var0, String var1);

   public static native String getWindowsDirectory();

   public static Object get(int var0, String var1, String var2) {
      int var3 = sysOpenKey(var0, var1, 131097);
      if (var3 != 0) {
         WinRegistry.KeyValue var4 = sysQueryKey(var3, var2);
         sysCloseKey(var3);
         if (var4 != null) {
            return var4.getValue();
         }
      }

      return null;
   }

   public static String getString(int var0, String var1, String var2) {
      Object var3 = get(var0, var1, var2);
      return var3 instanceof String ? (String)var3 : null;
   }

   public static Integer getInteger(int var0, String var1, String var2) {
      Object var3 = get(var0, var1, var2);
      if (var3 instanceof Integer) {
         return (Integer)var3;
      } else if (var3 instanceof byte[]) {
         byte[] var4 = (byte[])var3;
         return var4.length == 4 && var4[1] == 0 && var4[2] == 0 && var4[3] == 0 ? new Integer(var4[0]) : null;
      } else {
         return null;
      }
   }

   public static boolean setStringValue(int var0, String var1, String var2, String var3) {
      boolean var4 = false;
      int var5 = sysCreateKey(var0, var1, 131078);
      if (var5 != 0) {
         var4 = sysSetStringValue(var5, var2, var3);
         sysCloseKey(var5);
      }

      return var4;
   }

   public static boolean doesSubKeyExist(int var0, String var1) {
      int var2 = sysOpenKey(var0, var1, 131097);
      if (var2 != 0) {
         sysCloseKey(var2);
         return true;
      } else {
         return false;
      }
   }

   public static boolean deleteKey(int var0, String var1) {
      return sysDeleteKey(var0, var1);
   }

   static class KeyValue {
      private final int type;
      private final byte[] data;
      private Object value = null;

      KeyValue(int var1, byte[] var2) {
         this.type = var1;
         this.data = var2;
      }

      public int getType() {
         return this.type;
      }

      public byte[] getData() {
         return this.data;
      }

      public Object getValue() {
         switch (this.type) {
            case 1:
               return new String(this.data, 0, this.data.length - 1);
            case 4:
               int var1 = 0;

               for (int var2 = 0; var2 < 4 && var2 < this.data.length; var2++) {
                  var1 += this.data[var2] << var2 * 8;
               }

               return new Integer(var1);
            default:
               return this.getData();
         }
      }
   }
}
