package sun.plugin.usability;

import java.awt.Component;
import java.awt.Graphics;
import java.awt.Insets;
import java.awt.Panel;
import javax.swing.Icon;
import javax.swing.border.Border;

public class BorderIcon implements Icon {
   Panel panel;
   Border border;
   Icon icon;

   public BorderIcon(Icon var1, Border var2) {
      this.icon = var1;
      this.border = var2;
      this.panel = new Panel();
      this.panel.setSize(100, 100);
   }

   public int getIconWidth() {
      Insets var1 = this.border.getBorderInsets(this.panel);
      return var1.left + var1.right + this.icon.getIconWidth();
   }

   public int getIconHeight() {
      Insets var1 = this.border.getBorderInsets(this.panel);
      return var1.top + var1.bottom + this.icon.getIconHeight();
   }

   public void paintIcon(Component var1, Graphics var2, int var3, int var4) {
      Insets var5 = this.border.getBorderInsets(var1);
      this.border.paintBorder(var1, var2, var3, var4, var5.left + var5.right + this.icon.getIconWidth(), var5.top + var5.bottom + this.icon.getIconHeight());
      this.icon.paintIcon(var1, var2, var3 + var5.left, var4 + var5.top);
   }
}
