package sun.plugin.usability;

import java.lang.reflect.Array;
import java.util.EventListener;

public class EventMulticaster implements ProgressListener, TraceListener {
   protected final EventListener a;
   protected final EventListener b;

   protected EventMulticaster(EventListener var1, EventListener var2) {
      this.a = var1;
      this.b = var2;
   }

   protected EventListener remove(EventListener var1) {
      if (var1 == this.a) {
         return this.b;
      } else if (var1 == this.b) {
         return this.a;
      } else {
         EventListener var2 = removeInternal(this.a, var1);
         EventListener var3 = removeInternal(this.b, var1);
         return (EventListener)(var2 == this.a && var3 == this.b ? this : addInternal(var2, var3));
      }
   }

   public void onStartBinding(Object var1) {
      ((ProgressListener)this.a).onStartBinding(var1);
      ((ProgressListener)this.b).onStartBinding(var1);
   }

   public void onProgressAvailable(Object var1, int var2, int var3) {
      ((ProgressListener)this.a).onProgressAvailable(var1, var2, var3);
      ((ProgressListener)this.b).onProgressAvailable(var1, var2, var3);
   }

   public void onStopBinding(Object var1) {
      ((ProgressListener)this.a).onStopBinding(var1);
      ((ProgressListener)this.b).onStopBinding(var1);
   }

   public void onProgressComplete(Object var1) {
      ((ProgressListener)this.a).onProgressComplete(var1);
      ((ProgressListener)this.b).onProgressComplete(var1);
   }

   public boolean isSupported(int var1) {
      return ((TraceListener)this.a).isSupported(var1) || ((TraceListener)this.b).isSupported(var1);
   }

   public void println(String var1, int var2) {
      if (((TraceListener)this.a).isSupported(var2)) {
         ((TraceListener)this.a).println(var1, var2);
      }

      if (((TraceListener)this.b).isSupported(var2)) {
         ((TraceListener)this.b).println(var1, var2);
      }
   }

   public static ProgressListener add(ProgressListener var0, ProgressListener var1) {
      return (ProgressListener)addInternal(var0, var1);
   }

   public static ProgressListener remove(ProgressListener var0, ProgressListener var1) {
      return (ProgressListener)removeInternal(var0, var1);
   }

   public static TraceListener add(TraceListener var0, TraceListener var1) {
      return (TraceListener)addInternal(var0, var1);
   }

   public static TraceListener remove(TraceListener var0, TraceListener var1) {
      return (TraceListener)removeInternal(var0, var1);
   }

   protected static EventListener addInternal(EventListener var0, EventListener var1) {
      if (var0 == null) {
         return var1;
      } else {
         return (EventListener)(var1 == null ? var0 : new EventMulticaster(var0, var1));
      }
   }

   protected static EventListener removeInternal(EventListener var0, EventListener var1) {
      if (var0 == var1 || var0 == null) {
         return null;
      } else {
         return var0 instanceof EventMulticaster ? ((EventMulticaster)var0).remove(var1) : var0;
      }
   }

   private static int getListenerCount(EventListener var0) {
      if (var0 instanceof EventMulticaster) {
         EventMulticaster var1 = (EventMulticaster)var0;
         return getListenerCount(var1.a) + getListenerCount(var1.b);
      } else {
         return var0 == null ? 0 : 1;
      }
   }

   private static int populateListenerArray(EventListener[] var0, EventListener var1, int var2) {
      if (var1 instanceof EventMulticaster) {
         EventMulticaster var3 = (EventMulticaster)var1;
         int var4 = populateListenerArray(var0, var3.a, var2);
         return populateListenerArray(var0, var3.b, var4);
      } else if (var1 != null) {
         var0[var2] = var1;
         return var2 + 1;
      } else {
         return var2;
      }
   }

   public static EventListener[] getListeners(EventListener var0, Class var1) {
      int var2 = getListenerCount(var0);
      EventListener[] var3 = (EventListener[])Array.newInstance(var1, var2);
      populateListenerArray(var3, var0, 0);
      return var3;
   }
}
