package sun.plugin.usability;

import java.security.AccessController;
import java.util.logging.Level;
import java.util.logging.Logger;
import sun.security.action.GetBooleanAction;

public class PluginLogger {
   private static Logger logger = null;
   private static boolean logOn = false;
   private static boolean loggerInit = false;

   private static synchronized void initLogger() {
      if (!loggerInit && logOn) {
         loggerInit = true;
         logger = AccessController.doPrivileged(new PluginLogger$1());
      }
   }

   public static void setLogging(boolean var0) {
      logOn = var0;
      initLogger();
   }

   public static boolean getLogging() {
      return logOn;
   }

   private static Logger getLogger() {
      initLogger();
      return logOn ? logger : null;
   }

   public static void log(String var0) {
      Logger var1 = getLogger();
      if (var1 != null) {
         var1.log(Level.INFO, var0);
      }
   }

   public static void logException(Throwable var0) {
      logException("THROW", var0);
   }

   public static void logException(String var0, Throwable var1) {
      Logger var2 = getLogger();
      if (var2 != null) {
         var2.log(Level.FINER, var0, var1);
      }
   }

   static {
      try {
         logOn = AccessController.doPrivileged(new GetBooleanAction("javaplugin.logging"));
         initLogger();
      } catch (Throwable var1) {
         Trace.printException(var1);
      }
   }
}
