package sun.plugin.usability;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.Toolkit;
import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JProgressBar;
import sun.plugin.resources.ResourceHandler;

public class ProgressDialog extends JFrame {
   private long upTime = 0L;
   private long minTime = 2000L;
   private JLabel fileLabel;
   private JProgressBar progressBar;
   private JLabel progressLabel;
   private String percentStr;
   private String titleStr;
   private String filename;
   private String labelStr;
   private boolean iconified = false;

   public void init(String var1) {
      this.filename = var1;
      this.titleStr = ResourceHandler.getMessage("progress_dialog.downloading");
      if (var1.lastIndexOf(47) != -1) {
         this.filename = var1.substring(var1.lastIndexOf(47) + 1);
      }

      if (var1.lastIndexOf(":/") != -1) {
         String var2 = var1.trim().substring(0, var1.lastIndexOf(":/"));
         String var3 = var2.substring(var2.lastIndexOf(58) + 1);
         if (!var3.equals("http") && !var3.equals("https")) {
            if (var3.trim().equals("file")) {
               var2 = var1.substring(var1.lastIndexOf(":/") + 2);
               var2 = var2.substring(0, var2.indexOf(47));
               this.labelStr = this.filename + " " + ResourceHandler.getMessage("progress_dialog.from") + " " + var3 + ":/" + var2 + "/";
            }
         } else {
            var2 = var1.substring(var1.lastIndexOf("://") + 3);
            var2 = var2.substring(0, var2.indexOf(47));
            this.labelStr = this.filename + " " + ResourceHandler.getMessage("progress_dialog.from") + " " + var3 + "://" + var2 + "/";
         }
      }

      if (this.labelStr == null) {
         this.labelStr = this.filename;
      }

      this.createComponents();
   }

   private void createComponents() {
      JPanel var1 = new JPanel();
      var1.setLayout(new BoxLayout(var1, 1));
      var1.add(Box.createGlue());
      Dimension var2 = new Dimension(1, 5);
      var1.add(Box.createRigidArea(var2));
      this.fileLabel = new JLabel(this.labelStr);
      JPanel var3 = new JPanel();
      var3.setLayout(new BoxLayout(var3, 0));
      var3.add(this.fileLabel);
      var3.add(Box.createGlue());
      var1.add(var3);
      var1.add(Box.createRigidArea(var2));
      this.progressBar = new JProgressBar();
      this.progressBar.setStringPainted(true);
      this.progressBar.setForeground(new Color(153, 153, 204));
      var1.add(this.progressBar);
      var1.add(Box.createGlue());
      JButton var4 = new JButton(ResourceHandler.getMessage("progress_dialog.dismiss_button"));
      var4.setMnemonic(var4.getText().charAt(0));
      var4.addActionListener(new ProgressDialog$1(this));
      JPanel var5 = new JPanel();
      var5.setLayout(new BoxLayout(var5, 0));
      var5.add(Box.createGlue());
      var5.add(var4);
      var5.add(Box.createGlue());
      var1.add(var5);
      var1.add(Box.createRigidArea(var2));
      JPanel var6 = new JPanel();
      var6.setLayout(new BoxLayout(var6, 0));
      var6.add(Box.createRigidArea(new Dimension(20, 1)));
      var6.add(var1);
      var6.add(Box.createRigidArea(new Dimension(20, 1)));
      this.setContentPane(var6);
      this.setTitle(this.titleStr);
      this.setSize(500, 150);
      this.setResizable(false);
      this.addWindowListener(new ProgressDialog$2(this));
      Dimension var7 = Toolkit.getDefaultToolkit().getScreenSize();
      Dimension var8 = this.getSize();
      this.setLocation((var7.width - var8.width) / 2, (var7.height - var8.height) / 2);
      this.setVisible(true);
      this.upTime = System.currentTimeMillis();
   }

   public void addBytes(int var1) {
      this.progressBar.setValue(var1);
      if (this.iconified) {
         this.percentStr = this.progressBar.getString();
         this.setTitle("(" + this.percentStr + ") - " + this.filename);
      }
   }

   public void setTotal(int var1) {
      this.progressBar.setMaximum(var1);
   }

   public void close() {
      this.progressBar.setValue(this.progressBar.getMaximum());

      while (System.currentTimeMillis() - this.upTime < this.minTime) {
         try {
            Thread.sleep(100L);
         } catch (InterruptedException var2) {
         }
      }

      this.setVisible(false);
   }

   public void reopen() {
      this.setVisible(true);
      this.progressBar.setValue(1);
      this.upTime = System.currentTimeMillis();
   }
}
