package sun.plugin.usability;

import java.util.HashMap;
import sun.plugin.resources.ResourceHandler;

public class ProgressTracker {
   private static HashMap threadGroups = new HashMap();

   public static void onStartBinding(Object var0) {
      Thread var1 = Thread.currentThread();
      ThreadGroup var2 = var1.getThreadGroup();
      ProgressListener var3 = null;
      HashMap var4 = threadGroups;
      synchronized (var4) {
         var3 = (ProgressListener)threadGroups.get(new Integer(var2.hashCode()));
      }

      if (var3 != null) {
         var3.onStartBinding(var0);
      }
   }

   public static void onStopBinding(Object var0) {
      Thread var1 = Thread.currentThread();
      ThreadGroup var2 = var1.getThreadGroup();
      ProgressListener var3 = null;
      HashMap var4 = threadGroups;
      synchronized (var4) {
         var3 = (ProgressListener)threadGroups.get(new Integer(var2.hashCode()));
      }

      if (var3 != null) {
         var3.onStopBinding(var0);
      }
   }

   public static void onProgressComplete(Object var0) {
      Thread var1 = Thread.currentThread();
      ThreadGroup var2 = var1.getThreadGroup();
      ProgressListener var3 = null;
      HashMap var4 = threadGroups;
      synchronized (var4) {
         var3 = (ProgressListener)threadGroups.get(new Integer(var2.hashCode()));
      }

      if (var3 != null) {
         var3.onProgressComplete(var0);
      }
   }

   public static void onProgressAvailable(Object var0, int var1, int var2) {
      Thread var3 = Thread.currentThread();
      ThreadGroup var4 = var3.getThreadGroup();
      ProgressListener var5 = null;
      HashMap var6 = threadGroups;
      synchronized (var6) {
         var5 = (ProgressListener)threadGroups.get(new Integer(var4.hashCode()));
      }

      if (var5 != null) {
         var5.onProgressAvailable(var0, var1, var2);
      }
   }

   public static void addProgressListener(ThreadGroup var0, ProgressListener var1) {
      Trace.println(ResourceHandler.getMessage("progress.listener.added") + var1, 2);
      HashMap var2 = threadGroups;
      synchronized (var2) {
         ProgressListener var3 = (ProgressListener)threadGroups.get(new Integer(var0.hashCode()));
         var3 = EventMulticaster.add(var3, var1);
         threadGroups.put(new Integer(var0.hashCode()), var3);
      }
   }

   public static void removeProgressListener(ThreadGroup var0, ProgressListener var1) {
      Trace.println(ResourceHandler.getMessage("progress.listener.removed") + var1, 2);
      HashMap var2 = threadGroups;
      synchronized (var2) {
         ProgressListener var3 = (ProgressListener)threadGroups.get(new Integer(var0.hashCode()));
         var3 = EventMulticaster.remove(var3, var1);
         if (var3 != null) {
            threadGroups.put(new Integer(var0.hashCode()), var3);
         } else {
            threadGroups.remove(new Integer(var0.hashCode()));
         }
      }
   }
}
