package sun.plugin.usability;

import java.io.File;
import java.security.AccessController;
import java.util.Date;
import sun.security.action.GetPropertyAction;

public class UserProfile {
   static String homeDir = null;
   static String userName = null;
   static String filesPath = null;
   static String noDotVersion = null;
   static String version = null;
   static String javaHome = null;
   static boolean overWrite = true;
   static String sep = File.separator;

   static String getReplacableFile(String var0) {
      String var1 = ".plugin" + noDotVersion;
      if (!overWrite) {
         var1 = var1 + userName + new Date().hashCode();
      }

      var1 = var1 + var0;
      return filesPath + sep + var1;
   }

   static String getNonReplacableFile(String var0) {
      return homeDir + sep + ".java" + sep + var0 + noDotVersion;
   }

   static String getNewCacheDir(String var0) {
      return getCommonCacheDir() + sep + var0;
   }

   public static String getCommonCacheDir() {
      String var0 = null;
      var0 = AccessController.doPrivileged(new GetPropertyAction("javaplugin.cache.directory"));
      if (var0 == null || var0.equalsIgnoreCase("")) {
         var0 = homeDir + sep + ".jpi_cache";
      }

      return var0;
   }

   public static String getHomeDir() {
      return homeDir;
   }

   public static String getJavaHome() {
      return javaHome;
   }

   public static String getTraceFile() {
      return getReplacableFile(".trace");
   }

   public static String getLogFile() {
      return getReplacableFile(".log");
   }

   public static String getPropertyFile() {
      return getNonReplacableFile("properties");
   }

   public static String getCertificateFile() {
      return getNonReplacableFile("jpicerts");
   }

   public static String getHttpsCertificateFile() {
      return getNonReplacableFile("jpihttpscerts");
   }

   public static String getNewJarCacheDir() {
      return getNewCacheDir("jar") + sep + "1.0";
   }

   public static String getNewFileCacheDir() {
      return getNewCacheDir("file") + sep + "1.0";
   }

   public static String getExtInstallDir() {
      return getNewCacheDir("ext") + sep + "1.0";
   }

   public static String getRootCertificateFile() {
      return javaHome + sep + "lib" + sep + "security" + sep + "cacerts";
   }

   public static String getHttpsRootCertFile() {
      return javaHome + sep + "lib" + sep + "security" + sep + "jssecacerts";
   }

   public static String getAppletViewerPropertyFile() {
      return javaHome + sep + "lib" + sep + "appletviewer.properties";
   }

   public static String getHTMLCacheDir() {
      return getNewCacheDir("html") + sep + "1.0";
   }

   static String getCacheDir(String var0) {
      return homeDir + sep + "java_plugin_AppletStore" + sep + version + sep + var0;
   }

   public static String getJarCacheDir() {
      return getCacheDir("jar") + sep + "legacy";
   }

   public static String getJarCacheTableFile() {
      return getJarCacheDir() + sep + "jarcache.table";
   }

   public static String getHTMLCacheTableFile() {
      return getHTMLCacheDir() + sep + "version.table";
   }

   static {
      homeDir = AccessController.doPrivileged(new GetPropertyAction("javaplugin.user.profile"));
      if (homeDir == null || homeDir.equalsIgnoreCase("")) {
         homeDir = AccessController.doPrivileged(new GetPropertyAction("user.home"));
      }

      String var0 = AccessController.doPrivileged(new GetPropertyAction("javaplugin.outputfiles.overwrite"));
      if (var0 != null && var0.equalsIgnoreCase("false")) {
         userName = AccessController.doPrivileged(new GetPropertyAction("user.name"));
         overWrite = false;
      }

      filesPath = AccessController.doPrivileged(new GetPropertyAction("javaplugin.outputfiles.path"));
      if (filesPath == null || filesPath.equalsIgnoreCase("")) {
         filesPath = homeDir;
      }

      version = AccessController.doPrivileged(new GetPropertyAction("javaplugin.version"));
      noDotVersion = AccessController.doPrivileged(new GetPropertyAction("javaplugin.nodotversion"));
      javaHome = AccessController.doPrivileged(new GetPropertyAction("java.home"));
   }
}
