package sun.plugin.viewer;

import java.applet.Applet;
import java.awt.Component;
import java.awt.Frame;
import sun.plugin.AppletViewer;
import sun.plugin.BeansApplet;
import sun.plugin.BeansViewer;
import sun.plugin.services.BrowserService;
import sun.plugin.services.ServiceProvider;
import sun.plugin.viewer.context.IExplorerAppletContext;
import sun.plugin.viewer.context.PluginAppletContext;
import sun.plugin.viewer.context.PluginBeansContext;
import sun.plugin.viewer.frame.IExplorerEmbeddedFrame;

public class IExplorerPluginObject {
   private IExplorerEmbeddedFrame frame = null;
   protected AppletViewer panel = null;
   protected int id = -1;
   private int handle = 0;
   private int width = 0;
   private int height = 0;
   private String identifier = null;
   private boolean bFrameReady = false;
   private boolean bContainerReady = false;
   private boolean bInit = false;

   IExplorerPluginObject(int var1, boolean var2, String var3) {
      this.id = var1;
      this.identifier = var3;
      this.panel = LifeCycleManager.getAppletPanel(var3);
      if (!var2) {
         if (this.panel == null) {
            this.panel = new AppletViewer();
         }

         PluginAppletContext var4 = (PluginAppletContext)this.panel.getAppletContext();
         if (var4 == null) {
            BrowserService var5 = ServiceProvider.getService();
            var4 = var5.getAppletContext();
         }

         var4.setAppletContextHandle(var1);
         this.panel.setAppletContext(var4);
      } else {
         if (this.panel == null) {
            this.panel = new BeansViewer();
         }

         PluginBeansContext var6 = (PluginBeansContext)this.panel.getAppletContext();
         if (var6 == null) {
            BrowserService var7 = ServiceProvider.getService();
            var6 = var7.getBeansContext();
         }

         var6.setAppletContextHandle(var1);
         this.panel.setAppletContext(var6);
      }
   }

   public IExplorerEmbeddedFrame createFrame(int var1) {
      IExplorerEmbeddedFrame var2 = new IExplorerEmbeddedFrame(var1, this);
      var2.setBean(this.panel);
      return var2;
   }

   private synchronized void initPlugin() {
      if (!$assertionsDisabled && this.panel == null) {
         throw new AssertionError();
      } else {
         this.panel.addAppletStatusListener(new IExplorerAppletStatusListener(this.id));
         new IExplorerPluginObject.Initer(this.panel, this).start();
      }
   }

   public void destroyPlugin() {
      if (!$assertionsDisabled && this.panel == null) {
         throw new AssertionError();
      } else {
         if (this.bInit) {
            PluginAppletContext var1 = (PluginAppletContext)this.panel.getAppletContext();
            LifeCycleManager.stopAppletPanel(this.panel);
            LifeCycleManager.destroyAppletPanel(this.identifier, this.panel);
            this.panel.removeAppletStatusListener(null);
            ((IExplorerAppletContext)var1).onClose();
            if (var1 != null) {
               var1.setAppletContextHandle(0);
            }
         }
      }
   }

   public void mayInit() {
      if (this.bFrameReady && this.bContainerReady && !this.bInit) {
         this.bInit = true;
         this.initPlugin();
      }
   }

   public void containerReady() {
      this.bContainerReady = true;
      this.mayInit();
   }

   public void frameReady() {
      this.bFrameReady = true;
      this.mayInit();
   }

   public AppletViewer getPanel() {
      return this.panel;
   }

   private Frame getFrame() {
      return this.frame;
   }

   void setFocus() {
      if (this.frame != null) {
         this.frame.requestFocus();
      }
   }

   void setFrameSize(int var1, int var2) {
      synchronized (this) {
         this.setParameter("width", new Integer(var1));
         this.setParameter("height", new Integer(var2));
         if (this.frame != null) {
            this.frame.setSize(var1, var2);
         }

         if (this.panel != null) {
            AppletViewer var4 = this.panel;
            if (var4 != null) {
               var4.setSize(var1, var2);
               this.panel.setParameter("width", new Integer(var1));
               this.panel.setParameter("height", new Integer(var2));
            }

            Object var5 = this.panel.getViewedObject();
            if (var5 != null) {
               Applet var6;
               if (var5 instanceof Applet) {
                  var6 = (Applet)var5;
               } else {
                  Component var7 = (Component)var5;
                  var7.setSize(var1, var2);
                  var6 = (Applet)var7.getParent();
               }

               if (var6 != null) {
                  var6.resize(var1, var2);
               }
            }
         }
      }
   }

   public Object getJavaObject() {
      Object var1 = null;
      if (this.panel != null) {
         var1 = this.panel.getViewedObject();
      }

      if (var1 instanceof BeansApplet) {
         BeansApplet var2 = (BeansApplet)var1;
         var1 = var2.getBean();
      }

      return var1;
   }

   int getLoadingStatus() {
      return this.panel != null ? this.panel.getLoadingStatus() : 7;
   }

   public String getParameter(String var1) {
      if (!$assertionsDisabled && this.panel == null) {
         throw new AssertionError();
      } else {
         return this.panel.getParameter(var1);
      }
   }

   public void setParameter(String var1, Object var2) {
      if (!$assertionsDisabled && this.panel == null) {
         throw new AssertionError();
      } else {
         this.panel.setParameter(var1, var2);
      }
   }

   private class Initer extends Thread {
      AppletViewer that;
      IExplorerPluginObject obj;

      Initer(AppletViewer var2, IExplorerPluginObject var3) {
         this.that = var2;
         this.obj = var3;
      }

      public void run() {
         LifeCycleManager.initAppletPanel(this.that);
         LifeCycleManager.startAppletPanel(this.that);
      }
   }
}
