package sun.plugin.viewer;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.LinkedHashMap;
import java.util.Set;
import sun.plugin.AppletViewer;
import sun.plugin.resources.ResourceHandler;
import sun.plugin.usability.Trace;

public class LifeCycleManager {
   private static LinkedHashMap appletPanels = new LinkedHashMap();

   public static AppletViewer getAppletPanel(String var0) {
      AppletViewer var1 = null;
      LinkedHashMap var2 = appletPanels;
      synchronized (var2) {
         var1 = (AppletViewer)appletPanels.remove(var0);
      }

      if (var1 != null) {
         Trace.println(ResourceHandler.getMessage("lifecycle.applet.found"));
      }

      return var1;
   }

   private static void add(String var0, AppletViewer var1) {
      ArrayList var2 = new ArrayList();
      LinkedHashMap var3 = appletPanels;
      synchronized (var3) {
         int var4 = appletPanels.size() - Integer.getInteger("javaplugin.lifecycle.cachesize", 1);
         if (var4 < 0) {
            var4 = 0;
         }

         Set var5 = appletPanels.keySet();
         Iterator var6 = var5.iterator();

         for (int var7 = 0; var7 < var4 && var6.hasNext(); var7++) {
            String var8 = (String)var6.next();
            var2.add(appletPanels.remove(var8));
         }

         appletPanels.put(var0, var1);
      }

      if (var2.size() > 0) {
         Trace.println(ResourceHandler.getMessage("lifecycle.applet.cachefull"));
      }

      for (AppletViewer var12 : var2) {
         var12.appletDestroy();
      }

      var2.clear();
   }

   public static String getIdentifier(String[] var0, String[] var1) {
      StringBuffer var2 = new StringBuffer();

      for (int var3 = 0; var3 < var0.length; var3++) {
         if (var0[var3] != null) {
            var2.append("<NAME=");
            var2.append(var0[var3]);
            var2.append(" VALUE=");
            var2.append(var1[var3]);
            var2.append(">");
         }
      }

      return var2.toString();
   }

   public static void initAppletPanel(AppletViewer var0) {
      if (var0.getLoadingStatus() != 2) {
         var0.appletInit();
      }
   }

   public static void startAppletPanel(AppletViewer var0) {
      var0.appletStart();
   }

   public static void stopAppletPanel(AppletViewer var0) {
      var0.appletStop();
   }

   public static void destroyAppletPanel(String var0, AppletViewer var1) {
      if (var1.isLegacyLifeCycle()) {
         Trace.println(ResourceHandler.getMessage("lifecycle.applet.support"));
         add(var0, var1);
      } else {
         var1.appletDestroy();
      }
   }
}
