package sun.plugin.viewer;

import java.applet.Applet;
import java.awt.Component;
import java.awt.EventQueue;
import java.awt.Frame;
import java.awt.event.WindowEvent;
import sun.plugin.AppletViewer;
import sun.plugin.BeansApplet;
import sun.plugin.BeansViewer;
import sun.plugin.services.BrowserService;
import sun.plugin.services.ServiceProvider;
import sun.plugin.usability.Trace;
import sun.plugin.viewer.context.PluginAppletContext;
import sun.plugin.viewer.context.PluginBeansContext;
import sun.plugin.viewer.frame.WNetscapeEmbeddedFrame;

public class WNetscapePluginObject {
   private WNetscapeEmbeddedFrame frame = null;
   protected AppletViewer panel = null;
   protected int id = -1;
   private int handle = 0;
   private int width = 0;
   private int height = 0;
   private String identifier = null;
   private int startCount = -1;
   private boolean initialized = false;

   WNetscapePluginObject(int var1, boolean var2, String var3) {
      this.id = var1;
      this.identifier = var3;
      this.panel = LifeCycleManager.getAppletPanel(var3);
      if (!var2) {
         if (this.panel == null) {
            this.panel = new AppletViewer();
         }

         PluginAppletContext var4 = (PluginAppletContext)this.panel.getAppletContext();
         if (var4 == null) {
            BrowserService var5 = ServiceProvider.getService();
            var4 = var5.getAppletContext();
         }

         var4.setAppletContextHandle(var1);
         this.panel.setAppletContext(var4);
      } else {
         if (this.panel == null) {
            this.panel = new BeansViewer();
         }

         PluginBeansContext var6 = (PluginBeansContext)this.panel.getAppletContext();
         if (var6 == null) {
            BrowserService var7 = ServiceProvider.getService();
            var6 = var7.getBeansContext();
         }

         var6.setAppletContextHandle(var1);
         this.panel.setAppletContext(var6);
      }
   }

   private WNetscapeEmbeddedFrame createFrame(int var1) {
      WNetscapeEmbeddedFrame var2 = new WNetscapeEmbeddedFrame(var1);
      var2.setJavaObject(this);
      return var2;
   }

   synchronized Frame setWindow(int var1, int var2, int var3, int var4) {
      if (this.handle == var1) {
         return this.frame;
      } else {
         if (this.frame != null) {
            WNetscapeEmbeddedFrame var5 = this.frame;

            try {
               this.frame.setVisible(false);
               this.frame.setEnabled(false);
            } catch (Throwable var11) {
            }

            this.frame.setWaitingEvent(var2);
            WindowEvent var6 = new WindowEvent(this.frame, 201);
            EventQueue var7 = this.frame.getToolkit().getSystemEventQueue();
            var7.postEvent(var6);
            this.frame.waitEvent(var2);
            this.frame.setWaitingEvent(0);
         }

         this.frame = null;
         this.handle = var1;
         if (var1 != 0) {
            try {
               this.width = Integer.parseInt(this.getParameter("width"));
               this.height = Integer.parseInt(this.getParameter("height"));
            } catch (NumberFormatException var9) {
               this.setParameter("width", new Integer(var3));
               this.setParameter("height", new Integer(var4));
               this.width = var3;
               this.height = var4;
            } catch (Throwable var10) {
               Trace.printException(var10);
            }

            this.frame = this.createFrame(var1);

            try {
               WNetscapeEmbeddedFrame var12 = this.frame;
               int var13 = this.width;
               int var14 = this.height;
               var12.setSize(var13, var14);
               var12.setVisible(true);
               var12.setEnabled(true);
            } catch (Exception var8) {
            }

            this.initPlugin();
         }

         return this.frame;
      }
   }

   private synchronized void initPlugin() {
      if (!$assertionsDisabled && this.panel == null) {
         throw new AssertionError();
      } else {
         if (this.frame != null) {
            try {
               WNetscapeEmbeddedFrame var1 = this.frame;
               var1.add(this.panel);
               var1.setVisible(true);
            } catch (Exception var2) {
            }

            if (!this.initialized) {
               this.initialized = true;
               new WNetscapePluginObject.Initer(this.panel, this).start();
            }
         }
      }
   }

   synchronized void startPlugin() {
      if (!$assertionsDisabled && this.panel == null) {
         throw new AssertionError();
      } else {
         if (this.initialized) {
            LifeCycleManager.startAppletPanel(this.panel);
         } else {
            if (this.startCount < 0) {
               this.startCount = 0;
            }

            this.startCount++;
         }
      }
   }

   synchronized void stopPlugin() {
      if (!$assertionsDisabled && this.panel == null) {
         throw new AssertionError();
      } else {
         if (this.initialized) {
            LifeCycleManager.stopAppletPanel(this.panel);
         } else {
            this.startCount--;
         }
      }
   }

   void destroyPlugin() {
      this.destroyPlugin(0);
   }

   synchronized void destroyPlugin(int var1) {
      if (!$assertionsDisabled && this.panel == null) {
         throw new AssertionError();
      } else {
         if (this.frame != null) {
            try {
               WNetscapeEmbeddedFrame var2 = this.frame;
               this.frame.setVisible(false);
               this.frame.setEnabled(false);
            } catch (Exception var4) {
            }

            this.frame.setWaitingEvent(var1);
            WindowEvent var5 = new WindowEvent(this.frame, 201);
            EventQueue var3 = this.frame.getToolkit().getSystemEventQueue();
            var3.postEvent(var5);
            this.frame.waitEvent(var1);
            this.frame.setWaitingEvent(0);
         }

         PluginAppletContext var6 = (PluginAppletContext)this.panel.getAppletContext();
         LifeCycleManager.destroyAppletPanel(this.identifier, this.panel);
         if (var6 != null) {
            var6.setAppletContextHandle(-1);
         }

         this.panel = null;
         this.frame = null;
      }
   }

   synchronized void setDocumentURL(String var1) {
      if (!$assertionsDisabled && this.panel == null) {
         throw new AssertionError();
      } else {
         try {
            this.notifyAll();
            this.panel.setDocumentBase(var1);
            this.initPlugin();
         } catch (Throwable var3) {
            Trace.printException(var3);
         }
      }
   }

   private Frame getFrame() {
      return this.frame;
   }

   void setFocus() {
      if (this.frame != null) {
         this.frame.requestFocus();
      }
   }

   void setFrameSize(int var1, int var2) {
      synchronized (this) {
         this.setParameter("width", new Integer(var1));
         this.setParameter("height", new Integer(var2));
         if (this.frame != null) {
            this.frame.setSize(var1, var2);
         }

         if (this.panel != null) {
            AppletViewer var4 = this.panel;
            if (var4 != null) {
               var4.setSize(var1, var2);
               this.panel.setParameter("width", new Integer(var1));
               this.panel.setParameter("height", new Integer(var2));
            }

            Object var5 = this.panel.getViewedObject();
            if (var5 != null) {
               Applet var6;
               if (var5 instanceof Applet) {
                  var6 = (Applet)var5;
               } else {
                  Component var7 = (Component)var5;
                  var7.setSize(var1, var2);
                  var6 = (Applet)var7.getParent();
               }

               if (var6 != null) {
                  var6.resize(var1, var2);
               }
            }
         }
      }
   }

   public Object getJavaObject() {
      Object var1 = null;
      if (this.panel != null) {
         var1 = this.panel.getViewedObject();
      }

      if (var1 instanceof BeansApplet) {
         BeansApplet var2 = (BeansApplet)var1;
         var1 = var2.getBean();
      }

      return var1;
   }

   int getLoadingStatus() {
      return this.panel != null ? this.panel.getLoadingStatus() : 7;
   }

   public String getParameter(String var1) {
      if (!$assertionsDisabled && this.panel == null) {
         throw new AssertionError();
      } else {
         return this.panel.getParameter(var1);
      }
   }

   public void setParameter(String var1, Object var2) {
      if (!$assertionsDisabled && this.panel == null) {
         throw new AssertionError();
      } else {
         this.panel.setParameter(var1, var2);
      }
   }

   public void setBoxColors() {
      this.panel.setColorAndText();
   }

   private class Initer extends Thread {
      AppletViewer that;
      WNetscapePluginObject obj;

      Initer(AppletViewer var2, WNetscapePluginObject var3) {
         this.that = var2;
         this.obj = var3;
      }

      public void run() {
         LifeCycleManager.initAppletPanel(this.that);
         WNetscapePluginObject var1 = this.obj;
         synchronized (var1) {
            this.obj.initialized = true;
            if (this.obj.startCount > 0) {
               this.obj.startCount = 0;
               this.obj.startPlugin();
            } else if (this.obj.startCount == 0) {
               this.obj.startPlugin();
               this.obj.stopPlugin();
            }
         }
      }
   }
}
