package sun.plugin.viewer.context;

import java.lang.ref.SoftReference;
import java.net.URL;
import java.util.ArrayList;
import sun.plugin.javascript.ocx.JSObject;

public class IExplorerAppletContext extends DefaultPluginAppletContext {
   private int handle;
   private ArrayList exported = new ArrayList();

   public IExplorerAppletContext() {
      this.handle = 0;
   }

   public void setAppletContextHandle(int var1) {
      this.handle = var1;
   }

   public void doShowDocument(URL var1, String var2) {
      if (this.handle >= 0) {
         this.nativeShowDocument(this.handle, var1.toString(), var2);
      }
   }

   public void doShowStatus(String var1) {
      if (this.handle >= 0) {
         this.nativeShowStatus(this.handle, var1);
      }
   }

   private native void nativeShowDocument(int var1, String var2, String var3);

   private native void nativeShowStatus(int var1, String var2);

   public void onClose() {
      this.handle = 0;
      ArrayList var1 = this.exported;
      synchronized (var1) {
         for (SoftReference var3 : this.exported) {
            if (var3 != null) {
               JSObject var4 = (JSObject)var3.get();
               if (var4 != null) {
                  var4.cleanup();
               }
            }
         }

         this.exported.clear();
      }
   }

   public native netscape.javascript.JSObject getJSObject();

   public void addJSObjectToExportedList(netscape.javascript.JSObject var1) {
      ArrayList var2 = this.exported;
      synchronized (var2) {
         this.exported.add(new SoftReference<>(var1));
      }
   }
}
