package sun.plugin.viewer.frame;

import java.applet.Applet;
import java.awt.BorderLayout;
import java.awt.Component;
import java.awt.Dimension;
import java.awt.EventQueue;
import java.awt.event.WindowEvent;
import java.awt.event.WindowListener;
import java.beans.Beans;
import sun.awt.windows.ModalityEvent;
import sun.awt.windows.ModalityListener;
import sun.awt.windows.WEmbeddedFrame;
import sun.awt.windows.WToolkit;
import sun.plugin.AppletViewer;
import sun.plugin.SystemEventQueueUtilities;
import sun.plugin.resources.ResourceHandler;
import sun.plugin.usability.Trace;
import sun.plugin.viewer.IExplorerPluginObject;

public class IExplorerEmbeddedFrame extends WEmbeddedFrame implements WindowListener, ModalityListener {
   private int waitingEvent = 0;
   private IExplorerPluginObject pluginObj = null;
   private Component c;
   private int handle = 0;

   public IExplorerEmbeddedFrame(int var1, IExplorerPluginObject var2) {
      super(var1);
      this.handle = var1;
      this.pluginObj = var2;
      this.setLayout(new BorderLayout());
      this.addWindowListener(this);
      WToolkit.getWToolkit().addModalityListener(this);
      Trace.println(ResourceHandler.getMessage("modality.register"), 2);
   }

   public void setComponent(Component var1) {
      if (var1 != null) {
         Dimension var2 = var1.getSize();
         this.add(var1);
         if (var2.width != 0 && var2.height != 0) {
            this.setSize(var2);
         }

         if (Beans.isInstanceOf(var1, class$java$applet$Applet == null ? (class$java$applet$Applet = class$("java.applet.Applet")) : class$java$applet$Applet)) {
            Applet var3 = (Applet)Beans.getInstanceOf(
               var1, class$java$applet$Applet == null ? (class$java$applet$Applet = class$("java.applet.Applet")) : class$java$applet$Applet
            );
            var3.start();
         }

         var1.requestFocus();
      }
   }

   public void setBean(Object var1) {
      try {
         SystemEventQueueUtilities.invokeAndWait(new IExplorerEmbeddedFrame$1(this, var1));
      } catch (Exception var3) {
         System.out.println("Failed to setBean() : ");
         var3.printStackTrace();
      }
   }

   public void destroy(int var1) {
      try {
         SystemEventQueueUtilities.invokeAndWait(new IExplorerEmbeddedFrame$2(this));
      } catch (Throwable var4) {
      }

      this.setWaitingEvent(var1);
      WindowEvent var2 = new WindowEvent(this, 201);
      EventQueue var3 = this.getToolkit().getSystemEventQueue();
      var3.postEvent(var2);
      this.waitEvent(var1);
      this.setWaitingEvent(0);
   }

   public void setFrameSize(int var1, int var2) {
      if (var1 > 0 && var2 > 0) {
         try {
            synchronized (this) {
               if (this.c instanceof AppletViewer) {
                  AppletViewer var4 = (AppletViewer)this.c;
                  var4.setParameter("width", Integer.toString(var1));
                  var4.setParameter("height", Integer.toString(var2));
               }
            }

            SystemEventQueueUtilities.invokeAndWait(new IExplorerEmbeddedFrame$3(this, var1, var2));
            this.pluginObj.frameReady();
         } catch (Throwable var7) {
         }
      }
   }

   public Dimension getPreferredSize() {
      return this.c != null ? this.c.getPreferredSize() : null;
   }

   public void requestFocus() {
      WindowEvent var1 = new WindowEvent(this, 205);
      EventQueue var2 = this.getToolkit().getSystemEventQueue();
      var2.postEvent(var1);
      if (this.c instanceof AppletViewer) {
         Applet var3 = ((AppletViewer)this.c).getApplet();
         if (var3 != null) {
            var3.requestFocus();
         }
      }
   }

   public void windowActivated(WindowEvent var1) {
   }

   public void windowClosed(WindowEvent var1) {
   }

   public void windowClosing(WindowEvent var1) {
      try {
         this.removeWindowListener(this);
         WToolkit.getWToolkit().removeModalityListener(this);
         Trace.println(ResourceHandler.getMessage("modality.unregister"), 2);
         this.removeAll();
         this.dispose();
         this.c = null;
         this.handle = 0;
         if (this.waitingEvent != 0) {
            this.setEvent(this.waitingEvent);
         }
      } catch (Throwable var3) {
         var3.printStackTrace();
      }
   }

   public void windowDeactivated(WindowEvent var1) {
   }

   public void windowDeiconified(WindowEvent var1) {
   }

   public void windowIconified(WindowEvent var1) {
   }

   public void windowOpened(WindowEvent var1) {
   }

   public void modalityPushed(ModalityEvent var1) {
      Trace.println(ResourceHandler.getMessage("modality.pushed"), 2);
      this.enableModeless(this.handle, false);
   }

   public void modalityPopped(ModalityEvent var1) {
      Trace.println(ResourceHandler.getMessage("modality.popped"), 2);
      this.enableModeless(this.handle, true);
   }

   private native void enableModeless(int var1, boolean var2);

   public native void setEvent(int var1);

   public native void waitEvent(int var1);

   public void setWaitingEvent(int var1) {
      this.waitingEvent = var1;
   }
}
