package sun.plugin.viewer.frame;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Component;
import java.awt.EventQueue;
import java.awt.event.WindowEvent;
import java.awt.event.WindowListener;
import sun.awt.windows.ModalityEvent;
import sun.awt.windows.ModalityListener;
import sun.awt.windows.WEmbeddedFrame;
import sun.awt.windows.WToolkit;
import sun.plugin.resources.ResourceHandler;
import sun.plugin.usability.Trace;
import sun.plugin.viewer.WNetscapePluginObject;

public class WNetscapeEmbeddedFrame extends WEmbeddedFrame implements WindowListener, ModalityListener {
   private int win_handle;
   private WNetscapePluginObject obj = null;
   private int handle;

   public WNetscapeEmbeddedFrame(int var1) {
      super(var1);
      this.win_handle = var1;
      this.setLayout(new BorderLayout());
      this.setBackground(Color.white);
      this.addWindowListener(this);
      WToolkit.getWToolkit().addModalityListener(this);
      Trace.println(ResourceHandler.getMessage("modality.register"), 2);
   }

   public void setJavaObject(WNetscapePluginObject var1) {
      this.obj = var1;
   }

   public void requestFocus() {
      WindowEvent var1 = new WindowEvent(this, 205);
      EventQueue var2 = this.getToolkit().getSystemEventQueue();
      var2.postEvent(var1);
      if (this.obj != null) {
         Component var3 = (Component)this.obj.getJavaObject();
         if (var3 != null) {
            var3.requestFocus();
         }
      } else {
         super.requestFocus();
      }
   }

   public void windowActivated(WindowEvent var1) {
   }

   public void windowClosed(WindowEvent var1) {
   }

   public void windowClosing(WindowEvent var1) {
      try {
         this.removeWindowListener(this);
         WToolkit.getWToolkit().removeModalityListener(this);
         Trace.println(ResourceHandler.getMessage("modality.unregister"), 2);
         this.removeAll();
         this.obj = null;
         this.dispose();
         if (this.handle != 0) {
            this.setEvent(this.handle);
         }
      } catch (Throwable var3) {
         Trace.printException(var3);
      }
   }

   public void windowDeactivated(WindowEvent var1) {
   }

   public void windowDeiconified(WindowEvent var1) {
   }

   public void windowIconified(WindowEvent var1) {
   }

   public void windowOpened(WindowEvent var1) {
   }

   public void setWaitingEvent(int var1) {
      this.handle = var1;
   }

   public native void setEvent(int var1);

   public native void waitEvent(int var1);

   public void modalityPushed(ModalityEvent var1) {
      Trace.println(ResourceHandler.getMessage("modality.pushed"), 2);
      this.enableModeless(this.win_handle, false);
   }

   public void modalityPopped(ModalityEvent var1) {
      Trace.println(ResourceHandler.getMessage("modality.popped"), 2);
      this.enableModeless(this.win_handle, true);
   }

   private native void enableModeless(int var1, boolean var2);
}
