package sunw.demo.classfile;

import java.io.DataOutputStream;
import java.io.IOException;

abstract class Attribute {
   static final String SOURCEFILE = "SourceFile";
   static final String CONSTANTVALUE = "ConstantValue";
   static final String LOCALVARIABLETABLE = "LocalVariableTable";
   static final String EXCEPTIONS = "Exceptions";
   static final String LINENUMBERTABLE = "LineNumberTable";
   static final String CODE = "Code";
   private UTF8Constant name;
   private ClassFile classFile;

   protected Attribute(String var1, ClassFile var2) {
      UTF8Constant var3 = new UTF8Constant(var1, var2);
      this.name = var3;
      this.classFile = var2;
   }

   ClassFile getClassFile() {
      return this.classFile;
   }

   String getName() {
      return this.name.getString();
   }

   short getNameConstantPoolIndex() {
      return this.name.getConstantPoolIndex();
   }

   abstract int getLength();

   abstract void write(DataOutputStream var1) throws IOException;

   public abstract boolean equals(Object var1);

   public abstract int hashCode();
}
