package sunw.demo.classfile;

import java.io.DataOutputStream;
import java.io.IOException;

class ClassConstant extends ConstantPoolEntry {
   private UTF8Constant name;

   ClassConstant(String var1, ClassFile var2) {
      super((byte)7, var2);
      this.name = var2.addUTF8Constant(ClassFile.fullyQualifiedForm(var1));
      this.addToConstantPool();
   }

   void write(DataOutputStream var1) throws IOException {
      if (ConstantPoolEntry.debug()) {
         System.err.println(this.getConstantPoolIndex() + " CLASS: " + this.name.getConstantPoolIndex());
      }

      var1.writeByte(this.getTag());
      var1.writeShort(this.name.getConstantPoolIndex());
   }

   String getClassName() {
      return this.name.getString();
   }

   Class getClassObject() throws ClassNotFoundException {
      return Class.forName(this.name.getString());
   }

   public boolean equals(Object var1) {
      if (var1 == null) {
         return false;
      } else if (var1 instanceof ClassConstant) {
         ClassConstant var2 = (ClassConstant)var1;
         return this.name.equals(var2.name);
      } else {
         return false;
      }
   }

   public int hashCode() {
      return this.name.getString().hashCode();
   }
}
