package sunw.demo.classfile;

import java.io.DataOutputStream;
import java.io.IOException;

class ConstantValue extends Attribute {
   private ConstantPoolEntry constant;

   private ConstantValue(ClassFile var1, ConstantPoolEntry var2) {
      super("ConstantValue", var1);
      this.constant = var2;
   }

   ConstantValue(ClassFile var1, IntegerConstant var2) {
      this(var1, (ConstantPoolEntry)var2);
   }

   ConstantValue(ClassFile var1, LongConstant var2) {
      this(var1, (ConstantPoolEntry)var2);
   }

   ConstantValue(ClassFile var1, FloatConstant var2) {
      this(var1, (ConstantPoolEntry)var2);
   }

   ConstantValue(ClassFile var1, DoubleConstant var2) {
      this(var1, (ConstantPoolEntry)var2);
   }

   ConstantValue(ClassFile var1, StringConstant var2) {
      this(var1, (ConstantPoolEntry)var2);
   }

   int getLength() {
      return 2;
   }

   ConstantPoolEntry getConstant() {
      return this.constant;
   }

   byte getConstantTag() {
      return this.constant.getTag();
   }

   void write(DataOutputStream var1) throws IOException {
      var1.writeShort(this.getNameConstantPoolIndex());
      var1.writeInt(this.getLength());
      var1.writeShort(this.constant.getConstantPoolIndex());
   }

   public boolean equals(Object var1) {
      return this.constant.equals(var1);
   }

   public int hashCode() {
      return this.constant.hashCode();
   }
}
