package sunw.demo.classfile;

import java.io.DataOutputStream;
import java.io.IOException;

class DoubleConstant extends ConstantPoolEntry {
   private double doubler;

   DoubleConstant(double var1, ClassFile var3) {
      super((byte)6, var3);
      this.doubler = var1;
      this.addToConstantPool();
   }

   void write(DataOutputStream var1) throws IOException {
      var1.writeByte(this.getTag());
      var1.writeDouble(this.doubler);
   }

   double getValue() {
      return this.doubler;
   }

   public boolean equals(Object var1) {
      if (var1 instanceof Double) {
         return this.doubler == (Double)var1;
      } else if (var1 instanceof DoubleConstant) {
         DoubleConstant var2 = (DoubleConstant)var1;
         return this.doubler == var2.getValue();
      } else {
         return false;
      }
   }

   public int hashCode() {
      return (int)this.doubler;
   }
}
