package sunw.demo.classfile;

import java.io.DataOutputStream;
import java.io.IOException;

final class FieldDesc {
   static final short ACC_PUBLIC = 1;
   static final short ACC_PRIVATE = 2;
   static final short ACC_PROTECTED = 4;
   static final short ACC_STATIC = 8;
   static final short ACC_FINAL = 16;
   static final short ACC_VOLATILE = 64;
   static final short ACC_TRANSIENT = 128;
   private UTF8Constant name;
   private UTF8Constant descriptor;
   private short accessFlags;
   private ClassFile classFile;
   private Attribute[] attributes;

   FieldDesc(String var1, String var2, short var3, ClassFile var4, Attribute[] var5) {
      this.name = var4.addUTF8Constant(var1);
      this.descriptor = var4.addUTF8Constant(var2);
      this.accessFlags = var3;
      this.classFile = var4;
      this.attributes = var5;
   }

   void write(DataOutputStream var1) throws IOException {
      var1.writeShort(this.accessFlags);
      var1.writeShort(this.name.getConstantPoolIndex());
      var1.writeShort(this.descriptor.getConstantPoolIndex());
      if (this.attributes != null && this.attributes.length == 0) {
         var1.writeShort(this.attributes.length);

         for (int var2 = 0; var2 < this.attributes.length; var2++) {
            this.attributes[var2].write(var1);
         }
      } else {
         var1.writeShort(0);
      }
   }
}
