package sunw.demo.classfile;

import java.io.DataOutputStream;
import java.io.IOException;

class IntegerConstant extends ConstantPoolEntry {
   private int integer;

   IntegerConstant(int var1, ClassFile var2) {
      super((byte)3, var2);
      this.integer = var1;
      this.addToConstantPool();
   }

   void write(DataOutputStream var1) throws IOException {
      var1.writeByte(this.getTag());
      var1.writeInt(this.integer);
   }

   int getValue() {
      return this.integer;
   }

   public boolean equals(Object var1) {
      if (var1 instanceof Integer) {
         return this.integer == (Integer)var1;
      } else if (var1 instanceof IntegerConstant) {
         IntegerConstant var2 = (IntegerConstant)var1;
         return this.integer == var2.getValue();
      } else {
         return false;
      }
   }

   public int hashCode() {
      return this.integer;
   }
}
