package sunw.demo.classfile;

import java.io.DataOutputStream;
import java.io.IOException;

class NameAndTypeConstant extends ConstantPoolEntry {
   private UTF8Constant name;
   private UTF8Constant desc;

   NameAndTypeConstant(String var1, String var2, ClassFile var3) {
      super((byte)12, var3);
      this.name = new UTF8Constant(var1, var3);
      this.desc = new UTF8Constant(var2, var3);
      this.addToConstantPool();
   }

   void write(DataOutputStream var1) throws IOException {
      if (ConstantPoolEntry.debug()) {
         System.err.println(this.getConstantPoolIndex() + " NAME: " + this.name.getConstantPoolIndex() + " TYPE: " + this.desc.getConstantPoolIndex());
      }

      var1.writeByte(this.getTag());
      var1.writeShort(this.name.getConstantPoolIndex());
      var1.writeShort(this.desc.getConstantPoolIndex());
   }

   String getName() {
      return this.name.getString();
   }

   String getDescriptor() {
      return this.desc.getString();
   }

   public boolean equals(Object var1) {
      if (!(var1 instanceof NameAndTypeConstant)) {
         return false;
      } else {
         NameAndTypeConstant var2 = (NameAndTypeConstant)var1;
         return this.name.equals(var2.name) && this.desc.equals(var2.desc);
      }
   }

   public int hashCode() {
      return this.name.hashCode() + this.desc.hashCode();
   }
}
