package sunw.demo.classfile;

import java.io.DataOutputStream;
import java.io.IOException;

class RefConstant extends ConstantPoolEntry {
   private ClassConstant clazz;
   private NameAndTypeConstant nandt;

   protected RefConstant(byte var1, String var2, String var3, String var4, ClassFile var5) {
      super(var1, var5);
      this.clazz = new ClassConstant(var2, var5);
      this.nandt = new NameAndTypeConstant(var3, var4, var5);
      this.addToConstantPool();
   }

   void write(DataOutputStream var1) throws IOException {
      var1.writeByte(this.getTag());
      var1.writeShort(this.clazz.getConstantPoolIndex());
      var1.writeShort(this.nandt.getConstantPoolIndex());
   }

   ClassConstant getClassObject() {
      return this.clazz;
   }

   NameAndTypeConstant getNameAndType() {
      return this.nandt;
   }

   public boolean equals(Object var1) {
      if (!(var1 instanceof RefConstant)) {
         return false;
      } else {
         RefConstant var2 = (RefConstant)var1;
         return this.clazz.equals(var2.clazz) && this.nandt.equals(var2.nandt);
      }
   }

   public int hashCode() {
      return this.clazz.hashCode() + this.nandt.hashCode();
   }
}
