package sunw.demo.classfile;

import java.io.DataOutputStream;
import java.io.IOException;

final class StringConstant extends ConstantPoolEntry {
   private UTF8Constant string;

   StringConstant(String var1, ClassFile var2) {
      super((byte)8, var2);
      this.string = var2.addUTF8Constant(var1);
      this.addToConstantPool();
   }

   StringConstant(UTF8Constant var1, ClassFile var2) {
      super((byte)8, var2);
      this.string = var1;
      this.addToConstantPool();
   }

   void write(DataOutputStream var1) throws IOException {
      var1.writeByte(this.getTag());
      var1.writeShort(this.string.getConstantPoolIndex());
   }

   String getString() {
      return this.string.getString();
   }

   public boolean equals(Object var1) {
      return var1 instanceof StringConstant ? this.string.equals(((StringConstant)var1).string) : false;
   }

   public int hashCode() {
      return this.string.hashCode();
   }
}
