package sunw.demo.classfile;

import java.io.DataOutputStream;
import java.io.IOException;

class UTF8Constant extends ConstantPoolEntry {
   private String string;

   UTF8Constant(String var1, ClassFile var2) {
      super((byte)1, var2);
      this.string = var1;
      this.addToConstantPool();
   }

   UTF8Constant(String var1, ClassFile var2, short var3) {
      super((byte)1, var2, var3);
      this.string = var1;
   }

   void write(DataOutputStream var1) throws IOException {
      var1.writeByte(this.getTag());
      var1.writeUTF(this.string);
   }

   String getString() {
      return this.string;
   }

   public boolean equals(Object var1) {
      return var1 instanceof UTF8Constant ? this.string.equals(((UTF8Constant)var1).getString()) : false;
   }

   public int hashCode() {
      return this.string.hashCode();
   }
}
