package foxtrot;

import java.security.AccessController;
import java.security.PrivilegedActionException;
import javax.swing.SwingUtilities;

public abstract class AbstractWorkerThread implements WorkerThread {
   private static final Runnable EMPTY_EVENT = new AbstractWorkerThread$1();

   protected AbstractWorkerThread() {
   }

   public void runTask(Task task) {
      try {
         Object obj = AccessController.doPrivileged(new AbstractWorkerThread$2(this, task), task.getSecurityContext());
         task.setResult(obj);
      } catch (PrivilegedActionException var9) {
         task.setThrowable(var9.getException());
      } catch (Throwable var10) {
         task.setThrowable(var10);
      } finally {
         task.setCompleted(true);
         SwingUtilities.invokeLater(EMPTY_EVENT);
      }
   }

   public abstract void postTask(Task var1);

   public abstract boolean isWorkerThread();

   public abstract boolean isAlive();

   public abstract void start();
}
