package foxtrot;

import java.security.AccessController;

class JREVersion {
   private static Boolean jre141;
   private static Boolean jre140;
   private static Boolean jre13;
   private static Boolean jre12;

   static boolean isJRE141() {
      if (jre141 == null) {
         Class cls = loadClass("java.awt.SequencedEvent");
         if (cls == null) {
            jre141 = Boolean.FALSE;
         } else {
            jre141 = hasGetFirst(cls);
         }
      }

      return jre141;
   }

   static boolean isJRE140() {
      if (jre140 == null) {
         Class cls = loadClass("java.awt.SequencedEvent");
         if (cls == null) {
            jre140 = Boolean.FALSE;
         } else {
            jre140 = hasGetFirst(cls) ? Boolean.FALSE : Boolean.TRUE;
         }
      }

      return jre140;
   }

   static boolean isJRE13() {
      if (jre13 == null) {
         jre13 = loadClass("java.lang.reflect.Proxy") == null ? Boolean.FALSE : Boolean.TRUE;
      }

      return jre13;
   }

   static boolean isJRE12() {
      if (jre12 == null) {
         jre12 = loadClass("java.util.Collection") == null ? Boolean.FALSE : Boolean.TRUE;
      }

      return jre12;
   }

   private static Class loadClass(String className) {
      try {
         return Class.forName(className, false, null);
      } catch (ClassNotFoundException var2) {
         return null;
      }
   }

   private static Boolean hasGetFirst(Class cls) {
      return AccessController.doPrivileged(new JREVersion$1(cls));
   }
}
