package amp.powerboard.clientapi.command;

import amp.powerboard.clientapi.common.exception.CDataException;
import amp.powerboard.clientapi.common.exception.CDataFormatException;
import amp.powerboard.clientapi.common.exception.CParamMissingException;
import amp.powerboard.clientapi.net.CMsgOutputStream;
import java.io.IOException;
import java.util.Enumeration;
import java.util.Vector;

public abstract class CCommand {
   protected Vector names;
   protected Vector values;
   private int opCode;
   public static final String LOCK_REQUIRED = "LOCK_REQUIRED";

   public CCommand(int var1) {
      this.opCode = var1;
      this.names = new Vector();
      this.values = new Vector();
   }

   public int getOpcode() {
      return this.opCode;
   }

   public void setProperty(String var1, int var2) throws CParamMissingException {
      if (var1 == null) {
         throw new CParamMissingException();
      } else {
         int var3 = 0;
         if (this.names.contains(var1)) {
            var3 = this.names.indexOf(var1);
            this.names.removeElementAt(var3);
            this.values.removeElementAt(var3);
         }

         this.names.addElement(var1);
         this.values.addElement(new Integer(var2));
      }
   }

   public void setProperty(String var1, String var2) throws CParamMissingException {
      if (var1 != null && var2 != null) {
         int var3 = 0;
         if (this.names.contains(var1)) {
            var3 = this.names.indexOf(var1);
            this.names.removeElementAt(var3);
            this.values.removeElementAt(var3);
         }

         this.names.addElement(var1);
         this.values.addElement(var2);
      } else {
         throw new CParamMissingException();
      }
   }

   public void setProperty(String var1, long var2) throws CParamMissingException {
      if (var1 == null) {
         throw new CParamMissingException();
      } else {
         int var4 = 0;
         if (this.names.contains(var1)) {
            var4 = this.names.indexOf(var1);
            this.names.removeElementAt(var4);
            this.values.removeElementAt(var4);
         }

         this.names.addElement(var1);
         this.values.addElement(new Long(var2));
      }
   }

   public void setProperty(String var1, short var2) throws CDataException {
      if (var1 == null) {
         throw new CParamMissingException();
      } else {
         int var3 = 0;
         if (this.names.contains(var1)) {
            var3 = this.names.indexOf(var1);
            this.names.removeElementAt(var3);
            this.values.removeElementAt(var3);
         }

         this.names.addElement(var1);
         this.values.addElement(new Short(var2));
      }
   }

   public void setProperty(String var1, double var2) throws CParamMissingException {
      if (var1 == null) {
         throw new CParamMissingException();
      } else {
         int var4 = 0;
         if (this.names.contains(var1)) {
            var4 = this.names.indexOf(var1);
            this.names.removeElementAt(var4);
            this.values.removeElementAt(var4);
         }

         this.names.addElement(var1);
         this.values.addElement(new Double(var2));
      }
   }

   public void setProperty(String var1, boolean var2) throws CParamMissingException {
      if (var1 == null) {
         throw new CParamMissingException();
      } else {
         int var3 = 0;
         if (this.names.contains(var1)) {
            var3 = this.names.indexOf(var1);
            this.names.removeElementAt(var3);
            this.values.removeElementAt(var3);
         }

         this.names.addElement(var1);
         this.values.addElement(new Boolean(var2));
      }
   }

   public void setProperty(String var1, byte[] var2) throws CParamMissingException {
      if (var1 == null) {
         throw new CParamMissingException();
      } else {
         int var3 = 0;
         if (this.names.contains(var1)) {
            var3 = this.names.indexOf(var1);
            this.names.removeElementAt(var3);
            this.values.removeElementAt(var3);
         }

         this.names.addElement(var1);
         this.values.addElement(var2);
      }
   }

   public void setProperty(String var1, int[] var2) throws CParamMissingException {
      if (var1 == null) {
         throw new CParamMissingException();
      } else {
         int var3 = 0;
         if (this.names.contains(var1)) {
            var3 = this.names.indexOf(var1);
            this.names.removeElementAt(var3);
            this.values.removeElementAt(var3);
         }

         this.names.addElement(var1);
         this.values.addElement(var2);
      }
   }

   public void setProperty(String var1, String[] var2) throws CParamMissingException {
      if (var1 == null) {
         throw new CParamMissingException();
      } else {
         int var3 = 0;
         if (this.names.contains(var1)) {
            var3 = this.names.indexOf(var1);
            this.names.removeElementAt(var3);
            this.values.removeElementAt(var3);
         }

         this.names.addElement(var1);
         this.values.addElement(var2);
      }
   }

   public void fillStream(CMsgOutputStream var1) throws CParamMissingException, CDataFormatException, IOException {
      Vector var2 = this.getNameList();
      Vector var3 = this.getDataTypes();
      int var4 = 0;
      if (!var2.isEmpty() && !var3.isEmpty()) {
         for (Enumeration var5 = var2.elements(); var5.hasMoreElements(); var4++) {
            String var6 = (String)var5.nextElement();
            int var7 = this.names.indexOf(var6);
            if (var7 == -1) {
               throw new CParamMissingException();
            }

            int var8 = (Integer)var3.elementAt(var4);
            switch (var8) {
               case 1:
                  try {
                     int var23 = (Integer)this.values.elementAt(var7);
                     var1.writeInt(var23);
                     break;
                  } catch (Exception var16) {
                     throw new CDataFormatException();
                  }
               case 2:
                  try {
                     long var22 = (Long)this.values.elementAt(var7);
                     var1.writeLong(var22);
                     break;
                  } catch (Exception var14) {
                     throw new CDataFormatException();
                  }
               case 3:
                  try {
                     Object var21 = this.values.elementAt(var7);
                     String var25 = (String)var21;
                     var1.writeShort((short)var25.length());
                     var1.writeBytes(var25);
                     break;
                  } catch (Exception var15) {
                     throw new CDataFormatException();
                  }
               case 4:
                  try {
                     short var20 = (Short)this.values.elementAt(var7);
                     var1.writeShort(var20);
                     break;
                  } catch (Exception var13) {
                     throw new CDataFormatException();
                  }
               case 5:
                  try {
                     double var19 = (Double)this.values.elementAt(var7);
                     var1.writeDouble(var19);
                     break;
                  } catch (Exception var12) {
                     throw new CDataFormatException();
                  }
               case 6:
               default:
                  throw new CDataFormatException();
               case 7:
                  try {
                     byte[] var18 = (byte[])this.values.elementAt(var7);
                     short var24 = (short)var18.length;
                     var1.writeShort(var24);
                     var1.write(var18, 0, var18.length);
                  } catch (Exception var11) {
                     throw new CDataFormatException();
                  }
               case 8:
                  break;
               case 9:
                  try {
                     int[] var9 = (int[])this.values.elementAt(var7);

                     for (int var10 = 0; var10 < var9.length; var10++) {
                        var1.writeInt(var9[var10]);
                     }
                  } catch (Exception var17) {
                     throw new CDataFormatException();
                  }
            }
         }

         var1.close();
      } else {
         var1.close();
      }
   }

   public abstract Vector getNameList();

   public abstract Vector getDataTypes();

   public boolean isLockRequired() {
      Vector var1 = this.getNameList();

      for (int var2 = 0; var2 < var1.size(); var2++) {
         String var3 = (String)var1.elementAt(var2);
         if (var3.equals("LOCK_REQUIRED")) {
            int var4 = this.names.indexOf(var3);
            Boolean var5 = (Boolean)this.values.elementAt(var4);
            return var5;
         }
      }

      return false;
   }

   public boolean isFetchCommand() {
      return false;
   }
}
