package amp.powerboard.clientapi.command;

import amp.powerboard.clientapi.event.IGenerateEvent;
import amp.powerboard.clientapi.net.CMsgInputStream;
import java.io.IOException;
import java.io.InputStream;

public class CCommandListenerThread extends Thread {
   private InputStream iStream = null;
   private IGenerateEvent evtGenerator = null;
   private boolean bSSLProduct;
   private boolean isActive = true;

   public CCommandListenerThread(InputStream var1, IGenerateEvent var2, boolean var3) {
      super("CommandListenerThread");
      this.iStream = var1;
      this.evtGenerator = var2;
      this.bSSLProduct = var3;
   }

   public void run() {
      while (this.isActive) {
         try {
            CMsgInputStream var1 = new CMsgInputStream(this.iStream);
            this.evtGenerator.generateEventObject(var1, this.bSSLProduct);
         } catch (IOException var9) {
            if (this.evtGenerator != null && this.isActive) {
               this.evtGenerator.generateKillEventObject();
            }

            this.isActive = false;
            this.evtGenerator = null;
         } catch (Exception var10) {
            var10.printStackTrace();
         } finally {
            ;
         }
      }
   }

   public void releaseResources() {
      try {
         this.evtGenerator = null;
         this.isActive = false;
         if (this.iStream != null) {
            this.iStream.close();
         }

         this.iStream = null;
      } catch (IOException var2) {
      }
   }
}
