package amp.powerboard.clientapi.command;

import amp.powerboard.clientapi.common.exception.CDataException;
import amp.powerboard.clientapi.common.exception.CDataFormatException;
import amp.powerboard.clientapi.common.exception.CParamMissingException;
import amp.powerboard.clientapi.net.CMsgOutputStream;
import java.io.IOException;
import java.util.Enumeration;
import java.util.Vector;

public class CSetNetwork extends CCommand {
   private Vector nameList = new Vector();
   private Vector dataTypes;
   public static final String HOST_NAME = "HOST_NAME";
   public static final String IP_ADDRESS = "IP_ADDRESS";
   public static final String SUBNET = "SUBNET";
   public static final String GATEWAY = "GATEWAY";
   public static final String PORT_ADDRESS = "PORT_ADDRESS";
   public static final String USE_SSL = "USE_SSL";
   public static final String PRIME1 = "PRIME1";
   public static final String PRIME2 = "PRIME2";
   public static final String TERMINAL_TYPE = "TERMINAL_TYPE";
   public static final String DEVICE_NAME = "DEVICE_NAME";

   public CSetNetwork() {
      super(4);
      this.nameList.addElement("HOST_NAME");
      this.nameList.addElement("IP_ADDRESS");
      this.nameList.addElement("SUBNET");
      this.nameList.addElement("GATEWAY");
      this.nameList.addElement("PORT_ADDRESS");
      this.nameList.addElement("TERMINAL_TYPE");
      this.nameList.addElement("USE_SSL");
      this.nameList.addElement("PRIME1");
      this.nameList.addElement("PRIME2");
      this.nameList.addElement("LOCK_REQUIRED");
      this.dataTypes = new Vector();
      this.dataTypes.addElement(new Integer(3));
      this.dataTypes.addElement(new Integer(3));
      this.dataTypes.addElement(new Integer(3));
      this.dataTypes.addElement(new Integer(3));
      this.dataTypes.addElement(new Integer(1));
      this.dataTypes.addElement(new Integer(1));
      this.dataTypes.addElement(new Integer(3));
      this.dataTypes.addElement(new Integer(7));
      this.dataTypes.addElement(new Integer(7));
      this.dataTypes.addElement(new Integer(8));

      try {
         this.setProperty("LOCK_REQUIRED", true);
      } catch (CDataException var2) {
      }
   }

   public CSetNetwork(String var1) {
      super(4);
      this.nameList.addElement("HOST_NAME");
      this.nameList.addElement("IP_ADDRESS");
      this.nameList.addElement("SUBNET");
      this.nameList.addElement("GATEWAY");
      this.nameList.addElement("PORT_ADDRESS");
      this.nameList.addElement("TERMINAL_TYPE");
      if (!var1.equals("HP")) {
         this.nameList.addElement("USE_SSL");
         this.nameList.addElement("PRIME1");
         this.nameList.addElement("PRIME2");
      }

      if (var1.equals("DC") || var1.equals("HP")) {
         this.nameList.addElement("DEVICE_NAME");
      }

      this.nameList.addElement("LOCK_REQUIRED");
      this.dataTypes = new Vector();
      this.dataTypes.addElement(new Integer(3));
      this.dataTypes.addElement(new Integer(3));
      this.dataTypes.addElement(new Integer(3));
      this.dataTypes.addElement(new Integer(3));
      this.dataTypes.addElement(new Integer(1));
      this.dataTypes.addElement(new Integer(1));
      if (!var1.equals("HP")) {
         this.dataTypes.addElement(new Integer(3));
         this.dataTypes.addElement(new Integer(7));
         this.dataTypes.addElement(new Integer(7));
      }

      if (var1.equals("DC") || var1.equals("HP")) {
         this.dataTypes.addElement(new Integer(3));
      }

      this.dataTypes.addElement(new Integer(8));

      try {
         this.setProperty("LOCK_REQUIRED", true);
      } catch (CDataException var3) {
      }
   }

   public Vector getNameList() {
      return this.nameList;
   }

   public Vector getDataTypes() {
      return this.dataTypes;
   }

   public void fillStream(CMsgOutputStream var1) throws CParamMissingException, CDataFormatException, IOException {
      int var2 = 0;
      Enumeration var3 = this.nameList.elements();

      while (var3.hasMoreElements()) {
         String var4 = (String)var3.nextElement();
         int var5 = super.names.indexOf(var4);
         if (var5 == -1) {
            throw new CParamMissingException();
         }

         if (var4.equals("IP_ADDRESS")) {
            int var13 = this.stringToIp((String)super.values.elementAt(var5));
            var1.writeInt(var13);
         } else if (var4.equals("GATEWAY")) {
            int var12 = this.stringToIp((String)super.values.elementAt(var5));
            var1.writeInt(var12);
         } else if (var4.equals("SUBNET")) {
            int var11 = this.stringToIp((String)super.values.elementAt(var5));
            var1.writeInt(var11);
         } else if (var4.equals("TERMINAL_TYPE")) {
            String var10 = (String)super.values.elementAt(var5);
            if (var10.equals("0")) {
               var1.writeInt(0);
            } else {
               var1.writeInt(1);
            }
         } else if (var4.equals("PORT_ADDRESS")) {
            int var9 = (Integer)super.values.elementAt(var5);
            var1.writeInt(var9);
         } else if (var4.equals("USE_SSL")) {
            var2 = (Integer)super.values.elementAt(var5);
            var1.writeInt(var2);
         } else if (!var4.equals("PRIME1") && !var4.equals("PRIME2")) {
            if (!var4.equals("LOCK_REQUIRED")) {
               String var8 = (String)super.values.elementAt(var5);
               var1.writeShort((short)var8.length());
               var1.writeBytes(var8);
            }
         } else if (var2 == 1) {
            byte[] var6 = (byte[])super.values.elementAt(var5);
            int var7 = var6.length;
            var1.writeShort((short)var7);
            var1.write(var6, 0, var7);
         }
      }

      var1.close();
   }

   public int stringToIp(String var1) throws NumberFormatException {
      int var3 = 0;
      int var6 = 0;
      if (var1.length() == 0) {
         throw new NumberFormatException("Invalid IP Argument");
      } else {
         int var2 = 0;

         while (var2 < 4) {
            int var4 = var1.indexOf(46, var3);
            if ((var4 != -1 || var2 >= 3) && (var4 == -1 || var2 != 3)) {
               String var7;
               if (var4 == -1) {
                  var7 = var1.substring(var3);
               } else {
                  var7 = var1.substring(var3, var4);
                  var3 = var4 + 1;
               }

               int var5 = Integer.parseInt(var7, 10);
               if (var5 >= 0 && var5 <= 255) {
                  var6 = var6 * 256 + var5;
                  var2++;
                  continue;
               }

               throw new NumberFormatException("Invalid IP Argument");
            }

            throw new NumberFormatException("Invalid IP Argument");
         }

         return var6;
      }
   }
}
