package amp.powerboard.clientapi.command;

import amp.powerboard.clientapi.common.exception.CDataException;
import amp.powerboard.clientapi.common.exception.CDataFormatException;
import amp.powerboard.clientapi.common.exception.CParamMissingException;
import amp.powerboard.clientapi.net.CMsgOutputStream;
import amp.powerboard.clientapi.security.CMd5;
import java.io.IOException;
import java.util.Enumeration;
import java.util.Vector;

public class CSetUser extends CCommand {
   private Vector nameList = new Vector();
   private Vector dataTypes;
   public static final String USER_ID = "USER_ID";
   public static final String LOGIN = "LOGIN";
   public static final String CAPABILITY = "CAPABILITY";
   public static final String USER_NAME = "USER_NAME";
   public static final String USER_INFO = "USER_INFO";
   public static final String PASSWORD = "PASSWORD";
   public static final String NUMPORTS = "NUMPORTS";
   public static final String PORTS = "PORTS";

   public CSetUser() {
      super(8);
      this.nameList.addElement("USER_ID");
      this.nameList.addElement("LOGIN");
      this.nameList.addElement("CAPABILITY");
      this.nameList.addElement("USER_NAME");
      this.nameList.addElement("USER_INFO");
      this.nameList.addElement("NUMPORTS");
      this.nameList.addElement("PORTS");
      this.nameList.addElement("PASSWORD");
      this.nameList.addElement("LOCK_REQUIRED");
      this.dataTypes = new Vector();
      this.dataTypes.addElement(new Integer(1));
      this.dataTypes.addElement(new Integer(3));
      this.dataTypes.addElement(new Integer(1));
      this.dataTypes.addElement(new Integer(3));
      this.dataTypes.addElement(new Integer(3));
      this.dataTypes.addElement(new Integer(1));
      this.dataTypes.addElement(new Integer(9));
      this.dataTypes.addElement(new Integer(3));
      this.dataTypes.addElement(new Integer(8));

      try {
         this.setProperty("LOCK_REQUIRED", true);
      } catch (CDataException var2) {
      }
   }

   public CSetUser(String var1) {
      super(8);
      this.nameList.addElement("USER_ID");
      this.nameList.addElement("LOGIN");
      this.nameList.addElement("CAPABILITY");
      this.nameList.addElement("USER_NAME");
      this.nameList.addElement("USER_INFO");
      if (!var1.equals("DC") && !var1.equals("HP")) {
         this.nameList.addElement("NUMPORTS");
         this.nameList.addElement("PORTS");
      }

      this.nameList.addElement("PASSWORD");
      this.nameList.addElement("LOCK_REQUIRED");
      this.dataTypes = new Vector();
      this.dataTypes.addElement(new Integer(1));
      this.dataTypes.addElement(new Integer(3));
      this.dataTypes.addElement(new Integer(1));
      this.dataTypes.addElement(new Integer(3));
      this.dataTypes.addElement(new Integer(3));
      if (!var1.equals("DC") && !var1.equals("HP")) {
         this.dataTypes.addElement(new Integer(1));
         this.dataTypes.addElement(new Integer(9));
      }

      this.dataTypes.addElement(new Integer(3));
      this.dataTypes.addElement(new Integer(8));

      try {
         this.setProperty("LOCK_REQUIRED", true);
      } catch (CDataException var3) {
      }
   }

   public Vector getNameList() {
      return this.nameList;
   }

   public Vector getDataTypes() {
      return this.dataTypes;
   }

   public void fillStream(CMsgOutputStream var1) throws CParamMissingException, CDataFormatException, IOException {
      int var2 = 0;
      Enumeration var3 = this.nameList.elements();

      try {
         while (var3.hasMoreElements()) {
            String var4 = (String)var3.nextElement();
            int var5 = super.names.indexOf(var4);
            if (var5 == -1) {
               throw new CParamMissingException();
            }

            if (var4.equals("PASSWORD")) {
               String var6 = (String)super.values.elementAt(var5);
               if (var6 != null && var6.length() != 0) {
                  byte[] var7 = this.getHashedPassword(var6);
                  var1.writeShort((short)16);
                  var1.write(var7);
               } else {
                  var1.writeShort((short)0);
               }
            } else if (var4.equals("NUMPORTS")) {
               var2 = (Integer)super.values.elementAt(var5);
               var1.writeInt(var2);
            } else if (var4.equals("PORTS")) {
               Object var11 = null;
               var11 = (int[])super.values.elementAt(var5);

               for (int var14 = 0; var14 < var2; var14++) {
                  var1.writeInt((int)((Object[])var11)[var14]);
               }
            } else {
               Object var13 = super.values.elementAt(var5);
               if (var13 instanceof String) {
                  String var15 = (String)var13;
                  var1.writeShort((short)var15.length());
                  var1.writeBytes(var15);
               } else if (var13 instanceof Integer) {
                  int var16 = (Integer)var13;
                  var1.writeInt(var16);
               } else if (var13 instanceof Short) {
                  short var17 = (Short)var13;
                  var1.writeShort(var17);
               } else if (var13 instanceof Long) {
                  long var18 = (Long)var13;
                  var1.writeLong(var18);
               } else if (!(var13 instanceof Boolean)) {
                  throw new CDataFormatException();
               }
            }

            var4 = null;
         }

         var1.close();
      } catch (IOException var9) {
         throw var9;
      }
   }

   private byte[] getHashedPassword(String var1) {
      byte[] var2 = new byte[var1.length()];
      var1.getBytes(0, var1.length(), var2, 0);
      CMd5 var3 = new CMd5();
      var3.update(var2);
      return var3.digest();
   }

   public String getUserName() {
      int var1 = super.names.indexOf("USER_NAME");
      return (String)super.values.elementAt(var1);
   }
}
