package amp.powerboard.clientapi.console;

import amp.powerboard.clientapi.event.CInternalEvent;
import java.io.BufferedInputStream;
import java.io.IOException;
import java.io.InputStream;

public class CConsoleListenerThread extends Thread {
   private static final int BUFFER_SIZE = 2048;
   private InputStream iStream = null;
   private CConsoleHandler consoleHandler = null;
   private boolean stoppedTerminal = false;
   private byte[] buffer;
   private CInternalEvent wrongFormat;

   public CConsoleListenerThread(InputStream var1, CConsoleHandler var2) {
      super("CConsoleHandlerThread");
      this.iStream = new BufferedInputStream(var1, 2048);
      this.consoleHandler = var2;
      this.buffer = new byte[2048];
   }

   public void run() {
      int var2 = 0;

      while (true) {
         while (this.stoppedTerminal) {
            try {
               Thread.sleep(100L);
            } catch (InterruptedException var5) {
            }
         }

         try {
            var2 = this.iStream.available();
            if (var2 == -1) {
               break;
            }

            if (var2 > 2048) {
               var2 = 2048;
            } else if (var2 <= 0) {
               var2 = 1;
            }

            var2 = this.iStream.read(this.buffer, 0, var2);
            if (var2 == -1) {
               break;
            }

            try {
               Thread.sleep(1L);
            } catch (InterruptedException var4) {
            }
         } catch (IOException var6) {
            this.wrongFormat = new CInternalEvent(0, 5, "Error reading from CONSOLE");
            break;
         }

         this.consoleHandler.fireBytesArrived(this.buffer, var2);
      }
   }

   public void releaseResources() {
      try {
         if (this.iStream != null) {
            this.iStream.close();
            this.iStream = null;
            this.buffer = null;
            this.consoleHandler = null;
         }
      } catch (IOException var3) {
      }

      try {
         this.stop();
      } catch (Exception var2) {
      }
   }

   public void setPaused(boolean var1) {
      this.stoppedTerminal = var1;
   }
}
