package amp.powerboard.clientapi.event;

import amp.powerboard.clientapi.net.CMsgInputStream;
import java.io.IOException;
import java.util.Hashtable;

public class CDataEventCreator {
   private int msgopCode;
   private String platform;
   private CDataEvent dataEvent;
   private String subPlatform;

   public CDataEventCreator(int var1) {
      this.msgopCode = var1;
   }

   public CDataEventCreator(int var1, String var2) {
      this.msgopCode = var1;
      this.platform = var2;
   }

   public CDataEventCreator(int var1, String var2, String var3) {
      this.msgopCode = var1;
      this.platform = var2;
      this.subPlatform = var3;
   }

   public String ipToString(int var1) {
      return (var1 >>> 24 & 0xFF) + "." + (var1 >>> 16 & 0xFF) + "." + (var1 >>> 8 & 0xFF) + "." + (var1 >>> 0 & 0xFF);
   }

   public CDataEvent getDataEvent() {
      return this.dataEvent;
   }

   public void createClientListEvent(CMsgInputStream var1) throws IOException, Exception {
      Object var2 = null;
      int var3 = var1.readInt();
      String[] var4 = new String[var3];

      for (int var6 = 0; var6 < var3; var6++) {
         short var7 = var1.readShort();
         var4[var6] = var1.readBytes(var7);
      }

      int var5 = var1.readInt();
      var1.close();
      var2 = new CClientListEvent(var3, var4, var5);
      if (var3 == 0) {
      }

      this.dataEvent = (CDataEvent)var2;
   }

   public void createUserInfoEvent(CMsgInputStream var1) throws IOException, Exception {
      Object var2 = null;
      short var3 = 0;
      int var4 = 0;
      int var5 = 0;
      int var6 = 0;
      String var7 = null;
      String var8 = null;
      String var9 = null;
      int var10 = 0;
      int[] var11 = null;
      var4 = var1.readInt();
      if (var4 == 0) {
         var5 = var1.readInt();
         var3 = var1.readShort();
         var7 = var1.readBytes(var3);
         var6 = var1.readInt();
         var3 = var1.readShort();
         var8 = var1.readBytes(var3);
         var3 = var1.readShort();
         var9 = var1.readBytes(var3);
         var10 = var1.readInt();
         if (var10 > 0) {
            var11 = new int[var10];

            for (int var12 = 0; var12 < var10; var12++) {
               var11[var12] = var1.readInt();
            }
         }

         var1.close();
      } else {
         var1.close();
      }

      var2 = new CInternalUserInfoEvent(var6, var8, var9, var4, var5, var7, var10, var11);
      this.dataEvent = (CDataEvent)var2;
   }

   public void createLoginInfoEvent(CMsgInputStream var1) throws IOException, Exception {
      Object var2 = null;
      Hashtable var7 = null;
      Hashtable var9 = null;
      int var3 = var1.readInt();
      short var4 = var1.readShort();
      String var5 = var1.readBytes(var4);
      if (this.platform != null && !this.platform.equals("DC") && (!this.platform.equals("CONSOLE_MANAGER") || !this.subPlatform.equals("DC"))) {
         int var6 = var1.readInt();
         var7 = new Hashtable();
         var9 = new Hashtable();

         for (int var14 = 0; var14 < var6; var14++) {
            int var12 = var1.readInt();
            short var16 = var1.readShort();
            String var18 = var1.readBytes(var16);
            var7.put(new Integer(var12), var18);
            if (this.platform.startsWith("SecureManage")
               || this.platform.startsWith("SecureAccess")
               || this.platform.equals("COMMAND_CENTER") && (this.subPlatform.startsWith("SecureManage") || this.subPlatform.startsWith("SecureAccess"))) {
               short var10 = var1.readShort();
               String var11 = var1.readBytes(var10);
               var9.put(new Integer(var12), var11);
            }
         }
      } else if (this.platform != null && (this.platform.equals("DC") || this.platform.equals("CONSOLE_MANAGER") && this.subPlatform.equals("DC"))) {
         var7 = new Hashtable(1);
         short var8 = var1.readShort();
         String var13 = var1.readBytes(var8);
         var7.put(new Integer(1), var13);
      }

      if (this.platform != null) {
         var2 = new CLoginInfoEvent(var3, var5, var7, false);
      } else {
         var2 = new CLoginInfoEvent(var3, var5, false);
      }

      this.dataEvent = (CDataEvent)var2;
   }

   public void createConfigLockEvent(CMsgInputStream var1) throws IOException, Exception {
      Object var2 = null;
      short var3 = 0;
      String var4 = null;
      int var5 = var1.readInt();
      if (var5 == 14) {
         var3 = var1.readShort();
         var4 = var1.readBytes(var3);
      }

      var1.close();
      var2 = new CConfigLockEvent(var5, var4);
      this.dataEvent = (CDataEvent)var2;
   }

   public void createNetworkEvent(CMsgInputStream var1, boolean var2) throws IOException, Exception {
      Object var3 = null;
      int var10 = -1;
      Object var11 = null;
      Object var12 = null;
      Object var13 = null;
      Object var14 = null;
      short var4 = var1.readShort();
      String var5 = var1.readBytes(var4);
      int var6 = var1.readInt();
      int var7 = var1.readInt();
      int var8 = var1.readInt();
      int var9 = var1.readInt();
      if (var1.readInt() == 0) {
         var11 = "0";
      } else {
         var11 = "1";
      }

      if (var2) {
         var10 = var1.readInt();
      }

      new String(var1.readBytes(var1.available()));
      var1.close();
      var12 = this.ipToString(var6);
      var13 = this.ipToString(var7);
      var14 = this.ipToString(var8);
      var3 = new CInternalNetworkEvent(var5, (String)var12, var9, (String)var13, (String)var14, (String)var11, var10);
      this.dataEvent = (CDataEvent)var3;
   }

   public void createHWMonitoringEvent(CMsgInputStream var1) throws IOException, Exception {
      Object var2 = null;
      byte var3;
      if (var1.readInt() == 0) {
         var3 = 0;
      } else {
         var3 = 1;
      }

      int var4 = var1.readInt();
      var1.close();
      var2 = new CInternalHWMonitoringEvent(var3, var4);
      this.dataEvent = (CDataEvent)var2;
   }

   public void createPingMonitoringEvent(CMsgInputStream var1) throws IOException, Exception {
      Object var2 = null;
      int var3 = var1.readInt();
      int var4 = var1.readInt();
      int[] var5 = new int[var4];

      for (int var7 = 0; var7 < var4; var7++) {
         var5[var7] = var1.readInt();
      }

      int var6 = var1.readInt();
      var1.close();
      var2 = new CInternalPingMonitoringEvent(var3, var4, var5, var6);
      this.dataEvent = (CDataEvent)var2;
   }

   public void createTCLLoaderStatusEvent(CMsgInputStream var1) throws IOException, Exception {
      Object var7 = null;
      int var3 = var1.readInt();
      int var4 = var1.readInt();
      int[] var5 = new int[var4];

      for (int var8 = 0; var8 < var4; var8++) {
         var5[var8] = var1.readInt();
      }

      int var6 = var1.readInt();
      short var9 = var1.readShort();
      var7 = var1.readBytes(var9);
      CGetTCLLoaderStatusEvent var2 = new CGetTCLLoaderStatusEvent(var3, var4, var5, var6, (String)var7);
      this.dataEvent = var2;
   }

   public void createTCLResponseEvent(CMsgInputStream var1) throws IOException, Exception {
      String var3 = "";

      try {
         while (var1.available() > 0) {
            short var2 = var1.readShort();
            var3 = var3 + var1.readBytes(var2);
         }

         var1.close();
      } catch (Exception var5) {
      }

      this.dataEvent = new CTCLResponseEvent(var3);
   }

   public void createTCLPrintEvent(CMsgInputStream var1) throws IOException, Exception {
      String var3 = "";

      try {
         while (var1.available() > 0) {
            short var2 = var1.readShort();
            var3 = var3 + var1.readBytes(var2);
         }

         var1.close();
      } catch (Exception var5) {
      }

      this.dataEvent = new CTCLPrintEvent(var3);
   }

   public void createSubscriptionEvent(CMsgInputStream var1) throws IOException, Exception {
      Object var2 = null;
      Object var5 = null;
      Object var6 = null;
      int var4 = var1.readInt();
      var5 = new String[var4];
      var6 = new String[var4];

      for (int var7 = 0; var7 < var4; var7++) {
         short var3 = var1.readShort();
         ((Object[])var5)[var7] = var1.readBytes(var3);
         var3 = var1.readShort();
         ((Object[])var6)[var7] = var1.readBytes(var3);
      }

      var1.close();
      var2 = new CInternalSubscriptionEvent(var4, (String[])var5, (String[])var6);
      this.dataEvent = (CDataEvent)var2;
   }

   public void createGetSMTPServerEvent(CMsgInputStream var1) throws IOException, Exception {
      Object var2 = null;
      int var3 = var1.readInt();
      var1.close();
      var2 = new CInternalSMTPServerEvent(var3);
      this.dataEvent = (CDataEvent)var2;
   }

   public void createGetSNMPAgentEvent(CMsgInputStream var1) throws IOException, Exception {
      Object var2 = null;
      Object var5 = null;
      String var7 = "";
      String var8 = "";
      var5 = new String[10];
      int var4 = var1.readInt();

      for (int var9 = 0; var9 < 10; var9++) {
         short var3 = var1.readShort();
         ((Object[])var5)[var9] = var1.readBytes(var3);
      }

      int var6 = var1.readInt();
      short var11 = var1.readShort();
      if (var11 > 0) {
         var7 = var1.readBytes(var11);
      }

      var11 = var1.readShort();
      if (var11 > 0) {
         var8 = var1.readBytes(var11);
      }

      var1.close();
      var2 = new CInternalSNMPAgentEvent(var4, (String[])var5, var6, var7, var8);
      this.dataEvent = (CDataEvent)var2;
   }

   public void createIPACLListEvent(CMsgInputStream var1) throws IOException, Exception {
      int var2 = var1.readInt();
      int var3 = var1.readInt();
      int[] var4 = null;
      int[] var5 = null;
      if (var3 > 0) {
         var4 = new int[var3];
         var5 = new int[var3];

         for (int var6 = 0; var6 < var3; var6++) {
            var4[var6] = var1.readInt();
            var5[var6] = var1.readInt();
         }
      }

      this.dataEvent = new CInternalIPACLListEvent(var2, var3, var4, var5);
   }

   public void createGetDataComAndSystemEvent(CMsgInputStream var1) throws IOException, Exception {
      int var11 = 0;
      int var13 = var1.readInt();
      int[] var5 = new int[var13 <= 32 ? var13 : 1];
      int[] var6 = new int[var13 <= 32 ? var13 : 1];
      int[] var7 = new int[var13 <= 32 ? var13 : 1];
      int[] var8 = new int[var13 <= 32 ? var13 : 1];
      int[] var9 = new int[var13 <= 32 ? var13 : 1];
      String[] var10 = new String[var13 <= 32 ? var13 : 1];
      int[] var4 = new int[var13 <= 32 ? var13 : 1];
      int[] var12 = new int[var13 <= 32 ? var13 : 1];
      if (var13 > 32) {
         var5[0] = var13;
         var7[0] = var1.readInt();
         var6[0] = var1.readInt();
         var8[0] = var1.readInt();
         var9[0] = var1.readInt();
         short var3 = var1.readShort();
         var10[0] = var1.readBytes(var3);
         var4[0] = var1.readInt();
      } else {
         var11 = var13;

         for (int var14 = 0; var14 < var11; var14++) {
            var4[var14] = var1.readInt();
            var5[var14] = var1.readInt();
            var7[var14] = var1.readInt();
            var6[var14] = var1.readInt();
            var8[var14] = var1.readInt();
            var9[var14] = var1.readInt();
            if (this.platform.equals("CEREBUS_X16+") || this.platform.equals("CEREBUS_X32+")) {
               var12[var14] = var1.readInt();
            }

            short var15 = var1.readShort();
            var10[var14] = var1.readBytes(var15);
         }
      }

      CInternalDataComAndSystemEvent var2;
      if (!this.platform.equals("CEREBUS_X16+") && !this.platform.equals("CEREBUS_X32+")) {
         var2 = new CInternalDataComAndSystemEvent(var11, var5, var7, var6, var8, var9, var10, var4);
      } else {
         var2 = new CInternalDataComAndSystemEvent(var11, var5, var7, var6, var8, var9, var10, var4, var12);
      }

      var1.close();
      this.dataEvent = var2;
   }

   public void createGetUserEvent(CMsgInputStream var1) throws IOException, Exception {
      int var4 = 0;
      int var5 = 0;
      int var6 = 0;
      String var7 = null;
      String var8 = null;
      String var9 = null;
      int var10 = 0;
      int[] var11 = null;
      var4 = var1.readInt();
      if (var4 == 0) {
         var6 = var1.readInt();
         short var3 = var1.readShort();
         var7 = var1.readBytes(var3);
         var5 = var1.readInt();
         var3 = var1.readShort();
         var8 = var1.readBytes(var3);
         var3 = var1.readShort();
         var9 = var1.readBytes(var3);
         var10 = var1.readInt();
         var11 = new int[var10];

         for (int var12 = 0; var12 < var10; var12++) {
            var11[var12] = var1.readInt();
         }
      } else {
         var1.close();
      }

      var1.close();
      CInternalUserEvent var2 = new CInternalUserEvent(var4, var6, var7, var5, var8, var9, var10, var11);
      this.dataEvent = var2;
   }

   public void createGetUserListEvent(CMsgInputStream var1) throws IOException, Exception {
      Object var5 = null;
      Object var6 = null;
      Object var7 = null;
      Object var8 = null;
      int var4 = var1.readInt();
      var5 = new String[var4];
      var6 = new int[var4];
      var7 = new int[var4];
      var8 = new int[var4][];

      for (int var9 = 0; var9 < var4; var9++) {
         short var3 = var1.readShort();
         ((Object[])var5)[var9] = var1.readBytes(var3);
         ((Object[])var6)[var9] = var1.readInt();
         ((Object[])var7)[var9] = var1.readInt();
         ((Object[])var8)[var9] = new int[((Object[])var7)[var9]];

         for (int var10 = 0; var10 < ((Object[])var7)[var9]; var10++) {
            ((Object[])((Object[])var8)[var9])[var10] = var1.readInt();
         }
      }

      CInternalUserListEvent var2 = new CInternalUserListEvent(var4, (String[])var5, (int[])var6, (int[])var7, (int[][])var8);
      this.dataEvent = var2;
   }

   public void createChatEvent(CMsgInputStream var1) throws IOException, Exception {
      short var3 = var1.readShort();
      String var4 = var1.readBytes(var3);
      var3 = var1.readShort();
      String var5 = var1.readBytes(var3);
      CChatEvent var2 = new CChatEvent(var4, var5);
      this.dataEvent = var2;
   }

   public void createUpgradeReportEvent(CMsgInputStream var1) throws IOException, Exception {
      Object var5 = null;
      int var3 = var1.readInt();
      short var4 = var1.readShort();
      if (var4 == 0) {
         var5 = " ";
      } else {
         var5 = new String(var1.readBytes(var4));
      }

      CUpgradeReportEvent var2 = new CUpgradeReportEvent(var3, (String)var5);
      this.dataEvent = var2;
      var1.close();
   }

   public void createResetEvent(CMsgInputStream var1) throws IOException, Exception {
      short var2 = 0;
      Object var3 = null;
      var2 = var1.readShort();
      var3 = var1.readBytes(var2);
      CInternalResetEvent var4 = new CInternalResetEvent((String)var3, 0);
      this.dataEvent = var4;
      var1.close();
   }

   public void createKillEvent(CMsgInputStream var1) throws IOException, Exception {
      Object var4 = null;
      short var3 = var1.readShort();
      var4 = var1.readBytes(var3);
      CKillEvent var2 = new CKillEvent((String)var4);
      this.dataEvent = var2;
      var1.close();
   }

   public void createRequestSessionIdEvent(CMsgInputStream var1) throws IOException, Exception {
      int var3 = var1.readInt();
      int var4 = 0;
      int var5 = 0;
      if (var3 == 0) {
         var4 = var1.readInt();
         var5 = var1.readInt();
      }

      CRequestSessionIdEvent var2 = new CRequestSessionIdEvent(var3, var4, var5);
      this.dataEvent = var2;
      var1.close();
   }

   public void createVersionReportEvent(CMsgInputStream var1) throws IOException, Exception {
      Object var2 = null;
      String var4 = null;

      try {
         short var3 = var1.readShort();
         var4 = var1.readBytes(var3);
         var1.close();
      } catch (Exception var6) {
      }

      this.dataEvent = new CVersionReportEvent(var4);
   }

   public void createConfigReportEvent(CMsgInputStream var1) throws IOException, Exception {
      Object var2 = null;
      String var4 = "";

      try {
         while (var1.available() > 0) {
            short var3 = var1.readShort();
            var4 = var4 + var1.readBytes(var3);
         }

         String var7 = new String("HP Secure Web Console");
         int var5 = var4.indexOf(var7);
         if (var5 != -1) {
            int var6 = var5 + var7.length();
            var4 = var4.substring(0, var5) + "Arula Web Console" + var4.substring(var6);
         }

         var1.close();
      } catch (Exception var8) {
      }

      this.dataEvent = new CConfigReportEvent(var4);
   }

   public void createCertificateEvent(CMsgInputStream var1) throws IOException, Exception {
      Object var2 = null;
      int var4 = var1.readInt();
      short var3 = var1.readShort();
      String var5 = var1.readBytes(var3);
      var1.close();
      var2 = new CInternalCertificateEvent(var4, var5);
      this.dataEvent = (CDataEvent)var2;
   }

   public void createModemEvent(CMsgInputStream var1) throws IOException, Exception {
      Object var2 = null;
      int var3 = var1.readInt();
      int var4 = var1.readInt();
      int var5 = var1.readInt();
      int var6 = var1.readInt();
      int var7 = var1.readInt();
      int var8 = var1.readInt();
      var1.close();
      var2 = new CInternalModemEvent(var3, var4, var5, var6, var7, var8);
      this.dataEvent = (CDataEvent)var2;
   }

   public void createRadClientEvent(CMsgInputStream var1) throws IOException, Exception {
      Object var2 = null;
      int var4 = var1.readInt();
      int var5 = var1.readInt();
      short var3 = var1.readShort();
      String var6 = var1.readBytes(var3);
      int var7 = var1.readInt();
      int var8 = var1.readInt();
      var3 = var1.readShort();
      String var9 = var1.readBytes(var3);
      int var10 = var1.readInt();
      var1.close();
      var2 = new CInternalRadClientEvent(var5, var6, var7, var8, var9, var10, var4);
      this.dataEvent = (CDataEvent)var2;
   }

   public void createTimeEvent(CMsgInputStream var1) throws IOException, Exception {
      Object var2 = null;
      int var3 = var1.readInt();
      int var4 = var1.readInt();
      int var5 = var1.readInt();
      int var6 = var1.readInt();
      int var7 = var1.readInt();
      int var8 = var1.readInt();
      var1.close();
      var2 = new CInternalTimeEvent(var3, var4, var5, var6, var7, var8);
      this.dataEvent = (CDataEvent)var2;
   }

   public void createCertStateEvent(CMsgInputStream var1) throws IOException, Exception {
      Object var2 = null;
      int var3 = var1.readInt();
      var1.close();
      var2 = new CInternalCertStateEvent(var3);
      this.dataEvent = (CDataEvent)var2;
   }
}
