package amp.powerboard.clientapi.event;

import java.util.Enumeration;
import java.util.Vector;

public class CEventDispatcher implements IDataEventHandler, IStatusEventHandler, IReportEventHandler {
   private Vector dataListeners = new Vector(6, 6);
   private Vector statusListeners = new Vector(6, 6);
   private Vector reportListeners = new Vector(6, 6);

   public synchronized void fireDataEvent(CDataEvent var1) {
      if (this.dataListeners != null) {
         Enumeration var2 = this.dataListeners.elements();

         while (var2.hasMoreElements()) {
            IDataListener var3 = (IDataListener)var2.nextElement();
            if (var3 != null) {
               var3.commandDataArrived(var1);
            }
         }
      }
   }

   public synchronized void fireStatusEvent(CStatusEvent var1) {
      Enumeration var2 = this.statusListeners.elements();

      while (var2.hasMoreElements()) {
         IStatusListener var3 = (IStatusListener)var2.nextElement();
         var3.commandStatusArrived(var1);
      }
   }

   public synchronized void fireReportEvent(CReportEvent var1) {
      Enumeration var2 = this.reportListeners.elements();

      while (var2.hasMoreElements()) {
         IReportListener var3 = (IReportListener)var2.nextElement();
         var3.commandReportArrived(var1);
      }
   }

   public synchronized void addDataListener(IDataListener var1) {
      if (this.dataListeners.indexOf(var1) == -1) {
         this.dataListeners.addElement(var1);
      }
   }

   public synchronized void removeDataListener(IDataListener var1) {
      if (this.dataListeners.indexOf(var1) != -1) {
         this.dataListeners.removeElement(var1);
      }
   }

   public synchronized void addStatusListener(IStatusListener var1) {
      if (this.statusListeners.indexOf(var1) == -1) {
         this.statusListeners.addElement(var1);
      }
   }

   public synchronized void removeStatusListener(IStatusListener var1) {
      if (this.statusListeners.indexOf(var1) != -1) {
         this.statusListeners.removeElement(var1);
      }
   }

   public synchronized void addReportListener(IReportListener var1) {
      if (this.reportListeners.indexOf(var1) == -1) {
         this.reportListeners.addElement(var1);
      }
   }

   public synchronized void removeReportListener(IReportListener var1) {
      if (this.reportListeners.indexOf(var1) != -1) {
         this.reportListeners.removeElement(var1);
      }
   }

   public synchronized void releaseResources() {
      this.dataListeners.removeAllElements();
      this.statusListeners.removeAllElements();
      this.reportListeners.removeAllElements();
      this.dataListeners = null;
      this.statusListeners = null;
      this.reportListeners = null;
   }

   public synchronized IDataListener[] getDataListeners() {
      int var1 = this.dataListeners.size();
      IDataListener[] var2 = new IDataListener[var1];
      this.dataListeners.copyInto(var2);
      return var2;
   }

   public synchronized IStatusListener[] getStatusListeners() {
      int var1 = this.statusListeners.size();
      IStatusListener[] var2 = new IStatusListener[var1];
      this.statusListeners.copyInto(var2);
      return var2;
   }
}
