package amp.powerboard.clientapi.event;

import amp.powerboard.clientapi.net.CMsgInputStream;
import java.io.IOException;

public class CEventGenerator implements IGenerateEvent {
   private CEventDispatcher eventDispatcher;
   private int msgopCode;
   private String platform;
   private String subPlatform;

   public CEventGenerator(CEventDispatcher var1) {
      this.eventDispatcher = var1;
   }

   public CEventGenerator(CEventDispatcher var1, String var2) {
      this.platform = var2;
      this.eventDispatcher = var1;
   }

   public CEventGenerator(CEventDispatcher var1, String var2, String var3) {
      this.platform = var2;
      this.eventDispatcher = var1;
      this.subPlatform = var3;
   }

   public void generateKillEventObject() {
      if (this.eventDispatcher != null) {
         this.eventDispatcher.fireDataEvent(new CKillEvent("You have been logged off."));
      }
   }

   public void generateEventObject(CMsgInputStream var1, boolean var2) {
      if (var1 == null) {
         CInternalEvent var6 = new CInternalEvent(0, 1, "YOUR SESSION CLOSED");
         if (this.eventDispatcher != null) {
            this.eventDispatcher.fireDataEvent(var6);
         }
      } else {
         this.msgopCode = var1.opCode;
         switch (this.msgopCode) {
            case 1:
               try {
                  CDataEventCreator var135 = new CDataEventCreator(this.msgopCode);
                  var135.createUserInfoEvent(var1);
                  if (this.eventDispatcher != null) {
                     this.eventDispatcher.fireDataEvent(var135.getDataEvent());
                  }
               } catch (IOException var104) {
                  CInternalEvent var247 = new CInternalEvent(this.msgopCode, 2, "Error In Reading Data");
                  if (this.eventDispatcher != null) {
                     this.eventDispatcher.fireDataEvent(var247);
                  }
               } catch (Exception var105) {
                  CInternalEvent var200 = new CInternalEvent(this.msgopCode, 3, "Illegal Data Format");
                  if (this.eventDispatcher != null) {
                     this.eventDispatcher.fireDataEvent(var200);
                  }
               }
               break;
            case 2:
               try {
                  CDataEventCreator var134 = new CDataEventCreator(this.msgopCode);
                  var134.createResetEvent(var1);
                  if (this.eventDispatcher != null) {
                     this.eventDispatcher.fireDataEvent(var134.getDataEvent());
                  }
               } catch (IOException var100) {
                  CInternalEvent var246 = new CInternalEvent(this.msgopCode, 2, "Error In Reading Data");
                  if (this.eventDispatcher != null) {
                     this.eventDispatcher.fireDataEvent(var246);
                  }
               } catch (Exception var101) {
                  CInternalEvent var199 = new CInternalEvent(this.msgopCode, 3, "Illegal Data Format");
                  if (this.eventDispatcher != null) {
                     this.eventDispatcher.fireDataEvent(var199);
                  }
               }
               break;
            case 3:
               try {
                  CStatusEventCreator var153 = new CStatusEventCreator(this.msgopCode);
                  var153.createGenericStatusEvent(var1);
                  if (this.eventDispatcher != null) {
                     this.eventDispatcher.fireStatusEvent(var153.getStatusEvent());
                  }
               } catch (IOException var32) {
                  CInternalEvent var245 = new CInternalEvent(this.msgopCode, 2, "Error In Reading Data");
                  if (this.eventDispatcher != null) {
                     this.eventDispatcher.fireDataEvent(var245);
                  }
               } catch (Exception var33) {
                  CInternalEvent var198 = new CInternalEvent(this.msgopCode, 3, "Illegal Data Format");
                  if (this.eventDispatcher != null) {
                     this.eventDispatcher.fireDataEvent(var198);
                  }
               }
               break;
            case 4:
               try {
                  CStatusEventCreator var152 = new CStatusEventCreator(this.msgopCode);
                  var152.createGenericStatusEvent(var1);
                  if (this.eventDispatcher != null) {
                     this.eventDispatcher.fireStatusEvent(var152.getStatusEvent());
                  }
               } catch (IOException var88) {
                  CInternalEvent var244 = new CInternalEvent(this.msgopCode, 2, "Error In Reading Data");
                  if (this.eventDispatcher != null) {
                     this.eventDispatcher.fireDataEvent(var244);
                  }
               } catch (Exception var89) {
                  CInternalEvent var197 = new CInternalEvent(this.msgopCode, 3, "Illegal Data Format");
                  if (this.eventDispatcher != null) {
                     this.eventDispatcher.fireDataEvent(var197);
                  }
               }
               break;
            case 5:
               try {
                  CDataEventCreator var133 = new CDataEventCreator(this.msgopCode);
                  var133.createNetworkEvent(var1, var2);
                  if (this.eventDispatcher != null) {
                     this.eventDispatcher.fireDataEvent(var133.getDataEvent());
                  }
               } catch (IOException var90) {
                  var90.printStackTrace();
                  CInternalEvent var243 = new CInternalEvent(this.msgopCode, 2, "Error In Reading Data");
                  if (this.eventDispatcher != null) {
                     this.eventDispatcher.fireDataEvent(var243);
                  }
               } catch (Exception var91) {
                  CInternalEvent var196 = new CInternalEvent(this.msgopCode, 3, "Illegal Data Format");
                  if (this.eventDispatcher != null) {
                     this.eventDispatcher.fireDataEvent(var196);
                  }
               }
               break;
            case 8:
               try {
                  CStatusEventCreator var151 = new CStatusEventCreator(this.msgopCode);
                  var151.createSetUserEvent(var1);
                  if (this.eventDispatcher != null) {
                     this.eventDispatcher.fireStatusEvent(var151.getStatusEvent());
                  }
               } catch (IOException var42) {
                  CInternalEvent var242 = new CInternalEvent(this.msgopCode, 2, "Error In Reading Data");
                  if (this.eventDispatcher != null) {
                     this.eventDispatcher.fireDataEvent(var242);
                  }
               } catch (Exception var43) {
                  CInternalEvent var195 = new CInternalEvent(this.msgopCode, 3, "Illegal Data Format");
                  if (this.eventDispatcher != null) {
                     this.eventDispatcher.fireDataEvent(var195);
                  }
               }
               break;
            case 9:
               try {
                  CDataEventCreator var132 = new CDataEventCreator(this.msgopCode);
                  var132.createGetUserEvent(var1);
                  if (this.eventDispatcher != null) {
                     this.eventDispatcher.fireDataEvent(var132.getDataEvent());
                  }
               } catch (IOException var44) {
                  CInternalEvent var241 = new CInternalEvent(this.msgopCode, 2, "Error In Reading Data");
                  if (this.eventDispatcher != null) {
                     this.eventDispatcher.fireDataEvent(var241);
                  }
               } catch (Exception var45) {
                  CInternalEvent var194 = new CInternalEvent(this.msgopCode, 3, "Illegal Data Format");
                  if (this.eventDispatcher != null) {
                     this.eventDispatcher.fireDataEvent(var194);
                  }
               }
               break;
            case 10:
               try {
                  CStatusEventCreator var150 = new CStatusEventCreator(this.msgopCode);
                  var150.createGenericStatusEvent(var1);
                  if (this.eventDispatcher != null) {
                     this.eventDispatcher.fireStatusEvent(var150.getStatusEvent());
                  }
               } catch (IOException var40) {
                  CInternalEvent var240 = new CInternalEvent(this.msgopCode, 2, "Error In Reading Data");
                  if (this.eventDispatcher != null) {
                     this.eventDispatcher.fireDataEvent(var240);
                  }
               } catch (Exception var41) {
                  CInternalEvent var193 = new CInternalEvent(this.msgopCode, 3, "Illegal Data Format");
                  if (this.eventDispatcher != null) {
                     this.eventDispatcher.fireDataEvent(var193);
                  }
               }
               break;
            case 11:
               try {
                  CStatusEventCreator var149 = new CStatusEventCreator(this.msgopCode);
                  var149.createGenericStatusEvent(var1);
                  if (this.eventDispatcher != null) {
                     this.eventDispatcher.fireStatusEvent(var149.getStatusEvent());
                  }
               } catch (IOException var46) {
                  CInternalEvent var239 = new CInternalEvent(this.msgopCode, 2, "Error In Reading Data");
                  if (this.eventDispatcher != null) {
                     this.eventDispatcher.fireDataEvent(var239);
                  }
               } catch (Exception var47) {
                  CInternalEvent var192 = new CInternalEvent(this.msgopCode, 3, "Illegal Data Format");
                  if (this.eventDispatcher != null) {
                     this.eventDispatcher.fireDataEvent(var192);
                  }
               }
               break;
            case 12:
               try {
                  CDataEventCreator var131 = new CDataEventCreator(this.msgopCode, this.platform);
                  var131.createGetDataComAndSystemEvent(var1);
                  if (this.eventDispatcher != null) {
                     this.eventDispatcher.fireDataEvent(var131.getDataEvent());
                  }
               } catch (IOException var48) {
                  CInternalEvent var238 = new CInternalEvent(this.msgopCode, 2, "Error In Reading Data");
                  if (this.eventDispatcher != null) {
                     this.eventDispatcher.fireDataEvent(var238);
                  }
               } catch (Exception var49) {
                  CInternalEvent var191 = new CInternalEvent(this.msgopCode, 3, "Illegal Data Format");
                  if (this.eventDispatcher != null) {
                     this.eventDispatcher.fireDataEvent(var191);
                  }
               }
               break;
            case 13:
               try {
                  CDataEventCreator var130 = new CDataEventCreator(this.msgopCode, this.platform, this.subPlatform);
                  var130.createLoginInfoEvent(var1);
                  if (this.eventDispatcher != null) {
                     this.eventDispatcher.fireDataEvent(var130.getDataEvent());
                  }
               } catch (IOException var102) {
                  CInternalEvent var237 = new CInternalEvent(this.msgopCode, 2, "Error In Reading Data");
                  if (this.eventDispatcher != null) {
                     this.eventDispatcher.fireDataEvent(var237);
                  }
               } catch (Exception var103) {
                  var103.printStackTrace();
                  CInternalEvent var190 = new CInternalEvent(this.msgopCode, 3, "Illegal Data Format");
                  if (this.eventDispatcher != null) {
                     this.eventDispatcher.fireDataEvent(var190);
                  }
               }
               break;
            case 14:
               try {
                  CDataEventCreator var129 = new CDataEventCreator(this.msgopCode);
                  var129.createUpgradeReportEvent(var1);
                  if (this.eventDispatcher != null) {
                     this.eventDispatcher.fireDataEvent(var129.getDataEvent());
                  }
               } catch (IOException var30) {
                  CInternalEvent var236 = new CInternalEvent(this.msgopCode, 2, "Error In Reading Data");
                  if (this.eventDispatcher != null) {
                     this.eventDispatcher.fireDataEvent(var236);
                  }
               } catch (Exception var31) {
                  CInternalEvent var189 = new CInternalEvent(this.msgopCode, 3, "Illegal Data Format");
                  if (this.eventDispatcher != null) {
                     this.eventDispatcher.fireDataEvent(var189);
                  }
               }
               break;
            case 15:
               try {
                  CDataEventCreator var128 = new CDataEventCreator(this.msgopCode);
                  var128.createConfigLockEvent(var1);
                  if (this.eventDispatcher != null) {
                     this.eventDispatcher.fireDataEvent(var128.getDataEvent());
                  }
               } catch (IOException var98) {
                  CInternalEvent var235 = new CInternalEvent(this.msgopCode, 2, "Error In Reading Data");
                  if (this.eventDispatcher != null) {
                     this.eventDispatcher.fireDataEvent(var235);
                  }
               } catch (Exception var99) {
                  CInternalEvent var188 = new CInternalEvent(this.msgopCode, 3, "Illegal Data Format");
                  if (this.eventDispatcher != null) {
                     this.eventDispatcher.fireDataEvent(var188);
                  }
               }
               break;
            case 16:
               try {
                  CStatusEventCreator var148 = new CStatusEventCreator(this.msgopCode);
                  var148.createGenericStatusEvent(var1);
                  if (this.eventDispatcher != null) {
                     this.eventDispatcher.fireStatusEvent(var148.getStatusEvent());
                  }
               } catch (IOException var96) {
                  CInternalEvent var234 = new CInternalEvent(this.msgopCode, 2, "Error In Reading Data");
                  if (this.eventDispatcher != null) {
                     this.eventDispatcher.fireDataEvent(var234);
                  }
               } catch (Exception var97) {
                  CInternalEvent var187 = new CInternalEvent(this.msgopCode, 3, "Illegal Data Format");
                  if (this.eventDispatcher != null) {
                     this.eventDispatcher.fireDataEvent(var187);
                  }
               }
               break;
            case 17:
               try {
                  CDataEventCreator var127 = new CDataEventCreator(this.msgopCode);
                  var127.createKillEvent(var1);
                  if (this.eventDispatcher != null) {
                     this.eventDispatcher.fireDataEvent(var127.getDataEvent());
                  }
               } catch (IOException var34) {
                  CInternalEvent var233 = new CInternalEvent(this.msgopCode, 2, "Error In Reading Data");
                  if (this.eventDispatcher != null) {
                     this.eventDispatcher.fireDataEvent(var233);
                  }
               } catch (Exception var35) {
                  CInternalEvent var186 = new CInternalEvent(this.msgopCode, 3, "Illegal Data Format");
                  if (this.eventDispatcher != null) {
                     this.eventDispatcher.fireDataEvent(var186);
                  }
               }
               break;
            case 18:
               try {
                  CDataEventCreator var126 = new CDataEventCreator(this.msgopCode);
                  var126.createVersionReportEvent(var1);
                  if (this.eventDispatcher != null) {
                     this.eventDispatcher.fireDataEvent(var126.getDataEvent());
                  }
               } catch (IOException var94) {
                  CInternalEvent var232 = new CInternalEvent(this.msgopCode, 2, "Error In Reading Data");
                  if (this.eventDispatcher != null) {
                     this.eventDispatcher.fireDataEvent(var232);
                  }
               } catch (Exception var95) {
                  CInternalEvent var185 = new CInternalEvent(this.msgopCode, 3, "Illegal Data Format");
                  if (this.eventDispatcher != null) {
                     this.eventDispatcher.fireDataEvent(var185);
                  }
               }
               break;
            case 19:
               try {
                  CDataEventCreator var125 = new CDataEventCreator(this.msgopCode);
                  var125.createConfigReportEvent(var1);
                  if (this.eventDispatcher != null) {
                     this.eventDispatcher.fireDataEvent(var125.getDataEvent());
                  }
               } catch (IOException var92) {
                  CInternalEvent var231 = new CInternalEvent(this.msgopCode, 2, "Error In Reading Data");
                  if (this.eventDispatcher != null) {
                     this.eventDispatcher.fireDataEvent(var231);
                  }
               } catch (Exception var93) {
                  CInternalEvent var184 = new CInternalEvent(this.msgopCode, 3, "Illegal Data Format");
                  if (this.eventDispatcher != null) {
                     this.eventDispatcher.fireDataEvent(var184);
                  }
               }
               break;
            case 20:
               try {
                  CDataEventCreator var124 = new CDataEventCreator(this.msgopCode);
                  var124.createGetUserListEvent(var1);
                  if (this.eventDispatcher != null) {
                     this.eventDispatcher.fireDataEvent(var124.getDataEvent());
                  }
               } catch (IOException var38) {
                  CInternalEvent var230 = new CInternalEvent(this.msgopCode, 2, "Error In Reading Data");
                  if (this.eventDispatcher != null) {
                     this.eventDispatcher.fireDataEvent(var230);
                  }
               } catch (Exception var39) {
                  CInternalEvent var183 = new CInternalEvent(this.msgopCode, 3, "Illegal Data Format");
                  if (this.eventDispatcher != null) {
                     this.eventDispatcher.fireDataEvent(var183);
                  }
               }
               break;
            case 23:
               try {
                  CStatusEventCreator var147 = new CStatusEventCreator(this.msgopCode);
                  var147.createGenericStatusEvent(var1);
                  if (this.eventDispatcher != null) {
                     this.eventDispatcher.fireStatusEvent(var147.getStatusEvent());
                  }
               } catch (IOException var54) {
                  CInternalEvent var229 = new CInternalEvent(this.msgopCode, 2, "Error In Reading Data");
                  if (this.eventDispatcher != null) {
                     this.eventDispatcher.fireDataEvent(var229);
                  }
               } catch (Exception var55) {
                  var55.printStackTrace();
                  CInternalEvent var182 = new CInternalEvent(this.msgopCode, 3, "Illegal Data Format");
                  if (this.eventDispatcher != null) {
                     this.eventDispatcher.fireDataEvent(var182);
                  }
               }
               break;
            case 24:
               try {
                  CStatusEventCreator var146 = new CStatusEventCreator(this.msgopCode);
                  var146.createGenericStatusEvent(var1);
                  if (this.eventDispatcher != null) {
                     this.eventDispatcher.fireStatusEvent(var146.getStatusEvent());
                  }
               } catch (IOException var52) {
                  CInternalEvent var228 = new CInternalEvent(this.msgopCode, 2, "Error In Reading Data");
                  if (this.eventDispatcher != null) {
                     this.eventDispatcher.fireDataEvent(var228);
                  }
               } catch (Exception var53) {
                  var53.printStackTrace();
                  CInternalEvent var181 = new CInternalEvent(this.msgopCode, 3, "Illegal Data Format");
                  if (this.eventDispatcher != null) {
                     this.eventDispatcher.fireDataEvent(var181);
                  }
               }
               break;
            case 25:
               try {
                  CDataEventCreator var123 = new CDataEventCreator(this.msgopCode);
                  var123.createIPACLListEvent(var1);
                  if (this.eventDispatcher != null) {
                     this.eventDispatcher.fireDataEvent(var123.getDataEvent());
                  }
               } catch (IOException var50) {
                  CInternalEvent var227 = new CInternalEvent(this.msgopCode, 2, "Error In Reading Data");
                  if (this.eventDispatcher != null) {
                     this.eventDispatcher.fireDataEvent(var227);
                  }
               } catch (Exception var51) {
                  var51.printStackTrace();
                  CInternalEvent var180 = new CInternalEvent(this.msgopCode, 3, "Illegal Data Format");
                  if (this.eventDispatcher != null) {
                     this.eventDispatcher.fireDataEvent(var180);
                  }
               }
               break;
            case 26:
               try {
                  CStatusEventCreator var145 = new CStatusEventCreator(this.msgopCode);
                  var145.createGenericStatusEvent(var1);
                  if (this.eventDispatcher != null) {
                     this.eventDispatcher.fireStatusEvent(var145.getStatusEvent());
                  }
               } catch (IOException var84) {
                  CInternalEvent var226 = new CInternalEvent(this.msgopCode, 2, "Error In Reading Data");
                  if (this.eventDispatcher != null) {
                     this.eventDispatcher.fireDataEvent(var226);
                  }
               } catch (Exception var85) {
                  var85.printStackTrace();
                  CInternalEvent var179 = new CInternalEvent(this.msgopCode, 3, "Illegal Data Format");
                  if (this.eventDispatcher != null) {
                     this.eventDispatcher.fireDataEvent(var179);
                  }
               }
               break;
            case 27:
               try {
                  CDataEventCreator var122 = new CDataEventCreator(this.msgopCode);
                  var122.createHWMonitoringEvent(var1);
                  if (this.eventDispatcher != null) {
                     this.eventDispatcher.fireDataEvent(var122.getDataEvent());
                  }
               } catch (IOException var86) {
                  CInternalEvent var225 = new CInternalEvent(this.msgopCode, 2, "Error In Reading Data");
                  if (this.eventDispatcher != null) {
                     this.eventDispatcher.fireDataEvent(var225);
                  }
               } catch (Exception var87) {
                  var87.printStackTrace();
                  CInternalEvent var178 = new CInternalEvent(this.msgopCode, 3, "Illegal Data Format");
                  if (this.eventDispatcher != null) {
                     this.eventDispatcher.fireDataEvent(var178);
                  }
               }
               break;
            case 28:
               try {
                  CStatusEventCreator var144 = new CStatusEventCreator(this.msgopCode);
                  var144.createGenericStatusEvent(var1);
                  if (this.eventDispatcher != null) {
                     this.eventDispatcher.fireStatusEvent(var144.getStatusEvent());
                  }
               } catch (IOException var80) {
                  CInternalEvent var224 = new CInternalEvent(this.msgopCode, 2, "Error In Reading Data");
                  if (this.eventDispatcher != null) {
                     this.eventDispatcher.fireDataEvent(var224);
                  }
               } catch (Exception var81) {
                  var81.printStackTrace();
                  CInternalEvent var177 = new CInternalEvent(this.msgopCode, 3, "Illegal Data Format");
                  if (this.eventDispatcher != null) {
                     this.eventDispatcher.fireDataEvent(var177);
                  }
               }
               break;
            case 29:
               try {
                  CDataEventCreator var121 = new CDataEventCreator(this.msgopCode);
                  var121.createPingMonitoringEvent(var1);
                  if (this.eventDispatcher != null) {
                     this.eventDispatcher.fireDataEvent(var121.getDataEvent());
                  }
               } catch (IOException var82) {
                  CInternalEvent var223 = new CInternalEvent(this.msgopCode, 2, "Error In Reading Data");
                  if (this.eventDispatcher != null) {
                     this.eventDispatcher.fireDataEvent(var223);
                  }
               } catch (Exception var83) {
                  var83.printStackTrace();
                  CInternalEvent var176 = new CInternalEvent(this.msgopCode, 3, "Illegal Data Format");
                  if (this.eventDispatcher != null) {
                     this.eventDispatcher.fireDataEvent(var176);
                  }
               }
               break;
            case 30:
            case 31:
            case 32:
            case 33:
               try {
                  CStatusEventCreator var143 = new CStatusEventCreator(this.msgopCode);
                  var143.createGenericStatusEvent(var1);
                  if (this.eventDispatcher != null) {
                     this.eventDispatcher.fireStatusEvent(var143.getStatusEvent());
                  }
               } catch (IOException var26) {
                  CInternalEvent var222 = new CInternalEvent(this.msgopCode, 2, "Error In Reading Data");
                  if (this.eventDispatcher != null) {
                     this.eventDispatcher.fireDataEvent(var222);
                  }
               } catch (Exception var27) {
                  CInternalEvent var175 = new CInternalEvent(this.msgopCode, 3, "Illegal Data Format");
                  if (this.eventDispatcher != null) {
                     this.eventDispatcher.fireDataEvent(var175);
                  }
               }
               break;
            case 34:
               try {
                  CStatusEventCreator var142 = new CStatusEventCreator(this.msgopCode);
                  var142.createGenericStatusEvent(var1);
                  if (this.eventDispatcher != null) {
                     this.eventDispatcher.fireStatusEvent(var142.getStatusEvent());
                  }
               } catch (IOException var68) {
                  CInternalEvent var221 = new CInternalEvent(this.msgopCode, 2, "Error In Reading Data");
                  if (this.eventDispatcher != null) {
                     this.eventDispatcher.fireDataEvent(var221);
                  }
               } catch (Exception var69) {
                  var69.printStackTrace();
                  CInternalEvent var174 = new CInternalEvent(this.msgopCode, 3, "Illegal Data Format");
                  if (this.eventDispatcher != null) {
                     this.eventDispatcher.fireDataEvent(var174);
                  }
               }
               break;
            case 35:
               try {
                  CStatusEventCreator var141 = new CStatusEventCreator(this.msgopCode);
                  var141.createGenericStatusEvent(var1);
                  if (this.eventDispatcher != null) {
                     this.eventDispatcher.fireStatusEvent(var141.getStatusEvent());
                  }
               } catch (IOException var66) {
                  CInternalEvent var220 = new CInternalEvent(this.msgopCode, 2, "Error In Reading Data");
                  if (this.eventDispatcher != null) {
                     this.eventDispatcher.fireDataEvent(var220);
                  }
               } catch (Exception var67) {
                  var67.printStackTrace();
                  CInternalEvent var173 = new CInternalEvent(this.msgopCode, 3, "Illegal Data Format");
                  if (this.eventDispatcher != null) {
                     this.eventDispatcher.fireDataEvent(var173);
                  }
               }
               break;
            case 36:
               try {
                  CDataEventCreator var120 = new CDataEventCreator(this.msgopCode);
                  var120.createSubscriptionEvent(var1);
                  if (this.eventDispatcher != null) {
                     this.eventDispatcher.fireDataEvent(var120.getDataEvent());
                  }
               } catch (IOException var64) {
                  CInternalEvent var219 = new CInternalEvent(this.msgopCode, 2, "Error In Reading Data");
                  if (this.eventDispatcher != null) {
                     this.eventDispatcher.fireDataEvent(var219);
                  }
               } catch (Exception var65) {
                  var65.printStackTrace();
                  CInternalEvent var172 = new CInternalEvent(this.msgopCode, 3, "Illegal Data Format");
                  if (this.eventDispatcher != null) {
                     this.eventDispatcher.fireDataEvent(var172);
                  }
               }
               break;
            case 37:
               try {
                  CStatusEventCreator var140 = new CStatusEventCreator(this.msgopCode);
                  var140.createGenericStatusEvent(var1);
                  if (this.eventDispatcher != null) {
                     this.eventDispatcher.fireStatusEvent(var140.getStatusEvent());
                  }
               } catch (IOException var62) {
                  CInternalEvent var218 = new CInternalEvent(this.msgopCode, 2, "Error In Reading Data");
                  if (this.eventDispatcher != null) {
                     this.eventDispatcher.fireDataEvent(var218);
                  }
               } catch (Exception var63) {
                  var63.printStackTrace();
                  CInternalEvent var171 = new CInternalEvent(this.msgopCode, 3, "Illegal Data Format");
                  if (this.eventDispatcher != null) {
                     this.eventDispatcher.fireDataEvent(var171);
                  }
               }
               break;
            case 38:
               try {
                  CDataEventCreator var119 = new CDataEventCreator(this.msgopCode);
                  var119.createGetSMTPServerEvent(var1);
                  if (this.eventDispatcher != null) {
                     this.eventDispatcher.fireDataEvent(var119.getDataEvent());
                  }
               } catch (IOException var60) {
                  CInternalEvent var217 = new CInternalEvent(this.msgopCode, 2, "Error In Reading Data");
                  if (this.eventDispatcher != null) {
                     this.eventDispatcher.fireDataEvent(var217);
                  }
               } catch (Exception var61) {
                  var61.printStackTrace();
                  CInternalEvent var170 = new CInternalEvent(this.msgopCode, 3, "Illegal Data Format");
                  if (this.eventDispatcher != null) {
                     this.eventDispatcher.fireDataEvent(var170);
                  }
               }
               break;
            case 39:
               try {
                  CStatusEventCreator var139 = new CStatusEventCreator(this.msgopCode);
                  var139.createGenericStatusEvent(var1);
                  if (this.eventDispatcher != null) {
                     this.eventDispatcher.fireStatusEvent(var139.getStatusEvent());
                  }
               } catch (IOException var58) {
                  CInternalEvent var216 = new CInternalEvent(this.msgopCode, 2, "Error In Reading Data");
                  if (this.eventDispatcher != null) {
                     this.eventDispatcher.fireDataEvent(var216);
                  }
               } catch (Exception var59) {
                  var59.printStackTrace();
                  CInternalEvent var169 = new CInternalEvent(this.msgopCode, 3, "Illegal Data Format");
                  if (this.eventDispatcher != null) {
                     this.eventDispatcher.fireDataEvent(var169);
                  }
               }
               break;
            case 40:
               try {
                  CDataEventCreator var118 = new CDataEventCreator(this.msgopCode);
                  var118.createGetSNMPAgentEvent(var1);
                  if (this.eventDispatcher != null) {
                     this.eventDispatcher.fireDataEvent(var118.getDataEvent());
                  }
               } catch (IOException var56) {
                  CInternalEvent var215 = new CInternalEvent(this.msgopCode, 2, "Error In Reading Data");
                  if (this.eventDispatcher != null) {
                     this.eventDispatcher.fireDataEvent(var215);
                  }
               } catch (Exception var57) {
                  var57.printStackTrace();
                  CInternalEvent var168 = new CInternalEvent(this.msgopCode, 3, "Illegal Data Format");
                  if (this.eventDispatcher != null) {
                     this.eventDispatcher.fireDataEvent(var168);
                  }
               }
               break;
            case 43:
            case 46:
            case 48:
            case 50:
            case 61:
            case 62:
               try {
                  CStatusEventCreator var138 = new CStatusEventCreator(this.msgopCode);
                  var138.createGenericStatusEvent(var1);
                  if (this.eventDispatcher != null) {
                     this.eventDispatcher.fireStatusEvent(var138.getStatusEvent());
                  }
               } catch (IOException var20) {
                  CInternalEvent var214 = new CInternalEvent(this.msgopCode, 2, "Error In Reading Data");
                  if (this.eventDispatcher != null) {
                     this.eventDispatcher.fireDataEvent(var214);
                  }
               } catch (Exception var21) {
                  var21.printStackTrace();
                  CInternalEvent var167 = new CInternalEvent(this.msgopCode, 3, "Illegal Data Format");
                  if (this.eventDispatcher != null) {
                     this.eventDispatcher.fireDataEvent(var167);
                  }
               }
               break;
            case 44:
               try {
                  CDataEventCreator var117 = new CDataEventCreator(this.msgopCode);
                  var117.createCertificateEvent(var1);
                  if (this.eventDispatcher != null) {
                     this.eventDispatcher.fireDataEvent(var117.getDataEvent());
                  }
               } catch (IOException var22) {
                  CInternalEvent var213 = new CInternalEvent(this.msgopCode, 2, "Error In Reading Data");
                  if (this.eventDispatcher != null) {
                     this.eventDispatcher.fireDataEvent(var213);
                  }
               } catch (Exception var23) {
                  var23.printStackTrace();
                  CInternalEvent var166 = new CInternalEvent(this.msgopCode, 3, "Illegal Data Format");
                  if (this.eventDispatcher != null) {
                     this.eventDispatcher.fireDataEvent(var166);
                  }
               }
               break;
            case 45:
               try {
                  CDataEventCreator var116 = new CDataEventCreator(this.msgopCode);
                  var116.createCertStateEvent(var1);
                  if (this.eventDispatcher != null) {
                     this.eventDispatcher.fireDataEvent(var116.getDataEvent());
                  }
               } catch (IOException var12) {
                  CInternalEvent var212 = new CInternalEvent(this.msgopCode, 2, "Error In Reading Data");
                  if (this.eventDispatcher != null) {
                     this.eventDispatcher.fireDataEvent(var212);
                  }
               } catch (Exception var13) {
                  var13.printStackTrace();
                  CInternalEvent var165 = new CInternalEvent(this.msgopCode, 3, "Illegal Data Format");
                  if (this.eventDispatcher != null) {
                     this.eventDispatcher.fireDataEvent(var165);
                  }
               }
               break;
            case 47:
               try {
                  CDataEventCreator var115 = new CDataEventCreator(this.msgopCode);
                  var115.createTimeEvent(var1);
                  if (this.eventDispatcher != null) {
                     this.eventDispatcher.fireDataEvent(var115.getDataEvent());
                  }
               } catch (IOException var14) {
                  CInternalEvent var211 = new CInternalEvent(this.msgopCode, 2, "Error In Reading Data");
                  if (this.eventDispatcher != null) {
                     this.eventDispatcher.fireDataEvent(var211);
                  }
               } catch (Exception var15) {
                  var15.printStackTrace();
                  CInternalEvent var164 = new CInternalEvent(this.msgopCode, 3, "Illegal Data Format");
                  if (this.eventDispatcher != null) {
                     this.eventDispatcher.fireDataEvent(var164);
                  }
               }
               break;
            case 49:
               try {
                  CDataEventCreator var114 = new CDataEventCreator(this.msgopCode);
                  var114.createRadClientEvent(var1);
                  if (this.eventDispatcher != null) {
                     this.eventDispatcher.fireDataEvent(var114.getDataEvent());
                  }
               } catch (IOException var16) {
                  CInternalEvent var210 = new CInternalEvent(this.msgopCode, 2, "Error In Reading Data");
                  if (this.eventDispatcher != null) {
                     this.eventDispatcher.fireDataEvent(var210);
                  }
               } catch (Exception var17) {
                  var17.printStackTrace();
                  CInternalEvent var163 = new CInternalEvent(this.msgopCode, 3, "Illegal Data Format");
                  if (this.eventDispatcher != null) {
                     this.eventDispatcher.fireDataEvent(var163);
                  }
               }
               break;
            case 60:
               try {
                  CDataEventCreator var113 = new CDataEventCreator(this.msgopCode);
                  var113.createModemEvent(var1);
                  if (this.eventDispatcher != null) {
                     this.eventDispatcher.fireDataEvent(var113.getDataEvent());
                  }
               } catch (IOException var18) {
                  CInternalEvent var209 = new CInternalEvent(this.msgopCode, 2, "Error In Reading Data");
                  if (this.eventDispatcher != null) {
                     this.eventDispatcher.fireDataEvent(var209);
                  }
               } catch (Exception var19) {
                  var19.printStackTrace();
                  CInternalEvent var162 = new CInternalEvent(this.msgopCode, 3, "Illegal Data Format");
                  if (this.eventDispatcher != null) {
                     this.eventDispatcher.fireDataEvent(var162);
                  }
               }
               break;
            case 500:
               try {
                  CDataEventCreator var112 = new CDataEventCreator(this.msgopCode);
                  var112.createRequestSessionIdEvent(var1);
                  if (this.eventDispatcher != null) {
                     this.eventDispatcher.fireDataEvent(var112.getDataEvent());
                  }
               } catch (IOException var28) {
                  CInternalEvent var208 = new CInternalEvent(this.msgopCode, 2, "Error In Reading Data");
                  if (this.eventDispatcher != null) {
                     this.eventDispatcher.fireDataEvent(var208);
                  }
               } catch (Exception var29) {
                  CInternalEvent var161 = new CInternalEvent(this.msgopCode, 3, "Illegal Data Format");
                  if (this.eventDispatcher != null) {
                     this.eventDispatcher.fireDataEvent(var161);
                  }
               }
               break;
            case 1501:
               try {
                  CDataEventCreator var111 = new CDataEventCreator(this.msgopCode);
                  var111.createChatEvent(var1);
                  if (this.eventDispatcher != null) {
                     this.eventDispatcher.fireDataEvent(var111.getDataEvent());
                  }
               } catch (IOException var36) {
                  CInternalEvent var207 = new CInternalEvent(this.msgopCode, 2, "Error In Reading Data");
                  if (this.eventDispatcher != null) {
                     this.eventDispatcher.fireDataEvent(var207);
                  }
               } catch (Exception var37) {
                  CInternalEvent var160 = new CInternalEvent(this.msgopCode, 3, "Illegal Data Format");
                  if (this.eventDispatcher != null) {
                     this.eventDispatcher.fireDataEvent(var160);
                  }
               }
               break;
            case 1503:
               try {
                  CDataEventCreator var110 = new CDataEventCreator(this.msgopCode);
                  var110.createClientListEvent(var1);
                  if (this.eventDispatcher != null) {
                     this.eventDispatcher.fireDataEvent(var110.getDataEvent());
                  }
               } catch (IOException var106) {
                  CInternalEvent var206 = new CInternalEvent(this.msgopCode, 2, "Error In Reading Data");
                  if (this.eventDispatcher != null) {
                     this.eventDispatcher.fireDataEvent(var206);
                  }
               } catch (Exception var107) {
                  var107.printStackTrace();
                  CInternalEvent var159 = new CInternalEvent(this.msgopCode, 3, "Illegal Data Format");
                  if (this.eventDispatcher != null) {
                     this.eventDispatcher.fireDataEvent(var159);
                  }
               }
               break;
            case 1505:
               try {
                  CStatusEventCreator var137 = new CStatusEventCreator(this.msgopCode);
                  var137.createGenericStatusEvent(var1);
                  if (this.eventDispatcher != null) {
                     this.eventDispatcher.fireStatusEvent(var137.getStatusEvent());
                  }
               } catch (IOException var24) {
                  CInternalEvent var205 = new CInternalEvent(this.msgopCode, 2, "Error In Reading Data");
                  if (this.eventDispatcher != null) {
                     this.eventDispatcher.fireDataEvent(var205);
                  }
               } catch (Exception var25) {
                  CInternalEvent var158 = new CInternalEvent(this.msgopCode, 3, "Illegal Data Format");
                  if (this.eventDispatcher != null) {
                     this.eventDispatcher.fireDataEvent(var158);
                  }
               }
               break;
            case 3000:
               CInternalStatusEvent var9 = new CInternalStatusEvent(this.msgopCode, 0, 0);
               if (this.eventDispatcher != null) {
                  this.eventDispatcher.fireStatusEvent(var9);
               }
               break;
            case 4500:
               try {
                  CStatusEventCreator var136 = new CStatusEventCreator(this.msgopCode);
                  var136.createGenericStatusEvent(var1);
                  if (this.eventDispatcher != null) {
                     this.eventDispatcher.fireStatusEvent(var136.getStatusEvent());
                  }
               } catch (IOException var78) {
                  CInternalEvent var204 = new CInternalEvent(this.msgopCode, 2, "Error In Reading Data");
                  if (this.eventDispatcher != null) {
                     this.eventDispatcher.fireDataEvent(var204);
                  }
               } catch (Exception var79) {
                  var79.printStackTrace();
                  CInternalEvent var157 = new CInternalEvent(this.msgopCode, 3, "Illegal Data Format");
                  if (this.eventDispatcher != null) {
                     this.eventDispatcher.fireDataEvent(var157);
                  }
               }
               break;
            case 4501:
               try {
                  CDataEventCreator var109 = new CDataEventCreator(this.msgopCode);
                  var109.createTCLLoaderStatusEvent(var1);
                  if (this.eventDispatcher != null) {
                     this.eventDispatcher.fireDataEvent(var109.getDataEvent());
                  }
               } catch (IOException var76) {
                  CInternalEvent var203 = new CInternalEvent(this.msgopCode, 2, "Error In Reading Data");
                  if (this.eventDispatcher != null) {
                     this.eventDispatcher.fireDataEvent(var203);
                  }
               } catch (Exception var77) {
                  var77.printStackTrace();
                  CInternalEvent var156 = new CInternalEvent(this.msgopCode, 3, "Illegal Data Format");
                  if (this.eventDispatcher != null) {
                     this.eventDispatcher.fireDataEvent(var156);
                  }
               }
               break;
            case 4502:
               try {
                  CStatusEventCreator var4 = new CStatusEventCreator(this.msgopCode);
                  var4.createGenericStatusEvent(var1);
                  if (this.eventDispatcher != null) {
                     this.eventDispatcher.fireStatusEvent(var4.getStatusEvent());
                  }
               } catch (IOException var74) {
                  CInternalEvent var202 = new CInternalEvent(this.msgopCode, 2, "Error In Reading Data");
                  if (this.eventDispatcher != null) {
                     this.eventDispatcher.fireDataEvent(var202);
                  }
               } catch (Exception var75) {
                  var75.printStackTrace();
                  CInternalEvent var155 = new CInternalEvent(this.msgopCode, 3, "Illegal Data Format");
                  if (this.eventDispatcher != null) {
                     this.eventDispatcher.fireDataEvent(var155);
                  }
               }
               break;
            case 4503:
               try {
                  CDataEventCreator var108 = new CDataEventCreator(this.msgopCode);
                  var108.createTCLResponseEvent(var1);
                  if (this.eventDispatcher != null) {
                     this.eventDispatcher.fireDataEvent(var108.getDataEvent());
                  }
               } catch (IOException var72) {
                  CInternalEvent var201 = new CInternalEvent(this.msgopCode, 2, "Error In Reading Data");
                  if (this.eventDispatcher != null) {
                     this.eventDispatcher.fireDataEvent(var201);
                  }
               } catch (Exception var73) {
                  var73.printStackTrace();
                  CInternalEvent var154 = new CInternalEvent(this.msgopCode, 3, "Illegal Data Format");
                  if (this.eventDispatcher != null) {
                     this.eventDispatcher.fireDataEvent(var154);
                  }
               }
               break;
            case 4504:
               try {
                  CDataEventCreator var3 = new CDataEventCreator(this.msgopCode);
                  var3.createTCLPrintEvent(var1);
                  if (this.eventDispatcher != null) {
                     this.eventDispatcher.fireDataEvent(var3.getDataEvent());
                  }
               } catch (IOException var70) {
                  CInternalEvent var8 = new CInternalEvent(this.msgopCode, 2, "Error In Reading Data");
                  if (this.eventDispatcher != null) {
                     this.eventDispatcher.fireDataEvent(var8);
                  }
               } catch (Exception var71) {
                  var71.printStackTrace();
                  CInternalEvent var7 = new CInternalEvent(this.msgopCode, 3, "Illegal Data Format");
                  if (this.eventDispatcher != null) {
                     this.eventDispatcher.fireDataEvent(var7);
                  }
               }
               break;
            default:
               CInternalEvent var5 = new CInternalEvent(this.msgopCode, 4, "Undefined Opcode");
               if (this.eventDispatcher != null) {
                  this.eventDispatcher.fireDataEvent(var5);
               }
         }
      }
   }
}
