package amp.powerboard.clientapi.event;

public class CGetDataComAndSystemEvent extends CDataEvent {
   private int[] baudRate;
   private int[] chkParity;
   private int[] parityBits;
   private int[] recvPace;
   private int[] xmitPace;
   private String[] deviceName;
   private int[] port;
   private int numPorts = 0;
   private int[] hwFlowControl;

   public CGetDataComAndSystemEvent(int var1, int[] var2, int[] var3, int[] var4, int[] var5, int[] var6, String[] var7, int[] var8, boolean var9, String var10) {
      super(12, var9);
      this.numPorts = var1;
      this.baudRate = var2;
      this.chkParity = var3;
      this.parityBits = var4;
      this.recvPace = var5;
      this.xmitPace = var6;
      this.deviceName = var7;
      this.port = var8;
      super.lockerName = var10;
   }

   public CGetDataComAndSystemEvent(boolean var1, String var2) {
      super(12, var1);
      super.lockerName = var2;
   }

   public CGetDataComAndSystemEvent(
      int var1, int[] var2, int[] var3, int[] var4, int[] var5, int[] var6, String[] var7, int[] var8, int[] var9, boolean var10, String var11
   ) {
      this(var1, var2, var3, var4, var5, var6, var7, var8, var10, var11);
      this.hwFlowControl = var9;
   }

   public int getbaudRate() {
      return this.baudRate[0];
   }

   public int getchkParity() {
      return this.chkParity[0];
   }

   public int getparityBits() {
      return this.parityBits[0];
   }

   public int getrecvPace() {
      return this.recvPace[0];
   }

   public int getxmitPace() {
      return this.xmitPace[0];
   }

   public String getdeviceName() {
      return this.deviceName[0];
   }

   public int getport() {
      return this.port[0];
   }

   public void setDataComAndSystem(CInternalDataComAndSystemEvent var1) {
      int var2 = var1.getNumPortsX16();
      this.baudRate = new int[var2 != 0 ? var2 : 1];
      this.chkParity = new int[var2 != 0 ? var2 : 1];
      this.parityBits = new int[var2 != 0 ? var2 : 1];
      this.recvPace = new int[var2 != 0 ? var2 : 1];
      this.xmitPace = new int[var2 != 0 ? var2 : 1];
      this.deviceName = new String[var2 != 0 ? var2 : 1];
      this.port = new int[var2 != 0 ? var2 : 1];
      this.hwFlowControl = new int[var2 != 0 ? var2 : 1];
      if (var1.getNumPortsX16() == 0) {
         this.baudRate[0] = var1.getbaudRate();
         this.chkParity[0] = var1.getchkParity();
         this.parityBits[0] = var1.getparityBits();
         this.recvPace[0] = var1.getrecvPace();
         this.xmitPace[0] = var1.getxmitPace();
         this.deviceName[0] = var1.getdeviceName();
         this.port[0] = var1.getport();
      } else {
         this.numPorts = var1.getNumPortsX16();
         this.baudRate = var1.getbaudRateX16();
         this.chkParity = var1.getchkParityX16();
         this.parityBits = var1.getparityBitsX16();
         this.recvPace = var1.getrecvPaceX16();
         this.xmitPace = var1.getxmitPaceX16();
         this.deviceName = var1.getdeviceNameX16();
         this.port = var1.getportX16();
         this.hwFlowControl = var1.getHwFlowControl();
      }
   }

   public int[] getbaudRateX16() {
      return this.baudRate;
   }

   public int[] getchkParityX16() {
      return this.chkParity;
   }

   public int[] getparityBitsX16() {
      return this.parityBits;
   }

   public int[] getrecvPaceX16() {
      return this.recvPace;
   }

   public int[] getxmitPaceX16() {
      return this.xmitPace;
   }

   public String[] getdeviceNameX16() {
      return this.deviceName;
   }

   public int[] getportX16() {
      return this.port;
   }

   public int getNumPortsX16() {
      return this.numPorts;
   }

   public int[] getHwFlowControl() {
      return this.hwFlowControl;
   }
}
