package amp.powerboard.clientapi.net;

import java.io.ByteArrayInputStream;
import java.io.DataInputStream;
import java.io.EOFException;
import java.io.IOException;
import java.io.InputStream;

public class CMsgInputStream extends InputStream {
   public int opCode;
   private DataInputStream message;
   private ByteArrayInputStream buffer;

   public CMsgInputStream(InputStream var1) throws IOException {
      byte var2;
      byte[] var3;
      do {
         this.message = new DataInputStream(var1);
         int var4 = this.message.readInt();
         if (var4 < 0 || var4 > 100000) {
            System.out.println("length = " + var4);
            System.out.println("Wrong message length. Aborted!!");
            System.exit(1);
         }

         var3 = new byte[var4];
         int var5 = 0;
         int var6 = var3.length;

         while (var6 > 0) {
            var4 = var1.read(var3, var5, var6);
            if (var4 == -1) {
               throw new EOFException();
            }

            var5 += var4;
            var6 -= var4;
         }

         var2 = this.message.readByte();
      } while (var2 > 0);

      this.buffer = new ByteArrayInputStream(var3);
      this.message = new DataInputStream(this.buffer);
      this.opCode = this.message.readInt();
   }

   public void close() throws IOException {
      if (this.buffer.available() != 0) {
         throw new IOException("early EOM");
      } else {
         this.buffer = null;
         this.message = null;
      }
   }

   public final String readBytes(int var1) throws IOException {
      byte[] var2 = new byte[var1];
      this.message.read(var2, 0, var1);
      return new String(var2, 0);
   }

   public int read() throws IOException {
      return this.message.read();
   }

   public final int read(byte[] var1) throws IOException {
      return this.message.read(var1);
   }

   public final int read(byte[] var1, int var2, int var3) throws IOException {
      return this.message.read(var1, var2, var3);
   }

   public final boolean readBoolean() throws IOException {
      return this.message.readBoolean();
   }

   public final byte readByte() throws IOException {
      return this.message.readByte();
   }

   public final char readChar() throws IOException {
      return this.message.readChar();
   }

   public final double readDouble() throws IOException {
      return this.message.readDouble();
   }

   public final float readFloat() throws IOException {
      return this.message.readFloat();
   }

   public final void readFully(byte[] var1) throws IOException {
      this.message.readFully(var1);
   }

   public final void readFully(byte[] var1, int var2, int var3) throws IOException {
      this.message.readFully(var1, var2, var3);
   }

   public final int readInt() throws IOException {
      return this.message.readInt();
   }

   public final String readLine() throws IOException {
      return this.message.readLine();
   }

   public final long readLong() throws IOException {
      return this.message.readLong();
   }

   public final short readShort() throws IOException {
      return this.message.readShort();
   }

   public final int readUnsignedByte() throws IOException {
      return this.message.readUnsignedByte();
   }

   public final int readUnsignedShort() throws IOException {
      return this.message.readUnsignedShort();
   }

   public final String readUTF() throws IOException {
      return this.message.readUTF();
   }

   public final int skipBytes(int var1) throws IOException {
      return this.message.skipBytes(var1);
   }

   public final int available() throws IOException {
      return this.buffer.available();
   }
}
