package amp.powerboard.clientapi.net;

import java.io.ByteArrayOutputStream;
import java.io.DataOutputStream;
import java.io.IOException;
import java.io.OutputStream;

public final class CMsgOutputStream extends OutputStream {
   private OutputStream out;
   private DataOutputStream message;
   private ByteArrayOutputStream buffer;
   public byte abort;

   public CMsgOutputStream(OutputStream var1, int var2) throws IOException {
      this.out = var1;
      this.buffer = new ByteArrayOutputStream();
      this.message = new DataOutputStream(this.buffer);
      this.message.writeInt(var2);
      this.abort = 0;
   }

   public void close() throws IOException {
      this.message = new DataOutputStream(this.out);
      this.message.writeInt(this.buffer.size());
      this.buffer.writeTo(this.out);
      this.message.writeByte(this.abort);
      this.message = null;
      this.buffer = null;
   }

   public final void write(byte[] var1, int var2, int var3) throws IOException {
      this.message.write(var1, var2, var3);
   }

   public final void write(int var1) throws IOException {
      this.message.write(var1);
   }

   public final void writeBoolean(boolean var1) throws IOException {
      this.message.writeBoolean(var1);
   }

   public final void writeByte(int var1) throws IOException {
      this.message.writeByte(var1);
   }

   public final void writeBytes(String var1) throws IOException {
      this.message.writeBytes(var1);
   }

   public final void writeChar(int var1) throws IOException {
      this.message.writeChar(var1);
   }

   public final void writeChars(String var1) throws IOException {
      this.message.writeChars(var1);
   }

   public final void writeDouble(double var1) throws IOException {
      this.message.writeDouble(var1);
   }

   public final void writeFloat(float var1) throws IOException {
      this.message.writeFloat(var1);
   }

   public final void writeInt(int var1) throws IOException {
      this.message.writeInt(var1);
   }

   public final void writeLong(long var1) throws IOException {
      this.message.writeLong(var1);
   }

   public final void writeShort(short var1) throws IOException {
      this.message.writeShort(var1);
   }

   public final void writeUTF(String var1) throws IOException {
      this.message.writeUTF(var1);
   }
}
