package amp.powerboard.clientapi.net;

import amp.powerboard.clientapi.command.CCommandHandler;
import amp.powerboard.clientapi.common.exception.CInvalidUserException;
import amp.powerboard.clientapi.common.exception.CMaxUserExceededException;
import amp.powerboard.clientapi.common.exception.CUserAlreadyLoggedException;
import amp.powerboard.clientapi.security.CCryptoKey;
import amp.powerboard.clientapi.security.CMd5;
import amp.powerboard.clientapi.security.RC4CryptoKey;
import com.ms.security.PermissionID;
import com.ms.security.PolicyEngine;
import java.io.ByteArrayOutputStream;
import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.net.InetAddress;
import java.net.Socket;
import java.util.Random;

public class CSecureSocket {
   private byte[] encryptKey = null;
   private byte[] decryptKey = null;
   public byte[] mbox_admin_cmd = null;
   public byte[] mbox_admin_con = null;
   public byte[] mbox_admin_recmd = null;
   RC4CryptoKey inCmKey = null;
   RC4CryptoKey outCmKey = null;
   private Socket socket;
   private InputStream secureInput;
   private OutputStream secureOutput;
   private String login;

   public CSecureSocket(
      int var1,
      byte var2,
      InetAddress var3,
      int var4,
      String var5,
      int var6,
      byte[] var7,
      String var8,
      CCryptoKey var9,
      CCryptoKey var10,
      int var11,
      String var12,
      String var13,
      String var14,
      byte[] var15,
      CCommandHandler var16
   ) throws IOException, CUserAlreadyLoggedException, CInvalidUserException, CMaxUserExceededException {
      this.login = var5;
      this.socket = new Socket(var3, var4);
      InputStream var21 = this.socket.getInputStream();
      OutputStream var22 = this.socket.getOutputStream();
      byte[] var23 = new byte[var8.length()];
      var8.getBytes(0, var8.length(), var23, 0);
      CMd5 var24 = new CMd5();
      var24.update(var23);
      byte[] var25 = var24.digest();
      if (var12.equals("HP")) {
         CMsgInputStream var18;
         ByteArrayOutputStream var26 = new ByteArrayOutputStream();
         DataOutputStream var27 = new DataOutputStream(var26);
         var27.writeBytes(this.login);
         var27.write(var25);
         var27.write(var7);
         var27.writeInt(var2);
         CMd5 var28 = new CMd5();
         var28.update(var26.toByteArray());
         var15 = var28.digest();
         CMsgOutputStream var17 = new CMsgOutputStream(var22, 2000);
         var17.writeShort((short)this.login.length());
         var17.writeBytes(this.login);
         var17.writeInt(var6);
         var17.writeInt(var2);
         var17.writeShort((short)16);
         var17.write(var15);
         var17.close();
         var18 = new CMsgInputStream(var21);
         label122:
         switch (var18.opCode) {
            case 2000:
               int var19 = var18.readInt();
               switch (var19) {
                  case 0:
                     break label122;
                  case 8:
                     throw new CUserAlreadyLoggedException();
                  case 9:
                     throw new CInvalidUserException();
                  case 10:
                     throw new CMaxUserExceededException();
                  default:
                     System.out.println("Authentication Error: " + var19);
                     break label122;
               }
            default:
               System.out.println("Invalid Opcode: " + var18.opCode);
         }

         try {
            var18.close();
         } catch (IOException var45) {
         }

         this.secureInput = var9.newInputStream(var21);
         this.secureOutput = var10.newOutputStream(var22);
         if (var9 != var10) {
            var9.StartEncryption();
            var10.StartEncryption();
         }
      } else if (!var12.equals("DC") && (!var12.equals("CONSOLE_MANAGER") || !var13.equals("DC"))) {
         if (var12.equals("COMMAND_CENTER")) {
            CMsgInputStream var52;
            this.generateCustomKeys();
            RC4CryptoKey var60 = (RC4CryptoKey)var10;
            new String(var7);
            ByteArrayOutputStream var65 = this.getEncryptedPacket(var10, var6, var7, var2, var14);
            byte[] var29 = var65.toByteArray();
            DataOutputStream var30 = new DataOutputStream(var22);
            var30.writeInt(var29.length - 1);
            var30.write(var29, 0, var29.length);
            var30.flush();
            var52 = new CMsgInputStream(var21);
            label105:
            switch (var52.opCode) {
               case 2000:
                  int var56 = var52.readInt();
                  switch (var56) {
                     case 0:
                        break label105;
                     case 8:
                        throw new CUserAlreadyLoggedException();
                     case 9:
                        throw new CInvalidUserException();
                     case 10:
                        throw new CMaxUserExceededException();
                     default:
                        System.out.println("Authentication Error: " + var56);
                        break label105;
                  }
               default:
                  System.out.println("Invalid Opcode: " + var52.opCode);
            }

            try {
               var52.close();
            } catch (IOException var43) {
            }

            this.secureInput = this.inCmKey.newInputStream(var21);
            this.secureOutput = this.outCmKey.newOutputStream(var22);
            this.inCmKey.StartEncryption();
            this.outCmKey.StartEncryption();
         } else {
            this.secureInput = var9.newInputStream(var21);
            this.secureOutput = var10.newOutputStream(var22);
            if (var9 != var10) {
               var9.StartEncryption();
               var10.StartEncryption();
            }

            byte var61 = 8;
            if (var12.equals("CONSOLE_MANAGER")) {
               var61 = 12;
            }

            DataOutputStream var63 = new DataOutputStream(var22);
            var63.writeInt(var61);
            var63.writeInt(var6);
            var63.writeInt(var2);
            if (var12.equals("CONSOLE_MANAGER")) {
               var63.writeInt(var11);
            }

            byte var66 = 0;
            var63.writeByte(var66);
            DataInputStream var68 = new DataInputStream(var21);
            int var69 = var68.readInt();
            ByteArrayOutputStream var31 = new ByteArrayOutputStream();
            DataOutputStream var32 = new DataOutputStream(var31);
            if (var12.indexOf("_APP") != -1) {
               if (var2 == 1) {
                  CMsgOutputStream var49 = new CMsgOutputStream(this.secureOutput, 2001);
                  var49.writeInt(var11);
                  var66 = 0;
                  var49.writeByte(var66);
                  var49.close();
                  CMsgInputStream var53 = new CMsgInputStream(this.secureInput);
                  switch (var53.opCode) {
                     case 2001:
                        int var57 = var53.readInt();
                        switch (var57) {
                           case 0:
                              int var37 = var53.readInt();
                              int var38 = var53.readInt();
                              int var39 = var53.readInt();
                              short var34 = var53.readShort();
                              this.login = var53.readBytes(var34);
                              var16.mboxLoginName = this.login;
                              var34 = var53.readShort();
                              byte[] var40 = new byte[var34];
                              int var79 = var53.read(var40, 0, var34);
                              int var41 = var34 / 3;
                              var15 = new byte[var41];
                              System.arraycopy(var40, 0, var15, 0, var41);
                              var16.mbox_mp_con = new byte[var41];
                              System.arraycopy(var40, var41, var16.mbox_mp_con, 0, var41);
                              var16.mbox_mp_recmd = new byte[var41];
                              System.arraycopy(var40, 2 * var41, var16.mbox_mp_recmd, 0, var41);
                        }
                  }
               }
            } else {
               var32.writeBytes(this.login);
               var32.write(var25);
               var32.write(var7);
               var32.writeInt(var2);
               CMd5 var33 = new CMd5();
               var33.update(var31.toByteArray());
               var15 = var33.digest();
               if (var2 == 1 || var2 == 3) {
                  var31 = new ByteArrayOutputStream();
                  var32 = new DataOutputStream(var31);
                  var32.writeBytes(this.login);
                  var32.write(var25);
                  var32.write(var7);
                  var32.writeInt(1);
                  var33 = new CMd5();
                  var33.update(var31.toByteArray());
                  this.mbox_admin_cmd = var33.digest();
                  var31 = new ByteArrayOutputStream();
                  var32 = new DataOutputStream(var31);
                  var32.writeBytes(this.login);
                  var32.write(var25);
                  var32.write(var7);
                  var32.writeInt(2);
                  var33 = new CMd5();
                  var33.update(var31.toByteArray());
                  this.mbox_admin_con = var33.digest();
                  var31 = new ByteArrayOutputStream();
                  var32 = new DataOutputStream(var31);
                  var32.writeBytes(this.login);
                  var32.write(var25);
                  var32.write(var7);
                  var32.writeInt(3);
                  var33 = new CMd5();
                  var33.update(var31.toByteArray());
                  this.mbox_admin_recmd = var33.digest();
               }
            }

            CMsgOutputStream var50 = new CMsgOutputStream(this.secureOutput, 2000);
            var50.writeShort((short)this.login.length());
            var50.writeBytes(this.login);
            var50.writeShort((short)16);
            var50.write(var15);
            var50.writeInt(var1);
            if (var12.equals("CEREBUS_X16+") || var12.equals("CEREBUS_X32+")) {
               var50.writeShort((short)var8.length());
               var50.writeBytes(var8);
            }

            if (var12.equals("CONSOLE_MANAGER")) {
               var50.writeInt(var11);
            }

            CMsgInputStream var54;
            var50.close();
            var54 = new CMsgInputStream(this.secureInput);
            label90:
            switch (var54.opCode) {
               case 2000:
                  int var58 = var54.readInt();
                  switch (var58) {
                     case 0:
                        break label90;
                     case 8:
                        throw new CUserAlreadyLoggedException();
                     case 9:
                        throw new CInvalidUserException();
                     case 10:
                        throw new CMaxUserExceededException();
                     default:
                        System.out.println("Authentication Error: " + var58);
                        break label90;
                  }
               default:
                  System.out.println("Invalid Opcode: " + var54.opCode);
            }

            try {
               var54.close();
            } catch (IOException var42) {
            }
         }
      } else {
         ByteArrayOutputStream var59 = new ByteArrayOutputStream();
         DataOutputStream var62 = new DataOutputStream(var59);
         var62.writeBytes(this.login);
         var62.write(var25);
         var62.write(var7);
         var62.writeInt(var2);
         CMd5 var64 = new CMd5();
         var64.update(var59.toByteArray());
         var15 = var64.digest();
         CMsgOutputStream var48 = new CMsgOutputStream(var22, 2000);
         var48.writeShort((short)this.login.length());
         var48.writeBytes(this.login);
         var48.writeInt(var6);
         var48.writeInt(var2);
         var48.writeShort((short)16);
         var48.write(var15);
         if (var12.equals("CONSOLE_MANAGER") && var13.equals("DC")) {
            var48.writeInt(var11);
         }

         CMsgInputStream var51;
         var48.close();
         var51 = new CMsgInputStream(var21);
         label112:
         switch (var51.opCode) {
            case 2000:
               int var55 = var51.readInt();
               switch (var55) {
                  case 0:
                     break label112;
                  case 8:
                     throw new CUserAlreadyLoggedException();
                  case 9:
                     throw new CInvalidUserException();
                  case 10:
                     throw new CMaxUserExceededException();
                  default:
                     System.out.println("Authentication Error: " + var55);
                     break label112;
               }
            default:
               System.out.println("Invalid Opcode: " + var51.opCode);
         }

         try {
            var51.close();
         } catch (IOException var44) {
         }

         this.secureInput = var9.newInputStream(var21);
         this.secureOutput = var10.newOutputStream(var22);
         if (var9 != var10) {
            var9.StartEncryption();
            var10.StartEncryption();
         }
      }
   }

   public CSecureSocket(InetAddress var1, int var2, int var3, int var4, int var5, byte var6, String var7) throws IOException, CInvalidUserException {
      try {
         if (Class.forName("com.ms.security.PolicyEngine") != null) {
            PolicyEngine.assertPermission(PermissionID.NETIO);
         }
      } catch (Throwable var18) {
      }

      this.socket = new Socket(var1, var2);
      InputStream var11 = this.socket.getInputStream();
      OutputStream var12 = this.socket.getOutputStream();
      this.secureInput = var11;
      this.secureOutput = var12;
      byte var13 = 16;
      DataOutputStream var14 = new DataOutputStream(var12);
      var14.writeInt(var13);
      var14.writeInt(var3);
      var14.writeInt(var4);
      var14.writeInt(var5);
      var14.writeInt(var6);
      byte var15 = 0;
      var14.writeByte(var15);
      DataInputStream var16 = new DataInputStream(var11);
      int var17 = var16.readInt();
      if (var17 != 0) {
         throw new CInvalidUserException();
      }
   }

   public void close() throws IOException {
      this.socket.close();
   }

   public InetAddress getInetAddress() throws IOException {
      return this.socket.getInetAddress();
   }

   public InetAddress getLocalAddress() throws IOException {
      return this.socket.getLocalAddress();
   }

   public InputStream getInputStream() throws IOException {
      return this.secureInput;
   }

   public int getLocalPort() throws IOException {
      return this.socket.getLocalPort();
   }

   public OutputStream getOutputStream() throws IOException {
      return this.secureOutput;
   }

   public int getPort() throws IOException {
      return this.socket.getPort();
   }

   public String toString() {
      return this.socket.toString() + ":" + this.login;
   }

   private ByteArrayOutputStream getEncryptedPacket(CCryptoKey var1, int var2, byte[] var3, int var4, String var5) throws IOException {
      ByteArrayOutputStream var6 = new ByteArrayOutputStream();
      DataOutputStream var7 = new DataOutputStream(var6);
      var7.writeInt(var2);
      this.secureOutput = var1.newOutputStream(var6);
      var1.StartEncryption();
      var7 = new DataOutputStream(this.secureOutput);
      var7.write(var3);
      byte[] var8 = var5.getBytes();
      int var9 = var8.length;
      var7.writeShort(var9);
      var7.write(var8, 0, var8.length);
      var7.writeInt(var4);
      var7.write(this.decryptKey, 0, this.decryptKey.length);
      var7.write(this.encryptKey, 0, this.encryptKey.length);
      var7.writeByte(0);
      return var6;
   }

   private void generateCustomKeys() {
      Random var1 = new Random();
      this.encryptKey = new byte[16];
      var1.nextBytes(this.encryptKey);
      this.decryptKey = new byte[16];
      var1.nextBytes(this.decryptKey);
      this.inCmKey = new RC4CryptoKey(this.decryptKey);
      this.outCmKey = new RC4CryptoKey(this.encryptKey);
   }
}
