package amp.powerboard.clientapi.security;

public final class CMd5 {
   private int[] state = new int[4];
   private int[] count = new int[2];
   private byte[] buffer = new byte[64];
   private static final int S11 = 7;
   private static final int S12 = 12;
   private static final int S13 = 17;
   private static final int S14 = 22;
   private static final int S21 = 5;
   private static final int S22 = 9;
   private static final int S23 = 14;
   private static final int S24 = 20;
   private static final int S31 = 4;
   private static final int S32 = 11;
   private static final int S33 = 16;
   private static final int S34 = 23;
   private static final int S41 = 6;
   private static final int S42 = 10;
   private static final int S43 = 15;
   private static final int S44 = 21;
   private static final byte[] PADDING = new byte[]{
      -128,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0,
      0
   };

   private static int F(int var0, int var1, int var2) {
      return var0 & var1 | ~var0 & var2;
   }

   private static int G(int var0, int var1, int var2) {
      return var0 & var2 | var1 & ~var2;
   }

   private static int H(int var0, int var1, int var2) {
      return var0 ^ var1 ^ var2;
   }

   private static int I(int var0, int var1, int var2) {
      return var1 ^ (var0 | ~var2);
   }

   private static int ROTATE_LEFT(int var0, int var1) {
      return var0 << var1 | var0 >>> 32 - var1;
   }

   private static int FF(int var0, int var1, int var2, int var3, int var4, int var5, int var6) {
      var0 += F(var1, var2, var3) + var4 + var6;
      var0 = ROTATE_LEFT(var0, var5);
      return var0 + var1;
   }

   private static int GG(int var0, int var1, int var2, int var3, int var4, int var5, int var6) {
      var0 += G(var1, var2, var3) + var4 + var6;
      var0 = ROTATE_LEFT(var0, var5);
      return var0 + var1;
   }

   private static int HH(int var0, int var1, int var2, int var3, int var4, int var5, int var6) {
      var0 += H(var1, var2, var3) + var4 + var6;
      var0 = ROTATE_LEFT(var0, var5);
      return var0 + var1;
   }

   private static int II(int var0, int var1, int var2, int var3, int var4, int var5, int var6) {
      var0 += I(var1, var2, var3) + var4 + var6;
      var0 = ROTATE_LEFT(var0, var5);
      return var0 + var1;
   }

   public CMd5() {
      this.reset();
   }

   private void reset() {
      this.count[0] = 0;
      this.count[1] = 0;
      this.state[0] = 1732584193;
      this.state[1] = -271733879;
      this.state[2] = -1732584194;
      this.state[3] = 271733878;
   }

   public void update(byte[] var1) {
      int var3 = this.count[0] >> 3 & 63;
      if ((this.count[0] = this.count[0] + (var1.length << 3)) < var1.length << 3) {
         this.count[1]++;
      }

      this.count[1] = this.count[1] + (var1.length >> 29);
      int var4 = 64 - var3;
      int var2;
      if (var1.length >= var4) {
         System.arraycopy(var1, 0, this.buffer, var3, var4);
         this.MD5Transform(this.buffer, 0);

         for (var2 = var4; var2 + 63 < var1.length; var2 += 64) {
            this.MD5Transform(var1, var2);
         }

         var3 = 0;
      } else {
         var2 = 0;
      }

      System.arraycopy(var1, var2, this.buffer, var3, var1.length - var2);
   }

   public byte[] digest() {
      byte[] var1 = new byte[16];
      byte[] var2 = new byte[8];
      Encode(var2, this.count);
      int var3 = this.count[0] >>> 3 & 63;
      int var4 = var3 < 56 ? 56 - var3 : 120 - var3;
      byte[] var5 = new byte[var4];
      System.arraycopy(PADDING, 0, var5, 0, var4);
      this.update(var5);
      this.update(var2);
      Encode(var1, this.state);
      this.reset();

      for (int var6 = 0; var6 < this.buffer.length; var6++) {
         this.buffer[var6] = 0;
      }

      return var1;
   }

   private void MD5Transform(byte[] var1, int var2) {
      int var3 = this.state[0];
      int var4 = this.state[1];
      int var5 = this.state[2];
      int var6 = this.state[3];
      int[] var7 = Decode(var1, var2, 64);
      var3 = FF(var3, var4, var5, var6, var7[0], 7, -680876936);
      var6 = FF(var6, var3, var4, var5, var7[1], 12, -389564586);
      var5 = FF(var5, var6, var3, var4, var7[2], 17, 606105819);
      var4 = FF(var4, var5, var6, var3, var7[3], 22, -1044525330);
      var3 = FF(var3, var4, var5, var6, var7[4], 7, -176418897);
      var6 = FF(var6, var3, var4, var5, var7[5], 12, 1200080426);
      var5 = FF(var5, var6, var3, var4, var7[6], 17, -1473231341);
      var4 = FF(var4, var5, var6, var3, var7[7], 22, -45705983);
      var3 = FF(var3, var4, var5, var6, var7[8], 7, 1770035416);
      var6 = FF(var6, var3, var4, var5, var7[9], 12, -1958414417);
      var5 = FF(var5, var6, var3, var4, var7[10], 17, -42063);
      var4 = FF(var4, var5, var6, var3, var7[11], 22, -1990404162);
      var3 = FF(var3, var4, var5, var6, var7[12], 7, 1804603682);
      var6 = FF(var6, var3, var4, var5, var7[13], 12, -40341101);
      var5 = FF(var5, var6, var3, var4, var7[14], 17, -1502002290);
      var4 = FF(var4, var5, var6, var3, var7[15], 22, 1236535329);
      var3 = GG(var3, var4, var5, var6, var7[1], 5, -165796510);
      var6 = GG(var6, var3, var4, var5, var7[6], 9, -1069501632);
      var5 = GG(var5, var6, var3, var4, var7[11], 14, 643717713);
      var4 = GG(var4, var5, var6, var3, var7[0], 20, -373897302);
      var3 = GG(var3, var4, var5, var6, var7[5], 5, -701558691);
      var6 = GG(var6, var3, var4, var5, var7[10], 9, 38016083);
      var5 = GG(var5, var6, var3, var4, var7[15], 14, -660478335);
      var4 = GG(var4, var5, var6, var3, var7[4], 20, -405537848);
      var3 = GG(var3, var4, var5, var6, var7[9], 5, 568446438);
      var6 = GG(var6, var3, var4, var5, var7[14], 9, -1019803690);
      var5 = GG(var5, var6, var3, var4, var7[3], 14, -187363961);
      var4 = GG(var4, var5, var6, var3, var7[8], 20, 1163531501);
      var3 = GG(var3, var4, var5, var6, var7[13], 5, -1444681467);
      var6 = GG(var6, var3, var4, var5, var7[2], 9, -51403784);
      var5 = GG(var5, var6, var3, var4, var7[7], 14, 1735328473);
      var4 = GG(var4, var5, var6, var3, var7[12], 20, -1926607734);
      var3 = HH(var3, var4, var5, var6, var7[5], 4, -378558);
      var6 = HH(var6, var3, var4, var5, var7[8], 11, -2022574463);
      var5 = HH(var5, var6, var3, var4, var7[11], 16, 1839030562);
      var4 = HH(var4, var5, var6, var3, var7[14], 23, -35309556);
      var3 = HH(var3, var4, var5, var6, var7[1], 4, -1530992060);
      var6 = HH(var6, var3, var4, var5, var7[4], 11, 1272893353);
      var5 = HH(var5, var6, var3, var4, var7[7], 16, -155497632);
      var4 = HH(var4, var5, var6, var3, var7[10], 23, -1094730640);
      var3 = HH(var3, var4, var5, var6, var7[13], 4, 681279174);
      var6 = HH(var6, var3, var4, var5, var7[0], 11, -358537222);
      var5 = HH(var5, var6, var3, var4, var7[3], 16, -722521979);
      var4 = HH(var4, var5, var6, var3, var7[6], 23, 76029189);
      var3 = HH(var3, var4, var5, var6, var7[9], 4, -640364487);
      var6 = HH(var6, var3, var4, var5, var7[12], 11, -421815835);
      var5 = HH(var5, var6, var3, var4, var7[15], 16, 530742520);
      var4 = HH(var4, var5, var6, var3, var7[2], 23, -995338651);
      var3 = II(var3, var4, var5, var6, var7[0], 6, -198630844);
      var6 = II(var6, var3, var4, var5, var7[7], 10, 1126891415);
      var5 = II(var5, var6, var3, var4, var7[14], 15, -1416354905);
      var4 = II(var4, var5, var6, var3, var7[5], 21, -57434055);
      var3 = II(var3, var4, var5, var6, var7[12], 6, 1700485571);
      var6 = II(var6, var3, var4, var5, var7[3], 10, -1894986606);
      var5 = II(var5, var6, var3, var4, var7[10], 15, -1051523);
      var4 = II(var4, var5, var6, var3, var7[1], 21, -2054922799);
      var3 = II(var3, var4, var5, var6, var7[8], 6, 1873313359);
      var6 = II(var6, var3, var4, var5, var7[15], 10, -30611744);
      var5 = II(var5, var6, var3, var4, var7[6], 15, -1560198380);
      var4 = II(var4, var5, var6, var3, var7[13], 21, 1309151649);
      var3 = II(var3, var4, var5, var6, var7[4], 6, -145523070);
      var6 = II(var6, var3, var4, var5, var7[11], 10, -1120210379);
      var5 = II(var5, var6, var3, var4, var7[2], 15, 718787259);
      var4 = II(var4, var5, var6, var3, var7[9], 21, -343485551);
      this.state[0] = this.state[0] + var3;
      this.state[1] = this.state[1] + var4;
      this.state[2] = this.state[2] + var5;
      this.state[3] = this.state[3] + var6;

      for (int var8 = 0; var8 < var7.length; var8++) {
         var7[var8] = 0;
      }
   }

   private static void Encode(byte[] var0, int[] var1) {
      int var2 = 0;

      for (byte var3 = 0; var3 < var0.length; var3 += 4) {
         var0[var3] = (byte)(var1[var2] & 0xFF);
         var0[var3 + 1] = (byte)(var1[var2] >>> 8 & 0xFF);
         var0[var3 + 2] = (byte)(var1[var2] >>> 16 & 0xFF);
         var0[var3 + 3] = (byte)(var1[var2] >>> 24 & 0xFF);
         var2++;
      }
   }

   private static int[] Decode(byte[] var0, int var1, int var2) {
      int[] var5 = new int[var2 >> 2];
      int var3 = 0;

      for (int var4 = var1; var4 < var2 + var1; var4 += 4) {
         var5[var3] = var0[var4] & 255 | (var0[var4 + 1] & 255) << 8 | (var0[var4 + 2] & 255) << 16 | (var0[var4 + 3] & 255) << 24;
         var3++;
      }

      return var5;
   }
}
