package amp.powerboard.clientapi.security;

import java.io.IOException;
import java.io.InputStream;

public abstract class CSecureInputStream extends InputStream {
   protected InputStream in;
   protected CCryptoKey key;
   protected boolean encrypt;

   public CSecureInputStream(InputStream var1, CCryptoKey var2) {
      this.in = var1;
      this.key = var2;
      this.encrypt = false;
   }

   public int available() throws IOException {
      return this.in.available();
   }

   public void close() throws IOException {
      this.in.close();
   }

   public long skip(long var1) throws IOException {
      return this.in.skip(var1);
   }

   public void StartEncryption() {
      this.encrypt = true;
   }

   public void StopEncryption() {
      this.encrypt = false;
   }
}
