package amp.powerboard.clientapi.security;

import java.io.InputStream;
import java.io.OutputStream;

public final class RC4CryptoKey extends CCryptoKey {
   public byte[] key = new byte[16];
   public int keyLen;
   public RC4 inKey;
   public RC4 outKey;
   private CSecureInputStream inpStream = null;
   private CSecureOutputStream outStream = null;

   public RC4CryptoKey(String var1) {
      this.keyLen = var1.length() / 2;

      for (int var2 = 0; var2 < this.keyLen; var2++) {
         this.key[var2] = (byte)Integer.parseInt(var1.substring(var2 * 2, var2 * 2 + 2), 16);
      }
   }

   public RC4CryptoKey(byte[] var1) {
      this.keyLen = var1.length;

      for (int var2 = 0; var2 < this.keyLen; var2++) {
         this.key[var2] = var1[var2];
      }
   }

   public CSecureInputStream newInputStream(InputStream var1) {
      this.inKey = new RC4(this.key, this.keyLen);
      this.inpStream = new RC4InputStream(var1, this);
      return this.inpStream;
   }

   public CSecureOutputStream newOutputStream(OutputStream var1) {
      this.outKey = new RC4(this.key, this.keyLen);
      this.outStream = new RC4OutputStream(var1, this);
      return this.outStream;
   }

   public void StartEncryption() {
      if (this.inpStream != null) {
         this.inpStream.StartEncryption();
      }

      if (this.outStream != null) {
         this.outStream.StartEncryption();
      }
   }

   public void StopEncryption() {
      if (this.inpStream != null) {
         this.inpStream.StopEncryption();
      }

      if (this.outStream != null) {
         this.outStream.StopEncryption();
      }
   }
}
