package amp.powerboard.clientapi.security;

import java.io.EOFException;
import java.io.IOException;
import java.io.InputStream;

public final class RC4InputStream extends CSecureInputStream {
   RC4 rc4_key = ((RC4CryptoKey)this.key).inKey;

   public RC4InputStream(InputStream var1, CCryptoKey var2) {
      super(var1, var2);
   }

   public int read() throws IOException {
      byte[] var1 = new byte[1];
      byte[] var2 = new byte[1];
      int var4 = super.in.read();
      if (var4 == -1) {
         throw new EOFException();
      } else {
         var1[0] = (byte)var4;
         if (super.encrypt) {
            this.rc4_key.rc4(var1, var2, 1);
            short var3 = var2[0];
            if (var3 < 0) {
               var3 += 256;
            }

            return var3;
         } else {
            return var1[0] ^ 55;
         }
      }
   }

   public int read(byte[] var1, int var2, int var3) throws IOException {
      byte[] var4 = new byte[var3];
      int var5 = super.in.read(var4, 0, var3);
      if (super.encrypt) {
         if (var2 != 0) {
            byte[] var6 = new byte[var5];
            this.rc4_key.rc4(var4, var6, var5);
            System.arraycopy(var6, 0, var1, var2, var5);
         } else {
            this.rc4_key.rc4(var4, var1, var5);
         }
      } else {
         for (int var7 = 0; var7 < var3; var7++) {
            var1[var7 + var2] = (byte)(var4[var7] ^ 55);
         }
      }

      return var5;
   }
}
