package amp.powerboard.clientapi.security;

import java.io.IOException;
import java.io.OutputStream;

public final class RC4OutputStream extends CSecureOutputStream {
   RC4 rc4_key = ((RC4CryptoKey)this.key).outKey;

   public RC4OutputStream(OutputStream var1, CCryptoKey var2) {
      super(var1, var2);
   }

   public void write(byte[] var1, int var2, int var3) throws IOException {
      byte[] var4 = new byte[var3];
      if (super.encrypt) {
         this.rc4_key.rc4(var1, var4, var3);
      } else {
         for (int var5 = 0; var5 < var3; var5++) {
            var4[var5] = (byte)(var1[var5] ^ 55);
         }
      }

      super.out.write(var4);
   }

   public void write(int var1) throws IOException {
      byte[] var2 = new byte[4];
      byte[] var3 = new byte[4];
      var3[0] = (byte)var1;
      if (super.encrypt) {
         this.rc4_key.rc4(var3, var2, 1);
      } else {
         var2[0] = (byte)(var3[0] ^ 55);
      }

      super.out.write(var2[0]);
   }
}
