package amp.powerboard.component;

import java.awt.Button;
import java.awt.Color;
import java.awt.Component;
import java.awt.Dialog;
import java.awt.Dimension;
import java.awt.Frame;
import java.awt.Insets;
import java.awt.Label;
import java.awt.Point;
import java.awt.Rectangle;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

public class DialogConfirm extends Dialog {
   DialogInterface parent;
   boolean fComponentsAdjusted = false;
   Label label1 = new Label();
   Label lblName = new Label();
   Button btnNo = new Button();
   Button btnYes = new Button();

   public DialogConfirm(Frame var1) {
      super(var1);
      this.setLayout(null);
      this.setBackground(Color.lightGray);
      this.setSize(386, 115);
      this.setVisible(false);
      this.label1.setText("Are you sure you want to disconnect power from the outlet named");
      this.label1.setAlignment(1);
      this.add(this.label1);
      this.label1.setBounds(7, 24, 372, 24);
      this.lblName.setAlignment(1);
      this.add(this.lblName);
      this.lblName.setBounds(7, 48, 372, 24);
      this.btnNo.setLabel("No");
      this.add(this.btnNo);
      this.btnNo.setBounds(99, 84, 80, 22);
      this.btnYes.setLabel("Yes");
      this.add(this.btnYes);
      this.btnYes.setBounds(207, 84, 80, 22);
      DialogConfirm.SymWindow var2 = new DialogConfirm.SymWindow();
      this.addWindowListener(var2);
      DialogConfirm.SymAction var3 = new DialogConfirm.SymAction();
      this.btnNo.addActionListener(var3);
      this.btnYes.addActionListener(var3);
   }

   public DialogConfirm(Frame var1, boolean var2) {
      this(var1);
      this.setModal(var2);
   }

   public void addNotify() {
      Dimension var1 = this.getSize();
      super.addNotify();
      if (!this.fComponentsAdjusted) {
         Insets var2 = this.getInsets();
         this.setSize(var2.left + var2.right + var1.width, var2.top + var2.bottom + var1.height);
         Component[] var3 = this.getComponents();

         for (int var4 = 0; var4 < var3.length; var4++) {
            Point var5 = var3[var4].getLocation();
            var5.translate(var2.left, var2.top);
            var3[var4].setLocation(var5);
         }

         this.fComponentsAdjusted = true;
      }
   }

   public DialogConfirm(Frame var1, String var2, boolean var3) {
      this(var1, var3);
      this.setTitle(var2);
   }

   public DialogConfirm(DialogInterface var1, String var2) {
      this(var1.getFrame(), true);
      this.parent = var1;
      this.setTitle("Confirm Power Disconnect");
      this.lblName.setText(var2 + "?");
      this.btnNo.requestFocus();
   }

   public void setVisible(boolean var1) {
      if (var1) {
         Rectangle var2 = this.getParent().getBounds();
         Rectangle var3 = this.getBounds();
         this.setLocation(var2.x + (var2.width - var3.width) / 2, var2.y + (var2.height - var3.height) / 2);
      }

      super.setVisible(var1);
   }

   void DialogConfirm_WindowClosing(WindowEvent var1) {
      this.setVisible(false);
   }

   void btnNo_ActionPerformed(ActionEvent var1) {
      this.parent.setConfirmation(false);
      this.setVisible(false);
      this.dispose();
   }

   void btnYes_ActionPerformed(ActionEvent var1) {
      this.parent.setConfirmation(true);
      this.setVisible(false);
      this.dispose();
   }

   class SymAction implements ActionListener {
      public void actionPerformed(ActionEvent var1) {
         Object var2 = var1.getSource();
         if (var2 == DialogConfirm.this.btnNo) {
            DialogConfirm.this.btnNo_ActionPerformed(var1);
         } else if (var2 == DialogConfirm.this.btnYes) {
            DialogConfirm.this.btnYes_ActionPerformed(var1);
         }
      }
   }

   class SymWindow extends WindowAdapter {
      public void windowClosing(WindowEvent var1) {
         Object var2 = var1.getSource();
         if (var2 == DialogConfirm.this) {
            DialogConfirm.this.DialogConfirm_WindowClosing(var1);
         }
      }
   }
}
