package amp.powerboard.component;

import java.awt.Button;
import java.awt.Color;
import java.awt.Component;
import java.awt.Dialog;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.FontMetrics;
import java.awt.Frame;
import java.awt.Insets;
import java.awt.Label;
import java.awt.Point;
import java.awt.Rectangle;
import java.awt.Toolkit;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

public class MessageBox extends Dialog {
   private final int LABEL_MAX = 50;
   private final int WIDTH_MAX = 524;
   private final int HEIGHT_MAX = 112;
   private final int INSET_MAX = 24;
   private final int BUFFER_FOR_IE = 16;
   private String message = "";
   private String title = "";
   Label lblMessage1 = new Label();
   Label lblMessage2 = new Label();
   Button btnOk = new Button();
   FontMetrics fontMetrics;
   AcpSwcService acpSwcService;
   private IClose iCleanUp = null;
   boolean fComponentsAdjusted = false;

   public MessageBox(Frame var1) {
      super(var1);
      this.setLayout(null);
      this.setSize(428, 142);
      this.setVisible(false);
      this.setResizable(false);
      this.layoutBox();
      MessageBox.SymWindow var2 = new MessageBox.SymWindow();
      this.addWindowListener(var2);
   }

   public MessageBox(String var1, String var2) {
      this(new Frame());
      this.setModal(true);
      this.setTitle(var1);
      this.setMessage(var2);
      this.layoutBox();
   }

   public MessageBox(String var1, String var2, boolean var3) {
      this(new Frame());
      this.setModal(var3);
      this.setTitle(var1);
      this.setMessage(var2);
      this.layoutBox();
   }

   public MessageBox(Frame var1, String var2, String var3, boolean var4) {
      this(var1);
      this.setModal(var4);
      this.setTitle(var2);
      this.setMessage(var3);
      this.layoutBox();
   }

   public MessageBox(AcpSwcService var1, Frame var2, String var3, String var4, boolean var5) {
      this(var2, var3, var4, var5);
      this.acpSwcService = var1;
      var1.addInstance(this);
   }

   public MessageBox(AcpSwcService var1, IClose var2, Frame var3, String var4, String var5, boolean var6) {
      this(var3, var4, var5, var6);
      this.acpSwcService = var1;
      this.iCleanUp = var2;
      var1.addInstance(this);
   }

   void layoutBox() {
      int var1 = AcpSwcService.adjustedFontSize(12);
      this.setFont(new Font("Dialog", 0, var1));
      Font var2 = new Font("Dialog", 0, var1);
      this.fontMetrics = this.getFontMetrics(var2);
      this.setLayout(null);
      this.setBackground(Color.lightGray);
      this.message = this.message.replace('\n', ' ');
      int var3 = this.getStringWidth(this.message);
      if (var3 < 524) {
         this.setSize(var3 + 24 + 16, 112);
         this.lblMessage1.setBounds(12, 30, var3 + 16, 22);
         this.lblMessage2.setBounds(12, 54, var3 + 16, 22);
         this.btnOk.setBounds((var3 + 24 + 16) / 2 - 36, 80, 72, 22);
      } else {
         this.setSize(548, 112);
         this.lblMessage1.setBounds(12, 30, 524, 22);
         this.lblMessage2.setBounds(12, 54, 524, 22);
         this.btnOk.setBounds(238, 80, 72, 22);
      }

      this.setVisible(false);
      this.add(this.lblMessage1);
      this.add(this.lblMessage2);
      this.lblMessage1.setFont(var2);
      this.lblMessage2.setFont(var2);
      this.btnOk.setLabel("OK");
      this.add(this.btnOk);
      this.btnOk.requestFocus();
      this.setResizable(false);
      MessageBox.SymAction var4 = new MessageBox.SymAction();
      this.btnOk.addActionListener(var4);
   }

   public void showMessage() {
      int var1 = this.message.length();
      String var4 = "";
      if (var1 < 50) {
         this.lblMessage1.setText(this.message);
      } else {
         char[] var5 = new char[this.message.length()];
         this.message.getChars(0, this.message.length(), var5, 0);
         int var2 = this.message.indexOf(" ");
         if (var2 != -1) {
            for (int var3 = this.getStringWidth(this.message.substring(0, var2));
               var3 <= 524 && var2 != -1 && this.getStringWidth(this.message.substring(0, var2 + 1) + var4) <= 524;
               var3 = this.getStringWidth(this.message.substring(0, var2))
            ) {
               var4 = var4 + this.message.substring(0, var2 + 1);
               this.message = this.message.substring(var2 + 1);
               var2 = this.message.indexOf(" ");
               if (var2 == -1) {
                  break;
               }
            }
         }

         this.lblMessage1.setText(var4);
         this.lblMessage2.setText(this.message);
      }

      if (this.iCleanUp != null) {
         this.iCleanUp.enableAll(false);
      }

      this.setVisible(true);
   }

   int getStringWidth(String var1) {
      char[] var2 = new char[var1.length()];
      var1.getChars(0, var1.length(), var2, 0);
      return this.fontMetrics.charsWidth(var2, 0, var1.length());
   }

   public void setMessage(String var1) {
      this.message = var1;
   }

   public void addNotify() {
      Dimension var1 = this.getSize();
      super.addNotify();
      if (!this.fComponentsAdjusted) {
         Insets var2 = this.getInsets();
         this.setSize(var2.left + var2.right + var1.width, var2.top + var2.bottom + var1.height);
         Component[] var3 = this.getComponents();

         for (int var4 = 0; var4 < var3.length; var4++) {
            Point var5 = var3[var4].getLocation();
            var5.translate(var2.left, var2.top);
            var3[var4].setLocation(var5);
         }

         this.fComponentsAdjusted = true;
      }
   }

   public void setVisible(boolean var1) {
      if (var1) {
         Dimension var3 = Toolkit.getDefaultToolkit().getScreenSize();
         Rectangle var2 = new Rectangle(var3);
         Rectangle var4 = this.getBounds();
         int var5 = var2.x + (var2.width - var4.width) / 2;
         int var6 = var2.y + (var2.height - var4.height) / 2;
         int var7 = var4.width;
         int var8 = var4.height;
         this.setBounds(var5, var6, var7, var8);
         var4 = this.getBounds();
      }

      super.setVisible(var1);
   }

   void MessageBox_WindowClosing(WindowEvent var1) {
      this.setVisible(false);
   }

   public String getMessage() {
      return this.message;
   }

   void btnOk_ActionPerformed(ActionEvent var1) {
      this.acpSwcService.removeInstance(this);
      this.dispose();
      if (this.iCleanUp != null) {
         this.iCleanUp.enableAll(true);
      }
   }

   void btnCancel_ActionPerformed(ActionEvent var1) {
      this.acpSwcService.removeInstance(this);
      this.dispose();
   }

   class SymAction implements ActionListener {
      public void actionPerformed(ActionEvent var1) {
         Object var2 = var1.getSource();
         if (var2 == MessageBox.this.btnOk) {
            MessageBox.this.btnOk_ActionPerformed(var1);
         }
      }
   }

   class SymWindow extends WindowAdapter {
      public void windowClosing(WindowEvent var1) {
         Object var2 = var1.getSource();
         if (var2 == MessageBox.this) {
            MessageBox.this.MessageBox_WindowClosing(var1);
         }
      }
   }
}
