package amp.powerboard.component;

import java.util.Hashtable;
import java.util.StringTokenizer;

public class RelayStatus {
   private String data;
   private int[] relayNumbers;
   private String[] relayNames;
   private boolean[] relayStates;
   private Hashtable hashNames = new Hashtable(20);
   private Hashtable hashStates = new Hashtable(20);

   public RelayStatus(String var1) {
      this.data = var1;
      var1 = var1.substring(var1.indexOf(Constants.DL_OUTLET) - 2);
      this.parseData(var1);
      int var2 = this.hashNames.size();
      this.relayNumbers = new int[var2];
      this.relayNames = new String[var2];
      this.relayStates = new boolean[var2];

      for (int var3 = 0; var3 < var2; var3++) {
         this.relayNumbers[var3] = var3 + 1;
         this.relayNames[var3] = (String)this.hashNames.get(new Integer(var3 + 1));
         this.relayStates[var3] = (Boolean)this.hashStates.get(new Integer(var3 + 1));
      }
   }

   private void parseData(String var1) {
      int var2 = 1;
      StringTokenizer var3 = new StringTokenizer(var1, "\n\r");

      while (var3.hasMoreTokens()) {
         String var4 = var3.nextToken();
         StringTokenizer var5 = new StringTokenizer(var4, ":");
         if (var5.countTokens() != 1) {
            String var6 = "";
            boolean var7 = false;
            if (var5.countTokens() == 3) {
               int var14 = 6;
               var6 = "";

               for (int var15 = 0; var15 < 2; var15++) {
                  int var16 = var4.indexOf(": On");
                  int var11 = var4.indexOf(": Off");
                  if (var11 == -1) {
                     var11 = var4.indexOf(":Off");
                  }

                  if (var16 != -1 && var11 != -1) {
                     if (var16 < var11) {
                        var6 = var4.substring(var14, var16);
                        var7 = true;
                        var14 += var16 + 3;
                     } else {
                        var6 = var4.substring(var14, var11);
                        var7 = false;
                        var14 += var11 + 4;
                     }
                  } else if (var16 != -1) {
                     var6 = var4.substring(var14, var16);
                     var7 = true;
                     var14 += var16 + 3;
                  } else if (var11 != -1) {
                     var6 = var4.substring(var14, var11);
                     var7 = false;
                     var14 += var11 + 4;
                  }

                  this.hashNames.put(new Integer(var2), var6);
                  this.hashStates.put(new Integer(var2++), new Boolean(var7));
                  if (var14 < var4.length()) {
                     var4 = var4.substring(var14).trim();
                  }

                  if (var2 > 9) {
                     var14 = 6;
                  } else {
                     var14 = 5;
                  }
               }
            } else {
               int var8 = var5.countTokens() - 1;

               for (int var9 = 0; var9 < var8; var9++) {
                  var6 = var6 + var5.nextToken();
               }

               String var10 = var5.nextToken();
               if (var10.indexOf("Off") != -1) {
                  var7 = false;
               } else {
                  var7 = true;
               }

               this.hashNames.put(new Integer(var2), var6.substring(6));
               this.hashStates.put(new Integer(var2++), new Boolean(var7));
            }
         }
      }
   }

   public int[] getRelayNumbers() {
      return this.relayNumbers;
   }

   public String[] getRelayNames() {
      return this.relayNames;
   }

   public boolean[] getRelayStates() {
      return this.relayStates;
   }

   public int getNumOutlets() {
      return this.relayNames.length;
   }
}
