package amp.powerboard.component;

import java.util.StringTokenizer;

public class SystemStatus {
   private String unitId = "";
   private int averagePower;
   private int apparentPower;
   private float trueRMSVoltage;
   private float trueRMSCurrent;
   private float maxDetected;
   private float internalTemp;
   private String circuitBreaker;

   public SystemStatus(String var1) {
      StringTokenizer var2 = new StringTokenizer(var1, Constants.DL_CR);

      while (var2.hasMoreTokens()) {
         String var3 = var2.nextToken();
         if (var3.indexOf(Constants.ST_ID) != -1) {
            this.unitId = var3.substring(Constants.ST_ID.length()).trim();
            if (this.unitId == null) {
               this.unitId = "";
            }
         }

         if (var3.indexOf(Constants.ST_AVG_PWR) != -1 && var3.indexOf(Constants.ST_APP_PWR) != -1) {
            this.averagePower = Integer.parseInt(var3.substring(Constants.ST_AVG_PWR.length(), var3.indexOf(Constants.ST_WATTS) - 1).trim());
            this.apparentPower = Integer.parseInt(
               var3.substring(var3.indexOf(Constants.ST_APP_PWR) + Constants.ST_APP_PWR.length(), var3.indexOf(Constants.ST_VA) - 1).trim()
            );
         }

         if (var3.indexOf(Constants.ST_RMS_VOLT) != -1) {
            this.trueRMSVoltage = new Float(var3.substring(Constants.ST_RMS_VOLT.length(), var3.indexOf(Constants.ST_VOLTS) - 1).trim());
         }

         if (var3.indexOf(Constants.ST_RMS_CURRENT) != -1) {
            this.trueRMSCurrent = new Float(var3.substring(Constants.ST_RMS_CURRENT.length(), var3.indexOf(Constants.ST_AMPS) - 1).trim());
         }

         if (var3.indexOf(Constants.ST_MAX_DETECTED) != -1) {
            this.maxDetected = new Float(
               var3.substring(var3.indexOf(Constants.ST_MAX_DETECTED) + Constants.ST_MAX_DETECTED.length(), var3.lastIndexOf(Constants.ST_AMPS) - 1).trim()
            );
         }

         if (var3.indexOf(Constants.ST_INT_TEMP) != -1) {
            this.internalTemp = new Float(var3.substring(Constants.ST_INT_TEMP.length(), var3.indexOf(Constants.ST_CELCIUS) - 1).trim());
         }

         if (var3.indexOf(Constants.ST_CIRCUIT_BR) != -1) {
            this.circuitBreaker = var3.substring(Constants.ST_CIRCUIT_BR.length()).trim();
         }
      }
   }

   public String getCircuitBreaker() {
      return this.circuitBreaker;
   }

   public void setCircuitBreaker(String var1) {
      this.circuitBreaker = var1;
   }

   public float getInternalTemp() {
      return this.internalTemp;
   }

   public void setInternalTemp(float var1) {
      this.internalTemp = var1;
   }

   public float getMaxDetected() {
      return this.maxDetected;
   }

   public void setMaxDetected(float var1) {
      this.maxDetected = var1;
   }

   public float getTrueRMSCurrent() {
      return this.trueRMSCurrent;
   }

   public void setTrueRMSCurrent(float var1) {
      this.trueRMSCurrent = this.trueRMSCurrent;
   }

   public float getTrueRMSVoltage() {
      return this.trueRMSVoltage;
   }

   public void setTrueRMSVoltage(float var1) {
      this.trueRMSVoltage = var1;
   }

   public int getApparentPower() {
      return this.apparentPower;
   }

   public void setApparentPower(int var1) {
      this.apparentPower = var1;
   }

   public int getAveragePower() {
      return this.averagePower;
   }

   public void setAveragePower(int var1) {
      this.averagePower = this.averagePower;
   }

   public String getUnitId() {
      return this.unitId;
   }

   public void setUnitId(String var1) {
      this.unitId = this.unitId;
   }
}
