package amp.powerboard.swing;

import amp.powerboard.UserAlreadyLoggedDlg;
import amp.powerboard.clientapi.common.exception.CAlreadyLoggedException;
import amp.powerboard.clientapi.common.exception.CBoxUnInitialisedException;
import amp.powerboard.clientapi.common.exception.CInvalidUserException;
import amp.powerboard.clientapi.common.exception.CMaxUserExceededException;
import amp.powerboard.clientapi.common.exception.CUserAlreadyLoggedException;
import amp.powerboard.clientapi.event.CDataEvent;
import amp.powerboard.clientapi.event.CLoginInfoEvent;
import amp.powerboard.clientapi.event.IDataListener;
import amp.powerboard.component.AcpSwcService;
import amp.powerboard.component.PowerboardInterface;
import java.awt.Color;
import java.awt.FlowLayout;
import java.awt.Image;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.io.IOException;
import java.net.MalformedURLException;
import java.net.URL;
import java.util.Hashtable;
import javaclientlib.clientlib.ISerialStream;
import javax.swing.JApplet;
import javax.swing.JOptionPane;

public class AmpApp extends JApplet implements IDataListener, PowerboardInterface {
   public Hashtable boxProperty = null;
   private String platform = null;
   private String subPlatform = null;
   int sPort = 1;
   String portName = "";
   String deviceName = "";
   boolean cleaned = false;
   String hostName;
   static final String CONSOLE_VERSION = "PowerBoard 3.1";
   static final String CONSOLE_DATE = "October 26, 2001";
   boolean debug = false;
   AcpSwcService acpSwcService1 = new AcpSwcService();
   StateManager stateManager1 = new StateManager();

   public void init() {
      this.getContentPane().setLayout(new FlowLayout());
      this.setBackground(Color.white);
      this.showStatus("Attempting connection to power strip...");
      String platformVal = this.getParameter("Platform");
      if (platformVal != null && !platformVal.equalsIgnoreCase("JavaRRC")) {
         this.initialize();
      } else {
         this.platform = "JavaRRC";
         this.stateManager1.setPlatform(this.platform);
         this.stateManager1.setPowerboardInterface(this);
      }

      new AmpApp.SymMouse();
   }

   private void initialize() {
      this.boxProperty = new Hashtable(10);
      String sValue;
      if ((sValue = this.getParameter("Platform")) != null) {
         this.boxProperty.put("Platform", sValue);
         this.platform = sValue;
         this.stateManager1.setPlatform(this.platform);
      }

      if ((sValue = this.getParameter("SubPlatform")) != null) {
         this.boxProperty.put("SubPlatform", sValue);
         this.subPlatform = sValue;
      }

      if (this.platform.indexOf("_APP") != -1 || this.platform.equals("COMMAND_CENTER")) {
         if ((sValue = this.getParameter("ChallengeId")) != null) {
            this.boxProperty.put("ChallengeId", sValue);
         }

         if ((sValue = this.getParameter("Challenge")) != null) {
            this.boxProperty.put("Challenge", sValue);
         }

         if ((sValue = this.getParameter("Product")) != null) {
            this.boxProperty.put("Product", sValue);
         }

         if ((sValue = this.getParameter("BoxState")) != null) {
            this.boxProperty.put("BoxState", sValue);
         }

         this.hostName = this.getCodeBase().getHost();
         if (this.hostName != null && !this.hostName.equals("")) {
            this.boxProperty.put("IPAddress", this.hostName);
         } else if ((sValue = this.getParameter("IPAddress")) != null) {
            this.boxProperty.put("IPAddress", sValue);
         }

         if ((sValue = this.getParameter("PortAddress")) != null) {
            this.boxProperty.put("PortAddress", sValue);
         }

         if ((sValue = this.getParameter("RC4Key")) != null) {
            this.boxProperty.put("RC4Key", sValue);
         }

         if ((sValue = this.getParameter("TerminalType")) != null) {
            this.boxProperty.put("TerminalType", sValue);
         }

         if ((sValue = this.getParameter("UseFrame")) != null) {
            this.boxProperty.put("UseFrame", sValue);
         }

         if ((sValue = this.getParameter("MenuBar")) != null) {
            this.boxProperty.put("MenuBar", sValue);
         }

         if ((sValue = this.getParameter("Title")) != null) {
            this.boxProperty.put("Title", sValue);
         }

         if ((sValue = this.getParameter("ScrollBar")) != null) {
            this.boxProperty.put("ScrollBar", sValue);
         }

         if ((sValue = this.getParameter("SubTitle")) != null) {
            this.boxProperty.put("SubTitle", sValue);
         }

         if ((sValue = this.getParameter("Version")) != null) {
            this.boxProperty.put("Version", sValue);
         }

         if ((sValue = this.getParameter("DeviceName")) != null) {
            this.boxProperty.put("DeviceName", sValue);
            this.deviceName = sValue;
         }

         if ((sValue = this.getParameter("USERNAME")) != null) {
            this.boxProperty.put("USERNAME", sValue);
         }

         if ((sValue = this.getParameter("SessionId")) != null) {
            this.boxProperty.put("SESSION_ID", sValue);
         }

         if ((sValue = this.getParameter("PortNumber")) != null) {
            this.boxProperty.put("PortNumber", sValue);
            this.sPort = Integer.parseInt(sValue);
         }

         this.acpSwcService1.writeBoxProperty(this.boxProperty);
      } else if (this.platform.equals("RX_SHIM")) {
         if (this.getParameter("BoxState") != null) {
            int boxState = Integer.parseInt(this.getParameter("BoxState"));
            if (boxState == 1) {
               System.out.println("PowerBoard Applet Installed.");
               return;
            }
         }

         String hostName = this.getParameter("IPAddress");
         if (hostName == null || hostName.equals("")) {
            hostName = this.getCodeBase().getHost();
         }

         this.boxProperty.put("IPAddress", hostName);
         if ((sValue = this.getParameter("PortAddress")) != null) {
            this.boxProperty.put("PortAddress", sValue);
         }

         if ((sValue = this.getParameter("SessionId")) != null) {
            this.boxProperty.put("SESSION_ID", sValue);
         }

         if ((sValue = this.getParameter("DeviceId")) != null) {
            this.boxProperty.put("DeviceId", sValue);
         }

         if ((sValue = this.getParameter("ChannelId")) != null) {
            this.boxProperty.put("ChannelId", sValue);
         }

         this.acpSwcService1.writeBoxProperty(this.boxProperty);
      }

      this.acpSwcService1.setParentFrame(this);
      this.acpSwcService1.getIDataEventHandler().addDataListener(this);
      this.stateManager1.writeSwcService(this.acpSwcService1);
      if (this.platform.equals("CONSOLE_MANAGER")) {
         this.cm_login();
      } else {
         this.login();
      }
   }

   private void login() {
      String sLoginName = "arula111";
      String sPassword = "arula111";
      if (this.platform.equals("SC_AMP")) {
         int t = 0;

         try {
            t = Integer.parseInt(this.getParameter("Debug"));
         } catch (Exception var10) {
         }

         if (t == 1) {
            sLoginName = this.getParameter("Login");
            sPassword = this.getParameter("Passwd");
         }
      } else if (this.platform.equals("COMMAND_CENTER")) {
         sLoginName = (String)this.boxProperty.get("USERNAME");
      }

      if (sLoginName != null && sPassword != null) {
         try {
            if (this.acpSwcService1 != null) {
               if (this.debug) {
                  this.acpSwcService1.login(11, sLoginName, sPassword);
               } else {
                  this.acpSwcService1.login(this.sPort, sLoginName, sPassword);
               }
            } else {
               System.out.println("Console: acpSwcService not set.");
            }
         } catch (CUserAlreadyLoggedException var11) {
            if (this.platform.equals("COMMAND_CENTER")) {
               JOptionPane.showMessageDialog(
                  this.stateManager1.getFrame(), "The private account of " + this.deviceName + " is in use. Please check with your administrator ", "Error", 0
               );
            } else {
               try {
                  this.acpSwcService1.reLogin(this.sPort, sLoginName, sPassword);
               } catch (Exception var9) {
                  System.out.println("[AmpApp_Relogin] : " + var9.getMessage());
               }
            }
         } catch (CMaxUserExceededException var12) {
            JOptionPane.showMessageDialog(this.stateManager1.getFrame(), "Console Port Access", "Maximum Users Exceeded", 0);
         } catch (CInvalidUserException var13) {
            System.out.println("Invalid User Exception.");
         } catch (CAlreadyLoggedException var14) {
            System.out.println("[AL] Already Logged Exception");
         } catch (CBoxUnInitialisedException var15) {
            System.out.println("[BUI] Box UnInitialised Exception.");
         } catch (IOException var16) {
            System.out.println("[IO] IO Exception");
         }

         if (this.platform.equals("RX_SHIM")) {
            this.stateManager1.setPowerboardInterface(this);
            if (this.debug) {
               this.stateManager1.connect(11);
            } else {
               this.stateManager1.connect(this.sPort);
            }
         }

         if (this.platform.equals("SC_AMP")) {
         }
      }
   }

   private void cm_login() {
      if (this.acpSwcService1 == null) {
         System.out.println("Console: acpSwcService not set.");
      }

      for (int i = 1; i <= 3; i++) {
         String sLoginName = "arula" + Integer.toString(i);
         String sPassword = sLoginName;

         try {
            this.acpSwcService1.login(this.sPort, sLoginName, sPassword);
            break;
         } catch (CUserAlreadyLoggedException var11) {
            if (i == 3) {
               UserAlreadyLoggedDlg ualiDlg = new UserAlreadyLoggedDlg(
                  this.acpSwcService1.getParentFrame(), "ASC Warning" + this.portName, true, this.acpSwcService1, this.sPort, sLoginName, sLoginName
               );
               ualiDlg.setVisible(true);
            }
         } catch (CMaxUserExceededException var12) {
            JOptionPane.showMessageDialog(this.stateManager1.getFrame(), "Console Port Access", "Maximum Users Exceeded", 0);
         } catch (CInvalidUserException var13) {
            System.out.println("CInvalidUserException.");
            break;
         } catch (CAlreadyLoggedException var14) {
            System.out.println("CAlreadyLoggedException.");
            break;
         } catch (CBoxUnInitialisedException var15) {
            System.out.println("CBoxUnInitialisedException.");
            break;
         } catch (IOException var16) {
            if (i == 3) {
               UserAlreadyLoggedDlg ualiDlg = new UserAlreadyLoggedDlg(
                  this.acpSwcService1.getParentFrame(), "ASC Warning" + this.portName, true, this.acpSwcService1, this.sPort, sLoginName, sLoginName
               );
               ualiDlg.setVisible(true);
            }
         }
      }
   }

   public void stop() {
      this.finalCleanUp();
   }

   public URL getCodebaseURL() {
      return this.getCodeBase();
   }

   public void addStateManager() {
      this.getContentPane().add(this.stateManager1.getPowerboardUI());
   }

   public void setSerialStream(ISerialStream serialStream) {
      this.stateManager1.setSerialStream(serialStream);
   }

   public void setDataBytes(byte[] data) {
      this.stateManager1.bytesArrived(data, data.length);
   }

   public void commandDataArrived(CDataEvent dataEvent) {
      switch (dataEvent.getOpcode()) {
         case 2:
            if (!this.acpSwcService1.isFirstTimeLogin()) {
               this.finalCleanUp();
            }
            break;
         case 13:
            CLoginInfoEvent loginInfoEvent = (CLoginInfoEvent)dataEvent;
            if (this.platform.equals("SC_AMP") || this.platform.equals("CONSOLE_MANAGER") && this.subPlatform.equals("DC")) {
               this.sPort = 1;
            }

            if (this.acpSwcService1.getPortNumberToNameMap() != null && this.acpSwcService1.getPortNumberToNameMap().get(new Integer(this.sPort)) != null) {
               this.portName = " - " + this.acpSwcService1.getPortNumberToNameMap().get(new Integer(this.sPort)).toString();
               this.stateManager1.setTitle("PowerBoard" + this.portName);
            }

            this.stateManager1.setPowerboardInterface(this);
            if (this.debug) {
               this.stateManager1.connect(11);
            } else {
               this.stateManager1.connect(this.sPort);
            }
            break;
         case 17:
            JOptionPane.showMessageDialog(this.stateManager1.getFrame(), "You have been logged out.", "Forced Logout", 0);
            if (!this.acpSwcService1.isFirstTimeLogin()) {
               this.finalCleanUp();
            }
            break;
         case 177:
            if (!this.acpSwcService1.isFirstTimeLogin()) {
               this.finalCleanUp();
            }
      }
   }

   public void chatCallback() {
   }

   public void scriptCallback() {
   }

   public void userListCallback() {
   }

   public void helpCallback() {
      String helpLink = this.getCodeBase().toString() + "help/console.htm";
      if (this.platform.equals("SC_AMP")) {
         helpLink = this.getCodeBase().toString() + "app/help/console.htm";
      } else if (this.platform.equals("COMMAND_CENTER")) {
         int pos = this.getCodeBase().toString().indexOf("cgi-bin");
         if (pos != -1) {
            helpLink = this.getCodeBase().toString().substring(0, pos) + "CommandCenter/help/console.htm";
         }
      }

      try {
         this.getAppletContext().showDocument(new URL(helpLink), "ConsoleHelp");
      } catch (MalformedURLException var3) {
         System.out.println("Cannot find Help page.");
      }
   }

   public Image getImage(String name_p) {
      return null;
   }

   public void finalCleanUp() {
      if (!this.cleaned) {
         this.cleaned = true;
         if (this.stateManager1 != null) {
            this.stateManager1.closeAll();
            this.stateManager1 = null;
         }

         if (this.acpSwcService1 != null) {
            this.acpSwcService1.removeAllInstances();
            this.acpSwcService1.forcedLogout();
            this.acpSwcService1 = null;
         }
      }
   }

   public void consoleCallback() {
   }

   public void powerHelpCallback() {
      String helpLink = this.getCodeBase().toString() + "help/pbhelp.htm";
      if (this.platform.equals("SC_AMP")) {
         helpLink = this.getCodeBase().toString() + "app/help/pbhelp.htm";
      } else if (this.platform.equals("COMMAND_CENTER")) {
         int pos = this.getCodeBase().toString().indexOf("cgi-bin");
         if (pos != -1) {
            helpLink = this.getCodeBase().toString().substring(0, pos) + "CommandCenter/help/pbhelp.htm";
         }
      }

      try {
         this.getAppletContext().showDocument(new URL(helpLink), "PowerboardHelp");
      } catch (MalformedURLException var3) {
         System.out.println("Cannot find Help page.");
      }
   }

   class SymMouse extends MouseAdapter {
      public void mouseClicked(MouseEvent event) {
         Object object = event.getSource();
      }
   }
}
