package amp.powerboard.swing;

import amp.powerboard.utils.PbResource;
import javax.swing.JOptionPane;
import javax.swing.JTextField;
import javax.swing.text.AttributeSet;
import javax.swing.text.BadLocationException;
import javax.swing.text.Document;
import javax.swing.text.PlainDocument;

public class OutletTextField extends JTextField {
   private static String validationErrMsg = PbResource.getString("ValidationErrorMessage");
   private static String validationErrTitle = PbResource.getString("ValidationErrorMessage.title");

   protected Document createDefaultModel() {
      return new OutletTextField.OutletTextDocument();
   }

   static class OutletTextDocument extends PlainDocument {
      public void insertString(int var1, String var2, AttributeSet var3) throws BadLocationException {
         if (var2.indexOf("(") == -1 && var2.indexOf(")") == -1 && var2.indexOf(".") == -1 && var2.indexOf(":") == -1) {
            super.insertString(var1, var2, var3);
         } else {
            JOptionPane.showMessageDialog(null, OutletTextField.validationErrMsg, OutletTextField.validationErrTitle, 0);
         }
      }
   }
}
