package amp.powerboard.swing;

import amp.powerboard.component.PowerboardInterface;
import amp.powerboard.component.RelayStatus;
import amp.powerboard.component.SystemStatus;
import amp.powerboard.utils.PbResource;
import amp.powerboard.utils.SpringUtilities;
import java.awt.Color;
import java.awt.Container;
import java.awt.Cursor;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.Font;
import java.awt.Frame;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import javax.swing.BorderFactory;
import javax.swing.Box;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.SpringLayout;

public class Powerboard extends JFrame implements MouseListener {
   StateManager stateManager;
   boolean refreshed = false;
   String codeBaseString;
   int columns;
   int rows;
   boolean initialized = false;
   ImageIcon grUp;
   ImageIcon grDown;
   ImageIcon grDis;
   ImageIcon redUp;
   ImageIcon redDown;
   ImageIcon redDis;
   ImageIcon pbLogo;
   ImageIcon raritanLogo;
   JLabel[] lblOutlets;
   JButton[] jibOutlets;
   private JPanel pbPanel;
   private PowerboardInterface applet;
   JLabel lblUnitId = new JLabel();
   JPanel panelSystemStatus = new JPanel();
   JPanel panelOutlets = new JPanel();
   JPanel panelButtons = new JPanel();
   JPanel panelLogos = new JPanel();
   JButton btnClose = new JButton();
   JButton btnConfig = new JButton();
   JPanel panelBorder = new JPanel();
   JLabel label4 = new JLabel("", 4);
   JLabel label5 = new JLabel("", 4);
   JLabel label6 = new JLabel("", 4);
   JLabel label7 = new JLabel("", 4);
   JLabel label8 = new JLabel("", 4);
   JLabel label9 = new JLabel("", 4);
   JLabel label10 = new JLabel("", 4);
   JLabel lblAvPower = new JLabel("tempvalue");
   JLabel lblRMSCurrent = new JLabel("tempvalue");
   JLabel lblRMSVolt = new JLabel("tempvalue");
   JLabel lblIntTemp = new JLabel("tempvalue");
   JLabel lblAppPower = new JLabel("tempvalue");
   JLabel lblMaxDetected = new JLabel("tempvalue");
   JLabel lblCircBrk = new JLabel("tempvalue");
   JLabel lblPowerBoard = new JLabel("tempvalue");
   JLabel jibRaritan = new JLabel();
   Font font18;
   Font font22;

   public Powerboard(String var1, StateManager var2) {
      this.stateManager = var2;
      this.getImages();
      this.font18 = new Font("Arial", 1, adjustedFontSize(18));
      this.font22 = new Font("Arial", 1, adjustedFontSize(22));
      this.pbPanel = new JPanel();
   }

   public void initUI(int var1) {
      this.setBackground(Color.white);
      this.pbPanel.setBackground(Color.white);
      SpringLayout var2 = new SpringLayout();
      this.pbPanel.setLayout(var2);
      this.panelLogos.setLayout(new GridLayout(1, 3));
      this.panelLogos.setBackground(Color.white);
      this.panelLogos.setMaximumSize(this.panelLogos.getPreferredSize());
      this.jibRaritan.setIcon(this.raritanLogo);
      this.panelLogos.add(this.jibRaritan);
      this.panelLogos.add(Box.createVerticalGlue());
      this.lblPowerBoard.setAlignmentX(1.0F);
      this.lblPowerBoard.setBackground(Color.white);
      this.lblPowerBoard.setText(PbResource.getString("PowerboardLabel.name") + PbResource.getString("VersionNo"));
      this.lblPowerBoard.setFont(this.font22);
      this.lblPowerBoard.setForeground(Color.black);
      this.panelLogos.add(this.lblPowerBoard);
      this.pbPanel.add(this.panelLogos);
      this.lblUnitId.setFont(this.font18);
      this.lblUnitId.setText("");
      this.pbPanel.add(this.lblUnitId);
      this.panelOutlets.setLayout(new SpringLayout());
      this.panelOutlets.setBackground(Color.white);
      this.panelOutlets.setMaximumSize(this.panelOutlets.getPreferredSize());
      if (!this.initialized) {
         this.lblOutlets = new JLabel[this.stateManager.getNumOutlets()];
         this.jibOutlets = new JButton[this.stateManager.getNumOutlets()];
         if (var1 == 8) {
            this.columns = 2;
         } else if (var1 == 12) {
            this.columns = 3;
         } else if (var1 == 18 || var1 == 20) {
            this.columns = 4;
         }

         this.rows = var1 / this.columns;
         if (var1 % this.columns > 0) {
            this.rows++;
         }

         int var3 = 0;

         for (int var4 = 0; var4 < this.columns; var4++) {
            JPanel var5 = new JPanel(new SpringLayout());
            var5.setBackground(Color.white);
            var5.setMaximumSize(var5.getPreferredSize());

            for (int var6 = 0; var6 < this.rows; var6++) {
               if (var3 < var1) {
                  this.jibOutlets[var3] = new JButton("button " + var6, this.grUp);
                  this.jibOutlets[var3].setHorizontalAlignment(2);
                  this.jibOutlets[var3].setMaximumSize(new Dimension(Integer.MAX_VALUE, Integer.MAX_VALUE));
                  this.jibOutlets[var3].setFocusPainted(false);
                  this.jibOutlets[var3].setBorderPainted(false);
                  this.jibOutlets[var3].setContentAreaFilled(false);
                  this.jibOutlets[var3].setCursor(Cursor.getPredefinedCursor(12));
                  this.jibOutlets[var3].addMouseListener(this);
                  var5.add(this.jibOutlets[var3]);
               } else {
                  JButton var7 = new JButton("Empty");
                  var7.setMaximumSize(new Dimension(Integer.MAX_VALUE, Integer.MAX_VALUE));
                  var7.setVisible(false);
                  var5.add(var7);
               }

               var3++;
            }

            SpringUtilities.makeCompactGrid(var5, var5.getComponentCount(), 1, 6, 6, 6, 6);
            this.panelOutlets.add(var5);
         }

         this.pbPanel.add(this.panelOutlets);
         SpringUtilities.makeCompactGrid(this.panelOutlets, 1, this.columns, 6, 6, 6, 6);
      }

      this.panelSystemStatus.setLayout(new SpringLayout());
      this.panelSystemStatus.setMaximumSize(this.panelSystemStatus.getPreferredSize());
      this.panelSystemStatus.setBackground(Color.lightGray);
      this.label4.setText(PbResource.getString("AveragePowerLabel.name") + " ");
      this.label4.setLabelFor(this.lblAppPower);
      this.panelSystemStatus.add(this.label4);
      this.panelSystemStatus.add(this.lblAppPower);
      this.lblAppPower.setForeground(Color.blue);
      this.panelSystemStatus.add(Box.createVerticalGlue());
      this.label5.setText(PbResource.getString("ApparentPowerLabel.name") + " ");
      this.label5.setLabelFor(this.lblAvPower);
      this.panelSystemStatus.add(this.label5);
      this.panelSystemStatus.add(this.lblAvPower);
      this.lblAvPower.setForeground(Color.blue);
      this.label6.setText(PbResource.getString("TrueRMSCurrentLabel.name") + " ");
      this.label6.setLabelFor(this.lblRMSCurrent);
      this.panelSystemStatus.add(this.label6);
      this.panelSystemStatus.add(this.lblRMSCurrent);
      this.lblRMSCurrent.setForeground(Color.blue);
      this.panelSystemStatus.add(Box.createVerticalGlue());
      this.label7.setText(PbResource.getString("MaxDetectedLabel.name") + " ");
      this.label7.setLabelFor(this.lblMaxDetected);
      this.panelSystemStatus.add(this.label7);
      this.panelSystemStatus.add(this.lblMaxDetected);
      this.lblMaxDetected.setForeground(Color.blue);
      this.label8.setText(PbResource.getString("TrueRMSVoltageLabel.name") + " ");
      this.label8.setLabelFor(this.lblRMSVolt);
      this.panelSystemStatus.add(this.label8);
      this.panelSystemStatus.add(this.lblRMSVolt);
      this.lblRMSVolt.setForeground(Color.blue);
      this.panelSystemStatus.add(Box.createVerticalGlue());
      this.panelSystemStatus.add(Box.createVerticalGlue());
      this.panelSystemStatus.add(Box.createVerticalGlue());
      this.label9.setText(PbResource.getString("InternalTempLabel.name") + " ");
      this.label9.setLabelFor(this.lblIntTemp);
      this.panelSystemStatus.add(this.label9);
      this.panelSystemStatus.add(this.lblIntTemp);
      this.lblIntTemp.setForeground(Color.blue);
      this.panelSystemStatus.add(Box.createVerticalGlue());
      this.label10.setText(PbResource.getString("OutletCircuitBreakerLabel.name") + " ");
      this.label10.setLabelFor(this.lblCircBrk);
      this.panelSystemStatus.add(this.label10);
      this.panelSystemStatus.add(this.lblCircBrk);
      this.lblCircBrk.setForeground(Color.blue);
      this.panelSystemStatus.setBorder(BorderFactory.createCompoundBorder(BorderFactory.createTitledBorder(""), BorderFactory.createEmptyBorder(5, 5, 5, 5)));
      SpringUtilities.makeCompactGrid(this.panelSystemStatus, 4, 5, 6, 6, 6, 6);
      JPanel var8 = new JPanel(new FlowLayout());
      var8.setBackground(Color.white);
      var8.add(Box.createVerticalGlue());
      var8.add(this.panelSystemStatus, 1);
      var8.add(Box.createVerticalGlue());
      this.pbPanel.add(var8);
      this.btnConfig.setText(PbResource.getString("ConfigButton.name"));
      this.btnConfig.setMaximumSize(this.btnConfig.getPreferredSize());
      this.panelButtons.add(this.btnConfig);
      this.panelButtons.setBackground(Color.white);
      this.panelButtons.setMaximumSize(this.panelButtons.getPreferredSize());
      this.pbPanel.add(this.panelButtons);
      this.pbPanel.setBorder(BorderFactory.createCompoundBorder(BorderFactory.createTitledBorder(""), BorderFactory.createEmptyBorder(5, 5, 5, 5)));
      SpringUtilities.makeCompactGrid(this.pbPanel, 5, 1, 6, 6, 6, 20);
      this.initialized = true;
      Powerboard.SymMouse var9 = new Powerboard.SymMouse();
      Powerboard.SymAction var10 = new Powerboard.SymAction();
      this.btnConfig.addActionListener(var10);
      this.addMouseListener(var9);
      this.btnClose.addActionListener(var10);
   }

   public void updateUI(RelayStatus var1, SystemStatus var2) {
      boolean[] var3 = var1.getRelayStates();
      String[] var4 = var1.getRelayNames();

      for (int var5 = 0; var5 < this.lblOutlets.length; var5++) {
         this.jibOutlets[var5].setText(var5 + 1 + ". " + var4[var5]);
         if (!var3[var5]) {
            this.jibOutlets[var5].setIcon(this.redUp);
            this.jibOutlets[var5].setSelectedIcon(this.redUp);
            this.jibOutlets[var5].setPressedIcon(this.redDown);
            this.jibOutlets[var5].setDisabledIcon(this.redDis);
         } else {
            this.jibOutlets[var5].setIcon(this.grUp);
            this.jibOutlets[var5].setSelectedIcon(this.grUp);
            this.jibOutlets[var5].setPressedIcon(this.grDown);
            this.jibOutlets[var5].setDisabledIcon(this.grDis);
         }
      }

      if (var2 != null) {
         this.lblUnitId.setText(var2.getUnitId());
         this.lblAvPower.setText(var2.getAveragePower() + " " + PbResource.getString("AveragePowerUnit.name"));
         this.lblRMSCurrent.setText(var2.getTrueRMSCurrent() + " " + PbResource.getString("TrueRMSCurrentUnit.name"));
         this.lblRMSVolt.setText(var2.getTrueRMSVoltage() + " " + PbResource.getString("TrueRMSVoltageUnit.name"));
         this.lblIntTemp.setText(var2.getInternalTemp() + " " + PbResource.getString("InternalTempUnit.name"));
         this.lblAppPower.setText(var2.getApparentPower() + " " + PbResource.getString("ApparentPowerUnit.name"));
         this.lblMaxDetected.setText(var2.getMaxDetected() + " " + PbResource.getString("MaxDetectedUnit.name"));
         this.lblCircBrk.setText(var2.getCircuitBreaker());
      }

      this.setDefaultCursor();
   }

   public void enableAll(boolean var1) {
      if (var1) {
         this.refreshed = true;
      }
   }

   public void updateStatus(String var1) {
   }

   public void updateUsers(int var1) {
   }

   public void getImages() {
      this.raritanLogo = PbResource.getIcon("RaritanLogo.image");
      this.grUp = PbResource.getIcon("GreenUp.image");
      this.grDown = PbResource.getIcon("GreenDown.image");
      this.grDis = this.grUp;
      this.redUp = PbResource.getIcon("RedUp.image");
      this.redDown = PbResource.getIcon("RedDown.image");
      this.redDis = this.redUp;
   }

   public Container getPowerboardUI() {
      return this.pbPanel;
   }

   public Frame getFrame() {
      Object var1 = this.pbPanel;

      while (var1 != null && !(var1 instanceof Frame)) {
         var1 = var1.getParent();
      }

      return (Frame)var1;
   }

   public void setPowerboardAppletInterface(PowerboardInterface var1) {
      this.applet = var1;
   }

   public boolean isInitialized() {
      return this.initialized;
   }

   void repaintPanel() {
      this.jibRaritan.repaint();

      for (int var1 = 0; var1 < this.jibOutlets.length; var1++) {
         this.jibOutlets[var1].repaint();
      }
   }

   public void setWaitCursor() {
      this.pbPanel.setCursor(Cursor.getPredefinedCursor(3));
   }

   public void setDefaultCursor() {
      this.pbPanel.setCursor(Cursor.getDefaultCursor());
   }

   public static int adjustedFontSize(int var0) {
      int var1 = var0;
      JPanel var2 = new JPanel();

      for (int var3 = var2.getFontMetrics(new Font("Dialog", 0, var0)).getHeight();
         var3 > var0 + 4;
         var3 = var2.getFontMetrics(new Font("Helvetica", 0, var1)).getHeight()
      ) {
         var1 -= 2;
      }

      return var1;
   }

   void btnConfig_ActionPerformed(ActionEvent var1) {
      this.setWaitCursor();
      this.stateManager.readSetupData();
   }

   void Powerboard_mouseClicked(MouseEvent var1) {
   }

   public void mouseReleased(MouseEvent var1) {
      if (this.stateManager.getRelayStatus() != null) {
         boolean[] var2 = this.stateManager.getRelayStatus().getRelayStates();

         for (int var3 = 0; var3 < var2.length; var3++) {
            if (var1.getSource() == this.jibOutlets[var3]) {
               if (var2[var3]) {
                  this.stateManager.sendOff(var3 + 1);
               } else {
                  this.stateManager.sendOn(var3 + 1);
               }
               break;
            }
         }
      }
   }

   public void mousePressed(MouseEvent var1) {
   }

   public void mouseEntered(MouseEvent var1) {
   }

   public void mouseExited(MouseEvent var1) {
   }

   public void mouseClicked(MouseEvent var1) {
   }

   void btnClose_ActionPerformed(ActionEvent var1) {
      this.setVisible(false);
      this.dispose();
   }

   void Powerboard_WindowClosing(WindowEvent var1) {
      this.setVisible(false);
      this.dispose();
   }

   class SymAction implements ActionListener {
      public void actionPerformed(ActionEvent var1) {
         Object var2 = var1.getSource();
         if (var2 == Powerboard.this.btnConfig) {
            Powerboard.this.btnConfig_ActionPerformed(var1);
         } else if (var2 == Powerboard.this.btnClose) {
            Powerboard.this.btnClose_ActionPerformed(var1);
         }
      }
   }

   class SymMouse extends MouseAdapter {
      public void mouseClicked(MouseEvent var1) {
         Object var2 = var1.getSource();
         if (var2 == Powerboard.this) {
            Powerboard.this.Powerboard_mouseClicked(var1);
         }
      }

      public void mouseReleased(MouseEvent var1) {
      }
   }

   class SymWindow extends WindowAdapter {
      public void windowClosing(WindowEvent var1) {
         Object var2 = var1.getSource();
         if (var2 == Powerboard.this) {
            Powerboard.this.Powerboard_WindowClosing(var1);
         }
      }
   }
}
