package amp.powerboard.utils;

import java.awt.Cursor;
import java.util.MissingResourceException;
import java.util.ResourceBundle;
import javax.swing.ImageIcon;

public class PbResource {
   private static ResourceBundle bundle;
   private static final Cursor HAND_CURSOR = Cursor.getPredefinedCursor(12);
   private static final Cursor WAIT_CURSOR = Cursor.getPredefinedCursor(3);
   private static final Cursor DEFAULT_CURSOR = Cursor.getDefaultCursor();

   protected static ResourceBundle getResourceBundle() {
      if (bundle == null) {
         bundle = ResourceBundle.getBundle("powerboard");
      }

      return bundle;
   }

   public static String getString(String var0) {
      String var1 = null;

      try {
         var1 = getResourceBundle().getString(var0);
      } catch (MissingResourceException var4) {
         System.out.println("Resource string for '" + var0 + "' does not exist ");
      } catch (Exception var5) {
         System.out.println("Throwing " + var5.getClass().getName() + " exception for key " + var0);
      }

      return var1;
   }

   public static ImageIcon getIcon(String var0) {
      ImageIcon var1 = null;
      StringBuffer var2 = new StringBuffer("/images/");
      var2.append(getString(var0));

      try {
         var1 = new ImageIcon(
            (class$amp$powerboard$utils$PbResource == null
                  ? (class$amp$powerboard$utils$PbResource = class$("amp.powerboard.utils.PbResource"))
                  : class$amp$powerboard$utils$PbResource)
               .getResource(var2.toString())
         );
      } catch (MissingResourceException var5) {
         System.out.println("Resource string for '" + var0 + "' does not exist ");
      } catch (Exception var6) {
         System.out.println("Throwing " + var6.getClass().getName() + " exception for key " + var0);
      }

      return var1;
   }

   public static Cursor getWaitCursor() {
      return WAIT_CURSOR;
   }

   public static Cursor getDefaultCursor() {
      return DEFAULT_CURSOR;
   }

   public static Cursor getHandCursor() {
      return HAND_CURSOR;
   }
}
