package amp.powerboard.utils;

import java.awt.Component;
import java.awt.Container;
import javax.swing.Spring;
import javax.swing.SpringLayout;
import javax.swing.SpringLayout.Constraints;

public class SpringUtilities {
   public static void printSizes(Component var0) {
      System.out.println("minimumSize = " + var0.getMinimumSize());
      System.out.println("preferredSize = " + var0.getPreferredSize());
      System.out.println("maximumSize = " + var0.getMaximumSize());
   }

   public static void makeGrid(Container var0, int var1, int var2, int var3, int var4, int var5, int var6) {
      SpringLayout var7;
      try {
         var7 = (SpringLayout)var0.getLayout();
      } catch (ClassCastException var21) {
         System.err.println("The first argument to makeGrid must use SpringLayout.");
         System.err.println("The " + var0.getName() + " does not use SpringLayout.");
         return;
      }

      Spring var8 = Spring.constant(var5);
      Spring var9 = Spring.constant(var6);
      Spring var10 = Spring.constant(var3);
      Spring var11 = Spring.constant(var4);
      int var12 = var1 * var2;
      Spring var13 = var7.getConstraints(var0.getComponent(0)).getWidth();
      Spring var14 = var7.getConstraints(var0.getComponent(0)).getWidth();

      for (int var15 = 1; var15 < var12; var15++) {
         Constraints var16 = var7.getConstraints(var0.getComponent(var15));
         var13 = Spring.max(var13, var16.getWidth());
         var14 = Spring.max(var14, var16.getHeight());
      }

      for (int var22 = 0; var22 < var12; var22++) {
         Constraints var17 = var7.getConstraints(var0.getComponent(var22));
         var17.setWidth(var13);
         var17.setHeight(var14);
      }

      Constraints var23 = null;
      Constraints var18 = null;

      for (int var19 = 0; var19 < var12; var19++) {
         Constraints var20 = var7.getConstraints(var0.getComponent(var19));
         if (var19 % var2 == 0) {
            var18 = var23;
            var20.setX(var10);
         } else {
            var20.setX(Spring.sum(var23.getConstraint("East"), var8));
         }

         if (var19 / var2 == 0) {
            var20.setY(var11);
         } else {
            var20.setY(Spring.sum(var18.getConstraint("South"), var9));
         }

         var23 = var20;
      }

      Constraints var24 = var7.getConstraints(var0);
      var24.setConstraint("South", Spring.sum(Spring.constant(var6), var23.getConstraint("South")));
      var24.setConstraint("East", Spring.sum(Spring.constant(var5), var23.getConstraint("East")));
   }

   private static Constraints getConstraintsForCell(int var0, int var1, Container var2, int var3) {
      SpringLayout var4 = (SpringLayout)var2.getLayout();
      Component var5 = var2.getComponent(var0 * var3 + var1);
      return var4.getConstraints(var5);
   }

   public static void makeCompactGrid(Container var0, int var1, int var2, int var3, int var4, int var5, int var6) {
      SpringLayout var7;
      try {
         var7 = (SpringLayout)var0.getLayout();
      } catch (ClassCastException var16) {
         System.err.println("The first argument to makeCompactGrid must use SpringLayout.");
         return;
      }

      Spring var8 = Spring.constant(var3);

      for (int var9 = 0; var9 < var2; var9++) {
         Spring var10 = Spring.constant(0);

         for (int var11 = 0; var11 < var1; var11++) {
            var10 = Spring.max(var10, getConstraintsForCell(var11, var9, var0, var2).getWidth());
         }

         for (int var12 = 0; var12 < var1; var12++) {
            Constraints var13 = getConstraintsForCell(var12, var9, var0, var2);
            var13.setX(var8);
            var13.setWidth(var10);
         }

         var8 = Spring.sum(var8, Spring.sum(var10, Spring.constant(var5)));
      }

      Spring var17 = Spring.constant(var4);

      for (int var18 = 0; var18 < var1; var18++) {
         Spring var19 = Spring.constant(0);

         for (int var21 = 0; var21 < var2; var21++) {
            var19 = Spring.max(var19, getConstraintsForCell(var18, var21, var0, var2).getHeight());
         }

         for (int var14 = 0; var14 < var2; var14++) {
            Constraints var15 = getConstraintsForCell(var18, var14, var0, var2);
            var15.setY(var17);
            var15.setHeight(var19);
         }

         var17 = Spring.sum(var17, Spring.sum(var19, Spring.constant(var6)));
      }

      Constraints var20 = var7.getConstraints(var0);
      var20.setConstraint("South", var17);
      var20.setConstraint("East", var8);
   }
}
