package com.raritan.plaf;

import java.awt.Color;
import java.awt.GradientPaint;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Point;
import java.awt.Rectangle;
import java.awt.geom.Point2D;
import javax.swing.JComponent;

public class RaritanGradientDrawer {
   public static void paintGradienLine(Graphics var0, Point var1, Point var2) {
      Graphics2D var3 = (Graphics2D)var0;
      var3.drawLine(var1.x, var1.y, var2.x, var2.y);
   }

   public static void paintGradiendRect(Graphics var0, Rectangle var1, Color var2, Color var3, boolean var4) {
      Graphics2D var5 = (Graphics2D)var0;
      Object var6 = null;
      Object var7 = null;
      if (var4) {
         var6 = new Point(var1.width / 2, var1.y);
         var7 = new Point(var1.width / 2, var1.y + var1.height);
      } else {
         var6 = new Point(var1.x, var1.height / 2);
         var7 = new Point(var1.x + var1.width, var1.height / 2);
      }

      GradientPaint var8 = new GradientPaint((Point2D)var6, var2, (Point2D)var7, var3);
      var5.setPaint(var8);
      var5.fill(var1);
   }

   public static void paintDefaultGradient(Graphics var0, JComponent var1, Color var2, Color var3) {
      Rectangle var4 = null;
      var4 = var1.getBounds();
      var4.x = 0;
      var4.y = 0;
      paintGradiendRect(var0, var4, var2, var3, true);
   }

   public static void paintDefaultGradientDual(Graphics var0, JComponent var1, Color var2, Color var3) {
      Rectangle var4 = null;
      var4 = var1.getBounds();
      var4.x = 0;
      var4.y = 0;
      var4.height = var4.height / 3 * 2;
      paintGradiendRect(var0, var4, var2, var3, true);
      var4 = var1.getBounds();
      var4.x = 0;
      var4.y = var4.height / 3 * 2;
      var4.height /= 3;
      paintGradiendRect(var0, var4, var3, var2, true);
   }

   public static void paintDefaultGradientDual(Graphics var0, JComponent var1, Color var2, Color var3, Color var4) {
      Rectangle var5 = null;
      var5 = var1.getBounds();
      var5.x = 0;
      var5.y = 0;
      var5.height = var5.height / 3 * 2;
      paintGradiendRect(var0, var5, var2, var3, true);
      var5 = var1.getBounds();
      var5.x = 0;
      var5.y = var5.height / 3 * 2;
      var5.height /= 3;
      paintGradiendRect(var0, var5, var3, var4, true);
   }

   public static void paintDefaultMenuBarGradient(Graphics var0, JComponent var1, Color var2, Color var3, Color var4) {
      Rectangle var5 = null;
      var5 = var1.getBounds();
      var5.x = 0;
      var5.y = 0;
      var5.height /= 2;
      paintGradiendRect(var0, var5, var2, var3, true);
      var5 = var1.getBounds();
      var5.x = 0;
      var5.y = var5.height / 2;
      var5.height /= 2;
      paintGradiendRect(var0, var5, var3, var4, true);
   }
}
