package com.raritan.plaf;

import java.awt.Color;
import java.awt.Graphics;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import javax.swing.ButtonModel;
import javax.swing.JComponent;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.plaf.ComponentUI;
import javax.swing.plaf.basic.BasicMenuUI;

public class RaritanMenuUI extends BasicMenuUI implements MouseListener {
   protected Color toolBarBorderLight = new Color(255, 254, 255);
   protected Color toolBarBorderDark = new Color(55, 53, 54);

   public static ComponentUI createUI(JComponent var0) {
      return new RaritanMenuUI();
   }

   @Override
   public void installUI(JComponent var1) {
      super.installUI(var1);
      var1.addMouseListener(this);
   }

   @Override
   public void update(Graphics var1, JComponent var2) {
      super.update(var1, var2);
   }

   @Override
   public void uninstallUI(JComponent var1) {
      super.uninstallUI(var1);
      var1.removeMouseListener(this);
   }

   @Override
   public void paint(Graphics var1, JComponent var2) {
      super.paint(var1, var2);
   }

   @Override
   protected void paintBackground(Graphics var1, JMenuItem var2, Color var3) {
      ButtonModel var4 = this.menuItem.getModel();
      JComponent var5 = (JComponent)var2.getParent();
      if (var4.isSelected()) {
         var1.setColor(RaritanLookAndFeel.BASE_BACKGROUND);
         var1.fillRect(0, 0, var2.getWidth(), var2.getHeight());
         super.paintBackground(var1, var2, var3);
      } else if (var2.getClientProperty("mouseIn") != null && var5 instanceof JMenuBar) {
         var1.setColor(RaritanLookAndFeel.BASE_BACKGROUND);
         var1.fillRect(1, 1, var2.getWidth(), var2.getHeight() - 2);
         var1.setColor(this.toolBarBorderLight);
         var1.drawLine(1, 1, var2.getWidth(), 1);
         var1.drawLine(1, 1, 1, var2.getHeight() - 2);
         var1.setColor(this.toolBarBorderDark);
         var1.drawLine(1, var2.getHeight() - 2, var2.getWidth(), var2.getHeight() - 2);
         var1.drawLine(var2.getWidth() - 1, 1, var2.getWidth() - 1, var2.getHeight() - 2);
      } else {
         super.paintBackground(var1, var2, var3);
      }
   }

   @Override
   public void mouseClicked(MouseEvent var1) {
   }

   @Override
   public void mouseEntered(MouseEvent var1) {
      JComponent var2 = (JComponent)var1.getComponent();
      var2.putClientProperty("mouseIn", "TRUE");
      var2.repaint();
   }

   @Override
   public void mouseExited(MouseEvent var1) {
      JComponent var2 = (JComponent)var1.getComponent();
      var2.putClientProperty("mouseIn", null);
      var2.repaint();
   }

   @Override
   public void mousePressed(MouseEvent var1) {
   }

   @Override
   public void mouseReleased(MouseEvent var1) {
   }
}
