package com.raritan.plaf;

import java.awt.Component;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.Insets;
import java.awt.LayoutManager2;
import java.awt.Rectangle;
import javax.swing.JRootPane;

public class RaritanRootPaneLayout implements LayoutManager2 {
   @Override
   public Dimension preferredLayoutSize(Container var1) {
      int var4 = 0;
      int var5 = 0;
      int var6 = 0;
      int var7 = 0;
      byte var8 = 0;
      Insets var9 = var1.getInsets();
      JRootPane var10 = (JRootPane)var1;
      Dimension var2;
      if (var10.getContentPane() != null) {
         var2 = var10.getContentPane().getPreferredSize();
      } else {
         var2 = var10.getSize();
      }

      if (var2 != null) {
         var4 = var2.width;
         var5 = var2.height;
      }

      if (var10.getJMenuBar() != null) {
         Dimension var3 = var10.getJMenuBar().getPreferredSize();
         if (var3 != null) {
            var6 = var3.width;
            var7 = var3.height;
         }
      }

      return new Dimension(Math.max(Math.max(var4, var6), var8) + var9.left + var9.right, var5 + var7 + var8 + var9.top + var9.bottom);
   }

   @Override
   public Dimension minimumLayoutSize(Container var1) {
      int var4 = 0;
      int var5 = 0;
      int var6 = 0;
      int var7 = 0;
      byte var8 = 0;
      Insets var9 = var1.getInsets();
      JRootPane var10 = (JRootPane)var1;
      Dimension var2;
      if (var10.getContentPane() != null) {
         var2 = var10.getContentPane().getMinimumSize();
      } else {
         var2 = var10.getSize();
      }

      if (var2 != null) {
         var4 = var2.width;
         var5 = var2.height;
      }

      if (var10.getJMenuBar() != null) {
         Dimension var3 = var10.getJMenuBar().getMinimumSize();
         if (var3 != null) {
            var6 = var3.width;
            var7 = var3.height;
         }
      }

      return new Dimension(Math.max(Math.max(var4, var6), var8) + var9.left + var9.right, var5 + var7 + var8 + var9.top + var9.bottom);
   }

   @Override
   public Dimension maximumLayoutSize(Container var1) {
      int var4 = Integer.MAX_VALUE;
      int var5 = Integer.MAX_VALUE;
      int var6 = Integer.MAX_VALUE;
      int var7 = Integer.MAX_VALUE;
      int var8 = Integer.MAX_VALUE;
      int var9 = Integer.MAX_VALUE;
      Insets var10 = var1.getInsets();
      JRootPane var11 = (JRootPane)var1;
      if (var11.getContentPane() != null) {
         Dimension var2 = var11.getContentPane().getMaximumSize();
         if (var2 != null) {
            var4 = var2.width;
            var5 = var2.height;
         }
      }

      if (var11.getJMenuBar() != null) {
         Dimension var3 = var11.getJMenuBar().getMaximumSize();
         if (var3 != null) {
            var6 = var3.width;
            var7 = var3.height;
         }
      }

      int var12 = Math.max(Math.max(var5, var7), var9);
      if (var12 != Integer.MAX_VALUE) {
         var12 = var5 + var7 + var9 + var10.top + var10.bottom;
      }

      int var13 = Math.max(Math.max(var4, var6), var8);
      if (var13 != Integer.MAX_VALUE) {
         var13 += var10.left + var10.right;
      }

      return new Dimension(var13, var12);
   }

   @Override
   public void layoutContainer(Container var1) {
      JRootPane var2 = (JRootPane)var1;
      Rectangle var3 = var2.getBounds();
      Insets var4 = var2.getInsets();
      int var5 = 0;
      int var6 = var3.width - var4.right - var4.left;
      int var7 = var3.height - var4.top - var4.bottom;
      if (var2.getLayeredPane() != null) {
         var2.getLayeredPane().setBounds(var4.left, var4.top, var6, var7);
      }

      if (var2.getGlassPane() != null) {
         var2.getGlassPane().setBounds(var4.left, var4.top, var6, var7);
      }

      if (var2.getJMenuBar() != null) {
         Dimension var8 = var2.getJMenuBar().getPreferredSize();
         var2.getJMenuBar().setBounds(0, var5, var6, var8.height);
         var5 += var8.height;
      }

      if (var2.getContentPane() != null) {
         var2.getContentPane().setBounds(0, var5, var6, var7 < var5 ? 0 : var7 - var5);
      }
   }

   @Override
   public float getLayoutAlignmentX(Container var1) {
      return 0.0F;
   }

   @Override
   public float getLayoutAlignmentY(Container var1) {
      return 0.0F;
   }

   @Override
   public void invalidateLayout(Container var1) {
   }

   @Override
   public void addLayoutComponent(Component var1, Object var2) {
   }

   @Override
   public void addLayoutComponent(String var1, Component var2) {
   }

   @Override
   public void removeLayoutComponent(Component var1) {
   }
}
