package com.raritan.plaf;

import java.awt.Color;
import java.awt.Graphics;
import java.awt.Rectangle;
import javax.swing.JButton;
import javax.swing.JComponent;
import javax.swing.plaf.ComponentUI;
import javax.swing.plaf.metal.MetalScrollBarUI;

public class RaritanScrollBarUI extends MetalScrollBarUI {
   protected Color bottomBorderIn = new Color(121, 120, 116);
   protected Color bottomBorderOut = new Color(181, 181, 181);
   protected Color rightBorderIn = new Color(121, 120, 116);
   protected Color rightBorderOut = new Color(212, 210, 211);
   protected Color leftBorder = new Color(178, 178, 178);
   protected Color dotColor = new Color(173, 167, 153);

   public static ComponentUI createUI(JComponent var0) {
      return new RaritanScrollBarUI();
   }

   @Override
   public void installUI(JComponent var1) {
      super.installUI(var1);
   }

   @Override
   public void update(Graphics var1, JComponent var2) {
      super.update(var1, var2);
   }

   @Override
   public void uninstallUI(JComponent var1) {
      super.uninstallUI(var1);
   }

   @Override
   public void paint(Graphics var1, JComponent var2) {
      super.paint(var1, var2);
   }

   @Override
   protected void paintThumb(Graphics var1, JComponent var2, Rectangle var3) {
      if (var2.isEnabled()) {
         var1.translate(var3.x, var3.y);
         if (this.scrollbar.getOrientation() == 1) {
            var1.setColor(RaritanLookAndFeel.BASE_BACKGROUND);
            var1.fillRect(2, 0, var3.width - 4, var3.height - 2);
            var1.setColor(this.bottomBorderIn);
            var1.drawLine(2, var3.height - 2, var3.width - 3, var3.height - 2);
            var1.setColor(this.bottomBorderOut);
            var1.drawLine(2, var3.height - 1, var3.width - 2, var3.height - 1);
            var1.setColor(this.rightBorderIn);
            var1.drawLine(var3.width - 2, 0, var3.width - 2, var3.height - 2);
            var1.setColor(this.rightBorderOut);
            var1.drawLine(var3.width - 1, 1, var3.width - 1, var3.height - 2);
            var1.setColor(this.dotColor);
            int var4 = var3.width / 2 + 2;
            int var5 = var3.height / 2;
            int var6 = var3.width / 4 - 1;
            int var7 = var3.height / 4;

            for (int var8 = var7; var8 < var7 + var5; var8 += 2) {
               for (int var9 = var6; var9 < var6 + var4; var9 += 2) {
                  var1.drawLine(var9, var8, var9, var8);
               }
            }
         } else {
            var1.setColor(RaritanLookAndFeel.BASE_BACKGROUND);
            var1.fillRect(0, 2, var3.width - 2, var3.height - 4);
            var1.setColor(this.bottomBorderIn);
            var1.drawLine(0, var3.height - 2, var3.width - 2, var3.height - 2);
            var1.setColor(this.bottomBorderOut);
            var1.drawLine(0, var3.height - 1, var3.width - 2, var3.height - 1);
            var1.setColor(this.rightBorderIn);
            var1.drawLine(var3.width - 2, 2, var3.width - 2, var3.height - 2);
            var1.setColor(this.rightBorderOut);
            var1.drawLine(var3.width - 1, 3, var3.width - 1, var3.height - 2);
            var1.setColor(this.dotColor);
            int var10 = var3.width / 2;
            int var11 = var3.height / 2 + 2;
            int var12 = var3.width / 4;
            int var13 = var3.height / 4 - 1;

            for (int var14 = var13; var14 < var13 + var11; var14 += 2) {
               for (int var15 = var12; var15 < var12 + var10; var15 += 2) {
                  var1.drawLine(var15, var14, var15, var14);
               }
            }
         }

         var1.translate(-var3.x, -var3.y);
      }
   }

   @Override
   protected void paintTrack(Graphics var1, JComponent var2, Rectangle var3) {
      var1.translate(var3.x, var3.y);
      if (this.scrollbar.getOrientation() == 1) {
         if (var2.isEnabled()) {
            var1.setColor(this.leftBorder);
            var1.drawLine(0, 0, 0, var3.height - 1);
         }
      } else if (var2.isEnabled()) {
         var1.setColor(this.leftBorder);
         var1.drawLine(0, 0, var3.width - 1, 0);
      }

      var1.translate(-var3.x, -var3.y);
   }

   @Override
   protected JButton createDecreaseButton(int var1) {
      return new RaritanScrollButton(var1);
   }

   @Override
   protected JButton createIncreaseButton(int var1) {
      return new RaritanScrollButton(var1);
   }
}
