package com.raritan.plaf;

import java.awt.Color;
import java.awt.Graphics;
import javax.swing.plaf.basic.BasicArrowButton;

public class RaritanScrollButton extends BasicArrowButton {
   private static final long serialVersionUID = 1691608421562200739L;
   protected Color leftBorder = new Color(178, 178, 178);
   protected Color bottomBorderIn = new Color(121, 120, 116);
   protected Color bottomBorderOut = new Color(181, 180, 185);
   protected Color rightBorderIn = new Color(121, 120, 116);
   protected Color rightBorderOut = new Color(212, 210, 213);
   protected Color upLeftBorderPressed = new Color(72, 71, 69);
   protected Color arrowColor = Color.BLACK;
   protected int arrowHeight = 3;

   public RaritanScrollButton(int var1) {
      super(var1);
   }

   @Override
   public void paint(Graphics var1) {
      boolean var2 = this.getModel().isPressed();
      int var3 = this.getSize().width;
      int var4 = this.getSize().height;
      var1.setColor(Color.WHITE);
      var1.fillRect(0, 0, var3, var4);
      var1.setColor(RaritanLookAndFeel.BASE_BACKGROUND);
      if (this.direction != 1 && this.direction != 5) {
         var1.fillRect(0, 2, var3 - 2, var4 - 3);
      } else {
         var1.fillRect(2, 0, var3 - 3, var4 - 2);
      }

      switch (this.direction) {
         case 1:
            var1.setColor(this.leftBorder);
            var1.drawLine(0, 0, 0, var4);
            var1.setColor(this.arrowColor);
            int var10 = (var4 - this.arrowHeight) / 2;
            int var13 = (var3 - 2) / 2;

            for (int var16 = 0; var16 < this.arrowHeight; var16++) {
               var1.drawLine(var13 - var16, var10 + var16, var13 + var16 + 1, var10 + var16);
            }
         case 2:
         case 4:
         case 6:
         default:
            break;
         case 3:
            var1.setColor(this.leftBorder);
            var1.drawLine(0, 0, var3, 0);
            var1.setColor(this.arrowColor);
            int var9 = (var3 - this.arrowHeight) / 2 + this.arrowHeight - 1;
            int var12 = (var4 - 2) / 2;

            for (int var15 = 0; var15 < this.arrowHeight; var15++) {
               var1.drawLine(var9 - var15, var12 - var15, var9 - var15, var12 + var15 + 1);
            }
            break;
         case 5:
            var1.setColor(this.leftBorder);
            var1.drawLine(0, 0, 0, var4);
            var1.setColor(this.arrowColor);
            int var8 = (var4 - this.arrowHeight) / 2 + this.arrowHeight - 1;
            int var11 = (var3 - 2) / 2;

            for (int var14 = 0; var14 < this.arrowHeight; var14++) {
               var1.drawLine(var11 - var14, var8 - var14, var11 + var14 + 1, var8 - var14);
            }
            break;
         case 7:
            var1.setColor(this.leftBorder);
            var1.drawLine(0, 0, var3, 0);
            var1.setColor(this.arrowColor);
            int var5 = (var3 - this.arrowHeight) / 2;
            int var6 = (var4 - 2) / 2;

            for (int var7 = 0; var7 < this.arrowHeight; var7++) {
               var1.drawLine(var5 + var7, var6 - var7, var5 + var7, var6 + var7 + 1);
            }
      }

      if (var2) {
         if (this.direction != 1 && this.direction != 5) {
            var1.setColor(this.upLeftBorderPressed);
            var1.drawLine(0, 2, 0, var4 - 3);
            var1.drawLine(0, 2, var3 - 3, 2);
         } else {
            var1.setColor(this.upLeftBorderPressed);
            var1.drawLine(2, 0, 2, var4 - 3);
            var1.drawLine(2, 0, var3 - 2, 0);
         }
      } else if (this.direction != 1 && this.direction != 5) {
         var1.setColor(this.bottomBorderIn);
         var1.drawLine(0, var4 - 2, var3 - 2, var4 - 2);
         var1.setColor(this.bottomBorderOut);
         var1.drawLine(1, var4 - 1, var3 - 3, var4 - 1);
         var1.setColor(this.rightBorderIn);
         var1.drawLine(var3 - 2, 2, var3 - 2, var4 - 2);
         var1.setColor(this.rightBorderOut);
         var1.drawLine(var3 - 1, 3, var3 - 1, var4 - 3);
      } else {
         var1.setColor(this.bottomBorderIn);
         var1.drawLine(2, var4 - 2, var3 - 2, var4 - 2);
         var1.setColor(this.bottomBorderOut);
         var1.drawLine(3, var4 - 1, var3 - 3, var4 - 1);
         var1.setColor(this.rightBorderIn);
         var1.drawLine(var3 - 2, 0, var3 - 2, var4 - 2);
         var1.setColor(this.rightBorderOut);
         var1.drawLine(var3 - 1, 1, var3 - 1, var4 - 3);
      }
   }
}
