package com.raritan.plaf;

import java.awt.Color;
import java.awt.Graphics;
import java.awt.Insets;
import java.awt.Rectangle;
import javax.swing.JComponent;
import javax.swing.JScrollPane;
import javax.swing.plaf.ComponentUI;
import javax.swing.plaf.basic.BasicTabbedPaneUI;

public class RaritanTabbedPaneUI extends BasicTabbedPaneUI {
   public static final int SHADOW_WIDTH = 4;
   protected Color bgFirst = new Color(236, 233, 216);
   protected Color bgSecond = new Color(186, 182, 171);
   protected Color shadowFrom = new Color(158, 155, 143);
   protected Color shadowTo = new Color(236, 233, 216);
   protected Color topHighlightLeft = new Color(62, 59, 54);
   protected Color topHighlightTop = new Color(147, 143, 132);
   protected Color topHighlightCorner = new Color(170, 167, 148);
   protected Color selTopHighlightLeft = new Color(159, 155, 146);
   protected Color selTopHighlightTop = new Color(199, 193, 193);
   protected Color selTopHighlightRight = new Color(47, 46, 42);
   protected Color topBorder = new Color(147, 143, 132);
   protected Color leftBorder = new Color(159, 155, 146);
   protected Color bottomBorderIn = new Color(66, 63, 58);
   protected Color bottomBorder = new Color(143, 143, 133);
   protected Color bottomBorderOut = new Color(204, 201, 182);
   protected Color rightBorderIn = new Color(66, 63, 58);
   protected Color rightBorder = new Color(143, 143, 133);
   protected Color rightBorderOut = new Color(204, 201, 182);

   public static ComponentUI createUI(JComponent var0) {
      return new RaritanTabbedPaneUI();
   }

   @Override
   public void installUI(JComponent var1) {
      super.installUI(var1);
   }

   @Override
   public void update(Graphics var1, JComponent var2) {
      super.update(var1, var2);
   }

   @Override
   public void uninstallUI(JComponent var1) {
      super.uninstallUI(var1);
   }

   @Override
   public void paint(Graphics var1, JComponent var2) {
      super.paint(var1, var2);
   }

   @Override
   protected void paintTab(Graphics var1, int var2, Rectangle[] var3, int var4, Rectangle var5, Rectangle var6) {
      super.paintTab(var1, var2, var3, var4, var5, var6);
      Rectangle var7 = var3[var4];
      int var8 = this.tabPane.getSelectedIndex();
      if (this.lastTabInRun(this.tabPane.getTabCount(), this.selectedRun) != var8 && var4 == var8 + 1) {
         if (var2 == 1) {
            Rectangle var9 = new Rectangle((int)var7.getX(), (int)var7.getY() + 1, 4, (int)var7.getHeight());
            RaritanGradientDrawer.paintGradiendRect(var1, var9, this.shadowFrom, this.shadowTo, false);
         } else if (var2 == 3) {
            Rectangle var10 = new Rectangle((int)var7.getX(), (int)var7.getY(), 4, (int)var7.getHeight() - 2);
            RaritanGradientDrawer.paintGradiendRect(var1, var10, this.shadowFrom, this.shadowTo, false);
         } else if (var2 == 2) {
            Rectangle var11 = new Rectangle((int)var7.getX() + 1, (int)var7.getY(), (int)var7.getWidth(), 4);
            RaritanGradientDrawer.paintGradiendRect(var1, var11, this.shadowFrom, this.shadowTo, true);
         } else if (var2 == 4) {
            Rectangle var12 = new Rectangle((int)var7.getX(), (int)var7.getY(), (int)var7.getWidth() - 2, 4);
            RaritanGradientDrawer.paintGradiendRect(var1, var12, this.shadowFrom, this.shadowTo, true);
         }
      }
   }

   @Override
   protected void paintTabBackground(Graphics var1, int var2, int var3, int var4, int var5, int var6, int var7, boolean var8) {
      JComponent var9 = (JComponent)this.tabPane.getComponent(var3);
      Color var10 = null;
      if (var8) {
         if (var9 instanceof JScrollPane) {
            var10 = ((JScrollPane)var9).getViewport().getView().getBackground();
         } else {
            var10 = var9.getBackground();
         }
      } else {
         var1.setColor(this.tabPane.getBackgroundAt(var3));
      }

      var1.setColor(var10);
      switch (var2) {
         case 1:
         default:
            if (var8) {
               var1.fillRect(var4 + 1, var5 + 1, var6 - 2, var7 - 1);
            } else {
               Rectangle var14 = new Rectangle(var4 + 1, var5 + 1, var6 - 1, var7 - 1);
               RaritanGradientDrawer.paintGradiendRect(var1, var14, this.bgFirst, this.bgSecond, true);
            }
            break;
         case 2:
            if (var8) {
               var1.fillRect(var4 + 1, var5 + 1, var6 - 2, var7 - 3);
            } else {
               Rectangle var13 = new Rectangle(var4 + 1, var5 + 1, var6 - 2, var7 - 3);
               RaritanGradientDrawer.paintGradiendRect(var1, var13, this.bgSecond, this.bgFirst, false);
            }
            break;
         case 3:
            if (var8) {
               var1.fillRect(var4 + 1, var5, var6 - 3, var7 - 1);
            } else {
               Rectangle var12 = new Rectangle(var4 + 1, var5, var6 - 1, var7 - 1);
               RaritanGradientDrawer.paintGradiendRect(var1, var12, this.bgSecond, this.bgFirst, true);
            }
            break;
         case 4:
            if (var8) {
               var1.fillRect(var4, var5 + 1, var6 - 2, var7 - 3);
            } else {
               Rectangle var11 = new Rectangle(var4, var5 + 1, var6 - 2, var7 - 3);
               RaritanGradientDrawer.paintGradiendRect(var1, var11, this.bgFirst, this.bgSecond, false);
            }
      }
   }

   @Override
   protected void paintTabBorder(Graphics var1, int var2, int var3, int var4, int var5, int var6, int var7, boolean var8) {
      int var9 = this.getRunForTab(this.tabPane.getTabCount(), var3);
      int var10 = this.lastTabInRun(this.tabPane.getTabCount(), var9);
      switch (var2) {
         case 1:
         default:
            if (var8) {
               var1.setColor(this.selTopHighlightLeft);
               var1.drawLine(var4, var5 + 1, var4, var5 + var7);
               var1.setColor(this.selTopHighlightTop);
               var1.drawLine(var4, var5, var4 + var6 - 1, var5);
               var1.setColor(this.selTopHighlightRight);
               var1.drawLine(var4 + var6 - 1, var5 + 1, var4 + var6 - 1, var5 + var7);
            } else {
               var1.setColor(this.topHighlightLeft);
               var1.drawLine(var4, var5 + 1, var4, var5 + var7);
               var1.setColor(this.topHighlightCorner);
               var1.drawLine(var4, var5, var4 + 1, var5);
               var1.setColor(this.topHighlightTop);
               var1.drawLine(var4 + 2, var5, var4 + var6 - 2, var5);
               var1.setColor(this.topHighlightCorner);
               var1.drawLine(var4 + var6 - 1, var5, var4 + var6, var5);
               if (var3 == var10) {
                  var1.setColor(this.topHighlightTop);
                  var1.drawLine(var4 + var6, var5 + 1, var4 + var6, var5 + var7);
               }
            }
            break;
         case 2:
            throw new RuntimeException("Code not finished");
         case 3:
            if (var8) {
               var1.setColor(this.selTopHighlightLeft);
               var1.drawLine(var4, var5 + 1, var4, var5 + var7 - 2);
               var1.setColor(this.selTopHighlightTop);
               var1.drawLine(var4, var5 + var7 - 2, var4 + var6 - 1, var5 + var7 - 2);
               var1.setColor(this.selTopHighlightRight);
               var1.drawLine(var4 + var6 - 1, var5 + 1, var4 + var6 - 1, var5 + var7 - 3);
            } else {
               var1.setColor(this.topHighlightLeft);
               var1.drawLine(var4, var5, var4, var5 + var7 - 2);
               var1.setColor(this.topHighlightCorner);
               var1.drawLine(var4, var5 + var7 - 2, var4 + 1, var5 + var7 - 2);
               var1.setColor(this.topHighlightTop);
               var1.drawLine(var4 + 2, var5 + var7 - 2, var4 + var6 - 2, var5 + var7 - 2);
               var1.setColor(this.topHighlightCorner);
               var1.drawLine(var4 + var6 - 1, var5 + var7 - 2, var4 + var6, var5 + var7 - 2);
               if (this.tabPane.getTabCount() == var3 + 1) {
                  var1.setColor(this.topHighlightTop);
                  var1.drawLine(var4 + var6, var5, var4 + var6, var5 + var7 - 2);
               }
            }
            break;
         case 4:
            throw new RuntimeException("Code not finished");
      }
   }

   @Override
   protected void paintContentBorder(Graphics var1, int var2, int var3) {
      JComponent var4 = (JComponent)this.tabPane.getComponent(var3);
      Object var5 = null;
      if (var4 instanceof JScrollPane) {
         var5 = ((JScrollPane)var4).getViewport().getView().getBackground();
      } else {
         var5 = var4.getBackground();
      }

      int var6 = this.tabPane.getWidth();
      int var7 = this.tabPane.getHeight();
      Insets var8 = this.tabPane.getInsets();
      int var9 = var8.left;
      int var10 = var8.top;
      int var11 = var6 - var8.right - var8.left;
      int var12 = var7 - var8.top - var8.bottom;
      switch (var2) {
         case 1:
         default:
            var10 += this.calculateTabAreaHeight(var2, this.runCount, this.maxTabHeight);
            var12 -= var10 - var8.top;
            break;
         case 2:
            var9 += this.calculateTabAreaWidth(var2, this.runCount, this.maxTabWidth);
            var11 -= var9 - var8.left;
            break;
         case 3:
            var12 -= this.calculateTabAreaHeight(var2, this.runCount, this.maxTabHeight);
            break;
         case 4:
            var11 -= this.calculateTabAreaWidth(var2, this.runCount, this.maxTabWidth);
      }

      var1.setColor((Color)var5);
      var1.fillRect(var9, var10, var11, var12);
      this.paintContentBorderTopEdge(var1, var2, var3, var9, var10, var11, var12);
      this.paintContentBorderLeftEdge(var1, var2, var3, var9, var10, var11, var12);
      this.paintContentBorderBottomEdge(var1, var2, var3, var9, var10, var11, var12);
      this.paintContentBorderRightEdge(var1, var2, var3, var9, var10, var11, var12);
   }

   @Override
   protected void paintContentBorderTopEdge(Graphics var1, int var2, int var3, int var4, int var5, int var6, int var7) {
      Rectangle var8 = var3 < 0 ? null : this.getTabBounds(var3, this.calcRect);
      var1.setColor(this.topBorder);
      if (var2 == 1 && var3 >= 0 && var8.y + var8.height + 1 >= var5 && var8.x >= var4 && var8.x <= var4 + var6) {
         if (var3 != 0) {
            var1.drawLine(var4, var5, var8.x, var5);
         }

         if (var8.x + var8.width < var4 + var6 - 2) {
            var1.drawLine(var8.x + var8.width - 1, var5, var4 + var6 - 2, var5);
         } else {
            var1.setColor(Color.GREEN);
            var1.drawLine(var4 + var6 - 2, var5, var4 + var6 - 2, var5);
         }
      } else {
         var1.drawLine(var4, var5, var4 + var6 - 2, var5);
      }
   }

   @Override
   protected void paintContentBorderLeftEdge(Graphics var1, int var2, int var3, int var4, int var5, int var6, int var7) {
      Rectangle var8 = var3 < 0 ? null : this.getTabBounds(var3, this.calcRect);
      var1.setColor(this.leftBorder);
      if (var2 != 2 || var3 < 0 || var8.x + var8.width + 1 < var4 || var8.y < var5 || var8.y > var5 + var7) {
         var1.drawLine(var4, var5, var4, var5 + var7 - 2);
      }
   }

   @Override
   protected void paintContentBorderBottomEdge(Graphics var1, int var2, int var3, int var4, int var5, int var6, int var7) {
      Rectangle var8 = var3 < 0 ? null : this.getTabBounds(var3, this.calcRect);
      if (var2 == 3 && var3 >= 0 && var8.y - 1 <= var7 && var8.x >= var4 && var8.x <= var4 + var6) {
         if (var3 != 0) {
            var1.drawLine(var4, var8.y + 1, var8.x, var8.y + 1);
         }

         if (var8.x + var8.width < var4 + var6 - 2) {
            var1.drawLine(var8.x + var8.width - 1, var8.y + 1, var4 + var6 - 2, var8.y + 1);
         } else {
            var1.setColor(Color.GREEN);
            var1.drawLine(var4 + var6 - 2, var5, var4 + var6 - 2, var5);
         }
      } else {
         var1.setColor(this.bottomBorderIn);
         var1.drawLine(var4, var5 + var7 - 2, var4 + var6 - 1, var5 + var7 - 2);
         var1.setColor(RaritanLookAndFeel.BASE_BACKGROUND);
         var1.drawLine(var4, var5 + var7 - 1, var4 + 1, var5 + var7 - 1);
         var1.setColor(this.bottomBorder);
         var1.drawLine(var4 + 1, var5 + var7 - 1, var4 + var6 - 1, var5 + var7 - 1);
         var1.setColor(this.bottomBorderOut);
         var1.drawLine(var4 + var6 - 2, var5 + var7 - 1, var4 + var6 - 1, var5 + var7 - 1);
         var1.drawLine(var4 + 2, var5 + var7, var4 + var6 - 2, var5 + var7);
      }
   }

   @Override
   protected void paintContentBorderRightEdge(Graphics var1, int var2, int var3, int var4, int var5, int var6, int var7) {
      Rectangle var8 = var3 < 0 ? null : this.getTabBounds(var3, this.calcRect);
      if (var2 != 4 || var3 < 0 || var8.x - 1 > var6 || var8.y < var5 || var8.y > var5 + var7) {
         var1.setColor(this.rightBorderIn);
         var1.drawLine(var4 + var6 - 2, var5, var4 + var6 - 2, var5 + var7 - 2);
         var1.setColor(RaritanLookAndFeel.BASE_BACKGROUND);
         var1.drawLine(var4 + var6 - 1, var5, var4 + var6 - 1, var5 + 1);
         var1.setColor(this.rightBorder);
         var1.drawLine(var4 + var6 - 1, var5 + 1, var4 + var6 - 1, var5 + var7 - 1);
         var1.setColor(this.rightBorderOut);
         var1.drawLine(var4 + var6 - 1, var5 + var7 - 2, var4 + var6 - 1, var5 + var7 - 1);
         var1.drawLine(var4 + var6, var5 + 2, var4 + var6, var5 + var7 - 2);
      }
   }
}
