package com.raritan.plaf;

import java.awt.Color;
import java.awt.Graphics;
import java.awt.Rectangle;
import javax.swing.JComponent;
import javax.swing.plaf.ComponentUI;
import javax.swing.plaf.metal.MetalToolBarUI;

public class RaritanToolBarUI extends MetalToolBarUI {
   protected Color colorTopUp = new Color(227, 225, 202);
   protected Color colorTopDown = new Color(219, 216, 199);
   protected Color colorCenterUp = new Color(216, 213, 196);
   protected Color colorCenterDown = new Color(205, 202, 185);
   protected Color colorBottomUp = new Color(203, 200, 183);
   protected Color colorBottomDown = new Color(201, 198, 181);

   public static ComponentUI createUI(JComponent var0) {
      return new RaritanToolBarUI();
   }

   @Override
   public void installUI(JComponent var1) {
      super.installUI(var1);
   }

   @Override
   public void update(Graphics var1, JComponent var2) {
      super.update(var1, var2);
   }

   @Override
   public void uninstallUI(JComponent var1) {
      super.uninstallUI(var1);
   }

   @Override
   public void paint(Graphics var1, JComponent var2) {
      Rectangle var3 = null;
      var3 = var2.getBounds();
      var3.x = 0;
      var3.y = 0;
      var3.height /= 3;
      RaritanGradientDrawer.paintGradiendRect(var1, var3, this.colorTopUp, this.colorTopDown, true);
      var3 = var2.getBounds();
      var3.x = 0;
      var3.y = var3.height / 3;
      var3.height /= 3;
      RaritanGradientDrawer.paintGradiendRect(var1, var3, this.colorCenterUp, this.colorCenterDown, true);
      var3 = var2.getBounds();
      var3.x = 0;
      var3.y = var3.height / 3 * 2;
      var3.height /= 3;
      RaritanGradientDrawer.paintGradiendRect(var1, var3, this.colorBottomUp, this.colorBottomDown, true);
   }
}
