package com.raritan.plaf.border;

import java.awt.Color;
import java.awt.Component;
import java.awt.Graphics;
import java.awt.Insets;
import javax.swing.border.AbstractBorder;

public class ButtonBorder extends AbstractBorder {
   private static final long serialVersionUID = -1718538469699834454L;
   private static final Color TOP_COLOR = new Color(182, 178, 175);
   private static final Color LEFT_COLOR = new Color(139, 134, 131);
   private static final Color RIGHT_IN_COLOR = new Color(48, 44, 41);
   private static final Color RIGHT_OUT_COLOR = new Color(193, 190, 175);
   private static final Color BOTTON_IN_COLOR = new Color(29, 25, 24);
   private static final Color BOTTON_OUT_COLOR = new Color(166, 167, 153);

   @Override
   public Insets getBorderInsets(Component var1, Insets var2) {
      var2.top = var2.left = 3;
      var2.bottom = var2.right = 4;
      return var2;
   }

   @Override
   public Insets getBorderInsets(Component var1) {
      return new Insets(3, 3, 4, 4);
   }

   @Override
   public boolean isBorderOpaque() {
      return false;
   }

   @Override
   public void paintBorder(Component var1, Graphics var2, int var3, int var4, int var5, int var6) {
      Color var7 = var2.getColor();
      var2.setColor(TOP_COLOR);
      var2.drawLine(var3, var4, var3 + var5 - 2, var4);
      var2.setColor(LEFT_COLOR);
      var2.drawLine(var3, var4 + 1, var3, var4 + var6 - 2);
      var2.setColor(RIGHT_IN_COLOR);
      var2.drawLine(var3 + var5 - 2, var4 + 1, var3 + var5 - 2, var4 + var6 - 2);
      var2.setColor(RIGHT_OUT_COLOR);
      var2.drawLine(var3 + var5 - 1, var4 + 2, var3 + var5 - 1, var4 + var6 - 2);
      var2.setColor(BOTTON_IN_COLOR);
      var2.drawLine(var3 + 1, var4 + var6 - 2, var3 + var5 - 2, var4 + var6 - 2);
      var2.setColor(BOTTON_OUT_COLOR);
      var2.drawLine(var3 + 2, var4 + var6 - 1, var3 + var5 - 2, var4 + var6 - 1);
      var2.setColor(var7);
   }
}
