package com.raritan.plaf.border;

import java.awt.Color;
import java.awt.Component;
import java.awt.Graphics;
import java.awt.Insets;
import javax.swing.ButtonModel;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.border.AbstractBorder;

public class MenuItemBorder extends AbstractBorder {
   private static final long serialVersionUID = -3899787709209973449L;
   protected Color menuTopLeft = new Color(57, 57, 57);
   protected Color menuBottomRight = new Color(255, 254, 253);
   protected Color menuItemTop = new Color(92, 86, 90);
   protected Color menuItemBottom = new Color(255, 255, 255);

   @Override
   public Insets getBorderInsets(Component var1, Insets var2) {
      var2.top = 1;
      var2.left = 1;
      var2.bottom = 1;
      var2.right = 1;
      return var2;
   }

   @Override
   public Insets getBorderInsets(Component var1) {
      return new Insets(1, 1, 1, 1);
   }

   @Override
   public boolean isBorderOpaque() {
      return false;
   }

   @Override
   public void paintBorder(Component var1, Graphics var2, int var3, int var4, int var5, int var6) {
      JMenuItem var7 = (JMenuItem)var1;
      ButtonModel var8 = var7.getModel();
      if (var1.getParent() instanceof JMenuBar) {
         if (var8.isSelected()) {
            var2.setColor(this.menuTopLeft);
            var2.drawLine(var3, var4, var3, var4 + var6);
            var2.drawLine(var3, var4, var3 + var5 - 2, var4);
            var2.setColor(this.menuBottomRight);
            var2.drawLine(var3 + 1, var4 + var6 - 1, var3 + var5, var4 + var6 - 1);
            var2.drawLine(var3 + var5 - 1, var4, var3 + var5 - 1, var4 + var6);
         }
      } else if (var8.isArmed() || var8.isSelected()) {
         var2.setColor(this.menuItemTop);
         var2.drawLine(var3, var4, var3 + var5, var4);
         var2.setColor(this.menuItemBottom);
         var2.drawLine(var3, var4 + var6 - 1, var3 + var5, var4 + var6 - 1);
      }
   }
}
