package com.raritan.plaf.border;

import com.raritan.plaf.RaritanLookAndFeel;
import java.awt.Color;
import java.awt.Component;
import java.awt.Graphics;
import java.awt.Insets;
import javax.swing.border.AbstractBorder;

public class TextFieldBorder extends AbstractBorder {
   private static final long serialVersionUID = -4241409721695177628L;
   protected Color colorTop = new Color(62, 59, 52);
   protected Color colorLeft = new Color(67, 64, 59);
   protected Color colorBottom = new Color(245, 241, 229);
   protected Color colorRight = new Color(239, 237, 224);

   @Override
   public Insets getBorderInsets(Component var1, Insets var2) {
      var2.top = var2.left = var2.bottom = var2.right = 1;
      return var2;
   }

   @Override
   public Insets getBorderInsets(Component var1) {
      return new Insets(1, 1, 1, 1);
   }

   @Override
   public boolean isBorderOpaque() {
      return false;
   }

   @Override
   public void paintBorder(Component var1, Graphics var2, int var3, int var4, int var5, int var6) {
      Color var7 = var2.getColor();
      var2.setColor(this.colorTop);
      var2.drawLine(var3, var4, var3 + var5, var4);
      var2.setColor(RaritanLookAndFeel.BASE_BACKGROUND);
      var2.drawLine(var3, var4 + var6 - 1, var3 + 2, var4 + var6 - 1);
      var2.setColor(this.colorLeft);
      var2.drawLine(var3, var4 + 1, var3, var4 + var6 - 2);
      var2.setColor(this.colorBottom);
      var2.drawLine(var3 + 2, var4 + var6 - 1, var3 + var5 - 2, var4 + var6 - 1);
      var2.setColor(this.colorRight);
      var2.drawLine(var3 + var5 - 1, var4 + 1, var3 + var5 - 1, var4 + var6 - 1);
      var2.setColor(var7);
   }
}
