package com.raritan.plaf.border;

import java.awt.Color;
import java.awt.Component;
import java.awt.Graphics;
import java.awt.Insets;
import javax.swing.border.AbstractBorder;

public class ToolBarBorder extends AbstractBorder {
   private static final long serialVersionUID = 880248942239751854L;
   private static final Color topIn = new Color(218, 216, 201);
   private static final Color leftRight = new Color(152, 150, 151);
   private static final Color bottomOut = new Color(92, 86, 90);
   private static final Color bottomCenter = new Color(203, 202, 184);
   private static final Color bottomIn = new Color(207, 204, 187);

   @Override
   public Insets getBorderInsets(Component var1, Insets var2) {
      var2.top = 1;
      var2.left = 1;
      var2.bottom = 3;
      var2.right = 1;
      return var2;
   }

   @Override
   public Insets getBorderInsets(Component var1) {
      return new Insets(1, 1, 3, 1);
   }

   @Override
   public boolean isBorderOpaque() {
      return false;
   }

   @Override
   public void paintBorder(Component var1, Graphics var2, int var3, int var4, int var5, int var6) {
      Color var7 = var2.getColor();
      var2.setColor(topIn);
      var2.drawLine(var3 + 1, var4, var3 + var5 - 2, var4);
      var2.setColor(leftRight);
      var2.drawLine(var3, var4, var3, var4 + var6 - 2);
      var2.drawLine(var3 + var5 - 1, var4, var3 + var5 - 1, var4 + var6 - 2);
      var2.setColor(bottomOut);
      var2.drawLine(var3, var4 + var6 - 1, var3 + var5, var4 + var6 - 1);
      var2.setColor(bottomCenter);
      var2.drawLine(var3 + 1, var4 + var6 - 2, var3 + var5 - 2, var4 + var6 - 2);
      var2.setColor(bottomIn);
      var2.drawLine(var3 + 1, var4 + var6 - 3, var3 + var5 - 2, var4 + var6 - 3);
      var2.setColor(var7);
   }
}
