package com.raritan.protocol.browser;

import java.net.UnknownHostException;
import java.util.Enumeration;

public interface Browser {
   boolean BROWSE_LOCAL_NETWORK = true;
   int QUERY_INTERVAL = 10;
   int REMOVE_INTERVAL = 100;
   int CSC_DISCOVERY_PORT = 5000;

   void start();

   void stop();

   boolean isRunning();

   void addHandler(BrowserEventHandler var1);

   void removeHandler(BrowserEventHandler var1);

   void removeAllHandlers();

   Enumeration getActiveDevices();

   Enumeration getActiveDevicesByName(String var1);

   Enumeration getActiveDevicesByHost(String var1) throws UnknownHostException;

   void addHintAddress(HintAddress var1) throws UnknownHostException;

   void removeHintAddress(HintAddress var1);

   void removeAllHintAddresses();

   Enumeration getAllHintAddresses();

   void addDNSHint(String var1, int var2);

   void removeDNSHint(String var1);

   void browseLocalNetwork(boolean var1);

   boolean isBrowseLocalNetwork();

   void setQueryInterval(int var1);

   int getQueryInterval();

   void setRemoveInterval(int var1);

   int getRemoveInterval();

   void setDefaultDiscoveryPort(int var1);

   int getDefaultDiscoveryPort();
}
