package com.raritan.protocol.browser;

import javaclientlib.tr.Constants;

public class HintAddress implements Comparable {
   public String host = null;
   public int port = Constants.TR_PORT_BASE;

   public HintAddress(String var1) {
      this.host = var1.trim().toLowerCase();
      if (var1.length() == 0) {
         throw new NullPointerException();
      }
   }

   public HintAddress(String var1, int var2) {
      this.host = var1.trim().toLowerCase();
      this.port = var2 > 0 ? var2 : Constants.TR_PORT_BASE;
   }

   @Override
   public int compareTo(Object var1) {
      if (var1 == null) {
         return 1;
      } else if (var1 instanceof HintAddress) {
         int var2 = this.host.trim().compareTo(((HintAddress)var1).host.trim());
         if (var2 != 0) {
            return var2;
         } else if (this.port > ((HintAddress)var1).port) {
            return 1;
         } else {
            return this.port < ((HintAddress)var1).port ? -1 : 0;
         }
      } else {
         return this.getClass().getName().compareTo(var1.getClass().getName());
      }
   }

   @Override
   public boolean equals(Object var1) {
      return this.compareTo(var1) == 0;
   }

   @Override
   public int hashCode() {
      return this.host.trim().hashCode() ^ this.port;
   }
}
