package com.raritan.protocol.browser.spi;

import com.raritan.protocol.browser.BrowserEvent;
import com.raritan.protocol.csc.RRCDeviceInfo;

public class BrowserEventImpl implements BrowserEvent {
   protected static final String[] typeNames = new String[]{"ADD", "DEL", "PING"};
   protected RRCDeviceInfo deviceInfo = null;
   protected int type = -1;

   public BrowserEventImpl(int var1, RRCDeviceInfo var2) {
      this.type = var1;
      this.deviceInfo = var2;
   }

   @Override
   public RRCDeviceInfo getDeviceInfo() {
      return this.deviceInfo;
   }

   @Override
   public int getType() {
      return this.type;
   }

   @Override
   public String toString() {
      StringBuffer var1 = new StringBuffer();
      var1.append("BrowserEvent[ ");
      if (this.type >= 1 && this.type <= 3) {
         var1.append(typeNames[this.type - 1]);
      } else {
         var1.append(this.type);
      }

      var1.append(", DeviceInfo[ Name='");
      var1.append(this.deviceInfo.getName());
      var1.append("', Ver='");
      var1.append(this.deviceInfo.getVersion());
      var1.append("', Host=");
      var1.append(this.deviceInfo.getHost());
      var1.append(':');
      var1.append(this.deviceInfo.getPort());
      var1.append(" ] ]");
      return var1.toString();
   }
}
