package com.raritan.protocol.browser.spi;

import com.raritan.protocol.browser.DeviceNameAddressProvider;
import com.raritan.protocol.browser.TooManyDevicesException;
import com.raritan.rrc.ui.models.DeviceInfoWrapper;
import com.raritan.rrc.ui.models.DeviceListingModel;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Iterator;
import java.util.List;
import java.util.Set;

public class DeviceNameAddressProvImpl implements DeviceNameAddressProvider {
   private final DeviceListingModel model;

   public DeviceNameAddressProvImpl(DeviceListingModel var1) {
      this.model = var1;
   }

   @Override
   public List getAddresses(String var1) throws TooManyDevicesException {
      Set var2 = this.model.getDeviceInfoWrappersForDeviceName(var1);
      if (var2.size() == 0) {
         return Collections.EMPTY_LIST;
      } else {
         ArrayList var3 = new ArrayList();
         Iterator var4 = var2.iterator();

         while (var4.hasNext()) {
            var3.add(((DeviceInfoWrapper)var4.next()).getDeviceInfo().getInetAddress());
         }

         return var3;
      }
   }
}
