package com.raritan.protocol.csc.spi;

import java.net.InetAddress;
import java.net.SocketAddress;

public class RRCDeviceInfo implements com.raritan.protocol.csc.RRCDeviceInfo {
   protected String m_Name = null;
   protected String m_Model = null;
   protected String m_Type = null;
   protected String m_ClusterId = null;
   protected String m_Version = null;
   private int m_Port = 0;
   private String deviceID;
   private InetAddress inetAddress;
   private String dnsName;
   private SocketAddress socketAddress;
   protected String m_ProductName = null;

   public RRCDeviceInfo() {
   }

   public RRCDeviceInfo(SocketAddress var1) {
      this.socketAddress = var1;
   }

   public RRCDeviceInfo(String var1, String var2, String var3, String var4, String var5) {
      this.m_Name = var1;
      this.m_Model = var3;
      this.m_Type = var2;
      this.m_ClusterId = var4;
      this.m_Version = var5;
   }

   @Override
   public String getClusterId() {
      return this.m_ClusterId;
   }

   @Override
   public String getModel() {
      return this.m_Model;
   }

   @Override
   public String getName() {
      return this.m_Name;
   }

   @Override
   public String getType() {
      return this.m_Type;
   }

   @Override
   public String getVersion() {
      return this.m_Version;
   }

   public void setClusterId(String var1) {
      this.m_ClusterId = var1;
   }

   public void setModel(String var1) {
      this.m_Model = var1;
   }

   public void setName(String var1) {
      this.m_Name = var1;
   }

   public void setType(String var1) {
      this.m_Type = var1;
   }

   public void setVersion(String var1) {
      this.m_Version = var1;
   }

   @Override
   public String getHost() {
      return this.getInetAddress().getHostAddress();
   }

   @Override
   public int getPort() {
      return this.m_Port;
   }

   public void setPort(int var1) {
      this.m_Port = var1;
   }

   @Override
   public String getProductName() {
      return this.m_ProductName;
   }

   public void setProductName(String var1) {
      this.m_ProductName = var1;
   }

   @Override
   public String toString() {
      StringBuffer var1 = new StringBuffer("\n---------- Device Info -------------");
      var1.append("\n\tName: " + this.m_Name);
      var1.append("\n\tType: " + this.m_Type);
      var1.append("\n\tModel: " + this.m_Model);
      var1.append("\n\tVersion: " + this.m_Version);
      var1.append("\n\tClusterID: " + this.m_ClusterId);
      var1.append("\n\tProductName: " + this.m_ProductName);
      var1.append("\n\tPort: " + this.m_Port);
      var1.append("\n\tdeviceID: " + this.deviceID);
      var1.append("\n\tinetAddress: " + this.inetAddress);
      var1.append("\n\tDNSName: " + this.dnsName);
      return var1.toString();
   }

   public void setDeviceID(String var1) {
      this.deviceID = var1;
   }

   @Override
   public String getDeviceID() {
      return this.deviceID;
   }

   public void setInetAddress(InetAddress var1) {
      this.inetAddress = var1;
   }

   @Override
   public InetAddress getInetAddress() {
      return this.inetAddress;
   }

   public void setDnsName(String var1) {
      this.dnsName = var1;
   }

   @Override
   public String getDnsName() {
      return this.dnsName;
   }

   @Override
   public SocketAddress getSocketAddress() {
      return this.socketAddress;
   }
}
