package com.raritan.rrc.components.serialconsole;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.Enumeration;
import java.util.Hashtable;
import java.util.StringTokenizer;
import netscape.security.PrivilegeManager;

public class ConfigManager {
   private File file = null;
   private FileOutputStream fos = null;
   private FileInputStream fis = null;
   private boolean accessGranted = false;
   private boolean writeAccessGranted = false;

   public ConfigManager() {
      String var1 = null;

      try {
         this.accessGranted = true;
      } catch (Exception var5) {
         if (var5.toString().indexOf("ClassNotFoundException") != -1) {
            this.accessGranted = true;
         } else {
            this.accessGranted = false;
         }
      } catch (NoClassDefFoundError var6) {
      }

      if (this.accessGranted) {
         try {
            var1 = System.getProperty("user.home");
         } catch (Exception var4) {
         }

         if (var1 != null) {
            try {
               this.file = new File(var1, "rcconfig.txt");
               this.fis = new FileInputStream(this.file);
            } catch (IOException var3) {
            }
         }
      }
   }

   public void writeConfig(Hashtable var1) {
      if (var1 != null) {
         try {
            PrivilegeManager.enablePrivilege("UniversalFileAccess");
            this.writeAccessGranted = true;
         } catch (Exception var5) {
            if (var5.toString().indexOf("ClassNotFoundException") != -1) {
               this.writeAccessGranted = true;
            } else {
               this.writeAccessGranted = false;
            }
         } catch (NoClassDefFoundError var6) {
         }

         if (this.writeAccessGranted) {
            try {
               if (this.file != null) {
                  this.fos = new FileOutputStream(this.file);
               }

               if (this.fos != null) {
                  Enumeration var2 = var1.keys();

                  for (Enumeration var3 = var1.elements(); var2.hasMoreElements(); this.fos = null) {
                     this.fos.write(((String)var2.nextElement() + "=").getBytes());
                     this.fos.write(((String)var3.nextElement()).getBytes());
                     this.fos.flush();
                     this.fos.close();
                  }
               }
            } catch (Exception var4) {
            }
         }
      }
   }

   protected Hashtable readConfig() {
      Hashtable var1 = new Hashtable();
      if (this.accessGranted) {
         try {
            int var2 = this.fis.available();
            if (var2 > 0) {
               byte[] var3 = new byte[var2];
               this.fis.read(var3);
               this.fis.close();
               this.fis = null;
               StringTokenizer var4 = new StringTokenizer(new String(var3), "\n");
               Object var5 = null;

               while (var4.hasMoreTokens()) {
                  var5 = new StringTokenizer(new String(var4.nextToken()), "=");
                  if (var5.countTokens() == 2) {
                     var1.put(var5.nextToken(), var5.nextToken());
                  }
               }

               return var1;
            }
         } catch (Exception var6) {
         }
      }

      return null;
   }

   protected void closeConfig() {
      try {
         if (this.fis != null) {
            this.fis.close();
            this.fis = null;
         }

         if (this.fos != null) {
            this.fos.close();
            this.fos = null;
         }

         this.file = null;
      } catch (Exception var2) {
      }
   }
}
