package com.raritan.rrc.components.serialconsole;

import java.awt.Graphics;
import java.util.Hashtable;

class DECSpecial {
   private static final char BITMAP = '\u0000';
   private static final char FILLRECT = '\u0001';
   private static final char GLYPH_WIDTH = '\u0001';
   private static final char GLYPH_HEIGHT = '\u0002';
   private static final char GLYPH_TYPE = '\u0003';
   private static final char GLYPH_DATA = '\u0004';
   private static final char[][] GLYPH_DATA_ARRAY = new char[][]{
      {'␉', '\b', '\b', '\u0000', '\u0000', 'l', '|', 'l', '\u0000', '?', '\f', '\f'},
      {'␌', '\b', '\b', '\u0000', '|', '`', 'x', '`', '\u001f', '\u0018', '\u001e', '\u0018'},
      {'␍', '\b', '\b', '\u0000', '<', '`', '<', '\u0000', '\u001e', '\u001b', '\u001e', '\u001b'},
      {'␊', '\b', '\b', '\u0000', '`', '`', '|', '\u0000', '\u001f', '\u0018', '\u001e', '\u0018'},
      {'␤', '\b', '\b', '\u0000', 'f', 'v', 'n', 'f', '\u0000', '\u0018', '\u0018', '\u001f'},
      {'␋', '\b', '\b', '\u0000', '\u0082', 'Æ', 'l', '8', '\u0000', '?', '\f', '\f'},
      {'♦', '\b', '\b', '\u0000', '\u0000', '\u0018', '<', '~', '~', '<', '\u0018', '\u0000'},
      {'▒', '\b', '\b', '\u0000', 'U', 'ª', 'U', 'ª', 'U', 'ª', 'U', 'ª'},
      {'≤', '\b', '\b', '\u0000', '\u0000', '\u0007', '\u0018', '`', '\u0018', '\u0007', '\u0000', '\u007f'},
      {'≥', '\b', '\b', '\u0000', '\u0000', 'p', '\f', '\u0003', '\f', 'p', '\u0000', '\u007f'},
      {'¶', '\b', '\b', '\u0000', '\u0000', '\u007f', '¶', '6', '6', '6', 'æ', '\u0000'},
      {'≠', '\b', '\b', '\u0000', '\u0000', '\u0003', '\u0006', 'ÿ', '\u0018', 'ÿ', '`', 'À'},
      {'│', '\b', '\b', '\u0001', '〨'},
      {'┤', '\b', '\b', '\u0001', '〨', 'б'},
      {'┐', '\b', '\b', '\u0001', 'ё', '㔣'},
      {'└', '\b', '\b', '\u0001', '〥', '吱'},
      {'┴', '\b', '\b', '\u0001', '〤', 'ҁ'},
      {'┬', '\b', '\b', '\u0001', 'ҁ', '㔣'},
      {'├', '\b', '\b', '\u0001', '〨', '吱'},
      {'▔', '\b', '\b', '\u0001', '\u0081'},
      {'▀', '\b', '\b', '\u0001', 'ʁ'},
      {'─', '\b', '\b', '\u0001', 'ҁ'},
      {'▬', '\b', '\b', '\u0001', 'ځ'},
      {'┼', '\b', '\b', '\u0001', '〨', 'ҁ'},
      {'┘', '\b', '\b', '\u0001', '〥', 'б'},
      {'┌', '\b', '\b', '\u0001', '㑑', '㔣'}
   };
   private static Hashtable glyph = new Hashtable();

   boolean isGlyph(char var1) {
      boolean var2 = false;
      if (glyph.get(new Integer(var1)) != null) {
         var2 = true;
      }

      return var2;
   }

   void drawGlyph(Graphics var1, char var2, int var3, int var4, int var5, int var6) {
      if (glyph.get(new Integer(var2)) != null) {
         int var13 = (Integer)glyph.get(new Integer(var2));
         char var15 = GLYPH_DATA_ARRAY[var13][1];
         char var16 = GLYPH_DATA_ARRAY[var13][2];
         double var7 = var5 * 1.0 / var15;
         double var9 = var6 * 1.0 / var16;
         switch (GLYPH_DATA_ARRAY[var13][3]) {
            case '\u0000':
               for (int var20 = 0; var20 < var16; var20++) {
                  for (int var19 = 0; var19 < var15; var19++) {
                     if (0 != (GLYPH_DATA_ARRAY[var13][var20 + 4] & 1 << 7 - var19)) {
                        var1.fillRect(
                           var3 + (int)(var19 * var7),
                           var4 + (int)(var20 * var9),
                           (int)((var19 + 1) * var7) - (int)(var19 * var7),
                           (int)((var20 + 1) * var9) - (int)(var20 * var9)
                        );
                     }
                  }
               }
               break;
            case '\u0001':
               for (int var14 = 4; var14 < GLYPH_DATA_ARRAY[var13].length; var14++) {
                  int var11 = (GLYPH_DATA_ARRAY[var13][var14] & '\uf000') >> 12;
                  int var12 = (GLYPH_DATA_ARRAY[var13][var14] & 3840) >> 8;
                  int var17 = (GLYPH_DATA_ARRAY[var13][var14] & 240) >> 4;
                  int var18 = GLYPH_DATA_ARRAY[var13][var14] & 15;
                  var1.fillRect(
                     var3 + (int)(var11 * var7),
                     var4 + (int)(var12 * var9),
                     (int)((var11 + var17) * var7) - (int)(var11 * var7),
                     (int)((var12 + var18) * var9) - (int)(var12 * var9)
                  );
               }
         }
      }
   }

   static {
      for (int var0 = 0; var0 < GLYPH_DATA_ARRAY.length; var0++) {
         glyph.put(new Integer(GLYPH_DATA_ARRAY[var0][0]), new Integer(var0));
      }
   }
}
