package com.raritan.rrc.components.serialconsole;

public class Emulator implements IConsoleListener {
   protected static final int ALTERNATEKEYPADON = 1;
   protected static final int ALTERNATEKEYPADOFF = 0;
   private static final int ECHO = 1;
   protected int keypadMode = 0;
   protected Terminal terminal;
   protected int sendcrlf = 0;
   protected char[] graphicsDesignator;
   protected boolean writingHistoryBufferOn = false;
   protected boolean softScroll = false;
   boolean needRedraw = false;
   String keyUp;
   String keyDown;
   String keyRight;
   String keyLeft;
   private boolean controlSequence = true;
   private boolean localEcho = false;
   private boolean logging = false;
   private FileLogger fileLogger;

   Emulator(Terminal var1) {
      this.terminal = var1;
      this.keyUp = "\u001b[A";
      this.keyDown = "\u001b[B";
      this.keyRight = "\u001b[C";
      this.keyLeft = "\u001b[D";
      this.graphicsDesignator = new char[4];
      this.graphicsDesignator[0] = 'B';
      this.graphicsDesignator[1] = '0';
      this.fileLogger = var1.fileLogger;
   }

   void setLocalEcho(boolean var1) {
      this.localEcho = var1;
   }

   void setLogging(boolean var1) {
      this.logging = var1;
   }

   void preProcessByte(byte[] var1) {
      if (this.terminal != null && this.terminal.vdu != null) {
         this.terminal.vdu.setCursorOnOff(0);
         int var2 = var1.length;
         if (this.writingHistoryBufferOn) {
            var2 = var1.length > 64 ? 64 : var1.length;
         }

         for (int var3 = 0; var3 < var2; var3++) {
            this.processByte(var1[var3]);
         }

         this.terminal.vdu.setCursorOnOff(1);
         this.terminal.vdu.reDraw();
      }
   }

   @Override
   public void bytesArrived(byte[] var1, int var2) {
      byte[] var3 = new byte[var2];
      System.arraycopy(var1, 0, var3, 0, var2);
      this.terminal.fireBytesArrived(var3);
      this.terminal.statusBar.setStatus(this.terminal.vdu.getCursorRow(), this.terminal.vdu.getCursorCol());
      if (this.logging) {
         this.fileLogger.log(var1, var2);
      }
   }

   boolean checkChar(char var1) {
      return true;
   }

   void doChar(char var1) {
   }

   void processByte(byte var1) {
   }

   int getNumCols() {
      return this.terminal.vdu.getRightMargin();
   }

   int getNumRows() {
      return this.terminal.vdu.getBottomMargin();
   }

   void callWhenExit() {
      this.terminal.callWhenExit();
   }

   void sendAnswerBack() {
      this.terminal.write("VT Emulation");
   }

   void sendC1(char var1) {
      if (this.controlSequence) {
         this.terminal.write((byte)var1);
      } else {
         this.terminal.write(27);
         this.terminal.write((byte)(var1 - '@'));
      }
   }

   public void setWritingHistoryBufferOn(boolean var1) {
      this.writingHistoryBufferOn = var1;
   }
}
