package com.raritan.rrc.components.serialconsole;

import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import javax.swing.JFileChooser;

public class FileLogger {
   private FileOutputStream fos = null;
   private boolean writeGranted = true;

   public boolean startLogging() {
      try {
         this.writeGranted = true;
      } catch (Exception var5) {
         if (var5.toString().indexOf("ClassNotFoundException") == -1) {
            this.writeGranted = false;
            return false;
         }

         this.writeGranted = true;
      } catch (NoClassDefFoundError var6) {
      }

      if (this.writeGranted) {
         JFileChooser var1 = new JFileChooser();
         var1.showOpenDialog(null);
         File var2 = var1.getSelectedFile();
         if (var2 != null) {
            try {
               this.fos = new FileOutputStream(var2, true);
               return true;
            } catch (IOException var4) {
               new MessageBox("Logging", "Could not open file for logging. File may be read-only or in use.", false).showMessage();
            }
         }
      }

      return false;
   }

   public boolean startLogging(File var1) {
      try {
         this.writeGranted = true;
      } catch (Exception var4) {
         if (var4.toString().indexOf("ClassNotFoundException") == -1) {
            this.writeGranted = false;
            return false;
         }

         this.writeGranted = true;
      } catch (NoClassDefFoundError var5) {
      }

      if (this.writeGranted && var1 != null) {
         try {
            this.fos = new FileOutputStream(var1, true);
            return true;
         } catch (IOException var3) {
            new MessageBox("Logging", "Could not open file for logging. File may be read-only or in use.", false).showMessage();
         }
      }

      return false;
   }

   public boolean stopLogging() {
      if (this.fos != null) {
         try {
            this.fos.close();
            this.fos = null;
            return true;
         } catch (Exception var2) {
         }
      }

      return false;
   }

   public void log(byte[] var1, int var2) {
      try {
         if (this.fos != null) {
            this.fos.write(var1, 0, var2);
            this.fos.flush();
         }
      } catch (Exception var4) {
         new MessageBox("Logging", "Could not write to file.", false).showMessage();
         this.stopLogging();
      }
   }
}
