package com.raritan.rrc.components.serialconsole;

import java.awt.Frame;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ArrayList;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JLabel;

public class MessageBox extends JDialog implements ActionListener {
   private static final long serialVersionUID = -6254738471702489136L;
   private static final int LABEL_MAX = 50;
   private String message = "";
   private JLabel lblMessage1;
   private JLabel lblMessage2;
   private JButton btnOk;

   public MessageBox(String var1, String var2, boolean var3) {
      super((Frame)null, var1, var3);
      this.setDefaultCloseOperation(1);
      this.getContentPane().setLayout(new GridBagLayout());
      this.layoutBox();
      this.pack();
      this.setSize(350, 100);
      this.setLocationRelativeTo(this.getParent());
      this.setResizable(false);
      this.setMessage(var2);
      this.layoutBox();
   }

   private void layoutBox() {
      this.message = this.message.replace('\n', ' ');
      this.lblMessage1 = new JLabel("", 0);
      this.getContentPane().add(this.lblMessage1, new GridBagConstraints(0, 0, 1, 1, 1.0, 0.0, 10, 2, new Insets(4, 2, 2, 2), 0, 0));
      this.lblMessage2 = new JLabel("", 0);
      this.getContentPane().add(this.lblMessage2, new GridBagConstraints(0, 1, 1, 1, 1.0, 0.0, 10, 2, new Insets(2, 2, 2, 2), 0, 0));
      this.btnOk = new JButton("OK");
      this.btnOk.addActionListener(this);
      this.getContentPane().add(this.btnOk, new GridBagConstraints(0, 3, 1, 1, 1.0, 1.0, 15, 0, new Insets(2, 2, 4, 2), 0, 0));
   }

   public void showMessage() {
      int var1 = this.message.length();
      if (var1 < 50) {
         this.lblMessage1.setText(this.message);
      } else {
         ArrayList var2 = new ArrayList();
         int var3 = 0;

         while (var3 >= 0) {
            if (++var3 > var1) {
               break;
            }

            var3 = this.message.indexOf(" ", var3);
            if (var3 >= 0) {
               var2.add(new Integer(var3));
            }
         }

         var3 = 0;
         if (var2.size() > 0) {
            Object var4 = null;

            for (Integer var9 : var2) {
               int var5 = var9;
               if (var5 > 50) {
                  if (var3 == 0) {
                     var3 = var5;
                  }
                  break;
               }

               var3 = var5;
            }
         } else {
            var3 = 50;
         }

         this.lblMessage1.setText(this.message.substring(0, var3));
         this.lblMessage2.setText(this.message.substring(var3));
      }

      this.setVisible(true);
   }

   public void setMessage(String var1) {
      this.message = var1;
   }

   public String getMessage() {
      return this.message;
   }

   @Override
   public void actionPerformed(ActionEvent var1) {
      this.dispose();
   }
}
