package com.raritan.rrc.components.serialconsole;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import javax.swing.JLabel;
import javax.swing.JPanel;

class StatusBar extends JPanel {
   private static final long serialVersionUID = -7178086867346908807L;
   private JLabel lblWriteAccess;
   private JLabel lblCodeSet;
   private JLabel lblCodeSetStatus;
   private JLabel lblLine;
   private JLabel lblLineStatus;
   private JLabel lblCol;
   private JLabel lblColStatus;
   private JLabel lblLog;
   private JLabel lblLogStatus;
   private JLabel lblUsers;
   private JLabel lblUsersStatus;
   private JPanel pnlWriteStatus;

   protected StatusBar() {
      this.setLayout(new GridBagLayout());
      this.pnlWriteStatus = new JPanel();
      this.pnlWriteStatus.setBackground(Color.GREEN);
      this.pnlWriteStatus.setForeground(Color.GREEN);
      this.pnlWriteStatus.setPreferredSize(new Dimension(13, 13));
      this.add(this.pnlWriteStatus, new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0, 17, 0, new Insets(2, 2, 2, 2), 0, 0));
      this.lblWriteAccess = new JLabel(" Write Access");
      this.add(this.lblWriteAccess, new GridBagConstraints(1, 0, 1, 1, 1.0, 0.0, 10, 2, new Insets(0, 0, 0, 0), 0, 0));
      this.lblCodeSet = new JLabel("Code Set:");
      this.add(this.lblCodeSet, new GridBagConstraints(2, 0, 1, 1, 0.0, 0.0, 10, 2, new Insets(0, 0, 0, 0), 0, 0));
      this.lblCodeSetStatus = new JLabel("US ASCII");
      this.lblCodeSetStatus.setForeground(Color.blue);
      this.add(this.lblCodeSetStatus, new GridBagConstraints(3, 0, 1, 1, 0.0, 0.0, 10, 2, new Insets(0, 0, 0, 4), 0, 0));
      this.lblLine = new JLabel("Line:");
      this.add(this.lblLine, new GridBagConstraints(4, 0, 1, 1, 0.0, 0.0, 10, 2, new Insets(0, 0, 0, 0), 0, 0));
      this.lblLineStatus = new JLabel();
      this.lblLineStatus.setForeground(Color.blue);
      this.add(this.lblLineStatus, new GridBagConstraints(5, 0, 1, 1, 0.0, 0.0, 10, 2, new Insets(0, 0, 0, 4), 0, 0));
      this.lblCol = new JLabel("Column:");
      this.add(this.lblCol, new GridBagConstraints(6, 0, 1, 1, 0.0, 0.0, 10, 2, new Insets(0, 0, 0, 0), 0, 0));
      this.lblColStatus = new JLabel();
      this.lblColStatus.setForeground(Color.blue);
      this.add(this.lblColStatus, new GridBagConstraints(7, 0, 1, 1, 0.0, 0.0, 10, 2, new Insets(0, 0, 0, 4), 0, 0));
      this.lblLog = new JLabel("Logging:");
      this.add(this.lblLog, new GridBagConstraints(8, 0, 1, 1, 0.0, 0.0, 10, 2, new Insets(0, 0, 0, 0), 0, 0));
      this.lblLogStatus = new JLabel("Off");
      this.lblLogStatus.setForeground(Color.blue);
      this.add(this.lblLogStatus, new GridBagConstraints(9, 0, 1, 1, 0.0, 0.0, 10, 2, new Insets(0, 0, 0, 4), 0, 0));
      this.lblUsers = new JLabel("Users:");
      this.add(this.lblUsers, new GridBagConstraints(10, 0, 1, 1, 0.0, 0.0, 10, 2, new Insets(0, 0, 0, 0), 0, 0));
      this.lblUsers.setVisible(false);
      this.lblUsersStatus = new JLabel();
      this.lblUsersStatus.setForeground(Color.blue);
      this.add(this.lblUsersStatus, new GridBagConstraints(11, 0, 1, 1, 0.0, 0.0, 10, 2, new Insets(0, 0, 0, 0), 0, 0));
      this.lblUsersStatus.setVisible(false);
   }

   protected void addUserLbl() {
      this.lblUsers.setVisible(true);
      this.lblUsersStatus.setVisible(true);
   }

   protected void updateUsersCnt(int var1) {
      this.lblUsersStatus.setText(String.valueOf(var1));
   }

   protected void setLoggingStatus(boolean var1) {
      if (var1) {
         this.lblLogStatus.setText("On");
      } else {
         this.lblLogStatus.setText("Off");
      }
   }

   protected void setStatus(boolean var1) {
      this.pnlWriteStatus.setBackground(Color.green);
      this.pnlWriteStatus.setForeground(Color.green);
   }

   protected void setStatus(String var1) {
      this.lblCodeSetStatus.setText(var1);
   }

   protected void setStatus(int var1, int var2) {
      this.lblLineStatus.setText("" + var1);
      this.lblColStatus.setText("" + var2);
   }

   protected void setStatus(String var1, String var2, String var3) {
      this.lblCodeSetStatus.setText(var1);
      this.lblLineStatus.setText(var2);
      this.lblColStatus.setText(var3);
   }
}
