package com.raritan.rrc.components.serialconsole;

class Timer implements Runnable {
   private VDU vdu;
   private Thread blinker;
   private boolean blinkCharacters = false;
   private int speed = 500;
   private boolean running;

   protected Timer(VDU var1) {
      this.vdu = var1;
      this.blinker = new Thread(this);
      this.blinkCharacters = false;
   }

   protected void start() {
      this.running = true;
      this.blinker.start();
   }

   protected void stop() {
      this.running = false;
   }

   protected void setBlinkChars(boolean var1) {
      this.blinkCharacters = var1;
   }

   @Override
   public void run() {
      while (this.running) {
         if (this.blinkCharacters) {
            this.vdu.reDrawBlink();
         } else {
            this.vdu.reDrawCursor();
         }

         try {
            Thread.sleep(this.speed);
         } catch (InterruptedException var2) {
         }
      }
   }
}
