package com.raritan.rrc.components.serialconsole;

import java.awt.Color;
import java.awt.Font;
import java.awt.Graphics;
import java.awt.Image;
import java.awt.Point;
import java.awt.Toolkit;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import javax.swing.JComponent;

public class VDU extends JComponent {
   static final int HALF_BRIGHT = 1;
   private static final long serialVersionUID = -7997946847764882081L;
   private static final int PLAIN = 0;
   private static final int BOLD = 1;
   private static final int UNDERLINE = 4;
   private static final int BLINK = 5;
   private static final int REVERSE = 7;
   private static final int BOLD_UNDERLINE = 14;
   private static final int BOLD_BLINK = 15;
   private static final int BOLD_REVERSE = 17;
   private static final int UNDERLINE_BLINK = 45;
   private static final int BLINK_REVERSE = 57;
   private static final int REVERSE_UNDERLINE = 74;
   private static final int BOLD_UNDERLINE_BLINK = 145;
   private static final int BOLD_BLINK_REVERSE = 157;
   private static final int BOLD_REVERSE_UNDERLINE = 174;
   private static final int UNDERLINE_BLINK_REVERSE = 457;
   private static final int BOLD_UNDERLINE_BLINK_REVERSE = 1457;
   private static final int SINGLE_WIDTH = 0;
   private static final int DOUBLE_WIDTH = 1;
   private static final int DOUBLE_HEIGHT_TOP_HALF = 2;
   private static final int DOUBLE_HEIGHT_BOT_HALF = 3;
   private static final int REPLACE = 0;
   private static final int INSERT = 1;
   private static final int FULL_BRIGHT = 0;
   private static final int AUTOWRAP_OFF = 0;
   private static final int AUTOWRAP_ON = 1;
   private static final int ORIGIN_ABSOLUTE = 0;
   private static final int ORIGIN_RELATIVE = 1;
   private static final int CURSOR_VISIBLE = 1;
   private static final int CURSOR_INVISIBLE = 0;
   private static final int SCREEN_TOP = 1;
   private static final int SCREEN_BOT = 25;
   private static final int BUFFER_MAX = 5002;
   private static final Color DARK_BACKGROUND = Color.black;
   private static final Color LIGHT_BACKGROUND = Color.lightGray.darker();
   private static final int PAINT_EXECUTED = 0;
   private static final int NORMAL_PAINT = 1;
   private static final int REDRAW_PAINT = 2;
   private static final int BLINK_PAINT = 3;
   private static final int CURSOR_PAINT = 4;
   private static final char[] DECSPECIAL = new char[]{
      '@',
      '♦',
      '▒',
      '␉',
      '␌',
      '␍',
      '␊',
      'º',
      '±',
      '␤',
      '␋',
      '┘',
      '┐',
      '┌',
      '└',
      '┼',
      '▔',
      '▀',
      '─',
      '▬',
      '_',
      '├',
      '┤',
      '┴',
      '┬',
      '│',
      '≤',
      '≥',
      '¶',
      '≠',
      '£',
      '·'
   };
   DECSpecial decSpl;
   private Color normalFgcolor = Color.lightGray;
   private Color boldFgcolor = Color.white;
   private Color reverseFgcolor = Color.black;
   private Color boldReverseFgcolor = Color.black;
   private Color normalBgcolor = Color.black;
   private Color boldBgcolor = Color.black;
   private Color reverseBgcolor = Color.lightGray;
   private Color boldReverseBgcolor = Color.white;
   private Color normalNormalFgcolor = Color.lightGray;
   private Color normalBoldFgcolor = Color.white;
   private Color normalReverseFgcolor = Color.black;
   private Color normalBoldReverseFgcolor = Color.black;
   private Color normalNormalBgcolor = Color.black;
   private Color normalBoldBgcolor = Color.black;
   private Color normalReverseBgcolor = Color.lightGray;
   private Color normalBoldReverseBgcolor = Color.white;
   private Color blinkNormalFgcolor = Color.gray;
   private Color blinkBoldFgcolor = Color.lightGray;
   private Color blinkReverseFgcolor = Color.lightGray;
   private Color blinkBoldReverseFgcolor = Color.white;
   private Color blinkNormalBgcolor = Color.black;
   private Color blinkBoldBgcolor = Color.black;
   private Color blinkReverseBgcolor = Color.black;
   private Color blinkBoldReverseBgcolor = Color.black;
   private boolean update = false;
   private char[][] charArrays = (char[][])null;
   private char[][] bufferArrays = (char[][])null;
   private int[][] charAttributes = (int[][])null;
   private int[][] bufCharAttributes = (int[][])null;
   private int[] bufLineAttributes = null;
   private int[] lineAttributes = null;
   private boolean[] charUpdates;
   private int cursorRow = 1;
   private int cursorCol = 1;
   private int diffCursor = 0;
   private int topMargin = 1;
   private int botMargin = 25;
   private int rightMargin = 80;
   private int bufBotMargin = 5002;
   private int charHeight;
   private int charWidth;
   private int charDescent;
   private int maxDis;
   private char graphicsLeft = 'B';
   private char graphicsRight = '0';
   private int fontStyle = 0;
   private Color bgColor = DARK_BACKGROUND;
   private Color fgColor = this.normalFgcolor;
   private int insertReplace = 0;
   private int cursorType = 1;
   private int cursorOnOff = 1;
   private int autoWrap = 1;
   private int originMode = 0;
   private Terminal terminal;
   private Image image10 = null;
   private Image image13 = null;
   private Image image = null;
   private Point startPoint;
   private Point endPoint;
   private boolean hasSelection = false;
   private Point lastEndPoint = null;
   private int[][] cutpasteBuf = new int[5002][this.rightMargin];
   private boolean allSelected = false;
   private int offSet = 0;
   private int base = 0;
   private Timer blinkTimer;
   private int paintFrom = 1;
   private int repaintFrom = 0;
   private boolean paintEnded = true;
   private boolean blinkStatus = false;
   private Color charColor = Color.lightGray;
   private int imageWidth = 0;
   private int imageHeight = 0;

   VDU(Terminal var1) {
      this.terminal = var1;
      this.addMouseListener(new VDU.FocusRequester());
      this.decSpl = new DECSpecial();
      this.charArrays = new char[this.botMargin][this.rightMargin];
      this.bufferArrays = new char[5002][this.rightMargin];
      this.charAttributes = new int[this.botMargin][this.rightMargin];
      this.bufCharAttributes = new int[5002][this.rightMargin];
      this.lineAttributes = new int[this.botMargin];
      this.bufLineAttributes = new int[5002];
      this.charUpdates = new boolean[this.botMargin];
      this.bgColor = DARK_BACKGROUND;
      this.fgColor = this.normalFgcolor;
      if (this.terminal.isAdmin() && !this.terminal.isDiagnostic()) {
         this.normalNormalBgcolor = Color.blue;
         this.normalBoldBgcolor = Color.blue;
      }

      this.setBackground(this.bgColor);
      this.setFont(new Font("Monospaced", 0, 12));
      this.charDescent = this.getFontMetrics(this.getFont()).getDescent();
      this.charHeight = this.getFontMetrics(this.getFont()).getHeight();
      this.charWidth = this.getFontMetrics(this.getFont()).charWidth('W');

      for (int var2 = 0; var2 < this.botMargin; var2++) {
         for (int var3 = 0; var3 < this.rightMargin; var3++) {
            this.charArrays[var2][var3] = ' ';
            this.charAttributes[var2][var3] = 0;
            this.lineAttributes[var2] = 0;
            this.charUpdates[var2] = true;
         }
      }

      for (int var4 = 0; var4 < 5002; var4++) {
         for (int var5 = 0; var5 < this.rightMargin; var5++) {
            this.bufferArrays[var4][var5] = ' ';
            this.bufCharAttributes[var4][var5] = 0;
            this.bufLineAttributes[var4] = 0;
         }
      }

      this.blinkTimer = new Timer(this);
      this.blinkTimer.start();
   }

   public String selectAllText() throws Exception {
      int var1 = 0;

      for (int var2 = 0; var2 < 5002; var2++) {
         if (!new String(this.bufferArrays[var2]).trim().equals("")) {
            var1 = var2;
         }
      }

      this.hasSelection = true;
      this.allSelected = true;
      StringBuffer var5 = new StringBuffer();
      var5.append(this.bufferArrays[0]);

      for (int var3 = 0; var3 < this.rightMargin; var3++) {
         this.cutpasteBuf[0][var3] = this.bufCharAttributes[0][var3];
         this.bufCharAttributes[0][var3] = 7;
      }

      for (int var6 = 1; var6 <= var1; var6++) {
         var5.append('\n');
         var5.append(this.bufferArrays[var6]);

         for (int var4 = 0; var4 < this.rightMargin; var4++) {
            this.cutpasteBuf[var6][var4] = this.bufCharAttributes[var6][var4];
            this.bufCharAttributes[var6][var4] = 7;
         }
      }

      this.offSet = 0;
      this.transferArray();
      this.repaint(0, 0, this.getWidth(), this.getHeight());
      return var5.toString();
   }

   public void deselectText() throws Exception {
      this.hasSelection = false;
      this.requestFocus();
      this.lastEndPoint = null;
      if (!this.allSelected) {
         this.selectBetween(this.startPoint, this.endPoint, false);
      } else {
         this.allSelected = false;

         for (int var1 = 0; var1 < 5002; var1++) {
            for (int var2 = 0; var2 < this.rightMargin; var2++) {
               this.bufCharAttributes[var1][var2] = this.cutpasteBuf[var1][var2];
            }
         }

         for (int var3 = 1; var3 <= 25; var3++) {
            this.charUpdates[var3 - 1] = true;
         }

         this.repaintFrom = 2;
         this.repaint(0, 0, this.getWidth(), this.getHeight());
      }
   }

   public boolean hasSelection() {
      return this.hasSelection;
   }

   private int translateXCoord(int var1) {
      return (int)Math.floor(var1 / this.charWidth);
   }

   private int translateYCoord(int var1) {
      return (int)Math.floor(var1 / this.charHeight);
   }

   private Point validatePoint(int var1, int var2, boolean var3) throws Exception {
      Point var4 = new Point(this.translateXCoord(var1), this.translateYCoord(var2));
      boolean var5 = false;
      if (var4.y >= this.botMargin) {
         var4.y = this.botMargin - 1;
         var4.x = this.rightMargin;
         var5 = true;
      }

      if (var4.y < this.topMargin - 1) {
         var4.y = this.topMargin - 1;
         var4.x = 0;
         var5 = true;
      }

      if (var4.x < 0) {
         var4.x = 0;
         var5 = true;
      }

      if (var4.x > this.rightMargin) {
         var4.x = this.rightMargin;
         var5 = true;
      }

      if (!var5 && var3 && (this.startPoint.y > var4.y || this.startPoint.y == var4.y && this.startPoint.x > var4.x)) {
         var4.x++;
      }

      return var4;
   }

   public void setSelectionStart(int var1, int var2) throws Exception {
      this.startPoint = this.validatePoint(var1, var2, false);
   }

   public void setSelectionEnd(int var1, int var2) throws Exception {
      this.endPoint = this.validatePoint(var1, var2, true);
   }

   private void swapPoints() {
      Point var1 = this.startPoint;
      this.startPoint = this.endPoint;
      this.endPoint = var1;
   }

   public String getSelectedText() throws Exception {
      if (this.startPoint.equals(this.endPoint)) {
         return "";
      } else {
         this.hasSelection = true;
         StringBuffer var1 = new StringBuffer();
         if (this.after(this.startPoint, this.endPoint)) {
            this.swapPoints();
         }

         if (this.startPoint.y == this.endPoint.y) {
            char[] var6 = new char[this.endPoint.x - this.startPoint.x];

            for (int var8 = 0; var8 < var6.length; var8++) {
               var6[var8] = this.charArrays[this.startPoint.y][this.startPoint.x + var8];
            }

            return new String(var6);
         } else {
            char[] var2 = new char[this.rightMargin - this.startPoint.x];

            for (int var3 = 0; var3 < var2.length; var3++) {
               var2[var3] = this.charArrays[this.startPoint.y][this.startPoint.x + var3];
            }

            var1.append(new String(var2));
            var1.append('\n');

            int var7;
            for (var7 = this.startPoint.y + 1; var7 < this.endPoint.y; var7++) {
               var1.append(new String(this.charArrays[var7]));
               var1.append('\n');
            }

            var2 = new char[this.endPoint.x];

            for (int var4 = 0; var4 < var2.length; var4++) {
               var2[var4] = this.charArrays[var7][var4];
            }

            var1.append(new String(var2));
            return var1.toString();
         }
      }
   }

   private boolean after(Point var1, Point var2) {
      return var1.y > var2.y || var1.y == var2.y && var1.x > var2.x;
   }

   private void selectBetween(Point var1, Point var2, boolean var3) {
      Point var4 = var1;
      Point var5 = var2;

      try {
         int var6 = 0;
         if (var3) {
            this.base = this.offSet;
         } else {
            var6 = this.offSet - this.base;
         }

         if (this.after(var4, var5)) {
            Point var7 = new Point(var4);
            var4 = var5;
            var5 = var7;
         }

         if (var4.y == var5.y) {
            for (int var10 = var4.x; var10 < var5.x; var10++) {
               if (var3) {
                  this.cutpasteBuf[var4.y][var10] = this.charAttributes[var4.y][var10];
                  this.charAttributes[var4.y][var10] = 7;
                  this.charUpdates[var4.y] = true;
               } else if (var4.y + var6 >= 0 && var4.y + var6 < this.botMargin) {
                  this.charAttributes[var4.y + var6][var10] = this.cutpasteBuf[var4.y][var10];
                  this.charUpdates[var4.y + var6] = true;
               }
            }

            this.repaintFrom = 2;
            this.repaint(0, 0, this.getWidth(), this.getHeight());
         } else {
            for (int var11 = var4.x; var11 < this.rightMargin; var11++) {
               if (var3) {
                  this.cutpasteBuf[var4.y][var11] = this.charAttributes[var4.y][var11];
                  this.charAttributes[var4.y][var11] = 7;
                  this.charUpdates[var4.y] = true;
               } else if (var4.y + var6 >= 0 && var4.y + var6 < this.botMargin) {
                  this.charAttributes[var4.y + var6][var11] = this.cutpasteBuf[var4.y][var11];
                  this.charUpdates[var4.y + var6] = true;
               }
            }

            int var12;
            for (var12 = var4.y + 1; var12 < var5.y; var12++) {
               for (int var8 = 0; var8 < this.rightMargin; var8++) {
                  if (var3) {
                     this.cutpasteBuf[var12][var8] = this.charAttributes[var12][var8];
                     this.charAttributes[var12][var8] = 7;
                     this.charUpdates[var12] = true;
                  } else if (var12 + var6 >= 0 && var12 + var6 < this.botMargin) {
                     this.charAttributes[var12 + var6][var8] = this.cutpasteBuf[var12][var8];
                     this.charUpdates[var12 + var6] = true;
                  }
               }
            }

            for (int var13 = 0; var13 < var5.x; var13++) {
               if (var3) {
                  this.cutpasteBuf[var12][var13] = this.charAttributes[var12][var13];
                  this.charAttributes[var12][var13] = 7;
                  this.charUpdates[var12] = true;
               } else if (var12 >= 0 && var12 + var6 < this.botMargin) {
                  this.charAttributes[var12 + var6][var13] = this.cutpasteBuf[var12][var13];
                  this.charUpdates[var12 + var6] = true;
               }
            }

            this.repaintFrom = 2;
            this.repaint(0, 0, this.getWidth(), this.getHeight());
         }
      } catch (Exception var9) {
      }
   }

   public void updateSelection(int var1, int var2) throws Exception {
      this.setSelectionEnd(var1, var2);
      if (this.lastEndPoint == null) {
         this.selectBetween(this.startPoint, this.endPoint, true);
         this.lastEndPoint = this.endPoint;
      } else {
         if (this.after(this.lastEndPoint, this.startPoint)) {
            if (!this.after(this.endPoint, this.startPoint)) {
               this.selectBetween(this.startPoint, this.lastEndPoint, false);
               this.selectBetween(this.startPoint, this.endPoint, true);
            } else if (this.after(this.endPoint, this.startPoint) && !this.after(this.endPoint, this.lastEndPoint)) {
               this.selectBetween(this.lastEndPoint, this.endPoint, false);
            } else if (this.after(this.endPoint, this.lastEndPoint)) {
               this.selectBetween(this.lastEndPoint, this.endPoint, true);
            }
         } else if (this.after(this.endPoint, this.startPoint)) {
            this.selectBetween(this.startPoint, this.lastEndPoint, false);
            this.selectBetween(this.startPoint, this.endPoint, true);
         } else if (!this.after(this.endPoint, this.startPoint) && this.after(this.endPoint, this.lastEndPoint)) {
            this.selectBetween(this.lastEndPoint, this.endPoint, false);
         } else if (!this.after(this.endPoint, this.lastEndPoint)) {
            this.selectBetween(this.lastEndPoint, this.endPoint, true);
         }

         this.lastEndPoint = this.endPoint;
      }
   }

   void setGraphicsRight(char var1) {
      this.graphicsRight = var1;
   }

   char getGraphicsRight() {
      return this.graphicsRight;
   }

   void setGraphicsLeft(char var1) {
      this.graphicsLeft = var1;
   }

   char getGraphicsLeft() {
      return this.graphicsLeft;
   }

   int getCharHeight() {
      return this.charHeight;
   }

   int getCharWidth() {
      return this.charWidth;
   }

   int getCharDescent() {
      return this.charDescent;
   }

   synchronized void reSetSettings() {
      this.cursorRow = 1;
      this.cursorCol = 1;
      this.diffCursor = 0;
      this.charArrays = new char[this.botMargin][this.rightMargin];
      this.bufferArrays = new char[5002][this.rightMargin];
      this.charAttributes = new int[this.botMargin][this.rightMargin];
      this.bufCharAttributes = new int[5002][this.rightMargin];
      this.lineAttributes = new int[this.botMargin];
      this.bufLineAttributes = new int[5002];
      this.charUpdates = new boolean[this.botMargin];

      for (int var1 = 0; var1 < this.botMargin; var1++) {
         for (int var2 = 0; var2 < this.rightMargin; var2++) {
            this.charArrays[var1][var2] = ' ';
            this.charAttributes[var1][var2] = 0;
            this.lineAttributes[var1] = 0;
            this.charUpdates[var1] = true;
         }
      }

      for (int var3 = 0; var3 < 5002; var3++) {
         for (int var4 = 0; var4 < this.rightMargin; var4++) {
            this.bufferArrays[var3][var4] = ' ';
            this.bufCharAttributes[var3][var4] = 0;
            this.bufLineAttributes[var3] = 0;
         }
      }

      this.setBackground(this.bgColor);
      this.terminal.setMyFont("VDU.reSetSettings", this.getSize().width, this.getSize().height);
      this.charDescent = this.getFontMetrics(this.getFont()).getDescent();
      this.charHeight = this.getFontMetrics(this.getFont()).getHeight();
      this.charWidth = this.getFontMetrics(this.getFont()).charWidth('W');
      this.update = true;
      this.reDraw();
   }

   void adjustBuffer(int var1) {
      int var2 = var1 + 1;
      if (var2 < this.bufBotMargin) {
         for (int var3 = var2 - 2; var3 < this.bufBotMargin; var3++) {
            for (int var4 = 0; var4 < this.rightMargin; var4++) {
               this.bufferArrays[var3][var4] = ' ';
               this.bufCharAttributes[var3][var4] = 0;
               this.bufLineAttributes[var3] = 0;
            }
         }

         this.bufBotMargin = var2;
         this.diffCursor = this.bufBotMargin - this.botMargin - 1;
         this.transferArray();
      } else {
         this.bufBotMargin = var2;
      }

      this.terminal.setThumbPosition(this.diffCursor);
   }

   void getImagesForDouble() {
      this.charWidth = this.getFontMetrics(this.getFont()).charWidth('W');
      if (this.charWidth < 8) {
         this.image = this.image10;
         this.imageWidth = 6;
         this.imageHeight = 12;
      } else {
         this.image = this.image13;
         this.imageWidth = 8;
         this.imageHeight = 16;
      }
   }

   void setFontStyle(int var1) {
      this.fontStyle = var1;
   }

   synchronized void setBackgroundColor(int var1) {
      if (var1 == 1) {
         this.bgColor = LIGHT_BACKGROUND;
         this.normalNormalFgcolor = Color.black;
         this.normalBoldFgcolor = Color.black;
         this.normalReverseFgcolor = Color.lightGray;
         this.normalBoldReverseFgcolor = Color.white;
         this.normalNormalBgcolor = Color.lightGray.darker();
         this.normalBoldBgcolor = Color.white;
         this.normalReverseBgcolor = Color.black;
         this.normalBoldReverseBgcolor = Color.black;
         this.blinkNormalFgcolor = Color.lightGray.darker();
         this.blinkBoldFgcolor = Color.white;
         this.blinkReverseFgcolor = Color.lightGray.darker();
         this.blinkBoldReverseFgcolor = Color.lightGray;
         this.blinkNormalBgcolor = Color.black;
         this.blinkBoldBgcolor = Color.black;
         this.blinkReverseBgcolor = Color.black;
         this.blinkBoldReverseBgcolor = Color.black;
      } else {
         this.bgColor = DARK_BACKGROUND;
         this.normalNormalFgcolor = Color.lightGray;
         this.normalBoldFgcolor = Color.white;
         this.normalReverseFgcolor = Color.black;
         this.normalBoldReverseFgcolor = Color.black;
         this.normalNormalBgcolor = Color.black;
         this.normalBoldBgcolor = Color.black;
         this.normalReverseBgcolor = Color.lightGray;
         this.normalBoldReverseBgcolor = Color.white;
         this.blinkNormalFgcolor = Color.gray;
         this.blinkBoldFgcolor = Color.lightGray;
         this.blinkReverseFgcolor = Color.lightGray;
         this.blinkBoldReverseFgcolor = Color.white;
         this.blinkNormalBgcolor = Color.black;
         this.blinkBoldBgcolor = Color.black;
         this.blinkReverseBgcolor = Color.black;
         this.blinkBoldReverseBgcolor = Color.black;
      }

      this.normalFgcolor = this.normalNormalFgcolor;
      this.boldFgcolor = this.normalBoldFgcolor;
      this.reverseFgcolor = this.normalReverseFgcolor;
      this.boldReverseFgcolor = this.normalBoldReverseFgcolor;
      this.normalBgcolor = this.normalNormalBgcolor;
      this.boldBgcolor = this.normalBoldBgcolor;
      this.reverseBgcolor = this.normalReverseBgcolor;
      this.boldReverseBgcolor = this.normalBoldReverseBgcolor;
      this.setBackground(this.bgColor);
      this.reDraw();
   }

   void setLineAttribute(int var1) {
      this.charUpdates[this.cursorRow - 1] = true;
      this.bufLineAttributes[this.cursorRow + this.diffCursor - 1] = var1;
   }

   void setCursorType(int var1) {
      this.cursorType = var1;
   }

   void setCursorOnOff(int var1) {
      this.cursorOnOff = var1;
   }

   int getFontStyle() {
      return this.fontStyle;
   }

   void setCursorPosition(int var1, int var2) {
      int var3 = var1;
      int var4 = var2;
      if (this.originMode == 0) {
         if (var1 < this.topMargin) {
            var3 = 1;
         }

         if (var3 > this.botMargin) {
            var3 = 24;
         }
      }

      if (this.originMode == 1) {
         var3 = var3 + this.topMargin - 1;
      }

      if (var2 > this.rightMargin) {
         var4 = this.rightMargin;
      }

      this.charUpdates[this.cursorRow - 1] = true;
      this.cursorRow = var3;
      this.cursorCol = var4;
      this.charUpdates[this.cursorRow - 1] = true;
   }

   int getCursorRow() {
      return this.cursorRow;
   }

   int getCursorCol() {
      return this.cursorCol;
   }

   synchronized void setScrollRegion(int var1, int var2) {
      this.topMargin = var1;
      this.botMargin = var2;
      this.cursorRow = this.topMargin;
   }

   synchronized void setOriginMode(int var1) {
      this.originMode = var1;
   }

   void setInsertReplace(int var1) {
      this.insertReplace = var1;
   }

   int getTopMargin() {
      return this.topMargin;
   }

   int getBottomMargin() {
      return this.botMargin;
   }

   int getRightMargin() {
      return this.rightMargin;
   }

   synchronized void setRightMargin(int var1) {
      this.rightMargin = var1;
   }

   void setBufferSize(int var1) {
      this.bufBotMargin = var1;
   }

   void setAutoWrap(int var1) {
      this.autoWrap = var1;
   }

   void putChar(String var1) {
      for (int var2 = 0; var2 < var1.length(); var2++) {
         this.putChar(var1.charAt(var2));
      }

      this.update = true;
   }

   void putChar(char var1) {
      char var2 = var1;
      switch (var1) {
         case '\b':
            this.cursorCol--;
            if (this.cursorCol < 1) {
               this.cursorCol = 1;
            }
            break;
         case '\n':
            this.charUpdates[this.cursorRow - 1] = true;
            this.cursorRow++;
            this.update = true;
            if (this.cursorRow > this.botMargin) {
               this.cursorRow = this.botMargin;
               if (this.topMargin > 1) {
                  char[] var7 = this.bufferArrays[this.topMargin - 1 + this.diffCursor];
                  int[] var9 = this.bufCharAttributes[this.topMargin - 1 + this.diffCursor];

                  for (int var13 = this.topMargin - 1 + this.diffCursor; var13 < this.diffCursor + this.botMargin - 1; var13++) {
                     this.bufferArrays[var13] = this.bufferArrays[var13 + 1];
                     this.bufCharAttributes[var13] = this.bufCharAttributes[var13 + 1];
                  }

                  this.bufferArrays[this.diffCursor + this.botMargin - 1] = var7;
                  this.bufCharAttributes[this.diffCursor + this.botMargin - 1] = var9;

                  for (int var14 = 0; var14 < this.rightMargin; var14++) {
                     this.bufferArrays[this.diffCursor + this.botMargin - 1][var14] = ' ';
                     this.bufCharAttributes[this.diffCursor + this.botMargin - 1][var14] = 0;
                  }
               } else {
                  this.update = true;
                  this.diffCursor++;
                  if (this.diffCursor > this.bufBotMargin - this.botMargin - 1) {
                     this.diffCursor--;
                     char[] var6 = this.bufferArrays[0];
                     int[] var8 = this.bufCharAttributes[0];

                     for (int var11 = 0; var11 < this.bufBotMargin - 1; var11++) {
                        this.bufferArrays[var11] = this.bufferArrays[var11 + 1];
                        this.bufCharAttributes[var11] = this.bufCharAttributes[var11 + 1];
                     }

                     this.bufferArrays[this.bufBotMargin - 1] = var6;
                     this.bufCharAttributes[this.bufBotMargin - 1] = var8;

                     for (int var12 = 0; var12 < this.rightMargin; var12++) {
                        this.bufferArrays[this.bufBotMargin - 1][var12] = ' ';
                        this.bufCharAttributes[this.bufBotMargin - 1][var12] = 0;
                     }
                  }
               }
            }

            if (this.diffCursor > 0 && this.diffCursor <= this.bufBotMargin - this.botMargin - 1) {
               this.terminal.enableScrollbar();
               this.terminal.setThumbPosition(this.diffCursor);
            }
            break;
         case '\r':
            this.cursorCol = 1;
            break;
         default:
            if (var1 != 0) {
               if (var1 == '\t') {
                  this.cursorCol = (this.cursorCol - 1 & 65528) + 8 + 1;
               } else if (var1 == 7) {
                  Toolkit.getDefaultToolkit().beep();
               } else {
                  if (this.autoWrap == 0) {
                     if (this.bufLineAttributes[this.cursorRow + this.diffCursor - 1] == 0 && this.cursorCol > this.rightMargin) {
                        this.cursorCol = this.rightMargin;
                     }

                     if (this.bufLineAttributes[this.cursorRow + this.diffCursor - 1] != 0 && this.cursorCol > this.rightMargin / 2) {
                        this.cursorCol = this.rightMargin / 2;
                     }
                  } else if (this.bufLineAttributes[this.cursorRow + this.diffCursor - 1] == 0 && this.cursorCol > this.rightMargin
                     || this.bufLineAttributes[this.cursorRow + this.diffCursor - 1] != 0 && this.cursorCol > this.rightMargin / 2) {
                     this.charUpdates[this.cursorRow - 1] = true;
                     this.cursorRow++;
                     this.cursorCol = 1;
                     if (this.cursorRow > this.botMargin) {
                        this.cursorRow = this.botMargin;
                        this.update = true;
                        this.diffCursor++;
                        if (this.diffCursor > this.bufBotMargin - this.botMargin - 1) {
                           this.diffCursor = this.bufBotMargin - this.botMargin - 1;
                           char[] var3 = this.bufferArrays[0];
                           int[] var4 = this.bufCharAttributes[0];

                           for (int var5 = 0; var5 < this.bufBotMargin - 1; var5++) {
                              this.bufferArrays[var5] = this.bufferArrays[var5 + 1];
                              this.bufCharAttributes[var5] = this.bufCharAttributes[var5 + 1];
                           }

                           this.bufferArrays[this.bufBotMargin - 1] = var3;
                           this.bufCharAttributes[this.bufBotMargin - 1] = var4;

                           for (int var10 = 1; var10 < this.rightMargin; var10++) {
                              this.bufferArrays[this.bufBotMargin - 1][var10] = ' ';
                              this.bufCharAttributes[this.bufBotMargin - 1][var10] = 0;
                           }
                        }
                     }

                     if (this.diffCursor > 0 && this.diffCursor <= this.bufBotMargin - this.botMargin - 1) {
                        this.terminal.enableScrollbar();
                        this.terminal.setThumbPosition(this.diffCursor);
                     }
                  }

                  if (this.graphicsLeft == '0') {
                     if (var1 >= '_' && var1 <= '~') {
                        var2 = DECSPECIAL[(short)var1 - 95];
                     }
                  } else if (this.graphicsLeft == 'A' && var1 == '#') {
                     var2 = 163;
                  }

                  if (this.originMode == 1) {
                     if (this.cursorRow < this.topMargin) {
                        this.cursorRow = this.topMargin;
                     }

                     if (this.cursorRow > this.botMargin) {
                        this.cursorRow = this.botMargin;
                     }
                  }

                  if (this.insertReplace == 0) {
                     this.putChar(this.cursorRow, this.cursorCol, var2);
                  } else {
                     this.insertChar(this.cursorRow, this.cursorCol, var2);
                  }

                  this.cursorCol++;
                  if (this.autoWrap == 0) {
                     if (this.bufLineAttributes[this.cursorRow + this.diffCursor - 1] == 0) {
                        if (this.cursorCol > this.rightMargin) {
                           this.cursorCol = this.rightMargin;
                        }
                     } else if (this.cursorCol > this.rightMargin / 2) {
                        this.cursorCol = this.rightMargin / 2;
                     }
                  }
               }
            }
      }
   }

   synchronized void putChar(int var1, int var2, char var3) {
      int var4 = this.checkBounds(var1, 1, this.bufBotMargin);
      int var5 = this.checkBounds(var2, 1, this.rightMargin);
      var4 += this.diffCursor;
      this.bufferArrays[var4 - 1][var5 - 1] = var3;
      this.bufCharAttributes[var4 - 1][var5 - 1] = this.fontStyle;
   }

   synchronized void insertChar(int var1, int var2, char var3) {
      int var4 = this.checkBounds(var1, 1, this.bufBotMargin);
      int var5 = this.checkBounds(var2, 1, this.rightMargin);
      var4 += this.diffCursor;

      for (int var6 = this.rightMargin; var6 >= var5 + 1; var6--) {
         this.bufferArrays[var4 - 1][var6 - 1] = this.bufferArrays[var4 - 1][var6 - 2];
         this.bufCharAttributes[var4 - 1][var6 - 1] = this.bufCharAttributes[var4 - 1][var6 - 2];
      }

      this.bufferArrays[var4 - 1][var5 - 1] = var3;
      this.bufCharAttributes[var4 - 1][var5 - 1] = this.fontStyle;
   }

   synchronized void transferArray() {
      for (int var1 = 1; var1 <= 25; var1++) {
         this.charArrays[var1 - 1] = this.bufferArrays[var1 + this.diffCursor - 1];
         this.charAttributes[var1 - 1] = this.bufCharAttributes[var1 + this.diffCursor - 1];
         this.lineAttributes[var1 - 1] = this.bufLineAttributes[var1 + this.diffCursor - 1];
      }

      for (int var2 = 1; var2 <= 25; var2++) {
         this.charUpdates[var2 - 1] = true;
      }

      if (this.diffCursor > 0 && this.diffCursor <= this.bufBotMargin - this.botMargin) {
         this.terminal.enableScrollbar();
         this.terminal.setThumbPosition(this.diffCursor);
      }

      this.update = false;
   }

   synchronized void transferArray(int var1) {
      if (this.update) {
         this.transferArray();
      } else {
         this.charArrays[var1 - 1] = this.bufferArrays[this.diffCursor + var1 - 1];
         this.charAttributes[var1 - 1] = this.bufCharAttributes[this.diffCursor + var1 - 1];
         this.lineAttributes[var1 - 1] = this.bufLineAttributes[this.diffCursor + var1 - 1];
         this.charUpdates[var1 - 1] = true;
      }
   }

   public void reDraw() {
      int var1 = this.cursorRow;
      this.transferArray(var1);
      if (this.repaintFrom != 1) {
         this.repaintFrom = 2;
         this.repaint(0, 0, this.getWidth(), this.getHeight());
      }
   }

   void reDrawBlink() {
      if (this.repaintFrom != 1 && this.repaintFrom != 2) {
         this.repaintFrom = 3;
         this.blinkStatus = !this.blinkStatus;
         this.blinkTimer.setBlinkChars(false);
         this.repaint(0, 0, this.getWidth(), this.getHeight());
      }
   }

   synchronized void reDrawCursor() {
      this.blinkStatus = !this.blinkStatus;
      this.repaintFrom = 4;
      this.repaint(0, 0, this.getWidth(), this.getHeight());
      if (this.cursorOnOff == 1) {
         this.cursorOnOff = 0;
      } else {
         this.cursorOnOff = 1;
      }
   }

   @Override
   public synchronized void paint(Graphics var1) {
      var1.setColor(this.bgColor);
      var1.fillRect(0, 0, this.getSize().width, this.getSize().height);

      try {
         if (this.paintFrom != 4) {
            this.charDescent = this.getFontMetrics(this.getFont()).getDescent();
            this.charHeight = this.getFontMetrics(this.getFont()).getHeight();
            this.charWidth = this.getFontMetrics(this.getFont()).charWidth('W');

            for (int var2 = 1; var2 <= 25; var2++) {
               if (this.paintFrom == 2) {
                  if (!this.charUpdates[var2 - 1]) {
                     continue;
                  }

                  var1.clearRect(0, (var2 - 1) * this.charHeight, (this.rightMargin + 40) * this.charWidth, this.charHeight);
                  this.charUpdates[var2 - 1] = false;
               }

               switch (this.lineAttributes[var2 - 1]) {
                  case 0:
                     this.paintSingleWidthLine(var1, var2);
                     break;
                  case 1:
                     this.paintDoubleWidthLine(var1, var2);
                     break;
                  case 2:
                     this.paintDoubleHeightLine(var1, var2, true);
                     break;
                  case 3:
                     this.paintDoubleHeightLine(var1, var2, false);
               }
            }
         }

         if (this.cursorOnOff == 1) {
            if (this.lineAttributes[this.cursorRow - 1] == 0) {
               var1.setColor(Color.white);
               var1.setXORMode(this.bgColor);
               if (this.cursorType == 0) {
                  var1.fillRect((this.cursorCol - 1) * this.charWidth, (this.cursorRow - 1) * this.charHeight, this.charWidth, this.charHeight);
               } else {
                  var1.fillRect((this.cursorCol - 1) * this.charWidth, this.cursorRow * this.charHeight - 1, this.charWidth, 1);
               }
            } else {
               var1.setColor(Color.white);
               var1.setXORMode(this.bgColor);
               if (this.cursorType == 0) {
                  var1.fillRect((this.cursorCol - 1) * this.charWidth * 2, (this.cursorRow - 1) * this.charHeight, this.charWidth * 2, this.charHeight);
               } else {
                  var1.fillRect((this.cursorCol - 1) * this.charWidth * 2, this.cursorRow * this.charHeight - 1, this.charWidth * 2, 1);
               }
            }
         }

         this.charUpdates[this.cursorRow - 1] = true;
         this.paintFrom = 1;
         this.paintEnded = true;
      } catch (Exception var3) {
      }
   }

   @Override
   public synchronized void update(Graphics var1) {
      this.paintFrom = this.repaintFrom;
      this.repaintFrom = 0;
      this.paintEnded = false;
      this.paint(var1);

      while (!this.paintEnded) {
         if (this.repaintFrom != 0) {
            while (this.paintEnded) {
               this.repaint(0, 0, this.getWidth(), this.getHeight());
            }
         }
      }
   }

   private synchronized void paintSingleWidthLine(Graphics var1, int var2) throws Exception {
      int var3 = this.charAttributes[var2 - 1][0];
      int var4 = 1;

      while (true) {
         int var9;
         while (true) {
            if (var4 > this.rightMargin) {
               return;
            }

            if (this.decSpl.isGlyph(this.charArrays[var2 - 1][var4 - 1])) {
               var3 = this.charAttributes[var2 - 1][var4 - 1];
               var9 = var4;

               while (var4 <= this.rightMargin && var3 == this.charAttributes[var2 - 1][var4 - 1] && this.decSpl.isGlyph(this.charArrays[var2 - 1][var4 - 1])) {
                  var4++;
               }

               if (var3 >= 30000) {
                  var3 -= 30000;
                  this.blinkTimer.setBlinkChars(true);
                  if (this.blinkStatus) {
                     this.normalFgcolor = this.blinkNormalFgcolor;
                     this.boldFgcolor = this.blinkBoldFgcolor;
                     this.reverseFgcolor = this.blinkReverseFgcolor;
                     this.boldReverseFgcolor = this.blinkBoldReverseFgcolor;
                     this.normalBgcolor = this.blinkNormalBgcolor;
                     this.boldBgcolor = this.blinkBoldBgcolor;
                     this.reverseBgcolor = this.blinkReverseBgcolor;
                     this.boldReverseBgcolor = this.blinkBoldReverseBgcolor;
                  }
                  break;
               }

               if (this.paintFrom != 3) {
                  break;
               }
            } else {
               var3 = this.charAttributes[var2 - 1][var4 - 1];
               var9 = var4;

               while (var4 <= this.rightMargin && var3 == this.charAttributes[var2 - 1][var4 - 1] && !this.decSpl.isGlyph(this.charArrays[var2 - 1][var4 - 1])) {
                  var4++;
               }

               if (var3 >= 30000) {
                  var3 -= 30000;
                  this.blinkTimer.setBlinkChars(true);
                  if (this.blinkStatus) {
                     this.normalFgcolor = this.blinkNormalFgcolor;
                     this.boldFgcolor = this.blinkBoldFgcolor;
                     this.reverseFgcolor = this.blinkReverseFgcolor;
                     this.boldReverseFgcolor = this.blinkBoldReverseFgcolor;
                     this.normalBgcolor = this.blinkNormalBgcolor;
                     this.boldBgcolor = this.blinkBoldBgcolor;
                     this.reverseBgcolor = this.blinkReverseBgcolor;
                     this.boldReverseBgcolor = this.blinkBoldReverseBgcolor;
                  }
               } else if (this.paintFrom == 3) {
                  continue;
               }

               switch (var3) {
                  case 0:
                  default:
                     if (this.normalBgcolor != this.bgColor) {
                        var1.setColor(this.normalBgcolor);
                        var1.fillRect((var9 - 1) * this.charWidth, (var2 - 1) * this.charHeight, (var4 - var9) * this.charWidth, this.charHeight);
                     }

                     var1.setColor(this.normalFgcolor);
                     break;
                  case 1:
                  case 15:
                     if (this.boldBgcolor != this.bgColor) {
                        var1.setColor(this.boldBgcolor);
                        var1.fillRect((var9 - 1) * this.charWidth, (var2 - 1) * this.charHeight, (var4 - var9) * this.charWidth, this.charHeight);
                     }

                     var1.setColor(this.boldFgcolor);
                     break;
                  case 4:
                  case 45:
                     if (this.normalBgcolor != this.bgColor) {
                        var1.setColor(this.normalBgcolor);
                        var1.fillRect((var9 - 1) * this.charWidth, (var2 - 1) * this.charHeight, (var4 - var9) * this.charWidth, this.charHeight);
                     }

                     var1.setColor(this.normalFgcolor);
                     var1.fillRect((var9 - 1) * this.charWidth, var2 * this.charHeight - 1, (var4 - var9) * this.charWidth, 1);
                     var1.setColor(this.normalFgcolor);
                     break;
                  case 7:
                  case 57:
                     var1.setColor(this.reverseBgcolor);
                     var1.fillRect((var9 - 1) * this.charWidth, (var2 - 1) * this.charHeight, (var4 - var9) * this.charWidth, this.charHeight);
                     var1.setColor(this.reverseFgcolor);
                     break;
                  case 14:
                  case 145:
                     if (this.boldBgcolor != this.bgColor) {
                        var1.setColor(this.boldBgcolor);
                        var1.fillRect((var9 - 1) * this.charWidth, (var2 - 1) * this.charHeight, (var4 - var9) * this.charWidth, this.charHeight);
                     }

                     var1.setColor(this.boldFgcolor);
                     var1.fillRect((var9 - 1) * this.charWidth, var2 * this.charHeight - 1, (var4 - var9) * this.charWidth, 1);
                     var1.setColor(this.boldFgcolor);
                     break;
                  case 17:
                  case 157:
                     var1.setColor(this.boldReverseBgcolor);
                     var1.fillRect((var9 - 1) * this.charWidth, (var2 - 1) * this.charHeight, (var4 - var9) * this.charWidth, this.charHeight);
                     var1.setColor(this.boldReverseFgcolor);
                     break;
                  case 74:
                  case 457:
                     var1.setColor(this.reverseBgcolor);
                     var1.fillRect((var9 - 1) * this.charWidth, (var2 - 1) * this.charHeight, (var4 - var9) * this.charWidth, this.charHeight);
                     var1.setColor(this.reverseFgcolor);
                     var1.fillRect((var9 - 1) * this.charWidth, var2 * this.charHeight - 1, (var4 - var9) * this.charWidth, 1);
                     var1.setColor(this.reverseFgcolor);
                     break;
                  case 174:
                  case 1457:
                     var1.setColor(this.boldReverseBgcolor);
                     var1.fillRect((var9 - 1) * this.charWidth, (var2 - 1) * this.charHeight, (var4 - var9) * this.charWidth, this.charHeight);
                     var1.setColor(this.boldReverseFgcolor);
                     var1.fillRect((var9 - 1) * this.charWidth, var2 * this.charHeight - 1, (var4 - var9) * this.charWidth, 1);
                     var1.setColor(this.boldReverseFgcolor);
               }

               var1.drawChars(this.charArrays[var2 - 1], var9 - 1, var4 - var9, (var9 - 1) * this.charWidth, var2 * this.charHeight - this.charDescent);
               if (this.blinkStatus) {
                  this.normalFgcolor = this.normalNormalFgcolor;
                  this.boldFgcolor = this.normalBoldFgcolor;
                  this.reverseFgcolor = this.normalReverseFgcolor;
                  this.boldReverseFgcolor = this.normalBoldReverseFgcolor;
                  this.normalBgcolor = this.normalNormalBgcolor;
                  this.boldBgcolor = this.normalBoldBgcolor;
                  this.reverseBgcolor = this.normalReverseBgcolor;
                  this.boldReverseBgcolor = this.normalBoldReverseBgcolor;
               }
            }
         }

         switch (var3) {
            case 0:
            default:
               if (this.normalBgcolor != this.bgColor) {
                  var1.setColor(this.normalBgcolor);
                  var1.fillRect((var9 - 1) * this.charWidth, (var2 - 1) * this.charHeight, (var4 - var9) * this.charWidth, this.charHeight);
               }

               var1.setColor(this.normalFgcolor);
               break;
            case 1:
               if (this.boldBgcolor != this.bgColor) {
                  var1.setColor(this.boldBgcolor);
                  var1.fillRect((var9 - 1) * this.charWidth, (var2 - 1) * this.charHeight, (var4 - var9) * this.charWidth, this.charHeight);
               }

               var1.setColor(this.boldFgcolor);
               break;
            case 4:
               var1.setColor(this.normalFgcolor);
               var1.fillRect((var9 - 1) * this.charWidth, var2 * this.charHeight - 1, (var4 - var9) * this.charWidth, 1);
               var1.setColor(this.normalFgcolor);
               break;
            case 7:
               var1.setColor(this.reverseBgcolor);
               var1.fillRect((var9 - 1) * this.charWidth, (var2 - 1) * this.charHeight, (var4 - var9) * this.charWidth, this.charHeight);
               var1.setColor(this.reverseFgcolor);
               break;
            case 14:
               if (this.normalBgcolor != this.bgColor) {
                  var1.setColor(this.normalBgcolor);
                  var1.fillRect((var9 - 1) * this.charWidth, (var2 - 1) * this.charHeight, (var4 - var9) * this.charWidth, this.charHeight);
               }

               var1.setColor(this.boldFgcolor);
               var1.fillRect((var9 - 1) * this.charWidth, var2 * this.charHeight - 1, (var4 - var9) * this.charWidth, 1);
               var1.setColor(this.boldFgcolor);
               break;
            case 17:
               var1.setColor(this.boldReverseBgcolor);
               var1.fillRect((var9 - 1) * this.charWidth, (var2 - 1) * this.charHeight, (var4 - var9) * this.charWidth, this.charHeight);
               var1.setColor(this.boldReverseFgcolor);
               break;
            case 74:
               var1.setColor(this.reverseBgcolor);
               var1.fillRect((var9 - 1) * this.charWidth, (var2 - 1) * this.charHeight, (var4 - var9) * this.charWidth, this.charHeight);
               var1.setColor(this.reverseFgcolor);
               var1.fillRect((var9 - 1) * this.charWidth, var2 * this.charHeight - 1, (var4 - var9) * this.charWidth, 1);
               var1.setColor(this.reverseFgcolor);
               break;
            case 174:
               var1.setColor(this.boldReverseBgcolor);
               var1.fillRect((var9 - 1) * this.charWidth, (var2 - 1) * this.charHeight, (var4 - var9) * this.charWidth, this.charHeight);
               var1.setColor(this.boldReverseFgcolor);
               var1.fillRect((var9 - 1) * this.charWidth, var2 * this.charHeight - 1, (var4 - var9) * this.charWidth, 1);
               var1.setColor(this.boldReverseFgcolor);
         }

         for (int var6 = var9; var6 < var4; var6++) {
            this.decSpl
               .drawGlyph(var1, this.charArrays[var2 - 1][var6 - 1], (var6 - 1) * this.charWidth, (var2 - 1) * this.charHeight, this.charWidth, this.charHeight);
         }

         if (this.blinkStatus) {
            this.normalFgcolor = this.normalNormalFgcolor;
            this.boldFgcolor = this.normalBoldFgcolor;
            this.reverseFgcolor = this.normalReverseFgcolor;
            this.boldReverseFgcolor = this.normalBoldReverseFgcolor;
            this.normalBgcolor = this.normalNormalBgcolor;
            this.boldBgcolor = this.normalBoldBgcolor;
            this.reverseBgcolor = this.normalReverseBgcolor;
            this.boldReverseBgcolor = this.normalBoldReverseBgcolor;
         }
      }
   }

   void draw(Graphics var1, char[] var2, int var3, int var4, int var5, int var6, boolean var7) {
      if (!var7) {
         var1.setColor(Color.black);
         this.setCursorOnOff(0);
      } else {
         var1.setColor(Color.white);
         this.setCursorOnOff(1);
      }

      if (this.decSpl.isGlyph(var2[var3])) {
         for (int var8 = var3; var8 < var3 + var4; var8++) {
            if (this.decSpl.isGlyph(var2[var8])) {
               this.decSpl.drawGlyph(var1, var2[var8], var8 * (var5 - 1), var6 - 1, this.charWidth, this.charHeight);
            }
         }
      } else {
         var1.drawChars(var2, var3, var4, var5, var6);
      }
   }

   void blink(boolean var1) {
      for (int var5 = 0; var5 < this.botMargin; var5++) {
         for (int var6 = 0; var6 < this.rightMargin; var6++) {
            if (this.lineAttributes[var5] == 0
               && (
                  this.charAttributes[var5][var6] == 5
                     || this.charAttributes[var5][var6] == 15
                     || this.charAttributes[var5][var6] == 45
                     || this.charAttributes[var5][var6] == 57
                     || this.charAttributes[var5][var6] == 145
                     || this.charAttributes[var5][var6] == 157
                     || this.charAttributes[var5][var6] == 457
                     || this.charAttributes[var5][var6] == 1457
               )) {
               int var2 = this.charAttributes[var5][var6];
               int var3 = var6;

               while (this.charAttributes[var5][var6++] == var2 && var6 < this.rightMargin) {
               }

               this.draw(
                  this.getGraphics(),
                  this.charArrays[var5 - 0],
                  var3,
                  var6 - var3,
                  var3 * this.charWidth,
                  (var5 + 1) * this.charHeight - this.charDescent,
                  var1
               );
            }
         }
      }
   }

   private synchronized void paintDoubleWidthLine(Graphics var1, int var2) throws Exception {
      int var3 = 1;
      int var4 = this.charAttributes[var2 - 1][var3 - 1];
      int var5 = 0;

      for (int var6 = 0; var3 <= this.rightMargin / 2; var3++) {
         var4 = this.charAttributes[var2 - 1][var3 - 1];
         if (var4 >= 30000) {
            var4 -= 30000;
            this.blinkTimer.setBlinkChars(true);
            if (this.blinkStatus) {
               this.normalFgcolor = this.blinkNormalFgcolor;
               this.boldFgcolor = this.blinkBoldFgcolor;
               this.reverseFgcolor = this.blinkReverseFgcolor;
               this.boldReverseFgcolor = this.blinkBoldReverseFgcolor;
               this.normalBgcolor = this.blinkNormalBgcolor;
               this.boldBgcolor = this.blinkBoldBgcolor;
               this.reverseBgcolor = this.blinkReverseBgcolor;
               this.boldReverseBgcolor = this.blinkBoldReverseBgcolor;
            }
         }

         switch (var4) {
            case 0:
            default:
               if ((this.bgColor != LIGHT_BACKGROUND || !this.blinkStatus || this.charArrays[var2 - 1][var3 - 1] == ' ') && this.bgColor != DARK_BACKGROUND) {
                  var5 = 2;
                  this.charColor = this.normalBgcolor;
               } else {
                  var5 = 0;
                  this.charColor = this.normalFgcolor;
               }
               break;
            case 1:
            case 14:
               if ((this.bgColor != LIGHT_BACKGROUND || !this.blinkStatus || this.charArrays[var2 - 1][var3 - 1] == ' ') && this.bgColor != DARK_BACKGROUND) {
                  var5 = 2;
                  this.charColor = this.boldBgcolor;
                  break;
               }

               var5 = 0;
               this.charColor = this.boldFgcolor;
               break;
            case 7:
            case 74:
               if (this.bgColor != LIGHT_BACKGROUND && (this.bgColor != DARK_BACKGROUND || !this.blinkStatus)) {
                  var5 = 2;
                  this.charColor = this.reverseBgcolor;
                  break;
               }

               var5 = 0;
               this.charColor = this.reverseFgcolor;
               break;
            case 17:
            case 174:
               if (this.bgColor != LIGHT_BACKGROUND && (this.bgColor != DARK_BACKGROUND || !this.blinkStatus)) {
                  var5 = 2;
                  this.charColor = this.boldReverseBgcolor;
               } else {
                  var5 = 0;
                  this.charColor = this.boldReverseFgcolor;
               }
         }

         if (!this.decSpl.isGlyph(this.charArrays[var2 - 1][var3 - 1])) {
            char var7 = this.charArrays[var2 - 1][var3 - 1];
            if (var7 >= ' ') {
               if (var7 < 127) {
                  var6 = var7 - ' ';
               } else if (var7 >= 160 && var7 < 254) {
                  var6 = var7 - 160;
                  var5++;
               }
            }
         } else {
            var6 = 0;

            while (var6 < DECSPECIAL.length && this.charArrays[var2 - 1][var3 - 1] != DECSPECIAL[var6]) {
               var6++;
            }

            if (var5 == 0) {
               var5 += 4;
            } else {
               var5 += 3;
            }
         }

         var1.drawImage(
            this.image,
            (var3 - 1) * this.charWidth * 2,
            (var2 - 1) * this.charHeight,
            var3 * this.charWidth * 2,
            var2 * this.charHeight,
            var6 * this.imageWidth,
            var5 * this.imageHeight,
            (var6 + 1) * this.imageWidth,
            (var5 + 1) * this.imageHeight,
            this.charColor,
            this
         );
         if (var4 == 4) {
            var1.setColor(this.normalFgcolor);
            var1.fillRect((var3 - 1) * this.charWidth * 2, var2 * this.charHeight - 1, this.charWidth * 2, 1);
            var1.setColor(this.normalFgcolor);
         }

         if (var4 == 14) {
            var1.setColor(this.boldFgcolor);
            var1.fillRect((var3 - 1) * this.charWidth * 2, var2 * this.charHeight - 1, this.charWidth * 2, 1);
            var1.setColor(this.normalFgcolor);
         }

         if (var4 == 74) {
            var1.setColor(this.reverseFgcolor);
            var1.fillRect((var3 - 1) * this.charWidth * 2, var2 * this.charHeight - 1, this.charWidth * 2, 1);
            var1.setColor(this.normalFgcolor);
         }

         if (var4 == 174) {
            var1.setColor(this.boldReverseFgcolor);
            var1.fillRect((var3 - 1) * this.charWidth * 2, var2 * this.charHeight - 1, this.charWidth * 2, 1);
            var1.setColor(this.normalFgcolor);
         }

         if (this.blinkStatus) {
            this.normalFgcolor = this.normalNormalFgcolor;
            this.boldFgcolor = this.normalBoldFgcolor;
            this.reverseFgcolor = this.normalReverseFgcolor;
            this.boldReverseFgcolor = this.normalBoldReverseFgcolor;
            this.normalBgcolor = this.normalNormalBgcolor;
            this.boldBgcolor = this.normalBoldBgcolor;
            this.reverseBgcolor = this.normalReverseBgcolor;
            this.boldReverseBgcolor = this.normalBoldReverseBgcolor;
         }
      }
   }

   private synchronized void paintDoubleHeightLine(Graphics var1, int var2, boolean var3) throws Exception {
      int var4 = 1;
      int var5 = this.charAttributes[var2 - 1][var4 - 1];
      int var6 = 0;

      for (int var7 = 0; var4 <= this.rightMargin / 2; var4++) {
         var5 = this.charAttributes[var2 - 1][var4 - 1];
         if (var5 >= 30000) {
            var5 -= 30000;
            this.blinkTimer.setBlinkChars(true);
            if (this.blinkStatus) {
               this.normalFgcolor = this.blinkNormalFgcolor;
               this.boldFgcolor = this.blinkBoldFgcolor;
               this.reverseFgcolor = this.blinkReverseFgcolor;
               this.boldReverseFgcolor = this.blinkBoldReverseFgcolor;
               this.normalBgcolor = this.blinkNormalBgcolor;
               this.boldBgcolor = this.blinkBoldBgcolor;
               this.reverseBgcolor = this.blinkReverseBgcolor;
               this.boldReverseBgcolor = this.blinkBoldReverseBgcolor;
            }
         }

         switch (var5) {
            case 0:
            default:
               if ((this.bgColor != LIGHT_BACKGROUND || !this.blinkStatus || this.charArrays[var2 - 1][var4 - 1] == ' ') && this.bgColor != DARK_BACKGROUND) {
                  var6 = 2;
                  this.charColor = this.normalBgcolor;
               } else {
                  var6 = 0;
                  this.charColor = this.normalFgcolor;
               }
               break;
            case 1:
            case 14:
               if ((this.bgColor != LIGHT_BACKGROUND || !this.blinkStatus || this.charArrays[var2 - 1][var4 - 1] == ' ') && this.bgColor != DARK_BACKGROUND) {
                  var6 = 2;
                  this.charColor = this.boldBgcolor;
                  break;
               }

               var6 = 0;
               this.charColor = this.boldFgcolor;
               break;
            case 7:
            case 74:
               if (this.bgColor != LIGHT_BACKGROUND && (this.bgColor != DARK_BACKGROUND || !this.blinkStatus)) {
                  var6 = 2;
                  this.charColor = this.reverseBgcolor;
                  break;
               }

               var6 = 0;
               this.charColor = this.reverseFgcolor;
               break;
            case 17:
            case 174:
               if (this.bgColor != LIGHT_BACKGROUND && (this.bgColor != DARK_BACKGROUND || !this.blinkStatus)) {
                  var6 = 2;
                  this.charColor = this.boldReverseBgcolor;
               } else {
                  var6 = 0;
                  this.charColor = this.boldReverseFgcolor;
               }
         }

         if (!this.decSpl.isGlyph(this.charArrays[var2 - 1][var4 - 1])) {
            char var8 = this.charArrays[var2 - 1][var4 - 1];
            if (var8 >= ' ') {
               if (var8 < 127) {
                  var7 = var8 - ' ';
               } else if (var8 >= 160 && var8 < 254) {
                  var7 = var8 - 160;
                  var6++;
               }
            }
         } else {
            var7 = 0;

            while (var7 < DECSPECIAL.length && this.charArrays[var2 - 1][var4 - 1] != DECSPECIAL[var7]) {
               var7++;
            }

            if (var6 == 0) {
               var6 += 4;
            } else {
               var6 += 3;
            }
         }

         if (var3) {
            var1.drawImage(
               this.image,
               (var4 - 1) * this.charWidth * 2,
               (var2 - 1) * this.charHeight,
               var4 * this.charWidth * 2,
               var2 * this.charHeight,
               var7 * this.imageWidth,
               var6 * this.imageHeight,
               (var7 + 1) * this.imageWidth,
               var6 * this.imageHeight + this.imageHeight / 2,
               this.charColor,
               this
            );
         } else {
            var1.drawImage(
               this.image,
               (var4 - 1) * this.charWidth * 2,
               (var2 - 1) * this.charHeight,
               var4 * this.charWidth * 2,
               var2 * this.charHeight,
               var7 * this.imageWidth,
               var6 * this.imageHeight + this.imageHeight / 2,
               (var7 + 1) * this.imageWidth,
               (var6 + 1) * this.imageHeight,
               this.charColor,
               this
            );
            if (var5 == 4) {
               var1.setColor(this.normalFgcolor);
               var1.fillRect((var4 - 1) * this.charWidth * 2, var2 * this.charHeight - 1, this.charWidth * 2, 1);
               var1.setColor(this.normalFgcolor);
            }

            if (var5 == 14) {
               var1.setColor(this.boldFgcolor);
               var1.fillRect((var4 - 1) * this.charWidth * 2, var2 * this.charHeight - 1, this.charWidth * 2, 1);
               var1.setColor(this.normalFgcolor);
            }

            if (var5 == 74) {
               var1.setColor(this.reverseFgcolor);
               var1.fillRect((var4 - 1) * this.charWidth * 2, var2 * this.charHeight - 1, this.charWidth * 2, 1);
               var1.setColor(this.normalFgcolor);
            }

            if (var5 == 174) {
               var1.setColor(this.boldReverseFgcolor);
               var1.fillRect((var4 - 1) * this.charWidth * 2, var2 * this.charHeight - 1, this.charWidth * 2, 1);
               var1.setColor(this.normalFgcolor);
            }
         }

         if (this.blinkStatus) {
            this.normalFgcolor = this.normalNormalFgcolor;
            this.boldFgcolor = this.normalBoldFgcolor;
            this.reverseFgcolor = this.normalReverseFgcolor;
            this.boldReverseFgcolor = this.normalBoldReverseFgcolor;
            this.normalBgcolor = this.normalNormalBgcolor;
            this.boldBgcolor = this.normalBoldBgcolor;
            this.reverseBgcolor = this.normalReverseBgcolor;
            this.boldReverseBgcolor = this.normalBoldReverseBgcolor;
         }
      }
   }

   void insertChars(int var1, int var2) {
      for (int var3 = 0; var3 < var2; var3++) {
         System.arraycopy(
            this.bufferArrays[var1 + this.diffCursor - 1],
            this.cursorCol + var3 - 1,
            this.bufferArrays[var1 + this.diffCursor - 1],
            this.cursorCol + var3,
            this.rightMargin - (this.cursorCol + var3) - 1
         );
         System.arraycopy(
            this.bufCharAttributes[var1 + this.diffCursor - 1],
            this.cursorCol + var3 - 1,
            this.bufCharAttributes[var1 + this.diffCursor - 1],
            this.cursorCol + var3,
            this.rightMargin - (this.cursorCol + var3) - 1
         );
         this.bufferArrays[var1 + this.diffCursor - 1][this.cursorCol + var3 - 1] = ' ';
         this.bufCharAttributes[var1 + this.diffCursor - 1][this.cursorCol + var3 - 1] = 0;
      }
   }

   void deleteChars(int var1, int var2) {
      int var3 = this.rightMargin - 1;

      for (int var4 = 0; var4 < var2; var4++) {
         for (int var5 = this.cursorCol; var5 <= var3; var5++) {
            this.bufferArrays[var1 + this.diffCursor - 1][var5 - 1] = this.bufferArrays[var1 + this.diffCursor - 1][var5];
         }

         this.bufferArrays[var1 + this.diffCursor - 1][var3] = ' ';
         this.bufCharAttributes[var1 + this.diffCursor - 1][var3] = 0;
         var3--;
      }
   }

   void screenEraseCharacters(int var1) {
      for (int var2 = 0; var2 < this.rightMargin - var1 && var2 + this.cursorCol - 1 != 80; var2++) {
         this.bufferArrays[this.cursorRow + this.diffCursor - 1][var2 + this.cursorCol - 1] = ' ';
         this.bufCharAttributes[this.cursorRow + this.diffCursor - 1][var2 + this.cursorCol - 1] = 0;
      }
   }

   void clearLine(int var1) {
      for (int var2 = 0; var2 < this.rightMargin; var2++) {
         this.bufferArrays[var1 - 1][var2] = ' ';
         this.bufCharAttributes[var1 - 1][var2] = 0;
      }

      this.bufLineAttributes[var1 - 1] = 0;
   }

   void insertLine(int var1, int var2) {
      int var3 = var1;
      int var4 = this.cursorRow + this.diffCursor;
      this.update = true;
      if (var1 != 1 && var1 > this.botMargin - this.cursorRow) {
         var3 = this.botMargin - this.cursorRow;
      }

      for (int var5 = 0; var5 < var3; var5++) {
         if (var2 == 2) {
            for (int var8 = this.diffCursor + this.botMargin; var8 > var4; var8--) {
               for (int var9 = 0; var9 < this.rightMargin; var9++) {
                  this.bufferArrays[var8 - 1][var9] = this.bufferArrays[var8 - 2][var9];
                  this.bufCharAttributes[var8 - 1][var9] = this.bufCharAttributes[var8 - 2][var9];
               }

               this.bufLineAttributes[var8 - 1] = this.bufLineAttributes[var8 - 2];
            }

            this.clearLine(var4);
         } else if (var2 == 1) {
            for (int var6 = 0; var6 < var4; var6++) {
               for (int var7 = 0; var7 < this.rightMargin; var7++) {
                  if (var6 < var4 - 1) {
                     this.bufferArrays[var6][var7] = this.bufferArrays[var6 + 1][var7];
                     this.bufCharAttributes[var6][var7] = this.bufCharAttributes[var6 + 1][var7];
                  }
               }

               this.bufLineAttributes[var6] = this.bufLineAttributes[var6 + 1];
            }

            this.clearLine(var4);
         }

         var4++;
      }
   }

   void scrollRows(int var1) {
      int var2 = 0;
      this.maxDis = var1 + this.botMargin;
      if (this.maxDis > this.bufBotMargin) {
         this.maxDis = this.bufBotMargin;
      }

      for (int var3 = var1; var3 < this.maxDis; var2++) {
         this.charArrays[var2] = this.bufferArrays[var3];
         this.charAttributes[var2] = this.bufCharAttributes[var3];
         this.lineAttributes[var2] = this.bufLineAttributes[var3];
         this.charUpdates[var2] = true;
         var3++;
      }

      if (var2 < this.botMargin) {
         while (var2 < this.botMargin) {
            for (int var4 = 0; var4 < this.rightMargin; var4++) {
               this.charArrays[var2][var4] = ' ';
               this.charAttributes[var2][var4] = 0;
            }

            this.charUpdates[var2] = true;
            var2++;
         }
      }

      this.repaintFrom = 2;
      this.cursorOnOff = 0;
      this.repaint(0, 0, this.getWidth(), this.getHeight());
      this.update = true;
      this.cursorOnOff = 1;
   }

   private int checkBounds(int var1, int var2, int var3) {
      if (var1 < var2) {
         return var2;
      } else {
         return var1 > var3 ? var3 : var1;
      }
   }

   void screenClearEOD() {
      this.update = true;

      for (int var1 = this.cursorCol - 1; var1 < this.rightMargin; var1++) {
         this.bufferArrays[this.cursorRow + this.diffCursor - 1][var1] = ' ';
         this.bufCharAttributes[this.cursorRow + this.diffCursor - 1][var1] = 0;
      }

      for (int var3 = this.cursorRow + this.diffCursor; var3 <= this.bufBotMargin; var3++) {
         for (int var2 = 0; var2 < this.rightMargin; var2++) {
            this.bufferArrays[var3 - 1][var2] = ' ';
            this.bufCharAttributes[var3 - 1][var2] = 0;
         }

         this.bufLineAttributes[var3 - 1] = 0;
      }
   }

   void screenClearBOD() {
      this.update = true;

      for (int var1 = this.diffCursor; var1 < this.cursorRow + this.diffCursor; var1++) {
         for (int var2 = 0; var2 <= (this.cursorRow + this.diffCursor - 1 != var1 ? this.rightMargin - 1 : this.cursorCol - 1); var2++) {
            this.bufferArrays[var1][var2] = ' ';
            this.bufCharAttributes[var1][var2] = 0;
         }

         this.bufLineAttributes[var1] = 0;
      }
   }

   synchronized void screenClearEntire() {
      for (int var1 = this.diffCursor + 1 - 1; var1 < this.diffCursor + 25; var1++) {
         for (int var2 = 0; var2 < this.rightMargin; var2++) {
            this.bufferArrays[var1][var2] = ' ';
            this.bufCharAttributes[var1][var2] = 0;
         }

         this.bufLineAttributes[var1] = 0;
      }

      this.update = true;
   }

   void screenClearEOL() {
      for (int var1 = this.cursorCol - 1; var1 < this.rightMargin; var1++) {
         this.bufferArrays[this.cursorRow + this.diffCursor - 1][var1] = ' ';
         this.bufCharAttributes[this.cursorRow + this.diffCursor - 1][var1] = 0;
      }
   }

   void screenClearBOL() {
      for (int var1 = 0; var1 < this.cursorCol; var1++) {
         this.bufferArrays[this.cursorRow + this.diffCursor - 1][var1] = ' ';
         this.bufCharAttributes[this.cursorRow + this.diffCursor - 1][var1] = 0;
      }
   }

   void screenClearLine() {
      for (int var1 = 0; var1 < this.rightMargin; var1++) {
         this.bufferArrays[this.cursorRow + this.diffCursor - 1][var1] = ' ';
         this.bufCharAttributes[this.cursorRow + this.diffCursor - 1][var1] = 0;
      }
   }

   void deleteLine(int var1) {
      int var3 = this.cursorRow + this.diffCursor;
      this.update = true;

      int var2;
      for (var2 = var3 - 1; var2 < this.diffCursor + this.botMargin - var1; var2++) {
         for (int var4 = 0; var4 < this.rightMargin; var4++) {
            this.bufferArrays[var2][var4] = this.bufferArrays[var2 + var1][var4];
            this.bufCharAttributes[var2][var4] = this.bufCharAttributes[var2 + var1][var4];
         }
      }

      while (var2 < this.diffCursor + this.botMargin) {
         for (int var5 = 0; var5 < this.rightMargin; var5++) {
            this.bufferArrays[var2][var5] = ' ';
            this.bufCharAttributes[var2][var5] = 0;
         }

         this.bufLineAttributes[var2] = 0;
         var2++;
      }
   }

   void fillWithE() {
      this.update = true;

      for (int var1 = 0; var1 < this.bufBotMargin; var1++) {
         for (int var2 = 0; var2 < this.rightMargin; var2++) {
            this.bufferArrays[var1][var2] = 'E';
            this.bufCharAttributes[var1][var2] = 0;
         }

         this.bufLineAttributes[var1] = 0;
      }

      this.diffCursor = 0;
   }

   void setImage10(Image var1) {
      this.image10 = var1;
   }

   void setImage13(Image var1) {
      this.image13 = var1;
   }

   public void onFinalize() {
      this.blinkTimer.stop();
      this.cutpasteBuf = (int[][])null;
      this.charArrays = (char[][])null;
      this.bufferArrays = (char[][])null;
      this.charAttributes = (int[][])null;
      this.bufCharAttributes = (int[][])null;
      this.lineAttributes = null;
      this.bufLineAttributes = null;
      this.charUpdates = null;
      this.decSpl = null;
   }

   private class FocusRequester extends MouseAdapter {
      private FocusRequester() {
      }

      @Override
      public void mouseClicked(MouseEvent var1) {
         VDU.this.requestFocus();
      }
   }
}
