package com.raritan.rrc.components.serialconsole;

import java.util.Hashtable;

class VT100_8859_15Emulator extends VT100Emulator {
   private Hashtable replacementCharacters = new Hashtable(8);

   VT100_8859_15Emulator(Terminal var1) {
      super(var1);
      this.replacementCharacters.put(new Integer(164), new Character('€'));
      this.replacementCharacters.put(new Integer(166), new Character('Š'));
      this.replacementCharacters.put(new Integer(168), new Character('š'));
      this.replacementCharacters.put(new Integer(180), new Character('Ž'));
      this.replacementCharacters.put(new Integer(184), new Character('ž'));
      this.replacementCharacters.put(new Integer(188), new Character('Œ'));
      this.replacementCharacters.put(new Integer(189), new Character('œ'));
      this.replacementCharacters.put(new Integer(190), new Character('Ÿ'));
   }

   @Override
   void processByte(byte var1) {
      char var2 = var1 >= 0 ? (char)var1 : (char)(var1 + 256);
      if (this.checkChar(var2)) {
         if (this.replacementCharacters.containsKey(new Integer(var2))) {
            var2 = (Character)this.replacementCharacters.get(new Integer(var2));
         }

         if (!this.writingHistoryBufferOn) {
            if (var2 == '\n') {
               this.terminal.vdu.putChar("\r");
            }

            this.terminal.vdu.putChar(var2);
         }

         if (this.softScroll && var2 == '\n') {
            this.terminal.vdu.reDraw();
         }
      } else {
         this.doChar(var2);
         if (this.needRedraw) {
            this.terminal.vdu.reDraw();
            this.needRedraw = false;
         }
      }

      if (this.writingHistoryBufferOn) {
         if (var2 == '\r') {
            if (this.sendcrlf == 1) {
               this.terminal.writeFromHistory("\r\n");
            } else {
               this.terminal.writeFromHistory("\r");
            }
         } else {
            this.terminal.writeFromHistory(var2);
         }
      }
   }
}
