package com.raritan.rrc.data;

import com.raritan.tools.resources.RaritanResourceBundle;

public class BladeChassis extends Device {
   protected int portIndex;
   private Device baseDevice;
   private String connectionId;

   public BladeChassis(Device var1) {
      this.baseDevice = var1;
   }

   @Override
   public String getViewName() {
      return null;
   }

   @Override
   public String getDeviceType() {
      return "BladeChassis";
   }

   @Override
   public boolean isConnected() {
      return super.isConnected();
   }

   public void setPortIndex(String var1) {
      int var2 = 0;

      try {
         var2 = Integer.parseInt(var1);
         this.portIndex = var2;
      } catch (NumberFormatException var4) {
         boolean var5 = false;
      }
   }

   public int getPortIndex() {
      return this.portIndex;
   }

   @Override
   public void setName(String var1) {
      super.setName(var1);
   }

   public String getDisplayName(int var1) {
      String var2 = new Integer(this.portIndex + 1).toString();
      String var3 = ": ";
      String var5 = this.getName();
      String var4;
      if (var5 != null && var5.length() != 0) {
         var4 = var5;
      } else {
         var4 = "<Unnamed>";
      }

      return var1 == 0 ? var2 + var3 + var4 : var4 + var3 + var2;
   }

   @Override
   public String getPortKey() {
      return null;
   }

   public Device getBaseDevice() {
      return this.baseDevice;
   }

   @Override
   public String getConnectionId() {
      return this.connectionId;
   }

   @Override
   public void setConnectionId(String var1) {
      this.connectionId = var1;
   }

   @Override
   public void setId(String var1) {
      String var2 = var1;
      if (!var1.contains("FG")) {
         this.setUniquePortId(var1);
      }

      if (var1 != null && !var1.startsWith("//*[@id=")) {
         var2 = "//*[@id=%s]".replaceFirst("%s", var1);
      }

      super.setId(var2);
   }

   @Override
   public void setPortStatus(int var1, int var2) {
      super.setPortStatus(var1, var2);
   }

   public int getPortStatus() {
      return super.getStatus();
   }

   public int getSortPos() {
      return 4;
   }

   @Override
   public void showCommunicationError(String var1, String var2) {
      if (this.bundle == null) {
         this.bundle = RaritanResourceBundle.getResourceBundle(this.scrContext.getLocale());
      }

      String var3 = this.bundle.getString("CommErrorWithPart1")
         + var1
         + ". "
         + this.bundle.getString("CommErrorWithPart2")
         + var2
         + ".\n"
         + this.bundle.getString("CommErrorWithBladeAuditLog");
      super.showCommunicationError(var3, this.bundle.getString("optionpane.error.title"));
   }
}
