package com.raritan.rrc.data;

import java.util.LinkedHashMap;
import java.util.Map;

public abstract class Component implements Connectable {
   private Component parent;
   private Map children;

   public void add(Component var1, String var2) {
      if (var1 != null) {
         var1.setParent(this);
         if (this.children == null) {
            this.children = new LinkedHashMap();
         }

         this.children.put(var2.toLowerCase(), var1);
      }
   }

   public void addChildren(Map var1) {
      if (var1 != null && !var1.isEmpty() && this.children != null) {
         this.children.clear();
         this.children.putAll(var1);
      }
   }

   public void remove(Component var1) {
      if (var1 != null) {
         this.children.remove(var1);
         var1.setParent(null);
      }
   }

   public void remove(Component var1, String var2) {
      if (var1 != null) {
         if (this.children.containsKey(var2.toLowerCase())) {
            this.children.remove(var2.toLowerCase());
         }

         var1.setParent(null);
      }
   }

   protected void removeChildren() {
      if (this.children != null) {
         this.children.clear();
         this.children = null;
      }
   }

   public boolean hasChildren() {
      return this.children == null ? false : !this.children.isEmpty();
   }

   public Map getChildren() {
      return this.children != null && !this.children.isEmpty() ? this.children : null;
   }

   public Component getParent() {
      return this.parent;
   }

   public void setParent(Component var1) {
      this.parent = var1;
   }
}
