package com.raritan.rrc.data;

import com.raritan.rrc.ui.commands.DoSwitchCommand;
import com.raritan.rrc.ui.commands.ShowUpdateDeviceCommand;
import com.raritan.rrc.ui.panes.KvmPanel;
import com.raritan.tools.commands.CommandResult;
import com.raritan.tools.resources.RaritanPropertyResourceBundle;
import java.util.LinkedHashMap;
import java.util.Map;
import javaclientlib.utils.RRCGeneralException;
import nn.pp.common.ApplicationContext;
import nn.pp.rccore.RCCore;

public abstract class DeviceHandlerImpl implements DeviceHandlerInterface {
   protected Device device;
   protected int upgradeDuration = 20;

   @Override
   public boolean isAbsoluteMouseSupported() {
      return false;
   }

   @Override
   public boolean isIntelligentMouseSupported() {
      return false;
   }

   @Override
   public boolean isStandardMouseSupported() {
      return false;
   }

   @Override
   public void doSwitch(DoSwitchCommand var1, CommandResult var2) {
   }

   @Override
   public void doShowDeviceUpdateCommand(ShowUpdateDeviceCommand var1) {
      this.device.setUpgradeDuration(this.upgradeDuration);
   }

   protected String getParamValue(Map var1, String var2, boolean var3) throws RRCGeneralException {
      String var4 = "";
      if (var1.get(var2) == null && var3) {
         throw new RRCGeneralException(var2 + " is missing");
      } else {
         return (String)var1.get(var2);
      }
   }

   @Override
   public void finishAutoSensing(KvmPanel var1) {
   }

   @Override
   public boolean hasColorCalibration(Port var1) {
      return true;
   }

   @Override
   public LinkedHashMap<String, RCCore.Compression> initializeAllConnSpeeds(RaritanPropertyResourceBundle var1) {
      LinkedHashMap var2 = new LinkedHashMap();
      var2.put(var1.getString("VideoOptimized.option"), RCCore.Compression.VIDEO_OPTIMIZED);
      var2.put(var1.getString("Ethernet1G.option"), RCCore.Compression.UNCOMPRESSED);
      var2.put(var1.getString("Ethernet100.option"), RCCore.Compression.UNCOMPRESSED);
      var2.put(var1.getString("Ethernet10.option"), RCCore.Compression.UNCOMPRESSED);
      var2.put(var1.getString("MaxDSL.option"), RCCore.Compression.LEVEL_1);
      var2.put(var1.getString("FastDSL.option"), RCCore.Compression.LEVEL_2);
      var2.put(var1.getString("MediumDSL.option"), RCCore.Compression.LEVEL_3);
      var2.put(var1.getString("SlowDSL.option"), RCCore.Compression.LEVEL_4);
      var2.put(var1.getString("Cable.option"), RCCore.Compression.LEVEL_5);
      var2.put(var1.getString("DualISDN.option"), RCCore.Compression.LEVEL_6);
      var2.put(var1.getString("ISPModem.option"), RCCore.Compression.LEVEL_7);
      var2.put(var1.getString("FastModem.option"), RCCore.Compression.LEVEL_8);
      var2.put(var1.getString("SlowModem.option"), RCCore.Compression.LEVEL_9);
      return var2;
   }

   @Override
   public void setToolTip(Port var1) {
   }

   @Override
   public boolean showCtrlNumlockCommand(Port var1) {
      return true;
   }

   @Override
   public boolean canDoTargetScreenCapture() {
      return false;
   }

   @Override
   public void updateHotkeys() {
      ApplicationContext.getInstance().setAttribute("HOTKEYMAP", null);
   }

   @Override
   public boolean isURLPortExecutable() {
      return false;
   }
}
