package com.raritan.rrc.data;

import com.raritan.rrc.ui.commands.DoSwitchCommand;
import com.raritan.rrc.ui.commands.ShowUpdateDeviceCommand;
import com.raritan.rrc.ui.panes.KvmPanel;
import com.raritan.tools.commands.CommandContext;
import com.raritan.tools.commands.CommandResult;
import com.raritan.tools.resources.RaritanPropertyResourceBundle;
import com.raritan.tools.ui.panes.displays.AbstractDisplay;
import com.raritan.tools.ui.panes.mediator.PanelMediator;
import java.io.IOException;
import java.security.KeyManagementException;
import java.security.NoSuchAlgorithmException;
import java.util.LinkedHashMap;
import javaclientlib.utils.RRCGeneralException;
import nn.pp.rccore.RCCore;

public interface DeviceHandlerInterface {
   void doPostLogin(boolean var1) throws RRCGeneralException, KeyManagementException, NoSuchAlgorithmException, IOException;

   void showRSA(boolean var1) throws RRCGeneralException, KeyManagementException, NoSuchAlgorithmException, IOException;

   boolean isAbsoluteMouseSupported();

   boolean isIntelligentMouseSupported();

   boolean isStandardMouseSupported();

   boolean changePassword(boolean var1, String var2, String var3, String var4);

   void doSwitch(DoSwitchCommand var1, CommandResult var2);

   boolean isWindowMenuItem(Port var1);

   boolean isShowHtmlPortExecutable();

   boolean isURLPortExecutable();

   void doShowDeviceUpdateCommand(ShowUpdateDeviceCommand var1);

   boolean isShowSaveActivityLogExecutable();

   boolean isShowSaveDeviceConfigurationExecutable();

   boolean isShowSaveDiagnosticLogExecutable();

   boolean isShowSaveTotalConfigurationExecutable();

   boolean isShowSaveUserConfigurationExecutable();

   String getCommandClassName(String var1);

   AbstractDisplay initializeDeviceView(CommandContext var1, String var2, PanelMediator var3) throws RRCGeneralException;

   boolean isRFPRecieveThreadNeeded();

   Port initSerialPort();

   boolean hasColorCalibration(Port var1);

   void finishAutoSensing(KvmPanel var1);

   void setToolTip(Port var1);

   void waitBeforeAutoReboot();

   boolean showCtrlNumlockCommand(Port var1);

   LinkedHashMap<String, RCCore.Compression> initializeAllConnSpeeds(RaritanPropertyResourceBundle var1);

   boolean canDoTargetScreenCapture();

   void updateHotkeys();
}
