package com.raritan.rrc.data;

import com.raritan.rrc.ui.panes.AppletView;
import com.raritan.rrc.ui.panes.DeviceView;

public class HtmlPort extends Port {
   private AppletView appletView;
   private String sessionId;

   @Override
   public DeviceView getView() {
      return this.appletView;
   }

   public void setView(AppletView var1) {
      this.appletView = var1;
   }

   @Override
   public void connect() {
      if (!this.isConnected()) {
         if (this.getDeviceConnector() != null) {
            this.sessionId = this.getDeviceConnector().getSessionID();
            this.setConnected(true);
            this.setState("CONNECTED");
            this.firePropertyChange("DEVICE_PORT_VIEW_ADD", null, null);
         }
      }
   }

   @Override
   public void disconnect() {
      this.setConnected(false);
      this.setState("AVAILABLE");
      super.disconnect();
      if (this.appletView != null) {
         ((AppletView)this.getView()).feedCommandContext(null);
         this.appletView.setVisible(false);
         this.appletView = null;
      }

      this.firePropertyChange("DEVICE_PORT_VIEW_REMOVE", null, null);
   }

   public boolean isAdministrator() {
      DeviceConnector var1 = this.device.getDeviceConnector();
      boolean var2 = (var1.getPermissions() & 2L) != 0L;
      boolean var3 = var1.getServerID().getProtocolVersion() > 11;
      boolean var4 = (var1.getServerID().getSecurityFlags() & 1) != 0;
      return var2 && var3 && var4;
   }

   @Override
   public Stream getStream() {
      return null;
   }

   public String getSessionId() {
      return this.sessionId;
   }
}
