package com.raritan.rrc.data;

import com.raritan.rrc.ui.RRCScreenContext;
import com.raritan.rrc.ui.commands.ShowUpdateDeviceCommand;
import com.raritan.tools.resources.RaritanPropertyResourceBundle;
import java.util.LinkedHashMap;
import nn.pp.rccore.RCCore;

public class KX101G2DeviceHandlerImpl extends G2DeviceHandlerImpl {
   public KX101G2DeviceHandlerImpl(Device var1) {
      super(var1);
   }

   @Override
   public void doShowDeviceUpdateCommand(ShowUpdateDeviceCommand var1) {
      this.upgradeDuration = 3;
      this.device.setUpgradeDuration(this.upgradeDuration);
      var1.setText(true, this.upgradeDuration);
   }

   @Override
   public LinkedHashMap<String, RCCore.Compression> initializeAllConnSpeeds(RaritanPropertyResourceBundle var1) {
      LinkedHashMap var2 = new LinkedHashMap();
      var2.put(var1.getString("VideoOptimized.option"), RCCore.Compression.VIDEO_OPTIMIZED);
      var2.put(var1.getString("Ethernet100.option"), RCCore.Compression.UNCOMPRESSED);
      var2.put(var1.getString("Ethernet10.option"), RCCore.Compression.UNCOMPRESSED);
      var2.put(var1.getString("MaxDSL.option"), RCCore.Compression.LEVEL_1);
      var2.put(var1.getString("FastDSL.option"), RCCore.Compression.LEVEL_2);
      var2.put(var1.getString("MediumDSL.option"), RCCore.Compression.LEVEL_3);
      var2.put(var1.getString("SlowDSL.option"), RCCore.Compression.LEVEL_4);
      var2.put(var1.getString("Cable.option"), RCCore.Compression.LEVEL_5);
      var2.put(var1.getString("DualISDN.option"), RCCore.Compression.LEVEL_6);
      var2.put(var1.getString("ISPModem.option"), RCCore.Compression.LEVEL_7);
      var2.put(var1.getString("FastModem.option"), RCCore.Compression.LEVEL_8);
      var2.put(var1.getString("SlowModem.option"), RCCore.Compression.LEVEL_9);
      return var2;
   }

   @Override
   public boolean isAbsoluteMouseSupported() {
      return ((RRCScreenContext)this.device.scrContext).getSelectView() != null
         ? ((RRCScreenContext)this.device.scrContext).getSelectView().getAbsoluteMouseSupported()
         : false;
   }

   @Override
   public boolean isIntelligentMouseSupported() {
      return ((RRCScreenContext)this.device.scrContext).getSelectView() != null
         ? ((RRCScreenContext)this.device.scrContext).getSelectView().getIntelligentMouseSupported()
         : false;
   }

   @Override
   public boolean isStandardMouseSupported() {
      return ((RRCScreenContext)this.device.scrContext).getSelectView() != null
         ? ((RRCScreenContext)this.device.scrContext).getSelectView().getStandardMouseSupported()
         : false;
   }
}
