package com.raritan.rrc.data;

import javaclientlib.clientlib.TRVideoStream;
import javaclientlib.tr.TRLIB_UPDATEINFO;
import javaclientlib.tr.TRRSP_NEW_VIDEO_MODE_DATA;
import javaclientlib.tr.TRSRVR_COMP_PARAMS;
import javaclientlib.tr.TRSRVR_TARGET_PARAMS;

public class KvmStream extends TRVideoStream implements Stream {
   private KvmPort kvmPort;
   private TRSRVR_COMP_PARAMS compParams;

   public KvmStream(KvmPort var1, int var2) {
      super(var1.getDeviceConnector(), var2);
      this.kvmPort = var1;
      if (var1.getDevice().getDevPrefs() != null) {
         this.compParams = var1.getDevice().getDevPrefs().getCompParams();
      } else {
         this.compParams = ((IPReach)var1.getDevice()).getConnectionInfo().getCompParams();
      }
   }

   public TRSRVR_COMP_PARAMS getCompressionParams() {
      return this.compParams;
   }

   @Override
   public boolean setCompParams(TRSRVR_COMP_PARAMS var1) {
      if (super.setCompParams(var1)) {
         this.compParams = var1;
         return true;
      } else {
         return false;
      }
   }

   public boolean startVideoStream(String var1, String var2, int var3) {
      try {
         return this.connectVideoStream(var1, var2, this.compParams, var3);
      } catch (Exception var5) {
         return false;
      }
   }

   @Override
   public void newVideoModeNotify(TRRSP_NEW_VIDEO_MODE_DATA var1) {
      this.kvmPort.newVideoModeNotify(var1);
   }

   @Override
   public void updateNotify(TRLIB_UPDATEINFO var1) {
      this.kvmPort.updateNotify(var1);
   }

   @Override
   public void notify(int var1, int var2) {
      this.kvmPort.notify(var1, var2);
   }

   @Override
   public void targetParamsChanged(TRSRVR_TARGET_PARAMS var1) {
      this.kvmPort.setUpKvmMouse(var1);
   }

   public TRRSP_NEW_VIDEO_MODE_DATA getVideoMode() {
      return this.objTRRSPNewVideoModeData;
   }
}
