package com.raritan.rrc.data;

import java.awt.Point;
import java.util.List;
import java.util.Vector;

public class MultiMonitorPort {
   private final List<MultiMonitorPort.PortConfig> ports = new Vector<>();
   private final Device device;

   public MultiMonitorPort(Device var1) {
      this.device = var1;
   }

   public List<MultiMonitorPort.PortConfig> getPorts() {
      return this.ports;
   }

   public void addPort(String var1, int var2, int var3, int var4) {
      this.ports.add(new MultiMonitorPort.PortConfig(var1, var2, var3, var4));
   }

   public Device getDevice() {
      return this.device;
   }

   public static class PortConfig {
      private final String portId;
      private final int monitorIdx;
      private final Point monitorPosition;

      public PortConfig(String var1, int var2, int var3, int var4) {
         this.portId = var1;
         this.monitorIdx = var2;
         this.monitorPosition = new Point(var3, var4);
      }

      public String getPortId() {
         return this.portId;
      }

      public int getMonitorIndex() {
         return this.monitorIdx;
      }

      public Point getMonitorPosition() {
         return this.monitorPosition;
      }
   }
}
