package com.raritan.rrc.data;

public class Paragon extends IPReach {
   private String document = null;
   private Device baseDevice = null;

   public Paragon(Device var1) {
      this.baseDevice = var1;
   }

   public Device getBaseDevice() {
      return this.baseDevice;
   }

   @Override
   public String getDeviceType() {
      return "Paragon";
   }

   @Override
   public String getViewName() {
      return "";
   }

   public String getDocument() {
      return this.document;
   }

   public void setDocument(String var1) {
      this.document = var1;
   }

   @Override
   public void connect() {
      this.setConnected(true);
      this.setState("CONNECTED");
      this.firePropertyChange("DEVICE_CONNECTED", null, null);
   }

   @Override
   public void disconnect() {
      this.setConnected(false);
      this.setState("AVAILABLE");
      if (this.hasChildren()) {
         this.removeChildren();
      }

      this.firePropertyChange("DEVICE_CONNECTION_LOST", null, null);
   }

   public String getPortal() {
      Device var1 = this.getBaseDevice();

      while (var1 != null && var1 instanceof Paragon) {
         var1 = ((Paragon)var1).getBaseDevice();
      }

      if (var1 != null && var1 instanceof IPReach) {
         IPReach var2 = (IPReach)var1;
         String var3 = var2.getKvmSwitchId();
         if (var3 != null) {
            return "//*[@id=" + var3 + "]";
         }
      }

      return "";
   }
}
