package com.raritan.rrc.data;

import com.raritan.rrc.util.StringUtils;
import com.raritan.tools.ui.ScreenContext;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;

public class PortFactory {
   private static final String[] ENUM_PORT_CLASS = new String[]{"KVM", "Serial", "Outlet", "HTML", "Virtual"};
   private static final PortFactory INSTANCE = new PortFactory();

   public static PortFactory getInstance() {
      return INSTANCE;
   }

   public void parseOutletAssociation(NodeList var1, Port var2) {
      Object var3 = null;
      Object var4 = null;
      if (var1 != null && var1.getLength() != 0) {
         for (int var5 = var1.getLength() - 1; var5 >= 0; var5--) {
            if (var1.item(var5) != null) {
               var3 = (Element)var1.item(var5);
               var4 = var3.getAttribute("ConnID").trim();
               var2.setOutLetPort(true);
               var2.addOutletId((String)var4);
            }
         }
      }
   }

   public PortFactory.PortOrParagon getPortOrParagon(Device var1, Element var2, ScreenContext var3, boolean var4) {
      PortFactory.PortOrParagon var5 = new PortFactory.PortOrParagon();
      Object var6 = null;
      Object var7 = null;
      String var8 = null;
      Object var9 = null;
      Object var10 = null;
      int var11 = 0;
      if (var2 == null) {
         return var5;
      } else {
         String var12 = var2.getAttribute("Class").trim();
         String var13 = var2.getAttribute("Type").trim();
         var10 = var2.getAttribute("Connection").trim();
         String var14 = var2.getAttribute("index").trim();
         String var15 = var2.getAttribute("id").trim();

         try {
            var11 = Integer.parseInt(var2.getAttribute("Ghost"));
         } catch (Exception var22) {
         }

         NodeList var16 = var2.getElementsByTagName("Name");
         if (var16 != null && var16.getLength() != 0 && var16.item(0).getFirstChild() != null) {
            Node var17 = var16.item(0).getFirstChild();
            var7 = var17.getNodeValue();
            if (StringUtils.nullOrEmpty((String)var7)) {
               var7 = "";
            }
         } else {
            var7 = "";
         }

         if (StringUtils.findInStringArray(var12, ENUM_PORT_CLASS)) {
            if (!var12.equalsIgnoreCase("KVM") && !var12.equalsIgnoreCase("Virtual")) {
               if (var12.equalsIgnoreCase("Serial")) {
                  if (var13.equalsIgnoreCase("VT100PowerPort")) {
                     var6 = new PowerPort();
                  } else {
                     var6 = var1.getHandler().initSerialPort();
                     NodeList var31 = var2.getElementsByTagName("AssociatedOutlet");
                     this.parseOutletAssociation(var31, (Port)var6);
                  }
               } else {
                  if (!var12.equalsIgnoreCase("HTML")) {
                     return var5;
                  }

                  var6 = new HtmlPort();
               }
            } else {
               if (var13.equalsIgnoreCase("UMT")) {
                  Paragon var30 = new Paragon(var1);
                  var30.setConnectionId((String)var10);
                  return new PortFactory.PortOrParagon(var30);
               }

               if (var13.equals("BladeChassis") || var13.equals("KVMSwitch")) {
                  BladeChassis var29 = new BladeChassis(var1);
                  var29.setPortIndex(var14);
                  var29.setName((String)var7);
                  var29.setConnectionId((String)var10);
                  var29.setId(var15);
                  String var18 = var2.getAttribute("Status");
                  String var19 = var2.getAttribute("StatAvailable");
                  var29.setPortStatus(Integer.parseInt(var18), Integer.parseInt(var19));
                  return new PortFactory.PortOrParagon(var29);
               }

               if (var13.equals("VirtualBladeChassis") || var13.equals("PortGroup")) {
                  VirtualBladeChassis var28 = new VirtualBladeChassis(var1);
                  var28.setName((String)var7);
                  var28.setId(var15);
                  var28.setConnectionId((String)var10);
                  var28.setVirtual(true);
                  var28.setPortIndex(var14);
                  return new PortFactory.PortOrParagon(var28);
               }

               if (var13.equals("TierDevice")) {
                  Object var27 = null;
                  return new PortFactory.PortOrParagon((Port)var27);
               }

               if (var4 && !var13.equals("MultiMonitorPort")) {
                  var6 = var1.getPortByTargetDeviceId("//*[@id=" + var15 + "]");
                  if (var6 != null) {
                     var13 = ((Port)var6).getPortType();
                  }
               }

               if (var6 == null) {
                  var6 = new KvmPort(var3);
               }

               new PortFactory.PortOrParagon((Port)var6);
               NodeList var26 = var2.getElementsByTagName("AssociatedOutlet");
               this.parseOutletAssociation(var26, (Port)var6);
            }
         }

         var5 = new PortFactory.PortOrParagon((Port)var6);
         NodeList var32 = var2.getElementsByTagName("DeviceID");
         if (var32.item(0) instanceof Element) {
            var8 = var32.item(0).getFirstChild().getNodeValue();
         }

         NodeList var33 = var2.getElementsByTagName("Path");
         if (var33 != null && var33.getLength() != 0 && var33.item(0) instanceof Element) {
            var8 = var15;
            if (var15 != null && !var15.startsWith("//*[@id=")) {
               StringBuffer var34 = new StringBuffer("//*[@id=");
               var34.append(var15);
               var34.append("]");
               var8 = var34.toString();
            }
         }

         if (var6 != null) {
            ((Port)var6).setDeviceClass(var12);
            ((Port)var6).setPortType(var13);
            String var35 = var2.getAttribute("StatAvailable");
            if (var35.equals("")) {
               ((Port)var6).setPortStatus(var2.getAttribute("Status").trim());
            } else {
               int var20 = Integer.parseInt(var2.getAttribute("Status").trim());
               int var21 = Integer.parseInt(var2.getAttribute("StatAvailable").trim());
               ((Port)var6).setPortStatus(var20, var21);
            }

            ((Port)var6).setName((String)var7);
            ((Port)var6).setTargetDeviceId(var8);
            ((Port)var6).setConnectionId((String)var10);
            ((Port)var6).setId(var15);
            ((Port)var6).setPortIndex(var14);
            ((Port)var6).setGhostMode(var11);
         }

         if (var8 == null && var6 != null) {
            ((Port)var6).setTargetDeviceId(((Port)var6).getId());
         }

         return var5;
      }
   }

   public class PortOrParagon {
      private Paragon paragon = null;
      private Port port = null;
      private BladeChassis bladeChassis = null;

      public PortOrParagon() {
         this.port = null;
         this.paragon = null;
         this.bladeChassis = null;
      }

      public PortOrParagon(Paragon var2) {
         this.paragon = var2;
      }

      public Paragon getParagon() {
         return this.paragon;
      }

      public PortOrParagon(Port var2) {
         this.port = var2;
      }

      public Port getPort() {
         return this.port;
      }

      public PortOrParagon(BladeChassis var2) {
         this.bladeChassis = var2;
      }

      public BladeChassis getBladeChassis() {
         return this.bladeChassis;
      }
   }
}
