package com.raritan.rrc.data;

import com.raritan.tools.resources.RaritanPropertyResourceBundle;
import com.raritan.tools.resources.RaritanResourceBundle;

public class ProductCodes {
   public static final int PRODID_dominionKXG2 = 0;
   public static final int PRODID_dominionKXG1 = 1;
   public static final int PRODID_dominionKSXG2 = 2;
   public static final int PRODID_dominionKSXG1 = 3;
   public static final int PRODID_dominionLX = 4;
   public static final int PRODID_ipReach = 5;
   public static final int PRODID_ustipG1 = 6;
   public static final int PRODID_kx101G2 = 7;
   public static final int PRODID_kx101 = 8;
   private final String[] productNames;
   private static ProductCodes sm_instance;

   private ProductCodes() {
      RaritanPropertyResourceBundle var1 = RaritanResourceBundle.getResourceBundle();
      this.productNames = new String[9];
      this.productNames[0] = var1.getString("dominionKXG2");
      this.productNames[1] = var1.getString("dominionKXG1");
      this.productNames[2] = var1.getString("dominionKSXG2");
      this.productNames[3] = var1.getString("dominionKSXG1");
      this.productNames[4] = var1.getString("dominionLX");
      this.productNames[5] = var1.getString("ipReach");
      this.productNames[6] = var1.getString("ustipG1");
      this.productNames[7] = var1.getString("kx101G2");
      this.productNames[8] = var1.getString("kx101");
   }

   public static synchronized ProductCodes getInstance() {
      if (sm_instance == null) {
         sm_instance = new ProductCodes();
      }

      return sm_instance;
   }

   public boolean isKSXG2(String var1) {
      return this.productNames[2].equals(var1);
   }

   public boolean isKX101G2(String var1) {
      return this.productNames[7].equals(var1);
   }

   public boolean isKXG2(String var1) {
      return this.productNames[0].equals(var1);
   }

   public boolean isDominionLX(String var1) {
      return this.productNames[4].equals(var1);
   }

   public String getProductCode(int var1) {
      return var1 >= 0 && var1 <= 8 ? this.productNames[var1] : null;
   }
}
