package com.raritan.rrc.data;

import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

public class VMConfigInfo {
   private ArrayList listofInterfaces = new ArrayList(4);
   private boolean cimActive = true;

   public VMConfigInfo(List var1) {
      this.listofInterfaces.addAll(var1);
   }

   public List getListofInterfaces() {
      return Collections.unmodifiableList(this.listofInterfaces);
   }

   public VMInterfaceInfo getVMInterface(int var1) {
      for (VMInterfaceInfo var3 : this.listofInterfaces) {
         if (var3.getMassStorageDevice(var1) != null) {
            return var3;
         }
      }

      return null;
   }

   public synchronized void setCimActive(boolean var1) {
      this.cimActive = var1;
   }

   public synchronized boolean isCimActive() {
      return this.cimActive;
   }

   public void copyStateTo(VMConfigInfo var1) {
      for (VMInterfaceInfo var3 : this.getListofInterfaces()) {
         for (VMInterfaceInfo var5 : var1.getListofInterfaces()) {
            if (var3.getInterfaceID() == var5.getInterfaceID()) {
               for (MassStorageDevice var7 : var3.getListofMassStorageDev()) {
                  final MassStorageDevice var8 = var5.getMassStorageDevice(var7.getDevType());
                  if (var8 != null) {
                     var8.setConnected(var7.isConnected());
                     var7.addPropertyChangeListener(new PropertyChangeListener() {
                        @Override
                        public void propertyChange(PropertyChangeEvent var1) {
                           if ("connected".equals(var1.getPropertyName())) {
                              var8.setConnected((Boolean)var1.getNewValue());
                           }
                        }
                     });
                  }
               }
            }
         }
      }
   }

   @Override
   public String toString() {
      return "VMConfigInfo : " + this.listofInterfaces + " : cimActive  : " + this.isCimActive();
   }
}
