package com.raritan.rrc.data;

import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

public class VMInterfaceInfo {
   private final int interfaceID;
   private final ArrayList listofMassStorageDev = new ArrayList(4);

   public VMInterfaceInfo(int var1, List var2) {
      this.interfaceID = var1;
      this.listofMassStorageDev.addAll(var2);
   }

   public List getListofMassStorageDev() {
      return Collections.unmodifiableList(this.listofMassStorageDev);
   }

   public int getInterfaceID() {
      return this.interfaceID;
   }

   public boolean isMultiLUN() {
      return this.listofMassStorageDev.size() > 1;
   }

   public boolean isInUse() {
      for (MassStorageDevice var2 : this.listofMassStorageDev) {
         if (var2.isConnected()) {
            return true;
         }
      }

      return false;
   }

   public MassStorageDevice getMassStorageDevice(int var1) {
      for (MassStorageDevice var3 : this.listofMassStorageDev) {
         if (var3.getDevType() == var1) {
            return var3;
         }
      }

      return null;
   }

   @Override
   public String toString() {
      return "VMInterfaceInfo - isMultiLUN : "
         + this.isMultiLUN()
         + " [interfaceID : "
         + this.interfaceID
         + "], [MassStorageDevs : "
         + this.listofMassStorageDev
         + "]";
   }
}
