package com.raritan.rrc.data;

import com.raritan.rrc.ui.rfbbridge.RFBProfile;
import com.raritan.rrc.ui.rfbbridge.RFBView;
import java.util.ArrayList;
import java.util.TreeMap;
import javaclientlib.utils.RRCLogger;
import nn.pp.rccore.VMMountRequestResponse;
import nn.pp.vmcore.VMCore;
import nn.pp.vmcore.VMCoreFactory;

public class VirtualMediaBean {
   private String portKey;
   private VMMountRequestResponse[] vmMountRequestResponseList;
   private String availableDrivesComboValue;
   private boolean fullLocalRadioButtonSelected = false;
   private boolean diskImageRadioButtonSelected = false;
   private boolean remoteImageRadioButtonSelected = false;
   private String imagesComboValue;
   private String imageTextValue = "";
   private RFBProfile rfbProfile = new RFBProfile();
   private RFBView rfbView;
   private boolean driveConnected = false;
   private String isoFilename = "";
   private String isoDirectory = "";
   private int port;
   private TreeMap vmMountRequestResponse;
   private ArrayList hosts;
   private VMMountRequestResponse sambaRequest;
   private String connectedDrive = "";
   private int connectionType = 0;
   private boolean isSwitched = false;
   private VMInterfaceInfo vmInterfaceInfo;
   private VMCore vmcore;

   public VirtualMediaBean(VMInterfaceInfo var1) {
      assert var1 != null;

      this.vmInterfaceInfo = var1;
      byte var2 = 0;
      this.vmcore = VMCoreFactory.loadVMCore(RRCLogger.getLogger(), var2);
   }

   public boolean isDriveConnected() {
      return this.driveConnected;
   }

   public void setDriveConnected(boolean var1) {
      this.driveConnected = var1;
      MassStorageDevice var2 = this.vmInterfaceInfo.getMassStorageDevice(1);
      var2.setConnected(var1);
   }

   public String getPortKey() {
      return this.portKey;
   }

   public void setPortKey(String var1) {
      this.portKey = var1;
   }

   public void setPort(int var1) {
      this.port = var1;
   }

   public int getPort() {
      return this.port;
   }

   public String getAvailableDrivesComboValue() {
      return this.availableDrivesComboValue;
   }

   public void setAvailableDrivesComboValue(String var1) {
      this.availableDrivesComboValue = var1;
   }

   public boolean isDiskImageRadioButtonSelected() {
      return this.diskImageRadioButtonSelected;
   }

   public void setDiskImageRadioButtonSelected(boolean var1) {
      this.diskImageRadioButtonSelected = var1;
   }

   public boolean isFullLocalRadioButtonSelected() {
      return this.fullLocalRadioButtonSelected;
   }

   public void setFullLocalRadioButtonSelected(boolean var1) {
      this.fullLocalRadioButtonSelected = var1;
   }

   public String getImagesComboValue() {
      return this.imagesComboValue;
   }

   public void setImagesComboValue(String var1) {
      this.imagesComboValue = var1;
   }

   public String getImageTextValue() {
      return this.imageTextValue;
   }

   public void setImageTextValue(String var1) {
      this.imageTextValue = var1;
   }

   public boolean isRemoteImageRadioButtonSelected() {
      return this.remoteImageRadioButtonSelected;
   }

   public void setRemoteImageRadioButtonSelected(boolean var1) {
      this.remoteImageRadioButtonSelected = var1;
   }

   public void setRFBProfile(RFBProfile var1) {
      this.rfbProfile = var1;
   }

   public RFBProfile getRFBProfile() {
      return this.rfbProfile;
   }

   public String getIsoFilename() {
      return this.isoFilename;
   }

   public void setIsoFilename(String var1) {
      this.isoFilename = var1;
   }

   public String getIsoDirectory() {
      return this.isoDirectory;
   }

   public void setIsoDirectory(String var1) {
      this.isoDirectory = var1;
   }

   public VMMountRequestResponse[] getVmMountRequestResponseList() {
      return this.vmMountRequestResponseList;
   }

   public void setVmMountRequestResponseList(VMMountRequestResponse[] var1) {
      this.vmMountRequestResponseList = var1;
      this.hosts = this.getHosts(var1);
      this.vmMountRequestResponse = this.getHostImageMap(var1, this.hosts);
   }

   private TreeMap getHostImageMap(VMMountRequestResponse[] var1, ArrayList var2) {
      ArrayList var3 = new ArrayList();
      TreeMap var4 = new TreeMap();
      if (var1 != null) {
         for (String var6 : var2) {
            for (int var7 = 0; var7 < var1.length; var7++) {
               if (var6.equals(var1[var7].getHost())) {
                  var3.add(var1[var7].getImage());
               }
            }

            var4.put(var6, var3);
            var3 = new ArrayList();
         }
      }

      return var4;
   }

   private ArrayList getHosts(VMMountRequestResponse[] var1) {
      ArrayList var2 = new ArrayList();
      if (var1 != null) {
         for (int var3 = 0; var3 < var1.length; var3++) {
            if (!var2.contains(var1[var3].getHost())) {
               var2.add(var1[var3].getHost());
            }
         }
      }

      return var2;
   }

   public ArrayList getHosts() {
      return this.hosts;
   }

   public TreeMap getVmMountRequestResponse() {
      return this.vmMountRequestResponse;
   }

   public void setSambaRequest(VMMountRequestResponse var1) {
      this.sambaRequest = var1;
   }

   public VMMountRequestResponse getSambaRequestDrive1() {
      return this.sambaRequest;
   }

   public void setRFBView(RFBView var1) {
      this.rfbView = var1;
   }

   public RFBView getRFBView() {
      return this.rfbView;
   }

   public void setConnectedDrive(String var1) {
      this.connectedDrive = var1;
   }

   public String getConnectedDrive() {
      return this.connectedDrive;
   }

   public void setConnectionType(int var1) {
      this.connectionType = var1;
   }

   public int getConnectionType() {
      return this.connectionType;
   }

   public void resetComponentState() {
      this.connectedDrive = "";
      this.diskImageRadioButtonSelected = false;
      this.imageTextValue = "";
      this.isoDirectory = "";
   }

   public boolean getSwitchedFlag() {
      return this.isSwitched;
   }

   public void setSwitchedFlag(boolean var1) {
      this.isSwitched = var1;
   }

   public VMInterfaceInfo getVmInterfaceInfo() {
      return this.vmInterfaceInfo;
   }

   public VMCore getVmCore() {
      return this.vmcore;
   }
}
