package com.raritan.rrc.data;

import com.raritan.rrc.ui.rfbbridge.RFBProfile;
import com.raritan.rrc.ui.rfbbridge.RFBView;
import javaclientlib.utils.RRCLogger;
import nn.pp.vmcore.VMCore;
import nn.pp.vmcore.VMCoreFactory;

public class VirtualMediaLocalBean {
   private String portKey;
   private boolean readWriteCheckBoxSelected = false;
   private String availableDrivesComboValue;
   private RFBProfile rfbProfile = new RFBProfile();
   private RFBView rfbView;
   private boolean driveConnected = false;
   private int port;
   private String connectedDrive;
   private boolean isSwitched = false;
   private VMInterfaceInfo vmInterfaceInfo;
   private VMCore vmcore;

   public VirtualMediaLocalBean(VMInterfaceInfo var1) {
      assert var1 != null;

      this.vmInterfaceInfo = var1;
      byte var2 = 1;
      this.vmcore = VMCoreFactory.loadVMCore(RRCLogger.getLogger(), var2);
   }

   public boolean isDriveConnected() {
      return this.driveConnected;
   }

   public void setDriveConnected(boolean var1) {
      this.driveConnected = var1;
      MassStorageDevice var2 = this.vmInterfaceInfo.getMassStorageDevice(4);
      var2.setConnected(var1);
   }

   public String getPortKey() {
      return this.portKey;
   }

   public void setPortKey(String var1) {
      this.portKey = var1;
   }

   public void setPort(int var1) {
      this.port = var1;
   }

   public int getPort() {
      return this.port;
   }

   public String getAvailableDrivesComboValue() {
      return this.availableDrivesComboValue;
   }

   public void setAvailableDrivesCombo1Value(String var1) {
      this.availableDrivesComboValue = var1;
   }

   public boolean isReadWriteCheckBoxSelected() {
      return this.readWriteCheckBoxSelected;
   }

   public void setReadWriteCheckBoxSelected(boolean var1) {
      this.readWriteCheckBoxSelected = var1;
   }

   public void setRFBProfile(RFBProfile var1) {
      this.rfbProfile = var1;
   }

   public RFBProfile getRFBProfile() {
      return this.rfbProfile;
   }

   public void setRFBView(RFBView var1) {
      this.rfbView = var1;
   }

   public RFBView getRFBView() {
      return this.rfbView;
   }

   public void setConnectedDrive(String var1) {
      this.connectedDrive = var1;
   }

   public String getConnectedDrive() {
      return this.connectedDrive;
   }

   public void resetComponentState() {
      this.connectedDrive = "";
      this.readWriteCheckBoxSelected = false;
   }

   public boolean getSwitchedFlag() {
      return this.isSwitched;
   }

   public void setSwitchedFlag(boolean var1) {
      this.isSwitched = var1;
   }

   public VMInterfaceInfo getVmInterfaceInfo() {
      return this.vmInterfaceInfo;
   }

   public VMCore getVmCore() {
      return this.vmcore;
   }
}
