package com.raritan.rrc.ui.applet;

import com.raritan.tools.ui.ScreenContext;
import java.applet.AppletContext;
import java.applet.AppletStub;
import java.net.MalformedURLException;
import java.net.URL;

public class EmbedAppletStub implements AppletStub {
   private EmbedAppletDataHolder holder;
   private EmbedAppletContext context;
   private URL connUrl;

   public EmbedAppletStub(ScreenContext var1, EmbedAppletDataHolder var2, URL var3) {
      this.holder = var2;
      this.context = new EmbedAppletContext(var1);
      this.connUrl = var3;
   }

   @Override
   public void appletResize(int var1, int var2) {
   }

   @Override
   public AppletContext getAppletContext() {
      return this.context;
   }

   @Override
   public URL getCodeBase() {
      try {
         int var1 = this.connUrl.getPort();
         return new URL(
            this.connUrl.getProtocol()
               + "://"
               + this.connUrl.getHost()
               + (var1 == -1 ? "" : ":" + var1)
               + "/"
               + (this.holder.getCodeBase() == null ? "" : this.holder.getCodeBase())
         );
      } catch (MalformedURLException var3) {
         return null;
      }
   }

   @Override
   public URL getDocumentBase() {
      try {
         return new URL(this.holder.getCodeBase());
      } catch (MalformedURLException var2) {
         return null;
      }
   }

   @Override
   public String getParameter(String var1) {
      return this.holder.getParameter(var1);
   }

   public void setParameter(String var1, String var2) {
      this.holder.setParameter(var1, var2);
   }

   @Override
   public boolean isActive() {
      return true;
   }
}
