package com.raritan.rrc.ui.commands;

import com.raritan.rrc.data.RRCRFPClient;
import com.raritan.tools.commands.AbstractCommand;
import com.raritan.tools.commands.CommandResult;
import com.raritan.tools.resources.RaritanPropertyResourceBundle;
import com.raritan.tools.resources.RaritanResourceBundle;
import com.raritan.tools.ui.ScreenContext;

public class CancelRFPOperationCommand extends AbstractCommand {
   private static final String COMMAND_KEY = "cancelRFPOperationCommand";
   private RaritanPropertyResourceBundle bundle = RaritanResourceBundle.getResourceBundle(this.scrContext.getLocale());

   public CancelRFPOperationCommand(ScreenContext var1) {
      super(var1);
   }

   @Override
   public String getKey() {
      return "cancelRFPOperationCommand";
   }

   @Override
   public CommandResult execute() {
      RRCRFPClient var1 = RRCRFPClient.getInstance();
      var1.setScreenContext(this.scrContext);
      var1.cancel();
      return new CommandResult(true, this.bundle.getString("rfpclient.operationcancelled.message"));
   }

   @Override
   public boolean isExecutable() {
      return true;
   }
}
