package com.raritan.rrc.ui.commands;

import com.raritan.rrc.ui.RRCScreenContext;
import com.raritan.tools.commands.AbstractCommand;
import com.raritan.tools.commands.CommandResult;
import com.raritan.tools.ui.ScreenContext;
import com.raritan.tools.ui.components.RaritanDesktopPane;
import com.raritan.tools.ui.panes.displays.ShellInternalFrame;
import java.beans.PropertyVetoException;
import java.util.HashMap;
import javax.swing.JInternalFrame;

public class CascadeWindowsCommand extends AbstractCommand {
   public static final String COMMAND_KEY = "cascadeWindowsCommand";

   public CascadeWindowsCommand(ScreenContext var1) {
      super(var1);
   }

   @Override
   public String getKey() {
      return "cascadeWindowsCommand";
   }

   @Override
   public CommandResult execute() {
      this.scrContext.getLogger().logTextDebug(" Started ");
      this.cascadeWindows();
      this.scrContext.getLogger().logTextDebug(" Finished ");
      return new CommandResult();
   }

   @Override
   public boolean isExecutable() {
      HashMap var1 = (HashMap)((RRCScreenContext)this.scrContext).getOpenPortsObservable().getComponent();
      return var1 != null && var1.size() > 0;
   }

   private void cascadeWindows() {
      RaritanDesktopPane var1 = (RaritanDesktopPane)this.scrContext.getPanelMediator().getParent();
      JInternalFrame[] var2 = var1.getAllFrames();
      JInternalFrame var3 = var1.getSelectedFrame();
      int var4 = 0;
      int var5 = 0;
      int var6 = var1.getWidth() / 2;
      int var7 = var1.getHeight() / 2;
      int var8 = 0;

      for (int var9 = var2.length - 1; var9 >= 0; var9--) {
         ShellInternalFrame var10 = (ShellInternalFrame)var2[var9];
         var10.removeInternalFrameListener(var10);
         if (var9 == var2.length - 1) {
            var8 = var2[var9].getHeight() - var2[var9].getContentPane().getHeight();
         }

         if (var2[var9].isIcon()) {
            try {
               var2[var9].setIcon(false);
            } catch (PropertyVetoException var13) {
            }
         }

         try {
            var2[var9].setMaximum(false);
            var2[var9].reshape(var4, var5, var6, var7);
            var2[var9].setSelected(false);
            var10.addInternalFrameListener(var10);
         } catch (PropertyVetoException var14) {
         }

         var4 += var8;
         var5 += var8;
         if (var4 + var6 > var1.getWidth() || var5 + var7 > var1.getHeight()) {
            var4 = 0;
            var5 = 0;
         }
      }

      if (var3 != null) {
         try {
            var3.setSelected(true);
         } catch (PropertyVetoException var12) {
         }
      }
   }
}
