package com.raritan.rrc.ui.commands;

import com.raritan.rrc.data.KvmPort;
import com.raritan.tools.commands.CommandResult;
import com.raritan.tools.ui.ScreenContext;
import javax.swing.Action;

public class ConnectAudioCommand extends AudioMenuCommand {
   public static final String COMMAND_KEY = "ConnectAudioCommand";

   public ConnectAudioCommand(ScreenContext var1) {
      super(var1);
   }

   @Override
   public String getKey() {
      return "ConnectAudioCommand";
   }

   @Override
   public boolean isExecutable() {
      KvmPort var1 = this.getKvmPort();
      return var1 != null && var1.isConnected() ? var1.getAudioAction().isEnabled() : false;
   }

   @Override
   protected Action getAction(KvmPort var1) {
      return var1.getConnectAudioAction();
   }

   @Override
   protected void doExecute(CommandResult var1) {
      KvmPort var2 = this.getKvmPort();
      if (var2 != null) {
         this.getAction(var2).actionPerformed(null);
      }

      var1.setIsSuccess(true);
   }

   public boolean isConnected() {
      KvmPort var1 = this.getKvmPort();
      return var1 != null ? (Boolean)this.getAction(var1).getValue("connected") : false;
   }
}
