package com.raritan.rrc.ui.commands;

import com.raritan.rrc.data.KvmPort;
import com.raritan.tools.commands.AbstractCommand;
import com.raritan.tools.commands.CommandResult;
import com.raritan.tools.resources.RaritanPropertyResourceBundle;
import com.raritan.tools.resources.RaritanResourceBundle;
import com.raritan.tools.ui.ScreenContext;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javaclientlib.clientlib.TRConnection;
import javax.swing.Timer;

public abstract class ConnectionCommand extends AbstractCommand {
   private RaritanPropertyResourceBundle bundle;
   private final int errCodeMask = 4095;
   private static boolean isBusy = false;
   private static Timer busyTimer = null;
   private static Integer busyBody = new Integer(0);

   public ConnectionCommand(ScreenContext var1) {
      super(var1);
      this.bundle = RaritanResourceBundle.getResourceBundle(this.scrContext.getLocale());
   }

   public void getTRSRVR_ErrorResult(CommandResult var1, KvmPort var2) {
      try {
         int var3 = TRConnection.getLastError();
         int var4 = var3 & -4096;
         var3 &= 4095;
         if (var3 != 12) {
            if (var4 == 0) {
               var4 = 536875008;
            }

            var1.setIsSuccess(false);
            String var5;
            byte var6;
            if (var4 == 536875008) {
               var5 = "TR_ERROR.";
               var6 = 24;
            } else {
               var5 = "TRLIB_ERROR.";
               var6 = 12;
            }

            if (var3 > var6) {
               var3 = var6;
            }

            var5 = var5 + Integer.toString(var3);
            var5 = "[" + var2.getDevice().getNameIP() + "]: " + this.bundle.getString(var5) + " (0x" + Integer.toHexString(var4 | var3) + ")";
            var1.setStatusMessage(var5);
         }
      } catch (Exception var7) {
      }
   }

   protected boolean setBusy(boolean var1) {
      synchronized (busyBody) {
         if (isBusy) {
            if (!var1) {
               if (busyTimer != null && busyTimer.isRunning()) {
                  busyTimer.stop();
               }

               isBusy = false;
            }

            return true;
         } else {
            if (var1) {
               isBusy = true;
               if (busyTimer != null && busyTimer.isRunning()) {
                  busyTimer.stop();
               }

               busyTimer = new Timer(5000, new ConnectionCommand.StayBusy());
               busyTimer.setRepeats(false);
               busyTimer.start();
            }

            return false;
         }
      }
   }

   private class StayBusy implements ActionListener {
      private StayBusy() {
      }

      @Override
      public void actionPerformed(ActionEvent var1) {
         ConnectionCommand.isBusy = false;
      }
   }
}
