package com.raritan.rrc.ui.commands;

import com.raritan.rrc.data.Device;
import com.raritan.rrc.data.Port;
import com.raritan.rrc.ui.RRCScreenContext;
import com.raritan.tools.commands.AbstractCommand;
import com.raritan.tools.commands.CommandResult;
import com.raritan.tools.ui.ScreenContext;
import java.util.ArrayList;

public class DeSelectPortViewCommand extends AbstractCommand {
   public static final String COMMAND_KEY = "deselectPortViewCommand";

   public DeSelectPortViewCommand(ScreenContext var1) {
      super(var1);
   }

   @Override
   public String getKey() {
      return "deselectPortViewCommand";
   }

   @Override
   public CommandResult execute() {
      Port var1 = (Port)this.getContext().getCommandParameter("selectedPortDevice");
      Object var2 = null;
      RRCScreenContext var3 = (RRCScreenContext)this.scrContext;
      if (var3.getSelectedDevicesObservable() != null && var3.getSelectedDevicesObservable().getComponent() != null) {
         ArrayList var4 = (ArrayList)var3.getSelectedDevicesObservable().getComponent();
         if (var4.get(0) != null) {
            var2 = (Device)var4.get(0);
            if (var2 instanceof Port) {
               Port var5 = (Port)var2;
               String var6 = var5 == null ? "null" : var5.getViewName();
               if (var1 != null && var1.getView() != null && var1.getViewName().equals(var6)) {
                  var1.firePropertyChange("DEVICE_DESELECTED", null, null);
               }
            }
         }
      }

      return new CommandResult(true, "");
   }

   @Override
   public boolean isExecutable() {
      return true;
   }
}
