package com.raritan.rrc.ui.commands;

import com.raritan.rrc.data.Device;
import com.raritan.rrc.data.KvmPort;
import com.raritan.rrc.ui.RRCScreenContext;
import com.raritan.rrc.ui.panes.DeviceView;
import com.raritan.tools.commands.AbstractCommand;
import com.raritan.tools.commands.CommandResult;
import com.raritan.tools.ui.ScreenContext;
import java.util.ArrayList;
import javaclientlib.utils.RRCLogger;

public class DoAbsoluteMouseCommand extends AbstractCommand {
   public static final String COMMAND_KEY = "absoluteMouseCommand";

   public DoAbsoluteMouseCommand(ScreenContext var1) {
      super(var1);
   }

   @Override
   public String getKey() {
      return "absoluteMouseCommand";
   }

   @Override
   public CommandResult execute() {
      this.scrContext.getLogger().logTextDebug(" Started ");
      RRCScreenContext var1 = (RRCScreenContext)this.scrContext;
      DeviceView var2 = var1.getSelectView();
      if (var2 != null) {
         var2.getCommandHandler().handleCommand(this, this.scrContext);
      } else {
         RRCLogger.log(100, 1, "View is null in DoAbsoluteMouseCommand");
      }

      this.scrContext.getLogger().logTextDebug(" Finished ");
      return new CommandResult();
   }

   @Override
   public boolean isExecutable() {
      Object var1 = null;
      if (this.scrContext != null
         && ((RRCScreenContext)this.scrContext).getSelectedDevicesObservable() != null
         && ((RRCScreenContext)this.scrContext).getSelectedDevicesObservable().getComponent() != null) {
         ArrayList var2 = (ArrayList)((RRCScreenContext)this.scrContext).getSelectedDevicesObservable().getComponent();
         if (var2.get(0) != null) {
            var1 = (Device)var2.get(0);
            if (((Device)var1).isConnected() && var1 instanceof KvmPort) {
               return ((KvmPort)var1).getDevice().getHandler().isAbsoluteMouseSupported();
            }
         }
      }

      return false;
   }

   public static void main(String[] var0) {
   }
}
