package com.raritan.rrc.ui.commands;

import com.raritan.rrc.data.IPReach;
import com.raritan.tools.commands.CancelButtonCommand;
import com.raritan.tools.commands.CommandResult;
import com.raritan.tools.ui.ScreenContext;

public class DoCancelLoginCommand extends CancelButtonCommand {
   public static final String COMMAND_KEY = "doCancelLoginCommand";

   public DoCancelLoginCommand(ScreenContext var1) {
      super(var1);
   }

   @Override
   public String getKey() {
      return "doCancelLoginCommand";
   }

   @Override
   public CommandResult execute() {
      CommandResult var1 = new CommandResult();
      IPReach var2 = (IPReach)this.cmdContext.getCommandParameter("devices");
      if (var2 == null) {
         return var1;
      } else {
         var2.setCancelLogin(true);
         if (var2.getDevPrefs() != null && var2.getDevPrefs().getModemConnector() != null && var2.isModemProfiled()) {
            var2.getDevPrefs().getModemConnector().rasHangUp();
            var2.getDevPrefs().setModemConnector(null);
            var2.setState("UNAVAILABLE");
         }

         if (var2.isConnected()) {
            var2.disconnect();
         }

         return var1;
      }
   }

   @Override
   public boolean isExecutable() {
      return true;
   }
}
