package com.raritan.rrc.ui.commands;

import com.raritan.rrc.data.KvmPort;
import com.raritan.rrc.data.USBProfile;
import com.raritan.rrc.data.USBProfilesInfo;
import com.raritan.rrc.ui.RRCScreenContext;
import com.raritan.rrc.ui.rfbbridge.RFBView;
import com.raritan.tools.commands.AbstractCommand;
import com.raritan.tools.commands.CommandResult;
import com.raritan.tools.ui.ScreenContext;
import java.util.ArrayList;

public class DoChangeActiveUSBProfileCommand extends AbstractCommand {
   public static final String COMMAND_KEY = "DoChangeActiveUSBProfileCommand";

   public DoChangeActiveUSBProfileCommand(ScreenContext var1) {
      super(var1);
   }

   @Override
   public String getKey() {
      return "DoChangeActiveUSBProfileCommand";
   }

   @Override
   public boolean isExecutable() {
      return true;
   }

   @Override
   public CommandResult execute() {
      ArrayList var1 = (ArrayList)((RRCScreenContext)this.scrContext).getSelectedDevicesObservable().getComponent();

      assert var1 != null;

      assert var1.size() > 0;

      assert var1.get(0) instanceof KvmPort;

      KvmPort var2 = (KvmPort)var1.get(0);
      USBProfilesInfo var3 = var2.getUsbProfilesInfo();

      assert var3 != null;

      USBProfile var4 = (USBProfile)this.getContext().getCommandParameter("SelectedUSBProfile");
      if (!var4.equals(var3.getActiveUSBProfile())) {
         RFBView var5 = (RFBView)var2.getView();
         var5.changeActiveUSBProfile(var4);
      }

      return new CommandResult(true, "");
   }
}
