package com.raritan.rrc.ui.commands;

import com.raritan.rrc.data.DeviceConnector;
import com.raritan.rrc.data.DevicePreferences;
import com.raritan.rrc.data.IPReach;
import com.raritan.rrc.ui.RRCScreenContext;
import com.raritan.rrc.util.MPCUtil;
import com.raritan.tools.commands.AbstractCommand;
import com.raritan.tools.commands.CommandResult;
import com.raritan.tools.resources.RaritanPropertyResourceBundle;
import com.raritan.tools.resources.RaritanResourceBundle;
import com.raritan.tools.ui.ScreenContext;
import javaclientlib.tr.TRLIB_USERINFO;
import javax.swing.SwingUtilities;

public class DoChangePasswordCommand extends AbstractCommand {
   public static final String COMMAND_KEY = "doChangePasswordCommand";
   private RaritanPropertyResourceBundle bundle = RaritanResourceBundle.getResourceBundle(this.scrContext.getLocale());

   public DoChangePasswordCommand(ScreenContext var1) {
      super(var1);
   }

   @Override
   public String getKey() {
      return "doChangePasswordCommand";
   }

   @Override
   public CommandResult execute() {
      this.scrContext.getLogger().logTextDebug(" Started ");
      CommandResult var1 = new CommandResult(true, "");
      String var2 = (String)this.cmdContext.getCommandParameter("userPassword");
      String var3 = (String)this.cmdContext.getCommandParameter("newPassword");
      String var4 = (String)this.cmdContext.getCommandParameter("confirmNewPassword");
      final IPReach var5 = (IPReach)this.cmdContext.getCommandParameter("devices");
      final Boolean var6 = (Boolean)this.cmdContext.getCommandParameter("userInvokedChangePassword");
      String var7 = "";
      if (var5.isModemProfiled()) {
         var7 = var5.getDevPrefs().getDescription();
      } else {
         var7 = var5.getName();
      }

      DeviceConnector var8 = var5.getDeviceConnector();
      String var9 = var8.getInetAddress().getHostAddress();
      if (!var3.equals(var4)) {
         var1.setStatusMessage("[" + var7 + " " + var9 + "]: " + this.bundle.getString("nonmatchingPasswords.error"));
         var1.setIsSuccess(false);
         return var1;
      } else {
         var1.setIsSuccess(var5.getHandler().changePassword(MPCUtil.isCCLaunched((RRCScreenContext)this.scrContext), var2, var3, var4));
         final String var10 = var1.isSuccess() ? var3 : var2;
         if (var1.isSuccess()) {
            var1.setStatusMessage("[" + var7 + " " + var9 + "]: " + this.bundle.getString("changePasswordSuccessful.text"));
            if (var5.isProfiled()) {
               DevicePreferences var11 = var5.getDevPrefs();
               var11.setPassword(var3);
               String var12 = var11.getNodeName();
               if (var12 != null) {
                  var11.exportPreferences(var12);
               }
            } else {
               TRLIB_USERINFO var14 = (TRLIB_USERINFO)((RRCScreenContext)this.scrContext).getUserInfoMap().get(var9);
               if (var14 != null) {
                  var14.setPassword(var10.getBytes());
               }
            }

            if (var6 != null && var6) {
               SwingUtilities.invokeLater(new Runnable() {
                  @Override
                  public void run() {
                     ShowLoginCommand var1x = new ShowLoginCommand(DoChangePasswordCommand.this.scrContext);
                     var1x.getContext().setCommandParameter("userInvokedChangePassword", var6);
                     var1x.getContext().setCommandParameter("password", var10);
                     if (var5.isModemProfiled()) {
                        var1x.getContext().setCommandParameter("ok_command", new DoDialCommand(DoChangePasswordCommand.this.scrContext));
                     } else {
                        var1x.getContext().setCommandParameter("ok_command", new DoLoginCommand(DoChangePasswordCommand.this.scrContext));
                     }

                     if (var1x.isExecutable()) {
                        CommandResult var2x = var1x.execute();
                        if (var2x.isSuccess()) {
                           DoChangePasswordCommand.this.scrContext.getPanelMediator().showPanel(var1x.getContext());
                        }
                     }
                  }
               });
            }

            this.scrContext.getLogger().logTextDebug(" Finished ");
            return var1;
         } else {
            var1.setStatusMessage("[" + var7 + " " + var9 + "]: " + this.bundle.getString("changePassword.error"));
            return var1;
         }
      }
   }

   @Override
   public boolean isExecutable() {
      return true;
   }
}
