package com.raritan.rrc.ui.commands;

import com.raritan.tools.commands.AbstractCommand;
import com.raritan.tools.commands.CommandResult;
import com.raritan.tools.ui.ScreenContext;
import java.awt.Toolkit;
import java.awt.datatransfer.Clipboard;
import java.awt.datatransfer.ClipboardOwner;
import java.awt.datatransfer.StringSelection;
import java.awt.datatransfer.Transferable;

public class DoCopyToClipboardCommand extends AbstractCommand implements ClipboardOwner {
   public static final String COMMAND_KEY = "doCopyToClipboardCommand";

   public DoCopyToClipboardCommand(ScreenContext var1) {
      super(var1);
   }

   @Override
   public String getKey() {
      return "doCopyToClipboardCommand";
   }

   @Override
   public CommandResult execute() {
      this.scrContext.getLogger().logTextDebug(" Started ");
      CommandResult var1 = new CommandResult();
      String var2 = (String)this.cmdContext.getCommandParameter("clipboardText");
      Clipboard var3 = Toolkit.getDefaultToolkit().getSystemClipboard();
      var3.setContents(new StringSelection(var2), this);
      this.scrContext.getLogger().logTextDebug(" Finished ");
      return var1;
   }

   @Override
   public boolean isExecutable() {
      return true;
   }

   @Override
   public void lostOwnership(Clipboard var1, Transferable var2) {
   }
}
