package com.raritan.rrc.ui.commands;

import com.raritan.rrc.data.KeyboardMacrosPreferences;
import com.raritan.rrc.ui.panes.KeyboardMacroPanel;
import com.raritan.rrc.ui.panes.mediator.RRCPanelMediator;
import com.raritan.rrc.util.StringUtils;
import com.raritan.tools.commands.AbstractCommand;
import com.raritan.tools.commands.CommandResult;
import com.raritan.tools.ui.ScreenContext;
import nn.pp.common.ApplicationContext;

public class DoDeleteKeyboardMacroCommand extends AbstractCommand {
   public static final String COMMAND_KEY = "doDeleteKeyboardMacroCommand";

   public DoDeleteKeyboardMacroCommand(ScreenContext var1) {
      super(var1);
   }

   @Override
   public String getKey() {
      return "doDeleteKeyboardMacroCommand";
   }

   @Override
   public CommandResult execute() {
      this.scrContext.getLogger().logTextDebug(" Started ");
      CommandResult var1 = new CommandResult();
      Object[] var2 = (Object[])this.cmdContext.getCommandParameter("keyboardMacroNameList");

      for (Object var6 : var2) {
         String var7 = var6.toString();
         if (StringUtils.notNullOrEmpty(var7)) {
            PopulateKeyboardMenuCommand.removeMacro(var7);
            KeyboardMacrosPreferences.deleteNode(var7);
            KeyboardMacroPanel var8 = ((RRCPanelMediator)this.scrContext.getPanelMediator()).getMainKeyboardMacroPanel();
            PopulateKeyboardMenuCommand.removeMacro(var7);
            var8.removeMacroFromList(var7);
         }
      }

      ApplicationContext.getInstance().setAttribute("HOTKEYMAP", null);
      this.scrContext.getLogger().logTextDebug(" Finished ");
      return var1;
   }

   @Override
   public boolean isExecutable() {
      return true;
   }
}
