package com.raritan.rrc.ui.commands;

import com.raritan.rrc.data.Device;
import com.raritan.rrc.data.DevicePreferences;
import com.raritan.rrc.data.IPReach;
import com.raritan.rrc.ui.RRCScreenContext;
import com.raritan.rrc.ui.controller.DeviceTreeController;
import com.raritan.tools.commands.AbstractCommand;
import com.raritan.tools.commands.CommandResult;
import com.raritan.tools.ui.ScreenContext;
import java.util.ArrayList;
import javaclientlib.utils.RRCLogger;

public class DoDeleteProfileCommand extends AbstractCommand {
   public static final String COMMAND_KEY = "doDeleteProfileCommand";

   public DoDeleteProfileCommand(ScreenContext var1) {
      super(var1);
   }

   @Override
   public String getKey() {
      return "doDeleteProfileCommand";
   }

   @Override
   public CommandResult execute() {
      this.scrContext.getLogger().logTextDebug(" Started ");
      ArrayList var1 = (ArrayList)((RRCScreenContext)this.scrContext).getSelectedDevicesObservable().getComponent();
      if (var1 != null && var1.size() > 0) {
         IPReach var2 = (IPReach)var1.get(0);
         String var3 = this.calculateExportKey(var2);
         if ("".equals(var3)) {
            RRCLogger.log(-1, 300, "Node name is null in Preferences");
            CommandResult var4 = new CommandResult();
            var4.setIsSuccess(false);
            return var4;
         }

         DeviceTreeController.getInstance((RRCScreenContext)this.scrContext).removeDevice(var2);
         DevicePreferences.deleteNode(this.calculateExportKey(var2));
      }

      this.scrContext.getLogger().logTextDebug(" Finished ");
      return new CommandResult();
   }

   @Override
   public boolean isExecutable() {
      ArrayList var1 = (ArrayList)((RRCScreenContext)this.scrContext).getSelectedDevicesObservable().getComponent();
      if (var1 != null && var1.size() > 0) {
         Device var2 = (Device)var1.get(0);
         if (var2 != null && var2.isProfiled() && !var2.isConnected()) {
            return true;
         }
      }

      return false;
   }

   private String calculateExportKey(IPReach var1) {
      String var2 = var1.getDevPrefs().getIp();
      if (var1.getDevPrefs().getConnectionType() == 2) {
         if (var1.getDevPrefs().getFindBy() == 1) {
            var2 = var1.getDevPrefs().getName();
         } else if (var1.getDevPrefs().getFindBy() == 2) {
            var2 = var1.getDevPrefs().getDnsName();
         }
      } else {
         var2 = var1.getDevPrefs().getPhone();
      }

      return var2;
   }
}
