package com.raritan.rrc.ui.commands;

import com.raritan.rrc.data.BladeChassis;
import com.raritan.rrc.data.Device;
import com.raritan.rrc.data.DeviceConnector;
import com.raritan.rrc.data.VirtualBladeChassis;
import com.raritan.rrc.ui.RRCScreenContext;
import com.raritan.rrc.util.MPCUtil;
import com.raritan.tools.commands.AbstractCommand;
import com.raritan.tools.commands.CommandResult;
import com.raritan.tools.resources.RaritanPropertyResourceBundle;
import com.raritan.tools.resources.RaritanResourceBundle;
import com.raritan.tools.ui.ScreenContext;
import java.util.ArrayList;

public class DoDisconnectCommand extends AbstractCommand {
   public static final String COMMAND_KEY = "doDisconnectCommand";
   private RaritanPropertyResourceBundle bundle = RaritanResourceBundle.getResourceBundle(this.scrContext.getLocale());

   public DoDisconnectCommand(ScreenContext var1) {
      super(var1);
   }

   @Override
   public String getKey() {
      return "doDisconnectCommand";
   }

   @Override
   public CommandResult execute() {
      this.scrContext.getLogger().logTextDebug(" Started ");
      CommandResult var1 = new CommandResult();
      boolean var2 = false;
      Device var3 = (Device)this.getContext().getCommandParameter("selectedPortDevice");
      if (var3 == null) {
         var3 = (Device)((ArrayList)((RRCScreenContext)this.scrContext).getSelectedDevicesObservable().getComponent()).get(0);
         var2 = true;
      }

      String var4 = "";
      if (var3.isModemProfiled()) {
         var4 = var3.getDevPrefs().getDescription();
      } else {
         var4 = var3.getName();
      }

      if (var3.isConnected()) {
         DeviceConnector var5 = var3.getDeviceConnector();
         String var6 = var5.getInetAddress().getHostAddress();
         var3.disconnect();
         var1.setStatusMessage("[" + var4 + " " + var6 + "]: " + this.bundle.getString("Device.message1020"));
         this.cmdContext.setCommandParameter("logtype", "[" + var3.getName() + " " + var6 + "]: " + this.bundle.getString("Device.message1020"));
         var1.setIsSuccess(true);
         ((RRCScreenContext)this.scrContext).resetDesktopFocus();
      }

      if (MPCUtil.isCCLaunched((RRCScreenContext)this.scrContext)) {
         this.scrContext.getApplication().disconnect();
      }

      this.scrContext.getLogger().logTextDebug(" Finished ");
      return var1;
   }

   @Override
   public boolean isExecutable() {
      ArrayList var1 = (ArrayList)((RRCScreenContext)this.scrContext).getSelectedDevicesObservable().getComponent();
      if (var1 != null && var1.size() > 0) {
         Device var2 = (Device)var1.get(0);
         if (var2 != null && var2.isConnected()) {
            if (!(var2 instanceof BladeChassis) && !(var2 instanceof VirtualBladeChassis)) {
               return true;
            }

            return false;
         }
      }

      return false;
   }
}
