package com.raritan.rrc.ui.commands;

import com.raritan.rrc.data.Device;
import com.raritan.rrc.data.Port;
import com.raritan.rrc.ui.RRCScreenContext;
import com.raritan.rrc.ui.panes.DeviceView;
import com.raritan.tools.commands.AbstractCommand;
import com.raritan.tools.commands.CommandResult;
import com.raritan.tools.ui.ScreenContext;
import java.util.ArrayList;

public class DoEnterOnscreenMenuCommand extends AbstractCommand {
   public static final String COMMAND_KEY = "doEnterOnscreenMenuCommand";

   public DoEnterOnscreenMenuCommand(ScreenContext var1) {
      super(var1);
   }

   @Override
   public String getKey() {
      return "doEnterOnscreenMenuCommand";
   }

   @Override
   public CommandResult execute() {
      this.scrContext.getLogger().logTextDebug(" Started ");
      CommandResult var1 = new CommandResult();

      try {
         Port var2 = ((RRCScreenContext)this.scrContext).getSelectedPort();
         DeviceView var3 = var2.getView();
         if (var3 != null) {
            var3.enterOnScreenMenu();
         }
      } catch (Exception var4) {
         var1.setIsSuccess(false);
         return var1;
      }

      this.scrContext.getLogger().logTextDebug(" Finished ");
      return new CommandResult();
   }

   @Override
   public boolean isExecutable() {
      Object var1 = null;
      if (this.scrContext != null
         && ((RRCScreenContext)this.scrContext).getSelectedDevicesObservable() != null
         && ((RRCScreenContext)this.scrContext).getSelectedDevicesObservable().getComponent() != null) {
         ArrayList var2 = (ArrayList)((RRCScreenContext)this.scrContext).getSelectedDevicesObservable().getComponent();
         if (var2.get(0) != null) {
            var1 = (Device)var2.get(0);
            if (var1 instanceof Port && ((Device)var1).isConnected()) {
               Port var3 = (Port)var1;
               if (var3.getDeviceClass().equalsIgnoreCase("KVM")) {
                  if (var3.getView() != null) {
                     return var3.getView().isCommandOperable(this);
                  }

                  return true;
               }
            }
         }
      }

      return false;
   }
}
