package com.raritan.rrc.ui.commands;

import com.raritan.rrc.data.KeyboardMacrosPreferences;
import com.raritan.tools.commands.AbstractCommand;
import com.raritan.tools.commands.CommandResult;
import com.raritan.tools.resources.RaritanPropertyResourceBundle;
import com.raritan.tools.resources.RaritanResourceBundle;
import com.raritan.tools.ui.ScreenContext;
import java.io.File;
import java.util.TreeMap;

public class DoExportSelectedMacrosCommand extends AbstractCommand {
   public static final String COMMAND_KEY = "doExportSelectedMacrosCommand";
   private static RaritanPropertyResourceBundle bundle;

   public DoExportSelectedMacrosCommand(ScreenContext var1) {
      super(var1);
      bundle = RaritanResourceBundle.getResourceBundle(this.scrContext.getLocale());
   }

   @Override
   public String getKey() {
      return "doExportSelectedMacrosCommand";
   }

   @Override
   public boolean isExecutable() {
      return true;
   }

   @Override
   public CommandResult execute() {
      TreeMap var1 = (TreeMap)this.getContext().getCommandParameter("importExportSelectedMacros");
      File var2 = (File)this.getContext().getCommandParameter("exportSelectedMacrosFilename");
      if (var1 == null) {
         System.out.println("Macros TreeMap is null");
         return new CommandResult(false, "Something has gone wrong");
      } else {
         return KeyboardMacrosPreferences.doExport(var1, var2, bundle);
      }
   }
}
