package com.raritan.rrc.ui.commands;

import com.raritan.rrc.data.KeyboardMacrosPreferences;
import com.raritan.tools.commands.AbstractCommand;
import com.raritan.tools.commands.CommandResult;
import com.raritan.tools.resources.RaritanPropertyResourceBundle;
import com.raritan.tools.resources.RaritanResourceBundle;
import com.raritan.tools.ui.ScreenContext;
import com.raritan.tools.ui.panes.displays.AbstractDisplay;
import java.util.Arrays;
import java.util.TreeMap;
import javax.swing.JOptionPane;

public class DoImportSelectedMacrosCommand extends AbstractCommand {
   public static final String COMMAND_KEY = "doImportSelectedMacrosCommand";
   private static final int EXIT_DIALOG = -1;
   private static final int YES = 0;
   private static final int YES_TO_ALL = 1;
   private static final int NO = 2;
   private static final int NO_TO_ALL = 3;
   private static final int RENAME = 4;
   private static final int CANCEL = 5;
   private static RaritanPropertyResourceBundle bundle;

   public DoImportSelectedMacrosCommand(ScreenContext var1) {
      super(var1);
      bundle = RaritanResourceBundle.getResourceBundle(this.scrContext.getLocale());
   }

   @Override
   public String getKey() {
      return "doImportSelectedMacrosCommand";
   }

   @Override
   public boolean isExecutable() {
      return true;
   }

   private int confirmOverwrite(String var1) {
      Object[] var2 = new Object[]{
         bundle.getString("Yes"),
         bundle.getString("yes.to.all"),
         bundle.getString("No"),
         bundle.getString("no.to.all"),
         bundle.getString("macro.import.rename.button"),
         bundle.getString("generic.dialog.cancel.text")
      };
      JOptionPane var3 = new JOptionPane(
         bundle.getString("macro.import.rename.alert").replaceFirst("\n\n", ":\n\n" + var1 + "\n\n") + "\n ", 1, 2, null, var2, var2[0]
      );
      Object var4 = this.scrContext
         .getPanelMediator()
         .showDialogOnTop(
            var3, bundle.getString("macro.import.title"), (AbstractDisplay)this.getContext().getCommandParameter("importExportSelectedMacrosCommandParent")
         );
      return Arrays.asList(var2).indexOf(var4);
   }

   private String renameMacro(String var1) {
      JOptionPane var2 = new JOptionPane(bundle.getString("macro.import.rename.message") + ":\n", -1, 2);
      var2.setWantsInput(true);
      var2.setInitialSelectionValue(var1);
      Object var3 = this.scrContext
         .getPanelMediator()
         .showDialogOnTop(
            var2,
            bundle.getString("macro.import.rename.title"),
            (AbstractDisplay)this.getContext().getCommandParameter("importExportSelectedMacrosCommandParent")
         );
      return Integer.valueOf(0).equals(var3) ? var2.getInputValue().toString() : null;
   }

   @Override
   public CommandResult execute() {
      TreeMap var1 = (TreeMap)this.getContext().getCommandParameter("importExportSelectedMacros");
      if (var1 == null) {
         System.out.println("Macros TreeMap is null");
      } else if (var1.size() < 1) {
         System.out.println("No macros were selected");
      } else {
         KeyboardMacrosPreferences var3 = new KeyboardMacrosPreferences();
         boolean[] var4 = new boolean[10];

         for (int var2 = 0; var2 < 10; var2++) {
            var4[var2] = false;
         }

         String[] var5 = KeyboardMacrosPreferences.returnNodes();

         for (int var11 = 0; var11 < var5.length; var11++) {
            var3.importSinglePreferenceInfo(var5[var11]);
            if (var3.getHotKeyCombination() != -1) {
               var4[var3.getHotKeyCombination()] = true;
            }
         }

         boolean var6 = false;
         boolean var7 = false;
         var5 = var1.keySet().toArray(new String[0]);
         int var8 = -1;

         for (int var12 = 0; var12 < var5.length; var12++) {
            if (KeyboardMacrosPreferences.containsNode(var5[var12])) {
               if (var7) {
                  continue;
               }

               if (!var6) {
                  var8 = this.confirmOverwrite(var5[var12]);
                  if (var8 == -1 || var8 == 5) {
                     break;
                  }

                  if (var8 == 2) {
                     continue;
                  }

                  if (var8 == 3) {
                     var7 = true;
                     continue;
                  }

                  if (var8 == 1) {
                     var6 = true;
                  } else if (var8 == 4) {
                     String var9 = var5[var12];

                     while (true) {
                        var9 = this.renameMacro(var5[var12]);
                        if (var9 == null || !KeyboardMacrosPreferences.containsNode(var9)) {
                           if (var9 != null && var9.length() >= 1) {
                              var3 = (KeyboardMacrosPreferences)var1.get(var5[var12]);
                              var1.remove(var5[var12]);
                              var5[var12] = var9;
                              var3.setMacroName(var9);
                              var1.put(var5[var12], var3);
                           } else {
                              var9 = var5[var12];
                              var12--;
                           }
                           break;
                        }

                        JOptionPane var10 = new JOptionPane(bundle.getString("macro.import.renamed.exists.alert").replaceFirst("%M", var9), 2);
                        this.scrContext
                           .getPanelMediator()
                           .showDialogOnTop(
                              var10,
                              bundle.getString("macro.import.renamed.exists.title"),
                              (AbstractDisplay)this.getContext().getCommandParameter("importExportSelectedMacrosCommandParent")
                           );
                     }
                  }
               }
            }

            var3 = (KeyboardMacrosPreferences)var1.get(var5[var12]);
            if (var3.getHotKeyCombination() > -1 && var4[var3.getHotKeyCombination()]) {
               var3.setHotKeyCombination(-1);
            }

            var3.exportPreferences(var5[var12], false);
         }

         KeyboardMacrosPreferences.exportPreferences();
      }

      return new CommandResult(true, bundle.getString("macro.import.success"));
   }
}
