package com.raritan.rrc.ui.commands;

import com.raritan.rrc.data.Port;
import com.raritan.rrc.ui.RRCScreenContext;
import com.raritan.rrc.ui.panes.DeviceView;
import com.raritan.tools.commands.AbstractCommand;
import com.raritan.tools.commands.CommandResult;
import com.raritan.tools.ui.ScreenContext;
import javaclientlib.utils.RRCLogger;

public class DoModifyConnectionPropertiesCommand extends AbstractCommand {
   public static final String COMMAND_KEY = "doModifyConnectionPropertiesCommand";

   public DoModifyConnectionPropertiesCommand(ScreenContext var1) {
      super(var1);
   }

   @Override
   public String getKey() {
      return "doModifyConnectionPropertiesCommand";
   }

   @Override
   public CommandResult execute() {
      this.scrContext.getLogger().logTextDebug(" Started ");
      CommandResult var1 = new CommandResult();
      Port var2 = ((RRCScreenContext)this.scrContext).getSelectedPort();
      if (var2 != null && var2.isConnected() && var2.getDeviceClass().equals("KVM")) {
         DeviceView var3 = var2.getView();
         if (var3 != null) {
            var3.getCommandHandler().handleCommand(this, this.scrContext);
         } else {
            RRCLogger.log(100, 1, "View is null in DoModifyConnectionPropertiesCommand");
         }
      }

      this.scrContext.getLogger().logTextDebug(" Finished ");
      return var1;
   }

   @Override
   public boolean isExecutable() {
      return true;
   }
}
