package com.raritan.rrc.ui.commands;

import com.raritan.rrc.data.Device;
import com.raritan.rrc.data.DeviceConnector;
import com.raritan.rrc.data.IPReach;
import com.raritan.rrc.ui.RRCScreenContext;
import com.raritan.rrc.ui.controller.DeviceTreeController;
import com.raritan.tools.commands.AbstractCommand;
import com.raritan.tools.commands.CommandResult;
import com.raritan.tools.ui.ScreenContext;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ArrayList;
import javax.swing.Timer;

public class DoRestartDeviceCommand extends AbstractCommand {
   public static final String COMMAND_KEY = "doRestartDeviceCommand";

   public DoRestartDeviceCommand(ScreenContext var1) {
      super(var1);
   }

   @Override
   public String getKey() {
      return "doRestartDeviceCommand";
   }

   @Override
   public CommandResult execute() {
      this.scrContext.getLogger().logTextDebug(" Started ");
      CommandResult var1 = new CommandResult();
      IPReach var2 = null;
      ArrayList var3 = (ArrayList)((RRCScreenContext)this.scrContext).getSelectedDevicesObservable().getComponent();
      if (var3 != null && var3.size() > 0) {
         var2 = (IPReach)var3.get(0);
      }

      if (var2 == null) {
         var2 = (IPReach)this.cmdContext.getCommandParameter("devices");
      }

      if (var2 == null) {
         var1.setStatusMessage("Error restarting the device");
         var1.setIsSuccess(false);
         return var1;
      } else {
         DeviceConnector var4 = var2.getDeviceConnector();
         if (var4 != null) {
            var4.resetTR();
            final DeviceTreeController var5 = DeviceTreeController.getInstance((RRCScreenContext)this.scrContext);
            var2.disconnect();
            if (var2.isProfiled()) {
               var2.setState("UNAVAILABLE");
            }

            Timer var6 = new Timer(5000, new ActionListener() {
               @Override
               public void actionPerformed(ActionEvent var1) {
                  var5.refreshTree();
               }
            });
            var6.setRepeats(false);
            var6.start();
         }

         return new CommandResult();
      }
   }

   @Override
   public boolean isExecutable() {
      ArrayList var1 = (ArrayList)((RRCScreenContext)this.scrContext).getSelectedDevicesObservable().getComponent();
      if (var1 != null && var1.size() > 0) {
         Device var2 = (Device)var1.get(0);
         if (var2 != null && var2 instanceof IPReach && var2.isConnected() && ((IPReach)var2).isAdministrator()) {
            return true;
         }
      }

      return false;
   }
}
