package com.raritan.rrc.ui.commands;

import com.raritan.rrc.data.Device;
import com.raritan.rrc.data.KeyboardMacrosPreferences;
import com.raritan.rrc.data.Port;
import com.raritan.rrc.ui.RRCScreenContext;
import com.raritan.rrc.ui.panes.DeviceView;
import com.raritan.tools.commands.AbstractCommand;
import com.raritan.tools.commands.CommandResult;
import com.raritan.tools.ui.ScreenContext;
import java.util.ArrayList;
import javaclientlib.utils.RRCLogger;

public class DoRunKeyboardMacroCommand extends AbstractCommand {
   public static final String COMMAND_KEY = "doRunKeyboardMacroCommand";

   public DoRunKeyboardMacroCommand(ScreenContext var1) {
      super(var1);
   }

   @Override
   public String getKey() {
      return "doRunKeyboardMacroCommand";
   }

   @Override
   public CommandResult execute() {
      this.scrContext.getLogger().logTextDebug(" Started ");
      CommandResult var1 = new CommandResult();
      Port var2 = ((RRCScreenContext)this.scrContext).getSelectedPort();
      if (var2 == null) {
         var1.setIsSuccess(false);
         return var1;
      } else {
         DeviceView var3 = var2.getView();
         String var4 = (String)this.cmdContext.getCommandParameter("keyboardMacroName");
         if (var3 != null) {
            KeyboardMacrosPreferences var5 = new KeyboardMacrosPreferences();
            var5.importPreferences(var4);
            var1.setIsSuccess(var3.macroMenuActionPerformed(var5.getMacroSequence()));
         } else {
            RRCLogger.log(100, 1, "View is null in DoRunKeyboardMacroCommand");
         }

         this.scrContext.getLogger().logTextDebug(" Finished ");
         return var1;
      }
   }

   @Override
   public boolean isExecutable() {
      Object var1 = null;
      if (this.scrContext != null
         && ((RRCScreenContext)this.scrContext).getSelectedDevicesObservable() != null
         && ((RRCScreenContext)this.scrContext).getSelectedDevicesObservable().getComponent() != null) {
         ArrayList var2 = (ArrayList)((RRCScreenContext)this.scrContext).getSelectedDevicesObservable().getComponent();
         if (var2.get(0) != null) {
            var1 = (Device)var2.get(0);
            if (var1 instanceof Port && ((Device)var1).isConnected()) {
               Port var3 = (Port)var1;
               if (var3.getDeviceClass().equalsIgnoreCase("KVM")) {
                  return true;
               }
            }
         }
      }

      return false;
   }
}
