package com.raritan.rrc.ui.commands;

import com.raritan.rrc.data.Device;
import com.raritan.rrc.data.RRCRFPClient;
import com.raritan.rrc.ui.RRCScreenContext;
import com.raritan.tools.commands.AbstractCommand;
import com.raritan.tools.commands.CommandResult;
import com.raritan.tools.resources.RaritanPropertyResourceBundle;
import com.raritan.tools.resources.RaritanResourceBundle;
import com.raritan.tools.ui.ScreenContext;
import com.raritan.tools.ui.components.CommonPopups;
import java.io.File;
import java.util.ArrayList;
import javaclientlib.clientlib.TRConnection;

public class DoSaveDeviceConfigurationCommand extends AbstractCommand {
   public static final String COMMAND_KEY = "saveDeviceConfigurationCommand";
   private RaritanPropertyResourceBundle bundle = RaritanResourceBundle.getResourceBundle(this.scrContext.getLocale());
   private File file;

   public DoSaveDeviceConfigurationCommand(ScreenContext var1) {
      super(var1);
   }

   @Override
   public String getKey() {
      return "saveDeviceConfigurationCommand";
   }

   @Override
   public CommandResult execute() {
      this.scrContext.getLogger().logTextDebug(" Started ");
      CommandResult var1 = new CommandResult();

      try {
         this.file = (File)this.getContext().getCommandParameter("selectedFile");
         if (this.file != null) {
            new DoSaveDeviceConfigurationCommand.DoSaveDeviceConfigThread().start();
         }

         var1.setIsSuccess(true);
      } catch (Exception var3) {
         var1.setIsSuccess(false);
         var1.setStatusMessage(this.bundle.getString("error.do.savedeviceconfig") + " " + var3.getMessage());
         this.scrContext.getLogger().logTextDebug(var3.getMessage());
      }

      this.scrContext.getLogger().logTextDebug(" Finished ");
      return var1;
   }

   @Override
   public boolean isExecutable() {
      return true;
   }

   private class DoSaveDeviceConfigThread extends Thread {
      protected DoSaveDeviceConfigThread() {
         super("DoSaveDeviceConfigThread");
      }

      @Override
      public void run() {
         ArrayList var1 = (ArrayList)((RRCScreenContext)DoSaveDeviceConfigurationCommand.this.scrContext).getSelectedDevicesObservable().getComponent();
         Device var2 = (Device)var1.get(0);
         DoSaveDeviceConfigurationCommand.this.scrContext
            .getLogger()
            .logStatus(DoSaveDeviceConfigurationCommand.this.bundle.getString("info.do.savedeviceconfig"));
         RRCRFPClient var3 = RRCRFPClient.getInstance();
         var3.setScreenContext(DoSaveDeviceConfigurationCommand.this.scrContext);

         try {
            var3.setShowProgress(true);
            boolean var4 = var3.receive("DeviceAndPortConfigFile", DoSaveDeviceConfigurationCommand.this.file.getPath(), 0);
            if (!var4) {
               CommonPopups.showInfoDialog(
                  DoSaveDeviceConfigurationCommand.this.bundle.getString("confirmation.dialog.do.savedeviceconfig.title"),
                  var3.showError(TRConnection.getLastError()),
                  null,
                  DoSaveDeviceConfigurationCommand.this.scrContext
               );
               DoSaveDeviceConfigurationCommand.this.scrContext
                  .getLogger()
                  .logStatus(DoSaveDeviceConfigurationCommand.this.bundle.getString("error.do.savedeviceconfig"));
               DoSaveDeviceConfigurationCommand.this.scrContext
                  .getLogger()
                  .logTextInfo("[" + var2.getNameIP() + "]: " + DoSaveDeviceConfigurationCommand.this.bundle.getString("error.do.savedeviceconfig"));
               return;
            }

            DoSaveDeviceConfigurationCommand.this.scrContext
               .getLogger()
               .logStatus(DoSaveDeviceConfigurationCommand.this.bundle.getString("success.do.savedeviceconfig"));
            DoSaveDeviceConfigurationCommand.this.scrContext
               .getLogger()
               .logTextInfo("[" + var2.getNameIP() + "]: " + DoSaveDeviceConfigurationCommand.this.bundle.getString("success.do.savedeviceconfig"));
            CommonPopups.showInfoDialog(
               DoSaveDeviceConfigurationCommand.this.bundle.getString("confirmation.dialog.do.savedeviceconfig.title"),
               DoSaveDeviceConfigurationCommand.this.bundle.getString("success.do.savedeviceconfig"),
               null,
               DoSaveDeviceConfigurationCommand.this.scrContext
            );
         } catch (Exception var5) {
            DoSaveDeviceConfigurationCommand.this.scrContext.getLogger().logTextDebug(" " + var5.getMessage());
            DoSaveDeviceConfigurationCommand.this.scrContext
               .getLogger()
               .logStatus(DoSaveDeviceConfigurationCommand.this.bundle.getString("error.ioexception.savedeviceconfig") + var5.getMessage());
         }
      }
   }
}
