package com.raritan.rrc.ui.commands;

import com.raritan.rrc.data.Device;
import com.raritan.rrc.data.DeviceConnector;
import com.raritan.rrc.data.RRCRFPClient;
import com.raritan.rrc.ui.RRCScreenContext;
import com.raritan.tools.commands.AbstractCommand;
import com.raritan.tools.commands.CommandResult;
import com.raritan.tools.resources.RaritanPropertyResourceBundle;
import com.raritan.tools.resources.RaritanResourceBundle;
import com.raritan.tools.ui.ScreenContext;
import com.raritan.tools.ui.components.CommonPopups;
import java.io.File;
import java.util.ArrayList;
import javaclientlib.clientlib.TRConnection;

public class DoSaveDiagnosticLogCommand extends AbstractCommand {
   public static final String COMMAND_KEY = "saveDiagnosticLogCommand";
   private RaritanPropertyResourceBundle bundle = RaritanResourceBundle.getResourceBundle(this.scrContext.getLocale());
   private File file;

   public DoSaveDiagnosticLogCommand(ScreenContext var1) {
      super(var1);
   }

   @Override
   public String getKey() {
      return "saveDiagnosticLogCommand";
   }

   @Override
   public CommandResult execute() {
      this.scrContext.getLogger().logTextDebug(" Started ");
      CommandResult var1 = new CommandResult();
      var1.setIsSuccess(true);
      ArrayList var2 = (ArrayList)((RRCScreenContext)this.scrContext).getSelectedDevicesObservable().getComponent();
      Device var3 = (Device)var2.get(0);

      try {
         this.file = (File)this.getContext().getCommandParameter("selectedFile");
         if (this.file == null) {
            var1.setIsSuccess(false);
            var1.setStatusMessage(this.bundle.getString("filebrowser.save.cannotopen"));
            return var1;
         }

         new DoSaveDiagnosticLogCommand.DoSaveDiagnosticLogThread().start();
         var1.setIsSuccess(true);
         var1.setIsSuccess(true);
      } catch (Exception var5) {
         var1.setIsSuccess(false);
         var1.setStatusMessage("[" + var3.getNameIP() + "]: " + this.bundle.getString("error.do.savediagnosticlog") + " " + var5.getMessage());
         this.scrContext.getLogger().logTextDebug("[" + var3.getNameIP() + "]: " + var5.getMessage());
      }

      this.scrContext.getLogger().logTextDebug(" Finished ");
      return var1;
   }

   @Override
   public boolean isExecutable() {
      return true;
   }

   private class DoSaveDiagnosticLogThread extends Thread {
      protected DoSaveDiagnosticLogThread() {
         super("DoSaveDiagnosticLogThread");
      }

      @Override
      public void run() {
         RRCRFPClient var1 = RRCRFPClient.getInstance();
         Device var2 = ((DeviceConnector)var1.getTRConnection()).getDevice();
         var1.setScreenContext(DoSaveDiagnosticLogCommand.this.scrContext);

         try {
            var1.setShowProgress(false);
            boolean var3 = var1.receive("DebugLogFile", DoSaveDiagnosticLogCommand.this.file.getPath(), 0);
            if (!var3) {
               CommonPopups.showInfoDialog(
                  DoSaveDiagnosticLogCommand.this.bundle.getString("confirmation.dialog.do.savediagnosticlog.title"),
                  var1.showError(TRConnection.getLastError()),
                  null,
                  DoSaveDiagnosticLogCommand.this.scrContext
               );
               DoSaveDiagnosticLogCommand.this.scrContext.getLogger().logStatus(DoSaveDiagnosticLogCommand.this.bundle.getString("error.do.savediagnosticlog"));
               DoSaveDiagnosticLogCommand.this.scrContext
                  .getLogger()
                  .logTextInfo("[" + var2.getNameIP() + "]: " + DoSaveDiagnosticLogCommand.this.bundle.getString("error.do.savediagnosticlog"));
               return;
            }

            DoSaveDiagnosticLogCommand.this.scrContext.getLogger().logStatus(DoSaveDiagnosticLogCommand.this.bundle.getString("success.do.savediagnosticlog"));
            DoSaveDiagnosticLogCommand.this.scrContext
               .getLogger()
               .logTextInfo("[" + var2.getNameIP() + "]: " + DoSaveDiagnosticLogCommand.this.bundle.getString("success.do.savediagnosticlog"));
            CommonPopups.showInfoDialog(
               DoSaveDiagnosticLogCommand.this.bundle.getString("confirmation.dialog.do.savediagnosticlog.title"),
               DoSaveDiagnosticLogCommand.this.bundle.getString("success.do.savediagnosticlog"),
               null,
               DoSaveDiagnosticLogCommand.this.scrContext
            );
         } catch (Exception var4) {
            DoSaveDiagnosticLogCommand.this.scrContext.getLogger().logTextDebug(" " + var4.getMessage());
            DoSaveDiagnosticLogCommand.this.scrContext
               .getLogger()
               .logStatus(DoSaveDiagnosticLogCommand.this.bundle.getString("error.do.savediagnosticlog") + var4.getMessage());
         }
      }
   }
}
