package com.raritan.rrc.ui.commands;

import com.raritan.rrc.data.Device;
import com.raritan.rrc.data.RRCRFPClient;
import com.raritan.rrc.ui.RRCScreenContext;
import com.raritan.tools.commands.AbstractCommand;
import com.raritan.tools.commands.CommandResult;
import com.raritan.tools.resources.RaritanPropertyResourceBundle;
import com.raritan.tools.resources.RaritanResourceBundle;
import com.raritan.tools.ui.ScreenContext;
import com.raritan.tools.ui.components.CommonPopups;
import java.io.File;
import java.util.ArrayList;
import javaclientlib.clientlib.TRConnection;

public class DoSaveUserConfigurationCommand extends AbstractCommand {
   public static final String COMMAND_KEY = "doSaveUserConfigurationCommand";
   private RaritanPropertyResourceBundle bundle = RaritanResourceBundle.getResourceBundle(this.scrContext.getLocale());
   private File file;

   public DoSaveUserConfigurationCommand(ScreenContext var1) {
      super(var1);
   }

   @Override
   public String getKey() {
      return "doSaveUserConfigurationCommand";
   }

   @Override
   public CommandResult execute() {
      this.scrContext.getLogger().logTextDebug(" Started ");
      CommandResult var1 = new CommandResult();

      try {
         this.file = (File)this.getContext().getCommandParameter("selectedFile");
         new DoSaveUserConfigurationCommand.DoSaveUserConfigThread().start();
         var1.setIsSuccess(true);
      } catch (Exception var3) {
         var1.setIsSuccess(false);
         this.scrContext.getLogger().logTextDebug(var3.getMessage());
      }

      this.scrContext.getLogger().logTextDebug(" Finished ");
      return var1;
   }

   @Override
   public boolean isExecutable() {
      return true;
   }

   private class DoSaveUserConfigThread extends Thread {
      protected DoSaveUserConfigThread() {
         super("DoSaveUserConfigThread");
      }

      @Override
      public void run() {
         ArrayList var1 = (ArrayList)((RRCScreenContext)DoSaveUserConfigurationCommand.this.scrContext).getSelectedDevicesObservable().getComponent();
         Device var2 = (Device)var1.get(0);
         DoSaveUserConfigurationCommand.this.scrContext.getLogger().logStatus(DoSaveUserConfigurationCommand.this.bundle.getString("info.do.saveuserconfig"));
         RRCRFPClient var3 = RRCRFPClient.getInstance();
         var3.setScreenContext(DoSaveUserConfigurationCommand.this.scrContext);

         try {
            var3.setShowProgress(true);
            boolean var4 = var3.receive("UserConfigFile", DoSaveUserConfigurationCommand.this.file.getPath(), 0);
            if (!var4) {
               CommonPopups.showInfoDialog(
                  DoSaveUserConfigurationCommand.this.bundle.getString("confirmation.dialog.do.saveuserconfig.title"),
                  var3.showError(TRConnection.getLastError()),
                  null,
                  DoSaveUserConfigurationCommand.this.scrContext
               );
               DoSaveUserConfigurationCommand.this.scrContext
                  .getLogger()
                  .logStatus(DoSaveUserConfigurationCommand.this.bundle.getString("error.do.saveuserconfig"));
               DoSaveUserConfigurationCommand.this.scrContext
                  .getLogger()
                  .logTextInfo("[" + var2.getNameIP() + "]: " + DoSaveUserConfigurationCommand.this.bundle.getString("error.do.saveuserconfig"));
               return;
            }

            CommonPopups.showInfoDialog(
               DoSaveUserConfigurationCommand.this.bundle.getString("confirmation.dialog.do.saveuserconfig.title"),
               DoSaveUserConfigurationCommand.this.bundle.getString("success.do.saveuserconfig"),
               null,
               DoSaveUserConfigurationCommand.this.scrContext
            );
            DoSaveUserConfigurationCommand.this.scrContext
               .getLogger()
               .logStatus(DoSaveUserConfigurationCommand.this.bundle.getString("success.do.saveuserconfig"));
            DoSaveUserConfigurationCommand.this.scrContext
               .getLogger()
               .logTextInfo("[" + var2.getNameIP() + "]: " + DoSaveUserConfigurationCommand.this.bundle.getString("success.do.saveuserconfig"));
         } catch (Exception var5) {
            DoSaveUserConfigurationCommand.this.scrContext.getLogger().logTextDebug(" " + var5.getMessage());
            DoSaveUserConfigurationCommand.this.scrContext
               .getLogger()
               .logStatus(DoSaveUserConfigurationCommand.this.bundle.getString("error.do.saveuserconfig") + var5.getMessage());
         }
      }
   }
}
