package com.raritan.rrc.ui.commands;

import com.raritan.rrc.data.Device;
import com.raritan.rrc.data.Port;
import com.raritan.rrc.ui.RRCScreenContext;
import com.raritan.tools.commands.AbstractCommand;
import com.raritan.tools.commands.CommandResult;
import com.raritan.tools.ui.ScreenContext;
import java.util.ArrayList;
import java.util.Hashtable;
import java.util.Vector;
import nn.pp.common.CommonFunctions;
import nn.pp.common.ui.helpers.IKVMTargetViewer;
import nn.pp.rccore.impl.keyboard.CharTranslatorConstants;

public class DoSendTextToTargetCommand extends AbstractCommand implements CharTranslatorConstants {
   public static final String COMMAND_KEY = "doSendTextToTargetCommand";
   private Hashtable<Character, Vector<Integer>> charMappings;

   public DoSendTextToTargetCommand(ScreenContext var1) {
      super(var1);
   }

   @Override
   public String getKey() {
      return "doSendTextToTargetCommand";
   }

   @Override
   protected void doExecute(CommandResult var1) {
      this.scrContext.getLogger().logTextDebug(" Started ");
      Port var2 = ((RRCScreenContext)this.scrContext).getSelectedPort();
      if (var2 == null) {
         var1.setIsSuccess(false);
         var1.setStatusMessage("Unable to send text to target because getSelectedPort returned null.");
      } else {
         IKVMTargetViewer var3 = (IKVMTargetViewer)var2.getView();
         if (var3 != null) {
            CommonFunctions.sendTextToTarget(
               (Integer)this.getContext().getCommandParameter("sendTextToTargetLanguageSelection"),
               (String)this.getContext().getCommandParameter("sendTextToTarget"),
               var3
            );
         } else {
            var1.setIsSuccess(false);
            var1.setStatusMessage("Unable to send text to target because device.getView() returned null.");
         }
      }
   }

   @Override
   public boolean isExecutable() {
      Object var1 = null;
      if (this.scrContext != null
         && ((RRCScreenContext)this.scrContext).getSelectedDevicesObservable() != null
         && ((RRCScreenContext)this.scrContext).getSelectedDevicesObservable().getComponent() != null) {
         ArrayList var2 = (ArrayList)((RRCScreenContext)this.scrContext).getSelectedDevicesObservable().getComponent();
         if (var2.get(0) != null) {
            var1 = (Device)var2.get(0);
            if (var1 instanceof Port && ((Device)var1).isConnected()) {
               Port var3 = (Port)var1;
               if (var3.getDeviceClass().equalsIgnoreCase("KVM") && var3.getDeviceConnector() != null) {
                  return var3.getDeviceConnector().isKX2Device();
               }
            }
         }
      }

      return false;
   }
}
