package com.raritan.rrc.ui.commands;

import com.raritan.rrc.data.Device;
import com.raritan.rrc.data.SerialPort;
import com.raritan.rrc.ui.RRCScreenContext;
import com.raritan.tools.commands.AbstractCommand;
import com.raritan.tools.commands.CommandResult;
import com.raritan.tools.ui.ScreenContext;
import java.util.ArrayList;
import javaclientlib.tr.TRSRVR_SERIAL_PARAMS;

public class DoSerialParametersCommand extends AbstractCommand {
   public static final String COMMAND_KEY = "doSerialParametersCommand";

   public DoSerialParametersCommand(ScreenContext var1) {
      super(var1);
   }

   @Override
   public String getKey() {
      return "doSerialParametersCommand";
   }

   @Override
   public CommandResult execute() {
      this.scrContext.getLogger().logTextDebug(" Started ");
      CommandResult var1 = new CommandResult(true, "");
      TRSRVR_SERIAL_PARAMS var2 = (TRSRVR_SERIAL_PARAMS)this.cmdContext.getCommandParameter("serialParams");
      ArrayList var3 = (ArrayList)((RRCScreenContext)this.scrContext).getSelectedDevicesObservable().getComponent();
      if (var3 != null) {
         Device var4 = (Device)var3.get(0);
         if (var4 instanceof SerialPort) {
            ((SerialPort)var4).setSerialParameters(var2);
         }
      }

      this.scrContext.getLogger().logTextDebug(" Finished ");
      return var1;
   }

   @Override
   public boolean isExecutable() {
      return true;
   }
}
