package com.raritan.rrc.ui.commands;

import com.raritan.rrc.data.Device;
import com.raritan.rrc.data.Port;
import com.raritan.rrc.ui.RRCScreenContext;
import com.raritan.rrc.ui.panes.DeviceView;
import com.raritan.tools.commands.AbstractCommand;
import com.raritan.tools.commands.CommandResult;
import com.raritan.tools.ui.ScreenContext;
import java.util.ArrayList;
import javaclientlib.utils.RRCLogger;

public class DoSingleMouseModeCommand extends AbstractCommand {
   public static final String COMMAND_KEY = "doSingleMouseModeCommand";

   public DoSingleMouseModeCommand(ScreenContext var1) {
      super(var1);
   }

   @Override
   public String getKey() {
      return "doSingleMouseModeCommand";
   }

   @Override
   public CommandResult execute() {
      this.scrContext.getLogger().logTextDebug(" Started ");
      RRCScreenContext var1 = (RRCScreenContext)this.scrContext;
      DeviceView var2 = var1.getSelectView();
      if (var2 != null) {
         var2.getCommandHandler().handleCommand(this, this.scrContext);
      } else {
         RRCLogger.log(100, 1, "View is null in DoSingleMouseModeCommand");
      }

      this.scrContext.getLogger().logTextDebug(" Finished ");
      return new CommandResult();
   }

   @Override
   public boolean isExecutable() {
      Object var1 = null;
      if (this.scrContext != null
         && ((RRCScreenContext)this.scrContext).getSelectedDevicesObservable() != null
         && ((RRCScreenContext)this.scrContext).getSelectedDevicesObservable().getComponent() != null) {
         ArrayList var2 = (ArrayList)((RRCScreenContext)this.scrContext).getSelectedDevicesObservable().getComponent();
         if (var2.get(0) != null) {
            var1 = (Device)var2.get(0);
            if (var1 instanceof Port) {
               Port var3 = (Port)var1;
               if (var3.getView() != null) {
                  return var3.getView().isCommandOperable(this);
               }
            }
         }
      }

      return true;
   }
}
