package com.raritan.rrc.ui.commands;

import com.raritan.rrc.data.Port;
import com.raritan.rrc.ui.RRCScreenContext;
import com.raritan.rrc.ui.panes.SerialView;
import com.raritan.rrc.util.MPCUtil;
import com.raritan.tools.commands.AbstractCommand;
import com.raritan.tools.commands.CommandResult;
import com.raritan.tools.resources.RaritanPropertyResourceBundle;
import com.raritan.tools.resources.RaritanResourceBundle;
import com.raritan.tools.ui.ScreenContext;
import java.io.File;

public class DoStartLoggingCommand extends AbstractCommand {
   public static final String COMMAND_KEY = "doStartLoggingCommand";
   private RaritanPropertyResourceBundle bundle = RaritanResourceBundle.getResourceBundle(this.scrContext.getLocale());

   public DoStartLoggingCommand(ScreenContext var1) {
      super(var1);
   }

   @Override
   public String getKey() {
      return "doStartLoggingCommand";
   }

   @Override
   public CommandResult execute() {
      this.scrContext.getLogger().logTextDebug(" Started ");
      CommandResult var1 = new CommandResult(true, "");
      Port var2 = (Port)this.cmdContext.getCommandParameter("devices");
      File var3 = (File)this.getContext().getCommandParameter("selectedFile");
      SerialView var4 = (SerialView)var2.getView();
      boolean var5 = false;
      if (var2.isConnected()) {
         var5 = var4.getSerialTerminal().doStartLogging(var3);
      }

      if (!var5) {
         var1.setStatusMessage(this.bundle.getString("startLogging.error"));
         var1.setIsSuccess(false);
         return var1;
      } else {
         MPCUtil.notifyObservers((RRCScreenContext)this.scrContext, var2);
         var1.setIsSuccess(true);
         this.scrContext.getLogger().logTextDebug(" Finished ");
         return var1;
      }
   }

   @Override
   public boolean isExecutable() {
      return true;
   }
}
