package com.raritan.rrc.ui.commands;

import com.raritan.rrc.data.KvmPort;
import com.raritan.rrc.data.Port;
import com.raritan.rrc.ui.RRCScreenContext;
import com.raritan.rrc.util.StringUtils;
import com.raritan.tools.commands.CommandResult;
import com.raritan.tools.resources.RaritanPropertyResourceBundle;
import com.raritan.tools.resources.RaritanResourceBundle;
import com.raritan.tools.ui.ScreenContext;
import java.util.ArrayList;

public class DoSwitchCommand extends ConnectionCommand {
   public static final String COMMAND_KEY = "doSwitchCommand";
   public static final String DO_SWITCH = "doSwitch";
   public static final int errCodeMask = 4095;
   private RaritanPropertyResourceBundle bundle = RaritanResourceBundle.getResourceBundle(this.scrContext.getLocale());

   public DoSwitchCommand(ScreenContext var1) {
      super(var1);
   }

   @Override
   public String getKey() {
      return "doSwitchCommand";
   }

   @Override
   public CommandResult execute() {
      this.scrContext.getLogger().logTextDebug(" Started ");
      CommandResult var1 = new CommandResult();
      if (this.setBusy(true)) {
         var1.setIsSuccess(false);
         var1.setStatusMessage("");
         return var1;
      } else {
         long var2 = Runtime.getRuntime().maxMemory() - Runtime.getRuntime().totalMemory() + Runtime.getRuntime().freeMemory();
         if (3145728L >= var2) {
            System.runFinalization();
            System.gc();
            var2 = Runtime.getRuntime().maxMemory() - Runtime.getRuntime().totalMemory() + Runtime.getRuntime().freeMemory();
            if (3145728L >= var2) {
               var1.setStatusMessage(this.bundle.getString("outOfMemory.error"));
               var1.setIsSuccess(false);
               return var1;
            }
         }

         ArrayList var4 = (ArrayList)((RRCScreenContext)this.scrContext).getSelectedDevicesObservable().getComponent();
         KvmPort var5 = (KvmPort)var4.get(0);
         if (var5.getPortStatus() == 0) {
            var1.setIsSuccess(false);
            var1.setStatusMessage(
               "["
                  + var5.getDevice().getNameIP()
                  + "]: "
                  + this.bundle.getString("KVMPort.couldNotConnect.error")
                  + " "
                  + (StringUtils.notNullOrEmpty(var5.getName()) ? var5.getName() : this.bundle.getString("DefaultPortString.error"))
            );
            return var1;
         } else {
            var5.getDevice().getHandler().doSwitch(this, var1);
            this.setBusy(false);
            this.scrContext.getLogger().logTextDebug(" Started ");
            return var1;
         }
      }
   }

   @Override
   public boolean setBusy(boolean var1) {
      return super.setBusy(var1);
   }

   @Override
   public boolean isExecutable() {
      ArrayList var1 = (ArrayList)((RRCScreenContext)this.scrContext).getSelectedDevicesObservable().getComponent();
      if (var1 != null && var1.size() != 0 && var1.get(0) instanceof Port) {
         Port var2 = (Port)var1.get(0);
         return var2 instanceof KvmPort
            && !var2.equals(var2.getDevice().getActiveKvmPort())
            && !var2.isConnected()
            && var2.getPortStatus() != 0
            && !var2.isSecondaryPort()
            && !var2.isPrimaryPort();
      } else {
         return false;
      }
   }
}
