package com.raritan.rrc.ui.commands;

import com.raritan.rrc.data.RRCRFPClient;
import com.raritan.rrc.ui.components.RRCStatusBar;
import com.raritan.tools.commands.AbstractCommand;
import com.raritan.tools.commands.CommandResult;
import com.raritan.tools.resources.RaritanPropertyResourceBundle;
import com.raritan.tools.resources.RaritanResourceBundle;
import com.raritan.tools.ui.ScreenContext;
import com.raritan.tools.ui.components.CommonPopups;
import java.io.File;
import javaclientlib.clientlib.TRConnection;

public class DoUpdateLDAPCertificateCommand extends AbstractCommand {
   public static final String COMMAND_KEY = "doUpdateLDAPCertificateCommand";
   private RaritanPropertyResourceBundle bundle = RaritanResourceBundle.getResourceBundle(this.scrContext.getLocale());

   public DoUpdateLDAPCertificateCommand(ScreenContext var1) {
      super(var1);
   }

   @Override
   public String getKey() {
      return "doUpdateLDAPCertificateCommand";
   }

   @Override
   public CommandResult execute() {
      this.scrContext.getLogger().logTextDebug(" Started ");
      CommandResult var1 = new CommandResult();
      File var2 = (File)this.getContext().getCommandParameter("selectedFile");
      new DoUpdateLDAPCertificateCommand.DoUpdateLDAPCertificateThread(var2).start();
      this.scrContext.getLogger().logTextDebug(" Finished ");
      return var1;
   }

   @Override
   public boolean isExecutable() {
      return true;
   }

   private class DoUpdateLDAPCertificateThread extends Thread {
      private File file;

      protected DoUpdateLDAPCertificateThread(File var2) {
         super("DoUpdateLDAPCertificateThread");
         this.file = var2;
      }

      @Override
      public void run() {
         DoUpdateLDAPCertificateCommand.this.scrContext
            .getLogger()
            .logStatus(DoUpdateLDAPCertificateCommand.this.bundle.getString("info.do.updateldapcertificate"));
         RRCRFPClient var1 = RRCRFPClient.getInstance();
         var1.setScreenContext(DoUpdateLDAPCertificateCommand.this.scrContext);

         try {
            var1.setShowProgress(true);
            var1.createRFPConnection();
            boolean var2 = var1.updateLDAPCertificate(this.file);
            if (var2) {
               int var3 = CommonPopups.showConfirmationDialog(
                  DoUpdateLDAPCertificateCommand.this.bundle.getString("confirmation.dialog.do.restartdevice.title"),
                  DoUpdateLDAPCertificateCommand.this.bundle.getString("confirmation.dialog.do.restartdevice.text"),
                  null,
                  DoUpdateLDAPCertificateCommand.this.scrContext
               );
               if (var3 == 2) {
                  DoRestartDeviceCommand var4 = new DoRestartDeviceCommand(DoUpdateLDAPCertificateCommand.this.scrContext);
                  var4.execute();
               }

               DoUpdateLDAPCertificateCommand.this.scrContext
                  .getLogger()
                  .logStatus(DoUpdateLDAPCertificateCommand.this.bundle.getString("success.do.updateldapcertificate"));
               ((RRCStatusBar)DoUpdateLDAPCertificateCommand.this.scrContext.getPanelMediator().getStatusPanel())
                  .setTextLabel(DoUpdateLDAPCertificateCommand.this.bundle.getString("success.do.updateldapcertificate"));
               return;
            }

            var1.closeRFPConnection();
            CommonPopups.showInfoDialog("", var1.showError(TRConnection.getLastError()), null, DoUpdateLDAPCertificateCommand.this.scrContext);
            DoUpdateLDAPCertificateCommand.this.scrContext
               .getLogger()
               .logStatus(DoUpdateLDAPCertificateCommand.this.bundle.getString("error.do.updateldapcertificate"));
         } catch (Exception var8) {
            DoUpdateLDAPCertificateCommand.this.scrContext.getLogger().logTextDebug(" " + var8.getMessage());
            DoUpdateLDAPCertificateCommand.this.scrContext
               .getLogger()
               .logStatus(DoUpdateLDAPCertificateCommand.this.bundle.getString("error.ioexception.updateldapcertificate") + var8.getMessage());
            return;
         } finally {
            var1.closeRFPConnection();
         }
      }
   }
}
