package com.raritan.rrc.ui.commands;

import com.raritan.rrc.data.RRCRFPClient;
import com.raritan.rrc.ui.components.RRCStatusBar;
import com.raritan.tools.commands.AbstractCommand;
import com.raritan.tools.commands.CommandResult;
import com.raritan.tools.resources.RaritanPropertyResourceBundle;
import com.raritan.tools.resources.RaritanResourceBundle;
import com.raritan.tools.ui.ScreenContext;
import com.raritan.tools.ui.components.CommonPopups;
import java.io.File;
import javaclientlib.clientlib.TRConnection;

public class DoUpdateLDAPKeyCommand extends AbstractCommand {
   public static final String COMMAND_KEY = "doUpdateLDAPKeyCommand";
   private RaritanPropertyResourceBundle bundle = RaritanResourceBundle.getResourceBundle(this.scrContext.getLocale());
   private File file;

   public DoUpdateLDAPKeyCommand(ScreenContext var1) {
      super(var1);
   }

   @Override
   public String getKey() {
      return "doUpdateLDAPKeyCommand";
   }

   @Override
   public CommandResult execute() {
      this.scrContext.getLogger().logTextDebug(" Started ");
      CommandResult var1 = new CommandResult();
      this.file = (File)this.getContext().getCommandParameter("selectedFile");
      new DoUpdateLDAPKeyCommand.DoUpdateLDAPKeyThread().start();
      this.scrContext.getLogger().logTextDebug(" Finished ");
      return var1;
   }

   @Override
   public boolean isExecutable() {
      return true;
   }

   private class DoUpdateLDAPKeyThread extends Thread {
      protected DoUpdateLDAPKeyThread() {
         super("DoUpdateLDAPKeyThread");
      }

      @Override
      public void run() {
         DoUpdateLDAPKeyCommand.this.scrContext.getLogger().logStatus(DoUpdateLDAPKeyCommand.this.bundle.getString("info.do.updateldapkey"));
         RRCRFPClient var1 = RRCRFPClient.getInstance();
         var1.setScreenContext(DoUpdateLDAPKeyCommand.this.scrContext);

         try {
            var1.setShowProgress(true);
            var1.createRFPConnection();
            boolean var2 = var1.updateLDAPKey(DoUpdateLDAPKeyCommand.this.file);
            if (var2) {
               int var3 = CommonPopups.showConfirmationDialog(
                  DoUpdateLDAPKeyCommand.this.bundle.getString("confirmation.dialog.do.restartdevice.title"),
                  DoUpdateLDAPKeyCommand.this.bundle.getString("confirmation.dialog.do.restartdevice.text"),
                  null,
                  DoUpdateLDAPKeyCommand.this.scrContext
               );
               if (var3 == 2) {
                  DoRestartDeviceCommand var4 = new DoRestartDeviceCommand(DoUpdateLDAPKeyCommand.this.scrContext);
                  var4.execute();
               }

               DoUpdateLDAPKeyCommand.this.scrContext.getLogger().logStatus(DoUpdateLDAPKeyCommand.this.bundle.getString("success.do.updateldapkey"));
               ((RRCStatusBar)DoUpdateLDAPKeyCommand.this.scrContext.getPanelMediator().getStatusPanel())
                  .setTextLabel(DoUpdateLDAPKeyCommand.this.bundle.getString("success.do.updateldapkey"));
               return;
            }

            CommonPopups.showInfoDialog("", var1.showError(TRConnection.getLastError()), null, DoUpdateLDAPKeyCommand.this.scrContext);
            DoUpdateLDAPKeyCommand.this.scrContext.getLogger().logStatus(DoUpdateLDAPKeyCommand.this.bundle.getString("error.do.updateldapkey"));
            var1.closeRFPConnection();
         } catch (Exception var8) {
            DoUpdateLDAPKeyCommand.this.scrContext.getLogger().logTextDebug(" " + var8.getMessage());
            DoUpdateLDAPKeyCommand.this.scrContext
               .getLogger()
               .logStatus(DoUpdateLDAPKeyCommand.this.bundle.getString("error.ioexception.updateldapkey") + var8.getMessage());
            return;
         } finally {
            var1.closeRFPConnection();
         }
      }
   }
}
