package com.raritan.rrc.ui.commands;

import com.raritan.rrc.data.Port;
import com.raritan.rrc.ui.RRCScreenContext;
import com.raritan.rrc.ui.panes.DeviceView;
import com.raritan.tools.commands.AbstractCommand;
import com.raritan.tools.commands.CommandResult;
import com.raritan.tools.ui.ScreenContext;
import javaclientlib.utils.RRCLogger;

public class HelpDisplayCommand extends AbstractCommand {
   public static final String COMMAND_KEY = "HelpDisplayCommand";

   public HelpDisplayCommand(ScreenContext var1) {
      super(var1);
   }

   @Override
   public String getKey() {
      return "HelpDisplayCommand";
   }

   @Override
   public CommandResult execute() {
      assert this.scrContext instanceof RRCScreenContext;

      RRCScreenContext var1 = (RRCScreenContext)this.scrContext;
      Port var2 = var1.getSelectedPort();
      DeviceView var3 = var2.getView();
      if (var3 != null) {
         if (var3.isFullScreenMode()) {
            var1.getHelpManager().showHelp((String)this.getContext().getCommandParameter("HelpTopicIDToDisplay"), var1.getApplication().getContentPane());
            var1.getHelpManager().setHelpWindowOnTop(true);
         } else {
            var1.getHelpManager().showHelp((String)this.getContext().getCommandParameter("HelpTopicIDToDisplay"), var3);
            var1.getHelpManager().setHelpWindowOnTop(false);
         }
      } else {
         RRCLogger.log(100, 1, "View is null in HelpDisplayCommand");
      }

      return new CommandResult(true, "");
   }

   @Override
   public boolean isExecutable() {
      return true;
   }
}
