package com.raritan.rrc.ui.commands;

import com.raritan.rrc.data.Device;
import com.raritan.rrc.data.Port;
import com.raritan.rrc.ui.RRCScreenContext;
import com.raritan.tools.commands.AbstractCommand;
import com.raritan.tools.commands.CommandResult;
import com.raritan.tools.ui.ScreenContext;
import java.util.ArrayList;

public class KVMPortDummyCommand extends AbstractCommand {
   public static final String COMMAND_KEY = "checkCommand";

   public KVMPortDummyCommand(ScreenContext var1) {
      super(var1);
   }

   @Override
   public String getKey() {
      return "checkCommand";
   }

   @Override
   public CommandResult execute() {
      this.scrContext.getLogger().logTextDebug(" Started ");
      this.scrContext.getLogger().logTextDebug(" Finished ");
      return new CommandResult();
   }

   @Override
   public boolean isExecutable() {
      Object var1 = null;
      if (this.scrContext != null
         && ((RRCScreenContext)this.scrContext).getSelectedDevicesObservable() != null
         && ((RRCScreenContext)this.scrContext).getSelectedDevicesObservable().getComponent() != null) {
         ArrayList var2 = (ArrayList)((RRCScreenContext)this.scrContext).getSelectedDevicesObservable().getComponent();
         if (var2.get(0) != null) {
            var1 = (Device)var2.get(0);
            if (var1 instanceof Port && ((Device)var1).isConnected()) {
               Port var3 = (Port)var1;
               if (var3.getDeviceClass().equalsIgnoreCase("KVM")) {
                  return true;
               }
            }
         }
      }

      return false;
   }
}
