package com.raritan.rrc.ui.commands;

import com.raritan.rrc.data.Device;
import com.raritan.rrc.data.Port;
import com.raritan.rrc.ui.RRCScreenContext;
import com.raritan.rrc.ui.panes.DeviceView;
import com.raritan.tools.commands.CommandResult;
import com.raritan.tools.ui.ScreenContext;
import java.util.ArrayList;
import javaclientlib.utils.RRCLogger;

public class MouseMenuCommand extends KVMPortDummyCommand {
   private String tooltip = null;
   public static final String COMMAND_KEY = "mouseMenuCommand";

   public MouseMenuCommand(ScreenContext var1) {
      super(var1);
   }

   @Override
   public CommandResult execute() {
      CommandResult var1 = new CommandResult();
      this.scrContext.getLogger().logTextDebug(" Started ");
      RRCScreenContext var2 = (RRCScreenContext)this.scrContext;
      DeviceView var3 = var2.getSelectView();
      if (var3 != null) {
         var3.getCommandHandler().handleCommand(this, this.scrContext);
      } else {
         RRCLogger.log(100, 1, "View is null in MouseMenuCommand");
      }

      this.scrContext.getLogger().logTextDebug(" Finished ");
      var1.setIsSuccess(true);
      return var1;
   }

   @Override
   public boolean isExecutable() {
      this.tooltip = null;
      Object var1 = null;
      if (this.scrContext != null
         && ((RRCScreenContext)this.scrContext).getSelectedDevicesObservable() != null
         && ((RRCScreenContext)this.scrContext).getSelectedDevicesObservable().getComponent() != null) {
         ArrayList var2 = (ArrayList)((RRCScreenContext)this.scrContext).getSelectedDevicesObservable().getComponent();
         if (var2.get(0) != null) {
            var1 = (Device)var2.get(0);
            if (var1 instanceof Port && ((Device)var1).isConnected()) {
               Port var3 = (Port)var1;
               if (var3.getDeviceClass().equalsIgnoreCase("KVM")) {
                  if (var3.isTopLeft()) {
                     return true;
                  }

                  this.tooltip = this.getBundle().getString("MouseMenu.NotTopLeft");
               }
            }
         }
      }

      return false;
   }

   public String getToolTip() {
      return this.tooltip;
   }
}
