package com.raritan.rrc.ui.commands;

import com.raritan.rrc.data.Port;
import com.raritan.rrc.ui.RRCScreenContext;
import com.raritan.rrc.ui.components.RRCMenuBar;
import com.raritan.tools.commands.AbstractCommand;
import com.raritan.tools.commands.CommandResult;
import com.raritan.tools.ui.components.CommandCheckMenuItem;
import com.raritan.tools.ui.components.CommandMenu;
import com.raritan.tools.ui.panes.displays.ShellInternalFrame;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Locale;

public class PopulateWindowMenuCommand extends AbstractCommand {
   public static final String COMMAND_KEY = "populateWindowMenuCommand";
   private RRCScreenContext scrContext;

   public PopulateWindowMenuCommand(RRCScreenContext var1) {
      super(var1);
      this.scrContext = var1;
   }

   @Override
   public CommandResult execute() {
      HashMap var1 = (HashMap)this.scrContext.getOpenPortsObservable().getComponent();
      ArrayList var2 = this.scrContext.getListOfOpenPorts();
      List var3 = this.scrContext.getMainScreenMediator().getWindowMenus();

      for (CommandMenu var6 : var3) {
         while (var6.getMenuComponentCount() > 2) {
            var6.remove(2);
         }
      }

      if (var1 == null) {
         return new CommandResult(true, "");
      } else {
         for (CommandMenu var17 : var3) {
            if (var2.size() > 0) {
               var17.addSeparator();
            }
         }

         int var16 = 1;
         int var18 = var2.size();
         Object var7 = null;
         Object var8 = null;

         for (int var9 = 0; var9 < var18; var9++) {
            var8 = var2.get(var9);
            if (var8 != null) {
               var7 = (Port)var1.get(var8);
               if (var7 != null && ((Port)var7).getView() != null && ((Port)var7).getDevice().getHandler().isWindowMenuItem((Port)var7)) {
                  ShellInternalFrame var10 = ((Port)var7).getView().getShellInternalFrame();

                  for (CommandMenu var12 : var3) {
                     CommandCheckMenuItem var13 = new CommandCheckMenuItem(var16 + " " + var10.getTitle(), var10.isSelected(), this.scrContext);
                     SelectWindowCheckMenuCommand var14 = new SelectWindowCheckMenuCommand(this.scrContext);
                     var14.setPort((Port)var7);
                     var13.setCommand(var14);
                     if (this.scrContext.getLocale() == Locale.US || this.scrContext.getLocale() == Locale.UK) {
                        var13.setDisplayedMnemonicIndex(0);
                     }

                     var13.setMnemonic(String.valueOf(var16).charAt(0));
                     var13.addActionListener((RRCMenuBar)var12.getParent());
                     var12.add(var13);
                  }

                  var16++;
               }
            }
         }

         for (CommandMenu var22 : var3) {
            var22.repaint();
         }

         return new CommandResult(true, "");
      }
   }

   @Override
   public String getKey() {
      return "populateWindowMenuCommand";
   }

   @Override
   public boolean isExecutable() {
      HashMap var1 = (HashMap)this.scrContext.getOpenPortsObservable().getComponent();
      return var1 != null && var1.size() > 0;
   }
}
