package com.raritan.rrc.ui.commands;

import com.raritan.rrc.data.Device;
import com.raritan.rrc.data.Port;
import com.raritan.rrc.ui.RRCScreenContext;
import com.raritan.tools.commands.AbstractCommand;
import com.raritan.tools.commands.CommandResult;
import com.raritan.tools.ui.ScreenContext;
import com.raritan.tools.ui.components.CommandCheckMenuItem;
import java.util.ArrayList;
import javax.swing.SwingUtilities;

public class SelectPortViewCommand extends AbstractCommand {
   public static final String COMMAND_KEY = "selectPortViewCommand";

   public SelectPortViewCommand(ScreenContext var1) {
      super(var1);
   }

   @Override
   public String getKey() {
      return "selectPortViewCommand";
   }

   @Override
   public CommandResult execute() {
      final Port var1 = (Port)this.getContext().getCommandParameter("selectedPortDevice");
      if (var1 != null && var1.getView() != null) {
         for (Port var3 : var1.getAssociatedPorts()) {
            if (var3.getView() != null && var3.getView().getShellInternalFrame() != null) {
               var3.getView().getShellInternalFrame().toFront();
            }
         }

         var1.getView().getShellInternalFrame().toFront();
         if (((RRCScreenContext)this.scrContext).getApplicationProperty("connection") != null) {
            var1.getView().setViewFocus();
         }

         SwingUtilities.invokeLater(new Runnable() {
            @Override
            public void run() {
               RRCScreenContext var1x = (RRCScreenContext)SelectPortViewCommand.this.scrContext;
               if (var1 != null && var1.getView() != null) {
                  for (CommandCheckMenuItem var3x : var1x.getMainScreenMediator().getCheckScaleVideoMenuItems()) {
                     var3x.setSelected(var1.getView().isScaleVideoFlag());
                  }

                  var1x.getMainScreenMediator().getToolBarScaleVideoButton().setSelected(var1.getView().isScaleVideoFlag());
               }
            }
         });
      }

      Object var7 = null;
      RRCScreenContext var9 = (RRCScreenContext)this.scrContext;
      if (var9.getSelectedDevicesObservable() != null && var9.getSelectedDevicesObservable().getComponent() != null) {
         ArrayList var4 = (ArrayList)var9.getSelectedDevicesObservable().getComponent();
         if (var4.get(0) != null) {
            var7 = (Device)var4.get(0);
            if (var7 instanceof Port) {
               Port var5 = (Port)var7;
               String var6 = var5 == null ? "null" : var5.getViewName();
               if (var1 != null && var1.getView() != null && var1.getViewName().equals(var6)) {
                  return new CommandResult(true, "");
               }
            }
         }
      }

      var1.firePropertyChange("DEVICE_SELECTED", null, null);
      return new CommandResult(true, "");
   }

   @Override
   public boolean isExecutable() {
      return true;
   }
}
