package com.raritan.rrc.ui.commands;

import com.raritan.rrc.data.Port;
import com.raritan.tools.commands.AbstractCommand;
import com.raritan.tools.commands.CommandResult;
import com.raritan.tools.ui.ScreenContext;
import java.beans.PropertyVetoException;

public class SelectWindowCheckMenuCommand extends AbstractCommand {
   public static final String COMMAND_KEY = "selectWindowCheckMenuCommand";
   private Port port;

   public SelectWindowCheckMenuCommand(ScreenContext var1) {
      super(var1);
   }

   @Override
   public String getKey() {
      return "selectWindowCheckMenuCommand";
   }

   @Override
   public boolean isExecutable() {
      return true;
   }

   public void setPort(Port var1) {
      this.port = var1;
   }

   public Port getPort() {
      return this.port;
   }

   @Override
   public CommandResult execute() {
      boolean var1 = (Boolean)this.getContext().getCommandParameter("selectedWindowItem");
      if (var1) {
         Port var2 = this.getPort();
         if (var2 != null && var2.getView() != null && var2.getView().getShellInternalFrame() != null) {
            try {
               var2.getView().getShellInternalFrame().setSelected(true);
               var2.getView().requestFocusInWindow();
            } catch (PropertyVetoException var4) {
            }
         }
      }

      return new CommandResult(true, "");
   }
}
