package com.raritan.rrc.ui.commands;

import com.raritan.rrc.data.Device;
import com.raritan.rrc.data.G2SerialPort;
import com.raritan.rrc.data.Port;
import com.raritan.rrc.data.PowerPort;
import com.raritan.rrc.ui.RRCScreenContext;
import com.raritan.tools.commands.AbstractCommand;
import com.raritan.tools.commands.CommandResult;
import com.raritan.tools.ui.ScreenContext;
import java.util.ArrayList;

public class SerialPortDummyCommand extends AbstractCommand {
   public static final String COMMAND_KEY = "checkCommand";

   public SerialPortDummyCommand(ScreenContext var1) {
      super(var1);
   }

   @Override
   public String getKey() {
      return "checkCommand";
   }

   @Override
   public CommandResult execute() {
      this.scrContext.getLogger().logTextDebug(" Started ");
      this.scrContext.getLogger().logTextDebug(" Finished ");
      return new CommandResult();
   }

   @Override
   public boolean isExecutable() {
      ArrayList var1 = (ArrayList)((RRCScreenContext)this.scrContext).getSelectedDevicesObservable().getComponent();
      if (var1 != null && var1.size() > 0) {
         Device var2 = (Device)var1.get(0);
         if (var2 != null
            && var2 instanceof Port
            && var2.isConnected()
            && var2.getDeviceClass().equals("Serial")
            && !((Port)var2).isAdmin()
            && !(var2 instanceof PowerPort)
            && !(var2 instanceof G2SerialPort)) {
            return true;
         }
      }

      return false;
   }
}
