package com.raritan.rrc.ui.commands;

import com.raritan.rrc.ui.RRCScreenContext;
import com.raritan.rrc.ui.controller.DeviceTreeController;
import com.raritan.tools.commands.AbstractCommand;
import com.raritan.tools.commands.CommandResult;
import com.raritan.tools.ui.ScreenContext;

public class ShowAllDevicesCommand extends AbstractCommand {
   public static final String COMMAND_KEY = "showAllDevicesCommand";

   public ShowAllDevicesCommand(ScreenContext var1) {
      super(var1);
   }

   @Override
   public String getKey() {
      return "showAllDevicesCommand";
   }

   @Override
   public CommandResult execute() {
      this.scrContext.getLogger().logTextDebug(" Started ");
      Boolean var1 = (Boolean)this.getContext().getCommandParameter("showAllDevicesMode");
      boolean var2 = var1;
      ((RRCScreenContext)this.scrContext).getMainScreenMediator().selectBrowseAllDevicesView(var2);
      ((RRCScreenContext)this.scrContext).getAppSettings().setShowAll(var2);
      DeviceTreeController var3 = DeviceTreeController.getInstance((RRCScreenContext)this.scrContext);
      if (!var2) {
         var3.stopBroadcastAndUpdateDevices();
      } else {
         var3.startBroadcast();
      }

      this.scrContext.getLogger().logTextDebug(" Finished ");
      return new CommandResult();
   }

   @Override
   public boolean isExecutable() {
      return this.scrContext.getApplicationProperty("connection") == null;
   }
}
