package com.raritan.rrc.ui.commands;

import com.raritan.rrc.data.KeyboardMacrosPreferences;
import com.raritan.tools.commands.AbstractCommand;
import com.raritan.tools.commands.CommandContext;
import com.raritan.tools.commands.CommandResult;
import com.raritan.tools.resources.RaritanPropertyResourceBundle;
import com.raritan.tools.resources.RaritanResourceBundle;
import com.raritan.tools.ui.ScreenContext;
import java.util.TreeMap;

public class ShowExportMacrosCommand extends AbstractCommand {
   private static RaritanPropertyResourceBundle bundle;
   public static final String COMMAND_KEY = "showExportMacrosCommand";

   public ShowExportMacrosCommand(ScreenContext var1) {
      super(var1);
      bundle = RaritanResourceBundle.getResourceBundle(this.scrContext.getLocale());
   }

   @Override
   public String getKey() {
      return "showExportMacrosCommand";
   }

   @Override
   public boolean isExecutable() {
      return true;
   }

   @Override
   public CommandResult execute() {
      this.scrContext.getLogger().logTextDebug(" Started ");
      KeyboardMacrosPreferences.importPreferences();
      String[] var1 = KeyboardMacrosPreferences.returnNodes();
      TreeMap var2 = new TreeMap();
      KeyboardMacrosPreferences var3 = null;

      for (int var4 = 0; var4 < var1.length; var4++) {
         var3 = new KeyboardMacrosPreferences();
         var3.importSinglePreferenceInfo(var1[var4]);
         var2.put(var1[var4], var3);
      }

      CommandResult var7 = new CommandResult(true, "");
      CommandContext var5 = this.getContext();
      if (var2.size() < 1) {
         var7.setIsSuccess(false);
         var7.setStatusMessage(bundle.getString("macro.export.no.macros.exist"));
      } else {
         var5.setCommandParameter("importExportSelectedMacros", var2);
      }

      this.scrContext.getLogger().logTextDebug(" Finished ");
      return var7;
   }
}
