package com.raritan.rrc.ui.commands;

import com.raritan.rrc.data.Port;
import com.raritan.rrc.ui.RRCApplication;
import com.raritan.rrc.ui.RRCScreenContext;
import com.raritan.rrc.ui.panes.DeviceView;
import com.raritan.tools.commands.AbstractCommand;
import com.raritan.tools.commands.CommandResult;
import com.raritan.tools.ui.ScreenContext;
import com.raritan.tools.ui.components.CommandCheckMenuItem;
import java.awt.Dimension;
import java.awt.Toolkit;
import java.util.ArrayList;

public class ShowFullScreenCommand extends AbstractCommand {
   public static final String COMMAND_KEY = "showFullScreenCommand";

   public ShowFullScreenCommand(ScreenContext var1) {
      super(var1);
   }

   @Override
   public String getKey() {
      return "showFullScreenCommand";
   }

   @Override
   public CommandResult execute() {
      this.scrContext.getLogger().logTextDebug(" Started ");
      Boolean var1 = (Boolean)this.getContext().getCommandParameter("showFullScreenMode");
      boolean var2 = var1;
      Dimension var3 = Toolkit.getDefaultToolkit().getScreenSize();
      if (this.scrContext.getApplication() instanceof RRCApplication) {
         ((RRCApplication)this.scrContext.getApplication()).setVisible(true);
         if (var2) {
            ((RRCApplication)this.scrContext.getApplication()).setExtendedState(6);
            ((RRCApplication)this.scrContext.getApplication()).repaint();
         } else {
            ((RRCApplication)this.scrContext.getApplication()).setExtendedState(0);
            ((RRCApplication)this.scrContext.getApplication()).repaint();
         }
      }

      try {
         ArrayList var4 = (ArrayList)((RRCScreenContext)this.scrContext).getSelectedDevicesObservable().getComponent();
         if (var4 != null && var4.size() > 0) {
            Port var5 = (Port)var4.get(0);
            DeviceView var6 = var5.getView();
            if (var6 != null && var6.isTargetScreenResolution() && var2) {
               var6.setTargetScreenResolution(false);
            }
         }
      } catch (ClassCastException var7) {
      }

      ((RRCScreenContext)this.scrContext).getMainScreenMediator().selectToolBarView(!var2);
      ((RRCScreenContext)this.scrContext).getMainScreenMediator().selectStatusBarView(!var2);
      ((RRCScreenContext)this.scrContext).getMainScreenMediator().selectNavigatorView(!var2);

      for (CommandCheckMenuItem var9 : ((RRCScreenContext)this.scrContext).getMainScreenMediator().getCheckFullScreenMenuItems()) {
         var9.setSelected(var2);
      }

      ((RRCScreenContext)this.scrContext).getMainScreenMediator().getToolBarFullScreenButton().setSelected(var2);
      this.scrContext.getLogger().logTextDebug(" Finished ");
      return new CommandResult();
   }

   @Override
   public boolean isExecutable() {
      return true;
   }
}
