package com.raritan.rrc.ui.commands;

import com.raritan.rrc.data.Device;
import com.raritan.rrc.data.G2SerialPort;
import com.raritan.rrc.data.Port;
import com.raritan.rrc.ui.RRCScreenContext;
import com.raritan.tools.commands.AbstractCommand;
import com.raritan.tools.commands.CommandResult;
import com.raritan.tools.ui.ScreenContext;
import java.util.ArrayList;

public class ShowKX2G2SerialPortCommand extends AbstractCommand {
   public static final String COMMAND_KEY = "showKX2G2SerialPortCommand";

   public ShowKX2G2SerialPortCommand(ScreenContext var1) {
      super(var1);
   }

   @Override
   public String getKey() {
      return "showKX2G2SerialPortCommand";
   }

   @Override
   public CommandResult execute() {
      CommandResult var1 = new CommandResult();
      ArrayList var2 = (ArrayList)((RRCScreenContext)this.scrContext).getSelectedDevicesObservable().getComponent();
      G2SerialPort var3 = (G2SerialPort)var2.get(0);
      var3.connect();
      var3.setContext(this.scrContext);
      var1.setIsSuccess(true);
      return var1;
   }

   @Override
   public boolean isExecutable() {
      ArrayList var1 = (ArrayList)((RRCScreenContext)this.scrContext).getSelectedDevicesObservable().getComponent();
      if (var1 != null && var1.size() > 0) {
         Device var2 = (Device)var1.get(0);
         if (var2 != null && var2 instanceof Port && var2.getDeviceClass().equals("Serial") && !var2.isConnected()) {
            if (((RRCScreenContext)this.scrContext).getOpenPortsObservable().getComponent() == null) {
               return true;
            }

            if (((RRCScreenContext)this.scrContext).getPortByKeyObservable((Port)var2) == null) {
               return true;
            }
         }
      }

      return false;
   }
}
