package com.raritan.rrc.ui.commands;

import com.raritan.rrc.data.BladeChassis;
import com.raritan.rrc.data.Device;
import com.raritan.rrc.data.DeviceNameMigrator;
import com.raritan.rrc.data.VirtualBladeChassis;
import com.raritan.rrc.ui.RRCScreenContext;
import com.raritan.tools.commands.AbstractCommand;
import com.raritan.tools.commands.CommandContext;
import com.raritan.tools.commands.CommandResult;
import com.raritan.tools.resources.RaritanPropertyResourceBundle;
import com.raritan.tools.resources.RaritanResourceBundle;
import com.raritan.tools.ui.ScreenContext;
import java.util.ArrayList;

public class ShowLoginCommand extends AbstractCommand {
   public static final String COMMAND_KEY = "showConnectCommand";
   private RaritanPropertyResourceBundle bundle = RaritanResourceBundle.getResourceBundle(this.scrContext.getLocale());

   public ShowLoginCommand(ScreenContext var1) {
      super(var1);
   }

   @Override
   public String getKey() {
      return "showConnectCommand";
   }

   @Override
   public CommandResult execute() {
      short var1 = 0;
      this.scrContext.getLogger().logTextDebug(" Started ");
      CommandResult var2 = new CommandResult(true, "");
      CommandContext var3 = this.getContext();
      Device var4 = (Device)var3.getCommandParameter("devices");
      if (var4 == null) {
         var4 = (Device)((ArrayList)((RRCScreenContext)this.scrContext).getSelectedDevicesObservable().getComponent()).get(0);
      }

      var3.setCommandParameter("devices", var4);
      if (var4.isProfiled()) {
         var1 = (short)var4.getDevPrefs().getPort();
      }

      DeviceNameMigrator.migrate(var4, this.scrContext.getDeviceNameAddressProvider());
      this.scrContext.getLogger().logTextDebug(" Finished ");
      var2.setIsSuccess(true);
      return var2;
   }

   @Override
   public boolean isExecutable() {
      try {
         Device var1 = (Device)((ArrayList)((RRCScreenContext)this.scrContext).getSelectedDevicesObservable().getComponent()).get(0);
         return !(var1 instanceof BladeChassis) && !(var1 instanceof VirtualBladeChassis) ? !var1.isConnected() : false;
      } catch (Exception var2) {
         return false;
      }
   }
}
