package com.raritan.rrc.ui.commands;

import com.raritan.rrc.data.Device;
import com.raritan.rrc.data.Port;
import com.raritan.rrc.ui.RRCScreenContext;
import com.raritan.tools.commands.AbstractCommand;
import com.raritan.tools.commands.CommandResult;
import com.raritan.tools.ui.ScreenContext;
import java.util.ArrayList;

public class ShowModifyProfileCommand extends AbstractCommand {
   public static final String COMMAND_KEY = "showModifyProfileCommand";

   public ShowModifyProfileCommand(ScreenContext var1) {
      super(var1);
   }

   @Override
   public String getKey() {
      return "showModifyProfileCommand";
   }

   @Override
   public CommandResult execute() {
      this.scrContext.getLogger().logTextDebug(" Started ");
      CommandResult var1 = new CommandResult();
      Device var2 = null;

      try {
         var2 = (Device)((ArrayList)((RRCScreenContext)this.scrContext).getSelectedDevicesObservable().getComponent()).get(0);
      } catch (Exception var4) {
         this.scrContext.getLogger().logTextDebug(var4.getMessage());
      }

      this.getContext(true).setCommandParameter("devices", var2);
      var1.setIsSuccess(true);
      this.scrContext.getLogger().logTextDebug(" Finished ");
      return var1;
   }

   @Override
   public boolean isExecutable() {
      ArrayList var1 = (ArrayList)((RRCScreenContext)this.scrContext).getSelectedDevicesObservable().getComponent();
      if (var1 != null && var1.size() > 0) {
         Device var2 = (Device)((ArrayList)((RRCScreenContext)this.scrContext).getSelectedDevicesObservable().getComponent()).get(0);
         if (var2 instanceof Port) {
            return false;
         }

         if (var2 != null && var2.isProfiled() && !var2.isConnected()) {
            return true;
         }
      }

      return false;
   }
}
