package com.raritan.rrc.ui.commands;

import com.raritan.rrc.data.Device;
import com.raritan.rrc.data.PowerPort;
import com.raritan.rrc.ui.RRCScreenContext;
import com.raritan.tools.commands.AbstractCommand;
import com.raritan.tools.commands.CommandResult;
import com.raritan.tools.resources.RaritanPropertyResourceBundle;
import com.raritan.tools.resources.RaritanResourceBundle;
import com.raritan.tools.ui.ScreenContext;
import java.util.ArrayList;

public class ShowPowerPortCommand extends AbstractCommand {
   public static final String COMMAND_KEY = "showPowerPortCommand";
   private RaritanPropertyResourceBundle bundle = RaritanResourceBundle.getResourceBundle(this.scrContext.getLocale());

   public ShowPowerPortCommand(ScreenContext var1) {
      super(var1);
   }

   @Override
   public String getKey() {
      return "showPowerPortCommand";
   }

   @Override
   public CommandResult execute() {
      CommandResult var1 = new CommandResult();
      long var2 = Runtime.getRuntime().maxMemory() - Runtime.getRuntime().totalMemory() + Runtime.getRuntime().freeMemory();
      if (1048576L >= var2) {
         var1.setStatusMessage(this.bundle.getString("outOfMemory.error"));
         var1.setIsSuccess(false);
         return var1;
      } else {
         PowerPort var4 = (PowerPort)((ArrayList)((RRCScreenContext)this.scrContext).getSelectedDevicesObservable().getComponent()).get(0);
         var4.connect();
         if (!var4.isConnected()) {
            var1.setStatusMessage(this.bundle.getString("PowerPort.busy.error"));
            var1.setIsSuccess(false);
            return var1;
         } else {
            var1.setIsSuccess(true);
            return var1;
         }
      }
   }

   @Override
   public boolean isExecutable() {
      ArrayList var1 = (ArrayList)((RRCScreenContext)this.scrContext).getSelectedDevicesObservable().getComponent();
      if (var1 != null && var1.size() > 0) {
         Device var2 = (Device)var1.get(0);
         if (var2 != null) {
            return !var2.isConnected();
         }
      }

      return false;
   }
}
