package com.raritan.rrc.ui.commands;

import com.raritan.rrc.data.Device;
import com.raritan.rrc.data.KvmStream;
import com.raritan.rrc.data.Port;
import com.raritan.rrc.ui.RRCScreenContext;
import com.raritan.rrc.ui.panes.DeviceView;
import com.raritan.rrc.ui.panes.KvmView;
import com.raritan.rrc.ui.rfbbridge.RFBView;
import com.raritan.tools.commands.AbstractCommand;
import com.raritan.tools.commands.CommandResult;
import com.raritan.tools.ui.ScreenContext;
import java.util.ArrayList;
import javaclientlib.tr.TRSRVR_COMP_PARAMS;

public class ShowPropertiesCommand extends AbstractCommand {
   public static final String COMMAND_KEY = "showPropertiesCommand";

   public ShowPropertiesCommand(ScreenContext var1) {
      super(var1);
   }

   @Override
   public String getKey() {
      return "showPropertiesCommand";
   }

   @Override
   public CommandResult execute() {
      this.scrContext.getLogger().logTextDebug(" Started ");
      Port var1 = ((RRCScreenContext)this.scrContext).getSelectedPort();
      this.cmdContext.setCommandParameter("deviceNode", var1.getDevice());
      DeviceView var2 = var1.getView();
      if (!(var2 instanceof RFBView) && var1.isConnected()) {
         TRSRVR_COMP_PARAMS var3 = ((KvmStream)var1.getStream()).getCompressionParams();
         this.cmdContext.setCommandParameter("compParams", var3);
      }

      this.scrContext.getLogger().logTextDebug(" Finished ");
      return new CommandResult(true, "");
   }

   @Override
   public boolean isExecutable() {
      Object var1 = null;
      if (this.scrContext != null
         && ((RRCScreenContext)this.scrContext).getSelectedDevicesObservable() != null
         && ((RRCScreenContext)this.scrContext).getSelectedDevicesObservable().getComponent() != null) {
         ArrayList var2 = (ArrayList)((RRCScreenContext)this.scrContext).getSelectedDevicesObservable().getComponent();
         if (var2.get(0) != null) {
            var1 = (Device)var2.get(0);
            if (var1 instanceof Port && ((Device)var1).isConnected()) {
               Port var3 = (Port)var1;
               if (var3.getView() != null && (var3.getView() instanceof KvmView || var3.getView() instanceof RFBView)) {
                  return var3.getView().isCommandOperable(this);
               }
            }
         }
      }

      return false;
   }
}
