package com.raritan.rrc.ui.commands;

import com.raritan.rrc.data.Device;
import com.raritan.rrc.data.IPReach;
import com.raritan.rrc.ui.RRCScreenContext;
import com.raritan.tools.commands.AbstractCommand;
import com.raritan.tools.commands.CommandResult;
import com.raritan.tools.ui.ScreenContext;
import java.util.ArrayList;

public class ShowSaveUserConfigurationCommand extends AbstractCommand {
   public static final String COMMAND_KEY = "showSaveUserConfigurationCommand";

   public ShowSaveUserConfigurationCommand(ScreenContext var1) {
      super(var1);
   }

   @Override
   public String getKey() {
      return "showSaveUserConfigurationCommand";
   }

   @Override
   public CommandResult execute() {
      this.scrContext.getLogger().logTextDebug(" Started ");
      CommandResult var1 = new CommandResult(true, "");
      this.scrContext.getLogger().logTextDebug(" Finished ");
      return var1;
   }

   @Override
   public boolean isExecutable() {
      ArrayList var1 = (ArrayList)((RRCScreenContext)this.scrContext).getSelectedDevicesObservable().getComponent();
      if (var1 != null && var1.size() > 0) {
         Device var2 = (Device)var1.get(0);
         if (var2 != null && var2 instanceof IPReach && var2.isConnected() && ((IPReach)var2).isAdministrator()) {
            return var2.getHandler().isShowSaveUserConfigurationExecutable();
         }
      }

      return false;
   }
}
