package com.raritan.rrc.ui.commands;

import com.raritan.rrc.ui.MPCScanFrame;
import com.raritan.rrc.ui.RRCScreenContext;
import com.raritan.tools.commands.AbstractCommand;
import com.raritan.tools.commands.CommandResult;
import com.raritan.tools.ui.ScreenContext;

public class ShowScanFrameCommand extends AbstractCommand {
   public static final String COMMAND_KEY = "showScanFrameCommand";
   RRCScreenContext rrcScreenContext;

   public ShowScanFrameCommand(ScreenContext var1) {
      super(var1);
      this.rrcScreenContext = (RRCScreenContext)var1;
   }

   @Override
   public String getKey() {
      return "showScanFrameCommand";
   }

   @Override
   public CommandResult execute() {
      CommandResult var1 = new CommandResult();
      new MPCScanFrame(this.rrcScreenContext);
      var1.setIsSuccess(true);
      return var1;
   }

   @Override
   public boolean isExecutable() {
      RRCScreenContext var1 = (RRCScreenContext)this.scrContext;
      return var1 != null ? !var1.isScanFrameOpened() : false;
   }
}
