package com.raritan.rrc.ui.commands;

import com.raritan.rrc.data.Device;
import com.raritan.rrc.data.G2SerialPort;
import com.raritan.rrc.data.Port;
import com.raritan.rrc.data.PowerPort;
import com.raritan.rrc.data.SerialPort;
import com.raritan.rrc.data.SerialStream;
import com.raritan.rrc.ui.RRCScreenContext;
import com.raritan.tools.commands.AbstractCommand;
import com.raritan.tools.commands.CommandResult;
import com.raritan.tools.ui.ScreenContext;
import java.util.ArrayList;
import javaclientlib.tr.TRSRVR_SERIAL_PARAMS;

public class ShowSerialParametersCommand extends AbstractCommand {
   public static final String COMMAND_KEY = "showSerialParametersCommand";

   public ShowSerialParametersCommand(ScreenContext var1) {
      super(var1);
   }

   @Override
   public String getKey() {
      return "showSerialParametersCommand";
   }

   @Override
   public CommandResult execute() {
      this.scrContext.getLogger().logTextDebug(" Started ");
      CommandResult var1 = new CommandResult(true, "");
      ArrayList var2 = (ArrayList)((RRCScreenContext)this.scrContext).getSelectedDevicesObservable().getComponent();
      Port var3 = (Port)var2.get(0);
      if (var3.isConnected()) {
         TRSRVR_SERIAL_PARAMS var4 = new TRSRVR_SERIAL_PARAMS();

         try {
            if (!((SerialStream)var3.getStream()).getSerialStream(var4)) {
               var4 = null;
            }
         } catch (Exception var6) {
            var4 = null;
         }

         this.cmdContext.setCommandParameter("serialParams", var4);
      }

      this.scrContext.getLogger().logTextDebug(" Finished ");
      return var1;
   }

   @Override
   public boolean isExecutable() {
      ArrayList var1 = (ArrayList)((RRCScreenContext)this.scrContext).getSelectedDevicesObservable().getComponent();
      if (var1 != null && var1.size() > 0) {
         Device var2 = (Device)var1.get(0);
         if (var2 != null
            && var2 instanceof Port
            && var2.isConnected()
            && var2.getDeviceClass().equals("Serial")
            && !(var2 instanceof PowerPort)
            && !(var2 instanceof G2SerialPort)) {
            SerialPort var3 = (SerialPort)var2;
            if (!var3.isAdmin() && !var3.isDiagnosticPort()) {
               return true;
            }

            return false;
         }
      }

      return false;
   }
}
