package com.raritan.rrc.ui.commands;

import com.raritan.rrc.data.Device;
import com.raritan.rrc.data.Port;
import com.raritan.rrc.data.SerialPort;
import com.raritan.rrc.ui.RRCScreenContext;
import com.raritan.tools.commands.AbstractCommand;
import com.raritan.tools.commands.CommandResult;
import com.raritan.tools.resources.RaritanPropertyResourceBundle;
import com.raritan.tools.resources.RaritanResourceBundle;
import com.raritan.tools.ui.ScreenContext;
import java.util.ArrayList;
import javax.swing.JOptionPane;

public class ShowSerialPortCommand extends AbstractCommand {
   public static final String COMMAND_KEY = "showSerialPortCommand";
   private RaritanPropertyResourceBundle bundle = RaritanResourceBundle.getResourceBundle(this.scrContext.getLocale());

   public ShowSerialPortCommand(ScreenContext var1) {
      super(var1);
   }

   @Override
   public String getKey() {
      return "showSerialPortCommand";
   }

   @Override
   public CommandResult execute() {
      CommandResult var1 = new CommandResult();
      ArrayList var2 = (ArrayList)((RRCScreenContext)this.scrContext).getSelectedDevicesObservable().getComponent();
      SerialPort var3 = (SerialPort)var2.get(0);
      long var4 = Runtime.getRuntime().maxMemory() - Runtime.getRuntime().totalMemory() + Runtime.getRuntime().freeMemory();
      if (var3.isAdmin()) {
         if (7340032L >= var4) {
            var1.setStatusMessage(this.bundle.getString("outOfMemory.error"));
            var1.setIsSuccess(false);
            return var1;
         }
      } else if (3145728L >= var4) {
         var1.setStatusMessage(this.bundle.getString("outOfMemory.error"));
         var1.setIsSuccess(false);
         return var1;
      }

      var3.setContext(this.scrContext);
      if (var3.isConnected()) {
         var3.getTerminal().getVDU().setRequestFocusEnabled(true);
      }

      var1.setIsSuccess(true);
      return var1;
   }

   @Override
   public boolean isExecutable() {
      ArrayList var1 = (ArrayList)((RRCScreenContext)this.scrContext).getSelectedDevicesObservable().getComponent();
      if (var1 != null && var1.size() > 0) {
         Device var2 = (Device)var1.get(0);
         if (var2 != null && var2 instanceof Port && var2.getDeviceClass().equals("Serial") && !var2.isConnected()) {
            SerialPort var3 = (SerialPort)var2;
            if (var3.getTargetDeviceIdIntValue() == 255 && !var3.isAdministrator()) {
               RaritanPropertyResourceBundle var4 = RaritanResourceBundle.getResourceBundle(this.scrContext.getLocale());
               JOptionPane.showMessageDialog(null, var4.getString("AdminPortAccess.errorMsg"));
               return false;
            }

            if (((RRCScreenContext)this.scrContext).getOpenPortsObservable().getComponent() == null) {
               return true;
            }

            if (((RRCScreenContext)this.scrContext).getPortByKeyObservable((Port)var2) == null) {
               return true;
            }
         }
      }

      return false;
   }
}
