package com.raritan.rrc.ui.commands;

import com.raritan.rrc.data.Device;
import com.raritan.rrc.data.Port;
import com.raritan.rrc.ui.RRCScreenContext;
import com.raritan.rrc.ui.panes.DeviceView;
import com.raritan.tools.commands.AbstractCommand;
import com.raritan.tools.commands.CommandResult;
import com.raritan.tools.ui.ScreenContext;
import java.util.ArrayList;
import javaclientlib.utils.RRCLogger;

public class ShowSingleCursorInstructionCommand extends AbstractCommand {
   public static final String COMMAND_KEY = "showSingleCursorInstructionCommand";
   private String tooltipText = null;

   public ShowSingleCursorInstructionCommand(ScreenContext var1) {
      super(var1);
   }

   @Override
   public String getKey() {
      return "showSingleCursorInstructionCommand";
   }

   @Override
   public CommandResult execute() {
      this.scrContext.getLogger().logTextDebug(" Started ");
      RRCScreenContext var1 = (RRCScreenContext)this.scrContext;
      DeviceView var2 = var1.getSelectView();
      if (var2 != null) {
         var2.getCommandHandler().handleCommand(this, this.scrContext);
      } else {
         RRCLogger.log(100, 1, "View is null in ShowSingleCursorInstructionCommand");
      }

      this.scrContext.getLogger().logTextDebug(" Finished ");
      return new CommandResult(true, "");
   }

   @Override
   public boolean isExecutable() {
      Object var1 = null;
      this.tooltipText = null;
      if (this.scrContext != null
         && ((RRCScreenContext)this.scrContext).getSelectedDevicesObservable() != null
         && ((RRCScreenContext)this.scrContext).getSelectedDevicesObservable().getComponent() != null) {
         ArrayList var2 = (ArrayList)((RRCScreenContext)this.scrContext).getSelectedDevicesObservable().getComponent();
         if (var2.get(0) != null) {
            var1 = (Device)var2.get(0);
            if (var1 instanceof Port && ((Device)var1).isConnected()) {
               Port var3 = (Port)var1;
               if (var3.getDeviceClass().equalsIgnoreCase("KVM")) {
                  if (!var3.isTopLeft()) {
                     this.tooltipText = this.getBundle().getString("SingleMouseCursorAction.NotTopLeft");
                     return false;
                  }

                  if (var3.getView() != null) {
                     return var3.getView().isCommandOperable(this);
                  }
               }
            }
         }
      }

      return false;
   }

   public String getTooltipText() {
      return this.tooltipText;
   }
}
