package com.raritan.rrc.ui.commands;

import com.raritan.rrc.data.Device;
import com.raritan.rrc.data.Port;
import com.raritan.rrc.ui.RRCScreenContext;
import com.raritan.rrc.ui.panes.SerialView;
import com.raritan.tools.commands.AbstractCommand;
import com.raritan.tools.commands.CommandResult;
import com.raritan.tools.ui.ScreenContext;
import java.util.ArrayList;

public class ShowStartLoggingCommand extends AbstractCommand {
   public static final String COMMAND_KEY = "showStartLoggingCommand";

   public ShowStartLoggingCommand(ScreenContext var1) {
      super(var1);
   }

   @Override
   public String getKey() {
      return "showStartLoggingCommand";
   }

   @Override
   public CommandResult execute() {
      this.scrContext.getLogger().logTextDebug(" Started ");
      ArrayList var1 = (ArrayList)((RRCScreenContext)this.scrContext).getSelectedDevicesObservable().getComponent();
      if (var1 != null && var1.size() > 0) {
         Port var2 = (Port)var1.get(0);
         this.getContext().setCommandParameter("devices", var2);
      }

      CommandResult var3 = new CommandResult(true, "");
      this.scrContext.getLogger().logTextDebug(" Finished ");
      return var3;
   }

   @Override
   public boolean isExecutable() {
      ArrayList var1 = (ArrayList)((RRCScreenContext)this.scrContext).getSelectedDevicesObservable().getComponent();

      try {
         if (var1 != null && var1.size() > 0) {
            Device var2 = (Device)var1.get(0);
            if (var2 != null && var2 instanceof Port && var2.isConnected() && var2.getDeviceClass().equals("Serial")) {
               SerialView var3 = (SerialView)((Port)var2).getView();
               if (var3 != null && var3.getSerialTerminal() != null) {
                  return !var3.getSerialTerminal().isLogging();
               }
            }
         }
      } catch (ClassCastException var4) {
      }

      return false;
   }
}
