package com.raritan.rrc.ui.commands;

import com.raritan.rrc.data.Device;
import com.raritan.rrc.data.IPReach;
import com.raritan.rrc.ui.RRCScreenContext;
import com.raritan.tools.commands.AbstractCommand;
import com.raritan.tools.commands.CommandResult;
import com.raritan.tools.resources.RaritanPropertyResourceBundle;
import com.raritan.tools.resources.RaritanResourceBundle;
import com.raritan.tools.ui.ScreenContext;
import com.raritan.tools.ui.components.CommonPopups;
import java.util.ArrayList;

public class ShowUpdateDeviceCommand extends AbstractCommand {
   private String dlgText;
   private String[] buttons = new String[]{"basescreen.command.yes.text", "basescreen.command.no.text"};
   public static final String COMMAND_KEY = "showUpdateDeviceCommand";

   public ShowUpdateDeviceCommand(ScreenContext var1) {
      super(var1);
   }

   @Override
   public String getKey() {
      return "showUpdateDeviceCommand";
   }

   @Override
   public CommandResult execute() {
      ArrayList var1 = (ArrayList)((RRCScreenContext)this.scrContext).getSelectedDevicesObservable().getComponent();
      if (var1 != null && var1.size() > 0) {
         Device var2 = (Device)var1.get(0);
         if (var2 != null && var2 instanceof IPReach && var2.isConnected() && ((IPReach)var2).isAdministrator()) {
            var2.getHandler().doShowDeviceUpdateCommand(this);
         }
      }

      this.scrContext.getLogger().logTextDebug(" Started ");
      RaritanPropertyResourceBundle var5 = RaritanResourceBundle.getResourceBundle(this.scrContext.getLocale());
      int var3 = CommonPopups.showConfirmationDialog(
         var5.getString("confirmation.dialog.showupdatedevicecommand.execution.title"), this.dlgText, null, this.scrContext, this.buttons
      );
      CommandResult var4 = new CommandResult(true, "");
      if (var3 != 2) {
         var4.setIsSuccess(false);
      }

      this.scrContext.getLogger().logTextDebug(" Finished ");
      return var4;
   }

   public void setText(boolean var1, int var2) {
      RaritanPropertyResourceBundle var3 = RaritanResourceBundle.getResourceBundle(this.scrContext.getLocale());
      if (var1) {
         this.dlgText = var3.getString("confirmation.dialog.showupdatedevicecommand.execution.text.kxonly1")
            + " "
            + var2
            + " "
            + var3.getString("generic.dialog.minutes.text")
            + " "
            + var3.getString("confirmation.dialog.showupdatedevicecommand.execution.text.kxonly15")
            + var3.getString("confirmation.dialog.showupdatedevicecommand.execution.text.kxonly2");
         this.buttons = new String[]{"basescreen.command.ok.text", "basescreen.command.cancel.text"};
      } else {
         this.dlgText = var3.getString("confirmation.dialog.showupdatedevicecommand.execution.text.1")
            + var3.getString("confirmation.dialog.showupdatedevicecommand.execution.text.2");
         this.buttons = new String[]{"basescreen.command.yes.text", "basescreen.command.no.text"};
      }
   }

   @Override
   public boolean isExecutable() {
      ArrayList var1 = (ArrayList)((RRCScreenContext)this.scrContext).getSelectedDevicesObservable().getComponent();
      if (var1 == null) {
         return false;
      } else {
         if (var1.size() > 0) {
            Device var2 = (Device)var1.get(0);
            if (var2 != null && var2 instanceof IPReach && var2.isConnected() && ((IPReach)var2).isAdministrator()) {
               if (var2.isModemProfiled()) {
                  return false;
               }

               this.setText(var2.isModelKX(), var2.getUpgradeDuration());
               return true;
            }
         }

         return false;
      }
   }
}
