package com.raritan.rrc.ui.commands;

import com.raritan.rrc.data.Device;
import com.raritan.rrc.data.IPReach;
import com.raritan.rrc.ui.RRCScreenContext;
import com.raritan.tools.commands.AbstractCommand;
import com.raritan.tools.commands.CommandContext;
import com.raritan.tools.commands.CommandResult;
import com.raritan.tools.ui.ScreenContext;
import java.util.ArrayList;
import javaclientlib.utils.RRCLogger;

public class ShowUserPasswordCommand extends AbstractCommand {
   public static final String COMMAND_KEY = "showUserPasswordCommand";

   public ShowUserPasswordCommand(ScreenContext var1) {
      super(var1);
   }

   @Override
   public String getKey() {
      return "showUserPasswordCommand";
   }

   @Override
   public CommandResult execute() {
      this.scrContext.getLogger().logTextDebug(" Started ");
      CommandResult var1 = new CommandResult(true, "");
      CommandContext var2 = this.getContext();
      var2.setCommandParameter("devices", (Device)((ArrayList)((RRCScreenContext)this.scrContext).getSelectedDevicesObservable().getComponent()).get(0));
      var2.setCommandParameter("userInvokedChangePassword", new Boolean(false));
      this.scrContext.getLogger().logTextDebug(" Finished ");
      return var1;
   }

   @Override
   public boolean isExecutable() {
      try {
         ArrayList var1 = (ArrayList)((RRCScreenContext)this.scrContext).getSelectedDevicesObservable().getComponent();
         if (var1 == null) {
            return false;
         }

         if (var1.size() > 0) {
            Device var2 = (Device)var1.get(0);
            if (var2 != null && var2 instanceof IPReach && var2.isConnected()) {
               return true;
            }
         }
      } catch (Exception var3) {
         RRCLogger.logException(var3);
      }

      return false;
   }
}
