package com.raritan.rrc.ui.commands;

import com.raritan.rrc.data.Device;
import com.raritan.rrc.data.Port;
import com.raritan.rrc.ui.RRCScreenContext;
import com.raritan.rrc.ui.panes.DeviceView;
import com.raritan.tools.commands.AbstractCommand;
import com.raritan.tools.commands.CommandResult;
import com.raritan.tools.ui.ScreenContext;
import com.raritan.tools.ui.components.CommandCheckMenuItem;
import java.util.ArrayList;

public class ShowVideoScaleCommand extends AbstractCommand {
   public static final String COMMAND_KEY = "showVideoScaleCommand";

   public ShowVideoScaleCommand(ScreenContext var1) {
      super(var1);
   }

   @Override
   public String getKey() {
      return "showVideoScaleCommand";
   }

   @Override
   public CommandResult execute() {
      if (this.isExecutable()) {
         Port var1 = ((RRCScreenContext)this.scrContext).getSelectedPort();
         if (var1 != null && var1.getDeviceClass().equals("KVM") && var1.isConnected()) {
            DeviceView var2 = var1.getView();
            if (var2 != null) {
               boolean var3 = (Boolean)this.getContext().getCommandParameter("scaleVideoMode");
               var2.setScaleVideoFlag(var3);
               RRCScreenContext var4 = (RRCScreenContext)this.scrContext;

               for (CommandCheckMenuItem var6 : var4.getMainScreenMediator().getCheckScaleVideoMenuItems()) {
                  var6.setSelected(var3);
               }

               var4.getMainScreenMediator().getToolBarScaleVideoButton().setSelected(var3);
            }
         }
      }

      return new CommandResult();
   }

   @Override
   public boolean isExecutable() {
      Object var1 = null;
      if (this.scrContext != null
         && ((RRCScreenContext)this.scrContext).getSelectedDevicesObservable() != null
         && ((RRCScreenContext)this.scrContext).getSelectedDevicesObservable().getComponent() != null) {
         ArrayList var2 = (ArrayList)((RRCScreenContext)this.scrContext).getSelectedDevicesObservable().getComponent();
         if (var2.get(0) != null) {
            var1 = (Device)var2.get(0);
            if (var1 instanceof Port && ((Device)var1).isConnected()) {
               Port var3 = (Port)var1;
               if (var3.getDeviceClass().equalsIgnoreCase("KVM")) {
                  DeviceView var4 = var3.getView();
                  if (var4 != null && var4.isScaleVideoFlag()) {
                     for (CommandCheckMenuItem var6 : ((RRCScreenContext)this.scrContext).getMainScreenMediator().getCheckScaleVideoMenuItems()) {
                        var6.setSelected(true);
                     }

                     ((RRCScreenContext)this.scrContext).getMainScreenMediator().getToolBarScaleVideoButton().setSelected(true);
                  }

                  return true;
               }
            }
         }
      }

      return false;
   }
}
