package com.raritan.rrc.ui.commands;

import com.raritan.rrc.data.KvmPort;
import com.raritan.rrc.ui.RRCScreenContext;
import com.raritan.tools.commands.AbstractCommand;
import com.raritan.tools.ui.ScreenContext;
import java.util.ArrayList;
import javax.swing.Action;

public class SmartCardMenuCommand extends AbstractCommand {
   public static final String COMMAND_KEY = "SmartCardMenuCommand";

   public SmartCardMenuCommand(ScreenContext var1) {
      super(var1);
   }

   @Override
   public String getKey() {
      return "SmartCardMenuCommand";
   }

   @Override
   public boolean isExecutable() {
      KvmPort var1 = this.getKvmPort();
      return var1 != null && var1.isConnected() ? this.getAction(var1).isEnabled() : false;
   }

   public String getToolTip() {
      KvmPort var1 = this.getKvmPort();
      return var1 != null ? (String)this.getAction(var1).getValue("ShortDescription") : null;
   }

   private KvmPort getKvmPort() {
      ArrayList var1 = (ArrayList)((RRCScreenContext)this.scrContext).getSelectedDevicesObservable().getComponent();
      return var1 != null && var1.size() != 0 && var1.get(0) instanceof KvmPort ? (KvmPort)var1.get(0) : null;
   }

   protected Action getAction(KvmPort var1) {
      return var1.getSmartCardAction();
   }
}
