package com.raritan.rrc.ui.commands;

import com.raritan.rrc.ui.RRCScreenContext;
import com.raritan.tools.commands.AbstractCommand;
import com.raritan.tools.commands.CommandResult;
import com.raritan.tools.ui.components.RaritanDesktopPane;
import com.raritan.tools.ui.panes.displays.ShellInternalFrame;
import java.beans.PropertyVetoException;
import java.util.HashMap;
import javax.swing.JInternalFrame;

public class TileWindowsCommand extends AbstractCommand {
   public static final String COMMAND_KEY = "tileWindowsCommand";

   public TileWindowsCommand(RRCScreenContext var1) {
      super(var1);
   }

   @Override
   public String getKey() {
      return "tileWindowsCommand";
   }

   @Override
   public CommandResult execute() {
      this.scrContext.getLogger().logTextDebug(" Started ");
      this.tileWindows();
      this.scrContext.getLogger().logTextDebug(" Finished ");
      return new CommandResult();
   }

   @Override
   public boolean isExecutable() {
      HashMap var1 = (HashMap)((RRCScreenContext)this.scrContext).getOpenPortsObservable().getComponent();
      return var1 != null && var1.size() > 1;
   }

   public void tileWindows() {
      RaritanDesktopPane var1 = (RaritanDesktopPane)this.scrContext.getPanelMediator().getParent();
      JInternalFrame[] var2 = var1.getAllFrames();
      JInternalFrame var3 = var1.getSelectedFrame();
      int var4 = var2.length;

      for (int var5 = var4 - 1; var5 >= 0; var5--) {
         ShellInternalFrame var6 = (ShellInternalFrame)var2[var5];
         var6.removeInternalFrameListener(var6);
         if (var2[var5].isIcon()) {
            try {
               var2[var5].setIcon(false);
            } catch (PropertyVetoException var16) {
            }
         }
      }

      int var17 = (int)Math.sqrt(var4);
      int var18 = var4 / var17;
      int var7 = var4 % var17;
      int var8 = var1.getWidth() / var17;
      int var9 = var1.getHeight() / var18;
      int var10 = 0;
      int var11 = 0;

      for (int var12 = var4 - 1; var12 >= 0; var12--) {
         try {
            var2[var12].setMaximum(false);
            var2[var12].reshape(var11 * var8, var10 * var9, var8, var9);
            if (++var11 == var17) {
               var11 = 0;
               if (++var10 == var18 - var7) {
                  var17++;
                  var8 = var1.getWidth() / var17;
               }
            }

            var2[var12].setSelected(false);
            ShellInternalFrame var13 = (ShellInternalFrame)var2[var12];
            var13.addInternalFrameListener(var13);
         } catch (PropertyVetoException var15) {
         }
      }

      if (var3 != null) {
         try {
            var3.setSelected(true);
         } catch (PropertyVetoException var14) {
         }
      }
   }
}
