package com.raritan.rrc.ui.commands;

import com.raritan.rrc.data.KvmPort;
import com.raritan.rrc.data.USBProfilesInfo;
import com.raritan.rrc.ui.RRCScreenContext;
import com.raritan.tools.commands.AbstractCommand;
import com.raritan.tools.ui.ScreenContext;
import java.util.ArrayList;

public class USBProfileCommand extends AbstractCommand {
   public static final String COMMAND_KEY = "USBProfileCommand";

   public USBProfileCommand(ScreenContext var1) {
      super(var1);
   }

   @Override
   public String getKey() {
      return "USBProfileCommand";
   }

   @Override
   public boolean isExecutable() {
      ArrayList var1 = (ArrayList)((RRCScreenContext)this.scrContext).getSelectedDevicesObservable().getComponent();
      if (var1 != null && var1.size() != 0 && var1.get(0) instanceof KvmPort) {
         KvmPort var2 = (KvmPort)var1.get(0);
         if (var2.isConnected()) {
            USBProfilesInfo var3 = var2.getUsbProfilesInfo();
            if (var3 != null) {
               return var3.getUSBProfiles().size() > 0;
            }
         }

         return false;
      } else {
         return false;
      }
   }
}
