package com.raritan.rrc.ui.components;

import com.raritan.rrc.data.Port;
import com.raritan.rrc.data.VirtualMediaBean;
import com.raritan.rrc.data.VirtualMediaLocalBean;
import com.raritan.rrc.ui.RRCScreenContext;
import com.raritan.tools.commands.AbstractCommand;
import com.raritan.tools.resources.RaritanPropertyResourceBundle;
import com.raritan.tools.resources.RaritanResourceBundle;
import com.raritan.tools.ui.ScreenContext;
import com.raritan.tools.ui.components.CommandMenuItem;
import com.raritan.tools.ui.components.RaritanPopupMenu;
import java.util.ArrayList;
import java.util.List;
import java.util.Locale;
import java.util.Map;
import javax.swing.event.PopupMenuEvent;
import javax.swing.event.PopupMenuListener;
import nn.pp.core.Platform;

public class ContextMenuDevice extends RaritanPopupMenu implements PopupMenuListener {
   private static final long serialVersionUID = 4350799418719060415L;
   private AbstractCommand loginCommand;
   private List context = new ArrayList();
   int vitrualMediaConnect = 0;
   private CommandMenuItem menuItem = null;
   private ScreenContext scrContext;

   public ContextMenuDevice(ScreenContext var1, AbstractCommand var2) {
      super(var1);
      this.scrContext = var1;
      this.loginCommand = var2;
      this.setContext();
      this.addContext(this.context);
      this.addPopupMenuListener(this);
   }

   public ContextMenuDevice(ScreenContext var1, AbstractCommand var2, int var3) {
      super(var1);
      this.scrContext = var1;
      this.loginCommand = var2;
      this.setContext();
      this.addContext(this.context);
      this.addPopupMenuListener(this);
      this.vitrualMediaConnect = var3;
   }

   @Override
   public void setContext() {
      this.menuItem = new CommandMenuItem(this.bundle.getString(MenuItemResourceBundleConstants.NEW_CONNECTION_ACTION_NAME), this.scrContext);
      this.menuItem.addActionListener(this.mali);
      this.menuItem.addObservable(((RRCScreenContext)this.scrContext).getSelectedDevicesObservable());
      this.menuItem.setCommand(this.loginCommand);
      if (this.scrContext.getLocale() == Locale.US || this.scrContext.getLocale() == Locale.UK) {
         this.menuItem.setDisplayedMnemonicIndex(Integer.parseInt(this.bundle.getString(MenuItemResourceBundleConstants.NEW_CONNECTION_ACTION_MNEMONIC_INDEX)));
      }

      this.menuItem.setMnemonic(new Character(this.bundle.getString(MenuItemResourceBundleConstants.NEW_CONNECTION_ACTION_MNEMONIC).toCharArray()[0]));
      this.context.add(this.menuItem);
      this.context.addAll(CommandMenuItemCache.getInstance(this.scrContext, this.mali).getCommandMenuItems());
      this.refreshExecuteStatus();
   }

   private void refreshExecuteStatus() {
      Port var1 = null;
      ArrayList var2 = (ArrayList)((RRCScreenContext)this.scrContext).getSelectedDevicesObservable().getComponent();
      if (var2 != null && var2.size() != 0 && var2.get(0) instanceof Port) {
         var1 = (Port)var2.get(0);
      }

      if (var1 != null) {
         RaritanPropertyResourceBundle var3 = RaritanResourceBundle.getResourceBundle(this.scrContext.getLocale());
         String var4 = "";
         var4 = var1.getViewName() + var1.getPortIndex();
         Map var5 = this.scrContext.getVirtualMediaLocalMap();
         Map var6 = this.scrContext.getVirtualMediaImageMap();
         if (var5 != null && var5.size() > 0) {
            VirtualMediaLocalBean var7 = (VirtualMediaLocalBean)var5.get(var4);
            if (var7 != null && var7.isDriveConnected()) {
               CommandMenuItemCache.getInstance().getVirtualMediaLocalMenu().setText(var3.getString("VirtualMediaDisconnect") + " " + var7.getConnectedDrive());
            } else {
               CommandMenuItemCache.getInstance().getVirtualMediaLocalMenu().setText(var3.getString("VirtualMediaLocalConnect.name"));
            }
         } else {
            CommandMenuItemCache.getInstance().getVirtualMediaLocalMenu().setText(var3.getString("VirtualMediaLocalConnect.name"));
         }

         if (!Platform.isVirtualMediaSupported()) {
            CommandMenuItemCache.getInstance().getVirtualMediaLocalMenu().setEnabled(false);
         }

         if (var6 != null && var6.size() > 0) {
            VirtualMediaBean var9 = (VirtualMediaBean)var6.get(var4);
            if (var9 != null && var9.isDriveConnected()) {
               CommandMenuItemCache.getInstance().getVirtualMediaImageMenu().setText(var3.getString("VirtualMediaDisconnect") + " " + var9.getConnectedDrive());
            } else {
               CommandMenuItemCache.getInstance().getVirtualMediaImageMenu().setText(var3.getString("VirtualMediaImageConnect.name"));
            }
         } else {
            CommandMenuItemCache.getInstance().getVirtualMediaImageMenu().setText(var3.getString("VirtualMediaImageConnect.name"));
         }
      }
   }

   @Override
   public void popupMenuCanceled(PopupMenuEvent var1) {
   }

   @Override
   public void popupMenuWillBecomeInvisible(PopupMenuEvent var1) {
      this.menuItem.removeObservable(((RRCScreenContext)this.scrContext).getSelectedDevicesObservable());
      Thread var2 = new Thread() {
         @Override
         public void run() {
            ((RRCScreenContext)ContextMenuDevice.this.scrContext).resetDefaultFocus();
         }
      };
      var2.start();
   }

   @Override
   public void popupMenuWillBecomeVisible(PopupMenuEvent var1) {
   }
}
