package com.raritan.rrc.ui.components;

import java.awt.event.KeyEvent;
import java.util.StringTokenizer;
import javax.swing.JTextField;
import javax.swing.LayoutFocusTraversalPolicy;

public class JIPTextField extends TextGroup {
   private MyFocusTraversalPolicy customFocusTraversalPolicy = new MyFocusTraversalPolicy(this);
   private LayoutFocusTraversalPolicy defaultFocusTraversalPolicy = new LayoutFocusTraversalPolicy();

   public JIPTextField(String var1, String var2) {
      super(var1, var2, new IntegerValidator(0, 255, null));
      this.setFocusTraversalPolicy(this.customFocusTraversalPolicy);
      this.setFocusTraversalPolicyProvider(true);
      this.setFocusCycleRoot(true);
   }

   @Override
   public void setEnabled(boolean var1) {
      this.setFocusTraversalPolicyProvider(var1);
      if (var1) {
         this.setFocusTraversalPolicy(this.customFocusTraversalPolicy);
      } else {
         this.setFocusTraversalPolicy(this.defaultFocusTraversalPolicy);
      }

      super.setEnabled(var1);
   }

   @Override
   public MaskTextField getMaskTextField(String var1, FieldValidator var2) {
      return new IPMaskTextField(var1.length(), var1);
   }

   @Override
   public void keyPressed(KeyEvent var1) {
      super.keyPressed(var1);
      JTextField var2 = (JTextField)var1.getSource();
      switch (var1.getKeyCode()) {
         case 46:
         case 110:
            this.tab(var2, 1);
         case 8:
         case 127:
      }
   }

   @Override
   public void setText(String var1) {
      StringTokenizer var2 = new StringTokenizer(var1, ".", false);
      int var3 = 0;

      while (var2.hasMoreElements()) {
         this.setText(var3++, var2.nextElement().toString());
      }
   }
}
