package com.raritan.rrc.ui.components;

import javax.swing.JTextField;
import javax.swing.text.AttributeSet;
import javax.swing.text.BadLocationException;
import javax.swing.text.Document;
import javax.swing.text.PlainDocument;

public class NumericField extends JTextField {
   private static final long serialVersionUID = -4013432194469899484L;

   public NumericField() {
   }

   public NumericField(String var1) {
      super(var1);
   }

   public NumericField(String var1, int var2) {
      super(var1, var2);
   }

   @Override
   protected Document createDefaultModel() {
      return new NumericField.NumericDocument();
   }

   static class NumericDocument extends PlainDocument {
      private static final long serialVersionUID = -7735266372856720168L;

      @Override
      public void insertString(int var1, String var2, AttributeSet var3) throws BadLocationException {
         for (int var4 = var2.length() - 1; var4 >= 0; var4--) {
            if (Character.isDigit(var2.charAt(var4))) {
               super.insertString(var1, var2.substring(var4, var4 + 1), var3);
            }
         }
      }
   }
}
