package com.raritan.rrc.ui.components;

import com.raritan.rrc.ui.RRCScreenContext;
import com.raritan.rrc.ui.commands.ShowScanFrameCommand;
import com.raritan.tools.ui.ScreenContext;
import com.raritan.tools.ui.components.CommandMenuItem;
import com.raritan.tools.ui.components.RaritanPopupMenu;
import java.util.ArrayList;
import java.util.List;
import java.util.Locale;
import javax.swing.event.PopupMenuEvent;
import javax.swing.event.PopupMenuListener;

public class ScanPopupMenu extends RaritanPopupMenu implements PopupMenuListener {
   private CommandMenuItem menuItem = null;
   private List<CommandMenuItem> context = new ArrayList<>();
   private RRCScreenContext screenContext;

   public ScanPopupMenu(ScreenContext var1) {
      super(var1);
      this.screenContext = (RRCScreenContext)var1;
      this.setContext();
      this.addContext(this.context);
   }

   @Override
   public void popupMenuCanceled(PopupMenuEvent var1) {
   }

   @Override
   public void popupMenuWillBecomeInvisible(PopupMenuEvent var1) {
   }

   @Override
   public void popupMenuWillBecomeVisible(PopupMenuEvent var1) {
   }

   @Override
   public void setContext() {
      this.menuItem = new CommandMenuItem(this.bundle.getString(MenuItemResourceBundleConstants.SCAN_START), this.scrContext);
      this.menuItem.addActionListener(this.mali);
      this.menuItem.setCommand(new ShowScanFrameCommand(this.screenContext));
      if (this.scrContext.getLocale() == Locale.US || this.scrContext.getLocale() == Locale.UK) {
         this.menuItem.setDisplayedMnemonicIndex(Integer.parseInt(this.bundle.getString(MenuItemResourceBundleConstants.SCAN_START_MNEMONIC_INDEX)));
      }

      this.menuItem.setMnemonic(new Character(this.bundle.getString(MenuItemResourceBundleConstants.SCAN_START_MNEMONIC).toCharArray()[0]));
      this.context.add(this.menuItem);
   }
}
