package com.raritan.rrc.ui.models;

import com.raritan.rrc.data.BladeChassis;
import com.raritan.rrc.data.Device;
import com.raritan.rrc.data.KvmPort;
import com.raritan.rrc.data.MultiMonitorPort;
import com.raritan.rrc.data.Paragon;
import com.raritan.rrc.data.Port;
import com.raritan.rrc.data.VirtualBladeChassis;
import com.raritan.rrc.ui.RRCScreenContext;
import com.raritan.rrc.ui.commands.DoDialCommand;
import com.raritan.rrc.ui.commands.DoLoginCommand;
import com.raritan.rrc.ui.commands.DoSwitchCommand;
import com.raritan.rrc.ui.commands.PopulateParagonPortsCommand;
import com.raritan.rrc.ui.commands.ShowKX2KvmPortCommand;
import com.raritan.rrc.ui.commands.ShowLoginCommand;
import com.raritan.rrc.ui.components.ContextMenuDevice;
import com.raritan.rrc.ui.components.ScanPopupMenu;
import com.raritan.rrc.util.MPCUtil;
import com.raritan.rrc.util.OS;
import com.raritan.tools.commands.AbstractCommand;
import com.raritan.tools.commands.CommandResult;
import com.raritan.tools.resources.RaritanPropertyResourceBundle;
import com.raritan.tools.resources.RaritanResourceBundle;
import com.raritan.tools.ui.ScreenContext;
import com.raritan.tools.ui.components.CommonPopups;
import java.awt.Component;
import java.awt.Rectangle;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.lang.reflect.Constructor;
import java.util.ArrayList;
import java.util.Map;
import javaclientlib.utils.RRCLogger;
import javax.swing.JTree;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.TreePath;

public class DeviceMouseListener extends MouseAdapter {
   protected RRCScreenContext scrContext;
   protected AbstractCommand command;
   private RaritanPropertyResourceBundle bundle;

   public DeviceMouseListener(ScreenContext var1) {
      this.scrContext = (RRCScreenContext)var1;
      if (this.scrContext != null) {
         this.bundle = RaritanResourceBundle.getResourceBundle(var1.getLocale());
      }
   }

   @Override
   public void mouseClicked(MouseEvent var1) {
      JTree var2 = (JTree)var1.getSource();
      int var3 = var2.getRowForLocation(var1.getX(), var1.getY());
      TreePath var4 = var2.getPathForLocation(var1.getX(), var1.getY());
      if (var4 == null) {
         this.scrContext.resetDefaultFocus();
      } else {
         DefaultMutableTreeNode var5 = (DefaultMutableTreeNode)var4.getLastPathComponent();
         if (var3 != -1 && var1.getClickCount() == 2 && var1.getButton() == 1) {
            Object var6 = null;

            try {
               if (var5.getUserObject() instanceof Port) {
                  Port var21 = (Port)var5.getUserObject();
                  Device var8 = var21.getDevice();
                  if (var21 instanceof KvmPort) {
                     this.command = new DoSwitchCommand(this.scrContext);
                     if (!this.command.isExecutable()) {
                        String var9 = var21.getClass().getName();
                        int var10 = var9.lastIndexOf(46);
                        var9 = var9.substring(var10 + 1);
                        String var11 = var21.getDevice().getHandler().getCommandClassName(var9);
                        Class var12 = Class.forName(var11);
                        Constructor var13 = var12.getConstructor(ScreenContext.class);
                        this.command = (AbstractCommand)var13.newInstance(this.scrContext);
                     }

                     if (this.command.isExecutable()) {
                        this.command.getContext().setCommandParameter("selectedPortDevice", var8);
                        CommandResult var23 = this.command.execute();
                        if (!var23.isSuccess() && !var23.hasErrorDescription()) {
                           return;
                        }

                        if (!var23.isSuccess() && var23.hasErrorDescription()) {
                           this.handleCommandResultErrorDescription(var23);
                        } else {
                           this.handleCommandResult(var23);
                           this.scrContext.getPanelMediator().showPanel(this.command.getContext());
                           if (this.command instanceof ShowKX2KvmPortCommand && var21.isPrimaryPort()) {
                              ArrayList var27 = (ArrayList)this.scrContext.getSelectedDevicesObservable().getComponent();
                              if (var27 != null && var27.size() > 0) {
                                 for (MultiMonitorPort.PortConfig var33 : var21.getSecondaryPortConfigs()) {
                                    Map var14 = var21.getDevice().getChildren();
                                    if (var14 != null) {
                                       for (Object var16 : var14.values()) {
                                          Port var17;
                                          if (var16 instanceof Port && (var17 = (Port)var16).getTargetDeviceId().equals(var33.getPortId())) {
                                             var27.set(0, var17);
                                             ShowKX2KvmPortCommand var18 = new ShowKX2KvmPortCommand(this.scrContext);
                                             var18.setAllowSecondary(true);
                                             if (var18.isExecutable()) {
                                                var18.getContext().setCommandParameter("selectedPortDevice", var8);
                                                var23 = var18.execute();
                                                if (!var23.isSuccess() && var23.hasErrorDescription()) {
                                                   this.handleCommandResultErrorDescription(var23);
                                                } else if (var23.isSuccess()) {
                                                   this.handleCommandResult(var23);
                                                   this.scrContext.getPanelMediator().showPanel(var18.getContext());
                                                }
                                             }
                                             break;
                                          }
                                       }
                                    }
                                 }
                              }

                              var21.getBaseDevice().setActiveKvmPort((KvmPort)var21);
                           }
                        }
                     }

                     this.scrContext.resetDefaultFocus();
                  } else {
                     String var25 = var21.getClass().getName();
                     int var28 = var25.lastIndexOf(46);
                     var25 = var25.substring(var28 + 1);
                     String var30 = var21.getDevice().getHandler().getCommandClassName(var25);
                     Class var32 = Class.forName(var30);
                     Constructor var34 = var32.getConstructor(ScreenContext.class);
                     this.command = (AbstractCommand)var34.newInstance(this.scrContext);
                     this.command.getContext().setCommandParameter("selectedPortDevice", var8);
                     if (this.command.isExecutable()) {
                        CommandResult var35 = this.command.execute();
                        if (!var35.isSuccess() && var35.hasErrorDescription()) {
                           this.handleCommandResultErrorDescription(var35);
                        } else {
                           this.handleCommandResult(var35);
                           this.scrContext.getPanelMediator().showPanel(this.command.getContext());
                        }
                     }

                     this.scrContext.resetDefaultFocus();
                  }
               } else if (var5.getUserObject() instanceof Device && !((Device)var5.getUserObject()).isConnected()) {
                  var6 = (Device)var5.getUserObject();
                  if (var6 instanceof Paragon) {
                     this.command = new PopulateParagonPortsCommand(this.scrContext);
                  } else {
                     if (var6 instanceof BladeChassis || var6 instanceof VirtualBladeChassis) {
                        return;
                     }

                     this.command = new ShowLoginCommand(this.scrContext);
                     if (((Device)var6).isModemProfiled()) {
                        this.command.getContext().setCommandParameter("ok_command", new DoDialCommand(this.scrContext));
                     } else {
                        this.command.getContext().setCommandParameter("ok_command", new DoLoginCommand(this.scrContext));
                     }
                  }

                  if (var6 != null && this.command.isExecutable()) {
                     this.command.getContext().setCommandParameter("devices", var6);
                     CommandResult var7 = this.command.execute();
                     if (!var7.isSuccess() && var7.hasErrorDescription()) {
                        this.handleCommandResultErrorDescription(var7);
                     } else {
                        this.handleCommandResult(var7);
                        this.scrContext.getPanelMediator().showPanel(this.command.getContext());
                     }
                  }

                  this.scrContext.resetDefaultFocus();
               }
            } catch (Exception var19) {
               var19.printStackTrace();
               RRCLogger.logException(var19);
            }
         }
      }
   }

   @Override
   public void mousePressed(MouseEvent var1) {
      if (var1.isPopupTrigger()) {
         JTree var2 = (JTree)var1.getSource();
         TreePath[] var3 = var2.getSelectionPaths();
         if (var3 != null) {
            ArrayList var4 = new ArrayList(var3.length);
            if (var3.length > 1) {
               if (var3.length > 32) {
                  CommonPopups.showCommandResultErrorMessage(this.bundle.getString("Scan.more.ports"), null, this.scrContext);
                  return;
               }

               for (int var5 = 0; var5 < var3.length; var5++) {
                  TreePath var6 = var3[var5];
                  DefaultMutableTreeNode var7 = (DefaultMutableTreeNode)var6.getLastPathComponent();
                  Object var8 = var7.getUserObject();
                  if (var8 instanceof KvmPort) {
                     KvmPort var9 = (KvmPort)var8;
                     if (!var9.isSecondaryPort()) {
                        var4.add(var9);
                     }
                  }
               }

               this.scrContext.setKvmPortsForScan(var4);
               this.showScanPopup(var1);
            } else if (var3.length == 1) {
               RRCLogger.log(300, 512, "Showing popup menu");
               this.showPopupEventually(var1);
            }
         }
      } else {
         RRCLogger.log(300, 512, "Popupmenu is already visible");
      }
   }

   @Override
   public void mouseReleased(MouseEvent var1) {
      if (var1.isPopupTrigger()) {
         JTree var2 = (JTree)var1.getSource();
         TreePath[] var3 = var2.getSelectionPaths();
         if (var3 != null) {
            ArrayList var4 = new ArrayList(var3.length);
            if (var3.length > 1) {
               if (var3.length > 32) {
                  CommonPopups.showCommandResultErrorMessage(this.bundle.getString("Scan.more.ports"), null, this.scrContext);
                  return;
               }

               for (int var5 = 0; var5 < var3.length; var5++) {
                  TreePath var6 = var3[var5];
                  DefaultMutableTreeNode var7 = (DefaultMutableTreeNode)var6.getLastPathComponent();
                  Object var8 = var7.getUserObject();
                  if (var8 instanceof KvmPort) {
                     KvmPort var9 = (KvmPort)var8;
                     if (!var9.isSecondaryPort()) {
                        var4.add(var9);
                     }
                  }
               }

               this.scrContext.setKvmPortsForScan(var4);
               this.showScanPopup(var1);
            } else if (var3.length == 1) {
               RRCLogger.log(300, 512, "Showing popup menu");
               this.showPopupEventually(var1);
            }
         }
      } else {
         RRCLogger.log(300, 512, "Popupmenu is already visible");
      }
   }

   private void showScanPopup(MouseEvent var1) {
      if (var1.isPopupTrigger() && var1.getSource() instanceof JTree) {
         int var2 = var1.getX();
         int var3 = var1.getY();
         JTree var4 = (JTree)var1.getSource();
         Component var5 = var1.getComponent();
         ScanPopupMenu var6 = new ScanPopupMenu(this.scrContext);
         var6.show(var5, var2, var3);
         if (OS.getCurrent() == OS.MAC) {
            var6.repaint();
         }

         if (this.scrContext.isScanFrameOpened()) {
            var6.setEnabled(false);
         }
      }
   }

   private void showPopupEventually(MouseEvent var1) {
      if (var1.isPopupTrigger() && var1.getSource() instanceof JTree) {
         int var2 = var1.getX();
         int var3 = var1.getY();
         JTree var4 = (JTree)var1.getSource();

         try {
            Rectangle var5 = var4.getRowBounds(var4.getRowForLocation(var2, var3));
            int var6 = var4.getRowForLocation(var1.getX(), var1.getY());
            TreePath var7 = var4.getPathForRow(var6);
            DefaultMutableTreeNode var8 = (DefaultMutableTreeNode)var7.getLastPathComponent();
            if (var8.getUserObject() instanceof Port) {
               Port var9 = (Port)var8.getUserObject();
               Device var10 = var9.getDevice();
               String var11 = var9.getClass().getName();
               int var12 = var11.lastIndexOf(46);
               var11 = var11.substring(var12 + 1);
               String var13 = var9.getDevice().getHandler().getCommandClassName(var11);
               Class var14 = Class.forName(var13);
               Constructor var15 = var14.getConstructor(ScreenContext.class);
               this.command = (AbstractCommand)var15.newInstance(this.scrContext);
               this.command.getContext().setCommandParameter("selectedPortDevice", var10);
            } else if (var8.getUserObject() instanceof Device && var6 != 0) {
               if (var8.getUserObject() instanceof Paragon) {
                  this.command = new PopulateParagonPortsCommand(this.scrContext);
               } else {
                  this.command = new ShowLoginCommand(this.scrContext);
                  if (((Device)var8.getUserObject()).isModemProfiled()) {
                     this.command.getContext().setCommandParameter("ok_command", new DoDialCommand(this.scrContext));
                  } else {
                     this.command.getContext().setCommandParameter("ok_command", new DoLoginCommand(this.scrContext));
                  }
               }
            }

            if (var5 != null && var6 != 0) {
               Component var17 = var1.getComponent();
               TreePath var18 = var4.getPathForLocation(var2, var3);
               var4.setSelectionPath(var18);
               MPCUtil.notifyObservers(this.scrContext, (Device)var8.getUserObject());
               ContextMenuDevice var20 = new ContextMenuDevice(this.scrContext, this.command);
               var20.show(var17, var2, var3);
               if (OS.getCurrent() == OS.MAC) {
                  var20.repaint();
               }
            }
         } catch (Exception var16) {
         }
      }
   }

   protected void handleCommandResult(CommandResult var1) {
      if (var1 != null) {
         this.scrContext.getLogger().logStatus(var1.getStatusMessage());
         this.scrContext.getLogger().logTextInfo(var1.getStatusMessage());
      }
   }

   protected void handleCommandResultErrorDescription(CommandResult var1) {
      if (var1 != null) {
         StringBuffer var2 = new StringBuffer("");
         if (var1.getErrorDescription() != null && var1.getErrorDescription().length > 0) {
            for (int var3 = 0; var3 < var1.getErrorDescription().length; var3++) {
               var2.append(var1.getErrorDescription()[var3]);
               var2.append("\n");
            }
         } else if (var1.getStatusMessage() != null) {
            var2.append(var1.getStatusMessage());
         } else {
            var2.append("No command result info.");
         }

         CommonPopups.showCommandResultErrorMessage(var2.toString(), null, this.scrContext);
         this.scrContext.getLogger().logStatus(var1.getStatusMessage());
         this.scrContext.getLogger().logTextInfo(var1.getStatusMessage());
      }
   }
}
