package com.raritan.rrc.ui.models;

import com.raritan.rrc.data.Device;
import com.raritan.rrc.data.Port;
import java.util.Enumeration;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.TreeNode;

public class FilteredTreeTableModel extends DeviceTreeTableModel {
   private boolean bShowWithoutTargets = true;
   private boolean bShowPowerStrips = true;
   private boolean bShowTools = true;

   public FilteredTreeTableModel(DefaultMutableTreeNode var1) {
      super(var1);
   }

   private boolean passesFilter(Object var1) {
      if (!(var1 instanceof Port)) {
         return true;
      } else {
         Port var2 = (Port)var1;
         if (!var2.isType("VT100Admin") && !var2.isClass("HTML") && !var2.isURL()) {
            return this.bShowWithoutTargets ? true : var2.getPortStatus() == 2 || var2.getPortStatus() == 1;
         } else {
            return this.bShowTools;
         }
      }
   }

   @Override
   public Object getChild(Object var1, int var2) {
      DefaultMutableTreeNode var3 = (DefaultMutableTreeNode)var1;
      DefaultMutableTreeNode var4 = null;
      int var5 = 0;

      for (int var6 = 0; var6 < var3.getChildCount(); var6++) {
         Object var7 = ((DefaultMutableTreeNode)var3.getChildAt(var6)).getUserObject();
         if (this.passesFilter(var7)) {
            if (var5 == var2) {
               var4 = (DefaultMutableTreeNode)var3.getChildAt(var6);
               break;
            }

            var5++;
         }
      }

      return var4;
   }

   @Override
   public int getIndexOfChild(Object var1, Object var2) {
      int var3 = -1;
      if (var1 != null && var1 instanceof TreeNode) {
         DefaultMutableTreeNode var4 = (DefaultMutableTreeNode)var1;
         Object var5 = var4.getUserObject();
      }

      if (var2 != null && var2 instanceof TreeNode) {
         DefaultMutableTreeNode var9 = (DefaultMutableTreeNode)var2;
         Object var11 = var9.getUserObject();
      }

      Object var10 = ((DefaultMutableTreeNode)var2).getUserObject();
      if (var1 instanceof TreeNode && var10 instanceof Device) {
         TreeNode var12 = (TreeNode)var1;
         if (this.passesFilter(var10)) {
            var3 = 0;

            for (int var6 = 0; var6 < var12.getChildCount(); var6++) {
               Object var7 = ((DefaultMutableTreeNode)var12.getChildAt(var6)).getUserObject();
               if (var10.equals(var7)) {
                  return var3;
               }

               Port var8 = var7 instanceof Port ? (Port)var7 : null;
               if (var8 == null || this.bShowWithoutTargets || var8.getPortStatus() != 0) {
                  var3++;
               }
            }
         }
      }

      return var3;
   }

   @Override
   public int getChildCount(Object var1) {
      int var2 = 0;
      Enumeration var3 = ((TreeNode)var1).children();

      while (var3.hasMoreElements()) {
         Object var4 = ((DefaultMutableTreeNode)var3.nextElement()).getUserObject();
         if (this.passesFilter(var4)) {
            var2++;
         }
      }

      return var2;
   }

   public boolean getShowWithoutTargets() {
      return this.bShowWithoutTargets;
   }

   public void setShowWithoutTargets(boolean var1) {
      if (var1 != this.bShowWithoutTargets) {
         this.bShowWithoutTargets = var1;
      }
   }

   public boolean getShowPowerStrips() {
      return this.bShowPowerStrips;
   }

   public void setShowPowerStrips(boolean var1) {
      if (this.bShowPowerStrips != var1) {
         this.bShowPowerStrips = var1;
      }
   }

   public boolean getShowTools() {
      return this.bShowTools;
   }

   public void setShowTools(boolean var1) {
      if (this.bShowTools != var1) {
         this.bShowTools = var1;
      }
   }

   @Override
   public void nodeChanged(TreeNode var1) {
      if (this.listenerList != null && var1 != null) {
         TreeNode var2 = var1.getParent();
         if (var2 != null) {
            int var3 = this.getIndexOfChild(var2, var1);
            if (var3 != -1) {
               int[] var4 = new int[]{var3};
               this.nodesChanged(var2, var4);
            }
         } else if (var1 == this.getRoot()) {
            this.nodesChanged(var1, null);
         }
      }
   }
}
