package com.raritan.rrc.ui.models;

import com.raritan.rrc.data.Device;
import com.raritan.rrc.util.HierComparator;
import com.raritan.rrc.util.MixedIPAddrComparator;
import java.net.InetAddress;
import java.util.Comparator;
import java.util.Map;

public class IPViewComparator implements Comparator {
   private static MixedIPAddrComparator ipComparator = new MixedIPAddrComparator();
   private static HierComparator hiercomparator = new HierComparator();
   private final Map map;
   private final DeviceDisplayLabelExtractor extractor;

   public IPViewComparator(Map var1, DeviceDisplayLabelExtractor var2) {
      this.map = var1;
      this.extractor = var2;
   }

   @Override
   public int compare(Object var1, Object var2) {
      Device var3 = (Device)this.map.get(var1);
      Device var4 = (Device)this.map.get(var2);
      Object[] var5 = this.extractor.getDisplayComponents(var3);
      Object[] var6 = this.extractor.getDisplayComponents(var4);
      boolean var7 = var5[0] instanceof InetAddress;
      boolean var8 = var6[0] instanceof InetAddress;
      int var9 = 0;
      if (var7 && var8) {
         var9 = ipComparator.compare(var5[0], var6[0]);
      } else {
         if (var7 || var8) {
            return var7 ? -1 : 1;
         }

         var9 = hiercomparator.compare(var5[0], var6[0]);
      }

      return var9 == 0 ? hiercomparator.compare(var5[1], var6[1]) : var9;
   }
}
