package com.raritan.rrc.ui.models;

import com.raritan.rrc.data.Device;
import com.raritan.rrc.util.HierComparator;
import com.raritan.rrc.util.MixedIPAddrComparator;
import java.net.InetAddress;
import java.util.Comparator;
import java.util.Map;

public class NameViewComparator implements Comparator {
   private static MixedIPAddrComparator ipComparator = new MixedIPAddrComparator();
   private static HierComparator hiercomparator = new HierComparator();
   private final Map map;
   private final DeviceDisplayLabelExtractor extractor;

   public NameViewComparator(Map var1, DeviceDisplayLabelExtractor var2) {
      this.map = var1;
      this.extractor = var2;
   }

   @Override
   public int compare(Object var1, Object var2) {
      Device var3 = (Device)this.map.get(var1);
      Device var4 = (Device)this.map.get(var2);
      Object[] var5 = this.extractor.getDisplayComponents(var3);
      Object[] var6 = this.extractor.getDisplayComponents(var4);
      int var7 = hiercomparator.compare(var5[0], var6[0]);
      if (var7 == 0) {
         boolean var8 = var5[1] instanceof InetAddress;
         boolean var9 = var6[1] instanceof InetAddress;
         if (var8 && var9) {
            return ipComparator.compare(var5[1], var6[1]);
         } else if (!var8 && !var9) {
            return hiercomparator.compare(var5[1], var6[1]);
         } else {
            return var8 ? 1 : -1;
         }
      } else {
         return var7;
      }
   }
}
