package com.raritan.rrc.ui.models;

import javax.swing.SpinnerNumberModel;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

public class SettingModel implements ChangeListener {
   private String name;
   private int value;
   private int minimum;
   private int maximum;
   private int step;
   private SpinnerNumberModel spinnerModel;
   private SliderRangeModel sliderModel;

   public SettingModel(String var1, int var2, int var3, int var4, int var5) {
      this.name = var1;
      this.value = var2;
      this.minimum = var3;
      this.maximum = var4;
      this.step = var5;
      this.spinnerModel = new SpinnerNumberModel(this.value, this.minimum, this.maximum, var5);
      this.spinnerModel.addChangeListener(this);
      this.sliderModel = new SliderRangeModel(this.value, this.minimum, this.maximum, var5 - 1);
      this.sliderModel.addChangeListener(this);
   }

   public String getName() {
      return this.name;
   }

   public int getValue() {
      return this.value;
   }

   public void setValue(int var1) {
      this.value = var1;
      this.setSpinnerSetting(var1);
   }

   public int getMaximum() {
      return this.maximum;
   }

   public SpinnerNumberModel getSpinnerModel() {
      return this.spinnerModel;
   }

   public SliderRangeModel getSliderModel() {
      return this.sliderModel;
   }

   private void setSpinnerSetting(int var1) {
      this.spinnerModel.setValue(new Integer(var1));
      this.value = var1;
   }

   private void setSliderSetting(int var1) {
      this.sliderModel.setValue(var1);
      this.value = var1;
   }

   public void addSliderModelListener(ChangeListener var1) {
      this.sliderModel.addChangeListener(var1);
   }

   public void removeSliderModelListener(ChangeListener var1) {
      this.sliderModel.removeChangeListener(var1);
   }

   @Override
   public void stateChanged(ChangeEvent var1) {
      Object var2 = var1.getSource();
      if (var2 instanceof SliderRangeModel) {
         SliderRangeModel var3 = (SliderRangeModel)var2;
         if (!var3.getValueIsAdjusting()) {
            this.value = var3.getValue();
            this.setSpinnerSetting(this.value);
         }
      }

      if (var2 instanceof SpinnerNumberModel) {
         SpinnerNumberModel var4 = (SpinnerNumberModel)var2;
         this.value = (Integer)var4.getValue();
         this.setSliderSetting(this.value);
      }
   }
}
