package com.raritan.rrc.ui.models;

import javax.swing.BoundedRangeModel;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;
import javax.swing.event.EventListenerList;

public class SliderRangeModel implements BoundedRangeModel {
   protected ChangeEvent changeEvent = null;
   protected EventListenerList listenerList = new EventListenerList();
   protected int maximum = 0;
   protected int minimum = 0;
   protected int extent = 0;
   protected int value = 0;
   protected boolean isAdjusting = false;

   public SliderRangeModel(int var1, int var2, int var3, int var4) {
      this.value = var1;
      this.minimum = var2;
      this.maximum = var3;
      this.extent = var4;
   }

   @Override
   public int getMinimum() {
      return this.minimum;
   }

   @Override
   public void setMinimum(int var1) {
   }

   @Override
   public int getMaximum() {
      return this.maximum;
   }

   @Override
   public void setMaximum(int var1) {
      this.setRangeProperties(this.value, this.extent, this.minimum, var1, this.isAdjusting);
   }

   @Override
   public int getValue() {
      return this.value;
   }

   @Override
   public void setValue(int var1) {
      this.setRangeProperties(var1, this.extent, this.minimum, this.maximum, this.isAdjusting);
   }

   @Override
   public void setValueIsAdjusting(boolean var1) {
      this.setRangeProperties(this.value, this.extent, this.minimum, this.maximum, var1);
   }

   @Override
   public boolean getValueIsAdjusting() {
      return this.isAdjusting;
   }

   @Override
   public int getExtent() {
      return this.extent;
   }

   @Override
   public void setExtent(int var1) {
   }

   @Override
   public void setRangeProperties(int var1, int var2, int var3, int var4, boolean var5) {
      int var6 = var4;
      int var7 = var1;
      if (var4 <= this.minimum) {
         var6 = this.minimum + 1;
      }

      if (var1 > var6) {
         var7 = var6;
      } else if (var1 < var3) {
         var7 = var3;
      }

      boolean var8 = false;
      if (var7 != this.value) {
         this.value = var7;
         var8 = true;
      }

      if (var6 != this.maximum) {
         this.maximum = var6;
         var8 = true;
      }

      if (var5 != this.isAdjusting) {
         this.maximum = var6;
         this.isAdjusting = var5;
         var8 = true;
      }

      if (var8) {
         this.fireStateChanged();
      }
   }

   @Override
   public void addChangeListener(ChangeListener var1) {
      this.listenerList.add(ChangeListener.class, var1);
   }

   @Override
   public void removeChangeListener(ChangeListener var1) {
      this.listenerList.remove(ChangeListener.class, var1);
   }

   protected void fireStateChanged() {
      Object[] var1 = this.listenerList.getListenerList();

      for (int var2 = var1.length - 2; var2 >= 0; var2 -= 2) {
         if (var1[var2] == ChangeListener.class) {
            if (this.changeEvent == null) {
               this.changeEvent = new ChangeEvent(this);
            }

            ((ChangeListener)var1[var2 + 1]).stateChanged(this.changeEvent);
         }
      }
   }
}
