package com.raritan.rrc.ui.panes;

import com.raritan.rrc.data.KeyboardMacrosPreferences;
import com.raritan.rrc.ui.commands.DoNewKeyboardMacroCommand;
import com.raritan.tools.commands.CommandContext;
import com.raritan.tools.ui.ScreenContext;
import java.util.ArrayList;
import java.util.Enumeration;

public class AddKeyboardMacroPanel extends AddModifyKeyboardMacroPanel {
   private static final long serialVersionUID = 5552818180641993930L;

   public AddKeyboardMacroPanel(boolean var1, ScreenContext var2) {
      super(var1, var2);
      this.setShell(this.bundle.getString("AddKeyboardMacrosDialog.title"));
      this.ok.setCommand(new DoNewKeyboardMacroCommand(this.scrContext));
   }

   @Override
   public void fillComponents(CommandContext var1) {
      super.fillComponents(var1);
      this.nameField.setText("");
      String[] var2 = KeyboardMacrosPreferences.returnNodes();
      KeyboardMacrosPreferences var3 = null;

      for (int var5 = 0; var5 < var2.length; var5++) {
         var3 = new KeyboardMacrosPreferences();
         var3.importPreferences(var2[var5]);
         int var4 = var3.getHotKeyCombination();
         if (var4 > -1) {
            this.hotKeyCombinationModel.removeElement(this.hotKeyCombinationType[var4 + 1]);
         }
      }

      this.hotKeyComboBox.setSelectedIndex(0);
      this.macroSequenceListModel.clear();
   }

   @Override
   protected void feedCommandContext(CommandContext var1) {
      super.feedCommandContext(var1);
      var1.setCommandParameter("keyboardMacroName", this.nameField.getText());
      String var2 = (String)this.hotKeyComboBox.getSelectedItem();
      var1.setCommandParameter("keyboardMacroHotKey", new Integer(this.getHotKeyIndex(var2)));
      ArrayList var3 = new ArrayList();
      Enumeration var4 = this.macroSequenceListModel.elements();

      while (var4.hasMoreElements()) {
         var3.add(var4.nextElement());
      }

      var1.setCommandParameter("macroSequence", var3);
   }
}
