package com.raritan.rrc.ui.panes;

import com.raritan.tools.commands.CancelButtonCommand;
import com.raritan.tools.commands.CommandContext;
import com.raritan.tools.resources.RaritanPropertyResourceBundle;
import com.raritan.tools.resources.RaritanResourceBundle;
import com.raritan.tools.ui.ScreenContext;
import com.raritan.tools.ui.components.CommandButton;
import com.raritan.tools.ui.panes.displays.AbstractDisplay;
import java.awt.BorderLayout;
import java.awt.FlowLayout;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import javax.swing.BorderFactory;
import javax.swing.JPanel;
import javax.swing.JTabbedPane;

public class AddModifyConnectionPanel extends AbstractDisplay implements MouseListener {
   private static final long serialVersionUID = 1L;
   protected ConnectPanel connectPanel;
   protected CompressionPanel compressionPanel;
   protected SecurityPanel securityPanel;
   protected JTabbedPane addConnectionTabbedPane;
   protected RaritanPropertyResourceBundle bundle;

   public AddModifyConnectionPanel(boolean var1, ScreenContext var2) {
      super(var2);
      this.isDialog = var1;
      this.bundle = RaritanResourceBundle.getResourceBundle(this.scrContext.getLocale());
      this.makeLayout();
   }

   @Override
   public void makeLayout() {
      this.setLayout(new BorderLayout());
      this.setBorder(BorderFactory.createEmptyBorder(10, 10, 0, 10));
      this.addConnectionTabbedPane = new JTabbedPane();
      String var1 = this.bundle.getString("ConnectTab.name");
      this.connectPanel = new ConnectPanel(false, this.scrContext);
      this.addConnectionTabbedPane.add(var1, this.connectPanel);
      this.compressionPanel = new CompressionPanel(false, this.scrContext);
      this.compressionPanel.setFocusable(true);
      var1 = this.bundle.getString("CompressionTab.name");
      this.addConnectionTabbedPane.add(var1, this.compressionPanel);
      this.securityPanel = new SecurityPanel(false, this.scrContext);
      this.securityPanel.setFocusable(true);
      var1 = this.bundle.getString("SecurityTab.name");
      this.addConnectionTabbedPane.add(var1, this.securityPanel);
      this.add(this.addConnectionTabbedPane, "Center");
      this.add(this.doButtonWidget(), "Last");
   }

   @Override
   public void mouseClicked(MouseEvent var1) {
   }

   @Override
   public void mouseEntered(MouseEvent var1) {
   }

   @Override
   public void mousePressed(MouseEvent var1) {
   }

   @Override
   public void mouseExited(MouseEvent var1) {
   }

   @Override
   public void mouseReleased(MouseEvent var1) {
   }

   @Override
   protected void feedCommandContext(CommandContext var1) {
   }

   @Override
   public void fillComponents(CommandContext var1) {
      this.connectPanel.fillComponents(var1);
   }

   @Override
   public JPanel doButtonWidget() {
      this.ok = new CommandButton(this.bundle.getString("basescreen.command.ok.text"), this.scrContext);
      this.ok.addActionListener(this);
      this.cancel = new CommandButton(this.bundle.getString("basescreen.command.cancel.text"), this.scrContext);
      this.cancel.setCommand(new CancelButtonCommand(this.scrContext));
      this.cancel.addActionListener(this);
      JPanel var1 = new JPanel(new FlowLayout(2));
      var1.add(this.ok);
      var1.add(this.cancel);
      return var1;
   }
}
