package com.raritan.rrc.ui.panes;

import com.raritan.rrc.data.KvmPort;
import com.raritan.rrc.ui.RRCScreenContext;
import com.raritan.tools.commands.CommandContext;
import com.raritan.tools.ui.ScreenContext;
import com.raritan.tools.ui.panes.displays.AbstractDisplay;
import com.raritan.tools.ui.panes.displays.Shell;
import com.raritan.tools.ui.panes.displays.ShellForAudioDialog;
import com.raritan.tools.ui.panes.displays.ShellForOptionPane;
import java.util.ArrayList;
import javax.swing.JOptionPane;
import nn.pp.common.audio.AudioDialog;

public class AudioPanel extends AbstractDisplay {
   private Shell shell;
   private ShellForAudioDialog shellForAudio;
   private ShellForOptionPane noDevShell;
   private ShellForOptionPane disconnectShell;
   private AudioDialog audioDialog;
   private KvmPort.ConnectAudioAction action;

   public AudioPanel(boolean var1, ScreenContext var2) {
      super(var2);
      this.setNewPanel(true);
      this.isDialog = true;
      this.shellForAudio = new ShellForAudioDialog(var2);
      this.audioDialog = new AudioDialog(this.shellForAudio, this.bundle.getString("Audio.connectAudioDevice"));
      this.shellForAudio.setAudioDialogAdapter(this.audioDialog);
      this.shellForAudio.setResizable(false);
      this.shellForAudio.setModal(true);
      this.shellForAudio.pack();
      this.shellForAudio.setVisible(false);
      this.shellForAudio.setClosable(true);
      this.noDevShell = new ShellForOptionPane(var2) {
         @Override
         public void setVisible(boolean var1) {
            super.setVisible(var1);
            ((RRCScreenContext)this.scrContext).getAudioObserver().forceNotifyObservers(this);
         }
      };
      JOptionPane var3 = new JOptionPane(
         this.bundle.getString("Audio.noAudioDevices"), 0, -1, null, new Object[]{this.bundle.getString("basescreen.command.ok.text")}
      );
      this.noDevShell.setOptionPane(var3);
      this.noDevShell.setTitle(this.bundle.getString("optionpane.error.title"));
      this.noDevShell.setResizable(false);
      this.noDevShell.setModal(true);
      this.noDevShell.pack();
      this.noDevShell.setVisible(false);
      this.noDevShell.setClosable(true);
      this.disconnectShell = new ShellForOptionPane(var2) {
         @Override
         public void setVisible(boolean var1) {
            super.setVisible(var1);
            ((RRCScreenContext)this.scrContext).getAudioObserver().forceNotifyObservers(this);
         }

         @Override
         protected void performAction(Object var1) {
            if (AudioPanel.this.bundle.getString("basescreen.command.yes.text").equals(var1)) {
               AudioPanel.this.action.disconnectAudio();
               JOptionPane.showOptionDialog(
                  this,
                  AudioPanel.this.bundle.getString("Audio.disconnectedSuccessfully"),
                  AudioPanel.this.bundle.getString("Audio.disconnectAudioDevice"),
                  -1,
                  1,
                  null,
                  new Object[]{AudioPanel.this.bundle.getString("basescreen.command.ok.text")},
                  null
               );
            }
         }
      };
      JOptionPane var4 = new JOptionPane(
         this.bundle.getString("Audio.disconnectConfirm"),
         3,
         -1,
         null,
         new Object[]{this.bundle.getString("basescreen.command.yes.text"), this.bundle.getString("basescreen.command.no.text")}
      );
      this.disconnectShell.setOptionPane(var4);
      this.disconnectShell.setTitle(this.bundle.getString("Audio.disconnectAudioDevice"));
      this.disconnectShell.setResizable(false);
      this.disconnectShell.setModal(true);
      this.disconnectShell.pack();
      this.disconnectShell.setVisible(false);
      this.disconnectShell.setClosable(true);
   }

   @Override
   public Shell getShell() {
      return this.shell;
   }

   @Override
   protected void feedCommandContext(CommandContext var1) {
   }

   @Override
   public void fillComponents(CommandContext var1) {
      ArrayList var2 = (ArrayList)((RRCScreenContext)this.scrContext).getSelectedDevicesObservable().getComponent();
      KvmPort var3 = (KvmPort)var2.get(0);
      this.action = var3.getConnectAudioAction();
      if (this.action.isConnected()) {
         this.shell = this.disconnectShell;
      } else if (!this.audioDialog.audioAvailable()) {
         this.shell = this.noDevShell;
      } else {
         this.audioDialog.setAudioBean(this.action.getAudioBean());
         this.audioDialog.setAudioCore(var3.getAudioCore());
         this.audioDialog.setPrefs(var3.getDevice().getDevPrefs());
         this.audioDialog.setTargetFormats(var3.getTargetSpeakerFormat(), var3.getTargetCaptureFormat());
         this.audioDialog.updateDevices();
         this.shell = this.shellForAudio;
      }
   }

   @Override
   public void makeLayout() {
   }
}
