package com.raritan.rrc.ui.panes;

import com.raritan.rrc.data.KvmPort;
import com.raritan.rrc.ui.RRCScreenContext;
import com.raritan.tools.commands.CommandContext;
import com.raritan.tools.ui.ScreenContext;
import com.raritan.tools.ui.panes.displays.AbstractDisplay;
import com.raritan.tools.ui.panes.displays.Shell;
import com.raritan.tools.ui.panes.displays.ShellForDialog;
import java.util.ArrayList;
import nn.pp.common.audio.AudioSettingsDialog;

public class AudioSettingsPanel extends AbstractDisplay {
   private ShellForDialog shellForAudio;
   private AudioSettingsDialog audioSettingsDialog;

   public AudioSettingsPanel(boolean var1, ScreenContext var2) {
      super(var2);
      this.isDialog = true;
      this.setNewPanel(true);
      this.shellForAudio = new ShellForDialog(var2);
      this.audioSettingsDialog = new AudioSettingsDialog(this.shellForAudio);
      this.shellForAudio.setDialogAdapter(this.audioSettingsDialog);
      this.shellForAudio.pack();
   }

   @Override
   public Shell getShell() {
      return this.shellForAudio;
   }

   @Override
   protected void feedCommandContext(CommandContext var1) {
   }

   @Override
   public void fillComponents(CommandContext var1) {
      ArrayList var2 = (ArrayList)((RRCScreenContext)this.scrContext).getSelectedDevicesObservable().getComponent();
      KvmPort var3 = (KvmPort)var2.get(0);
      this.audioSettingsDialog.setPrefs(var3.getDevice().getDevPrefs());
      this.audioSettingsDialog.setAudioBean(var3.getConnectAudioAction().getAudioBean());
      this.audioSettingsDialog.setAudioCore(var3.getAudioCore());
   }

   @Override
   public void makeLayout() {
   }
}
