package com.raritan.rrc.ui.panes;

import java.applet.AppletContext;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.lang.reflect.Method;
import java.net.URL;
import javax.swing.JOptionPane;

public class BrowserLaunch {
   private static final String errMsg = "Error attempting to launch web browser.";

   public static void openURL(String var0, AppletContext var1) {
      String var2 = System.getProperty("os.name");

      try {
         if (var2.startsWith("Mac OS")) {
            Class var3 = Class.forName("com.apple.eio.FileManager");
            Method var4 = var3.getDeclaredMethod("openURL", String.class);
            var4.invoke(null, var0);
         } else if (var2.startsWith("Windows")) {
            if (var1 != null) {
               var1.showDocument(new URL(var0), "_blank");
            } else {
               String[] var7 = new String[]{"rundll32", "url.dll,FileProtocolHandler", displayURLinNew(var0)};
               Runtime.getRuntime().exec(var7);
            }
         } else {
            String[] var8 = new String[]{"firefox", "opera", "konqueror", "epiphany", "mozilla", "netscape"};
            String var9 = null;

            for (int var5 = 0; var5 < var8.length && var9 == null; var5++) {
               if (Runtime.getRuntime().exec(new String[]{"which", var8[var5]}).waitFor() == 0) {
                  var9 = var8[var5];
               }
            }

            if (var9 == null) {
               throw new Exception("Could not find web browser");
            }

            Runtime.getRuntime().exec(new String[]{var9, var0});
         }
      } catch (Exception var6) {
         JOptionPane.showMessageDialog(null, "Error attempting to launch web browser.:\n" + var6.getLocalizedMessage());
      }
   }

   public static String displayURLinNew(String var0) throws IOException {
      File var1 = File.createTempFile("DisplayURLs", ".html");
      var1.deleteOnExit();
      var1 = var1.getCanonicalFile();
      PrintWriter var2 = new PrintWriter(new FileWriter(var1));
      var2.println("<!-- saved from url=(0014)about:internet -->");
      var2.println("<html>");
      var2.println("<head>");
      var2.println("<title> Admin </title>");
      var2.println("<script language=\"javascript\" type=\"text/javascript\">");
      var2.println("function displayURLs(){");
      var2.println(
         "window.open(\"" + var0 + "\", \"_self\", \"toolbar=yes,location=yes,directories=yes,status=yes,menubar=yes,scrollbars=yes,resizable=yes\");"
      );
      var2.println("}");
      var2.println("</script>");
      var2.println("</head>");
      var2.println("<body onload=\"javascript:displayURLs()\">");
      var2.println("<noscript>");
      var2.println("<a target=\"_blank\" href=\"" + var0 + "\"> Launch Admin </a><br>");
      var2.println("</noscript>");
      var2.println("</body>");
      var2.println("</html>");
      var2.close();
      return var1.getAbsolutePath();
   }
}
