package com.raritan.rrc.ui.panes;

import com.raritan.rrc.data.KvmPort;
import com.raritan.rrc.data.Port;
import com.raritan.rrc.ui.RRCScreenContext;
import com.raritan.rrc.ui.commands.DoAbsoluteMouseCommand;
import com.raritan.rrc.ui.commands.DoCalibrateColorCommand;
import com.raritan.rrc.ui.commands.DoIntelligentMouseCommand;
import com.raritan.rrc.ui.commands.DoModifyConnectionPropertiesCommand;
import com.raritan.rrc.ui.commands.DoRefreshScreenCommand;
import com.raritan.rrc.ui.commands.DoSingleMouseModeCommand;
import com.raritan.rrc.ui.commands.DoStandardMouseCommand;
import com.raritan.rrc.ui.commands.DoSwitchCommand;
import com.raritan.rrc.ui.commands.DoSynchronizeMouseCommand;
import com.raritan.rrc.ui.commands.DoVideoSettingsCommand;
import com.raritan.rrc.ui.commands.MouseMenuCommand;
import com.raritan.rrc.ui.commands.ShowConnectionInfoCommand;
import com.raritan.rrc.ui.commands.ShowSingleCursorInstructionCommand;
import com.raritan.rrc.ui.commands.ShowVideoSettingsCommand;
import com.raritan.rrc.ui.commands.ShowVirtualMediaImagePanelCommand;
import com.raritan.rrc.ui.commands.ShowVirtualMediaLocalPanelCommand;
import com.raritan.rrc.ui.commands.VirtualMediaMenuCommand;
import com.raritan.tools.commands.CommandResult;
import com.raritan.tools.ui.ScreenContext;
import javaclientlib.utils.RRCLogger;

public class DefaultCommandHandler implements ICommandHandler {
   @Override
   public void handleCommand(DoAbsoluteMouseCommand var1, ScreenContext var2) {
      var2.getLogger().logTextDebug(" Started ");
      if (RRCLogger.logEnabled) {
         RRCLogger.log(300, 1, "DefaultCommandHandler.handleCommand(DoAbsoluteMouseCommand)");
      }

      var2.getLogger().logTextDebug(" Finished ");
   }

   @Override
   public void handleCommand(DoStandardMouseCommand var1, ScreenContext var2) {
      var2.getLogger().logTextDebug(" Started ");
      if (RRCLogger.logEnabled) {
         RRCLogger.log(300, 1, "DefaultCommandHandler.handleCommand(DoAbsoluteMouseCommand)");
      }

      var2.getLogger().logTextDebug(" Finished ");
   }

   @Override
   public void handleCommand(DoIntelligentMouseCommand var1, ScreenContext var2) {
      var2.getLogger().logTextDebug(" Started ");
      if (RRCLogger.logEnabled) {
         RRCLogger.log(300, 1, "DefaultCommandHandler.handleCommand(DoIntelligentMouseCommand)");
      }

      var2.getLogger().logTextDebug(" Finished ");
   }

   @Override
   public void handleCommand(DoSingleMouseModeCommand var1, ScreenContext var2) {
      var2.getLogger().logTextDebug(" Started ");
      Boolean var3 = (Boolean)var1.getContext().getCommandParameter("showSingleCursorModeInstructions");
      Port var4 = ((RRCScreenContext)var2).getSelectedPort();
      if (var4 != null && var4.isConnected() && var4 instanceof KvmPort) {
         ((KvmPort)var4).toggleSingleMouseCursor();
         ((RRCScreenContext)var2).getMainScreenMediator().selectSingleMouseCursorMode();
         if (var3 != null) {
            ((RRCScreenContext)var2).getAppSettings().setSingleMouseInstructions(var3);
         }
      }

      var2.getLogger().logTextDebug(" Finished ");
   }

   @Override
   public void handleCommand(ShowSingleCursorInstructionCommand var1, ScreenContext var2) {
      var2.getLogger().logTextDebug(" Started ");
      Port var3 = ((RRCScreenContext)var2).getSelectedPort();
      DeviceView var4 = var3.getView();
      var2.getLogger().logTextDebug(" Finished ");
   }

   @Override
   public void handleCommand(DoSwitchCommand var1, ScreenContext var2, CommandResult var3) {
      var2.getLogger().logTextDebug(" Started ");
      if (RRCLogger.logEnabled) {
         RRCLogger.log(300, 1, "DefaultCommandHandler.handleCommand(DoSwitchCommand)");
      }

      var2.getLogger().logTextDebug(" Finished ");
   }

   protected DeviceView getCurrentView(ScreenContext var1) {
      RRCScreenContext var2 = (RRCScreenContext)var1;
      DeviceView var3 = var2.getSelectView();
      return var3 != null ? var3 : null;
   }

   @Override
   public void handleCommand(MouseMenuCommand var1, ScreenContext var2) {
      var2.getLogger().logTextDebug(" Started ");
      if (RRCLogger.logEnabled) {
         RRCLogger.log(300, 1, "DefaultCommandHandler.handleCommand(MouseMenuCommand)");
      }

      var2.getLogger().logTextDebug(" Finished ");
   }

   @Override
   public void handleCommand(VirtualMediaMenuCommand var1, ScreenContext var2) {
      var2.getLogger().logTextDebug(" Started ");
      if (RRCLogger.logEnabled) {
         RRCLogger.log(300, 1, "DefaultCommandHandler.handleCommand(VirtualMediaMenuCommand)");
      }

      var2.getLogger().logTextDebug(" Finished ");
   }

   @Override
   public void handleCommand(DoModifyConnectionPropertiesCommand var1, ScreenContext var2) {
      var2.getLogger().logTextDebug(" Started ");
      if (RRCLogger.logEnabled) {
         RRCLogger.log(300, 1, "DefaultCommandHandler.handleCommand(DoModifyConnectionPropertiesCommand)");
      }

      var2.getLogger().logTextDebug(" Finished ");
   }

   @Override
   public void handleCommand(DoSynchronizeMouseCommand var1, ScreenContext var2) {
      Port var3 = ((RRCScreenContext)var2).getSelectedPort();
      if (var3 != null && var3.isConnected() && var3.getDeviceClass().equals("KVM")) {
         DeviceView var4 = var3.getView();
         if (var4 != null) {
            var4.synchronizeMouse(false);
         }
      }
   }

   @Override
   public void handleCommand(ShowConnectionInfoCommand var1, ScreenContext var2) {
      var2.getLogger().logTextDebug(" Started ");
      if (RRCLogger.logEnabled) {
         RRCLogger.log(300, 1, "DefaultCommandHandler.handleCommand(ShowConnectionInfoCommand)");
      }

      var2.getLogger().logTextDebug(" Finished ");
   }

   @Override
   public void handleCommand(DoRefreshScreenCommand var1, ScreenContext var2) {
      Port var3 = ((RRCScreenContext)var2).getSelectedPort();
      if (var3 != null && var3 instanceof KvmPort && var3.isConnected()) {
         DeviceView var4 = var3.getView();
         if (var4 != null) {
            var4.refreshScreen();
         }
      }
   }

   @Override
   public void handleCommand(DoCalibrateColorCommand var1, ScreenContext var2) {
      Port var3 = ((RRCScreenContext)var2).getSelectedPort();
      if (var3 != null && var3.isConnected() && var3.getDeviceClass().equals("KVM") && var3.isConnected()) {
         var3.getView().calibrateColor();
      }
   }

   @Override
   public void handleCommand(DoVideoSettingsCommand var1, ScreenContext var2) {
   }

   @Override
   public void handleCommand(ShowVideoSettingsCommand var1, ScreenContext var2) {
   }

   @Override
   public void handleCommand(ShowVirtualMediaLocalPanelCommand var1, ScreenContext var2) {
   }

   @Override
   public void handleCommand(ShowVirtualMediaImagePanelCommand var1, ScreenContext var2) {
   }
}
