package com.raritan.rrc.ui.panes;

import com.raritan.rrc.ui.commands.DoLoadConfigurationCommand;
import com.raritan.tools.commands.CommandContext;
import com.raritan.tools.ui.ScreenContext;
import com.raritan.tools.util.io.AllFilesFilter;

public class LoadDeviceConfigurationPanel extends FileBrowserPanel {
   private static final long serialVersionUID = 8182265312457127698L;

   public LoadDeviceConfigurationPanel(boolean var1, ScreenContext var2) {
      super(var1, var2);
      this.setTitle(this.bundle.getString("filebrowser.load.deviceconfig.title"));
   }

   @Override
   public void makeLayout() {
      super.makeLayout();
      this.chooser.setDialogType(0);
      this.chooser.setCommand(new DoLoadConfigurationCommand(this.scrContext));
      this.chooser.addChoosableFileFilter(new AllFilesFilter(4));
   }

   @Override
   protected void feedCommandContext(CommandContext var1) {
      var1.setCommandParameter("selectedFileMapper", AllFilesFilter.createFileMapper());
      super.feedCommandContext(var1);
   }

   @Override
   public void fillComponents(CommandContext var1) {
      super.fillComponents(var1);
      this.chooser.rescanCurrentDirectory();
   }
}
