package com.raritan.rrc.ui.panes;

import com.raritan.rrc.data.KeyboardMacrosPreferences;
import com.raritan.rrc.ui.commands.DoExportSelectedMacrosCommand;
import com.raritan.tools.commands.CommandContext;
import com.raritan.tools.ui.ScreenContext;
import com.raritan.tools.ui.components.CommonPopups;
import java.awt.event.ActionEvent;
import java.io.File;
import javax.swing.JPanel;

public class MacroExportSelectionPanel extends MacroSelectionPanel {
   private static final long serialVersionUID = 2028595561540428644L;
   private File exportFileName = null;

   public MacroExportSelectionPanel(boolean var1, ScreenContext var2) {
      super(var1, var2);
   }

   @Override
   public JPanel doButtonWidget() {
      JPanel var1 = super.doButtonWidget();
      this.ok.setCommand(new DoExportSelectedMacrosCommand(this.scrContext));
      return var1;
   }

   @Override
   public void feedCommandContext(CommandContext var1) {
      super.feedCommandContext(var1);
      var1.setCommandParameter("exportSelectedMacrosFilename", this.exportFileName);
   }

   @Override
   public void fillComponents(CommandContext var1) {
      super.fillComponents(var1);
      this.setShell(this.bundle.getString("macro.export.selection.title"));
   }

   @Override
   public void actionPerformed(ActionEvent var1) {
      Object var2 = var1.getSource();
      if (var2 == this.ok) {
         this.ok.setEnabled(false);
         this.exportFileName = this.selectFileForExport();
         if (this.exportFileName == null) {
            this.ok.setEnabled(true);
            return;
         }
      }

      super.actionPerformed(var1);
   }

   private File selectFileForExport() {
      File var1 = null;

      while (true) {
         var1 = KeyboardMacrosPreferences.chooseXmlFile(this.bundle.getString("macro.export.file.dialog.title"), 1, this);
         if (var1 == null || !var1.exists()) {
            break;
         }

         int var2 = CommonPopups.showFileOverwriteConfirmationDialog(this, this.scrContext);
         if (var2 != 1) {
            var1.delete();
            break;
         }
      }

      return var1;
   }
}
