package com.raritan.rrc.ui.panes;

import com.raritan.rrc.ui.commands.DoMacroTextInterpreterCommand;
import com.raritan.tools.commands.CommandContext;
import com.raritan.tools.ui.ScreenContext;
import com.util.kbd.KeyboardMappings;
import javax.swing.JPanel;
import nn.pp.common.ui.helpers.IMacroCreatorDialog;

public class MacroTextInterpreterPanel extends SendTextToTargetPanel {
   private static final long serialVersionUID = 2028595561540428645L;
   private KeyboardMappings kmap = null;
   private IMacroCreatorDialog myParent = null;

   public MacroTextInterpreterPanel(boolean var1, ScreenContext var2) {
      super(var1, var2);
   }

   @Override
   public JPanel doButtonWidget() {
      JPanel var1 = super.doButtonWidget();
      this.ok.setCommand(new DoMacroTextInterpreterCommand(this.scrContext));
      return var1;
   }

   @Override
   public void feedCommandContext(CommandContext var1) {
      targetUSIntlSelected = this.targetIsUSIntl.isSelected();
      var1.setCommandParameter("macroTextInterpreter", this.kmap);
      var1.setCommandParameter("macroTextInterpreterParent", this.myParent);
      var1.setCommandParameter("macroTextInterpreterText", this.textPad.getText());
      var1.setCommandParameter("macroTextInterpreterLang", targetUSIntlSelected && this.keyboardType == 0 ? 255 : this.keyboardType);
   }

   @Override
   public void fillComponents(CommandContext var1) {
      super.fillComponents(var1);
      this.kmap = (KeyboardMappings)var1.getCommandParameter("macroTextInterpreter");
      this.myParent = (IMacroCreatorDialog)var1.getCommandParameter("macroTextInterpreterParent");
   }
}
