package com.raritan.rrc.ui.panes;

import com.raritan.rrc.data.KeyboardMacrosPreferences;
import com.raritan.rrc.ui.commands.DoModifyKeyboardMacroCommand;
import com.raritan.tools.commands.CommandContext;
import com.raritan.tools.ui.ScreenContext;
import com.util.kbd.KeyboardKey;
import java.util.ArrayList;
import java.util.Enumeration;
import java.util.StringTokenizer;

public class ModifyKeyboardMacroPanel extends AddModifyKeyboardMacroPanel {
   private static final long serialVersionUID = 3198026599694724832L;
   private String oldMacroName;

   public ModifyKeyboardMacroPanel(boolean var1, ScreenContext var2) {
      super(var1, var2);
      this.setShell(this.bundle.getString("ModifyKeyboardMacrosDialog.title"));
      this.ok.setCommand(new DoModifyKeyboardMacroCommand(this.scrContext));
   }

   @Override
   public void fillComponents(CommandContext var1) {
      super.fillComponents(var1);
      String var2 = (String)var1.getCommandParameter("keyboardMacroName");
      this.oldMacroName = var2;
      this.nameField.setText(var2);
      KeyboardMacrosPreferences var3 = new KeyboardMacrosPreferences();
      var3.importPreferences(var2);
      int var4 = var3.getHotKeyCombination();
      this.hotKeyCombinationModel.removeAllElements();

      for (int var5 = 0; var5 < this.hotKeyCombinationType.length; var5++) {
         this.hotKeyCombinationModel.addElement(this.hotKeyCombinationType[var5]);
      }

      String[] var14 = KeyboardMacrosPreferences.returnNodes();
      KeyboardMacrosPreferences var6 = null;

      for (int var8 = 0; var8 < var14.length; var8++) {
         var6 = new KeyboardMacrosPreferences();
         var6.importPreferences(var14[var8]);
         int var7 = var6.getHotKeyCombination();
         if (var7 > -1 && var7 != var4) {
            this.hotKeyCombinationModel.removeElement(this.hotKeyCombinationType[var7 + 1]);
         }
      }

      this.hotKeyCombinationModel.setSelectedItem(this.hotKeyCombinationType[var4 + 1]);
      this.macroSequenceListModel.clear();
      StringTokenizer var16 = new StringTokenizer(var3.getMacroSequence(), "&&");

      while (var16.hasMoreTokens()) {
         String var9 = var16.nextToken();
         String var10 = var9.substring(var9.lastIndexOf(" ") + 1);
         int var11 = Integer.parseInt(var10);
         KeyboardKey var12 = this.keyboardMappings.getItem(var11);
         if (var12 != null) {
            KeyboardKey var13 = new KeyboardKey(var12.getIndex(), var12.getKeyName(), var12.getKeyCode(), var12.getKeyLocation());
            if (var9.startsWith("p")) {
               var13.setString(this.bundle.getString("press.text") + " " + var12.getKeyName());
            } else if (var9.startsWith("r")) {
               var13.setString(this.bundle.getString("release.text") + " " + var12.getKeyName());
            }

            this.macroSequenceListModel.addElement(var13);
         }
      }

      this.clearButton.setEnabled(true);
   }

   @Override
   protected void feedCommandContext(CommandContext var1) {
      super.feedCommandContext(var1);
      var1.setCommandParameter("keyboardMacroName", this.nameField.getText());
      var1.setCommandParameter("oldMacroName", this.oldMacroName);
      String var2 = (String)this.hotKeyComboBox.getSelectedItem();
      var1.setCommandParameter("keyboardMacroHotKey", new Integer(this.getHotKeyIndex(var2)));
      ArrayList var3 = new ArrayList();
      Enumeration var4 = this.macroSequenceListModel.elements();

      while (var4.hasMoreElements()) {
         var3.add(var4.nextElement());
      }

      var1.setCommandParameter("macroSequence", var3);
   }
}
