package com.raritan.rrc.ui.panes;

import com.raritan.tools.resources.RaritanPropertyResourceBundle;
import java.awt.BorderLayout;
import java.awt.Component;
import java.awt.Container;
import java.awt.FlowLayout;
import java.awt.Image;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowEvent;
import java.awt.event.WindowListener;
import java.awt.image.BufferedImage;
import java.util.Hashtable;
import java.util.MissingResourceException;
import java.util.Vector;
import javaclientlib.utils.RRCLogger;
import javax.swing.AbstractButton;
import javax.swing.BorderFactory;
import javax.swing.BoxLayout;
import javax.swing.ButtonGroup;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import javax.swing.JToggleButton;

public class RPSelectionDialog extends JDialog implements ActionListener, WindowListener {
   private JPanel optionList;
   private JPanel customOptionList;
   private JButton okButton;
   private JButton cancelButton;
   private JRadioButton customRestore = null;
   private Hashtable<JToggleButton, String> itemToRPID;
   private String[] selectedPackages = null;
   private boolean hasValidPackages = false;
   private static JFrame dummyParentFrame = new JFrame();
   private static Image icon = new BufferedImage(1, 1, 3);
   private RaritanPropertyResourceBundle rprBundle;

   @Override
   public void windowActivated(WindowEvent var1) {
   }

   @Override
   public void windowClosed(WindowEvent var1) {
   }

   @Override
   public void windowClosing(WindowEvent var1) {
      this.cancelOperation();
   }

   @Override
   public void windowDeactivated(WindowEvent var1) {
   }

   @Override
   public void windowDeiconified(WindowEvent var1) {
   }

   @Override
   public void windowIconified(WindowEvent var1) {
   }

   @Override
   public void windowOpened(WindowEvent var1) {
   }

   @Override
   public void actionPerformed(ActionEvent var1) {
      Object var2 = var1.getSource();
      if (var2 == this.cancelButton) {
         this.cancelOperation();
      } else if (var2 == this.okButton) {
         Component[] var3;
         if (this.customRestore.isSelected()) {
            var3 = this.customOptionList.getComponents();
         } else {
            var3 = this.optionList.getComponents();
         }

         Vector var4 = new Vector();

         for (int var5 = 0; var5 < var3.length; var5++) {
            if (((JToggleButton)var3[var5]).isSelected()) {
               var4.add(this.itemToRPID.get(var3[var5]));
            }
         }

         if (var4.size() == 0) {
            this.selectedPackages = null;
            JOptionPane.showMessageDialog(this, this.rprBundle.getString("rpid.package.error.NothingSelected"));
            return;
         }

         this.selectedPackages = var4.toArray(new String[0]);
         this.setVisible(false);
      } else if (var2 instanceof JRadioButton) {
         boolean var6 = this.customRestore.isSelected();
         Component[] var7 = this.customOptionList.getComponents();

         for (int var8 = 0; var8 < var7.length; var8++) {
            var7[var8].setEnabled(var6);
            if (!var6) {
               ((JCheckBox)var7[var8]).setSelected(false);
            }
         }
      }
   }

   public RPSelectionDialog(Container var1, String[] var2, RaritanPropertyResourceBundle var3) {
      super(dummyParentFrame, var3.getString("RPSelectionDialog.title"), true);
      dummyParentFrame.setIconImage(icon);
      if (var2 == null) {
         if (RRCLogger.logEnabled) {
            RRCLogger.log(300, 65, "RPSelectionDialog called with null string array for rpidlist");
         }

         this.hasValidPackages = false;
      } else {
         this.setLocationRelativeTo(var1);
         this.rprBundle = var3;
         this.optionList = new JPanel();
         this.customOptionList = new JPanel();
         this.itemToRPID = new Hashtable<>();
         ButtonGroup var5 = new ButtonGroup();
         Object var6 = null;
         Object var7 = null;

         for (int var4 = 0; var4 < var2.length; var4++) {
            if (var2[var4] != null) {
               if (var2[var4].startsWith("C")) {
                  var6 = new JCheckBox();
               } else {
                  if (!var2[var4].startsWith("UC")) {
                     continue;
                  }

                  var6 = new JRadioButton();
               }

               try {
                  var7 = this.rprBundle.getString("rpid.package.label." + var2[var4]);
               } catch (MissingResourceException var9) {
                  continue;
               }

               this.itemToRPID.put((JToggleButton)var6, var2[var4]);
               var6.setText((String)var7);
               if (var6 instanceof JRadioButton) {
                  var5.add((AbstractButton)var6);
                  this.optionList.add((Component)var6);
                  var6.addActionListener(this);
               } else {
                  this.customOptionList.add((Component)var6);
               }
            }
         }

         Component[] var8 = this.customOptionList.getComponents();
         if (var8.length > 0) {
            for (int var10 = 0; var10 < var8.length; var10++) {
               var8[var10].setEnabled(false);
            }

            this.customRestore = new JRadioButton(this.rprBundle.getString("rpid.package.label.CustomRestore"));
            var5.add(this.customRestore);
            this.optionList.add(this.customRestore);
            this.customRestore.addActionListener(this);
         }

         var8 = this.optionList.getComponents();
         if (var8.length == 0) {
            this.hasValidPackages = false;
         } else {
            ((JRadioButton)var8[0]).setSelected(true);
            this.hasValidPackages = true;
            this.makeLayout();
            this.addWindowListener(this);
         }
      }
   }

   private void makeLayout() {
      JPanel var1 = new JPanel();
      JPanel var2 = new JPanel();
      this.optionList.setLayout(new BoxLayout(this.optionList, 3));
      if (this.customOptionList.getComponents().length > 0) {
         this.customOptionList.setLayout(new BoxLayout(this.customOptionList, 3));
         this.customOptionList.setBorder(BorderFactory.createTitledBorder(this.rprBundle.getString("rpid.package.label.ChooseCustomPackages")));
      }

      this.okButton = new JButton(this.rprBundle.getString("generic.dialog.ok.text"));
      this.cancelButton = new JButton(this.rprBundle.getString("generic.dialog.cancel.text"));
      var2.setLayout(new FlowLayout(1));
      var2.add(this.okButton);
      var2.add(this.cancelButton);
      this.okButton.addActionListener(this);
      this.cancelButton.addActionListener(this);
      var1.setLayout(new BoxLayout(var1, 3));
      var1.setBorder(BorderFactory.createEmptyBorder(10, 10, 5, 10));
      var1.add(this.optionList);
      if (this.customOptionList != null) {
         var1.add(this.customOptionList);
      }

      var1.setAlignmentX(0.5F);
      Container var3 = this.getContentPane();
      var3.setLayout(new BorderLayout());
      var3.add(var1, "Center");
      var3.add(var2, "Last");
      this.okButton.enableInputMethods(false);
      this.cancelButton.enableInputMethods(false);
      this.pack();
      this.setResizable(false);
   }

   private void cancelOperation() {
      this.selectedPackages = null;
      this.setVisible(false);
   }

   public String[] selectRPDialog() {
      if (this.hasValidPackages) {
         this.setVisible(true);
      }

      return this.selectedPackages;
   }

   public boolean hasValidPackages() {
      return this.hasValidPackages;
   }
}
