package com.raritan.rrc.ui.panes;

import com.raritan.tools.commands.Command;
import com.raritan.tools.ui.panes.displays.ShellInternalFrame;
import java.beans.PropertyVetoException;
import javax.swing.JInternalFrame;
import javax.swing.event.InternalFrameEvent;

public class RRCShellInternalFrame extends ShellInternalFrame {
   private static final long serialVersionUID = -4032147001877990192L;
   private Command frameClosedCommand;
   private Command frameActivatedCommand;
   private DeviceView deviceView;
   private Command frameDeActivatedCommand;

   public RRCShellInternalFrame() {
      this.setDefaultCloseOperation(2);
   }

   @Override
   public void internalFrameClosed(InternalFrameEvent var1) {
      if (this.frameClosedCommand != null) {
         this.setWindowClosing(true);
         this.frameClosedCommand.execute();
      }
   }

   @Override
   public void internalFrameActivated(InternalFrameEvent var1) {
      if (this.frameActivatedCommand != null) {
         this.frameActivatedCommand.execute();
      }
   }

   @Override
   public void internalFrameClosing(InternalFrameEvent var1) {
      super.internalFrameClosing(var1);
      this.setWindowClosing(true);
   }

   @Override
   public void internalFrameDeiconified(InternalFrameEvent var1) {
      if (this.deviceView != null && this.deviceView.allowMaximumSize()) {
         super.internalFrameDeiconified(var1);
      }

      if (this.frameActivatedCommand != null) {
         this.frameActivatedCommand.execute();
      }
   }

   @Override
   public void internalFrameIconified(InternalFrameEvent var1) {
      super.internalFrameIconified(var1);
      if (this.frameDeActivatedCommand != null) {
         this.frameDeActivatedCommand.execute();
      }
   }

   public void setFrameActivatedCommand(Command var1) {
      this.frameActivatedCommand = var1;
   }

   public void setFrameClosedCommand(Command var1) {
      this.frameClosedCommand = var1;
   }

   public void setDeviceView(DeviceView var1) {
      this.deviceView = var1;
   }

   public DeviceView getDeviceView() {
      return this.deviceView;
   }

   public void setFrameDeActivatedCommand(Command var1) {
      this.frameDeActivatedCommand = var1;
   }

   @Override
   public void setSelected(boolean var1) throws PropertyVetoException {
      if (var1 && this.getDesktopPane() != null) {
         JInternalFrame var2 = this.getDesktopPane().getSelectedFrame();
         if (var2 != null && this != var2) {
            var2.setSelected(false);
         }
      }

      super.setSelected(var1);
   }
}
