package com.raritan.rrc.ui.panes;

import com.raritan.rrc.data.Device;
import com.raritan.rrc.data.G2SerialPort;
import com.raritan.rrc.data.IPReach;
import com.raritan.rrc.ui.RRCScreenContext;
import com.raritan.rrc.ui.applet.EmbedAppletClassLoader;
import com.raritan.rrc.ui.applet.EmbedAppletDataHolder;
import com.raritan.rrc.ui.applet.EmbedAppletStub;
import com.raritan.rrc.ui.components.RRCStatusBar;
import com.raritan.tools.commands.CommandContext;
import com.raritan.tools.resources.RaritanPropertyResourceBundle;
import com.raritan.tools.resources.RaritanResourceBundle;
import com.raritan.tools.ui.ScreenContext;
import com.raritan.tools.ui.components.RaritanDesktopPane;
import com.raritan.tools.ui.panes.displays.ShellInternalFrame;
import com.raritan.tools.util.Util;
import java.awt.BorderLayout;
import java.awt.CardLayout;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import java.net.MalformedURLException;
import java.net.URL;
import java.net.URLClassLoader;
import java.util.ArrayList;
import java.util.Observable;
import java.util.Observer;
import javaclientlib.utils.RRCLogger;
import javax.swing.JApplet;
import javax.swing.JInternalFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JProgressBar;

public class RSCView extends DeviceViewAdapter {
   private static final long serialVersionUID = 4778443664182470436L;
   private Device dev = null;
   private ScreenContext scrContext = null;
   private EmbedAppletDataHolder holder = null;
   private Class claz = null;
   private RSCView.SerialPortThread thread;
   private G2SerialPort serialPort;
   private JApplet applet;
   private EmbedAppletClassLoader classLoader;
   private EmbedAppletStub stub;
   protected RaritanPropertyResourceBundle bundle;
   private static final String LOADING_CARD = "loadingCard";
   private static final String APPLET_CARD = "appletCard";
   private JPanel loadingPanel = null;
   private JPanel appletPanel = null;
   private JProgressBar progress;
   private Method defFocusMethod = null;

   public RSCView(boolean var1, ScreenContext var2) {
      super((RRCScreenContext)var2);
      this.scrContext = var2;
      this.isNewPanel = true;
      this.bundle = RaritanResourceBundle.getResourceBundle(this.scrContext.getLocale());
      this.serialPort = (G2SerialPort)((ArrayList)((RRCScreenContext)var2).getSelectedDevicesObservable().getComponent()).get(0);
      this.serialPort.setView(this);
      this.makeLayout();
   }

   @Override
   public void makeLayout() {
      this.setLayout(new CardLayout());
      this.loadingPanel = new JPanel();
      this.loadingPanel.setLayout(new GridBagLayout());
      this.progress = new JProgressBar(0, 500);
      this.progress.setIndeterminate(true);
      this.loadingPanel
         .add(new JLabel(this.bundle.getString("RSC_LOADING_MSG")), new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0, 10, 0, new Insets(0, 0, 0, 0), 0, 0));
      this.loadingPanel.add(this.progress, new GridBagConstraints(0, 1, 1, 1, 0.0, 0.0, 10, 0, new Insets(0, 0, 0, 0), 0, 0));
      this.appletPanel = new JPanel();
      this.add("loadingCard", this.loadingPanel);
      this.add("appletCard", this.appletPanel);
      RaritanDesktopPane var1 = (RaritanDesktopPane)((RRCScreenContext)this.scrContext).getPanelMediator().getParent();
      this.setSize(var1.getSize());
      this.setFocusable(true);
      ((RRCStatusBar)this.scrContext.getPanelMediator().getStatusPanel()).setTextLabel(this.bundle.getString("RSC_LOADING_MSG"));
   }

   public void loadApplet(String var1, String var2, int var3) {
      if (var2 != null && !var2.equals("")) {
         try {
            this.holder = new EmbedAppletDataHolder();
            this.stub = new EmbedAppletStub((RRCScreenContext)this.scrContext, this.holder, new URL(var1, var2, var3, this.serialPort.getRSCJarName()));
            this.stub.setParameter("host", var2);
            IPReach var4 = (IPReach)this.serialPort.getDevice();
            this.stub.setParameter("TCPPort", String.valueOf(var4.getIPPort()));
            this.stub.setParameter("target", Integer.toString(this.serialPort.getPortIndex() + 1));
            RRCLogger.log(300, 4, "Connecting to port " + Integer.toString(this.serialPort.getPortIndex() + 1));
            this.stub.setParameter("SessionID", var4.getRdmSessionId());
            this.stub.setParameter("SessionKey", var4.getRdmSessionKey());
            RRCLogger.log(
               300,
               4,
               "Connecting to serial port:"
                  + Integer.toString(this.serialPort.getPortIndex() + 1)
                  + " on Device "
                  + var2
                  + "using TCP Port "
                  + var4.getIPPort()
                  + " .RDM Session Info:"
                  + var4.getRdmSessionId()
                  + ":"
                  + var4.getRdmSessionKey()
            );
            this.classLoader = new EmbedAppletClassLoader(new URL[]{this.serialPort.getDevice().getRscFileHandle().toURL()}, null);
            String var5 = "com.raritan.serialconsole.sx.ui.InternalFrameSerialApplet";
            this.claz = this.classLoader.loadClass(var5);
            JApplet var6 = (JApplet)this.claz.newInstance();
            this.setApplet(var6);
            var6.setSize((int)this.getSize().getHeight() - 20, (int)this.getSize().getWidth() - 20);
            var6.setStub(this.stub);
            URLClassLoader var7 = new URLClassLoader(new URL[]{new URL("file:./")}, null);
            Thread.currentThread().setContextClassLoader(var7);
            var6.init();
            var6.start();
            var6.validate();
            Method var8 = var6.getClass().getMethod("getFrameComponent", null);
            Object var9 = var8.invoke(var6, null);
            Method var10 = var6.getClass().getMethod("setDefaultFocus", null);
            this.setDefaultFocusMethod(var10);
            var8 = var6.getClass().getMethod("addObserver", Observer.class);
            var8.invoke(var6, new RSCView.RSCObserver(this));
            if (!(var9 instanceof JInternalFrame)) {
               throw new IllegalArgumentException("Unknown component " + var9.getClass().getName());
            }

            this.appletPanel.setLayout(new BorderLayout());
            JInternalFrame var11 = (JInternalFrame)var9;
            this.appletPanel.add(var11.getRootPane(), "Center");
            this.appletPanel.revalidate();
            ((CardLayout)this.getLayout()).show(this, "appletCard");
            ((RRCStatusBar)this.scrContext.getPanelMediator().getStatusPanel()).setTextLabel("");
            var8 = var6.getClass().getMethod("connect", null);
            var9 = var8.invoke(var6, null);
            var8 = var6.getClass().getMethod("syncScreenSize", null);
            var8.invoke(var6, null);
            if (var9 instanceof Boolean) {
               this.serialPort.setConnected((Boolean)var9);
            }
         } catch (ClassCastException var12) {
            RRCLogger.logException(var12);
         } catch (MalformedURLException var13) {
            RRCLogger.logException(var13);
         } catch (SecurityException var14) {
            RRCLogger.logException(var14);
         } catch (NoSuchMethodException var15) {
            RRCLogger.logException(var15);
         } catch (IllegalArgumentException var16) {
            RRCLogger.logException(var16);
         } catch (IllegalAccessException var17) {
            RRCLogger.logException(var17);
         } catch (InvocationTargetException var18) {
            RRCLogger.logException(var18);
         } catch (ClassNotFoundException var19) {
            RRCLogger.logException(var19);
         } catch (InstantiationException var20) {
            RRCLogger.logException(var20);
         }
      }
   }

   @Override
   public void fillComponents(CommandContext var1) {
      this.dev = (Device)var1.getCommandParameter("selectedPortDevice");
      if (this.dev != null) {
         ((CardLayout)this.getLayout()).show(this, "loadingCard");
         this.thread = new RSCView.SerialPortThread(this);
         this.thread.start();
      }
   }

   @Override
   public void feedCommandContext(CommandContext var1) {
      this.stub = null;
      this.classLoader = null;
      this.claz = null;
      this.holder = null;
      JApplet var2 = this.getApplet();
      if (var2 != null && var2.isVisible()) {
         var2.setStub(null);

         try {
            var2.destroy();
         } catch (Throwable var4) {
         }

         Object var5 = null;
      }

      this.thread.interrupt();
      this.thread = null;
   }

   public synchronized JApplet getApplet() {
      return this.applet;
   }

   private synchronized void setApplet(JApplet var1) {
      this.applet = var1;
   }

   @Override
   public void setViewFocus() {
      Method var1 = this.getDefaultFocusMethod();
      if (var1 != null && this.applet != null) {
         try {
            var1.invoke(this.applet, null);
         } catch (Exception var3) {
            RRCLogger.logException(var3);
         }
      }
   }

   @Override
   public void setDefaultFocussedComponent() {
      JApplet var1 = this.getApplet();
      if (var1 != null) {
         var1.requestFocusInWindow();
      }
   }

   public void disconnected() {
      ((RRCScreenContext)this.scrContext).removePortInObservable(this.serialPort);
      this.getShellInternalFrame().dispose();
   }

   private synchronized void setDefaultFocusMethod(Method var1) {
      this.defFocusMethod = var1;
   }

   private synchronized Method getDefaultFocusMethod() {
      return this.defFocusMethod;
   }

   @Override
   public boolean hasFocus() {
      ShellInternalFrame var1 = this.getShellInternalFrame();
      return var1 != null && var1.isSelected();
   }

   @Override
   public boolean allowMaximumSize() {
      return false;
   }

   class RSCObserver implements Observer {
      private RSCView view;

      public RSCObserver(RSCView var2) {
         this.view = var2;
      }

      @Override
      public void update(Observable var1, Object var2) {
         if (var2.toString().startsWith("Exited")) {
            this.view.disconnected();
         } else if (var2 instanceof Exception) {
            Exception var3 = (Exception)var2;
            JOptionPane.showMessageDialog(
               JOptionPane.getFrameForComponent(RSCView.this), var3.getMessage(), RSCView.this.bundle.getString("optionpane.error.title"), 0
            );
            this.view.disconnected();
         } else if ("pack".equals(var2)) {
            RSCView.this.getShellInternalFrame().pack();
            RSCView.this.setViewFocus();
         }
      }
   }

   private class SerialPortThread extends Thread {
      private RSCView view;

      public SerialPortThread(RSCView var2) {
         this.setName("RSCThread");
         this.view = var2;
      }

      @Override
      public void run() {
         if (this.view != null) {
            RSCView.this.loadApplet("https", Util.getURLCompatibleIP(RSCView.this.dev.getDeviceConnector().getInetAddress()), RSCView.this.dev.getHttpsPort());
         }
      }
   }
}
