package com.raritan.rrc.ui.panes;

import com.raritan.rrc.ui.commands.DoSaveActivityLogCommand;
import com.raritan.tools.commands.CommandContext;
import com.raritan.tools.ui.ScreenContext;
import com.raritan.tools.util.io.AllFilesFilter;
import java.io.File;

public class SaveActivityLogPanel extends FileBrowserPanel {
   private static final long serialVersionUID = -7017529872865510276L;

   public SaveActivityLogPanel(boolean var1, ScreenContext var2) {
      super(var1, var2);
      this.setTitle(this.bundle.getString("filebrowser.save.activitylog.title"));
   }

   @Override
   public void makeLayout() {
      super.makeLayout();
      this.chooser.setDialogType(1);
      this.chooser.setCommand(new DoSaveActivityLogCommand(this.scrContext));
      this.chooser.addChoosableFileFilter(new AllFilesFilter(3));
   }

   @Override
   protected boolean checkPassedCommandConfirm(Object var1) {
      this.verifyFileExtension();
      boolean var2 = super.checkPassedCommandConfirm(var1);
      return var2 && this.confirmFileOverwrite();
   }

   private void verifyFileExtension() {
      File var1 = this.chooser.getSelectedFile();
      String var2 = var1.getName();
      int var3 = var2.lastIndexOf(46);
      if (var3 < 0) {
         var1 = new File(var1.getParentFile(), var2 + "." + "TXT".toLowerCase());
      }

      this.chooser.setSelectedFile(var1);
   }

   @Override
   public void fillComponents(CommandContext var1) {
      super.fillComponents(var1);
      this.chooser.rescanCurrentDirectory();
   }

   @Override
   protected void feedCommandContext(CommandContext var1) {
      var1.setCommandParameter("selectedFileMapper", AllFilesFilter.createFileMapper());
      super.feedCommandContext(var1);
   }
}
