package com.raritan.rrc.ui.panes;

import com.raritan.rrc.ui.commands.DoSaveTotalConfigurationCommand;
import com.raritan.tools.commands.CommandContext;
import com.raritan.tools.ui.ScreenContext;
import com.raritan.tools.util.io.AllFilesFilter;
import java.io.File;

public class SaveTotalConfigurationPanel extends FileBrowserPanel {
   private static final long serialVersionUID = -5219254633560134388L;

   public SaveTotalConfigurationPanel(boolean var1, ScreenContext var2) {
      super(var1, var2);
      this.setTitle(this.bundle.getString("filebrowser.save.totalconfig.title"));
   }

   @Override
   public boolean isDialog() {
      return this.isDialog;
   }

   @Override
   public void makeLayout() {
      super.makeLayout();
      this.chooser.setDialogType(1);
      this.chooser.setCommand(new DoSaveTotalConfigurationCommand(this.scrContext));
      this.chooser.addChoosableFileFilter(new AllFilesFilter(4));
   }

   @Override
   protected boolean checkPassedCommandConfirm(Object var1) {
      this.verifyFileExtension();
      boolean var2 = super.checkPassedCommandConfirm(var1);
      return var2 && this.confirmFileOverwrite();
   }

   private boolean fileExists(File var1) {
      return var1 != null && var1.exists();
   }

   private void verifyFileExtension() {
      File var1 = this.chooser.getSelectedFile();
      String var2 = var1.getName();
      boolean var3 = false;
      int var4 = var2.lastIndexOf(46);
      if (var4 < 0) {
         var1 = new File(var1.getParentFile(), var2 + "." + "RFP".toLowerCase());
      }

      this.chooser.setSelectedFile(var1);
   }

   @Override
   public void fillComponents(CommandContext var1) {
      super.fillComponents(var1);
      this.chooser.rescanCurrentDirectory();
   }

   @Override
   protected void feedCommandContext(CommandContext var1) {
      var1.setCommandParameter("selectedFileMapper", AllFilesFilter.createFileMapper());
      super.feedCommandContext(var1);
   }
}
