package com.raritan.rrc.ui.panes;

import com.raritan.rrc.ui.RRCScreenContext;
import com.raritan.rrc.ui.commands.DoSingleMouseModeCommand;
import com.raritan.rrc.util.OS;
import com.raritan.rrc.util.SpringUtilities;
import com.raritan.tools.commands.CancelButtonCommand;
import com.raritan.tools.commands.CommandContext;
import com.raritan.tools.resources.RaritanPropertyResourceBundle;
import com.raritan.tools.resources.RaritanResourceBundle;
import com.raritan.tools.ui.ScreenContext;
import com.raritan.tools.ui.components.CommandButton;
import com.raritan.tools.ui.panes.displays.AbstractDisplay;
import java.awt.AWTException;
import java.awt.FlowLayout;
import java.awt.Robot;
import javax.swing.JCheckBox;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.SpringLayout;
import javax.swing.SwingUtilities;

public class SingleCursorInstructionsPanel extends AbstractDisplay {
   private static final long serialVersionUID = -4386781648327798198L;
   private RRCScreenContext scrCtx;
   protected RaritanPropertyResourceBundle bundle;
   private JCheckBox showChkBox;
   private JLabel label3;

   public SingleCursorInstructionsPanel(boolean var1, ScreenContext var2) {
      super(var2);
      this.isDialog = var1;
      this.bundle = RaritanResourceBundle.getResourceBundle(this.scrContext.getLocale());
      this.scrCtx = (RRCScreenContext)var2;
      this.makeLayout();
      this.setShell(this.bundle.getString("SingleMouseModeInstructions.title"));
   }

   @Override
   public void makeLayout() {
      this.setLayout(new SpringLayout());
      JPanel var1 = new JPanel(new FlowLayout(1));
      JLabel var2 = new JLabel(
         "<html>"
            + this.bundle.getString("SingleMouseModeInstructions1.text")
            + "<br>"
            + this.bundle.getString("SingleMouseModeInstructions1cont.text")
            + "</html>"
      );
      var1.add(var2);
      this.add(var1);
      JPanel var3 = new JPanel(new FlowLayout(1));
      JLabel var4 = new JLabel(this.bundle.getString("SingleMouseModeInstructions2.text"));
      var3.add(var4);
      this.add(var3);
      JPanel var5 = new JPanel(new FlowLayout(1));
      this.label3 = new JLabel(
         this.bundle.getString("SingleMouseModeInstructions3.text")
            + RRCScreenContext.getKvmPopupKey()
            + this.bundle.getString("SingleMouseModeInstructions5.text")
      );
      var5.add(this.label3);
      this.add(var5);
      JPanel var6 = new JPanel(new FlowLayout(1));
      this.showChkBox = new JCheckBox(this.bundle.getString("SingleMouseModeInstructions4.text"));
      this.showChkBox.setSelected(true);
      var6.add(this.showChkBox);
      this.add(var6);
      JPanel var7 = new JPanel(new FlowLayout(1));
      this.ok = new CommandButton(this.bundle.getString("basescreen.command.ok.text"), this.scrContext);
      this.ok.setCommand(new DoSingleMouseModeCommand(this.scrContext));
      this.ok.addActionListener(this);
      var7.add(this.ok);
      this.cancel = new CommandButton(this.bundle.getString("basescreen.command.cancel.text"), this.scrContext);
      this.cancel.setCommand(new CancelButtonCommand(this.scrContext));
      this.cancel.addActionListener(this);
      var7.add(this.cancel);
      this.add(var7);
      SpringUtilities.makeCompactGrid(this, 5, 1, 15, 10, 15, 5);
   }

   @Override
   public void fillComponents(CommandContext var1) {
      this.label3
         .setText(
            this.bundle.getString("SingleMouseModeInstructions3.text")
               + RRCScreenContext.getKvmPopupKey()
               + this.bundle.getString("SingleMouseModeInstructions5.text")
         );
      this.showChkBox.setSelected(((RRCScreenContext)this.scrContext).getAppSettings().isSingleMouseInstructions());
      if (OS.getCurrent() == OS.MAC) {
         SwingUtilities.invokeLater(new Runnable() {
            @Override
            public void run() {
               SingleCursorInstructionsPanel.this.repaint();
            }
         });
      }
   }

   @Override
   protected void feedCommandContext(CommandContext var1) {
      var1.setCommandParameter("showSingleCursorModeInstructions", new Boolean(this.showChkBox.isSelected()));
      if (OS.getCurrent() == OS.MAC && "doSingleMouseModeCommand".equals(var1.getCommandKey())) {
         try {
            new Robot().mouseMove(0, 0);
         } catch (AWTException var3) {
         }
      }
   }
}
