package com.raritan.rrc.ui.panes;

import com.raritan.rrc.data.KvmPort;
import com.raritan.rrc.ui.RRCScreenContext;
import com.raritan.tools.commands.CommandContext;
import com.raritan.tools.ui.ScreenContext;
import com.raritan.tools.ui.panes.displays.AbstractDisplay;
import com.raritan.tools.ui.panes.displays.Shell;
import com.raritan.tools.ui.panes.displays.ShellForSmartCardDialog;
import java.util.ArrayList;
import nn.pp.common.smartcard.SmartCardReaderDialog;

public class SmartCardPanel extends AbstractDisplay {
   private ShellForSmartCardDialog shellForSmartCard;
   private SmartCardReaderDialog smartCardReaderDialog;

   public SmartCardPanel(boolean var1, ScreenContext var2) {
      super(var2);
      this.isDialog = true;
      this.shellForSmartCard = new ShellForSmartCardDialog(var2);
      this.smartCardReaderDialog = new SmartCardReaderDialog(this.shellForSmartCard, ((RRCScreenContext)var2).getSmartCardCore());
      this.shellForSmartCard.setSmartCardDialogAdapter(this.smartCardReaderDialog);
      this.shellForSmartCard.pack();
   }

   @Override
   public Shell getShell() {
      return this.shellForSmartCard;
   }

   @Override
   protected void feedCommandContext(CommandContext var1) {
   }

   @Override
   public void fillComponents(CommandContext var1) {
      ArrayList var2 = (ArrayList)((RRCScreenContext)this.scrContext).getSelectedDevicesObservable().getComponent();
      KvmPort var3 = (KvmPort)var2.get(0);
      this.smartCardReaderDialog.setSmartcardBean(var3.getSelectCardReaderAction().getConfiguredSmartCardBean());
   }

   @Override
   public void makeLayout() {
   }
}
