package com.raritan.rrc.ui.panes;

import com.raritan.rrc.data.Port;
import com.raritan.rrc.ui.commands.DoStartLoggingCommand;
import com.raritan.tools.commands.CommandContext;
import com.raritan.tools.ui.ScreenContext;
import com.raritan.tools.util.io.AllFilesFilter;

public class StartLoggingPanel extends FileBrowserPanel {
   private static final long serialVersionUID = -8425217259916272248L;
   private Port device;

   public StartLoggingPanel(boolean var1, ScreenContext var2) {
      super(var1, var2);
      this.setTitle(this.bundle.getString("filebrowser.start.logging.title"));
   }

   @Override
   public boolean isDialog() {
      return this.isDialog;
   }

   @Override
   public void makeLayout() {
      super.makeLayout();
      this.chooser.setDialogType(1);
      this.chooser.setCommand(new DoStartLoggingCommand(this.scrContext));
   }

   @Override
   protected boolean checkPassedCommandConfirm(Object var1) {
      boolean var2 = super.checkPassedCommandConfirm(var1);
      return var2 && this.confirmFileOverwrite();
   }

   @Override
   public void fillComponents(CommandContext var1) {
      this.device = (Port)var1.getCommandParameter("devices");
      super.fillComponents(var1);
      this.chooser.rescanCurrentDirectory();
   }

   @Override
   protected void feedCommandContext(CommandContext var1) {
      var1.setCommandParameter("devices", this.device);
      var1.setCommandParameter("selectedFileMapper", AllFilesFilter.createFileMapper());
      super.feedCommandContext(var1);
   }
}
