package com.raritan.rrc.ui.panes;

import com.raritan.tools.commands.CommandContext;
import com.raritan.tools.ui.ScreenContext;
import com.raritan.tools.ui.panes.displays.AbstractDisplay;
import com.raritan.tools.ui.panes.displays.Shell;
import com.raritan.tools.ui.panes.displays.ShellForOptionPane;
import javax.swing.JOptionPane;

public abstract class VirtualMediaDisconnectPanel extends AbstractDisplay {
   protected String portKey;
   protected ShellForOptionPane disconnectShell;

   public VirtualMediaDisconnectPanel(ScreenContext var1, String var2) {
      super(var1);
      this.portKey = var2;
      this.isDialog = true;
   }

   protected void loadShell(String var1) {
      this.disconnectShell = new ShellForOptionPane(this.scrContext) {
         @Override
         protected void performAction(Object var1) {
            if (VirtualMediaDisconnectPanel.this.bundle.getString("basescreen.command.yes.text").equals(var1)) {
               VirtualMediaDisconnectPanel.this.disconnectVm();
               JOptionPane.showOptionDialog(
                  this,
                  VirtualMediaDisconnectPanel.this.bundle.getString("vmpanel.DISCONNECT_SUCEESS_MESSAGE")
                     + "\n"
                     + VirtualMediaDisconnectPanel.this.bundle.getString("vmpanel.DISCONNECT_SUCEESS_NOTE"),
                  VirtualMediaDisconnectPanel.this.bundle.getString("optionpane.success.title"),
                  -1,
                  1,
                  null,
                  new Object[]{VirtualMediaDisconnectPanel.this.bundle.getString("basescreen.command.ok.text")},
                  null
               );
            }
         }
      };
      JOptionPane var2 = new JOptionPane(
         this.bundle.getString("vm.disconnect.message1") + " " + var1 + ". " + this.bundle.getString("vm.disconnect.message2"),
         3,
         -1,
         null,
         new Object[]{this.bundle.getString("vmpanel.POPUP_OPTION_YES"), this.bundle.getString("vmpanel.POPUP_OPTION_NO")}
      );
      this.disconnectShell.setOptionPane(var2);
      this.disconnectShell.setTitle(this.bundle.getString("vm.disconnect.title"));
   }

   protected abstract void disconnectVm();

   @Override
   public Shell getShell() {
      return this.disconnectShell;
   }

   @Override
   protected void feedCommandContext(CommandContext var1) {
   }

   @Override
   public void fillComponents(CommandContext var1) {
   }

   @Override
   public void makeLayout() {
   }
}
