package com.raritan.rrc.ui.rfbbridge;

import com.raritan.tools.util.Util;
import java.util.Date;

public class RFBProfile {
   public String connectId;
   public String username;
   public String password;
   public String rdmSession;
   private String rdmSessionMultiPortTag;
   public String proxyModeConnectionID;
   public int portId;
   public String portIdRDM;
   public int channelId;
   public String targetId;
   public boolean doInitSwitch;
   private String remoteHost;
   private String realRemoteHost;
   public int primaryPort;
   public int secondaryPort;
   public int sslPort;
   public boolean sslRequired;
   public boolean useProxy;
   private String proxyHost;
   public int proxyPort;
   public boolean noTrialAndError;
   public boolean drawEachPixelForRawRects;
   public boolean shareDesktop;
   public String norbox;
   private String norbox_ipv4target;
   private String norbox_ipv6target;
   public String protocol_version;
   public boolean initialMoniMode;
   public boolean driveRedirection;
   public int driveRedirectionNoDrives;
   public boolean forensicConsole;
   public boolean forensicNoKeyboard;
   public boolean forensicFilterKeyboard;
   public int replaySessionID;
   public int replayCimId;
   public Date replayStartTime;
   public Date replayEndTime;
   public String mouseSyncKey;
   public String mouseSyncKeyCodes;
   public String fullScreenKeyCodes;
   public boolean wlanEnabled;
   public boolean exclusiveMouse;
   public String vsType;
   public boolean vsTypeFull;
   public int vsPerms;
   public String kbdLayout;
   public String localKbdMapping;
   public String softKbdMapping;
   public String proxyUseSSL;
   public String jarVersion;

   public RFBProfile() {
      this(
         "",
         null,
         null,
         0,
         "0",
         false,
         "",
         443,
         80,
         443,
         false,
         false,
         null,
         0,
         true,
         false,
         true,
         false,
         false,
         false,
         false,
         -1,
         -1,
         null,
         null,
         1,
         "no",
         "",
         "",
         null,
         null
      );
   }

   public RFBProfile(
      String var1,
      String var2,
      String var3,
      int var4,
      String var5,
      boolean var6,
      String var7,
      int var8,
      int var9,
      int var10,
      boolean var11,
      boolean var12,
      String var13,
      int var14,
      boolean var15,
      boolean var16,
      boolean var17,
      boolean var18,
      boolean var19,
      boolean var20,
      boolean var21,
      int var22,
      int var23,
      Date var24,
      Date var25,
      int var26,
      String var27,
      String var28,
      String var29,
      String var30,
      String var31
   ) {
      this.connectId = var1;
      this.channelId = var4;
      this.targetId = var5;
      this.doInitSwitch = var6;
      this.username = var2;
      this.password = var3;
      this.remoteHost = var7;
      this.primaryPort = var8;
      this.secondaryPort = var9;
      this.sslPort = var10;
      this.sslRequired = var11;
      this.useProxy = var12;
      this.proxyHost = var13;
      this.proxyPort = var14;
      this.noTrialAndError = var15;
      this.drawEachPixelForRawRects = var16;
      this.shareDesktop = var17;
      this.driveRedirection = var18;
      this.forensicConsole = var19;
      this.forensicNoKeyboard = var20;
      this.forensicFilterKeyboard = var21;
      this.replaySessionID = var22;
      this.replayCimId = var23;
      this.replayStartTime = var24;
      this.replayEndTime = var25;
      this.driveRedirectionNoDrives = var26;
      this.norbox = var27;
      this.norbox_ipv4target = var28;
      this.norbox_ipv6target = var29;
      this.protocol_version = var30;
      this.rdmSessionMultiPortTag = var31;
   }

   @Override
   public String toString() {
      return "\nconnectId = "
         + this.connectId
         + "\nusername = "
         + this.username
         + "\nchannelId = "
         + this.channelId
         + "\ntargetId = "
         + this.targetId
         + "\nportIdRDM = "
         + this.portIdRDM
         + "\nrdmSession = "
         + this.rdmSession
         + "\nrdmSessionMultiPortTag = "
         + this.rdmSessionMultiPortTag
         + "\nproxyModeConnectionID = "
         + this.proxyModeConnectionID
         + "\ndoInitSwitch = "
         + this.doInitSwitch
         + "\nremoteHost = "
         + this.remoteHost
         + "\nprimaryPort = "
         + this.primaryPort
         + "\nsecondaryPort = "
         + this.secondaryPort
         + "\nsslPort = "
         + this.sslPort
         + "\nsslRequired = "
         + this.sslRequired
         + "\nuseProxy = "
         + this.useProxy
         + "\nproxyHost = "
         + this.getProxyHost()
         + "\nproxyPort = "
         + this.proxyPort
         + "\nnoTrialAndError = "
         + this.noTrialAndError
         + "\ndrawEachPixelForRawRects = "
         + this.drawEachPixelForRawRects
         + "\nshareDesktop = "
         + this.shareDesktop
         + "\ndriveRedirection = "
         + this.driveRedirection
         + "\ndriveRedirectionNoDrives = "
         + this.driveRedirectionNoDrives
         + "\nnorbox = "
         + this.norbox
         + "\nnorbox_ipv4target = "
         + this.getNorbox_ipv4target()
         + "\nnorbox_ipv6target = "
         + this.getNorbox_ipv6target()
         + "\nprotocol_version = "
         + this.protocol_version
         + "\nvsPerms = "
         + this.vsPerms
         + "\nvsType = "
         + this.vsType
         + "\nvsTypeFull = "
         + this.vsTypeFull;
   }

   public void setRemoteHost(String var1) {
      this.remoteHost = var1;
   }

   public String getRemoteHost() {
      return this.remoteHost;
   }

   public String getURLCompatibleRemoteHost() {
      return Util.getURLCompatibleIP(this.remoteHost);
   }

   public void setRealRemoteHost(String var1) {
      this.realRemoteHost = var1;
   }

   public String getRealRemoteHost() {
      return this.realRemoteHost;
   }

   public void setProxyHost(String var1) {
      this.proxyHost = var1;
   }

   public String getProxyHost() {
      return this.proxyHost;
   }

   public void setNorbox_ipv6target(String var1) {
      this.norbox_ipv6target = var1;
   }

   public String getNorbox_ipv6target() {
      return this.norbox_ipv6target;
   }

   public void setNorbox_ipv4target(String var1) {
      this.norbox_ipv4target = var1;
   }

   public String getNorbox_ipv4target() {
      return this.norbox_ipv4target;
   }

   public String getRdmSessionMultiPortTag() {
      return this.rdmSessionMultiPortTag;
   }

   public void setRdmSessionMultiPortTag(String var1) {
      this.rdmSessionMultiPortTag = var1;
   }
}
