package com.raritan.rrc.util;

import com.raritan.rrc.data.BladeChassis;
import com.raritan.rrc.data.Device;
import com.raritan.rrc.data.Port;
import com.raritan.rrc.data.VirtualBladeChassis;
import java.util.Map.Entry;

public class DeviceComparator extends HierComparator {
   private int sortType = 0;

   public void setSortType(int var1) {
      this.sortType = var1;
   }

   public int getSortType() {
      return this.sortType;
   }

   @Override
   public int compare(Object var1, Object var2) {
      Object var3 = ((Entry)var1).getValue();
      Object var4 = ((Entry)var2).getValue();
      Device var5 = var3 instanceof Device ? (Device)var3 : null;
      Device var6 = var4 instanceof Device ? (Device)var4 : null;
      if (var5 != null && var6 != null) {
         Port var7 = var5 instanceof Port ? (Port)var5 : null;
         Port var8 = var6 instanceof Port ? (Port)var6 : null;
         BladeChassis var9 = var5 instanceof BladeChassis ? (BladeChassis)var5 : null;
         BladeChassis var10 = var6 instanceof BladeChassis ? (BladeChassis)var6 : null;
         if (var7 != null == (var8 != null) || var9 != null || var10 != null) {
            if (var9 != null != (var10 != null) && var7 == null && var8 == null) {
               if (var10 != null) {
                  if (var5.isConnected()) {
                     return -1;
                  } else {
                     return var10.isConnected() ? 1 : -1;
                  }
               } else if (var6.isConnected()) {
                  return 1;
               } else {
                  return var9.isConnected() ? -1 : 1;
               }
            } else if (var7 == null && var8 == null && var9 == null && var10 == null) {
               return super.compare(var5.getName(), var6.getName());
            } else if (var7 != null && var8 != null) {
               int var18 = var7.getSortPos();
               int var19 = var8.getSortPos();
               var7.setSortType(this.sortType);
               var8.setSortType(this.sortType);
               boolean var20 = Device.isFixedSortPos(var18);
               boolean var21 = Device.isFixedSortPos(var19);
               if (var20 && var21) {
                  return var18 == var19 ? super.compare(var7, var8) : var18 - var19;
               } else if (var20) {
                  return 1;
               } else if (var21) {
                  return -1;
               } else if (this.sortType == 1) {
                  return super.compare(var7.getName(), var8.getName());
               } else if (this.sortType == 0) {
                  return var7.getPortIndex() < var8.getPortIndex()
                     ? -1
                     : (var7.getPortIndex() > var8.getPortIndex() ? 1 : super.compare(var7.getName(), var8.getName()));
               } else if (this.sortType != 2) {
                  return 0;
               } else {
                  return var18 == var19 ? super.compare(var7.getName(), var8.getName()) : var18 - var19;
               }
            } else if (var9 != null && var10 != null) {
               if (this.sortType == 2) {
                  if (var9 instanceof VirtualBladeChassis && var10 instanceof BladeChassis) {
                     return -1;
                  }

                  if (var9 instanceof BladeChassis && var10 instanceof VirtualBladeChassis) {
                     return 1;
                  }
               } else if (this.sortType == 0) {
                  if (var9 instanceof VirtualBladeChassis && !(var10 instanceof VirtualBladeChassis)) {
                     return 1;
                  }

                  if (var10 instanceof VirtualBladeChassis && !(var9 instanceof VirtualBladeChassis)) {
                     return -1;
                  }

                  if (var9 instanceof VirtualBladeChassis && var10 instanceof VirtualBladeChassis) {
                     return super.compare(var9.getName(), var10.getName());
                  }

                  return var9.getPortIndex() < var10.getPortIndex()
                     ? -1
                     : (var9.getPortIndex() > var10.getPortIndex() ? 1 : super.compare(var9.getName(), var10.getName()));
               }

               return super.compare(var9.getName(), var10.getName());
            } else {
               Port var11 = var7 != null ? var7 : var8;
               BladeChassis var12 = var9 != null ? var9 : var10;
               int var13 = var11.getSortPos();
               int var14 = var12.getSortPos();
               var11.setSortType(this.sortType);
               boolean var15 = Device.isFixedSortPos(var13);
               boolean var16 = Device.isFixedSortPos(var14);
               if (var15 && var16) {
                  return var13 == var14 ? super.compare(var11, var12) : var13 - var14;
               } else if (var15) {
                  return var11 == var7 ? 1 : -1;
               } else if (var16) {
                  return -1;
               } else {
                  if (this.sortType == 1) {
                     if (var11 == var7) {
                        return super.compare(var11.getName(), var12.getName());
                     }

                     if (var11 == var8) {
                        return super.compare(var12.getName(), var11.getName());
                     }
                  } else if (this.sortType == 0) {
                     if (var11 == var7) {
                        if (var12 instanceof VirtualBladeChassis) {
                           return -1;
                        }

                        return var11.getPortIndex() < var12.getPortIndex()
                           ? -1
                           : (var11.getPortIndex() > var12.getPortIndex() ? 1 : super.compare(var11.getName(), var12.getName()));
                     }

                     if (var11 == var8) {
                        if (var12 instanceof VirtualBladeChassis) {
                           return 1;
                        }

                        return var11.getPortIndex() < var12.getPortIndex()
                           ? 1
                           : (var11.getPortIndex() > var12.getPortIndex() ? -1 : super.compare(var12.getName(), var11.getName()));
                     }
                  } else if (this.sortType == 2) {
                     if (var13 == var14) {
                        if (var12 == var9 && var9 instanceof VirtualBladeChassis) {
                           return -1;
                        }

                        if (var12 == var10 && var10 instanceof VirtualBladeChassis) {
                           return 1;
                        }

                        if (var11 == var7) {
                           return super.compare(var11.getName(), var12.getName());
                        }

                        if (var11 == var8) {
                           return super.compare(var12.getName(), var11.getName());
                        }
                     } else {
                        if (var11 == var7) {
                           return var13 - var14;
                        }

                        if (var11 == var8) {
                           return var14 - var13;
                        }
                     }
                  }

                  return 0;
               }
            }
         } else if (var8 != null) {
            if (var5.isConnected()) {
               return -1;
            } else {
               return var8.isConnected() ? 1 : -1;
            }
         } else if (var6.isConnected()) {
            return 1;
         } else {
            return var7.isConnected() ? -1 : 1;
         }
      } else {
         return 0;
      }
   }
}
