package com.raritan.rrc.util;

import java.io.Serializable;
import java.math.BigInteger;
import java.util.Comparator;

public class HierComparator implements Comparator, Serializable {
   private static final long serialVersionUID = 8283687772792937969L;
   private StringBuffer s1Buf = new StringBuffer("");
   private StringBuffer s2Buf = new StringBuffer("");
   StringBuffer part = new StringBuffer("");

   @Override
   public int compare(Object var1, Object var2) {
      Object var3 = null;
      Object var4 = null;
      if (var1 instanceof String) {
         var3 = (String)var1;
      } else {
         if (!(var1 instanceof Displayable)) {
            return -1;
         }

         var3 = ((Displayable)var1).getSortValue();
      }

      if (var2 instanceof String) {
         var4 = (String)var2;
      } else {
         if (!(var1 instanceof Displayable)) {
            return -1;
         }

         var4 = ((Displayable)var2).getSortValue();
      }

      if (var3.equalsIgnoreCase((String)var4)) {
         return 0;
      } else if (var3.length() == 0) {
         return 1;
      } else if (var4.length() == 0) {
         return -1;
      } else if ((!Character.isDigit(var3.charAt(0)) || Character.isDigit(var4.charAt(0)))
         && (Character.isDigit(var3.charAt(0)) || !Character.isDigit(var4.charAt(0)))) {
         this.s1Buf.delete(0, this.s1Buf.length());
         this.s2Buf.delete(0, this.s2Buf.length());
         this.s1Buf.insert(0, (String)var3);
         this.s2Buf.insert(0, (String)var4);

         while (this.s1Buf.length() > 0 && this.s2Buf.length() > 0) {
            String var5 = this.parsePart(this.s1Buf);
            String var6 = this.parsePart(this.s2Buf);
            if (Character.isDigit(var5.charAt(0))) {
               BigInteger var7 = new BigInteger(var5);
               BigInteger var8 = new BigInteger(var6);
               if (!var7.equals(var8)) {
                  return var7.compareTo(var8);
               }

               if (var5.length() > var6.length()) {
                  return -1;
               }
            } else {
               int var11 = var5.compareToIgnoreCase(var6);
               if (var11 != 0) {
                  return var11;
               }
            }
         }

         return this.s1Buf.length() == 0 ? -1 : 1;
      } else {
         return var3.charAt(0) - var4.charAt(0);
      }
   }

   private String parsePart(StringBuffer var1) {
      this.part.delete(0, this.part.length());
      boolean var2 = Character.isDigit(var1.charAt(0));

      while (var1.length() > 0 && Character.isDigit(var1.charAt(0)) == var2) {
         this.part.append(var1.charAt(0));
         var1.deleteCharAt(0);
      }

      return this.part.toString();
   }

   @Override
   public boolean equals(Object var1) {
      return var1 instanceof HierComparator;
   }
}
