package com.raritan.rrc.util;

import com.raritan.rrc.data.Device;
import com.raritan.rrc.data.Port;
import com.raritan.rrc.ui.RRCScreenContext;
import com.raritan.rrc.ui.rfbbridge.RFBView;
import com.raritan.tools.util.Util;
import java.util.ArrayList;
import javax.swing.JDialog;

public final class MPCUtil {
   private static boolean isCCMultiMonitorLaunch = false;

   private MPCUtil() {
   }

   public static synchronized void notifyObservers(RRCScreenContext var0, Device var1) {
      if (var1 == null) {
         var0.getSelectedDevicesObservable().setComponent(null);
      } else {
         ArrayList var2 = new ArrayList(1);
         var2.add(var1);
         var0.getSelectedDevicesObservable().setComponent(var2);
      }
   }

   public static synchronized boolean isCCLaunched(RRCScreenContext var0) {
      return var0.getApplicationProperty("connection") != null;
   }

   public static synchronized boolean isCCMultiMonitorLaunch() {
      return isCCMultiMonitorLaunch;
   }

   public static synchronized void setCCMultiMonitorLaunch(boolean var0) {
      isCCMultiMonitorLaunch = var0;
   }

   public static synchronized void notifyObserversIfSelected(RRCScreenContext var0, Device var1) {
      Object var2 = var0.getSelectedDevicesObservable().getComponent();
      if (var2 instanceof ArrayList) {
         ArrayList var3 = (ArrayList)var2;
         if (var3.size() > 0 && var3.get(0).equals(var1)) {
            notifyObservers(var0, var1);
         }
      }
   }

   public static void clearUnfocusedMenus(RRCScreenContext var0) {
      ArrayList var1 = var0.getListOfOpenPorts();
      Object var2 = null;

      for (int var3 = 0; var1 != null && var3 < var1.size(); var3++) {
         var2 = (Port)var0.getPortByKeyObservable((String)var1.get(var3));
         if (var2 != null && ((Port)var2).getView() instanceof RFBView) {
            ((RFBView)((Port)var2).getView()).setContextMenuKVMVisible(false);
         }
      }
   }

   public static synchronized void notifyOpenPortsObservers(RRCScreenContext var0) {
      if (var0 != null) {
         var0.sendOpenPortNotification();
      }
   }

   public static void jre17WorkaroundInheritAlwaysOnTop(JDialog var0) {
      Util.jre17WorkaroundInheritAlwaysOnTop(var0);
   }
}
