package com.raritan.rrc.util;

import java.net.Inet6Address;
import java.net.InetAddress;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;

public class MixedIPAddrComparator implements Comparator {
   private static IPAddrComparator ipAddrComparator = new IPAddrComparator();

   @Override
   public int compare(Object var1, Object var2) {
      boolean var3 = var1 instanceof Inet6Address;
      boolean var4 = var2 instanceof Inet6Address;
      if (var3 ^ var4) {
         return var3 ? -1 : 1;
      } else {
         return ipAddrComparator.compare(var1, var2);
      }
   }

   public static void main(String[] var0) throws Exception {
      ArrayList var1 = new ArrayList();
      var1.add(InetAddress.getByName("192.168.51.52"));
      var1.add(InetAddress.getByName("192.143.91.53"));
      var1.add(InetAddress.getByName("192.168.91.53"));
      var1.add(InetAddress.getByName("92.168.91.53"));
      var1.add(InetAddress.getByName("192.168.51.53"));
      var1.add(InetAddress.getByName("192.43.51.53"));
      var1.add(InetAddress.getByName("192.43.51.200"));
      var1.add(InetAddress.getByName("31.168.91.53"));
      var1.add(InetAddress.getByName("0.1.0.53"));
      var1.add(InetAddress.getByName("0.1.0.53"));
      var1.add(InetAddress.getByName("192.168.221.53"));
      var1.add(InetAddress.getByName("fd00:a:b:2400::21"));
      var1.add(InetAddress.getByName("fd00:a:b:2400::20"));
      var1.add(InetAddress.getByName("fd00:a:b:2400::20"));
      var1.add(InetAddress.getByName("ad00:a:b:2400::20"));
      var1.add(InetAddress.getByName("ad00:c:0b:2400::20"));
      var1.add(InetAddress.getByName("ad00:c:a:2400::20"));
      var1.add(InetAddress.getByName("ad00:c:1b:2400::20"));
      Collections.sort(var1, new MixedIPAddrComparator());
      System.out.println(var1);
   }
}
