package com.raritan.rrc.util;

public final class OS {
   public static final OS WINDOWS = new OS("Windows", false);
   public static final OS LINUX = new OS("Linux", true);
   public static final OS SOLARIS = new OS("Sun", true);
   public static final OS MAC = new OS("Mac", true);
   private static final OS[] STORAGE = new OS[]{WINDOWS, LINUX, SOLARIS, MAC};
   private String name = null;
   private boolean unixOS = false;

   private OS(String var1, boolean var2) {
      this.name = var1;
      this.unixOS = var2;
   }

   public static OS valueOf(String var0) {
      int var1 = indexOf(var0);
      return var1 != -1 ? STORAGE[var1] : null;
   }

   public static OS getCurrent() {
      return valueOf(ModemOSSupport.getOSname());
   }

   private static int indexOf(String var0) {
      if (var0 == null) {
         return -1;
      } else {
         for (int var2 = 0; var2 < STORAGE.length; var2++) {
            OS var1 = STORAGE[var2];
            if (var0.equals(var1.name)) {
               return var2;
            }
         }

         return -1;
      }
   }

   public boolean isUnixOS() {
      return this.unixOS;
   }

   @Override
   public String toString() {
      return this.name;
   }
}
