package com.raritan.rrc.util.modem;

import com.raritan.rrc.util.ModemOSSupport;
import com.raritan.rrc.util.OS;
import java.util.ArrayList;
import java.util.Locale;
import netscape.javascript.JSObject;

public abstract class ModemConnector {
   public static final int ERROR_NONE = 0;
   public static final int ERROR_UNSPECIFIED = 1;
   public static final int ERROR_PORT_INUSE = 633;
   public static final int ERROR_MODEM_REPORTED = 651;
   public static final int ERROR_AUTH_FAILED = 691;
   private ArrayList _dialStatusListeners = new ArrayList();

   protected ModemConnector() {
   }

   public static ModemConnector getConnector(JSObject var0) {
      return getConnector(var0, null);
   }

   public static ModemConnector getConnector(JSObject var0, Locale var1) {
      if (!ModemOSSupport.isOSSupported()) {
         System.out.println(0);
         return null;
      } else {
         OS var2 = OS.valueOf(ModemOSSupport.getOSname());
         if (var2 == OS.WINDOWS) {
            return (ModemConnector)(var0 != null ? new RRC_RAS_Applet(var0) : new RRC_RAS(var1));
         } else {
            return var2 != OS.LINUX && var2 != OS.SOLARIS && var2 != OS.MAC ? null : new PPPDConnector(var1);
         }
      }
   }

   public long rasConnect(String var1, String var2) throws Exception {
      return 0L;
   }

   public long rasConnectWithIdentity(String var1, String var2, String var3, String var4) throws Exception {
      return 0L;
   }

   public long rasEnumConnections() {
      return 0L;
   }

   public long rasEnumDevices() {
      return 0L;
   }

   public long rasEnumEntries() {
      return 0L;
   }

   public String rasGetDeviceName(long var1) {
      return "";
   }

   public String rasGetDeviceType(long var1) {
      return "";
   }

   public String rasGetEntryName(long var1) {
      return "";
   }

   public void rasHangUp() {
   }

   public String rasGetServerIP() {
      return "";
   }

   public synchronized void addDialStatusListener(DialStatusListener var1) {
      this._dialStatusListeners.add(var1);
   }

   public synchronized void removeDialStatusListener(DialStatusListener var1) {
      this._dialStatusListeners.remove(var1);
   }

   protected synchronized void fireDialStatusMsg(String var1) {
      for (DialStatusListener var3 : this._dialStatusListeners) {
         var3.dialingStatus(var1);
      }
   }
}
