package com.raritan.smartcard;

import java.lang.reflect.InvocationTargetException;

public class SmartCardCoreFactory {
   private static SmartCardCore defaultImpl;
   private static final String DEFAULT_IMPL_CLASS = "com.raritan.smartcard.impl.SmartCardCoreImpl";

   public static synchronized SmartCardCore getDefault() throws SmartCardInitException {
      if (defaultImpl == null) {
         defaultImpl = getInstance("com.raritan.smartcard.impl.SmartCardCoreImpl");
      }

      return defaultImpl;
   }

   public static synchronized void reset() {
      defaultImpl = null;
   }

   public static SmartCardCore getInstance(String var0) throws SmartCardInitException {
      Class var1 = null;

      try {
         var1 = Class.forName(var0);
      } catch (ClassNotFoundException var9) {
         throw new SmartCardInitException(var9);
      }

      Class var2;
      try {
         var2 = var1.asSubclass(SmartCardCore.class);
      } catch (ClassCastException var8) {
         throw new SmartCardInitException(var8);
      }

      Object var3 = null;

      try {
         var3 = var2.getConstructor();
      } catch (SecurityException var6) {
         throw new SmartCardInitException(var6);
      } catch (NoSuchMethodException var7) {
         throw new SmartCardInitException(var7);
      }

      try {
         return (SmartCardCore)var3.newInstance();
      } catch (IllegalArgumentException var10) {
         throw new SmartCardInitException(var10);
      } catch (InstantiationException var11) {
         throw new SmartCardInitException(var11);
      } catch (IllegalAccessException var12) {
         throw new SmartCardInitException(var12);
      } catch (InvocationTargetException var13) {
         if (var13.getCause() instanceof SmartCardInitException) {
            SmartCardInitException var5 = (SmartCardInitException)var13.getCause();
            var5.fillInStackTrace();
            throw var5;
         } else {
            throw new SmartCardInitException(var13);
         }
      }
   }

   public static void main(String[] var0) throws Exception {
      getDefault();
   }

   static {
      System.setProperty("sun.security.smartcardio.t1GetResponse", "false");
      System.setProperty("sun.security.smartcardio.t0GetResponse", "false");
   }
}
