package com.raritan.smartcard.impl;

import com.raritan.smartcard.SmartCardReaderStatus;

public class CardAndReaderEventsStateMachine {
   private SmartCardReaderStatus cardReaderState = SmartCardReaderStatus.UNKNOWN;
   private final CardEventsStateMachine cardState = new CardEventsStateMachine();

   public boolean setCardReaderStatus(SmartCardReaderStatus var1) {
      if (SmartCardReaderStatus.PRESENT.equals(var1)) {
         if (this.cardReaderState.equals(SmartCardReaderStatus.UNKNOWN)) {
            this.cardReaderState = var1;
            return true;
         }
      } else if (SmartCardReaderStatus.ABSENT.equals(var1)) {
         if (this.cardReaderState.equals(SmartCardReaderStatus.PRESENT)) {
            this.cardReaderState = var1;
            return true;
         }
      } else {
         assert false : "Non supported State " + var1;
      }

      return false;
   }

   public boolean setCardStatus(SmartCardReaderStatus var1) {
      return this.cardReaderState.equals(SmartCardReaderStatus.PRESENT) ? this.cardState.setCardStatus(var1) : false;
   }

   public SmartCardReaderStatus getCardReaderState() {
      return this.cardReaderState;
   }

   public SmartCardReaderStatus getCardState() {
      return this.cardState.getCardState();
   }
}
