package com.raritan.smartcard.impl;

import java.lang.management.ManagementFactory;
import java.util.Collections;
import java.util.HashMap;
import java.util.Map;
import java.util.WeakHashMap;
import javax.management.InstanceAlreadyExistsException;
import javax.management.JMX;
import javax.management.MBeanRegistrationException;
import javax.management.MBeanServer;
import javax.management.MalformedObjectNameException;
import javax.management.NotCompliantMBeanException;
import javax.management.ObjectName;
import javax.management.StandardMBean;
import javax.smartcardio.Card;

public class CardLockProviderFactory {
   private static final String PROPERTY_LOCK_MAP = "lockMap";
   private static final String OBJECT_NAME = "com.raritan.smartcard.impl:type=CardLockProviderFactory,name=properties";

   public static CardLockProvider getCardLockProvider() {
      return new CardLockProviderImpl(getSharedLockMap(getProperties()));
   }

   private static Map<String, Object> getProperties() {
      ObjectName var0 = null;

      try {
         var0 = new ObjectName("com.raritan.smartcard.impl:type=CardLockProviderFactory,name=properties");
      } catch (MalformedObjectNameException var7) {
         assert false;
      }

      MBeanServer var1 = ManagementFactory.getPlatformMBeanServer();
      if (!var1.isRegistered(var0)) {
         HashMap var2 = new HashMap();
         var2.put("lockMap", new WeakHashMap());

         try {
            var1.registerMBean(new StandardMBean(Collections.unmodifiableMap(var2), Map.class), var0);
         } catch (InstanceAlreadyExistsException var4) {
         } catch (MBeanRegistrationException var5) {
            assert false;
         } catch (NotCompliantMBeanException var6) {
            assert false;
         }
      }

      return JMX.newMBeanProxy(var1, var0, Map.class);
   }

   private static WeakHashMap<Card, Map> getSharedLockMap(Map var0) {
      return (WeakHashMap<Card, Map>)var0.get("lockMap");
   }
}
