package com.raritan.smartcard.impl;

import com.raritan.smartcard.SmartCardCore;
import com.raritan.smartcard.SmartCardCoreFactory;
import com.raritan.smartcard.SmartCardInitException;
import com.raritan.smartcard.SmartCardReaderSession;
import java.util.List;
import nn.pp.core.JVMVersionInfo;
import nn.pp.core.Platform;

public class SmartCardCoreImpl implements SmartCardCore {
   private final SmartCardCore smartCardCore;

   public SmartCardCoreImpl() throws SmartCardInitException {
      if (!JVMVersionInfo.getJVMVersionInfo().isJava16()) {
         throw new SmartCardInitException(SmartCardInitException.ExceptionCause.UNSUPPORTED_JRE);
      } else if (Platform.isMac()) {
         throw new SmartCardInitException(SmartCardInitException.ExceptionCause.UNSUPPORTED_OS);
      } else {
         this.smartCardCore = SmartCardCoreFactory.getInstance("com.raritan.smartcard.impl.SmartCardCoreImpl0");
      }
   }

   @Override
   public List<String> getAvailableSmartCardReaders() {
      return this.smartCardCore.getAvailableSmartCardReaders();
   }

   @Override
   public SmartCardReaderSession createCardReaderSessionWithEricKey(
      String var1, String var2, int var3, boolean var4, int var5, int var6, String var7, String var8
   ) {
      return this.smartCardCore.createCardReaderSessionWithEricKey(var1, var2, var3, var4, var5, var6, var7, var8);
   }

   @Override
   public SmartCardReaderSession createCardReaderSessionWithRdmSessionID(
      String var1, String var2, int var3, boolean var4, int var5, int var6, String var7, String var8
   ) {
      return this.smartCardCore.createCardReaderSessionWithRdmSessionID(var1, var2, var3, var4, var5, var6, var7, var8);
   }
}
