package com.raritan.smartcard.impl;

import com.raritan.smartcard.SmartCardCore;
import com.raritan.smartcard.SmartCardInitException;
import com.raritan.smartcard.SmartCardReaderSession;
import java.util.List;

public class SmartCardCoreImpl0 implements SmartCardCore {
   private final SmartCardClientModule clientModule = new SmartCardClientModule();
   private final CardLockProvider lockProvider = CardLockProviderFactory.getCardLockProvider();
   private final TransportProtoProvider transProtoProvider = new TransportProtoProviderImpl();
   private final CardAccessManager cardAccessManager = new CardAccessManager(this.clientModule, this.lockProvider, this.transProtoProvider);

   public SmartCardCoreImpl0() throws SmartCardInitException {
   }

   @Override
   public List<String> getAvailableSmartCardReaders() {
      return this.clientModule.getSmartCardReaders(true);
   }

   @Override
   public SmartCardReaderSession createCardReaderSessionWithEricKey(
      String var1, String var2, int var3, boolean var4, int var5, int var6, String var7, String var8
   ) {
      return new SmartCardReaderSessionImpl(var1, var2, var3, var4, var5, var6, null, var7, var8, this.cardAccessManager);
   }

   @Override
   public SmartCardReaderSession createCardReaderSessionWithRdmSessionID(
      String var1, String var2, int var3, boolean var4, int var5, int var6, String var7, String var8
   ) {
      return new SmartCardReaderSessionImpl(var1, var2, var3, var4, var5, var6, var7, null, var8, this.cardAccessManager);
   }
}
