package com.raritan.smartcard.impl;

import java.util.logging.Level;
import java.util.logging.Logger;
import javax.smartcardio.CardChannel;
import javax.smartcardio.CardException;
import javax.smartcardio.CommandAPDU;
import javax.smartcardio.ResponseAPDU;

public class T0TransportProtoHandler implements TransportProtoHandler {
   private static final Logger LOGGER = Logger.getLogger(T0TransportProtoHandler.class.getName());
   private static final int MAX_BYTES = 255;
   private final CardChannel cardChannel;
   private ResponseAPDU lastRapdu;
   private CommandAPDU lastCapdu;
   private CommandAPDU selectFile;
   private CommandAPDU verifyData;

   public T0TransportProtoHandler(CardChannel var1) {
      this.cardChannel = var1;
   }

   private static void print(String var0, byte[] var1) {
   }

   private ResponseAPDU transmit0(CommandAPDU var1) throws CardException {
      print("CAPDU : ", var1.getBytes());
      if (this.lastRapdu != null) {
         ResponseAPDU var2 = this.lastRapdu;
         this.lastRapdu = null;
         if (var1.getINS() == 192) {
            if (var1.getNe() < var2.getNr()) {
               byte[] var9 = new byte[var1.getNe() + 2];
               var9[var9.length - 2] = 97;
               int var4 = var2.getNr() - var1.getNe();
               var9[var9.length - 1] = (byte)(var4 > 255 ? 255 : var4);
               System.arraycopy(var2.getBytes(), 0, var9, 0, var1.getNe());
               byte[] var5 = new byte[var4 + 2];
               System.arraycopy(var2.getBytes(), var1.getNe(), var5, 0, var5.length);
               var2 = new ResponseAPDU(var9);
               this.lastRapdu = new ResponseAPDU(var5);
            }

            return var2;
         }
      }

      boolean var6 = false;
      if (var1.getINS() == 164) {
         this.selectFile = var1;
         var6 = true;
      } else if (this.selectFile != null) {
         print("Select CAPDU : ", this.selectFile.getBytes());
         ResponseAPDU var3 = this.cardChannel.transmit(this.selectFile);
         print("Select RAPDU : ", var3.getBytes());
      }

      ResponseAPDU var8 = this.cardChannel.transmit(var1);
      print("RAPDU : ", var8.getBytes());
      LOGGER.log(Level.INFO, "RAPDU ORIGINAL STATUS " + Integer.toHexString(var8.getSW1()) + Integer.toHexString(var8.getSW2()));
      if (var8.getNr() == 0 || var8.getNr() == var1.getNe()) {
         return var8;
      } else if (var8.getNr() > var1.getNe()) {
         this.lastRapdu = var8;
         return var8.getNr() > 255 ? new ResponseAPDU(new byte[]{97, -1}) : new ResponseAPDU(new byte[]{97, (byte)var8.getNr()});
      } else {
         return var8;
      }
   }

   @Override
   public byte[] transmit(byte[] var1) throws CardException {
      CommandAPDU var2 = new CommandAPDU(var1);
      ResponseAPDU var3 = this.cardChannel.transmit(var2);
      return var3.getBytes();
   }
}
