package com.raritan.smartcard.impl.commands;

import com.raritan.smartcard.SmartCardException;
import java.io.IOException;

public class AuthHttpIDChallResponse implements SupportsVisitor<CommandVisitorV01_00> {
   private final byte[] challenge;
   private final String httpSessionID;

   public AuthHttpIDChallResponse(byte[] var1, String var2) throws SmartCardException {
      this.challenge = var1;
      this.httpSessionID = var2;
   }

   public void accept(CommandVisitorV01_00 var1) throws IOException, SmartCardException {
      var1.handleHttpIDChallengeResponse(this);
   }

   public byte[] getChallenge() {
      return this.challenge;
   }

   public String getHttpSessionID() {
      return this.httpSessionID;
   }
}
