package com.raritan.smartcard.impl.commands;

import com.raritan.smartcard.SmartCardException;
import java.io.IOException;

public class CardInsertedMessage implements SupportsVisitor<CommandVisitorV01_00> {
   private final String proto;
   private final byte[] atrBytes;

   public CardInsertedMessage(String var1, byte[] var2) {
      this.proto = var1;
      this.atrBytes = var2;
   }

   public void accept(CommandVisitorV01_00 var1) throws IOException, SmartCardException {
      var1.handleCardInsertedMessage(this);
   }

   public String getProto() {
      return this.proto;
   }

   public byte[] getAtrBytes() {
      return this.atrBytes;
   }
}
