package com.raritan.smartcard.impl.crp.V01_00;

import com.raritan.smartcard.SmartCardException;
import com.raritan.smartcard.impl.EventsListenerManager;
import com.raritan.smartcard.impl.commands.ClientCommandsExecutor;
import com.raritan.smartcard.impl.commands.CommandVisitorV01_00;
import com.raritan.smartcard.impl.commands.SupportsVisitor;
import com.raritan.smartcard.impl.crp.CRPProtoHandler;
import com.raritan.smartcard.impl.crp.MessageToCommandProducer;
import java.io.IOException;
import java.lang.reflect.ParameterizedType;
import nn.pp.core.Util;
import nn.pp.core.impl.MonitoringDataInputStream;
import nn.pp.core.impl.MonitoringDataOutputStream;

public class CRPProtoHandlerV01_00 implements CRPProtoHandler<CRPMessageHandlerV01_00> {
   private final CRPMessageHandlerV01_00Impl messageHandler = new CRPMessageHandlerV01_00Impl();

   @Override
   public void executeCommand(MessageToCommandProducer<CRPMessageHandlerV01_00> var1) {
      var1.visit(this.messageHandler);
   }

   @Override
   public MessageToCommandProducer<CRPMessageHandlerV01_00> getMessageToCommandProducer(int var1) {
      switch (var1) {
         case 3:
            return new QuitRequestFromServer();
         case 4:
            return new PingRequest();
         case 128:
            return new AuthResponse();
         case 129:
            return new MountCardReaderResponse();
         case 130:
            return new CommandAPDURequest();
         default:
            return null;
      }
   }

   @Override
   public void setClientCommandsExecutor(ClientCommandsExecutor var1) {
      this.messageHandler.setClientCommandsExecutor(var1);
   }

   @Override
   public <T> void executeClientCommands(MonitoringDataOutputStream var1, MonitoringDataInputStream var2, SupportsVisitor<T> var3) throws IOException, SmartCardException {
      ParameterizedType var4 = Util.getParameterizedType(var3, SupportsVisitor.class);
      if (!CommandVisitorV01_00.class.isAssignableFrom((Class<?>)var4.getActualTypeArguments()[0])) {
         throw new SmartCardException("Unsupported Client command...");
      } else {
         this.messageHandler.setOs(var1);
         this.messageHandler.setIs(var2);
         var3.accept(this.messageHandler);
      }
   }

   @Override
   public void setEventsListenerManager(EventsListenerManager var1) {
      this.messageHandler.setEventsListenerManager(var1);
   }

   @Override
   public void handleDisconnection() {
      this.messageHandler.handleDisconnection();
   }
}
