package com.raritan.smartcard.impl.crp.V01_00;

import com.raritan.smartcard.SmartCardException;
import com.raritan.smartcard.impl.crp.MessageToCommandProducer;
import java.io.IOException;
import nn.pp.core.impl.MonitoringDataInputStream;

public class CommandAPDURequest implements MessageToCommandProducer<CRPMessageHandlerV01_00> {
   private final int sequenceNum;
   private final byte[] capdu;

   public CommandAPDURequest() {
      this(-1, null);
   }

   private CommandAPDURequest(int var1, byte[] var2) {
      this.sequenceNum = var1;
      this.capdu = var2;
   }

   public CommandAPDURequest readMessage(MonitoringDataInputStream var1) throws IOException, SmartCardException {
      var1.read();
      var1.readShort();
      int var2 = var1.readInt();
      int var3 = var1.readInt();
      byte[] var4 = new byte[var3];
      var1.readFully(var4);
      return new CommandAPDURequest(var2, var4);
   }

   public void visit(CRPMessageHandlerV01_00 var1) {
      var1.handleCommandAPDU(this);
   }

   public int getSequenceNum() {
      return this.sequenceNum;
   }

   public byte[] getCapdu() {
      return this.capdu;
   }
}
