package com.raritan.smartcard.impl.crp.V01_00;

import com.raritan.smartcard.SmartCardException;
import com.raritan.smartcard.impl.crp.MessageToCommandProducer;
import java.io.IOException;
import nn.pp.core.impl.MonitoringDataInputStream;

public class MountCardReaderResponse implements MessageToCommandProducer<CRPMessageHandlerV01_00> {
   private final int ack;
   private final int reason;

   public MountCardReaderResponse() {
      this(-1, -1);
   }

   private MountCardReaderResponse(int var1, int var2) {
      this.ack = var1;
      this.reason = var2;
   }

   public MountCardReaderResponse readMessage(MonitoringDataInputStream var1) throws IOException, SmartCardException {
      int var2 = var1.read() & 0xFF;
      var1.readShort();
      int var3 = var1.readInt();
      return new MountCardReaderResponse(var2, var3);
   }

   public void visit(CRPMessageHandlerV01_00 var1) {
      var1.handleMountCardReaderResponse(this);
   }

   public int getAck() {
      return this.ack;
   }

   public int getReason() {
      return this.reason;
   }
}
