package com.raritan.tools.commands;

import com.raritan.tools.resources.RaritanPropertyResourceBundle;
import com.raritan.tools.resources.RaritanResourceBundle;
import com.raritan.tools.ui.ScreenContext;
import foxtrot.Task;
import java.util.ResourceBundle;

public abstract class AbstractCommand implements Command {
   protected CommandContext cmdContext;
   protected ScreenContext scrContext;
   private RaritanPropertyResourceBundle bundle;

   public AbstractCommand(ScreenContext var1) {
      this.scrContext = var1;
      this.cmdContext = new CommandContext(this.getKey());
      this.bundle = RaritanResourceBundle.getResourceBundle(this.scrContext.getLocale());
   }

   @Override
   public CommandContext getContext() {
      return this.getContext(false);
   }

   @Override
   public CommandContext getContext(boolean var1) {
      if (var1) {
         this.cmdContext = new CommandContext(this.getKey());
      }

      return this.cmdContext;
   }

   @Override
   public abstract String getKey();

   @Override
   public CommandResult execute() {
      this.scrContext.getLogger().logTextDebug(" Started " + this.getClass().getName());
      final CommandResult var1 = new CommandResult();
      Task var2 = new Task() {
         public Object run() throws Exception {
            AbstractCommand.this.doExecute(var1);
            AbstractCommand.this.scrContext.getLogger().logTextDebug(" Finished " + this.getClass().getName());
            return null;
         }
      };
      this.scrContext.getBlockingHelper().executeTaskDialog(var2, this.executeWithBlocking());
      return var1;
   }

   @Override
   public abstract boolean isExecutable();

   protected void doExecute(CommandResult var1) {
   }

   protected boolean executeWithBlocking() {
      return false;
   }

   protected ResourceBundle getBundle() {
      return this.bundle;
   }
}
