package com.raritan.tools.commands;

import com.raritan.tools.ui.ScreenContext;
import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import javax.swing.JApplet;
import netscape.javascript.JSException;
import netscape.javascript.JSObject;
import sun.applet.AppletViewer;

public class CloseBrowserCommand extends AbstractCommand {
   public static final String COMMAND_KEY = "closeBrowserCommand";

   public CloseBrowserCommand(ScreenContext var1) {
      super(var1);
   }

   @Override
   public CommandResult execute() {
      CommandResult var1 = new CommandResult();

      try {
         this.invokeWindowClose();
         var1.setIsSuccess(true);
         ((JApplet)this.scrContext.getApplication()).stop();
      } catch (JSException var3) {
         if (((JApplet)this.scrContext.getApplication()).getAppletContext() instanceof AppletViewer) {
         }

         var1.setIsSuccess(true);
      } catch (Exception var4) {
         this.scrContext.getLogger().logTextError(var4.getMessage());
         var1.setIsSuccess(false);
      }

      return var1;
   }

   @Override
   public boolean isExecutable() {
      return true;
   }

   @Override
   public String getKey() {
      return "closeBrowserCommand";
   }

   private void invokeWindowClose() {
      JSObject var1 = sun.plugin.javascript.JSObject.getWindow((JApplet)this.scrContext.getApplication());
      if (var1 != null) {
         try {
            Method var2 = var1.getClass().getMethod("call", String.class, Object[].class);
            if (var2 != null) {
               var2.invoke(var1, "close", new Object[0]);
            }
         } catch (SecurityException var3) {
            var3.printStackTrace();
         } catch (IllegalArgumentException var4) {
            var4.printStackTrace();
         } catch (NoSuchMethodException var5) {
            var5.printStackTrace();
         } catch (IllegalAccessException var6) {
            var6.printStackTrace();
         } catch (InvocationTargetException var7) {
            var7.printStackTrace();
         }
      }
   }
}
