package com.raritan.tools.commands;

import java.io.Serializable;

public class CommandResult implements Serializable {
   private static final long serialVersionUID = -8562694698723962418L;
   private boolean isSuccess;
   private String statusMessage;
   private Object[] errorDescription;

   public CommandResult() {
      this.isSuccess = false;
      this.statusMessage = "";
      this.errorDescription = null;
   }

   public CommandResult(boolean var1, String var2) {
      this.isSuccess = var1;
      this.statusMessage = var2;
   }

   public void setIsSuccess(boolean var1) {
      this.isSuccess = var1;
   }

   public void setErrorDescription(Object[] var1) {
      this.errorDescription = var1;
   }

   public boolean isSuccess() {
      return this.isSuccess;
   }

   public void setStatusMessage(String var1) {
      this.statusMessage = var1;
   }

   public String getStatusMessage() {
      return this.statusMessage;
   }

   public Object[] getErrorDescription() {
      return this.errorDescription;
   }

   public boolean hasErrorDescription() {
      boolean var1 = this.errorDescription != null && this.errorDescription.length > 0;
      if (!var1) {
         var1 = this.statusMessage != null && !"".equals(this.statusMessage.trim());
      }

      return var1;
   }
}
