package com.raritan.tools.resources;

import java.io.IOException;
import java.io.InputStream;
import java.util.MissingResourceException;
import java.util.PropertyResourceBundle;
import java.util.StringTokenizer;

public class RaritanPropertyResourceBundle extends PropertyResourceBundle {
   private static final String MULTY_VALUE_DELIMITER = "&&";

   public RaritanPropertyResourceBundle(InputStream var1) throws IOException {
      super(var1);
   }

   public String[] getMultyValue(String var1) {
      String var2 = this.getString(var1);
      if (var2 == null) {
         return null;
      } else {
         StringTokenizer var3 = new StringTokenizer(var2, "&&");
         int var4 = var3.countTokens();
         if (var4 <= 0) {
            return new String[]{var2};
         } else {
            String[] var5 = new String[var4];

            for (int var6 = 0; var3.hasMoreTokens(); var6++) {
               var5[var6] = var3.nextToken();
            }

            return var5;
         }
      }
   }

   public String getMessage(String var1, int var2) {
      try {
         return this.getString(var1);
      } catch (MissingResourceException var4) {
         return this.getString("Device.errorNumber") + Integer.toHexString(var2);
      }
   }
}
