package com.raritan.tools.resources;

import com.raritan.tools.util.config.ConfigurationManager;
import java.util.Locale;
import javaclientlib.utils.RRCLogger;

public class RaritanResourceBundle {
   private static RaritanPropertyResourceBundle propertyResourceBundle = null;
   private static Locale locale = null;
   private static String resourceFile = null;
   private static Class loaderClass = null;

   public static void initResourceBundle(String var0, Class var1, Locale var2) {
      resourceFile = var0;
      loaderClass = var1;
      locale = var2;
   }

   public static RaritanPropertyResourceBundle getResourceBundle(Locale var0) {
      if (resourceFile == null) {
         throw new IllegalStateException("ResourceBundle is not initialized: initResourceBundle has not been called");
      } else {
         if (propertyResourceBundle == null || propertyResourceBundle != null && !var0.equals(locale)) {
            synchronized (RaritanResourceBundle.class) {
               try {
                  propertyResourceBundle = new RaritanPropertyResourceBundle(ConfigurationManager.getResourceInputStream(loaderClass, resourceFile));
               } catch (Exception var4) {
                  RRCLogger.logException(var4);
               }
            }
         }

         return propertyResourceBundle;
      }
   }

   public static RaritanPropertyResourceBundle getResourceBundle() {
      if (resourceFile == null) {
         throw new IllegalStateException("ResourceBundle is not initialized: initResourceBundle has not been called");
      } else {
         synchronized (RaritanResourceBundle.class) {
            if (propertyResourceBundle == null) {
               try {
                  propertyResourceBundle = new RaritanPropertyResourceBundle(
                     ConfigurationManager.getResourceInputStream(loaderClass, resourceFile + "_en.properties")
                  );
               } catch (Exception var3) {
                  var3.printStackTrace();
               }
            }
         }

         return propertyResourceBundle;
      }
   }
}
