package com.raritan.tools.ui;

import com.raritan.rrc.data.Port;
import com.raritan.rrc.ui.components.FullScreenToolBar;
import java.awt.Component;
import java.awt.Container;
import java.awt.Cursor;
import java.awt.GraphicsDevice;
import java.awt.Image;
import java.net.URL;
import java.util.Locale;
import javax.swing.JDialog;
import javax.swing.JInternalFrame;
import javax.swing.JLayeredPane;

public interface AbstractUIManager {
   Container getContentPane();

   Container getContentPaneForPort(Port var1);

   JLayeredPane getLayeredPane();

   URL getIconBase();

   Component getOptionComponent();

   boolean isStandalone();

   void changeScreen(boolean var1, JInternalFrame var2, Port var3, AbstractUIManager.FullScreenTarget var4);

   GraphicsDevice getGraphicsDevice();

   void setGraphicsDevice(String var1);

   Cursor getDefaultCursor();

   Cursor getBlankCursor();

   void disconnect();

   FullScreenToolBar getFSToolBar(JInternalFrame var1);

   Locale getLocale();

   void setIconImage(Image var1);

   void setFrameVisible(boolean var1);

   String getAppId();

   void addDisposedShell(JDialog var1);

   public static enum FullScreenTarget {
      SINGLE,
      PRIMARY,
      SECONDARY;
   }
}
