package com.raritan.tools.ui.blocking;

import com.raritan.tools.ui.ScreenContext;
import java.awt.Cursor;
import java.awt.event.ComponentListener;
import javax.swing.JDialog;

public class BlockingDialog implements BlockingGui {
   protected JDialog dialog;
   private ScreenContext scrContext;

   public BlockingDialog(ScreenContext var1, JDialog var2) {
      this.scrContext = var1;
      this.setBlockingDialog(var2);
   }

   @Override
   public void hideGui() {
      this.dialog.hide();
   }

   @Override
   public void showGui() {
      this.dialog.show();
   }

   @Override
   public Cursor getCursor() {
      return this.dialog.getCursor();
   }

   @Override
   public void setCursor(Cursor var1) {
      this.dialog.setCursor(var1);
      this.dialog.getParent().setCursor(var1);
   }

   public void setTitle(String var1) {
      this.dialog.setTitle(var1);
   }

   public void setBlockingDialog(JDialog var1) {
      this.dialog = var1;
   }

   @Override
   public void addComponentListener(ComponentListener var1) {
      this.dialog.addComponentListener(var1);
   }

   @Override
   public void removeComponentListener(ComponentListener var1) {
      this.dialog.removeComponentListener(var1);
   }
}
