package com.raritan.tools.ui.blocking;

import com.raritan.tools.ui.ScreenContext;
import foxtrot.Task;
import foxtrot.Worker;
import java.awt.Frame;
import javax.swing.JDialog;
import javax.swing.JOptionPane;
import javax.swing.JPanel;

public class BlockingHelper {
   private BlockingThread blockingThread;
   private ScreenContext scrContext;
   private BlockingDialog blockingDialog;
   private BlockingHelper.FakeDialog fakeDialog;

   public BlockingHelper(ScreenContext var1) {
      this.scrContext = var1;
   }

   public void executeTaskDialog(Task var1, boolean var2) {
      if (var2) {
         this.executeTaskDialog(var1);
      } else {
         try {
            Worker.post(var1);
         } catch (Exception var4) {
         }
      }
   }

   public void executeTaskDialog(Task var1) {
      if (this.blockingDialog == null) {
         this.fakeDialog = new BlockingHelper.FakeDialog(JOptionPane.getFrameForComponent(this.scrContext.getOptionComponent()));
         this.blockingDialog = new BlockingDialog(this.scrContext, this.fakeDialog);
      }

      this.blockingThread = new BlockingThread(this.blockingDialog);

      try {
         this.blockingThread.execute(var1);
      } catch (Throwable var3) {
      }
   }

   private static class FakeDialog extends JDialog {
      private static final long serialVersionUID = -8982355371443785332L;

      FakeDialog(Frame var1) {
         super(var1, "", true);
         this.setUndecorated(true);
         ((JPanel)this.getContentPane()).setOpaque(false);
      }
   }
}
