package com.raritan.tools.ui.blocking;

import foxtrot.Task;
import foxtrot.Worker;
import java.awt.Cursor;
import javax.swing.SwingUtilities;

class BlockingThread extends Task {
   protected BlockingGui blockingGui;
   protected Cursor oldCursor;
   private Task task;

   protected void showGUI() {
      SwingUtilities.invokeLater(new Runnable() {
         @Override
         public void run() {
            BlockingThread.this.oldCursor = BlockingThread.this.blockingGui.getCursor();
            BlockingThread.this.blockingGui.setCursor(Cursor.getPredefinedCursor(3));
            BlockingThread.this.blockingGui.showGui();
         }
      });
   }

   protected void hideGUI() {
      SwingUtilities.invokeLater(new Runnable() {
         @Override
         public void run() {
            BlockingThread.this.blockingGui.hideGui();
            BlockingThread.this.blockingGui.setCursor(Cursor.getDefaultCursor());
            BlockingThread.this.oldCursor = null;
         }
      });
   }

   public BlockingThread(BlockingGui var1) {
      this.blockingGui = var1;
   }

   public void execute(Task var1) throws Exception {
      this.task = var1;
      Worker.post(this);
   }

   public Object run() throws Exception {
      this.showGUI();
      Object var1 = null;

      try {
         var1 = this.task.run();
      } finally {
         this.hideGUI();
      }

      return var1;
   }
}
