package com.raritan.tools.ui.components;

import com.raritan.tools.commands.Command;
import com.raritan.tools.commands.CommandHolder;
import com.raritan.tools.commands.DummyCommand;
import com.raritan.tools.ui.ScreenContext;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Observable;
import javax.swing.Action;
import javax.swing.Icon;
import javax.swing.JRadioButtonMenuItem;

public class CommandRadioMenuItem extends JRadioButtonMenuItem implements CommandHolder, MultyObserverComponentInterface {
   private static final long serialVersionUID = 6254803675283965839L;
   private Command command;
   private final HashMap observables = new HashMap();
   protected ScreenContext scrContext;

   public CommandRadioMenuItem(ScreenContext var1) {
      this.scrContext = var1;
      this.command = new DummyCommand(this.scrContext);
   }

   public CommandRadioMenuItem(String var1, ScreenContext var2) {
      super(var1);
      this.scrContext = var2;
      this.command = new DummyCommand(this.scrContext);
   }

   public CommandRadioMenuItem(String var1, boolean var2, ScreenContext var3) {
      super(var1, var2);
      this.scrContext = var3;
      this.command = new DummyCommand(this.scrContext);
   }

   public CommandRadioMenuItem(Action var1, ScreenContext var2) {
      super(var1);
      this.scrContext = var2;
      this.command = new DummyCommand(this.scrContext);
   }

   public CommandRadioMenuItem(Icon var1, ScreenContext var2) {
      super(var1);
      this.scrContext = var2;
      this.command = new DummyCommand(this.scrContext);
   }

   public CommandRadioMenuItem(String var1, Icon var2, ScreenContext var3) {
      super(var1, var2);
      this.scrContext = var3;
      this.command = new DummyCommand(this.scrContext);
   }

   public CommandRadioMenuItem(String var1, Icon var2, boolean var3, ScreenContext var4) {
      super(var1, var2, var3);
      this.scrContext = var4;
      this.command = new DummyCommand(this.scrContext);
   }

   @Override
   public void setCommand(Command var1) {
      this.command = var1;
      if (var1 != null && !(var1 instanceof DummyCommand)) {
         this.setEnabled(var1.isExecutable());
      }
   }

   @Override
   public Command getCommand() {
      return this.command;
   }

   @Override
   public void update(Observable var1, Object var2) {
      if (this.getCommand() != null) {
         this.setEnabled(this.getCommand().isExecutable());
      } else {
         this.setEnabled(false);
      }
   }

   @Override
   public List getObservables() {
      return new ArrayList(this.observables.values());
   }

   @Override
   public void clearObservables() {
      if (this.observables != null && this.observables.size() > 0) {
         for (Observable var2 : this.observables.values()) {
            var2.deleteObserver(this);
         }

         this.observables.clear();
      }
   }

   @Override
   public void addObservable(Observable var1) {
      this.observables.put(this.hashCode() + "", this);
      var1.addObserver(this);
   }

   @Override
   public void removeObservable(Observable var1) {
      this.observables.remove(this.hashCode() + "");
      var1.deleteObserver(this);
   }

   protected void init() {
      this.command = new DummyCommand(this.scrContext);
      this.setEnabled(this.command.isExecutable());
   }
}
