package com.raritan.tools.ui.components;

import com.raritan.tools.commands.Command;
import com.raritan.tools.commands.CommandHolder;
import com.raritan.tools.commands.DummyCommand;
import com.raritan.tools.ui.ScreenContext;
import java.text.ParseException;
import javax.swing.JFormattedTextField;
import javax.swing.JFormattedTextField.AbstractFormatter;
import javax.swing.text.DefaultFormatterFactory;
import javax.swing.text.Document;
import javax.swing.text.MaskFormatter;

public class CommandTextField extends JFormattedTextField implements CommandHolder {
   private static final long serialVersionUID = 222348584715042511L;
   private Command command;
   protected ScreenContext scrContext;

   public CommandTextField(ScreenContext var1) {
      this.scrContext = var1;
      this.init();
   }

   public CommandTextField(int var1, ScreenContext var2) {
      this.scrContext = var2;
      this.setColumns(var1);
      this.init();
   }

   public CommandTextField(String var1, ScreenContext var2) {
      super(var1);
      this.scrContext = var2;
      this.init();
   }

   public CommandTextField(String var1, int var2, ScreenContext var3) {
      super(var1);
      this.scrContext = var3;
      this.setColumns(var2);
      this.init();
   }

   public CommandTextField(Document var1, String var2, int var3, ScreenContext var4) {
      super(var2);
      this.scrContext = var4;
      this.setDocument(var1);
      this.setColumns(var3);
      this.init();
   }

   @Override
   public void setText(String var1) {
      if (var1 == null) {
         super.setText("");
      } else {
         super.setText(var1);
      }
   }

   @Override
   public Command getCommand() {
      return this.command;
   }

   @Override
   public void setCommand(Command var1) {
      this.command = var1;
   }

   private void init() {
      this.command = new DummyCommand(this.scrContext);
      this.setFieldFormatter(new InputFilterFormatter());
   }

   public void setFieldFormatter(AbstractFormatter var1) {
      DefaultFormatterFactory var2 = new DefaultFormatterFactory(var1);
      super.setFormatterFactory(var2);
   }

   public void setFormattingString(String var1) {
      try {
         MaskFormatter var2 = new MaskFormatter(var1);
         var2.setPlaceholderCharacter(' ');
         DefaultFormatterFactory var3 = new DefaultFormatterFactory(var2);
         super.setFormatterFactory(var3);
      } catch (ParseException var4) {
         var4.printStackTrace();
      }
   }

   public InputFilterFormatter getInputFilterFormatter() {
      try {
         return (InputFilterFormatter)this.getFormatter();
      } catch (ClassCastException var2) {
         return null;
      }
   }
}
