package com.raritan.tools.ui.components;

import com.raritan.tools.resources.RaritanPropertyResourceBundle;
import com.raritan.tools.resources.RaritanResourceBundle;
import com.raritan.tools.ui.ScreenContext;
import java.util.List;
import javax.swing.JMenu;
import javax.swing.JPopupMenu;
import javax.swing.JPopupMenu.Separator;

public abstract class RaritanPopupMenu extends JPopupMenu {
   protected ScreenContext scrContext;
   protected RaritanPropertyResourceBundle bundle;
   protected MenuActionListenerImplementation mali;

   public RaritanPopupMenu(ScreenContext var1) {
      this.scrContext = var1;
      this.bundle = RaritanResourceBundle.getResourceBundle(this.scrContext.getLocale());
      this.mali = new MenuActionListenerImplementation(this.scrContext);
   }

   public RaritanPopupMenu(String var1) {
      super(var1);
   }

   public abstract void setContext();

   /** @deprecated */
   public void addContext(Object[] var1) {
      for (int var3 = 0; var3 < var1.length; var3++) {
         Object var2 = var1[var3];
         if (var2 instanceof CommandMenuItem) {
            this.add((CommandMenuItem)var2);
         } else if (var2 instanceof Separator) {
            this.addSeparator();
         } else if (var2 instanceof JMenu) {
            this.add((JMenu)var2);
         } else if (var2 instanceof String) {
            this.add(new CommandMenuItem((String)var2, this.scrContext));
         } else {
            this.scrContext.getLogger().logTextDebug("Unhandled class type");
         }
      }
   }

   public void addContext(List var1) {
      Object var2 = null;

      for (int var3 = 0; var3 < var1.size(); var3++) {
         var2 = var1.get(var3);
         this.addToMenu(var2);
      }
   }

   private void addToMenu(Object var1) {
      if (var1 instanceof CommandMenuItem) {
         this.add((CommandMenuItem)var1);
      } else if (var1 instanceof Separator) {
         this.addSeparator();
      } else if (var1 instanceof JMenu) {
         this.add((JMenu)var1);
      } else if (var1 instanceof String) {
         this.add(new CommandMenuItem((String)var1, this.scrContext));
      } else {
         this.scrContext.getLogger().logTextDebug("Unhandled class type");
      }
   }
}
