package com.raritan.tools.ui.panes.displays;

import com.raritan.tools.ui.ScreenContext;
import java.lang.reflect.InvocationTargetException;

public class AbstractDisplayStrategy {
   private Class abstractDisplayClazz;
   private boolean isDialog;
   private boolean isNewPanel;
   private ScreenContext scrContext;

   public AbstractDisplayStrategy(Class var1, boolean var2, ScreenContext var3) {
      this.abstractDisplayClazz = var1;
      this.isDialog = var2;
      this.scrContext = var3;
   }

   public AbstractDisplayStrategy(Class var1, boolean var2, ScreenContext var3, boolean var4) {
      this.abstractDisplayClazz = var1;
      this.isDialog = var2;
      this.scrContext = var3;
      this.isNewPanel = var4;
   }

   public AbstractDisplay create() throws InvocationTargetException, IllegalAccessException, NoSuchMethodException, InstantiationException {
      return this.isNewPanel
         ? (AbstractDisplay)this.abstractDisplayClazz
            .getConstructor(boolean.class, ScreenContext.class, boolean.class)
            .newInstance(new Boolean(this.isDialog), this.scrContext, new Boolean(this.isNewPanel))
         : (AbstractDisplay)this.abstractDisplayClazz
            .getConstructor(boolean.class, ScreenContext.class)
            .newInstance(new Boolean(this.isDialog), this.scrContext);
   }

   public Class getAbstractDisplayClass() {
      return this.abstractDisplayClazz;
   }
}
