package com.raritan.tools.ui.panes.displays;

import java.awt.Component;
import java.awt.Point;
import java.awt.Rectangle;
import java.awt.event.ComponentAdapter;
import java.awt.event.ComponentEvent;

public class ShellComponentAdapter extends ComponentAdapter {
   private int shellX;
   private int shellY;
   private int shellXW;
   private int shellYH;
   private int shellWidth = 150;
   private int shellHeight = 150;
   private Component parent;
   private Rectangle rv = new Rectangle(100, 100, 400, 400);
   private Point point = new Point(100, 100);

   public void initMe(Component var1) {
      this.shellX = var1.getX();
      this.shellY = var1.getY();
      this.shellWidth = var1.getWidth();
      this.shellHeight = var1.getHeight();
   }

   @Override
   public void componentMoved(ComponentEvent var1) {
      Component var2 = var1.getComponent();
      this.shellX = var2.getX();
      this.shellY = var2.getY();
      this.permitMove(var2);
   }

   @Override
   public void componentResized(ComponentEvent var1) {
      Component var2 = var1.getComponent();
      this.shellWidth = var2.getWidth();
      this.shellHeight = var2.getHeight();
      this.permitMove(var2);
   }

   public void setFloatingParent(Component var1) {
      this.parent = var1;
   }

   private void permitMove(Component var1) {
      if (this.parent.isShowing()) {
         this.point = this.parent.getLocationOnScreen();
         this.rv = this.parent.getBounds();
         int var2 = this.rv.width + this.point.x;
         int var3 = this.rv.height + this.point.y;
         this.shellXW = this.shellX + this.shellWidth;
         this.shellYH = this.shellY + this.shellHeight;
         if (this.shellWidth > this.rv.width) {
            this.shellWidth = this.rv.width;
         }

         if (this.shellHeight > this.rv.height) {
            this.shellHeight = this.rv.height;
         }

         if (this.shellX < this.point.x) {
            this.shellX = this.point.x;
         }

         if (this.shellXW > var2) {
            this.shellX = var2 - this.shellWidth;
         }

         if (this.shellY < this.point.y) {
            this.shellY = this.point.y;
         }

         if (this.shellYH > var3) {
            this.shellY = var3 - this.shellHeight;
         }

         var1.removeComponentListener(this);
         var1.setBounds(this.shellX, this.shellY, this.shellWidth, this.shellHeight);
         var1.addComponentListener(this);
      }
   }
}
