package com.raritan.tools.ui.panes.displays;

import com.raritan.tools.ui.ScreenContext;
import java.util.Stack;
import javax.swing.JDialog;

public class ShellFocusObserver {
   private static final Stack shellVisible = new Stack();
   static final String OS_NAME = System.getProperty("os.name");

   public static synchronized void addShellVisible(JDialog var0, ScreenContext var1) {
      if (!shellVisible.contains(var0)) {
         shellVisible.push(var0);
         setFocusOnLast(var1);
         var1.getLogger().logTextDebug("shell added " + var0.getTitle());
      } else {
         var1.getLogger().logTextDebug("shell NOT added " + var0.getTitle() + " :: " + var0.isVisible() + " " + !shellVisible.contains(var0));
      }
   }

   public static synchronized void removeShellVisible(JDialog var0, ScreenContext var1) {
      if (shellVisible.contains(var0)) {
         shellVisible.pop();
         setFocusOnLast(var1);
         var1.getLogger().logTextDebug("shell removed " + var0.getTitle());
      } else {
         var1.getLogger().logTextDebug("shell NOT removed " + var0.getTitle() + " :: " + !var0.isVisible() + " " + shellVisible.contains(var0));
      }
   }

   public static synchronized void setFocusOnLast(ScreenContext var0) {
      var0.getLogger().logTextDebug(" Invoked");
      if (!shellVisible.isEmpty()) {
         JDialog var1 = (JDialog)shellVisible.peek();
         if (OS_NAME.toLowerCase().indexOf("windows") != -1) {
            var1.setFocusableWindowState(true);
         } else if (var1.isFocused()) {
            var1.toFront();
         }
      }

      var0.getLogger().logTextDebug(" Finished");
   }
}
