package com.raritan.tools.ui.panes.displays;

import com.raritan.tools.ui.ScreenContext;
import java.awt.BorderLayout;
import java.awt.Container;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;
import javax.swing.JOptionPane;

public class ShellForOptionPane extends Shell {
   private JOptionPane pane;
   private boolean visible;

   public ShellForOptionPane(ScreenContext var1) {
      super(var1);
   }

   @Override
   public void setVisible(boolean var1) {
      if (this.visible != var1) {
         this.visible = var1;
         if (var1) {
            this.setLocationRelativeTo(this.getOwner());
         }

         super.setVisible(var1);
      }
   }

   public void setOptionPane(final JOptionPane var1) {
      this.pane = var1;
      Container var2 = this.getContentPane();
      var2.removeAll();
      var2.setLayout(new BorderLayout());
      var2.add(var1, "Center");
      this.pack();
      var1.addPropertyChangeListener(
         new PropertyChangeListener() {
            @Override
            public void propertyChange(PropertyChangeEvent var1x) {
               if (ShellForOptionPane.this.isVisible()
                  && var1x.getSource() == var1
                  && var1x.getPropertyName().equals("value")
                  && var1x.getNewValue() != null
                  && var1x.getNewValue() != JOptionPane.UNINITIALIZED_VALUE) {
                  ShellForOptionPane.this.performAction(var1x.getNewValue());
                  var1.setValue(JOptionPane.UNINITIALIZED_VALUE);
                  ShellForOptionPane.this.setVisible(false);
               }
            }
         }
      );
   }

   protected void performAction(Object var1) {
   }
}
