package com.raritan.tools.ui.panes.displays;

import com.raritan.tools.commands.Command;
import com.raritan.tools.ui.components.RaritanDesktopPane;
import java.beans.PropertyVetoException;
import javax.swing.JInternalFrame;
import javax.swing.JInternalFrame.JDesktopIcon;
import javax.swing.event.InternalFrameEvent;
import javax.swing.event.InternalFrameListener;

public class ShellInternalFrame extends JInternalFrame implements InternalFrameListener {
   private static final long serialVersionUID = 8746040099815503198L;
   private Command command = null;
   private boolean isWindowClosing = false;

   public ShellInternalFrame() {
      this.addInternalFrameListener(this);
   }

   protected void processWindowEvent(InternalFrameEvent var1) {
      InternalFrameListener[] var2 = this.getInternalFrameListeners();
      if (var2.length > 0) {
         InternalFrameListener var3 = var2[0];
         switch (var1.getID()) {
            case 200:
               this.internalFrameOpened(var1);
               break;
            case 201:
               this.isWindowClosing = true;
               var3.internalFrameClosing(var1);
               break;
            case 202:
               var3.internalFrameClosed(var1);
               break;
            case 203:
               var3.internalFrameIconified(var1);
               break;
            case 204:
               var3.internalFrameDeiconified(var1);
               break;
            case 205:
               var3.internalFrameActivated(var1);
               break;
            case 206:
               var3.internalFrameDeactivated(var1);
         }
      }
   }

   @Override
   public void internalFrameOpened(InternalFrameEvent var1) {
      try {
         this.setMaximum(true);
      } catch (PropertyVetoException var3) {
      } catch (Exception var4) {
      }
   }

   @Override
   public void internalFrameClosing(InternalFrameEvent var1) {
      switch (this.getDefaultCloseOperation()) {
         case 0:
         default:
            break;
         case 1:
            this.setVisible(false);
            break;
         case 2:
            this.setVisible(false);
            this.dispose();
      }
   }

   @Override
   public void internalFrameActivated(InternalFrameEvent var1) {
   }

   @Override
   public void internalFrameClosed(InternalFrameEvent var1) {
      if (this.command != null) {
         this.command.execute();
      }
   }

   @Override
   public void internalFrameDeactivated(InternalFrameEvent var1) {
   }

   @Override
   public void internalFrameDeiconified(InternalFrameEvent var1) {
      try {
         this.setMaximum(true);
      } catch (PropertyVetoException var3) {
      }
   }

   @Override
   public void internalFrameIconified(InternalFrameEvent var1) {
      RaritanDesktopPane var2 = (RaritanDesktopPane)this.getDesktopPane();
      int var3 = 1;
      int var4 = 0;
      JInternalFrame[] var5 = var2.getAllFrames();

      for (int var6 = 0; var6 < var5.length; var6++) {
         if (var5[var6].isIcon()) {
            JDesktopIcon var7 = var5[var6].getDesktopIcon();
            if ((var4 + 1) * var7.getWidth() > var2.getWidth()) {
               var3++;
               var4 = 0;
            }

            var7.setLocation(var4 * var7.getWidth(), var2.getHeight() - var3 * var7.getHeight());
            var4++;
         }
      }
   }

   public Command getCommand() {
      return this.command;
   }

   public void setCommand(Command var1) {
      this.command = var1;
   }

   public boolean isWindowClosing() {
      return this.isWindowClosing;
   }

   public void setWindowClosing(boolean var1) {
      this.isWindowClosing = var1;
   }
}
