package com.raritan.tools.ui.renders;

import java.awt.Color;
import javax.swing.UIManager;

public class RendersUtils {
   private static final Color activeSelectionColor = UIManager.getColor("Tree.selectionBackground");
   private static Color inactiveSelectionColor;

   public static Color getInactiveSelectionColor() {
      if (inactiveSelectionColor == null) {
         int var0 = (255 - activeSelectionColor.getRed()) / 2 + activeSelectionColor.getRed();
         int var1 = (255 - activeSelectionColor.getGreen()) / 2 + activeSelectionColor.getGreen();
         int var2 = (255 - activeSelectionColor.getBlue()) / 2 + activeSelectionColor.getBlue();
         inactiveSelectionColor = new Color(var0, var1, var2);
      }

      return inactiveSelectionColor;
   }

   public static Color getActiveSelectionColor() {
      return activeSelectionColor;
   }
}
