package com.raritan.tools.util;

import java.security.InvalidKeyException;
import java.security.Key;
import java.security.MessageDigest;
import java.security.NoSuchAlgorithmException;
import java.util.Arrays;
import javax.crypto.BadPaddingException;
import javax.crypto.Cipher;
import javax.crypto.IllegalBlockSizeException;
import javax.crypto.KeyGenerator;
import javax.crypto.NoSuchPaddingException;
import javax.crypto.spec.SecretKeySpec;

public class CryptoUtil {
   public static final boolean CRYPT = true;

   public static SecretKeySpec decodeKey(byte[] var0, String var1) {
      return new SecretKeySpec(var0, var1);
   }

   public static byte[] decrypt(byte[] var0, Key var1, String var2) throws CryptoException {
      try {
         Cipher var3 = Cipher.getInstance(var2);
         var3.init(2, var1);
         return var3.doFinal(var0);
      } catch (NoSuchAlgorithmException var4) {
         throw new CryptoException(var4.getMessage());
      } catch (NoSuchPaddingException var5) {
         throw new CryptoException(var5.getMessage());
      } catch (InvalidKeyException var6) {
         throw new CryptoException(var6.getMessage());
      } catch (BadPaddingException var7) {
         throw new CryptoException(var7.getMessage());
      } catch (IllegalBlockSizeException var8) {
         throw new CryptoException(var8.getMessage());
      }
   }

   public static byte[] encrypt(byte[] var0, Key var1, String var2) throws CryptoException {
      try {
         Cipher var3 = Cipher.getInstance(var2);
         var3.init(1, var1);
         return var3.doFinal(var0);
      } catch (NoSuchAlgorithmException var4) {
         throw new CryptoException(var4.getMessage());
      } catch (NoSuchPaddingException var5) {
         throw new CryptoException(var5.getMessage());
      } catch (InvalidKeyException var6) {
         throw new CryptoException(var6.getMessage());
      } catch (BadPaddingException var7) {
         throw new CryptoException(var7.getMessage());
      } catch (IllegalBlockSizeException var8) {
         throw new CryptoException(var8.getMessage());
      }
   }

   public static Key generateKey(String var0, int var1) throws CryptoException {
      try {
         KeyGenerator var2 = KeyGenerator.getInstance(var0);
         var2.init(var1);
         return var2.generateKey();
      } catch (NoSuchAlgorithmException var3) {
         throw new CryptoException(var3.getMessage());
      }
   }

   public static byte[] getMessageDigest(byte[] var0, String var1) throws CryptoException {
      try {
         MessageDigest var2 = MessageDigest.getInstance(var1);
         var2.reset();
         var2.update(var0);
         return var2.digest();
      } catch (NoSuchAlgorithmException var3) {
         throw new CryptoException();
      }
   }

   public static byte[] sign(byte[] var0, Key var1, String var2, String var3) throws CryptoException {
      return encrypt(getMessageDigest(var0, var2), var1, var3);
   }

   public static boolean verifySignature(byte[] var0, byte[] var1, Key var2, String var3, String var4) throws CryptoException {
      byte[] var5 = sign(var0, var2, var3, var4);
      return Arrays.equals(var1, var5);
   }
}
