package com.raritan.tools.util;

import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.security.Key;
import sun.misc.BASE64Decoder;
import sun.misc.BASE64Encoder;

public class StringCryptoUtil extends CryptoUtil {
   public static final String CIPHER_ALGORITHM = "DESede/ECB/NoPadding";
   public static final String CIPHER_KEY_ALGORITHM = "DESede";
   public static final int CIPHER_KEY_LENGTH = 1;
   public static final String MESSAGE_DIGEST_ALGORITHM = "SHA1";
   public static final String STRING_ENCODING = "UnicodeLittleUnmarked";
   public static final String STRING_DECODING = "UnicodeLittle";
   public static final int FILL_DEL = 8;

   public static byte[] base64decode(String var0) throws IOException {
      return new BASE64Decoder().decodeBuffer(var0);
   }

   public static String base64encode(byte[] var0) {
      return new BASE64Encoder().encode(var0);
   }

   public static Key decodeKey(String var0, String var1) throws IOException {
      return decodeKey(base64decode(var0), var1);
   }

   public static String decrypt(String var0, String var1) throws CryptoException, IOException {
      Object var2 = null;
      byte[] var3 = null;

      try {
         var2 = base64decode(var0);
         var3 = unfillByteArray(decrypt((byte[])var2, decodeKey(var1, "DESede"), "DESede/ECB/NoPadding"));
      } catch (CryptoException var5) {
      } catch (IOException var6) {
      }

      return getByteArrayAsString(var3);
   }

   public static String encodeKey(Key var0) {
      return base64encode(var0.getEncoded());
   }

   public static String encrypt(String var0, String var1) throws CryptoException, IOException {
      byte[] var2 = fillByteArray(getStringAsByteArray(var0), 8);
      return base64encode(encrypt(var2, decodeKey(var1, "DESede"), "DESede/ECB/NoPadding"));
   }

   protected static byte[] fillByteArray(byte[] var0, int var1) {
      int var2 = var0.length % var1;
      if (var2 == 0) {
         return var0;
      } else {
         byte[] var3 = new byte[var0.length + var1 - var2];
         System.arraycopy(var0, 0, var3, 0, var0.length);
         return var3;
      }
   }

   public static String generateKey() throws CryptoException {
      return encodeKey(generateKey("DESede", 1));
   }

   public static String getByteArrayAsString(byte[] var0) {
      try {
         return new String(var0, "UnicodeLittle");
      } catch (UnsupportedEncodingException var2) {
         return new String(var0);
      }
   }

   public static String getMessageDigest(String var0) throws CryptoException {
      byte[] var1 = getStringAsByteArray(var0);
      return base64encode(getMessageDigest(var1, "SHA1"));
   }

   public static byte[] getStringAsByteArray(String var0) {
      try {
         return var0.getBytes("UnicodeLittleUnmarked");
      } catch (UnsupportedEncodingException var2) {
         return var0.getBytes();
      }
   }

   public static String sign(String var0, String var1) throws CryptoException, IOException {
      byte[] var2 = getMessageDigest(getStringAsByteArray(var0), "SHA1");
      byte[] var3 = encrypt(fillByteArray(var2, 8), decodeKey(var1, "DESede"), "DESede/ECB/NoPadding");
      return base64encode(var3);
   }

   protected static byte[] unfillByteArray(byte[] var0) {
      int var1 = var0.length;

      while (var0[var1 - 1] == 0) {
         var1--;
      }

      if (var1 % 2 != 0) {
         var1++;
      }

      if (var1 == var0.length) {
         return var0;
      } else {
         byte[] var2 = new byte[var1];
         System.arraycopy(var0, 0, var2, 0, var1);
         return var2;
      }
   }

   public static boolean verifySignature(String var0, String var1, String var2) throws CryptoException, IOException {
      return var1.equals(sign(var0, var2));
   }
}
