package com.raritan.tools.util;

import java.awt.Container;
import java.awt.FontMetrics;
import java.awt.GraphicsEnvironment;
import java.awt.Window;
import java.net.Inet6Address;
import java.net.InetAddress;
import java.net.NetworkInterface;
import java.net.SocketException;
import java.net.UnknownHostException;
import java.util.ArrayList;
import java.util.Enumeration;
import java.util.StringTokenizer;
import java.util.Vector;
import javax.swing.JDialog;

public class Util {
   private static int ipv6Supported = -1;

   public static int getElementIndex(String[] var0, String var1) {
      for (int var2 = 0; var2 < var0.length; var2++) {
         if (var0[var2].equals(var1)) {
            return var2;
         }
      }

      return 0;
   }

   public static String str2IPString(String var0) {
      if (var0 != null) {
         try {
            long var1 = Long.valueOf(var0);
            StringBuffer var3 = new StringBuffer();
            var3.append(var1 >> 24 & 255L);
            var3.append('.');
            var3.append(var1 >> 16 & 255L);
            var3.append('.');
            var3.append(var1 >> 8 & 255L);
            var3.append('.');
            var3.append(var1 & 255L);
            return new String(var3);
         } catch (NumberFormatException var4) {
         }
      }

      return var0;
   }

   public static long ipToLong(String var0) {
      long var1 = 0L;

      try {
         byte[] var3 = InetAddress.getByName(var0).getAddress();
         long var4 = var3[0] & 255;
         var4 <<= 24;
         long var6 = var3[1] & 255;
         var6 <<= 16;
         long var8 = var3[2] & 255;
         var8 <<= 8;
         long var10 = var3[3] & 255;
         return var4 | var6 | var8 | var10;
      } catch (Exception var12) {
         return 0L;
      }
   }

   public static String ipStringToString(String var0) {
      long var1 = 0L;

      try {
         byte[] var3 = InetAddress.getByName(var0).getAddress();
         long var4 = var3[0] & 255;
         var4 <<= 24;
         long var6 = var3[1] & 255;
         var6 <<= 16;
         long var8 = var3[2] & 255;
         var8 <<= 8;
         long var10 = var3[3] & 255;
         var1 = var4 | var6 | var8 | var10;
      } catch (Exception var12) {
      }

      return String.valueOf(var1);
   }

   public static ArrayList arrayToArrayList(Object[] var0) {
      int var1 = var0.length;
      ArrayList var2 = new ArrayList();

      for (int var3 = 0; var3 < var1; var3++) {
         var2.add(var0[var3]);
      }

      return var2;
   }

   public static Vector arrayToVector(Object[] var0) {
      int var1 = var0.length;
      Vector var2 = new Vector();

      for (int var3 = 0; var3 < var1; var3++) {
         var2.addElement(var0[var3]);
      }

      return var2;
   }

   public static boolean intToBoolean(int var0) {
      return var0 == 1;
   }

   public static int booleanToInt(boolean var0) {
      return var0 ? 1 : 0;
   }

   public static boolean stringToBoolean(String var0) {
      return var0.equals("1");
   }

   public static int stringToInt(String var0) {
      try {
         return Integer.parseInt(var0);
      } catch (NumberFormatException var2) {
         return -1;
      }
   }

   public static long stringToLong(String var0) {
      try {
         return Long.parseLong(var0);
      } catch (NumberFormatException var2) {
         return -1L;
      }
   }

   public static String formatStringNull(String var0) {
      return var0 == null ? "" : var0;
   }

   public static boolean isValidIPAddress(String var0) {
      return !isValidIPV4Address(var0) ? isValidIPV6Address(var0) : true;
   }

   public static boolean isValidIPV4Address(String var0) {
      String[] var1 = new String[4];
      if (!var0.startsWith(".") && !var0.endsWith(".")) {
         StringTokenizer var2 = new StringTokenizer(var0, ".");
         if (var2.countTokens() != var1.length) {
            return false;
         } else {
            for (int var3 = 0; var2.hasMoreTokens(); var3++) {
               var1[var3] = var2.nextToken();

               try {
                  int var4 = Integer.parseInt(var1[var3]);
                  if (var4 > 255 || var4 < 0) {
                     return false;
                  }
               } catch (Exception var5) {
                  return false;
               }
            }

            return true;
         }
      } else {
         return false;
      }
   }

   private static String getScopelessIP6Address(String var0) {
      int var1 = var0.indexOf(37);
      return var1 != -1 ? var0.substring(0, var1) : var0;
   }

   public static boolean isValidIPV6Address(String var0) {
      if (var0 == null) {
         return false;
      } else {
         var0 = getScopelessIP6Address(var0);
         int var1 = var0.length();
         if (var1 < 2) {
            return false;
         } else {
            char[] var2 = var0.toCharArray();
            int var3 = 0;
            boolean var4 = false;
            if (var2[0] == ':') {
               if (var2[1] != ':') {
                  return false;
               }

               var4 = true;
               var3 = 2;
            }

            if (var2[var1 - 1] == ':' && var2[var1 - 2] != ':') {
               return false;
            } else {
               boolean var6 = false;
               byte var7 = 0;
               int var8 = 0;

               while (var3 < var1) {
                  char var5 = var2[var3++];
                  int var9 = Character.digit(var5, 16);
                  if (var9 != -1) {
                     var8 <<= 4;
                     var8 |= var9;
                     if (var8 > 65535) {
                        return false;
                     }

                     var6 = true;
                  } else {
                     if (var5 != ':') {
                        return false;
                     }

                     if (!var6) {
                        if (var4) {
                           return false;
                        }

                        var4 = true;
                     } else {
                        var7 += 2;
                        if (var7 > 16) {
                           return false;
                        }

                        var6 = false;
                        var8 = 0;
                     }
                  }
               }

               if (var6) {
                  var7 += 2;
                  if (var7 > 16) {
                     return false;
                  }
               }

               return var4 ? var7 < 16 : var7 == 16;
            }
         }
      }
   }

   public static boolean isValidPort(String var0) {
      return isValidPort(var0, false);
   }

   public static boolean isValidPort(String var0, boolean var1) {
      if (var0 != null && !"".equals(var0)) {
         try {
            int var2 = Integer.parseInt(var0);
            return isValidPort(var2);
         } catch (Exception var3) {
            return false;
         }
      } else {
         return var1;
      }
   }

   public static boolean isValidPort(int var0) {
      return var0 > 0 && var0 <= 65535;
   }

   public static boolean validateLongValue(String var0, boolean var1, boolean var2) {
      if (var0 != null && !"".equals(var0)) {
         long var3 = stringToLong(var0);
         return var3 == -1L ? false : var1 || var3 >= 0L;
      } else {
         return var2;
      }
   }

   public static boolean validateIntegerValue(String var0, boolean var1, boolean var2) {
      if (var0 != null && !"".equals(var0)) {
         int var3 = stringToInt(var0);
         return var3 == -1 ? false : var1 || var3 >= 0;
      } else {
         return var2;
      }
   }

   public static String getNoneEmptyIPAddress(String var0) {
      return var0 != null && !"".equals(var0) ? var0 : "0.0.0.0";
   }

   public static String[] concatArrays(String[] var0, String[] var1) {
      String[] var2 = new String[var0.length + var1.length];
      System.arraycopy(var0, 0, var2, 0, var0.length);
      System.arraycopy(var1, 0, var2, var0.length, var1.length);
      return var2;
   }

   public static boolean isFullscreenExclusiveModeSupported() {
      return GraphicsEnvironment.getLocalGraphicsEnvironment().getDefaultScreenDevice().isFullScreenSupported();
   }

   public static boolean isIPV6Supported() {
      if (ipv6Supported == -1) {
         ipv6Supported = determineIPV6Support();
      }

      return ipv6Supported == 1;
   }

   private static int determineIPV6Support() {
      Object var0 = null;

      try {
         var0 = NetworkInterface.getNetworkInterfaces();
      } catch (SocketException var2) {
         var2.printStackTrace();
         return 0;
      }

      while (var0.hasMoreElements()) {
         Enumeration var1 = ((NetworkInterface)var0.nextElement()).getInetAddresses();

         while (var1.hasMoreElements()) {
            if (var1.nextElement() instanceof Inet6Address) {
               return 1;
            }
         }
      }

      return 0;
   }

   public static int getSizeOfIPV6Component(FontMetrics var0) {
      int var1 = var0.charWidth('C');
      int var2 = var0.charWidth(':');
      int var3 = var1 * 30;
      return var3 + var2 * 7;
   }

   public static String getURLCompatibleIP(InetAddress var0) {
      String var1 = "";
      if (var0 != null) {
         var1 = var0.getHostAddress();
         if (var0 instanceof Inet6Address) {
            var1 = "[" + var1 + "]";
         }
      }

      return var1;
   }

   public static String getURLCompatibleIP(InetAddress var0, int var1) {
      return getURLCompatibleIP(var0) + ":" + var1;
   }

   public static String getURLCompatibleIP(String var0) {
      String var1 = var0;
      InetAddress var2 = null;

      try {
         var2 = InetAddress.getByName(var1);
      } catch (UnknownHostException var4) {
         assert false : "ipAddr arg is a value other than valid IP";

         var4.printStackTrace();
      }

      if (var2 instanceof Inet6Address) {
         var1 = "[" + var2.getHostAddress() + "]";
      }

      return var1;
   }

   public static String getURLCompatibleIP(String var0, int var1) {
      return getURLCompatibleIP(var0) + ":" + var1;
   }

   public static void jre17WorkaroundInheritAlwaysOnTop(JDialog var0) {
      Container var1 = var0.getParent();
      if (var1 instanceof Window) {
         Window var2 = (Window)var1;
         if (var2.isAlwaysOnTopSupported()) {
            var0.setAlwaysOnTop(var2.isAlwaysOnTop());
         }
      }
   }
}
