package com.raritan.tools.util.image;

import java.awt.Color;
import java.awt.Graphics2D;
import java.awt.GraphicsConfiguration;
import java.awt.GraphicsDevice;
import java.awt.GraphicsEnvironment;
import java.awt.image.BufferedImage;
import javax.swing.ImageIcon;

public class DualImage {
   private ImageIcon leftImage;
   private ImageIcon rightImage;
   private BufferedImage dualImage;
   private ImageIcon dualIcon;

   public DualImage(ImageIcon var1, ImageIcon var2) {
      this.leftImage = var1;
      this.rightImage = var2;
   }

   @Override
   public boolean equals(Object var1) {
      if (!(var1 instanceof DualImage)) {
         return false;
      } else {
         DualImage var2 = (DualImage)var1;
         return this.getLeftImage() == var2.getLeftImage() && this.getRightImage() == var2.getRightImage();
      }
   }

   public ImageIcon getLeftImage() {
      return this.leftImage;
   }

   public ImageIcon getRightImage() {
      return this.rightImage;
   }

   public ImageIcon getDualIcon() {
      if (this.dualIcon == null) {
         this.dualIcon = new ImageIcon(this.getDualImage());
      }

      return this.dualIcon;
   }

   public BufferedImage getDualImage() {
      if (this.dualImage == null) {
         this.dualImage = createDualImage(this.leftImage, this.rightImage);
      }

      return this.dualImage;
   }

   private static BufferedImage createDualImage(ImageIcon var0, ImageIcon var1) {
      int var2 = var0.getIconWidth() + var1.getIconWidth();
      int var3 = var0.getIconHeight();
      if (var1.getIconHeight() > var3) {
         var3 = var1.getIconHeight();
      }

      new BufferedImage(var2, var3, 1);
      GraphicsEnvironment var5 = GraphicsEnvironment.getLocalGraphicsEnvironment();
      GraphicsDevice var6 = var5.getDefaultScreenDevice();
      GraphicsConfiguration var7 = var6.getDefaultConfiguration();
      BufferedImage var4 = var7.createCompatibleImage(var2, var3, 2);
      Graphics2D var8 = var4.createGraphics();
      var8.drawImage(var0.getImage(), 0, 0, null);
      var8.drawImage(var1.getImage(), var0.getIconWidth(), 0, null);
      var8.setBackground(Color.WHITE);
      return var4;
   }
}
