package com.raritan.tools.util.image;

import java.util.ArrayList;
import javax.swing.ImageIcon;

public class DualImageFactory {
   private static final ArrayList cachedImages = new ArrayList();

   public static ImageIcon getDualImageIcon(ImageIcon var0, ImageIcon var1) {
      if (var1 == null) {
         return var0;
      } else {
         return var0 == null ? var1 : getDualImage(var0, var1).getDualIcon();
      }
   }

   public static DualImage getDualImage(ImageIcon var0, ImageIcon var1) {
      DualImage var2 = null;
      Object var3 = null;

      for (DualImage var5 : cachedImages) {
         if (var5.getLeftImage().getDescription().equals(var0.getDescription()) && var5.getRightImage().getDescription().equals(var1.getDescription())) {
            var2 = var5;
            break;
         }
      }

      if (var2 == null) {
         var2 = new DualImage(var0, var1);
         cachedImages.add(var2);
      }

      return var2;
   }

   public static void clearCachedImages() {
      cachedImages.clear();
   }
}
