package com.raritan.tools.util.io;

import java.io.File;
import javax.swing.filechooser.FileFilter;

public class AllFilesFilter extends FileFilter {
   public static final String LDAP_FILE_EXTENSION = "DB";
   public static final String HMX_EXTENSION = "RFP";
   public static final String TEXT_FILE_EXTENSION = "TXT";
   public static final int LDAP_CERTIFICATE_FILE_TYPE = 1;
   public static final int LDAP_KEY_FILE_TYPE = 2;
   public static final int TEXT_FILE_TYPE = 3;
   public static final int RFP_FILE_TYPE = 4;
   public static final String CERTIFICATE_EXTENSION = "CRT";
   private String description = "LDAP Certificate (*." + "DB".toLowerCase() + ")";

   public AllFilesFilter() {
   }

   public AllFilesFilter(int var1) {
      switch (var1) {
         case 1:
            this.description = "LDAP Certificate (*." + "DB".toLowerCase() + ")";
            break;
         case 2:
            this.description = "LDAP Key (*." + "DB".toLowerCase() + ")";
            break;
         case 3:
            this.description = "Text Files (*." + "TXT".toLowerCase() + ")";
            break;
         case 4:
            this.description = "RFP Files (*." + "RFP".toLowerCase() + ")";
      }
   }

   @Override
   public boolean accept(File var1) {
      if (var1 != null && var1.isDirectory()) {
         return true;
      } else {
         String var2 = this.getExtension(var1);
         if (var2.equalsIgnoreCase("CRT")) {
            return true;
         } else if (var2.equalsIgnoreCase("RFP")) {
            return true;
         } else {
            return var2.equalsIgnoreCase("TXT") ? true : var2.equalsIgnoreCase("DB");
         }
      }
   }

   public static FileMapper createFileMapper() {
      return new DefaultFileMapper();
   }

   private String getExtension(File var1) {
      if (var1 != null) {
         String var2 = var1.getName();
         int var3 = var2.lastIndexOf(46);
         if (var3 > 0 && var3 < var2.length() - 1) {
            return var2.substring(var3 + 1).toLowerCase();
         }
      }

      return "";
   }

   @Override
   public String getDescription() {
      return this.description;
   }
}
