package com.util.kbd;

import java.util.Hashtable;
import java.util.Locale;
import java.util.Map;
import java.util.Vector;
import nn.pp.core.T;

public class KeyHIDValue {
   public static short[] HIDMAP = null;
   public static int keyboardLanguage;
   public static final int US = 0;
   public static final int JAPANESE = 1;
   public static final int UK = 2;
   public static final int GERMAN = 3;
   public static final int FRENCH = 4;
   public static final int KOREAN = 5;
   public static final int BELGIAN_FRENCH = 6;
   public static final int NORWEGIAN = 7;
   public static final int DANISH = 8;
   public static final int SWEDISH = 9;
   public static final int SWISS_GERMAN = 10;
   public static final int HUNGARIAN = 11;
   public static final int SPANISH = 12;
   public static final int ITALIAN = 13;
   public static final int SLOVENIAN = 14;
   public static final int PORTUGUESE = 15;
   public static final int US_ENGL = 254;
   public static final int US_INTL = 255;
   public static final int TRANSLATE_FRENCH_ENGLISH = 1278;
   public static final int TRANSLATE_FRENCH_ENGLISH_INTL = 1279;
   private static Hashtable<String, Integer> languages = null;
   public static final Locale BELGIUM_FRENCH = new Locale("fr", "BE");
   public static final Locale NORWAY = new Locale("no", "NO");
   public static final Locale DENMARK = new Locale("da", "DK");
   public static final Locale SWEDEN = new Locale("sv", "SE");
   public static final Locale SWITZERLAND_GERMAN = new Locale("de", "CH");
   public static final Locale HUNGARY = new Locale("hu", "HU");
   public static final Locale SPAIN = new Locale("es", "ES");
   public static final Locale SLOVENIA = new Locale("sl", "SL");
   public static final Locale PORTUGAL = new Locale("pt", "PT");
   public static final Locale FRENCH_TO_ENGLISH = new Locale("fr", "US");
   public static final Locale FRENCH_TO_ENGLISH_INTL = new Locale("fr", "en");
   private static KeyHIDTables tables = new KeyHIDTables();

   public static void setHIDMap(Locale var0) {
      setHIDMap(KeyboardUtil.getLanguageNumber(var0));
   }

   public static synchronized Map<String, Integer> getLanguages() {
      if (languages == null) {
         languages = new Hashtable<>();
         languages.put(T._("Danish (Denmark)"), 8);
         languages.put(T._("English (UK)"), 2);
         languages.put(T._("English (US/Int'l)"), 0);
         languages.put(T._("French (Belgium)"), 6);
         languages.put(T._("French (France)"), 4);
         languages.put(T._("German (Germany)"), 3);
         languages.put(T._("German (Switzerland)"), 10);
         languages.put(T._("Hungarian"), 11);
         languages.put(T._("Italian (Italy)"), 13);
         languages.put(T._("Japanese"), 1);
         languages.put(T._("Korean (Korea)"), 5);
         languages.put(T._("Norwegian (Norway)"), 7);
         languages.put(T._("Portuguese (Portugal)"), 15);
         languages.put(T._("Slovenian"), 14);
         languages.put(T._("Spanish (Spain)"), 12);
         languages.put(T._("Swedish (Sweden)"), 9);
         languages.put(T._("Translation: French-US"), 1278);
         languages.put(T._("Translation: French-US International"), 1279);
      }

      return languages;
   }

   public static String getLanguageLabel(int var0) {
      if (languages == null) {
         getLanguages();
      }

      String[] var1 = languages.keySet().toArray(new String[0]);

      for (int var2 = 0; var2 < var1.length; var2++) {
         if (languages.get(var1[var2]) == var0) {
            return var1[var2];
         }
      }

      return null;
   }

   public static void setHIDMap(int var0) {
      keyboardLanguage = var0;
      int var1 = KeyHIDTables.defaultTable.length;
      if (HIDMAP == null) {
         HIDMAP = new short[var1];
      }

      for (int var2 = 0; var2 < var1; var2++) {
         HIDMAP[var2] = KeyHIDTables.defaultTable[var2];
      }

      String var6 = "__none__";
      if (var0 == 3) {
         var6 = "de_DE";
      } else if (var0 == 4) {
         var6 = "fr_FR";
      } else if (var0 == 1) {
         var6 = "ja_JP";
      } else if (var0 == 2) {
         var6 = "en_GB";
      } else if (var0 == 5) {
         var6 = "ko_KR";
      }

      Vector var3 = tables.tables.get(var6);
      if (var3 != null) {
         for (KeyHIDTables.Pair var5 : var3) {
            HIDMAP[var5.key] = var5.value;
         }
      }
   }
}
