package com.util.kbd;

import java.util.Locale;
import javax.swing.KeyStroke;

public class KeyboardUtil {
   public static synchronized int getVKCodeForMacroCode(short[] var0, int var1) {
      int var2 = -1;
      var2 = 0;

      while (var2 < var0.length && var0[var2] != var1) {
         var2++;
      }

      return var2;
   }

   public static synchronized int getVKCodeForMacroCode(int var0, int var1) {
      KeyHIDValue.setHIDMap(var1);
      return getVKCodeForMacroCode(KeyHIDValue.HIDMAP, var0);
   }

   public static synchronized int getVKCodeForMacroCode(int var0, Locale var1) {
      return var0 == 230 ? 65406 : getVKCodeForMacroCode(var0, getLanguageNumber(var1));
   }

   public static synchronized int getMacroKeyCode(int var0, Locale var1) {
      return getMacroKeyCode(var0, getLanguageNumber(var1));
   }

   public static synchronized int getMacroKeyCode(int var0, int var1) {
      int var2 = -1;
      KeyHIDValue.setHIDMap(var1);

      for (int var3 = 0; var3 < KeyHIDValue.HIDMAP.length; var3++) {
         if (var0 == KeyHIDValue.HIDMAP[var3]) {
            var2 = var3;
            break;
         }
      }

      return var2;
   }

   public static synchronized int getKeyCode(char var0) {
      return KeyStroke.getKeyStroke(Character.toUpperCase(var0), 0, true).getKeyCode();
   }

   public static int getLanguageNumber(Locale var0) {
      if (Locale.US.equals(var0)) {
         return 0;
      } else if (Locale.GERMANY.equals(var0)) {
         return 3;
      } else if (Locale.FRANCE.equals(var0)) {
         return 4;
      } else if (Locale.JAPAN.equals(var0)) {
         return 1;
      } else if (Locale.KOREA.equals(var0)) {
         return 5;
      } else if (Locale.UK.equals(var0)) {
         return 2;
      } else if (KeyHIDValue.BELGIUM_FRENCH.equals(var0)) {
         return 6;
      } else if (KeyHIDValue.NORWAY.equals(var0)) {
         return 7;
      } else if (KeyHIDValue.DENMARK.equals(var0)) {
         return 8;
      } else if (KeyHIDValue.SWEDEN.equals(var0)) {
         return 9;
      } else if (KeyHIDValue.SWITZERLAND_GERMAN.equals(var0)) {
         return 10;
      } else if (KeyHIDValue.HUNGARY.equals(var0)) {
         return 11;
      } else if (KeyHIDValue.SPAIN.equals(var0)) {
         return 12;
      } else if (Locale.ITALY.equals(var0)) {
         return 13;
      } else if (KeyHIDValue.SLOVENIA.equals(var0)) {
         return 14;
      } else if (KeyHIDValue.PORTUGAL.equals(var0)) {
         return 15;
      } else if (KeyHIDValue.FRENCH_TO_ENGLISH.equals(var0)) {
         return 1278;
      } else {
         return KeyHIDValue.FRENCH_TO_ENGLISH_INTL.equals(var0) ? 1279 : 0;
      }
   }

   public static Locale getLocale(int var0) {
      switch (var0) {
         case 0:
            return Locale.US;
         case 1:
            return Locale.JAPAN;
         case 2:
            return Locale.UK;
         case 3:
            return Locale.GERMANY;
         case 4:
            return Locale.FRANCE;
         case 5:
            return Locale.KOREA;
         case 6:
            return KeyHIDValue.BELGIUM_FRENCH;
         case 7:
            return KeyHIDValue.NORWAY;
         case 8:
            return KeyHIDValue.DENMARK;
         case 9:
            return KeyHIDValue.SWEDEN;
         case 10:
            return KeyHIDValue.SWITZERLAND_GERMAN;
         case 11:
            return KeyHIDValue.HUNGARY;
         case 12:
            return KeyHIDValue.SPAIN;
         case 13:
            return Locale.ITALY;
         case 14:
            return KeyHIDValue.SLOVENIA;
         case 15:
            return KeyHIDValue.PORTUGAL;
         case 1278:
            return KeyHIDValue.FRENCH_TO_ENGLISH;
         case 1279:
            return KeyHIDValue.FRENCH_TO_ENGLISH_INTL;
         default:
            throw new IllegalArgumentException("Unknown language number " + var0);
      }
   }
}
