package javaclientlib.clientlib;

public class PS2Mouse {
   short sDeltaX;
   short sDeltaY;
   short sDeltaZ;
   int iButtonCount;
   int iAxesCount;
   byte[] byButtons = new byte[3];
   byte[] byLastButtons = new byte[3];

   public PS2Mouse() {
      this.sDeltaX = 0;
      this.sDeltaY = 0;
      this.sDeltaZ = 0;
      this.iButtonCount = 3;
      this.iAxesCount = 3;

      for (int var1 = 0; var1 < this.iButtonCount; var1++) {
         this.byButtons[var1] = 0;
         this.byLastButtons[var1] = 0;
      }
   }

   public void setMouseType(int var1, int var2) {
      if (var1 == 2 || var1 == 3) {
         this.iButtonCount = var1;
      }

      if (var2 == 2 || var2 == 3) {
         this.iAxesCount = var2;
      }
   }

   public boolean processMouseData(byte var1, short var2, short var3, short var4) {
      boolean var5 = false;
      synchronized (this) {
         switch (var1) {
            case 0:
               this.byButtons[0] = 1;
               var5 = true;
               break;
            case 1:
               this.byButtons[0] = 0;
               var5 = true;
               break;
            case 2:
               this.byButtons[1] = 1;
               var5 = true;
               break;
            case 3:
               this.byButtons[1] = 0;
               var5 = true;
               break;
            case 4:
               this.byButtons[2] = 1;
               var5 = true;
               break;
            case 5:
               this.byButtons[2] = 1;
               var5 = true;
            case 6:
            default:
               break;
            case 7:
               this.sDeltaX += var2;
               this.sDeltaY -= var3;
               break;
            case 8:
               if (var4 >= 0) {
                  this.sDeltaZ++;
               } else {
                  this.sDeltaZ--;
               }
         }

         return var5;
      }
   }

   public boolean isMousePacketReady() {
      boolean var1 = true;
      synchronized (this) {
         var1 = this.sDeltaX == 1 || this.sDeltaY == 1;
         if (this.iAxesCount == 3) {
            var1 |= this.sDeltaZ == 1;
         }

         var1 |= this.byButtons[0] != this.byLastButtons[0] || this.byButtons[1] != this.byLastButtons[1];
         if (this.iButtonCount == 3) {
            var1 |= this.byButtons[2] != this.byLastButtons[2];
         }

         return var1;
      }
   }

   public int getMousePacket(byte[] var1) {
      synchronized (this) {
         var1[0] = (byte)(8 | (this.byButtons[0] == 1 ? 1 : 0) | (this.byButtons[1] == 1 ? 1 : 0));
         if (this.iButtonCount > 2) {
            var1[0] |= (byte)(this.byButtons[2] == 1 ? 1 : 0);
         }

         if (this.sDeltaX >= 0) {
            if (this.sDeltaX > 127) {
               this.sDeltaX = 127;
            }

            var1[1] = (byte)this.sDeltaX;
         } else {
            var1[0] = (byte)(var1[0] | 16);
            if (this.sDeltaX < -128) {
               this.sDeltaX = -128;
            }

            var1[1] = (byte)this.sDeltaX;
         }

         if (var1[1] == -86) {
            var1[1] = -87;
         }

         if (this.sDeltaY >= 0) {
            if (this.sDeltaY > 127) {
               this.sDeltaY = 127;
            }

            var1[2] = (byte)this.sDeltaY;
         } else {
            var1[0] = (byte)(var1[0] | 32);
            if (this.sDeltaY < -128) {
               this.sDeltaY = -128;
            }

            var1[2] = (byte)this.sDeltaY;
         }

         if (var1[2] == -86) {
            var1[2] = -87;
         }

         if (this.iAxesCount > 2) {
            if (this.sDeltaZ == 0) {
               var1[3] = 0;
            } else if (this.sDeltaZ > 0) {
               var1[3] = -1;
            } else {
               var1[3] = 1;
            }
         }

         this.sDeltaX = this.sDeltaY = this.sDeltaZ = 0;

         for (int var2 = 0; var2 < this.iButtonCount; var2++) {
            this.byLastButtons[var2] = this.byButtons[var2];
         }
      }

      return this.iAxesCount + 1;
   }
}
