package javaclientlib.clientlib;

import javaclientlib.tr.TRCOMMAND;
import javaclientlib.utils.RRCLogger;

public class TRKeepAliveThread extends Thread {
   private TRConnection objTRConnection;

   public TRKeepAliveThread(TRConnection var1) {
      this.objTRConnection = var1;
   }

   @Override
   public void run() {
      TRCOMMAND var1 = new TRCOMMAND();
      long var2 = 58000L;
      long var4 = var2 >> 1;
      long var6 = var4;

      while (true) {
         try {
            synchronized (this) {
               this.wait(var6);
            }

            var6 = var4;
            if (interrupted()) {
               return;
            }

            if (this.objTRConnection.getAuthenticated()) {
               if (System.currentTimeMillis() - this.objTRConnection.getTimeLastMsg() > var2) {
                  if (RRCLogger.logEnabled) {
                     RRCLogger.log(300, 8, "KAT: Not Responding");
                  }

                  try {
                     this.objTRConnection.disConnect();
                  } catch (Exception var12) {
                  }

                  this.objTRConnection.dbLog("Server not responding\n");
               } else {
                  long var8 = System.currentTimeMillis() - this.objTRConnection.getTimeLastMsgSent();
                  long var10 = System.currentTimeMillis() - this.objTRConnection.getTimeLastMsg();
                  if (var8 < var4 && var10 < var4) {
                     var6 = var4 - Math.max(var8, var10);
                     continue;
                  }

                  var1.setCommand((byte)3);
                  var1.setCmdLength((short)4);
                  var1.setPktID((byte)0);
                  if (this.objTRConnection.sendTRCmd(var1)) {
                     continue;
                  }

                  this.objTRConnection.disConnect();
                  this.objTRConnection.dbLog("PING Error");
               }

               return;
            }
         } catch (InterruptedException var15) {
            if (RRCLogger.logEnabled) {
               RRCLogger.log(300, 8, "KAT: InterruptedException");
            }

            return;
         } catch (Exception var16) {
            if (RRCLogger.logEnabled) {
               RRCLogger.log(300, 8, "KAT: Exception");
            }

            this.objTRConnection.dbNotify(536870916, 9);
            RRCLogger.logException(var16);

            try {
               this.objTRConnection.disConnect();
            } catch (Exception var14) {
               if (RRCLogger.logEnabled) {
                  RRCLogger.log(100, 8, "TRKeepAliveThread:run - 2 " + var14.getMessage());
               }
            }
         }
      }
   }
}
