package javaclientlib.clientlib;

import com.util.kbd.KeyHIDValue;
import java.awt.Rectangle;
import java.awt.image.BufferedImage;
import java.awt.image.DataBufferInt;
import java.io.FileOutputStream;
import java.net.InetAddress;
import java.util.Arrays;
import javaclientlib.common.CCT;
import javaclientlib.common.org.lzo.Int;
import javaclientlib.common.org.lzo.Lzo1xDecompressor;
import javaclientlib.tr.BitMapInfo;
import javaclientlib.tr.Cell;
import javaclientlib.tr.Constants;
import javaclientlib.tr.TRCCT;
import javaclientlib.tr.TRCMD_CONNECT_VIDEO_STREAM_DATA;
import javaclientlib.tr.TRCMD_GET_COMP_PARAMS_DATA;
import javaclientlib.tr.TRCMD_GET_TARGET_INTERFACE_DATA;
import javaclientlib.tr.TRCMD_GET_VIDEO_PARAMS_DATA;
import javaclientlib.tr.TRCMD_KB_DATA;
import javaclientlib.tr.TRCMD_MOUSE_DATA;
import javaclientlib.tr.TRCMD_RAW_MOUSE_DATA;
import javaclientlib.tr.TRCMD_REFRESH_DATA;
import javaclientlib.tr.TRCMD_SET_COMP_PARAMS_DATA;
import javaclientlib.tr.TRCMD_SET_TARGET_INTERFACE_DATA;
import javaclientlib.tr.TRCMD_SET_VIDEO_PARAMS_DATA;
import javaclientlib.tr.TRCMD_STOP_VIDEO_STREAM_DATA;
import javaclientlib.tr.TRCMD_SYNC_MOUSE_DATA;
import javaclientlib.tr.TRCOMMAND;
import javaclientlib.tr.TRLIB_COMM;
import javaclientlib.tr.TRLIB_REFERRAL_COMM;
import javaclientlib.tr.TRLIB_UPDATEINFO;
import javaclientlib.tr.TRLIB_USERINFO;
import javaclientlib.tr.TRRECT;
import javaclientlib.tr.TRRSP_BITPLANE_DATA;
import javaclientlib.tr.TRRSP_CACHE_DATA;
import javaclientlib.tr.TRRSP_CELL_DATA;
import javaclientlib.tr.TRRSP_CONNECTED_DATA;
import javaclientlib.tr.TRRSP_KB_STATUS_DATA;
import javaclientlib.tr.TRRSP_NEW_VIDEO_MODE_DATA;
import javaclientlib.tr.TRRSP_NOTIFY_DATA;
import javaclientlib.tr.TRRSP_RECEIVE_SERIAL_DATA;
import javaclientlib.tr.TRRSP_TARGET_PARAMS_DATA;
import javaclientlib.tr.TRRSP_VIDEO_MARKER_DATA;
import javaclientlib.tr.TRRSP_VIDEO_PARAMS_DATA;
import javaclientlib.tr.TRSRVR_COMP_PARAMS;
import javaclientlib.tr.TRSRVR_SERIAL_PARAMS;
import javaclientlib.tr.TRSRVR_TARGET_PARAMS;
import javaclientlib.tr.TRSRVR_VIDEO_PARAMS;
import javaclientlib.utils.RRCGeneralException;
import javaclientlib.utils.RRCLogger;

public class TRVideoStream implements IKvmData, Keyboard {
   private Keyboard keyboard = null;
   long minUpdateTime = 50L;
   private TRConnection objConn;
   private TRVideoStream objVSNext;
   private boolean boolObjectGood;
   private byte byDeviceID;
   private boolean boolConnected;
   private boolean boolWaitVideoMode;
   private TRCCT objCCT;
   private int iKBDataCount;
   private BitMapInfo[] objDIB;
   private boolean boolCacheEnabled;
   private boolean boolSixteenBit;
   private byte[] byDIBBytes;
   private int[] iPixelData;
   private int[] iPaletteTemp;
   private BufferedImage bufferedImage = null;
   private boolean boolProgressiveUpdate;
   private byte[] byCache0;
   private byte[] byCache1;
   private byte[] byCache2;
   private int iCacheDepth;
   protected TRRSP_NEW_VIDEO_MODE_DATA objTRRSPNewVideoModeData;
   private Cell[] objCellInfo;
   private byte[] byKBBuffer;
   private byte[] byBitPlaneBuffer;
   private boolean mylog = true;
   private int iConst1 = 31744;
   private int iConst2 = 992;
   private int iConst3 = 31;
   private int Const4 = -1;
   private int Const5 = -1;
   private int Const6 = -1;
   private short[] pMaskMap;
   private short[] p16BitConvertTable;
   private int icc = 0;
   short[] progressiveMaskMap = new short[]{31744, 992, 31, 15360, 480, 15, 7168, 224, 7, 3072, 96, 3, 1024, 32, 1};
   short[] RGB16MaskMap = new short[]{1, 2, 4, 8, 16, 32, 64, 128, 256, 512, 1024, 2048, 4096, 8192, 16384, 0};
   short[] RGB12MaskMap = new short[]{3, 4, 8, 16, 96, 128, 256, 512, 3072, 4096, 8192, 16384, 0, 0, 0, 0};
   public static final int DECOMP_BUFFER_SIZE = 131072;
   private static int[] iMaskMap;

   public void setMinFrameUpdateTime(long var1) {
      this.minUpdateTime = var1;
   }

   public TRVideoStream(TRConnection var1, int var2) {
      this.objConn = var1;
      this.boolObjectGood = true;
      this.objVSNext = (TRVideoStream)null;
      this.byDeviceID = 0;
      this.boolConnected = false;
      this.boolWaitVideoMode = true;
      this.objCCT = (TRCCT)null;
      this.iKBDataCount = 0;
      this.byKBBuffer = new byte[16];
      this.objDIB = new BitMapInfo[16];
      iMaskMap = new int[16];
      this.boolCacheEnabled = false;
      this.boolSixteenBit = false;
      this.byDIBBytes = null;
      this.boolProgressiveUpdate = false;
      this.byBitPlaneBuffer = null;
      this.p16BitConvertTable = null;
      this.byCache0 = null;
      this.byCache1 = null;
      this.byCache2 = null;
      this.pMaskMap = new short[16];
      this.iCacheDepth = 0;
      this.objTRRSPNewVideoModeData = null;
      this.objCellInfo = new Cell[1024];

      for (int var3 = 0; var3 < this.objCellInfo.length; var3++) {
         this.objCellInfo[var3] = new Cell();
      }

      this.objTRRSPNewVideoModeData = new TRRSP_NEW_VIDEO_MODE_DATA();
      var1.addVideoStream(this);
      if ((var1.getServerID().getOptions() & 4) > 0) {
         this.keyboard = new HIDKeyboard(this);
      } else {
         this.keyboard = new PS2Keyboard(this);
      }

      KeyHIDValue.setHIDMap(var2);
   }

   @Override
   protected void finalize() {
      if (this.boolConnected) {
         this.stopVideoStream();
      }

      if (this.objConn != null) {
         this.objConn.removeVideoStream(this);
      }

      this.objTRRSPNewVideoModeData = null;
   }

   public void setDeviceID(byte var1) {
      this.byDeviceID = var1;
   }

   public void setConnected(boolean var1) {
      this.boolConnected = var1;
   }

   public boolean isConnected() {
      return this.boolConnected;
   }

   public void setVideoStreamDevice(byte var1) {
      this.objConn.setVideoStreamDevice(this, var1);
   }

   public boolean connectVideoStream(String var1, String var2, TRSRVR_COMP_PARAMS var3, int var4) {
      try {
         TRCMD_CONNECT_VIDEO_STREAM_DATA var5 = new TRCMD_CONNECT_VIDEO_STREAM_DATA((short)4108);
         boolean var6 = false;
         Object var7 = null;
         if (var4 == 0) {
            var7 = "<Connect><Portal>" + var1 + "</Portal><Target>" + var2 + "</Target></Connect>";
         } else {
            var7 = "<Connect ForceConnection=\"1\"><Portal>" + var1 + "</Portal><Target>" + var2 + "</Target></Connect>";
         }

         var5.setCommand((byte)55);
         System.arraycopy(var7.getBytes(), 0, var5.toByteArray(), 44, var7.getBytes().length);
         var5.setCmdLength((short)(44 + var7.getBytes().length));
         var5.setCompParams(var3);
         var6 = this.objConn.sendTRCmdExx(var5, true, null, 37, true, 20000);
         var6 = this.objConn.processResponse(var6, var5);
         if (var6) {
            TRRSP_CONNECTED_DATA var8 = new TRRSP_CONNECTED_DATA(var5.toByteArray());
            this.byDeviceID = var8.getDeviceID();
            this.objConn.setVideoStreamDevice(this, this.byDeviceID);
            this.boolConnected = true;
         }

         this.objConn.syncTRCmd();
         return var6;
      } catch (Exception var9) {
         RRCLogger.logException(var9);
         return false;
      }
   }

   public boolean switchVideoStream(String var1, String var2) {
      try {
         TRCOMMAND var3 = new TRCOMMAND((short)4108);
         boolean var4 = false;
         String var5 = "<Connect><Portal>" + var1 + "</Portal><Target>" + var2 + "</Target></Connect>";
         this.boolWaitVideoMode = true;
         var3.setCommand((byte)57);
         System.arraycopy(var5.getBytes(), 0, var3.toByteArray(), 4, var5.getBytes().length);
         var3.setCmdLength((short)(4 + var5.getBytes().length));
         var4 = this.objConn.sendTRCmdEx(var3, true, null, 2);
         return this.objConn.processResponse(var4, var3);
      } catch (Exception var6) {
         RRCLogger.logException(var6);
         return false;
      }
   }

   public boolean stopVideoStream() {
      try {
         boolean var1 = false;
         this.boolWaitVideoMode = true;
         this.boolConnected = false;
         TRCMD_STOP_VIDEO_STREAM_DATA var2 = new TRCMD_STOP_VIDEO_STREAM_DATA((short)4108);
         var2.setCommand((byte)10);
         var2.setCmdLength((short)5);
         var2.setDeviceID(this.byDeviceID);
         var1 = this.objConn.sendTRCmdEx(var2, true, null, 2, 20000);
         this.objConn.setVideoStreamDevice(null, this.byDeviceID);
         var1 = this.objConn.processResponse(var1, var2);
         if (this.objConn != null) {
            this.objConn.removeVideoStream(this);
         }

         this.objTRRSPNewVideoModeData = null;
         this.bufferedImage = null;
         this.iPixelData = null;
         this.iPaletteTemp = null;
         this.freeDecompressionResources();
         return var1;
      } catch (Exception var3) {
         RRCLogger.logException(var3);
         return false;
      }
   }

   public boolean setVideoParams(TRSRVR_VIDEO_PARAMS var1) {
      try {
         boolean var2 = true;
         TRCMD_SET_VIDEO_PARAMS_DATA var3 = new TRCMD_SET_VIDEO_PARAMS_DATA((short)4108);
         var3.setCommand((byte)45);
         var3.setCmdLength((short)89);
         var3.setDeviceID(this.byDeviceID);
         var3.setVideoParams(var1);
         var2 = this.objConn.sendTRCmdEx(var3, true, null, 2);
         return this.objConn.processResponse(var2, var3);
      } catch (Exception var4) {
         RRCLogger.logException(var4);
         return false;
      }
   }

   public boolean getVideoParams(TRSRVR_VIDEO_PARAMS var1) {
      try {
         boolean var2 = true;
         TRCMD_GET_VIDEO_PARAMS_DATA var3 = new TRCMD_GET_VIDEO_PARAMS_DATA((short)4108);
         var3.setCommand((byte)11);
         var3.setCmdLength((short)5);
         var3.setDeviceID(this.byDeviceID);
         var2 = this.objConn.sendTRCmdEx(var3, true, null, 29);
         if (var2) {
            TRRSP_VIDEO_PARAMS_DATA var4 = new TRRSP_VIDEO_PARAMS_DATA(var3.toByteArray());
            var1.setVideoParams(var4.getParams());
         }

         return this.objConn.processResponse(var2, var3);
      } catch (Exception var5) {
         RRCLogger.logException(var5);
         return false;
      }
   }

   public boolean setTargetParams(byte[] var1, int var2) {
      try {
         boolean var3 = true;
         TRCMD_SET_TARGET_INTERFACE_DATA var4 = new TRCMD_SET_TARGET_INTERFACE_DATA();
         var4.setCommand((byte)60);
         var4.setCmdLength((short)73);
         var4.setDeviceID(this.byDeviceID);
         if (var1 != null && var1.length != 0) {
            var4.setIType(var1);
            var4.setISettings(var2);
            if (this.objConn.getServerID().getProtocolVersion() < 22) {
               return false;
            } else {
               var3 = this.objConn.sendTRCmdEx(var4, true, null, 2);
               return this.objConn.processResponse(var3, var4);
            }
         } else {
            return false;
         }
      } catch (Exception var5) {
         RRCLogger.logException(var5);
         return false;
      }
   }

   public boolean getTargetParams(TRSRVR_TARGET_PARAMS var1) {
      try {
         boolean var2 = true;
         TRCMD_GET_TARGET_INTERFACE_DATA var3 = new TRCMD_GET_TARGET_INTERFACE_DATA();
         var3.setCommand((byte)59);
         var3.setCmdLength((short)145);
         var3.setDeviceID(this.byDeviceID);
         var3.setTargetParams(var1);
         if (this.objConn.getServerID().getProtocolVersion() < 22) {
            return false;
         } else {
            var2 = this.objConn.sendTRCmdEx(var3, true, null, 47);
            if (var2) {
               TRRSP_TARGET_PARAMS_DATA var4 = new TRRSP_TARGET_PARAMS_DATA(var3.toByteArray());
               var1.setTargetParams(var4.getParams());
            }

            return this.objConn.processResponse(var2, var3);
         }
      } catch (Exception var5) {
         RRCLogger.logException(var5);
         return false;
      }
   }

   public boolean setCompParams(TRSRVR_COMP_PARAMS var1) {
      try {
         boolean var2 = false;
         TRCMD_SET_COMP_PARAMS_DATA var3 = new TRCMD_SET_COMP_PARAMS_DATA((short)4108);
         var3.setCommand((byte)46);
         var3.setCmdLength((short)45);
         var3.setDeviceID(this.byDeviceID);
         var1.setCompressMode(2);
         var3.setParams(var1);
         var2 = this.objConn.sendTRCmdEx(var3, true, null, 2);
         return this.objConn.processResponse(var2, var3);
      } catch (Exception var4) {
         RRCLogger.logException(var4);
         return false;
      }
   }

   public boolean getCompParams(TRSRVR_VIDEO_PARAMS var1, boolean var2) {
      try {
         boolean var3 = true;
         TRCMD_GET_COMP_PARAMS_DATA var4 = new TRCMD_GET_COMP_PARAMS_DATA((short)4108);
         var4.setCommand((byte)13);
         var4.setCmdLength((short)6);
         var4.setDeviceID(this.byDeviceID);
         var4.setPVSettings((byte)(var2 ? 1 : 0));
         var3 = this.objConn.sendTRCmdEx(var4, true, null, 11);
         if (var3) {
            TRRSP_VIDEO_PARAMS_DATA var5 = new TRRSP_VIDEO_PARAMS_DATA(var4.toByteArray());
            var1.setVideoParams(var5.getParams());
         }

         return this.objConn.processResponse(var3, var4);
      } catch (Exception var6) {
         RRCLogger.logException(var6);
         return false;
      }
   }

   public boolean refreshVideo(int var1, boolean var2) {
      try {
         boolean var3 = true;
         TRCMD_REFRESH_DATA var4 = new TRCMD_REFRESH_DATA();
         var4.setCommand((byte)47);
         var4.setCmdLength((short)10);
         var4.setDeviceID(this.byDeviceID);
         var4.setFlags(var1);
         var4.setAutoSense(var2);
         return this.objConn.sendTRCmd(var4);
      } catch (Exception var5) {
         RRCLogger.logException(var5);
         return false;
      }
   }

   public boolean sendKeyData(int var1, byte[] var2) {
      try {
         byte[] var3 = new byte[21];
         boolean var4 = false;
         TRCMD_KB_DATA var5 = new TRCMD_KB_DATA(var3);
         var5.setCommand((byte)17);
         var5.setCmdLength((short)(5 + var1));
         var5.setDeviceID(this.byDeviceID);
         System.arraycopy(var2, 0, var5.toByteArray(), 5, var1);
         return this.objConn.sendTRCmd(var5);
      } catch (Exception var6) {
         RRCLogger.logException(var6);
         return false;
      }
   }

   public boolean sendMouseData(byte var1, short var2, short var3, short var4) {
      try {
         boolean var5 = false;
         TRCMD_MOUSE_DATA var6 = new TRCMD_MOUSE_DATA();
         var6.setCommand((byte)18);
         var6.setCmdLength((short)10);
         var6.setDeviceID(this.byDeviceID);
         var6.setFunction(var1);
         switch (var1) {
            case 6:
            case 7:
               var6.setX(var2);
               break;
            case 8:
               var6.setX(var4);
               break;
            default:
               var6.setX(var2);
         }

         var6.setY(var3);
         return this.objConn.sendTRCmd(var6);
      } catch (Exception var7) {
         RRCLogger.logException(var7);
         return false;
      }
   }

   public boolean sendRawMouseData(int var1, byte[] var2) {
      try {
         boolean var3 = false;
         if (var1 != 4) {
            TRConnection.setLastError(1);
            return false;
         } else {
            byte[] var4 = new byte[9];
            TRCMD_RAW_MOUSE_DATA var5 = new TRCMD_RAW_MOUSE_DATA(var4);
            var5.setCommand((byte)19);
            var5.setCmdLength((short)(5 + var1));
            var5.setDeviceID(this.byDeviceID);
            System.arraycopy(var2, 0, var5.toByteArray(), 5, var1);
            return this.objConn.sendTRCmd(var5);
         }
      } catch (Exception var6) {
         RRCLogger.logException(var6);
         return false;
      }
   }

   public boolean syncMouse(int var1) {
      try {
         boolean var2 = false;
         TRCMD_SYNC_MOUSE_DATA var3 = new TRCMD_SYNC_MOUSE_DATA();
         var3.setCommand((byte)49);
         var3.setCmdLength((short)9);
         var3.setSyncFlags(var1);
         var3.setDeviceID(this.byDeviceID);
         return this.objConn.sendTRCmd(var3);
      } catch (Exception var4) {
         RRCLogger.logException(var4);
         return false;
      }
   }

   public boolean TRRSP_Notify(TRCOMMAND var1) {
      TRRSP_NOTIFY_DATA var2 = new TRRSP_NOTIFY_DATA(var1.toByteArray());
      this.notify(var2.getEvent(), var2.getParam());
      return true;
   }

   public void targetParamsChanged(TRSRVR_TARGET_PARAMS var1) {
   }

   public boolean TRRSP_New_Video_Mode(TRCOMMAND var1) {
      DataBufferInt var2 = null;

      try {
         if (this.Const4 == -1) {
            this.iConst1 = 2080374784;
            this.Const4 = 0;

            while ((this.iConst1 >>> this.Const4 & -256) != 0) {
               this.Const4++;
            }
         }

         if (this.Const5 == -1) {
            this.iConst2 = 65011712;
            this.Const5 = 0;

            while ((this.iConst2 >>> this.Const5 & -256) != 0) {
               this.Const5++;
            }
         }

         if (this.Const6 == -1) {
            this.iConst3 = 2031616;
            this.Const6 = 0;

            while ((this.iConst3 >>> this.Const6 & -256) != 0) {
               this.Const6++;
            }
         }

         boolean var3 = false;
         TRRSP_NEW_VIDEO_MODE_DATA var4 = new TRRSP_NEW_VIDEO_MODE_DATA(var1.toByteArray());
         if ((var4.getFlags() & 2) != 0 && !this.boolWaitVideoMode) {
            return true;
         } else {
            this.objTRRSPNewVideoModeData.setNewVideoMode(var4);
            this.objCCT = CCT.getCCT(this.objTRRSPNewVideoModeData.getCCT());
            this.freeDecompressionResources();
            if (this.objCCT == null) {
               this.objConn.dbNotify(1016, 39);
               return false;
            } else {
               if ((this.objTRRSPNewVideoModeData.getCompParams().getFlags() & 32768) != 0) {
                  this.boolProgressiveUpdate = true;
               } else {
                  this.boolProgressiveUpdate = false;
               }

               if (this.objCCT.getBitsPerPixel() > 8) {
                  if (this.boolProgressiveUpdate) {
                     this.pMaskMap = this.progressiveMaskMap;
                  } else if (this.objCCT.getBitsPerPixel() == 12) {
                     this.pMaskMap = this.RGB12MaskMap;
                  } else {
                     this.pMaskMap = this.RGB16MaskMap;
                  }
               }

               var3 = this.allocateDecompressionResources();
               if (!var3) {
                  this.objConn.dbNotify(1021, 40);
                  return false;
               } else {
                  for (int var5 = 0; var5 < 1024; var5++) {
                     this.objCellInfo[var5].setRefresh(false);
                     this.objCellInfo[var5].setCodePlane((short)0);
                     this.objCellInfo[var5].setCacheHead((short)0);
                     this.objCellInfo[var5].setCache(0, 0);
                     this.objCellInfo[var5].setCache(1, 0);
                     this.objCellInfo[var5].setCache(2, 0);
                  }

                  for (int var9 = 0; var9 < this.objCCT.getCCTFieldCount(); var9++) {
                     this.objDIB[var9].getBMIHeader().setBIWidth(this.objTRRSPNewVideoModeData.getLogicalHSize());
                     this.objDIB[var9].getBMIHeader().setBIHeight(-this.objTRRSPNewVideoModeData.getLogicalVSize());
                  }

                  this.boolWaitVideoMode = false;
                  this.bufferedImage = new BufferedImage(this.objTRRSPNewVideoModeData.getLogicalHSize(), this.objTRRSPNewVideoModeData.getLogicalVSize(), 2);
                  var2 = (DataBufferInt)this.bufferedImage.getRaster().getDataBuffer();
                  this.iPixelData = var2.getData();
                  this.newVideoModeNotify(this.objTRRSPNewVideoModeData);
                  return true;
               }
            }
         }
      } catch (Exception var6) {
         RRCLogger.logException(var6);
         return false;
      }
   }

   public boolean TRRSP_Cache(TRCOMMAND var1) {
      boolean var19 = true;
      TRRSP_CACHE_DATA var21 = new TRRSP_CACHE_DATA(var1.toByteArray());
      if (this.boolWaitVideoMode) {
         return true;
      } else {
         int var5 = (this.objTRRSPNewVideoModeData.getLogicalHSize() + this.objTRRSPNewVideoModeData.getCellHSize() - 1)
            / this.objTRRSPNewVideoModeData.getCellHSize();
         int var6 = (this.objTRRSPNewVideoModeData.getLogicalVSize() + this.objTRRSPNewVideoModeData.getCellVSize() - 1)
            / this.objTRRSPNewVideoModeData.getCellVSize();
         short var20 = this.objTRRSPNewVideoModeData.getLogicalHSize();
         int var9 = 0;
         byte var14 = -64;
         byte var10 = 6;

         for (int var2 = var21.getStart(); var2 < var21.getStart() + var21.getCount(); var2++) {
            TRLIB_UPDATEINFO var22 = new TRLIB_UPDATEINFO();
            var22.setLastField(true);
            var22.setFrameBuffer(this.byDIBBytes);
            var22.setBitMapInfo(this.objDIB[this.objCCT.getCCTFieldCount() - 1]);
            if ((var21.getCell()[var9] & var14) == 1) {
               int var11 = ((var21.getCell()[var9] & var14) >> var10) - 1;
               byte[] var17;
               if (var11 == 0) {
                  var17 = this.byCache0;
               } else if (var11 == 1) {
                  var17 = this.byCache1;
               } else {
                  var17 = this.byCache2;
               }

               int var4 = var2 / var5;
               int var3 = var2 % var5;
               var22.getRect().setLeft((short)(var3 * this.objTRRSPNewVideoModeData.getCellHSize()));
               var22.getRect().setRight((short)(var22.getRect().getLeft() + this.objTRRSPNewVideoModeData.getCellHSize() - 1));
               var22.getRect().setTop((short)(var4 * this.objTRRSPNewVideoModeData.getCellVSize()));
               var22.getRect().setBottom((short)(var22.getRect().getTop() + this.objTRRSPNewVideoModeData.getCellVSize() - 1));

               for (int var8 = var22.getRect().getTop(); var8 <= var22.getRect().getBottom(); var8++) {
                  int var12 = var8 * var20 + var22.getRect().getLeft();
                  int var13 = var8 * var20 + var22.getRect().getLeft();

                  for (int var7 = var22.getRect().getLeft(); var7 <= var22.getRect().getRight(); var7++) {
                     this.byDIBBytes[var13++] = var17[var12++];
                  }
               }

               if (var22.getRect().getRight() >= this.objTRRSPNewVideoModeData.getActualHSize()) {
                  var22.getRect().setRight((short)(this.objTRRSPNewVideoModeData.getActualHSize() - 1));
               }

               if (var22.getRect().getBottom() >= this.objTRRSPNewVideoModeData.getActualVSize()) {
                  var22.getRect().setBottom((short)(this.objTRRSPNewVideoModeData.getActualVSize() - 1));
               }

               this.updateNotify(var22);
            }

            var14 = (byte)(var14 >> 2);
            var10 -= 2;
            if (var14 == 0) {
               var9++;
               var14 = -64;
               var10 = 6;
            }
         }

         return var19;
      }
   }

   public boolean TRRSP_Cell_Data(TRCOMMAND var1) {
      try {
         boolean var2 = false;
         Rectangle var13 = null;
         new TRRECT();
         int var19 = 0;
         int var20 = 0;
         int var21 = 0;
         TRRSP_CELL_DATA var29 = new TRRSP_CELL_DATA(var1.toByteArray());
         int var18 = var29.getCmdLength() - 8;
         short var8 = var29.getCellCount();
         byte var28 = var29.getFlags();
         var2 = this.objConn.read(var1.toByteArray(), 8, var18);
         if (!var2) {
            return false;
         } else if (this.boolWaitVideoMode) {
            return true;
         } else {
            Int var30 = new Int(131072);
            if ((var28 & 1) != 0) {
               int var31 = 0;
               Lzo1xDecompressor var32 = new Lzo1xDecompressor();
               var31 = var32.decompress(var1.toByteArray(), 8, var18, this.byBitPlaneBuffer, 0, var30);
               if (var31 != 0) {
                  return false;
               }
            }

            int var6 = (this.objTRRSPNewVideoModeData.getLogicalHSize() + this.objTRRSPNewVideoModeData.getCellHSize() - 1)
               / this.objTRRSPNewVideoModeData.getCellHSize();
            int var7 = (this.objTRRSPNewVideoModeData.getLogicalVSize() + this.objTRRSPNewVideoModeData.getCellVSize() - 1)
               / this.objTRRSPNewVideoModeData.getCellVSize();
            int var12 = this.boolSixteenBit ? 2 : 1;
            short var15 = this.objTRRSPNewVideoModeData.getLogicalHSize();

            for (int var11 = 0; var11 < var8; var11++) {
               TRLIB_UPDATEINFO var52 = new TRLIB_UPDATEINFO();
               var52.setLastField(true);
               short var3 = (short)(((this.byBitPlaneBuffer[var20 + 2] & 255) << 8) + ((this.byBitPlaneBuffer[var20 + 3] & 255) << 0));
               var20 += 8;
               if (var3 > this.objTRRSPNewVideoModeData.getCellCount()) {
                  break;
               }

               int var4 = var3 / var6;
               int var5 = var3 % var6;
               int var24 = var5 * this.objTRRSPNewVideoModeData.getCellHSize();
               int var25 = var24 + this.objTRRSPNewVideoModeData.getCellHSize() - 1;
               int var22 = var4 * this.objTRRSPNewVideoModeData.getCellVSize();
               int var23 = var22 + this.objTRRSPNewVideoModeData.getCellVSize() - 1;
               if (this.boolSixteenBit) {
                  if (this.p16BitConvertTable == null) {
                     for (int var10 = var22; var10 <= var23; var10++) {
                        var19 = (var10 * var15 + var24) * var12;
                        int var9 = (var25 - var24 + 1) * var12 / 32;

                        for (int var26 = var24; var9-- != 0; var26 += 16) {
                           var21 = var10 * var15 + var26;

                           for (int var53 = 0; var53 < 16; var53++) {
                              int var16 = (this.byBitPlaneBuffer[var20++] & 255) << 8 | this.byBitPlaneBuffer[var20++] & 255;
                              this.iPixelData[var21++] = 0xFF000000 | (var16 & 31744) << 9 | (var16 & 992) << 6 | (var16 & 31) << 3;
                           }
                        }
                     }
                  } else {
                     for (int var39 = var22; var39 <= var23; var39++) {
                        var19 = (var39 * var15 + var24) * var12;
                        int var37 = (var25 - var24 + 1) / 16 * var12;

                        for (int var50 = var24; var37-- != 0; var50 += 8) {
                           var21 = var39 * var15 + var50;

                           for (int var34 = 0; var34 < 8; var34++) {
                              int var42 = (this.byBitPlaneBuffer[var20++] & 255) << 8 | this.byBitPlaneBuffer[var20++] & 255;
                              this.iPixelData[var21++] = 0xFF000000 | (var42 & 3840) << 12 | (var42 & 240) << 8 | (var42 & 15) << 4;
                           }
                        }
                     }
                  }
               } else {
                  for (int var40 = var22; var40 <= var23; var40++) {
                     var19 = (var40 * var15 + var24) * var12;

                     for (int var38 = var25 - var24 + 1; var38 > 0; var38--) {
                        this.iPixelData[var19++] = this.iPaletteTemp[this.byBitPlaneBuffer[var20++] & 255];
                     }
                  }
               }

               if (var25 >= this.objTRRSPNewVideoModeData.getActualHSize()) {
                  var25 = this.objTRRSPNewVideoModeData.getActualHSize() - 1;
               }

               if (var23 >= this.objTRRSPNewVideoModeData.getActualVSize()) {
                  var23 = this.objTRRSPNewVideoModeData.getActualVSize() - 1;
               }

               if (var13 == null) {
                  var13 = new Rectangle(var24, var22, var25 - var24 + 1, var23 - var22 + 1);
               } else {
                  var13 = var13.union(new Rectangle(var24, var22, var25 - var24 + 1, var23 - var22 + 1));
               }

               var52.setRectangle(var13);
               var52.setImage(this.bufferedImage);
               this.updateNotify(var52);
               var13 = null;
            }

            return true;
         }
      } catch (Exception var35) {
         RRCLogger.logException(var35);
         return false;
      }
   }

   public boolean TRRSP_Bitplane(TRCOMMAND var1) {
      try {
         boolean var2 = true;
         TRRECT var4 = new TRRECT();
         TRLIB_UPDATEINFO var7 = new TRLIB_UPDATEINFO();
         new TRLIB_UPDATEINFO();
         TRRSP_BITPLANE_DATA var9 = new TRRSP_BITPLANE_DATA(var1.toByteArray());
         TRRECT var10 = var9.getArea();
         var4.setBottom(var10.getBottom());
         var4.setLeft(var10.getLeft());
         var4.setRight(var10.getRight());
         var4.setTop(var10.getTop());
         byte var6 = var9.getPlane();
         int var3 = var9.getCmdLength() - 14;
         var2 = this.objConn.read(var9.toByteArray(), 0, var3);
         if (this.boolWaitVideoMode) {
            return false;
         } else {
            if (var2) {
               this.merge(var4, var9.toByteArray(), var6, true);

               for (int var5 = 0; var5 < this.objCCT.getCCTFieldCount(); var5++) {
                  if (var6 == this.objCCT.getCCTField()[var5].getBitCount() - 1) {
                     var7.setRect(var4);
                     var7.setBitMapInfo(this.objDIB[var5]);
                     var7.setFrameBuffer(this.byDIBBytes);
                     var7.setImage(this.bufferedImage);
                     var7.setLastField(var5 == this.objCCT.getCCTFieldCount() - 1);
                     if (var7.getRect().getRight() >= this.objTRRSPNewVideoModeData.getActualHSize()) {
                        var7.getRect().setRight((short)(this.objTRRSPNewVideoModeData.getActualHSize() - 1));
                     }

                     if (var7.getRect().getBottom() >= this.objTRRSPNewVideoModeData.getActualVSize()) {
                        var7.getRect().setBottom((short)(this.objTRRSPNewVideoModeData.getActualVSize() - 1));
                     }

                     if (this.boolProgressiveUpdate || var7.isLastField()) {
                        this.updateNotify(var7);
                     }

                     if (var7.isLastField()) {
                        this.updateCache(var7);
                     }
                     break;
                  }

                  if (var6 < this.objCCT.getCCTField()[var5].getBitCount()) {
                     break;
                  }

                  var6 -= this.objCCT.getCCTField()[var5].getBitCount();
               }
            }

            return var2;
         }
      } catch (Exception var11) {
         RRCLogger.logException(var11);
         return false;
      }
   }

   public boolean TRRSP_Packed(TRCOMMAND var1) {
      return false;
   }

   public boolean TRRSP_Video_Marker(TRCOMMAND var1) {
      try {
         short var2 = 0;
         boolean var3 = true;
         TRRSP_VIDEO_MARKER_DATA var4 = new TRRSP_VIDEO_MARKER_DATA(var1.toByteArray());
         var2 = var4.getCount();
         var4.setCommand((byte)48);
         var4.setCmdLength((short)7);
         var4.setCount(var2);
         return this.objConn.sendTRCmd(var1);
      } catch (Exception var5) {
         RRCLogger.logException(var5);
         return false;
      }
   }

   public boolean TRRSP_KB_Status(TRCOMMAND var1) {
      TRRSP_KB_STATUS_DATA var2 = new TRRSP_KB_STATUS_DATA(var1.toByteArray());
      this.setLEDState((var2.getStatus() & 16) != 0, (var2.getStatus() & 32) != 0, (var2.getStatus() & 64) != 0);
      this.setScanCodeSet((var2.getStatus() & 12) >> 2);
      this.setTargetType((var2.getStatus() & 3840) != 0);
      if (var2.getCount() != 0) {
         this.setScanCode3Data(var2.getData(), var2.getCount());
      }

      this.notify(1031, (var2.getStatus() & 112) >> 4);
      return true;
   }

   public boolean allocateDecompressionResources() {
      boolean var2 = false;
      this.boolSixteenBit = this.objCCT.getBitsPerPixel() > 8;
      this.byBitPlaneBuffer = new byte[131072];
      if (this.objCCT.getBitsPerPixel() == 12) {
         this.p16BitConvertTable = new short[4096];
         Arrays.fill(this.p16BitConvertTable, (short)0);

         for (int var3 = 0; var3 < 4096; var3++) {
            this.p16BitConvertTable[var3] = (short)(
               (var3 & 3840) << 3
                  | ((var3 & 256) != 0 ? 1024 : 0)
                  | (var3 & 240) << 2
                  | ((var3 & 16) != 0 ? 32 : 0)
                  | (var3 & 15) << 1
                  | ((var3 & 1) != 0 ? 1 : 0)
            );
         }
      }

      int var1 = this.objTRRSPNewVideoModeData.getLogicalHSize() * this.objTRRSPNewVideoModeData.getLogicalVSize();
      if (this.boolSixteenBit) {
         var1 *= 2;
      }

      this.byDIBBytes = new byte[var1];
      Arrays.fill(this.byDIBBytes, (byte)0);
      if (this.boolCacheEnabled) {
         this.byCache0 = new byte[var1];
         this.byCache1 = new byte[var1];
         this.byCache2 = new byte[var1];
      }

      if (this.buildDIBs()) {
         var2 = true;
      }

      return var2;
   }

   public void freeDecompressionResources() {
      this.byBitPlaneBuffer = null;
      this.byDIBBytes = null;
      this.byCache0 = null;
      this.byCache1 = null;
      this.byCache2 = null;
      this.p16BitConvertTable = null;

      for (int var1 = 0; var1 < this.objDIB.length; var1++) {
         this.objDIB[var1] = null;
      }
   }

   public boolean buildDIBs() {
      boolean var4 = false;
      int var2;
      if (this.objCCT.getBitsPerPixel() <= 8) {
         var2 = 1024;
      } else {
         var2 = 131072;
      }

      byte[] var3 = new byte[var2 * this.objCCT.getCCTFieldCount()];
      this.iPaletteTemp = new int[var2 * this.objCCT.getCCTFieldCount() / 4];
      BitMapInfo var5 = new BitMapInfo();
      var5.setColors(var3);
      if (var3 != null) {
         for (int var6 = 0; var6 < this.objCCT.getCCTFieldCount(); var6++) {
            this.objDIB[var6] = var5;
            this.objDIB[var6].getBMIHeader().setBISize(40);
            this.objDIB[var6].getBMIHeader().setBIWidth(1280);
            this.objDIB[var6].getBMIHeader().setBIHeight(-1024);
            this.objDIB[var6].getBMIHeader().setBIPlanes((short)1);
            if (this.objCCT.getBitsPerPixel() <= 8) {
               this.objDIB[var6].getBMIHeader().setBIBitCount((short)8);
            } else {
               this.objDIB[var6].getBMIHeader().setBIBitCount((short)16);
            }

            this.objDIB[var6].getBMIHeader().setBICompression(0);
            this.objDIB[var6].getBMIHeader().setBISizeImage(0);
            this.objDIB[var6].getBMIHeader().setBIXPelsPerMeter(3780);
            this.objDIB[var6].getBMIHeader().setBIYPelsPerMeter(3780);
            this.objDIB[var6].getBMIHeader().setBIClrUsed(this.objCCT.getColors());
            this.objDIB[var6].getBMIHeader().setBIClrImportant(0);
            if (this.objCCT.getBitsPerPixel() <= 8) {
               for (int var7 = 0; var7 < this.objCCT.getColors(); var7++) {
                  int var1 = this.objCCT.getRGBCode(var7).getCode() * 4;
                  var3[var1 + 0] = this.objCCT.getRGBCode(var7).getRGBTriple().getRGBTBlue();
                  var3[var1 + 1] = this.objCCT.getRGBCode(var7).getRGBTriple().getRGBTGreen();
                  var3[var1 + 2] = this.objCCT.getRGBCode(var7).getRGBTriple().getRGBTRed();
                  var3[var1 + 3] = 0;
               }

               int var13 = 0;

               for (int var8 = 0; var8 < this.iPaletteTemp.length; var8++) {
                  int var9 = var3[var13++] & 255;
                  int var10 = var3[var13++] & 255;
                  int var11 = var3[var13++] & 255;
                  int var12 = var3[var13++] & 255;
                  this.iPaletteTemp[var8] = ((var12 * 256 + var11) * 256 + var10) * 256 + var9 | 0xFF000000;
               }
            }
         }

         var4 = true;
      } else {
         this.objConn.dbNotify(1021, 44);
      }

      return var4;
   }

   public void merge(TRRECT var1, byte[] var2, int var3, boolean var4) {
      boolean var6 = false;
      boolean var7 = false;
      int var8 = 0;
      int var9 = 0;
      int var10 = 0;
      short var13 = var1.getLeft();
      short var14 = var1.getRight();
      short var15 = var1.getTop();
      short var16 = var1.getBottom();
      short var17 = this.objTRRSPNewVideoModeData.getLogicalHSize();
      byte var11 = (byte)(1 << var3);
      byte var12 = (byte)(~var11);
      if (!this.boolSixteenBit) {
         if (!var4) {
            for (int var32 = var15; var32 < var16 + 1; var32++) {
               var8 = var32 * var17 + var13;

               for (short var29 = var13; var29 < var14 + 1; var10++) {
                  byte var5 = var2[var10];
                  if ((var5 & 128) != 0) {
                     this.byDIBBytes[var8] = var11;
                     this.iPixelData[var8] = this.iPaletteTemp[this.byDIBBytes[var8] & 255];
                     var8++;
                  } else {
                     this.byDIBBytes[var8] = 0;
                     this.iPixelData[var8] = this.iPaletteTemp[this.byDIBBytes[var8] & 255];
                     var8++;
                  }

                  if ((var5 & 64) != 0) {
                     this.byDIBBytes[var8] = var11;
                     this.iPixelData[var8] = this.iPaletteTemp[this.byDIBBytes[var8] & 255];
                     var8++;
                  } else {
                     this.byDIBBytes[var8] = 0;
                     this.iPixelData[var8] = this.iPaletteTemp[this.byDIBBytes[var8] & 255];
                     var8++;
                  }

                  if ((var5 & 32) != 0) {
                     this.byDIBBytes[var8] = var11;
                     this.iPixelData[var8] = this.iPaletteTemp[this.byDIBBytes[var8] & 255];
                     var8++;
                  } else {
                     this.byDIBBytes[var8] = 0;
                     this.iPixelData[var8] = this.iPaletteTemp[this.byDIBBytes[var8] & 255];
                     var8++;
                  }

                  if ((var5 & 16) != 0) {
                     this.byDIBBytes[var8] = var11;
                     this.iPixelData[var8] = this.iPaletteTemp[this.byDIBBytes[var8] & 255];
                     var8++;
                  } else {
                     this.byDIBBytes[var8] = 0;
                     this.iPixelData[var8] = this.iPaletteTemp[this.byDIBBytes[var8] & 255];
                     var8++;
                  }

                  if ((var5 & 8) != 0) {
                     this.byDIBBytes[var8] = var11;
                     this.iPixelData[var8] = this.iPaletteTemp[this.byDIBBytes[var8] & 255];
                     var8++;
                  } else {
                     this.byDIBBytes[var8] = 0;
                     this.iPixelData[var8] = this.iPaletteTemp[this.byDIBBytes[var8] & 255];
                     var8++;
                  }

                  if ((var5 & 4) != 0) {
                     this.byDIBBytes[var8] = var11;
                     this.iPixelData[var8] = this.iPaletteTemp[this.byDIBBytes[var8] & 255];
                     var8++;
                  } else {
                     this.byDIBBytes[var8] = 0;
                     this.iPixelData[var8] = this.iPaletteTemp[this.byDIBBytes[var8] & 255];
                     var8++;
                  }

                  if ((var5 & 2) != 0) {
                     this.byDIBBytes[var8] = var11;
                     this.iPixelData[var8] = this.iPaletteTemp[this.byDIBBytes[var8] & 255];
                     var8++;
                  } else {
                     this.byDIBBytes[var8] = 0;
                     this.iPixelData[var8] = this.iPaletteTemp[this.byDIBBytes[var8] & 255];
                     var8++;
                  }

                  if ((var5 & 1) != 0) {
                     this.byDIBBytes[var8] = var11;
                     this.iPixelData[var8] = this.iPaletteTemp[this.byDIBBytes[var8] & 255];
                     var8++;
                  } else {
                     this.byDIBBytes[var8] = 0;
                     this.iPixelData[var8] = this.iPaletteTemp[this.byDIBBytes[var8] & 255];
                     var8++;
                  }

                  var29 += 8;
               }
            }
         } else {
            for (int var33 = var15; var33 < var16 + 1; var33++) {
               var8 = var33 * var17 + var13;

               for (short var30 = var13; var30 < var14 + 1; var10++) {
                  byte var27 = var2[var10];
                  if ((var27 & 128) != 0) {
                     this.byDIBBytes[var8] = (byte)(this.byDIBBytes[var8] | var11);
                     this.iPixelData[var8] = this.iPaletteTemp[this.byDIBBytes[var8] & 255];
                     var8++;
                  } else {
                     this.byDIBBytes[var8] = (byte)(this.byDIBBytes[var8] & var12);
                     this.iPixelData[var8] = this.iPaletteTemp[this.byDIBBytes[var8] & 255];
                     var8++;
                  }

                  if ((var27 & 64) != 0) {
                     this.byDIBBytes[var8] = (byte)(this.byDIBBytes[var8] | var11);
                     this.iPixelData[var8] = this.iPaletteTemp[this.byDIBBytes[var8] & 255];
                     var8++;
                  } else {
                     this.byDIBBytes[var8] = (byte)(this.byDIBBytes[var8] & var12);
                     this.iPixelData[var8] = this.iPaletteTemp[this.byDIBBytes[var8] & 255];
                     var8++;
                  }

                  if ((var27 & 32) != 0) {
                     this.byDIBBytes[var8] = (byte)(this.byDIBBytes[var8] | var11);
                     this.iPixelData[var8] = this.iPaletteTemp[this.byDIBBytes[var8] & 255];
                     var8++;
                  } else {
                     this.byDIBBytes[var8] = (byte)(this.byDIBBytes[var8] & var12);
                     this.iPixelData[var8] = this.iPaletteTemp[this.byDIBBytes[var8] & 255];
                     var8++;
                  }

                  if ((var27 & 16) != 0) {
                     this.byDIBBytes[var8] = (byte)(this.byDIBBytes[var8] | var11);
                     this.iPixelData[var8] = this.iPaletteTemp[this.byDIBBytes[var8] & 255];
                     var8++;
                  } else {
                     this.byDIBBytes[var8] = (byte)(this.byDIBBytes[var8] & var12);
                     this.iPixelData[var8] = this.iPaletteTemp[this.byDIBBytes[var8] & 255];
                     var8++;
                  }

                  if ((var27 & 8) != 0) {
                     this.byDIBBytes[var8] = (byte)(this.byDIBBytes[var8] | var11);
                     this.iPixelData[var8] = this.iPaletteTemp[this.byDIBBytes[var8] & 255];
                     var8++;
                  } else {
                     this.byDIBBytes[var8] = (byte)(this.byDIBBytes[var8] & var12);
                     this.iPixelData[var8] = this.iPaletteTemp[this.byDIBBytes[var8] & 255];
                     var8++;
                  }

                  if ((var27 & 4) != 0) {
                     this.byDIBBytes[var8] = (byte)(this.byDIBBytes[var8] | var11);
                     this.iPixelData[var8] = this.iPaletteTemp[this.byDIBBytes[var8] & 255];
                     var8++;
                  } else {
                     this.byDIBBytes[var8] = (byte)(this.byDIBBytes[var8] & var12);
                     this.iPixelData[var8] = this.iPaletteTemp[this.byDIBBytes[var8] & 255];
                     var8++;
                  }

                  if ((var27 & 2) != 0) {
                     this.byDIBBytes[var8] = (byte)(this.byDIBBytes[var8] | var11);
                     this.iPixelData[var8] = this.iPaletteTemp[this.byDIBBytes[var8] & 255];
                     var8++;
                  } else {
                     this.byDIBBytes[var8] = (byte)(this.byDIBBytes[var8] & var12);
                     this.iPixelData[var8] = this.iPaletteTemp[this.byDIBBytes[var8] & 255];
                     var8++;
                  }

                  if ((var27 & 1) != 0) {
                     this.byDIBBytes[var8] = (byte)(this.byDIBBytes[var8] | var11);
                     this.iPixelData[var8] = this.iPaletteTemp[this.byDIBBytes[var8] & 255];
                     var8++;
                  } else {
                     this.byDIBBytes[var8] = (byte)(this.byDIBBytes[var8] & var12);
                     this.iPixelData[var8] = this.iPaletteTemp[this.byDIBBytes[var8] & 255];
                     var8++;
                  }

                  var30 += 8;
               }
            }
         }
      } else {
         byte[] var23 = new byte[2];
         byte[] var24 = new byte[2];
         short var18 = this.pMaskMap[var3];
         short var19 = (short)(~var18);
         var23[1] = (byte)(var18 >>> 0 & 0xFF);
         var23[0] = (byte)(var18 >>> 8 & 0xFF);
         var24[1] = (byte)(var19 >>> 0 & 0xFF);
         var24[0] = (byte)(var19 >>> 8 & 0xFF);

         for (int var34 = var15; var34 <= var16; var34++) {
            var8 = 2 * (var34 * var17 + var13);

            for (short var31 = var13; var31 < var14 + 1; var10++) {
               var9 = var34 * var17 + var31;
               byte var28 = var2[var10];
               short var20 = (short)(var2[var10] & 255);
               if ((var20 & 128) != 0) {
                  this.byDIBBytes[var8] = (byte)(this.byDIBBytes[var8] | var23[1]);
                  this.byDIBBytes[++var8] = (byte)(this.byDIBBytes[var8] | var23[0]);
                  var8++;
               } else {
                  this.byDIBBytes[var8] = (byte)(this.byDIBBytes[var8] & var24[1]);
                  this.byDIBBytes[++var8] = (byte)(this.byDIBBytes[var8] & var24[0]);
                  var8++;
               }

               if ((var20 & 64) != 0) {
                  this.byDIBBytes[var8] = (byte)(this.byDIBBytes[var8] | var23[1]);
                  this.byDIBBytes[++var8] = (byte)(this.byDIBBytes[var8] | var23[0]);
                  var8++;
               } else {
                  this.byDIBBytes[var8] = (byte)(this.byDIBBytes[var8] & var24[1]);
                  this.byDIBBytes[++var8] = (byte)(this.byDIBBytes[var8] & var24[0]);
                  var8++;
               }

               if ((var20 & 32) != 0) {
                  this.byDIBBytes[var8] = (byte)(this.byDIBBytes[var8] | var23[1]);
                  this.byDIBBytes[++var8] = (byte)(this.byDIBBytes[var8] | var23[0]);
                  var8++;
               } else {
                  this.byDIBBytes[var8] = (byte)(this.byDIBBytes[var8] & var24[1]);
                  this.byDIBBytes[++var8] = (byte)(this.byDIBBytes[var8] & var24[0]);
                  var8++;
               }

               if ((var20 & 16) != 0) {
                  this.byDIBBytes[var8] = (byte)(this.byDIBBytes[var8] | var23[1]);
                  this.byDIBBytes[++var8] = (byte)(this.byDIBBytes[var8] | var23[0]);
                  var8++;
               } else {
                  this.byDIBBytes[var8] = (byte)(this.byDIBBytes[var8] & var24[1]);
                  this.byDIBBytes[++var8] = (byte)(this.byDIBBytes[var8] & var24[0]);
                  var8++;
               }

               if ((var20 & 8) != 0) {
                  this.byDIBBytes[var8] = (byte)(this.byDIBBytes[var8] | var23[1]);
                  this.byDIBBytes[++var8] = (byte)(this.byDIBBytes[var8] | var23[0]);
                  var8++;
               } else {
                  this.byDIBBytes[var8] = (byte)(this.byDIBBytes[var8] & var24[1]);
                  this.byDIBBytes[++var8] = (byte)(this.byDIBBytes[var8] & var24[0]);
                  var8++;
               }

               if ((var20 & 4) != 0) {
                  this.byDIBBytes[var8] = (byte)(this.byDIBBytes[var8] | var23[1]);
                  this.byDIBBytes[++var8] = (byte)(this.byDIBBytes[var8] | var23[0]);
                  var8++;
               } else {
                  this.byDIBBytes[var8] = (byte)(this.byDIBBytes[var8] & var24[1]);
                  this.byDIBBytes[++var8] = (byte)(this.byDIBBytes[var8] & var24[0]);
                  var8++;
               }

               if ((var20 & 2) != 0) {
                  this.byDIBBytes[var8] = (byte)(this.byDIBBytes[var8] | var23[1]);
                  this.byDIBBytes[++var8] = (byte)(this.byDIBBytes[var8] | var23[0]);
                  var8++;
               } else {
                  this.byDIBBytes[var8] = (byte)(this.byDIBBytes[var8] & var24[1]);
                  this.byDIBBytes[++var8] = (byte)(this.byDIBBytes[var8] & var24[0]);
                  var8++;
               }

               if ((var20 & 1) != 0) {
                  this.byDIBBytes[var8] = (byte)(this.byDIBBytes[var8] | var23[1]);
                  this.byDIBBytes[++var8] = (byte)(this.byDIBBytes[var8] | var23[0]);
                  var8++;
               } else {
                  this.byDIBBytes[var8] = (byte)(this.byDIBBytes[var8] & var24[1]);
                  this.byDIBBytes[++var8] = (byte)(this.byDIBBytes[var8] & var24[0]);
                  var8++;
               }

               int var25 = var8 - 16;

               for (int var26 = 0; var26 < 8; var26++) {
                  int var21 = (this.byDIBBytes[var25 + 1] & 255) * 256 + (this.byDIBBytes[var25] & 255);
                  int var22 = var21 << 16 & -65536;
                  this.iPixelData[var9++] = (var22 & this.iConst1) >>> this.Const4 << 16 & 0xFF0000
                     | (var22 & this.iConst2) >>> this.Const5 << 8 & 0xFF00
                     | (var22 & this.iConst3) >>> this.Const6 & 0xFF
                     | 0xFF000000;
                  var25 += 2;
               }

               var31 += 8;
            }
         }
      }
   }

   public void updateCache(TRLIB_UPDATEINFO var1) {
      TRRECT var15 = new TRRECT();
      boolean var16 = true;
      if (this.boolCacheEnabled) {
         int var4 = (this.objTRRSPNewVideoModeData.getLogicalHSize() + this.objTRRSPNewVideoModeData.getCellHSize() - 1)
            / this.objTRRSPNewVideoModeData.getCellHSize();
         int var5 = (this.objTRRSPNewVideoModeData.getLogicalVSize() + this.objTRRSPNewVideoModeData.getCellVSize() - 1)
            / this.objTRRSPNewVideoModeData.getCellVSize();
         short var17 = this.objTRRSPNewVideoModeData.getLogicalHSize();

         for (short var10 = var1.getRect().getTop(); var10 <= var1.getRect().getBottom(); var10 += this.objTRRSPNewVideoModeData.getCellVSize()) {
            for (short var9 = var1.getRect().getLeft(); var9 <= var1.getRect().getRight(); var9 += this.objTRRSPNewVideoModeData.getCellHSize()) {
               int var3 = var10 / this.objTRRSPNewVideoModeData.getCellVSize();
               int var2 = var9 / this.objTRRSPNewVideoModeData.getCellHSize();
               Cell var18 = this.objCellInfo[var3 * var4 + var2];
               short var8 = var18.getCacheHead();
               var18.setCacheHead((short)(var8 + 1));
               if (var18.getCacheHead() == 3) {
                  var18.setCacheHead((short)0);
               }

               byte[] var14;
               if (var8 == 0) {
                  var14 = this.byCache0;
               } else if (var8 == 1) {
                  var14 = this.byCache1;
               } else {
                  var14 = this.byCache2;
               }

               var15.setLeft((short)(var2 * this.objTRRSPNewVideoModeData.getCellHSize()));
               var15.setRight((short)(var15.getLeft() + this.objTRRSPNewVideoModeData.getCellHSize() - 1));
               var15.setTop((short)(var3 * this.objTRRSPNewVideoModeData.getCellVSize()));
               var15.setBottom((short)(var15.getTop() + this.objTRRSPNewVideoModeData.getCellVSize() - 1));

               for (int var7 = var15.getTop(); var7 <= var15.getBottom(); var7++) {
                  int var11 = var7 * var17 + var15.getLeft();
                  int var12 = var7 * var17 + var15.getLeft();

                  for (int var6 = var15.getLeft(); var6 <= var15.getRight(); var6++) {
                     var14[var12++] = this.byDIBBytes[var11++];
                  }
               }

               if (var8 == 0) {
                  this.byCache0 = var14;
               } else if (var8 == 1) {
                  this.byCache1 = var14;
               } else {
                  this.byCache2 = var14;
               }
            }
         }
      }
   }

   public byte getDeviceID() {
      return this.byDeviceID;
   }

   @Override
   public void notify(int var1, int var2) {
      if (RRCLogger.logEnabled) {
         RRCLogger.log(200, 2, "NOTIFY  Event=" + var1 + " Param=" + var2);
      }
   }

   @Override
   public void updateNotify(TRLIB_UPDATEINFO var1) {
   }

   @Override
   public void newVideoModeNotify(TRRSP_NEW_VIDEO_MODE_DATA var1) {
      if (RRCLogger.logEnabled) {
         RRCLogger.log(200, 2, "newVideoModeNotify=" + var1);
      }
   }

   public void setNext(TRVideoStream var1) {
      this.objVSNext = var1;
   }

   public TRVideoStream getNext() {
      return this.objVSNext;
   }

   private int Endian(int var1) {
      return var1 << 24 | (var1 & 0xFF00) << 8 | (var1 & 0xFF0000) >> 8 | var1 >> 24;
   }

   public static void main(String[] var0) {
      TRLIB_COMM var1 = new TRLIB_COMM();
      TRLIB_USERINFO var2 = new TRLIB_USERINFO();
      TRLIB_REFERRAL_COMM var3 = new TRLIB_REFERRAL_COMM();
      new TRSRVR_SERIAL_PARAMS();
      boolean var5 = false;
      TRSRVR_COMP_PARAMS var6 = new TRSRVR_COMP_PARAMS();
      int[] var7 = new int[]{0, 0, 0};
      var6.setFlags(56);
      var6.setCCT((short)10);
      var6.setCacheDepth((short)0);
      var6.setCompressMode(0);
      var6.setSpeed(0);
      var6.setMinFrameTime(0);
      var6.setMaxFrameTime(0);
      var6.setSmoothing(6);
      var6.setReserved(var7);
      TRSRVR_VIDEO_PARAMS var8 = new TRSRVR_VIDEO_PARAMS();
      new TRSRVR_VIDEO_PARAMS();
      int[] var10 = new int[]{0, 0, 0};
      byte[] var11 = new byte[]{0, 0, 0};
      var8.setAdType(0);
      var8.setSettings(1023);
      var8.setFlags(1241188);
      var8.setAutoSense(0);
      var8.setNoiseFilter(4);
      var8.setRedGain(128);
      var8.setRedOffset(32);
      var8.setGreenGain(128);
      var8.setGreenOffset(32);
      var8.setBlueGain(128);
      var8.setBlueOffset(32);
      var8.setPllDivider(1343);
      var8.setPllOffset(20);
      var8.setVoltage(8237536);
      var8.setCurrent(1240484);
      var8.setReserved1(var10);
      var8.setReserved2(var11);
      TRRSP_RECEIVE_SERIAL_DATA var12 = new TRRSP_RECEIVE_SERIAL_DATA();
      byte var13 = 0;
      byte var14 = 0;
      var12.setFlags(var13);
      var12.setDeviceID((byte)var14);
      Object var15 = null;

      try {
         var15 = InetAddress.getByName("10.0.0.240");
         var1.setIpAddress(var15.hashCode());
         var1.setConnType(2);
         var1.setServerName("IP Reach".getBytes());
         var1.setDnsName("IP Reach".getBytes());
         var1.setIpPort(5000);
         var1.setFindBy(0);
         var2.setName("admin".getBytes());
         var2.setPassword(Constants.DEFAULT_PASSWORD.getBytes());
         var3.setVersion(1);
         TRConnection var16 = new TRConnection();
         boolean var18 = var16.connect(var1, var2, null, null);

         while (!var16.getAuthenticated()) {
            Thread.sleep(100L);
         }

         TRVideoStream var17 = new TRVideoStream(var16, 0);
         var18 = var17.connectVideoStream("//*[@id=FG0]", "//*[@id=S0T1]", var6, 0);
         Thread.sleep(500L);
         System.out.print("\n--------------------------------" + var18);
         var18 = var17.stopVideoStream();
         System.out.print("\nDisconnect Connection");
         System.out.println("--------------------------------");
         var16.disConnect();
         System.out.println("**************+Disconnect Successful **********");
      } catch (Exception var19) {
      }
   }

   public boolean TRRSP_Compressed(TRCOMMAND var1) throws RRCGeneralException {
      try {
         throw new RRCGeneralException("TRRSP_Compressed: JBIG Compression NOT Supported in this release.");
      } catch (RRCGeneralException var3) {
         RRCLogger.logException(var3);
         throw var3;
      }
   }

   public static void saveToFile(int[] var0, String var1) {
      try {
         FileOutputStream var2 = new FileOutputStream(var1);
         byte[] var3 = new byte[var0.length * 4];
         int var4 = 0;

         for (int var5 = 0; var5 < var0.length; var5++) {
            var3[var4 + 3] = (byte)(var0[var5] >>> 0 & 0xFF);
            var3[var4 + 2] = (byte)(var0[var5] >>> 8 & 0xFF);
            var3[var4 + 1] = (byte)(var0[var5] >>> 16 & 0xFF);
            var3[var4 + 0] = (byte)(var0[var5] >>> 24 & 0xFF);
            var4++;
         }

         var2.write(var3);
         var2.close();
      } catch (Exception var6) {
      }
   }

   public static void saveToFile(byte[] var0, String var1) {
      try {
         FileOutputStream var2 = new FileOutputStream(var1);
         var2.write(var0);
         var2.close();
      } catch (Exception var3) {
      }
   }

   public static void saveToFile(byte[] var0, int var1, int var2, String var3) {
      try {
         FileOutputStream var4 = new FileOutputStream(var3);
         var4.write(var0, var1, var2);
         var4.close();
      } catch (Exception var5) {
      }
   }

   @Override
   public boolean setKeyState(short var1, boolean var2, boolean var3) {
      return this.keyboard.setKeyState(var1, var2, var3);
   }

   @Override
   public boolean getKeyState(short var1) {
      return this.keyboard.getKeyState(var1);
   }

   @Override
   public boolean releaseAllPressedKeys() {
      return this.keyboard.releaseAllPressedKeys();
   }

   @Override
   public boolean releaseKeyIfPressed(short var1) {
      return this.keyboard.releaseKeyIfPressed(var1);
   }

   @Override
   public boolean toogleKeyState(short var1) {
      return this.keyboard.toogleKeyState(var1);
   }

   @Override
   public boolean outputKeyData(byte[] var1, int var2, int var3) {
      return this.keyboard.outputKeyData(var1, var2, var3);
   }

   @Override
   public boolean flushKeyData() {
      return this.keyboard.flushKeyData();
   }

   @Override
   public void setLEDState(boolean var1, boolean var2, boolean var3) {
      this.keyboard.setLEDState(var1, var2, var3);
   }

   @Override
   public boolean getScrollLockStatus() {
      return this.keyboard.getScrollLockStatus();
   }

   @Override
   public boolean getNumLockStatus() {
      return this.keyboard.getNumLockStatus();
   }

   @Override
   public boolean getCapsLockStatus() {
      return this.keyboard.getCapsLockStatus();
   }

   @Override
   public void setScanCode3Data(byte[] var1, int var2) {
      this.keyboard.setScanCode3Data(var1, var2);
   }

   @Override
   public void setScanCodeSet(int var1) {
      this.keyboard.setScanCodeSet(var1);
   }

   @Override
   public void setTargetType(boolean var1) {
      this.keyboard.setTargetType(var1);
   }

   @Override
   public boolean isTargetType() {
      return this.keyboard.isTargetType();
   }
}
