package javaclientlib.common.org.lzo;

public class Adler32 {
   private static final int BASE = 65521;
   private static final int NMAX = 2775;
   private int s1 = 1;
   private int s2 = 0;

   public void reset() {
      this.s1 = 1;
      this.s2 = 0;
   }

   public long getValue() {
      return (long)this.s2 << 16 | this.s1;
   }

   public void update(int var1) {
      this.s1 += var1 & 0xFF;
      this.s2 = this.s2 + this.s1;
      this.s1 %= 65521;
      this.s2 %= 65521;
   }

   public void update(byte[] var1, int var2, int var3) {
      while (var3 > 0) {
         int var4 = var3 < 2775 ? var3 : 2775;

         for (var3 -= var4; var4 >= 16; var4 -= 16) {
            this.s1 = this.s1 + (var1[var2++] & 255);
            this.s2 = this.s2 + this.s1;
            this.s1 = this.s1 + (var1[var2++] & 255);
            this.s2 = this.s2 + this.s1;
            this.s1 = this.s1 + (var1[var2++] & 255);
            this.s2 = this.s2 + this.s1;
            this.s1 = this.s1 + (var1[var2++] & 255);
            this.s2 = this.s2 + this.s1;
            this.s1 = this.s1 + (var1[var2++] & 255);
            this.s2 = this.s2 + this.s1;
            this.s1 = this.s1 + (var1[var2++] & 255);
            this.s2 = this.s2 + this.s1;
            this.s1 = this.s1 + (var1[var2++] & 255);
            this.s2 = this.s2 + this.s1;
            this.s1 = this.s1 + (var1[var2++] & 255);
            this.s2 = this.s2 + this.s1;
            this.s1 = this.s1 + (var1[var2++] & 255);
            this.s2 = this.s2 + this.s1;
            this.s1 = this.s1 + (var1[var2++] & 255);
            this.s2 = this.s2 + this.s1;
            this.s1 = this.s1 + (var1[var2++] & 255);
            this.s2 = this.s2 + this.s1;
            this.s1 = this.s1 + (var1[var2++] & 255);
            this.s2 = this.s2 + this.s1;
            this.s1 = this.s1 + (var1[var2++] & 255);
            this.s2 = this.s2 + this.s1;
            this.s1 = this.s1 + (var1[var2++] & 255);
            this.s2 = this.s2 + this.s1;
            this.s1 = this.s1 + (var1[var2++] & 255);
            this.s2 = this.s2 + this.s1;
            this.s1 = this.s1 + (var1[var2++] & 255);
            this.s2 = this.s2 + this.s1;
         }

         if (var4 != 0) {
            do {
               this.s1 = this.s1 + (var1[var2++] & 255);
               this.s2 = this.s2 + this.s1;
            } while (--var4 > 0);
         }

         this.s1 %= 65521;
         this.s2 %= 65521;
      }
   }

   public void update(byte[] var1) {
      this.update(var1, 0, var1.length);
   }
}
