package javaclientlib.common.org.lzo;

import java.io.EOFException;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;

public class Util implements Constants {
   private Util() {
   }

   public static int memcmp(byte[] var0, int var1, byte[] var2, int var3, int var4) {
      while (var4-- > 0) {
         if (var0[var1] != var2[var3]) {
            return (var0[var1] & 0xFF) - (var2[var3] & 0xFF);
         }

         var1++;
         var3++;
      }

      return 0;
   }

   public static int memcmp(byte[] var0, byte[] var1, int var2) {
      return memcmp(var0, 0, var1, 0, var2);
   }

   public static int xread(InputStream var0, byte[] var1, int var2, int var3, boolean var4) throws IOException {
      int var5 = 0;
      int var6 = var3;

      while (var6 > 0) {
         int var7 = var0.read(var1, var2 + var5, var6);
         if (var7 == -1) {
            break;
         }

         if (var7 < 0) {
            throw new IOException();
         }

         var5 += var7;
         var6 -= var7;
      }

      if (var5 != var3 && !var4) {
         throw new EOFException("read error - premature end of file");
      } else {
         return var5;
      }
   }

   public static int xread(InputStream var0, byte[] var1, int var2, int var3) throws IOException {
      return xread(var0, var1, var2, var3, true);
   }

   public static int xwrite(OutputStream var0, byte[] var1, int var2, int var3) throws IOException {
      if (var0 != null) {
         var0.write(var1, var2, var3);
      }

      return var3;
   }

   public static int xread32(InputStream var0) throws IOException {
      byte[] var1 = new byte[4];
      xread(var0, var1, 0, 4, false);
      int var2 = (var1[3] & 255) << 0;
      var2 |= (var1[2] & 255) << 8;
      var2 |= (var1[1] & 255) << 16;
      return var2 | (var1[0] & 0xFF) << 24;
   }

   public static void xwrite32(OutputStream var0, int var1) throws IOException {
      byte[] var2 = new byte[]{(byte)(var1 >>> 24), (byte)(var1 >>> 16), (byte)(var1 >>> 8), (byte)(var1 >>> 0)};
      xwrite(var0, var2, 0, 4);
   }

   public static int xgetc(InputStream var0) throws IOException {
      byte[] var1 = new byte[1];
      xread(var0, var1, 0, 1, false);
      return var1[0] & 0xFF;
   }

   public static void xputc(OutputStream var0, int var1) throws IOException {
      byte[] var2 = new byte[]{(byte)(var1 & 0xFF)};
      xwrite(var0, var2, 0, 1);
   }
}
