package javaclientlib.tr;

public class TRBASECOMMAND {
   private byte[] byData;

   public TRBASECOMMAND() {
      if (this.byData == null) {
         this.byData = new byte[4108];
      }
   }

   protected TRBASECOMMAND(short var1) {
      if (this.byData == null) {
         this.byData = new byte[var1];
      }
   }

   protected TRBASECOMMAND(int var1) {
      if (this.byData == null) {
         this.byData = new byte[var1];
      }
   }

   public TRBASECOMMAND(byte[] var1) {
      this.byData = var1;
   }

   public byte[] toByteArray() {
      return this.byData;
   }

   public void fromByteArray(byte[] var1) {
      this.byData = var1;
   }

   public void setBoolean(boolean var1, int var2) {
      this.byData[var2] = (byte)(var1 ? 1 : 0);
   }

   public boolean getBoolean(int var1) {
      return this.byData[var1] == 1;
   }

   public void setByte(byte var1, int var2) {
      this.byData[var2] = var1;
   }

   public byte getByte(int var1) {
      return this.byData[var1];
   }

   public void setShort(short var1, int var2) {
      this.byData[var2 + 1] = (byte)(var1 >>> 0 & 0xFF);
      this.byData[var2 + 0] = (byte)(var1 >>> 8 & 0xFF);
   }

   public short getShort(int var1) {
      int var2 = (this.byData[var1 + 0] & 255) >> 0;
      int var3 = (this.byData[var1 + 1] & 255) >> 0;
      return (short)((var2 << 8) + (var3 << 0));
   }

   public int getUShort(int var1) {
      int var2 = (this.byData[var1 + 0] & 255) >> 0;
      int var3 = (this.byData[var1 + 1] & 255) >> 0;
      return (var2 << 8) + (var3 << 0);
   }

   public void setInt(int var1, int var2) {
      this.byData[var2 + 3] = (byte)(var1 >>> 0 & 0xFF);
      this.byData[var2 + 2] = (byte)(var1 >>> 8 & 0xFF);
      this.byData[var2 + 1] = (byte)(var1 >>> 16 & 0xFF);
      this.byData[var2 + 0] = (byte)(var1 >>> 24 & 0xFF);
   }

   public int getInt(int var1) {
      int var2 = (this.byData[var1 + 0] & 255) >> 0;
      int var3 = (this.byData[var1 + 1] & 255) >> 0;
      int var4 = (this.byData[var1 + 2] & 255) >> 0;
      int var5 = (this.byData[var1 + 3] & 255) >> 0;
      return (var2 << 24) + (var3 << 16) + (var4 << 8) + (var5 << 0);
   }

   public void setBytes(byte[] var1, int var2) {
      System.arraycopy(var1, 0, this.byData, var2, var1.length);
   }

   public byte[] getBytes(int var1, int var2) {
      byte[] var3 = new byte[var2];
      System.arraycopy(this.byData, var1, var3, 0, var3.length);
      return var3;
   }

   public int[] getIntArray(int var1, int var2) {
      int[] var3 = new int[var2];

      for (int var4 = 0; var4 < var3.length; var4++) {
         var3[var4] = this.getInt(var1);
         var1 += 4;
      }

      return var3;
   }
}
