package javaclientlib.tr;

import java.io.DataInput;
import java.io.DataOutput;
import java.lang.reflect.Array;
import java.lang.reflect.Method;

public class TRDATASTRUCTURE_DEF {
   protected static final int debug = 0;
   protected static final int TYPE_Unknown = 0;
   protected static final int TYPE_BOOLEAN = 1;
   protected static final int TYPE_BYTE = 2;
   protected static final int TYPE_CHAR = 3;
   protected static final int TYPE_SHORT = 4;
   protected static final int TYPE_INT = 5;
   protected static final int TYPE_LONG = 6;
   protected static final int TYPE_FLOAT = 7;
   protected static final int TYPE_DOUBLE = 8;
   protected static final int TYPE_STRUCT = 9;
   protected static final int TYPE_ARRAY = 16;
   protected Class structType;
   protected TRDATASTRUCTURE_DEF.Property[] properties;

   public TRDATASTRUCTURE_DEF(Class var1, String[] var2, Class[] var3, int[] var4) {
      try {
         log("Init( " + var1.getName() + " )");
         this.properties = new TRDATASTRUCTURE_DEF.Property[var2.length];
         this.structType = var1;
         Method[] var5 = this.structType.getDeclaredMethods();

         for (int var6 = 0; var6 < this.properties.length; var6++) {
            String var7 = "get" + var2[var6];
            String var8 = null;
            if (boolean.class.equals(var3[var6])) {
               var8 = "is" + var2[var6];
            }

            String var9 = "set" + var2[var6];
            Method var10 = null;
            Method var11 = null;

            for (int var12 = 0; var12 < var5.length; var12++) {
               Method var13 = var5[var12];
               if (var10 == null && var7.equalsIgnoreCase(var13.getName())) {
                  if (var13.getParameterTypes().length == 0 && isCompatibleTypes(var4[var6] != 0, var3[var6], var13.getReturnType())) {
                     var10 = var13;
                     if (var11 != null) {
                        break;
                     }
                  }
               } else if (var10 == null && var8 != null && var8.equalsIgnoreCase(var13.getName())) {
                  if (var13.getParameterTypes().length == 0 && isCompatibleTypes(var4[var6] != 0, var3[var6], var13.getReturnType())) {
                     var10 = var13;
                     if (var11 != null) {
                        break;
                     }
                  }
               } else if (var11 == null
                  && var9.equalsIgnoreCase(var13.getName())
                  && var13.getParameterTypes().length == 1
                  && isCompatibleTypes(var4[var6] != 0, var3[var6], var13.getParameterTypes()[0])) {
                  var11 = var13;
                  if (var10 != null) {
                     break;
                  }
               }
            }

            if (var10 == null || var11 == null) {
               System.err
                  .println(
                     "TRDATASTRUCTURE("
                        + this.structType.getName()
                        + ")."
                        + var2[var6]
                        + "["
                        + var4[var6]
                        + "]"
                        + " Fatal Error! getter="
                        + var10
                        + " setter="
                        + var11
                  );
               throw new NullPointerException();
            }

            this.properties[var6] = new TRDATASTRUCTURE_DEF.Property(var2[var6], var3[var6], var4[var6], var10, var11);
         }
      } catch (Exception var14) {
         var14.printStackTrace(System.err);
      }
   }

   protected static int getTypeCode(Class var0) {
      byte var1 = 0;
      if (var0.isArray()) {
         var1 = 16;
         var0 = var0.getComponentType();
      }

      if (boolean.class.equals(var0)) {
         return var1 | 1;
      } else if (byte.class.equals(var0)) {
         return var1 | 2;
      } else if (char.class.equals(var0)) {
         return var1 | 3;
      } else if (short.class.equals(var0)) {
         return var1 | 4;
      } else if (int.class.equals(var0)) {
         return var1 | 5;
      } else if (long.class.equals(var0)) {
         return var1 | 6;
      } else if (float.class.equals(var0)) {
         return var1 | 7;
      } else if (double.class.equals(var0)) {
         return var1 | 8;
      } else {
         return TRDATASTRUCTURE.class.isAssignableFrom(var0) ? var1 | 9 : 0;
      }
   }

   protected static boolean isCompatibleTypes(boolean var0, Class var1, Class var2) {
      int var3 = getTypeCode(var1);
      if (var3 == 0) {
         return false;
      } else {
         if (var0) {
            var3 |= 16;
         }

         int var4 = getTypeCode(var2);
         if (var3 != var4) {
            return false;
         } else if (var3 == 9) {
            return var1.equals(var2);
         } else if (var4 == 25) {
            var2 = var2.getComponentType();
            return var1.equals(var2);
         } else {
            return true;
         }
      }
   }

   public int read(TRDATASTRUCTURE var1, DataInput var2) throws Exception {
      int var3 = 0;
      Object[] var4 = new Object[1];
      Object var5 = null;

      for (int var6 = 0; var6 < this.properties.length; var6++) {
         TRDATASTRUCTURE_DEF.Property var7 = this.properties[var6];
         int var8 = 0;
         if ((var7.typeCode & 16) != 0) {
            var4[0] = null;
            if (var7.len > 0) {
               var8 = var7.len;
            } else {
               var4[0] = var7.getter.invoke(var1, null);
               var8 = Array.getLength(var4[0]);
            }
         }

         switch (var7.typeCode) {
            case 1:
               var4[0] = new Boolean(var2.readBoolean());
               var3++;
               break;
            case 2:
               var4[0] = new Byte(var2.readByte());
               var3++;
               break;
            case 3:
               var4[0] = new Character(var2.readChar());
               var3 += 2;
               break;
            case 4:
               var4[0] = new Short(var2.readShort());
               var3 += 2;
               break;
            case 5:
               var4[0] = new Integer(var2.readInt());
               var3 += 4;
               break;
            case 6:
               var4[0] = new Long(var2.readLong());
               var3 += 8;
               break;
            case 7:
               var4[0] = new Float(var2.readFloat());
               var3 += 4;
               break;
            case 8:
               var4[0] = new Double(var2.readDouble());
               var3 += 8;
               break;
            case 9:
               var5 = (TRDATASTRUCTURE)var7.type.newInstance();
               var3 += ((TRDATASTRUCTURE)var5).getDefinition().read((TRDATASTRUCTURE)var5, var2);
               log("read_nested( " + var7.type.getName() + " )");
               var4[0] = var5;
            case 10:
            case 11:
            case 12:
            case 13:
            case 14:
            case 15:
            case 16:
            default:
               break;
            case 17:
               if (var4[0] == null) {
                  var4[0] = new boolean[var8];
               }

               for (int var19 = 0; var19 < var8; var19++) {
                  ((boolean[])var4[0])[var19] = var2.readBoolean();
               }

               var3 += var8;
               break;
            case 18:
               if (var4[0] == null) {
                  var4[0] = new byte[var8];
               }

               for (int var18 = 0; var18 < var8; var18++) {
                  ((byte[])var4[0])[var18] = var2.readByte();
               }

               var3 += var8;
               break;
            case 19:
               if (var4[0] == null) {
                  var4[0] = new char[var8];
               }

               for (int var17 = 0; var17 < var8; var17++) {
                  ((char[])var4[0])[var17] = var2.readChar();
               }

               var3 += var8 * 2;
               break;
            case 20:
               if (var4[0] == null) {
                  var4[0] = new short[var8];
               }

               for (int var16 = 0; var16 < var8; var16++) {
                  ((short[])var4[0])[var16] = var2.readShort();
               }

               var3 += var8 * 2;
               break;
            case 21:
               if (var4[0] == null) {
                  var4[0] = new int[var8];
               }

               for (int var15 = 0; var15 < var8; var15++) {
                  ((int[])var4[0])[var15] = var2.readInt();
               }

               var3 += var8 * 4;
               break;
            case 22:
               if (var4[0] == null) {
                  var4[0] = new long[var8];
               }

               for (int var14 = 0; var14 < var8; var14++) {
                  ((long[])var4[0])[var14] = var2.readLong();
               }

               var3 += var8 * 8;
               break;
            case 23:
               if (var4[0] == null) {
                  var4[0] = new float[var8];
               }

               for (int var13 = 0; var13 < var8; var13++) {
                  ((float[])var4[0])[var13] = var2.readFloat();
               }

               var3 += var8 * 4;
               break;
            case 24:
               if (var4[0] == null) {
                  var4[0] = new double[var8];
               }

               for (int var12 = 0; var12 < var8; var12++) {
                  ((double[])var4[0])[var12] = var2.readDouble();
               }

               var3 += var8 * 8;
               break;
            case 25:
               log("read nested array begin!");
               if (var4[0] == null) {
                  var4[0] = Array.newInstance(var7.type, var8);
               }

               for (int var9 = 0; var9 < var8; var9++) {
                  var5 = (TRDATASTRUCTURE)var7.type.newInstance();
                  var3 += ((TRDATASTRUCTURE)var5).getDefinition().read((TRDATASTRUCTURE)var5, var2);
                  Array.set(var4[0], var9, var5);
                  log("read_nested( " + var7.type.getName() + "[" + var9 + "] )");
               }

               log("read nested array end!");
         }

         var7.setter.invoke(var1, var4);
      }

      return var3;
   }

   public int write(TRDATASTRUCTURE var1, DataOutput var2) throws Exception {
      int var3 = 0;
      Object var4 = null;
      Object var5 = null;

      for (int var6 = 0; var6 < this.properties.length; var6++) {
         TRDATASTRUCTURE_DEF.Property var7 = this.properties[var6];
         var4 = var7.getter.invoke(var1, null);
         int var8 = 0;
         if ((var7.typeCode & 16) != 0) {
            if (var7.len > 0) {
               var8 = var7.len;
            } else {
               var8 = Array.getLength(var4);
            }
         }

         switch (var7.typeCode) {
            case 1:
               var2.writeBoolean((Boolean)var4);
               var3++;
               break;
            case 2:
               var2.writeByte((Byte)var4);
               var3++;
               break;
            case 3:
               var2.writeChar((Character)var4);
               var3 += 2;
               break;
            case 4:
               var2.writeShort((Short)var4);
               var3 += 2;
               break;
            case 5:
               var2.writeInt((Integer)var4);
               var3 += 4;
               break;
            case 6:
               var2.writeLong((Long)var4);
               var3 += 8;
               break;
            case 7:
               var2.writeFloat((Float)var4);
               var3 += 4;
               break;
            case 8:
               var2.writeDouble((Double)var4);
               var3 += 8;
               break;
            case 9:
               var3 += ((TRDATASTRUCTURE)var4).getDefinition().write((TRDATASTRUCTURE)var4, var2);
            case 10:
            case 11:
            case 12:
            case 13:
            case 14:
            case 15:
            case 16:
            default:
               break;
            case 17:
               for (int var19 = 0; var19 < var8; var19++) {
                  var2.writeBoolean(Array.getBoolean(var4, var19));
               }

               var3 += var8;
               break;
            case 18:
               for (int var18 = 0; var18 < var8; var18++) {
                  var2.writeByte(Array.getByte(var4, var18));
               }

               var3 += var8;
               break;
            case 19:
               for (int var17 = 0; var17 < var8; var17++) {
                  var2.writeChar(Array.getChar(var4, var17));
               }

               var3 += var8 * 2;
               break;
            case 20:
               for (int var16 = 0; var16 < var8; var16++) {
                  var2.writeShort(Array.getShort(var4, var16));
               }

               var3 += var8 * 2;
               break;
            case 21:
               for (int var15 = 0; var15 < var8; var15++) {
                  var2.writeInt(Array.getInt(var4, var15));
               }

               var3 += var8 * 4;
               break;
            case 22:
               for (int var14 = 0; var14 < var8; var14++) {
                  var2.writeLong(Array.getLong(var4, var14));
               }

               var3 += var8 * 8;
               break;
            case 23:
               for (int var13 = 0; var13 < var8; var13++) {
                  var2.writeFloat(Array.getFloat(var4, var13));
               }

               var3 += var8 * 4;
               break;
            case 24:
               for (int var12 = 0; var12 < var8; var12++) {
                  var2.writeDouble(Array.getDouble(var4, var12));
               }

               var3 += var8 * 8;
               break;
            case 25:
               for (int var9 = 0; var9 < var8; var9++) {
                  var5 = (TRDATASTRUCTURE)Array.get(var4, var9);
                  var3 += ((TRDATASTRUCTURE)var5).getDefinition().write((TRDATASTRUCTURE)var5, var2);
               }
         }
      }

      return var3;
   }

   public int getLength(TRDATASTRUCTURE var1) throws Exception {
      int var2 = 0;
      Object var3 = null;
      Object var4 = null;

      for (int var5 = 0; var5 < this.properties.length; var5++) {
         TRDATASTRUCTURE_DEF.Property var6 = this.properties[var5];
         int var7 = 0;
         if ((var6.typeCode & 16) != 0) {
            if (var6.len > 0) {
               var7 = var6.len;
            } else {
               var3 = var6.getter.invoke(var1, null);
               var7 = Array.getLength(var3);
            }
         }

         switch (var6.typeCode) {
            case 1:
               var2++;
               break;
            case 2:
               var2++;
               break;
            case 3:
               var2 += 2;
               break;
            case 4:
               var2 += 2;
               break;
            case 5:
               var2 += 4;
               break;
            case 6:
               var2 += 8;
               break;
            case 7:
               var2 += 4;
               break;
            case 8:
               var2 += 8;
               break;
            case 9:
               var3 = var6.getter.invoke(var1, null);
               var2 += ((TRDATASTRUCTURE)var3).getDefinition().getLength((TRDATASTRUCTURE)var3);
            case 10:
            case 11:
            case 12:
            case 13:
            case 14:
            case 15:
            case 16:
            default:
               break;
            case 17:
               var2 += var7;
               break;
            case 18:
               var2 += var7;
               break;
            case 19:
               var2 += var7 * 2;
               break;
            case 20:
               var2 += var7 * 2;
               break;
            case 21:
               var2 += var7 * 4;
               break;
            case 22:
               var2 += var7 * 8;
               break;
            case 23:
               var2 += var7 * 4;
               break;
            case 24:
               var2 += var7 * 8;
               break;
            case 25:
               if (var3 == null) {
                  var3 = var6.getter.invoke(var1, null);
               }

               for (int var8 = 0; var8 < var7; var8++) {
                  var4 = (TRDATASTRUCTURE)Array.get(var3, var8);
                  var2 += ((TRDATASTRUCTURE)var4).getDefinition().getLength((TRDATASTRUCTURE)var4);
               }
         }
      }

      return var2;
   }

   protected static final void log(Object var0) {
   }

   protected class Property {
      protected String name;
      protected Class type;
      protected int typeCode;
      protected int len;
      protected Method getter;
      protected Method setter;

      protected Property(String var2, Class var3, int var4, Method var5, Method var6) {
         this.name = var2;
         this.type = var3;
         this.typeCode = TRDATASTRUCTURE_DEF.getTypeCode(var3);
         if (var4 != 0) {
            this.typeCode |= 16;
         }

         this.len = var4;
         this.getter = var5;
         this.setter = var6;
      }
   }
}
