package javaclientlib.tr;

import java.net.InetAddress;

public class TRLIB_COMM extends TRDATASTRUCTURE {
   protected static final TRDATASTRUCTURE_DEF definition = new TRDATASTRUCTURE_DEF(
      TRLIB_COMM.class,
      new String[]{"findBy", "ipAddress", "serverName", "dnsName", "ipPort"},
      new Class[]{int.class, long.class, byte.class, byte.class, int.class},
      new int[]{0, 0, 16, 255, 0}
   );
   private int size;
   private int connType;
   private int findBy;
   private long ipAddress;
   private byte[] serverName = new byte[16];
   private byte[] dnsName = new byte[255];
   private int ipPort;
   private byte[] deviceName = new byte[255];
   private byte[] phoneNumber = new byte[255];
   private byte[] privateKey = new byte[24];
   private InetAddress inetAddress;
   public static final short CMD_LEN = 825;

   @Override
   public TRDATASTRUCTURE_DEF getDefinition() {
      return definition;
   }

   public static String long2IPString(long var0) {
      StringBuffer var2 = new StringBuffer();
      var2.append(var0 >> 24 & 255L);
      var2.append('.');
      var2.append(var0 >> 16 & 255L);
      var2.append('.');
      var2.append(var0 >> 8 & 255L);
      var2.append('.');
      var2.append(var0 & 255L);
      return var2.toString();
   }

   @Override
   public short getLength() {
      return 825;
   }

   public int getSize() {
      return this.size;
   }

   public void setSize(int var1) {
      this.size = var1;
   }

   public int getConnType() {
      return this.connType;
   }

   public void setConnType(int var1) {
      this.connType = var1;
   }

   public int getFindBy() {
      return this.findBy;
   }

   public void setFindBy(int var1) {
      this.findBy = var1;
   }

   public long getIpAddress() {
      return this.ipAddress;
   }

   public void setIpAddress(long var1) {
      this.ipAddress = var1;
   }

   public void setIpAddress(int var1) {
      this.ipAddress = var1;
      if (this.inetAddress == null) {
         try {
            InetAddress var2 = InetAddress.getByName(long2IPString(var1));
            this.setInetAddress(var2);
         } catch (Exception var3) {
         }
      }
   }

   public byte[] getServerName() {
      return this.serverName;
   }

   public void setServerName(byte[] var1) {
      this.serverName = var1;
   }

   public byte[] getDnsName() {
      return this.dnsName;
   }

   public void setDnsName(byte[] var1) {
      this.dnsName = var1;
   }

   public int getIpPort() {
      return this.ipPort;
   }

   public void setIpPort(int var1) {
      this.ipPort = var1;
   }

   public byte[] getDeviceName() {
      return this.deviceName;
   }

   public void setDeviceName(byte[] var1) {
      this.deviceName = var1;
   }

   public byte[] getPhoneNumber() {
      return this.phoneNumber;
   }

   public void setPhoneNumber(byte[] var1) {
      this.phoneNumber = var1;
   }

   public byte[] getPrivateKey() {
      return this.privateKey;
   }

   public void setPrivateKey(byte[] var1) {
      this.privateKey = var1;
   }

   @Override
   public String toString() {
      StringBuffer var1 = new StringBuffer();
      var1.append("\n\t TRLIB_COMM ---------");
      var1.append("\nserverName =" + new String(this.serverName));
      var1.append("\ndnsName =" + new String(this.dnsName));
      var1.append("\ndeviceName=" + new String(this.deviceName));
      var1.append("\nphoneNumber=" + new String(this.phoneNumber));
      var1.append("\nprivateKey=" + new String(this.privateKey));
      var1.append("\nfindBy=" + this.findBy);
      var1.append(
         "\nipAddr= "
            + (this.ipAddress >> 24 & 255L)
            + "."
            + (this.ipAddress >> 16 & 255L)
            + "."
            + (this.ipAddress >> 8 & 255L)
            + "."
            + (this.ipAddress & 255L)
      );
      var1.append("\nipAddress(i)=" + this.ipAddress);
      var1.append("\ninetAddress=" + this.inetAddress);
      var1.append("\nipPort =" + this.ipPort);
      return var1.toString();
   }

   public InetAddress getInetAddress() {
      return this.inetAddress;
   }

   public void setInetAddress(InetAddress var1) {
      this.inetAddress = var1;
   }
}
