package javaclientlib.tr;

public class TRLIB_REFERRAL_COMM extends TRDATASTRUCTURE {
   protected static final TRDATASTRUCTURE_DEF definition = new TRDATASTRUCTURE_DEF(
      TRLIB_REFERRAL_COMM.class,
      new String[]{"version", "sessionID", "sessionKey", "connectionID"},
      new Class[]{int.class, byte.class, byte.class, byte.class},
      new int[]{0, 16, 64, 128}
   );
   int version;
   byte[] sessionID = new byte[16];
   byte[] sessionKey = new byte[64];
   byte[] connectionID = new byte[128];
   private static final int TRLIB_MAX_ID = 16;
   private static final int TRLIB_MAX_KEY_BASE64 = 64;
   private static final int TRLIB_MAX_CONN_ID = 128;
   public static final short CMD_LEN = 52;

   @Override
   public TRDATASTRUCTURE_DEF getDefinition() {
      return definition;
   }

   @Override
   public short getLength() {
      return 52;
   }

   public int getVersion() {
      return this.version;
   }

   public void setVersion(int var1) {
      this.version = var1;
   }

   public byte[] getSessionID() {
      return this.sessionID;
   }

   public void setSessionID(byte[] var1) {
      this.sessionID = var1;
   }

   public byte[] getSessionKey() {
      return this.sessionKey;
   }

   public void setSessionKey(byte[] var1) {
      this.sessionKey = var1;
   }

   public byte[] getConnectionID() {
      return this.connectionID;
   }

   public void setConnectionID(byte[] var1) {
      this.connectionID = var1;
   }

   @Override
   public String toString() {
      StringBuffer var1 = new StringBuffer();
      var1.append("\n\t TRLIB_REFERRAL_COMM ---------");
      var1.append("\nversion =" + this.getVersion());
      var1.append("\nsessionID =" + new String(this.getSessionID()));
      var1.append("\nsessionKey=" + new String(this.getSessionKey()));
      var1.append("\nconnectionID=" + new String(this.getConnectionID()));
      return var1.toString();
   }
}
