package javaclientlib.tr;

public class TRRECT extends TRDATASTRUCTURE {
   protected static final TRDATASTRUCTURE_DEF definition = new TRDATASTRUCTURE_DEF(
      TRRECT.class, new String[]{"left", "top", "right", "bottom"}, new Class[]{short.class, short.class, short.class, short.class}, new int[]{0, 0, 0, 0}
   );
   private short left;
   private short top;
   private short right;
   private short bottom;
   static final short CMD_LEN = 8;

   @Override
   public TRDATASTRUCTURE_DEF getDefinition() {
      return definition;
   }

   public TRRECT() {
   }

   public TRRECT(byte[] var1) {
      int var2 = (var1[0] & 255) >> 0;
      int var3 = (var1[1] & 255) >> 0;
      this.left = (short)((var2 << 8) + (var3 << 0));
      var2 = (var1[2] & 255) >> 0;
      var3 = (var1[3] & 255) >> 0;
      this.top = (short)((var2 << 8) + (var3 << 0));
      var2 = (var1[4] & 255) >> 0;
      var3 = (var1[5] & 255) >> 0;
      this.right = (short)((var2 << 8) + (var3 << 0));
      var2 = (var1[6] & 255) >> 0;
      var3 = (var1[7] & 255) >> 0;
      this.bottom = (short)((var2 << 8) + (var3 << 0));
   }

   @Override
   public short getLength() {
      return 8;
   }

   public short getLeft() {
      return this.left;
   }

   public void setLeft(short var1) {
      this.left = var1;
   }

   public short getTop() {
      return this.top;
   }

   public void setTop(short var1) {
      this.top = var1;
   }

   public short getRight() {
      return this.right;
   }

   public void setRight(short var1) {
      this.right = var1;
   }

   public short getBottom() {
      return this.bottom;
   }

   public void setBottom(short var1) {
      this.bottom = var1;
   }

   @Override
   public String toString() {
      try {
         StringBuffer var1 = new StringBuffer();
         var1.append("\nleft=" + this.getLeft());
         var1.append("\ntop=" + this.getTop());
         var1.append("\nright=" + this.getRight());
         var1.append("\nbottom=" + this.getBottom());
         return var1.toString();
      } catch (Exception var2) {
         var2.printStackTrace();
         return var2.getMessage();
      }
   }
}
