package javaclientlib.tr;

public class TRSRVR_SERVER_ID extends TRDATASTRUCTURE {
   protected static final TRDATASTRUCTURE_DEF definition = new TRDATASTRUCTURE_DEF(
      TRSRVR_SERVER_ID.class,
      new String[]{
         "cbSize",
         "serverName",
         "ipAddress",
         "port",
         "protocolVersion",
         "oldestProtocolVersion",
         "hwVersion",
         "post",
         "netFlags",
         "securityFlags",
         "options",
         "frameGrabberInfo",
         "kvmInfo",
         "serialInfo",
         "numVideoDevices",
         "numSerialDevices",
         "reserved",
         "swVersion"
      },
      new Class[]{
         int.class,
         byte.class,
         int.class,
         short.class,
         short.class,
         short.class,
         short.class,
         int.class,
         int.class,
         int.class,
         int.class,
         int.class,
         int.class,
         int.class,
         int.class,
         int.class,
         int.class,
         short.class
      },
      new int[]{0, 16, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0}
   );
   private int cbSize;
   private byte[] serverName = new byte[16];
   private int ipAddress;
   private short port;
   private short protocolVersion;
   private short oldestProtocolVersion;
   private short hwVersion;
   private int post;
   private int netFlags;
   private int securityFlags;
   private int options;
   private int frameGrabberInfo;
   private int kvmInfo;
   private int serialInfo;
   private int numVideoDevices;
   private int numSerialDevices;
   private int reserved;
   private short swVersion;
   public static final short CMD_LEN = 74;

   @Override
   public TRDATASTRUCTURE_DEF getDefinition() {
      return definition;
   }

   public TRSRVR_SERVER_ID() {
   }

   public TRSRVR_SERVER_ID(byte[] var1, boolean var2) {
      this();
      int var3 = 0;
      if (var2) {
         this.cbSize = this.getBigInt(var1, var3, 4);
      } else {
         this.cbSize = this.getSmallInt(var1, var3, 4);
      }

      var3 += 4;

      for (int var4 = 0; var4 < 16; var4++) {
         this.serverName[var4] = var1[var3 + var4];
      }

      var3 += 16;
      if (var2) {
         this.ipAddress = this.getBigInt(var1, var3, 4);
         this.port = (short)this.getBigInt(var1, var3 + 4, 2);
         this.protocolVersion = (short)this.getBigInt(var1, var3 + 6, 2);
         this.oldestProtocolVersion = (short)this.getBigInt(var1, var3 + 8, 2);
         this.hwVersion = (short)this.getBigInt(var1, var3 + 10, 2);
         this.post = this.getBigInt(var1, var3 + 12, 4);
         this.netFlags = this.getBigInt(var1, var3 + 16, 4);
         this.securityFlags = this.getBigInt(var1, var3 + 20, 4);
         this.options = this.getBigInt(var1, var3 + 24, 4);
         this.frameGrabberInfo = this.getBigInt(var1, var3 + 28, 4);
         this.kvmInfo = this.getBigInt(var1, var3 + 32, 4);
         this.serialInfo = this.getBigInt(var1, var3 + 36, 4);
         this.numVideoDevices = this.getBigInt(var1, var3 + 40, 4);
         this.numSerialDevices = this.getBigInt(var1, var3 + 44, 4);
         this.reserved = this.getBigInt(var1, var3 + 48, 4);
         this.swVersion = (short)this.getBigInt(var1, var3 + 52, 2);
      } else {
         this.ipAddress = this.getSmallInt(var1, var3, 4);
         this.port = (short)this.getSmallInt(var1, var3 + 4, 2);
         this.protocolVersion = (short)this.getSmallInt(var1, var3 + 6, 2);
         this.oldestProtocolVersion = (short)this.getSmallInt(var1, var3 + 8, 2);
         this.hwVersion = (short)this.getSmallInt(var1, var3 + 10, 2);
         this.post = this.getSmallInt(var1, var3 + 12, 4);
         this.netFlags = this.getSmallInt(var1, var3 + 16, 4);
         this.securityFlags = this.getSmallInt(var1, var3 + 20, 4);
         this.options = this.getSmallInt(var1, var3 + 24, 4);
         this.frameGrabberInfo = this.getSmallInt(var1, var3 + 28, 4);
         this.kvmInfo = this.getSmallInt(var1, var3 + 32, 4);
         this.serialInfo = this.getSmallInt(var1, var3 + 36, 4);
         this.numVideoDevices = this.getSmallInt(var1, var3 + 40, 4);
         this.numSerialDevices = this.getSmallInt(var1, var3 + 44, 4);
         this.reserved = this.getSmallInt(var1, var3 + 48, 4);
         this.swVersion = (short)this.getSmallInt(var1, var3 + 52, 2);
      }
   }

   private int getBigInt(byte[] var1, int var2, int var3) {
      if (var3 == 2) {
         return ((var1[var2 + 1] & 0xFF) << 8) + ((var1[var2 + 0] & 0xFF) << 0);
      } else {
         return var3 == 4
            ? ((var1[var2 + 3] & 0xFF) << 24) + ((var1[var2 + 2] & 0xFF) << 16) + ((var1[var2 + 1] & 0xFF) << 8) + ((var1[var2 + 0] & 0xFF) << 0)
            : 0;
      }
   }

   private int getSmallInt(byte[] var1, int var2, int var3) {
      if (var3 == 2) {
         return ((var1[var2 + 0] & 0xFF) << 8) + ((var1[var2 + 1] & 0xFF) << 0);
      } else {
         return var3 == 4
            ? ((var1[var2 + 0] & 0xFF) << 24) + ((var1[var2 + 1] & 0xFF) << 16) + ((var1[var2 + 2] & 0xFF) << 8) + ((var1[var2 + 3] & 0xFF) << 0)
            : 0;
      }
   }

   @Override
   public short getLength() {
      return 74;
   }

   @Override
   public String toString() {
      StringBuffer var1 = new StringBuffer();
      var1.append("\ncbSize=" + this.getCbSize() + "\n");
      var1.append("serverName=" + this.getServerNameString() + "\n");
      var1.append("ipAddress=" + this.getIpAddress() + "\n");
      var1.append("port=" + this.getPort() + "\n");
      var1.append("protocolVersion=" + this.getProtocolVersion() + "\n");
      var1.append("oldestProtocolVersion=" + this.getOldestProtocolVersion() + "\n");
      var1.append("hwVersion=" + this.getHwVersion() + "\n");
      var1.append("post=" + this.getPost() + "\n");
      var1.append("netFlags=" + this.getNetFlags() + "\n");
      var1.append("securityFlags=" + this.getSecurityFlags() + "\n");
      var1.append("options=" + this.getOptions() + "\n");
      var1.append("frameGrabberInfo=" + this.getFrameGrabberInfo() + "\n");
      var1.append("kvmInfo=" + this.getKvmInfo() + "\n");
      var1.append("serialInfo=" + this.getSerialInfo() + "\n");
      var1.append("numVideoDevices=" + this.getNumVideoDevices() + "\n");
      var1.append("numSerialDevices=" + this.getNumSerialDevices() + "\n");
      var1.append("reserved=" + this.getReserved() + "\n");
      var1.append("swVersion=" + this.getSwVersion() + "\n");
      return var1.toString();
   }

   public void setTRSRVR_SERVER_ID(TRSRVR_SERVER_ID var1) {
      this.cbSize = var1.getCbSize();
      this.serverName = var1.getServerName();
      this.ipAddress = var1.getIpAddress();
      this.port = var1.getPort();
      this.protocolVersion = var1.getProtocolVersion();
      this.oldestProtocolVersion = var1.getOldestProtocolVersion();
      this.hwVersion = var1.getHwVersion();
      this.post = var1.getPost();
      this.netFlags = var1.getNetFlags();
      this.securityFlags = var1.getSecurityFlags();
      this.options = var1.getOptions();
      this.frameGrabberInfo = var1.getFrameGrabberInfo();
      this.kvmInfo = var1.getKvmInfo();
      this.serialInfo = var1.getSerialInfo();
      this.numVideoDevices = var1.getNumVideoDevices();
      this.numSerialDevices = var1.getNumSerialDevices();
      this.reserved = var1.getReserved();
      this.swVersion = var1.getSwVersion();
   }

   public int getCbSize() {
      return this.cbSize;
   }

   public void setCbSize(int var1) {
      this.cbSize = var1;
   }

   public byte[] getServerName() {
      return this.serverName;
   }

   public String getServerNameString() {
      StringBuffer var1 = new StringBuffer(16);

      for (int var2 = 0; var2 < 16 && this.serverName[var2] != 0; var2++) {
         var1.append((char)this.serverName[var2]);
      }

      return new String(var1);
   }

   public void setServerName(byte[] var1) {
      this.serverName = var1;
   }

   public int getIpAddress() {
      return this.ipAddress;
   }

   public void setIpAddress(int var1) {
      this.ipAddress = var1;
   }

   public short getPort() {
      return this.port;
   }

   public void setPort(short var1) {
      this.port = var1;
   }

   public short getProtocolVersion() {
      return this.protocolVersion;
   }

   public void setProtocolVersion(short var1) {
      this.protocolVersion = var1;
   }

   public short getOldestProtocolVersion() {
      return this.oldestProtocolVersion;
   }

   public void setOldestProtocolVersion(short var1) {
      this.oldestProtocolVersion = var1;
   }

   public short getHwVersion() {
      return this.hwVersion;
   }

   public void setHwVersion(short var1) {
      this.hwVersion = var1;
   }

   public int getPost() {
      return this.post;
   }

   public void setPost(int var1) {
      this.post = var1;
   }

   public int getNetFlags() {
      return this.netFlags;
   }

   public void setNetFlags(int var1) {
      this.netFlags = var1;
   }

   public int getSecurityFlags() {
      return this.securityFlags;
   }

   public void setSecurityFlags(int var1) {
      this.securityFlags = var1;
   }

   public int getOptions() {
      return this.options;
   }

   public void setOptions(int var1) {
      this.options = var1;
   }

   public int getFrameGrabberInfo() {
      return this.frameGrabberInfo;
   }

   public void setFrameGrabberInfo(int var1) {
      this.frameGrabberInfo = var1;
   }

   public int getKvmInfo() {
      return this.kvmInfo;
   }

   public void setKvmInfo(int var1) {
      this.kvmInfo = var1;
   }

   public int getSerialInfo() {
      return this.serialInfo;
   }

   public void setSerialInfo(int var1) {
      this.serialInfo = var1;
   }

   public int getNumVideoDevices() {
      return this.numVideoDevices;
   }

   public void setNumVideoDevices(int var1) {
      this.numVideoDevices = var1;
   }

   public int getNumSerialDevices() {
      return this.numSerialDevices;
   }

   public void setNumSerialDevices(int var1) {
      this.numSerialDevices = var1;
   }

   public int getReserved() {
      return this.reserved;
   }

   public void setReserved(int var1) {
      this.reserved = var1;
   }

   public short getSwVersion() {
      return this.swVersion;
   }

   public void setSwVersion(short var1) {
      this.swVersion = var1;
   }
}
