package javaclientlib.tr;

public class TRSRVR_VIDEO_PARAMS extends TRDATASTRUCTURE {
   protected static final TRDATASTRUCTURE_DEF definition = new TRDATASTRUCTURE_DEF(
      TRSRVR_VIDEO_PARAMS.class,
      new String[]{
         "adType",
         "settings",
         "flags",
         "autoSense",
         "noiseFilter",
         "redGain",
         "redOffset",
         "greenGain",
         "greenOffset",
         "blueGain",
         "blueOffset",
         "pllDivider",
         "pllOffset",
         "voltage",
         "current",
         "brightness",
         "reserved1",
         "AGCGain",
         "reserved2"
      },
      new Class[]{
         int.class,
         int.class,
         int.class,
         int.class,
         int.class,
         int.class,
         int.class,
         int.class,
         int.class,
         int.class,
         int.class,
         int.class,
         int.class,
         int.class,
         int.class,
         int.class,
         int.class,
         byte.class,
         byte.class
      },
      new int[]{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 4, 0, 3}
   );
   private int adType;
   private int settings;
   private int flags;
   private int autoSense;
   private int noiseFilter;
   private int redGain;
   private int redOffset;
   private int greenGain;
   private int greenOffset;
   private int blueGain;
   private int blueOffset;
   private int pllDivider;
   private int pllOffset;
   private int voltage;
   private int current;
   private int brightness;
   private byte agcGain;
   private int[] reserved1 = new int[3];
   private byte[] reserved2 = new byte[3];
   private int vOffSet;
   private int hOffSet;
   private boolean autoMaticColorCalibrate;
   static final short CMD_LEN = 84;

   @Override
   public TRDATASTRUCTURE_DEF getDefinition() {
      return definition;
   }

   @Override
   public short getLength() {
      return 84;
   }

   public void setVideoParams(TRSRVR_VIDEO_PARAMS var1) {
      this.adType = var1.getAdType();
      this.settings = var1.getSettings();
      this.flags = var1.getFlags();
      this.autoSense = var1.getAutoSense();
      this.noiseFilter = var1.getNoiseFilter();
      this.redGain = var1.getRedGain();
      this.redOffset = var1.getRedOffset();
      this.greenGain = var1.getGreenGain();
      this.greenOffset = var1.getGreenOffset();
      this.blueGain = var1.getBlueGain();
      this.blueOffset = var1.getBlueOffset();
      this.pllDivider = var1.getPllDivider();
      this.pllOffset = var1.getPllOffset();
      this.voltage = var1.getVoltage();
      this.current = var1.getCurrent();
      this.brightness = var1.getBrightness();
      this.agcGain = var1.getAGCGain();
      this.reserved1 = var1.getReserved1();
      this.reserved2 = var1.getReserved2();
      this.vOffSet = var1.getVOffSet();
      this.hOffSet = var1.getHOffSet();
   }

   public int getAdType() {
      return this.adType;
   }

   public void setAdType(int var1) {
      this.adType = var1;
   }

   public int getSettings() {
      return this.settings;
   }

   public void setSettings(int var1) {
      this.settings = var1;
   }

   public int getFlags() {
      return this.flags;
   }

   public void setFlags(int var1) {
      this.flags = var1;
   }

   public int getAutoSense() {
      return this.autoSense;
   }

   public void setAutoSense(int var1) {
      this.autoSense = var1;
   }

   public int getNoiseFilter() {
      return this.noiseFilter;
   }

   public void setNoiseFilter(int var1) {
      this.noiseFilter = var1;
   }

   public int getBrightness() {
      return this.brightness;
   }

   public void setBrightness(int var1) {
      this.brightness = var1;
   }

   public byte getAGCGain() {
      return this.agcGain;
   }

   public void setAGCGain(byte var1) {
      this.agcGain = var1;
   }

   public int getRedGain() {
      return this.redGain;
   }

   public void setRedGain(int var1) {
      this.redGain = var1;
   }

   public int getRedOffset() {
      return this.redOffset;
   }

   public void setRedOffset(int var1) {
      this.redOffset = var1;
   }

   public int getGreenGain() {
      return this.greenGain;
   }

   public void setGreenGain(int var1) {
      this.greenGain = var1;
   }

   public int getGreenOffset() {
      return this.greenOffset;
   }

   public void setGreenOffset(int var1) {
      this.greenOffset = var1;
   }

   public int getBlueGain() {
      return this.blueGain;
   }

   public void setBlueGain(int var1) {
      this.blueGain = var1;
   }

   public int getBlueOffset() {
      return this.blueOffset;
   }

   public void setBlueOffset(int var1) {
      this.blueOffset = var1;
   }

   public int getPllDivider() {
      return this.pllDivider;
   }

   public void setPllDivider(int var1) {
      this.pllDivider = var1;
   }

   public int getPllOffset() {
      return this.pllOffset;
   }

   public void setPllOffset(int var1) {
      this.pllOffset = var1;
   }

   public int getVoltage() {
      return this.voltage;
   }

   public void setVoltage(int var1) {
      this.voltage = var1;
   }

   public int getCurrent() {
      return this.current;
   }

   public void setCurrent(int var1) {
      this.current = var1;
   }

   public int[] getReserved1() {
      return this.reserved1;
   }

   public byte[] getReserved2() {
      return this.reserved2;
   }

   public void setReserved1(int[] var1) {
      this.reserved1 = var1;
   }

   public void setReserved2(byte[] var1) {
      this.reserved2 = var1;
   }

   public void setReserved1(int var1, int var2) {
      this.reserved1[var1] = var2;
   }

   public void setReserved2(int var1, byte var2) {
      this.reserved2[var1] = var2;
   }

   public int getReserved1(int var1) {
      return this.reserved1[var1];
   }

   public byte getReserved(int var1) {
      return this.reserved2[var1];
   }

   public int getHOffSet() {
      return this.hOffSet;
   }

   public void setHOffSet(int var1) {
      this.hOffSet = var1;
   }

   public int getVOffSet() {
      return this.vOffSet;
   }

   public void setVOffSet(int var1) {
      this.vOffSet = var1;
   }

   public boolean isAutomaticColorCalibrate() {
      return this.autoMaticColorCalibrate;
   }

   public void setAutoMaticColorCalibrate(boolean var1) {
      this.autoMaticColorCalibrate = var1;
   }
}
