package javaclientlib.utils;

import java.awt.Image;
import java.awt.image.BufferedImage;
import java.awt.image.DataBufferInt;
import java.io.FileOutputStream;
import javaclientlib.tr.BitMapInfoHeader;

public class BMP {
   BufferedImage bufferedimage = null;
   DataBufferInt dbi = null;
   int[] iPixelData = null;
   int iConst1 = 31744;
   int iConst2 = 992;
   int iConst3 = 31;
   int Const4 = -1;
   int Const5 = -1;
   int Const6 = -1;

   public void setVideoMode(int var1, int var2) {
      this.bufferedimage = new BufferedImage(var1, var2, 2);
      this.dbi = (DataBufferInt)this.bufferedimage.getRaster().getDataBuffer();
      this.iPixelData = this.dbi.getData();
   }

   public Image getImage(BitMapInfoHeader var1, byte[] var2, byte[] var3) {
      if (var1.getBIHeight() < 0) {
         var1.setBIHeight(-1 * var1.getBIHeight());
      }

      if (var3 != null) {
         return var1.getBIBitCount() > 8
            ? this.unpack16(var3, var1.getBIWidth(), var1.getBIHeight())
            : this.unpack08(var3, var2, var1.getBIBitCount(), var1.getBIWidth(), var1.getBIHeight());
      } else {
         return null;
      }
   }

   Image unpack16(byte[] var1, int var2, int var3) {
      byte var4 = 0;
      if (this.Const4 == -1) {
         this.iConst1 = 2080374784;
         this.Const4 = 0;

         while ((this.iConst1 >>> this.Const4 & -256) != 0) {
            this.Const4++;
         }
      }

      if (this.Const5 == -1) {
         this.iConst2 = 65011712;
         this.Const5 = 0;

         while ((this.iConst2 >>> this.Const5 & -256) != 0) {
            this.Const5++;
         }
      }

      if (this.Const6 == -1) {
         this.iConst3 = 2031616;
         this.Const6 = 0;

         while ((this.iConst3 >>> this.Const6 & -256) != 0) {
            this.Const6++;
         }
      }

      for (int var5 = 0; var5 < var3; var5++) {
         for (int var6 = 0; var6 < var2; var6++) {
            int var7 = (var1[var4 + 1] & 255) * 256 + (var1[var4] & 255);
            var4 += 2;
            int var8 = var7 << 16 & -65536;
            this.iPixelData[var5 * var2 + var6] = (var8 & this.iConst1) >>> this.Const4 << 16 & 0xFF0000
               | (var8 & this.iConst2) >>> this.Const5 << 8 & 0xFF00
               | (var8 & this.iConst3) >>> this.Const6 & 0xFF
               | 0xFF000000;
         }
      }

      return this.bufferedimage;
   }

   Image unpack08(byte[] var1, byte[] var2, short var3, int var4, int var5) {
      int[] var6 = new int[var2.length / 4];
      int var7 = 0;

      for (int var8 = 0; var8 < var6.length; var8++) {
         byte var9 = var2[var7++];
         byte var10 = var2[var7++];
         byte var11 = var2[var7++];
         byte var12 = var2[var7++];
         var6[var8] = ((var12 * 256 + var11) * 256 + var10) * 256 + var9 | 0xFF000000;
      }

      int var16 = 0;
      int var17 = 4 - var4 % 4;
      if (var17 == 4) {
         boolean var18 = false;
      }

      for (int var19 = 0; var19 < var5; var19++) {
         for (int var20 = 0; var20 < var4; var20++) {
            this.iPixelData[var19 * var4 + var20] = var6[var1[var16++] & 255];
         }
      }

      return this.bufferedimage;
   }

   private void log(String var1) {
      RRCLogger.log(300, 512, "BMP::" + var1);
   }

   public static void saveToFile(int[] var0, String var1) {
      try {
         FileOutputStream var2 = new FileOutputStream(var1);
         byte[] var3 = new byte[var0.length * 4];
         int var4 = 0;

         for (int var5 = 0; var5 < var0.length; var5++) {
            var3[var4 + 3] = (byte)(var0[var5] >>> 0 & 0xFF);
            var3[var4 + 2] = (byte)(var0[var5] >>> 8 & 0xFF);
            var3[var4 + 1] = (byte)(var0[var5] >>> 16 & 0xFF);
            var3[var4 + 0] = (byte)(var0[var5] >>> 24 & 0xFF);
            var4++;
         }

         var2.write(var3);
         var2.close();
      } catch (Exception var6) {
         var6.printStackTrace();
      }
   }

   public static void saveToFile(byte[] var0, String var1) {
      try {
         FileOutputStream var2 = new FileOutputStream(var1);
         var2.write(var0);
         var2.close();
      } catch (Exception var3) {
         var3.printStackTrace();
      }
   }
}
