package javaclientlib.utils;

import java.io.DataInput;
import java.io.EOFException;
import java.io.FilterInputStream;
import java.io.IOException;
import java.io.InputStream;

public class BigEndianInputStream extends FilterInputStream implements DataInput {
   private char[] lineBuffer;

   public BigEndianInputStream(InputStream var1) {
      super(var1);
   }

   @Override
   public final int readInt() throws IOException {
      InputStream var1 = this.in;
      int var2 = var1.read();
      int var3 = var1.read();
      int var4 = var1.read();
      int var5 = var1.read();
      if ((var2 | var3 | var4 | var5) < 0) {
         throw new EOFException();
      } else {
         return (var5 << 24) + (var4 << 16) + (var3 << 8) + (var2 << 0);
      }
   }

   @Override
   public final short readShort() throws IOException {
      InputStream var1 = this.in;
      int var2 = var1.read();
      int var3 = var1.read();
      if ((var2 | var3) < 0) {
         throw new EOFException();
      } else {
         return (short)((var3 << 8) + (var2 << 0));
      }
   }

   @Override
   public final char readChar() throws IOException {
      InputStream var1 = this.in;
      int var2 = var1.read();
      int var3 = var1.read();
      if ((var2 | var3) < 0) {
         throw new EOFException();
      } else {
         return (char)((var3 << 8) + (var2 << 0));
      }
   }

   @Override
   public final long readLong() throws IOException {
      InputStream var1 = this.in;
      long var2 = this.readInt();
      int var4 = this.readInt();
      return ((long)var4 << 32) + (var2 & 4294967295L);
   }

   @Override
   public final float readFloat() throws IOException {
      return Float.intBitsToFloat(this.readInt());
   }

   @Override
   public final double readDouble() throws IOException {
      return Double.longBitsToDouble(this.readLong());
   }

   @Override
   public final void readFully(byte[] var1) throws IOException {
   }

   @Override
   public final void readFully(byte[] var1, int var2, int var3) throws IOException {
   }

   @Override
   public final int skipBytes(int var1) throws IOException {
      return 0;
   }

   @Override
   public final boolean readBoolean() throws IOException {
      int var1 = this.in.read();
      if (var1 < 0) {
         throw new EOFException();
      } else {
         return var1 != 0;
      }
   }

   @Override
   public final byte readByte() throws IOException {
      int var1 = this.in.read();
      if (var1 < 0) {
         throw new EOFException();
      } else {
         return (byte)var1;
      }
   }

   @Override
   public final int readUnsignedByte() throws IOException {
      return 0;
   }

   @Override
   public final int readUnsignedShort() throws IOException {
      return 0;
   }

   @Override
   public final String readLine() throws IOException {
      return null;
   }

   @Override
   public final String readUTF() throws IOException {
      return null;
   }

   public static final String readUTF(DataInput var0) throws IOException {
      return null;
   }
}
