package javaclientlib.utils;

public class RC4Cipher {
   public int keySize;
   private int[] state = new int[256];
   private int x;
   private int y;

   public RC4Cipher(byte[] var1) {
      this.keySize = 256;
      this.setKey(var1);
   }

   public void setKey(byte[] var1) {
      for (int var4 = 0; var4 < 256; var4++) {
         this.state[var4] = (byte)var4;
      }

      this.x = 0;
      this.y = 0;
      int var2 = 0;
      int var3 = 0;

      for (int var6 = 0; var6 < 256; var6++) {
         var3 = var1[var2] + this.state[var6] + var3 & 0xFF;
         int var5 = this.state[var6];
         this.state[var6] = this.state[var3];
         this.state[var3] = var5;
         var2 = (var2 + 1) % var1.length;
      }
   }

   public final byte encrypt(byte var1) {
      return (byte)(var1 ^ this.state[this.nextState()]);
   }

   public final byte decrypt(byte var1) {
      return (byte)(var1 ^ this.state[this.nextState()]);
   }

   public final void encrypt(byte[] var1, int var2, byte[] var3, int var4, int var5) {
      while (var5-- > 0) {
         this.x = this.x + 1 & 0xFF;
         int var6 = this.state[this.x];
         this.y = this.y + var6 & 0xFF;
         int var7 = this.state[this.y];
         this.state[this.x] = var7;
         this.state[this.y] = var6;
         var3[var4++] = (byte)(var1[var2++] ^ this.state[var6 + var7 & 0xFF]);
      }
   }

   public final void decrypt(byte[] var1, int var2, byte[] var3, int var4, int var5) {
      while (var5-- > 0) {
         this.x = this.x + 1 & 0xFF;
         int var6 = this.state[this.x];
         this.y = this.y + var6 & 0xFF;
         int var7 = this.state[this.y];
         this.state[this.x] = var7;
         this.state[this.y] = var6;
         var3[var4++] = (byte)(var1[var2++] ^ this.state[var6 + var7 & 0xFF]);
      }
   }

   private final int nextState() {
      this.x = this.x + 1 & 0xFF;
      this.y = this.y + this.state[this.x] & 0xFF;
      int var1 = this.state[this.x];
      int var2 = this.state[this.y];
      this.state[this.x] = var2;
      this.state[this.y] = var1;
      return var1 + var2 & 0xFF;
   }

   public static void main(String[] var0) {
      byte[] var1 = new byte[]{120, -65, -57, -57, -24, 36, -29, -29, 48, 10, 25, -21, 19, -65, -37, -58};
      byte[] var2 = new byte[]{-26, 0, -71, 8, 0, -17, 39, -1, 114, -115, 78, 87, -31, 123};
      byte[] var3 = new byte[var2.length];
      new RC4Cipher(var1);
      RRCUtil.print("B4 Encrypt", var2, 0, var2.length);
      RC4Cipher var4 = new RC4Cipher(var1);
      var4.encrypt(var2, 0, var3, 0, var2.length);
      RRCUtil.print("After Encrypt", var3, 0, var3.length);
      var4 = new RC4Cipher(var1);
      var4.decrypt(var3, 0, var2, 0, var3.length);
      RRCUtil.print("After Decrypt", var2, 0, var2.length);
   }
}
