package javaclientlib.utils;

import com.sun.net.ssl.SSLContext;
import com.sun.net.ssl.TrustManager;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.net.Socket;
import java.security.KeyManagementException;
import java.security.NoSuchAlgorithmException;
import java.security.Security;
import javax.net.ssl.SSLSocket;
import javax.net.ssl.SSLSocketFactory;
import sun.security.jgss.SunProvider;

public class SecureSocket {
   private int iPort;
   private String sHostName;
   private Socket objSocket;
   private SSLSocket objSSLSocket;
   private boolean useTLS = false;

   public SecureSocket() {
   }

   public SecureSocket(Socket var1, String var2, int var3, boolean var4) {
      this.objSocket = var1;
      this.sHostName = var2;
      this.iPort = var3;
      this.useTLS = var4;
   }

   public void setSocket(Socket var1) {
      this.objSocket = var1;
   }

   public void setHostName(String var1) {
      this.sHostName = var1;
   }

   public void setPort(int var1) {
      this.iPort = var1;
   }

   public void connect() throws NoSuchAlgorithmException, KeyManagementException, IOException {
      Security.addProvider(new SunProvider());
      SSLContext var1;
      if (this.useTLS) {
         var1 = SSLContext.getInstance("TLSv1");
      } else {
         var1 = SSLContext.getInstance("SSLv3");
      }

      TrustManager[] var2 = new TrustManager[]{new DummyTrustManager()};
      var1.init(null, var2, null);
      SSLSocketFactory var3 = var1.getSocketFactory();
      this.objSSLSocket = (SSLSocket)var3.createSocket(this.objSocket, this.sHostName, this.iPort, false);
      if (this.useTLS) {
         this.objSSLSocket.setEnabledProtocols(new String[]{"TLSv1", "SSLv3"});
      } else {
         this.objSSLSocket.setEnabledProtocols(new String[]{"SSLv3"});
      }

      this.objSSLSocket.startHandshake();
   }

   public InputStream getSecureInputStream() throws IOException {
      return this.objSSLSocket.getInputStream();
   }

   public OutputStream getSecureOutputStream() throws IOException {
      return this.objSSLSocket.getOutputStream();
   }
}
