package nn.pp.audiocore;

import java.io.IOException;
import javax.net.ssl.X509TrustManager;
import nn.pp.core.NotificationListener;

public interface AudioCore {
   int DEFAULT_MIC_BLK_SIZE = 120;
   int DEFAULT_SPK_BLK_SIZE = 120;
   int MAX_MIC_BLK_SIZE = 400;
   int MAX_SPK_BLK_SIZE = 400;
   int BLK_SIZE_MULTIPLY = 40;

   void dispose();

   void setX509TrustManager(X509TrustManager var1);

   void connectAudioWithUserLogin(
      String var1,
      int var2,
      boolean var3,
      String var4,
      int var5,
      int var6,
      AudioDevice var7,
      AudioFormat var8,
      AudioDevice var9,
      AudioFormat var10,
      String var11,
      String var12
   ) throws IOException, AudioException;

   void connectAudioWithRdmSession(
      String var1,
      int var2,
      boolean var3,
      String var4,
      int var5,
      int var6,
      AudioDevice var7,
      AudioFormat var8,
      AudioDevice var9,
      AudioFormat var10,
      String var11,
      String var12,
      String var13
   ) throws IOException, AudioException;

   void connectAudioWithEricKey(
      String var1,
      int var2,
      boolean var3,
      String var4,
      int var5,
      int var6,
      AudioDevice var7,
      AudioFormat var8,
      AudioDevice var9,
      AudioFormat var10,
      String var11
   ) throws IOException, AudioException;

   void disconnect();

   void setCaptureBufferSizeMs(int var1) throws IOException;

   int getCaptureBufferSizeMs();

   void setPlaybackBufferSizeMs(int var1) throws IOException;

   int getPlaybackBufferSizeMs();

   void addNotificationListener(NotificationListener var1);

   void removeNotificationListener(NotificationListener var1);

   void addAudioEventListener(AudioEventListener var1);

   void removeAudioEventListener(AudioEventListener var1);
}
