package nn.pp.audiocore;

import java.text.MessageFormat;
import nn.pp.core.T;

public class AudioFormat extends javax.sound.sampled.AudioFormat {
   public AudioFormat(float var1, int var2, int var3) {
      super(var1, var2, var3, var2 != 8, false);
   }

   public int getBytesPerSecond() {
      return (int)this.sampleRate * this.channels * this.sampleSizeInBits / 8;
   }

   @Override
   public String toString() {
      String var1;
      if (this.getChannels() == 1) {
         var1 = T._("mono");
      } else if (this.getChannels() == 2) {
         var1 = T._("stereo");
      } else {
         var1 = MessageFormat.format("{0} channels", this.getChannels());
      }

      String var2 = MessageFormat.format("{0} bit", this.getSampleSizeInBits());
      String var3 = MessageFormat.format("{0} Hz", this.getSampleRate());
      return var1 + ", " + var2 + ", " + var3;
   }

   public String toShortString() {
      return (int)this.getSampleRate() + "_" + this.getSampleSizeInBits() + "_" + this.getChannels();
   }
}
