package nn.pp.audiocore.impl.audio;

import java.io.IOException;

public class CircularBufferStream {
   private int posWrite = 0;
   private int posRead = 0;
   private int bufSize = 0;
   private int bufBytes = 0;
   private byte[] bufCircular = null;

   public CircularBufferStream(int var1) {
      this.bufCircular = new byte[var1];
      this.bufSize = var1;
   }

   public void bufReset() {
      this.posWrite = 0;
      this.posRead = 0;
      this.bufBytes = 0;
   }

   public int getAvailableBytes() {
      return this.bufBytes;
   }

   public int getWritableBytes() {
      return this.bufSize - this.bufBytes;
   }

   public int read(byte[] var1, int var2) throws IOException {
      int var3 = 0;
      int var4 = this.posWrite - this.posRead;
      int var5 = this.bufSize - this.posRead;
      if (this.bufBytes > this.bufSize) {
         this.bufReset();
         return 0;
      } else {
         if (var4 >= var2 && var4 > 0) {
            var3 = var2;
         } else if (var4 < var2 && var4 > 0) {
            var3 = var4;
         } else if (var4 <= 0) {
            if (var3 > var2) {
               var3 = var2;
            } else if (this.posWrite > var2 - var5) {
               var3 = var2;
            } else {
               var3 = var5 + this.posWrite;
            }
         }

         try {
            if (var3 < var5) {
               System.arraycopy(this.bufCircular, this.posRead, var1, 0, var3);
               this.posRead += var3;
            } else if (var3 == var5) {
               System.arraycopy(this.bufCircular, this.posRead, var1, 0, var3);
               this.posRead = 0;
            } else {
               System.arraycopy(this.bufCircular, this.posRead, var1, 0, var5);
               System.arraycopy(this.bufCircular, 0, var1, var5, var3 - var5);
               this.posRead = var3 - var5;
            }

            this.bufBytes -= var3;
            return var3;
         } catch (Exception var7) {
            throw new IOException("Buffer Error");
         }
      }
   }

   public void write(byte[] var1, int var2, int var3) throws IOException {
      int var4 = this.bufSize - this.posWrite;
      if (var3 != 0) {
         try {
            if (var4 > var3) {
               System.arraycopy(var1, var2, this.bufCircular, this.posWrite, var3);
               this.posWrite += var3;
            } else {
               System.arraycopy(var1, var2, this.bufCircular, this.posWrite, var4);
               System.arraycopy(var1, var2 + var4, this.bufCircular, 0, var3 - var4);
               this.posWrite = var3 - var4;
            }

            this.bufBytes += var3;
         } catch (Exception var6) {
            throw new IOException("Buffer Error");
         }
      }
   }
}
