package nn.pp.audiocore.impl.rap.V02_00;

import java.io.IOException;
import nn.pp.audiocore.AudioFormat;
import nn.pp.core.impl.MonitoringDataInputStream;
import nn.pp.core.impl.MonitoringDataOutputStream;
import nn.pp.core.impl.ProtocolMessage;

public class RapDataMsgV02_00 extends ProtocolMessage {
   public byte[] dataBuffer = null;
   public int dataSize;
   public AudioFormat format;
   private RapAudioFormatV02_00 formatMessage = new RapAudioFormatV02_00();

   private void checkDataBufSize(int var1) {
      if (this.dataBuffer == null || this.dataBuffer.length < var1) {
         this.dataBuffer = new byte[var1];
      }
   }

   public void read(MonitoringDataInputStream var1, boolean var2) throws IOException {
      if (!var2) {
         var1.readUnsignedByte();
      }

      var1.readUnsignedByte();
      var1.readUnsignedShort();
      this.formatMessage.read(var1);
      this.format = this.formatMessage.audioFormat;
      this.dataSize = var1.readInt() & -1;
      this.checkDataBufSize(this.dataSize);
      var1.readFully(this.dataBuffer, 0, this.dataSize);
   }

   public void write(MonitoringDataOutputStream var1, int var2, AudioFormat var3, byte[] var4, int var5, int var6) throws IOException {
      this.write(3);
      this.write(0);
      this.writeShort(0);
      this.formatMessage.write(this, var2, var3);
      this.writeInt(var6);
      this.write(var4, var5, var6);
      var1.write(this);
   }
}
