package nn.pp.common;

import java.util.ArrayList;
import java.util.HashMap;

public final class ApplicationContext extends HashMap {
   public static final String KEY_HOTKEYMAP = "HOTKEYMAP";
   public static final String KEY_KEYBOARDLANG = "KEYBOARDLANGUAGE";
   public static final String KEY_SCROLL_BORDERS = "SCROLLBORDERS";
   private static ApplicationContext appCtx = null;
   private ArrayList<ContextListener> listeners;

   private ApplicationContext() {
   }

   public static ApplicationContext getInstance() {
      return appCtx;
   }

   public Object getAttribute(String var1) {
      return this.get(var1);
   }

   public Object setAttribute(String var1, Object var2) {
      Object var3 = this.put(var1, var2);
      this.fireContextChanged(var1);
      return var3;
   }

   public void registerListener(ContextListener var1) {
      if (this.listeners == null) {
         this.listeners = new ArrayList<>();
      }

      this.listeners.add(var1);
   }

   public void removeListener(ContextListener var1) {
      if (this.listeners != null) {
         this.listeners.remove(var1);
      }
   }

   private void fireContextChanged(String var1) {
      if (this.listeners != null) {
         for (ContextListener var3 : this.listeners) {
            var3.contextChanged(new ContextEventImpl(var1) {});
         }
      }
   }

   static {
      appCtx = new ApplicationContext();
   }
}
