package nn.pp.common;

import java.awt.Toolkit;
import java.awt.datatransfer.Clipboard;
import java.awt.datatransfer.ClipboardOwner;
import java.awt.datatransfer.StringSelection;
import java.awt.datatransfer.Transferable;

public class ClipboardHandler implements ClipboardOwner {
   private static Clipboard clipboard;
   private static ClipboardHandler cbhInstance;

   private ClipboardHandler() {
   }

   public static ClipboardHandler getInstance() {
      if (cbhInstance == null) {
         cbhInstance = new ClipboardHandler();
      }

      return cbhInstance;
   }

   public void copyToClipboard(String var1) {
      synchronized (cbhInstance) {
         if (clipboard == null) {
            clipboard = Toolkit.getDefaultToolkit().getSystemClipboard();
         }

         clipboard.setContents(new StringSelection(var1), cbhInstance);
      }
   }

   @Override
   public void lostOwnership(Clipboard var1, Transferable var2) {
   }

   @Override
   public Object clone() throws CloneNotSupportedException {
      throw new CloneNotSupportedException();
   }
}
