package nn.pp.common;

import javax.swing.text.AttributeSet;
import javax.swing.text.BadLocationException;
import javax.swing.text.PlainDocument;

public class LimitedLengthDocument extends PlainDocument {
   private int MAXLEN = 255;

   public LimitedLengthDocument() {
   }

   public LimitedLengthDocument(int var1) {
      this.MAXLEN = var1;
   }

   @Override
   public void insertString(int var1, String var2, AttributeSet var3) throws BadLocationException {
      if (var2 != null) {
         String var4 = this.getText(0, this.getLength());
         if (var4.length() != this.MAXLEN) {
            if (var4.length() + var2.length() <= this.MAXLEN) {
               super.insertString(var1, var2, var3);
            } else {
               super.insertString(var1, var2.substring(0, this.MAXLEN - var4.length()), var3);
            }
         }
      }
   }
}
