package nn.pp.common;

import java.awt.Point;

public class RemoteConsoleParameters {
   public String host;
   public int tcpPort = 443;
   public boolean ssl = false;
   public String username;
   public String password;
   public String ericKey;
   public String rdmSession;
   public String rdmSessionMultiPortTag;
   public String targetPortId;
   public String portIndex;
   public int sessionId;
   public String proxyConnectionId;
   public String proxyConnectionIdVM;
   public String proxyUseSSL;
   public String applianceId;
   public String archivePath = "";
   public String portName = "";
   public int monitorIndex = 0;
   public Point position = null;
   public int numberOfMonitorsForTarget = 1;

   public RemoteConsoleParameters() {
   }

   public RemoteConsoleParameters(RemoteConsoleParameters var1) {
      this.host = var1.host;
      this.tcpPort = var1.tcpPort;
      this.ssl = var1.ssl;
      this.username = var1.username;
      this.password = var1.password;
      this.ericKey = var1.ericKey;
      this.rdmSession = var1.rdmSession;
      this.targetPortId = var1.targetPortId;
      this.portIndex = var1.portIndex;
      this.sessionId = var1.sessionId;
      this.proxyConnectionId = var1.proxyConnectionId;
      this.proxyConnectionIdVM = var1.proxyConnectionIdVM;
      this.proxyUseSSL = var1.proxyUseSSL;
      this.applianceId = var1.applianceId;
      this.archivePath = var1.archivePath;
      this.portName = var1.portName;
      this.monitorIndex = var1.monitorIndex;
      this.position = var1.position != null ? new Point(var1.position) : null;
      this.numberOfMonitorsForTarget = var1.numberOfMonitorsForTarget;
      this.rdmSessionMultiPortTag = var1.rdmSessionMultiPortTag;
   }

   public boolean isTopLeft() {
      return this.position == null || this.position.x == 0 && this.position.y == 0;
   }

   public boolean isPrimaryOrSingle() {
      return this.monitorIndex == 0;
   }

   public boolean isPrimary() {
      return this.monitorIndex == 0 && this.numberOfMonitorsForTarget > 1;
   }

   public boolean isSecondary() {
      return this.monitorIndex != 0;
   }

   public boolean isMultiMonitorPort() {
      return this.numberOfMonitorsForTarget > 1;
   }

   public String getURLCompatibleRemoteHost() {
      return nn.pp.core.Util.getURLCompatibleIP(this.host);
   }

   @Override
   public String toString() {
      return "host: "
         + this.host
         + ", port: "
         + this.tcpPort
         + ", ssl: "
         + this.ssl
         + ",\n"
         + "username: "
         + this.username
         + ", password: "
         + "xxx"
         + ",\n"
         + "ericKey: "
         + this.ericKey
         + ", rdmSession: "
         + this.rdmSession
         + ",\n"
         + "targetPortId: "
         + this.targetPortId
         + "portName: "
         + this.portName
         + " proxyConnectionId: "
         + this.proxyConnectionId
         + "proxyConnectionIdVM: "
         + this.proxyConnectionIdVM
         + "proxyUseSSL: "
         + this.proxyUseSSL
         + "applianceId:"
         + this.applianceId
         + "archivePath:"
         + this.archivePath
         + "rdmSessionMultiPortTag:"
         + this.rdmSessionMultiPortTag;
   }
}
