package nn.pp.common;

import java.awt.Image;
import java.awt.Toolkit;
import java.net.URL;
import java.util.logging.Level;
import javax.swing.ImageIcon;
import nn.pp.logging.RemoteConsoleLogger;

public class ResourceLoader {
   public static Image loadImage(String var0) {
      URL var1 = ResourceLoader.class.getResource("/" + ResourceLoader.class.getPackage().getName().replace('.', '/') + "/icons/" + var0);
      if (var1 != null) {
         return Toolkit.getDefaultToolkit().getImage(var1);
      } else {
         RemoteConsoleLogger.getInstance()
            .getLogger()
            .log(Level.WARNING, "Failed to load image " + var0 + " from:n\t" + ResourceLoader.class.getPackage().getName().replace('.', '/') + "/icons/" + var0);
         return null;
      }
   }

   public static ImageIcon loadImageIcon(String var0) {
      Image var1 = loadImage(var0);
      if (var1 != null) {
         ImageIcon var2 = new ImageIcon(var1);
         var2.setDescription(var0);
         return var2;
      } else {
         return null;
      }
   }
}
