package nn.pp.common.audio;

import java.awt.Window;
import nn.pp.audiocore.AudioDevice;
import nn.pp.audiocore.AudioFormat;
import nn.pp.core.INotificationEvent;

public class AudioBean {
   private final String host;
   private final int port;
   private final boolean sslMode;
   private final String username;
   private final String password;
   private final String rdmSession;
   private final String proxyConnectionId;
   private final String proxyUseSSL;
   private final String ericKey;
   private int rfbSessionId;
   private int msindex = -1;
   private String portId;
   private AudioDevice playbackDevice;
   private AudioDevice captureDevice;
   private AudioFormat playbackFormat;
   private AudioFormat captureFormat;
   private final AudioErrorsAndMessageHandler audioErrorsAndMessageHandler;

   public AudioBean(
      String var1, int var2, boolean var3, String var4, String var5, String var6, String var7, String var8, String var9, AudioErrorsAndMessageHandler var10
   ) {
      this.host = var1;
      this.port = var2;
      this.sslMode = var3;
      this.username = var4;
      this.password = var5;
      this.rdmSession = var6;
      this.proxyConnectionId = var7;
      this.proxyUseSSL = var8;
      this.ericKey = var9;
      this.audioErrorsAndMessageHandler = var10;
   }

   public String getHost() {
      return this.host;
   }

   public int getPort() {
      return this.port;
   }

   public boolean isSslMode() {
      return this.sslMode;
   }

   public String getPortId() {
      return this.portId;
   }

   public String getUsername() {
      return this.username;
   }

   public String getPassword() {
      return this.password;
   }

   public String getRdmSession() {
      return this.rdmSession;
   }

   public String getProxyConnectionId() {
      return this.proxyConnectionId;
   }

   public String getProxyUseSSL() {
      return this.proxyUseSSL;
   }

   public String getEricKey() {
      return this.ericKey;
   }

   public int getRfbSessionId() {
      return this.rfbSessionId;
   }

   public int getMsindex() {
      return this.msindex;
   }

   public void setRfbSessionId(int var1) {
      this.rfbSessionId = var1;
   }

   public void setMsindex(int var1) {
      this.msindex = var1;
   }

   public void setPortId(String var1) {
      this.portId = var1;
   }

   public void setCaptureDevice(AudioDevice var1) {
      this.captureDevice = var1;
   }

   public AudioDevice getCaptureDevice() {
      return this.captureDevice;
   }

   public void setPlaybackDevice(AudioDevice var1) {
      this.playbackDevice = var1;
   }

   public AudioDevice getPlaybackDevice() {
      return this.playbackDevice;
   }

   public void setCaptureFormat(AudioFormat var1) {
      this.captureFormat = var1;
   }

   public AudioFormat getCaptureFormat() {
      return this.captureFormat;
   }

   public void setPlaybackFormat(AudioFormat var1) {
      this.playbackFormat = var1;
   }

   public AudioFormat getPlaybackFormat() {
      return this.playbackFormat;
   }

   public void notificationReceived(Window var1, INotificationEvent var2, String var3) {
      this.audioErrorsAndMessageHandler.notificationReceived(var1, var2, var3);
   }

   public void errorMessage(Window var1, String var2, String var3) {
      this.audioErrorsAndMessageHandler.errorMessage(var1, var2, var3);
   }
}
