package nn.pp.common.scan;

import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

public class GridCalculationUtil {
   public static void main(String[] var0) {
      for (int var1 = 1; var1 <= 32; var1++) {
         System.out.println("Panels " + var1 + " : " + calculateColsAndRows(var1));
      }
   }

   static GridCalculationUtil.GridLayoutInfo calculateColsAndRows(int var0) {
      int var1 = (int)Math.sqrt(var0);
      int var2 = var1;

      while (var2 * var1 < var0) {
         if (var2 > var1) {
            var1++;
         } else {
            var2++;
         }
      }

      Object var3 = Collections.emptyList();
      if (var2 > var1) {
         int var5 = var0 - var1 * var1;
         int var6 = var1 - var5 - 1;
         if (var6 > 0) {
            var3 = new ArrayList();
         }

         for (int var7 = var1 - var6; var7 < var1; var7++) {
            var3.add(var7 * var2);
         }
      }

      return new GridCalculationUtil.GridLayoutInfo(var2, var1, (List<Integer>)var3);
   }

   static class GridLayoutInfo {
      public final int cols;
      public final int rows;
      public final List<Integer> fillers;

      public GridLayoutInfo(int var1, int var2, List<Integer> var3) {
         this.cols = var1;
         this.rows = var2;
         this.fillers = Collections.unmodifiableList(var3);
      }

      @Override
      public String toString() {
         return "GridLayoutInfo [cols=" + this.cols + ", rows=" + this.rows + ", fillers=" + this.fillers + "]";
      }
   }
}
