package nn.pp.common.scan;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Image;
import java.awt.RenderingHints;
import javax.swing.JPanel;
import nn.pp.core.Util;

public class ResizeableVideoSnapshotViewer extends JPanel {
   private Image image;
   private static final RenderingHints renderingHints = new RenderingHints(RenderingHints.KEY_RENDERING, RenderingHints.VALUE_RENDER_DEFAULT);

   public ResizeableVideoSnapshotViewer() {
      this.setLayout(new BorderLayout());
   }

   @Override
   protected void paintComponent(Graphics var1) {
      super.paintComponent(var1);
      if (this.getComponentCount() == 0 && this.image != null) {
         Dimension var2 = this.getSize();
         int var3 = this.image.getWidth(null);
         int var4 = this.image.getHeight(null);
         Dimension var5 = Util.getScaledDimension(var2, new Dimension(var3, var4));
         int var6 = (var2.width - var5.width) / 2;
         int var7 = (var2.height - var5.height) / 2;
         Graphics2D var8 = (Graphics2D)var1;
         RenderingHints var9 = var8.getRenderingHints();
         var8.setRenderingHints(renderingHints);
         var1.drawImage(this.image, var6, var7, var5.width, var5.height, null);
         var8.setRenderingHints(var9);
      }
   }

   public void setSnapshot(Image var1, Dimension var2) {
      this.createSnapshot(var1, var2);
      this.repaint();
   }

   public void clearShanpshot() {
      this.image = null;
      this.repaint();
   }

   private void createSnapshot(Image var1, Dimension var2) {
      if (var2.width == var1.getWidth(null) && var2.height == var1.getHeight(null)) {
         this.image = var1;
      } else {
         this.image = this.getGraphicsConfiguration().createCompatibleImage(var2.width, var2.height);
         Graphics var3 = this.image.getGraphics();
         ((Graphics2D)var3).setRenderingHints(renderingHints);
         var3.drawImage(var1, 0, 0, var2.width, var2.height, null);
         var3.dispose();
      }
   }

   static {
      renderingHints.add(new RenderingHints(RenderingHints.KEY_INTERPOLATION, RenderingHints.VALUE_INTERPOLATION_BILINEAR));
   }
}
