package nn.pp.common.scan;

import java.awt.Dimension;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Image;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowEvent;
import java.awt.event.WindowListener;
import java.io.IOException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.concurrent.ExecutionException;
import javax.swing.BorderFactory;
import javax.swing.ButtonGroup;
import javax.swing.JComponent;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JRadioButtonMenuItem;
import javax.swing.SwingWorker;
import javax.swing.UIManager;
import nn.pp.common.RemoteConsoleParameters;
import nn.pp.common.ResourceLoader;
import nn.pp.core.INotificationEvent;
import nn.pp.core.NotificationListener;
import nn.pp.rccore.scan.ScanCore;
import nn.pp.rccore.scan.ScanCoreException;
import nn.pp.rccore.scan.ScanCoreFactory;
import nn.pp.rccore.scan.ScanSession;
import nn.pp.rccore.scan.ScanSessionEventsListener;

public class TSP {
   private static final String NO_VIDEO_FROM_TARGET_SERVER = "No video from target server";
   private static TargetState state = TargetState.INACTIVE;
   private static ScanSession scanSession;

   public static void main(String[] var0) {
      try {
         UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
      } catch (Exception var30) {
      }

      JFrame var1 = new JFrame("TSP");
      var1.setDefaultCloseOperation(0);
      var1.setExtendedState(6);
      String[] var2 = new String[]{"P_000d5d1d2d4d_0", "P_000d5d1d2d4d_11", "P_000d5d1d2d4d_4", "P_000d5d1d2d4d_15"};
      String[] var3 = new String[]{"basit_cim1", "Fedora", "vijay_cim1", "WinXP"};
      ArrayList var4 = new ArrayList();

      for (int var5 = 0; var5 < var2.length; var5++) {
         RemoteConsoleParameters var6 = new RemoteConsoleParameters();
         var6.targetPortId = var2[var5];
         var6.portName = var3[var5];
         var6.username = "test";
         var6.password = "raritan";
         var6.host = "192.168.50.207";
         var6.tcpPort = 443;
         var6.ssl = true;
         var6.portIndex = var2[var5].substring(var2[var5].lastIndexOf(95) + 1);
         var4.add(var6);
      }

      final HashMap var31 = new HashMap();

      for (RemoteConsoleParameters var7 : var4) {
         var31.put(var7.targetPortId, var7);
      }

      final TSP.MyLabel var33 = new TSP.MyLabel();
      final TSP.MyLabel var34 = new TSP.MyLabel();
      final ScanConnector var8 = createScanConnector(var4);
      var8.addScanEventListener(
         new ScanEventListener() {
            @Override
            public void videoComponentAvailable(String var1, JComponent var2x) {
               TSP.state = TargetState.INACTIVE;
               var33.setIcon(ResourceLoader.loadImageIcon("Common_led_white.gif"));
               var33.setText(
                  Integer.parseInt(((RemoteConsoleParameters)var31.get(var1)).portIndex) + 1 + " - " + ((RemoteConsoleParameters)var31.get(var1)).portName
               );
            }

            @Override
            public void scanAbortedOnConnectError() {
               TSP.scanSession.close();
            }

            @Override
            public void scanAborted(INotificationEvent var1) {
               TSP.scanSession.close();
               System.out.println(var1.isError());
               System.out.println(var1);
            }

            @Override
            public void displayVideoStart(String var1, boolean var2x) {
               if (TSP.state == TargetState.INACTIVE) {
                  TSP.state = TargetState.CONNECTED;
                  var33.setIcon(ResourceLoader.loadImageIcon("Common_led_green.gif"));
               }
            }

            @Override
            public void displayVideoError(String var1, int var2x) {
               TSP.state = TargetState.BUSY;
               var33.setIcon(ResourceLoader.loadImageIcon("Common_led_red.gif"));
               var34.setText("");
               var34.setToolTipText(null);
            }

            @Override
            public void displayVideoEnd(String var1, Image var2x) {
               TSP.state = TargetState.INACTIVE;
               var33.setIcon(ResourceLoader.loadImageIcon("Common_led_white.gif"));
               var34.setText("");
               var34.setToolTipText(null);
            }

            @Override
            public void displayVideoCommunicationError(String var1) {
               TSP.state = TargetState.BUSY;
               var33.setIcon(ResourceLoader.loadImageIcon("Common_led_red.gif"));
               var34.setText("");
               var34.setToolTipText(null);
            }

            @Override
            public void osdMessageReceived(String var1, String var2x) {
               var34.setText(var2x);
               var34.setToolTipText(var34.getText());
               if ("No video from target server".equals(var2x)) {
                  TSP.state = TargetState.DOWN;
                  var33.setIcon(ResourceLoader.loadImageIcon("Common_led_yellow.gif"));
               } else {
                  TSP.state = TargetState.CONNECTED;
                  var33.setIcon(ResourceLoader.loadImageIcon("Common_led_green.gif"));
               }
            }
         }
      );
      var8.setScanInterval(25000);
      var8.setSwitchInterval(10000);
      final ScanPanelHelper var9 = new ScanPanelHelper(var4, var8, new Dimension(160, 120), 1);
      JMenuBar var10 = new JMenuBar();
      JMenu var11 = new JMenu("Options");
      JMenu var12 = new JMenu("Size");
      JRadioButtonMenuItem var13 = new JRadioButtonMenuItem("320 * 240");
      var12.add((JMenuItem)var13);
      ButtonGroup var14 = new ButtonGroup();
      var14.add(var13);
      JRadioButtonMenuItem var15 = new JRadioButtonMenuItem("160 * 120");
      var12.add((JMenuItem)var15);
      var14.add(var15);
      ActionListener var16 = new ActionListener() {
         @Override
         public void actionPerformed(ActionEvent var1) {
            String var2x = ((JRadioButtonMenuItem)var1.getSource()).getText();
            if ("320 * 240".equals(var2x)) {
               var9.setThumbnailSize(new Dimension(320, 240));
            } else if ("160 * 120".equals(var2x)) {
               var9.setThumbnailSize(new Dimension(160, 120));
            }
         }
      };
      var13.addActionListener(var16);
      var15.addActionListener(var16);
      var15.setSelected(true);
      JMenuItem var17 = new JMenuItem("Pause");
      ActionListener var18 = new ActionListener() {
         @Override
         public void actionPerformed(ActionEvent var1) {
            TSP.state = TargetState.INACTIVE;
            var33.setIcon(ResourceLoader.loadImageIcon("Common_led_white.gif"));
            var33.setText("Paused");
            var8.pause();
         }
      };
      var17.addActionListener(var18);
      JMenuItem var19 = new JMenuItem("Resume");
      ActionListener var20 = new ActionListener() {
         @Override
         public void actionPerformed(ActionEvent var1) {
            var8.resume();
         }
      };
      var19.addActionListener(var20);
      JMenu var21 = new JMenu("Split Orientation");
      JRadioButtonMenuItem var22 = new JRadioButtonMenuItem("Horizontal");
      JRadioButtonMenuItem var23 = new JRadioButtonMenuItem("Vertical");
      ButtonGroup var24 = new ButtonGroup();
      var24.add(var22);
      var24.add(var23);
      var22.setSelected(true);
      ActionListener var25 = new ActionListener() {
         @Override
         public void actionPerformed(ActionEvent var1) {
            var9.setSplitPaneOrientation(1);
         }
      };
      var22.addActionListener(var25);
      ActionListener var26 = new ActionListener() {
         @Override
         public void actionPerformed(ActionEvent var1) {
            var9.setSplitPaneOrientation(0);
         }
      };
      var23.addActionListener(var26);
      var21.add((JMenuItem)var22);
      var21.add((JMenuItem)var23);
      var11.add((JMenuItem)var12);
      var11.add(var17);
      var11.add(var19);
      var11.add((JMenuItem)var21);
      var10.add(var11);
      var9.addVideoSnapshotSelectionListener(new VideoSnapshotSelectionListener<RemoteConsoleParameters>() {
         public void videoSnapshotSingleClickSelected(RemoteConsoleParameters var1) {
            System.out.println("Single click selected... " + var1.targetPortId);
         }

         public void videoSnapshotDoubleClickSelected(RemoteConsoleParameters var1) {
            System.out.println("Double Click Selected.. " + var1.targetPortId);
         }
      });
      var1.setJMenuBar(var10);
      var1.add(var9.getScanPanel());
      JPanel var27 = new JPanel();
      var27.setLayout(new GridBagLayout());
      GridBagConstraints var28 = new GridBagConstraints();
      var27.setBorder(BorderFactory.createRaisedBevelBorder());
      var33.setBorder(BorderFactory.createLoweredBevelBorder());
      var34.setBorder(BorderFactory.createLoweredBevelBorder());
      JPanel var29 = new JPanel();
      var29.setLayout(new GridBagLayout());
      var28.weightx = 0.3;
      var28.weighty = 1.0;
      var28.fill = 1;
      var29.add(var33, var28);
      var28.weightx = 0.7;
      var28.gridx = 1;
      var29.add(var34, var28);
      var28 = new GridBagConstraints();
      var28.weightx = 1.0;
      var28.fill = 1;
      var27.add(var29, var28);
      var1.add(var27, "South");
      var1.setVisible(true);
      createScanSession((RemoteConsoleParameters)var4.get(0), var2, new ScanSessionEventsListener() {
         @Override
         public void disconnected(Exception var1) {
            if (var1 != null) {
               var9.getScanConnector().stop();
               JOptionPane.showMessageDialog(null, "Error received on Scan session connection");
            }
         }

         @Override
         public void scanSessionCreated(int var1) {
            var9.getScanConnector().start(var1);
         }
      }, new NotificationListener() {
         @Override
         public void receivedNotification(INotificationEvent var1) {
            System.out.println(var1.getErrorCode());
            switch (var1.getErrorCode()) {
               case -1610612735:
               case -1610612734:
               case -1610481663:
               case -1610481662:
               case -1576927228:
                  var9.getScanConnector().stop();
                  JOptionPane.showMessageDialog(null, "Error Recived from server " + Integer.toHexString(var1.getErrorCode()));
            }
         }

         @Override
         public void textNotification(String var1) {
         }
      });
      var1.addWindowListener(new WindowListener() {
         @Override
         public void windowOpened(WindowEvent var1) {
         }

         @Override
         public void windowIconified(WindowEvent var1) {
         }

         @Override
         public void windowDeiconified(WindowEvent var1) {
         }

         @Override
         public void windowDeactivated(WindowEvent var1) {
         }

         @Override
         public void windowClosing(WindowEvent var1) {
            var9.getScanConnector().stop();
            if (TSP.scanSession != null) {
               TSP.scanSession.close();
            }

            var1.getWindow().dispose();
            System.exit(0);
         }

         @Override
         public void windowClosed(WindowEvent var1) {
         }

         @Override
         public void windowActivated(WindowEvent var1) {
         }
      });
   }

   private static ScanConnector createScanConnector(List<RemoteConsoleParameters> var0) {
      ArrayList var1 = new ArrayList();

      for (RemoteConsoleParameters var3 : var0) {
         var1.add(var3.targetPortId);
      }

      return new ScanConnector(var0);
   }

   private static void createScanSession(
      final RemoteConsoleParameters var0, final String[] var1, final ScanSessionEventsListener var2, final NotificationListener var3
   ) {
      SwingWorker var4 = new SwingWorker<ScanSession, Void>() {
         protected ScanSession doInBackground() throws Exception {
            ScanCore var1x;
            try {
               var1x = ScanCoreFactory.getDefault();
            } catch (ScanCoreException var6) {
               throw var6;
            }

            ScanSession var2x;
            if (var0.username != null && var0.password != null) {
               var2x = var1x.createScanSessionWithUsernameAndPassword(var0.getURLCompatibleRemoteHost(), var0.tcpPort, var0.ssl, var0.username, var0.password);
            } else if (var0.ericKey != null) {
               var2x = var1x.createScanSessionWithEricKey(var0.getURLCompatibleRemoteHost(), var0.tcpPort, var0.ssl, var0.ericKey);
            } else {
               if (var0.rdmSession == null) {
                  throw new Exception("Missing authentication parameters");
               }

               var2x = var1x.createScanSessionWithRdmSessionID(
                  var0.getURLCompatibleRemoteHost(), var0.tcpPort, var0.ssl, var0.rdmSession, var0.proxyConnectionId, var0.proxyUseSSL
               );
            }

            try {
               var2x.start(var1, var2, var3);
               return var2x;
            } catch (ScanCoreException var4x) {
               throw var4x;
            } catch (IOException var5) {
               throw var5;
            }
         }

         @Override
         protected void done() {
            try {
               try {
                  TSP.scanSession = this.get();
               } catch (InterruptedException var6) {
                  Thread.currentThread().interrupt();
                  return;
               } catch (ExecutionException var7) {
                  var7.printStackTrace();
                  JOptionPane.showMessageDialog(null, "Error connecting to the device");
               }
            } finally {
               ;
            }
         }
      };
      var4.execute();
   }

   private static class MyLabel extends JLabel {
      private MyLabel() {
      }

      @Override
      public Dimension getPreferredSize() {
         return new Dimension(10, super.getPreferredSize().height);
      }

      @Override
      public Dimension getMinimumSize() {
         return this.getPreferredSize();
      }
   }
}
