package nn.pp.common.scan;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Component;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.GraphicsEnvironment;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.GridLayout;
import java.awt.Image;
import java.awt.Insets;
import java.awt.Rectangle;
import java.awt.Toolkit;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.LinkedList;
import java.util.List;
import javax.swing.BorderFactory;
import javax.swing.ButtonGroup;
import javax.swing.JButton;
import javax.swing.JCheckBoxMenuItem;
import javax.swing.JComponent;
import javax.swing.JFrame;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JRadioButtonMenuItem;
import javax.swing.JScrollPane;
import javax.swing.Timer;
import nn.pp.common.RemoteConsoleParameters;
import nn.pp.common.ui.helpers.FullScreenMenuHandler;
import nn.pp.core.INotificationEvent;
import nn.pp.core.NotificationListener;
import nn.pp.rccore.RCAdapter;
import nn.pp.rccore.RCCore;
import nn.pp.rccore.RCCoreFactory;
import nn.pp.rccore.VideoEventListener;

public class TVideo {
   private static final int COL_CAL_TIME = 3000;
   private static final int SWITCH_TIME = 3000;
   private static final int SCAN_TIME = 5000;
   static boolean stoppedColorCalTimer;
   static Timer scanTimer;
   static Timer switchTimer;
   static Timer colorCalTimer;
   static VideoSnapshotViewer[] imgDisp;
   static List<VideoSnapshotPanel<Object>> imgPanels;
   static String[] portIds;
   static int index = 0;
   static RCCore rccore;
   static Dimension selectedSize;
   static NotificationListener videoStateNotificationListener;
   static VideoEventListener colorCalListener;
   static JFrame frame;
   static JFrame fullScreenFrame;
   static JPanel videoPanel;
   static FullScreenMenuHandler fullScreenMenuHandler;
   static String selectedPortId;
   static JMenuItem resumeAfter;
   private static ScanConnector scanConnector;

   public static void main(String[] var0) throws Exception {
      frame = new JFrame("TVideo");
      final JMenuBar var1 = new JMenuBar();
      JMenu var2 = new JMenu("Options");
      JMenu var3 = new JMenu("Size");
      JRadioButtonMenuItem var4 = new JRadioButtonMenuItem("320 * 240");
      var3.add((JMenuItem)var4);
      TVideo.SizeSelector var5 = new TVideo.SizeSelector();
      var4.addActionListener(var5);
      JRadioButtonMenuItem var6 = new JRadioButtonMenuItem("160 * 120");
      var3.add((JMenuItem)var6);
      var6.addActionListener(var5);
      ButtonGroup var7 = new ButtonGroup();
      var7.add(var4);
      var7.add(var6);
      var4.setSelected(true);
      selectedSize = new Dimension(320, 240);
      JMenuItem var8 = new JMenuItem("Pause");
      ActionListener var9 = new ActionListener() {
         @Override
         public void actionPerformed(ActionEvent var1) {
            TVideo.scanConnector.pause();
         }
      };
      var8.addActionListener(var9);
      JMenuItem var10 = new JMenuItem("Resume");
      ActionListener var11 = new ActionListener() {
         @Override
         public void actionPerformed(ActionEvent var1) {
            TVideo.scanConnector.resume();
         }
      };
      var10.addActionListener(var11);
      resumeAfter = new JMenuItem("Resume After");
      ActionListener var12 = new ActionListener() {
         @Override
         public void actionPerformed(ActionEvent var1) {
            TVideo.scanConnector.resumeAfter(TVideo.selectedPortId);
            TVideo.resumeAfter.setEnabled(false);
         }
      };
      resumeAfter.addActionListener(var12);
      resumeAfter.setEnabled(false);
      var2.add((JMenuItem)var3);
      var2.add(var8);
      var2.add(var10);
      var2.add(resumeAfter);
      var1.add(var2);
      JMenu var13 = new JMenu("View");
      final JCheckBoxMenuItem var14 = new JCheckBoxMenuItem("Full Screen");
      var14.addActionListener(new ActionListener() {
         @Override
         public void actionPerformed(ActionEvent var1x) {
            System.out.println(var1x);
            if (var14.isSelected()) {
               JFrame var2x = new JFrame();
               JPanel var3x = new JPanel();
               var3x.setLayout(new GridBagLayout());
               GridBagConstraints var4x = new GridBagConstraints();
               var4x.weightx = 1.0;
               var4x.weighty = 1.0;
               JPanel var5x = new JPanel() {
                  @Override
                  public Dimension getMinimumSize() {
                     return this.getPreferredSize();
                  }
               };
               var5x.setBorder(BorderFactory.createLineBorder(Color.blue));
               var5x.setLayout(new BorderLayout());
               var5x.add(TVideo.frame.getContentPane().getComponent(0));
               var3x.add(var5x, var4x);
               var2x.add(var3x);
               var2x.setUndecorated(true);
               var2x.setAlwaysOnTop(true);
               Dimension var6x = Toolkit.getDefaultToolkit().getScreenSize();
               var2x.setSize(var6x.width, var6x.height);
               var2x.setVisible(true);
               var2x.toFront();
               TVideo.fullScreenFrame = var2x;
               TVideo.frame.setVisible(false);
               TVideo.fullScreenMenuHandler = new FullScreenMenuHandler(var2x, var1, new Component[0], "", true);
               TVideo.fullScreenMenuHandler.startSliding(true);
            } else {
               TVideo.fullScreenMenuHandler.stopSliding();
               TVideo.frame.add(((Container)((Container)TVideo.fullScreenFrame.getContentPane().getComponent(0)).getComponent(0)).getComponent(0));
               TVideo.fullScreenFrame.dispose();
               TVideo.fullScreenMenuHandler = null;
               TVideo.frame.setJMenuBar(var1);
               TVideo.frame.setVisible(true);
               TVideo.frame.pack();
            }
         }
      });
      var13.add((JMenuItem)var14);
      var1.add(var13);
      frame.setJMenuBar(var1);
      frame.getContentPane().setLayout(new BorderLayout());
      JPanel var15 = new JPanel();
      JButton var16 = new JButton("Pause");
      JButton var17 = new JButton("Resume");
      var16.addActionListener(var9);
      var17.addActionListener(var11);
      var15.add(var16);
      var15.add(var17);
      frame.setDefaultCloseOperation(3);
      VideoSnapshotViewer var18 = new VideoSnapshotViewer();
      var18.setThumbnailSize(selectedSize);
      VideoSnapshotViewer var19 = new VideoSnapshotViewer();
      var19.setThumbnailSize(selectedSize);
      VideoSnapshotViewer var20 = new VideoSnapshotViewer();
      var20.setThumbnailSize(selectedSize);
      VideoSnapshotViewer var21 = new VideoSnapshotViewer();
      var21.setThumbnailSize(selectedSize);
      portIds = new String[]{"P_000d5d1d2d4d_0", "P_000d5d1d2d4d_11", "P_000d5d1d2d4d_4", "P_000d5d1d2d4d_15"};
      imgDisp = new VideoSnapshotViewer[]{var18, var19, var20, var21};
      imgPanels = new ArrayList<>();
      imgPanels.add(new VideoSnapshotPanel<>(var18, portIds[0]));
      imgPanels.add(new VideoSnapshotPanel<>(var19, portIds[1]));
      imgPanels.add(new VideoSnapshotPanel<>(var20, portIds[2]));
      imgPanels.add(new VideoSnapshotPanel<>(var21, portIds[3]));

      for (VideoSnapshotPanel var23 : imgPanels) {
         TVideo.SelListener var24 = new TVideo.SelListener();
         var23.addVideoSnapshotSelectionListener(var24);
      }

      for (int var37 = 0; var37 < imgPanels.size(); var37++) {
         VideoSnapshotPanel var39 = imgPanels.get(var37);
         if (var37 < portIds.length) {
            var39.setInformation(portIds[var37]);
         }
      }

      JPanel var38 = new JPanel();
      var38.setBorder(BorderFactory.createEmptyBorder(10, 10, 10, 10));
      GridCalculationUtil.GridLayoutInfo var40 = GridCalculationUtil.calculateColsAndRows(imgPanels.size());
      System.out.println(var40);
      GridLayout var41 = new GridLayout(var40.rows, var40.cols, 10, 10);
      var38.setLayout(var41);
      LinkedList var25 = new LinkedList<>(imgPanels);

      for (Integer var27 : var40.fillers) {
         var25.add(var27 - 1, new JPanel());
      }

      for (JComponent var44 : var25) {
         var44.setBorder(BorderFactory.createLineBorder(Color.RED));
         var38.add(var44);
      }

      videoPanel = var38;
      JScrollPane var43 = new JScrollPane(var38);
      var43.setHorizontalScrollBarPolicy(30);
      var43.setVerticalScrollBarPolicy(20);
      frame.getContentPane().add(var43, "Center");
      frame.pack();
      frame.setVisible(true);
      final HashMap var45 = new HashMap();
      final HashMap var28 = new HashMap();
      int var29 = 0;

      for (String var33 : portIds) {
         var28.put(var33, imgDisp[var29++]);
      }

      var29 = 0;

      for (String var53 : portIds) {
         var45.put(var53, imgPanels.get(var29++));
      }

      ScanEventListener var48 = new ScanEventListener() {
         @Override
         public void videoComponentAvailable(String var1, JComponent var2x) {
            var2x.setVisible(false);
            ((VideoSnapshotViewer)var28.get(var1)).add(var2x);

            assert ((VideoSnapshotViewer)var28.get(var1)).getComponentCount() == 1;
         }

         @Override
         public void scanAbortedOnConnectError() {
            JOptionPane.showMessageDialog(TVideo.frame, "Unable to connect to KX");
            System.exit(0);
         }

         @Override
         public void displayVideoStart(String var1, boolean var2x) {
            ((VideoSnapshotViewer)var28.get(var1)).getComponent(0).setVisible(true);
            if (var2x) {
               ((VideoSnapshotPanel)var45.get(var1)).setTargetState(TargetState.DOWN);
            } else {
               ((VideoSnapshotPanel)var45.get(var1)).setTargetState(TargetState.CONNECTED);
            }
         }

         @Override
         public void displayVideoEnd(String var1, Image var2x) {
            ((VideoSnapshotPanel)var45.get(var1)).setTargetState(TargetState.INACTIVE);
            VideoSnapshotViewer var3x = (VideoSnapshotViewer)var28.get(var1);
            JComponent var4x = (JComponent)var3x.getComponent(0);
            if (var2x != null) {
               var3x.setSnapshot(var2x, var4x.getPreferredSize());
            }

            System.out.println(var4x.getPreferredSize());
            var3x.remove(var4x);

            assert ((VideoSnapshotViewer)var28.get(var1)).getComponentCount() == 0;
         }

         @Override
         public void displayVideoError(String var1, int var2x) {
            ((VideoSnapshotPanel)var45.get(var1)).setTargetState(TargetState.INACTIVE);
            VideoSnapshotViewer var3x = (VideoSnapshotViewer)var28.get(var1);
            var3x.clearShanpshot();
            var3x.remove(var3x.getComponent(0));

            assert ((VideoSnapshotViewer)var28.get(var1)).getComponentCount() == 0;
         }

         @Override
         public void displayVideoCommunicationError(String var1) {
            ((VideoSnapshotPanel)var45.get(var1)).setTargetState(TargetState.INACTIVE);
            VideoSnapshotViewer var2x = (VideoSnapshotViewer)var28.get(var1);
            var2x.clearShanpshot();
            var2x.remove(var2x.getComponent(0));

            assert ((VideoSnapshotViewer)var28.get(var1)).getComponentCount() == 0;
         }

         @Override
         public void scanAborted(INotificationEvent var1) {
            JOptionPane.showMessageDialog(TVideo.frame, "Scan Aborted : " + var1);
            System.exit(0);
         }

         @Override
         public void osdMessageReceived(String var1, String var2x) {
         }
      };
      String[] var50 = new String[]{"P_000d5d1d2d4d_0", "P_000d5d1d2d4d_11", "P_000d5d1d2d4d_4", "P_000d5d1d2d4d_15"};
      String[] var52 = new String[]{"basit_cim1", "Fedora", "vijay_cim1", "WinXP"};
      ArrayList var54 = new ArrayList();

      for (int var34 = 0; var34 < var50.length; var34++) {
         RemoteConsoleParameters var35 = new RemoteConsoleParameters();
         var35.targetPortId = var50[var34];
         var35.portName = var52[var34];
         var35.username = "test";
         var35.password = "raritan";
         var35.host = "192.168.50.207";
         var35.tcpPort = 443;
         var35.ssl = true;
         var54.add(var35);
      }

      scanConnector = new ScanConnector(var54);
      scanConnector.addScanEventListener(var48);
      scanConnector.start(1);
      frame.pack();
      Rectangle var55 = GraphicsEnvironment.getLocalGraphicsEnvironment().getDefaultScreenDevice().getDefaultConfiguration().getBounds();
      Insets var56 = Toolkit.getDefaultToolkit()
         .getScreenInsets(GraphicsEnvironment.getLocalGraphicsEnvironment().getDefaultScreenDevice().getDefaultConfiguration());
      Dimension var36 = new Dimension(var55.width - (var56.left + var56.right), var55.height - (var56.top + var56.bottom));
      if (frame.getWidth() > var36.width || frame.getHeight() > var36.height) {
         frame.setSize(var36);
      }
   }

   private static void createRCCore() throws Exception {
      rccore = RCCoreFactory.loadGraphicalReadOnlyRCCore(null);
      rccore.setScaleToFit(true, true, selectedSize);
   }

   private static void connectRCCore() throws Exception {
      rccore.addVideoEventListener(colorCalListener, 32);
      rccore.addNotificationListener(videoStateNotificationListener);
      rccore.addConnectionEventListener(new TVideo.ConnectionEventHandler(), 8191);
      rccore.connectRCWithUserLogin("192.168.50.207", 443, true, portIds[index], "test", "raritan");
   }

   private static void switchVideo() {
      imgDisp[index].clearShanpshot();
      imgDisp[index].getComponent(0).setVisible(true);
      scanTimer.restart();
   }

   private static void switchOnErrorVideo() {
      imgPanels.get(index).setTargetState(TargetState.BUSY);
      imgDisp[index].clearShanpshot();
      imgDisp[index].remove(rccore.getRCJComponent());
      rccore.disconnect();
      rccore.dispose();
      rccore = null;
      switchTimer.restart();
   }

   static class ConnectionEventHandler extends RCAdapter {
      @Override
      public void disconnected(Exception var1) {
         System.out.println("Disconnected " + var1);
      }

      @Override
      public void connected() {
         System.out.println("Connected");
      }
   }

   static class SelListener implements VideoSnapshotSelectionListener<Object> {
      @Override
      public void videoSnapshotSingleClickSelected(Object var1) {
         System.out.println("Selected " + var1);
         TVideo.scanConnector.pause();
         TVideo.selectedPortId = (String)var1;
         TVideo.resumeAfter.setEnabled(true);
      }

      @Override
      public void videoSnapshotDoubleClickSelected(Object var1) {
      }
   }

   static class SizeSelector implements ActionListener {
      @Override
      public void actionPerformed(ActionEvent var1) {
         String var2 = ((JRadioButtonMenuItem)var1.getSource()).getText();
         if ("320 * 240".equals(var2)) {
            TVideo.selectedSize = new Dimension(320, 240);
         } else if ("160 * 120".equals(var2)) {
            TVideo.selectedSize = new Dimension(160, 120);
         }

         for (VideoSnapshotViewer var6 : TVideo.imgDisp) {
            var6.setThumbnailSize(TVideo.selectedSize);
         }

         ((JComponent)TVideo.videoPanel.getRootPane().getContentPane()).revalidate();
         TVideo.videoPanel.revalidate();
         TVideo.frame.pack();
      }
   }
}
