package nn.pp.common.smartcard;

import java.util.Collections;
import java.util.List;
import nn.pp.common.VMFeatures;

public class SmartCardIndexHelper {
   private final List<VMFeatures> vmFeatures;

   public SmartCardIndexHelper(List<VMFeatures> var1) {
      if (var1 == null) {
         this.vmFeatures = Collections.emptyList();
      } else {
         this.vmFeatures = var1;
      }
   }

   public boolean isSmartCardAvailable() {
      return this.vmFeatures.size() > 0;
   }

   public int getSmartCardIndex(boolean var1, boolean var2, boolean var3, int var4, int var5, int var6) {
      List var7 = this.vmFeatures;

      assert var7.size() > 0;

      Collections.sort(var7);
      int var8 = ((VMFeatures)var7.get(0)).getIndex();
      if (var1) {
         if (var4 == var8) {
            assert var7.size() > 1;

            return ((VMFeatures)var7.get(1)).getIndex();
         } else {
            return var8;
         }
      } else if (var2) {
         if (var5 == var8) {
            assert var7.size() > 1;

            return ((VMFeatures)var7.get(1)).getIndex();
         } else {
            return var8;
         }
      } else if (var3) {
         if (var6 == var8) {
            assert var7.size() > 1;

            return ((VMFeatures)var7.get(1)).getIndex();
         } else {
            return var8;
         }
      } else {
         return var8;
      }
   }
}
