package nn.pp.common.ui.helpers;

import nn.pp.common.KXHttpConnection;
import nn.pp.core.T;

public class AboutSwingWorker extends SwingWorker {
   private String url = null;
   private String descrip = null;
   private ICopyrightHandler callingDialog = null;
   private String host = null;

   public AboutSwingWorker(ICopyrightHandler var1, String var2, String var3, String var4) {
      this.url = var2;
      this.descrip = var3;
      this.callingDialog = var1;
      this.host = var4;
   }

   @Override
   public Object construct() {
      return KXHttpConnection.getArbitraryURL("https://" + this.host, this.url, this.descrip);
   }

   @Override
   public void finished() {
      String var1 = (String)this.getValue();
      if (var1.length() == 0) {
         var1 = T._("Unable to obtain license and copyright data from device.");
         this.callingDialog.fillCopyrightInfo(var1, "", "");
      } else {
         String var2 = "";
         String var3 = "";

         try {
            int var4 = var1.indexOf("<td id=\"licstatement\"");
            var4 = var1.indexOf(">", var4) + 1;
            int var5 = var1.indexOf("</td", var4);
            var2 = var1.substring(var4, var5);
            var3 = this.parseTable(var1);
            var2 = this.reassignHREF(var2);
            var1 = "";
         } catch (RuntimeException var6) {
            var1 = T._("Unable to obtain license and copyright data from device.");
         }

         this.callingDialog.fillCopyrightInfo(var1, var3, var2);
      }
   }

   private String reassignHREF(String var1) {
      return var1.replaceAll("a href=\"/license/", "a href=\"https://" + this.host + "/license/");
   }

   private String parseTable(String var1) {
      if (var1 != null && var1.length() >= 16) {
         int var2 = var1.indexOf("id=\"licences\"");
         var2 = var1.substring(0, var2).lastIndexOf("<table");
         int var3 = var2 + var1.substring(var2).indexOf("</table");
         var3 = var3 + 1 + var1.substring(var3).indexOf(">");
         String var4 = var1.substring(var2, var3);
         var4 = var4.replaceFirst(
            "<table[^>]*>", "<table border=\"1\" rules=\"all\"><caption align=\"left\"><b>" + T._("Open Source Packages:") + "</b></caption>"
         );
         var4 = var4.replaceAll("A_\\(\"", "");
         var4 = var4.replaceAll("\"\\)", "");
         return this.reassignHREF(var4);
      } else {
         return "";
      }
   }
}
