package nn.pp.core;

import java.util.Collections;
import java.util.LinkedHashMap;
import java.util.Map;

public class JVMVersionInfo {
   private static int jvmajor = 0;
   private static int jvminor = 0;
   private static int jvminor_build = 0;
   private static String jvendor = "";
   static JVMVersionInfo vi = null;

   public static JVMVersionInfo getJVMVersionInfo() {
      if (vi == null) {
         vi = new JVMVersionInfo();
      }

      return vi;
   }

   public JVMVersionInfo() {
      String var1 = System.getProperty("java.version");
      System.out.println(var1);
      jvendor = System.getProperty("java.vendor");

      try {
         int var2;
         String var4 = var1.substring(0, var2 = var1.indexOf(46));
         jvmajor = Integer.valueOf(var4);
         int var3 = var1.indexOf(46, var2 + 1);
         String var5 = var1.substring(var2 + 1, var3 < 0 ? var1.length() : var3);
         jvminor = Integer.valueOf(var5);
         int var6 = var1.indexOf(95);
         if (var6 > -1) {
            String var7 = var1.substring(var6 + 1);
            jvminor_build = Integer.valueOf(var7);
         }
      } catch (Exception var8) {
      }

      System.out.println("JVMVersionInfo: java.vender=" + jvendor + " java.version=" + var1 + " major=" + jvmajor + " minor=" + jvminor);
   }

   public boolean isJava12() {
      return jvmajor == 1 && jvminor >= 2;
   }

   public boolean isJava13() {
      return jvmajor == 1 && jvminor >= 3;
   }

   public boolean isJava14() {
      return jvmajor == 1 && jvminor >= 4;
   }

   public boolean isJava15() {
      return jvmajor == 1 && jvminor >= 5;
   }

   public boolean isJava16() {
      return jvmajor == 1 && jvminor >= 6;
   }

   public boolean isJava17() {
      return jvmajor == 1 && jvminor >= 7;
   }

   public boolean isPJava() {
      return jvmajor == 3 && jvminor == 1;
   }

   public boolean isNSJava() {
      return jvendor.startsWith("Netscape");
   }

   public boolean isMSJava() {
      return jvendor.startsWith("Microsoft");
   }

   public int getMajorVersion() {
      return jvmajor;
   }

   public int getMinorVersion() {
      return jvminor;
   }

   public int getMinorBuildVersion() {
      return jvminor_build;
   }

   public static Map<String, String> getSystemProperties() {
      LinkedHashMap var0 = new LinkedHashMap();
      var0.put("JVM Version", System.getProperty("java.version"));
      var0.put("JVM Vendor", System.getProperty("java.vm.vendor"));
      var0.put("Operating System", System.getProperty("os.name"));
      var0.put("Operating System Version", System.getProperty("os.version"));
      var0.put("System Architecture", System.getProperty("os.arch"));
      return Collections.unmodifiableMap(var0);
   }

   @Override
   public String toString() {
      return new String(
         "JVMVersionInfo: Java13="
            + this.isJava13()
            + ", Java14="
            + this.isJava14()
            + ", Java15="
            + this.isJava15()
            + ", Java16="
            + this.isJava16()
            + ", Java17="
            + this.isJava17()
            + ", PJava="
            + this.isPJava()
            + "isNSJava="
            + this.isNSJava()
            + ", isMSJava="
            + this.isMSJava()
      );
   }
}
