package nn.pp.core;

import java.awt.Dimension;
import java.io.UnsupportedEncodingException;
import java.lang.reflect.ParameterizedType;
import java.lang.reflect.Type;
import java.net.Inet6Address;
import java.net.InetAddress;
import java.net.UnknownHostException;
import java.security.MessageDigest;
import java.security.NoSuchAlgorithmException;

public class Util {
   public static String getURLCompatibleIP(String var0) {
      String var1 = var0;
      InetAddress var2 = null;

      try {
         var2 = InetAddress.getByName(var1);
      } catch (UnknownHostException var4) {
         var4.printStackTrace();
      }

      if (var2 instanceof Inet6Address) {
         var1 = "[" + var2.getHostAddress() + "]";
      }

      return var1;
   }

   public static String getURLCompatibleIP(String var0, int var1) {
      return getURLCompatibleIP(var0) + ":" + var1;
   }

   public static String binToHex(byte[] var0) {
      String var1 = "";

      for (int var2 = 0; var2 < var0.length; var2++) {
         int var3 = var0[var2] & 255;
         if (var3 <= 15) {
            var1 = var1 + "0";
         }

         var1 = var1 + Integer.toHexString(var3).toUpperCase();
      }

      return var1;
   }

   public static byte[] getHash(byte[] var0, byte[]... var1) throws NoSuchAlgorithmException {
      String var2 = null;

      try {
         var2 = new String(var0, "ISO-8859-1");
      } catch (UnsupportedEncodingException var9) {
      }

      String var3;
      if (var2.startsWith("{SHA256}")) {
         var3 = "SHA-256";
      } else {
         var3 = "MD5";
      }

      MessageDigest var4 = MessageDigest.getInstance(var3);
      var4.update(var0);

      for (byte[] var8 : var1) {
         var4.update(var8, 0, var8.length);
      }

      return var4.digest();
   }

   public static ParameterizedType getParameterizedType(Object var0, Class var1) {
      for (Type var5 : var0.getClass().getGenericInterfaces()) {
         if (var5 instanceof ParameterizedType) {
            ParameterizedType var6 = (ParameterizedType)var5;
            if (var6.getRawType().equals(var1)) {
               return var6;
            }
         }
      }

      return null;
   }

   public static void main(String[] var0) throws Exception {
      System.out
         .println(binToHex(getHash("ABCDEFGHIJKLMNOPQRSTUVWXYZABCDEFGHIJKLMNOPQRSTUVWXYZABCDEFGHIJKL".getBytes("ISO-8859-1"), "ABCD".getBytes("ISO-8859-1"))));
   }

   public static Dimension getScaledDimension(Dimension var0, Dimension var1) {
      Dimension var2 = new Dimension();
      int var3 = var0.width;
      int var4 = var0.height;
      double var5 = (double)var1.height / var1.width;
      double var7 = (double)var1.width / var3;
      double var9 = (double)var1.height / var4;
      if (var7 >= var9) {
         int var11 = (int)(var3 * var5 + 0.5);
         int var12 = var4 - var11;
         var2.height = var4 - var12;
         var2.width = var3;
      } else {
         int var13 = (int)(var4 / var5 + 0.5);
         int var14 = var3 - var13;
         var2.width = var3 - var14;
         var2.height = var4;
      }

      return var2;
   }
}
