package nn.pp.ext;

import nn.pp.ext.macro.IMacroHelper;
import nn.pp.ext.macro.IMacroParser;
import nn.pp.ext.macro.MacroException;
import nn.pp.ext.macro.MacroFactory;
import nn.pp.ext.pref.ApplicationPreferences;
import nn.pp.ext.pref.IApplicationPreferences;

public class ExtensionFactory {
   private static ExtensionFactory factory = null;
   private IApplicationPreferences applicationPreferences = null;

   private ExtensionFactory() {
   }

   public static ExtensionFactory getInstance() {
      synchronized (ExtensionFactory.class) {
         if (factory == null) {
            factory = new ExtensionFactory();
         }
      }

      return factory;
   }

   public synchronized IApplicationPreferences getApplicationPreferences() {
      if (this.applicationPreferences == null) {
         this.applicationPreferences = new ApplicationPreferences();
      }

      return this.applicationPreferences;
   }

   public IMacroParser getMacroParser() throws MacroException {
      return MacroFactory.getInstance().getMacroParser();
   }

   public IMacroHelper getMacroHelper() throws MacroException {
      return MacroFactory.getInstance().getMacroHelper();
   }
}
