package nn.pp.ext.macro;

import java.io.File;
import java.io.IOException;
import java.util.List;
import java.util.SortedMap;
import org.xml.sax.SAXException;

public interface IMacroParser {
   int NUMBER_OF_ATTRIBUTES = 3;

   IMacro getKeyboardMacro(String var1);

   List<IMacro> getKeyboardMacros() throws MacroException;

   List<IMacro> getKeyboardMacros(String var1) throws MacroException;

   void createKeyboardMacro(IMacro var1) throws MacroException;

   void createKeyboardMacro(IMacro var1, boolean var2) throws MacroException;

   void saveKeyboardMacro() throws MacroException;

   void saveKeyboardMacro(String var1) throws MacroException;

   void updateKeyboardMacro(IMacro var1, String var2) throws MacroException;

   void updateKeyboardMacro(IMacro var1, String var2, boolean var3) throws MacroException;

   void deleteKeyboardMacro(IMacro var1) throws MacroException;

   void deleteKeyboardMacro(IMacro var1, boolean var2) throws MacroException;

   SortedMap<String, IMacro> getValidMacros(File var1) throws IOException, SAXException;

   String getBackupFilename();
}
