package nn.pp.ext.macro;

public final class MacroFactory {
   private static final MacroFactory macroFactory = new MacroFactory();

   private MacroFactory() {
   }

   public static MacroFactory getInstance() {
      return macroFactory;
   }

   public IMacroParser getMacroParser() {
      return new KeyboardMacroParserImpl();
   }

   public IMacroHelper getMacroHelper() {
      MacroHelperImpl var1 = new MacroHelperImpl();
      var1.init();
      return var1;
   }
}
