package nn.pp.ext.macro;

import com.util.kbd.KeyHIDValue;
import com.util.kbd.KeyboardKey;
import com.util.kbd.KeyboardMappings;
import com.util.kbd.KeyboardUtil;
import java.util.Locale;

public class MacroHelperImpl extends KeyboardUtil implements IMacroHelper {
   private static KeyboardMappings keyboardMappings = null;

   MacroHelperImpl() {
   }

   @Override
   public void init() {
      keyboardMappings = new KeyboardMappings();
   }

   @Override
   public int getVKCode(short[] var1, short var2) {
      short[] var3 = var1 == null ? KeyHIDValue.HIDMAP : var1;
      KeyboardKey var4 = keyboardMappings.getItem(var2);
      return var4 == null ? -1 : KeyboardUtil.getVKCodeForMacroCode(var3, var4.getKeyCode());
   }

   @Override
   public int getVKCode(short var1, Locale var2) {
      KeyboardKey var3 = keyboardMappings.getItem(var1);
      if (var3.getKeyCode() == 230) {
         return 65406;
      } else if (var3.getKeyCode() == 104) {
         return 61440;
      } else if (var3.getKeyCode() == 105) {
         return 61441;
      } else if (var3.getKeyCode() == 106) {
         return 61442;
      } else {
         return var3.getKeyCode() == 107 ? 61443 : KeyboardUtil.getVKCodeForMacroCode(var3.getKeyCode(), var2);
      }
   }

   @Override
   public char getKeyChar(short[] var1, short var2) {
      KeyboardKey var3 = keyboardMappings.getItem(var2);
      char var4 = '\n';
      if (var3 != null && var3.getKeyName() != null && var3.getKeyName().length() == 1) {
         var4 = var3.getKeyName().charAt(0);
      }

      return var4;
   }

   @Override
   public char getKeyChar(short var1, Locale var2) {
      return this.getKeyChar(KeyHIDValue.HIDMAP, var1);
   }

   @Override
   public String getKeyName(int var1) {
      KeyboardKey var2 = keyboardMappings.getItem(var1);
      return var2 != null ? var2.getKeyName() : null;
   }

   @Override
   public KeyboardMappings getKeyMappings() {
      return keyboardMappings;
   }
}
