package nn.pp.logging;

import java.io.PrintWriter;
import java.io.StringWriter;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.logging.Formatter;
import java.util.logging.LogRecord;

public class LogFormatter extends Formatter {
   private static Date today = new Date();
   private static final SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss.SSSZ");
   private static final String lineSep = System.getProperty("line.separator");

   public static String getDate(long var0) {
      today.setTime(var0);
      return sdf.format(today);
   }

   @Override
   public String format(LogRecord var1) {
      StringBuilder var2 = new StringBuilder()
         .append(getDate(System.currentTimeMillis()))
         .append(":")
         .append(var1.getLevel())
         .append(":")
         .append(Thread.currentThread().getName())
         .append(":")
         .append(var1.getSourceClassName())
         .append(":")
         .append(var1.getSourceMethodName())
         .append(":")
         .append(var1.getMessage())
         .append(' ')
         .append(lineSep);
      if (var1.getThrown() != null) {
         try {
            StringWriter var3 = new StringWriter();
            PrintWriter var4 = new PrintWriter(var3);
            var1.getThrown().printStackTrace(var4);
            var4.close();
            var2.append(var3);
         } catch (Exception var5) {
            var5.printStackTrace();
         }
      }

      return var2.toString();
   }
}
