package nn.pp.rccore;

public class KvmPort implements IKvmPort {
   private String portNo;
   private String uniquePortId;
   private String portName;
   private boolean vmPortType;
   private IKvmPort.KvmPermission kvmPermission;
   private IKvmPort.VmPermission vmPermission;

   public KvmPort(String var1, String var2, String var3, IKvmPort.KvmPermission var4, IKvmPort.VmPermission var5) {
      this.portNo = var1;
      this.uniquePortId = var2;
      this.portName = var3;
      this.kvmPermission = var4;
      this.vmPermission = var5;
   }

   public KvmPort(String var1, String var2, String var3, IKvmPort.KvmPermission var4, IKvmPort.VmPermission var5, boolean var6) {
      this.portNo = var1;
      this.uniquePortId = var2;
      this.portName = var3;
      this.kvmPermission = var4;
      this.vmPermission = var5;
      this.vmPortType = var6;
   }

   public KvmPort(IKvmPort var1) {
      this.kvmPermission = var1.getKvmPermission();
      this.vmPermission = var1.getVmPermission();
      this.uniquePortId = new String(var1.getUniquePortId());
      this.portName = new String(var1.getPortName());
      this.portNo = var1.getPortNo();
      this.vmPortType = var1.isVmPortType();
   }

   @Override
   public boolean equals(Object var1) {
      if (var1 instanceof String) {
         return this.uniquePortId.equals((String)var1);
      } else if (!(var1 instanceof KvmPort)) {
         return false;
      } else {
         KvmPort var2 = (KvmPort)var1;
         return this.uniquePortId.equals(var2.uniquePortId)
            && this.portName.equals(var2.portName)
            && this.portNo == var2.portNo
            && this.kvmPermission == var2.kvmPermission
            && this.vmPermission == var2.vmPermission;
      }
   }

   @Override
   public String toString() {
      return this.portName;
   }

   @Override
   public String getPortNo() {
      return this.portNo;
   }

   @Override
   public void setPortNo(String var1) {
      this.portNo = var1;
   }

   @Override
   public String getUniquePortId() {
      return this.uniquePortId;
   }

   @Override
   public void setUniquePortId(String var1) {
      this.uniquePortId = var1;
   }

   @Override
   public String getPortName() {
      return this.portName;
   }

   @Override
   public IKvmPort.KvmPermission getKvmPermission() {
      return this.kvmPermission;
   }

   @Override
   public IKvmPort.VmPermission getVmPermission() {
      return this.vmPermission;
   }

   @Override
   public void setKvmPermission(IKvmPort.KvmPermission var1) {
      this.kvmPermission = var1;
   }

   @Override
   public void setVMPermission(IKvmPort.VmPermission var1) {
      this.vmPermission = var1;
   }

   @Override
   public boolean isVmPortType() {
      return this.vmPortType;
   }

   @Override
   public void setVmPortType(boolean var1) {
      this.vmPortType = var1;
   }
}
