package nn.pp.rccore;

import java.util.logging.Logger;
import nn.pp.rccore.impl.RCCoreGenericImpl;
import nn.pp.rccore.impl.RCCoreImplGraphical;
import nn.pp.rccore.impl.RCCoreProvider;
import nn.pp.rccore.impl.RemoteConsoleRenderer;
import nn.pp.rccore.impl.RemoteConsoleRendererMemory;

public class RCCoreFactory implements RCCoreProvider {
   public static RCCore loadGraphicalRCCoreNoVolatileImage(Logger var0) {
      RCCoreImplGraphical var1 = new RCCoreImplGraphical(var0, false);
      var1.init();
      return var1;
   }

   public static RCCore loadGraphicalRCCore(Logger var0) {
      RCCoreImplGraphical var1 = new RCCoreImplGraphical(var0, true);
      var1.init();
      return var1;
   }

   public static RCCore loadMemoryBufferRCCore(Logger var0) {
      RCCoreGenericImpl var1 = new RCCoreGenericImpl(var0, new RemoteConsoleRendererMemory());
      var1.init();
      return var1;
   }

   public static RCCore loadGraphicalReadOnlyRCCore(Logger var0) {
      RCCoreImplGraphical var1 = new RCCoreImplGraphical(var0, true);
      var1.init();
      var1.setMonitorMode(true);
      var1.setOsdDisabled(true);
      return var1;
   }

   @Override
   public RCCore createRCCore(RemoteConsoleRenderer var1) {
      RCCoreGenericImpl var2 = new RCCoreGenericImpl(null, var1);
      var2.init();
      return var2;
   }
}
