package nn.pp.rccore;

import java.util.Arrays;
import java.util.List;

public class VMConfigInfo implements IVMConfigInfo {
   private int[] vmconfig;
   private String errorMsg = "ERROR: ";
   private static final List<Integer> validValues;

   public VMConfigInfo(int[] var1) {
      this.vmconfig = var1;
   }

   @Override
   public int[] getVMConfig() {
      return this.vmconfig;
   }

   public int validate() {
      if (this.vmconfig.length >= 0 && this.vmconfig.length <= 4) {
         for (int var1 = 0; var1 < this.vmconfig.length; var1++) {
            if (this.vmconfig[var1] != 0 && this.vmconfig[var1] != 1 && this.vmconfig[var1] != 4 && this.vmconfig[var1] != 2 && this.vmconfig[var1] != 5) {
               this.errorMsg = this.errorMsg + "received index: " + this.vmconfig[var1];
            }
         }
      } else {
         this.errorMsg = this.errorMsg + "Invalid number of devices";
      }

      return this.errorMsg.length() > 7 ? -1 : 1;
   }

   public int validate_28() {
      if (this.vmconfig.length >= 0 && this.vmconfig.length <= 4) {
         for (int var1 = 0; var1 < this.vmconfig.length; var1++) {
            if (!validValues.contains(this.vmconfig[var1])) {
               this.errorMsg = this.errorMsg + "received index: " + this.vmconfig[var1];
            }
         }
      } else {
         this.errorMsg = this.errorMsg + "Invalid number of devices";
      }

      return this.errorMsg.length() > 7 ? -1 : 1;
   }

   public String getErrorMessage() {
      return this.errorMsg;
   }

   @Override
   public String toString() {
      StringBuffer var1 = new StringBuffer();
      var1.append("VMConfigInfo: [");

      for (int var2 = 0; var2 < this.vmconfig.length; var2++) {
         var1.append(this.vmconfig[var2] + (var2 != this.vmconfig.length - 1 ? "," : "]"));
      }

      return var1.toString();
   }

   static {
      byte var0 = 0;
      byte var1 = 2;
      byte var2 = 8;
      byte var3 = 1;
      byte var4 = 4;
      byte var5 = 5;
      byte var6 = 9;
      byte var7 = 12;
      byte var8 = 13;
      byte var9 = 16;
      byte var10 = 17;
      byte var11 = 20;
      byte var12 = 21;
      byte var13 = 24;
      byte var14 = 25;
      byte var15 = 28;
      byte var16 = 29;
      validValues = Arrays.asList(
         Integer.valueOf(var0),
         Integer.valueOf(var1),
         Integer.valueOf(var2),
         Integer.valueOf(var3),
         Integer.valueOf(var4),
         Integer.valueOf(var5),
         Integer.valueOf(var6),
         Integer.valueOf(var7),
         Integer.valueOf(var8),
         Integer.valueOf(var9),
         Integer.valueOf(var10),
         Integer.valueOf(var11),
         Integer.valueOf(var12),
         Integer.valueOf(var13),
         Integer.valueOf(var14),
         Integer.valueOf(var15),
         Integer.valueOf(var16)
      );
   }
}
