package nn.pp.rccore;

import java.text.MessageFormat;
import nn.pp.core.T;

public class VideoSettings implements IVideoSettings {
   private VideoSettings.VideoSettingInteger brightness;
   private VideoSettings.VideoSettingInteger brightnessRed;
   private VideoSettings.VideoSettingInteger brightnessGreen;
   private VideoSettings.VideoSettingInteger brightnessBlue;
   private VideoSettings.VideoSettingInteger contrastRed;
   private VideoSettings.VideoSettingInteger contrastGreen;
   private VideoSettings.VideoSettingInteger contrastBlue;
   private VideoSettings.VideoSettingInteger clock;
   private VideoSettings.VideoSettingInteger phase;
   private VideoSettings.VideoSettingInteger offsetX;
   private VideoSettings.VideoSettingInteger offsetY;
   private VideoSettings.VideoSettingInteger noiseFilter;
   private VideoSettings.VideoSettingBoolean autoColorCalibration;
   private VideoSettings.VideoSettingBoolean autoAutoAdjust;
   private VideoSettings.VideoSettingAction resetAllModes;
   private VideoSettings.VideoSettingAction resetThisMode;
   private VideoSettings.VideoSettingAction resetThisPort;
   private VideoSettings.VideoSettingAction saveSettings;
   private VideoSettings.VideoSettingAction cancelSettings;
   private VideoSettings.VideoSettingIntegerReadOnly resolutionX;
   private VideoSettings.VideoSettingIntegerReadOnly resolutionY;
   private VideoSettings.VideoSettingIntegerReadOnly refreshRate;

   public VideoSettings.VideoSettingInteger getBrightness() {
      return this.brightness;
   }

   public VideoSettings.VideoSettingInteger getBrightnessRed() {
      return this.brightnessRed;
   }

   public VideoSettings.VideoSettingInteger getBrightnessGreen() {
      return this.brightnessGreen;
   }

   public VideoSettings.VideoSettingInteger getBrightnessBlue() {
      return this.brightnessBlue;
   }

   public VideoSettings.VideoSettingInteger getContrastRed() {
      return this.contrastRed;
   }

   public VideoSettings.VideoSettingInteger getContrastGreen() {
      return this.contrastGreen;
   }

   public VideoSettings.VideoSettingInteger getContrastBlue() {
      return this.contrastBlue;
   }

   public VideoSettings.VideoSettingInteger getPhase() {
      return this.phase;
   }

   public VideoSettings.VideoSettingInteger getClock() {
      return this.clock;
   }

   public VideoSettings.VideoSettingInteger getOffsetX() {
      return this.offsetX;
   }

   public VideoSettings.VideoSettingInteger getOffsetY() {
      return this.offsetY;
   }

   public VideoSettings.VideoSettingInteger getNoiseFilter() {
      return this.noiseFilter;
   }

   public VideoSettings.VideoSettingBoolean getAutoColorCalibration() {
      return this.autoColorCalibration;
   }

   public VideoSettings.VideoSettingBoolean getAutoAutoAdjust() {
      return this.autoAutoAdjust;
   }

   public VideoSettings.VideoSettingAction getResetAllModes() {
      return this.resetAllModes;
   }

   public VideoSettings.VideoSettingAction getResetThisMode() {
      return this.resetThisMode;
   }

   public VideoSettings.VideoSettingAction getResetThisPort() {
      return this.resetThisPort;
   }

   public VideoSettings.VideoSettingAction getSaveSettings() {
      return this.saveSettings;
   }

   public VideoSettings.VideoSettingAction getCancelSettings() {
      return this.cancelSettings;
   }

   public VideoSettings.VideoSettingIntegerReadOnly getResolutionX() {
      return this.resolutionX;
   }

   public VideoSettings.VideoSettingIntegerReadOnly getResolutionY() {
      return this.resolutionY;
   }

   public VideoSettings.VideoSettingIntegerReadOnly getRefreshRate() {
      return this.refreshRate;
   }

   public VideoSettings() {
      this.brightness = new VideoSettings.VideoSettingInteger(0, 127);
      this.brightnessRed = new VideoSettings.VideoSettingInteger(0, 127);
      this.brightnessGreen = new VideoSettings.VideoSettingInteger(0, 127);
      this.brightnessBlue = new VideoSettings.VideoSettingInteger(0, 127);
      this.contrastRed = new VideoSettings.VideoSettingInteger(0, 255);
      this.contrastGreen = new VideoSettings.VideoSettingInteger(0, 255);
      this.contrastBlue = new VideoSettings.VideoSettingInteger(0, 255);
      this.clock = new VideoSettings.VideoSettingInteger(0, 4096);
      this.phase = new VideoSettings.VideoSettingInteger(0, 31);
      this.offsetX = new VideoSettings.VideoSettingInteger(0, 512);
      this.offsetY = new VideoSettings.VideoSettingInteger(0, 128);
      this.noiseFilter = new VideoSettings.VideoSettingInteger(0, 7);
      this.autoColorCalibration = new VideoSettings.VideoSettingBoolean();
      this.autoAutoAdjust = new VideoSettings.VideoSettingBoolean();
      this.resetAllModes = new VideoSettings.VideoSettingAction();
      this.resetThisMode = new VideoSettings.VideoSettingAction();
      this.resetThisPort = new VideoSettings.VideoSettingAction();
      this.saveSettings = new VideoSettings.VideoSettingAction();
      this.cancelSettings = new VideoSettings.VideoSettingAction();
      this.resolutionX = new VideoSettings.VideoSettingIntegerReadOnly();
      this.resolutionY = new VideoSettings.VideoSettingIntegerReadOnly();
      this.refreshRate = new VideoSettings.VideoSettingIntegerReadOnly();
   }

   public VideoSettings(IVideoSettings var1) {
      this.brightness = new VideoSettings.VideoSettingInteger(var1.getBrightness());
      this.brightnessRed = new VideoSettings.VideoSettingInteger(var1.getBrightnessRed());
      this.brightnessGreen = new VideoSettings.VideoSettingInteger(var1.getBrightnessGreen());
      this.brightnessBlue = new VideoSettings.VideoSettingInteger(var1.getBrightnessBlue());
      this.contrastRed = new VideoSettings.VideoSettingInteger(var1.getContrastRed());
      this.contrastGreen = new VideoSettings.VideoSettingInteger(var1.getContrastGreen());
      this.contrastBlue = new VideoSettings.VideoSettingInteger(var1.getContrastBlue());
      this.clock = new VideoSettings.VideoSettingInteger(var1.getClock());
      this.phase = new VideoSettings.VideoSettingInteger(var1.getPhase());
      this.offsetX = new VideoSettings.VideoSettingInteger(var1.getOffsetX());
      this.offsetY = new VideoSettings.VideoSettingInteger(var1.getOffsetY());
      this.noiseFilter = new VideoSettings.VideoSettingInteger(var1.getNoiseFilter());
      this.autoColorCalibration = new VideoSettings.VideoSettingBoolean(var1.getAutoColorCalibration());
      this.autoAutoAdjust = new VideoSettings.VideoSettingBoolean(var1.getAutoAutoAdjust());
      this.resetAllModes = new VideoSettings.VideoSettingAction(var1.getResetAllModes());
      this.resetThisMode = new VideoSettings.VideoSettingAction(var1.getResetThisMode());
      this.resetThisPort = new VideoSettings.VideoSettingAction(var1.getResetThisPort());
      this.saveSettings = new VideoSettings.VideoSettingAction(var1.getSaveSettings());
      this.cancelSettings = new VideoSettings.VideoSettingAction(var1.getCancelSettings());
      this.resolutionX = new VideoSettings.VideoSettingIntegerReadOnly(var1.getResolutionX());
      this.resolutionY = new VideoSettings.VideoSettingIntegerReadOnly(var1.getResolutionY());
      this.refreshRate = new VideoSettings.VideoSettingIntegerReadOnly(var1.getRefreshRate());
   }

   @Override
   public String toString() {
      return "brightness: "
         + this.brightness.toString()
         + "brightnessRed: "
         + this.brightnessRed.toString()
         + "brightnessGreen: "
         + this.brightnessGreen.toString()
         + "brightnessBlue: "
         + this.brightnessBlue.toString()
         + "contrastRed: "
         + this.contrastRed.toString()
         + "contrastGreen: "
         + this.contrastGreen.toString()
         + "contrastBlue: "
         + this.contrastBlue.toString()
         + "clock: "
         + this.clock.toString()
         + "phase: "
         + this.phase.toString()
         + "offsetX: "
         + this.offsetX.toString()
         + "offsetY: "
         + this.offsetY.toString()
         + "noiseFilter: "
         + this.noiseFilter.toString()
         + "autoColorCalibration: "
         + this.autoColorCalibration.toString()
         + "autoAutoAdjust: "
         + this.autoAutoAdjust.toString()
         + "resetAllModes: "
         + this.resetAllModes.toString()
         + "resetThisMode: "
         + this.resetThisMode.toString()
         + "resetThisPort: "
         + this.resetThisPort.toString()
         + "saveSettings: "
         + this.saveSettings.toString()
         + "cancelSettings: "
         + this.cancelSettings.toString()
         + "resolutionX: "
         + this.resolutionX.toString()
         + "resolutionY: "
         + this.resolutionY.toString()
         + "refreshRate: "
         + this.refreshRate.toString();
   }

   public abstract class VideoSetting implements IVideoSettings.IVideoSetting {
      private boolean supported = false;

      @Override
      public boolean isSupported() {
         return this.supported;
      }

      @Override
      public void setSupported(boolean var1) {
         this.supported = var1;
      }

      public VideoSetting() {
         this.supported = false;
      }

      public VideoSetting(VideoSettings.VideoSetting var2) {
         this.supported = var2.supported;
      }
   }

   public class VideoSettingAction extends VideoSettings.VideoSetting implements IVideoSettings.IVideoSettingAction {
      public VideoSettingAction() {
      }

      public VideoSettingAction(IVideoSettings.IVideoSettingAction var2) {
         super((VideoSettings.VideoSetting)var2);
      }

      @Override
      public String toString() {
         return MessageFormat.format(T._("[Action - supported: {0}]"), this.isSupported() ? T._("yes") : T._("no"));
      }
   }

   public class VideoSettingBoolean extends VideoSettings.VideoSetting implements IVideoSettings.IVideoSettingBoolean {
      private boolean enabled = false;

      @Override
      public boolean isEnabled() {
         return this.enabled;
      }

      @Override
      public void setEnabled(boolean var1) {
         this.enabled = var1;
      }

      public VideoSettingBoolean() {
         this.enabled = false;
      }

      public VideoSettingBoolean(IVideoSettings.IVideoSettingBoolean var2) {
         super((VideoSettings.VideoSetting)var2);
         this.enabled = var2.isEnabled();
      }

      @Override
      public String toString() {
         return MessageFormat.format(
            T._("[Boolean - supported: {0}, value: {1}]"), this.isSupported() ? T._("yes") : T._("no"), this.isEnabled() ? T._("true") : T._("false")
         );
      }
   }

   public class VideoSettingInteger extends VideoSettings.VideoSettingIntegerReadOnly implements IVideoSettings.IVideoSettingInteger {
      private int minValue = 0;
      private int maxValue = 0;

      @Override
      public int getMinValue() {
         return this.minValue;
      }

      @Override
      public void setMinValue(int var1) {
         this.minValue = var1;
      }

      @Override
      public int getMaxValue() {
         return this.maxValue;
      }

      @Override
      public void setMaxValue(int var1) {
         this.maxValue = var1;
      }

      public VideoSettingInteger(int var2, int var3) {
         this.minValue = var2;
         this.maxValue = var3;
      }

      public VideoSettingInteger(IVideoSettings.IVideoSettingInteger var2) {
         super((VideoSettings.VideoSettingIntegerReadOnly)var2);
         this.minValue = var2.getMinValue();
         this.maxValue = var2.getMaxValue();
      }
   }

   public class VideoSettingIntegerReadOnly extends VideoSettings.VideoSetting implements IVideoSettings.IVideoSettingIntegerReadOnly {
      private int value = 0;

      @Override
      public int getValue() {
         return this.value;
      }

      @Override
      public void setValue(int var1) {
         this.value = var1;
      }

      @Override
      public String toString() {
         return MessageFormat.format(T._("[Integer - supported: {0}, value: {1}]"), this.isSupported() ? T._("yes") : T._("no"), new Integer(this.getValue()));
      }

      public VideoSettingIntegerReadOnly() {
         this.value = 0;
      }

      public VideoSettingIntegerReadOnly(IVideoSettings.IVideoSettingIntegerReadOnly var2) {
         super((VideoSettings.VideoSetting)var2);
         this.value = var2.getValue();
      }
   }
}
