package nn.pp.rccore;

public class VirtualMediaConfig {
   private VirtualMediaConfig.Config[] configs;

   public VirtualMediaConfig(int var1) {
      this.configs = new VirtualMediaConfig.Config[var1];

      for (int var2 = 0; var2 < var1; var2++) {
         this.configs[var2] = new VirtualMediaConfig.Config();
      }
   }

   public VirtualMediaConfig(VirtualMediaConfig var1) {
      this.configs = new VirtualMediaConfig.Config[var1.configs.length];

      for (int var2 = 0; var2 < this.configs.length; var2++) {
         this.configs[var2] = new VirtualMediaConfig.Config(var1.configs[var2]);
      }
   }

   public void setCdrom(int var1, boolean var2) {
      if (var1 < this.configs.length) {
         this.configs[var1].cdrom = var2;
      }
   }

   public void setFloppy(int var1, boolean var2) {
      if (var1 < this.configs.length) {
         this.configs[var1].floppy = var2;
      }
   }

   public void setRemovable(int var1, boolean var2) {
      if (var1 < this.configs.length) {
         this.configs[var1].removable = var2;
      }
   }

   public int getNoMassStorage() {
      return this.configs.length;
   }

   public boolean getCdrom(int var1) {
      return var1 < this.configs.length ? this.configs[var1].cdrom : false;
   }

   public boolean getFloppy(int var1) {
      return var1 < this.configs.length ? this.configs[var1].floppy : false;
   }

   public boolean getRemovable(int var1) {
      return var1 < this.configs.length ? this.configs[var1].removable : false;
   }

   private class Config {
      boolean cdrom;
      boolean floppy;
      boolean removable;

      Config() {
         this.cdrom = this.floppy = this.removable = false;
      }

      Config(VirtualMediaConfig.Config var2) {
         this.cdrom = var2.cdrom;
         this.floppy = var2.floppy;
         this.removable = var2.removable;
      }
   }
}
