package nn.pp.rccore.impl;

import nn.pp.rccore.IAudioStatusExSupport;

public class AudioStatusExSupport implements IAudioStatusExSupport, IAudioStatusExSupport.IListener {
   private AudioStatusExListenerList list;
   private IAudioStatusExSupport.AudioStatus speakerStatus = new IAudioStatusExSupport.AudioStatus(false, null);
   private IAudioStatusExSupport.AudioStatus micStatus = new IAudioStatusExSupport.AudioStatus(false, null);

   public AudioStatusExSupport(AudioStatusExListenerList var1) {
      this.list = var1;
      this.addListener(this);
   }

   @Override
   public void audioSettingsChanged(IAudioStatusExSupport.AudioStatus var1, IAudioStatusExSupport.AudioStatus var2) {
      this.speakerStatus = var1;
      this.micStatus = var2;
   }

   @Override
   public void addListener(IAudioStatusExSupport.IListener var1) {
      this.list.addListener(var1);
   }

   @Override
   public void removeListener(IAudioStatusExSupport.IListener var1) {
      this.list.removeListener(var1);
   }

   @Override
   public IAudioStatusExSupport.AudioStatus getSpeakerStatus() {
      return this.speakerStatus;
   }

   @Override
   public IAudioStatusExSupport.AudioStatus getMicrophoneStatus() {
      return this.micStatus;
   }
}
