package nn.pp.rccore.impl;

import java.util.List;
import java.util.Locale;
import java.util.Vector;
import nn.pp.core.impl.ListenerList;
import nn.pp.rccore.ConnectionEventListener;
import nn.pp.rccore.IKvmPort;
import nn.pp.rccore.KvmPort;

public class ConnectionEventListenerList extends ListenerList<ConnectionEventListener> {
   public void fireDisconnected(final Exception var1) {
      this.fire(new ConnectionEventListenerAction() {
         @Override
         public void run() {
            this.listener.disconnected(var1);
         }
      });
   }

   public void fireConnected() {
      this.fire(new ConnectionEventListenerAction() {
         @Override
         public void run() {
            this.listener.connected();
         }
      });
   }

   public String firePortListChanged(List<? extends IKvmPort> var1) {
      final Vector var2 = new Vector();

      for (IKvmPort var4 : var1) {
         var2.add(new KvmPort(var4));
      }

      String var5 = new ListenerList.FireResult<String>().fire(new ConnectionEventListenerActionString() {
         @Override
         public void run() {
            this.result = this.listener.portListChanged(var2);
         }
      }, 1);
      return var5 != null ? var5 : null;
   }

   public void fireServerSessionIdChanged(final int var1) {
      this.fire(new ConnectionEventListenerAction() {
         @Override
         public void run() {
            this.listener.serverSessionIdChanged(var1);
         }
      }, 2);
   }

   public void fireConnectedUsersChanged(final int var1) {
      this.fire(new ConnectionEventListenerAction() {
         @Override
         public void run() {
            this.listener.connectedUsersChanged(var1);
         }
      }, 4);
   }

   public void fireMonitorModePermissionChanged(final boolean var1) {
      this.fire(new ConnectionEventListenerAction() {
         @Override
         public void run() {
            this.listener.monitorModePermissionChanged(var1);
         }
      }, 8);
   }

   public void fireMonitorModeChanged(final boolean var1) {
      this.fire(new ConnectionEventListenerAction() {
         @Override
         public void run() {
            this.listener.monitorModeChanged(var1);
         }
      }, 8);
   }

   public void fireExclusiveModePermissionChanged(final boolean var1) {
      this.fire(new ConnectionEventListenerAction() {
         @Override
         public void run() {
            this.listener.exclusiveModePermissionChanged(var1);
         }
      }, 16);
   }

   public void fireExclusiveModeChanged(final boolean var1) {
      this.fire(new ConnectionEventListenerAction() {
         @Override
         public void run() {
            this.listener.exclusiveModeChanged(var1);
         }
      }, 16);
   }

   public void fireLanguageChanged(Locale var1) {
      final Locale var2 = StringLocale.loadLocale(var1);
      this.fire(new ConnectionEventListenerAction() {
         @Override
         public void run() {
            this.listener.languageChanged(var2);
         }
      }, 32);
   }

   public void fireProtocolVersionChanged(String var1) {
      final String var2 = new String(var1);
      this.fire(new ConnectionEventListenerAction() {
         @Override
         public void run() {
            this.listener.protocolVersionChanged(var2);
         }
      }, 64);
   }

   public void fireDeviceNameChanged(String var1) {
      final String var2 = new String(var1);
      this.fire(new ConnectionEventListenerAction() {
         @Override
         public void run() {
            this.listener.deviceNameChanged(var2);
         }
      }, 128);
   }

   public void fireIncomingTrafficSpeed(final int var1) {
      this.fire(new ConnectionEventListenerAction() {
         @Override
         public void run() {
            this.listener.incomingTrafficSpeed(var1);
         }
      }, 256);
   }

   public void fireOutgoingTrafficSpeed(final int var1) {
      this.fire(new ConnectionEventListenerAction() {
         @Override
         public void run() {
            this.listener.outgoingTrafficSpeed(var1);
         }
      }, 256);
   }

   public void fireFramesPerSecond(final int var1) {
      this.fire(new ConnectionEventListenerAction() {
         @Override
         public void run() {
            this.listener.framesPerSecond(var1);
         }
      }, 256);
   }

   public void fireChatWelcomeChanged(String var1) {
      final String var2 = new String(var1);
      this.fire(new ConnectionEventListenerAction() {
         @Override
         public void run() {
            this.listener.chatWelcomeChanged(var2);
         }
      }, 512);
   }

   public void fireNewChatMessage(String var1) {
      final String var2 = new String(var1);
      this.fire(new ConnectionEventListenerAction() {
         @Override
         public void run() {
            this.listener.newChatMessage(var2);
         }
      }, 512);
   }

   public void fireCimLanguageOptionsSupported(final boolean var1) {
      this.fire(new ConnectionEventListenerAction() {
         @Override
         public void run() {
            this.listener.cimLanguageOptionsSupported(var1);
         }
      }, 2048);
   }

   public void fireEthernetGigabitSupported(final boolean var1) {
      this.fire(new ConnectionEventListenerAction() {
         @Override
         public void run() {
            this.listener.ethernetGigabitSupported(var1);
         }
      }, 4096);
   }
}
