package nn.pp.rccore.impl;

import java.util.List;
import java.util.Locale;
import java.util.Vector;
import nn.pp.core.impl.ListenerList;
import nn.pp.rccore.KeyboardInfoListener;
import nn.pp.rccore.KeyboardMacro;
import nn.pp.rccore.RCCore;

public class KeyboardInfoListenerList extends ListenerList<KeyboardInfoListener> {
   public void fireKeyboardMacroListChanged(List<KeyboardMacro> var1) {
      final Vector var2 = new Vector(var1.size());

      for (KeyboardMacro var4 : var1) {
         var2.add(new KeyboardMacro(var4));
      }

      this.fire(new KeyboardInfoListenerAction() {
         @Override
         public void run() {
            this.listener.keyboardMacroListChanged(var2);
         }
      }, 1);
   }

   public void fireSoftKeyboardMappingChanged(Locale var1) {
      final Locale var2 = StringLocale.loadLocale(var1);
      this.fire(new KeyboardInfoListenerAction() {
         @Override
         public void run() {
            this.listener.softKeyboardMappingChanged(var2);
         }
      }, 2);
   }

   public void fireLocalKeyboardMappingChanged(Locale var1) {
      final Locale var2 = StringLocale.loadLocale(var1);
      this.fire(new KeyboardInfoListenerAction() {
         @Override
         public void run() {
            this.listener.localKeyboardMappingChanged(var2);
         }
      }, 4);
   }

   public void fireKeyboardLedStateChanged(List<RCCore.KeyboardLed> var1) {
      final Vector var2 = new Vector(var1);
      this.fire(new KeyboardInfoListenerAction() {
         @Override
         public void run() {
            this.listener.keyboardLedStateChanged(var2);
         }
      }, 8);
   }

   public void fireSunKeyboardSupported(final boolean var1) {
      this.fire(new KeyboardInfoListenerAction() {
         @Override
         public void run() {
            this.listener.sunKeyboardSupported(var1);
         }
      }, 16);
   }
}
