package nn.pp.rccore.impl;

import java.util.HashMap;
import java.util.Map;
import nn.pp.rccore.ILicenseSupport;

public class LicenseSupport implements ILicenseSupport, ILicenseSupport.IListener {
   private LicenseSupportListenerList list;
   private Map<String, Boolean> features;

   public LicenseSupport(LicenseSupportListenerList var1) {
      this.list = var1;
      this.addListener(this);
   }

   @Override
   public boolean isFeatureLicensed(String var1) {
      if (this.features == null) {
         return true;
      } else {
         Boolean var2 = this.features.get(var1.toLowerCase());
         return var2 != null ? var2 : false;
      }
   }

   @Override
   public Map<String, Boolean> getLicensedFeatures() {
      return this.features;
   }

   @Override
   public void licenseFeatureSupportChanged(String var1, boolean var2) {
      if (this.features == null) {
         this.features = new HashMap<>();
      }

      this.features.put(var1.toLowerCase(), var2);
   }

   @Override
   public void addListener(ILicenseSupport.IListener var1) {
      this.list.addListener(var1);
   }

   @Override
   public void removeListener(ILicenseSupport.IListener var1) {
      this.list.removeListener(var1);
   }
}
