package nn.pp.rccore.impl;

import java.util.Timer;
import java.util.TimerTask;
import java.util.logging.Logger;
import javax.net.ssl.X509TrustManager;
import nn.pp.core.impl.DeviceConnector;

public class MonitoringDeviceConnector extends DeviceConnector {
   private Timer trafficTimer = new Timer("Traffic");

   public MonitoringDeviceConnector(Logger var1, X509TrustManager var2, final ConnectionEventListenerList var3) {
      super(var1, var2);
      this.trafficTimer.schedule(new TimerTask() {
         @Override
         public void run() {
            int var1x = 0;
            int var2x = 0;
            synchronized (MonitoringDeviceConnector.this.streamMtx) {
               if (MonitoringDeviceConnector.this.inputStream != null) {
                  var1x = MonitoringDeviceConnector.this.inputStream.getAndClearIn();
               }

               if (MonitoringDeviceConnector.this.outputStream != null) {
                  var2x = MonitoringDeviceConnector.this.outputStream.getAndClearOut();
               }
            }

            var3.fireIncomingTrafficSpeed(var1x);
            var3.fireOutgoingTrafficSpeed(var2x);
         }
      }, 1000L, 1000L);
   }

   @Override
   public void disconnect() {
      if (this.trafficTimer != null) {
         this.trafficTimer.cancel();
      }

      super.disconnect();
   }
}
