package nn.pp.rccore.impl;

import java.util.List;
import java.util.Vector;
import nn.pp.core.impl.ListenerList;
import nn.pp.rccore.MouseModeListener;
import nn.pp.rccore.RCCore;

public class MouseModeListenerList extends ListenerList<MouseModeListener> {
   public void fireMouseModeChangeSupportChanged(final boolean var1) {
      this.fire(new MouseModeListenerAction() {
         @Override
         public void run() {
            this.listener.mouseModeChangeSupportChanged(var1);
         }
      }, 1);
   }

   public void fireSupportedMouseModesChanged(List<RCCore.MouseMode> var1) {
      final Vector var2 = new Vector(var1);
      this.fire(new MouseModeListenerAction() {
         @Override
         public void run() {
            this.listener.supportedMouseModesChanged(var2);
         }
      }, 1);
   }

   public void fireMouseModeChanged(final RCCore.MouseMode var1) {
      this.fire(new MouseModeListenerAction() {
         @Override
         public void run() {
            this.listener.mouseModeChanged(var1);
         }
      }, 1);
   }

   public void fireSingleCursorModeSupportChanged(final boolean var1) {
      this.fire(new MouseModeListenerAction() {
         @Override
         public void run() {
            this.listener.singleCursorModeSupportChanged(var1);
         }
      }, 2);
   }

   public void fireSingleCursorModeChanged(final boolean var1) {
      this.fire(new MouseModeListenerAction() {
         @Override
         public void run() {
            this.listener.singleCursorModeChanged(var1);
         }
      }, 2);
   }

   public void fireMouseSyncSupportChanged(final boolean var1) {
      this.fire(new MouseModeListenerAction() {
         @Override
         public void run() {
            this.listener.mouseSyncSupportChanged(var1);
         }
      }, 4);
   }
}
