package nn.pp.rccore.impl;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.image.VolatileImage;
import java.util.logging.Logger;
import nn.pp.core.T;

public class RemoteConsoleRendererGraphicalVolatileImage extends RemoteConsoleRendererGraphical {
   private VolatileImage vimage;
   private boolean initialPaint = true;

   RemoteConsoleRendererGraphicalVolatileImage(Logger var1, ListenerLists var2) {
      super(var1, var2);
   }

   @Override
   public String toString() {
      return T._("Renderer with Volatile Image acceleration");
   }

   @Override
   protected void createImage() {
      if (this.vimage != null) {
         this.vimage.flush();
      }

      if (this.graphics != null) {
         this.graphics.dispose();
      }

      this.image = this.vimage = this.createVolatileImage(this.dimension.width, this.dimension.height);
      if (this.vimage != null) {
         this.graphics = this.vimage.createGraphics();
      }
   }

   @Override
   public void paintComponent(Graphics var1) {
      if (this.image != null) {
         Dimension var2 = this.getPreferredSize();

         do {
            switch (this.vimage.validate(this.getGraphicsConfiguration())) {
               case 0:
                  if (this.initialPaint) {
                     this.renewer.renewFramebuffer();
                  }
                  break;
               case 2:
                  this.createImage();
               case 1:
                  this.graphics.dispose();
                  this.graphics = this.vimage.createGraphics();
                  this.graphics.setColor(Color.black);
                  this.graphics.fillRect(0, 0, var2.width, var2.height);
                  this.renewer.renewFramebuffer();
            }

            this.paintContentInterpolated(var1, var2);
            this.initialPaint = false;
         } while (this.vimage.contentsLost());
      }
   }

   @Override
   public void dispose() {
      if (this.vimage != null) {
         this.vimage = null;
         super.dispose();
      }
   }
}
