package nn.pp.rccore.impl;

import java.awt.Color;
import java.awt.Cursor;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Image;
import java.awt.Rectangle;
import java.awt.image.BufferedImage;
import java.text.ParseException;
import java.util.concurrent.locks.ReadWriteLock;
import javax.swing.JComponent;
import nn.pp.rccore.RCCore;

public class RemoteConsoleRendererMemory implements RemoteConsoleRenderer {
   private BufferedImage image;
   private Graphics graphics;
   private Object imageMtx = new Object();
   private Dimension dimension = new Dimension(640, 480);
   private boolean osdDisabled = false;

   @Override
   public JComponent getRCJComponent() {
      return null;
   }

   @Override
   public BufferedImage getSnapshot() {
      return this.getSnapshot(null);
   }

   @Override
   public BufferedImage getSnapshot(Rectangle var1) {
      synchronized (this.imageMtx) {
         if (var1 == null) {
            var1 = new Rectangle(0, 0, this.dimension.width, this.dimension.height);
         } else if (var1.x < 0
            || var1.y < 0
            || var1.width < 0
            || var1.height < 0
            || var1.x + var1.width > this.dimension.width
            || var1.y + var1.height > this.dimension.height) {
            throw new IllegalArgumentException();
         }

         BufferedImage var3 = new BufferedImage(var1.width, var1.height, 1);
         Graphics var4 = var3.getGraphics();
         var4.drawImage(this.image, 0, 0, var1.width, var1.height, var1.x, var1.y, var1.x + var1.width, var1.y + var1.height, null);
         return var3;
      }
   }

   @Override
   public void drawRemoteConsoleData(Image var1, int var2, int var3, int var4, int var5) {
      synchronized (this.imageMtx) {
         this.graphics.setClip(var2, var3, var4, var5);
         this.graphics.drawImage(var1, 0, 0, null);
         this.graphics.setClip(0, 0, this.dimension.width, this.dimension.height);
      }
   }

   @Override
   public void screenResolutionChanged(Dimension var1) {
      synchronized (this.imageMtx) {
         this.dimension = new Dimension(var1.width, var1.height);
         this.createImage(var1);
      }
   }

   private void createImage(Dimension var1) {
      this.image = new BufferedImage(var1.width, var1.height, 1);
      this.graphics = this.image.getGraphics();
   }

   @Override
   public void setOSD(String var1, int var2, boolean var3) {
   }

   @Override
   public void init() {
      this.createImage(new Dimension(640, 480));
   }

   @Override
   public void dispose() {
      this.graphics.dispose();
   }

   @Override
   public void setRenewer(FramebufferRenewer var1) {
   }

   @Override
   public void setSingleCursorMode(boolean var1) {
   }

   @Override
   public void setMouseSyncString(String var1) {
   }

   @Override
   public void setMouseSyncKeys(String var1, String var2) throws ParseException {
   }

   @Override
   public void setCaptureRightAway(boolean var1) {
   }

   @Override
   public void setEnforceSmmHotkeyCheck(boolean var1) {
   }

   @Override
   public void setOsdBgColor(Color var1) {
   }

   @Override
   public void setOsdFgColor(Color var1) {
   }

   @Override
   public void setOsdAlpha(int var1) {
   }

   @Override
   public void setOsdPosition(String var1) {
   }

   public Cursor getCursor() {
      return null;
   }

   public void setCursor(Cursor var1) {
   }

   @Override
   public double getScalingX() {
      return 1.0;
   }

   @Override
   public double getScalingY() {
      return 1.0;
   }

   @Override
   public boolean isScaleToFit() {
      return false;
   }

   @Override
   public boolean isScaleToFitKeepAr() {
      return false;
   }

   @Override
   public void setScaling(double var1, double var3) throws IllegalArgumentException {
   }

   @Override
   public void setScaleToFit(boolean var1, boolean var2, Dimension var3) {
   }

   @Override
   public RCCore.Interpolation getInterpolation() {
      return RCCore.Interpolation.NONE;
   }

   @Override
   public void setInterpolation(RCCore.Interpolation var1) {
   }

   @Override
   public void setFrameSize(Dimension var1) {
   }

   @Override
   public <CT> CT getCapablity(Class<CT> var1) {
      return null;
   }

   @Override
   public boolean isOsdDisabled() {
      return this.osdDisabled;
   }

   @Override
   public void setOsdDisabled(boolean var1) {
      this.osdDisabled = var1;
   }

   @Override
   public ReadWriteLock getLock() {
      return null;
   }

   @Override
   public void setImageProvider(ImageProvider var1) {
   }
}
