package nn.pp.rccore.impl;

import java.awt.Dimension;
import java.awt.Rectangle;
import java.util.List;
import java.util.Vector;
import nn.pp.core.impl.ListenerList;
import nn.pp.rccore.RCCore;
import nn.pp.rccore.VideoEventListener;
import nn.pp.rccore.VideoSettings;

public class VideoEventListenerList extends ListenerList<VideoEventListener> {
   public void fireEncodingChangeAllowed(final boolean var1) {
      this.fire(new VideoEventListenerAction() {
         @Override
         public void run() {
            this.listener.encodingChangeAllowed(var1);
         }
      }, 1);
   }

   public void fireEncodingAutoSupportedChanged(final boolean var1) {
      this.fire(new VideoEventListenerAction() {
         @Override
         public void run() {
            this.listener.encodingAutoSupportedChanged(var1);
         }
      }, 2);
   }

   public void fireSupportedEncodingPredefinesChanged(List<RCCore.Predefine> var1) {
      final Vector var2 = new Vector(var1);
      this.fire(new VideoEventListenerAction() {
         @Override
         public void run() {
            this.listener.supportedEncodingPredefinesChanged(var2);
         }
      }, 2);
   }

   public void fireSupportedEncodingColorDepthsChanged(List<RCCore.ColorDepth> var1) {
      final Vector var2 = new Vector(var1);
      this.fire(new VideoEventListenerAction() {
         @Override
         public void run() {
            this.listener.supportedEncodingColorDepthsChanged(var2);
         }
      }, 2);
   }

   public void fireSupportedEncodingCompressionsChanged(List<RCCore.Compression> var1) {
      final Vector var2 = new Vector(var1);
      this.fire(new VideoEventListenerAction() {
         @Override
         public void run() {
            this.listener.supportedEncodingCompressionsChanged(var2);
         }
      }, 2);
   }

   public void fireEncodingLossySupportedChanged(final boolean var1) {
      this.fire(new VideoEventListenerAction() {
         @Override
         public void run() {
            this.listener.encodingLossySupportedChanged(var1);
         }
      }, 2);
   }

   public void fireEncodingAutoChanged(final boolean var1) {
      this.fire(new VideoEventListenerAction() {
         @Override
         public void run() {
            this.listener.encodingAutoChanged(var1);
         }
      }, 4);
   }

   public void fireEncodingColorDepthChanged(final RCCore.ColorDepth var1) {
      this.fire(new VideoEventListenerAction() {
         @Override
         public void run() {
            this.listener.encodingColorDepthChanged(var1);
         }
      }, 4);
   }

   public void fireEncodingCompressionChanged(final RCCore.Compression var1) {
      this.fire(new VideoEventListenerAction() {
         @Override
         public void run() {
            this.listener.encodingCompressionChanged(var1);
         }
      }, 4);
   }

   public void fireEncodingLossyChanged(final boolean var1) {
      this.fire(new VideoEventListenerAction() {
         @Override
         public void run() {
            this.listener.encodingLossyChanged(var1);
         }
      }, 4);
   }

   public void fireVideoSettingsSupportChanged(final boolean var1) {
      this.fire(new VideoEventListenerAction() {
         @Override
         public void run() {
            this.listener.videoSettingsSupportChanged(var1);
         }
      }, 8);
   }

   public void fireVideoAutoAdjustSupportChanged(final boolean var1) {
      this.fire(new VideoEventListenerAction() {
         @Override
         public void run() {
            this.listener.videoAutoAdjustSupportChanged(var1);
         }
      }, 8);
   }

   public void fireColorCalibrationSupportChanged(final boolean var1) {
      this.fire(new VideoEventListenerAction() {
         @Override
         public void run() {
            this.listener.colorCalibrationSupportChanged(var1);
         }
      }, 8);
   }

   public void fireVideoRefreshSupportChanged(final boolean var1) {
      this.fire(new VideoEventListenerAction() {
         @Override
         public void run() {
            this.listener.videoRefreshSupportChanged(var1);
         }
      }, 8);
   }

   public void fireVideoSettingsUpdated(VideoSettings var1) {
      final VideoSettings var2 = new VideoSettings(var1);
      this.fire(new VideoEventListenerAction() {
         @Override
         public void run() {
            this.listener.videoSettingsUpdated(var2);
         }
      }, 8);
   }

   public void fireResolutionChanged(Dimension var1) {
      final Dimension var2 = new Dimension(var1);
      this.fire(new VideoEventListenerAction() {
         @Override
         public void run() {
            this.listener.resolutionChanged(var2);
         }
      }, 16);
   }

   public void fireOsdMessageReceived(final String var1, final boolean var2) {
      this.fire(new VideoEventListenerAction() {
         @Override
         public void run() {
            this.listener.osdMessageReceived(var1, var2);
         }
      }, 32);
   }

   public void fireVideoDataUpdated(int var1, int var2, int var3, int var4) {
      final Rectangle var5 = new Rectangle(var1, var2, var3, var4);
      this.fire(new VideoEventListenerAction() {
         @Override
         public void run() {
            this.listener.videoDataUpdated(var5);
         }
      }, 64);
   }
}
