package nn.pp.rccore.impl;

import java.util.List;
import java.util.Vector;
import nn.pp.core.impl.ListenerList;
import nn.pp.rccore.UsbProfileList;
import nn.pp.rccore.VMConfigInfo;
import nn.pp.rccore.VMMountRequestResponse;
import nn.pp.rccore.VirtualMediaInfoListener;

public class VirtualMediaInfoListenerList extends ListenerList<VirtualMediaInfoListener> {
   public void fireVirtualMediaSupportChanged(final boolean var1) {
      this.fire(new VirtualMediaInfoListenerAction() {
         @Override
         public void run() {
            this.listener.virtualMediaSupportChanged(var1);
         }
      }, 1);
   }

   public void fireVirtualMediaReadOnlyChanged(final boolean var1) {
      this.fire(new VirtualMediaInfoListenerAction() {
         @Override
         public void run() {
            this.listener.virtualMediaReadOnlyChanged(var1);
         }
      }, 1);
   }

   public void fireVirtualMediaDriveCountChanged(final int var1) {
      this.fire(new VirtualMediaInfoListenerAction() {
         @Override
         public void run() {
            this.listener.virtualMediaDriveCountChanged(var1);
         }
      }, 1);
   }

   public void fireRemoteIsoSupportChanged(final boolean var1) {
      this.fire(new VirtualMediaInfoListenerAction() {
         @Override
         public void run() {
            this.listener.remoteIsoSupportChanged(var1);
         }
      }, 2);
   }

   public void fireRemoteIsoListChanged(List<VMMountRequestResponse> var1) {
      final Vector var2 = new Vector(var1);
      this.fire(new VirtualMediaInfoListenerAction() {
         @Override
         public void run() {
            this.listener.remoteIsoListChanged(var2);
         }
      }, 2);
   }

   public void fireRemoteIsoMountFinished(VMMountRequestResponse var1) {
      final VMMountRequestResponse var2 = new VMMountRequestResponse(var1);
      this.fire(new VirtualMediaInfoListenerAction() {
         @Override
         public void run() {
            this.listener.remoteIsoMountFinished(var2);
         }
      }, 2);
   }

   public void fireVirtualMediaConfigChanged(final VMConfigInfo var1) {
      this.fire(new VirtualMediaInfoListenerAction() {
         @Override
         public void run() {
            this.listener.virtualMediaConfigChanged(var1);
         }
      }, 4);
   }

   public void fireUsbProfileListChanged(final UsbProfileList var1) {
      this.fire(new VirtualMediaInfoListenerAction() {
         @Override
         public void run() {
            this.listener.UsbProfileListChanged(var1);
         }
      }, 4);
   }
}
