package nn.pp.rccore.impl.keyboard;

import java.awt.event.KeyEvent;
import java.util.Hashtable;
import java.util.Locale;

public abstract class KeyTranslator {
   private Hashtable<KeycodeWithLocation, Integer> keyMappingsByCode = new Hashtable<>();
   private Hashtable<Integer, Integer> keyMappingsByCharacter = new Hashtable<>();
   static final int PseudoVK_RIGHT_SHIFT = 272;
   static final int PseudoVK_RIGHT_CONTROL = 273;
   static final int PseudoVK_RIGHT_WINDOWS = 268;

   public KeyTranslator() {
      this.addKeys();
   }

   protected void addKeyMappingByCode(int var1, int var2, int var3) {
      this.keyMappingsByCode.put(new KeycodeWithLocation(var1, var2), var3);
   }

   protected void addKeyMappingByCharacter(int var1, int var2) {
      this.keyMappingsByCharacter.put(var1, var2);
   }

   public int translateKeyEvent(KeyEvent var1) {
      return this.translateKeyEvent(var1.getKeyCode(), var1.getKeyChar(), var1.getKeyLocation());
   }

   public int translateKeyEvent(int var1, char var2, int var3) {
      Integer var4 = this.getByCode(var1, var3);
      if (var4 != null) {
         return var4;
      } else {
         var4 = this.keyMappingsByCharacter.get(Integer.valueOf(var2));
         return var4 != null ? var4 : -1;
      }
   }

   protected Integer getByCode(int var1, int var2) {
      Integer var3 = this.keyMappingsByCode.get(new KeycodeWithLocation(var1, var2));
      if (var3 == null && var2 == 0) {
         var3 = this.keyMappingsByCode.get(new KeycodeWithLocation(var1, 1));
      }

      return var3;
   }

   public abstract Locale getLocale();

   public boolean allowAltGr() {
      return true;
   }

   public void loadKeys() {
   }

   protected void addKeys() {
   }

   public void dispose() {
      if (this.keyMappingsByCode != null) {
         this.keyMappingsByCode = null;
      }

      if (this.keyMappingsByCharacter != null) {
         this.keyMappingsByCharacter = null;
      }
   }
}
