package nn.pp.rccore.impl.mouse;

import java.awt.Point;
import java.awt.event.MouseEvent;
import java.awt.event.MouseWheelEvent;
import nn.pp.rccore.RCCore;
import nn.pp.rccore.impl.MouseEventListenerList;
import nn.pp.rccore.impl.RemoteConsoleRendererGraphical;

public abstract class MouseHandler extends MyMouseAdapter {
   public static final int BUTTON_1 = 1;
   public static final int BUTTON_2 = 2;
   public static final int BUTTON_3 = 4;
   protected int pointerMask = 0;
   protected Point oldPos = new Point(0, 0);
   protected Point currentPos = new Point(0, 0);
   protected RemoteConsoleRendererGraphical renderer;
   protected MouseEventListenerList mouseListenerList;

   public MouseHandler(RemoteConsoleRendererGraphical var1, MouseEventListenerList var2) {
      this.renderer = var1;
      this.mouseListenerList = var2;
   }

   public void dispose() {
   }

   public int processMouseButtonEvent(MouseEvent var1, int var2) {
      int var3 = var1.getButton();
      byte var4 = 0;
      int var5 = 0;
      if (var3 == 1) {
         var4 = 1;
      } else if (var3 == 2) {
         var4 = 2;
      } else if (var3 == 3) {
         var4 = 4;
      }

      if ((var2 & var4) == 0) {
         var5 = var2 | var4;
      } else {
         var5 = var2 & ~var4;
      }

      return var5;
   }

   protected int getPointerMask(MouseEvent var1) {
      this.pointerMask = this.processMouseButtonEvent(var1, this.pointerMask);
      return this.pointerMask;
   }

   public void clearPointerMask() {
      this.pointerMask = 0;
   }

   public abstract void doMouseSync(RCCore.MouseSyncType var1);

   public abstract void handleMouseSyncHotkey();

   protected abstract int getPointerMask();

   @Override
   public void mouseWheelMoved(MouseWheelEvent var1) {
      MouseEventConsumer var2 = this.renderer.getMouseEventConsumer();
      int var3 = this.getPointerMask();
      int var4 = var1.getWheelRotation();
      if (var2 != null) {
         var2.consumeMouseWheelEvent(var4, var3);
      }

      this.mouseListenerList.fireMouseWheelEvent(var4, var3);
   }

   public void setCaptureRightAway(boolean var1) {
   }
}
