package nn.pp.rccore.impl.mouse;

import java.awt.event.MouseEvent;
import nn.pp.rccore.RCCore;
import nn.pp.rccore.impl.MouseEventListenerList;
import nn.pp.rccore.impl.RemoteConsoleRendererGraphical;

public class MouseHandlerAbsolute extends MouseHandler {
   public MouseHandlerAbsolute(RemoteConsoleRendererGraphical var1, MouseEventListenerList var2) {
      super(var1, var2);
   }

   @Override
   public void doMouseSync(RCCore.MouseSyncType var1) {
      MouseEventConsumer var2 = this.renderer.getMouseEventConsumer();
      if (var2 != null) {
         var2.handleMouseSync(var1);
         var2.consumeAbsoluteMouseEvent((int)this.oldPos.getX(), (int)this.oldPos.getY(), this.pointerMask);
         this.mouseListenerList.fireAbsoluteMouseEvent((int)this.oldPos.getX(), (int)this.oldPos.getY(), this.pointerMask);
      }
   }

   @Override
   protected int getPointerMask() {
      return this.pointerMask;
   }

   @Override
   public void handleMouseSyncHotkey() {
      this.doMouseSync(RCCore.MouseSyncType.FAST);
   }

   @Override
   public void mouseEntered(MouseEvent var1) {
      this.clearPointerMask();
   }

   @Override
   public void mouseExited(MouseEvent var1) {
      this.clearPointerMask();
      if (var1.getModifiersEx() == 1024) {
         MouseEvent var2 = new MouseEvent(this.renderer, 502, var1.getWhen(), var1.getModifiers(), var1.getX(), var1.getY(), 1, false);
         this.processMouseEvent(var2);
      }
   }

   @Override
   public void mousePressed(MouseEvent var1) {
      this.renderer.requestFocusInWindow();
      this.pointerMask = this.getPointerMask(var1);
      this.processMouseEvent(var1);
   }

   @Override
   public void mouseReleased(MouseEvent var1) {
      this.clearPointerMask();
      this.processMouseEvent(var1);
   }

   @Override
   public void mouseMoved(MouseEvent var1) {
      this.processMouseEvent(var1);
   }

   @Override
   public void mouseDragged(MouseEvent var1) {
      this.processMouseEvent(var1);
   }

   private void processMouseEvent(MouseEvent var1) {
      MouseEventConsumer var2 = this.renderer.getMouseEventConsumer();
      if (var2 != null && this.renderer.isFocusOwner()) {
         this.currentPos.setLocation(var1.getX(), var1.getY());
         this.renderer.descalePoint(this.currentPos);
         this.oldPos.setLocation(this.currentPos);
         var2.consumeAbsoluteMouseEvent((int)this.currentPos.getX(), (int)this.currentPos.getY(), this.pointerMask);
         this.mouseListenerList.fireAbsoluteMouseEvent((int)this.currentPos.getX(), (int)this.currentPos.getY(), this.pointerMask);
      }
   }

   @Override
   public void setCaptureRightAway(boolean var1) {
   }
}
