package nn.pp.rccore.impl.rfb;

import java.io.IOException;
import java.text.MessageFormat;
import java.util.logging.Logger;
import nn.pp.core.T;
import nn.pp.core.impl.MonitoringDataInputStream;
import nn.pp.rccore.RCException;

public class ImageDecoderRaw extends ImageDecoderSoftware {
   protected byte[] rawBuf;

   public ImageDecoderRaw(Logger var1, RfbHandler var2) {
      super(var1, var2);
   }

   @Override
   public void decodeImage(
      MonitoringDataInputStream var1,
      int[] var2,
      int var3,
      int var4,
      int var5,
      int var6,
      int var7,
      int var8,
      int var9,
      int var10,
      int var11,
      RfbPixelFormat var12
   ) throws IOException, RCException {
      if (var12.bitsPerPixel == 8) {
         this.drawRawRect8(var1, var2, var8, var9, var10, var11, var3, var12);
      } else {
         if (var12.bitsPerPixel != 16) {
            throw new RCException(MessageFormat.format(T._("Raw Encoding for {0} bits color depth not supported"), var12.bitsPerPixel));
         }

         this.drawRawRect16(var1, var2, var8, var9, var10, var11, var3, var12);
      }
   }

   protected final void checkRawBufSize(int var1) {
      if (this.rawBuf == null || this.rawBuf.length < var1) {
         this.rawBuf = new byte[var1];
      }
   }

   protected final void drawRawRect8(MonitoringDataInputStream var1, int[] var2, int var3, int var4, int var5, int var6, int var7, RfbPixelFormat var8) throws IOException, RCException {
      int var9 = var5 * var6;
      this.checkRawBufSize(var9);
      var1.readFully(this.rawBuf, 0, var9);
      this.colorDecode8(var2, this.rawBuf, var4 * var7 + var3, var5, var6, var7);
   }

   protected final void drawRawRect16(MonitoringDataInputStream var1, int[] var2, int var3, int var4, int var5, int var6, int var7, RfbPixelFormat var8) throws IOException, RCException {
      int var9 = 2 * var5 * var6;
      this.checkRawBufSize(var9);
      var1.readFully(this.rawBuf, 0, var9);
      this.colorDecode16(var2, this.rawBuf, var4 * var7 + var3, var5, var6, var7, var8.bigEndian);
   }
}
