package nn.pp.rccore.impl.rfb;

import nn.pp.core.NotificationEvent;
import nn.pp.core.T;

public class RfbNotificationEvent extends NotificationEvent {
   public RfbNotificationEvent(int var1, int var2) {
      super(var1, var2);
   }

   public RfbNotificationEvent(int var1, int var2, boolean var3, String var4) {
      super(var1, var2, var3, var4);
   }

   public NotificationEvent clone() {
      return new RfbNotificationEvent(this.flags, this.errorCode);
   }

   @Override
   public String getMessage() {
      return getMessageString(this.getErrorCode());
   }

   public static String getMessageString(int var0) {
      String var1 = null;
      switch (var0) {
         case 10001:
            var1 = T._("Invalid message from server. Please see logs (if enabled) for details");
            break;
         case 268435457:
            var1 = T._("Permission denied to perform this operation.\nContact your system administrator.");
            break;
         case 268435458:
            var1 = T._("Access denied. Your account is currently disabled.\nContact your system administrator.");
            break;
         case 268435459:
            var1 = T._("Authentication failed.\nPlease check your user name and password; then try again.");
            break;
         case 268500993:
            var1 = T._("Maximum number of virtual media connections reached on the Port.\nPlease try again later.");
            break;
         case 268500994:
            var1 = T._(
               "Virtual Media mounting on the Port failed.\nUnable to connect to the File Server \nor incorrect File Server user name and password.\nContact your system administrator."
            );
            break;
         case 268500995:
            var1 = T._("Virtual Media mounting on the Port failed.\nConnection denied by File Server.\nContact your system administrator.");
            break;
         case 268500996:
            var1 = T._("Virtual Media mounting on the Port denied.\nVM Share Mode is set to OFF.\nContact your system administrator.");
            break;
         case 268500997:
            var1 = T._("Virtual Media mounting on the Port failed.\nThere is an unexpected communication error.\nPlease try again later.");
            break;
         case 268500998:
            var1 = T._("Virtual Media mounting on the Port failed.\nThe selected mass storage device is already in use.");
            break;
         case 268500999:
            var1 = T._(
               "Virtual Media mounting on the Port failed.\nPermission to mount the image onto the target is denied.\nContact your system administrator."
            );
            break;
         case 268501000:
            var1 = T._("A VM connection is currently in use. Please try again later.");
            break;
         case 268566529:
            var1 = T._("Exclusive access is active.\nContact your system administrator.");
            break;
         case 268566530:
            var1 = T._("Connection to the Port denied.\nContact your system administrator.");
            break;
         case 268566531:
            var1 = T._("Maximum number of users are already connected to this port.\nPlease try again later.");
            break;
         case 268566532:
            var1 = T._("Connecting to the Port failed. This may be due to switching failure or could not detect video.\nPlease try again later.");
            break;
         case 268566533:
            var1 = T._("Maximum number of KVM connections has exceeded.\nPlease try again later.");
            break;
         case 268566534:
            var1 = T._("Connection to the port denied.\nVirtual Media connection is active and VM Share Mode is set to OFF.\nPlease try again later.");
            break;
         case 268566538:
            var1 = T._("Communication Error. Failed to connect to target.");
            break;
         case 268697601:
            var1 = T._(
               "There was a problem in the communication. Please try again.\nIf you receive this error repeatedly. Contact Raritan technical support for assistance."
            );
            break;
         case 268697602:
            var1 = T._(
               "There was a problem communicating with this device. Please update your client application.\nIf you receive this error repeatedly, contact Raritan techincal support for assistance."
            );
            break;
         case 268697603:
            var1 = T._(
               "There was a problem communicating with this device. Please update your client application.\nIf you receive this error repeatedly, contact Raritan techincal support for assistance."
            );
            break;
         case 268697604:
            var1 = T._(
               "There was a problem in the communication. Please try again.\nIf you receive this error repeatedly. Contact Raritan technical support for assistance."
            );
            break;
         case 268828673:
            var1 = T._("SSL connection enforced by the device, but unencrypted connection detected.\nPlease reconnect using SSL.");
            break;
         case 268894209:
            var1 = T._(
               "Cannot switch to a different USB profile.\nVirtual Media connections are currently active.\nPlease close all the Virtual Media connections and try again."
            );
            break;
         case 268894211:
            var1 = T._("Cannot switch to the specified USB Profile. This profile is not applicable for the connected CIM.");
            break;
         case 285343753:
            var1 = T._(
               "WARNING: Your CIM has older firmware.\nSome of the newer features may not work.\nPlease upgrade your CIM to a newer firmware to take advantage\nof new features. Please refer to user manual for more details\non how to upgrade your CIM or contact your system administrator."
            );
            break;
         case 285671426:
            var1 = T._("The currently active profile is different\nthan the designated preferred profile\n for this target.");
            break;
         case 302383106:
            var1 = T._("Client has been disconnected from target.");
            break;
         default:
            var1 = T._("Unknown error.\nContact your system administrator.");
      }

      return var1;
   }
}
