package nn.pp.rccore.impl.rfb;

public class RfbPixelFormat {
   public int bitsPerPixel;
   public int depth;
   public boolean bigEndian;
   public boolean trueColour;
   public int redMax;
   public int greenMax;
   public int blueMax;
   public int redShift;
   public int greenShift;
   public int blueShift;
   public static RfbPixelFormat rfbPixelFormat16Bit = new RfbPixelFormat(16, 16, true, true, 31, 63, 31, 11, 5, 0);
   public static RfbPixelFormat rfbPixelFormat8Bit = new RfbPixelFormat(8, 8, true, true, 7, 7, 3, 0, 3, 6);
   private static RfbPixelFormat[] rfbPixelFormats = new RfbPixelFormat[]{rfbPixelFormat16Bit, rfbPixelFormat8Bit};

   private RfbPixelFormat(int var1, int var2, boolean var3, boolean var4, int var5, int var6, int var7, int var8, int var9, int var10) {
      this.bitsPerPixel = var1;
      this.depth = var2;
      this.bigEndian = var3;
      this.trueColour = var4;
      this.redMax = var5;
      this.greenMax = var6;
      this.blueMax = var7;
      this.redShift = var8;
      this.greenShift = var9;
      this.blueShift = var10;
   }

   @Override
   public boolean equals(Object var1) {
      if (!(var1 instanceof RfbPixelFormat)) {
         return false;
      } else {
         RfbPixelFormat var2 = (RfbPixelFormat)var1;
         return var2.bitsPerPixel == this.bitsPerPixel
            && var2.depth == this.depth
            && var2.bigEndian == this.bigEndian
            && var2.trueColour == this.trueColour
            && var2.redMax == this.redMax
            && var2.greenMax == this.greenMax
            && var2.blueMax == this.blueMax
            && var2.redShift == this.redShift
            && var2.greenShift == this.greenShift
            && var2.blueShift == this.blueShift;
      }
   }

   public static RfbPixelFormat getInstance(int var0, int var1, boolean var2, boolean var3, int var4, int var5, int var6, int var7, int var8, int var9) {
      RfbPixelFormat var10 = new RfbPixelFormat(var0, var1, var2, var3, var4, var5, var6, var7, var8, var9);

      for (int var11 = 0; var11 < rfbPixelFormats.length; var11++) {
         RfbPixelFormat var12 = rfbPixelFormats[var11];
         if (var12.equals(var10)) {
            return var12;
         }
      }

      return var10;
   }
}
