package nn.pp.rccore.impl.rfb;

import java.io.IOException;
import nn.pp.rccore.IVideoSettings;
import nn.pp.rccore.VideoSettings;

public abstract class RfbVideoSettingsHandler {
   protected RfbHandler rfbHandler;
   protected VideoSettings lastVideoSettings;

   public RfbVideoSettingsHandler(RfbHandler var1) {
      this.rfbHandler = var1;
   }

   public void setLastVideoSettings(VideoSettings var1) {
      this.lastVideoSettings = new VideoSettings(var1);
   }

   public void requestVideoSettingsUpdates() throws IOException {
      this.rfbHandler.writeVideoSettingsRequest(1);
   }

   public void stopVideoSettingsUpdates() throws IOException {
      this.rfbHandler.writeVideoSettingsRequest(2);
   }

   public abstract void setVideoSettings(IVideoSettings var1) throws IOException;

   public abstract void requestVideoAutoSense() throws IOException;

   public abstract void requestVideoColorCalibration() throws IOException;

   public abstract void saveVideoSettings() throws IOException;

   public abstract void cancelVideoSettings() throws IOException;

   public abstract void resetVideoSettingsAllModes() throws IOException;

   public abstract void resetVideoSettingsThisMode() throws IOException;

   public abstract void resetVideoSettingsThisPort() throws IOException;
}
