package nn.pp.rccore.impl.rfb.V01_00;

import java.io.IOException;
import nn.pp.core.T;
import nn.pp.core.impl.MonitoringDataInputStream;
import nn.pp.core.impl.MonitoringDataOutputStream;
import nn.pp.core.impl.ProtocolMessage;
import nn.pp.rccore.RCException;

public class RfbVersionMsgV01_00 extends ProtocolMessage {
   public int versionMajor;
   public int versionMinor;

   public void read(MonitoringDataInputStream var1) throws IOException, RCException {
      byte[] var2 = new byte[16];
      var1.readFully(var2);
      String var3 = new String(var2);
      if (var3.substring(0, 10).equals("e-RIC RFB xx.xx\n".substring(0, 10))
         && var2[10] >= 48
         && var2[10] <= 57
         && var2[11] >= 48
         && var2[11] <= 57
         && var2[12] == 46
         && var2[13] >= 48
         && var2[13] <= 57
         && var2[14] >= 48
         && var2[14] <= 57
         && var2[15] == 10) {
         this.versionMajor = (var2[10] - 48) * 10 + (var2[11] - 48);
         this.versionMinor = (var2[13] - 48) * 10 + (var2[14] - 48);
      } else {
         throw new RCException(T._("Device hasn't a valid server version (protocol error)"));
      }
   }

   public void write(MonitoringDataOutputStream var1, int var2, int var3) throws IOException {
      String var4 = "" + var2;
      if (var2 < 10) {
         var4 = "0" + var4;
      }

      String var5 = "" + var3;
      if (var3 < 10) {
         var5 = "0" + var5;
      }

      String var6 = "e-RIC RFB xx.xx\n".substring(0, 10) + var4 + "." + var5 + "\n";
      byte[] var7 = var6.getBytes();
      this.write(var7);
      var1.write(this);
   }
}
