package nn.pp.rccore.impl.rfb.V01_21;

import java.io.EOFException;
import java.io.IOException;
import nn.pp.core.NotificationEvent;
import nn.pp.core.impl.MonitoringDataInputStream;
import nn.pp.core.impl.ProtocolMessage;
import nn.pp.rccore.impl.ListenerLists;

public class RfbServerInitMsgV01_21 extends ProtocolMessage {
   private int serverId;
   NotificationEvent event;
   ListenerLists listenerList;

   public RfbServerInitMsgV01_21(ListenerLists var1) {
      this.listenerList = var1;
   }

   public void read(MonitoringDataInputStream var1, boolean var2) throws IOException {
      if (!var2) {
         var1.readUnsignedByte();
      }

      int var3 = var1.read();
      if (var3 == 3) {
         RfbUserNotificationEventMsgV01_21 var7 = new RfbUserNotificationEventMsgV01_21();
         var7.read(var1, var2);
         this.event = var7.event;
         if (this.listenerList != null) {
            this.listenerList.notificationListenerList.fireNotification(this.event);
         }

         throw new IOException("Force quit from server");
      } else {
         int var4 = var1.read();
         int var5 = var1.read();
         int var6 = var1.read();
         if ((var3 | var4 | var5 | var6) < 0) {
            throw new EOFException();
         } else {
            this.serverId = (var3 << 24) + (var4 << 16) + (var5 << 8) + (var6 << 0);
         }
      }
   }

   public int getServerId() {
      return this.serverId;
   }
}
