package nn.pp.rccore.impl.rfb.V01_21;

import java.io.IOException;
import nn.pp.rccore.IVideoSettings;
import nn.pp.rccore.impl.rfb.RfbHandler;
import nn.pp.rccore.impl.rfb.RfbVideoSettingsHandler;

public class RfbVideoSettingsHandler_V01_21 extends RfbVideoSettingsHandler {
   public RfbVideoSettingsHandler_V01_21(RfbHandler var1) {
      super(var1);
   }

   @Override
   public void requestVideoAutoSense() throws IOException {
      this.rfbHandler.writeVideoSettingsEvent(18, 0);
   }

   @Override
   public void requestVideoColorCalibration() throws IOException {
      this.rfbHandler.writeVideoSettingsEvent(19, 0);
   }

   @Override
   public void saveVideoSettings() throws IOException {
      this.rfbHandler.writeVideoSettingsEvent(16, 0);
   }

   @Override
   public void cancelVideoSettings() throws IOException {
      this.rfbHandler.writeVideoSettingsEvent(17, 0);
   }

   @Override
   public void resetVideoSettingsAllModes() throws IOException {
      this.rfbHandler.writeVideoSettingsEvent(13, 0);
   }

   @Override
   public void resetVideoSettingsThisMode() throws IOException {
      this.rfbHandler.writeVideoSettingsEvent(14, 0);
   }

   @Override
   public void resetVideoSettingsThisPort() throws IOException {
      this.rfbHandler.writeVideoSettingsEvent(15, 0);
   }

   @Override
   public void setVideoSettings(IVideoSettings var1) throws IOException {
      if (this.lastVideoSettings == null || this.lastVideoSettings.getBrightnessRed().getValue() != var1.getBrightnessRed().getValue()) {
         this.rfbHandler.writeVideoSettingsEvent(0, var1.getBrightnessRed().getValue());
         if (this.lastVideoSettings != null) {
            this.lastVideoSettings.getBrightnessRed().setValue(var1.getBrightnessRed().getValue());
         }
      }

      if (this.lastVideoSettings == null || this.lastVideoSettings.getBrightnessGreen().getValue() != var1.getBrightnessGreen().getValue()) {
         this.rfbHandler.writeVideoSettingsEvent(1, var1.getBrightnessGreen().getValue());
         if (this.lastVideoSettings != null) {
            this.lastVideoSettings.getBrightnessGreen().setValue(var1.getBrightnessGreen().getValue());
         }
      }

      if (this.lastVideoSettings == null || this.lastVideoSettings.getBrightnessBlue().getValue() != var1.getBrightnessBlue().getValue()) {
         this.rfbHandler.writeVideoSettingsEvent(2, var1.getBrightnessBlue().getValue());
         if (this.lastVideoSettings != null) {
            this.lastVideoSettings.getBrightnessBlue().setValue(var1.getBrightnessBlue().getValue());
         }
      }

      if (this.lastVideoSettings == null || this.lastVideoSettings.getAutoColorCalibration().isEnabled() != var1.getAutoColorCalibration().isEnabled()) {
         this.rfbHandler.writeVideoSettingsEvent(10, var1.getAutoColorCalibration().isEnabled() ? 1 : 0);
         if (this.lastVideoSettings != null) {
            this.lastVideoSettings.getAutoColorCalibration().setEnabled(var1.getAutoColorCalibration().isEnabled());
         }
      }

      if (this.lastVideoSettings == null || this.lastVideoSettings.getAutoAutoAdjust().isEnabled() != var1.getAutoAutoAdjust().isEnabled()) {
         this.rfbHandler.writeVideoSettingsEvent(11, var1.getAutoAutoAdjust().isEnabled() ? 1 : 0);
         if (this.lastVideoSettings != null) {
            this.lastVideoSettings.getAutoAutoAdjust().setEnabled(var1.getAutoAutoAdjust().isEnabled());
         }
      }

      if (this.lastVideoSettings == null || this.lastVideoSettings.getContrastRed().getValue() != var1.getContrastRed().getValue()) {
         this.rfbHandler.writeVideoSettingsEvent(3, var1.getContrastRed().getValue());
         if (this.lastVideoSettings != null) {
            this.lastVideoSettings.getContrastRed().setValue(var1.getContrastRed().getValue());
         }
      }

      if (this.lastVideoSettings == null || this.lastVideoSettings.getContrastGreen().getValue() != var1.getContrastGreen().getValue()) {
         this.rfbHandler.writeVideoSettingsEvent(4, var1.getContrastGreen().getValue());
         if (this.lastVideoSettings != null) {
            this.lastVideoSettings.getContrastGreen().setValue(var1.getContrastGreen().getValue());
         }
      }

      if (this.lastVideoSettings == null || this.lastVideoSettings.getContrastBlue().getValue() != var1.getContrastBlue().getValue()) {
         this.rfbHandler.writeVideoSettingsEvent(5, var1.getContrastBlue().getValue());
         if (this.lastVideoSettings != null) {
            this.lastVideoSettings.getContrastBlue().setValue(var1.getContrastBlue().getValue());
         }
      }

      if (this.lastVideoSettings == null || this.lastVideoSettings.getPhase().getValue() != var1.getPhase().getValue()) {
         this.rfbHandler.writeVideoSettingsEvent(7, var1.getPhase().getValue());
         if (this.lastVideoSettings != null) {
            this.lastVideoSettings.getPhase().setValue(var1.getPhase().getValue());
         }
      }

      if (this.lastVideoSettings == null || this.lastVideoSettings.getClock().getValue() != var1.getClock().getValue()) {
         this.rfbHandler.writeVideoSettingsEvent(6, var1.getClock().getValue());
         if (this.lastVideoSettings != null) {
            this.lastVideoSettings.getClock().setValue(var1.getClock().getValue());
         }
      }

      if (this.lastVideoSettings == null || this.lastVideoSettings.getOffsetX().getValue() != var1.getOffsetX().getValue()) {
         this.rfbHandler.writeVideoSettingsEvent(8, var1.getOffsetX().getValue());
         if (this.lastVideoSettings != null) {
            this.lastVideoSettings.getOffsetX().setValue(var1.getOffsetX().getValue());
         }
      }

      if (this.lastVideoSettings == null || this.lastVideoSettings.getOffsetY().getValue() != var1.getOffsetY().getValue()) {
         this.rfbHandler.writeVideoSettingsEvent(9, var1.getOffsetY().getValue());
         if (this.lastVideoSettings != null) {
            this.lastVideoSettings.getOffsetY().setValue(var1.getOffsetY().getValue());
         }
      }

      if (this.lastVideoSettings == null || this.lastVideoSettings.getNoiseFilter().getValue() != var1.getNoiseFilter().getValue()) {
         this.rfbHandler.writeVideoSettingsEvent(12, var1.getNoiseFilter().getValue());
         if (this.lastVideoSettings != null) {
            this.lastVideoSettings.getNoiseFilter().setValue(var1.getNoiseFilter().getValue());
         }
      }
   }
}
