package nn.pp.rccore.impl.rfb.V01_21;

import java.io.IOException;
import nn.pp.core.impl.MonitoringDataInputStream;
import nn.pp.core.impl.ProtocolMessage;
import nn.pp.rccore.VideoSettings;

public class RfbVideoSettingsS2CMsgV01_21 extends ProtocolMessage {
   public VideoSettings videoSettings;
   private static final int clockMax = 4096;
   private static final int clockRange = 500;

   public void read(MonitoringDataInputStream var1, boolean var2, boolean var3, boolean var4, boolean var5) throws IOException {
      if (!var2) {
         var1.readUnsignedByte();
      }

      this.videoSettings = new VideoSettings();
      var1.readUnsignedByte();
      this.videoSettings.getBrightnessRed().setValue(var1.readUnsignedByte());
      this.videoSettings.getBrightnessGreen().setValue(var1.readUnsignedByte());
      this.videoSettings.getBrightnessBlue().setValue(var1.readUnsignedByte());
      this.videoSettings.getContrastRed().setValue(var1.readUnsignedByte());
      this.videoSettings.getContrastGreen().setValue(var1.readUnsignedByte());
      this.videoSettings.getContrastBlue().setValue(var1.readUnsignedByte());
      this.videoSettings.getAutoColorCalibration().setEnabled(var1.readUnsignedByte() != 0);
      this.videoSettings.getAutoAutoAdjust().setEnabled(var1.readUnsignedByte() != 0);
      this.videoSettings.getClock().setValue(var1.readUnsignedShort());
      this.videoSettings.getPhase().setValue(var1.readUnsignedShort());
      this.videoSettings.getOffsetX().setValue(var1.readUnsignedShort());
      this.videoSettings.getOffsetY().setValue(var1.readUnsignedShort());
      this.videoSettings.getResolutionX().setValue(var1.readUnsignedShort());
      this.videoSettings.getResolutionY().setValue(var1.readUnsignedShort());
      this.videoSettings.getRefreshRate().setValue(var1.readUnsignedShort());
      this.videoSettings.getNoiseFilter().setValue(var1.readUnsignedShort());
      this.videoSettings.getOffsetY().setMaxValue(var1.readUnsignedShort());
      int var6 = this.videoSettings.getResolutionX().getValue() + 2;
      int var7 = this.videoSettings.getClock().getValue() + 500;
      if (var7 > 4096) {
         var7 = 4096;
      }

      this.videoSettings.getClock().setMinValue(var6);
      this.videoSettings.getClock().setMaxValue(var7);
      this.videoSettings.getResolutionX().setSupported(true);
      this.videoSettings.getResolutionY().setSupported(true);
      this.videoSettings.getRefreshRate().setSupported(true);
      this.videoSettings.getSaveSettings().setSupported(true);
      this.videoSettings.getCancelSettings().setSupported(true);
      if (var4 || var5) {
         if (!var3) {
            this.videoSettings.getBrightnessRed().setSupported(true);
            this.videoSettings.getBrightnessGreen().setSupported(true);
            this.videoSettings.getBrightnessBlue().setSupported(true);
            this.videoSettings.getContrastRed().setSupported(true);
            this.videoSettings.getContrastGreen().setSupported(true);
            this.videoSettings.getContrastBlue().setSupported(true);
         }

         if (var5) {
            if (!var3) {
               this.videoSettings.getClock().setSupported(true);
               this.videoSettings.getPhase().setSupported(true);
               this.videoSettings.getAutoColorCalibration().setSupported(true);
               this.videoSettings.getAutoAutoAdjust().setSupported(true);
               this.videoSettings.getNoiseFilter().setSupported(true);
            }

            this.videoSettings.getOffsetX().setSupported(true);
            this.videoSettings.getOffsetY().setSupported(true);
            this.videoSettings.getResetAllModes().setSupported(true);
            this.videoSettings.getResetThisMode().setSupported(true);
         }
      }
   }
}
