package nn.pp.rccore.impl.rfb.V01_22;

import java.io.IOException;
import nn.pp.rccore.IVideoSettings;
import nn.pp.rccore.impl.rfb.RfbHandler;
import nn.pp.rccore.impl.rfb.RfbVideoSettingsHandler;

public class RfbVideoSettingsHandler_V01_22 extends RfbVideoSettingsHandler {
   public RfbVideoSettingsHandler_V01_22(RfbHandler var1) {
      super(var1);
   }

   @Override
   public void requestVideoAutoSense() throws IOException {
      this.rfbHandler.writeVideoSettingsEvent(12, 0);
   }

   @Override
   public void requestVideoColorCalibration() throws IOException {
      this.rfbHandler.writeVideoSettingsEvent(13, 0);
   }

   @Override
   public void saveVideoSettings() throws IOException {
      this.rfbHandler.writeVideoSettingsEvent(10, 0);
   }

   @Override
   public void cancelVideoSettings() throws IOException {
      this.rfbHandler.writeVideoSettingsEvent(11, 0);
   }

   @Override
   public void resetVideoSettingsAllModes() throws IOException {
      this.rfbHandler.writeVideoSettingsEvent(8, 0);
   }

   @Override
   public void resetVideoSettingsThisMode() throws IOException {
      this.rfbHandler.writeVideoSettingsEvent(9, 0);
   }

   @Override
   public void resetVideoSettingsThisPort() throws IOException {
      throw new UnsupportedOperationException();
   }

   @Override
   public void setVideoSettings(IVideoSettings var1) throws IOException {
      if (this.lastVideoSettings == null || this.lastVideoSettings.getBrightness().getValue() != var1.getBrightness().getValue()) {
         this.rfbHandler.writeVideoSettingsEvent(0, var1.getBrightness().getValue());
         if (this.lastVideoSettings != null) {
            this.lastVideoSettings.getBrightness().setValue(var1.getBrightness().getValue());
         }
      }

      if (this.lastVideoSettings == null || this.lastVideoSettings.getContrastRed().getValue() != var1.getContrastRed().getValue()) {
         this.rfbHandler.writeVideoSettingsEvent(1, var1.getContrastRed().getValue());
         if (this.lastVideoSettings != null) {
            this.lastVideoSettings.getContrastRed().setValue(var1.getContrastRed().getValue());
         }
      }

      if (this.lastVideoSettings == null || this.lastVideoSettings.getContrastGreen().getValue() != var1.getContrastGreen().getValue()) {
         this.rfbHandler.writeVideoSettingsEvent(2, var1.getContrastGreen().getValue());
         if (this.lastVideoSettings != null) {
            this.lastVideoSettings.getContrastGreen().setValue(var1.getContrastGreen().getValue());
         }
      }

      if (this.lastVideoSettings == null || this.lastVideoSettings.getContrastBlue().getValue() != var1.getContrastBlue().getValue()) {
         this.rfbHandler.writeVideoSettingsEvent(3, var1.getContrastBlue().getValue());
         if (this.lastVideoSettings != null) {
            this.lastVideoSettings.getContrastBlue().setValue(var1.getContrastBlue().getValue());
         }
      }

      if (this.lastVideoSettings == null || this.lastVideoSettings.getPhase().getValue() != var1.getPhase().getValue()) {
         this.rfbHandler.writeVideoSettingsEvent(5, var1.getPhase().getValue());
         if (this.lastVideoSettings != null) {
            this.lastVideoSettings.getPhase().setValue(var1.getPhase().getValue());
         }
      }

      if (this.lastVideoSettings == null || this.lastVideoSettings.getClock().getValue() != var1.getClock().getValue()) {
         this.rfbHandler.writeVideoSettingsEvent(4, var1.getClock().getValue());
         if (this.lastVideoSettings != null) {
            this.lastVideoSettings.getClock().setValue(var1.getClock().getValue());
         }
      }

      if (this.lastVideoSettings == null || this.lastVideoSettings.getOffsetX().getValue() != var1.getOffsetX().getValue()) {
         this.rfbHandler.writeVideoSettingsEvent(6, var1.getOffsetX().getValue());
         if (this.lastVideoSettings != null) {
            this.lastVideoSettings.getOffsetX().setValue(var1.getOffsetX().getValue());
         }
      }

      if (this.lastVideoSettings == null || this.lastVideoSettings.getOffsetY().getValue() != var1.getOffsetY().getValue()) {
         this.rfbHandler.writeVideoSettingsEvent(7, var1.getOffsetY().getValue());
         if (this.lastVideoSettings != null) {
            this.lastVideoSettings.getOffsetY().setValue(var1.getOffsetY().getValue());
         }
      }
   }
}
