package nn.pp.rccore.impl.rfb;

import java.io.ByteArrayInputStream;
import java.io.IOException;
import java.util.logging.Level;
import java.util.logging.Logger;
import java.util.zip.DataFormatException;
import java.util.zip.Inflater;
import nn.pp.core.T;
import nn.pp.core.impl.MonitoringDataInputStream;

public class ZlibEncodingInflater {
   private Logger logger;
   private byte[] updateBuf;
   static final int updatePortionBufSize = 65536;
   private byte[] updatePortionBuf = new byte[65536];
   private Inflater zlibInflater = null;
   private int uncompressedSize;

   public ZlibEncodingInflater(Logger var1) {
      this.logger = var1;
   }

   public MonitoringDataInputStream getUncompressedDataStream(MonitoringDataInputStream var1, RfbHandler var2, boolean var3, boolean var4, int var5) throws IOException {
      if (var3) {
         this.logger.log(Level.FINEST, T._("Inflating zlib stream compressed data"));
         if (var5 <= 0) {
            var5 = var2.readCompactLen();
         }

         this.uncompressedSize = var5;
         if (this.updateBuf == null || var5 > this.updateBuf.length) {
            this.updateBuf = new byte[var5];
         }

         int var16 = var5;
         int var17 = 0;
         if (this.zlibInflater == null) {
            this.zlibInflater = new Inflater();
         }

         while (var16 > 0) {
            int var18 = var2.readCompactLen();
            var1.readFully(this.updatePortionBuf, 0, var18);
            this.zlibInflater.setInput(this.updatePortionBuf, 0, var18);

            try {
               int var19 = this.zlibInflater.inflate(this.updateBuf, var17, var16);
               var17 += var19;
               var16 -= var19;
            } catch (DataFormatException var13) {
               throw new IOException(var13.toString());
            }
         }

         return new MonitoringDataInputStream(new ByteArrayInputStream(this.updateBuf));
      } else if (!var4) {
         this.uncompressedSize = var5;
         return var1;
      } else {
         this.logger.log(Level.INFO, T._("Inflating zlib \"compress\" compressed data"));
         int var6 = (int)var1.readUnsignedInt();
         var5 = (int)var1.readUnsignedInt();
         this.uncompressedSize = var5;
         int var7 = 0;
         int var8 = 0;
         int var9 = var5;
         if (this.updateBuf == null || var5 > this.updateBuf.length) {
            this.updateBuf = new byte[var5];
         }

         Inflater var10 = new Inflater();

         while (var7 < var6) {
            int var11 = var6 - var7 > 65536 ? 65536 : (var6 - var7) % 65536;
            var1.readFully(this.updatePortionBuf, 0, var11);
            var10.setInput(this.updatePortionBuf, 0, var11);

            try {
               int var12 = var10.inflate(this.updateBuf, var8, var9);
               var8 += var12;
               var7 += var11;
               var9 -= var12;
            } catch (DataFormatException var14) {
               throw new IOException(var14.toString());
            }
         }

         var10.end();
         return new MonitoringDataInputStream(new ByteArrayInputStream(this.updateBuf));
      }
   }

   public int getUncompressedSize() {
      return this.uncompressedSize;
   }
}
