package nn.pp.rccore.scan;

import java.lang.reflect.InvocationTargetException;

public class ScanCoreFactory {
   private static ScanCore defaultImpl;
   private static final String DEFAULT_IMPL_CLASS = "nn.pp.rccore.scan.impl.ScanCoreImpl";

   public static synchronized ScanCore getDefault() throws ScanCoreException {
      if (defaultImpl == null) {
         defaultImpl = getInstance("nn.pp.rccore.scan.impl.ScanCoreImpl");
      }

      return defaultImpl;
   }

   public static ScanCore getInstance(String var0) throws ScanCoreException {
      Class var1 = null;

      try {
         var1 = Class.forName(var0);
      } catch (ClassNotFoundException var12) {
         throw new ScanCoreException(var12);
      }

      Class var2;
      try {
         var2 = var1.asSubclass(ScanCore.class);
      } catch (ClassCastException var11) {
         throw new ScanCoreException(var11);
      }

      Object var3 = null;

      try {
         var3 = var2.getConstructor();
      } catch (SecurityException var9) {
         throw new ScanCoreException(var9);
      } catch (NoSuchMethodException var10) {
         throw new ScanCoreException(var10);
      }

      try {
         return (ScanCore)var3.newInstance();
      } catch (IllegalArgumentException var5) {
         throw new ScanCoreException(var5);
      } catch (InstantiationException var6) {
         throw new ScanCoreException(var6);
      } catch (IllegalAccessException var7) {
         throw new ScanCoreException(var7);
      } catch (InvocationTargetException var8) {
         throw new ScanCoreException(var8);
      }
   }
}
