package nn.pp.rccore.scan.impl.commands;

import java.io.IOException;
import nn.pp.rccore.scan.ScanCoreException;
import nn.pp.rccore.scan.impl.rsp.SupportsVisitor;

public class AuthHttpIDChallResponse implements SupportsVisitor<CommandVisitorV01_00> {
   private final byte[] challenge;
   private final String httpSessionID;

   public AuthHttpIDChallResponse(byte[] var1, String var2) throws ScanCoreException {
      this.challenge = var1;
      this.httpSessionID = var2;
   }

   public void accept(CommandVisitorV01_00 var1) throws IOException, ScanCoreException {
      var1.handleHttpIDChallengeResponse(this);
   }

   public byte[] getChallenge() {
      return this.challenge;
   }

   public String getHttpSessionID() {
      return this.httpSessionID;
   }
}
