package nn.pp.rccore.scan.impl.rsp;

import java.io.IOException;
import java.io.UnsupportedEncodingException;
import nn.pp.core.impl.MonitoringDataOutputStream;
import nn.pp.rccore.scan.ScanCoreException;

public class RSPVersionAcceptMessage implements CommandToMessageWriter {
   private final int versionMajor;
   private final int versionMinor;

   public RSPVersionAcceptMessage(int var1, int var2) {
      this.versionMajor = var1;
      this.versionMinor = var2;
   }

   @Override
   public void writeMessage(MonitoringDataOutputStream var1) throws ScanCoreException, IOException {
      String var2 = "" + this.versionMajor;
      if (this.versionMajor < 10) {
         var2 = "0" + var2;
      }

      String var3 = "" + this.versionMinor;
      if (this.versionMinor < 10) {
         var3 = "0" + var3;
      }

      String var4 = "e-RIC RSP xx.xx\n".substring(0, 10) + var2 + "." + var3 + "\n";

      try {
         var1.write(var4.getBytes("ISO-8859-1"));
         var1.flush();
      } catch (UnsupportedEncodingException var6) {
         throw new ScanCoreException(var6);
      }
   }
}
