package nn.pp.rccore.scan.impl.rsp.V01_00;

import java.io.IOException;
import nn.pp.core.impl.MonitoringDataInputStream;
import nn.pp.rccore.scan.ScanCoreException;
import nn.pp.rccore.scan.impl.rsp.MessageToCommandProducer;

public class AuthHttpIDChallenge implements MessageToCommandProducer<Object> {
   private final byte[] challenge;

   public AuthHttpIDChallenge() {
      this(null);
   }

   private AuthHttpIDChallenge(byte[] var1) {
      this.challenge = var1;
   }

   public AuthHttpIDChallenge readMessage(MonitoringDataInputStream var1) throws IOException, ScanCoreException {
      byte[] var2 = new byte[73];
      byte[] var3 = new byte[64];
      var1.readFully(var2);
      if (!new String(var2, "ISO-8859-1").substring(0, 9).equals("RSP CHAL=")) {
         throw new ScanCoreException("Device doesn't have valid authentication challenge format");
      } else {
         System.arraycopy(var2, 9, var3, 0, var3.length);
         return new AuthHttpIDChallenge(var3);
      }
   }

   @Override
   public void visit(Object var1) {
   }

   public byte[] getChallenge() {
      return this.challenge;
   }
}
