package nn.pp.rccore.scan.impl.rsp.V01_00;

import java.io.IOException;
import nn.pp.core.impl.MonitoringDataInputStream;
import nn.pp.rccore.scan.ScanCoreException;
import nn.pp.rccore.scan.impl.rsp.MessageToCommandProducer;

public class AuthResponse implements MessageToCommandProducer<RSPMessageHandlerV01_00> {
   private final int ack;
   private final int reason;

   public AuthResponse() {
      this(-1, -1);
   }

   private AuthResponse(int var1, int var2) {
      this.ack = var1;
      this.reason = var2;
   }

   public AuthResponse readMessage(MonitoringDataInputStream var1) throws IOException, ScanCoreException {
      int var2 = var1.read() & 0xFF;
      var1.readShort();
      int var3 = var1.readInt();
      return new AuthResponse(var2, var3);
   }

   public void visit(RSPMessageHandlerV01_00 var1) {
      var1.handleAuthResponse(this);
   }

   public int getAck() {
      return this.ack;
   }

   public int getReason() {
      return this.reason;
   }
}
