package nn.pp.rccore.scan.impl.rsp.V01_00;

import java.io.IOException;
import java.lang.reflect.ParameterizedType;
import nn.pp.core.Util;
import nn.pp.core.impl.MonitoringDataInputStream;
import nn.pp.core.impl.MonitoringDataOutputStream;
import nn.pp.rccore.scan.ScanCoreException;
import nn.pp.rccore.scan.impl.commands.CommandVisitorV01_00;
import nn.pp.rccore.scan.impl.rsp.ClientCommandsExecutor;
import nn.pp.rccore.scan.impl.rsp.EventsListenerManager;
import nn.pp.rccore.scan.impl.rsp.MessageToCommandProducer;
import nn.pp.rccore.scan.impl.rsp.RSPProtoHandler;
import nn.pp.rccore.scan.impl.rsp.SupportsVisitor;

public class RSPProtoHandlerV01_00 implements RSPProtoHandler<RSPMessageHandlerV01_00> {
   private final RSPMessageHandlerV01_00Impl messageHandler = new RSPMessageHandlerV01_00Impl();

   @Override
   public <T> void executeClientCommands(MonitoringDataOutputStream var1, MonitoringDataInputStream var2, SupportsVisitor<T> var3) throws IOException, ScanCoreException {
      ParameterizedType var4 = Util.getParameterizedType(var3, SupportsVisitor.class);
      if (!CommandVisitorV01_00.class.isAssignableFrom((Class<?>)var4.getActualTypeArguments()[0])) {
         throw new ScanCoreException("Unsupported Client command...");
      } else {
         this.messageHandler.setOs(var1);
         this.messageHandler.setIs(var2);
         var3.accept(this.messageHandler);
      }
   }

   @Override
   public void executeCommand(MessageToCommandProducer<RSPMessageHandlerV01_00> var1) {
      var1.visit(this.messageHandler);
   }

   @Override
   public MessageToCommandProducer<RSPMessageHandlerV01_00> getMessageToCommandProducer(int var1) {
      switch (var1) {
         case 3:
            return new QuitRequestFromServer();
         case 4:
            return new PingRequest();
         case 128:
            return new AuthResponse();
         case 129:
            return new ScanSessionResponse();
         default:
            return null;
      }
   }

   @Override
   public void handleDisconnection() {
      this.messageHandler.handleDisconnection();
   }

   @Override
   public void setClientCommandsExecutor(ClientCommandsExecutor var1) {
      this.messageHandler.setClientCommandsExecutor(var1);
   }

   @Override
   public void setEventsListenerManager(EventsListenerManager var1) {
      this.messageHandler.setEventsListenerManager(var1);
   }
}
