package nn.pp.rccore.scan.impl.rsp.V01_00;

import java.io.IOException;
import nn.pp.core.impl.MonitoringDataInputStream;
import nn.pp.rccore.scan.ScanCoreException;
import nn.pp.rccore.scan.impl.rsp.MessageToCommandProducer;

public class ScanSessionResponse implements MessageToCommandProducer<RSPMessageHandlerV01_00> {
   private final int ack;
   private final int reason;
   private final int scanReferralId;

   public ScanSessionResponse() {
      this(-1, -1, -1);
   }

   private ScanSessionResponse(int var1, int var2, int var3) {
      this.ack = var1;
      this.reason = var2;
      this.scanReferralId = var3;
   }

   @Override
   public MessageToCommandProducer<RSPMessageHandlerV01_00> readMessage(MonitoringDataInputStream var1) throws IOException, ScanCoreException {
      int var2 = var1.read() & 0xFF;
      var1.readShort();
      int var3 = var1.readInt();
      int var4 = var1.readInt();
      return new ScanSessionResponse(var2, var3, var4);
   }

   public void visit(RSPMessageHandlerV01_00 var1) {
      var1.handleScanSessionResponse(this);
   }

   public int getAck() {
      return this.ack;
   }

   public int getReason() {
      return this.reason;
   }

   public int getScanReferralId() {
      return this.scanReferralId;
   }
}
