package nn.pp.vmcore;

import java.io.IOException;
import javax.net.ssl.X509TrustManager;
import nn.pp.core.NotificationListener;

public interface VMCore {
   void dispose();

   void setX509TrustManager(X509TrustManager var1);

   void connectVMWithUserLogin(
      String var1,
      int var2,
      boolean var3,
      String var4,
      int var5,
      RedirectableObject var6,
      boolean var7,
      VMCore.LockFailBehavior var8,
      String var9,
      String var10
   ) throws IOException, VMException;

   void connectVMWithRdmSession(
      String var1,
      int var2,
      boolean var3,
      String var4,
      int var5,
      RedirectableObject var6,
      boolean var7,
      VMCore.LockFailBehavior var8,
      String var9,
      String var10,
      String var11
   ) throws IOException, VMException;

   void connectVMWithEricKey(
      String var1, int var2, boolean var3, String var4, int var5, RedirectableObject var6, boolean var7, VMCore.LockFailBehavior var8, String var9
   ) throws IOException, VMException;

   void disconnect();

   void disconnect(boolean var1);

   void addNotificationListener(NotificationListener var1);

   void removeNotificationListener(NotificationListener var1);

   void addVirtualMediaEventListener(VirtualMediaEventListener var1, int var2);

   void removeVirtualMediaEventListener(VirtualMediaEventListener var1);

   void setMsIndex(int var1);

   public static enum DriveType {
      UNKNOWN,
      CDROM,
      FLOPPY,
      REMOVABLE,
      HARD_DISK_FULL,
      HARD_DISK_FULL_EXTERNAL,
      HARD_DISK_PARTITION,
      HARD_DISK_PARTITION_EXTERNAL;
   }

   public static enum LockFailBehavior {
      FAIL,
      ASK,
      IGNORE;
   }
}
