package nn.pp.vmcore.impl;

import java.io.IOException;
import java.util.logging.Logger;
import nn.pp.core.T;
import nn.pp.vmcore.RedirectableObject;
import nn.pp.vmcore.VMCore;
import nn.pp.vmcore.VMException;

public class Drive extends RedirectableObject implements Comparable<Drive> {
   protected String driveName;
   protected VMCore.DriveType driveType;

   public Drive(String var1, VMCore.DriveType var2) {
      this.driveName = var1;
      this.driveType = var2;
   }

   @Override
   public VMCore.DriveType getDriveType(Logger var1) throws IOException, VMException {
      return this.getDriveType();
   }

   public VMCore.DriveType getDriveType() {
      return this.driveType;
   }

   public void setDriveType(VMCore.DriveType var1) {
      this.driveType = var1;
   }

   private String getDescription() {
      switch (this.driveType) {
         case CDROM:
            return T._("CD-ROM");
         case HARD_DISK_FULL:
            return T._("Hard Disk");
         case HARD_DISK_PARTITION:
            return T._("Hard Disk Partition");
         case REMOVABLE:
            return T._("Removable");
         case HARD_DISK_FULL_EXTERNAL:
            return T._("External Hard Disk");
         case HARD_DISK_PARTITION_EXTERNAL:
            return T._("External Hard Disk Partition");
         case UNKNOWN:
         default:
            return null;
      }
   }

   public int compareTo(Drive var1) {
      return this.driveName.compareTo(var1.driveName);
   }

   @Override
   public String getShortName() {
      return this.driveName;
   }

   @Override
   public String getLongName() {
      String var1 = this.getDescription();
      return var1 == null ? this.driveName : this.driveName + " (" + var1 + ")";
   }

   @Override
   public String getRedirectionType() {
      return T._("Local Drive");
   }
}
