package nn.pp.vmcore.impl;

import java.util.List;
import java.util.Vector;
import java.util.logging.Logger;
import nn.pp.vmcore.DriveEnumerator;
import nn.pp.vmcore.RedirectableObject;

public class DriveEnumeratorDefault implements DriveEnumerator {
   private static List<String> lockedDrives = new Vector<>();
   private static Object lockedDrivesMutex = new Object();

   public static void driveLocked(RedirectableObject var0, boolean var1) {
      String var2 = var0.getLongName();
      synchronized (lockedDrivesMutex) {
         if (var1) {
            if (!lockedDrives.contains(var2)) {
               lockedDrives.add(var2);
            }
         } else if (lockedDrives.contains(var2)) {
            lockedDrives.remove(var2);
         }
      }
   }

   @Override
   public List<RedirectableObject> getAvailableDrives(Logger var1) {
      List var2 = this.enumerateDrives(var1);
      if (var2 == null) {
         return null;
      } else {
         Vector var3 = new Vector();
         synchronized (lockedDrivesMutex) {
            for (RedirectableObject var6 : var2) {
               if (!lockedDrives.contains(var6.getLongName())) {
                  var3.add(var6);
               }
            }

            return var3;
         }
      }
   }

   protected List<RedirectableObject> enumerateDrives(Logger var1) {
      return new Vector<>();
   }
}
