package nn.pp.vmcore.impl;

import java.util.List;
import java.util.logging.Logger;
import nn.pp.vmcore.RedirectableObject;

public abstract class DriveEnumeratorImpl extends DriveEnumeratorDefault {
   private long nativeEnum = 0L;
   private static Object nativeLock = new Object();
   private static boolean loadNativeCode = true;
   private static boolean nativeCodeFailed = false;

   private List<RedirectableObject> enumerateNativeDrives() {
      if (this.nativeEnum != 0L) {
         this.releaseEnumerationNative(this.nativeEnum);
      }

      this.nativeEnum = this.enumerateNative();
      return this.createListFromEnumeration(this.nativeEnum);
   }

   private native long enumerateNative();

   private native void releaseEnumerationNative(long var1);

   private native List<RedirectableObject> createListFromEnumeration(long var1);

   static boolean loadLibrary() {
      synchronized (nativeLock) {
         if (nativeCodeFailed) {
            System.out.println("nativeCodeFailed:" + nativeCodeFailed);
            return false;
         } else {
            if (loadNativeCode) {
               System.out.println("loadNativeCode:" + loadNativeCode);
               NativeLibraryDownloader var1 = new NativeLibraryDownloader();

               try {
                  var1.loadNativeLibrary();
                  loadNativeCode = false;
               } catch (Exception var4) {
                  nativeCodeFailed = true;
                  return false;
               }
            }

            return true;
         }
      }
   }

   @Override
   protected List<RedirectableObject> enumerateDrives(Logger var1) {
      return loadLibrary() ? this.enumerateNativeDrives() : super.enumerateDrives(var1);
   }
}
