package nn.pp.vmcore.impl;

import java.io.File;
import java.util.List;
import java.util.Vector;
import java.util.logging.Logger;
import nn.pp.vmcore.RedirectableObject;
import nn.pp.vmcore.VMCore;

public class DriveEnumeratorLinux extends DriveEnumeratorUnix {
   @Override
   protected List<RedirectableObject> enumerateDevDrives(Logger var1) {
      Vector var2 = new Vector();
      Vector var3 = new Vector();
      File var4 = new File("/dev");
      File[] var5 = var4.listFiles();

      for (int var6 = 0; var5 != null && var6 < var5.length; var6++) {
         File var7 = var5[var6];
         String var8 = var7.getName();
         if (!var7.isDirectory()) {
            if (var8.startsWith("fd") && var8.length() < 4 && !this.contains(var7)) {
               var2.add(new DriveDev(var7.getAbsolutePath(), VMCore.DriveType.FLOPPY));
            }

            if (var8.startsWith("cdrom") && !var8.startsWith("cdrom-sg") && !this.contains(var7)) {
               var2.add(new DriveDev(var7.getAbsolutePath(), VMCore.DriveType.CDROM));
            }

            if ((var8.startsWith("scd") || var8.startsWith("sr")) && !this.contains(var7)) {
               var2.add(new DriveDev(var7.getAbsolutePath(), VMCore.DriveType.CDROM));
            }

            if ((var8.startsWith("hd") || var8.startsWith("sd")) && !this.contains(var7)) {
               var2.add(new DriveDev(var7.getAbsolutePath(), VMCore.DriveType.UNKNOWN));
            }
         }
      }

      for (DriveDev var13 : var2) {
         try {
            RedirectedObject var14 = RedirectedObject.loadRedirectedObject(var13, true, var1);
            var14.open();
            if (var13.getDriveType() == VMCore.DriveType.UNKNOWN) {
               try {
                  var14.determineGeometry();
               } catch (Exception var10) {
                  var14.close();
                  throw var10;
               }

               VMCore.DriveType var9 = var14.getDriveType();
               if (var9 == VMCore.DriveType.HARD_DISK_FULL) {
                  var13.setDriveType(var9);
               }
            }

            var14.close();
            var3.add(var13);
         } catch (Exception var11) {
         }
      }

      return var3;
   }
}
