package nn.pp.vmcore.impl;

import java.io.File;
import java.util.List;
import java.util.Vector;
import java.util.logging.Logger;
import nn.pp.vmcore.RedirectableObject;
import nn.pp.vmcore.VMCore;

public class DriveEnumeratorMacOsX extends DriveEnumeratorUnix {
   private static final String prefix = "disk";

   private String getMainName(String var1) {
      String[] var2 = var1.split("disk");
      if (var2 != null && var2.length == 2) {
         String var3 = var2[1];
         int var4 = var3.indexOf(115);
         if (var4 != -1) {
            var3 = var3.substring(0, var4);
         }

         return "disk" + var3;
      } else {
         return var1;
      }
   }

   @Override
   protected List<RedirectableObject> enumerateDevDrives(Logger var1) {
      Vector var2 = new Vector();
      Vector var3 = new Vector();
      Vector var4 = new Vector();
      File var5 = new File("/dev");
      File[] var6 = var5.listFiles();

      for (int var7 = 0; var6 != null && var7 < var6.length; var7++) {
         File var8 = var6[var7];
         String var9 = var8.getName();
         String var10 = var8.getAbsolutePath();
         if (!var8.isDirectory() && var9.startsWith("disk") && !this.contains(var8)) {
            VMCore.DriveType var11 = VMCore.DriveType.UNKNOWN;

            try {
               DriveDev var12 = new DriveDev(var10, VMCore.DriveType.UNKNOWN);
               RedirectedObject var13 = RedirectedObject.loadRedirectedObject(var12, true, var1);
               var13.open();

               try {
                  var13.determineGeometry();
                  var11 = var13.getDriveType();
               } catch (Exception var16) {
                  var13.close();
                  throw var16;
               }

               var13.close();
               if (var11 == VMCore.DriveType.CDROM) {
                  var2.add(new DriveDev(var10, VMCore.DriveType.CDROM));
                  var4.add(this.getMainName(var10));
               } else if (var11 != VMCore.DriveType.HARD_DISK_FULL && var11 != VMCore.DriveType.FLOPPY) {
                  var2.add(new DriveDev(var10, VMCore.DriveType.UNKNOWN));
               } else {
                  var2.add(new DriveDev(var10, var11));
               }
            } catch (Exception var17) {
            }
         }
      }

      for (RedirectableObject var19 : var2) {
         try {
            if (var19.getDriveType(var1) == VMCore.DriveType.CDROM) {
               var3.add(var19);
            } else if (!var4.contains(this.getMainName(var19.getShortName()))) {
               var3.add(var19);
            }
         } catch (Exception var15) {
         }
      }

      return var3;
   }
}
