package nn.pp.vmcore.impl;

import java.io.File;
import java.io.IOException;
import java.util.Collections;
import java.util.Comparator;
import java.util.List;
import java.util.Vector;
import java.util.logging.Logger;
import nn.pp.vmcore.RedirectableObject;

public abstract class DriveEnumeratorUnix extends DriveEnumeratorDefault {
   private List<String> found = new Vector<>();

   protected boolean contains(File var1) {
      String var2 = var1.getAbsolutePath();

      String var3;
      try {
         var3 = var1.getCanonicalPath();
      } catch (IOException var6) {
         var3 = var2;
      }

      for (String var5 : this.found) {
         if (var3.equals(var5)) {
            return true;
         }
      }

      this.found.add(var3);
      return false;
   }

   protected abstract List<RedirectableObject> enumerateDevDrives(Logger var1);

   @Override
   protected List<RedirectableObject> enumerateDrives(Logger var1) {
      List var2 = this.enumerateDevDrives(var1);
      Collections.sort(var2, new Comparator<RedirectableObject>() {
         public int compare(RedirectableObject var1, RedirectableObject var2x) {
            return var1.getLongName().compareTo(var2x.getLongName());
         }
      });
      return var2;
   }
}
