package nn.pp.vmcore.impl;

import java.io.File;
import java.io.IOException;
import java.util.logging.Logger;
import nn.pp.core.T;
import nn.pp.vmcore.RedirectableObject;
import nn.pp.vmcore.VMCore;
import nn.pp.vmcore.VMException;

public class IsoImage extends RedirectableObject {
   private File file;

   public IsoImage(File var1) {
      this.file = var1;
   }

   public File getFile() {
      return this.file;
   }

   @Override
   public String getShortName() {
      return this.file.getName();
   }

   @Override
   public String getLongName() {
      return this.file.getName();
   }

   @Override
   public String getRedirectionType() {
      return T._("Image File");
   }

   @Override
   public VMCore.DriveType getDriveType(Logger var1) throws IOException, VMException {
      RedirectedObject var2 = RedirectedObject.loadRedirectedObject(this, true, var1);
      var2.open();
      var2.determineGeometry();
      VMCore.DriveType var3 = var2.getDriveType();
      var2.close();
      return var3;
   }
}
