package nn.pp.vmcore.impl;

import nn.pp.core.WorkstationUnlockDetector;

public class WorkstationUnlockDetectorImpl implements WorkstationUnlockDetector {
   private static final boolean dllLoaded;

   private static native int getWorkstationLockStatus();

   private static native boolean initialize();

   @Override
   public boolean isWorkstationUnlocked() {
      if (dllLoaded) {
         switch (getWorkstationLockStatus()) {
            case 1:
            case 3:
               return true;
            default:
               return false;
         }
      } else {
         return true;
      }
   }

   static {
      boolean var0 = false;
      if (DriveEnumeratorImpl.loadLibrary()) {
         var0 = initialize();
      }

      dllLoaded = var0;
   }
}
