package nn.pp.vmcore.impl.msp;

import nn.pp.core.NotificationEvent;
import nn.pp.core.T;

public class MspNotificationEvent extends NotificationEvent {
   public MspNotificationEvent(int var1, int var2) {
      super(var1, var2);
   }

   public NotificationEvent clone() {
      return new MspNotificationEvent(this.flags, this.errorCode);
   }

   @Override
   public String getMessage() {
      return getMessageString(this.getErrorCode());
   }

   public static String getMessageString(int var0) {
      switch (var0) {
         case 805306369:
            return T._("Virtual Media mounting on the Port denied.\nContact your system administrator.");
         case 805306370:
            return T._("Virtual Media mounting on the Port denied.\nContact your system administrator.");
         case 805306371:
            return T._("Permission to transfer files from target to the virtual drive denied.\nContact your system administrator.");
         case 805371905:
            return T._(
               "Virtual Media mounting on the Port failed. Please try the again.\nIf you receive this error repeatedly, contact technical support for assistance."
            );
         case 805371906:
            return T._("Virtual Media mounting on the Port unavailable.\nContact your system administrator");
         case 805371907:
            return T._(
               "There is already a Virtual Media connection established to the selected drive.\nPlease disconnect the current virtual media connection before\nre-establishing a new Virtual media connection."
            );
         case 805371908:
            return T._(
               "There is already another virtual media connection active on the selected image.\nPlease disconnect the current virtual media connection before\nre-establishing a new Virtual media connection."
            );
         case 805371909:
            return T._("Virtual Media mounting on the Port denied.\nVM Share Mode is set to OFF.\nContact your system administrator.");
         case 805371910:
            return T._("A VM connection is currently in use. Please try again later.");
         case 805371911:
            return T._("Communication Error. Failed to connect Virtual Media to target.");
         case 805437441:
            return T._(
               "There was a problem with Virtual Media communication. Please try the again.\nIf you receive this error repeatedly, contact technical support for assistance."
            );
         case 805437442:
            return T._(
               "Virtual Media mounting on the Port failed. Please try again.\nIf you receive this error repeatedly, contact technical support for assistance"
            );
         case 838991875:
            return T._("User cancelled connection.");
         case 838991876:
            return T._("Device cancelled connection.");
         default:
            return T._("Unknown error");
      }
   }
}
