package nn.pp.vmcore.impl.msp.V01_02;

import java.io.IOException;
import nn.pp.core.impl.MonitoringDataInputStream;
import nn.pp.core.impl.MonitoringDataOutputStream;
import nn.pp.core.impl.ProtocolMessage;

public class MspSendDataMsgV01_02 extends ProtocolMessage {
   public byte[] writeBuffer = null;
   public int sectorCount;
   public int sectorSize;
   public long startSector;

   private void checkWriteBufSize(int var1) {
      if (this.writeBuffer == null || this.writeBuffer.length < var1) {
         this.writeBuffer = new byte[var1];
      }
   }

   public void write(MonitoringDataOutputStream var1, int var2, int var3, int var4, byte[] var5) throws IOException {
      this.write(2);
      this.writeByte(var2 & 0xFF);
      this.writeUnsignedShort(var3);
      this.writeUnsignedShort(var4);
      this.writeShort(0);
      this.writeInt(0);
      if (var3 != 0 && var4 != 0) {
         this.write(var5, 0, var3 * var4);
      }

      var1.write(this);
   }

   public void read(MonitoringDataInputStream var1, boolean var2) throws IOException {
      if (!var2) {
         var1.readUnsignedByte();
      }

      var1.readByte();
      this.sectorCount = var1.readShort() & '\uffff';
      this.sectorSize = var1.readShort() & '\uffff';
      var1.readShort();
      this.startSector = var1.readInt() & -1;
      this.checkWriteBufSize(this.sectorCount * this.sectorSize);
      var1.readFully(this.writeBuffer, 0, this.sectorCount * this.sectorSize);
   }
}
