package nn.pp.core;

public interface INotificationEvent {
   int getErrorCode();

   int getGroupId();

   int getMessageGroupErrorCode();

   int getMessageGroupId();

   boolean isDebug();

   boolean isError();

   boolean isWarning();

   boolean isInfo();

   boolean isQuit();

   boolean isClientGeneratedError();

   INotificationEvent.Severity getSeverityType();

   String getMessage();

   boolean isRFB();

   boolean isMSP();

   INotificationEvent clone();

   public static enum Severity {
      DEBUG,
      ERROR,
      WARNING,
      INFO,
      UNKNOWN;
   }
}
