package nn.pp.rccore;

import java.util.List;
import java.util.Locale;

public interface ConnectionEventListener {
   int PORT_LIST = 1;
   int SERVER_ID = 2;
   int CONNECTED_USERS = 4;
   int MONITOR_MODE = 8;
   int EXCLUSIVE_MODE = 16;
   int LANGUAGE = 32;
   int PROTOCOL_VERSION = 64;
   int DEVICE_NAME = 128;
   int STATUS_INFO = 256;
   int CHAT = 512;
   int USB_PROFILE = 1024;
   int CIM_LANG_OPTION = 2048;
   int ETH_GIGABIT_SUPPORT = 4096;
   int ALL = 8191;

   void disconnected(Exception var1);

   void connected();

   String portListChanged(List<? extends IKvmPort> var1);

   void serverSessionIdChanged(int var1);

   void connectedUsersChanged(int var1);

   void monitorModePermissionChanged(boolean var1);

   void monitorModeChanged(boolean var1);

   void exclusiveModePermissionChanged(boolean var1);

   void exclusiveModeChanged(boolean var1);

   void languageChanged(Locale var1);

   void protocolVersionChanged(String var1);

   void deviceNameChanged(String var1);

   void incomingTrafficSpeed(int var1);

   void outgoingTrafficSpeed(int var1);

   void framesPerSecond(int var1);

   void chatWelcomeChanged(String var1);

   void newChatMessage(String var1);

   void cimLanguageOptionsSupported(boolean var1);

   void ethernetGigabitSupported(boolean var1);
}
