package nn.pp.rccore;

public interface IVideoSettings {
   IVideoSettings.IVideoSettingInteger getBrightness();

   IVideoSettings.IVideoSettingInteger getBrightnessRed();

   IVideoSettings.IVideoSettingInteger getBrightnessGreen();

   IVideoSettings.IVideoSettingInteger getBrightnessBlue();

   IVideoSettings.IVideoSettingInteger getContrastRed();

   IVideoSettings.IVideoSettingInteger getContrastGreen();

   IVideoSettings.IVideoSettingInteger getContrastBlue();

   IVideoSettings.IVideoSettingInteger getPhase();

   IVideoSettings.IVideoSettingInteger getClock();

   IVideoSettings.IVideoSettingInteger getOffsetX();

   IVideoSettings.IVideoSettingInteger getOffsetY();

   IVideoSettings.IVideoSettingInteger getNoiseFilter();

   IVideoSettings.IVideoSettingBoolean getAutoColorCalibration();

   IVideoSettings.IVideoSettingBoolean getAutoAutoAdjust();

   IVideoSettings.IVideoSettingAction getResetAllModes();

   IVideoSettings.IVideoSettingAction getResetThisMode();

   IVideoSettings.IVideoSettingAction getResetThisPort();

   IVideoSettings.IVideoSettingAction getSaveSettings();

   IVideoSettings.IVideoSettingAction getCancelSettings();

   IVideoSettings.IVideoSettingIntegerReadOnly getResolutionX();

   IVideoSettings.IVideoSettingIntegerReadOnly getResolutionY();

   IVideoSettings.IVideoSettingIntegerReadOnly getRefreshRate();

   public interface IVideoSetting {
      boolean isSupported();

      void setSupported(boolean var1);
   }

   public interface IVideoSettingAction extends IVideoSettings.IVideoSetting {
   }

   public interface IVideoSettingBoolean extends IVideoSettings.IVideoSetting {
      boolean isEnabled();

      void setEnabled(boolean var1);
   }

   public interface IVideoSettingInteger extends IVideoSettings.IVideoSettingIntegerReadOnly {
      int getMinValue();

      void setMinValue(int var1);

      int getMaxValue();

      void setMaxValue(int var1);
   }

   public interface IVideoSettingIntegerReadOnly extends IVideoSettings.IVideoSetting {
      int getValue();

      void setValue(int var1);
   }
}
