package nn.pp.rccore;

import java.awt.Dimension;
import java.awt.Rectangle;
import java.util.List;

public interface VideoEventListener {
   int ENCODING_CHANGE_ALLOWED = 1;
   int ENCODING_SETTINGS_CHANGED = 2;
   int ENCODING_CHANGED = 4;
   int VIDEO_SETTINGS = 8;
   int RESOLUTION_CHANGED = 16;
   int OSD_MESSAGE_RECEIVED = 32;
   int VIDEO_DATA_UPDATED = 64;
   int ALL = 127;

   void encodingChangeAllowed(boolean var1);

   void encodingAutoSupportedChanged(boolean var1);

   void supportedEncodingPredefinesChanged(List<RCCore.Predefine> var1);

   void supportedEncodingColorDepthsChanged(List<RCCore.ColorDepth> var1);

   void supportedEncodingCompressionsChanged(List<RCCore.Compression> var1);

   void encodingLossySupportedChanged(boolean var1);

   void encodingAutoChanged(boolean var1);

   void encodingColorDepthChanged(RCCore.ColorDepth var1);

   void encodingCompressionChanged(RCCore.Compression var1);

   void encodingLossyChanged(boolean var1);

   void videoSettingsSupportChanged(boolean var1);

   void videoAutoAdjustSupportChanged(boolean var1);

   void colorCalibrationSupportChanged(boolean var1);

   void videoRefreshSupportChanged(boolean var1);

   void videoSettingsUpdated(IVideoSettings var1);

   void resolutionChanged(Dimension var1);

   void osdMessageReceived(String var1, boolean var2);

   void videoDataUpdated(Rectangle var1);
}
