package nn.pp.rccore.impl;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.Image;
import java.awt.Rectangle;
import java.awt.image.BufferedImage;
import java.text.ParseException;
import java.util.concurrent.locks.ReadWriteLock;
import javax.swing.JComponent;
import nn.pp.rccore.RCCore;

public interface RemoteConsoleRenderer {
   JComponent getRCJComponent();

   BufferedImage getSnapshot();

   BufferedImage getSnapshot(Rectangle var1);

   void drawRemoteConsoleData(Image var1, int var2, int var3, int var4, int var5);

   void screenResolutionChanged(Dimension var1);

   void setOSD(String var1, int var2, boolean var3);

   void init();

   void dispose();

   void setRenewer(FramebufferRenewer var1);

   void setSingleCursorMode(boolean var1);

   void setMouseSyncString(String var1);

   void setMouseSyncKeys(String var1, String var2) throws ParseException;

   void setCaptureRightAway(boolean var1);

   void setEnforceSmmHotkeyCheck(boolean var1);

   void setOsdBgColor(Color var1);

   void setOsdFgColor(Color var1);

   void setOsdAlpha(int var1);

   void setOsdPosition(String var1);

   void setOsdDisabled(boolean var1);

   boolean isOsdDisabled();

   double getScalingX();

   double getScalingY();

   boolean isScaleToFit();

   boolean isScaleToFitKeepAr();

   void setScaling(double var1, double var3) throws IllegalArgumentException;

   void setScaleToFit(boolean var1, boolean var2, Dimension var3);

   RCCore.Interpolation getInterpolation();

   void setInterpolation(RCCore.Interpolation var1);

   void setFrameSize(Dimension var1);

   <CT> CT getCapablity(Class<CT> var1);

   ReadWriteLock getLock();

   void setImageProvider(ImageProvider var1);
}
