package com.sun.deploy;

import com.sun.deploy.net.cookie.DeployCookieSelector;
import com.sun.deploy.net.proxy.DeployProxySelector;
import com.sun.deploy.net.proxy.StaticProxyManager;
import com.sun.deploy.security.DeployAuthenticator;
import com.sun.deploy.services.ServiceManager;
import java.lang.reflect.Method;
import java.lang.reflect.Modifier;
import java.net.Authenticator;
import java.util.Properties;

public class ClientContainer {
   public static void main(String[] var0) {
      if (var0.length < 1) {
         System.err.println("Usage: ClientContainer class-name [args ...]");
         System.exit(1);
      }

      try {
         if (System.getProperty("os.name").indexOf("Windows") != -1) {
            ServiceManager.setService(33024);
         } else {
            ServiceManager.setService(36864);
         }

         try {
            DeployProxySelector.reset();
            DeployCookieSelector.reset();
         } catch (Throwable var8) {
            StaticProxyManager.reset();
         }

         Properties var1 = System.getProperties();
         String var2 = (String)var1.get("java.protocol.handler.pkgs");
         if (var2 != null) {
            var1.put("java.protocol.handler.pkgs", var2 + "|com.sun.deploy.net.protocol");
         } else {
            var1.put("java.protocol.handler.pkgs", "com.sun.deploy.net.protocol");
         }

         System.setProperties(var1);
         Authenticator.setDefault(new DeployAuthenticator());
         Class var3 = Class.forName(var0[0]);
         Class[] var4 = new Class[]{new String[0].getClass()};
         Method var5 = var3.getMethod("main", var4);
         if (!Modifier.isStatic(var5.getModifiers())) {
            throw new NoSuchMethodException("Cannot find main-method.");
         }

         var5.setAccessible(true);
         String[] var6 = new String[var0.length - 1];

         for (int var7 = 0; var7 < var6.length; var7++) {
            var6[var7] = var0[var7 + 1];
         }

         Object[] var10 = new Object[]{var6};
         var5.invoke(null, var10);
      } catch (Throwable var9) {
         var9.printStackTrace();
         System.exit(2);
      }

      System.exit(0);
   }
}
