package com.sun.deploy.association.utility;

import com.sun.deploy.association.Association;
import com.sun.deploy.association.AssociationAlreadyRegisteredException;
import com.sun.deploy.association.AssociationNotRegisteredException;
import com.sun.deploy.association.RegisterFailedException;

public interface AppAssociationWriter {
   int USER_LEVEL = 1;
   int SYSTEM_LEVEL = 2;
   int DEFAULT_LEVEL = 3;

   void checkAssociationValidForRegistration(Association var1) throws IllegalArgumentException;

   void checkAssociationValidForUnregistration(Association var1) throws IllegalArgumentException;

   boolean isAssociationExist(Association var1, int var2);

   void registerAssociation(Association var1, int var2) throws AssociationAlreadyRegisteredException, RegisterFailedException;

   void unregisterAssociation(Association var1, int var2) throws AssociationNotRegisteredException, RegisterFailedException;
}
