package com.sun.deploy.association.utility;

import com.sun.deploy.association.Action;
import java.net.URL;
import java.util.ArrayList;
import java.util.List;

public class GnomeAssociationUtil {
   public static final String GNOME_VFS_MIME_KEY_DESCRIPTION = "description";
   public static final String GNOME_VFS_MIME_KEY_ICON_FILENAME = "icon_filename";

   private GnomeAssociationUtil() {
   }

   public static String getMimeTypeByFileExt(String var0) {
      String var1 = null;
      String[] var2 = GnomeVfsWrapper.gnome_vfs_get_registered_mime_types();
      if (var2 == null) {
         return null;
      } else {
         for (int var3 = 0; var3 < var2.length; var3++) {
            String var4 = var2[var3];
            String[] var5 = GnomeVfsWrapper.gnome_vfs_mime_get_extensions_list(var4);
            if (var5 != null) {
               for (int var6 = 0; var6 < var5.length; var6++) {
                  if (var5[var6].equals(var0)) {
                     var1 = var2[var3];
                     break;
                  }
               }
            }

            if (var1 != null) {
               break;
            }
         }

         return var1;
      }
   }

   public static List getFileExtListByMimeType(String var0) {
      String[] var1 = GnomeVfsWrapper.gnome_vfs_mime_get_extensions_list(var0);
      if (var1 == null) {
         return null;
      } else {
         ArrayList var2 = new ArrayList();

         for (int var3 = 0; var3 < var1.length; var3++) {
            var2.add(var1[var3]);
         }

         return var2;
      }
   }

   public static String getIconFileNameByMimeType(String var0) {
      return GnomeVfsWrapper.gnome_vfs_mime_get_icon(var0);
   }

   public static String getDescriptionByMimeType(String var0) {
      return GnomeVfsWrapper.gnome_vfs_mime_get_description(var0);
   }

   public static List getActionListByMimeType(String var0) {
      ArrayList var1 = new ArrayList();
      Object var2 = null;
      String[] var3 = GnomeVfsWrapper.gnome_vfs_mime_get_key_list(var0);
      if (var3 != null) {
         Object var4 = null;

         for (int var5 = 0; var5 < var3.length; var5++) {
            var4 = GnomeVfsWrapper.gnome_vfs_mime_get_value(var0, var3[var5]);
            if (var4 != null) {
               var2 = new Action(var3[var5], (String)var4);
               var1.add(var2);
            }
         }
      }

      String var8 = GnomeVfsWrapper.gnome_vfs_mime_get_default_application_command(var0);
      if (var8 != null) {
         var1.add(new Action("open", var8));
      }

      return var1.isEmpty() ? null : var1;
   }

   public static String getMimeTypeByURL(URL var0) {
      return GnomeVfsWrapper.gnome_vfs_get_mime_type(var0.toString());
   }

   public static boolean isMimeTypeExist(String var0) {
      boolean var1 = false;
      String[] var2 = GnomeVfsWrapper.gnome_vfs_get_registered_mime_types();
      if (var2 == null) {
         return false;
      } else {
         for (int var3 = 0; var3 < var2.length; var3++) {
            if (var0.equals(var2[var3])) {
               var1 = true;
               break;
            }
         }

         return var1;
      }
   }

   public static boolean isFileExtExist(String var0) {
      return getMimeTypeByFileExt(var0) != null;
   }

   public static String getEnv(String var0) {
      return GnomeVfsWrapper.getenv(var0);
   }
}
