package com.sun.deploy.config;

import com.sun.deploy.util.Trace;
import java.io.File;
import java.util.ArrayList;
import java.util.Enumeration;
import java.util.Iterator;
import java.util.Properties;

public class JREInfo {
   private static ArrayList _jres = new ArrayList();
   private String _platform;
   private String _product;
   private String _location;
   private String _path;
   private String _osname;
   private String _osarch;
   private boolean _enabled;
   private boolean _registered;
   private boolean _system;

   public String getPlatform() {
      return this._platform;
   }

   public String getProduct() {
      return this._product;
   }

   public String getLocation() {
      return this._location;
   }

   public String getPath() {
      return this._path;
   }

   public String getDebugJavaPath() {
      return Config.getInstance().getDebugJavaPath(this._path);
   }

   public String getOSName() {
      return this._osname;
   }

   public String getOSArch() {
      return this._osarch;
   }

   public boolean isEnabled() {
      return this._enabled;
   }

   public boolean isRegistered() {
      return this._registered;
   }

   public boolean isSystemJRE() {
      return this._system;
   }

   public void setPlatform(String var1) {
      this._platform = var1;
   }

   public void setProduct(String var1) {
      this._product = var1;
   }

   public void setLocation(String var1) {
      this._location = var1;
   }

   public void setPath(String var1) {
      this._path = var1;
   }

   public void setOSName(String var1) {
      this._osname = var1;
   }

   public void setOSArch(String var1) {
      this._osarch = var1;
   }

   public void setEnabled(boolean var1) {
      this._enabled = var1;
   }

   public void setRegistered(boolean var1) {
      this._registered = var1;
   }

   public void setSystemJRE(boolean var1) {
      this._system = var1;
   }

   public JREInfo(String var1, String var2, String var3, String var4, String var5, String var6, boolean var7, boolean var8) {
      this._platform = var1;
      this._product = var2;
      this._location = var3;
      this._path = var4;
      this._osname = var5;
      this._osarch = var6;
      this._enabled = var7;
      this._registered = var8;
      this._system = false;
      if (this._osname == null && this._osarch == null) {
         this._osname = Config.getOSName();
         this._osarch = Config.getOSArch();
      }

      if (this._location == null) {
         this._location = Config.getProperty("deployment.javaws.installURL");
      }
   }

   public JREInfo(int var1, Properties var2, boolean var3) {
      this(
         var2.getProperty("deployment.javaws.jre." + var1 + ".platform"),
         var2.getProperty("deployment.javaws.jre." + var1 + ".product"),
         var2.getProperty("deployment.javaws.jre." + var1 + ".location"),
         var2.getProperty("deployment.javaws.jre." + var1 + ".path"),
         var2.getProperty("deployment.javaws.jre." + var1 + ".osname"),
         var2.getProperty("deployment.javaws.jre." + var1 + ".osarch"),
         false,
         false
      );
      String var4 = var2.getProperty("deployment.javaws.jre." + var1 + ".enabled");
      if (var4 != null && Boolean.valueOf(var4)) {
         this.setEnabled(true);
      }

      var4 = var2.getProperty("deployment.javaws.jre." + var1 + ".registered");
      if (var4 != null && Boolean.valueOf(var4)) {
         this.setRegistered(true);
      }

      this.setSystemJRE(var3);
   }

   public JREInfo(JREInfo var1) {
      this(var1.getPlatform(), var1.getProduct(), var1.getLocation(), var1.getPath(), var1.getOSName(), var1.getOSArch(), var1.isEnabled(), var1.isRegistered());
      this.setSystemJRE(var1.isSystemJRE());
   }

   public static void addJRE(JREInfo var0) {
      _jres.add(var0);
   }

   public static void removeJRE(int var0) {
      _jres.remove(var0);
   }

   public static JREInfo getJREInfo(int var0) {
      return (JREInfo)_jres.get(var0);
   }

   public static void setJREInfo(int var0, JREInfo var1) {
      _jres.set(var0, var1);
   }

   public static void clear() {
      _jres.clear();
   }

   public static JREInfo[] get() {
      return _jres.toArray(new JREInfo[0]);
   }

   public static void initialize(Properties var0, Properties var1) {
      ArrayList var2 = new ArrayList();
      int var3 = -1;
      _jres.clear();
      Enumeration var4 = var1.keys();

      while (var4.hasMoreElements()) {
         String var5 = (String)var4.nextElement();
         if (var5.startsWith("deployment.javaws.jre.")) {
            int var6 = getJREIndex(var5);
            if (var6 >= 0 && var6 != var3) {
               Integer var7 = new Integer(var6);
               if (!var2.contains(var7)) {
                  var2.add(var7);
                  addJRE(new JREInfo(var6, var1, false));
               }

               var3 = var6;
            }
         }
      }

      var4 = var0.keys();
      var3 = -1;
      var2 = new ArrayList();

      while (var4.hasMoreElements()) {
         String var12 = (String)var4.nextElement();
         if (var12.startsWith("deployment.javaws.jre.")) {
            int var14 = getJREIndex(var12);
            if (var14 >= 0 && var14 != var3) {
               Integer var16 = new Integer(var14);
               if (!var2.contains(var16)) {
                  var2.add(var16);
                  addJRE(new JREInfo(var14, var0, true));
               }

               var3 = var14;
            }
         }
      }

      JREInfo var13 = getHomeJRE();
      if (var13 != null) {
         boolean var15 = false;

         for (int var17 = 0; var17 < _jres.size(); var17++) {
            JREInfo var8 = (JREInfo)_jres.get(var17);
            if (var8.isSystemJRE() && var8.getPath() != null && var8.getPath().equals(var13.getPath())) {
               var15 = true;
            }
         }

         if (!var15) {
            JREInfo var18 = new JREInfo(var13);
            var18.setEnabled(true);
            var18.setLocation(Config.getProperty("deployment.javaws.installURL"));
            var18.setRegistered(true);
            var18.setSystemJRE(true);
            String var19 = Config.getProperty("deployment.version");
            if (var19 != null && var19.length() >= 3) {
               var18.setPlatform(var19.substring(0, 3));
               var18.setProduct(var19);
            }

            addJRE(var18);
         }
      }
   }

   private static int getJREIndex(String var0) {
      int var1 = "deployment.javaws.jre.".length();
      int var2 = var0.indexOf(".", var1);
      if (var2 > var1) {
         String var3 = var0.substring(var1, var2);

         try {
            return Integer.parseInt(var3);
         } catch (NumberFormatException var5) {
         }
      }

      return -1;
   }

   public boolean isOsInfoMatch(String var1, String var2) {
      if (this._osname == null || this._osarch == null) {
         return true;
      } else {
         return !this._osname.equals("SunOS") ? this._osname.equals(var1) : this._osname.equals(var1) && this._osarch.equals(var2);
      }
   }

   public String toString() {
      int var1 = 0;

      while (var1 < _jres.size() && !this.equals(_jres.get(var1))) {
         var1++;
      }

      return (var1 < _jres.size() ? "JREInfo for index " + var1 + ":\n" : "JREInfo (not in list):\n")
         + "    platform is: "
         + this._platform
         + "\n"
         + "    product is: "
         + this._product
         + "\n"
         + "    location is: "
         + this._location
         + "\n"
         + "    path is: "
         + this._path
         + "\n"
         + "    osname is: "
         + this._osname
         + "\n"
         + "    osarch is: "
         + this._osarch
         + "\n"
         + "    enabled is: "
         + this._enabled
         + "\n"
         + "    registered is: "
         + this._registered
         + "\n"
         + "    system is: "
         + this._system
         + "\n"
         + "";
   }

   public static void printJREs() {
      for (int var0 = 0; var0 < _jres.size(); var0++) {
         Trace.println(_jres.get(var0).toString());
      }
   }

   public static String getKnownPlatforms() {
      StringBuffer var0 = new StringBuffer();

      for (int var1 = 0; var1 < _jres.size(); var1++) {
         JREInfo var2 = (JREInfo)_jres.get(var1);
         var0.append(var2.getPlatform());
         var0.append(" ");
      }

      return var0.toString();
   }

   public static String getDefaultJavaPath() {
      JREInfo var0 = getHomeJRE();
      return var0 != null ? var0.getPath() : ((JREInfo)_jres.get(0)).getPath();
   }

   public static JREInfo getHomeJRE() {
      String var0 = Config.getJavaHome();
      File var1 = new File(var0);

      for (int var2 = 0; var2 < _jres.size(); var2++) {
         JREInfo var3 = (JREInfo)_jres.get(var2);
         String var4 = var3.getPath();
         if (var4 != null) {
            File var5 = new File(var4).getParentFile();
            if (var5 != null && var5.getParentFile().equals(var1)) {
               return var3;
            }
         }
      }

      return null;
   }

   public static void removeJREsIn(String var0) {
      Iterator var1 = _jres.iterator();

      while (var1.hasNext()) {
         JREInfo var2 = (JREInfo)var1.next();
         String var3 = var2.getPath();
         if (var3 != null && var3.startsWith(var0)) {
            var1.remove();
         }
      }
   }
}
