package com.sun.deploy.config;

import com.sun.deploy.panel.PlatformSpecificUtils;
import com.sun.deploy.resources.ResourceManager;
import java.util.ArrayList;
import java.util.Enumeration;
import java.util.HashMap;
import java.util.Properties;
import java.util.Vector;

public class PluginJavaInfo extends JREInfo {
   private static ArrayList pluginJres = new ArrayList();
   private static String JRENAME = getMessage("jpi.jre.string");
   private static String JDKNAME = getMessage("jpi.jdk.string");
   private String vm_args;
   private String productName = JRENAME;

   public PluginJavaInfo(String var1, String var2, boolean var3, String var4) {
      super((String)null, var1, (String)null, var2, Config.getOSName(), Config.getOSArch(), false, false);
      this.setSystemJRE(var3);
      this.vm_args = var4;
   }

   public PluginJavaInfo(PluginJavaInfo var1) {
      super(
         var1.getPlatform(), var1.getProduct(), var1.getLocation(), var1.getPath(), var1.getOSName(), var1.getOSArch(), var1.isEnabled(), var1.isRegistered()
      );
      this.setSystemJRE(var1.isSystemJRE());
      this.vm_args = var1.getVmArgs();
      this.productName = var1.getProductName();
   }

   public String getVmArgs() {
      return this.vm_args;
   }

   public String getProductName() {
      return this.productName;
   }

   public void setVmArgs(String var1) {
      this.vm_args = var1;
   }

   public void setProductName(String var1) {
      this.productName = var1;
   }

   public static void addJRE(PluginJavaInfo var0) {
      pluginJres.add(var0);
   }

   public static void removeJRE(int var0) {
      pluginJres.remove(var0);
   }

   public static void setJREInfo(int var0, PluginJavaInfo var1) {
      pluginJres.set(var0, var1);
   }

   public static void clear() {
      pluginJres.clear();
   }

   public static PluginJavaInfo[] getAll() {
      return pluginJres.toArray(new PluginJavaInfo[0]);
   }

   public static void initialize(Properties var0, Properties var1) {
      clear();
      Vector var2 = PlatformSpecificUtils.getPublicJres();
      setInstalledJREList(var2);
      addToList(var0);
      addToList(var1);
   }

   private static void addToList(Properties var0) {
      Enumeration var1 = var0.keys();
      HashMap var2 = new HashMap();
      HashMap var3 = new HashMap();
      boolean var4 = true;

      while (var1.hasMoreElements()) {
         String var5 = (String)var1.nextElement();
         int var6;
         if (var5.startsWith("deployment.javapi.jre.")) {
            var6 = "deployment.javapi.jre.".length();
         } else {
            var6 = "deployment.javapi.jdk.".length();
            var4 = false;
         }

         if (var5.endsWith(".path")) {
            int var7 = var5.indexOf(".path");
            String var8 = var5.substring(var6, var7);
            String var9 = (String)var0.get(var5);
            var2.put(var8, var9);
         } else {
            int var15 = var5.indexOf(".args");
            if (var15 != -1) {
               String var18 = var5.substring(var6, var15);
               String var10 = (String)var0.get(var5);
               var3.put(var18, var10);
            }
         }
      }

      PluginJavaInfo[] var12 = getAll();

      for (int var13 = 0; var13 < var12.length; var13++) {
         if (var12[var13].getOSName().equals(Config.getOSName()) && var12[var13].getOSArch().equals(Config.getOSArch())) {
            String var16 = var12[var13].getProduct();
            if (var2.containsKey(var16)) {
               var2.remove(var16);
               if (var3.containsKey(var16)) {
                  String var19 = (String)var3.get(var16);
                  var12[var13].setVmArgs(var19);
                  var3.remove(var16);
               }
            }
         }
      }

      for (String var17 : var2.keySet()) {
         String var20 = (String)var2.get(var17);
         String var21 = (String)var3.get(var17);
         PluginJavaInfo var11 = new PluginJavaInfo(var17, var20, false, var21);
         if (!var4) {
            var11.setProductName(JDKNAME);
         }

         addJRE(var11);
      }
   }

   public static void setInstalledJREList(Vector var0) {
      for (byte var1 = 0; var1 < var0.size(); var1 += 2) {
         String var2 = (String)var0.get(var1);
         String var3 = (String)var0.get(var1 + 1);
         if (var2.lastIndexOf(".") > 2) {
            PluginJavaInfo var4 = new PluginJavaInfo(var2, var3, true, "");
            addJRE(var4);
         }
      }
   }

   public static void setInstalledJDKList(Vector var0) {
      for (byte var1 = 0; var1 < var0.size(); var1 += 2) {
         String var2 = (String)var0.get(var1);
         String var3 = (String)var0.get(var1 + 1);
         PluginJavaInfo var4 = new PluginJavaInfo(var2, var3, true, "");
         var4.setProductName(JDKNAME);
         addJRE(var4);
      }
   }

   private static String getMessage(String var0) {
      return ResourceManager.getMessage(var0);
   }
}
