package com.sun.deploy.net.cookie;

import com.sun.deploy.resources.ResourceManager;
import com.sun.deploy.services.Service;
import com.sun.deploy.services.ServiceManager;
import com.sun.deploy.util.Trace;
import java.net.URL;
import java.util.HashMap;

public class DeployCookieManager {
   private static HashMap cookieTable = new HashMap();
   private static CookieHandler cookieHandler = null;

   public static synchronized void setCookieInfo(URL var0, String var1) {
      initialize();
      Trace.msgNetPrintln("net.cookie.server", new Object[]{var0, var1});

      try {
         if (cookieHandler != null) {
            cookieHandler.setCookieInfo(var0, var1);
         }
      } catch (CookieUnavailableException var3) {
         System.out.println(ResourceManager.getMessage("net.cookie.ignore.setcookie"));
      }
   }

   public static synchronized String getCookieInfo(URL var0) {
      initialize();
      String var1 = null;

      try {
         String var2 = var0.getProtocol() + var0.getHost() + var0.getFile();
         int var3 = var2.lastIndexOf(47);
         if (var3 < 0) {
            return null;
         }

         var2 = var2.substring(0, var3);

         try {
            if (cookieHandler != null) {
               var1 = cookieHandler.getCookieInfo(var0);
            }

            if (var1 != null && !var1.equals("") && !var1.equals("\n") && !var1.equals("\r\n")) {
               cookieTable.put(var2, var1);
            } else {
               cookieTable.put(var2, "");
               var1 = null;
            }
         } catch (CookieUnavailableException var5) {
            System.out.println(ResourceManager.getMessage("net.cookie.noservice"));
            var1 = (String)cookieTable.get(var2);
         }

         if (var1 != null) {
            Trace.msgNetPrintln("net.cookie.connect", new Object[]{var0, var1});
         }
      } catch (Throwable var6) {
         var6.printStackTrace();
      }

      return var1;
   }

   private static void initialize() {
      if (cookieHandler == null) {
         Service var0 = ServiceManager.getService();
         cookieHandler = var0.getCookieHandler();
      }
   }
}
