package com.sun.deploy.net.cookie;

import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.Locale;
import java.util.TimeZone;

class RfcDateParser {
   private boolean isGMT = false;
   private static final String[] standardFormats = new String[]{
      "EEEE', 'dd-MMM-yy HH:mm:ss z",
      "EEEE', 'dd-MMM-yy HH:mm:ss",
      "EEE', 'dd-MMM-yyyy HH:mm:ss z",
      "EEE', 'dd MMM yyyy HH:mm:ss z",
      "EEEE', 'dd MMM yyyy HH:mm:ss z",
      "EEE', 'dd MMM yyyy hh:mm:ss z",
      "EEEE', 'dd MMM yyyy hh:mm:ss z",
      "EEE MMM dd HH:mm:ss z yyyy",
      "EEE MMM dd HH:mm:ss yyyy",
      "EEE', 'dd-MMM-yy HH:mm:ss",
      "EEE', 'dd-MMM-yyyy HH:mm:ss"
   };
   private static final String[] gmtStandardFormats = new String[]{
      "EEEE',' dd-MMM-yy HH:mm:ss 'GMT'",
      "EEE',' dd-MMM-yyyy HH:mm:ss 'GMT'",
      "EEE',' dd MMM yyyy HH:mm:ss 'GMT'",
      "EEEE',' dd MMM yyyy HH:mm:ss 'GMT'",
      "EEE',' dd MMM yyyy hh:mm:ss 'GMT'",
      "EEEE',' dd MMM yyyy hh:mm:ss 'GMT'",
      "EEE MMM dd HH:mm:ss 'GMT' yyyy"
   };
   String dateString;

   RfcDateParser(String var1) {
      this.dateString = var1.trim();
      if (this.dateString.indexOf("GMT") != -1) {
         this.isGMT = true;
      }
   }

   Date getDate() {
      int var1 = this.isGMT ? gmtStandardFormats.length : standardFormats.length;

      for (int var2 = 0; var2 < var1; var2++) {
         Date var3;
         if (this.isGMT) {
            var3 = this.tryParsing(gmtStandardFormats[var2]);
         } else {
            var3 = this.tryParsing(standardFormats[var2]);
         }

         if (var3 != null) {
            return var3;
         }
      }

      return null;
   }

   private Date tryParsing(String var1) {
      SimpleDateFormat var2 = new SimpleDateFormat(var1, Locale.US);
      if (this.isGMT) {
         var2.setTimeZone(TimeZone.getTimeZone("GMT"));
      }

      try {
         return var2.parse(this.dateString);
      } catch (Exception var4) {
         return null;
      }
   }
}
