package com.sun.deploy.net.proxy;

import com.sun.deploy.util.Trace;
import java.net.URL;

public class BrowserProxyConfigCanonicalizer implements BrowserProxyConfig {
   private BrowserProxyInfo bpi = new BrowserProxyInfo();

   public BrowserProxyConfigCanonicalizer(BrowserProxyConfig var1, ProxyHandler var2) {
      this.bpi = var1.getBrowserProxyInfo();
      if (this.bpi.getType() == 4) {
         var1.getSystemProxy(this.bpi);
      }

      this.canonicalizeAutoConfigProxy(this.bpi, var2);
   }

   private void canonicalizeAutoConfigProxy(BrowserProxyInfo var1, ProxyHandler var2) {
      if (var1.getType() == 2) {
         ProxyInfo[] var3 = new ProxyInfo[0];

         try {
            var2.init(var1);
            var3 = var2.getProxyInfo(new URL("http://java.sun.com"));
         } catch (Throwable var5) {
            Trace.msgNetPrintln("net.proxy.loading.auto.error");
         }

         ProxyInfo var4 = null;
         if (var3.length > 0) {
            var4 = var3[0];
         }

         var1.setHintOnly(true);
         if (var4 != null) {
            if (var4.isSocksUsed()) {
               var1.setSocksHost(var4.getSocksProxy());
               var1.setSocksPort(var4.getSocksPort());
            } else {
               var1.setHttpHost(var4.getProxy());
               var1.setHttpPort(var4.getPort());
               var1.setHttpsHost(var4.getProxy());
               var1.setHttpsPort(var4.getPort());
               var1.setFtpHost(var4.getProxy());
               var1.setFtpPort(var4.getPort());
               var1.setGopherHost(var4.getProxy());
               var1.setGopherPort(var4.getPort());
            }
         }
      }
   }

   public BrowserProxyInfo getBrowserProxyInfo() {
      return this.bpi;
   }

   public void getSystemProxy(BrowserProxyInfo var1) {
   }
}
