package com.sun.deploy.net.proxy;

import com.sun.deploy.util.Trace;
import java.io.IOException;
import java.net.MalformedURLException;
import java.net.Proxy;
import java.net.ProxySelector;
import java.net.SocketAddress;
import java.net.URI;
import java.net.URL;
import java.security.AccessController;
import java.security.PrivilegedActionException;
import java.util.ArrayList;
import java.util.List;

public class DeployProxySelector extends ProxySelector {
   public static void reset() {
      DynamicProxyManager.reset();
      ProxySelector.setDefault(new DeployProxySelector());
   }

   public List select(URI var1) {
      if (var1 == null) {
         throw new IllegalArgumentException();
      } else {
         String var2 = var1.getHost();
         int var3 = var1.getPort();
         if (var2 == null) {
            String var4 = var1.getAuthority();
            if (var4 != null) {
               int var5 = var4.indexOf(64);
               if (var5 >= 0) {
                  var4 = var4.substring(var5 + 1);
               }

               var5 = var4.lastIndexOf(58);
               if (var5 >= 0) {
                  try {
                     var3 = Integer.parseInt(var4.substring(var5 + 1));
                  } catch (NumberFormatException var12) {
                     var3 = -1;
                  }

                  var4 = var4.substring(0, var5);
               }

               var2 = var4;
            }
         }

         ArrayList var15 = new ArrayList();
         Proxy var17 = Proxy.NO_PROXY;

         try {
            String var6 = var1.getScheme();
            boolean var7 = var6.equalsIgnoreCase("socket") || var6.equalsIgnoreCase("serversocket");
            Object var8 = null;
            if (var7) {
               if (var3 == -1) {
                  var8 = new URL("http://" + var2 + "/");
               } else {
                  var8 = new URL("http://" + var2 + ":" + var3 + "/");
               }
            } else {
               var8 = var1.toURL();
            }

            ProxyInfo var9 = DynamicProxyManager.getProxyInfo((URL)var8);
            if (var9.isProxyUsed()) {
               try {
                  var17 = AccessController.doPrivileged(new DeployProxySelector$1(this, var7, var9));
               } catch (PrivilegedActionException var11) {
               }
            }
         } catch (MalformedURLException var13) {
            var13.printStackTrace();
         } catch (Throwable var14) {
            var14.printStackTrace();
         }

         Trace.msgNetPrintln("net.proxy.connect", new Object[]{var1, var17});
         var15.add(var17);
         return var15;
      }
   }

   public void connectFailed(URI var1, SocketAddress var2, IOException var3) {
      if (var1 == null || var2 == null || var3 == null) {
         throw new IllegalArgumentException("Arguments can't be null.");
      }
   }
}
