package com.sun.deploy.net.proxy;

import com.sun.deploy.util.Trace;
import java.net.URL;

public class MSystemProxyHandler implements ProxyHandler {
   protected static boolean hasSystemProxies = false;

   public final boolean isSupported(int var1) {
      return var1 == 4;
   }

   public final boolean isProxyCacheSupported() {
      return false;
   }

   public final void init(BrowserProxyInfo var1) throws ProxyConfigException {
      Trace.msgNetPrintln("net.proxy.loading.system");
      if (!this.isSupported(var1.getType())) {
         throw new ProxyConfigException("Unable to support proxy type: " + var1.getType());
      } else {
         Trace.msgNetPrintln("net.proxy.loading.done");
      }
   }

   public final ProxyInfo[] getProxyInfo(URL var1) throws ProxyUnavailableException {
      ProxyInfo[] var2 = new ProxyInfo[1];
      String var3 = var1.getProtocol();
      String var4 = var1.getHost();
      if (hasSystemProxies) {
         String var5 = this.getSystemProxy(var3, var4);
         if (var5 == null) {
            return new ProxyInfo[]{new ProxyInfo(null)};
         } else {
            var2[0] = new ProxyInfo(var5);
            return var2;
         }
      } else {
         return new ProxyInfo[]{new ProxyInfo(null)};
      }
   }

   protected static native boolean init();

   protected native String getSystemProxy(String var1, String var2);

   static {
      hasSystemProxies = init();
   }
}
