package com.sun.deploy.net.proxy;

public final class ProxyInfo {
   private String proxy = null;
   private int port = -1;
   private String socksProxy = null;
   private int socksPort = -1;

   public ProxyInfo(String var1) {
      this(var1, null);
   }

   public ProxyInfo(String var1, String var2) {
      if (var1 != null) {
         int var3 = var1.indexOf("//");
         if (var3 >= 0) {
            var1 = var1.substring(var3 + 2);
         }

         var3 = var1.lastIndexOf(58);
         if (var3 >= 0) {
            this.proxy = var1.substring(0, var3);

            try {
               this.port = Integer.parseInt(var1.substring(var3 + 1));
            } catch (Exception var6) {
            }
         } else if (!var1.equals("")) {
            this.proxy = var1;
         }
      }

      if (var2 != null) {
         int var8 = var2.lastIndexOf(58);
         if (var8 >= 0) {
            this.socksProxy = var2.substring(0, var8);

            try {
               this.socksPort = Integer.parseInt(var2.substring(var8 + 1));
            } catch (Exception var5) {
            }
         } else if (!var2.equals("")) {
            this.socksProxy = var2;
         }
      }
   }

   public ProxyInfo(String var1, int var2) {
      this(var1, var2, null, -1);
   }

   public ProxyInfo(String var1, int var2, String var3, int var4) {
      this.proxy = var1;
      this.port = var2;
      this.socksProxy = var3;
      this.socksPort = var4;
   }

   public String getProxy() {
      return this.proxy;
   }

   public int getPort() {
      return this.port;
   }

   public String getSocksProxy() {
      return this.socksProxy;
   }

   public int getSocksPort() {
      return this.socksPort;
   }

   public boolean isProxyUsed() {
      return this.proxy != null || this.socksProxy != null;
   }

   public boolean isSocksUsed() {
      return this.socksProxy != null;
   }

   public String toString() {
      if (this.proxy != null) {
         return this.proxy + ":" + this.port;
      } else {
         return this.socksProxy != null ? this.socksProxy + ":" + this.socksPort : "DIRECT";
      }
   }
}
