package com.sun.deploy.net.proxy;

import com.sun.deploy.config.Config;
import com.sun.deploy.net.protocol.rmi.DeployRMISocketFactory;
import com.sun.deploy.services.Service;
import com.sun.deploy.services.ServiceManager;
import com.sun.deploy.util.DialogFactory;
import com.sun.deploy.util.Trace;
import java.rmi.server.RMISocketFactory;
import java.security.AccessController;
import java.util.Properties;

public class StaticProxyManager {
   public static void reset() {
      try {
         UserDefinedProxyConfig var0 = new UserDefinedProxyConfig();
         BrowserProxyInfo var1 = var0.getBrowserProxyInfo();
         Service var2 = ServiceManager.getService();
         if (var1.getType() == 3) {
            BrowserProxyConfig var3 = var2.getProxyConfig();
            var1 = var3.getBrowserProxyInfo();
         } else if (var1.getType() == 2) {
            BrowserProxyConfigCanonicalizer var6 = new BrowserProxyConfigCanonicalizer(var0, var2.getAutoProxyHandler());
            var1 = var6.getBrowserProxyInfo();
         }

         try {
            if (var1.getType() != 0) {
               RMISocketFactory.setSocketFactory(new DeployRMISocketFactory());
            }
         } catch (Throwable var4) {
         }

         AccessController.doPrivileged(new StaticProxyManager$1(var1));
         Trace.msgNetPrintln(var1.toString());
      } catch (Throwable var5) {
         var5.printStackTrace();
         DialogFactory.showExceptionDialog(var5);
      }
   }

   private static void setProperties(BrowserProxyInfo var0) {
      Properties var1 = System.getProperties();
      boolean var2 = !Config.isJavaVersionAtLeast14();
      switch (var0.getType()) {
         case 0:
            var1.remove("trustProxy");
            if (var2) {
               var1.remove("proxyHost");
               var1.remove("proxyPort");
            }

            var1.remove("http.proxyHost");
            var1.remove("http.proxyPort");
            var1.remove("http.nonProxyHosts");
            var1.remove("https.proxyHost");
            var1.remove("https.proxyPort");
            var1.remove("https.nonProxyHosts");
            var1.remove("ftp.proxyHost");
            var1.remove("ftp.proxyPort");
            var1.remove("ftp.nonProxyHosts");
            var1.remove("gopherProxySet");
            var1.remove("gopherProxyHost");
            var1.remove("gopherProxyPort");
            var1.remove("socksProxyHost");
            var1.remove("socksProxyPort");
            break;
         case 1:
         case 2:
            var1.put("trustProxy", "true");
            if (var0.getHttpHost() != null) {
               if (var2) {
                  var1.put("proxyHost", var0.getHttpHost());
                  var1.put("proxyPort", String.valueOf(var0.getHttpPort()));
               }

               var1.put("http.proxyHost", var0.getHttpHost());
               var1.put("http.proxyPort", String.valueOf(var0.getHttpPort()));
               var1.put("http.nonProxyHosts", var0.getOverridesString());
            }

            if (var0.getHttpsHost() != null) {
               var1.put("https.proxyHost", var0.getHttpsHost());
               var1.put("https.proxyPort", String.valueOf(var0.getHttpsPort()));
               var1.put("https.nonProxyHosts", var0.getOverridesString());
            }

            if (var0.getFtpHost() != null) {
               var1.put("ftp.proxyHost", var0.getFtpHost());
               var1.put("ftp.proxyPort", String.valueOf(var0.getFtpPort()));
               var1.put("ftp.nonProxyHosts", var0.getOverridesString());
            }

            if (var0.getGopherHost() != null) {
               var1.put("gopherProxySet", "true");
               var1.put("gopherProxyHost", var0.getGopherHost());
               var1.put("gopherProxyPort", String.valueOf(var0.getGopherPort()));
            }

            if (var0.getHttpHost() == null && var0.getSocksHost() != null) {
               var1.put("socksProxyHost", var0.getSocksHost());
               var1.put("socksProxyPort", String.valueOf(var0.getSocksPort()));
            }
            break;
         case 3:
            throw new IllegalStateException("StaticProxyManager:  ProxyType should not be BROWSER");
      }

      System.setProperties(var1);
   }
}
