package com.sun.deploy.net.proxy;

import com.sun.deploy.config.Config;
import com.sun.deploy.util.Trace;
import java.util.ArrayList;
import java.util.Locale;
import java.util.StringTokenizer;

public final class UserDefinedProxyConfig implements BrowserProxyConfig {
   public BrowserProxyInfo getBrowserProxyInfo() {
      Trace.msgNetPrintln("net.proxy.loading.userdef");
      BrowserProxyInfo var1 = new BrowserProxyInfo();
      var1.setType(3);
      Config.refreshIfNecessary();
      int var2 = Config.getIntProperty("deployment.proxy.type");
      if (var2 == 0) {
         var1.setType(0);
      } else if (var2 == 1 || var2 == 2) {
         var1.setType(1);
         if (var2 == 2) {
            String var3 = Config.getProperty("deployment.proxy.auto.config.url");
            Trace.msgNetPrintln("net.proxy.browser.autoConfigURL", new Object[]{var3});
            if (var3 != null && !"".equals(var3.trim())) {
               var1.setType(2);
               var1.setAutoConfigURL(var3);
            }
         }

         StringBuffer var12 = new StringBuffer();
         boolean var4 = false;
         boolean var5 = Config.getBooleanProperty("deployment.proxy.same");
         String var6 = Config.getProperty("deployment.proxy.http.host");
         if (var6 != null && var6.trim().length() > 0) {
            var4 = true;
            if (!var5) {
               var12.append("http=");
            }

            var12.append(var6);
            int var7 = Config.getIntProperty("deployment.proxy.http.port");
            if (var7 > 0) {
               var12.append(":" + var7);
            }
         }

         if (!var5) {
            String var14 = Config.getProperty("deployment.proxy.https.host");
            if (var14 != null && var14.trim().length() > 0) {
               if (var4) {
                  var12.append(";");
               }

               var4 = true;
               var12.append("https=");
               var12.append(var14);
               int var8 = Config.getIntProperty("deployment.proxy.https.port");
               if (var8 > 0) {
                  var12.append(":" + var8);
               }
            }

            String var16 = Config.getProperty("deployment.proxy.ftp.host");
            if (var16 != null && var16.trim().length() > 0) {
               if (var4) {
                  var12.append(";");
               }

               var4 = true;
               var12.append("ftp=");
               var12.append(var16);
               int var9 = Config.getIntProperty("deployment.proxy.ftp.port");
               if (var9 > 0) {
                  var12.append(":" + var9);
               }
            }

            String var18 = Config.getProperty("deployment.proxy.socks.host");
            if (var18 != null && var18.trim().length() > 0) {
               if (var4) {
                  var12.append(";");
               }

               var4 = true;
               var12.append("socks=");
               var12.append(var18);
               int var10 = Config.getIntProperty("deployment.proxy.socks.port");
               if (var10 > 0) {
                  var12.append(":" + var10);
               }
            }
         }

         String var15 = var12.toString();
         Trace.msgNetPrintln("net.proxy.browser.proxyList", new Object[]{var15});
         if (var15 != null && !"".equals(var15.trim())) {
            ProxyUtils.parseProxyServer(var15, var1);
         }

         String var17 = Config.getProperty("deployment.proxy.bypass.list");
         if (Config.getBooleanProperty("deployment.proxy.bypass.local")) {
            if (var17 != null) {
               var17 = var17 + ";<local>";
            } else {
               var17 = "<local>";
            }
         }

         Trace.msgNetPrintln("net.proxy.browser.proxyOverride", new Object[]{var17});
         if (var17 != null && !"".equals(var17.trim())) {
            StringTokenizer var19 = new StringTokenizer(var17, ";");
            ArrayList var20 = new ArrayList();

            while (var19.hasMoreTokens()) {
               String var11 = var19.nextToken().toLowerCase(Locale.ENGLISH).trim();
               if (var11 != null) {
                  var20.add(var11);
               }
            }

            var1.setOverrides(var20);
         }
      }

      Trace.msgNetPrintln("net.proxy.loading.done");
      return var1;
   }

   public void getSystemProxy(BrowserProxyInfo var1) {
   }
}
