package com.sun.deploy.panel;

import com.sun.deploy.config.Config;
import com.sun.deploy.resources.ResourceManager;

public abstract class BasicProperty implements IProperty {
   private String sName;
   private String sValue;
   private String propertyName;
   private String tooltipStr;

   public BasicProperty(String var1, String var2) {
      this.sName = ResourceManager.getMessage(var1);
      this.propertyName = var1;
      this.sValue = var2;
      String var3 = ResourceManager.getMessage(var1 + ".tooltip");
      if (!var3.equalsIgnoreCase(var1 + ".tooltip")) {
         this.tooltipStr = var3;
      } else {
         this.tooltipStr = this.sName;
      }
   }

   public String getDescription() {
      return this.sName;
   }

   public String getPropertyName() {
      return this.propertyName;
   }

   public String getTooltip() {
      return this.tooltipStr;
   }

   public String getValue() {
      return this.sValue;
   }

   public void setValue(String var1) {
      this.sValue = var1;
      Config.setProperty(this.propertyName, var1);
   }
}
