package com.sun.deploy.panel;

import com.sun.deploy.security.CertUtils;
import java.awt.BorderLayout;
import java.security.cert.X509Certificate;
import java.util.Collection;
import javax.swing.BorderFactory;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.table.TableModel;

class CertificateTabPanel extends JPanel {
   private JTable certsTable;

   CertificateTabPanel(CertificatesInfo var1, int var2) {
      this.setLayout(new BorderLayout());
      this.setBorder(BorderFactory.createEmptyBorder(5, 10, 5, 10));
      JScrollPane var3 = new JScrollPane();
      var3.setHorizontalScrollBarPolicy(30);
      var3.setVerticalScrollBarPolicy(22);
      var3.setAutoscrolls(true);
      Collection var4 = var1.getTrustedCertificates(var2);
      if (var4 != null && var4.size() != 0) {
         ReadOnlyTableModel var9 = new ReadOnlyTableModel(var4.size());
         int var6 = 0;

         for (X509Certificate var8 : var4) {
            var9.setValueAt(CertUtils.extractSubjectAliasName(var8), var6, 0);
            var9.setValueAt(CertUtils.extractIssuerAliasName(var8), var6, 1);
            var6++;
         }

         this.certsTable = new JTable(var9);
      } else {
         ReadOnlyTableModel var5 = new ReadOnlyTableModel();
         this.certsTable = new JTable(var5);
      }

      this.certsTable.setDragEnabled(false);
      this.certsTable.setSelectionMode(0);
      this.certsTable.setColumnSelectionAllowed(false);
      if (var4 != null && var4.size() > 0) {
         this.certsTable.setRowSelectionInterval(0, 0);
      }

      var3.setViewportView(this.certsTable);
      this.add(var3, "Center");
   }

   void setCertificateTableModel(TableModel var1) {
      this.certsTable.setModel(var1);
      this.certsTable.setDragEnabled(false);
      this.certsTable.setSelectionMode(0);
      this.certsTable.setColumnSelectionAllowed(false);
      if (var1.getRowCount() > 0) {
         this.certsTable.setRowSelectionInterval(0, 0);
      }

      this.certsTable.updateUI();
   }

   int getSelectedCertificateTableRow() {
      return this.certsTable.getSelectedRow();
   }

   boolean isCertificateSelected() {
      return this.getSelectedCertificateTableRow() != -1;
   }
}
