package com.sun.deploy.panel;

import com.sun.deploy.config.Config;
import com.sun.deploy.resources.ResourceManager;
import java.awt.Component;
import java.io.File;
import java.io.IOException;
import javax.swing.BoxLayout;
import javax.swing.JCheckBox;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;

public class DeleteFilesDialog {
   private JCheckBox appletsCheckBox;
   private JCheckBox applicationCheckBox;
   private JCheckBox tempFilesCheckBox;

   public DeleteFilesDialog(Component var1) {
      JPanel var2 = new JPanel();
      var2.setLayout(new BoxLayout(var2, 1));
      JLabel var3 = new JLabel(this.getMessage("delete.files.dlg.temp_files"));
      this.appletsCheckBox = new JCheckBox(this.getMessage("delete.files.dlg.applets"));
      this.appletsCheckBox.setSelected(true);
      this.applicationCheckBox = new JCheckBox(this.getMessage("delete.files.dlg.applications"));
      this.applicationCheckBox.setSelected(true);
      this.tempFilesCheckBox = new JCheckBox(this.getMessage("delete.files.dlg.other"));
      this.tempFilesCheckBox.setSelected(true);
      var2.add(var3);
      var2.add(new JLabel("   "));
      var2.add(this.appletsCheckBox);
      var2.add(this.applicationCheckBox);
      var2.add(this.tempFilesCheckBox);
      int var4 = JOptionPane.showConfirmDialog(var1, var2, this.getMessage("delete.files.dlg.title"), 2);
      if (var4 == 0) {
         if (this.appletsCheckBox.isSelected()) {
            File var5 = new File(Config.getPluginCacheDir());
            this.deleteFiles(var5);
         }

         if (this.applicationCheckBox.isSelected()) {
            String[] var8 = new String[]{Config.getJavawsCommand(), "-uninstall"};

            try {
               Runtime.getRuntime().exec(var8);
            } catch (IOException var7) {
            }
         }

         if (this.tempFilesCheckBox.isSelected()) {
            File var9 = new File(Config.getLogDirectory());
            this.deleteFiles(var9);
            var9 = new File(Config.getUserExtensionDirectory());
            this.deleteFiles(var9);
            var9 = new File(Config.getTempCacheDir());
            this.deleteFiles(var9);
         }
      }
   }

   private void deleteFilesWithExtension(File var1, String var2) {
      String var3 = "." + var2;
      File[] var4 = var1.listFiles();

      for (int var5 = 0; var5 < var4.length; var5++) {
         if (var4[var5].isDirectory()) {
            this.deleteFilesWithExtension(var4[var5], var2);
            var4[var5].delete();
         } else if (var4[var5].getPath().endsWith(var3)) {
            var4[var5].delete();
         }
      }
   }

   private void deleteFiles(File var1) {
      if (var1.exists() && var1.isDirectory()) {
         File[] var2 = var1.listFiles();

         for (int var3 = 0; var3 < var2.length; var3++) {
            if (var2[var3].isDirectory()) {
               this.deleteFiles(var2[var3]);
            }

            var2[var3].delete();
         }
      }
   }

   private String getMessage(String var1) {
      return ResourceManager.getMessage(var1);
   }
}
