package com.sun.deploy.panel;

import com.sun.deploy.resources.ResourceManager;
import com.sun.deploy.util.AboutDialog;
import java.awt.BorderLayout;
import java.awt.FlowLayout;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.border.EmptyBorder;
import javax.swing.border.EtchedBorder;
import javax.swing.border.TitledBorder;

public class GeneralPanel extends JPanel {
   public GeneralPanel() {
      this.initComponents();
   }

   public void initComponents() {
      this.setLayout(new BorderLayout());
      this.setBorder(new EmptyBorder(new Insets(5, 5, 5, 5)));
      JPanel var1 = new JPanel();
      var1.setLayout(new BoxLayout(var1, 1));
      JPanel var2 = new JPanel();
      var2.setBorder(new TitledBorder(new TitledBorder(new EtchedBorder()), this.getMessage("general.about.border"), 0, 0));
      var2.setLayout(new BorderLayout());
      JSmartTextArea var3 = new JSmartTextArea(this.getMessage("general.about.text"));
      JPanel var4 = new JPanel();
      var4.setLayout(new FlowLayout(2));
      JButton var5 = new JButton(this.getMessage("general.about.btn"));
      var5.setMnemonic(ResourceManager.getVKCode("general.about.btn.mnemonic"));
      var5.addActionListener(new GeneralPanel$1(this));
      var5.setToolTipText(this.getMessage("general.about.btn.tooltip"));
      var4.add(var5);
      var2.add(var3, "North");
      var2.add(var4, "South");
      JPanel var6 = new JPanel();
      var6.setLayout(new BorderLayout());
      var6.setBorder(new TitledBorder(new TitledBorder(new EtchedBorder()), this.getMessage("general.cache.border.text"), 0, 0));
      JPanel var7 = new JPanel();
      var7.setLayout(new FlowLayout(2));
      JButton var8 = this.makeButton("general.cache.delete.text");
      var8.addActionListener(new GeneralPanel$2(this));
      var8.setToolTipText(this.getMessage("temp.files.delete.btn.tooltip"));
      JButton var9 = this.makeButton("general.cache.settings.text");
      var9.addActionListener(new GeneralPanel$3(this));
      var9.setToolTipText(this.getMessage("temp.files.settings.btn.tooltip"));
      JSmartTextArea var10 = new JSmartTextArea(this.getMessage("general.cache.desc.text"));
      var7.add(var8);
      var7.add(var9);
      var6.add(var10, "North");
      var6.add(var7, "South");
      JPanel var11 = new JPanel();
      var11.setLayout(new BorderLayout());
      var11.setBorder(new TitledBorder(new TitledBorder(new EtchedBorder()), this.getMessage("general.network.border.text"), 0, 0));
      JPanel var12 = new JPanel();
      var12.setLayout(new FlowLayout(2));
      JButton var13 = this.makeButton("general.network.settings.text");
      var13.addActionListener(new GeneralPanel$4(this));
      var13.setToolTipText(this.getMessage("network.settings.btn.tooltip"));
      var12.add(var13);
      JSmartTextArea var14 = new JSmartTextArea(this.getMessage("general.network.desc.text"));
      var11.add(var14, "North");
      var11.add(var12, "South");
      var1.add(var2);
      var1.add(var11);
      var1.add(var6);
      this.add(var1, "Center");
   }

   private void aboutBtnActionPerformed(ActionEvent var1) {
      AboutDialog var2 = new AboutDialog((JFrame)this.getTopLevelAncestor(), true);
      var2.setVisible(true);
      var2.pack();
      var2.setLocationRelativeTo(this);
      var2.setResizable(false);
   }

   private void tempFilesDeleteBtnActionPerformed(ActionEvent var1) {
      new DeleteFilesDialog(this);
   }

   private void tempFilesSettingsBtnActionPerformed(ActionEvent var1) {
      CacheSettingsDialog var2 = new CacheSettingsDialog((JFrame)this.getTopLevelAncestor(), true);
      var2.pack();
      var2.setLocationRelativeTo(this);
      var2.setVisible(true);
   }

   private void networkSettingsBtnActionPerformed(ActionEvent var1) {
      NetworkSettingsDialog var2 = new NetworkSettingsDialog((JFrame)this.getTopLevelAncestor(), true);
      var2.pack();
      var2.setLocationRelativeTo(this);
      var2.setVisible(true);
   }

   private void viewExtFilesBtnActionPerformed(ActionEvent var1) {
   }

   private String getMessage(String var1) {
      return ResourceManager.getMessage(var1);
   }

   public JButton makeButton(String var1) {
      JButton var2 = new JButton(this.getMessage(var1));
      var2.setMnemonic(ResourceManager.getVKCode(var1 + ".mnemonic"));
      return var2;
   }
}
