package com.sun.deploy.panel;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Insets;
import javax.swing.JLabel;
import javax.swing.JTextArea;
import javax.swing.border.EmptyBorder;

public class JSmartTextArea extends JTextArea {
   public JSmartTextArea(String var1) {
      this();
      this.setText(var1);
   }

   public JSmartTextArea() {
      JLabel var1 = new JLabel();
      this.setBorder(new EmptyBorder(new Insets(0, 5, 0, 0)));
      this.setEditable(false);
      this.setLineWrap(true);
      this.setWrapStyleWord(true);
      this.setFont(var1.getFont());
      this.setFocusable(false);
      this.setRows(0);
      this.invalidate();
   }

   public void setText(String var1) {
      super.setText(var1);
      this.invalidate();
   }

   public void paintComponent(Graphics var1) {
      this.setBackground(new Color(this.getParent().getBackground().getRGB()));
      super.paintComponent(var1);
   }

   public Dimension getPreferredSize() {
      Dimension var1;
      if (this.getRows() == 0 && this.getColumns() == 0) {
         int var2 = 360 / this.getColumnWidth();
         this.setColumns(var2);
         var1 = super.getPreferredSize();
         this.setColumns(0);
      } else {
         var1 = super.getPreferredSize();
      }

      return var1;
   }
}
