package com.sun.deploy.panel;

import com.sun.deploy.resources.ResourceManager;
import java.awt.BorderLayout;
import java.awt.FlowLayout;
import java.awt.GridLayout;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.border.EmptyBorder;
import javax.swing.border.EtchedBorder;
import javax.swing.border.TitledBorder;

public class JavaPanel extends JPanel {
   private JSmartTextArea jpiTextArea;
   private JSmartTextArea jwsTextArea;
   private JButton jpiSettingsBtn;
   private JButton jwsSettingsBtn;

   public JavaPanel() {
      this.initComponents();
   }

   private void initComponents() {
      this.setLayout(new BorderLayout());
      this.setBorder(new EmptyBorder(new Insets(5, 5, 5, 5)));
      JPanel var1 = new JPanel();
      var1.setLayout(new GridLayout(2, 1));
      JPanel var2 = new JPanel();
      var2.setBorder(new TitledBorder(new TitledBorder(new EtchedBorder()), this.getMessage("java.panel.plugin.border"), 0, 0));
      var2.setLayout(new BorderLayout());
      this.jpiTextArea = new JSmartTextArea(this.getMessage("java.panel.plugin.text"));
      JPanel var3 = new JPanel();
      var3.setLayout(new FlowLayout(2));
      this.jpiSettingsBtn = new JButton(this.getMessage("java.panel.jpi_view_btn"));
      this.jpiSettingsBtn.setMnemonic(ResourceManager.getVKCode("java.panel.jpi_view_btn.mnemonic"));
      this.jpiSettingsBtn.addActionListener(new JavaPanel$1(this));
      this.jpiSettingsBtn.setToolTipText(this.getMessage("java.panel.jpi_view_btn.tooltip"));
      var3.add(this.jpiSettingsBtn);
      var2.add(this.jpiTextArea, "North");
      var2.add(var3, "South");
      var1.add(var2);
      JPanel var4 = new JPanel();
      var4.setBorder(new TitledBorder(new TitledBorder(new EtchedBorder()), this.getMessage("java.panel.javaws.border"), 0, 0));
      var4.setLayout(new BorderLayout());
      this.jwsTextArea = new JSmartTextArea(this.getMessage("java.panel.javaws.text"));
      JPanel var5 = new JPanel();
      var5.setLayout(new FlowLayout(2));
      this.jwsSettingsBtn = new JButton(this.getMessage("java.panel.javaws_view_btn"));
      this.jwsSettingsBtn.setMnemonic(ResourceManager.getVKCode("java.panel.javaws_view_btn.mnemonic"));
      this.jwsSettingsBtn.addActionListener(new JavaPanel$2(this));
      this.jwsSettingsBtn.setToolTipText(this.getMessage("java.panel.javaws_view_btn.tooltip"));
      var5.add(this.jwsSettingsBtn);
      var4.add(this.jwsTextArea, "North");
      var4.add(var5, "South");
      var1.add(var4);
      this.add(var1, "Center");
   }

   private void jpiSettingsBtnActionPerformed(ActionEvent var1) {
      PluginJreDialog var2 = new PluginJreDialog((JFrame)this.getTopLevelAncestor(), true);
      var2.setLocationRelativeTo(this);
      var2.setVisible(true);
   }

   private void jwsSettingsBtnActionPerformed(ActionEvent var1) {
      JavawsJreDialog var2 = new JavawsJreDialog((JFrame)this.getTopLevelAncestor(), true);
      var2.setLocationRelativeTo(this);
      var2.setVisible(true);
   }

   private String getMessage(String var1) {
      return ResourceManager.getMessage(var1);
   }
}
