package com.sun.deploy.panel;

import com.sun.deploy.config.JREInfo;
import com.sun.deploy.util.Trace;
import java.util.ArrayList;
import javax.swing.table.AbstractTableModel;

public abstract class JreTableModel extends AbstractTableModel {
   ArrayList _jres = new ArrayList();
   ArrayList _validPaths = new ArrayList();
   String[] _columnNames;

   public JreTableModel(String[] var1) {
      this._columnNames = var1;
   }

   public int getColumnCount() {
      return this._columnNames.length;
   }

   public int getRowCount() {
      return this._jres.size();
   }

   public JREInfo getJRE(int var1) {
      return (JREInfo)this._jres.get(var1);
   }

   public String getColumnName(int var1) {
      return this._columnNames[var1];
   }

   public boolean isPathValid(int var1) {
      Boolean var2 = (Boolean)this._validPaths.get(var1);
      if (var2 == null) {
         if (this.isValidJREPath(this.getJRE(var1).getPath())) {
            var2 = Boolean.TRUE;
         } else {
            var2 = Boolean.FALSE;
         }

         this._validPaths.set(var1, var2);
      }

      return Boolean.TRUE.equals(var2);
   }

   public abstract boolean isValidJREPath(String var1);

   public void add(JREInfo var1, boolean var2, boolean var3) {
      Trace.println("adding jre: " + var1);
      this._jres.add(var1);
      if (var2) {
         this._validPaths.add(Boolean.TRUE);
      } else {
         this._validPaths.add(null);
      }

      if (var3) {
         this.fireTableRowsInserted(this._jres.size() - 1, this._jres.size() - 1);
      }
   }

   public void remove(int[] var1) {
      if (var1 != null) {
         int var2 = this.getRowCount();

         for (int var3 = var1.length - 1; var3 >= 0; var3--) {
            if (var1[var3] != -1 && var1[var3] < var2) {
               this._jres.remove(var1[var3]);
               this._validPaths.remove(var1[var3]);
            }
         }
      }

      this.fireTableDataChanged();
   }
}
