package com.sun.deploy.panel;

import com.sun.deploy.config.Config;
import com.sun.deploy.resources.ResourceManager;
import com.sun.deploy.util.AdvancedNetworkSettingsDialog;
import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowEvent;
import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.ButtonGroup;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import javax.swing.JTextField;
import javax.swing.KeyStroke;
import javax.swing.border.EtchedBorder;
import javax.swing.border.TitledBorder;

public class NetworkSettingsDialog extends JDialog implements ActionListener {
   private ButtonGroup proxySettingsButtonGroup;
   private JSmartTextArea descriptionTextArea;
   private JLabel addressLabel;
   private JLabel portLabel;
   private JLabel locationLabel;
   private JRadioButton browserRbutton;
   private JRadioButton manualRbutton;
   private JRadioButton autoConfigRbutton;
   private JRadioButton directRbutton;
   private JTextField addressTextField;
   private JTextField portTextField;
   private JTextField locationTextField;
   private JCheckBox bypassProxyChbox;
   private JButton advancedBtn;
   private JButton okButton;
   private JButton cancelButton;

   NetworkSettingsDialog(JFrame var1, boolean var2) {
      super(var1, var2);
      this.initComponents();
   }

   private void initComponents() {
      this.proxySettingsButtonGroup = new ButtonGroup();
      this.browserRbutton = new JRadioButton();
      this.manualRbutton = new JRadioButton();
      this.bypassProxyChbox = new JCheckBox();
      this.autoConfigRbutton = new JRadioButton();
      this.setDefaultCloseOperation(2);
      this.setTitle(this.getMessage("network.settings.dlg.title"));
      this.setModal(true);
      this.addWindowListener(new NetworkSettingsDialog$1(this));
      JPanel var1 = new JPanel();
      var1.setLayout(new BorderLayout());
      var1.setBorder(new TitledBorder(new TitledBorder(new EtchedBorder()), this.getMessage("network.settings.dlg.border_title"), 0, 0));
      this.descriptionTextArea = new JSmartTextArea();
      this.descriptionTextArea.setRows(2);
      JPanel var2 = new JPanel();
      var2.setLayout(new BorderLayout());
      var2.add(this.descriptionTextArea, "North");
      var2.add(new JLabel(" "), "Center");
      var1.add(var2, "North");
      JPanel var3 = new JPanel();
      var3.setLayout(new BoxLayout(var3, 1));
      JPanel var4 = new JPanel();
      var4.setLayout(new BorderLayout());
      this.browserRbutton.setText(this.getMessage("network.settings.dlg.browser_rbtn"));
      this.browserRbutton.setMnemonic(ResourceManager.getVKCode("browser_rbtn.mnemonic"));
      this.proxySettingsButtonGroup.add(this.browserRbutton);
      var4.add(this.browserRbutton, "North");
      var3.add(var4);
      JPanel var5 = new JPanel();
      var5.setLayout(new BorderLayout());
      this.manualRbutton.setText(this.getMessage("network.settings.dlg.manual_rbtn"));
      this.manualRbutton.setMnemonic(ResourceManager.getVKCode("manual_rbtn.mnemonic"));
      this.proxySettingsButtonGroup.add(this.manualRbutton);
      var5.add(this.manualRbutton, "North");
      JPanel var6 = new JPanel();
      var6.add(Box.createRigidArea(new Dimension(20, 1)));
      this.addressLabel = new JLabel(this.getMessage("network.settings.dlg.address_lbl"));
      var6.add(this.addressLabel);
      this.addressTextField = new JTextField("");
      this.addressTextField.setColumns(10);
      var6.add(this.addressTextField);
      var6.add(Box.createGlue());
      this.portLabel = new JLabel(this.getMessage("network.settings.dlg.port_lbl"));
      var6.add(this.portLabel);
      this.portTextField = new JTextField("");
      this.portTextField.setColumns(3);
      this.portTextField.setDocument(new NumberDocument());
      var6.add(this.portTextField);
      var6.add(Box.createGlue());
      var5.add(var6, "West");
      JPanel var7 = new JPanel();
      this.advancedBtn = this.makeButton("network.settings.dlg.advanced_btn");
      this.advancedBtn.addActionListener(new NetworkSettingsDialog$2(this));
      this.advancedBtn.setToolTipText(this.getMessage("network.settings.advanced_btn.tooltip"));
      var7.add(this.advancedBtn);
      var5.add(var7, "East");
      JPanel var8 = new JPanel();
      var8.setLayout(new BoxLayout(var8, 0));
      var8.add(Box.createRigidArea(new Dimension(20, 1)));
      this.bypassProxyChbox.setText(this.getMessage("network.settings.dlg.bypass_text"));
      this.bypassProxyChbox.setMnemonic(ResourceManager.getVKCode("network.settings.dlg.bypass.mnemonic"));
      var8.add(this.bypassProxyChbox);
      var8.add(Box.createGlue());
      var5.add(var8, "South");
      var3.add(var5);
      JPanel var9 = new JPanel();
      var9.setLayout(new BorderLayout());
      this.autoConfigRbutton.setText(this.getMessage("network.settings.dlg.autoconfig_rbtn"));
      this.autoConfigRbutton.setMnemonic(ResourceManager.getVKCode("autoconfig_rbtn.mnemonic"));
      this.proxySettingsButtonGroup.add(this.autoConfigRbutton);
      var9.add(this.autoConfigRbutton, "North");
      JPanel var10 = new JPanel();
      var10.setLayout(new FlowLayout(0));
      this.locationLabel = new JLabel(this.getMessage("network.settings.dlg.location_lbl"));
      var10.add(Box.createHorizontalStrut(20));
      var10.add(this.locationLabel);
      this.locationTextField = new JTextField("");
      this.locationTextField.setColumns(20);
      var10.add(this.locationTextField);
      var9.add(var10, "Center");
      var3.add(var9);
      JPanel var11 = new JPanel();
      var11.setLayout(new BorderLayout());
      this.directRbutton = new JRadioButton(this.getMessage("network.settings.dlg.direct_rbtn"));
      this.directRbutton.setMnemonic(ResourceManager.getVKCode("direct_rbtn.mnemonic"));
      this.proxySettingsButtonGroup.add(this.directRbutton);
      var11.add(this.directRbutton, "North");
      var3.add(var11);
      var1.add(var3, "Center");
      this.getContentPane().add(var1, "Center");
      JPanel var12 = new JPanel();
      var12.setLayout(new FlowLayout(2));
      this.okButton = this.makeButton("common.ok_btn");
      this.okButton.addActionListener(new NetworkSettingsDialog$3(this));
      var12.add(this.okButton);
      this.cancelButton = this.makeButton("common.cancel_btn");
      NetworkSettingsDialog$4 var13 = new NetworkSettingsDialog$4(this);
      this.cancelButton.addActionListener(var13);
      this.getRootPane().getInputMap(2).put(KeyStroke.getKeyStroke('\u001b'), "cancel");
      this.getRootPane().getActionMap().put("cancel", var13);
      var12.add(this.cancelButton);
      this.getContentPane().add(var12, "South");
      this.browserRbutton.addActionListener(this);
      this.browserRbutton.setActionCommand("useBrowser");
      this.manualRbutton.addActionListener(this);
      this.manualRbutton.setActionCommand("useProxy");
      this.autoConfigRbutton.addActionListener(this);
      this.autoConfigRbutton.setActionCommand("useScript");
      this.directRbutton.addActionListener(this);
      this.directRbutton.setActionCommand("noProxy");
      this.getRootPane().setDefaultButton(this.okButton);
      this.setValues();
      this.pack();
      this.setResizable(false);
   }

   private void setValues() {
      this.addressTextField.setText(Config.getProperty("deployment.proxy.http.host"));
      this.portTextField.setText(Config.getProperty("deployment.proxy.http.port"));
      this.locationTextField.setText(Config.getProperty("deployment.proxy.auto.config.url"));
      this.bypassProxyChbox.setSelected(Config.getBooleanProperty("deployment.proxy.bypass.local"));
      int var1 = Config.getIntProperty("deployment.proxy.type");
      boolean var2 = !Config.isLocked("deployment.proxy.type");
      switch (var1) {
         case 0:
            this.directRbutton.setSelected(true);
            this.noProxy();
            break;
         case 1:
            this.manualRbutton.setSelected(true);
            this.useProxy();
            break;
         case 2:
            this.autoConfigRbutton.setSelected(true);
            this.useScript();
            break;
         default:
            this.browserRbutton.setSelected(true);
            this.useBrowser();
      }

      this.manualRbutton.setEnabled(var2);
      this.autoConfigRbutton.setEnabled(var2);
      this.directRbutton.setEnabled(var2);
      this.browserRbutton.setEnabled(var2);
   }

   public void updateProxyInfo() {
      this.addressTextField.setText(Config.getProperty("deployment.proxy.http.host"));
      this.portTextField.setText(Config.getProperty("deployment.proxy.http.port"));
   }

   public String getProxyAddressField() {
      return this.addressTextField.getText();
   }

   public String getProxyPortField() {
      return this.portTextField.getText();
   }

   private void disableAll() {
      this.addressLabel.setEnabled(false);
      this.addressTextField.setEnabled(false);
      this.portLabel.setEnabled(false);
      this.portTextField.setEnabled(false);
      this.advancedBtn.setEnabled(false);
      this.bypassProxyChbox.setEnabled(false);
      this.locationLabel.setEnabled(false);
      this.locationTextField.setEnabled(false);
      this.addressTextField.setEditable(false);
      this.locationTextField.setEditable(false);
      this.portTextField.setEditable(false);
   }

   private void useBrowser() {
      this.descriptionTextArea.setText(this.getMessage("network.settings.dlg.browser_text"));
      this.disableAll();
   }

   private void useProxy() {
      this.descriptionTextArea.setText(this.getMessage("network.settings.dlg.proxy_text"));
      this.disableAll();
      if (!Config.isLocked("deployment.proxy.http.host")) {
         this.addressLabel.setEnabled(true);
         this.addressTextField.setEnabled(true);
         this.addressTextField.setEditable(true);
      }

      if (!Config.isLocked("deployment.proxy.http.port")) {
         this.portLabel.setEnabled(true);
         this.portTextField.setEnabled(true);
         this.portTextField.setEditable(true);
      }

      this.advancedBtn.setEnabled(true);
      if (!Config.isLocked("deployment.proxy.bypass.local")) {
         this.bypassProxyChbox.setEnabled(true);
      }
   }

   private void useScript() {
      this.descriptionTextArea.setText(this.getMessage("network.settings.dlg.auto_text"));
      this.disableAll();
      if (!Config.isLocked("deployment.proxy.auto.config.url")) {
         this.locationLabel.setEnabled(true);
         this.locationTextField.setEnabled(true);
         this.locationTextField.setEditable(true);
      }
   }

   private void noProxy() {
      this.descriptionTextArea.setText(this.getMessage("network.settings.dlg.none_text"));
      this.disableAll();
   }

   public void actionPerformed(ActionEvent var1) {
      String var2 = var1.getActionCommand();
      if (var2.equalsIgnoreCase("useBrowser")) {
         this.useBrowser();
      } else if (var2.equalsIgnoreCase("useProxy")) {
         this.useProxy();
      } else if (var2.equalsIgnoreCase("useScript")) {
         this.useScript();
      } else if (var2.equalsIgnoreCase("noProxy")) {
         this.noProxy();
      }
   }

   private void advancedBtnActionPerformed(ActionEvent var1) {
      AdvancedNetworkSettingsDialog var2 = new AdvancedNetworkSettingsDialog(this, true);
      var2.setLocationRelativeTo(this);
      var2.setVisible(true);
      this.updateProxyInfo();
   }

   private void okBtnActionPerformed(ActionEvent var1) {
      if (this.browserRbutton.isSelected()) {
         Config.setIntProperty("deployment.proxy.type", 3);
      } else if (this.manualRbutton.isSelected()) {
         Config.setIntProperty("deployment.proxy.type", 1);
      } else if (this.autoConfigRbutton.isSelected()) {
         Config.setIntProperty("deployment.proxy.type", 2);
      } else if (this.directRbutton.isSelected()) {
         Config.setIntProperty("deployment.proxy.type", 0);
      }

      String var2;
      if ((var2 = this.addressTextField.getText()) != null && !var2.trim().equals("")) {
         Config.setProperty("deployment.proxy.http.host", var2);
      }

      if ((var2 = this.portTextField.getText()) != null && !var2.trim().equals("")) {
         Config.setProperty("deployment.proxy.http.port", var2);
      }

      if ((var2 = this.locationTextField.getText()) != null && !var2.trim().equals("")) {
         Config.setProperty("deployment.proxy.auto.config.url", var2);
      }

      Config.setBooleanProperty("deployment.proxy.bypass.local", this.bypassProxyChbox.isSelected());
      this.setVisible(false);
      this.dispose();
   }

   private void cancelBtnActionPerformed(ActionEvent var1) {
      this.setVisible(false);
      this.dispose();
   }

   private void closeDialog(WindowEvent var1) {
      this.setVisible(false);
      this.dispose();
   }

   private String getMessage(String var1) {
      return ResourceManager.getMessage(var1);
   }

   public JButton makeButton(String var1) {
      JButton var2 = new JButton(this.getMessage(var1));
      var2.setMnemonic(ResourceManager.getVKCode(var1 + ".mnemonic"));
      return var2;
   }
}
