package com.sun.deploy.panel;

import java.awt.Color;
import java.awt.Component;
import javax.swing.DefaultCellEditor;
import javax.swing.JTable;
import javax.swing.JTextField;
import javax.swing.border.Border;
import javax.swing.border.LineBorder;
import javax.swing.event.DocumentEvent;
import javax.swing.event.DocumentListener;

public class PathEditor extends DefaultCellEditor implements DocumentListener {
   private int row;
   private Border badBorder = new LineBorder(Color.red);
   private Border goodBorder = new LineBorder(Color.black);
   private Border currentBorder = this.badBorder;
   private JTable table;

   PathEditor() {
      super(new JTextField());
      ((JTextField)this.editorComponent).getDocument().addDocumentListener(this);
   }

   public Component getTableCellEditorComponent(JTable var1, Object var2, boolean var3, int var4, int var5) {
      var1.getTableHeader().setResizingAllowed(false);
      this.row = var4;
      this.table = var1;
      super.getTableCellEditorComponent(var1, var2, var3, var4, var5);
      this.currentBorder = ((JreTableModel)var1.getModel()).isPathValid(var4) ? this.goodBorder : this.badBorder;
      this.editorComponent.setBorder(this.currentBorder);
      return this.editorComponent;
   }

   public void insertUpdate(DocumentEvent var1) {
      this.updateBorderFromEditor();
   }

   public void removeUpdate(DocumentEvent var1) {
      this.updateBorderFromEditor();
   }

   public void changedUpdate(DocumentEvent var1) {
   }

   private void updateBorderFromEditor() {
      Object var1 = this.getCellEditorValue();
      boolean var2;
      if (var1 instanceof String && this.table.getModel() instanceof JreTableModel) {
         var2 = ((JreTableModel)this.table.getModel()).isValidJREPath((String)var1);
      } else {
         var2 = false;
      }

      if (var2) {
         this.editorComponent.setBorder(this.goodBorder);
      } else {
         this.editorComponent.setBorder(this.badBorder);
      }
   }

   public boolean stopCellEditing() {
      this.table.getTableHeader().setResizingAllowed(true);
      return super.stopCellEditing();
   }
}
