package com.sun.deploy.panel;

import com.sun.deploy.config.PluginJavaInfo;
import com.sun.deploy.resources.ResourceManager;
import java.io.File;
import java.util.HashSet;

public class PluginTableModel extends JreTableModel {
   HashSet _vmArgs = new HashSet();

   public PluginTableModel() {
      super(
         new String[]{
            ResourceManager.getMessage("jpi.jres.dialog.column1"),
            ResourceManager.getMessage("jpi.jres.dialog.column2"),
            ResourceManager.getMessage("jpi.jres.dialog.column3"),
            ResourceManager.getMessage("jpi.jres.dialog.column4")
         }
      );
      this.refresh();
   }

   public void refresh() {
      PluginJavaInfo[] var1 = PluginJavaInfo.getAll();
      this._jres.clear();
      this._validPaths.clear();
      this._vmArgs.clear();

      for (int var2 = 0; var2 < var1.length; var2++) {
         PluginJavaInfo var3 = var1[var2];
         if (var3.getPath() != null) {
            this.add(new PluginJavaInfo(var3), false, false);
            this.addVmArgs(var3);
         }
      }

      this.fireTableDataChanged();
   }

   public Object getValueAt(int var1, int var2) {
      switch (var2) {
         case 0:
            if (this.getJRE(var1) instanceof PluginJavaInfo) {
               return ((PluginJavaInfo)this.getJRE(var1)).getProductName();
            }

            return "";
         case 1:
            return this.getJRE(var1).getProduct();
         case 2:
            return this.getJRE(var1).getPath();
         default:
            String var3;
            if (this.getJRE(var1) instanceof PluginJavaInfo) {
               var3 = ((PluginJavaInfo)this.getJRE(var1)).getVmArgs();
            } else {
               var3 = "";
            }

            return var3;
      }
   }

   public boolean isCellEditable(int var1, int var2) {
      return (!this.getJRE(var1).isSystemJRE() || var2 >= 3) && var2 >= 1;
   }

   public void add(PluginJavaInfo var1, boolean var2, boolean var3) {
      super.add(var1, var2, var3);
   }

   public void setValueAt(Object var1, int var2, int var3) {
      if (var2 < this._jres.size()) {
         switch (var3) {
            case 0:
               ((PluginJavaInfo)this.getJRE(var2)).setProductName((String)var1);
               break;
            case 1:
               this.getJRE(var2).setProduct((String)var1);
               break;
            case 2:
               this.getJRE(var2).setPath((String)var1);
               this._validPaths.set(var2, null);
               break;
            case 3:
               ((PluginJavaInfo)this.getJRE(var2)).setVmArgs((String)var1);
         }

         this.fireTableCellUpdated(var2, var3);
      }
   }

   public void addVmArgs(PluginJavaInfo var1) {
      this._vmArgs.add(var1);
   }

   public boolean isValidJREPath(String var1) {
      String var2 = "java";
      if (System.getProperty("os.name").indexOf("Windows") != -1) {
         var2 = var2 + ".exe";
      }

      if (var1 != null) {
         if (var1.endsWith(File.separator)) {
            var1 = var1 + "bin" + File.separator + var2;
         } else {
            var1 = var1 + File.separator + "bin" + File.separator + var2;
         }

         File var3 = new File(var1);
         return var3.exists();
      } else {
         return false;
      }
   }
}
