package com.sun.deploy.panel;

import javax.swing.event.TreeModelListener;
import javax.swing.tree.TreeModel;
import javax.swing.tree.TreePath;

public class PropertyTreeModel implements TreeModel {
   private ITreeNode root;

   public PropertyTreeModel(ITreeNode var1) {
      this.root = var1;
   }

   public Object getRoot() {
      return this.root;
   }

   public int getChildCount(Object var1) {
      if (var1 instanceof ITreeNode) {
         ITreeNode var2 = (ITreeNode)var1;
         return var2.getChildNodeCount() + var2.getPropertyCount();
      } else {
         return 0;
      }
   }

   public Object getChild(Object var1, int var2) {
      ITreeNode var3 = (ITreeNode)var1;
      int var4 = var3.getChildNodeCount();
      return var2 < var4 ? var3.getChildNode(var2) : var3.getProperty(var2 - var4);
   }

   public boolean isLeaf(Object var1) {
      return var1 instanceof IProperty;
   }

   public void valueForPathChanged(TreePath var1, Object var2) {
      Object var3 = var1.getLastPathComponent();
      if (var3 instanceof IProperty) {
         ((IProperty)var3).setValue((String)var2);
      }
   }

   public int getIndexOfChild(Object var1, Object var2) {
      for (int var3 = 0; var3 < this.getChildCount(var1); var3++) {
         if (this.getChild(var1, var3) == var2) {
            return var3;
         }
      }

      return -1;
   }

   public void addTreeModelListener(TreeModelListener var1) {
   }

   public void removeTreeModelListener(TreeModelListener var1) {
   }
}
