package com.sun.deploy.panel;

import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import javax.swing.JTree;
import javax.swing.ToolTipManager;

public class TreeBuilder {
   public static final JTree createTree(PropertyTreeModel var0) {
      JTree var1 = new JTree();
      var1.setModel(var0);
      var1.setCellRenderer(TreeRenderers.getRenderer());
      TreeEditors.DelegateEditor var2 = new TreeEditors.DelegateEditor(var1);
      var1.setEditable(true);
      var1.setOpaque(true);
      var1.setCellEditor(var2);
      var1.setDoubleBuffered(true);
      var1.putClientProperty("JTree.lineStyle", "None");
      var1.getSelectionModel().setSelectionMode(1);
      var1.setRowHeight(0);
      ToolTipManager.sharedInstance().registerComponent(var1);
      var1.addKeyListener(new SpecialTreeListener());
      var1.addMouseListener(new TreeBuilder.TreeMouseListener());
      return var1;
   }

   static final class TreeMouseListener extends MouseAdapter {
      public TreeMouseListener() {
      }

      public void mouseClicked(MouseEvent var1) {
         if (var1.getSource() instanceof JTree) {
            ((JTree)var1.getSource()).repaint();
         }
      }
   }
}
