package com.sun.deploy.panel;

import com.sun.deploy.config.Config;
import com.sun.deploy.resources.ResourceManager;
import java.awt.BorderLayout;
import java.awt.Component;
import javax.swing.BorderFactory;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import javax.swing.JTextField;
import javax.swing.JTree;
import javax.swing.border.Border;
import javax.swing.tree.DefaultTreeCellRenderer;

class TreeRenderers$1 extends DefaultTreeCellRenderer {
   private JCheckBox _checkBox = new TreeRenderers$1$1(this);
   private JPanel _cbPanel = new JPanel(new BorderLayout());
   private final JRadioButton _radio = new TreeRenderers$1$2(this);
   private JPanel _radioPanel = new JPanel(new BorderLayout());
   private JPanel _textPanel = new JPanel(new BorderLayout());
   private JButton _browse = new JButton(ResourceManager.getMessage("deploy.advanced.browse.browse_btn"));
   private JTextField _path = new JTextField("");
   private final JLabel _label = new JLabel();
   private JPanel _labelPanel = new JPanel(new BorderLayout());
   private Border _emptyBorder = BorderFactory.createEmptyBorder();
   private Border _invisBorder = BorderFactory.createEmptyBorder(1, 1, 1, 1);

   public Component getTreeCellRendererComponent(JTree var1, Object var2, boolean var3, boolean var4, boolean var5, int var6, boolean var7) {
      if (var2 instanceof ToggleProperty) {
         ToggleProperty var11 = (ToggleProperty)var2;
         this._cbPanel.removeAll();
         if (var3) {
            this._checkBox.setForeground(this.getTextSelectionColor());
            this._checkBox.setBackground(this.getBackgroundSelectionColor());
            this._cbPanel.setBackground(this.getBackgroundSelectionColor());
            this._checkBox.setBorder(BorderFactory.createLineBorder(this.getBorderSelectionColor()));
         } else {
            this._checkBox.setForeground(this.getTextNonSelectionColor());
            this._checkBox.setBackground(this.getBackgroundNonSelectionColor());
            this._cbPanel.setBackground(this.getBackgroundNonSelectionColor());
            this._checkBox.setBorder(this._invisBorder);
         }

         this._checkBox.setSelected(var11.isSelected());
         this._checkBox.setText(var11.getDescription());
         this._checkBox.setFont(var1.getFont());
         this._checkBox.setEnabled(!Config.isLocked(var11.getPropertyName()));
         this._checkBox.setRequestFocusEnabled(var7);
         this._checkBox.setOpaque(false);
         this._cbPanel.setOpaque(true);
         this._cbPanel.setToolTipText(var11.getTooltip());
         this._cbPanel.add(this._checkBox);
         return this._cbPanel;
      } else if (var2 instanceof RadioProperty) {
         RadioProperty var10 = (RadioProperty)var2;
         this._radioPanel.removeAll();
         if (var3) {
            this._radio.setForeground(this.getTextSelectionColor());
            this._radio.setBackground(this.getBackgroundSelectionColor());
            this._radioPanel.setBackground(this.getBackgroundSelectionColor());
            this._radio.setBorder(BorderFactory.createLineBorder(this.getBorderSelectionColor()));
         } else {
            this._radio.setForeground(this.getTextNonSelectionColor());
            this._radio.setBackground(this.getBackgroundNonSelectionColor());
            this._radioPanel.setBackground(this.getBackgroundNonSelectionColor());
            this._radio.setBorder(this._invisBorder);
         }

         this._radio.setText(var10.getDescription());
         this._radio.setFont(var1.getFont());
         this._radio.setSelected(var10.isSelected());
         this._radio.setEnabled(!Config.isLocked(var10.getPropertyName()));
         this._radio.setRequestFocusEnabled(var7);
         this._radio.setOpaque(false);
         this._radioPanel.setOpaque(true);
         this._radioPanel.setToolTipText(var10.getTooltip());
         this._radioPanel.add(this._radio);
         return this._radioPanel;
      } else if (var2 instanceof TextFieldProperty) {
         TextFieldProperty var8 = (TextFieldProperty)var2;
         this._textPanel.removeAll();
         if (var3) {
            this._textPanel.setBackground(this.getBackgroundSelectionColor());
            this._textPanel.setBorder(BorderFactory.createLineBorder(this.getBorderSelectionColor()));
         } else {
            this._textPanel.setBackground(this.getBackgroundNonSelectionColor());
            this._textPanel.setBorder(this._invisBorder);
         }

         this._path.setColumns(22);
         this._textPanel.add(this._path, "Center");
         this._textPanel.add(this._browse, "East");
         this._textPanel.setOpaque(true);
         boolean var9 = !Config.isLocked(var8.getPropertyName());
         this._path.setEnabled(var9);
         this._browse.setEnabled(var9);
         this._path.setText(var8.getValue());
         this._path.setFont(var1.getFont());
         return this._textPanel;
      } else {
         this._labelPanel.removeAll();
         if (var3) {
            this._label.setForeground(this.getTextSelectionColor());
            this._label.setBackground(this.getBackgroundSelectionColor());
            this._label.setBorder(BorderFactory.createLineBorder(this.getBorderSelectionColor()));
         } else {
            this._label.setForeground(this.getTextNonSelectionColor());
            this._label.setBackground(this.getBackgroundNonSelectionColor());
            this._label.setBorder(this._invisBorder);
         }

         this._label.setFont(var1.getFont());
         this._label.setText(String.valueOf(var2));
         this._label.setOpaque(true);
         this._labelPanel.add(this._label);
         return this._labelPanel;
      }
   }
}
