package com.sun.deploy.panel;

import com.sun.deploy.resources.ResourceManager;
import com.sun.deploy.util.DialogFactory;
import java.awt.BorderLayout;
import java.awt.Component;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.GridLayout;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;
import java.text.DateFormat;
import java.text.DateFormatSymbols;
import java.text.MessageFormat;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.GregorianCalendar;
import java.util.Locale;
import javax.swing.BorderFactory;
import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.ButtonGroup;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JComboBox;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import javax.swing.JSpinner;
import javax.swing.SpinnerNumberModel;
import javax.swing.border.Border;
import javax.swing.border.EmptyBorder;
import javax.swing.border.EtchedBorder;
import javax.swing.border.TitledBorder;
import javax.swing.event.ChangeListener;

public class UpdatePanel extends JPanel implements ActionListener {
   private int update_notify = 0;
   private int update_frequency = 1;
   private int update_day = 1;
   private int update_schedule = 0;
   private String update_lastrun;
   private static final String update_image = "com/sun/deploy/resources/image/JavaUpdateIcon-48.png";
   private JButton updateNowBtn;
   private JButton advancedUpdateBtn;
   private JComboBox notifyComboBox;
   private JCheckBox autoUpdateChBox;
   private JSmartTextArea updateScheduleTextArea;
   private JSmartTextArea lastUpdatedTextArea;
   private String textDesc;
   private DateFormat df = new SimpleDateFormat("EEE, dd MMM yyyy hh:mm:ss zzz", Locale.US);
   private String sysTrayIconText = this.getMessage("update.desc_systrayicon.text");
   private String[] weekDays;
   private String[] atComboBoxText;
   private boolean javaUpdateEnabled = false;
   private boolean autoUpdateCheck = true;
   private boolean schedulerPlatform = true;

   UpdatePanel() {
      PlatformSpecificUtils var1 = new PlatformSpecificUtils();
      var1.onLoad(this);
      this.setLayout(new BorderLayout());
      EmptyBorder var2 = new EmptyBorder(new Insets(5, 5, 5, 5));
      TitledBorder var3 = new TitledBorder(new TitledBorder(new EtchedBorder()), this.getMessage("update.notify.border.text"), 0, 0);
      this.setBorder(BorderFactory.createCompoundBorder(var2, var3));
      JPanel var4 = new JPanel();
      var4.setLayout(new BorderLayout());
      JPanel var5 = new JPanel();
      var5.setLayout(new BorderLayout());
      ImageIcon var6 = new ImageIcon(ClassLoader.getSystemResource("com/sun/deploy/resources/image/JavaUpdateIcon-48.png"));
      JLabel var7 = new JLabel();
      var7.setIcon(var6);
      var5.add(var7, "North");
      var4.add(var5, "West");
      JPanel var8 = new JPanel();
      var8.setLayout(new BorderLayout());
      JPanel var9 = new JPanel();
      var9.setLayout(new BorderLayout());
      var9.setBorder(BorderFactory.createEmptyBorder(5, 5, 5, 5));
      DateFormatSymbols var10 = new DateFormatSymbols();
      DateFormat var11 = DateFormat.getTimeInstance(3);
      SimpleDateFormat var12 = new SimpleDateFormat("H:mm");
      this.weekDays = var10.getWeekdays();
      this.atComboBoxText = new String[24];

      for (int var14 = 0; var14 < 24; var14++) {
         try {
            Date var13 = var12.parse(var14 + ":00");
            this.atComboBoxText[var14] = var11.format(var13);
         } catch (Exception var23) {
            this.atComboBoxText[var14] = var14 + ":00";
         }
      }

      JSmartTextArea var24 = new JSmartTextArea(this.getMessage("update.desc.text"));
      var9.add(var24, "Center");
      JPanel var15 = new JPanel();
      var15.setLayout(new BorderLayout());
      var15.add(var9, "North");
      JPanel var16 = new JPanel();
      var16.setLayout(new UpdatePanel.MyBoxLayout(var16, 0));
      var16.setBorder(BorderFactory.createEmptyBorder(5, 10, 5, 8));
      JLabel var17 = new JLabel(this.getMessage("update.notify.text"));
      this.notifyComboBox = new UpdatePanel.UComboBox();
      this.notifyComboBox.addItem(this.getMessage("update.notify_install.text"));
      this.notifyComboBox.addItem(this.getMessage("update.notify_download.text"));
      this.notifyComboBox.addActionListener(this);
      this.notifyComboBox.setToolTipText(this.getMessage("update.notify_combo.tooltip"));
      var16.add(var17);
      var16.add(Box.createGlue());
      var16.add(this.notifyComboBox);
      var15.add(var16, "Center");
      JPanel var18 = new JPanel();
      var18.setLayout(new UpdatePanel.MyBoxLayout(var18, 0));
      var18.setBorder(BorderFactory.createEmptyBorder(5, 7, 5, 8));
      this.autoUpdateChBox = new JCheckBox(this.getMessage("update.autoupdate.text"));
      this.autoUpdateChBox.addActionListener(this);
      this.advancedUpdateBtn = new JButton(this.getMessage("update.advanced.button.text"));
      this.advancedUpdateBtn.setMnemonic(ResourceManager.getVKCode("update.advanced.button.mnemonic"));
      this.advancedUpdateBtn.setToolTipText(this.getMessage("update.advanced_btn.tooltip"));
      this.advancedUpdateBtn.addActionListener(this);
      var18.add(this.autoUpdateChBox);
      var18.add(Box.createGlue());
      var18.add(this.advancedUpdateBtn);
      var15.add(var18, "South");
      var8.add(var15, "North");
      JPanel var19 = new JPanel();
      var19.setLayout(new GridLayout(1, 1));
      var19.setBorder(BorderFactory.createEmptyBorder(5, 5, 5, 5));
      this.updateScheduleTextArea = new JSmartTextArea(" ");
      var19.add(this.updateScheduleTextArea);
      JPanel var20 = new JPanel();
      var20.setLayout(new GridLayout(1, 1));
      var20.add(var19);
      var8.add(var20, "Center");
      BorderLayout var21 = new BorderLayout();
      var21.setHgap(8);
      JPanel var22 = new JPanel(var21);
      var22.setBorder(BorderFactory.createEmptyBorder(5, 5, 5, 5));
      this.lastUpdatedTextArea = new JSmartTextArea(" ");
      this.updateNowBtn = new JButton(this.getMessage("update.updatenow.button.text"));
      this.updateNowBtn.setMnemonic(ResourceManager.getVKCode("update.updatenow.button.mnemonic"));
      this.updateNowBtn.setToolTipText(this.getMessage("update.now_btn.tooltip"));
      this.updateNowBtn.addActionListener(this);
      var22.add(this.lastUpdatedTextArea, "Center");
      var22.add(this.updateNowBtn, "East");
      var8.add(var22, "South");
      var4.add(var8, "Center");
      this.add(var4, "Center");
      this.reset();
   }

   public void reset() {
      if (this.isSchedulerPlatform()) {
         this.autoUpdateChBox.setSelected(this.isAutoUpdateChecked());
      } else {
         this.autoUpdateChBox.setEnabled(false);
      }

      this.notifyComboBox.setSelectedIndex(this.getUpdateNotify());
      this.setText();
      String var1 = this.getUpdateLastRun();
      GregorianCalendar var2 = new GregorianCalendar();

      try {
         var2.setTime(this.df.parse(var1));
      } catch (Exception var8) {
         var1 = null;
         System.out.println("got exception:" + var8);
      }

      if (var1 == null) {
         var1 = new String("    ");
      } else {
         DateFormat var4 = DateFormat.getTimeInstance(3);
         DateFormat var5 = DateFormat.getDateInstance(3);
         MessageFormat var3 = new MessageFormat(this.getMessage("update.lastrun.text"));
         String var6 = var4.format(var2.getTime());
         String var7 = var5.format(var2.getTime());
         var1 = var3.format(new String[]{var6, var7});
      }

      this.lastUpdatedTextArea.setText(var1);
   }

   private void setText() {
      if (!this.autoUpdateChBox.isSelected()) {
         this.notifyComboBox.setEnabled(false);
         this.advancedUpdateBtn.setEnabled(false);
         this.textDesc = this.getMessage("update.desc_autooff.text");
         this.updateScheduleTextArea.setText(this.textDesc);
      } else {
         this.notifyComboBox.setEnabled(true);
         this.advancedUpdateBtn.setEnabled(true);
         int var1 = this.getUpdateFrequency();
         String var3 = this.atComboBoxText[this.getUpdateSchedule()];
         String var4 = null;
         if (var1 == 0) {
            this.textDesc = this.getMessage("update.desc_check_daily.text");
            MessageFormat var2 = new MessageFormat(this.textDesc);
            this.textDesc = var2.format(new String[]{var3});
         } else if (var1 == 2) {
            this.textDesc = this.getMessage("update.desc_check_monthly.text");
            var4 = String.valueOf(this.getUpdateDay());
         } else {
            this.textDesc = this.getMessage("update.desc_check_weekly.text");
            var4 = String.valueOf(this.weekDays[this.getUpdateDay()]);
         }

         if (var4 != null) {
            MessageFormat var6 = new MessageFormat(this.textDesc);
            this.textDesc = var6.format(new String[]{var4, var3});
         }

         this.textDesc = this.textDesc + this.sysTrayIconText;
         var1 = this.notifyComboBox.getSelectedIndex();
         if (var1 == 1) {
            this.textDesc = this.textDesc + this.getMessage("update.desc_notify_download.text");
         } else {
            this.textDesc = this.textDesc + this.getMessage("update.desc_notify_install.text");
         }

         this.updateScheduleTextArea.setText(this.textDesc);
      }
   }

   public void actionPerformed(ActionEvent var1) {
      try {
         if (var1.getSource() == this.updateNowBtn) {
            String var2 = System.getProperty("java.home") + File.separator + "bin" + File.separator + "jucheck.exe";
            Runtime.getRuntime().exec(var2);
         } else if (var1.getSource() == this.advancedUpdateBtn) {
            new UpdatePanel.AdvancedDialog(this);
         } else if (var1.getSource() == this.notifyComboBox) {
            int var4 = this.notifyComboBox.getSelectedIndex();
            this.setUpdateNotify(var4);
            this.setText();
            ControlPanel.propertyHasChanged();
         } else if (var1.getSource() == this.autoUpdateChBox) {
            boolean var5 = this.autoUpdateChBox.isSelected();
            this.setAutoUpdateCheck(var5);
            this.setText();
            ControlPanel.propertyHasChanged();
         }
      } catch (Exception var3) {
         DialogFactory.showExceptionDialog(this, var3);
      }
   }

   public String[] getAtComboBoxText() {
      return this.atComboBoxText;
   }

   public String[] getWeekDays() {
      return this.weekDays;
   }

   private String getMessage(String var1) {
      return ResourceManager.getMessage(var1);
   }

   public void saveUpdateSettingsInReg() {
      PlatformSpecificUtils var1 = new PlatformSpecificUtils();
      var1.onSave(this);
   }

   public void setUpdateNotify(int var1) {
      this.update_notify = var1;
   }

   public int getUpdateNotify() {
      return this.update_notify;
   }

   public void setUpdateFrequency(int var1) {
      this.update_frequency = var1;
   }

   public void setUpdateDay(int var1) {
      this.update_day = var1;
   }

   public int getUpdateFrequency() {
      return this.update_frequency;
   }

   public int getUpdateDay() {
      return this.update_day;
   }

   public void setUpdateSchedule(int var1) {
      this.update_schedule = var1;
   }

   public int getUpdateSchedule() {
      return this.update_schedule;
   }

   public void setUpdateLastRun(String var1) {
      this.update_lastrun = var1;
   }

   public String getUpdateLastRun() {
      return this.update_lastrun;
   }

   public void enableJavaUpdate(boolean var1) {
      this.javaUpdateEnabled = var1;
   }

   public boolean isJavaUpdateEnabled() {
      return this.javaUpdateEnabled;
   }

   public void setAutoUpdateCheck(boolean var1) {
      this.autoUpdateCheck = var1;
   }

   public boolean isAutoUpdateChecked() {
      return this.autoUpdateCheck;
   }

   public void setSchedulerPlatform(boolean var1) {
      this.schedulerPlatform = var1;
   }

   public boolean isSchedulerPlatform() {
      return this.schedulerPlatform;
   }

   private class AdvancedDialog implements ActionListener {
      ChangeListener changeListener = new UpdatePanel$AdvancedDialog$1(this);
      private UpdatePanel updPanel;
      private JRadioButton RButton1;
      private JRadioButton RButton2;
      private JRadioButton RButton3;
      private JRadioButton RButtonLast = null;
      private ButtonGroup FreqGroup;
      private String[] weekDays;
      private String[] atComboBoxText;
      private JComboBox at;
      private JComboBox every;
      JSpinner day;
      SpinnerNumberModel daymodel;
      private String atLabelText;
      private String everyLabelText;
      private String dayLabelText;
      private JLabel whenLabel1;
      private JLabel whenLabel2;
      private JLabel descLabel;
      private JLabel dummyLabel;
      JPanel whenPanel1;
      JPanel whenPanel2;
      JPanel whenPanel;
      GridBagConstraints c;

      public AdvancedDialog(UpdatePanel var2) {
         this.updPanel = var2;
         JPanel var3 = new JPanel();
         var3.setLayout(new GridBagLayout());
         this.c = new GridBagConstraints();
         this.c.anchor = 17;
         this.c.fill = 0;
         this.c.insets = new Insets(5, 0, 0, 0);
         this.c.weighty = 1.0;
         this.c.weightx = 0.0;
         this.c.gridwidth = 0;
         var3.add(new JLabel(var2.getMessage("update.advanced_title1.text")), this.c);
         JPanel var4 = new JPanel();
         var4.setLayout(new BoxLayout(var4, 1));
         Border var5 = BorderFactory.createEtchedBorder();
         var4.setBorder(
            BorderFactory.createCompoundBorder(
               BorderFactory.createEmptyBorder(4, 4, 4, 4), BorderFactory.createTitledBorder(var5, var2.getMessage("update.advanced_title2.text"))
            )
         );
         this.RButton1 = new JRadioButton(var2.getMessage("update.check_daily.text"));
         this.RButton2 = new JRadioButton(var2.getMessage("update.check_weekly.text"));
         this.RButton3 = new JRadioButton(var2.getMessage("update.check_monthly.text"));
         this.FreqGroup = new ButtonGroup();
         this.FreqGroup.add(this.RButton1);
         this.FreqGroup.add(this.RButton2);
         this.FreqGroup.add(this.RButton3);
         this.RButton1.addActionListener(this);
         this.RButton2.addActionListener(this);
         this.RButton3.addActionListener(this);
         var4.add(this.RButton1);
         var4.add(this.RButton2);
         var4.add(this.RButton3);
         this.c.weighty = 3.0;
         this.c.weightx = 0.0;
         this.c.gridwidth = 2;
         this.c.insets = new Insets(0, 0, 0, 0);
         var3.add(var4, this.c);
         this.whenPanel = new JPanel();
         this.whenPanel.setLayout(new GridBagLayout());
         this.whenPanel
            .setBorder(
               BorderFactory.createCompoundBorder(
                  BorderFactory.createEmptyBorder(4, 4, 4, 4), BorderFactory.createTitledBorder(var5, var2.getMessage("update.advanced_title3.text"))
               )
            );
         this.atComboBoxText = var2.getAtComboBoxText();
         this.weekDays = var2.getWeekDays();
         this.dummyLabel = new JLabel("    ");
         this.everyLabelText = var2.getMessage("update.check_day.text");
         this.atLabelText = var2.getMessage("update.check_time.text");
         this.dayLabelText = var2.getMessage("update.check_date.text");
         this.whenLabel1 = new JLabel();
         this.whenLabel2 = new JLabel();
         this.every = UpdatePanel.this.new UComboBox();
         this.every.setMaximumRowCount(7);
         this.every.addItem(this.weekDays[1]);
         this.every.addItem(this.weekDays[2]);
         this.every.addItem(this.weekDays[3]);
         this.every.addItem(this.weekDays[4]);
         this.every.addItem(this.weekDays[5]);
         this.every.addItem(this.weekDays[6]);
         this.every.addItem(this.weekDays[7]);
         this.every.addActionListener(this);
         this.at = UpdatePanel.this.new UComboBox();
         this.at.setMaximumRowCount(this.atComboBoxText.length);

         for (int var6 = 0; var6 < this.atComboBoxText.length; var6++) {
            this.at.addItem(this.atComboBoxText[var6]);
         }

         this.at.addActionListener(this);
         this.daymodel = new SpinnerNumberModel(1, 1, 31, 1);
         this.day = new JSpinner(this.daymodel);
         this.daymodel.addChangeListener(this.changeListener);
         this.c.anchor = 17;
         this.whenPanel1 = new JPanel();
         this.whenPanel2 = new JPanel();
         this.c.insets = new Insets(0, 10, 0, 5);
         this.c.gridwidth = 2;
         this.c.gridheight = 2;
         this.c.weighty = 0.0;
         this.c.weightx = 0.0;
         this.whenPanel.add(this.whenLabel1, this.c);
         this.c.gridwidth = 0;
         this.c.weightx = 2.0;
         this.c.fill = 2;
         this.whenPanel.add(this.whenPanel1, this.c);
         this.c.gridwidth = 2;
         this.c.fill = 0;
         this.c.weightx = 0.0;
         this.c.gridheight = 0;
         this.whenPanel.add(this.whenLabel2, this.c);
         this.c.weightx = 1.0;
         this.c.fill = 2;
         this.c.gridwidth = 0;
         this.whenPanel.add(this.whenPanel2, this.c);
         this.c.weightx = 2.0;
         this.c.weighty = 3.0;
         this.c.fill = 1;
         this.c.gridheight = -1;
         this.c.insets = new Insets(0, 5, 0, 0);
         this.c.gridwidth = 0;
         var3.add(this.whenPanel, this.c);
         if (var2.getUpdateFrequency() == 0) {
            this.RButton1.setSelected(true);
         } else if (var2.getUpdateFrequency() == 2) {
            this.RButton3.setSelected(true);
            this.day.setValue(new Integer(var2.getUpdateDay()));
         } else {
            this.RButton2.setSelected(true);
            this.every.setSelectedIndex(var2.getUpdateDay() - 1);
         }

         this.at.setSelectedIndex(var2.getUpdateSchedule());
         this.descLabel = new JLabel("  ");
         this.descLabel.setBorder(BorderFactory.createCompoundBorder(BorderFactory.createEmptyBorder(4, 4, 4, 4), BorderFactory.createTitledBorder(var5, "")));
         this.c.fill = 2;
         this.c.weightx = 1.0;
         this.c.weighty = 1.0;
         this.c.insets = new Insets(0, 0, 0, 0);
         this.c.gridwidth = 0;
         var3.add(this.descLabel, this.c);
         this.setPanelOptions();
         JOptionPane var9 = new JOptionPane(var3, -1, 2);
         JDialog var7 = var9.createDialog(var2, var2.getMessage("update.advanced_title.text"));
         var7.setModal(true);
         var7.setDefaultCloseOperation(2);
         var7.setVisible(true);
         Integer var8 = (Integer)var9.getValue();
         if (var8 != null && var8 == 0) {
            var2.setUpdateSchedule(this.at.getSelectedIndex());
            if (this.RButton1.isSelected()) {
               var2.setUpdateFrequency(0);
               var2.setUpdateDay(0);
            } else if (this.RButton3.isSelected()) {
               var2.setUpdateFrequency(2);
               var2.setUpdateDay((Integer)this.day.getValue());
            } else {
               var2.setUpdateFrequency(1);
               var2.setUpdateDay(this.every.getSelectedIndex() + 1);
            }

            ControlPanel.propertyHasChanged();
         }

         var2.setText();
      }

      void setPanelOptions() {
         String var1 = null;
         String var2 = null;
         if (this.RButton1.isSelected()) {
            if (!this.RButton1.equals(this.RButtonLast)) {
               this.day.setVisible(false);
               this.every.setVisible(false);
               this.whenLabel1.setText("  ");
               this.whenLabel2.setText(this.atLabelText);
               this.whenPanel1.add(this.dummyLabel);
               this.whenPanel2.add(this.at);
               this.at.setVisible(true);
               this.dummyLabel.setVisible(true);
               this.RButtonLast = this.RButton1;
            }

            var1 = this.updPanel.getMessage("update.advanced_desc1.text");
            MessageFormat var3 = new MessageFormat(var1);
            var1 = var3.format(new String[]{(String)this.at.getItemAt(this.at.getSelectedIndex())});
         } else if (this.RButton2.isSelected()) {
            if (!this.RButton2.equals(this.RButtonLast)) {
               this.day.setVisible(false);
               this.dummyLabel.setVisible(false);
               this.whenLabel1.setText(this.everyLabelText);
               this.whenLabel2.setText(this.atLabelText);
               this.whenPanel1.add(this.every);
               this.whenPanel2.add(this.at);
               this.every.setVisible(true);
               this.at.setVisible(true);
               this.RButtonLast = this.RButton2;
            }

            var2 = (String)this.every.getItemAt(this.every.getSelectedIndex());
            var1 = this.updPanel.getMessage("update.advanced_desc2.text");
         } else if (this.RButton3.isSelected()) {
            if (!this.RButton3.equals(this.RButtonLast)) {
               this.dummyLabel.setVisible(false);
               this.every.setVisible(false);
               this.whenLabel1.setText(this.dayLabelText);
               this.whenLabel2.setText(this.atLabelText);
               this.whenPanel1.add(this.day);
               this.whenPanel2.add(this.at);
               this.day.setVisible(true);
               this.at.setVisible(true);
               this.RButtonLast = this.RButton3;
            }

            var2 = String.valueOf(((Integer)this.day.getValue()).intValue());
            var1 = this.updPanel.getMessage("update.advanced_desc3.text");
         }

         if (var2 != null) {
            MessageFormat var5 = new MessageFormat(var1);
            var1 = var5.format(new String[]{var2, (String)this.at.getItemAt(this.at.getSelectedIndex())});
         }

         this.descLabel.setText(var1);
      }

      public void actionPerformed(ActionEvent var1) {
         try {
            if (var1.getSource() == this.RButton1
               || var1.getSource() == this.RButton2
               || var1.getSource() == this.RButton3
               || var1.getSource() == this.every
               || var1.getSource() == this.at) {
               this.setPanelOptions();
            }
         } catch (Exception var3) {
         }
      }
   }

   private class MyBoxLayout extends BoxLayout {
      public MyBoxLayout(Container var2, int var3) {
         super(var2, var3);
      }

      public Dimension preferredLayoutSize(Container var1) {
         int var2 = var1.getWidth();
         Dimension var3 = super.preferredLayoutSize(var1);
         if (var2 > 0 && var3.width > var2) {
            Component[] var4 = var1.getComponents();
            var1.removeAll();
            var1.setLayout(new BorderLayout());
            if (var4.length > 0) {
               var1.add(var4[0], "North");
            }

            if (var4.length > 2) {
               var1.add(var4[2], "East");
            }

            return var1.getLayout().preferredLayoutSize(var1);
         } else {
            return var3;
         }
      }
   }

   private class UComboBox extends JComboBox {
      private UComboBox() {
      }

      public Dimension getPreferredSize() {
         Dimension var1 = super.getPreferredSize();
         var1.width += 8;
         return var1;
      }
   }
}
