package com.sun.deploy.panel;

import com.sun.deploy.config.Config;
import com.sun.deploy.resources.ResourceManager;
import java.util.ArrayList;
import java.util.StringTokenizer;
import java.util.Vector;
import javax.swing.JTree;
import org.xml.sax.Attributes;
import org.xml.sax.SAXException;
import org.xml.sax.SAXParseException;
import org.xml.sax.helpers.DefaultHandler;

final class XMLDocumentHandler extends DefaultHandler {
   private ArrayList elementStack = new ArrayList();
   private boolean addNode = true;

   public void startDocument() throws SAXException {
      SimpleTreeNode var1 = new SimpleTreeNode(this.getMessage("common.settings"));
      this.elementStack.add(0, var1);
   }

   public void startElement(String var1, String var2, String var3, Attributes var4) throws SAXException {
      if (var3.equalsIgnoreCase("label")) {
         if (this.getShouldAdd()) {
            SimpleTreeNode var5 = new SimpleTreeNode(var4.getValue("text"));
            ITreeNode var6 = (ITreeNode)this.elementStack.get(0);
            var6.addChildNode(var5);
            this.elementStack.add(0, var5);
         }
      } else if (var3.equalsIgnoreCase("checkbox")) {
         if (this.getShouldAdd()) {
            ToggleProperty var10 = new ToggleProperty(var4.getValue("propertyName"), var4.getValue("checked"));
            ITreeNode var15 = (ITreeNode)this.elementStack.get(0);
            var15.addProperty(var10);
         }
      } else if (var3.equalsIgnoreCase("radiogroup")) {
         if (this.getShouldAdd()) {
            String var11 = var4.getValue("propertyName");
            String var16 = var4.getValue("checked");
            RadioPropertyGroup var7 = new RadioPropertyGroup(var11, var16);
            this.elementStack.add(0, var7);
         }
      } else if (var3.equalsIgnoreCase("rButton")) {
         if (this.getShouldAdd()) {
            String var12 = var4.getValue("text");
            RadioPropertyGroup var17 = (RadioPropertyGroup)this.elementStack.remove(0);
            String var20 = var17.getPropertyName();
            RadioProperty var8 = new RadioProperty(var20, var12);
            var8.setGroup(var17);
            ITreeNode var9 = (ITreeNode)this.elementStack.get(0);
            var9.addProperty(var8);
            this.elementStack.add(0, var17);
         }
      } else if (var3.equalsIgnoreCase("TextField")) {
         if (this.getShouldAdd()) {
            String var13 = var4.getValue("propertyName");
            TextFieldProperty var18 = new TextFieldProperty(var13, "");
            ITreeNode var21 = (ITreeNode)this.elementStack.get(0);
            var21.addProperty(var18);
         }
      } else if (var3.equalsIgnoreCase("platform")) {
         String var14 = var4.getValue("text");
         Vector var19 = new Vector();
         if (var14.indexOf(",") != -1) {
            StringTokenizer var22 = new StringTokenizer(var14, ",");

            while (var22.hasMoreTokens()) {
               String var23 = var22.nextToken();
               var19.add(var23.trim());
            }
         } else {
            var19.add(var14.trim());
         }

         if (!this.setShouldAdd(var19)) {
            this.elementStack.add(0, var14);
         }
      }
   }

   public void endElement(String var1, String var2, String var3) throws SAXException {
      if (var3.equalsIgnoreCase("label")) {
         if (this.getShouldAdd()) {
            this.elementStack.remove(0);
         }
      } else if (var3.equalsIgnoreCase("radiogroup")) {
         if (this.getShouldAdd()) {
            this.elementStack.remove(0);
         }
      } else if (var3.equalsIgnoreCase("platform")) {
         if (!this.getShouldAdd()) {
            this.elementStack.remove(0);
         }

         this.addNode = true;
      }
   }

   private boolean getShouldAdd() {
      return this.addNode;
   }

   private boolean setShouldAdd(Vector var1) {
      String var2 = System.getProperty("os.name").toLowerCase();

      for (int var3 = 0; var3 < var1.size(); var3++) {
         String var4 = ((String)var1.get(var3)).toLowerCase();
         if (var4.indexOf("gnome") != -1 && Config.getInstance().isLocalInstallSupported()) {
            this.addNode = true;
            break;
         }

         if (var2.indexOf(var4) != -1) {
            this.addNode = true;
            break;
         }

         this.addNode = false;
      }

      return this.addNode;
   }

   public void endDocument() throws SAXException {
      ITreeNode var1 = (ITreeNode)this.elementStack.get(0);
   }

   public void error(SAXParseException var1) {
      System.err.println("Error: " + var1);
   }

   public void fatalError(SAXParseException var1) {
      System.err.println("FatalError: " + var1);
   }

   public void warning(SAXParseException var1) {
      System.err.println("Warning: " + var1);
   }

   JTree getJTree() {
      ITreeNode var1 = (ITreeNode)this.elementStack.get(0);
      JTree var2 = TreeBuilder.createTree(new PropertyTreeModel(var1));
      var2.setFont(ResourceManager.getUIFont());
      return var2;
   }

   private String getMessage(String var1) {
      return ResourceManager.getMessage(var1);
   }
}
