package com.sun.deploy.resources;

import com.sun.deploy.util.Trace;
import java.awt.Color;
import java.awt.Font;
import java.lang.reflect.Field;
import java.text.MessageFormat;
import java.text.NumberFormat;
import java.util.MissingResourceException;
import java.util.ResourceBundle;
import javax.swing.ImageIcon;
import javax.swing.JLabel;

public class ResourceManager {
   private static ResourceBundle rb = ResourceBundle.getBundle("com.sun.deploy.resources.Deployment");
   private static NumberFormat _numberFormat = null;
   static Class _keyEventClazz = null;

   public static String getMessage(String var0) {
      try {
         return rb.getString(var0);
      } catch (MissingResourceException var2) {
         return var0;
      }
   }

   public static String getFormattedMessage(String var0, Object[] var1) {
      try {
         MessageFormat var2 = new MessageFormat(rb.getString(var0));
         return var2.format(var1);
      } catch (MissingResourceException var3) {
         return var0;
      }
   }

   public static String[] getMessageArray(String var0) {
      try {
         return rb.getStringArray(var0);
      } catch (MissingResourceException var2) {
         return new String[]{var0};
      }
   }

   public static int getAcceleratorKey(String var0) {
      Integer var1 = (Integer)rb.getObject(var0 + ".acceleratorKey");
      return var1;
   }

   public static String getString(String var0) {
      try {
         return rb.getString(var0);
      } catch (MissingResourceException var2) {
         Trace.ignoredException(var2);
         return null;
      }
   }

   public static int getInteger(String var0) {
      try {
         return Integer.parseInt(getString(var0), 16);
      } catch (MissingResourceException var2) {
         Trace.ignoredException(var2);
         return -1;
      }
   }

   public static String getString(String var0, String var1) {
      Object[] var2 = new Object[]{var1};
      return applyPattern(var0, var2);
   }

   public static String getString(String var0, String var1, String var2) {
      Object[] var3 = new Object[]{var1, var2};
      return applyPattern(var0, var3);
   }

   public static String getString(String var0, Long var1, Long var2) {
      Object[] var3 = new Object[]{var1, var2};
      return applyPattern(var0, var3);
   }

   public static String getString(String var0, String var1, String var2, String var3) {
      Object[] var4 = new Object[]{var1, var2, var3};
      return applyPattern(var0, var4);
   }

   public static String getString(String var0, int var1) {
      Object[] var2 = new Object[]{new Integer(var1)};
      return applyPattern(var0, var2);
   }

   public static String getString(String var0, int var1, int var2, int var3) {
      Object[] var4 = new Object[]{new Integer(var1), new Integer(var2), new Integer(var3)};
      return applyPattern(var0, var4);
   }

   public static String getString(String var0, String var1, int var2, String var3) {
      Object[] var4 = new Object[]{var1, new Integer(var2), var3};
      return applyPattern(var0, var4);
   }

   public static String getString(String var0, String var1, int var2) {
      Object[] var3 = new Object[]{var1, new Integer(var2)};
      return applyPattern(var0, var3);
   }

   public static synchronized String formatDouble(double var0, int var2) {
      _numberFormat.setGroupingUsed(true);
      _numberFormat.setMaximumFractionDigits(var2);
      _numberFormat.setMinimumFractionDigits(var2);
      return _numberFormat.format(var0);
   }

   public static ImageIcon getIcon(String var0) {
      String var1 = getString(var0);
      return new ImageIcon(
         (class$com$sun$deploy$resources$ResourceManager == null
               ? (class$com$sun$deploy$resources$ResourceManager = class$("com.sun.deploy.resources.ResourceManager"))
               : class$com$sun$deploy$resources$ResourceManager)
            .getResource(var1)
      );
   }

   private static String applyPattern(String var0, Object[] var1) {
      String var2 = getString(var0);
      MessageFormat var3 = new MessageFormat(var2);
      return MessageFormat.format(var2, var1);
   }

   public static Color getColor(String var0) {
      int var1 = getInteger(var0);
      return new Color(var1);
   }

   public static Font getUIFont() {
      return new JLabel().getFont();
   }

   public static int getMinFontSize() {
      int var0 = 0;

      try {
         var0 = (Integer)rb.getObject("ui.min.font.size");
      } catch (MissingResourceException var2) {
      }

      return var0;
   }

   public static int getVKCode(String var0) {
      String var1 = getString(var0);
      if (var1 != null && var1.startsWith("VK_")) {
         try {
            if (_keyEventClazz == null) {
               _keyEventClazz = Class.forName("java.awt.event.KeyEvent");
            }

            Field var2 = _keyEventClazz.getDeclaredField(var1);
            return var2.getInt(null);
         } catch (ClassNotFoundException var4) {
            Trace.ignoredException(var4);
         } catch (NoSuchFieldException var5) {
            Trace.ignoredException(var5);
         } catch (SecurityException var6) {
            Trace.ignoredException(var6);
         } catch (Exception var7) {
            Trace.ignoredException(var7);
         }
      }

      return 0;
   }

   static {
      _numberFormat = NumberFormat.getInstance();
   }
}
