package com.sun.deploy.security;

import com.sun.deploy.resources.ResourceManager;
import com.sun.deploy.util.DeployUIManager;
import com.sun.deploy.util.DialogFactory;
import com.sun.deploy.util.Trace;
import java.awt.FlowLayout;
import java.security.CodeSource;
import java.security.cert.Certificate;
import java.text.MessageFormat;
import java.util.ArrayList;
import javax.swing.JButton;
import javax.swing.JPanel;
import javax.swing.LookAndFeel;

public class BadCertificateDialog {
   private static boolean _isHttps = false;

   public static void show(CodeSource var0, String var1, Exception var2) {
      Certificate[] var3 = var0.getCertificates();
      LookAndFeel var4 = null;

      try {
         var4 = DeployUIManager.setLookAndFeel();
         ArrayList var5 = new ArrayList();
         Object var6 = null;
         if (getHttpsDialog()) {
            var6 = new MessageFormat(getMessage("security.badcert.https.text"));
         } else if (var2 instanceof CertificateConfigException) {
            var6 = new MessageFormat(getMessage("security.badcert.config.text"));
         } else {
            var6 = new MessageFormat(getMessage("security.badcert.text"));
         }

         Object[] var7 = new Object[]{getMessage(var1)};
         var5.add(var6.format(var7));
         JButton var8 = new JButton(getMessage("security.badcert.viewException"));
         var8.setMnemonic(getAcceleratorKey("security.badcert.viewException"));
         var8.addActionListener(new BadCertificateDialog$1(var2));
         JButton var9 = new JButton(getMessage("security.badcert.viewCert"));
         var9.setMnemonic(getAcceleratorKey("security.badcert.viewCert"));
         var9.addActionListener(new BadCertificateDialog$2(var3));
         JPanel var10 = new JPanel();
         var10.add(var8);
         var10.add(var9);
         var10.setLayout(new FlowLayout(1));
         var5.add(var10);
         if (!Trace.isAutomationEnabled()) {
            DialogFactory.showInformationDialog(var5.toArray(), getMessage("security.badcert.caption"));
         } else {
            Trace.msgSecurityPrintln("trustdecider.automation.badcert");
         }
      } finally {
         DeployUIManager.restoreLookAndFeel(var4);
      }
   }

   private static String getMessage(String var0) {
      return ResourceManager.getMessage(var0);
   }

   private static int getAcceleratorKey(String var0) {
      return ResourceManager.getAcceleratorKey(var0);
   }

   private static boolean getHttpsDialog() {
      return _isHttps;
   }

   public static void setHttpsDialog(boolean var0) {
      _isHttps = var0;
   }
}
