package com.sun.deploy.security;

import com.sun.deploy.config.Config;
import com.sun.deploy.util.Trace;
import java.net.URL;
import java.security.AllPermission;
import java.security.CodeSource;
import java.security.Permission;
import java.security.PermissionCollection;
import java.security.Permissions;
import java.security.Security;
import java.security.cert.Certificate;
import java.util.Enumeration;
import sun.security.provider.PolicyFile;

public final class CeilingPolicy {
   private static PermissionCollection _trustedPerms = null;
   private static boolean _initialized = false;

   public static void addTrustedPermissions(PermissionCollection var0) {
      if (!_initialized) {
         _initialized = true;
         String var1 = Config.getProperty("deployment.security.trusted.policy");
         if (var1 != null && var1.length() > 0) {
            CodeSource var2 = new CodeSource((URL)null, (Certificate[])null);
            int var3 = 1;

            while (Security.getProperty("policy.url." + var3) != null) {
               var3++;
            }

            String var4 = "policy.url." + var3;
            Security.setProperty(var4, var1);

            try {
               PolicyFile var5 = new PolicyFile();
               _trustedPerms = var5.getPermissions(var2);
            } catch (Exception var6) {
               Trace.ignoredException(var6);
            }

            Security.setProperty(var4, "");
         } else {
            _trustedPerms = new Permissions();
            _trustedPerms.add(new AllPermission());
         }
      }

      if (_trustedPerms != null) {
         Enumeration var7 = _trustedPerms.elements();

         while (var7.hasMoreElements()) {
            var0.add((Permission)var7.nextElement());
         }
      }
   }
}
