package com.sun.deploy.security;

import com.sun.deploy.config.Config;
import com.sun.deploy.resources.ResourceManager;
import com.sun.deploy.ui.AppInfo;
import com.sun.deploy.util.Trace;
import java.security.AccessController;
import java.security.cert.Certificate;
import java.security.cert.X509Certificate;
import java.util.HashSet;
import javax.net.ssl.HostnameVerifier;
import javax.net.ssl.SSLPeerUnverifiedException;
import javax.net.ssl.SSLSession;

public final class CertificateHostnameVerifier implements HostnameVerifier {
   private static HashSet hashSet = new HashSet();

   public boolean verify(String var1, SSLSession var2) {
      String var3 = ResourceManager.getMessage("https.dialog.unknown.host");

      try {
         Certificate[] var4 = var2.getPeerCertificates();
         if (!(var4[0] instanceof X509Certificate)) {
            throw new SSLPeerUnverifiedException("");
         }

         X509Certificate var5 = (X509Certificate)var4[0];
         String var6 = var5.getSubjectDN().getName();
         if (var6 != null) {
            int var7 = var6.toUpperCase().indexOf("CN=");
            if (var7 != -1) {
               int var8 = var6.indexOf(",", var7);
               if (var8 != -1) {
                  var3 = var6.substring(var7 + 3, var8);
               } else {
                  var3 = var6.substring(var7 + 3);
               }
            }
         }
      } catch (SSLPeerUnverifiedException var9) {
         return false;
      }

      if (!var1.equalsIgnoreCase(var3) && !var3.equals("*")) {
         for (Object[] var11 : hashSet) {
            if (var11[0].toString().equalsIgnoreCase(var1) && var11[1].toString().equalsIgnoreCase(var3)) {
               return true;
            }
         }

         return this.showHostnameMismatchDialog(var1, var3);
      } else {
         return true;
      }
   }

   private boolean showHostnameMismatchDialog(String var1, String var2) {
      String var3 = ResourceManager.getMessage("https.dialog.caption");
      String var4 = ResourceManager.getMessage("https.dialog.text");
      AppInfo var5 = new AppInfo(0, var1, var2, null, null, null);
      String var6 = ResourceManager.getMessage("security.dialog.signed.buttonContinue");
      String var7 = ResourceManager.getMessage("security.dialog.signed.buttonCancel");
      int var8 = -1;
      if (!Trace.isAutomationEnabled()) {
         if (Config.getBooleanProperty("deployment.security.jsse.hostmismatch.warning")) {
            var8 = AccessController.doPrivileged(new CertificateHostnameVerifier$1(this, var5, var4, var3, var6, var7));
         } else {
            var8 = 0;
         }
      } else {
         Trace.msgSecurityPrintln("hostnameverifier.automation.ignoremismatch");
         var8 = 0;
      }

      if (var8 == 0) {
         Object[] var9 = new Object[]{var1, var2};
         hashSet.add(var9);
      }

      return var8 == 0;
   }

   public static void reset() {
      hashSet.clear();
   }
}
