package com.sun.deploy.security;

import com.sun.deploy.resources.ResourceManager;
import com.sun.deploy.util.DialogFactory;
import java.awt.BorderLayout;
import java.awt.FlowLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.security.cert.X509Certificate;
import java.text.MessageFormat;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Vector;
import javax.swing.JButton;
import javax.swing.JList;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.border.EmptyBorder;

final class ClientCertDialog implements ActionListener {
   private HashMap clientAuthCertsMap = new HashMap();
   private Vector certs = new Vector();
   private JList certList;

   ClientCertDialog(HashMap var1, HashMap var2) {
      this.clientAuthCertsMap = var1;
      Iterator var3 = var1.keySet().iterator();

      while (var3.hasNext()) {
         Object var4 = null;
         String var5 = (String)var3.next();
         X509Certificate[] var6 = (X509Certificate[])var1.get(var5);
         Object var7 = var2.get(var5);
         String var8 = CertUtils.extractSubjectAliasName(var6[0]);
         if (var7.equals(CertType.PLUGIN)) {
            var4 = new MessageFormat(getMessage("clientauth.certlist.dialog.javaKS"));
         } else {
            var4 = new MessageFormat(getMessage("clientauth.certlist.dialog.browserKS"));
         }

         Object[] var9 = new Object[]{var8};
         this.certs.add(var4.format(var9));
      }
   }

   String DoModal() {
      String var1 = getMessage("clientauth.certlist.dialog.text");
      JPanel var2 = new JPanel();
      var2.setLayout(new BorderLayout());
      var2.setBorder(new EmptyBorder(0, 5, 0, 5));
      this.certList = new JList();
      this.certList.setSelectionMode(0);
      this.certList.setListData(this.certs);
      if (this.certs.size() > 0) {
         this.certList.setSelectedIndex(0);
      }

      JButton var3 = new JButton(getMessage("clientauth.certlist.dialog.buttonDetails"));
      var3.setMnemonic(getAcceleratorKey("clientauth.certlist.dialog.buttonDetails"));
      var3.addActionListener(this);
      var2.add(new JScrollPane(this.certList), "Center");
      JPanel var4 = new JPanel();
      var4.add(var3);
      var4.setLayout(new FlowLayout(2));
      Object[] var5 = new Object[]{var1.toString(), var2, var4};
      JButton var6 = new JButton(getMessage("clientauth.certlist.dialog.buttonOK"));
      JButton var7 = new JButton(getMessage("clientauth.certlist.dialog.buttonCancel"));
      String var8 = getMessage("clientauth.certlist.dialog.caption");
      Object[] var9 = new Object[]{var6, var7};
      int var10 = DialogFactory.showOptionDialog(4, var5, var8, var9, var9[0]);
      int var11 = this.certList.getSelectedIndex();
      String var12 = null;
      if (var10 == 0) {
         for (Iterator var13 = this.clientAuthCertsMap.keySet().iterator(); var11 >= 0 && var13.hasNext(); var11--) {
            var12 = (String)var13.next();
         }
      }

      return var12;
   }

   public void actionPerformed(ActionEvent var1) {
      int var2 = this.certList.getSelectedIndex();
      X509Certificate[] var3 = null;

      for (Iterator var4 = this.clientAuthCertsMap.values().iterator(); var2 >= 0 && var4.hasNext(); var2--) {
         var3 = (X509Certificate[])var4.next();
      }

      if (var3 != null) {
         CertificateDialog var5 = new CertificateDialog(var3, 0, var3.length);
         var5.DoModal();
      }
   }

   private static String getMessage(String var0) {
      return ResourceManager.getMessage(var0);
   }

   private static int getAcceleratorKey(String var0) {
      return ResourceManager.getAcceleratorKey(var0);
   }
}
