package com.sun.deploy.security;

import com.sun.deploy.util.Trace;
import java.io.IOException;
import java.security.KeyStore;
import java.security.KeyStoreException;
import java.security.NoSuchAlgorithmException;
import java.security.cert.Certificate;
import java.security.cert.CertificateException;
import java.util.Collection;
import java.util.HashSet;
import java.util.Iterator;

public final class SessionCertStore implements CertStore {
   private Collection _certs = new HashSet();

   public void load() throws IOException, CertificateException, KeyStoreException, NoSuchAlgorithmException {
      Trace.msgSecurityPrintln("sessioncertstore.cert.loading");
      Trace.msgSecurityPrintln("sessioncertstore.cert.loaded");
   }

   public void save() throws IOException, CertificateException, KeyStoreException, NoSuchAlgorithmException {
      Trace.msgSecurityPrintln("sessioncertstore.cert.saving");
      Trace.msgSecurityPrintln("sessioncertstore.cert.saved");
   }

   public void add(Certificate var1) throws KeyStoreException {
      Trace.msgSecurityPrintln("sessioncertstore.cert.adding");
      this._certs.add(var1);
      Trace.msgSecurityPrintln("sessioncertstore.cert.added");
   }

   public boolean remove(Certificate var1) throws IOException, KeyStoreException {
      Trace.msgSecurityPrintln("sessioncertstore.cert.removing");
      this._certs.remove(var1);
      Trace.msgSecurityPrintln("sessioncertstore.cert.removed");
      return true;
   }

   public boolean contains(Certificate var1) throws KeyStoreException {
      Trace.msgSecurityPrintln("sessioncertstore.cert.instore");
      return this._certs.contains(var1);
   }

   public boolean verify(Certificate var1) throws KeyStoreException {
      Trace.msgSecurityPrintln("sessioncertstore.cert.canverify");
      return false;
   }

   public Iterator iterator(int var1) throws KeyStoreException {
      Trace.msgSecurityPrintln("sessioncertstore.cert.iterator");
      return this._certs.iterator();
   }

   private KeyStore getKeyStore(int var1) {
      Trace.msgSecurityPrintln("sessioncertstore.cert.getkeystore");
      return null;
   }
}
