package com.sun.deploy.security;

import com.sun.deploy.resources.ResourceManager;
import com.sun.deploy.ui.AppInfo;
import com.sun.deploy.ui.UIFactory;
import com.sun.deploy.util.Trace;
import java.net.URL;
import java.security.Principal;
import java.security.cert.Certificate;
import java.security.cert.CertificateException;
import java.security.cert.X509Certificate;
import java.text.DateFormat;
import java.text.MessageFormat;
import java.util.ArrayList;
import java.util.Date;

class TrustDeciderDialog {
   public static final int TrustOption_GrantThisSession = 0;
   public static final int TrustOption_Deny = 1;
   public static final int TrustOption_GrantAlways = 2;

   public static int showDialog(Certificate[] var0, URL var1, int var2, int var3, boolean var4, boolean var5, Date var6, AppInfo var7, boolean var8) throws CertificateException {
      int var9 = -1;
      if (var0[var2] instanceof X509Certificate && var0[var3 - 1] instanceof X509Certificate) {
         X509Certificate var10 = (X509Certificate)var0[var2];
         X509Certificate var11 = (X509Certificate)var0[var3 - 1];
         Principal var12 = var10.getSubjectDN();
         Principal var13 = var11.getIssuerDN();
         String var14 = var12.getName();
         Object var15 = null;
         int var16 = var14.indexOf("CN=");
         int var17 = 0;
         if (var16 < 0) {
            var15 = getMessage("security.dialog.unknown.subject");
         } else {
            try {
               var16 += 3;
               if (var14.charAt(var16) == '"') {
                  var17 = var14.indexOf(34, ++var16);
               } else {
                  var17 = var14.indexOf(44, var16);
               }

               if (var17 < 0) {
                  var15 = var14.substring(var16);
               } else {
                  var15 = var14.substring(var16, var17);
               }
            } catch (IndexOutOfBoundsException var31) {
               var15 = getMessage("security.dialog.unknown.subject");
            }
         }

         String var18 = var13.getName();
         Object var19 = null;
         var16 = var18.indexOf("O=");
         int var37 = 0;
         if (var16 < 0) {
            var19 = getMessage("security.dialog.unknown.issuer");
         } else {
            try {
               var16 += 2;
               if (var18.charAt(var16) == '"') {
                  var37 = var18.indexOf(34, ++var16);
               } else {
                  var37 = var18.indexOf(44, var16);
               }

               if (var37 < 0) {
                  var19 = var18.substring(var16);
               } else {
                  var19 = var18.substring(var16, var37);
               }
            } catch (IndexOutOfBoundsException var30) {
               var19 = getMessage("security.dialog.unknown.issuer");
            }
         }

         Object var20 = null;
         ArrayList var21 = new ArrayList();
         ArrayList var22 = new ArrayList();
         String var23 = null;
         String var24 = null;
         if (!var4 && !var5) {
            var24 = getMessage(var8 ? "security.dialog.trusted.https.caption" : "security.dialog.trusted.app.caption");
            var22.add(getMessage(var8 ? "security.dialog.trusted.https.bullet" : "security.dialog.trusted.bullet"));
            var20 = new MessageFormat(getMessage("security.dialog.text1"));
            Object[] var46 = new Object[]{var15, var15};
            var22.add(var20.format(var46));
            var22.add(getMessage("security.dialog.rootCAValid"));
            if (var6 != null) {
               DateFormat var49 = DateFormat.getDateTimeInstance(1, 1);
               String var51 = var49.format(var6);
               Object[] var28 = new Object[]{var51};
               var20 = new MessageFormat(getMessage("security.dialog.timestamp"));
               var22.add(var20.format(var28));
            } else {
               var22.add(getMessage("security.dialog.timeValid"));
            }
         } else {
            if (var4) {
               var23 = getMessage(var8 ? "security.dialog.untrusted.https.caption" : "security.dialog.untrusted.app.caption");
               var21.add(getMessage(var8 ? "security.dialog.untrusted.https.bullet" : "security.dialog.untrusted.bullet"));
               var21.add(getMessage("security.dialog.rootCANotValid"));
            } else {
               var24 = getMessage(var8 ? "security.dialog.trusted.https.caption" : "security.dialog.trusted.app.caption");
               var22.add(getMessage("security.dialog.rootCAValid"));
            }

            if (var5) {
               if (var23 == null) {
                  var23 = getMessage(var8 ? "security.dialog.invalid.time.https.caption" : "security.dialog.invalid.time.app.caption");
               }

               if (var21.isEmpty()) {
                  var21.add(getMessage(var8 ? "security.dialog.invalid.time.https.bullet" : "security.dialog.invalid.time.bullet"));
               }

               var21.add(getMessage("security.dialog.timeNotValid"));
            } else if (var6 != null) {
               DateFormat var25 = DateFormat.getDateTimeInstance(1, 1);
               String var26 = var25.format(var6);
               Object[] var27 = new Object[]{var26};
               var20 = new MessageFormat(getMessage("security.dialog.timestamp"));
               var22.add(var20.format(var27));
            } else {
               var22.add(getMessage("security.dialog.timeValid"));
            }
         }

         if (!var8) {
            String var47 = getMessage("security.dialog.signed.moreinfo.generic");
            if (!var21.isEmpty()) {
               var21.add(1, var47);
            } else if (!var22.isEmpty()) {
               var22.add(1, var47);
            }
         }

         if (var8) {
            var7.setTitle((String)var15);
         }

         String var48 = var23 != null ? var23 : var24;
         String[] var50 = null;
         String[] var52 = null;
         if (!var21.isEmpty()) {
            var50 = new String[var21.size()];

            for (int var53 = 0; var53 < var21.size(); var53++) {
               var50[var53] = var21.get(var53).toString();
            }
         }

         if (!var22.isEmpty()) {
            var52 = new String[var22.size()];

            for (int var54 = 0; var54 < var22.size(); var54++) {
               var52[var54] = var22.get(var54).toString();
            }
         }

         if (var21.isEmpty() && var22.isEmpty()) {
            throw new CertificateException(getMessage("security.dialog.exception.message"));
         }

         if (!Trace.isAutomationEnabled()) {
            String var55 = var8 ? "security.dialog.https.buttonContinue" : "security.dialog.signed.buttonContinue";
            String var29 = var8 ? "security.dialog.https.buttonCancel" : "security.dialog.signed.buttonCancel";
            var9 = UIFactory.showSecurityDialog(
               var7, getMessage("security.dialog.caption"), var48, (String)var15, var1, true, false, var55, var29, var50, var52, true, var0, var2, var3, var4
            );
         } else {
            Trace.msgSecurityPrintln("trustdecider.automation.trustcert");
            var9 = 0;
         }
      }

      return var9;
   }

   private static String getMessage(String var0) {
      return ResourceManager.getMessage(var0);
   }

   private static int getAcceleratorKey(String var0) {
      return ResourceManager.getAcceleratorKey(var0);
   }
}
