package com.sun.deploy.security;

import com.sun.deploy.util.Trace;
import java.io.IOException;
import java.security.Principal;
import java.security.cert.Certificate;
import java.security.cert.CertificateException;
import java.security.cert.CertificateParsingException;
import java.security.cert.X509Certificate;
import java.util.ArrayList;
import java.util.List;
import java.util.Vector;
import sun.security.util.DerInputStream;
import sun.security.util.DerValue;
import sun.security.util.ObjectIdentifier;

class X509Util {
   private static final String OID_EXTENDED_KEY_USAGE = "2.5.29.37";

   static Principal getIssuerPrincipal(Certificate var0) {
      try {
         return ((X509Certificate)var0).getIssuerX500Principal();
      } catch (NoSuchMethodError var2) {
         Trace.println("getIssuerX500Principal NoSuchMethodError: " + var2);
         return ((X509Certificate)var0).getIssuerDN();
      }
   }

   static Principal getSubjectPrincipal(Certificate var0) {
      try {
         return ((X509Certificate)var0).getSubjectX500Principal();
      } catch (NoSuchMethodError var2) {
         Trace.println("getSubjectX500Principal NoSuchMethodError: " + var2);
         return ((X509Certificate)var0).getSubjectDN();
      }
   }

   static List getExtendedKeyUsage(Certificate var0) throws CertificateParsingException {
      try {
         return ((X509Certificate)var0).getExtendedKeyUsage();
      } catch (NoSuchMethodError var6) {
         Trace.println("getExtendedKeyUsage NoSuchMethodError: " + var6);

         try {
            return oldGetExtendedKeyUsage((X509Certificate)var0);
         } catch (IOException var4) {
            Trace.ignoredException(var4);
            String var7 = var4.toString();
            throw new CertificateParsingException(var7);
         } catch (CertificateException var5) {
            Trace.ignoredException(var5);
            String var3 = var5.toString();
            throw new CertificateParsingException(var3);
         }
      }
   }

   private static List oldGetExtendedKeyUsage(X509Certificate var0) throws CertificateException, IOException {
      byte[] var1 = var0.getExtensionValue("2.5.29.37");
      if (var1 == null) {
         return null;
      } else {
         DerInputStream var2 = new DerInputStream(var1);
         byte[] var3 = var2.getOctetString();
         DerValue var4 = new DerValue(var3);
         Vector var5 = new Vector(1, 1);

         while (var4.data.available() != 0) {
            DerValue var6 = var4.data.getDerValue();
            ObjectIdentifier var7 = var6.getOID();
            var5.addElement(var7);
         }

         ArrayList var8 = new ArrayList(var5.size());

         for (int var9 = 0; var9 < var5.size(); var9++) {
            var8.add(var5.elementAt(var9).toString());
         }

         return var8;
      }
   }
}
