package com.sun.deploy.services;

import com.sun.deploy.net.cookie.CookieHandler;
import com.sun.deploy.net.cookie.GenericCookieHandler;
import com.sun.deploy.net.proxy.BrowserProxyConfig;
import com.sun.deploy.net.proxy.DummyAutoProxyHandler;
import com.sun.deploy.net.proxy.MDefaultBrowserProxyConfig;
import com.sun.deploy.net.proxy.MSystemProxyHandler;
import com.sun.deploy.net.proxy.ProxyHandler;
import com.sun.deploy.security.BrowserAuthenticator;
import com.sun.deploy.security.BrowserKeystore;
import com.sun.deploy.security.CertStore;
import com.sun.deploy.security.MozillaSSLRootCertStore;
import com.sun.deploy.security.MozillaSigningRootCertStore;
import java.io.File;
import java.security.AccessController;
import java.security.KeyStore;
import java.security.SecureRandom;
import java.security.Security;

public class MPlatformService implements Service {
   public CookieHandler getCookieHandler() {
      return new GenericCookieHandler();
   }

   public BrowserProxyConfig getProxyConfig() {
      return new MDefaultBrowserProxyConfig();
   }

   public ProxyHandler getSystemProxyHandler() {
      return new MSystemProxyHandler();
   }

   public ProxyHandler getAutoProxyHandler() {
      return new DummyAutoProxyHandler();
   }

   public ProxyHandler getBrowserProxyHandler() {
      return null;
   }

   public CertStore getBrowserSigningRootCertStore() {
      return BrowserKeystore.isJSSCryptoConfigured() ? new MozillaSigningRootCertStore() : null;
   }

   public CertStore getBrowserSSLRootCertStore() {
      return BrowserKeystore.isJSSCryptoConfigured() ? new MozillaSSLRootCertStore() : null;
   }

   public CertStore getBrowserTrustedCertStore() {
      return null;
   }

   public KeyStore getBrowserClientAuthKeyStore() {
      return BrowserKeystore.isJSSCryptoConfigured() ? AccessController.doPrivileged(new MPlatformService$1(this)) : null;
   }

   public BrowserAuthenticator getBrowserAuthenticator() {
      return null;
   }

   public SecureRandom getSecureRandom() {
      try {
         File var1 = new File("/dev/urandom");
         if (var1 != null && var1.exists()) {
            Security.setProperty("securerandom.source", "file:/dev/urandom");
         }
      } catch (Throwable var2) {
      }

      return new SecureRandom();
   }

   public boolean isIExplorer() {
      return false;
   }

   public boolean isNetscape() {
      return true;
   }
}
