package com.sun.deploy.si;

import com.sun.deploy.util.Trace;
import com.sun.deploy.util.TraceLevel;
import java.io.BufferedReader;
import java.io.File;
import java.io.InputStreamReader;
import java.io.PrintStream;
import java.net.ConnectException;
import java.net.Socket;
import java.net.SocketException;

public class SingleInstanceManager {
   private static String _idString;
   private static int _currPort;

   public static boolean isServerRunning(String var0) {
      File var1 = new File(SingleInstanceImpl.SI_FILEDIR);
      String[] var2 = var1.list();
      if (var2 != null) {
         for (int var3 = 0; var3 < var2.length; var3++) {
            if (var2[var3].startsWith(SingleInstanceImpl.getSingleInstanceFilePrefix(var0))) {
               try {
                  _currPort = Integer.parseInt(var2[var3].substring(var2[var3].lastIndexOf(95) + 1));
               } catch (NumberFormatException var5) {
                  Trace.ignoredException(var5);
                  return false;
               }

               Trace.println("server running at port: " + _currPort, TraceLevel.TEMP);
               _idString = var0;
               return true;
            }
         }
      }

      return false;
   }

   public static boolean connectToServer(String var0) {
      Trace.println("connect to: " + _idString + " " + _currPort, TraceLevel.TEMP);

      try {
         Socket var1 = new Socket("127.0.0.1", _currPort);
         PrintStream var2 = new PrintStream(var1.getOutputStream());
         BufferedReader var3 = new BufferedReader(new InputStreamReader(var1.getInputStream()));
         var2.println("javaws.singleinstance.init");
         var2.println(var0);
         var2.println("EOF");
         var2.flush();
         Trace.println("waiting for ack", TraceLevel.TEMP);
         byte var4 = 5;

         for (int var5 = 0; var5 < var4; var5++) {
            String var6 = var3.readLine();
            if (var6 != null && var6.equals("javaws.singleinstance.ack")) {
               Trace.println("GOT ACK", TraceLevel.TEMP);
               var1.close();
               return true;
            }
         }

         var1.close();
      } catch (ConnectException var7) {
         Trace.println("no server is running - continue launch!", TraceLevel.TEMP);
         return false;
      } catch (SocketException var8) {
         Trace.println("no server is running - continue launch!", TraceLevel.TEMP);
      } catch (Exception var9) {
         var9.printStackTrace();
      }

      return false;
   }
}
