package com.sun.deploy.ui;

import com.sun.deploy.resources.ResourceManager;
import java.awt.Color;
import java.awt.Cursor;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import javax.swing.BorderFactory;
import javax.swing.JButton;
import javax.swing.KeyStroke;

class FancyButton extends JButton implements MouseListener {
   private Color originalColor;
   private Color activeColor = Color.red;
   private Cursor handCursor = new Cursor(12);

   FancyButton(String var1, Color var2) {
      super(ResourceManager.getMessage(var1));
      this.setMnemonic(ResourceManager.getAcceleratorKey(var1));
      this.originalColor = var2;
      this.setForeground(this.originalColor);
      this.setCursor(this.handCursor);
      this.setBorderPainted(false);
      this.setBorder(BorderFactory.createEmptyBorder(5, 5, 5, 5));
      this.addMouseListener(this);
      this.setRolloverEnabled(false);
      this.setContentAreaFilled(false);
      KeyStroke var3 = KeyStroke.getKeyStroke(10, 0);
      this.getInputMap().put(var3, "none");
   }

   public void mouseClicked(MouseEvent var1) {
   }

   public void mouseEntered(MouseEvent var1) {
      this.setForeground(this.activeColor);
   }

   public void mouseExited(MouseEvent var1) {
      if (this.originalColor != null) {
         this.setForeground(this.originalColor);
      }
   }

   public void mouseReleased(MouseEvent var1) {
   }

   public void mousePressed(MouseEvent var1) {
   }
}
