package com.sun.deploy.ui;

import com.sun.deploy.config.Config;
import com.sun.deploy.util.DeploySysRun;
import com.sun.deploy.util.DialogListener;
import com.sun.deploy.util.Trace;
import java.awt.Component;
import java.awt.GraphicsDevice;
import java.awt.GraphicsEnvironment;
import java.awt.MouseInfo;
import java.awt.Point;
import java.awt.Rectangle;
import java.awt.Toolkit;
import java.awt.Window;
import java.net.URL;
import java.security.cert.Certificate;

public class UIFactory {
   public static final int ERROR = -1;
   public static final int OK = 0;
   public static final int CANCEL = 1;
   public static final int ALWAYS = 2;
   public static final int ASK_ME_LATER = 3;
   private static long tsLastActive = 0L;
   private static DialogListener dialogListener = null;

   public static int showSecurityDialog(
      AppInfo var0,
      String var1,
      String var2,
      String var3,
      URL var4,
      boolean var5,
      boolean var6,
      String var7,
      String var8,
      String[] var9,
      String[] var10,
      boolean var11,
      Certificate[] var12,
      int var13,
      int var14,
      boolean var15
   ) {
      try {
         return (Integer)DeploySysRun.executePrivileged(
            new UIFactory$1(var10, var0, var3, var4, var1, var2, var5, var6, var7, var8, var9, var11, var12, var13, var14, var15), new Integer(-1)
         );
      } catch (Throwable var17) {
         Trace.ignored(var17);
         return -1;
      }
   }

   public static int showConfirmDialog(Component var0, AppInfo var1, String var2, String var3, String var4, String var5, String var6, boolean var7) {
      AppInfo var8 = var1 == null ? new AppInfo() : var1;

      try {
         return (Integer)DeploySysRun.executePrivileged(new UIFactory$2(var8, var0, var4, var2, var3, var5, var6, var7), new Integer(-1));
      } catch (Throwable var10) {
         Trace.ignored(var10);
         return -1;
      }
   }

   public static void placeWindow(Window var0) {
      Window var1 = var0.getOwner();
      boolean var2 = var1 != null && var1.isVisible();
      Rectangle var3 = getMouseScreenBounds();
      Rectangle var4 = var0.getBounds();
      Rectangle var5 = var1 != null && var1.isVisible() ? var1.getBounds() : var3;
      if (var5.x + var5.width < 0) {
         var2 = false;
         var5 = var3;
      }

      double var6 = var5.height - var5.height / 1.618;
      var4.x = var5.x + (var5.width - var4.width) / 2;
      int var8 = (int)(var6 - var4.height / 2);
      int var9 = var2 ? var1.getInsets().top : var3.height / 2 - 2 * var4.height / 3;
      var4.y = var5.y + Math.max(var8, var9);
      if (var4.x + var4.width > var3.width) {
         var4.x = Math.max(var3.width - var4.width, 0);
      }

      if (var4.y + var4.height > var3.height) {
         var4.y = Math.max(var3.height - var4.height, 0);
      }

      var0.setLocation(var4.x, var4.y);
   }

   public static Rectangle getMouseScreenBounds() {
      if (Config.isJavaVersionAtLeast13()) {
         Point var0 = new Point(1, 1);
         if (Config.isJavaVersionAtLeast15()) {
            var0 = MouseInfo.getPointerInfo().getLocation();
         }

         GraphicsDevice[] var1 = GraphicsEnvironment.getLocalGraphicsEnvironment().getScreenDevices();

         for (int var2 = 0; var2 < var1.length; var2++) {
            Rectangle var3 = var1[var2].getDefaultConfiguration().getBounds();
            if (var0.x >= var3.x && var0.y >= var3.y && var0.x <= var3.x + var3.width && var0.y <= var3.y + var3.height) {
               return var3;
            }
         }
      }

      return new Rectangle(new Point(0, 0), Toolkit.getDefaultToolkit().getScreenSize());
   }

   public static void setDialogListener(DialogListener var0) {
      dialogListener = var0;
   }

   public static DialogListener getDialogListener() {
      return dialogListener;
   }
}
