package com.sun.deploy.ui;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.Graphics;
import java.awt.Image;
import java.awt.Insets;
import javax.swing.JLabel;
import javax.swing.JTextArea;
import javax.swing.border.EmptyBorder;

public class UITextArea extends JTextArea {
   int preferred_width = 360;
   Image backgroundImage = null;

   public UITextArea() {
      JLabel var1 = new JLabel();
      this.setBorder(new EmptyBorder(new Insets(0, 5, 0, 0)));
      this.setEditable(false);
      this.setLineWrap(true);
      this.setWrapStyleWord(true);
      this.setFont(var1.getFont());
      this.setRows(0);
      this.setHighlighter(null);
      this.invalidate();
   }

   public UITextArea(String var1) {
      this();
      this.setText(var1);
   }

   public UITextArea(int var1, int var2, boolean var3) {
      this();
      this.preferred_width = var2;
      JLabel var4 = new JLabel();
      Font var5 = var4.getFont();
      Font var6;
      if (var3) {
         var6 = new Font(var5.getName(), 1, var1);
      } else {
         var6 = new Font(var5.getName(), var5.getStyle(), var1);
      }

      this.setBorder(new EmptyBorder(new Insets(0, 0, 0, 0)));
      this.setFont(var6);
      this.invalidate();
   }

   public boolean isFocusTraversable() {
      return false;
   }

   public void setText(String var1) {
      super.setText(var1);
      this.invalidate();
   }

   public void setBackgroundImage(Image var1) {
      this.backgroundImage = var1;
      boolean var2 = this.backgroundImage == null;
      this.setOpaque(var2);
   }

   public void paintComponent(Graphics var1) {
      if (this.backgroundImage != null) {
         var1.drawImage(this.backgroundImage, 0, 0, this);
      } else {
         this.setBackground(new Color(this.getParent().getBackground().getRGB()));
      }

      super.paintComponent(var1);
   }

   public Dimension getPreferredSize() {
      Dimension var1;
      if (this.backgroundImage != null) {
         var1 = new Dimension(this.backgroundImage.getWidth(this), this.backgroundImage.getHeight(this));
      } else if (this.getRows() == 0 && this.getColumns() == 0) {
         int var2 = this.preferred_width / this.getColumnWidth();
         this.setColumns(var2);
         var1 = super.getPreferredSize();
         this.setColumns(0);
      } else {
         var1 = super.getPreferredSize();
      }

      return var1;
   }
}
