package com.sun.deploy.util;

import com.sun.deploy.config.Config;
import com.sun.deploy.resources.ResourceManager;
import com.sun.deploy.si.DeploySIListener;
import com.sun.deploy.si.SingleInstanceImpl;
import com.sun.deploy.si.SingleInstanceManager;
import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.Font;
import java.awt.FontMetrics;
import java.awt.event.ActionEvent;
import java.awt.event.WindowEvent;
import java.net.URL;
import java.text.MessageFormat;
import javax.swing.BorderFactory;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JEditorPane;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextArea;
import javax.swing.KeyStroke;

public class AboutDialog extends JDialog implements DeploySIListener {
   private SingleInstanceImpl sil = null;
   private static String ABOUT_JAVA_ID = "com_sun_deploy_AboutJava-" + Config.getProperty("deployment.version");
   private String java_image = "com/sun/deploy/resources/image/about_java.png";

   public AboutDialog(JFrame var1, boolean var2, boolean var3) {
      super(var1, var2);
      if (var3) {
         this.initSIImpl();
      }

      this.initComponents();
   }

   public AboutDialog(JFrame var1, boolean var2) {
      super(var1, var2);
      this.initComponents();
   }

   public AboutDialog(JDialog var1, boolean var2) {
      super(var1, var2);
      this.initComponents();
   }

   private void initSIImpl() {
      this.sil = new SingleInstanceImpl();
      this.sil.addSingleInstanceListener(this, ABOUT_JAVA_ID);
   }

   public static boolean shouldStartNewInstance() {
      return !SingleInstanceManager.isServerRunning(ABOUT_JAVA_ID) || !SingleInstanceManager.connectToServer("");
   }

   private void initComponents() {
      this.setResizable(false);
      this.setTitle(this.getMessage("about.dialog.title"));
      this.setDefaultCloseOperation(2);
      this.addWindowListener(new AboutDialog$1(this));
      JPanel var1 = new JPanel(new BorderLayout());
      var1.setForeground(Color.white);
      var1.setBackground(Color.white);
      var1.setBorder(BorderFactory.createLineBorder(Color.black));
      URL var2 = ClassLoader.getSystemResource("com/sun/deploy/resources/image/aboutjava.png");
      ImageIcon var3 = new ImageIcon(var2);
      JLabel var4 = new JLabel(var3);
      JPanel var5 = new JPanel(new BorderLayout());
      var5.setForeground(Color.WHITE);
      var5.setBackground(Color.WHITE);
      var5.add(var4, "Center");
      var5.setBorder(BorderFactory.createEmptyBorder(4, 4, 4, 4));
      var1.add("North", var5);
      int var6 = var3.getIconWidth() - 20;
      JPanel var7 = new JPanel(new BorderLayout());
      var7.setBorder(BorderFactory.createEmptyBorder(6, 9, 9, 11));
      var7.setForeground(Color.WHITE);
      var7.setBackground(Color.WHITE);
      String var8 = System.getProperty("java.version");
      int var9 = var8.lastIndexOf("_");
      if (var9 != -1) {
         var8 = var8.substring(0, var9);
      }

      String var10 = MessageFormat.format(this.getMessage("about.java.version"), var8, System.getProperty("java.runtime.version"))
         + '\n'
         + this.getMessage("about.copyright")
         + '\n'
         + this.getMessage("about.legal.note");
      JTextArea var11 = new JTextArea();
      var11.setBorder(BorderFactory.createEmptyBorder(0, 4, 0, 4));
      var11.setEditable(false);
      var11.setLineWrap(true);
      var11.setWrapStyleWord(true);
      Font var12 = var11.getFont();
      float var13 = var12.getSize2D();
      var13 = Math.max((float)(var13 - 1.0), 11.0F);
      Font var14 = var12.deriveFont(var13);
      var11.setFont(var14);
      var11.setText(var10);
      FontMetrics var15 = var11.getFontMetrics(var14);
      int var16 = var15.stringWidth(this.getMessage("about.legal.note"));
      int var17 = (var16 + var6 - 1) / var6 + 2;
      var11.setRows(var17);
      var7.add(var11, "North");
      String var18 = this.getMessage("about.prompt.info");
      String var19 = this.getMessage("about.home.link");
      String var20 = "<font face=" + var14.getFamily() + " size=-1>" + var18 + " <a style='color:blue' href=" + var19 + '>' + var19 + "</a></font>";
      JEditorPane var21 = new JEditorPane("text/html", var20);
      var21.setFont(var14);
      var15 = var21.getFontMetrics(var14);
      var16 = var15.stringWidth(var18 + ' ' + var19);
      var17 = (var16 + var6 - 1) / var6;
      int var22 = var15.getHeight();
      int var23 = Math.max(var17, 2) * Math.max(var22, 15) + var21.getInsets().top + var21.getInsets().bottom;
      Dimension var24 = new Dimension(var6, var23);
      var21.setPreferredSize(var24);
      var21.setEditable(false);
      var21.addHyperlinkListener(new AboutDialog$2(this, var21, var20));
      var21.setForeground(new Color(var11.getForeground().getRGB()));
      var21.setBackground(new Color(var11.getBackground().getRGB()));
      var7.add(var21, "South");
      JPanel var25 = new JPanel(new FlowLayout(2));
      JButton var26 = new JButton(this.getMessage("about.option.close"));
      var26.setMnemonic(ResourceManager.getAcceleratorKey("about.option.close"));
      AboutDialog$3 var27 = new AboutDialog$3(this);
      var26.addActionListener(var27);
      KeyStroke var28 = KeyStroke.getKeyStroke('\u001b');
      this.getRootPane().getInputMap(2).put(var28, "cancel");
      this.getRootPane().getActionMap().put("cancel", var27);
      var11.getInputMap().put(var28, "cancel");
      var11.getActionMap().put("cancel", null);
      var21.getInputMap().put(var28, "cancel");
      var21.getActionMap().put("cancel", null);
      var25.add(var26);
      var1.add(var7, "Center");
      this.getContentPane().setLayout(new BorderLayout());
      this.getContentPane().add(var25, "South");
      this.getContentPane().add(var1, "Center");
      this.getRootPane().setDefaultButton(var26);
      this.pack();
      DialogFactory.positionDialog(this);
   }

   private void okBtnActionPerformed(ActionEvent var1) {
      if (this.sil != null) {
         this.sil.removeSingleInstanceListener(this);
      }

      this.setVisible(false);
      this.dispose();
   }

   private void closeDialog(WindowEvent var1) {
      if (this.sil != null) {
         this.sil.removeSingleInstanceListener(this);
      }

      this.setVisible(false);
      this.dispose();
   }

   private String getMessage(String var1) {
      return ResourceManager.getMessage(var1);
   }

   public void newActivation(String[] var1) {
      Object var2 = this;

      while ((var2 = var2.getOwner()) != null && !(var2 instanceof JFrame)) {
      }

      if (var2 != null) {
         ((JFrame)var2).toFront();
      }
   }

   public Object getSingleInstanceListener() {
      return this;
   }
}
