package com.sun.deploy.util;

import com.sun.deploy.config.Config;
import com.sun.deploy.panel.NetworkSettingsDialog;
import com.sun.deploy.panel.NumberDocument;
import com.sun.deploy.resources.ResourceManager;
import java.awt.BorderLayout;
import java.awt.Dialog;
import java.awt.FlowLayout;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ItemEvent;
import javax.swing.BorderFactory;
import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JComponent;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.JTextField;
import javax.swing.KeyStroke;
import javax.swing.border.EtchedBorder;

public class AdvancedNetworkSettingsDialog extends JDialog {
   private JTextArea bypassTextArea;
   private JTextField httpTextField;
   private JTextField secureTextField;
   private JTextField ftpTextField;
   private JTextField socksTextField;
   private JTextField httpPortTextField;
   private JTextField securePortTextField;
   private JTextField ftpPortTextField;
   private JTextField socksPortTextField;
   private JButton okButton;
   private JButton cancelButton;
   private JCheckBox useForAllChBox;

   public AdvancedNetworkSettingsDialog(Dialog var1, boolean var2) {
      super(var1, var2);
      this.initComponents();
   }

   private void initComponents() {
      this.setTitle(this.getMessage("advanced.network.dlg.title"));
      this.addWindowListener(new AdvancedNetworkSettingsDialog$1(this));
      JPanel var1 = new JPanel();
      var1.setLayout(new BorderLayout());
      JPanel var2 = new JPanel();
      var2.setLayout(new BorderLayout());
      var2.setBorder(BorderFactory.createTitledBorder(new EtchedBorder(), this.getMessage("advanced.network.dlg.servers"), 0, 0));
      JPanel var3 = new JPanel();
      var3.setLayout(new BoxLayout(var3, 0));
      JPanel var4 = new JPanel();
      var4.setLayout(new GridLayout(5, 1, 0, 5));
      JLabel var5 = new JLabel(this.getMessage("advanced.network.dlg.type"));
      var5.setHorizontalAlignment(0);
      JLabel var6 = new JLabel(this.getMessage("advanced.network.dlg.http"));
      JLabel var7 = new JLabel(this.getMessage("advanced.network.dlg.secure"));
      JLabel var8 = new JLabel(this.getMessage("advanced.network.dlg.ftp"));
      JLabel var9 = new JLabel(this.getMessage("advanced.network.dlg.socks"));
      var4.add(var5);
      var4.add(var6);
      var4.add(var7);
      var4.add(var8);
      var4.add(var9);
      var3.add(Box.createHorizontalStrut(5));
      var3.add(var4);
      var3.add(Box.createHorizontalStrut(5));
      JPanel var10 = new JPanel();
      var10.setLayout(new GridLayout(5, 1, 0, 5));
      JLabel var11 = new JLabel(this.getMessage("advanced.network.dlg.proxy_address"));
      var11.setHorizontalAlignment(0);
      this.httpTextField = new JTextField(20);
      this.secureTextField = new JTextField(20);
      this.ftpTextField = new JTextField(20);
      this.socksTextField = new JTextField(20);
      var10.add(var11);
      var10.add(this.httpTextField);
      var10.add(this.secureTextField);
      var10.add(this.ftpTextField);
      var10.add(this.socksTextField);
      var3.add(var10);
      var3.add(Box.createHorizontalStrut(5));
      JPanel var12 = new JPanel();
      var12.setLayout(new GridLayout(5, 1, 0, 5));
      JLabel var13 = new JLabel(":");
      var13.setHorizontalAlignment(0);
      JLabel var14 = new JLabel(":");
      var14.setHorizontalAlignment(0);
      JLabel var15 = new JLabel(":");
      var15.setHorizontalAlignment(0);
      JLabel var16 = new JLabel(":");
      var16.setHorizontalAlignment(0);
      var12.add(Box.createGlue());
      var12.add(var13);
      var12.add(var14);
      var12.add(var15);
      var12.add(var16);
      var3.add(var12);
      var3.add(Box.createHorizontalStrut(5));
      JPanel var17 = new JPanel();
      var17.setLayout(new GridLayout(5, 1, 0, 5));
      JLabel var18 = new JLabel(this.getMessage("advanced.network.dlg.port"));
      var18.setHorizontalAlignment(0);
      this.httpPortTextField = new JTextField(6);
      this.httpPortTextField.setDocument(new NumberDocument());
      this.securePortTextField = new JTextField(6);
      this.securePortTextField.setDocument(new NumberDocument());
      this.ftpPortTextField = new JTextField(6);
      this.ftpPortTextField.setDocument(new NumberDocument());
      this.socksPortTextField = new JTextField(6);
      this.socksPortTextField.setDocument(new NumberDocument());
      var17.add(var18);
      var17.add(this.httpPortTextField);
      var17.add(this.securePortTextField);
      var17.add(this.ftpPortTextField);
      var17.add(this.socksPortTextField);
      var3.add(var17);
      var3.add(Box.createHorizontalStrut(5));
      JPanel var19 = new JPanel();
      var19.setLayout(new FlowLayout(1));
      this.useForAllChBox = new JCheckBox(this.getMessage("advanced.network.dlg.same_proxy"));
      this.useForAllChBox.setSelected(false);
      this.useForAllChBox.setMnemonic(ResourceManager.getVKCode("advanced.network.dlg.same_proxy.mnemonic"));
      this.useForAllChBox.addItemListener(new AdvancedNetworkSettingsDialog$2(this));
      var19.add(this.useForAllChBox);
      var2.add(var3, "Center");
      var2.add(var19, "South");
      var1.add(var2, "North");
      JPanel var20 = new JPanel();
      var20.setLayout(new BorderLayout());
      var20.setBorder(BorderFactory.createTitledBorder(new EtchedBorder(), this.getMessage("advanced.network.dlg.exceptions"), 0, 0));
      JLabel var21 = new JLabel(this.getMessage("advanced.network.dlg.no_proxy"));
      this.bypassTextArea = new JTextArea(3, 1);
      this.bypassTextArea.setFont(ResourceManager.getUIFont());
      JScrollPane var22 = new JScrollPane();
      var22.setHorizontalScrollBarPolicy(31);
      var22.setVerticalScrollBarPolicy(22);
      var22.setAutoscrolls(true);
      var22.setViewportView(this.bypassTextArea);
      JLabel var23 = new JLabel(this.getMessage("advanced.network.dlg.no_proxy_note"));
      JPanel var24 = new JPanel();
      var24.setLayout(new BorderLayout());
      var24.add(var21, "North");
      var24.add(var22, "Center");
      var24.add(var23, "South");
      var20.add(Box.createHorizontalStrut(10), "West");
      var20.add(var24, "Center");
      var20.add(Box.createHorizontalStrut(10), "East");
      var20.add(Box.createVerticalStrut(5), "South");
      var1.add(var20, "Center");
      JPanel var25 = new JPanel();
      var25.setLayout(new FlowLayout(2));
      this.okButton = new JButton(this.getMessage("common.ok_btn"));
      this.okButton.setMnemonic(ResourceManager.getVKCode("common.ok_btn.mnemonic"));
      this.okButton.addActionListener(new AdvancedNetworkSettingsDialog$3(this));
      this.cancelButton = new JButton(this.getMessage("common.cancel_btn"));
      this.cancelButton.setMnemonic(ResourceManager.getVKCode("common.cancel_btn.mnemonic"));
      AdvancedNetworkSettingsDialog$4 var26 = new AdvancedNetworkSettingsDialog$4(this);
      this.cancelButton.addActionListener(var26);
      this.getRootPane().registerKeyboardAction(var26, KeyStroke.getKeyStroke('\u001b'), 2);
      var25.add(this.okButton);
      var25.add(this.cancelButton);
      this.getRootPane().setDefaultButton(this.okButton);
      var1.add(var25, "South");
      this.getContentPane().add(var1);
      this.pack();
      this.setValues();
      this.setResizable(false);
      this.setFocusSequence();
   }

   private void setValues() {
      String var1;
      String var2;
      if (this.getParent() != null && this.getParent() instanceof NetworkSettingsDialog) {
         var1 = ((NetworkSettingsDialog)this.getParent()).getProxyAddressField();
         var2 = ((NetworkSettingsDialog)this.getParent()).getProxyPortField();
      } else {
         var1 = Config.getProperty("deployment.proxy.http.host");
         var2 = Config.getProperty("deployment.proxy.http.port");
      }

      this.httpTextField.setText(var1);
      boolean var3 = !Config.isLocked("deployment.proxy.http.host");
      this.httpTextField.setEditable(var3);
      this.httpTextField.setEnabled(var3);
      this.httpPortTextField.setText(var2);
      var3 = !Config.isLocked("deployment.proxy.http.port");
      this.httpPortTextField.setEditable(var3);
      this.httpPortTextField.setEnabled(var3);
      this.useForAllChBox.setSelected(Config.getBooleanProperty("deployment.proxy.same"));
      this.useForAllChBox.setEnabled(!Config.isLocked("deployment.proxy.same"));
      this.setUseForAll(this.useForAllChBox.isSelected());
      var1 = Config.getProperty("deployment.proxy.socks.host");
      var2 = Config.getProperty("deployment.proxy.socks.port");
      this.socksTextField.setText(var1);
      var3 = !Config.isLocked("deployment.proxy.socks.host");
      this.socksTextField.setEditable(var3);
      this.socksTextField.setEnabled(var3);
      this.socksPortTextField.setText(var2);
      var3 = !Config.isLocked("deployment.proxy.socks.port");
      this.socksPortTextField.setEditable(var3);
      this.socksPortTextField.setEnabled(var3);
      String var4 = Config.getProperty("deployment.proxy.bypass.list");
      this.bypassTextArea.setText(var4);
      this.bypassTextArea.setEditable(!Config.isLocked("deployment.proxy.bypass.list"));
   }

   private void setFocusSequence() {
      this.httpTextField.setNextFocusableComponent(this.httpPortTextField);
      this.secureTextField.setNextFocusableComponent(this.securePortTextField);
      this.ftpTextField.setNextFocusableComponent(this.ftpPortTextField);
      this.socksTextField.setNextFocusableComponent(this.socksPortTextField);
      this.httpPortTextField.setNextFocusableComponent(this.secureTextField);
      this.securePortTextField.setNextFocusableComponent(this.ftpTextField);
      this.ftpPortTextField.setNextFocusableComponent(this.socksTextField);
      this.bypassTextArea.setNextFocusableComponent(this.okButton);
   }

   private void setComponent(JComponent var1, boolean var2) {
      if (var1 instanceof JLabel || var1 instanceof JCheckBox || var1 instanceof JButton) {
         var1.setEnabled(var2);
      } else if (var1 instanceof JTextField) {
         var1.setEnabled(var2);
         ((JTextField)var1).setEditable(var2);
      }
   }

   private void okButtonActionPerformed(ActionEvent var1) {
      Config.setProperty("deployment.proxy.http.host", this.httpTextField.getText());
      Config.setProperty("deployment.proxy.http.port", this.httpPortTextField.getText());
      Config.setProperty("deployment.proxy.https.host", this.secureTextField.getText());
      Config.setProperty("deployment.proxy.https.port", this.securePortTextField.getText());
      Config.setProperty("deployment.proxy.ftp.host", this.ftpTextField.getText());
      Config.setProperty("deployment.proxy.ftp.port", this.ftpPortTextField.getText());
      Config.setProperty("deployment.proxy.socks.host", this.socksTextField.getText());
      Config.setProperty("deployment.proxy.socks.port", this.socksPortTextField.getText());
      Config.setBooleanProperty("deployment.proxy.same", this.useForAllChBox.isSelected());
      Config.setProperty("deployment.proxy.bypass.list", this.bypassTextArea.getText());
      this.setVisible(false);
      this.dispose();
   }

   private void useForAllChBoxItemStateChanged(ItemEvent var1) {
      this.setUseForAll(var1.getStateChange() == 1);
   }

   private void setUseForAll(boolean var1) {
      if (var1) {
         this.setTextFields(false);
         String var2 = this.httpTextField.getText();
         String var3 = this.httpPortTextField.getText();
         this.secureTextField.setText(var2);
         this.securePortTextField.setText(var3);
         this.ftpTextField.setText(var2);
         this.ftpPortTextField.setText(var3);
      } else {
         this.secureTextField.setText(Config.getProperty("deployment.proxy.https.host"));
         this.securePortTextField.setText(Config.getProperty("deployment.proxy.https.port"));
         this.ftpTextField.setText(Config.getProperty("deployment.proxy.ftp.host"));
         this.ftpPortTextField.setText(Config.getProperty("deployment.proxy.ftp.port"));
         this.setTextFields(true);
      }
   }

   private void setTextFields(boolean var1) {
      boolean var2 = var1 && !Config.isLocked("deployment.proxy.https.host");
      this.secureTextField.setEnabled(var2);
      this.secureTextField.setEditable(var2);
      var2 = var1 && !Config.isLocked("deployment.proxy.ftp.host");
      this.ftpTextField.setEnabled(var2);
      this.ftpTextField.setEditable(var2);
      var2 = var1 && !Config.isLocked("deployment.proxy.https.port");
      this.securePortTextField.setEnabled(var2);
      this.securePortTextField.setEditable(var2);
      var2 = var1 && !Config.isLocked("deployment.proxy.ftp.port");
      this.ftpPortTextField.setEnabled(var2);
      this.ftpPortTextField.setEditable(var2);
   }

   private void closeDialog() {
      this.setVisible(false);
      this.dispose();
   }

   private String getMessage(String var1) {
      return ResourceManager.getMessage(var1);
   }
}
