package com.sun.deploy.util;

import com.sun.deploy.config.Config;
import com.sun.deploy.resources.ResourceManager;
import java.util.Enumeration;
import java.util.Properties;
import java.util.TreeSet;

public final class ConsoleHelper {
   private static ConsoleController controller = null;

   public static void setConsoleController(ConsoleController var0) {
      controller = var0;
   }

   static void dumpThreadGroup(ThreadGroup var0, StringBuffer var1) {
      if (var0 != null) {
         try {
            if (var0.activeCount() == 0 && var0.activeGroupCount() == 0 && !var0.isDestroyed()) {
               var0.destroy();
            }
         } catch (Throwable var5) {
         }

         var1.append("Group " + var0.getName());
         var1.append(",ac=" + var0.activeCount());
         var1.append(",agc=" + var0.activeGroupCount());
         var1.append(",pri=" + var0.getMaxPriority());
         if (var0.isDestroyed()) {
            var1.append(",destoyed");
         }

         if (var0.isDaemon()) {
            var1.append(",daemon");
         }

         var1.append("\n");
         Thread[] var2 = new Thread[1000];
         var0.enumerate(var2, false);

         for (int var3 = 0; var3 < var2.length; var3++) {
            if (var2[var3] != null) {
               var1.append("    ");
               var1.append(var2[var3].getName());
               var1.append(",");
               var1.append(var2[var3].getPriority());
               if (var2[var3].isAlive()) {
                  var1.append(",alive");
               } else {
                  var1.append(",not alive");
               }

               if (var2[var3].isDaemon()) {
                  var1.append(",daemon");
               }

               if (var2[var3].isInterrupted()) {
                  var1.append(",interrupted");
               }

               var1.append("\n");
            }
         }

         ThreadGroup[] var6 = new ThreadGroup[1000];
         var0.enumerate(var6, false);

         for (int var4 = 0; var4 < var6.length; var4++) {
            if (var6[var4] != null) {
               dumpThreadGroup(var6[var4], var1);
            }
         }
      }
   }

   public static String displayHelp() {
      StringBuffer var0 = new StringBuffer();
      var0.append(ResourceManager.getMessage("console.menu.text.top"));
      var0.append(ResourceManager.getMessage("console.menu.text.c"));
      var0.append(ResourceManager.getMessage("console.menu.text.f"));
      var0.append(ResourceManager.getMessage("console.menu.text.g"));
      var0.append(ResourceManager.getMessage("console.menu.text.h"));
      if (controller.isJCovSupported()) {
         var0.append(ResourceManager.getMessage("console.menu.text.j"));
      }

      if (controller.isDumpClassLoaderSupported()) {
         var0.append(ResourceManager.getMessage("console.menu.text.l"));
      }

      var0.append(ResourceManager.getMessage("console.menu.text.m"));
      if (controller.isLoggingSupported()) {
         var0.append(ResourceManager.getMessage("console.menu.text.o"));
      }

      if (controller.isProxyConfigReloadSupported()) {
         var0.append(ResourceManager.getMessage("console.menu.text.p"));
      }

      var0.append(ResourceManager.getMessage("console.menu.text.q"));
      if (controller.isSecurityPolicyReloadSupported()) {
         var0.append(ResourceManager.getMessage("console.menu.text.r"));
      }

      var0.append(ResourceManager.getMessage("console.menu.text.s"));
      var0.append(ResourceManager.getMessage("console.menu.text.t"));
      if (controller.isDumpStackSupported()) {
         var0.append(ResourceManager.getMessage("console.menu.text.v"));
      }

      if (controller.isClearClassLoaderSupported()) {
         var0.append(ResourceManager.getMessage("console.menu.text.x"));
      }

      var0.append(ResourceManager.getMessage("console.menu.text.0"));
      var0.append(ResourceManager.getMessage("console.menu.text.tail"));
      return var0.toString();
   }

   public static String displayVersion() {
      StringBuffer var0 = new StringBuffer();
      var0.append(controller.getProductName());
      var0.append("\n");
      var0.append(ResourceManager.getMessage("console.using_jre_version"));
      var0.append(" ");
      var0.append(System.getProperty("java.version"));
      var0.append(" ");
      var0.append(System.getProperty("java.vm.name"));
      var0.append("\n");
      var0.append(ResourceManager.getMessage("console.user_home"));
      var0.append(" = ");
      var0.append(System.getProperty("user.home"));
      return var0.toString();
   }

   public static String displaySystemProperties() {
      TreeSet var0 = new TreeSet();
      Properties var1 = Config.getProperties();
      Enumeration var2 = System.getProperties().propertyNames();

      while (var2.hasMoreElements()) {
         var0.add(var2.nextElement());
      }

      StringBuffer var6 = new StringBuffer();
      var6.append(ResourceManager.getMessage("console.dump.system.properties"));
      var6.append(ResourceManager.getMessage("console.menu.text.top"));

      for (String var4 : var0) {
         if (!var1.containsKey(var4)) {
            String var5 = System.getProperty(var4);
            if (var5 != null) {
               if (var5.equals("\n")) {
                  var5 = "\\n";
               } else if (var5.equals("\r")) {
                  var5 = "\\r";
               } else if (var5.equals("\r\n")) {
                  var5 = "\\r\\n";
               } else if (var5.equals("\n\r")) {
                  var5 = "\\n\\r";
               } else if (var5.equals("\n\n")) {
                  var5 = "\\n\\n";
               } else if (var5.equals("\r\r")) {
                  var5 = "\\r\\r";
               }
            }

            var6.append(var4 + " = " + var5 + "\n");
         }
      }

      var6.append(ResourceManager.getMessage("console.menu.text.tail"));
      var0.clear();
      Enumeration var7 = var1.propertyNames();

      while (var7.hasMoreElements()) {
         var0.add(var7.nextElement());
      }

      var6.append(ResourceManager.getMessage("console.dump.deployment.properties"));
      var6.append(ResourceManager.getMessage("console.menu.text.top"));

      for (String var9 : var0) {
         String var10 = var1.getProperty(var9);
         if (var10 != null) {
            if (var10.equals("\n")) {
               var10 = "\\n";
            } else if (var10.equals("\r")) {
               var10 = "\\r";
            } else if (var10.equals("\r\n")) {
               var10 = "\\r\\n";
            } else if (var10.equals("\n\r")) {
               var10 = "\\n\\r";
            } else if (var10.equals("\n\n")) {
               var10 = "\\n\\n";
            } else if (var10.equals("\r\r")) {
               var10 = "\\r\\r";
            }
         }

         var6.append(var9 + " = " + var10 + "\n");
      }

      var6.append(ResourceManager.getMessage("console.menu.text.tail"));
      var6.append(ResourceManager.getMessage("console.done"));
      return var6.toString();
   }
}
