package com.sun.deploy.util;

public final class ConsoleTraceListener implements TraceListener {
   private static final long MIN_CONSOLE_OUTPUT_INTERVAL = 100L;
   private Object lock = new Object();
   private ConsoleWindow console = null;
   private StringBuffer buffer = new StringBuffer();

   public ConsoleTraceListener(ConsoleController var1) {
      ConsoleHelper.setConsoleController(var1);
   }

   public void setConsole(ConsoleWindow var1) {
      this.console = var1;
      new ConsoleTraceListener.ConsoleWriterThread();
   }

   public void print(String var1) {
      synchronized (this.lock) {
         boolean var3 = this.buffer.length() == 0;
         this.buffer.append(var1);
         if (var3 && this.console != null) {
            this.lock.notifyAll();
         }
      }
   }

   class ConsoleWriterThread extends Thread {
      public ConsoleWriterThread() {
         super("ConsoleWriterThread");
         this.setDaemon(true);
         this.start();
      }

      public void run() {
         long var1 = System.currentTimeMillis();

         while (true) {
            long var3 = System.currentTimeMillis();
            synchronized (ConsoleTraceListener.this.lock) {
               if (var3 - var1 >= 100L && ConsoleTraceListener.this.buffer.length() > 0) {
                  ConsoleTraceListener.this.console.append(ConsoleTraceListener.this.buffer.toString());
                  ConsoleTraceListener.this.buffer = new StringBuffer();
                  var1 = var3;
               } else {
                  try {
                     if (ConsoleTraceListener.this.buffer.length() == 0) {
                        ConsoleTraceListener.this.lock.wait();
                     } else {
                        ConsoleTraceListener.this.lock.wait(100L - (var3 - var1));
                     }
                  } catch (InterruptedException var8) {
                  }
               }
            }
         }
      }
   }
}
