package com.sun.deploy.util;

import com.sun.deploy.config.Config;
import sun.misc.PerformanceLogger;

public final class PerfLogger {
   private static boolean perfLogOn = false;
   private static String perfLogFilePath = null;
   private static long endTime = 0L;

   public static boolean perfLogEnabled() {
      return perfLogOn;
   }

   public static void setStartTime(String var0) {
      if (perfLogOn) {
         PerformanceLogger.setStartTime(var0);
      }
   }

   public static void setTime(String var0) {
      if (perfLogOn) {
         PerformanceLogger.setTime(var0);
      }
   }

   public static void setEndTime(String var0) {
      if (perfLogOn) {
         PerformanceLogger.setTime(var0);
         endTime = System.currentTimeMillis();
      }
   }

   public static void outputLog() {
      if (perfLogOn) {
         if (endTime != 0L) {
            PerformanceLogger.setTime("Deployment Java Startup time " + (endTime - PerformanceLogger.getStartTime()));
         }

         if (Trace.isEnabled()) {
            PerformanceLogger.outputLog();
         }
      }
   }

   static {
      perfLogFilePath = System.getProperty("sun.perflog");
      if (perfLogFilePath != null && Config.isJavaVersionAtLeast15()) {
         perfLogOn = true;
      }
   }
}
