package com.sun.deploy.util;

import java.io.BufferedOutputStream;
import java.io.IOException;
import java.io.PrintStream;
import java.net.Socket;
import java.net.UnknownHostException;

public class SocketTraceListener implements TraceListener {
   private String host;
   private int port;
   private PrintStream socketTraceStream = null;
   private Socket socket;

   public SocketTraceListener(String var1, int var2) {
      this.host = var1;
      this.port = var2;
      this.init();
   }

   private void init() {
      try {
         this.socket = new Socket(this.host, this.port);
         this.socketTraceStream = new PrintStream(new BufferedOutputStream(this.socket.getOutputStream()));
      } catch (UnknownHostException var2) {
         var2.printStackTrace();
      } catch (IOException var3) {
         var3.printStackTrace();
      }
   }

   public Socket getSocket() {
      return this.socket;
   }

   public void print(String var1) {
      if (this.socketTraceStream != null) {
         this.socketTraceStream.print(var1);
         this.socketTraceStream.flush();
      }
   }
}
