package com.sun.deploy.util;

final class TraceMessage {
   private TraceLevel level;
   private String msg;
   private boolean newline;

   TraceMessage(TraceLevel var1, String var2) {
      this(var1, var2, false);
   }

   TraceMessage(TraceLevel var1, String var2, boolean var3) {
      this.level = var1;
      this.msg = var2;
      this.newline = var3;
   }

   public String toString() {
      return PerfLogger.perfLogEnabled() ? "ts: " + System.currentTimeMillis() + " " + this.level + ": " + this.msg : this.level + ": " + this.msg;
   }

   String getMessage() {
      StringBuffer var1 = new StringBuffer();
      if (PerfLogger.perfLogEnabled()) {
         var1.append("ts: ").append(System.currentTimeMillis()).append(" ");
      }

      if (this.level.equals(TraceLevel.DEFAULT)) {
         var1.append(this.msg);
      } else {
         var1.append(this.level).append(": ").append(this.msg);
      }

      if (this.newline) {
         var1.append("\n");
      }

      return var1.toString();
   }
}
