package com.sun.deploy.xml;

public class XMLAttribute {
   private String _name;
   private String _value;
   private XMLAttribute _next;

   public XMLAttribute(String var1, String var2) {
      this._name = var1;
      this._value = var2;
      this._next = null;
   }

   public XMLAttribute(String var1, String var2, XMLAttribute var3) {
      this._name = var1;
      this._value = var2;
      this._next = var3;
   }

   public String getName() {
      return this._name;
   }

   public String getValue() {
      return this._value;
   }

   public XMLAttribute getNext() {
      return this._next;
   }

   public void setNext(XMLAttribute var1) {
      this._next = var1;
   }

   public boolean equals(Object var1) {
      if (var1 != null && var1 instanceof XMLAttribute) {
         XMLAttribute var2 = (XMLAttribute)var1;
         return match(this._name, var2._name) && match(this._value, var2._value) && match(this._next, var2._next);
      } else {
         return false;
      }
   }

   private static boolean match(Object var0, Object var1) {
      return var0 == null ? var1 == null : var0.equals(var1);
   }

   public String toString() {
      return this._next != null ? this._name + "=\"" + this._value + "\" " + this._next.toString() : this._name + "=\"" + this._value + "\"";
   }
}
