package com.sun.deploy.xml;

import java.net.URL;

public class XMLAttributeBuilder {
   private XMLAttribute _root = null;
   private XMLAttribute _next;

   public void add(XMLAttribute var1) {
      if (var1 != null) {
         if (this._next == null) {
            this._root = this._next = var1;
            var1.setNext(null);
         } else {
            this._next.setNext(var1);
            this._next = var1;
            var1.setNext(null);
         }
      }
   }

   public void add(String var1, String var2) {
      if (var2 != null && var2.length() > 0) {
         this.add(new XMLAttribute(var1, var2));
      }
   }

   public void add(String var1, URL var2) {
      if (var2 != null) {
         this.add(new XMLAttribute(var1, var2.toString()));
      }
   }

   public void add(String var1, long var2) {
      if (var2 != 0L) {
         this.add(new XMLAttribute(var1, new Long(var2).toString()));
      }
   }

   public void add(String var1, boolean var2) {
      this.add(new XMLAttribute(var1, var2 ? "true" : "false"));
   }

   public XMLAttribute getAttributeList() {
      return this._root;
   }
}
