package com.sun.deploy.xml;

public class XMLNodeBuilder {
   private XMLNode _root;
   private XMLNode _last;

   public XMLNodeBuilder(String var1, XMLAttribute var2) {
      this._root = new XMLNode(var1, var2, null, null);
      this._last = null;
   }

   public void add(XMLNode var1) {
      if (var1 != null) {
         if (this._last == null) {
            this._root.setNested(var1);
            this._last = var1;
         } else {
            this._last.setNext(var1);
            var1.setNext(null);
            this._last = var1;
         }
      }
   }

   public void add(XMLable var1) {
      if (var1 != null) {
         this.add(var1.asXML());
      }
   }

   public void add(String var1, String var2) {
      if (var2 != null) {
         this.add(new XMLNode(var1, null, new XMLNode(var2), null));
      }
   }

   public XMLNode getNode() {
      return this._root;
   }
}
