package netscape.javascript;

public class JSException extends RuntimeException {
   public static final int EXCEPTION_TYPE_EMPTY = -1;
   public static final int EXCEPTION_TYPE_VOID = 0;
   public static final int EXCEPTION_TYPE_OBJECT = 1;
   public static final int EXCEPTION_TYPE_FUNCTION = 2;
   public static final int EXCEPTION_TYPE_STRING = 3;
   public static final int EXCEPTION_TYPE_NUMBER = 4;
   public static final int EXCEPTION_TYPE_BOOLEAN = 5;
   public static final int EXCEPTION_TYPE_ERROR = 6;
   protected String message = null;
   protected String filename = null;
   protected int lineno = -1;
   protected String source = null;
   protected int tokenIndex = -1;
   private int wrappedExceptionType = -1;
   private Object wrappedException = null;

   public int getWrappedExceptionType() {
      return this.wrappedExceptionType;
   }

   public JSException() {
      this(null);
   }

   public Object getWrappedException() {
      return this.wrappedException;
   }

   public JSException(int var1, Object var2) {
      this();
      this.wrappedExceptionType = var1;
      this.wrappedException = var2;
   }

   public JSException(String var1) {
      this(var1, null, -1, null, -1);
   }

   public JSException(String var1, String var2, int var3, String var4, int var5) {
      super(var1);
      this.message = var1;
      this.filename = var2;
      this.lineno = var3;
      this.source = var4;
      this.tokenIndex = var5;
      this.wrappedExceptionType = -1;
   }
}
