package netscape.security;

import java.net.URL;

public final class Principal {
   public static final int CODEBASE_EXACT = 1;
   public static final int CODEBASE_REGEXP = 2;
   public static final int CERT = 3;
   public static final int CERT_FINGERPRINT = 4;
   public static final int CERT_KEY = 5;
   private int type = 3;
   private URL url = null;

   public Principal() {
   }

   public boolean isCert() {
      return this.type == 3;
   }

   public boolean isCertFingerprint() {
      return this.type == 4;
   }

   public boolean isCodebase() {
      return this.isCodebaseExact() || this.isCodebaseRegexp();
   }

   public boolean isCodebaseExact() {
      return this.type == 1;
   }

   public boolean isCodebaseRegexp() {
      return this.type == 2;
   }

   public boolean isSystemPrincipal() {
      return false;
   }

   public Principal(int var1, byte[] var2) {
      this.type = var1;
   }

   public Principal(int var1, byte[] var2, Class var3) {
      this.type = var1;
   }

   public static int getZigPtr(Class var0) {
      return -1;
   }

   public String getNickname() {
      return null;
   }

   public String getVendor() {
      return null;
   }

   public String toVerboseHtml() {
      return null;
   }

   public String toVerboseString() {
      return this.toString();
   }

   public Principal(int var1, String var2) {
      this.type = var1;
   }

   public Principal(URL var1) {
      this.url = var1;
   }
}
