package netscape.security;

public final class Privilege {
   public static final int N_PERMISSIONS = 15;
   public static final int FORBIDDEN = 0;
   public static final int ALLOWED = 1;
   public static final int BLANK = 2;
   public static final int N_DURATIONS = 240;
   public static final int SCOPE = 16;
   public static final int SESSION = 32;
   public static final int FOREVER = 64;
   private int permission = 0;
   private int duration = 16;

   public int getDuration() {
      return this.duration;
   }

   public int getPermission() {
      return this.permission;
   }

   public boolean isAllowed() {
      return this.permission == 1;
   }

   public boolean isBlank() {
      return this.permission == 2;
   }

   public boolean isForbidden() {
      return this.permission == 0;
   }

   public boolean sameDuration(int var1) {
      return this.duration == var1;
   }

   public boolean samePermission(int var1) {
      return this.permission == var1;
   }

   public static int add(int var0, int var1) {
      if (var0 == 0 || var1 == 0) {
         return 0;
      } else if (var0 == 2) {
         return var1;
      } else if (var1 == 2) {
         return var0;
      } else {
         return var0 != 1 && var1 != 1 ? 2 : 1;
      }
   }

   Privilege(int var1, int var2) {
      this.permission = var1;
      this.duration = var2;
   }

   public boolean equals(Object var1) {
      if (!(var1 instanceof Privilege)) {
         return false;
      } else {
         Privilege var2 = (Privilege)var1;
         return this.permission == var2.getPermission() && this.duration == var2.getDuration();
      }
   }

   public static Privilege findPrivilege(int var0, int var1) {
      return new Privilege(var0, var1);
   }

   public boolean sameDuration(Privilege var1) {
      return this.sameDuration(var1.getDuration());
   }

   public boolean samePermission(Privilege var1) {
      return this.samePermission(var1.getPermission());
   }

   public static Privilege add(Privilege var0, Privilege var1) {
      int var2 = add(var0.getPermission(), var1.getPermission());
      return new Privilege(var2, var0.getDuration());
   }
}
