package sun.plugin;

import com.sun.java.browser.net.ProxyService;
import java.applet.Applet;
import java.applet.AppletContext;
import java.awt.Color;
import java.awt.Component;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.FontMetrics;
import java.awt.Frame;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Image;
import java.awt.MenuItem;
import java.awt.Point;
import java.awt.PopupMenu;
import java.awt.RenderingHints;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.event.WindowEvent;
import java.awt.event.WindowListener;
import java.io.BufferedInputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.lang.reflect.Method;
import java.net.MalformedURLException;
import java.net.URL;
import java.net.URLConnection;
import java.security.Security;
import java.text.MessageFormat;
import java.util.Enumeration;
import java.util.HashMap;
import java.util.Locale;
import java.util.Properties;
import java.util.StringTokenizer;
import netscape.javascript.JSException;
import netscape.javascript.JSObject;
import sun.applet.AppletClassLoader;
import sun.applet.AppletEvent;
import sun.applet.AppletListener;
import sun.applet.AppletPanel;
import sun.net.www.MimeTable;
import sun.net.www.protocol.http.ExAuthenticator;
import sun.net.www.protocol.jar.URLJarFile;
import sun.plugin.cache.JarCache;
import sun.plugin.cache.JarCacheUtil;
import sun.plugin.extension.ExtensionInstallationImpl;
import sun.plugin.javascript.JSContext;
import sun.plugin.net.proxy.PluginProxyManager;
import sun.plugin.net.proxy.PluginProxyServiceProvider;
import sun.plugin.resources.ResourceHandler;
import sun.plugin.security.ActivatorSecurityManager;
import sun.plugin.security.JDK11ClassFileTransformer;
import sun.plugin.security.PluginAuthenticator;
import sun.plugin.security.PluginClassLoader;
import sun.plugin.services.BrowserService;
import sun.plugin.services.ServiceProvider;
import sun.plugin.util.DialogFactory;
import sun.plugin.util.ProgressListener;
import sun.plugin.util.ProgressTracker;
import sun.plugin.util.Steamer;
import sun.plugin.util.ThreadGroupLocal;
import sun.plugin.util.Trace;
import sun.plugin.util.URLUtil;
import sun.plugin.util.UpdateCheck;
import sun.plugin.util.UserProfile;
import sun.plugin.viewer.context.PluginAppletContext;

public class AppletViewer extends AppletPanel implements ProgressListener, WindowListener {
   private final ProgressInfo appletProgress = new ProgressInfo();
   private boolean progress_bar_local = false;
   private Steamer steam_the_cup = null;
   private AppletViewer.GrayBoxListener grayBoxListener = null;
   private boolean loading_first_time = true;
   private boolean preloading = false;
   private volatile boolean stopped = false;
   private static Frame dummyFrame = new Frame();
   private Color boxBGColor = Color.lightGray;
   private Color boxFGColor = Color.black;
   private Color progressColor = new Color(153, 153, 204);
   private String userMsg = null;
   private boolean colorSet = false;
   private static boolean initialized = false;
   public static String theVersion = "1.1";
   public static File theUserPropertiesFile;
   private URL documentURL = null;
   protected URL baseURL = null;
   private static AppletMessageHandler amh = new AppletMessageHandler("appletpanel");
   protected HashMap atts = new HashMap();
   private ClassLoaderInfo cli = null;
   private static boolean fShowException = false;
   public boolean readyToQuit = true;
   public Object appletQuitLock = new Object();
   private AppletViewer.AppletEventListener appletEventListener = new AppletViewer.AppletEventListener(null);
   private Object syncInit = new Object();
   private boolean bInit = false;
   private boolean docbaseInit = false;
   private Object docBaseSyncObj = new Object();
   protected boolean codeBaseInit = false;
   private String classLoaderCacheKey = null;
   private AppletStatusListener statusListener = null;
   private PluginAppletContext appletContext;
   private InputStream is;
   private GrayBoxPainter grayBoxPainter = null;
   static Class class$java$lang$String;
   static Class class$javax$swing$ImageIcon;
   static Class class$javax$swing$plaf$basic$BasicComboBoxUI;
   static Class class$sun$plugin$AppletViewer;

   public int getHeight() {
      String var1 = this.getParameter("height");
      return var1 != null ? Integer.valueOf(var1) : 0;
   }

   public int getLoadingStatus() {
      return this.status;
   }

   public int getWidth() {
      String var1 = this.getParameter("width");
      return var1 != null ? Integer.valueOf(var1) : 0;
   }

   public void appletDestroy() {
      this.appletDestroy(1000L);
   }

   public void appletInit() {
      this.addAppletListener(this.appletEventListener);
      String var1 = this.getParameter("cache_archive");
      String var2 = this.getParameter("cache_version");
      String var3 = this.getParameter("cache_archive_ex");
      URL var4 = this.getCodeBase();
      if (var4 != null) {
         try {
            HashMap var5 = JarCacheUtil.getJarsWithVersion(var1, var2, var3);
            if (!var5.isEmpty()) {
               JarCacheUtil.verifyJarVersions(var4, this.getClassLoaderCacheKey(), var5);
            }
         } catch (Exception var11) {
            Trace.printException(var11, ResourceHandler.getMessage("cache.error.text"), ResourceHandler.getMessage("cache.error.caption"));
         }

         this.cli = ClassLoaderInfo.find(var4, this.getClassLoaderCacheKey());
         this.cli.addReference();
         this.appletContext.addAppletPanelInContext(this);
         synchronized (class$sun$plugin$AppletViewer == null
            ? (class$sun$plugin$AppletViewer = class$("sun.plugin.AppletViewer"))
            : class$sun$plugin$AppletViewer) {
            super.init();
         }

         Thread var12 = this.getAppletHandlerThread();
         this.steam_the_cup = new Steamer(this);
         String var6 = this.getParameter("image");
         if (var6 != null) {
            this.steam_the_cup.setCustomImage(this.getCodeBase(), var6);
         }

         this.steam_the_cup.init();
         if (this.progress_bar_local) {
            ThreadGroupLocal.put(var12.getThreadGroup(), "javaplugin.progressTracking", Boolean.TRUE);
            ProgressTracker.addProgressListener(var12.getThreadGroup(), this);
            this.grayBoxPainter = new GrayBoxPainter(var12.getThreadGroup(), this);
            this.grayBoxPainter.start();
            this.appletProgress.init(this);
         }

         this.grayBoxListener = new AppletViewer.GrayBoxListener(this, this.userMsg);
         this.addMouseListener(this.grayBoxListener);
         Trace.msgPrintln("applet.progress.load");
         this.sendEvent(1);
         Trace.msgPrintln("applet.progress.init");
         this.sendEvent(2);
         synchronized (this.syncInit) {
            this.bInit = true;
         }
      }
   }

   public void appletStart() {
      synchronized (this.syncInit) {
         if (!this.bInit) {
            return;
         }
      }

      this.stopped = false;
      Trace.msgPrintln("applet.progress.start");
      this.sendEvent(3);
   }

   public void appletStop() {
      synchronized (this.syncInit) {
         if (!this.bInit) {
            return;
         }
      }

      if (this.status == 1) {
         Trace.msgPrintln("applet.progress.stoploading");
         this.stopLoading();
      }

      this.stopped = true;
      Trace.msgPrintln("applet.progress.stop");
      this.sendEvent(4);
   }

   public static void loadPropertiesFiles() {
      try {
         theUserPropertiesFile = new File(UserProfile.getPropertyFile());
         new File(theUserPropertiesFile.getParent()).mkdirs();
      } catch (Throwable var1) {
         Trace.printException(var1);
      }
   }

   public void preRefresh() {
      if (this.cli != null) {
         ClassLoaderInfo.markNotCachable(this.getCodeBase(), this.getClassLoaderCacheKey());
      }
   }

   public void setColorAndText() {
      Object var1 = null;
      String var2 = this.getParameter("boxbgcolor");
      if (var2 != null) {
         var1 = this.createColor("boxbgcolor", var2);
         if (var1 != null) {
            this.boxBGColor = (Color)var1;
         }
      }

      this.setBackground(this.boxBGColor);
      String var3 = this.getParameter("boxfgcolor");
      if (var3 != null) {
         var1 = this.createColor("boxfgcolor", var3);
         if (var1 != null) {
            this.boxFGColor = (Color)var1;
         }
      }

      String var4 = this.getParameter("progresscolor");
      if (var4 != null) {
         var1 = this.createColor("progresscolor", var4);
         if (var1 != null) {
            this.progressColor = (Color)var1;
         }
      }

      this.userMsg = this.getParameter("boxmessage");
      String var5 = this.getParameter("progressbar");
      if (var5 != null) {
         this.progress_bar_local = new Boolean(var5);
      }

      this.colorSet = true;
   }

   public boolean hasInitialFocus() {
      String var1 = this.getParameter("initial_focus");
      return var1 == null || !var1.toLowerCase().equals("false") && !var1.toLowerCase().equals("off") && !var1.equals("0");
   }

   public boolean isLegacyLifeCycle() {
      String var1 = this.getParameter("legacy_lifecycle");
      return var1 != null && var1.equalsIgnoreCase("true");
   }

   public boolean isStopped() {
      return this.stopped;
   }

   public static void initEnvironment(int var0) {
      if (!initialized) {
         initialized = true;
         JavaRunTime.getPluginThreadGroup();

         try {
            ProxyService.setProvider(new PluginProxyServiceProvider());
         } catch (Exception var15) {
         }

         ServiceProvider.setService(var0);

         try {
            if (class$javax$swing$ImageIcon == null) {
               class$javax$swing$ImageIcon = class$("javax.swing.ImageIcon");
            }

            if (class$javax$swing$plaf$basic$BasicComboBoxUI == null) {
               class$javax$swing$plaf$basic$BasicComboBoxUI = class$("javax.swing.plaf.basic.BasicComboBoxUI");
            }
         } catch (Throwable var14) {
         }

         try {
            JDK11ClassFileTransformer.init();
         } catch (Throwable var13) {
            var13.printStackTrace();
         }

         Properties var1 = new Properties(System.getProperties());
         var1.put("acl.read", "+");
         var1.put("acl.read.default", "");
         var1.put("acl.write", "+");
         var1.put("acl.write.default", "");
         var1.put("browser.version", theVersion);
         var1.put("browser.vendor", "Sun Microsystems, Inc.");
         var1.put("http.agent", "Mozilla/4.0 (" + System.getProperty("os.name") + " " + System.getProperty("os.version") + ")");
         var1.put("package.restrict.access.sun", "true");
         var1.put("package.restrict.access.netscape", "false");
         var1.put("package.restrict.definition.java", "true");
         var1.put("package.restrict.definition.sun", "true");
         var1.put("package.restrict.definition.netscape", "true");
         var1.put("java.version.applet", "true");
         var1.put("java.vendor.applet", "true");
         var1.put("java.vendor.url.applet", "true");
         var1.put("java.class.version.applet", "true");
         var1.put("os.name.applet", "true");
         var1.put("os.version.applet", "true");
         var1.put("os.arch.applet", "true");
         var1.put("file.separator.applet", "true");
         var1.put("path.separator.applet", "true");
         var1.put("line.separator.applet", "true");
         String var2 = var1.getProperty("java.protocol.handler.pkgs");
         if (var2 != null) {
            var1.put("java.protocol.handler.pkgs", var2 + "|sun.plugin.net.protocol");
         } else {
            var1.put("java.protocol.handler.pkgs", "sun.plugin.net.protocol");
         }

         URLConnection.setDefaultAllowUserInteraction(true);
         if (var1.get("https.protocols") == null) {
            var1.put("https.protocols", "SSLv3,SSLv2Hello");
         }

         var1.put("http.auth.serializeRequests", "true");
         Properties var3 = UserProfile.getConfigProperties();
         if (var3 != null) {
            try {
               Enumeration var4 = var3.propertyNames();

               while (var4.hasMoreElements()) {
                  String var5 = (String)var4.nextElement();
                  var1.put(var5, var3.getProperty(var5));
               }

               int var17 = 1;
               Object var21 = null;

               while (true) {
                  var21 = Security.getProperty("policy.url." + var17);
                  if (var21 == null) {
                     String var6 = var3.getProperty("deployment.system.security.policy");
                     String var7 = var3.getProperty("deployment.user.security.policy");
                     if (var6 != null) {
                        Security.setProperty("policy.url." + var17, var6);
                        var17++;
                     }

                     if (var7 != null) {
                        Security.setProperty("policy.url." + var17, var7);
                        var17++;
                     }
                     break;
                  }

                  var17++;
               }
            } catch (Exception var16) {
               var16.printStackTrace();
            }
         }

         try {
            FileInputStream var19 = new FileInputStream(theUserPropertiesFile);
            BufferedInputStream var23 = new BufferedInputStream(var19);
            var1.load(var23);
            var23.close();
            var19.close();
         } catch (Exception var12) {
         }

         String var20 = var1.getProperty("javaplugin.console", "hide");
         if ("show".equalsIgnoreCase(var20)) {
            JavaRunTime.showJavaConsole(true);
         } else if ("nothing".equalsIgnoreCase(var20)) {
            JavaRunTime.initTraceEnvironment();
         } else {
            BrowserService var24 = ServiceProvider.getService();
            if (var24.isConsoleIconifiedOnClose()) {
               JavaRunTime.showJavaConsole(false);
            } else {
               JavaRunTime.initTraceEnvironment();
            }
         }

         if ("true".equalsIgnoreCase(var1.getProperty("javaplugin.exception", "false"))) {
            fShowException = true;
         }

         String var25 = var1.getProperty("sun.net.client.defaultConnectTimeout", "120000");
         var1.put("sun.net.client.defaultConnectTimeout", var25);

         try {
            Class var26 = Class.forName("sun.misc.ExtensionDependency");
            if (var26 != null) {
               Class[] var29 = new Class[]{Class.forName("sun.misc.ExtensionInstallationProvider")};
               Method var8 = var26.getMethod("addExtensionInstallationProvider", var29);
               if (var8 != null) {
                  Object[] var9 = new Object[]{new ExtensionInstallationImpl()};
                  var8.invoke(null, var9);
               } else {
                  Trace.msgPrintln("optpkg.install.error.nomethod");
               }
            } else {
               Trace.msgPrintln("optpkg.install.error.noclass");
            }
         } catch (Throwable var11) {
            Trace.printException(var11);
         }

         var1.remove("proxyHost");
         var1.remove("proxyPort");
         var1.remove("http.proxyHost");
         var1.remove("http.proxyPort");
         var1.remove("https.proxyHost");
         var1.remove("https.proxyPort");
         var1.remove("ftpProxyHost");
         var1.remove("ftpProxyPort");
         var1.remove("ftpProxySet");
         var1.remove("gopherProxyHost");
         var1.remove("gopherProxyPort");
         var1.remove("gopherProxySet");
         var1.remove("socksProxyHost");
         var1.remove("socksProxyPort");
         if ("true".equalsIgnoreCase(var1.getProperty("javaplugin.proxy.authentication", "true"))) {
            ExAuthenticator.setDefault(new PluginAuthenticator());
         }

         System.setProperties(var1);
         System.out.println("");
         PluginProxyManager.reset();
         System.out.println("");
         JarCache.init();
         if (Trace.isEnabled()) {
            JavaRunTime.showSystemProperties();
         }

         System.out.println("");

         try {
            MimeTable var27 = MimeTable.getDefaultTable();
         } catch (Throwable var10) {
            Trace.printException(var10);
         }

         ActivatorSecurityManager var28 = new ActivatorSecurityManager();
         System.setSecurityManager(var28);
         JavaRunTime.showJavaConsoleHelp();
         URLJarFile.setCallBack(new PluginURLJarFileCallBack());
         if (System.getProperty("os.name").indexOf("Windows") != -1) {
            UpdateCheck.showDialog();
         }
      }
   }

   protected void onPrivateClose(int var1) {
      Trace.msgPrintln("applet.progress.destroy");
      this.sendEvent(5);
      Trace.msgPrintln("applet.progress.dispose");
      this.sendEvent(0);
      synchronized (this.appletQuitLock) {
         while (!this.readyToQuit) {
            try {
               this.appletQuitLock.wait();
            } catch (InterruptedException var5) {
            }
         }
      }

      Trace.msgPrintln("applet.progress.quit");
      this.sendEvent(6);
      this.appletContext = null;
   }

   public void setStatus(int var1) {
      this.status = var1;
   }

   public static void initEnvironment(int var0, long var1) {
      if (!initialized) {
         setStartTime(var1);
         initEnvironment(var0);
      }
   }

   public void appletDestroy(long var1) {
      synchronized (this.syncInit) {
         if (!this.bInit) {
            return;
         }
      }

      if (this.steam_the_cup != null) {
         this.steam_the_cup.destroy();
         this.steam_the_cup = null;
      }

      if (this.grayBoxPainter != null) {
         this.grayBoxPainter.interrupt();
         this.grayBoxPainter = null;
      }

      if (this.grayBoxListener != null) {
         this.removeMouseListener(this.grayBoxListener);
         this.grayBoxListener = null;
      }

      this.removeAppletListener(this.appletEventListener);
      this.appletEventListener = null;
      this.appletContext.removeAppletPanelFromContext(this);
      Thread var9 = this.getAppletHandlerThread();
      if (var9 != null && this.progress_bar_local) {
         ProgressTracker.removeProgressListener(var9.getThreadGroup(), this);
         ThreadGroupLocal.destroy(var9.getThreadGroup());
      }

      Trace.msgPrintln("applet.progress.findinfo.0");
      this.cli.removeReference();
      this.cli = null;
      Trace.msgPrintln("applet.progress.findinfo.1");
      AppletViewer$1 var4 = new AppletViewer$1(this);
      Thread var5 = new Thread(var4);
      var5.start();

      try {
         Trace.msgPrintln("applet.progress.joining");
         if (var9 != null) {
            var9.join(var1);
         }

         Trace.msgPrintln("applet.progress.joined");
      } catch (InterruptedException var7) {
      }
   }

   public static void setStartTime(long var0) {
      String var2 = System.getProperty("sun.perflog");
      if (var2 != null) {
         try {
            Class var3 = Class.forName("sun.misc.PerformanceLogger");
            if (var3 != null) {
               Class[] var4 = new Class[]{
                  class$java$lang$String == null ? (class$java$lang$String = class$("java.lang.String")) : class$java$lang$String, long.class
               };
               Method var5 = var3.getMethod("setStartTime", var4);
               if (var5 != null) {
                  Object[] var6 = new Object[]{"Java Plug-in load time", new Long(var0)};
                  var5.invoke(null, var6);
               }
            }
         } catch (Exception var7) {
         }
      }
   }

   public void setDoInit(boolean var1) {
      this.doInit = var1;
   }

   public Applet getApplet() {
      Applet var1 = super.getApplet();
      if (var1 != null) {
         return var1 instanceof BeansApplet ? null : var1;
      } else {
         return null;
      }
   }

   public AppletContext getAppletContext() {
      return this.appletContext;
   }

   public void setAppletContext(AppletContext var1) {
      if (var1 == null) {
         throw new IllegalArgumentException("AppletContext");
      } else {
         if (this.appletContext != null) {
            this.appletContext.removeAppletPanelFromContext(this);
         }

         this.appletContext = (PluginAppletContext)var1;
      }
   }

   public Color getForeground() {
      Color var1 = super.getForeground();
      if (null == var1) {
         var1 = Color.BLACK;
      }

      return var1;
   }

   public void paint(Graphics var1) {
      Dimension var2 = this.getSize();
      if (var2.width <= 0 || var2.height <= 0 || this.status != 1 && this.status != 2 && this.status != 7) {
         super.paint(var1);
      } else {
         this.paintForegrnd(var1);
      }
   }

   public void paintForegrnd(Graphics var1) {
      Dimension var2 = this.getSize();
      if (var2.width > 0 && var2.height > 0) {
         Image var3 = this.createImage(var2.width, var2.height);
         Graphics2D var4 = (Graphics2D)var3.getGraphics();
         var4.setRenderingHint(RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_ON);
         var4.setBackground(this.boxBGColor);
         var4.setColor(this.boxBGColor);
         var4.fillRect(0, 0, var2.width, var2.height);
         Font var5 = var4.getFont();
         var5 = var5.deriveFont(0, 10.0F);
         var4.setFont(var5);
         FontMetrics var6 = var4.getFontMetrics(var5);
         if (var2 != null && var6 != null && var2.width >= 36 && var2.height >= 36) {
            if (this.progress_bar_local) {
               var4.setColor(this.boxFGColor);
               Object var7 = null;
               if (this.userMsg != null) {
                  var7 = this.userMsg;
               } else {
                  var7 = this.getWaitingMessage();
               }

               var4.drawString((String)var7, (var2.width - var6.stringWidth((String)var7)) / 2, (var2.height + var6.getAscent()) / 2);
               var4.drawRect(
                  (int)(var2.width * 0.2), (var2.height + var6.getAscent()) / 2 + var6.getHeight() - 1, (int)(var2.width * 0.6), var6.getHeight() + 1
               );
               var4.setColor(this.progressColor);
               int var8 = 0;
               synchronized (this.appletProgress) {
                  var8 = (int)((var2.width * 0.6 - 1.0) * this.appletProgress.getProgress() / this.appletProgress.getProgressMax());
               }

               var4.fillRect((int)(var2.width * 0.2 + 1.0), (var2.height + var6.getAscent()) / 2 + var6.getHeight(), var8, var6.getHeight());
            } else {
               var4.setColor(this.boxBGColor);
               if (this.steam_the_cup != null) {
                  Image var14 = this.steam_the_cup.getCurrentImage();
                  if (var14 != null) {
                     Point var16 = this.steam_the_cup.getImgCoordinates();
                     var4.drawImage(var14, (int)var16.getX(), (int)var16.getY(), null);
                  }
               }
            }
         }

         var1.drawImage(var3, 0, 0, null);
         var4.dispose();
         var3.flush();
      }
   }

   public void update(Graphics var1) {
      Dimension var2 = this.getSize();
      if (var2.width <= 0 || var2.height <= 0 || this.status != 1 && this.status != 2 && this.status != 7) {
         super.update(var1);
      } else {
         this.paintForegrnd(var1);
      }
   }

   public void windowActivated(WindowEvent var1) {
   }

   public void windowClosed(WindowEvent var1) {
   }

   public void windowClosing(WindowEvent var1) {
   }

   public void windowDeactivated(WindowEvent var1) {
   }

   public void windowDeiconified(WindowEvent var1) {
   }

   public void windowIconified(WindowEvent var1) {
   }

   public void windowOpened(WindowEvent var1) {
   }

   protected void load(InputStream var1) {
      this.is = var1;
   }

   public Object getViewedObject() {
      Applet var1 = super.getApplet();
      return var1 instanceof BeansApplet ? ((BeansApplet)var1).bean : var1;
   }

   public void onProgressComplete(Object var1) {
      this.appletProgress.doOnFinish(var1);
      if (this.grayBoxPainter != null) {
         this.grayBoxPainter.repaint();
      }
   }

   public void onStartBinding(Object var1) {
      this.appletProgress.doOnStart(var1);
      if (this.grayBoxPainter != null) {
         this.grayBoxPainter.repaint();
      }

      if (this.preloading) {
         Trace.msgPrintln("progress_bar.preload", new Object[]{var1.toString().substring(var1.toString().lastIndexOf(47) + 1)});
      }
   }

   public void onStopBinding(Object var1) {
      this.onProgressComplete(var1);
   }

   public void onProgressAvailable(Object var1, int var2, int var3) {
      this.appletProgress.doOnProgress(var1, var2, var3);
      if (this.grayBoxPainter != null) {
         this.grayBoxPainter.repaint();
      }
   }

   public String getClassLoaderCacheKey() {
      String var1 = this.getParameter("classloader-policy");
      if (var1 != null && var1.equals("classic")) {
         return super.getClassLoaderCacheKey();
      } else {
         if (this.classLoaderCacheKey == null) {
            StringBuffer var2 = new StringBuffer();
            var2.append(this.getCodeBase());
            String var3 = this.getParameter("cache_archive");
            if (var3 != null) {
               var2.append(",");
               var2.append(var3);
            }

            var3 = this.getParameter("java_archive");
            if (var3 != null) {
               var2.append(",");
               var2.append(var3);
            }

            var3 = this.getParameter("archive");
            if (var3 != null) {
               var2.append(",");
               var2.append(var3);
            }

            this.classLoaderCacheKey = var2.toString();
         }

         return this.classLoaderCacheKey;
      }
   }

   public String getCode() {
      String var1 = this.getParameter("classid");
      String var2 = null;
      if (var1 != null) {
         int var3 = var1.indexOf("java:");
         if (var3 > -1) {
            var2 = var1.substring(5 + var3);
            if (var2 != null || !var2.equals("")) {
               return var2;
            }
         }
      }

      var2 = this.getParameter("java_code");
      if (var2 == null) {
         var2 = this.getParameter("code");
      }

      return var2;
   }

   protected String getHandledType() {
      return getMessage("java_applet");
   }

   public String getJarFiles() {
      String var1 = this.getParameter("archive");
      String var2 = this.getParameter("java_archive");
      String var3 = this.getParameter("cache_archive");
      String var4 = this.getParameter("cache_archive_ex");
      String var5 = null;
      if (var4 != null) {
         int var6 = var4.indexOf(";");
         if (var6 != -1) {
            var5 = JarCacheUtil.getJarsInCacheArchiveEx(var4);
         } else {
            var5 = var4;
         }
      }

      return this.addJarFileToPath(var5, this.addJarFileToPath(var3, this.addJarFileToPath(var2, var1)));
   }

   public String getName() {
      String var1 = this.getParameter("name");
      if (var1 != null) {
         return var1;
      } else {
         var1 = this.getCode();
         if (var1 != null) {
            int var2 = var1.lastIndexOf(".class");
            if (var2 != -1) {
               var1 = var1.substring(0, var2);
            }
         } else {
            var1 = this.getSerializedObject();
            if (var1 != null) {
               int var4 = var1.lastIndexOf(".ser");
               if (var4 != -1) {
                  var1 = var1.substring(0, var4);
               }
            }
         }

         return var1;
      }
   }

   public String getSerializedObject() {
      String var1 = this.getParameter("java_object");
      if (var1 == null) {
         var1 = this.getParameter("object");
      }

      return var1;
   }

   public String getWaitingMessage() {
      if (this.status == 7) {
         return getMessage("failed");
      } else {
         MessageFormat var1 = new MessageFormat(getMessage("loading"));
         return var1.format(new Object[]{this.getHandledType()});
      }
   }

   public static int getAcceleratorKey(String var0) {
      return ResourceHandler.getAcceleratorKey(var0);
   }

   public void setDocumentBase(String var1) {
      if (!this.docbaseInit) {
         String var2 = URLUtil.canonicalize(var1);

         try {
            this.documentURL = new URL(this.canonicalizeDocumentURL(var2));
         } catch (Throwable var6) {
            var6.printStackTrace();
         }

         this.docbaseInit = true;
         synchronized (this.docBaseSyncObj) {
            this.docBaseSyncObj.notifyAll();
         }
      }
   }

   public void showAppletLog(String var1) {
      super.showAppletLog(var1);
   }

   public void showAppletStatus(String var1) {
      if (var1 != null && !var1.equals("") && !var1.equals("\n")) {
         try {
            String var2 = this.getName();
            MessageFormat var3 = new MessageFormat(getMessage("status_applet"));
            if (var2 != null && !var1.equals("")) {
               this.getAppletContext().showStatus(var3.format(new Object[]{var2, var1}));
            } else {
               this.getAppletContext().showStatus(var3.format(new Object[]{var1, ""}));
            }

            if ((this.status == 3 || this.status == 7) && this.grayBoxPainter != null) {
               this.grayBoxPainter.interrupt();
               this.grayBoxPainter = null;
            }

            if (this.steam_the_cup != null) {
               if (this.status == 7) {
                  this.steam_the_cup.error();
               } else if (this.status >= 3) {
                  this.steam_the_cup.stop();
               }
            }

            if (this.statusListener != null) {
               this.statusListener.statusChanged(this.status);
            }
         } catch (Throwable var4) {
            var4.printStackTrace();
         }
      }
   }

   public void showStatusText(String var1) {
      this.getAppletContext().showStatus(var1);
   }

   protected void showAppletException(Throwable var1) {
      super.showAppletException(var1);
      Trace.msgPrintln("exception", new Object[]{var1.toString()});
      if (fShowException) {
         Trace.printException(var1);
      }

      if (this.steam_the_cup != null) {
         this.steam_the_cup.error();
      }
   }

   public URL getCodeBase() {
      Object var1 = new Object();
      synchronized (var1) {
         if (!this.codeBaseInit) {
            String var3 = this.getParameter("java_codebase");
            if (var3 == null) {
               var3 = this.getParameter("codebase");
            }

            URL var4 = this.getDocumentBase();
            if (var4 == null) {
               return null;
            }

            if (var3 != null) {
               if (!var3.equals(".") && !var3.endsWith("/")) {
                  var3 = var3 + "/";
               }

               var3 = URLUtil.canonicalize(var3);

               try {
                  this.baseURL = new URL(var4, var3);
               } catch (MalformedURLException var10) {
               }
            }

            if (this.baseURL == null) {
               String var5 = var4.toString();
               int var6 = var5.lastIndexOf(47);
               if (var6 > -1 && var6 < var5.length() - 1) {
                  try {
                     this.baseURL = new URL(URLUtil.canonicalize(var5.substring(0, var6 + 1)));
                  } catch (MalformedURLException var9) {
                  }
               }

               if (this.baseURL == null) {
                  this.baseURL = var4;
               }
            }

            this.codeBaseInit = true;
         }
      }

      return this.baseURL;
   }

   public URL getDocumentBase() {
      Object var1 = new Object();
      synchronized (var1) {
         if (!this.docbaseInit) {
            BrowserService var3 = ServiceProvider.getService();
            if (var3.isNetscape() && var3.getBrowserVersion() >= 5.0F) {
               try {
                  synchronized (this.docBaseSyncObj) {
                     while (!this.docbaseInit) {
                        this.docBaseSyncObj.wait(0L);
                     }
                  }
               } catch (InterruptedException var11) {
                  var11.printStackTrace();
               }
            } else {
               JSContext var4 = (JSContext)this.getAppletContext();

               try {
                  JSObject var5 = var4.getJSObject();
                  if (var5 == null) {
                     throw new JSException("Unable to obtain Window object");
                  }

                  JSObject var6 = (JSObject)var5.getMember("document");
                  if (var6 == null) {
                     throw new JSException("Unable to obtain Document object");
                  }

                  String var7 = (String)var6.getMember("URL");
                  String var8 = URLUtil.canonicalize(var7);
                  this.documentURL = new URL(this.canonicalizeDocumentURL(var8));
               } catch (Throwable var12) {
                  Trace.println(var12.getMessage());
                  return null;
               }

               this.docbaseInit = true;
            }
         }
      }

      return this.documentURL;
   }

   protected void loadJarFiles(AppletClassLoader var1) throws IOException, InterruptedException {
      if (this.loading_first_time) {
         this.loading_first_time = false;
         String var2 = this.getParameter("cache_archive_ex");

         try {
            if (var2 != null) {
               this.preloading = true;
               JarCacheUtil.preload(this.getCodeBase(), var2);
               this.preloading = false;
            }
         } catch (Exception var8) {
            Trace.printException(var8, ResourceHandler.getMessage("cache.error.text"), ResourceHandler.getMessage("cache.error.caption"));
         }
      }

      String var10 = this.getJarFiles();

      try {
         this.cli.lock();
         if (!this.cli.getLocalJarsLoaded() && var1 instanceof PluginClassLoader) {
            this.loadLocalJarFiles((PluginClassLoader)var1);
            this.cli.setLocalJarsLoaded(true);
         }

         if (var10 != null) {
            StringTokenizer var3 = new StringTokenizer(var10, ",", false);

            while (var3.hasMoreTokens()) {
               String var4 = var3.nextToken().trim();
               if (!this.cli.hasJar(var4)) {
                  this.cli.addJar(var4);
               }
            }

            super.loadJarFiles(var1);
            return;
         }
      } finally {
         this.cli.unlock();
      }
   }

   public void addAppletStatusListener(AppletStatusListener var1) {
      this.statusListener = var1;
   }

   public void removeAppletStatusListener(AppletStatusListener var1) {
      this.statusListener = null;
   }

   private void loadLocalJarFiles(PluginClassLoader var1) {
      String var2 = File.separator;
      String var3 = System.getProperty("java.home") + var2 + "lib" + var2 + "applet";
      File var4 = new File(var3);
      if (var4.exists()) {
         String[] var5 = var4.list(new AppletViewer$2(this));

         for (int var6 = 0; var6 < var5.length; var6++) {
            try {
               URL var7 = new File(var3 + var2 + var5[var6]).toURL();
               var1.addLocalJar(var7);
            } catch (MalformedURLException var8) {
               var8.printStackTrace();
            }
         }
      }
   }

   protected Applet createApplet(AppletClassLoader var1) throws ClassNotFoundException, IllegalAccessException, IOException, InstantiationException, InterruptedException {
      if (this.is == null) {
         return super.createApplet(var1);
      } else {
         AppletObjectInputStream var2 = new AppletObjectInputStream(this.is, var1);
         Object var3 = var2.readObject();
         Applet var4 = (Applet)var3;
         this.doInit = false;
         if (Thread.interrupted()) {
            try {
               this.status = 0;
               Object var8 = null;
               this.showAppletStatus("death");
            } finally {
               Thread.currentThread().interrupt();
            }

            return null;
         } else {
            this.is = null;
            return var4;
         }
      }
   }

   static Class class$(String var0) {
      try {
         return Class.forName(var0);
      } catch (ClassNotFoundException var2) {
         throw new NoClassDefFoundError().initCause(var2);
      }
   }

   public void setParameter(String var1, Object var2) {
      var1 = var1.toLowerCase(Locale.ENGLISH);
      synchronized (this.atts) {
         this.atts.put(var1, this.trimWhiteSpaces(var2.toString()));
      }
   }

   public String canonicalizeDocumentURL(String var1) {
      int var2 = -1;
      int var4 = var1.indexOf(35);
      int var5 = var1.indexOf(63);
      if (var5 != -1 && var4 != -1) {
         var2 = Math.min(var4, var5);
      } else if (var4 != -1) {
         var2 = var4;
      } else if (var5 != -1) {
         var2 = var5;
      }

      String var6;
      if (var2 == -1) {
         var6 = var1;
      } else {
         var6 = var1.substring(0, var2);
      }

      StringBuffer var7 = new StringBuffer(var6);
      int var8 = var7.toString().indexOf("|");
      if (var8 >= 0) {
         var7.setCharAt(var8, ':');
      }

      if (var2 != -1) {
         var7.append(var1.substring(var2));
      }

      return var7.toString();
   }

   public static String getMessage(String var0) {
      return ResourceHandler.getMessage(var0);
   }

   public String getParameter(String var1) {
      var1 = var1.toLowerCase(Locale.ENGLISH);
      synchronized (this.atts) {
         String var3 = (String)this.atts.get(var1);
         if (var3 != null) {
            var3 = this.trimWhiteSpaces(var3);
         }

         return var3;
      }
   }

   private String trimWhiteSpaces(String var1) {
      if (var1 == null) {
         return var1;
      } else {
         StringBuffer var2 = new StringBuffer();

         for (int var3 = 0; var3 < var1.length(); var3++) {
            char var4 = var1.charAt(var3);
            if (var4 != '\n' && var4 != '\f' && var4 != '\r' && var4 != '\t') {
               var2.append(var4);
            }
         }

         return var2.toString().trim();
      }
   }

   public static String[] getMessageArray(String var0) {
      return ResourceHandler.getMessageArray(var0);
   }

   protected AppletClassLoader createClassLoader(URL var1) {
      return ClassLoaderInfo.find(var1, this.getClassLoaderCacheKey()).getLoader();
   }

   private Color createColor(String var1, String var2) {
      if (var2 != null && var2.indexOf(",") != -1) {
         StringTokenizer var3 = new StringTokenizer(var2, ",");
         if (var3.countTokens() == 3) {
            int var4 = 0;
            int var5 = 0;
            int var6 = 0;

            int var7;
            for (var7 = 0; var3.hasMoreTokens(); var4++) {
               String var8 = (String)var3.nextElement();
               switch (var4) {
                  case 0:
                     if (!var8.trim().equals("")) {
                        var5 = new Integer(var8.trim());
                     }
                     break;
                  case 1:
                     if (!var8.trim().equals("")) {
                        var6 = new Integer(var8.trim());
                     }
                     break;
                  case 2:
                     if (!var8.trim().equals("")) {
                        var7 = new Integer(var8.trim());
                     }
               }
            }

            return new Color(var5, var6, var7);
         } else {
            Trace.msgPrintln("applet_viewer.color_tag", new Object[]{var1});
            return null;
         }
      } else {
         if (var2 != null) {
            try {
               return Color.decode(var2);
            } catch (NumberFormatException var9) {
               if (var2.equalsIgnoreCase("red")) {
                  return Color.red;
               }

               if (var2.equalsIgnoreCase("yellow")) {
                  return Color.yellow;
               }
            }

            if (var2.equalsIgnoreCase("black")) {
               return Color.black;
            }

            if (var2.equalsIgnoreCase("blue")) {
               return Color.blue;
            }

            if (var2.equalsIgnoreCase("cyan") || var2.equalsIgnoreCase("aqua")) {
               return Color.cyan;
            }

            if (var2.equalsIgnoreCase("darkGray")) {
               return Color.darkGray;
            }

            if (var2.equalsIgnoreCase("gray")) {
               return Color.gray;
            }

            if (var2.equalsIgnoreCase("lightGray") || var2.equalsIgnoreCase("silver")) {
               return Color.lightGray;
            }

            if (var2.equalsIgnoreCase("green") || var2.equalsIgnoreCase("lime")) {
               return Color.green;
            }

            if (var2.equalsIgnoreCase("magenta") || var2.equalsIgnoreCase("fuchsia")) {
               return Color.magenta;
            }

            if (var2.equalsIgnoreCase("orange")) {
               return Color.orange;
            }

            if (var2.equalsIgnoreCase("pink")) {
               return Color.pink;
            }

            if (var2.equalsIgnoreCase("white")) {
               return Color.white;
            }

            if (var2.equalsIgnoreCase("maroon")) {
               return new Color(128, 0, 0);
            }

            if (var2.equalsIgnoreCase("purple")) {
               return new Color(128, 0, 128);
            }

            if (var2.equalsIgnoreCase("navy")) {
               return new Color(0, 0, 128);
            }

            if (var2.equalsIgnoreCase("teal")) {
               return new Color(0, 128, 128);
            }

            if (var2.equalsIgnoreCase("olive")) {
               return new Color(128, 128, 0);
            }
         }

         return null;
      }
   }

   private String addJarFileToPath(String var1, String var2) {
      if (var1 == null && var2 == null) {
         return null;
      } else if (var1 == null && var2 != null) {
         return var2;
      } else {
         return var1 != null && var2 == null ? var1 : var1 + "," + var2;
      }
   }

   private static class AppletEventListener implements AppletListener {
      private AppletEventListener() {
      }

      public void appletStateChanged(AppletEvent var1) {
         switch (var1.getID()) {
            case 51234:
               AppletViewer var2 = (AppletViewer)var1.getSource();
               if (var2 != null) {
                  Object var3 = var2.getViewedObject();
                  if (var3 instanceof Component) {
                     var2.setSize(var2.getSize());
                     ((Component)var3).setSize(var2.getSize());
                     var2.validate();
                  }
               }
         }
      }

      AppletEventListener(AppletViewer$1 var1) {
         this();
      }
   }

   static class GrayBoxListener implements MouseListener, ActionListener {
      private PopupMenu popup;
      private MenuItem open_console;
      private MenuItem about_java;
      private String msg = null;
      private AppletViewer av;

      private PopupMenu getPopupMenu() {
         if (this.popup == null) {
            Font var1 = this.av.getFont();
            Font var2 = var1.deriveFont(11.0F);
            this.popup = new PopupMenu();
            this.open_console = new MenuItem(ResourceHandler.getMessage("usability.menu.open_console"));
            this.open_console.setFont(var2);
            this.about_java = new MenuItem(ResourceHandler.getMessage("usability.menu.about_java"));
            this.about_java.setFont(var2);
            this.open_console.addActionListener(this);
            this.about_java.addActionListener(this);
            this.popup.add(this.open_console);
            this.popup.add("-");
            this.popup.add(this.about_java);
            this.av.add(this.popup);
         }

         return this.popup;
      }

      public void actionPerformed(ActionEvent var1) {
         if (var1.getSource() == this.open_console) {
            JavaRunTime.showJavaConsoleLater(true);
         } else if (var1.getSource() == this.about_java) {
            DialogFactory.showAboutPluginDialog();
         }
      }

      public void mouseClicked(MouseEvent var1) {
      }

      public void mouseEntered(MouseEvent var1) {
         if (this.msg != null) {
            this.av.showStatusText(this.msg);
         } else {
            this.av.showStatusText(this.av.getWaitingMessage());
         }
      }

      public void mouseExited(MouseEvent var1) {
      }

      public void mousePressed(MouseEvent var1) {
         if (var1.isPopupTrigger() && this.av.getLoadingStatus() == 7) {
            this.getPopupMenu().show(var1.getComponent(), var1.getX(), var1.getY());
         }
      }

      public void mouseReleased(MouseEvent var1) {
         if (var1.isPopupTrigger() && this.av.getLoadingStatus() == 7) {
            this.getPopupMenu().show(var1.getComponent(), var1.getX(), var1.getY());
         }
      }

      GrayBoxListener(AppletViewer var1, String var2) {
         this.msg = var2;
         this.av = var1;
      }
   }
}
