package sun.plugin;

import java.io.BufferedOutputStream;
import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.OutputStream;
import java.io.PrintStream;
import java.util.Properties;
import sun.plugin.util.PluginSysUtil;
import sun.plugin.util.UserProfile;

public class JavaRunTime {
   private static OutputStream traceStream = null;
   private static MainConsoleWriter mainWriter = null;
   private static boolean traceInit = false;

   public static synchronized void initTraceEnvironment() {
      if (!traceInit) {
         traceInit = true;
         mainWriter = new MainConsoleWriter(getTraceOutputStream());
         DebugOutputStream var0 = new DebugOutputStream(mainWriter);
         PrintStream var1 = new PrintStream(var0, true);
         System.setErr(var1);
         DebugOutputStream var2 = new DebugOutputStream(mainWriter);
         PrintStream var3 = new PrintStream(var2, true);
         System.setOut(var3);
         String var4 = ConsoleWindow.displayVersion();
         System.out.print(var4);
      }
   }

   public static void showJavaConsoleHelp() {
      initTraceEnvironment();
      String var0 = ConsoleWindow.displayHelp();
      System.out.print(var0);
   }

   public static void showSystemProperties() {
      initTraceEnvironment();
      ConsoleWindow.displaySystemProperties();
   }

   public static boolean isJavaConsoleVisible() {
      ConsoleWindow var0 = getJavaConsole();
      return var0 != null ? var0.isConsoleVisible() : false;
   }

   public static void showJavaConsole(boolean var0) {
      ConsoleWindow var1 = getJavaConsole();
      if (var1 != null) {
         try {
            PluginSysUtil.invokeAndWait(new JavaRunTime$1(var1, var0));
         } catch (Throwable var3) {
            var3.printStackTrace();
         }
      }
   }

   public static void showJavaConsoleLater(boolean var0) {
      ConsoleWindow var1 = getJavaConsole();
      if (var1 != null) {
         try {
            PluginSysUtil.invokeLater(new JavaRunTime$2(var1, var0));
         } catch (Throwable var3) {
            var3.printStackTrace();
         }
      }
   }

   public static OutputStream getTraceOutputStream() {
      if (traceStream != null) {
         return traceStream;
      } else {
         try {
            File var0 = new File(UserProfile.getTraceFile());
            if (var0.exists()) {
               var0.delete();
            }

            traceStream = new BufferedOutputStream(new FileOutputStream(var0));
         } catch (IOException var1) {
            var1.printStackTrace();
         }

         return traceStream;
      }
   }

   public static native String dumpAllStacks();

   public static void printToJavaConsole(String var0) {
      ConsoleWindow var1 = getJavaConsole();
      if (var1 != null) {
         var1.append(var0);
      }
   }

   public static synchronized ThreadGroup getPluginThreadGroup() {
      return PluginSysUtil.getPluginThreadGroup();
   }

   public static synchronized ConsoleWindow getJavaConsole() {
      initTraceEnvironment();
      return mainWriter.getJavaConsole();
   }

   protected static void initEnvironment(String var0, String var1, String var2) {
      Properties var3 = System.getProperties();
      var3.put("java.home", var0);
      if (var2 == null) {
         var3.put("user.home", var0);
      } else {
         var3.put("user.home", var2);
      }

      AppletViewer.loadPropertiesFiles();
   }
}
