package sun.plugin;

import java.io.ByteArrayOutputStream;
import java.io.OutputStream;
import java.util.LinkedList;
import sun.plugin.util.PluginSysUtil;

public class MainConsoleWriter implements Runnable {
   private LinkedList queue = new LinkedList();
   private ByteArrayOutputStream consoleBuffer = null;
   private OutputStream traceOutputStream;
   private ConsoleWindow console = null;
   private Object consoleSyncObject = new Object();
   static final boolean $assertionsDisabled = !(MainConsoleWriter.class$sun$plugin$MainConsoleWriter == null
         ? (MainConsoleWriter.class$sun$plugin$MainConsoleWriter = class$("sun.plugin.MainConsoleWriter"))
         : MainConsoleWriter.class$sun$plugin$MainConsoleWriter)
      .desiredAssertionStatus();
   static Class class$sun$plugin$MainConsoleWriter;

   public void run() {
      while (true) {
         byte[] var1 = null;

         try {
            synchronized (this.queue) {
               if (this.queue.size() > 0) {
                  var1 = (byte[])this.queue.remove(0);
               } else {
                  this.queue.wait();
               }
            }

            if (var1 != null) {
               this.trace(var1);
            }
         } catch (InterruptedException var5) {
         }
      }
   }

   public void enQueue(byte[] var1) {
      try {
         synchronized (this.queue) {
            this.queue.addLast(var1);
            this.queue.notifyAll();
         }
      } catch (Exception var5) {
         this.writeToConsole(var5.toString());
      }
   }

   private void trace(byte[] var1) {
      try {
         this.writeToConsole(var1);
         this.traceOutputStream.write(var1);
         this.traceOutputStream.flush();
      } catch (Exception var3) {
         this.console.append(var3.toString());
      }
   }

   private void writeToConsole(byte[] var1) {
      synchronized (this.consoleSyncObject) {
         if (this.console != null) {
            this.console.append(new String(var1));
         } else {
            if (this.consoleBuffer == null) {
               this.consoleBuffer = new ByteArrayOutputStream();
            }

            this.consoleBuffer.write(var1, 0, var1.length);
         }
      }
   }

   MainConsoleWriter(OutputStream var1) {
      this.console = null;
      this.traceOutputStream = var1;
      Thread var2 = PluginSysUtil.createPluginSysThread(this, "Main Console Writer");
      var2.setDaemon(false);
      var2.setPriority(6);
      var2.start();
   }

   private void writeToConsole(String var1) {
      this.writeToConsole(var1.getBytes());
   }

   ConsoleWindow getJavaConsole() {
      synchronized (this.consoleSyncObject) {
         if (this.console == null) {
            try {
               this.console = (ConsoleWindow)PluginSysUtil.execute(new MainConsoleWriter$1(this));
            } catch (Exception var4) {
               if (!$assertionsDisabled) {
                  throw new AssertionError();
               }

               return null;
            }

            if (this.consoleBuffer != null) {
               byte[] var2 = this.consoleBuffer.toByteArray();
               this.console.append(new String(var2));
               this.consoleBuffer = null;
            }
         }

         return this.console;
      }
   }

   static Class class$(String var0) {
      try {
         return Class.forName(var0);
      } catch (ClassNotFoundException var2) {
         throw new NoClassDefFoundError().initCause(var2);
      }
   }
}
