package sun.plugin.cache;

import java.io.File;
import java.security.PrivilegedAction;
import sun.plugin.util.UserProfile;

class JarCache$1 implements PrivilegedAction {
   public Object run() {
      Cache.init();
      if (!Cache.cachingDisabled) {
         JarCache.directory = null;
         String var1 = UserProfile.getJarCacheDirectory();
         if (var1 != null) {
            JarCache.directory = new File(var1.trim());
         }

         boolean var2 = false;
         if (JarCache.directory != null) {
            var2 = JarCache.directory.exists();
            if (!var2) {
               var2 = JarCache.directory.mkdirs();
               if (!var2) {
                  Cache.msgPrintln("cache.create_warning", new Object[]{JarCache.directory});
               }
            } else if (!JarCache.directory.canRead()) {
               var2 = false;
               Cache.msgPrintln("cache.read_warning", new Object[]{JarCache.directory});
            } else if (!JarCache.directory.canWrite()) {
               var2 = false;
               Cache.msgPrintln("cache.write_warning", new Object[]{JarCache.directory});
            } else if (!JarCache.directory.isDirectory()) {
               var2 = false;
               Cache.msgPrintln("cache.directory_warning", new Object[]{JarCache.directory});
            }
         }

         if (var2) {
            Cache.createTable(JarCache.directory, JarCache.filesInCache);
            var1 = System.getProperty("javaplugin.cache.compression", "0");
            var1.trim();

            try {
               JarCache.compression = Integer.valueOf(var1);
               if (JarCache.compression < 0 || JarCache.compression > 9) {
                  JarCache.compression = 0;
               }
            } catch (NumberFormatException var4) {
               JarCache.compression = 0;
            }

            Cache.msgPrintln("cache.compression", new Object[]{String.valueOf(JarCache.compression)});
         }
      }

      return null;
   }
}
