package sun.plugin.cache;

import javax.swing.table.DefaultTableColumnModel;

public class JarCacheTableColumnModel extends DefaultTableColumnModel {
   public static final boolean VISIBLE = true;
   public static final boolean HIDDEN = false;
   public static final boolean LEFT_ALIGNED = true;
   public static final boolean RIGHT_ALIGNED = false;
   public static final boolean ASCENDING = true;
   public static final boolean DESCENDING = false;
   private JarCacheTableColumn nameColumn = new JarCacheTableColumn(JarCacheEntry.NAME, JarCacheEntry.NAME_HELP, true);
   private JarCacheTableColumn typeColumn = new JarCacheTableColumn(JarCacheEntry.TYPE, JarCacheEntry.TYPE_HELP, true);
   private JarCacheTableColumn sizeColumn = new JarCacheTableColumn(JarCacheEntry.SIZE, JarCacheEntry.SIZE_HELP, true);
   private JarCacheTableColumn expiryColumn = new JarCacheTableColumn(JarCacheEntry.EXPIRY_DATE, JarCacheEntry.EXPIRY_DATE_HELP, true);
   private JarCacheTableColumn modifyColumn = new JarCacheTableColumn(JarCacheEntry.MODIFY_DATE, JarCacheEntry.MODIFY_DATE_HELP, true);
   private JarCacheTableColumn versionColumn = new JarCacheTableColumn(JarCacheEntry.VERSION, JarCacheEntry.VERSION_HELP, true);
   private JarCacheTableColumn urlColumn = new JarCacheTableColumn(JarCacheEntry.URL, JarCacheEntry.URL_HELP, false);
   private JarCacheTableColumn[] tableColumns = new JarCacheTableColumn[]{
      this.nameColumn, this.typeColumn, this.sizeColumn, this.expiryColumn, this.modifyColumn, this.versionColumn, this.urlColumn
   };

   public JarCacheTableColumnModel() {
      for (int var1 = 0; var1 < this.tableColumns.length; var1++) {
         this.addColumn(this.tableColumns[var1]);
      }
   }

   public String[] getColumnNames() {
      String[] var1 = new String[this.tableColumns.length];

      for (int var2 = 0; var2 < var1.length; var2++) {
         var1[var2] = this.tableColumns[var2].getHeaderValue().toString();
      }

      return var1;
   }

   public JarCacheTableColumn[] getColumnArray() {
      return this.tableColumns;
   }
}
