package sun.plugin.cache;

import java.text.MessageFormat;
import java.util.LinkedList;
import javax.swing.table.AbstractTableModel;
import sun.plugin.resources.ResourceHandler;
import sun.plugin.util.DialogFactory;

public class JarCacheTableModel extends AbstractTableModel {
   private LinkedList list = JarCacheEntry.getEntries();
   protected Object[] tableRows = this.list.toArray();
   private String[] columnNames;

   public int getColumnCount() {
      return this.columnNames.length;
   }

   public int getRowCount() {
      return this.list.size();
   }

   public void refresh() {
      this.list = JarCacheEntry.getEntries();
      this.tableRows = this.list.toArray();
   }

   public void removeRows(int[] var1) {
      if (var1.length > 0) {
         for (int var2 = 0; var2 < var1.length; var2++) {
            JarCacheEntry var3 = (JarCacheEntry)this.tableRows[var1[var2]];
            if (var3.delete()) {
               int var4 = this.list.indexOf(this.tableRows[var1[var2]]);
               this.list.remove(var4);
            } else {
               String var7 = ResourceHandler.getMessage("cache_viewer.delete.text");
               String var5 = ResourceHandler.getMessage("cache_viewer.delete.caption");
               MessageFormat var6 = new MessageFormat(var7);
               var7 = var6.format(new Object[]{var3.getName()});
               DialogFactory.showErrorDialog(var7, var5);
            }
         }

         this.tableRows = this.list.toArray();
      }
   }

   public Object getValueAt(int var1, int var2) {
      Object var3 = null;
      if (var1 < this.getRowCount() && var2 < this.getColumnCount()) {
         JarCacheEntry var4 = (JarCacheEntry)this.tableRows[var1];
         var3 = var4.getDisplayValue(this.columnNames[var2]);
      }

      return var3;
   }

   public String getColumnName(int var1) {
      return var1 < this.columnNames.length ? this.columnNames[var1] : null;
   }

   public JarCacheTableModel(String[] var1) {
      this.columnNames = var1;
   }
}
