package sun.plugin.cache;

import java.awt.Container;
import java.awt.FlowLayout;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import sun.plugin.resources.ResourceHandler;
import sun.plugin.util.UserProfile;

public class JarCacheViewer extends JDialog {
   private JarCacheTable viewerTable;
   private static String cacheLocation;

   public static String getPluginCacheLocation() {
      return cacheLocation != null ? cacheLocation : UserProfile.getPluginCacheDirectory();
   }

   public JarCacheViewer(String var1) {
      if (var1 != null) {
         cacheLocation = var1;
      }

      Container var2 = this.getContentPane();
      this.setTitle(ResourceHandler.getMessage("cache_viewer.caption"));
      this.setModal(true);
      this.viewerTable = new JarCacheTable();
      JScrollPane var3 = new JScrollPane(this.viewerTable);
      var2.add(var3, "Center");
      JPanel var4 = new JPanel();
      var4.setLayout(new FlowLayout(1));
      JButton var5 = new JButton(ResourceHandler.getMessage("cache_viewer.refresh"));
      JButton var6 = new JButton(ResourceHandler.getMessage("cache_viewer.remove"));
      JButton var7 = new JButton(ResourceHandler.getMessage("cache_viewer.close"));
      var5.setMnemonic(ResourceHandler.getAcceleratorKey("cache_viewer.refresh"));
      var6.setMnemonic(ResourceHandler.getAcceleratorKey("cache_viewer.remove"));
      var7.setMnemonic(ResourceHandler.getAcceleratorKey("cache_viewer.close"));
      var4.setLayout(new FlowLayout(2));
      var4.add(var5);
      var4.add(var6);
      var4.add(var7);
      var2.add(var4, "South");
      this.addWindowListener(new JarCacheViewer$1(this));
      JarCacheViewer$2 var8 = new JarCacheViewer$2(this);
      JarCacheViewer$3 var9 = new JarCacheViewer$3(this);
      JarCacheViewer$4 var10 = new JarCacheViewer$4(this);
      var5.addActionListener(var8);
      var6.addActionListener(var9);
      var7.addActionListener(var10);
      this.getRootPane().addComponentListener(new JarCacheViewer$5(this));
      this.setSize(800, 400);
      this.setVisible(true);
   }

   public static void main(String[] var0) {
      new JarCacheViewer(var0[0]);
   }

   static JarCacheTable access$000(JarCacheViewer var0) {
      return var0.viewerTable;
   }
}
