package sun.plugin.dom;

import org.w3c.dom.DOMException;
import org.w3c.dom.Document;
import org.w3c.dom.DocumentType;
import org.w3c.dom.css.CSSStyleSheet;
import org.w3c.dom.css.DOMImplementationCSS;
import org.w3c.dom.html.HTMLDOMImplementation;
import org.w3c.dom.html.HTMLDocument;
import sun.plugin.dom.exception.NotSupportedException;

public class DOMImplementation implements org.w3c.dom.DOMImplementation, HTMLDOMImplementation, DOMImplementationCSS {
   public boolean hasFeature(String var1, String var2) {
      if (var1 == null) {
         return false;
      } else {
         if (var2 == null) {
            var2 = "2.0";
         }

         return var2.equals("2.0")
            && (
               var1.equalsIgnoreCase("dom")
                  || var1.equalsIgnoreCase("xml")
                  || var1.equalsIgnoreCase("html")
                  || var1.equalsIgnoreCase("stylesheets")
                  || var1.equalsIgnoreCase("views")
                  || var1.equalsIgnoreCase("css")
            );
      }
   }

   public HTMLDocument createHTMLDocument(String var1) {
      throw new NotSupportedException("HTMLDOMImplementation.createHTMLDocument() is not supported");
   }

   public CSSStyleSheet createCSSStyleSheet(String var1, String var2) throws DOMException {
      throw new NotSupportedException("DOMImplementationCSS.createCSSStyleSheet() is not supported");
   }

   public Document createDocument(String var1, String var2, DocumentType var3) throws DOMException {
      throw new NotSupportedException("DOMImplementation.createDocument() is not supported");
   }

   public DocumentType createDocumentType(String var1, String var2, String var3) throws DOMException {
      throw new NotSupportedException("DOMImplementation.createDocumentType() is not supported");
   }
}
