package sun.plugin.dom.core;

import org.w3c.dom.DOMException;
import sun.plugin.dom.DOMObject;
import sun.plugin.dom.DOMObjectHelper;

final class Attr extends Node implements org.w3c.dom.Attr {
   private Document doc;

   public short getNodeType() {
      return 2;
   }

   public boolean getSpecified() {
      return DOMObjectHelper.getBooleanMemberNoEx(this.obj, "specified");
   }

   public String getName() {
      return DOMObjectHelper.getStringMemberNoEx(this.obj, "name");
   }

   public String getNodeName() {
      return this.getName();
   }

   public String getNodeValue() throws DOMException {
      return this.getValue();
   }

   public String getValue() {
      return DOMObjectHelper.getStringMemberNoEx(this.obj, "value");
   }

   public void setNodeValue(String var1) throws DOMException {
      this.setValue(var1);
   }

   public void setValue(String var1) throws DOMException {
      DOMObjectHelper.setStringMember(this.obj, "value", var1);
   }

   public org.w3c.dom.Document getOwnerDocument() {
      return this.doc;
   }

   public org.w3c.dom.Element getOwnerElement() {
      return null;
   }

   public Attr(DOMObject var1, Document var2) {
      super(1, var1);
      this.doc = var2;
   }
}
