package sun.plugin.dom.core;

import org.w3c.dom.DOMException;
import sun.plugin.dom.DOMObject;
import sun.plugin.dom.DOMObjectHelper;

class CharacterData extends Node implements org.w3c.dom.CharacterData {
   public int getLength() {
      return DOMObjectHelper.getIntMemberNoEx(this.obj, "length");
   }

   public short getNodeType() {
      return 4;
   }

   public void deleteData(int var1, int var2) throws DOMException {
      Object[] var3 = new Object[]{new Integer(var1), new Integer(var2)};
      this.obj.call("deleteData", var3);
   }

   public String getData() throws DOMException {
      return DOMObjectHelper.getStringMemberNoEx(this.obj, "data");
   }

   public String getNodeName() {
      return "#cdata-section";
   }

   public String getNodeValue() throws DOMException {
      return this.getData();
   }

   public String substringData(int var1, int var2) throws DOMException {
      Object[] var3 = new Object[]{new Integer(var1), new Integer(var2)};
      return DOMObjectHelper.callStringMethod(this.obj, "substringData", var3);
   }

   public void replaceData(int var1, int var2, String var3) throws DOMException {
      Object[] var4 = new Object[]{new Integer(var1), new Integer(var2), var3};
      this.obj.call("replaceData", var4);
   }

   public void insertData(int var1, String var2) throws DOMException {
      Object[] var3 = new Object[]{new Integer(var1), var2};
      this.obj.call("insertData", var3);
   }

   public void appendData(String var1) throws DOMException {
      Object[] var2 = new Object[]{var1};
      this.obj.call("appendData", var2);
   }

   public void setData(String var1) throws DOMException {
      DOMObjectHelper.setStringMember(this.obj, "data", var1);
   }

   public void setNodeValue(String var1) throws DOMException {
      this.setData(var1);
   }

   public org.w3c.dom.Document getOwnerDocument() {
      return null;
   }

   protected CharacterData(int var1, DOMObject var2) {
      super(var1, var2);
   }

   protected CharacterData(DOMObject var1) {
      super(3, var1);
   }
}
