package sun.plugin.dom.core;

import org.w3c.dom.DOMException;
import org.w3c.dom.NamedNodeMap;
import org.w3c.dom.NodeList;
import sun.plugin.dom.DOMImplementation;
import sun.plugin.dom.DOMObject;
import sun.plugin.dom.exception.HierarchyRequestException;
import sun.plugin.dom.exception.NoModificationAllowedException;

public abstract class Node implements org.w3c.dom.Node {
   protected int type;
   protected DOMObject obj;

   public abstract short getNodeType();

   public void normalize() {
   }

   public boolean hasAttributes() {
      return true;
   }

   public boolean hasChildNodes() {
      return false;
   }

   public String getLocalName() {
      return null;
   }

   public String getNamespaceURI() {
      return null;
   }

   public abstract String getNodeName();

   public abstract String getNodeValue() throws DOMException;

   public String getPrefix() {
      return null;
   }

   public abstract void setNodeValue(String var1) throws DOMException;

   public void setPrefix(String var1) throws DOMException {
      throw new NoModificationAllowedException("Node.setPrefix() is not supported");
   }

   public abstract org.w3c.dom.Document getOwnerDocument();

   public NamedNodeMap getAttributes() {
      return null;
   }

   public org.w3c.dom.Node getFirstChild() {
      return null;
   }

   public org.w3c.dom.Node getLastChild() {
      return null;
   }

   public org.w3c.dom.Node getNextSibling() {
      return null;
   }

   public org.w3c.dom.Node getParentNode() {
      return null;
   }

   public org.w3c.dom.Node getPreviousSibling() {
      return null;
   }

   public org.w3c.dom.Node cloneNode(boolean var1) {
      return null;
   }

   public NodeList getChildNodes() {
      return null;
   }

   protected Node(int var1, DOMObject var2) {
      this.type = var1;
      this.obj = var2;
   }

   public boolean isSupported(String var1, String var2) {
      DOMImplementation var3 = new DOMImplementation();
      return var3.hasFeature(var1, var2);
   }

   public org.w3c.dom.Node appendChild(org.w3c.dom.Node var1) throws DOMException {
      throw new NoModificationAllowedException("Node.appendChild() is not supported");
   }

   public org.w3c.dom.Node removeChild(org.w3c.dom.Node var1) throws DOMException {
      throw new NoModificationAllowedException("Node.removeChild() is not supported");
   }

   public org.w3c.dom.Node insertBefore(org.w3c.dom.Node var1, org.w3c.dom.Node var2) throws DOMException {
      throw new HierarchyRequestException("Node.insertBefore() is not supported");
   }

   public org.w3c.dom.Node replaceChild(org.w3c.dom.Node var1, org.w3c.dom.Node var2) throws DOMException {
      throw new HierarchyRequestException("Node.replaceChild() is not supported");
   }
}
