package sun.plugin.dom.html;

import org.w3c.dom.Element;
import org.w3c.dom.Node;
import sun.plugin.dom.DOMObject;
import sun.plugin.dom.DOMObjectFactory;
import sun.plugin.dom.DOMObjectHelper;

final class HTMLCollection implements org.w3c.dom.html.HTMLCollection {
   private int type;
   private DOMObject obj;
   private org.w3c.dom.html.HTMLDocument doc;
   private Element owner;

   public int getLength() {
      return DOMObjectHelper.getIntMemberNoEx(this.obj, "length");
   }

   public Node item(int var1) {
      Object var2 = this.obj.getSlot(var1);
      return DOMObjectFactory.createHTMLElement(this.type, var2, this.doc, this.owner);
   }

   public Node namedItem(String var1) {
      Object var2 = this.obj.getMember(var1);
      return DOMObjectFactory.createHTMLElement(this.type, var2, this.doc, this.owner);
   }

   public HTMLCollection(int var1, DOMObject var2, org.w3c.dom.html.HTMLDocument var3) {
      this(var1, var2, var3, null);
   }

   public HTMLCollection(int var1, DOMObject var2, org.w3c.dom.html.HTMLDocument var3, Element var4) {
      this.type = var1;
      this.obj = var2;
      this.doc = var3;
      this.owner = var4;
   }
}
