package sun.plugin.dom.html;

import org.w3c.dom.DOMException;
import org.w3c.dom.Element;
import org.w3c.dom.NodeList;
import org.w3c.dom.css.CSSStyleDeclaration;
import org.w3c.dom.css.DocumentCSS;
import org.w3c.dom.css.ElementCSSInlineStyle;
import org.w3c.dom.stylesheets.DocumentStyle;
import org.w3c.dom.stylesheets.StyleSheetList;
import org.w3c.dom.views.AbstractView;
import org.w3c.dom.views.DocumentView;
import sun.plugin.dom.DOMObject;
import sun.plugin.dom.DOMObjectHelper;
import sun.plugin.dom.core.Document;
import sun.plugin.dom.css.ViewCSS;
import sun.plugin.dom.exception.NotSupportedException;

public class HTMLDocument extends Document implements org.w3c.dom.html.HTMLDocument, DocumentView, DocumentStyle, DocumentCSS {
   public void close() {
      throw new NotSupportedException("HTMLDocument.close() is not supported");
   }

   public void open() {
      throw new NotSupportedException("HTMLDocument.open() is not supported");
   }

   public String getCookie() {
      return this.getAttribute("cookie");
   }

   public String getDomain() {
      return this.getAttribute("domain");
   }

   public String getReferrer() {
      return this.getAttribute("referrer");
   }

   public String getTitle() {
      return this.getAttribute("title");
   }

   public String getURL() {
      return this.getAttribute("URL");
   }

   public void setCookie(String var1) {
      this.setAttribute("cookie", var1);
   }

   public void setTitle(String var1) {
      this.setAttribute("title", var1);
   }

   public void write(String var1) {
      throw new NotSupportedException("HTMLDocument.write() is not supported");
   }

   public void writeln(String var1) {
      throw new NotSupportedException("HTMLDocument.writeln() is not supported");
   }

   public Element getDocumentElement() {
      Object var1 = this.obj.getMember("documentElement");
      return var1 != null && var1 instanceof DOMObject ? new HTMLHtmlElement((DOMObject)var1, this) : null;
   }

   public org.w3c.dom.html.HTMLCollection getAnchors() {
      Object var1 = this.obj.getMember("anchors");
      return var1 != null && var1 instanceof DOMObject ? new HTMLCollection(19, (DOMObject)var1, this) : null;
   }

   public org.w3c.dom.html.HTMLCollection getApplets() {
      return null;
   }

   public org.w3c.dom.html.HTMLCollection getForms() {
      Object var1 = this.obj.getMember("forms");
      return var1 != null && var1 instanceof DOMObject ? new HTMLCollection(36, (DOMObject)var1, this) : null;
   }

   public org.w3c.dom.html.HTMLCollection getImages() {
      Object var1 = this.obj.getMember("images");
      return var1 != null && var1 instanceof DOMObject ? new HTMLCollection(44, (DOMObject)var1, this) : null;
   }

   public org.w3c.dom.html.HTMLCollection getLinks() {
      Object var1 = this.obj.getMember("links");
      return var1 != null && var1 instanceof DOMObject ? new HTMLCollection(50, (DOMObject)var1, this) : null;
   }

   public org.w3c.dom.html.HTMLElement getBody() {
      return null;
   }

   public void setBody(org.w3c.dom.html.HTMLElement var1) {
   }

   public StyleSheetList getStyleSheets() {
      try {
         Object var1 = this.obj.getMember("stylesheets");
         if (var1 != null && var1 instanceof DOMObject) {
            return new sun.plugin.dom.stylesheets.StyleSheetList(113, (DOMObject)var1, this);
         }
      } catch (DOMException var2) {
      }

      return null;
   }

   public AbstractView getDefaultView() {
      return new ViewCSS(this);
   }

   public HTMLDocument(DOMObject var1) {
      super(31, var1);
   }

   private String getAttribute(String var1) {
      return DOMObjectHelper.getStringMemberNoEx(this.obj, var1);
   }

   private void setAttribute(String var1, String var2) {
      DOMObjectHelper.setStringMemberNoEx(this.obj, var1, var2);
   }

   public Element createElement(String var1) throws DOMException {
      return null;
   }

   public Element getElementById(String var1) {
      return null;
   }

   public NodeList getElementsByName(String var1) {
      return null;
   }

   public NodeList getElementsByTagName(String var1) {
      return null;
   }

   public CSSStyleDeclaration getOverrideStyle(Element var1, String var2) {
      if (var1 instanceof ElementCSSInlineStyle) {
         ElementCSSInlineStyle var3 = (ElementCSSInlineStyle)var1;
         return var3.getStyle();
      } else {
         return null;
      }
   }
}
