package sun.plugin.dom.html;

import sun.plugin.dom.DOMObject;
import sun.plugin.dom.DOMObjectHelper;

public class HTMLInputElement extends HTMLElement implements org.w3c.dom.html.HTMLInputElement {
   public int getMaxLength() {
      return DOMObjectHelper.getIntMemberNoEx(this.obj, "maxLength");
   }

   public int getTabIndex() {
      return DOMObjectHelper.getIntMemberNoEx(this.obj, "tabIndex");
   }

   public void blur() {
      this.obj.call("blur", null);
   }

   public void click() {
      this.obj.call("click", null);
   }

   public void focus() {
      this.obj.call("focus", null);
   }

   public void select() {
      this.obj.call("select", null);
   }

   public boolean getChecked() {
      return DOMObjectHelper.getBooleanMemberNoEx(this.obj, "checked");
   }

   public boolean getDefaultChecked() {
      return DOMObjectHelper.getBooleanMemberNoEx(this.obj, "defaultChecked");
   }

   public boolean getDisabled() {
      return DOMObjectHelper.getBooleanMemberNoEx(this.obj, "disabled");
   }

   public boolean getReadOnly() {
      return DOMObjectHelper.getBooleanMemberNoEx(this.obj, "readOnly");
   }

   public void setMaxLength(int var1) {
      DOMObjectHelper.setIntMemberNoEx(this.obj, "maxLength", var1);
   }

   public void setTabIndex(int var1) {
      DOMObjectHelper.setIntMemberNoEx(this.obj, "tabIndex", var1);
   }

   public void setChecked(boolean var1) {
      DOMObjectHelper.setBooleanMemberNoEx(this.obj, "checked", var1);
   }

   public void setDefaultChecked(boolean var1) {
      DOMObjectHelper.setBooleanMemberNoEx(this.obj, "defaultChecked", var1);
   }

   public void setDisabled(boolean var1) {
      DOMObjectHelper.setBooleanMemberNoEx(this.obj, "disabled", var1);
   }

   public void setReadOnly(boolean var1) {
      DOMObjectHelper.setBooleanMemberNoEx(this.obj, "readOnly", var1);
   }

   public String getAccept() {
      return this.getAttribute("accept");
   }

   public String getAccessKey() {
      return this.getAttribute("accessKey");
   }

   public String getAlign() {
      return this.getAttribute("align");
   }

   public String getAlt() {
      return this.getAttribute("alt");
   }

   public String getDefaultValue() {
      return this.getAttribute("defaultValue");
   }

   public String getName() {
      return this.getAttribute("name");
   }

   public String getSize() {
      return this.getAttribute("size");
   }

   public String getSrc() {
      return this.getAttribute("src");
   }

   public String getType() {
      return this.getAttribute("type");
   }

   public String getUseMap() {
      return this.getAttribute("useMap");
   }

   public String getValue() {
      return this.getAttribute("value");
   }

   public void setAccept(String var1) {
      this.setAttribute("accept", var1);
   }

   public void setAccessKey(String var1) {
      this.setAttribute("accessKey", var1);
   }

   public void setAlign(String var1) {
      this.setAttribute("align", var1);
   }

   public void setAlt(String var1) {
      this.setAttribute("alt", var1);
   }

   public void setDefaultValue(String var1) {
      this.setAttribute("defaultValue", var1);
   }

   public void setName(String var1) {
      this.setAttribute("name", var1);
   }

   public void setSize(String var1) {
      this.setAttribute("size", var1);
   }

   public void setSrc(String var1) {
      this.setAttribute("src", var1);
   }

   public void setUseMap(String var1) {
      this.setAttribute("useMap", var1);
   }

   public void setValue(String var1) {
      this.setAttribute("value", var1);
   }

   public org.w3c.dom.html.HTMLFormElement getForm() {
      return (org.w3c.dom.html.HTMLFormElement)this.owner;
   }

   public HTMLInputElement(DOMObject var1, org.w3c.dom.html.HTMLDocument var2, org.w3c.dom.html.HTMLFormElement var3) {
      super(45, var1, var2, var3);
   }
}
