package sun.plugin.dom.stylesheets;

import org.w3c.dom.DOMException;
import sun.plugin.dom.DOMObject;
import sun.plugin.dom.DOMObjectHelper;

final class MediaList implements org.w3c.dom.stylesheets.MediaList {
   private DOMObject obj;

   public int getLength() {
      return DOMObjectHelper.getIntMemberNoEx(this.obj, "length");
   }

   public String getMediaText() {
      return DOMObjectHelper.getStringMemberNoEx(this.obj, "mediaText");
   }

   public String item(int var1) {
      try {
         Object var2 = this.obj.getSlot(var1);
         return var2 != null ? var2.toString() : null;
      } catch (DOMException var3) {
         return null;
      }
   }

   public void appendMedium(String var1) throws DOMException {
      Object[] var2 = new Object[]{var1};
      DOMObjectHelper.callStringMethod(this.obj, "appendMedium", var2);
   }

   public void deleteMedium(String var1) throws DOMException {
      Object[] var2 = new Object[]{var1};
      DOMObjectHelper.callStringMethod(this.obj, "deleteMedium", var2);
   }

   public void setMediaText(String var1) throws DOMException {
      DOMObjectHelper.setStringMember(this.obj, "mediaText", var1);
   }

   public MediaList(DOMObject var1) {
      this.obj = var1;
   }
}
