package sun.plugin.extension;

import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.util.jar.Attributes;
import java.util.jar.JarFile;
import java.util.jar.Manifest;
import java.util.jar.Attributes.Name;
import sun.plugin.resources.ResourceHandler;
import sun.plugin.util.DialogFactory;
import sun.plugin.util.Trace;

public class NativeExtensionInstaller implements ExtensionInstaller {
   public boolean install(String var1, String var2, String var3) throws IOException, InterruptedException {
      Trace.msgExtPrintln("optpkg.install.native.launch");
      String var4 = null;

      try {
         JarFile var5 = new JarFile(var2);
         Manifest var6 = var5.getManifest();
         Attributes var7 = var6.getMainAttributes();
         String var8 = var7.getValue(Name.EXTENSION_INSTALLATION);
         if (var8 != null) {
            var8 = var8.trim();
         }

         InputStream var9 = var5.getInputStream(var5.getEntry(var8));
         BufferedInputStream var10 = new BufferedInputStream(var9);
         var4 = ExtensionUtils.getTempDir() + File.separator + var8;
         FileOutputStream var11 = new FileOutputStream(var4);
         BufferedOutputStream var12 = new BufferedOutputStream(var11);
         ExtensionUtils.copy(var10, var12);
         var10.close();
         var9.close();
         var12.close();
         var11.close();
         String var13 = System.getProperty("os.name");
         String var14 = System.getProperty("java.home");
         if (var13.indexOf("Windows") != -1) {
            Process var35 = Runtime.getRuntime().exec(var4);
            DialogFactory.showInformationDialog(
               ResourceHandler.getMessage("optpkg.installer.launch.wait"), ResourceHandler.getMessage("optpkg.installer.launch.caption")
            );
            return true;
         } else {
            Process var15 = Runtime.getRuntime().exec("chmod 755 " + var4);
            var15.waitFor();

            try {
               File var16 = new File(var14);
               Process var17 = Runtime.getRuntime().exec(var4, null, var16);
               int var18 = var17.waitFor();
               if (var18 != 0) {
                  Trace.msgExtPrintln("optpkg.install.native.launch.fail.0", new Object[]{var4});
                  return false;
               }
            } catch (SecurityException var32) {
               Trace.msgExtPrintln("optpkg.install.native.launch.fail.1", new Object[]{var14});
               Trace.securityPrintException(var32);
            } finally {
               if (var4 != null) {
                  File var22 = new File(var4);
                  if (var22.exists()) {
                     var22.delete();
                  }
               }
            }

            return false;
         }
      } finally {
         if (var4 != null) {
            File var25 = new File(var4);
            if (var25.exists()) {
               var25.delete();
            }
         }
      }
   }
}
