package sun.plugin.javascript.navig;

import java.util.HashMap;
import netscape.javascript.JSException;

public class Window extends JSObject {
   private static HashMap methodTable = new HashMap();
   private static HashMap fieldTable = new HashMap();
   private static long varCount = 0L;

   static {
      methodTable.put("alert", Boolean.FALSE);
      methodTable.put("blur", Boolean.FALSE);
      methodTable.put("clearTimeout", Boolean.FALSE);
      methodTable.put("close", Boolean.FALSE);
      methodTable.put("confirm", Boolean.TRUE);
      methodTable.put("focus", Boolean.FALSE);
      methodTable.put("open", Boolean.TRUE);
      methodTable.put("prompt", Boolean.TRUE);
      methodTable.put("scroll", Boolean.FALSE);
      methodTable.put("setTimeout", Boolean.TRUE);
      fieldTable.put("closed", Boolean.FALSE);
      fieldTable.put("defaultStatus", Boolean.FALSE);
      fieldTable.put("frames", Boolean.FALSE);
      fieldTable.put("history", Boolean.FALSE);
      fieldTable.put("length", Boolean.FALSE);
      fieldTable.put("location", Boolean.FALSE);
      fieldTable.put("name", Boolean.TRUE);
      fieldTable.put("navigator", Boolean.FALSE);
      fieldTable.put("opener", Boolean.TRUE);
      fieldTable.put("parent", Boolean.TRUE);
      fieldTable.put("self", Boolean.FALSE);
      fieldTable.put("status", Boolean.TRUE);
      fieldTable.put("top", Boolean.TRUE);
      fieldTable.put("window", Boolean.FALSE);
   }

   public Window(int var1) {
      this(var1, "self");
   }

   public Window(int var1, String var2) {
      super(var1, var2);
      this.addObjectTable(fieldTable, methodTable);
   }

   public Object getMember(String var1) throws JSException {
      if (var1.equals("document")) {
         return this.resolveObject("[object Document]", this.context + ".document");
      } else if (var1.equals("history")) {
         return this.resolveObject("[object History]", this.context + ".history");
      } else if (var1.equals("location")) {
         return this.resolveObject("[object Location]", this.context + ".location");
      } else if (var1.equals("frames")) {
         return this.resolveObject("[object FrameArray]", this.context + ".frames");
      } else if (var1.equals("navigator")) {
         return this.resolveObject("[object Navigator]", "navigator");
      } else if (var1.equals("self")) {
         return this;
      } else if (var1.equals("window")) {
         return this;
      } else if (var1.equals("parent")) {
         return this.resolveObject("[object Window]", this.context + ".parent");
      } else if (var1.equals("top")) {
         return this.resolveObject("[object Window]", this.context + ".top");
      } else if (var1.equals("opener")) {
         return this.resolveObject("[object Window]", this.context + ".opener");
      } else {
         try {
            return super.getMember(var1);
         } catch (JSException var5) {
            String var3 = generateVarName("__pluginVar");
            Object var4 = this.eval(var3 + "=" + this.context + "." + var1);
            if (var4 != null) {
               var4 = this.resolveObject(var4.toString().trim(), this.context + "." + var3);
            }

            return var4;
         }
      }
   }

   public void setMember(String var1, Object var2) throws JSException {
      try {
         super.setMember(var1, var2);
      } catch (JSException var4) {
         if (var2 instanceof String) {
            this.eval(this.context + "." + var1 + "='" + var2.toString() + "'");
         } else {
            this.eval(this.context + "." + var1 + "=" + var2.toString());
         }
      }
   }

   protected static String generateVarName(String var0) {
      return var0 != null ? var0 + varCount++ : "__pluginTemp" + varCount++;
   }

   public Object call(String var1, Object[] var2) throws JSException {
      if (!var1.equals("open")) {
         try {
            return super.call(var1, var2);
         } catch (JSException var7) {
            if (this.eval(this.context + "." + var1) == null) {
               throw new JSException("call does not support " + this.toString() + "." + var1);
            } else {
               String var8 = this.context + "." + var1 + "(";
               if (var2 != null) {
                  for (int var11 = 0; var11 < var2.length; var11++) {
                     if (var2[var11] instanceof String) {
                        var8 = var8 + "'" + var2[var11].toString() + "'";
                     } else {
                        var8 = var8 + var2[var11].toString();
                     }

                     if (var11 != var2.length - 1) {
                        var8 = var8 + ", ";
                     }
                  }
               }

               var8 = var8 + ")";
               String var12 = generateVarName("__pluginVar");
               Object var13 = this.eval(var12 + "=" + var8);
               if (var13 != null) {
                  var13 = this.resolveObject(var13.toString().trim(), this.context + "." + var12);
               }

               return var13;
            }
         }
      } else {
         Object[] var3;
         if (var2 != null && var2.length != 0) {
            if (var2.length == 1) {
               var3 = new Object[]{var2[0], generateVarName("__pluginwin")};
            } else {
               var3 = var2;
            }
         } else {
            var3 = new Object[]{"", generateVarName("__pluginwin")};
         }

         Object var4 = super.call(var1, var3);
         if (var4 == null) {
            throw new JSException("call does not support " + this.toString() + "." + var1);
         } else {
            String var5 = this.context + ".open(";

            for (int var6 = 0; var6 < var3.length; var6++) {
               if (var3[var6] instanceof String) {
                  var5 = var5 + "'" + var3[var6].toString() + "'";
               } else {
                  var5 = var5 + var3[var6].toString();
               }

               if (var6 != var3.length - 1) {
                  var5 = var5 + ", ";
               }
            }

            var5 = var5 + ")";
            return this.resolveObject("[object Window]", var5);
         }
      }
   }
}
