package sun.plugin.javascript.navig5;

import java.security.AccessControlContext;
import java.security.AccessControlException;
import java.security.AllPermission;
import netscape.javascript.JSException;
import sun.plugin.util.Trace;
import sun.plugin.viewer.context.NetscapeAppletContext;

public class JSObject extends netscape.javascript.JSObject {
   private int nativeJSObject = 0;
   private int jsThreadID = 0;
   private int peer = 0;
   private NetscapeAppletContext nac = null;

   public void finalize() throws Throwable {
      JSFinalize(this.peer, this.jsThreadID, this.nativeJSObject);
      this.setNetscapeAppletContext(this.nac);
      super.finalize();
   }

   private static int JSGetNativeJSObject(int var0) {
      SecurityContext var1 = SecurityContext.getCurrentSecurityContext();
      boolean var2 = false;

      try {
         AccessControlContext var3 = var1.getAccessControlContext();
         var3.checkPermission(new AllPermission());
         var2 = true;
      } catch (AccessControlException var4) {
      }

      return JSGetNativeJSObject(var0, var1.getURL(), var2);
   }

   private static native int JSGetThreadID(int var0);

   public JSObject(int var1) {
      this(JSGetThreadID(var1), JSGetNativeJSObject(var1));
      this.peer = var1;
   }

   public JSObject(int var1, int var2) {
      this.jsThreadID = var1;
      this.nativeJSObject = var2;
   }

   private static native void JSFinalize(int var0, int var1, int var2);

   public Object getSlot(int var1) throws JSException {
      SecurityContext var2 = SecurityContext.getCurrentSecurityContext();
      boolean var3 = false;

      try {
         AccessControlContext var4 = var2.getAccessControlContext();
         var4.checkPermission(new AllPermission());
         var3 = true;
      } catch (AccessControlException var5) {
      }

      Trace.msgLiveConnectPrintln("jsobject.getSlot", new Object[]{String.valueOf(var1), var2.getURL(), String.valueOf(var3)});
      Object var6 = JSObjectGetSlot(this.peer, this.jsThreadID, this.nativeJSObject, var2.getURL(), var1, var3);
      if (var6 != null && var6 instanceof JSObject) {
         ((JSObject)var6).setNetscapeAppletContext(this.nac);
      }

      return var6;
   }

   public void setSlot(int var1, Object var2) throws JSException {
      SecurityContext var3 = SecurityContext.getCurrentSecurityContext();
      boolean var4 = false;

      try {
         AccessControlContext var5 = var3.getAccessControlContext();
         var5.checkPermission(new AllPermission());
         var4 = true;
      } catch (AccessControlException var6) {
      }

      Trace.msgLiveConnectPrintln("jsobject.setSlot", new Object[]{String.valueOf(var1), var3.getURL(), String.valueOf(var4)});
      JSObjectSetSlot(this.peer, this.jsThreadID, this.nativeJSObject, var3.getURL(), var1, var2, var4);
      this.setNetscapeAppletContext(this.nac);
   }

   public String toString() {
      String var1 = JSObjectToString(this.peer, this.jsThreadID, this.nativeJSObject);
      this.setNetscapeAppletContext(this.nac);
      return var1;
   }

   private static native String JSObjectToString(int var0, int var1, int var2);

   private static native int JSGetNativeJSObject(int var0, String var1, boolean var2);

   public void removeMember(String var1) throws JSException {
      SecurityContext var2 = SecurityContext.getCurrentSecurityContext();
      boolean var3 = false;

      try {
         AccessControlContext var4 = var2.getAccessControlContext();
         var4.checkPermission(new AllPermission());
         var3 = true;
      } catch (AccessControlException var5) {
      }

      Trace.msgLiveConnectPrintln("jsobject.removeMember", new Object[]{var1, var2.getURL(), String.valueOf(var3)});
      JSObjectRemoveMember(this.peer, this.jsThreadID, this.nativeJSObject, var2.getURL(), var1, var3);
      this.setNetscapeAppletContext(this.nac);
   }

   public void setNetscapeAppletContext(NetscapeAppletContext var1) {
      this.nac = var1;
      this.peer = var1.getAppletContextHandle();
   }

   private static native void JSObjectSetSlot(int var0, int var1, int var2, String var3, int var4, Object var5, boolean var6) throws JSException;

   private static native Object JSObjectGetSlot(int var0, int var1, int var2, String var3, int var4, boolean var5) throws JSException;

   public Object eval(String var1) throws JSException {
      SecurityContext var2 = SecurityContext.getCurrentSecurityContext();
      boolean var3 = false;

      try {
         AccessControlContext var4 = var2.getAccessControlContext();
         var4.checkPermission(new AllPermission());
         var3 = true;
      } catch (AccessControlException var5) {
      }

      Trace.msgLiveConnectPrintln("jsobject.eval.url.permission", new Object[]{var1, var2.getURL(), String.valueOf(var3)});
      Object var6 = JSObjectEval(this.peer, this.jsThreadID, this.nativeJSObject, var2.getURL(), var1, var3);
      if (var6 != null && var6 instanceof JSObject) {
         ((JSObject)var6).setNetscapeAppletContext(this.nac);
      }

      return var6;
   }

   public Object getMember(String var1) throws JSException {
      SecurityContext var2 = SecurityContext.getCurrentSecurityContext();
      boolean var3 = false;

      try {
         AccessControlContext var4 = var2.getAccessControlContext();
         var4.checkPermission(new AllPermission());
         var3 = true;
      } catch (AccessControlException var5) {
      }

      Trace.msgLiveConnectPrintln("jsobject.getMember", new Object[]{var1, var2.getURL(), String.valueOf(var3)});
      Object var6 = JSObjectGetMember(this.peer, this.jsThreadID, this.nativeJSObject, var2.getURL(), var1, var3);
      if (var6 != null && var6 instanceof JSObject) {
         ((JSObject)var6).setNetscapeAppletContext(this.nac);
      }

      return var6;
   }

   public void setMember(String var1, Object var2) throws JSException {
      SecurityContext var3 = SecurityContext.getCurrentSecurityContext();
      boolean var4 = false;

      try {
         AccessControlContext var5 = var3.getAccessControlContext();
         var5.checkPermission(new AllPermission());
         var4 = true;
      } catch (AccessControlException var6) {
      }

      Trace.msgLiveConnectPrintln("jsobject.setMember", new Object[]{var1, var3.getURL(), String.valueOf(var4)});
      JSObjectSetMember(this.peer, this.jsThreadID, this.nativeJSObject, var3.getURL(), var1, var2, var4);
      this.setNetscapeAppletContext(this.nac);
   }

   private static native void JSObjectRemoveMember(int var0, int var1, int var2, String var3, String var4, boolean var5) throws JSException;

   public Object call(String var1, Object[] var2) throws JSException {
      SecurityContext var3 = SecurityContext.getCurrentSecurityContext();
      boolean var4 = false;

      try {
         AccessControlContext var5 = var3.getAccessControlContext();
         var5.checkPermission(new AllPermission());
         var4 = true;
      } catch (AccessControlException var6) {
      }

      Trace.msgLiveConnectPrintln("jsobject.call", new Object[]{var1, var3.getURL(), String.valueOf(var4)});
      Object var7 = JSObjectCall(this.peer, this.jsThreadID, this.nativeJSObject, var3.getURL(), var1, var2, var4);
      if (var7 != null && var7 instanceof JSObject) {
         ((JSObject)var7).setNetscapeAppletContext(this.nac);
      }

      return var7;
   }

   private static native void JSObjectSetMember(int var0, int var1, int var2, String var3, String var4, Object var5, boolean var6) throws JSException;

   private static native Object JSObjectEval(int var0, int var1, int var2, String var3, String var4, boolean var5) throws JSException;

   private static native Object JSObjectGetMember(int var0, int var1, int var2, String var3, String var4, boolean var5) throws JSException;

   private static native Object JSObjectCall(int var0, int var1, int var2, String var3, String var4, Object[] var5, boolean var6) throws JSException;
}
