package sun.plugin.javascript.navig5;

import java.net.URL;
import java.net.URLClassLoader;
import java.security.AccessControlContext;
import java.security.AccessController;
import java.security.CodeSource;
import java.security.PrivilegedActionException;
import java.security.PrivilegedExceptionAction;
import java.security.ProtectionDomain;
import sun.applet.AppletClassLoader;
import sun.plugin.security.ActivatorSecurityManager;
import sun.plugin.util.Trace;

class SecurityContext {
   private ProtectionDomain domain;
   private AccessControlContext ctx;
   static Class class$sun$applet$AppletClassLoader;

   int getNumOfCert() {
      return 0;
   }

   int[] getCertLength() {
      return null;
   }

   byte[][] getCertChain() {
      return (byte[][])null;
   }

   String getURL() {
      if (this.domain != null) {
         CodeSource var1 = this.domain.getCodeSource();
         if (var1 != null) {
            URL var2 = var1.getLocation();
            if (var2 != null) {
               StringBuffer var3 = new StringBuffer();
               String var4 = var2.getProtocol();
               String var5 = var2.getHost();
               int var6 = var2.getPort();
               var3.append(var4);
               var3.append("://");
               var3.append(var5);
               if (var6 != -1) {
                  var3.append(":" + var6);
               }

               return var3.toString();
            }
         }
      }

      return "file://";
   }

   AccessControlContext getAccessControlContext() {
      return this.ctx;
   }

   static SecurityContext getCurrentSecurityContext() {
      AccessControlContext var0 = AccessController.getContext();

      try {
         return AccessController.doPrivileged(new SecurityContext.PrivilegedBlockAction(var0));
      } catch (PrivilegedActionException var2) {
         Trace.securityPrintException(var2);
         return new SecurityContext(null, var0);
      }
   }

   static Class class$(String var0) {
      try {
         return Class.forName(var0);
      } catch (ClassNotFoundException var2) {
         throw new NoClassDefFoundError().initCause(var2);
      }
   }

   SecurityContext(ProtectionDomain var1, AccessControlContext var2) {
      this.domain = var1;
      this.ctx = var2;
   }

   static class PrivilegedBlockAction implements PrivilegedExceptionAction {
      AccessControlContext ctx;

      public Object run() throws Exception {
         SecurityManager var1 = System.getSecurityManager();
         if (var1 != null && var1 instanceof ActivatorSecurityManager) {
            ActivatorSecurityManager var2 = (ActivatorSecurityManager)var1;
            Class[] var3 = var2.getExecutionStackContext();

            for (int var4 = 0; var4 < var3.length; var4++) {
               Class var5 = var3[var4];
               ClassLoader var6 = var5.getClassLoader();
               if (var6 instanceof URLClassLoader
                  || var6 instanceof AppletClassLoader
                  || (SecurityContext.class$sun$applet$AppletClassLoader == null
                        ? (SecurityContext.class$sun$applet$AppletClassLoader = SecurityContext.class$("sun.applet.AppletClassLoader"))
                        : SecurityContext.class$sun$applet$AppletClassLoader)
                     .isAssignableFrom(var5)) {
                  return new SecurityContext(var5.getProtectionDomain(), this.ctx);
               }
            }
         }

         return new SecurityContext(null, this.ctx);
      }

      PrivilegedBlockAction(AccessControlContext var1) {
         this.ctx = var1;
      }
   }
}
