package sun.plugin.liveconnect;

import java.lang.reflect.Constructor;
import java.lang.reflect.Method;
import java.lang.reflect.Modifier;
import java.security.PrivilegedExceptionAction;
import sun.plugin.javascript.JSClassLoader;
import sun.plugin.javascript.ReflectUtil;

class PrivilegedCallMethodAction implements PrivilegedExceptionAction {
   Method method;
   Object obj;
   Object[] args;

   public Object run() throws Exception {
      if (this.obj instanceof Class) {
         String var1 = this.method.getName();
         Class var2 = (Class)this.obj;
         if (var1.equals("getMethods")) {
            Method[] var3 = ReflectUtil.getJScriptMethods(var2);

            for (int var4 = 0; var4 < var3.length; var4++) {
               Method var5 = var3[var4];
               if (Modifier.isAbstract(var5.getModifiers())) {
                  Class[] var6 = var5.getParameterTypes();
                  var3[var4] = var2.getMethod(var5.getName(), var6);
               }
            }

            return var3;
         }

         if (var1.equals("getFields")) {
            return ReflectUtil.getJScriptFields(var2);
         }

         if (var1.equals("getConstructors") && (!Modifier.isPublic(var2.getModifiers()) || !JSClassLoader.isPackageAccessible(var2))) {
            return new Constructor[0];
         }
      }

      Method var7 = ReplaceMethod.getJScriptMethod(this.method);
      if (var7 != null) {
         return JSClassLoader.invoke(var7, this.obj, this.args);
      } else {
         throw new NoSuchMethodException(this.method.getName());
      }
   }

   PrivilegedCallMethodAction(Method var1, Object var2, Object[] var3) {
      this.method = var1;
      this.obj = var2;
      this.args = var3;
      if (this.args == null) {
         this.args = new Object[0];
      }
   }
}
