package sun.plugin.liveconnect;

import java.lang.reflect.Method;
import java.lang.reflect.Modifier;
import sun.plugin.javascript.JSClassLoader;

public class ReplaceMethod {
   static Method getJScriptMethod(Method var0) {
      Class var1 = var0.getDeclaringClass();
      if (Modifier.isPublic(var1.getModifiers())) {
         return var0;
      } else {
         String var2 = var0.getName();
         Class[] var3 = var0.getParameterTypes();

         Method var4;
         for (var4 = null; var1 != null && var4 == null; var1 = var1.getSuperclass()) {
            var4 = getPublicMethod(var1, var2, var3);
            if (var4 == null) {
               var4 = getJScriptInterfaceMethod(var1, var2, var3);
            }
         }

         return var4;
      }
   }

   static Method getJScriptInterfaceMethod(Class var0, String var1, Class[] var2) {
      Method var3 = null;
      Class[] var4 = var0.getInterfaces();

      for (int var5 = 0; var5 < var4.length && var3 == null; var5++) {
         Class var6 = var4[var5];
         var3 = getPublicMethod(var6, var1, var2);
         if (var3 == null) {
            var3 = getJScriptInterfaceMethod(var6, var1, var2);
         }
      }

      return var3;
   }

   private static Method getPublicMethod(Class var0, String var1, Class[] var2) {
      try {
         if (!Modifier.isPublic(var0.getModifiers())) {
            return null;
         } else {
            return !JSClassLoader.isPackageAccessible(var0) ? null : var0.getMethod(var1, var2);
         }
      } catch (NoSuchMethodException var4) {
         return null;
      } catch (SecurityException var5) {
         return null;
      }
   }
}
