package sun.plugin.navig.motif;

import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.util.Hashtable;

public class OJIPlugin {
   public static final int SpontFD = 10;
   private static int spontcount = 0;
   private static Hashtable threads = new Hashtable();
   private static Object SpontMonitor = new Object();
   private static DataOutputStream spontOut;
   private static DataInputStream spontIn;

   public static int acquirePipeForCurrentThread() {
      AThread var0 = getCurrentAThread();
      int var1;
      if (var0 != null) {
         var1 = var0.getPipe();
         System.err.println("OJIPlugin acq thread=:" + var0.toString() + " pipe=" + var1);
      } else {
         var1 = 10;
         System.err.println("OJIPlugin acq Spontaneous pipe=" + var1);
         enterSpontaneousMonitor();
      }

      return var1;
   }

   static void enterSpontaneousMonitor() {
      System.err.println("Trying to enter spont monitor: " + spontcount);
      enterMonitor(SpontMonitor);
      spontcount++;
   }

   static void exitSpontaneousMonitor() {
      spontcount--;
      exitMonitor(SpontMonitor);
   }

   public static void initialize() {
      spontIn = Plugin.newInput("Spont Comm", 10);
      spontOut = Plugin.newOutput("Spont Comm", 10);
   }

   public static void releasePipeForCurrentThread() {
      Thread var0 = Thread.currentThread();
      if (var0 != null) {
         System.err.println(" OJIPlugin release for:" + var0.toString());
      } else {
         System.err.println(" OJIPlugin release for: null thread!?");
      }

      if (!threads.contains(var0)) {
         System.err.println("OJIPlugin releasePipe - exiting spont monitor");
         exitSpontaneousMonitor();
      } else {
         System.err.println("OJIPlugin release - non spontaneous pipe");
      }
   }

   private static native void enterMonitor(Object var0);

   private static native void exitMonitor(Object var0);

   private static synchronized AThread getCurrentAThread() {
      Thread var0 = Thread.currentThread();
      System.err.println("Current thread:" + var0.toString());
      if (threads.contains(var0)) {
         System.err.println("OJIPlugin: Retrieve the AThread\n");
         return (AThread)threads.get(var0);
      } else {
         System.err.println("OJIPlugin: No AThread\n");
         return null;
      }
   }

   public static synchronized void registerThread(AThread var0) {
      Thread var1 = Thread.currentThread();
      Plugin.trace("Registering thread: " + var1.toString() + " with AThread " + var0.toString());
      threads.put(var1, var0);
   }
}
