package sun.plugin.navig.motif;

import java.awt.Color;
import java.awt.Toolkit;
import java.io.BufferedOutputStream;
import java.io.BufferedWriter;
import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.EOFException;
import java.io.FileDescriptor;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintStream;
import java.io.PrintWriter;
import java.util.Hashtable;
import sun.plugin.AppletViewer;
import sun.plugin.JavaRunTime;
import sun.plugin.viewer.LifeCycleManager;
import sun.plugin.viewer.MNetscapePluginContext;
import sun.plugin.viewer.MNetscapePluginObject;

public class Plugin extends JavaRunTime {
   private static String encoding;
   private static Hashtable panels = new Hashtable();
   private static int nextId = 0;
   private static boolean tracing;
   private static PrintStream printOut;
   private static DataOutputStream cmdOut;
   private static DataInputStream cmdIn;
   private static Worker worker;
   private static int navig_version;
   private static BufferedWriter tracefile;
   private static String messages = "";
   public static final int CmdFD = 11;
   public static final int WorkFD = 12;
   public static final int PrintFD = 13;
   public static OJIPlugin oji;
   public static final int JAVA_PLUGIN_NEW = 16384001;
   public static final int JAVA_PLUGIN_DESTROY = 16384002;
   public static final int JAVA_PLUGIN_WINDOW = 16384003;
   public static final int JAVA_PLUGIN_SHUTDOWN = 16384004;
   public static final int JAVA_PLUGIN_DOCBASE = 16384005;
   public static final int JAVA_PLUGIN_PROXY_MAPPING = 16384007;
   public static final int JAVA_PLUGIN_COOKIE = 16384008;
   public static final int JAVA_PLUGIN_JAVASCRIPT_REPLY = 16384010;
   public static final int JAVA_PLUGIN_JAVASCRIPT_END = 16384011;
   public static final int JAVA_PLUGIN_START = 16384017;
   public static final int JAVA_PLUGIN_STOP = 16384018;
   public static final int JAVA_PLUGIN_ATTACH_THREAD = 16384019;
   public static final int JAVA_PLUGIN_REQUEST_ABRUPTLY_TERMINATED = 16384020;
   public static final int JAVA_PLUGIN_GET_INSTANCE_JAVA_OBJECT = 16384021;
   public static final int JAVA_PLUGIN_PRINT = 16384022;
   public static final int JAVA_PLUGIN_CONSOLE_SHOW = 16384025;
   public static final int JAVA_PLUGIN_CONSOLE_HIDE = 16384026;
   public static final int JAVA_PLUGIN_OK = 16449537;
   public static String Progress;

   public static int getNavigVersion() {
      return navig_version;
   }

   private static native void attachThread();

   private void doit() {
      try {
         trace("Plugin class started");
         String var19 = getenv("JAVA_HOME");
         String var20 = getenv("HOME");
         JavaRunTime.initEnvironment(var19, "", var20);
         String var21 = getenv("JAVA_PLUGIN_VERSION");
         if (var21 != null) {
            System.getProperties().put("javaplugin.version", var21);
         }

         if (!tracing) {
            try {
               FileOutputStream var4 = new FileOutputStream("/dev/null");
               BufferedOutputStream var5 = new BufferedOutputStream(var4);
               PrintStream var6 = new PrintStream(var5);
               System.setOut(var6);
               System.setErr(var6);
            } catch (IOException var15) {
               error("Java process: Couldn't reassign stdout/stderr: " + var15);
            }
         }

         if (getNavigVersion() >= 5.0F) {
            AppletViewer.initEnvironment(4099);
            encoding = new String("UTF-8");
         } else {
            AppletViewer.initEnvironment(4098);
            encoding = new String("ISO-8859-1");
         }

         trace("Initialized environment. Printing  messages.\n");
         System.out.print(messages);
         Plugin.Watcher var22 = new Plugin.Watcher(this);
         var22.start();
         this.initializeCommunication();

         while (true) {
            int var23;
            while (true) {
               if (!parentAlive()) {
                  trace("parent is dead. Exiting.");
                  this.onExit();
                  System.exit(4);
               }

               var23 = -1;
               trace("Plugin: Reading next  code...");

               try {
                  var23 = cmdIn.readInt();
                  break;
               } catch (EOFException var16) {
                  trace("Pipe got closed, our work is done. Exiting.");
                  this.onExit();
                  System.exit(4);
                  break;
               } catch (IOException var17) {
                  trace("Could not read next command code!");
               }
            }

            if (tracing) {
               trace("VM Received Command >>>" + protocol_to_str(var23));
            }

            if (var23 == 16384001) {
               int var35 = cmdIn.readInt();
               int var46 = cmdIn.readInt();
               int var51 = cmdIn.readInt();
               String[] var53 = new String[var51];
               String[] var55 = new String[var51];

               for (int var57 = 0; var57 < var51; var57++) {
                  var53[var57] = readString();
                  var55[var57] = readString();
                  if (tracing) {
                     trace("   >" + var53[var57] + "==>" + var55[var57]);
                  }
               }

               MNetscapePluginObject var58 = MNetscapePluginContext.createPluginObject(var46 != 0, var53, var55, var35);
               panels.put(new Integer(var35), var58);
               trace("Registering panel:" + var35);
               replyOK();
            } else if (var23 == 16384017) {
               int var24 = cmdIn.readInt();
               MNetscapePluginObject var7 = getPluginObject(var24);
               if (var7 != null) {
                  var7.startPlugin();
               }
            } else if (var23 == 16384018) {
               int var25 = cmdIn.readInt();
               MNetscapePluginObject var36 = getPluginObject(var25);
               if (var36 != null) {
                  var36.stopPlugin();
               }
            } else if (var23 == 16384002) {
               int var26 = cmdIn.readInt();
               MNetscapePluginObject var37 = getPluginObject(var26);
               if (var37 != null) {
                  trace("Removing panel:" + var26);
                  panels.remove(new Integer(var26));

                  try {
                     var37.destroyPlugin();
                  } catch (Exception var14) {
                     var14.printStackTrace();
                  }
               }

               replyOK();
            } else if (var23 == 16384003) {
               int var27 = cmdIn.readInt();
               int var38 = cmdIn.readInt();
               int var8 = cmdIn.readInt();
               int var9 = cmdIn.readInt();
               int var10 = cmdIn.readInt();
               int var11 = cmdIn.readInt();
               MNetscapePluginObject var12 = getPluginObject(var27);
               trace("Window " + var38 + " " + var8 + "x" + var9 + " " + var10 + "x" + var11);
               if (var12 != null) {
                  var12.setWindow(var38, var8, var9, var10, var11);
               }

               replyOK();
            } else if (var23 != 16384004) {
               if (var23 == 16384005) {
                  int var28 = cmdIn.readInt();
                  String var39 = readString();
                  trace("DOCBASE := " + var39);
                  MNetscapePluginObject var47 = getPluginObject(var28);
                  trace("Setting docbase for " + var28 + " to " + var39);
                  if (var47 != null) {
                     var47.setDocumentURL(var39);
                  }
               } else if (var23 == 16384007) {
                  String var29 = readString();
                  String var40 = readString();
                  trace("Plugin.java: PROXY MAPPING: \"" + var29 + "\" => \"" + var40 + "\"");
                  Worker.addProxyMapping(var29, var40);
               } else if (var23 == 16384022) {
                  int var30 = cmdIn.readInt();
                  int var41 = cmdIn.readInt() / 10;
                  int var48 = cmdIn.readInt() / 10;
                  int var52 = cmdIn.readInt() / 10;
                  int var54 = cmdIn.readInt() / 10;
                  trace("PRINT " + var30 + " x=" + var41 + " y=" + var48 + " w=" + var52 + " h=" + var54);
                  MNetscapePluginObject var56 = getPluginObject(var30);
                  if (var56 != null) {
                     var56.doPrint(var41, var48, var52, var54, printOut);
                  }

                  replyOK();
               } else if (var23 == 16384008) {
                  int var31 = cmdIn.readInt();
                  String var42 = readString();
                  Worker.setCookieString(var42);
               } else if (var23 == 16384010) {
                  int var32 = cmdIn.readInt();
                  String var43 = readString();
                  MNetscapePluginObject var49 = getPluginObject(var32);
                  if (var49 != null) {
                     var49.setJSReply(var43);
                  }
               } else if (var23 == 16384011) {
                  int var33 = cmdIn.readInt();
                  MNetscapePluginObject var44 = getPluginObject(var33);
                  if (var44 != null) {
                     var44.finishJSReply();
                  }
               } else if (var23 == 16384020) {
                  Worker.terminateRequestAbruptly();
               } else if (var23 == 16384019) {
                  trace("Attach Thread ");
                  attachThread();
               } else if (var23 == 16384021) {
                  trace("Getting java object");
                  int var34 = cmdIn.readInt();
                  MNetscapePluginObject var45 = getPluginObject(var34);
                  int var50 = 0;
                  if (var45 != null) {
                     var50 = var45.getNativeJavaObject();
                  }

                  cmdOut.writeInt(var50);
                  cmdOut.flush();
               } else if (var23 == 16384025) {
                  trace("Showing Java Console");
                  JavaRunTime.showJavaConsole(true);
               } else if (var23 == 16384026) {
                  trace("Hiding Java Console");
                  JavaRunTime.showJavaConsole(false);
               } else {
                  error("Java process: unexpected request " + Integer.toHexString(var23));
                  this.onExit();
                  System.exit(6);
               }
            }
         }
      } catch (Throwable var18) {
         Throwable var1 = var18;
         if (parentAlive()) {
            error("Java process caught exception: " + var18);
            var18.printStackTrace();
         }

         try {
            FileOutputStream var2 = new FileOutputStream("plugin_stack.trace");
            PrintWriter var3 = new PrintWriter(var2);
            trace("Java process caught exception: " + var1.toString());
            var1.printStackTrace(var3);
            var3.flush();
            var3.close();
         } catch (IOException var13) {
            error("Could not print the stack trace\n");
         }

         trace("Exiting. Navigator may also be dead.");
         this.onExit();
         System.exit(6);
      }
   }

   void initializeCommunication() {
      trace("Opening pipes at this end\n");
      cmdIn = newInput("Command Input", 11);
      cmdOut = newOutput("Command Output", 11);
      DataInputStream var1 = newInput("Work Input", 12);
      DataOutputStream var2 = newOutput("Work Output", 12);
      FileDescriptor var3 = getPipe(13);
      FileOutputStream var4 = new FileOutputStream(var3);
      printOut = new PrintStream(var4);
      Toolkit var5 = Toolkit.getDefaultToolkit();
      trace("Toolkit = " + var5.getClass().getName());
      worker = new Worker(var1, var2);
      trace("Initialized worker");

      try {
         cmdOut.write(17);
         cmdOut.flush();
         trace("Wrote initial ack on command pipe");
      } catch (IOException var7) {
         error("Error in writing back to the parent");
      }

      trace("Wrote the initial ack\n");
   }

   private static void loadLibrary() {
      String var0 = System.getProperty("javaplugin.lib");

      try {
         System.load(var0);
      } catch (UnsatisfiedLinkError var2) {
         System.err.println("Plugin could not load:" + var0);
         System.err.println("Path is:" + System.getProperty("java.library.path"));
         System.err.println(var2.toString());
      }
   }

   protected void onExit() {
      LifeCycleManager.destroyCachedAppletPanels();
   }

   private static void replyOK() throws IOException {
      trace("Sending OK reply");
      cmdOut.writeInt(16449537);
      cmdOut.flush();
   }

   static boolean getTracing() {
      return tracing;
   }

   public static boolean getTracingFlag() {
      return tracing;
   }

   static native boolean parentAlive();

   private static byte[] readByteArray() throws IOException {
      int var0 = cmdIn.readInt();
      byte[] var1 = new byte[var0];

      for (int var2 = 0; var2 < var0; var2++) {
         var1[var2] = cmdIn.readByte();
      }

      return var1;
   }

   public static void start(boolean var0) {
      tracing = var0;
      Color var1 = Color.black;
      loadLibrary();
      String var2 = System.getProperty("javaplugin.nodotversion");
      Progress = System.getProperty("progressON");
      if (tracing) {
         String var3 = "plugin_java" + var2 + ".trace";

         try {
            String var4 = System.getProperty("user.name", "unknown");
            var3 = "/tmp/plugin_java" + var2 + "_" + var4 + ".trace";
            tracefile = new BufferedWriter(new FileWriter(var3));
         } catch (IOException var5) {
            error("Could not create " + var3);
         }
      }

      String var6 = getenv("JAVA_PLUGIN_AGENT");
      if (var6.indexOf("Mozilla/3") >= 0) {
         trace("Setting Mozilla version to 3");
         navig_version = 3;
      } else if (var6.indexOf("Mozilla/4") >= 0) {
         trace("Setting Mozilla version to 4");
         navig_version = 4;
      } else {
         trace("Setting Mozilla version to 5");
         navig_version = 5;
      }

      Plugin var7 = new Plugin();
      var7.doit();
   }

   static native FileDescriptor getPipe(int var0);

   private static String readString() throws IOException {
      int var0 = cmdIn.readUnsignedShort();
      byte[] var1 = new byte[var0];

      for (int var2 = 0; var2 < var0; var2++) {
         var1[var2] = cmdIn.readByte();
      }

      String var3 = new String(var1, encoding);
      trace("readString:" + var3);
      return var3;
   }

   public static String protocol_to_str(int var0) {
      switch (var0) {
         case 16384001:
            return "JAVA_PLUGIN_NEW";
         case 16384002:
            return "JAVA_PLUGIN_DESTROY";
         case 16384003:
            return "JAVA_PLUGIN_WINDOW";
         case 16384004:
            return "JAVA_PLUGIN_SHUTDOWN";
         case 16384005:
            return "JAVA_PLUGIN_DOCBASE";
         case 16384007:
            return "JAVA_PLUGIN_PROXY_MAPPING";
         case 16384008:
            return "JAVA_PLUGIN_COOKIE     ";
         case 16384010:
            return "JAVA_PLUGIN_JAVASCRIPT_REPLY";
         case 16384011:
            return "JAVA_PLUGIN_JAVASCRIPT_END";
         case 16384017:
            return "JAVA_PLUGIN_START";
         case 16384018:
            return "JAVA_PLUGIN_STOP";
         case 16384019:
            return "JAVA_PLUGIN_ATTACH_THRE";
         case 16384020:
            return "JAVA_PLUGIN_REQUEST_ABRUPTLY_TERMINATED";
         case 16384022:
            return "JAVA_PLUGIN_PRINT";
         case 16384025:
            return "JAVA_PLUGIN_CONSOLE_SHOW";
         case 16384026:
            return "JAVA_PLUGIN_CONSOLE_HIDE";
         case 16449537:
            return "JAVA_PLUGIN_OK";
         default:
            return "Unknown code:" + var0;
      }
   }

   public static void error(String var0) {
      System.err.println("                      PLUGIN ERROR ");
      System.err.println("                      ************ ");
      System.err.println(var0);
      System.err.println("\n");
      trace(var0);
   }

   public static void trace(String var0) {
      if (tracing) {
         try {
            System.err.println("Child: " + var0);
            tracefile.write(var0);
            tracefile.newLine();
         } catch (IOException var2) {
            System.err.println("Could not write to trace file");
         }
      }
   }

   public static MNetscapePluginObject getPluginObject(int var0) {
      Integer var1 = new Integer(var0);
      MNetscapePluginObject var2 = (MNetscapePluginObject)panels.get(var1);
      if (var2 == null) {
         error("Could not find a Viewer for " + var0);
      } else {
         trace("Found a viewer for:" + var0);
      }

      return var2;
   }

   static DataInputStream newInput(String var0, int var1) {
      trace("Creating input pipe:" + var0 + " fd = " + var1);
      FileDescriptor var2 = getPipe(var1);
      FileInputStream var3 = new FileInputStream(var2);
      return new DataInputStream(var3);
   }

   static DataOutputStream newOutput(String var0, int var1) {
      trace("Creating output pipe:" + var0 + " fd = " + var1);
      FileDescriptor var2 = getPipe(var1);
      FileOutputStream var3 = new FileOutputStream(var2);
      BufferedOutputStream var4 = new BufferedOutputStream(var3);
      return new DataOutputStream(var4);
   }

   private static String evalString(int var0, String var1) {
      MNetscapePluginObject var2 = (MNetscapePluginObject)panels.get(new Integer(var0));
      return var2 != null ? var2.evalString(var0, var1) : null;
   }

   private static native String getenv(String var0);

   private class Watcher extends Thread {
      private final Plugin this$0;

      public void run() {
         Plugin.trace(" Starting watcher\n");

         while (true) {
            try {
               Thread.sleep(30000L);
            } catch (InterruptedException var2) {
            }

            if (!Plugin.parentAlive()) {
               Plugin.trace(" exiting due to parent death");
               this.this$0.onExit();
               System.exit(2);
            }
         }
      }

      private Watcher(Plugin var1) {
         this.this$0 = var1;
      }

      Watcher(Plugin var1, <unrepresentable> var2) {
         this(var1);
      }
   }
}
