package sun.plugin.navig.motif;

import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;
import java.net.MalformedURLException;
import java.net.URL;
import java.util.Hashtable;

public class Worker {
   private static DataInputStream data_in;
   private static DataOutputStream data_out;
   private static Hashtable proxmap = new Hashtable();
   private static String cookieString = null;
   public static final int JAVA_PLUGIN_SHOW_STATUS = 16121857;
   public static final int JAVA_PLUGIN_SHOW_DOCUMENT = 16121858;
   public static final int JAVA_PLUGIN_FIND_PROXY = 16121859;
   public static final int JAVA_PLUGIN_FIND_COOKIE = 16121860;
   public static final int JAVA_PLUGIN_JAVASCRIPT_REQUEST = 16121862;
   public static final int JAVA_PLUGIN_SET_COOKIE = 16121865;
   private static String requestName;
   private static final int REQUEST_IDLE = 1;
   private static final int REQUEST_IN_PROGRESS = 2;
   private static final int RESPONSE_IS_READY = 3;
   private static final int REQUEST_ABRUPTLY_TERMINATED = 4;
   private static int requestStatus = 1;
   static Class class$sun$plugin$navig$motif$Worker;

   static synchronized void clearRequest() {
      Plugin.trace("Request was cleared");
      requestStatus = 1;
      (class$sun$plugin$navig$motif$Worker == null
            ? (class$sun$plugin$navig$motif$Worker = class$("sun.plugin.navig.motif.Worker"))
            : class$sun$plugin$navig$motif$Worker)
         .notifyAll();
   }

   static synchronized void terminateAbruptly() {
      Plugin.trace("Request was abruptly terminated");
      if (requestStatus != 1) {
         requestStatus = 4;
      }

      (class$sun$plugin$navig$motif$Worker == null
            ? (class$sun$plugin$navig$motif$Worker = class$("sun.plugin.navig.motif.Worker"))
            : class$sun$plugin$navig$motif$Worker)
         .notifyAll();
   }

   static synchronized void terminateRequestAbruptly() {
      terminateAbruptly();
   }

   private static synchronized void writeByteArr(byte[] var0) throws IOException {
      data_out.writeInt(var0.length);

      for (int var1 = 0; var1 < var0.length; var1++) {
         data_out.writeByte(var0[var1]);
      }
   }

   public static synchronized void sendJSRequest(int var0, String var1) {
      try {
         data_out.writeInt(16121862);
         data_out.writeShort((short)var0);
         data_out.writeShort(0);
         writeString(var1);
         pushRequest("JS Request");
      } catch (IOException var3) {
         System.err.println("sendJSRequest: io error in Plugin " + var3);
      }
   }

   public static synchronized void showStatus(int var0, String var1) {
      try {
         if (!Plugin.parentAlive()) {
            return;
         }

         if (var1 == null) {
            var1 = "";
         }

         data_out.writeInt(16121857);
         data_out.writeShort(var0);
         writeString(var1);
         pushRequest("showstatus:" + var1);
      } catch (IOException var3) {
         Plugin.error("java process show status: write to parent failed\nException: " + var3.toString());
      }
   }

   static synchronized void enterRequest(String var0) {
      try {
         while (true) {
            if (requestStatus != 1) {
               (class$sun$plugin$navig$motif$Worker == null
                     ? (class$sun$plugin$navig$motif$Worker = class$("sun.plugin.navig.motif.Worker"))
                     : class$sun$plugin$navig$motif$Worker)
                  .wait();
            } else {
               requestName = var0;
               requestStatus = 2;
               Plugin.trace("Entering request for:" + var0);
               break;
            }
         }
      } catch (InterruptedException var2) {
         Plugin.trace("Request was interrupted when entering");
      }
   }

   private static synchronized void pushRequest(String var0) throws IOException {
      data_out.flush();
      Plugin.trace("Worker pushRequest:" + var0);
   }

   static synchronized void responseIsReady(String var0) {
      Plugin.trace("Response is ready:" + var0);
      requestStatus = 3;
      (class$sun$plugin$navig$motif$Worker == null
            ? (class$sun$plugin$navig$motif$Worker = class$("sun.plugin.navig.motif.Worker"))
            : class$sun$plugin$navig$motif$Worker)
         .notifyAll();
   }

   static synchronized void setCookieString(String var0) {
      cookieString = var0;
      responseIsReady("Cookie");
   }

   private static synchronized void writeString(String var0) throws IOException {
      data_out.writeInt(var0.length());

      for (int var1 = 0; var1 < var0.length(); var1++) {
         char var2 = var0.charAt(var1);
         data_out.writeByte((byte)var2);
      }
   }

   static synchronized boolean waitForResponse(String var0) {
      Plugin.trace("Waiting for response: " + var0);

      try {
         while (requestStatus != 3) {
            (class$sun$plugin$navig$motif$Worker == null
                  ? (class$sun$plugin$navig$motif$Worker = class$("sun.plugin.navig.motif.Worker"))
                  : class$sun$plugin$navig$motif$Worker)
               .wait();
            Plugin.trace("Woke up in request for:" + var0);
            if (requestStatus == 4) {
               clearRequest();
               return false;
            }
         }

         Plugin.trace("Got response for request:" + var0);
         return true;
      } catch (InterruptedException var2) {
         Plugin.trace("Request was interrupted before response");
         return false;
      }
   }

   Worker(DataInputStream var1, DataOutputStream var2) {
      data_out = var2;
      data_in = var1;
   }

   static Class class$(String var0) {
      try {
         return Class.forName(var0);
      } catch (ClassNotFoundException var2) {
         throw new NoClassDefFoundError().initCause(var2);
      }
   }

   public static synchronized String findCookieForURL(String var0) {
      Plugin.trace("Worker.findCookieForURL: " + var0);

      try {
         enterRequest("Cookie");
         cookieString = null;
         data_out.writeInt(16121860);
         data_out.writeShort(-1);
         writeString(var0);
         pushRequest("FindCookie");
         waitForResponse("Cookie");
         String var1 = cookieString;
         clearRequest();
         Plugin.trace(" Got cookie string:" + var1);
         return var1;
      } catch (IOException var2) {
         System.err.println("IOException in findCookieURL");
         System.err.println("Bad termination of cookie request!");
         clearRequest();
         return null;
      }
   }

   public static synchronized String getProxySettings(String var0) {
      try {
         URL var1 = new URL(var0);
         String var2 = var1.getProtocol() + ":" + var1.getHost() + ":" + var1.getPort();
         Plugin.trace("getProxySettings. Using key:" + var2);
         String var3 = (String)proxmap.get(var2);
         if (var3 != null) {
            Plugin.trace("Retrieving cached proxy:" + var3);
            return var3;
         }

         enterRequest("Proxy");
         data_out.writeInt(16121859);
         data_out.writeShort(-1);
         writeString(var0);
         writeString(var1.getHost());
         pushRequest("FindProxy");
         waitForResponse("Proxy");
         var3 = (String)proxmap.get(var2);
         clearRequest();
         return var3;
      } catch (MalformedURLException var4) {
         System.err.println("Bad URL in getProxySettings: " + var0);
      } catch (IOException var5) {
         System.err.println("getProxySettings: IO error on plugin");
      }

      clearRequest();
      return null;
   }

   static synchronized void addProxyMapping(String var0, String var1) {
      try {
         URL var2 = new URL(var0);
         String var3 = var2.getProtocol() + ":" + var2.getHost() + ":" + var2.getPort();
         proxmap.put(var3, var1);
         responseIsReady("Proxy");
      } catch (MalformedURLException var4) {
         System.err.println("Bad URL in getting proxy: " + var0);
      }
   }

   public static synchronized void showDocument(int var0, URL var1, String var2) {
      try {
         data_out.writeInt(16121858);
         data_out.writeShort(var0);
         writeString("" + var1);
         writeString(var2);
         pushRequest("showDocument");
      } catch (IOException var4) {
         Plugin.error("java process showDocument: write to parent failed\nException: " + var4.toString());
      }
   }

   public static synchronized String setCookieForURL(String var0, String var1) {
      Plugin.trace("Worker.setCookieForURL: " + var0 + "=" + var1);

      try {
         data_out.writeInt(16121865);
         data_out.writeShort(-1);
         writeString("" + var0);
         writeString("" + var1);
         pushRequest("setCookie");
      } catch (IOException var3) {
         Plugin.error("java process setCookie: write to parent failed\nException: " + var3.toString());
      }

      return null;
   }
}
