package sun.plugin.net.protocol.ftp;

import java.io.IOException;
import java.net.URL;
import java.net.URLConnection;
import java.net.URLStreamHandler;
import sun.net.ftp.FtpClient;
import sun.net.www.protocol.ftp.FtpURLConnection;
import sun.plugin.net.protocol.http.HttpURLConnection;
import sun.plugin.net.proxy.PluginProxyManager;
import sun.plugin.net.proxy.ProxyInfo;

public class Handler extends URLStreamHandler {
   protected int getDefaultPort() {
      return 21;
   }

   protected boolean equals(URL var1, URL var2) {
      String var3 = var1.getUserInfo();
      String var4 = var2.getUserInfo();
      return super.equals(var1, var2) && (var3 == null ? var4 == null : var3.equals(var4));
   }

   protected URLConnection openConnection(URL var1) {
      ProxyInfo var2 = PluginProxyManager.getProxyInfo(var1);

      try {
         return (URLConnection)(var2 != null && var2.isProxyUsed()
            ? new HttpURLConnection(var1, var2.getProxy(), var2.getPort())
            : this.superOpenConnection(var1));
      } catch (IOException var4) {
         return this.superOpenConnection(var1);
      }
   }

   protected URLConnection superOpenConnection(URL var1) {
      try {
         if (FtpClient.getUseFtpProxy()) {
            String var2 = FtpClient.getFtpProxyHost();
            if (var2 != null && var2.length() > 0) {
               return new HttpURLConnection(var1, var2, FtpClient.getFtpProxyPort());
            }
         }
      } catch (IOException var3) {
      }

      return new FtpURLConnection(var1);
   }
}
