package sun.plugin.net.protocol.http;

import java.io.IOException;
import java.net.Socket;
import java.net.URL;
import java.net.UnknownHostException;
import java.security.AccessController;
import java.security.PrivilegedActionException;
import sun.plugin.net.proxy.PluginProxyManager;
import sun.plugin.net.proxy.ProxyInfo;

public final class HttpClient extends sun.net.www.http.HttpClient {
   private boolean resolveProxy = true;

   public HttpClient(URL var1, String var2, int var3, boolean var4) throws IOException {
      super(var1, var2, var3);
      this.resolveProxy = var4;
   }

   protected Socket doConnect(String var1, int var2) throws IOException, UnknownHostException {
      if (this.resolveProxy) {
         ProxyInfo var3 = PluginProxyManager.getProxyInfo(this.url);
         if (var3 != null && var3.isSocksUsed()) {
            try {
               return AccessController.doPrivileged(new HttpClient$1(this, var1, var2, var3));
            } catch (PrivilegedActionException var6) {
               IOException var5 = (IOException)var6.getException();
               throw var5;
            }
         }
      }

      return super.doConnect(var1, var2);
   }

   public static sun.net.www.http.HttpClient New(URL var0, String var1, int var2, boolean var3) throws IOException {
      Object var4 = kac.get(var0, null);
      HttpClient var5 = null;
      if (var4 instanceof HttpClient) {
         var5 = (HttpClient)var4;
      }

      if (var5 == null) {
         var5 = new HttpClient(var0, var1, var2, var3);
      } else {
         SecurityManager var6 = System.getSecurityManager();
         if (var6 != null) {
            var6.checkConnect(var0.getHost(), var0.getPort());
         }

         var5.url = var0;
      }

      return var5;
   }
}
