package sun.plugin.net.proxy;

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.io.StringWriter;
import java.net.InetAddress;
import java.net.MalformedURLException;
import java.net.URL;
import java.util.StringTokenizer;
import netscape.javascript.JSObject;
import sun.applet.AppletPanel;
import sun.plugin.net.protocol.http.HttpURLConnection;
import sun.plugin.services.BrowserService;
import sun.plugin.services.ServiceProvider;
import sun.plugin.services.ServiceUnavailableException;
import sun.plugin.util.Trace;
import sun.plugin.viewer.AppletPanelCache;
import sun.plugin.viewer.context.PluginAppletContext;

public class AutoProxyHandler implements ProxyHandler {
   private BrowserProxyInfo bpi = null;
   private StringBuffer autoProxyScript = null;

   public boolean isProxyCacheSupported() {
      return true;
   }

   public boolean isSupported(int var1) {
      return var1 == 2;
   }

   public void init(BrowserProxyInfo var1) throws ProxyConfigException {
      Trace.msgNetPrintln("net.proxy.loading.auto");
      if (!this.isSupported(var1.getType())) {
         throw new ProxyConfigException("Unable to support proxy type: " + var1.getType());
      } else {
         this.bpi = var1;
         BrowserService var2 = ServiceProvider.getService();
         this.autoProxyScript = new StringBuffer();
         this.autoProxyScript
            .append(
               "var _mon = new Array('JAN', 'FEB', 'MAR', 'APR', 'MAY', 'JUN', 'JUL', 'AUG', 'SEP', 'OCT', 'NOV', 'DEC');var _day = new Array('SUN', 'MON', 'TUE', 'WED', 'THU', 'FRI', 'SAT');function _isGmt(i) { return typeof i == 'string' && i == 'GMT'; }"
            );
         this.autoProxyScript
            .append("function dnsDomainIs(host, domain) {if (domain != null && domain.charAt(0) != '.')return false;return shExpMatch(host, '*' + domain); }");
         this.autoProxyScript.append("function isPlainHostName(host){return (dnsDomainLevels(host) == 0); }");
         if (var2.isIExplorer()) {
            this.autoProxyScript
               .append(
                  "function isInNet(host, pattern, mask){if (typeof host != 'string' || typeof pattern != 'string' || typeof mask != 'string') return false; if (dnsDomainLevels(pattern) != 3 || dnsDomainLevels(mask) != 3)return false;var hostInIpFormat = dnsResolve(host);var offset1 = 0, offset2 = 0, ofs1 = 0, ofs2 = 0;var m = '', result;for (var i=0; i < 4; i++){ofs1 = pattern.indexOf('.', offset1);ofs2 = mask.indexOf('.', offset2);if (i != 3)result = (pattern.substring(offset1, ofs1) - 0) & (mask.substring(offset2, ofs2) - 0);else result = (pattern.substring(offset1) & mask.substring(offset2));if (result == 0)result = '*';m = m + result;if (i != 3)m = m + '.';offset1 = ofs1 + 1;offset2 = ofs2 + 1;}return shExpMatch(hostInIpFormat, m); }"
               );
            this.autoProxyScript
               .append(
                  "function dnsResolve(host){if (typeof host != 'string') return ''; var isIpFormat = false;if (dnsDomainLevels(host) == 3){for (var i=0; i < host.length; i++){if ((host.charAt(i) >= '0' && host.charAt(i) <= '9') || host.charAt(i) == '.') isIpFormat = true;else {isIpFormat = false;break;}}}if (isIpFormat == true) return host;else {var jpi = new ActiveXObject('JavaPlugin');return jpi.dnsResolve(host);}}"
               );
         } else {
            this.autoProxyScript
               .append(
                  "function isInNet(host, pattern, mask){if (typeof host != 'string' || typeof pattern != 'string' || typeof mask != 'string') return false; if (dnsDomainLevels(pattern) != 3 || dnsDomainLevels(mask) != 3)return false;var offset1 = 0, offset2 = 0, ofs1 = 0, ofs2 = 0;var m = '', result;for (var i=0; i < 4; i++){ofs1 = pattern.indexOf('.', offset1);ofs2 = mask.indexOf('.', offset2);if (i != 3)result = (pattern.substring(offset1, ofs1) - 0) & (mask.substring(offset2, ofs2) - 0);else result = (pattern.substring(offset1) & mask.substring(offset2));if (result == 0)result = '*';m = m + result;if (i != 3)m = m + '.';offset1 = ofs1 + 1;offset2 = ofs2 + 1;}return shExpMatch(host, m); }"
               );
            this.autoProxyScript
               .append(
                  "function dnsResolve(host){if (typeof host != 'string' || dnsDomainLevels(host) != 3) return ''; for (var i=0; i < host.length; i++) if ((host.charAt(i) < '0' || host.charAt(i) > '9') && host.charAt(i) != '.') return ''; return host; }"
               );
         }

         this.autoProxyScript.append("function isResolvable(host){return (dnsResolve(host) != ''); }");
         this.autoProxyScript.append("function localHostOrDomainIs(host, hostdom){return shExpMatch(hostdom, host + '*'); }");
         this.autoProxyScript
            .append("function dnsDomainLevels(host){var s = host + '';for (var i=0, j=0; i < s.length; i++)if (s.charAt(i) == '.')j++;return j; }");
         this.autoProxyScript.append("function myIpAddress(){return '");

         try {
            InetAddress var3 = InetAddress.getLocalHost();
            this.autoProxyScript.append(var3.getHostAddress());
         } catch (Throwable var6) {
            var6.printStackTrace();
            this.autoProxyScript.append("127.0.0.1");
         }

         this.autoProxyScript.append("'; }");
         this.autoProxyScript
            .append(
               "function shExpMatch(str, shexp){  if (typeof str != 'string' || typeof shexp != 'string') return false;  if (shexp == '*') return true;  if (str == '' && shexp == '') return true;  str = str.toLowerCase(); shexp = shexp.toLowerCase(); var index = shexp.indexOf('*'); if (index == -1) { return (str == shexp); }  else if (index == 0) {  for (var i=0; i <= str.length; i++) {  if (shExpMatch(str.substring(i), shexp.substring(1))) return true;  } return false; } else { var sub = null, sub2 = null; sub = shexp.substring(0, index);if (index <= str.length) sub2 = str.substring(0, index); if (sub != '' && sub2 != '' && sub == sub2) { return shExpMatch(str.substring(index), shexp.substring(index)); }else {\treturn false; }} }"
            );
         this.autoProxyScript
            .append(
               "function _dateRange(day1, month1, year1, day2, month2, year2, gmt){if (typeof day1 != 'number' || day1 <= 0 || typeof month1 != 'string' || typeof year1 != 'number' || year1 <= 0 || typeof day2 != 'number' || day2 <= 0 || typeof month2 != 'string' || typeof year2 != 'number' || year2 <= 0 || typeof gmt != 'boolean') return false; var m1 = -1, m2 = -1;for (var i=0; i < _mon.length; i++){if (_mon[i] == month1)m1 = i;if (_mon[i] == month2)m2 = i;}var cur = new Date();var d1 = new Date(year1, m1, day1, 0, 0, 0);var d2 = new Date(year2, m2, day2, 23, 59, 59);if (gmt == true)cur = new Date(cur.getTime() - cur.getTimezoneOffset() * 60 * 1000);return ((d1.getTime() <= cur.getTime()) && (cur.getTime() <= d2.getTime()));}function dateRange(p1, p2, p3, p4, p5, p6, p7){var cur = new Date();if (typeof p1 == 'undefined')return false;else if (typeof p2 == 'undefined' || _isGmt(p2)){if ((typeof p1) == 'string')return _dateRange(1, p1, cur.getFullYear(), 31, p1, cur.getFullYear(), _isGmt(p2));else if (typeof p1 == 'number' && p1 > 31)return _dateRange(1, 'JAN', p1, 31, 'DEC', p1, _isGmt(p2));else {for (var i=0; i < _mon.length; i++)if (_dateRange(p1, _mon[i], cur.getFullYear(), p1, _mon[i], cur.getFullYear(), _isGmt(p2))) return true;return false;}}else if (typeof p3 == 'undefined' || _isGmt(p3)){if ((typeof p1) == 'string')return _dateRange(1, p1, cur.getFullYear(), 31, p2, cur.getFullYear(), _isGmt(p3));else if (typeof p1 == 'number' && typeof p2 == 'number' && (p1 > 31 || p2 > 31))return _dateRange(1, 'JAN', p1, 31, 'DEC', p2, _isGmt(p3));else {if ((typeof p2) == 'string'){return _dateRange(p1, p2, cur.getFullYear(), p1, p2, cur.getFullYear(), _isGmt(p3));}else {for (var i=0; i < _mon.length; i++)if (_dateRange(p1, _mon[i], cur.getFullYear(), p2, _mon[i], cur.getFullYear(), _isGmt(p3)))return true;return false;}}}else if (typeof p4 == 'undefined' || _isGmt(p4))return _dateRange(p1, p2, p3, p1, p2, p3, _isGmt(p4));else if (typeof p5 == 'undefined' || _isGmt(p5)){if (typeof p2 == 'number')return _dateRange(1, p1, p2, 31, p3, p4, _isGmt(p5));else return _dateRange(p1, p2, cur.getFullYear(), p3, p4, cur.getFullYear(), _isGmt(p5))}else if (typeof p6 == 'undefined')return false;else return _dateRange(p1, p2, p3, p4, p5, p6, _isGmt(p7));}"
            );
         this.autoProxyScript
            .append(
               "function timeRange(p1, p2, p3, p4, p5, p6, p7) {if (typeof p1 == 'undefined')return false;else if (typeof p2 == 'undefined' || _isGmt(p2))return _timeRange(p1, 0, 0, p1, 59, 59, _isGmt(p2));else if (typeof p3 == 'undefined' || _isGmt(p3))return _timeRange(p1, 0, 0, p2, 0, 0, _isGmt(p3));else if (typeof p4 == 'undefined')return false;else if (typeof p5 == 'undefined' || _isGmt(p5))return _timeRange(p1, p2, 0, p3, p4, 0, _isGmt(p5));else if (typeof p6 == 'undefined')return false;else return _timeRange(p1, p2, p3, p4, p5, p6, _isGmt(p7));}function _timeRange(hour1, min1, sec1, hour2, min2, sec2, gmt) {if (typeof hour1 != 'number' || typeof min1 != 'number' || typeof sec1 != 'number' || hour1 < 0 || min1 < 0 || sec1 < 0 || typeof hour2 != 'number' || typeof min2 != 'number' || typeof sec2 != 'number' || hour2 < 0 || min2 < 0 || sec2 < 0 || typeof gmt != 'boolean')  return false; var cur = new Date();var d1 = new Date();var d2 = new Date();d1.setHours(hour1);d1.setMinutes(min1);d1.setSeconds(sec1);d2.setHours(hour2);d2.setMinutes(min2);d2.setSeconds(sec2);if (gmt == true)cur = new Date(cur.getTime() - cur.getTimezoneOffset() * 60 * 1000);return ((d1.getTime() <= cur.getTime()) && (cur.getTime() <= d2.getTime()));}"
            );
         this.autoProxyScript
            .append(
               "function weekdayRange(wd1, wd2, gmt){if (typeof wd1 == 'undefined') return false;else if (typeof wd2 == 'undefined' || _isGmt(wd2)) return _weekdayRange(wd1, wd1, _isGmt(wd2)); else return _weekdayRange(wd1, wd2, _isGmt(gmt)); }function _weekdayRange(wd1, wd2, gmt) {if (typeof wd1 != 'string' || typeof wd2 != 'string' || typeof gmt != 'boolean') return false; var w1 = -1, w2 = -1;for (var i=0; i < _day.length; i++) {if (_day[i] == wd1)w1 = i;if (_day[i] == wd2)w2 = i; }var cur = new Date();if (gmt == true)cur = new Date(cur.getTime() - cur.getTimezoneOffset() * 60 * 1000);var w3 = cur.getDay();if (w1 > w2)w2 = w2 + 7;if (w1 > w3)w3 = w3 + 7;return (w1 <= w3 && w3 <= w2); }"
            );
         String var7 = this.bpi.getAutoConfigURL();

         try {
            new URL(var7);
         } catch (MalformedURLException var5) {
            throw new ProxyConfigException("Auto config URL is malformed");
         }

         if (var7.toLowerCase().endsWith(".ins")) {
            var7 = this.getAutoConfigURLFromINS(var7);
         }

         this.autoProxyScript.append(this.getJSFileFromURL(var7));
         Trace.msgNetPrintln("net.proxy.loading.done");
      }
   }

   private String fileurlNormalize(String var1) {
      if (!var1.startsWith("file")) {
         return var1;
      } else {
         int var2 = var1.indexOf(47);

         while (var1.charAt(++var2) == '/') {
         }

         return "file:/" + var1.substring(var2);
      }
   }

   private String getAutoConfigURLFromINS(String var1) throws ProxyConfigException {
      Trace.msgNetPrintln("net.proxy.auto.download.ins", new Object[]{var1});

      try {
         URL var2 = new URL(var1);
         String var3 = var2.getProtocol();
         Object var4 = null;
         if (var3.equals("file")) {
            var2 = new URL(this.fileurlNormalize(var1));
            var4 = var2.openConnection();
         } else if (var3.equals("http")) {
            var4 = new HttpURLConnection(var2, null, -1, false);
         } else {
            var4 = var2.openConnection();
         }

         BufferedReader var5 = new BufferedReader(new InputStreamReader(var4.getInputStream()));
         String var6 = null;
         String var7 = null;

         do {
            var6 = var5.readLine();
            if (var6 != null && var6.indexOf("AutoConfigJSURL=") == 0) {
               var7 = var6.substring(16);
               break;
            }
         } while (var6 != null);

         var5.close();
         if (var7 != null) {
            return var7;
         } else {
            throw new ProxyConfigException("Unable to locate 'AutoConfigJSURL' in INS file");
         }
      } catch (ProxyConfigException var8) {
         throw var8;
      } catch (Throwable var9) {
         throw new ProxyConfigException("Unable to obtain INS file from " + var1, var9);
      }
   }

   private String getJSFileFromURL(String var1) throws ProxyConfigException {
      Trace.msgNetPrintln("net.proxy.auto.download.js", new Object[]{var1});

      try {
         URL var2 = new URL(var1);
         String var3 = var2.getProtocol();
         Object var4 = null;
         if (var3.equals("file")) {
            var2 = new URL(this.fileurlNormalize(var1));
            var4 = var2.openConnection();
         } else if (var3.equals("http")) {
            var4 = new HttpURLConnection(var2, null, -1, false);
         } else {
            var4 = var2.openConnection();
         }

         RemoveCommentReader var5 = new RemoveCommentReader(new InputStreamReader(var4.getInputStream()));
         BufferedReader var6 = new BufferedReader(var5);
         StringWriter var7 = new StringWriter();
         char[] var8 = new char[4096];

         int var9;
         while ((var9 = var6.read(var8)) != -1) {
            var7.write(var8, 0, var9);
         }

         var6.close();
         var5.close();
         var7.close();
         return var7.toString();
      } catch (Throwable var10) {
         throw new ProxyConfigException("Unable to obtain auto proxy file from " + var1, var10);
      }
   }

   private ProxyInfo[] extractAutoProxySetting(String var1) {
      if (var1 != null) {
         StringTokenizer var2 = new StringTokenizer(var1, ";", false);
         ProxyInfo[] var3 = new ProxyInfo[var2.countTokens()];
         int var4 = 0;

         while (var2.hasMoreTokens()) {
            String var5 = var2.nextToken();
            int var6 = var5.indexOf("PROXY");
            if (var6 != -1) {
               var3[var4++] = new ProxyInfo(var5.substring(var6 + 6));
            } else {
               var6 = var5.indexOf("SOCKS");
               if (var6 != -1) {
                  var3[var4++] = new ProxyInfo(null, var5.substring(var6 + 6));
               } else {
                  var3[var4++] = new ProxyInfo(null, -1);
               }
            }
         }

         return var3;
      } else {
         return new ProxyInfo[]{new ProxyInfo(null)};
      }
   }

   public ProxyInfo[] getProxyInfo(URL var1) throws ServiceUnavailableException {
      if (!AppletPanelCache.hasValidInstance()) {
         throw new ServiceUnavailableException("Proxy service unavailable");
      } else {
         Object[] var2 = AppletPanelCache.getAppletPanels();
         AppletPanel var3 = (AppletPanel)var2[0];
         PluginAppletContext var4 = (PluginAppletContext)var3.getAppletContext();
         Object var5 = null;

         try {
            JSObject var6 = var4.getJSObject();
            StringBuffer var7 = new StringBuffer();
            var7.append(this.autoProxyScript);
            var7.append("FindProxyForURL('");
            var7.append(var1);
            var7.append("','");
            var7.append(var1.getHost());
            var7.append("');");
            var5 = (String)var6.eval(var7.toString());
            return this.extractAutoProxySetting((String)var5);
         } catch (Throwable var8) {
            Trace.msgNetPrintln("net.proxy.auto.result.error");
            return new ProxyInfo[]{new ProxyInfo(null)};
         }
      }
   }
}
