package sun.plugin.net.proxy;

import java.net.URL;
import java.util.StringTokenizer;
import sun.plugin.util.Trace;

abstract class BrowserProxyHandler_share implements ProxyHandler {
   public final boolean isProxyCacheSupported() {
      return false;
   }

   public final boolean isSupported(int var1) {
      return var1 == 3;
   }

   public final void init(BrowserProxyInfo var1) throws ProxyConfigException {
      Trace.msgNetPrintln("net.proxy.loading.browser");
      if (!this.isSupported(var1.getType())) {
         throw new ProxyConfigException("Unable to support proxy type: " + var1.getType());
      } else {
         Trace.msgNetPrintln("net.proxy.loading.done");
      }
   }

   abstract String findProxyForURL(String var1);

   private ProxyInfo[] extractAutoProxySetting(String var1) {
      if (var1 != null) {
         StringTokenizer var2 = new StringTokenizer(var1, ";", false);
         ProxyInfo[] var3 = new ProxyInfo[var2.countTokens()];
         int var4 = 0;

         while (var2.hasMoreTokens()) {
            String var5 = var2.nextToken();
            int var6 = var5.indexOf("PROXY");
            if (var6 != -1) {
               var3[var4++] = new ProxyInfo(var5.substring(var6 + 6));
            } else {
               var6 = var5.indexOf("SOCKS");
               if (var6 != -1) {
                  var3[var4++] = new ProxyInfo(null, var5.substring(var6 + 6));
               } else {
                  var3[var4++] = new ProxyInfo(null, -1);
               }
            }
         }

         return var3;
      } else {
         return new ProxyInfo[]{new ProxyInfo(null)};
      }
   }

   public final ProxyInfo[] getProxyInfo(URL var1) {
      String var2 = this.findProxyForURL(var1.toString());
      return this.extractAutoProxySetting(var2);
   }
}
