package sun.plugin.net.proxy;

import java.util.ArrayList;
import java.util.List;
import sun.plugin.resources.ResourceHandler;

public class BrowserProxyInfo {
   private int type = 0;
   private String _httpHost;
   private int _httpPort = -1;
   private String _httpsHost;
   private int _httpsPort = -1;
   private String _ftpHost;
   private int _ftpPort = -1;
   private String _gopherHost;
   private int _gopherPort = -1;
   private String _socksHost;
   private int _socksPort = -1;
   private String[] _overrides = null;
   private String _autoConfigURL;

   public int getFtpPort() {
      return this._ftpPort;
   }

   public int getGopherPort() {
      return this._gopherPort;
   }

   public int getHttpPort() {
      return this._httpPort;
   }

   public int getHttpsPort() {
      return this._httpsPort;
   }

   public int getSocksPort() {
      return this._socksPort;
   }

   public int getType() {
      return this.type;
   }

   public void setFtpPort(int var1) {
      this._ftpPort = var1;
   }

   public void setGopherPort(int var1) {
      this._gopherPort = var1;
   }

   public void setHttpPort(int var1) {
      this._httpPort = var1;
   }

   public void setHttpsPort(int var1) {
      this._httpsPort = var1;
   }

   public void setSocksPort(int var1) {
      this._socksPort = var1;
   }

   public void setType(int var1) {
      this.type = var1;
   }

   public String getAutoConfigURL() {
      return this._autoConfigURL;
   }

   public String getFtpHost() {
      return this._ftpHost;
   }

   public String getGopherHost() {
      return this._gopherHost;
   }

   public String getHttpHost() {
      return this._httpHost;
   }

   public String getHttpsHost() {
      return this._httpsHost;
   }

   public String getSocksHost() {
      return this._socksHost;
   }

   public String toString() {
      StringBuffer var1 = new StringBuffer();
      var1.append(ResourceHandler.getMessage("proxy_configuration"));
      switch (this.type) {
         case 0:
            var1.append(ResourceHandler.getMessage("no_proxy"));
            break;
         case 1:
            var1.append(ResourceHandler.getMessage("manual_config"));
            var1.append("\n");
            var1.append("     " + ResourceHandler.getMessage("proxy_is"));
            if (this._httpHost != null) {
               var1.append("http=" + this._httpHost);
               if (this._httpPort != -1) {
                  var1.append(":" + this._httpPort);
               }
            }

            if (this._httpsHost != null) {
               var1.append(",https=" + this._httpsHost);
               if (this._httpsPort != -1) {
                  var1.append(":" + this._httpsPort);
               }
            }

            if (this._ftpHost != null) {
               var1.append(",ftp=" + this._ftpHost);
               if (this._ftpPort != -1) {
                  var1.append(":" + this._ftpPort);
               }
            }

            if (this._gopherHost != null) {
               var1.append(",gopher=" + this._gopherHost);
               if (this._gopherPort != -1) {
                  var1.append(":" + this._gopherPort);
               }
            }

            if (this._socksHost != null) {
               var1.append(",socks=" + this._socksHost);
               if (this._socksPort != -1) {
                  var1.append(":" + this._socksPort);
               }
            }

            var1.append("\n");
            var1.append("     " + ResourceHandler.getMessage("proxy_override_is"));
            if (this._overrides != null) {
               boolean var2 = true;

               for (int var3 = 0; var3 < this._overrides.length; var3++) {
                  if (var3 != 0) {
                     var1.append(",");
                  }

                  var1.append(this._overrides[var3]);
               }
            }
            break;
         case 2:
            var1.append(ResourceHandler.getMessage("auto_config"));
            var1.append("\n");
            var1.append("     URL: " + this._autoConfigURL);
            break;
         case 3:
            var1.append(ResourceHandler.getMessage("browser_config"));
            break;
         default:
            var1.append("<Unrecognized Proxy Type>");
      }

      return var1.toString();
   }

   public String[] getOverrides() {
      return this._overrides;
   }

   void setAutoConfigURL(String var1) {
      this._autoConfigURL = var1;
   }

   public void setFtpHost(String var1) {
      this._ftpHost = var1;
   }

   public void setGopherHost(String var1) {
      this._gopherHost = var1;
   }

   public void setHttpHost(String var1) {
      this._httpHost = var1;
   }

   public void setHttpsHost(String var1) {
      this._httpsHost = var1;
   }

   public void setSocksHost(String var1) {
      this._socksHost = var1;
   }

   public void setOverrides(String[] var1) {
      this._overrides = var1;
   }

   public void setOverrides(List var1) {
      if (var1 != null) {
         ArrayList var2 = new ArrayList(var1);
         this._overrides = new String[var2.size()];
         this._overrides = var2.toArray(this._overrides);
      }
   }
}
