package sun.plugin.panel;

import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.BorderFactory;
import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.ButtonGroup;
import javax.swing.JCheckBox;
import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import javax.swing.border.Border;

public class BasicPanel extends ActivatorSubPanel implements ActionListener {
   private JCheckBox showException = null;
   private JCheckBox showSysTray = null;
   private MessageHandler mh = new MessageHandler("basic");
   private JRadioButton show;
   private JRadioButton hide;
   private JRadioButton nothing;
   private ButtonGroup one;

   public void reset() {
      String var1 = this.model.isConsoleEnabled();
      if (var1.equalsIgnoreCase("show")) {
         this.show.setSelected(true);
      }

      if (var1.equalsIgnoreCase("hide")) {
         this.hide.setSelected(true);
      }

      if (var1.equalsIgnoreCase("nothing")) {
         this.nothing.setSelected(true);
      }

      if (this.showSysTray != null) {
         this.showSysTray.setSelected(this.model.isSysTrayEnabled());
      }

      this.showException.setSelected(this.model.isShowExceptionEnabled());
   }

   public void actionPerformed(ActionEvent var1) {
      if (var1.getSource() == this.show) {
         this.model.setConsoleEnabled("show");
      }

      if (var1.getSource() == this.hide) {
         this.model.setConsoleEnabled("hide");
      }

      if (var1.getSource() == this.nothing) {
         this.model.setConsoleEnabled("nothing");
      }

      if (var1.getSource() == this.showException) {
         this.model.setShowException(this.showException.isSelected());
      }

      if (var1.getSource() == this.showSysTray) {
         this.model.setShowSysTray(this.showSysTray.isSelected());
      }
   }

   BasicPanel(ConfigurationInfo var1) {
      super(var1);
      this.setLayout(new BoxLayout(this, 1));
      Dimension var2 = new Dimension(1, 5);
      JPanel var3 = new JPanel();
      var3.setLayout(new BoxLayout(var3, 0));
      this.add(var3);
      JPanel var4 = new JPanel();
      var4.setLayout(new BoxLayout(var4, 1));
      Border var5 = BorderFactory.createEtchedBorder();
      var4.setBorder(
         BorderFactory.createCompoundBorder(
            BorderFactory.createEmptyBorder(4, 4, 4, 4), BorderFactory.createTitledBorder(var5, this.mh.getMessage("java_console"))
         )
      );
      JPanel var6 = new JPanel();
      var6.setLayout(new BoxLayout(var6, 0));
      var4.add(Box.createGlue());
      this.show = new JRadioButton(this.mh.getMessage("show_console"));
      this.hide = new JRadioButton(this.mh.getMessage("hide_console"));
      this.hide.setSelected(true);
      this.nothing = new JRadioButton(this.mh.getMessage("no_console"));
      this.one = new ButtonGroup();
      this.one.add(this.show);
      this.one.add(this.hide);
      this.one.add(this.nothing);
      this.show.addActionListener(this);
      this.hide.addActionListener(this);
      this.nothing.addActionListener(this);
      JPanel var7 = new JPanel();
      var7.setLayout(new BoxLayout(var7, 1));
      var7.add(this.show);
      var7.add(this.hide);
      var7.add(this.nothing);
      var6.add(Box.createRigidArea(new Dimension(15, 1)));
      var6.add(var7);
      var6.add(Box.createGlue());
      var4.add(var6);
      this.add(var4);
      this.add(Box.createRigidArea(var2));
      if (var1.isShowBrowserPanel()) {
         JPanel var8 = new JPanel();
         var8.setLayout(new BoxLayout(var8, 1));
         JPanel var9 = new JPanel();
         var9.setLayout(new BoxLayout(var9, 0));
         this.showSysTray = new JCheckBox(this.mh.getMessage("show_systray"));
         this.showSysTray.addActionListener(this);
         var9.add(this.showSysTray);
         var9.add(Box.createGlue());
         var8.add(var9);
         this.add(var8);
         this.add(Box.createRigidArea(var2));
      }

      JPanel var10 = new JPanel();
      var10.setLayout(new BoxLayout(var10, 1));
      JPanel var11 = new JPanel();
      var11.setLayout(new BoxLayout(var11, 0));
      this.showException = new JCheckBox(this.mh.getMessage("show_exception"));
      this.showException.addActionListener(this);
      var11.add(this.showException);
      var11.add(Box.createGlue());
      var10.add(var11);
      this.add(var10);
      this.add(Box.createRigidArea(new Dimension(1, 10)));
      this.add(Box.createGlue());
      this.add(Box.createRigidArea(new Dimension(1, 10)));
      this.add(Box.createGlue());
      this.add(Box.createGlue());
      this.reset();
   }

   private JComboBox addComboBoxFor(JPanel var1, JLabel var2, String[] var3, int var4) {
      var1.add(var2);
      JComboBox var5 = new JComboBox();

      for (int var6 = 0; var6 < var3.length; var6++) {
         var5.addItem(var3[var6]);
      }

      var5.setSelectedIndex(var4);
      var5.addActionListener(this);
      var1.add(var5);
      return var5;
   }
}
