package sun.plugin.panel;

import java.io.File;
import java.util.Enumeration;
import java.util.Hashtable;
import javax.swing.filechooser.FileFilter;

final class CertFileFilter extends FileFilter {
   private Hashtable filters = null;
   private String description = null;
   private String fullDescription = null;
   private boolean useExtensionsInDescription = true;

   CertFileFilter() {
      this.filters = new Hashtable();
   }

   public boolean isExtensionListInDescription() {
      return this.useExtensionsInDescription;
   }

   public boolean accept(File var1) {
      if (var1 != null) {
         if (var1.isDirectory()) {
            return true;
         }

         String var2 = this.getExtension(var1);
         if (var2 != null && this.filters.get(this.getExtension(var1)) != null) {
            return true;
         }
      }

      return false;
   }

   public String getDescription() {
      if (this.fullDescription == null) {
         if (this.description != null && !this.isExtensionListInDescription()) {
            this.fullDescription = this.description;
         } else {
            this.fullDescription = this.description == null ? "(" : this.description + " (";
            Enumeration var1 = this.filters.keys();
            if (var1 != null) {
               this.fullDescription = this.fullDescription + "." + (String)var1.nextElement();

               while (var1.hasMoreElements()) {
                  this.fullDescription = this.fullDescription + ", ." + (String)var1.nextElement();
               }
            }

            this.fullDescription = this.fullDescription + ")";
         }
      }

      return this.fullDescription;
   }

   void addExtension(String var1) {
      if (this.filters == null) {
         this.filters = new Hashtable(5);
      }

      this.filters.put(var1.toLowerCase(), this);
      this.fullDescription = null;
   }

   void setDescription(String var1) {
      this.description = var1;
      this.fullDescription = null;
   }

   String getExtension(File var1) {
      if (var1 != null) {
         String var2 = var1.getName();
         int var3 = var2.lastIndexOf(46);
         if (var3 > 0 && var3 < var2.length() - 1) {
            return var2.substring(var3 + 1).toLowerCase();
         }
      }

      return null;
   }
}
