package sun.plugin.panel;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.BorderFactory;
import javax.swing.BoxLayout;
import javax.swing.ButtonGroup;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import javax.swing.border.Border;

final class CertificatePanel extends ActivatorSubPanel implements ActionListener {
   private JRadioButton RButton1;
   private JRadioButton RButton2;
   private JRadioButton RButton3;
   private JRadioButton RButton4;
   private ButtonGroup CertGroup;
   private CertAllPanel CertAllPanel;
   private MessageHandler mh = new MessageHandler("cert");

   void reset() {
      this.CertAllPanel.reset();
   }

   public void actionPerformed(ActionEvent var1) {
      if (var1.getSource() == this.RButton1) {
         this.CertAllPanel.setRadioPos(this.mh.getMessage("SignedApplet_value"));
      }

      if (var1.getSource() == this.RButton2) {
         this.CertAllPanel.setRadioPos(this.mh.getMessage("SecureSite_value"));
      }

      if (var1.getSource() == this.RButton3) {
         this.CertAllPanel.setRadioPos(this.mh.getMessage("SignerCA_value"));
      }

      if (var1.getSource() == this.RButton4) {
         this.CertAllPanel.setRadioPos(this.mh.getMessage("SecureSiteCA_value"));
      }

      this.CertAllPanel.reset();
   }

   CertificatePanel(ConfigurationInfo var1) {
      super(var1);
      this.setLayout(new BoxLayout(this, 0));
      JPanel var2 = new JPanel();
      Border var3 = BorderFactory.createEtchedBorder();
      var2.setBorder(
         BorderFactory.createCompoundBorder(BorderFactory.createEmptyBorder(4, 4, 4, 4), BorderFactory.createTitledBorder(var3, this.mh.getMessage("settings")))
      );
      JPanel var4 = new JPanel();
      var4.setLayout(new BoxLayout(var4, 1));
      this.RButton1 = new JRadioButton(this.mh.getMessage("rbutton_signed_applet"));
      this.RButton1.setSelected(true);
      this.RButton2 = new JRadioButton(this.mh.getMessage("rbutton_secure_site"));
      this.RButton3 = new JRadioButton(this.mh.getMessage("rbutton_signer_ca"));
      this.RButton4 = new JRadioButton(this.mh.getMessage("rbutton_secure_site_ca"));
      this.CertGroup = new ButtonGroup();
      this.CertGroup.add(this.RButton1);
      this.CertGroup.add(this.RButton2);
      this.CertGroup.add(this.RButton3);
      this.CertGroup.add(this.RButton4);
      this.RButton1.addActionListener(this);
      this.RButton2.addActionListener(this);
      this.RButton3.addActionListener(this);
      this.RButton4.addActionListener(this);
      var4.add(this.RButton1);
      var4.add(this.RButton2);
      var4.add(this.RButton3);
      var4.add(this.RButton4);
      var2.add(var4);
      this.add(var2);
      this.CertAllPanel = new CertAllPanel(var1);
      this.CertAllPanel.setBorder(BorderFactory.createEmptyBorder(6, 0, 4, 4));
      this.add(this.CertAllPanel);
   }
}
