package sun.plugin.security;

import java.awt.BorderLayout;
import java.awt.Component;
import java.awt.Dimension;
import java.security.cert.Certificate;
import java.security.cert.X509Certificate;
import javax.swing.BorderFactory;
import javax.swing.JButton;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.JTextArea;
import javax.swing.JTree;
import javax.swing.ListSelectionModel;
import javax.swing.LookAndFeel;
import javax.swing.UIManager;
import javax.swing.border.Border;
import javax.swing.tree.DefaultMutableTreeNode;
import sun.misc.HexDumpEncoder;
import sun.plugin.resources.ResourceHandler;
import sun.plugin.util.DialogFactory;
import sun.plugin.util.PluginUIManager;
import sun.plugin.util.Trace;
import sun.security.x509.SerialNumber;

public class CertificateDialog {
   private Certificate[] certs = null;
   private int start = 0;
   private int end = 0;
   private Component parentComponent;
   JTree certChainTree = null;
   final JTable certInfoTable = new JTable();
   final JTextArea textArea = new JTextArea();
   Object[] msg;
   Object[] options;
   static final boolean $assertionsDisabled = !(CertificateDialog.class$sun$plugin$security$CertificateDialog == null
         ? (CertificateDialog.class$sun$plugin$security$CertificateDialog = class$("sun.plugin.security.CertificateDialog"))
         : CertificateDialog.class$sun$plugin$security$CertificateDialog)
      .desiredAssertionStatus();
   static Class class$sun$plugin$security$CertificateDialog;
   static Class class$java$lang$String;
   static Class class$java$lang$Object;

   public void DoModal() {
      if (!Trace.isAutomationEnabled()) {
         DialogFactory.showOptionDialog(this.parentComponent, this.msg, getMessage("cert_dialog.caption"), this.options, this.options[0]);
      }
   }

   private static int getAcceleratorKey(String var0) {
      return ResourceHandler.getAcceleratorKey(var0);
   }

   public CertificateDialog(Certificate[] var1, int var2, int var3) {
      this(null, var1, var2, var3);
   }

   private void showCertificateInfo(X509Certificate var1) {
      String var2 = "V" + var1.getVersion();
      SerialNumber var3 = new SerialNumber(var1.getSerialNumber());
      String var4 = "[" + var3.getNumber() + "]";
      String var5 = "[" + var1.getSigAlgName() + "]";
      String var6 = this.formatDNString(var1.getIssuerDN().toString());
      String var7 = "[From: " + var1.getNotBefore() + ",\n To: " + var1.getNotAfter() + "]";
      String var8 = this.formatDNString(var1.getSubjectDN().toString());
      HexDumpEncoder var9 = new HexDumpEncoder();
      String var10 = var9.encodeBuffer(var1.getSignature());
      Object[][] var11 = new Object[][]{
         {getMessage("cert_dialog.field.Version"), var2},
         {getMessage("cert_dialog.field.SerialNumber"), var4},
         {getMessage("cert_dialog.field.SignatureAlg"), var5},
         {getMessage("cert_dialog.field.Issuer"), var6},
         {getMessage("cert_dialog.field.Validity"), var7},
         {getMessage("cert_dialog.field.Subject"), var8},
         {getMessage("cert_dialog.field.Signature"), var10}
      };
      String[] var12 = new String[]{getMessage("cert_dialog.field"), getMessage("cert_dialog.value")};
      this.certInfoTable.setModel(new CertificateDialog$3(this, var11, var12));
      this.certInfoTable.setRowSelectionInterval(6, 6);
      this.certInfoTable.repaint();
      this.textArea.repaint();
   }

   static Class class$(String var0) {
      try {
         return Class.forName(var0);
      } catch (ClassNotFoundException var2) {
         throw new NoClassDefFoundError().initCause(var2);
      }
   }

   private String formatDNString(String var1) {
      int var2 = var1.length();
      boolean var3 = false;
      boolean var4 = false;
      StringBuffer var5 = new StringBuffer();

      for (int var6 = 0; var6 < var2; var6++) {
         char var7 = var1.charAt(var6);
         if (var7 == '"' || var7 == '\'') {
            var4 = !var4;
         }

         if (var7 == ',' && !var4) {
            var5.append(",\n");
         } else {
            var5.append(var7);
         }
      }

      return var5.toString();
   }

   private static String getMessage(String var0) {
      return ResourceHandler.getMessage(var0);
   }

   public CertificateDialog(Component var1, Certificate[] var2, int var3, int var4) {
      if ($assertionsDisabled || var2 != null && var3 >= 0 && var4 >= 0 && var3 <= var4) {
         LookAndFeel var5 = null;

         try {
            var5 = PluginUIManager.setTheme();
            this.certs = var2;
            this.start = var3;
            this.end = var4;
            this.parentComponent = var1;
            UIManager.getBorder("TableHeader.cellBorder");
            UIManager.getBorder("Table.focusCellHighlightBorder");
            UIManager.getColor("Table.focusCellForeground");
            UIManager.getColor("Table.focusCellBackground");
            JTable var6 = new JTable();
            var6.getDefaultRenderer(class$java$lang$String == null ? (class$java$lang$String = class$("java.lang.String")) : class$java$lang$String);
            var6.getDefaultRenderer(class$java$lang$Object == null ? (class$java$lang$Object = class$("java.lang.Object")) : class$java$lang$Object);
            if (var2.length > var3 && var2[var3] instanceof X509Certificate) {
               Border var7 = BorderFactory.createEtchedBorder();
               this.certChainTree = this.buildCertChainTree(var2, var3, var4);
               this.certChainTree.addTreeSelectionListener(new CertificateDialog$1(this));
               this.showCertificateInfo((X509Certificate)var2[var3]);
               this.certInfoTable.setSelectionMode(0);
               ListSelectionModel var8 = this.certInfoTable.getSelectionModel();
               var8.addListSelectionListener(new CertificateDialog$2(this));
               this.textArea.setLineWrap(false);
               this.textArea.setEditable(false);
               this.textArea.setRows(10);
               this.textArea.setColumns(40);
               this.certInfoTable.setRowSelectionInterval(6, 6);
               JPanel var9 = new JPanel();
               var9.setLayout(new BorderLayout());
               Dimension var10 = this.certInfoTable.getPreferredScrollableViewportSize();
               var10.setSize(var10.getWidth(), 120.0);
               this.certInfoTable.setPreferredScrollableViewportSize(var10);
               JScrollPane var11 = new JScrollPane(this.certInfoTable);
               var11.setBorder(BorderFactory.createCompoundBorder(BorderFactory.createEmptyBorder(0, 0, 5, 0), var11.getBorder()));
               var9.add(var11, "Center");
               var9.add(new JScrollPane(this.textArea), "South");
               var9.setBorder(BorderFactory.createEmptyBorder(0, 5, 0, 0));
               JPanel var12 = new JPanel();
               var12.setLayout(new BorderLayout());
               var10 = this.certChainTree.getPreferredScrollableViewportSize();
               var10.setSize(200.0, 100.0);
               var11 = new JScrollPane(this.certChainTree);
               var11.setPreferredSize(var10);
               var12.add(var11, "West");
               var12.add(var9, "East");
               this.msg = new Object[]{var12};
               JButton var13 = new JButton(getMessage("cert_dialog.close"));
               var13.setMnemonic(getAcceleratorKey("cert_dialog.close"));
               this.options = new Object[]{var13};
            }
         } finally {
            PluginUIManager.restoreTheme(var5);
         }
      } else {
         throw new AssertionError();
      }
   }

   static void access$000(CertificateDialog var0, X509Certificate var1) {
      var0.showCertificateInfo(var1);
   }

   private JTree buildCertChainTree(Certificate[] var1, int var2, int var3) {
      DefaultMutableTreeNode var4 = null;
      DefaultMutableTreeNode var5 = null;

      for (int var6 = var2; var6 < var1.length && var6 < var3; var6++) {
         DefaultMutableTreeNode var7 = new DefaultMutableTreeNode(new CertificateInfo((X509Certificate)var1[var6]));
         if (var4 == null) {
            var4 = var7;
            var5 = var7;
         } else {
            var5.add(var7);
            var5 = var7;
         }
      }

      JTree var8 = new JTree(var4);
      var8.getSelectionModel().setSelectionMode(1);
      var8.putClientProperty("JTree.lineStyle", "Angled");
      return var8;
   }
}
