package sun.plugin.security;

import java.security.cert.Certificate;
import java.security.cert.X509Certificate;
import java.text.MessageFormat;
import java.util.HashSet;
import javax.net.ssl.HostnameVerifier;
import javax.net.ssl.SSLPeerUnverifiedException;
import javax.net.ssl.SSLSession;
import sun.plugin.resources.ResourceHandler;
import sun.plugin.util.DialogFactory;
import sun.plugin.util.Trace;

public final class CertificateHostnameVerifier implements HostnameVerifier {
   private static HashSet hashSet = new HashSet();

   public static void reset() {
      hashSet.clear();
   }

   private boolean showHostnameMismatchDialog(String var1, String var2) {
      String var3 = ResourceHandler.getMessage("https_dialog.caption");
      MessageFormat var4 = new MessageFormat(ResourceHandler.getMessage("https_dialog.text"));
      Object[] var5 = new Object[]{var1, var2};
      String var6 = var4.format(var5);
      int var7 = 1;
      if (!Trace.isAutomationEnabled()) {
         var7 = DialogFactory.showConfirmDialog(var6, var3);
      } else {
         Trace.msgSecurityPrintln("hostnameverifier.automation.ignoremismatch");
         var7 = 0;
      }

      if (var7 == 0) {
         Object[] var8 = new Object[]{var1, var2};
         hashSet.add(var8);
      }

      return var7 == 0;
   }

   public boolean verify(String var1, SSLSession var2) {
      String var3 = ResourceHandler.getMessage("https_dialog.unknown.host");

      try {
         Certificate[] var4 = var2.getPeerCertificates();
         if (!(var4[0] instanceof X509Certificate)) {
            throw new SSLPeerUnverifiedException("");
         }

         X509Certificate var5 = (X509Certificate)var4[0];
         String var6 = var5.getSubjectDN().getName();
         if (var6 != null) {
            int var7 = var6.toUpperCase().indexOf("CN=");
            if (var7 != -1) {
               int var8 = var6.indexOf(",", var7);
               if (var8 != -1) {
                  var3 = var6.substring(var7 + 3, var8);
               } else {
                  var3 = var6.substring(var7 + 3);
               }
            }
         }
      } catch (SSLPeerUnverifiedException var9) {
         return false;
      }

      if (!var1.equalsIgnoreCase(var3) && !var3.equals("*")) {
         for (Object[] var11 : hashSet) {
            if (var11[0].toString().equalsIgnoreCase(var1) && var11[1].toString().equalsIgnoreCase(var3)) {
               return true;
            }
         }

         return this.showHostnameMismatchDialog(var1, var3);
      } else {
         return true;
      }
   }
}
