package sun.plugin.security;

import java.security.Principal;
import java.security.cert.X509Certificate;
import java.text.MessageFormat;
import sun.plugin.resources.ResourceHandler;
import sun.plugin.util.Trace;

class CertificateInfo {
   X509Certificate cert;

   public String toString() {
      return this.extractAliasName(this.cert);
   }

   public X509Certificate getCertificate() {
      return this.cert;
   }

   CertificateInfo(X509Certificate var1) {
      this.cert = var1;
   }

   private static String getMessage(String var0) {
      return ResourceHandler.getMessage(var0);
   }

   private String extractAliasName(X509Certificate var1) {
      String var2 = getMessage("security_dialog.unknown.subject");
      String var3 = getMessage("security_dialog.unknown.issuer");

      try {
         Principal var4 = var1.getSubjectDN();
         Principal var5 = var1.getIssuerDN();
         String var6 = var4.getName();
         String var7 = var5.getName();
         var2 = this.extractFromQuote(var6, "CN=");
         if (var2 == null) {
            var2 = this.extractFromQuote(var6, "O=");
         }

         if (var2 == null) {
            var2 = getMessage("security_dialog.unknown.subject");
         }

         var3 = this.extractFromQuote(var7, "CN=");
         if (var3 == null) {
            var3 = this.extractFromQuote(var7, "O=");
         }

         if (var3 == null) {
            var3 = getMessage("security_dialog.unknown.issuer");
         }
      } catch (Exception var8) {
         Trace.printException(var8);
      }

      MessageFormat var9 = new MessageFormat(getMessage("security_dialog.certShowName"));
      Object[] var10 = new Object[]{var2, var3};
      return var9.format(var10);
   }

   private String extractFromQuote(String var1, String var2) {
      if (var1 == null) {
         return null;
      } else {
         int var3 = var1.indexOf(var2);
         int var4 = 0;
         if (var3 >= 0) {
            var3 += var2.length();
            if (var1.charAt(var3) == '"') {
               var4 = var1.indexOf(34, ++var3);
            } else {
               var4 = var1.indexOf(44, var3);
            }

            return var4 < 0 ? var1.substring(var3) : var1.substring(var3, var4);
         } else {
            return null;
         }
      }
   }
}
