package sun.plugin.security;

import java.io.IOException;
import java.security.KeyStore;
import java.security.KeyStoreException;
import java.security.NoSuchAlgorithmException;
import java.security.cert.Certificate;
import java.security.cert.CertificateException;
import java.util.Iterator;

public interface CertificateStore {
   void load() throws IOException, CertificateException, KeyStoreException, NoSuchAlgorithmException;

   void save() throws IOException, CertificateException, KeyStoreException, NoSuchAlgorithmException;

   KeyStore getKeyStore() throws KeyStoreException;

   void add(Certificate var1) throws KeyStoreException;

   void remove(Certificate var1) throws KeyStoreException;

   boolean contains(Certificate var1) throws KeyStoreException;

   boolean verify(Certificate var1) throws KeyStoreException;

   Iterator iterator() throws KeyStoreException;
}
