package sun.plugin.security;

import java.net.InetAddress;
import java.net.PasswordAuthentication;
import java.util.Arrays;
import java.util.HashMap;
import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JPasswordField;
import javax.swing.JTextField;
import javax.swing.LookAndFeel;
import sun.net.www.protocol.http.ExAuthenticator;
import sun.plugin.resources.ResourceHandler;
import sun.plugin.services.BrowserAuthenticator;
import sun.plugin.services.ServiceProvider;
import sun.plugin.util.DialogFactory;
import sun.plugin.util.PluginSysUtil;
import sun.plugin.util.PluginUIManager;
import sun.plugin.util.Trace;

public final class PluginAuthenticator extends ExAuthenticator {
   private static HashMap baSites = new HashMap();
   static final boolean $assertionsDisabled = !(PluginAuthenticator.class$sun$plugin$security$PluginAuthenticator == null
         ? (PluginAuthenticator.class$sun$plugin$security$PluginAuthenticator = class$("sun.plugin.security.PluginAuthenticator"))
         : PluginAuthenticator.class$sun$plugin$security$PluginAuthenticator)
      .desiredAssertionStatus();
   static Class class$sun$plugin$security$PluginAuthenticator;

   protected synchronized PasswordAuthentication getPasswordAuthentication() {
      PasswordAuthentication var1 = null;

      try {
         InetAddress var2 = this.getRequestingSite();
         String var3 = this.getMessage("net.authenticate.unknownSite");
         if (var2 != null) {
            var3 = var2.toString();
         }

         StringBuffer var4 = new StringBuffer(this.getRequestingProtocol());
         var4.append(':');
         var4.append(this.getRequestingHost());
         var4.append(':');
         var4.append(this.getRequestingPort());
         var4.append(':');
         var4.append(this.getRequestingScheme());
         var4.append(':');
         var4.append(this.getRequestingPrompt());
         if (!baSites.containsKey(var4.toString())) {
            BrowserAuthenticator var5 = ServiceProvider.getService().getBrowserAuthenticator();
            if (var5 != null) {
               var1 = var5.getAuthentication(
                  this.getRequestingProtocol(),
                  this.getRequestingHost(),
                  this.getRequestingPort(),
                  this.getRequestingScheme(),
                  this.getRequestingPrompt(),
                  this.getRequestingURL(),
                  this.getRequestorType()
               );
               if (var1 != null) {
                  baSites.put(var4.toString(), var4.toString());
                  return var1;
               }
            }
         }

         StringBuffer var7 = new StringBuffer();
         var7.append("Firewall authentication: site=");
         var7.append(this.getRequestingSite());
         var7.append(":" + this.getRequestingPort());
         var7.append(", protocol=");
         var7.append(this.getRequestingProtocol());
         var7.append(", prompt=");
         var7.append(this.getRequestingPrompt());
         var7.append(", scheme=");
         var7.append(this.getRequestingScheme());
         Trace.netPrintln(var7.toString());
         var1 = this.openDialog(var3, this.getRequestingPrompt(), this.getRequestingScheme());
      } catch (Exception var6) {
         Trace.netPrintException(var6);
      }

      return var1;
   }

   static Class class$(String var0) {
      try {
         return Class.forName(var0);
      } catch (ClassNotFoundException var2) {
         throw new NoClassDefFoundError().initCause(var2);
      }
   }

   private String getMessage(String var1) {
      return ResourceHandler.getMessage(var1);
   }

   private PasswordAuthentication openDialog(String var1, String var2, String var3) {
      String var4 = var1;
      String var5 = var2;
      String var6 = var3;

      try {
         return (PasswordAuthentication)PluginSysUtil.execute(new PluginAuthenticator$1(this, var4, var5, var6));
      } catch (Exception var8) {
         if (!$assertionsDisabled) {
            throw new AssertionError();
         } else {
            return null;
         }
      }
   }

   private PasswordAuthentication openDialogImpl(String var1, String var2, String var3) {
      LookAndFeel var4 = null;

      PasswordAuthentication var14;
      try {
         var4 = PluginUIManager.setTheme();
         if (var1 == null) {
            var1 = "";
         }

         if (var2 == null) {
            var2 = "";
         }

         if (var3 == null) {
            var3 = "";
         }

         JTextField var5 = new JTextField();
         var5.setColumns(15);
         JPasswordField var6 = new JPasswordField();
         var6.setColumns(15);
         JPanel var7 = new JPanel();
         var7.setLayout(new BoxLayout(var7, 1));
         var7.add(new JLabel(this.getMessage("net.authenticate.firewall")));
         var7.add(Box.createVerticalStrut(5));
         var7.add(new JLabel(this.getMessage("net.authenticate.realm")));
         var7.add(Box.createVerticalStrut(5));
         var7.add(new JLabel(this.getMessage("net.authenticate.scheme")));
         var7.add(Box.createVerticalStrut(15));
         var7.add(new JLabel(this.getMessage("net.authenticate.username")));
         var7.add(Box.createVerticalStrut(15));
         var7.add(new JLabel(this.getMessage("net.authenticate.password")));
         var7.add(Box.createVerticalStrut(15));
         JPanel var8 = new JPanel();
         var8.setLayout(new BoxLayout(var8, 1));
         var8.add(new JLabel(var1));
         var8.add(Box.createVerticalStrut(5));
         var8.add(new JLabel(var2));
         var8.add(Box.createVerticalStrut(5));
         var8.add(new JLabel(var3));
         var8.add(Box.createVerticalStrut(10));
         var8.add(var5);
         var8.add(Box.createVerticalStrut(10));
         var8.add(var6);
         JPanel var9 = new JPanel();
         var9.setLayout(new BoxLayout(var9, 0));
         var9.add(var7);
         var9.add(Box.createHorizontalStrut(15));
         var9.add(var8);
         Object[] var10 = new Object[]{var9};
         int var11 = DialogFactory.showConfirmDialog(var10, this.getMessage("net.authenticate.caption"));
         if (var11 != 0) {
            return null;
         }

         char[] var13 = var6.getPassword();
         PasswordAuthentication var12 = new PasswordAuthentication(var5.getText(), var13);
         Arrays.fill(var13, ' ');
         var14 = var12;
      } finally {
         PluginUIManager.restoreTheme(var4);
      }

      return var14;
   }

   static PasswordAuthentication access$000(PluginAuthenticator var0, String var1, String var2, String var3) {
      return var0.openDialogImpl(var1, var2, var3);
   }
}
