package sun.plugin.security;

import java.io.IOException;
import java.security.KeyStore;
import java.security.KeyStoreException;
import java.security.NoSuchAlgorithmException;
import java.security.cert.Certificate;
import java.security.cert.CertificateException;
import java.util.Collection;
import java.util.HashSet;
import java.util.Iterator;
import sun.plugin.util.Trace;

public final class SessionCertificateStore implements CertificateStore {
   private Collection _certs = new HashSet();

   public void load() throws IOException, CertificateException, KeyStoreException, NoSuchAlgorithmException {
      Trace.msgSecurityPrintln("sessioncertstore.cert.loading");
      Trace.msgSecurityPrintln("sessioncertstore.cert.loaded");
   }

   public void save() throws IOException, CertificateException, KeyStoreException, NoSuchAlgorithmException {
      Trace.msgSecurityPrintln("sessioncertstore.cert.saving");
      Trace.msgSecurityPrintln("sessioncertstore.cert.saved");
   }

   public KeyStore getKeyStore() {
      Trace.msgSecurityPrintln("sessioncertstore.cert.getkeystore");
      return null;
   }

   public void add(Certificate var1) throws KeyStoreException {
      Trace.msgSecurityPrintln("sessioncertstore.cert.adding");
      this._certs.add(var1);
      Trace.msgSecurityPrintln("sessioncertstore.cert.added");
   }

   public void remove(Certificate var1) throws KeyStoreException {
      Trace.msgSecurityPrintln("sessioncertstore.cert.removing");
      this._certs.remove(var1);
      Trace.msgSecurityPrintln("sessioncertstore.cert.removed");
   }

   public boolean contains(Certificate var1) throws KeyStoreException {
      Trace.msgSecurityPrintln("sessioncertstore.cert.instore");
      return this._certs.contains(var1);
   }

   public boolean verify(Certificate var1) throws KeyStoreException {
      Trace.msgSecurityPrintln("sessioncertstore.cert.canverify");
      return false;
   }

   public Iterator iterator() throws KeyStoreException {
      Trace.msgSecurityPrintln("sessioncertstore.cert.iterator");
      return this._certs.iterator();
   }
}
