package sun.plugin.services;

import java.security.AccessController;
import sun.plugin.util.Trace;
import sun.security.action.GetPropertyAction;

public abstract class PlatformService {
   private static PlatformService ps = null;

   public void dispatchNativeEvent() {
   }

   public void signalEvent(int var1) {
   }

   public void waitEvent(int var1) {
   }

   public void waitEvent(int var1, int var2) {
      this.waitEvent(var2);
   }

   public abstract String getInfrastructurePath();

   public abstract String getSystemProfilePath();

   public abstract String getUserProfilePath();

   public static synchronized PlatformService getService() {
      if (ps == null) {
         String var0 = AccessController.doPrivileged(new GetPropertyAction("os.name"));

         try {
            Object var1 = null;
            if (var0.indexOf("Windows") != -1) {
               var1 = "sun.plugin.services.WPlatformService";
            } else {
               var1 = "sun.plugin.services.MPlatformService";
            }

            Class var2 = Class.forName((String)var1);
            if (var2 != null) {
               Object var3 = var2.newInstance();
               if (var3 instanceof PlatformService) {
                  ps = (PlatformService)var3;
               }
            }
         } catch (Exception var4) {
            Trace.printException(var4);
         }
      }

      return ps;
   }
}
