package sun.plugin.util;

import java.awt.AWTEvent;
import java.awt.Component;
import java.awt.EventQueue;
import java.awt.Toolkit;
import java.awt.event.InvocationEvent;
import java.lang.reflect.InvocationTargetException;
import sun.awt.SunToolkit;

public class PluginAWTUtil {
   public static void postEvent(Component var0, AWTEvent var1) {
      SunToolkit.postEvent(SunToolkit.targetToAppContext(var0), var1);
   }

   public static void invokeAndWait(Component var0, Runnable var1) throws InterruptedException, InvocationTargetException {
      if (EventQueue.isDispatchThread()) {
         throw new Error("Cannot call invokeAndWait from the event dispatcher thread");
      } else {
         PluginAWTUtil$1AWTInvocationLock var2 = new PluginAWTUtil$1AWTInvocationLock();
         InvocationEvent var3 = new InvocationEvent(Toolkit.getDefaultToolkit(), var1, var2, true);
         synchronized (var2) {
            SunToolkit.postEvent(SunToolkit.targetToAppContext(var0), var3);
            var2.wait();
         }

         Exception var4 = var3.getException();
         if (var4 != null) {
            throw new InvocationTargetException(var4);
         }
      }
   }

   public static void invokeLater(Component var0, Runnable var1) {
      SunToolkit.postEvent(SunToolkit.targetToAppContext(var0), new InvocationEvent(Toolkit.getDefaultToolkit(), var1));
   }
}
