package sun.plugin.util;

import java.awt.Image;
import java.awt.MediaTracker;
import java.awt.Point;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.net.URL;
import javax.swing.ImageIcon;
import javax.swing.Timer;
import sun.plugin.AppletViewer;

public class Steamer implements ActionListener {
   private Timer ticker;
   private static final int NUMBER_OF_IMAGES = 1;
   private static final String img_base = "sun/plugin/util/cup";
   private static final String broken_image = "sun/plugin/util/graybox_broken.gif";
   private static Image[] cups = new Image[1];
   private static Image broken_graybox_image = null;
   private String custom_image_file = null;
   private Image custom_image;
   private int current_image_number = 0;
   private URL codebase;
   private boolean applet_error = false;
   private int X_coordinate = 6;
   private int Y_coordinate = 6;
   AppletViewer av;
   private static MediaTracker tracker;
   private static boolean init = false;

   public void destroy() {
      this.stopTimer();
   }

   public void error() {
      this.applet_error = true;
      this.X_coordinate = 6;
      this.Y_coordinate = 6;
      this.custom_image = null;
   }

   public void init() {
      tracker = new MediaTracker(this.av);
      this.loadDefaultImages();
      if (this.custom_image_file != null) {
         this.loadCustomImage();
      } else {
         this.startTimer();
      }
   }

   private void loadCustomImage() {
      Steamer$3 var1 = new Steamer$3(this);
      Thread var2 = new Thread(var1, "Custom Image Loader");
      var2.start();
   }

   private void loadDefaultImages() {
      if (!init) {
         init = true;
         this.loadFirstImage();
         loadOtherImages();
      }
   }

   private void loadFirstImage() {
      if (cups[0] == null) {
         Steamer$1 var1 = new Steamer$1(this);
         Thread var2 = new Thread(var1, "Default Image Loader");
         var2.start();
      }
   }

   private static synchronized void loadOtherImages() {
      Steamer$2 var0 = new Steamer$2();
      Thread var1 = new Thread(var0, "Graybox Image Loader");
      var1.start();
   }

   public synchronized void startTimer() {
   }

   public void stop() {
      this.stopTimer();
      this.av.repaint();
   }

   public synchronized void stopTimer() {
   }

   public Image getCurrentImage() {
      if (this.applet_error) {
         this.stopTimer();
         broken_graybox_image = new ImageIcon(ClassLoader.getSystemResource("sun/plugin/util/graybox_broken.gif")).getImage();
         return broken_graybox_image;
      } else if (this.custom_image != null) {
         return this.custom_image;
      } else {
         this.startTimer();
         return this.getCurrentImage(this.current_image_number);
      }
   }

   static Image[] access$000() {
      return cups;
   }

   private Image getCurrentImage(int var1) {
      if (var1 < 0) {
         return null;
      } else {
         for (int var2 = var1; var2 >= 0; var2--) {
            if (cups[var2] != null) {
               return cups[var2];
            }
         }

         return null;
      }
   }

   static MediaTracker access$100() {
      return tracker;
   }

   public Point getImgCoordinates() {
      return new Point(this.X_coordinate, this.Y_coordinate);
   }

   public void actionPerformed(ActionEvent var1) {
      this.current_image_number++;
      this.current_image_number %= 1;
      this.av.repaint();
   }

   public Steamer(AppletViewer var1) {
      this.av = var1;
   }

   static int access$502(Steamer var0, int var1) {
      return var0.X_coordinate = var1;
   }

   static int access$602(Steamer var0, int var1) {
      return var0.Y_coordinate = var1;
   }

   static Image access$400(Steamer var0) {
      return var0.custom_image;
   }

   public void setCustomImage(URL var1, String var2) {
      this.X_coordinate = 0;
      this.Y_coordinate = 0;
      this.codebase = var1;
      this.custom_image_file = var2;
   }

   static String access$200(Steamer var0) {
      return var0.custom_image_file;
   }

   static URL access$300(Steamer var0) {
      return var0.codebase;
   }

   static Image access$402(Steamer var0, Image var1) {
      return var0.custom_image = var1;
   }
}
