package sun.plugin.util;

import java.awt.Component;
import java.security.AccessController;
import java.text.MessageFormat;
import java.util.HashMap;
import java.util.StringTokenizer;
import sun.plugin.resources.ResourceHandler;
import sun.security.action.GetBooleanAction;
import sun.security.action.GetPropertyAction;

public class Trace {
   private static boolean bBasicTraceOn = false;
   private static boolean bExtTraceOn = false;
   private static boolean bSecurityTraceOn = false;
   private static boolean bNetTraceOn = false;
   private static boolean bLiveConnectTraceOn = false;
   private static boolean bAutomationOn = false;
   private static HashMap threadGroups = new HashMap();

   static {
      reset();
      bAutomationOn = AccessController.doPrivileged(new GetBooleanAction("javaplugin.automation"));
   }

   public static void reset() {
      if (AccessController.doPrivileged(new GetBooleanAction("javaplugin.trace"))) {
         String var0 = AccessController.doPrivileged(new GetPropertyAction("javaplugin.trace.option"));
         if (var0 == null) {
            bBasicTraceOn = true;
            bNetTraceOn = true;
            bSecurityTraceOn = true;
            bExtTraceOn = true;
            bLiveConnectTraceOn = true;
         } else {
            StringTokenizer var1 = new StringTokenizer(var0, "|");

            while (var1.hasMoreTokens()) {
               String var2 = var1.nextToken();
               if (var2 == null || var2.equalsIgnoreCase("all")) {
                  bBasicTraceOn = true;
                  bNetTraceOn = true;
                  bSecurityTraceOn = true;
                  bExtTraceOn = true;
                  bLiveConnectTraceOn = true;
                  break;
               }

               if (var2.equalsIgnoreCase("basic")) {
                  bBasicTraceOn = true;
               } else if (var2.equalsIgnoreCase("net")) {
                  bNetTraceOn = true;
               } else if (var2.equalsIgnoreCase("security")) {
                  bSecurityTraceOn = true;
               } else if (var2.equalsIgnoreCase("ext")) {
                  bExtTraceOn = true;
               } else if (var2.equalsIgnoreCase("liveconnect")) {
                  bLiveConnectTraceOn = true;
               }
            }
         }
      }
   }

   public static boolean isAutomationEnabled() {
      return bAutomationOn;
   }

   public static boolean isEnabled() {
      return bBasicTraceOn || bNetTraceOn || bSecurityTraceOn || bExtTraceOn || bLiveConnectTraceOn;
   }

   public static void setBasicTrace(boolean var0) {
      bBasicTraceOn = var0;
   }

   public static void setExtTrace(boolean var0) {
      bExtTraceOn = var0;
   }

   public static void setLiveConnectTrace(boolean var0) {
      bLiveConnectTraceOn = var0;
   }

   public static void setNetTrace(boolean var0) {
      bNetTraceOn = var0;
   }

   public static void setSecurityTrace(boolean var0) {
      bSecurityTraceOn = var0;
   }

   public static void extPrintln(String var0) {
      println(var0, null, 130);
   }

   public static void liveConnectPrintln(String var0) {
      println(var0, null, 258);
   }

   public static void msgExtPrintln(String var0) {
      msgPrintln(var0, null, null, 130);
   }

   public static void msgLiveConnectPrintln(String var0) {
      msgPrintln(var0, null, null, 258);
   }

   public static void msgNetPrintln(String var0) {
      msgPrintln(var0, null, null, 34);
   }

   public static void msgPrintln(String var0) {
      msgPrintln(var0, null, 2);
   }

   public static void msgSecurityPrintln(String var0) {
      msgPrintln(var0, null, null, 66);
   }

   public static void netPrintln(String var0) {
      println(var0, null, 34);
   }

   public static void println(String var0) {
      println(var0, null);
   }

   public static void securityPrintln(String var0) {
      println(var0, null, 66);
   }

   public static void extPrintln(String var0, int var1) {
      println(var0, null, var1 | 128);
   }

   public static void liveConnectPrintln(String var0, int var1) {
      println(var0, null, var1 | 256);
   }

   public static void msgExtPrintln(String var0, int var1) {
      msgPrintln(var0, null, null, var1 | 128);
   }

   public static void msgLiveConnectPrintln(String var0, int var1) {
      msgPrintln(var0, null, null, var1 | 256);
   }

   public static void msgNetPrintln(String var0, int var1) {
      msgPrintln(var0, null, null, var1 | 32);
   }

   public static void msgPrintln(String var0, int var1) {
      msgPrintln(var0, null, var1);
   }

   public static void netPrintln(String var0, int var1) {
      println(var0, null, var1 | 32);
   }

   public static void println(String var0, int var1) {
      println(var0, null, var1);
   }

   public static void extPrintException(Throwable var0) {
      printException(null, var0, ResourceHandler.getMessage("usability.ext_error"), null, true);
   }

   public static void liveConnectPrintException(Throwable var0) {
      printException(null, var0, null, null, false);
   }

   public static void netPrintException(Throwable var0) {
      printException(null, var0, ResourceHandler.getMessage("usability.net_error"), null, false);
   }

   public static void printException(Throwable var0) {
      printException(null, var0);
   }

   public static void securityPrintException(Throwable var0) {
      printException(null, var0, ResourceHandler.getMessage("usability.security_error"), null, true);
   }

   public static void msgExtPrintln(String var0, Object[] var1) {
      msgPrintln(var0, var1, null, 130);
   }

   public static void msgLiveConnectPrintln(String var0, Object[] var1) {
      msgPrintln(var0, var1, null, 258);
   }

   public static void msgNetPrintln(String var0, Object[] var1) {
      msgPrintln(var0, var1, null, 34);
   }

   public static void msgPrintln(String var0, Object[] var1) {
      msgPrintln(var0, var1, null, 2);
   }

   public static void msgSecurityPrintln(String var0, Object[] var1) {
      msgPrintln(var0, var1, null, 66);
   }

   public static void printException(Component var0, Throwable var1) {
      printException(var0, var1, null, null);
   }

   public static void msgPrintln(String var0, TraceListener var1) {
      msgPrintln(var0, var1, 2);
   }

   public static void println(String var0, TraceListener var1) {
      println(var0, var1, 2);
   }

   private static void firePrintlnEvent(String var0, TraceListener var1, int var2) {
      if (var1 != null && var1.isSupported(var2)) {
         var1.println(var0, var2);
      } else if (threadGroups.size() > 0) {
         Thread var3 = Thread.currentThread();
         ThreadGroup var4 = var3.getThreadGroup();
         TraceListener var5 = null;
         synchronized (threadGroups) {
            var5 = (TraceListener)threadGroups.get(new Integer(var4.hashCode()));
         }

         if (var5 != null) {
            var5.println(var0, var2);
         }
      }
   }

   public static void msgPrintln(String var0, TraceListener var1, int var2) {
      msgPrintln(var0, null, var1, var2);
   }

   public static void println(String var0, TraceListener var1, int var2) {
      if ((var2 & 2) == 2) {
         if ((var2 & 4080) == 0) {
            var2 |= 16;
         }

         switch (var2 & 4080) {
            case 16:
               if (!bBasicTraceOn) {
                  return;
               }
               break;
            case 32:
               if (!bNetTraceOn) {
                  return;
               }
               break;
            case 64:
               if (!bSecurityTraceOn) {
                  return;
               }
               break;
            case 128:
               if (!bExtTraceOn) {
                  return;
               }
               break;
            case 256:
               if (!bLiveConnectTraceOn) {
                  return;
               }
         }

         System.err.println(var0);
         System.err.flush();
         PluginLogger.log(var0);
      }

      firePrintlnEvent(var0, var1, var2);
   }

   public static void addTraceListener(ThreadGroup var0, TraceListener var1) {
      msgPrintln("trace.listener.added", new Object[]{var1});
      synchronized (threadGroups) {
         TraceListener var3 = (TraceListener)threadGroups.get(new Integer(var0.hashCode()));
         var3 = EventMulticaster.add(var3, var1);
         threadGroups.put(new Integer(var0.hashCode()), var3);
      }
   }

   public static void removeTraceListener(ThreadGroup var0, TraceListener var1) {
      msgPrintln("trace.listener.removed", new Object[]{var1});
      synchronized (threadGroups) {
         TraceListener var3 = (TraceListener)threadGroups.get(new Integer(var0.hashCode()));
         var3 = EventMulticaster.remove(var3, var1);
         if (var3 != null) {
            threadGroups.put(new Integer(var0.hashCode()), var3);
         } else {
            threadGroups.remove(new Integer(var0.hashCode()));
         }
      }
   }

   public static void extPrintException(Throwable var0, String var1, String var2) {
      printException(null, var0, var1, var2, true);
   }

   public static void netPrintException(Throwable var0, String var1, String var2) {
      printException(null, var0, var1, var2, false);
   }

   public static void printException(Throwable var0, String var1, String var2) {
      printException(null, var0, var1, var2);
   }

   public static void securityPrintException(Throwable var0, String var1, String var2) {
      printException(null, var0, var1, var2, true);
   }

   public static void msgPrintln(String var0, Object[] var1, TraceListener var2) {
      msgPrintln(var0, var1, var2, 2);
   }

   public static void msgPrintln(String var0, Object[] var1, TraceListener var2, int var3) {
      if ((var3 & 2) == 2) {
         if ((var3 & 4080) == 0) {
            var3 |= 16;
         }

         switch (var3 & 4080) {
            case 16:
               if (!bBasicTraceOn) {
                  return;
               }
               break;
            case 32:
               if (!bNetTraceOn) {
                  return;
               }
               break;
            case 64:
               if (!bSecurityTraceOn) {
                  return;
               }
               break;
            case 128:
               if (!bExtTraceOn) {
                  return;
               }
               break;
            case 256:
               if (!bLiveConnectTraceOn) {
                  return;
               }
         }
      }

      Object var4 = null;
      if (var1 == null) {
         var4 = ResourceHandler.getMessage(var0);
      } else {
         MessageFormat var5 = new MessageFormat(ResourceHandler.getMessage(var0));
         var4 = var5.format(var1);
      }

      if ((var3 & 2) == 2) {
         System.err.println((String)var4);
         System.err.flush();
         PluginLogger.log((String)var4);
      }

      firePrintlnEvent((String)var4, var2, var3);
   }

   public static void printException(Component var0, Throwable var1, String var2, String var3) {
      printException(var0, var1, var2, var3, true);
   }

   public static void printException(Component var0, Throwable var1, String var2, String var3, boolean var4) {
      var1.printStackTrace();
      if (var2 == null) {
         PluginLogger.logException(var1);
      } else {
         PluginLogger.logException(var2, var1);
      }

      if (var4 && !isAutomationEnabled()) {
         if (var2 == null) {
            var2 = ResourceHandler.getMessage("usability.general_error");
         }

         DialogFactory.showExceptionDialog(var0, var1, var2, var3);
      }
   }
}
