package sun.plugin.util;

import java.io.File;
import java.security.AccessController;
import java.util.Date;
import java.util.Properties;
import sun.security.action.GetBooleanAction;
import sun.security.action.GetPropertyAction;

public class UserProfile {
   private static PluginConfig config = new PluginConfig();

   static {
      try {
         new File(getPluginCacheDirectory()).mkdirs();
         new File(getJarCacheDirectory()).mkdirs();
         new File(getFileCacheDirectory()).mkdirs();
         new File(getExtensionDirectory()).mkdirs();
         new File(getTempDirectory()).mkdirs();
      } catch (Throwable var1) {
         var1.printStackTrace();
      }
   }

   public static String getCertificateFile() {
      return config.getTrustedSigningCertStore();
   }

   public static String getExtensionDirectory() {
      return config.getPluginCacheDirectory() + File.separator + "ext";
   }

   public static String getFileCacheDirectory() {
      return config.getPluginCacheDirectory() + File.separator + "file";
   }

   public static String getHttpsCertificateFile() {
      return config.getTrustedJsseCertStore();
   }

   public static String getHttpsRootCertFile() {
      return config.getJsseCACertStore();
   }

   public static String getJarCacheDirectory() {
      return config.getPluginCacheDirectory() + File.separator + "jar";
   }

   public static String getLogFile() {
      return config.getLogDirectory() + File.separator + generateFilename(".log");
   }

   public static String getPluginCacheDirectory() {
      return config.getPluginCacheDirectory();
   }

   public static String getPropertyFile() {
      return config.getPropertiesFile();
   }

   public static String getRootCertificateFile() {
      return config.getRootCACertStore();
   }

   public static String getTempDirectory() {
      return config.getPluginCacheDirectory() + File.separator + "tmp";
   }

   public static String getTraceFile() {
      return config.getLogDirectory() + File.separator + generateFilename(".trace");
   }

   public static Properties getConfigProperties() {
      return config.getConfigProperties();
   }

   private static String generateFilename(String var0) {
      StringBuffer var1 = new StringBuffer();
      var1.append("plugin");
      String var2 = AccessController.doPrivileged(new GetPropertyAction("javaplugin.nodotversion"));
      var1.append(var2);
      Boolean var3 = AccessController.doPrivileged(new GetBooleanAction("javaplugin.outputfiles.overwrite"));
      if (var3.equals(Boolean.FALSE)) {
         String var4 = AccessController.doPrivileged(new GetPropertyAction("user.name"));
         var1.append(var4);
         var1.append(new Date().hashCode());
      }

      var1.append(var0);
      return var1.toString();
   }
}
