package sun.plugin.viewer;

import java.applet.Applet;
import java.awt.Component;
import java.awt.Frame;
import java.awt.event.WindowEvent;
import java.io.PrintStream;
import sun.applet.AppletEvent;
import sun.applet.AppletListener;
import sun.applet.AppletPanel;
import sun.awt.AppContext;
import sun.awt.SunToolkit;
import sun.plugin.AppletViewer;
import sun.plugin.BeansApplet;
import sun.plugin.BeansViewer;
import sun.plugin.navig.motif.Worker;
import sun.plugin.services.BrowserService;
import sun.plugin.services.ServiceProvider;
import sun.plugin.util.PluginAWTUtil;
import sun.plugin.util.Trace;
import sun.plugin.viewer.context.PluginAppletContext;
import sun.plugin.viewer.context.PluginBeansContext;
import sun.plugin.viewer.frame.MNetscapeEmbeddedFrame;
import sun.print.PSPrinterJob.PluginPrinter;

public class MNetscapePluginObject implements AppletListener {
   private MNetscapeEmbeddedFrame frame = null;
   protected AppletViewer panel = null;
   protected int id = -1;
   private int winID = 0;
   private int width = 0;
   private int height = 0;
   private String identifier = null;
   private int startCount = -1;
   private boolean initialized = false;
   private boolean setDocBase = false;
   private int nativeJavaObject = 0;
   private int printCounter = 0;
   private boolean evaluatingExp = false;
   private boolean returnedExp = false;
   private String returnJS = null;
   private Object syncObject = new Object();
   static final boolean $assertionsDisabled = !(MNetscapePluginObject.class$sun$plugin$viewer$MNetscapePluginObject == null
         ? (MNetscapePluginObject.class$sun$plugin$viewer$MNetscapePluginObject = class$("sun.plugin.viewer.MNetscapePluginObject"))
         : MNetscapePluginObject.class$sun$plugin$viewer$MNetscapePluginObject)
      .desiredAssertionStatus();
   static Class class$sun$plugin$viewer$MNetscapePluginObject;

   int getLoadingStatus() {
      return this.panel != null ? this.panel.getLoadingStatus() : 7;
   }

   public int getNativeJavaObject() {
      if (this.nativeJavaObject == 0) {
         Object var1 = this.getJavaObject();
         this.nativeJavaObject = this.convertToGlobalRef(var1);
      }

      return this.nativeJavaObject;
   }

   public synchronized void destroyPlugin() {
      if (!$assertionsDisabled && this.panel == null) {
         throw new AssertionError();
      } else {
         if (this.frame != null) {
            this.frame.setVisible(false);
            this.frame.setEnabled(false);
            this.frame.removeAll();
            WindowEvent var1 = new WindowEvent(this.frame, 201);
            PluginAWTUtil.postEvent(this.frame, var1);
            this.panel.removeNotify();
         }

         PluginAppletContext var2 = (PluginAppletContext)this.panel.getAppletContext();
         LifeCycleManager.destroyAppletPanel(this.identifier, this.panel);
         if (var2 != null) {
            var2.setAppletContextHandle(-1);
         }

         this.panel = null;
         this.frame = null;
      }
   }

   public void finishJSReply() {
      synchronized (this.syncObject) {
         this.returnedExp = true;
         this.syncObject.notifyAll();
      }
   }

   private synchronized void initPlugin() {
      if (!$assertionsDisabled && this.panel == null) {
         throw new AssertionError();
      } else {
         if (this.frame != null) {
            Applet var1 = this.panel.getApplet();
            if (var1 != null) {
               AppletPanel.changeFrameAppContext(this.frame, SunToolkit.targetToAppContext(var1));
            }

            this.frame.add(this.panel);
            this.frame.setVisible(true);
            if (!this.initialized && this.setDocBase) {
               this.initialized = true;
               LifeCycleManager.checkLifeCycle(this.panel);
               new MNetscapePluginObject.Initer(this, this.panel, this).start();
            }
         }
      }
   }

   public void setBoxColors() {
      this.panel.setColorAndText();
   }

   void setFocus() {
      if (this.frame != null) {
         this.frame.requestFocus();
      }
   }

   public synchronized void startPlugin() {
      if (!$assertionsDisabled && this.panel == null) {
         throw new AssertionError();
      } else {
         if (this.initialized) {
            LifeCycleManager.startAppletPanel(this.panel);
         } else {
            if (this.startCount < 0) {
               this.startCount = 0;
            }

            this.startCount++;
         }
      }
   }

   public synchronized void stopPlugin() {
      if (!$assertionsDisabled && this.panel == null) {
         throw new AssertionError();
      } else {
         if (this.initialized) {
            LifeCycleManager.stopAppletPanel(this.panel);
         } else {
            this.startCount--;
         }

         if (this.nativeJavaObject != 0) {
            this.releaseGlobalRef(this.nativeJavaObject);
            this.nativeJavaObject = 0;
         }
      }
   }

   private native void releaseGlobalRef(int var1);

   void setFrameSize(int var1, int var2) {
      synchronized (this) {
         this.setParameter("width", new Integer(var1));
         this.setParameter("height", new Integer(var2));
         if (this.frame != null) {
            this.frame.setSize(var1, var2);
         }

         if (this.panel != null) {
            AppletViewer var4 = this.panel;
            if (var4 != null) {
               var4.setSize(var1, var2);
               this.panel.setParameter("width", new Integer(var1));
               this.panel.setParameter("height", new Integer(var2));
            }

            Object var5 = this.panel.getViewedObject();
            if (var5 != null) {
               Applet var6;
               if (var5 instanceof Applet) {
                  var6 = (Applet)var5;
               } else {
                  Component var7 = (Component)var5;
                  var7.setSize(var1, var2);
                  var6 = (Applet)var7.getParent();
               }

               if (var6 != null) {
                  var6.resize(var1, var2);
               }
            }
         }
      }
   }

   public void setWindow(int var1, int var2, int var3, int var4, int var5) {
      if (var2 == 0) {
         var2 = 1;
      }

      if (var3 == 0) {
         var3 = 1;
      }

      if (this.winID != var1) {
         if (this.frame != null) {
            this.frame.setVisible(false);
            this.frame.setEnabled(false);
            this.frame.removeAll();
            WindowEvent var6 = new WindowEvent(this.frame, 201);
            PluginAWTUtil.postEvent(this.frame, var6);
            this.panel.removeNotify();
         }

         this.frame = null;
         this.winID = var1;
         if (this.winID != 0) {
            int var12 = MNetscapePluginContext.getWidget(this.winID, var2, var3, var4, var5);
            this.frame = this.createFrame(var12);
            if (this.frame == null) {
               System.err.println("Creation of frame failed");
               return;
            }

            MNetscapePluginContext.mapWidget(var12, var2, var3, var4, var5);
            Object var7 = this.getJavaObject();
            if (var7 == null) {
               Trace.println("setWindow: call before applet exists:" + this.winID);

               try {
                  int var9 = Integer.parseInt(this.getParameter("width"));
                  int var10 = Integer.parseInt(this.getParameter("height"));
                  this.width = var9;
                  this.height = var10;
               } catch (NumberFormatException var11) {
                  this.setParameter("width", new Integer(var2));
                  this.setParameter("height", new Integer(var3));
                  this.width = var2;
                  this.height = var3;
               }
            } else {
               this.setParameter("width", new Integer(var2));
               this.setParameter("height", new Integer(var3));
               this.width = var2;
               this.height = var3;
               this.panel.setSize(var2, var3);
               Applet var8;
               if (var7 instanceof Applet) {
                  var8 = (Applet)var7;
               } else {
                  Trace.println("setWindow: Viewing a bean component");
                  Component var13 = (Component)var7;
                  var13.setSize(var2, var3);
                  var8 = (Applet)var13.getParent();
               }

               var8.resize(var2, var3);
               var8.setVisible(true);
            }

            this.panel.setBounds(0, 0, var2, var3);
            this.frame.setVisible(true);
            this.frame.setBounds(0, 0, var2, var3);
            this.initPlugin();
         }
      } else {
         if (var2 != this.width || var3 != this.height) {
            this.setFrameSize(var2, var3);
         }
      }
   }

   private Frame getFrame() {
      return this.frame;
   }

   public void doPrint(int var1, int var2, int var3, int var4, PrintStream var5) {
      if (++this.printCounter == 3) {
         this.printCounter = 0;
         if (this.panel != null) {
            PluginPrinter var6 = new PluginPrinter(this.panel, var5, var1, var2, var3, var4);

            try {
               var6.printAll();
            } catch (Throwable var8) {
               Trace.println("doPrint: printAll failed");
               Trace.printException(var8);
            }
         }
      }
   }

   public Object getJavaObject() {
      Object var1 = null;
      if (this.panel != null) {
         var1 = this.panel.getViewedObject();
      }

      if (var1 instanceof BeansApplet) {
         BeansApplet var2 = (BeansApplet)var1;
         var1 = var2.getBean();
      }

      return var1;
   }

   private native int convertToGlobalRef(Object var1);

   MNetscapePluginObject(int var1, boolean var2, String var3) {
      this.id = var1;
      this.identifier = var3;
      this.panel = LifeCycleManager.getAppletPanel(var3);
      if (!var2) {
         if (this.panel == null) {
            this.panel = new AppletViewer();
            this.panel.addAppletListener(this);
         }

         PluginAppletContext var4 = (PluginAppletContext)this.panel.getAppletContext();
         if (var4 == null) {
            BrowserService var5 = ServiceProvider.getService();
            var4 = var5.getAppletContext();
         }

         var4.setAppletContextHandle(var1);
         this.panel.setAppletContext(var4);
      } else {
         if (this.panel == null) {
            this.panel = new BeansViewer();
         }

         PluginBeansContext var6 = (PluginBeansContext)this.panel.getAppletContext();
         if (var6 == null) {
            BrowserService var7 = ServiceProvider.getService();
            var6 = var7.getBeansContext();
         }

         var6.setAppletContextHandle(var1);
         this.panel.setAppletContext(var6);
      }
   }

   public synchronized void setDocumentURL(String var1) {
      if (!$assertionsDisabled && this.panel == null) {
         throw new AssertionError();
      } else {
         try {
            this.notifyAll();
            this.panel.setDocumentBase(var1);
            this.setDocBase = true;
            this.initPlugin();
         } catch (Throwable var3) {
            Trace.printException(var3);
         }
      }
   }

   public void setJSReply(String var1) {
      synchronized (this.syncObject) {
         if (this.returnJS == null) {
            this.returnJS = var1;
         } else {
            this.returnJS = this.returnJS + var1;
         }
      }
   }

   public void appletStateChanged(AppletEvent var1) {
      AppletPanel var2 = (AppletPanel)var1.getSource();
      switch (var1.getID()) {
         case 51236:
            if (this.frame != null) {
               Applet var3 = var2.getApplet();
               if (var3 != null) {
                  AppletPanel.changeFrameAppContext(this.frame, SunToolkit.targetToAppContext(var3));
               } else {
                  AppletPanel.changeFrameAppContext(this.frame, AppContext.getAppContext());
               }
            }
      }
   }

   static int access$100(MNetscapePluginObject var0) {
      return var0.startCount;
   }

   static int access$102(MNetscapePluginObject var0, int var1) {
      return var0.startCount = var1;
   }

   static boolean access$002(MNetscapePluginObject var0, boolean var1) {
      return var0.initialized = var1;
   }

   private MNetscapeEmbeddedFrame createFrame(int var1) {
      MNetscapeEmbeddedFrame var2 = new MNetscapeEmbeddedFrame(var1);
      Applet var3 = this.panel.getApplet();
      if (var3 != null) {
         AppletPanel.changeFrameAppContext(var2, SunToolkit.targetToAppContext(var3));
      }

      return var2;
   }

   static Class class$(String var0) {
      try {
         return Class.forName(var0);
      } catch (ClassNotFoundException var2) {
         throw new NoClassDefFoundError().initCause(var2);
      }
   }

   public void setParameter(String var1, Object var2) {
      if (!$assertionsDisabled && this.panel == null) {
         throw new AssertionError();
      } else {
         this.panel.setParameter(var1, var2);
      }
   }

   public String evalString(int var1, String var2) {
      synchronized (this.syncObject) {
         String var10000;
         try {
            while (this.evaluatingExp) {
               this.syncObject.wait();
            }

            this.evaluatingExp = true;
            this.returnedExp = false;
            Worker.sendJSRequest(var1, var2);

            while (!this.returnedExp) {
               this.syncObject.wait();
            }

            this.evaluatingExp = false;
            String var4 = this.returnJS;
            this.returnJS = null;
            this.syncObject.notifyAll();
            var10000 = var4;
         } catch (Exception var6) {
            this.evaluatingExp = false;
            this.returnJS = null;
            this.syncObject.notifyAll();
            return null;
         }

         return var10000;
      }
   }

   public String getParameter(String var1) {
      if (!$assertionsDisabled && this.panel == null) {
         throw new AssertionError();
      } else {
         return this.panel.getParameter(var1);
      }
   }

   private class Initer extends Thread {
      AppletViewer that;
      MNetscapePluginObject obj;
      private final MNetscapePluginObject this$0;

      public void run() {
         LifeCycleManager.initAppletPanel(this.that);
         synchronized (this.obj) {
            MNetscapePluginObject.access$002(this.obj, true);
            if (MNetscapePluginObject.access$100(this.obj) > 0) {
               MNetscapePluginObject.access$102(this.obj, 0);
               this.obj.startPlugin();
            } else if (MNetscapePluginObject.access$100(this.obj) == 0) {
               this.obj.startPlugin();
               this.obj.stopPlugin();
            }
         }
      }

      Initer(MNetscapePluginObject var1, AppletViewer var2, MNetscapePluginObject var3) {
         this.this$0 = var1;
         this.that = var2;
         this.obj = var3;
      }
   }
}
